=== modified file 'BRANCH.TODO'
--- BRANCH.TODO	2006-01-25 14:30:06 +0000
+++ BRANCH.TODO	2006-03-20 08:31:00 +0000
@@ -1,3 +1,4 @@
 # This file is for listing TODOs for branches that are being worked on.
 # It should ALWAYS be empty in the mainline or in integration branches.
 # 
+

=== modified file 'Makefile'
--- Makefile	2006-01-25 14:30:06 +0000
+++ Makefile	2006-03-20 08:31:00 +0000
@@ -10,8 +10,7 @@
 
 clean: 
 	./setup.py clean
-	-find . -name "*.pyc" | xargs rm
-	-find . -name "*.pyo" | xargs rm
+	-find . -name "*.pyc" -o -name "*.pyo" | xargs rm -f
 	rm -rf test????.tmp
 
 .PHONY: all

=== modified file 'NEWS'
--- NEWS	2006-01-25 14:30:06 +0000
+++ NEWS	2006-03-20 08:31:00 +0000
@@ -1,4 +1,107 @@
-bzr 0.7 2006-01-23
+bzr development version
+ 
+
+  IMPROVEMENTS:
+
+    * Sftp paths can now be relative, or local, according to the lftp
+      convention. Paths now take the form:
+      sftp://user:pass@host:port/~/relative/path
+      or
+      sftp://user:pass@host:port/absolute/path
+
+    * The FTP transport now tries to reconnect after a temporary
+      failure. ftp put is made atomic. (Matthieu Moy)
+
+    * The FTP transport now maintains a pool of connections, and
+      reuses them to avoid multiple connections to the same host (like
+      sftp did). (Daniel Silverstone)
+
+    * The bzr_man.py file has been removed. To create the man page now,
+      use ./generate_docs.py man. The new program can also create other files.
+      Run "python generate_docs.py --help" for usage information. (Hans
+      Ulrich Niedermann & James Blackwell).
+
+    * Man Page now gives full help (James Blackwell). Help also updated to 
+      reflect user config now being stored in .bazaar (Hans Ulrich
+      Niedermann)
+
+    * It's now possible to set aliases in bazaar.conf (Erik Bågfors)
+
+    * Pull now accepts a --revision argument (Erik Bågfors)
+
+    * 'bzr re-sign' now allows multiple revisions to be supplied on the command
+      line. You can now use the following command to sign all of your old commits.
+        find .bzr/revision-store// -name my@email-* \
+          | sed 's/.*\/\/..\///' \
+          | xargs bzr re-sign
+
+    * Upgrade can now upgrade over the network. (Robert Collins)
+
+    * Two new commands 'bzr checkout' and 'bzr update' allow for CVS/SVN-alike
+      behaviour. They use the existing serverless-mode and store no data
+      locally. As such they are not suitable for use except in high bandwidth
+      low latency environments like LAN's or local disk. (Robert Collins)
+
+    * 'revert' unversions newly-versioned files, instead of deleting them.
+
+    * 'merge' is more robust.  Conflict messages have changed.
+
+    * 'merge' and 'revert' no longer clobber existing files that end in '~' or
+      '.moved'.
+
+    * Default log format can be set in configuration and plugins can register
+      their own formatters. (Erik Bågfors)
+
+    * New 'reconcile' command will check branch consistency and repair indexes
+      that can become out of sync in pre 0.8 formats. (Robert Collins,
+      Aaron Bentley)
+
+  INTERNALS:
+  
+    * The internal storage of history, and logical branch identity have now
+      been split into Branch, and Repository. The common locking and file 
+      management routines are now in bzrlib.lockablefiles. 
+      (Aaron Bentley, Robert Collins, Martin Pool)
+
+    * Using Tree Transform for merge, revert, tree-building
+
+    * WorkingTree.create, Branch.create, WorkingTree.create_standalone,
+      Branch.initialize are now deprecated. Please see BzrDir.create_* for
+      replacement API's. (Robert Collins)
+
+    * New BzrDir class represents the .bzr control directory and manages
+      formatting issues. (Robert Collins)
+
+    * New repository.InterRepository class encapsulates Repository to 
+      Repository actions and allows for clean selection of optimised code
+      paths. (Robert Collins)
+
+    * bzrlib.fetch.fetch and bzrlib.fetch.greedy_fetch are now deprecated,
+      please use 'branch.fetch' or 'repository.fetch' depending on your
+      needs. (Robert Collins)
+
+    * deprecated methods now have a 'is_deprecated' flag on them that can
+      be checked, if you need to determine whether a given callable is 
+      deprecated at runtime. (Robert Collins)
+
+  TESTING:
+
+    * SFTP tests now shortcut the SSH negotiation, reducing test overhead
+      for testing SFTP protocol support. (Robey Pointer)
+
+    * Branch formats are now tested once per implementation (see bzrlib.
+      tests.branch_implementations. This is analagous to the transport
+      interface tests, and has been followed up with working tree,
+      repository and BzrDir tests. (Robert Collins)
+
+    * New test base class TestCaseWithTransport provides a transport aware
+      test environment, useful for testing any transport-interface using
+      code. The test suite option --transport controls the transport used
+      by this class (when its not being used as part of implementation
+      contract testing). (Robert Collins)
+
+
+bzr 0.7rc1 2006-01-09
 
   CHANGES:
 
@@ -27,14 +130,6 @@
       This gives better integration with user settings such as ProxyCommand.
       (James Henstridge)
 
-    * Sftp paths can now be relative, or local, according to the IETF 
-      draft spec.  Paths now take the form:
-      sftp://user:pass@host:port/relative/path
-      or
-      sftp://user:pass@host:port/%2Fabsolute/path
-      or
-      sftp://user:pass@host:port//absolute/path
-
     * Permissions on files underneath .bzr/ are inherited from the .bzr 
       directory. So for a shared repository, simply doing 'chmod -R g+w .bzr/'
       will mean that future file will be created with group write permissions.
@@ -105,12 +200,12 @@
     * 'bzr add' now takes a --dry-run parameter which shows you what would be
       added, but doesn't actually add anything. (Michael Ellerman)
 
-    * bzr add now lists how many files were ignored per glob.  add --verbose
+    * 'bzr add' now lists how many files were ignored per glob.  add --verbose
       lists the specific files.  (Aaron Bentley)
 
-    * Reduced CPU usage for merge/fetch. (Goffredo Baroncelli)
-
-    * Faster diff and status commands.  (Denys Duchier)
+    * 'bzr missing' now supports displaying changes in diverged trees and can
+      be limited to show what either end of the comparison is missing.
+      (Aaron Bently, with a little prompting from Daniel Silverstone)
 
   BUG FIXES:
 
@@ -202,6 +297,21 @@
       (Martin Pool) (NB: TestSkipped should only be raised for correctable
       reasons - see the wiki spec ImprovingBzrTestSuite).
 
+    * Test sftp with relative, absolute-in-homedir and absolute-not-in-homedir
+      paths for the transport tests. Introduce blackbox remote sftp tests that
+      test the same permutations. (Robert Collins, Robey Pointer)
+
+    * Transport implementation tests are now independent of the local file
+      system, which allows tests for esoteric transports, and for features
+      not available in the local file system. They also repeat for variations
+      on the URL scheme that can introduce issues in the transport code,
+      see bzrlib.transport.TransportTestProviderAdapter() for this.
+      (Robert Collins).
+
+    * TestCase.build_tree uses the transport interface to build trees, pass
+      in a transport parameter to give it an existing connection.
+      (Robert Collins).
+
   INTERNALS:
 
     * WorkingTree.pull has been split across Branch and WorkingTree,
@@ -265,6 +375,12 @@
     * Simplify handling of DivergedBranches in cmd_pull().
       (Michael Ellerman)
 		   
+   
+    * Branch.controlfile* logic has moved to lockablefiles.LockableFiles, which
+      is exposed as Branch().control_files. Also this has been altered with the
+      controlfile pre/suffix replaced by simple method names like 'get' and
+      'put'. (Aaron Bentley, Robert Collins).
+
     * Deprecated functions and methods can now be marked as such using the 
       bzrlib.symbol_versioning module. Marked method have their docstring
       updated and will issue a DeprecationWarning using the warnings module

=== modified file 'README'
--- README	2006-01-25 14:30:06 +0000
+++ README	2006-03-20 08:31:00 +0000
@@ -1,5 +1,5 @@
 *******************************
-Release notes for Bazaar-NG 0.7
+Release notes for Bazaar-NG 0.6
 *******************************
 
 bazaar-ng is a distributed/decentralized version control system.

=== modified file 'TODO'
--- TODO	2006-01-25 14:30:06 +0000
+++ TODO	2006-03-20 08:31:00 +0000
@@ -362,20 +362,10 @@
   and a new commit will automatically be made against the
   predecessor.  This can be repeated.
 
-  It only makes sense to delete from the tail of history, not from the
-  end.
-
-  The revision, its inventory and texts remain floating in the store.
-  We should perhaps add the revision to a list of removed-commits, so
-  that it can be restored or at least accounted for when checking
-  consistency.  This file would not be versioned, and probably should
-  not propagate when branched.
-
-  If we track merged revisions then we need to update this list too.
-  If the list is stored in a weave it's easy (implicit): the version
-  of the list can remain but it won't be referenced anymore.  It's
-  probably best to just store this list in a weave in the first place
-  and be done.
+  It only makes sense to delete from the tail of history.
+
+  This has been implemented, but it does not remove the texts from
+  the store.
 
 
 Large things

=== modified file 'bzr'
--- bzr	2006-01-25 14:30:06 +0000
+++ bzr	2006-03-20 08:31:00 +0000
@@ -55,7 +55,7 @@
                      "\n")
     raise
 
-if bzrlib.version_info[:3] != (0, 7, 0):
+if bzrlib.version_info[:3] != (0, 8, 0):
     sys.stderr.write("bzr: WARNING: bzrlib version doesn't match the bzr program.\n"
             "This may indicate an installation problem.\n"
             "bzrlib from %s is version %r\n"

=== removed file 'bzr_man.py'
--- bzr_man.py	2006-01-25 14:30:06 +0000
+++ bzr_man.py	1970-01-01 00:00:00 +0000
@@ -1,248 +0,0 @@
-#!/usr/bin/python
-
-# Copyright (C) 2005 by Hans Ulrich Niedermann
-# Portions Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-#<<< code taken from bzr (C) Canonical
-
-import os, sys
-
-import bzrlib, bzrlib.help
-
-#>>> code taken from bzr (C) Canonical
-
-#<<< code by HUN
-
-import time
-import re
-
-
-def man_escape(string):
-    result = string.replace("\\","\\\\")
-    result = result.replace("`","\\`")
-    result = result.replace("'","\\'")
-    result = result.replace("-","\\-")
-    return result
-
-
-class Parser:
-
-    def parse_line(self, line):
-        pass
-
-
-class CommandListParser(Parser):
-
-    """Parser for output of "bzr help commands".
-
-    The parsed content can then be used to
-    - write a "COMMAND OVERVIEW" section into a man page
-    - provide a list of all commands
-    """
-
-    def __init__(self,params):
-        self.params = params
-        self.command_usage = []
-        self.all_commands = []
-        self.usage_exp = re.compile("([a-z0-9-]+).*")
-        self.descr_exp = re.compile("    ([A-Z].*)\s*")
-        self.state = 0
-        self.command = None
-        self.usage = None
-        self.descr = None
-
-    def parse_line(self, line):
-        m = self.usage_exp.match(line)
-	if line == '':
-		return
-        if m:
-            if self.state == 0:
-                if self.usage:
-                    self.command_usage.append((self.command,self.usage,self.descr))
-                    self.all_commands.append(self.command)
-                self.usage = " ".join(line.split(" ")[1:])
-                self.command = m.groups()[0]
-            else:
-                raise RuntimeError, "matching usage line in state %d" % state
-            self.state = 1
-            return
-        m = self.descr_exp.match(line)
-        if m:
-            if self.state == 1:
-                self.descr = m.groups()[0]
-            else:
-                raise RuntimeError, "matching descr line in state %d" % state
-            self.state = 0
-            return
-        raise RuntimeError, "Cannot parse this line ('%s')." % line
-
-    def end_parse(self):
-        if self.state == 0:
-            if self.usage:
-                self.command_usage.append((self.command,self.usage,self.descr))
-                self.all_commands.append(self.command)
-        else:
-            raise RuntimeError, "ending parse in state %d" % state
-
-    def write_to_manpage(self, outfile):
-        bzrcmd = self.params["bzrcmd"]
-        outfile.write('.SH "COMMAND OVERVIEW"\n')
-        for (command,usage,descr) in self.command_usage:
-            outfile.write('.TP\n.B "%s %s"\n%s\n' % (bzrcmd, usage, descr))
-
-
-class HelpReader:
-
-    def __init__(self, parser):
-        self.parser = parser
-
-    def write(self, data):
-        if data[-1] == '\n':
-            data = data[:-1]
-        for line in data.split('\n'):
-            self.parser.parse_line(line)
-
-
-def write_command_details(params, command, usage, descr, outfile):
-    x = ('.SS "%s %s"\n.B "%s"\n.PP\n.B "Usage:"\n%s %s\n\n' %
-         (params["bzrcmd"],
-          command,
-          descr,
-          params["bzrcmd"],
-          usage))
-    outfile.write(man_escape(x))
-
-
-man_preamble = """\
-.\\\" Man page for %(bzrcmd)s (bazaar-ng)
-.\\\"
-.\\\" Large parts of this file are autogenerated from the output of
-.\\\"     \"%(bzrcmd)s help commands\"
-.\\\"     \"%(bzrcmd)s help <cmd>\"
-.\\\"
-.\\\" Generation time: %(timestamp)s
-.\\\"
-"""
-
-# The DESCRIPTION text was taken from http://www.bazaar-ng.org/
-# and is thus (C) Canonical
-man_head = """\
-.TH bzr 1 "%(datestamp)s" "%(version)s" "bazaar-ng"
-.SH "NAME"
-%(bzrcmd)s - bazaar-ng next-generation distributed version control
-.SH "SYNOPSIS"
-.B "%(bzrcmd)s"
-.I "command"
-[
-.I "command_options"
-]
-.br
-.B "%(bzrcmd)s"
-.B "help"
-.br
-.B "%(bzrcmd)s"
-.B "help"
-.I "command"
-.SH "DESCRIPTION"
-bazaar-ng (or
-.B "%(bzrcmd)s"
-) is a project of Canonical to develop an open source distributed version control system that is powerful, friendly, and scalable. Version control means a system that keeps track of previous revisions of software source code or similar information and helps people work on it in teams.
-.SS "Warning"
-bazaar-ng is at an early stage of development, and the design is still changing from week to week. This man page here may be inconsistent with itself, with other documentation or with the code, and sometimes refer to features that are planned but not yet written. Comments are still very welcome; please send them to bazaar-ng@lists.canonical.com.
-"""
-
-man_foot = """\
-.SH "ENVIRONMENT"
-.TP
-.I "BZRPATH"
-Path where
-.B "%(bzrcmd)s"
-is to look for external command.
-.TP
-.I "BZREMAIL"
-E-Mail address of the user. Overrides
-.I "~/.bzr.conf/email" and
-.IR "EMAIL" .
-Example content:
-.I "John Doe <john@example.com>"
-.TP
-.I "EMAIL"
-E-Mail address of the user. Overridden by the content of the file
-.I "~/.bzr.conf/email"
-and of the environment variable
-.IR "BZREMAIL" .
-.SH "FILES"
-.TP
-.I "~/.bzr.conf/"
-Directory where all the user\'s settings are stored.
-.TP
-.I "~/.bzr.conf/email"
-Stores name and email address of the user. Overrides content of
-.I "EMAIL"
-environment variable. Example content:
-.I "John Doe <john@example.com>"
-.SH "SEE ALSO"
-.UR http://www.bazaar-ng.org/
-.BR http://www.bazaar-ng.org/,
-.UR http://www.bazaar-ng.org/doc/
-.BR http://www.bazaar-ng.org/doc/
-"""
-
-def main(args=[]):
-    """ main function
-    :param  args:   command-line arguments (sys.argv[1:])
-    :type   args:   list
-    """
-    t = time.time()
-    tt = time.gmtime(t)
-    params = \
-           { "bzrcmd": "bzr",
-             "datestamp": time.strftime("%Y-%m-%d",tt),
-             "timestamp": time.strftime("%Y-%m-%d %H:%M:%S +0000",tt),
-             "version": bzrlib.__version__,
-             }
-
-    clp = CommandListParser(params)
-    bzrlib.help.help("commands", outfile=HelpReader(clp))
-    clp.end_parse()
-
-    filename = "bzr.1"
-    if len(args) == 1:
-        filename = args[0]
-    if filename == "-":
-        outfile = sys.stdout
-    else:
-        outfile = open(filename,"w")
-
-    outfile.write(man_preamble % params)
-    outfile.write(man_escape(man_head % params))
-    clp.write_to_manpage(outfile)
-
-    # FIXME:
-    #   This doesn't do more than the summary so far.
-    #outfile.write('.SH "DETAILED COMMAND DESCRIPTION"\n')
-    #for (command,usage,descr) in clp.command_usage:
-    #    write_command_details(params, command, usage, descr, outfile = outfile)
-
-    outfile.write(man_escape(man_foot % params))
-
-
-if __name__ == '__main__':
-    main(sys.argv[1:])
-
-
-#>>> code by HUN

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2006-01-25 14:30:06 +0000
+++ bzrlib/__init__.py	2006-03-20 08:31:00 +0000
@@ -16,7 +16,6 @@
 
 """bzr library"""
 
-BZRDIR = ".bzr"
 
 # please keep these sorted (in C locale order) to aid merging
 DEFAULT_IGNORE = [
@@ -89,9 +88,9 @@
 del locale
 
 __copyright__ = "Copyright 2005,06 Canonical Development Ltd."
-__version__ = version_string = '0.7'
+__version__ = version_string = '0.8pre'
 # same format as sys.version_info
-version_info = (0, 7, 0, 'final', 0)
+version_info = (0, 8, 0, 'pre', 0)
 
 
 from bzrlib.symbol_versioning import deprecated_function, zero_seven

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2006-01-25 14:30:06 +0000
+++ bzrlib/add.py	2006-03-20 08:31:00 +0000
@@ -20,7 +20,7 @@
 from bzrlib.inventory import InventoryEntry
 from bzrlib.trace import mutter, note, warning
 from bzrlib.errors import NotBranchError
-from bzrlib.branch import is_control_file
+from bzrlib.workingtree import is_control_file
 import bzrlib.osutils
 from bzrlib.workingtree import WorkingTree
 
@@ -123,14 +123,14 @@
 
         mutter("smart add of %r, abs=%r", f, af)
         
-        if is_control_file(af):
+        if tree.is_control_filename(af):
             raise ForbiddenFileError('cannot add control file %s' % f)
             
         versioned = (inv.path2id(rf) != None)
 
         if kind == 'directory':
             try:
-                sub_branch = WorkingTree(af)
+                sub_branch = WorkingTree.open(af)
                 sub_tree = True
             except NotBranchError:
                 sub_tree = False
@@ -152,7 +152,7 @@
         if kind == 'directory' and recurse and not sub_tree:
             for subf in os.listdir(af):
                 subp = bzrlib.osutils.pathjoin(rf, subf)
-                if subf == bzrlib.BZRDIR:
+                if tree.is_control_filename(subp):
                     mutter("skip control directory %r", subp)
                 else:
                     ignore_glob = tree.is_ignored(subp)

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2006-01-25 14:30:06 +0000
+++ bzrlib/annotate.py	2006-03-20 08:31:00 +0000
@@ -55,7 +55,8 @@
 def _annotate_file(branch, rev_id, file_id ):
 
     rh = branch.revision_history()
-    w = branch.weave_store.get_weave(file_id, branch.get_transaction())
+    w = branch.repository.weave_store.get_weave(file_id, 
+        branch.repository.get_transaction())
     last_origin = None
     for origin, text in w.annotate_iter(rev_id):
         text = text.rstrip('\r\n')
@@ -64,14 +65,14 @@
         else:
             last_origin = origin
             line_rev_id = w.idx_to_name(origin)
-            if not branch.has_revision(line_rev_id):
+            if not branch.repository.has_revision(line_rev_id):
                 (revno_str, author, date_str) = ('?','?','?')
             else:
                 if line_rev_id in rh:
                     revno_str = str(rh.index(line_rev_id) + 1)
                 else:
                     revno_str = 'merge'
-            rev = branch.get_revision(line_rev_id)
+            rev = branch.repository.get_revision(line_rev_id)
             tz = rev.timezone or 0
             date_str = time.strftime('%Y%m%d', 
                                      time.gmtime(rev.timestamp + tz))

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2006-01-25 14:30:06 +0000
+++ bzrlib/branch.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,81 +15,76 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+from copy import deepcopy
+from cStringIO import StringIO
+import errno
+import os
 import shutil
 import sys
-import os
-import errno
+from unittest import TestSuite
 from warnings import warn
-from cStringIO import StringIO
+try:
+    import xml.sax.saxutils
+except ImportError:
+    raise ImportError("We were unable to import 'xml.sax.saxutils',"
+                      " most likely you have an xml.pyc or xml.pyo file"
+                      " lying around in your bzrlib directory."
+                      " Please remove it.")
 
 
 import bzrlib
-import bzrlib.inventory as inventory
-from bzrlib.trace import mutter, note
-from bzrlib.osutils import (isdir, quotefn,
-                            rename, splitpath, sha_file,
-                            file_kind, abspath, normpath, pathjoin)
+import bzrlib.bzrdir as bzrdir
+from bzrlib.config import TreeConfig
+from bzrlib.decorators import needs_read_lock, needs_write_lock
+from bzrlib.delta import compare_trees
 import bzrlib.errors as errors
 from bzrlib.errors import (BzrError, InvalidRevisionNumber, InvalidRevisionId,
                            NoSuchRevision, HistoryMissing, NotBranchError,
-                           DivergedBranches, LockError, UnlistableStore,
+                           DivergedBranches, LockError,
+                           UninitializableFormat,
+                           UnlistableStore,
                            UnlistableBranch, NoSuchFile, NotVersionedError,
                            NoWorkingTree)
+import bzrlib.inventory as inventory
+from bzrlib.inventory import Inventory
+from bzrlib.lockable_files import LockableFiles, TransportLock
+from bzrlib.osutils import (isdir, quotefn,
+                            rename, splitpath, sha_file,
+                            file_kind, abspath, normpath, pathjoin,
+                            safe_unicode,
+                            )
 from bzrlib.textui import show_status
-from bzrlib.revision import (Revision, is_ancestor, get_intervening_revisions,
-                             NULL_REVISION)
-
-from bzrlib.delta import compare_trees
+from bzrlib.trace import mutter, note
 from bzrlib.tree import EmptyTree, RevisionTree
-from bzrlib.inventory import Inventory
+from bzrlib.repository import Repository
+from bzrlib.revision import (
+                             get_intervening_revisions,
+                             is_ancestor,
+                             NULL_REVISION,
+                             Revision,
+                             )
 from bzrlib.store import copy_all
-from bzrlib.store.text import TextStore
-from bzrlib.store.weave import WeaveStore
-from bzrlib.testament import Testament
+from bzrlib.symbol_versioning import *
 import bzrlib.transactions as transactions
 from bzrlib.transport import Transport, get_transport
+from bzrlib.tree import EmptyTree, RevisionTree
+import bzrlib.ui
 import bzrlib.xml5
-import bzrlib.ui
-from config import TreeConfig
 
 
 BZR_BRANCH_FORMAT_4 = "Bazaar-NG branch, format 0.0.4\n"
 BZR_BRANCH_FORMAT_5 = "Bazaar-NG branch, format 5\n"
 BZR_BRANCH_FORMAT_6 = "Bazaar-NG branch, format 6\n"
-## TODO: Maybe include checks for common corruption of newlines, etc?
-
+
+
+# TODO: Maybe include checks for common corruption of newlines, etc?
 
 # TODO: Some operations like log might retrieve the same revisions
 # repeatedly to calculate deltas.  We could perhaps have a weakref
 # cache in memory to make this faster.  In general anything can be
-# cached in memory between lock and unlock operations.
-
-def find_branch(*ignored, **ignored_too):
-    # XXX: leave this here for about one release, then remove it
-    raise NotImplementedError('find_branch() is not supported anymore, '
-                              'please use one of the new branch constructors')
-
-
-def needs_read_lock(unbound):
-    """Decorate unbound to take out and release a read lock."""
-    def decorated(self, *args, **kwargs):
-        self.lock_read()
-        try:
-            return unbound(self, *args, **kwargs)
-        finally:
-            self.unlock()
-    return decorated
-
-
-def needs_write_lock(unbound):
-    """Decorate unbound to take out and release a write lock."""
-    def decorated(self, *args, **kwargs):
-        self.lock_write()
-        try:
-            return unbound(self, *args, **kwargs)
-        finally:
-            self.unlock()
-    return decorated
+# cached in memory between lock and unlock operations. .. nb thats
+# what the transaction identity map provides
+
 
 ######################################################################
 # branch objects
@@ -100,24 +95,28 @@
     base
         Base directory/url of the branch.
     """
+    # this is really an instance variable - FIXME move it there
+    # - RBC 20060112
     base = None
 
     def __init__(self, *ignored, **ignored_too):
         raise NotImplementedError('The Branch class is abstract')
 
     @staticmethod
+    @deprecated_method(zero_eight)
     def open_downlevel(base):
-        """Open a branch which may be of an old format.
-        
-        Only local branches are supported."""
-        return BzrBranch(get_transport(base), relax_version_check=True)
+        """Open a branch which may be of an old format."""
+        return Branch.open(base, _unsupported=True)
         
     @staticmethod
-    def open(base):
-        """Open an existing branch, rooted at 'base' (url)"""
-        t = get_transport(base)
-        mutter("trying to open %r with transport %r", base, t)
-        return BzrBranch(t)
+    def open(base, _unsupported=False):
+        """Open the repository rooted at base.
+
+        For instance, if the repository is at URL/.bzr/repository,
+        Repository.open(URL) -> a Repository instance.
+        """
+        control = bzrdir.BzrDir.open(base, _unsupported)
+        return control.open_branch(_unsupported)
 
     @staticmethod
     def open_containing(url):
@@ -127,35 +126,34 @@
 
         Basically we keep looking up until we find the control directory or
         run into the root.  If there isn't one, raises NotBranchError.
+        If there is one and it is either an unrecognised format or an unsupported 
+        format, UnknownFormatError or UnsupportedFormatError are raised.
         If there is one, it is returned, along with the unused portion of url.
         """
-        t = get_transport(url)
-        while True:
-            try:
-                return BzrBranch(t), t.relpath(url)
-            except NotBranchError, e:
-                mutter('not a branch in: %r %s', t.base, e)
-            new_t = t.clone('..')
-            if new_t.base == t.base:
-                # reached the root, whatever that may be
-                raise NotBranchError(path=url)
-            t = new_t
+        control, relpath = bzrdir.BzrDir.open_containing(url)
+        return control.open_branch(), relpath
 
     @staticmethod
+    @deprecated_function(zero_eight)
     def initialize(base):
-        """Create a new branch, rooted at 'base' (url)"""
-        t = get_transport(base)
-        return BzrBranch(t, init=True)
+        """Create a new working tree and branch, rooted at 'base' (url)
+
+        NOTE: This will soon be deprecated in favour of creation
+        through a BzrDir.
+        """
+        return bzrdir.BzrDir.create_standalone_workingtree(base).branch
 
     def setup_caching(self, cache_root):
         """Subclasses that care about caching should override this, and set
         up cached stores located under cache_root.
         """
+        # seems to be unused, 2006-01-13 mbp
+        warn('%s is deprecated' % self.setup_caching)
         self.cache_root = cache_root
 
     def _get_nick(self):
         cfg = self.tree_config()
-        return cfg.get_option(u"nickname", default=self.base.split('/')[-1])
+        return cfg.get_option(u"nickname", default=self.base.split('/')[-2])
 
     def _set_nick(self, nick):
         cfg = self.tree_config()
@@ -164,18 +162,6 @@
 
     nick = property(_get_nick, _set_nick)
         
-    def push_stores(self, branch_to):
-        """Copy the content of this branches store to branch_to."""
-        raise NotImplementedError('push_stores is abstract')
-
-    def get_transaction(self):
-        """Return the current active transaction.
-
-        If no transaction is active, this returns a passthrough object
-        for which all data is immediately flushed and no caching happens.
-        """
-        raise NotImplementedError('get_transaction is abstract')
-
     def lock_write(self):
         raise NotImplementedError('lock_write is abstract')
         
@@ -185,6 +171,10 @@
     def unlock(self):
         raise NotImplementedError('unlock is abstract')
 
+    def peek_lock_mode(self):
+        """Return lock mode for the Branch: 'r', 'w' or None"""
+        raise NotImplementedError(self.peek_lock_mode)
+
     def abspath(self, name):
         """Return absolute filename for something in the branch
         
@@ -193,49 +183,67 @@
         """
         raise NotImplementedError('abspath is abstract')
 
-    def controlfilename(self, file_or_path):
-        """Return location relative to branch."""
-        raise NotImplementedError('controlfilename is abstract')
-
-    def controlfile(self, file_or_path, mode='r'):
-        """Open a control file for this branch.
-
-        There are two classes of file in the control directory: text
-        and binary.  binary files are untranslated byte streams.  Text
-        control files are stored with Unix newlines and in UTF-8, even
-        if the platform or locale defaults are different.
-
-        Controlfiles should almost never be opened in write mode but
-        rather should be atomically copied and replaced using atomicfile.
-        """
-        raise NotImplementedError('controlfile is abstract')
-
-    def put_controlfile(self, path, f, encode=True):
-        """Write an entry as a controlfile.
-
-        :param path: The path to put the file, relative to the .bzr control
-                     directory
-        :param f: A file-like or string object whose contents should be copied.
-        :param encode:  If true, encode the contents as utf-8
-        """
-        raise NotImplementedError('put_controlfile is abstract')
-
-    def put_controlfiles(self, files, encode=True):
-        """Write several entries as controlfiles.
-
-        :param files: A list of [(path, file)] pairs, where the path is the directory
-                      underneath the bzr control directory
-        :param encode:  If true, encode the contents as utf-8
-        """
-        raise NotImplementedError('put_controlfiles is abstract')
+    def bind(self, other):
+        """Bind the local branch the other branch.
+
+        :param other: The branch to bind to
+        :type other: Branch
+        """
+        raise errors.UpgradeRequired(self.base)
+
+    @needs_write_lock
+    def fetch(self, from_branch, last_revision=None, pb=None):
+        """Copy revisions from from_branch into this branch.
+
+        :param from_branch: Where to copy from.
+        :param last_revision: What revision to stop at (None for at the end
+                              of the branch.
+        :param pb: An optional progress bar to use.
+
+        Returns the copied revision count and the failed revisions in a tuple:
+        (copied, failures).
+        """
+        if self.base == from_branch.base:
+            raise Exception("can't fetch from a branch to itself %s, %s" % 
+                            (self.base, to_branch.base))
+        if pb is None:
+            pb = bzrlib.ui.ui_factory.progress_bar()
+
+        from_branch.lock_read()
+        try:
+            if last_revision is None:
+                pb.update('get source history')
+                from_history = from_branch.revision_history()
+                if from_history:
+                    last_revision = from_history[-1]
+                else:
+                    # no history in the source branch
+                    last_revision = NULL_REVISION
+            return self.repository.fetch(from_branch.repository,
+                                         revision_id=last_revision,
+                                         pb=pb)
+        finally:
+            from_branch.unlock()
+
+    def get_bound_location(self):
+        """Return the URL of the rbanch we are bound to.
+
+        Older format branches cannot bind, please be sure to use a metadir
+        branch.
+        """
+        return None
+
+    def get_master_branch(self):
+        """Return the branch we are bound to.
+        
+        :return: Either a Branch, or None
+        """
+        return None
 
     def get_root_id(self):
         """Return the id of this branches root"""
         raise NotImplementedError('get_root_id is abstract')
 
-    def set_root_id(self, file_id):
-        raise NotImplementedError('set_root_id is abstract')
-
     def print_file(self, file, revision_id):
         """Print `file` to stdout."""
         raise NotImplementedError('print_file is abstract')
@@ -246,69 +254,6 @@
     def set_revision_history(self, rev_history):
         raise NotImplementedError('set_revision_history is abstract')
 
-    def has_revision(self, revision_id):
-        """True if this branch has a copy of the revision.
-
-        This does not necessarily imply the revision is merge
-        or on the mainline."""
-        raise NotImplementedError('has_revision is abstract')
-
-    def get_revision_xml(self, revision_id):
-        raise NotImplementedError('get_revision_xml is abstract')
-
-    def get_revision(self, revision_id):
-        """Return the Revision object for a named revision"""
-        raise NotImplementedError('get_revision is abstract')
-
-    def get_revision_delta(self, revno):
-        """Return the delta for one revision.
-
-        The delta is relative to its mainline predecessor, or the
-        empty tree for revision 1.
-        """
-        assert isinstance(revno, int)
-        rh = self.revision_history()
-        if not (1 <= revno <= len(rh)):
-            raise InvalidRevisionNumber(revno)
-
-        # revno is 1-based; list is 0-based
-
-        new_tree = self.revision_tree(rh[revno-1])
-        if revno == 1:
-            old_tree = EmptyTree()
-        else:
-            old_tree = self.revision_tree(rh[revno-2])
-
-        return compare_trees(old_tree, new_tree)
-
-    def get_revision_sha1(self, revision_id):
-        """Hash the stored value of a revision, and return it."""
-        raise NotImplementedError('get_revision_sha1 is abstract')
-
-    def get_ancestry(self, revision_id):
-        """Return a list of revision-ids integrated by a revision.
-        
-        This currently returns a list, but the ordering is not guaranteed:
-        treat it as a set.
-        """
-        raise NotImplementedError('get_ancestry is abstract')
-
-    def get_inventory(self, revision_id):
-        """Get Inventory object by hash."""
-        raise NotImplementedError('get_inventory is abstract')
-
-    def get_inventory_xml(self, revision_id):
-        """Get inventory XML as a file object."""
-        raise NotImplementedError('get_inventory_xml is abstract')
-
-    def get_inventory_sha1(self, revision_id):
-        """Return the sha1 hash of the inventory entry."""
-        raise NotImplementedError('get_inventory_sha1 is abstract')
-
-    def get_revision_inventory(self, revision_id):
-        """Return inventory of a past revision."""
-        raise NotImplementedError('get_revision_inventory is abstract')
-
     def revision_history(self):
         """Return sequence of revision hashes on to this branch."""
         raise NotImplementedError('revision_history is abstract')
@@ -321,6 +266,10 @@
         """
         return len(self.revision_history())
 
+    def unbind(self):
+        """Older format branches cannot bind or unbind."""
+        raise errors.UpgradeRequired(self.base)
+
     def last_revision(self):
         """Return last patch hash, or None if no history."""
         ph = self.revision_history()
@@ -329,30 +278,34 @@
         else:
             return None
 
-    def missing_revisions(self, other, stop_revision=None, diverged_ok=False):
+    def missing_revisions(self, other, stop_revision=None):
         """Return a list of new revisions that would perfectly fit.
         
         If self and other have not diverged, return a list of the revisions
         present in other, but missing from self.
 
-        >>> from bzrlib.commit import commit
+        >>> from bzrlib.workingtree import WorkingTree
         >>> bzrlib.trace.silent = True
-        >>> br1 = ScratchBranch()
-        >>> br2 = ScratchBranch()
+        >>> d1 = bzrdir.ScratchDir()
+        >>> br1 = d1.open_branch()
+        >>> wt1 = d1.open_workingtree()
+        >>> d2 = bzrdir.ScratchDir()
+        >>> br2 = d2.open_branch()
+        >>> wt2 = d2.open_workingtree()
         >>> br1.missing_revisions(br2)
         []
-        >>> commit(br2, "lala!", rev_id="REVISION-ID-1")
+        >>> wt2.commit("lala!", rev_id="REVISION-ID-1")
         >>> br1.missing_revisions(br2)
         [u'REVISION-ID-1']
         >>> br2.missing_revisions(br1)
         []
-        >>> commit(br1, "lala!", rev_id="REVISION-ID-1")
+        >>> wt1.commit("lala!", rev_id="REVISION-ID-1")
         >>> br1.missing_revisions(br2)
         []
-        >>> commit(br2, "lala!", rev_id="REVISION-ID-2A")
+        >>> wt2.commit("lala!", rev_id="REVISION-ID-2A")
         >>> br1.missing_revisions(br2)
         [u'REVISION-ID-2A']
-        >>> commit(br1, "lala!", rev_id="REVISION-ID-2B")
+        >>> wt1.commit("lala!", rev_id="REVISION-ID-2B")
         >>> br1.missing_revisions(br2)
         Traceback (most recent call last):
         DivergedBranches: These branches have diverged.  Try merge.
@@ -373,9 +326,14 @@
             if stop_revision > other_len:
                 raise bzrlib.errors.NoSuchRevision(self, stop_revision)
         return other_history[self_len:stop_revision]
-    
+
     def update_revisions(self, other, stop_revision=None):
-        """Pull in new perfect-fit revisions."""
+        """Pull in new perfect-fit revisions.
+
+        :param other: Another Branch to pull from
+        :param stop_revision: Updated until the given revision
+        :return: None
+        """
         raise NotImplementedError('update_revisions is abstract')
 
     def pullable_revisions(self, other, stop_revision):
@@ -401,18 +359,7 @@
             raise bzrlib.errors.NoSuchRevision(self, revno)
         return history[revno - 1]
 
-    def revision_tree(self, revision_id):
-        """Return Tree for a revision on this branch.
-
-        `revision_id` may be None for the null revision, in which case
-        an `EmptyTree` is returned."""
-        raise NotImplementedError('revision_tree is abstract')
-
-    def working_tree(self):
-        """Return a `Tree` for the working copy if this is a local branch."""
-        raise NotImplementedError('working_tree is abstract')
-
-    def pull(self, source, overwrite=False):
+    def pull(self, source, overwrite=False, stop_revision=None):
         raise NotImplementedError('pull is abstract')
 
     def basis_tree(self):
@@ -420,7 +367,7 @@
 
         If there are no revisions yet, return an `EmptyTree`.
         """
-        return self.revision_tree(self.last_revision())
+        return self.repository.revision_tree(self.last_revision())
 
     def rename_one(self, from_rel, to_rel):
         """Rename one file.
@@ -465,6 +412,14 @@
     def set_parent(self, url):
         raise NotImplementedError('set_parent is abstract')
 
+    @needs_write_lock
+    def update(self):
+        """Synchronise this branch with the master branch if any. 
+
+        :return: None or the last_revision pivoted out during the update.
+        """
+        return None
+
     def check_revno(self, revno):
         """\
         Check whether a revno corresponds to any revision.
@@ -480,12 +435,351 @@
         """
         if revno < 1 or revno > self.revno():
             raise InvalidRevisionNumber(revno)
-        
-    def sign_revision(self, revision_id, gpg_strategy):
-        raise NotImplementedError('sign_revision is abstract')
-
-    def store_revision_signature(self, gpg_strategy, plaintext, revision_id):
-        raise NotImplementedError('store_revision_signature is abstract')
+
+    @needs_read_lock
+    def clone(self, *args, **kwargs):
+        """Clone this branch into to_bzrdir preserving all semantic values.
+        
+        revision_id: if not None, the revision history in the new branch will
+                     be truncated to end with revision_id.
+        """
+        # for API compatability, until 0.8 releases we provide the old api:
+        # def clone(self, to_location, revision=None, basis_branch=None, to_branch_format=None):
+        # after 0.8 releases, the *args and **kwargs should be changed:
+        # def clone(self, to_bzrdir, revision_id=None):
+        if (kwargs.get('to_location', None) or
+            kwargs.get('revision', None) or
+            kwargs.get('basis_branch', None) or
+            (len(args) and isinstance(args[0], basestring))):
+            # backwards compatability api:
+            warn("Branch.clone() has been deprecated for BzrDir.clone() from"
+                 " bzrlib 0.8.", DeprecationWarning, stacklevel=3)
+            # get basis_branch
+            if len(args) > 2:
+                basis_branch = args[2]
+            else:
+                basis_branch = kwargs.get('basis_branch', None)
+            if basis_branch:
+                basis = basis_branch.bzrdir
+            else:
+                basis = None
+            # get revision
+            if len(args) > 1:
+                revision_id = args[1]
+            else:
+                revision_id = kwargs.get('revision', None)
+            # get location
+            if len(args):
+                url = args[0]
+            else:
+                # no default to raise if not provided.
+                url = kwargs.get('to_location')
+            return self.bzrdir.clone(url,
+                                     revision_id=revision_id,
+                                     basis=basis).open_branch()
+        # new cleaner api.
+        # generate args by hand 
+        if len(args) > 1:
+            revision_id = args[1]
+        else:
+            revision_id = kwargs.get('revision_id', None)
+        if len(args):
+            to_bzrdir = args[0]
+        else:
+            # no default to raise if not provided.
+            to_bzrdir = kwargs.get('to_bzrdir')
+        result = self._format.initialize(to_bzrdir)
+        self.copy_content_into(result, revision_id=revision_id)
+        return  result
+
+    @needs_read_lock
+    def sprout(self, to_bzrdir, revision_id=None):
+        """Create a new line of development from the branch, into to_bzrdir.
+        
+        revision_id: if not None, the revision history in the new branch will
+                     be truncated to end with revision_id.
+        """
+        result = self._format.initialize(to_bzrdir)
+        self.copy_content_into(result, revision_id=revision_id)
+        result.set_parent(self.bzrdir.root_transport.base)
+        return result
+
+    @needs_read_lock
+    def copy_content_into(self, destination, revision_id=None):
+        """Copy the content of self into destination.
+
+        revision_id: if not None, the revision history in the new branch will
+                     be truncated to end with revision_id.
+        """
+        new_history = self.revision_history()
+        if revision_id is not None:
+            try:
+                new_history = new_history[:new_history.index(revision_id) + 1]
+            except ValueError:
+                rev = self.repository.get_revision(revision_id)
+                new_history = rev.get_history(self.repository)[1:]
+        destination.set_revision_history(new_history)
+        parent = self.get_parent()
+        if parent:
+            destination.set_parent(parent)
+
+
+class BranchFormat(object):
+    """An encapsulation of the initialization and open routines for a format.
+
+    Formats provide three things:
+     * An initialization routine,
+     * a format string,
+     * an open routine.
+
+    Formats are placed in an dict by their format string for reference 
+    during branch opening. Its not required that these be instances, they
+    can be classes themselves with class methods - it simply depends on 
+    whether state is needed for a given format or not.
+
+    Once a format is deprecated, just deprecate the initialize and open
+    methods on the format class. Do not deprecate the object, as the 
+    object will be created every time regardless.
+    """
+
+    _default_format = None
+    """The default format used for new branches."""
+
+    _formats = {}
+    """The known formats."""
+
+    @classmethod
+    def find_format(klass, a_bzrdir):
+        """Return the format for the branch object in a_bzrdir."""
+        try:
+            transport = a_bzrdir.get_branch_transport(None)
+            format_string = transport.get("format").read()
+            return klass._formats[format_string]
+        except NoSuchFile:
+            raise NotBranchError(path=transport.base)
+        except KeyError:
+            raise errors.UnknownFormatError(format_string)
+
+    @classmethod
+    def get_default_format(klass):
+        """Return the current default format."""
+        return klass._default_format
+
+    def get_format_string(self):
+        """Return the ASCII format string that identifies this format."""
+        raise NotImplementedError(self.get_format_string)
+
+    def initialize(self, a_bzrdir):
+        """Create a branch of this format in a_bzrdir."""
+        raise NotImplementedError(self.initialized)
+
+    def is_supported(self):
+        """Is this format supported?
+
+        Supported formats can be initialized and opened.
+        Unsupported formats may not support initialization or committing or 
+        some other features depending on the reason for not being supported.
+        """
+        return True
+
+    def open(self, a_bzrdir, _found=False):
+        """Return the branch object for a_bzrdir
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already be done.
+        """
+        raise NotImplementedError(self.open)
+
+    @classmethod
+    def register_format(klass, format):
+        klass._formats[format.get_format_string()] = format
+
+    @classmethod
+    def set_default_format(klass, format):
+        klass._default_format = format
+
+    @classmethod
+    def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
+        del klass._formats[format.get_format_string()]
+
+
+class BzrBranchFormat4(BranchFormat):
+    """Bzr branch format 4.
+
+    This format has:
+     - a revision-history file.
+     - a branch-lock lock file [ to be shared with the bzrdir ]
+    """
+
+    def initialize(self, a_bzrdir):
+        """Create a branch of this format in a_bzrdir."""
+        mutter('creating branch in %s', a_bzrdir.transport.base)
+        branch_transport = a_bzrdir.get_branch_transport(self)
+        utf8_files = [('revision-history', ''),
+                      ('branch-name', ''),
+                      ]
+        control_files = LockableFiles(branch_transport, 'branch-lock',
+                                      TransportLock)
+        control_files.create_lock()
+        control_files.lock_write()
+        try:
+            for file, content in utf8_files:
+                control_files.put_utf8(file, content)
+        finally:
+            control_files.unlock()
+        return self.open(a_bzrdir, _found=True)
+
+    def __init__(self):
+        super(BzrBranchFormat4, self).__init__()
+        self._matchingbzrdir = bzrdir.BzrDirFormat6()
+
+    def open(self, a_bzrdir, _found=False):
+        """Return the branch object for a_bzrdir
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already be done.
+        """
+        if not _found:
+            # we are being called directly and must probe.
+            raise NotImplementedError
+        return BzrBranch(_format=self,
+                         _control_files=a_bzrdir._control_files,
+                         a_bzrdir=a_bzrdir,
+                         _repository=a_bzrdir.open_repository())
+
+
+class BzrBranchFormat5(BranchFormat):
+    """Bzr branch format 5.
+
+    This format has:
+     - a revision-history file.
+     - a format string
+     - a lock file.
+     - works with shared repositories.
+    """
+
+    def get_format_string(self):
+        """See BranchFormat.get_format_string()."""
+        return "Bazaar-NG branch format 5\n"
+        
+    def initialize(self, a_bzrdir):
+        """Create a branch of this format in a_bzrdir."""
+        mutter('creating branch in %s', a_bzrdir.transport.base)
+        branch_transport = a_bzrdir.get_branch_transport(self)
+
+        utf8_files = [('revision-history', ''),
+                      ('branch-name', ''),
+                      ]
+        control_files = LockableFiles(branch_transport, 'lock', TransportLock)
+        control_files.create_lock()
+        control_files.lock_write()
+        control_files.put_utf8('format', self.get_format_string())
+        try:
+            for file, content in utf8_files:
+                control_files.put_utf8(file, content)
+        finally:
+            control_files.unlock()
+        return self.open(a_bzrdir, _found=True, )
+
+    def __init__(self):
+        super(BzrBranchFormat5, self).__init__()
+        self._matchingbzrdir = bzrdir.BzrDirMetaFormat1()
+
+    def open(self, a_bzrdir, _found=False):
+        """Return the branch object for a_bzrdir
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already be done.
+        """
+        if not _found:
+            format = BranchFormat.find_format(a_bzrdir)
+            assert format.__class__ == self.__class__
+        transport = a_bzrdir.get_branch_transport(None)
+        control_files = LockableFiles(transport, 'lock', TransportLock)
+        return BzrBranch5(_format=self,
+                          _control_files=control_files,
+                          a_bzrdir=a_bzrdir,
+                          _repository=a_bzrdir.find_repository())
+
+    def __str__(self):
+        return "Bazaar-NG Metadir branch format 5"
+
+
+class BranchReferenceFormat(BranchFormat):
+    """Bzr branch reference format.
+
+    Branch references are used in implementing checkouts, they
+    act as an alias to the real branch which is at some other url.
+
+    This format has:
+     - A location file
+     - a format string
+    """
+
+    def get_format_string(self):
+        """See BranchFormat.get_format_string()."""
+        return "Bazaar-NG Branch Reference Format 1\n"
+        
+    def initialize(self, a_bzrdir, target_branch=None):
+        """Create a branch of this format in a_bzrdir."""
+        if target_branch is None:
+            # this format does not implement branch itself, thus the implicit
+            # creation contract must see it as uninitializable
+            raise errors.UninitializableFormat(self)
+        mutter('creating branch reference in %s', a_bzrdir.transport.base)
+        branch_transport = a_bzrdir.get_branch_transport(self)
+        # FIXME rbc 20060209 one j-a-ms encoding branch lands this str() cast is not needed.
+        branch_transport.put('location', StringIO(str(target_branch.bzrdir.root_transport.base)))
+        branch_transport.put('format', StringIO(self.get_format_string()))
+        return self.open(a_bzrdir, _found=True)
+
+    def __init__(self):
+        super(BranchReferenceFormat, self).__init__()
+        self._matchingbzrdir = bzrdir.BzrDirMetaFormat1()
+
+    def _make_reference_clone_function(format, a_branch):
+        """Create a clone() routine for a branch dynamically."""
+        def clone(to_bzrdir, revision_id=None):
+            """See Branch.clone()."""
+            return format.initialize(to_bzrdir, a_branch)
+            # cannot obey revision_id limits when cloning a reference ...
+            # FIXME RBC 20060210 either nuke revision_id for clone, or
+            # emit some sort of warning/error to the caller ?!
+        return clone
+
+    def open(self, a_bzrdir, _found=False):
+        """Return the branch that the branch reference in a_bzrdir points at.
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already be done.
+        """
+        if not _found:
+            format = BranchFormat.find_format(a_bzrdir)
+            assert format.__class__ == self.__class__
+        transport = a_bzrdir.get_branch_transport(None)
+        real_bzrdir = bzrdir.BzrDir.open(transport.get('location').read())
+        result = real_bzrdir.open_branch()
+        # this changes the behaviour of result.clone to create a new reference
+        # rather than a copy of the content of the branch.
+        # I did not use a proxy object because that needs much more extensive
+        # testing, and we are only changing one behaviour at the moment.
+        # If we decide to alter more behaviours - i.e. the implicit nickname
+        # then this should be refactored to introduce a tested proxy branch
+        # and a subclass of that for use in overriding clone() and ....
+        # - RBC 20060210
+        result.clone = self._make_reference_clone_function(result)
+        return result
+
+
+# formats which have no format string are not discoverable
+# and not independently creatable, so are not registered.
+__default_format = BzrBranchFormat5()
+BranchFormat.register_format(__default_format)
+BranchFormat.register_format(BranchReferenceFormat())
+BranchFormat.set_default_format(__default_format)
+_legacy_formats = [BzrBranchFormat4(),
+                   ]
 
 class BzrBranch(Branch):
     """A branch stored in the actual filesystem.
@@ -493,57 +787,11 @@
     Note that it's "local" in the context of the filesystem; it doesn't
     really matter if it's on an nfs/smb/afs/coda/... share, as long as
     it's writable, and can be accessed via the normal filesystem API.
-
-    _lock_mode
-        None, or 'r' or 'w'
-
-    _lock_count
-        If _lock_mode is true, a positive count of the number of times the
-        lock has been taken.
-
-    _lock
-        Lock object from bzrlib.lock.
     """
-    # We actually expect this class to be somewhat short-lived; part of its
-    # purpose is to try to isolate what bits of the branch logic are tied to
-    # filesystem access, so that in a later step, we can extricate them to
-    # a separarte ("storage") class.
-    _lock_mode = None
-    _lock_count = None
-    _lock = None
-    _inventory_weave = None
-    # If set to False (by a plugin, etc) BzrBranch will not set the
-    # mode on created files or directories
-    _set_file_mode = True
-    _set_dir_mode = True
     
-    # Map some sort of prefix into a namespace
-    # stuff like "revno:10", "revid:", etc.
-    # This should match a prefix with a function which accepts
-    REVISION_NAMESPACES = {}
-
-    def push_stores(self, branch_to):
-        """See Branch.push_stores."""
-        if (self._branch_format != branch_to._branch_format
-            or self._branch_format != 4):
-            from bzrlib.fetch import greedy_fetch
-            mutter("falling back to fetch logic to push between %s(%s) and %s(%s)",
-                   self, self._branch_format, branch_to, branch_to._branch_format)
-            greedy_fetch(to_branch=branch_to, from_branch=self,
-                         revision=self.last_revision())
-            return
-
-        store_pairs = ((self.text_store,      branch_to.text_store),
-                       (self.inventory_store, branch_to.inventory_store),
-                       (self.revision_store,  branch_to.revision_store))
-        try:
-            for from_store, to_store in store_pairs: 
-                copy_all(from_store, to_store)
-        except UnlistableStore:
-            raise UnlistableBranch(from_store)
-
-    def __init__(self, transport, init=False,
-                 relax_version_check=False):
+    def __init__(self, transport=DEPRECATED_PARAMETER, init=DEPRECATED_PARAMETER,
+                 relax_version_check=DEPRECATED_PARAMETER, _format=None,
+                 _control_files=None, a_bzrdir=None, _repository=None):
         """Create new branch object at a particular location.
 
         transport -- A Transport object, defining how to access files.
@@ -556,71 +804,62 @@
             version is not applied.  This is intended only for
             upgrade/recovery type use; it's not guaranteed that
             all operations will work on old format branches.
-
-        In the test suite, creation of new trees is tested using the
-        `ScratchBranch` class.
         """
-        assert isinstance(transport, Transport), \
-            "%r is not a Transport" % transport
-        self._transport = transport
-        if init:
-            self._make_control()
-        self._check_format(relax_version_check)
-        self._find_modes()
-
-        def get_store(name, compressed=True, prefixed=False):
-            relpath = self._rel_controlfilename(unicode(name))
-            store = TextStore(self._transport.clone(relpath),
-                              dir_mode=self._dir_mode,
-                              file_mode=self._file_mode,
-                              prefixed=prefixed,
-                              compressed=compressed)
-            return store
-
-        def get_weave(name, prefixed=False):
-            relpath = self._rel_controlfilename(unicode(name))
-            ws = WeaveStore(self._transport.clone(relpath),
-                            prefixed=prefixed,
-                            dir_mode=self._dir_mode,
-                            file_mode=self._file_mode)
-            if self._transport.should_cache():
-                ws.enable_cache = True
-            return ws
-
-        if self._branch_format == 4:
-            self.inventory_store = get_store('inventory-store')
-            self.text_store = get_store('text-store')
-            self.revision_store = get_store('revision-store')
-        elif self._branch_format == 5:
-            self.control_weaves = get_weave(u'')
-            self.weave_store = get_weave(u'weaves')
-            self.revision_store = get_store(u'revision-store', compressed=False)
-        elif self._branch_format == 6:
-            self.control_weaves = get_weave(u'')
-            self.weave_store = get_weave(u'weaves', prefixed=True)
-            self.revision_store = get_store(u'revision-store', compressed=False,
-                                            prefixed=True)
-        self.revision_store.register_suffix('sig')
-        self._transaction = None
+        if a_bzrdir is None:
+            self.bzrdir = bzrdir.BzrDir.open(transport.base)
+        else:
+            self.bzrdir = a_bzrdir
+        self._transport = self.bzrdir.transport.clone('..')
+        self._base = self._transport.base
+        self._format = _format
+        if _control_files is None:
+            raise BzrBadParameterMissing('_control_files')
+        self.control_files = _control_files
+        if deprecated_passed(init):
+            warn("BzrBranch.__init__(..., init=XXX): The init parameter is "
+                 "deprecated as of bzr 0.8. Please use Branch.create().",
+                 DeprecationWarning,
+                 stacklevel=2)
+            if init:
+                # this is slower than before deprecation, oh well never mind.
+                # -> its deprecated.
+                self._initialize(transport.base)
+        self._check_format(_format)
+        if deprecated_passed(relax_version_check):
+            warn("BzrBranch.__init__(..., relax_version_check=XXX_: The "
+                 "relax_version_check parameter is deprecated as of bzr 0.8. "
+                 "Please use BzrDir.open_downlevel, or a BzrBranchFormat's "
+                 "open() method.",
+                 DeprecationWarning,
+                 stacklevel=2)
+            if (not relax_version_check
+                and not self._format.is_supported()):
+                raise errors.UnsupportedFormatError(
+                        'sorry, branch format %r not supported' % fmt,
+                        ['use a different bzr version',
+                         'or remove the .bzr directory'
+                         ' and "bzr init" again'])
+        if deprecated_passed(transport):
+            warn("BzrBranch.__init__(transport=XXX...): The transport "
+                 "parameter is deprecated as of bzr 0.8. "
+                 "Please use Branch.open, or bzrdir.open_branch().",
+                 DeprecationWarning,
+                 stacklevel=2)
+        self.repository = _repository
 
     def __str__(self):
-        return '%s(%r)' % (self.__class__.__name__, self._transport.base)
+        return '%s(%r)' % (self.__class__.__name__, self.base)
 
     __repr__ = __str__
 
     def __del__(self):
-        if self._lock_mode or self._lock:
-            # XXX: This should show something every time, and be suitable for
-            # headless operation and embedding
-            warn("branch %r was not explicitly unlocked" % self)
-            self._lock.unlock()
-
         # TODO: It might be best to do this somewhere else,
         # but it is nice for a Branch object to automatically
         # cache it's information.
         # Alternatively, we could have the Transport objects cache requests
         # See the earlier discussion about how major objects (like Branch)
         # should never expect their __del__ function to run.
+        # XXX: cache_root seems to be unused, 2006-01-13 mbp
         if hasattr(self, 'cache_root') and self.cache_root is not None:
             try:
                 shutil.rmtree(self.cache_root)
@@ -629,243 +868,84 @@
             self.cache_root = None
 
     def _get_base(self):
-        if self._transport:
-            return self._transport.base
-        return None
+        return self._base
 
     base = property(_get_base, doc="The URL for the root of this branch.")
 
     def _finish_transaction(self):
         """Exit the current transaction."""
-        if self._transaction is None:
-            raise errors.LockError('Branch %s is not in a transaction' %
-                                   self)
-        transaction = self._transaction
-        self._transaction = None
-        transaction.finish()
+        return self.control_files._finish_transaction()
 
     def get_transaction(self):
-        """See Branch.get_transaction."""
-        if self._transaction is None:
-            return transactions.PassThroughTransaction()
-        else:
-            return self._transaction
-
-    def _set_transaction(self, new_transaction):
+        """Return the current active transaction.
+
+        If no transaction is active, this returns a passthrough object
+        for which all data is immediately flushed and no caching happens.
+        """
+        # this is an explicit function so that we can do tricky stuff
+        # when the storage in rev_storage is elsewhere.
+        # we probably need to hook the two 'lock a location' and 
+        # 'have a transaction' together more delicately, so that
+        # we can have two locks (branch and storage) and one transaction
+        # ... and finishing the transaction unlocks both, but unlocking
+        # does not. - RBC 20051121
+        return self.control_files.get_transaction()
+
+    def _set_transaction(self, transaction):
         """Set a new active transaction."""
-        if self._transaction is not None:
-            raise errors.LockError('Branch %s is in a transaction already.' %
-                                   self)
-        self._transaction = new_transaction
-
-    def lock_write(self):
-        #mutter("lock write: %s (%s)", self, self._lock_count)
-        # TODO: Upgrade locking to support using a Transport,
-        # and potentially a remote locking protocol
-        if self._lock_mode:
-            if self._lock_mode != 'w':
-                raise LockError("can't upgrade to a write lock from %r" %
-                                self._lock_mode)
-            self._lock_count += 1
-        else:
-            self._lock = self._transport.lock_write(
-                    self._rel_controlfilename('branch-lock'))
-            self._lock_mode = 'w'
-            self._lock_count = 1
-            self._set_transaction(transactions.PassThroughTransaction())
-
-    def lock_read(self):
-        #mutter("lock read: %s (%s)", self, self._lock_count)
-        if self._lock_mode:
-            assert self._lock_mode in ('r', 'w'), \
-                   "invalid lock mode %r" % self._lock_mode
-            self._lock_count += 1
-        else:
-            self._lock = self._transport.lock_read(
-                    self._rel_controlfilename('branch-lock'))
-            self._lock_mode = 'r'
-            self._lock_count = 1
-            self._set_transaction(transactions.ReadOnlyTransaction())
-            # 5K may be excessive, but hey, its a knob.
-            self.get_transaction().set_cache_size(5000)
-                        
-    def unlock(self):
-        #mutter("unlock: %s (%s)", self, self._lock_count)
-        if not self._lock_mode:
-            raise LockError('branch %r is not locked' % (self))
-
-        if self._lock_count > 1:
-            self._lock_count -= 1
-        else:
-            self._finish_transaction()
-            self._lock.unlock()
-            self._lock = None
-            self._lock_mode = self._lock_count = None
+        return self.control_files._set_transaction(transaction)
 
     def abspath(self, name):
         """See Branch.abspath."""
-        return self._transport.abspath(name)
-
-    def _rel_controlfilename(self, file_or_path):
-        if not isinstance(file_or_path, basestring):
-            file_or_path = u'/'.join(file_or_path)
-        if file_or_path == '':
-            return bzrlib.BZRDIR
-        return bzrlib.transport.urlescape(bzrlib.BZRDIR + u'/' + file_or_path)
-
-    def controlfilename(self, file_or_path):
-        """See Branch.controlfilename."""
-        return self._transport.abspath(self._rel_controlfilename(file_or_path))
-
-    def controlfile(self, file_or_path, mode='r'):
-        """See Branch.controlfile."""
-        import codecs
-
-        relpath = self._rel_controlfilename(file_or_path)
-        #TODO: codecs.open() buffers linewise, so it was overloaded with
-        # a much larger buffer, do we need to do the same for getreader/getwriter?
-        if mode == 'rb': 
-            return self._transport.get(relpath)
-        elif mode == 'wb':
-            raise BzrError("Branch.controlfile(mode='wb') is not supported, use put_controlfiles")
-        elif mode == 'r':
-            # XXX: Do we really want errors='replace'?   Perhaps it should be
-            # an error, or at least reported, if there's incorrectly-encoded
-            # data inside a file.
-            # <https://launchpad.net/products/bzr/+bug/3823>
-            return codecs.getreader('utf-8')(self._transport.get(relpath), errors='replace')
-        elif mode == 'w':
-            raise BzrError("Branch.controlfile(mode='w') is not supported, use put_controlfiles")
-        else:
-            raise BzrError("invalid controlfile mode %r" % mode)
-
-    def put_controlfile(self, path, f, encode=True):
-        """See Branch.put_controlfile."""
-        self.put_controlfiles([(path, f)], encode=encode)
-
-    def put_controlfiles(self, files, encode=True):
-        """See Branch.put_controlfiles."""
-        import codecs
-        ctrl_files = []
-        for path, f in files:
-            if encode:
-                if isinstance(f, basestring):
-                    f = f.encode('utf-8', 'replace')
-                else:
-                    f = codecs.getwriter('utf-8')(f, errors='replace')
-            path = self._rel_controlfilename(path)
-            ctrl_files.append((path, f))
-        self._transport.put_multi(ctrl_files, mode=self._file_mode)
-
-    def _find_modes(self, path=None):
-        """Determine the appropriate modes for files and directories."""
-        try:
-            if path is None:
-                path = self._rel_controlfilename('')
-            st = self._transport.stat(path)
-        except errors.TransportNotPossible:
-            self._dir_mode = 0755
-            self._file_mode = 0644
-        else:
-            self._dir_mode = st.st_mode & 07777
-            # Remove the sticky and execute bits for files
-            self._file_mode = self._dir_mode & ~07111
-        if not self._set_dir_mode:
-            self._dir_mode = None
-        if not self._set_file_mode:
-            self._file_mode = None
-
-    def _make_control(self):
-        from bzrlib.inventory import Inventory
-        from bzrlib.weavefile import write_weave_v5
-        from bzrlib.weave import Weave
-        
-        # Create an empty inventory
-        sio = StringIO()
-        # if we want per-tree root ids then this is the place to set
-        # them; they're not needed for now and so ommitted for
-        # simplicity.
-        bzrlib.xml5.serializer_v5.write_inventory(Inventory(), sio)
-        empty_inv = sio.getvalue()
-        sio = StringIO()
-        bzrlib.weavefile.write_weave_v5(Weave(), sio)
-        empty_weave = sio.getvalue()
-
-        cfn = self._rel_controlfilename
-        # Since we don't have a .bzr directory, inherit the
-        # mode from the root directory
-        self._find_modes(u'.')
-
-        dirs = ['', 'revision-store', 'weaves']
-        files = [('README', 
-            "This is a Bazaar-NG control directory.\n"
-            "Do not change any files in this directory.\n"),
-            ('branch-format', BZR_BRANCH_FORMAT_6),
-            ('revision-history', ''),
-            ('branch-name', ''),
-            ('branch-lock', ''),
-            ('pending-merges', ''),
-            ('inventory', empty_inv),
-            ('inventory.weave', empty_weave),
-            ('ancestry.weave', empty_weave)
-        ]
-        self._transport.mkdir_multi([cfn(d) for d in dirs], mode=self._dir_mode)
-        self.put_controlfiles(files)
-        mutter('created control directory in ' + self._transport.base)
-
-    def _check_format(self, relax_version_check):
-        """Check this branch format is supported.
-
-        The format level is stored, as an integer, in
-        self._branch_format for code that needs to check it later.
-
-        In the future, we might need different in-memory Branch
-        classes to support downlevel branches.  But not yet.
+        return self.control_files._transport.abspath(name)
+
+    def _check_format(self, format):
+        """Identify the branch format if needed.
+
+        The format is stored as a reference to the format object in
+        self._format for code that needs to check it later.
+
+        The format parameter is either None or the branch format class
+        used to open this branch.
+
+        FIXME: DELETE THIS METHOD when pre 0.8 support is removed.
         """
-        try:
-            fmt = self.controlfile('branch-format', 'r').read()
-        except NoSuchFile:
-            raise NotBranchError(path=self.base)
-        mutter("got branch format %r", fmt)
-        if fmt == BZR_BRANCH_FORMAT_6:
-            self._branch_format = 6
-        elif fmt == BZR_BRANCH_FORMAT_5:
-            self._branch_format = 5
-        elif fmt == BZR_BRANCH_FORMAT_4:
-            self._branch_format = 4
-
-        if (not relax_version_check
-            and self._branch_format not in (5, 6)):
-            raise errors.UnsupportedFormatError(
-                           'sorry, branch format %r not supported' % fmt,
-                           ['use a different bzr version',
-                            'or remove the .bzr directory'
-                            ' and "bzr init" again'])
+        if format is None:
+            format = BzrBranchFormat.find_format(self.bzrdir)
+        self._format = format
+        mutter("got branch format %s", self._format)
 
     @needs_read_lock
     def get_root_id(self):
         """See Branch.get_root_id."""
-        inv = self.get_inventory(self.last_revision())
-        return inv.root.file_id
+        tree = self.repository.revision_tree(self.last_revision())
+        return tree.inventory.root.file_id
+
+    def lock_write(self):
+        # TODO: test for failed two phase locks. This is known broken.
+        self.control_files.lock_write()
+        self.repository.lock_write()
+
+    def lock_read(self):
+        # TODO: test for failed two phase locks. This is known broken.
+        self.control_files.lock_read()
+        self.repository.lock_read()
+
+    def unlock(self):
+        # TODO: test for failed two phase locks. This is known broken.
+        self.repository.unlock()
+        self.control_files.unlock()
+        
+    def peek_lock_mode(self):
+        if self.control_files._lock_count == 0:
+            return None
+        else:
+            return self.control_files._lock_mode
 
     @needs_read_lock
     def print_file(self, file, revision_id):
         """See Branch.print_file."""
-        tree = self.revision_tree(revision_id)
-        # use inventory as it was in that revision
-        file_id = tree.inventory.path2id(file)
-        if not file_id:
-            try:
-                revno = self.revision_id_to_revno(revision_id)
-            except errors.NoSuchRevision:
-                # TODO: This should not be BzrError,
-                # but NoSuchFile doesn't fit either
-                raise BzrError('%r is not present in revision %s' 
-                                % (file, revision_id))
-            else:
-                raise BzrError('%r is not present in revision %s'
-                                % (file, revno))
-        tree.print_file(file_id)
+        return self.repository.print_file(file, revision_id)
 
     @needs_write_lock
     def append_revision(self, *revision_ids):
@@ -879,111 +959,40 @@
     @needs_write_lock
     def set_revision_history(self, rev_history):
         """See Branch.set_revision_history."""
-        old_revision = self.last_revision()
-        new_revision = rev_history[-1]
-        self.put_controlfile('revision-history', '\n'.join(rev_history))
-        try:
-            self.working_tree().set_last_revision(new_revision, old_revision)
-        except NoWorkingTree:
-            mutter('Unable to set_last_revision without a working tree.')
-
-    def has_revision(self, revision_id):
-        """See Branch.has_revision."""
-        return (revision_id is None
-                or self.revision_store.has_id(revision_id))
-
-    @needs_read_lock
-    def _get_revision_xml_file(self, revision_id):
-        if not revision_id or not isinstance(revision_id, basestring):
-            raise InvalidRevisionId(revision_id=revision_id, branch=self)
-        try:
-            return self.revision_store.get(revision_id)
-        except (IndexError, KeyError):
-            raise bzrlib.errors.NoSuchRevision(self, revision_id)
-
-    def get_revision_xml(self, revision_id):
-        """See Branch.get_revision_xml."""
-        return self._get_revision_xml_file(revision_id).read()
-
-    def get_revision(self, revision_id):
-        """See Branch.get_revision."""
-        xml_file = self._get_revision_xml_file(revision_id)
-
-        try:
-            r = bzrlib.xml5.serializer_v5.read_revision(xml_file)
-        except SyntaxError, e:
-            raise bzrlib.errors.BzrError('failed to unpack revision_xml',
-                                         [revision_id,
-                                          str(e)])
-            
-        assert r.revision_id == revision_id
-        return r
-
-    def get_revision_sha1(self, revision_id):
-        """See Branch.get_revision_sha1."""
-        # In the future, revision entries will be signed. At that
-        # point, it is probably best *not* to include the signature
-        # in the revision hash. Because that lets you re-sign
-        # the revision, (add signatures/remove signatures) and still
-        # have all hash pointers stay consistent.
-        # But for now, just hash the contents.
-        return bzrlib.osutils.sha_file(self.get_revision_xml_file(revision_id))
-
-    def get_ancestry(self, revision_id):
-        """See Branch.get_ancestry."""
-        if revision_id is None:
-            return [None]
-        w = self._get_inventory_weave()
-        return [None] + map(w.idx_to_name,
-                            w.inclusions([w.lookup(revision_id)]))
-
-    def _get_inventory_weave(self):
-        return self.control_weaves.get_weave('inventory',
-                                             self.get_transaction())
-
-    def get_inventory(self, revision_id):
-        """See Branch.get_inventory."""
-        xml = self.get_inventory_xml(revision_id)
-        return bzrlib.xml5.serializer_v5.read_inventory_from_string(xml)
-
-    def get_inventory_xml(self, revision_id):
-        """See Branch.get_inventory_xml."""
-        try:
-            assert isinstance(revision_id, basestring), type(revision_id)
-            iw = self._get_inventory_weave()
-            return iw.get_text(iw.lookup(revision_id))
-        except IndexError:
-            raise bzrlib.errors.HistoryMissing(self, 'inventory', revision_id)
-
-    def get_inventory_sha1(self, revision_id):
-        """See Branch.get_inventory_sha1."""
-        return self.get_revision(revision_id).inventory_sha1
-
-    def get_revision_inventory(self, revision_id):
-        """See Branch.get_revision_inventory."""
-        # TODO: Unify this with get_inventory()
-        # bzr 0.0.6 and later imposes the constraint that the inventory_id
-        # must be the same as its revision, so this is trivial.
-        if revision_id == None:
-            # This does not make sense: if there is no revision,
-            # then it is the current tree inventory surely ?!
-            # and thus get_root_id() is something that looks at the last
-            # commit on the branch, and the get_root_id is an inventory check.
-            raise NotImplementedError
-            # return Inventory(self.get_root_id())
+        self.control_files.put_utf8(
+            'revision-history', '\n'.join(rev_history))
+
+    def get_revision_delta(self, revno):
+        """Return the delta for one revision.
+
+        The delta is relative to its mainline predecessor, or the
+        empty tree for revision 1.
+        """
+        assert isinstance(revno, int)
+        rh = self.revision_history()
+        if not (1 <= revno <= len(rh)):
+            raise InvalidRevisionNumber(revno)
+
+        # revno is 1-based; list is 0-based
+
+        new_tree = self.repository.revision_tree(rh[revno-1])
+        if revno == 1:
+            old_tree = EmptyTree()
         else:
-            return self.get_inventory(revision_id)
+            old_tree = self.repository.revision_tree(rh[revno-2])
+        return compare_trees(old_tree, new_tree)
 
     @needs_read_lock
     def revision_history(self):
         """See Branch.revision_history."""
+        # FIXME are transactions bound to control files ? RBC 20051121
         transaction = self.get_transaction()
         history = transaction.map.find_revision_history()
         if history is not None:
             mutter("cache hit for revision-history in %s", self)
             return list(history)
         history = [l.rstrip('\r\n') for l in
-                self.controlfile('revision-history', 'r').readlines()]
+                self.control_files.get_utf8('revision-history').readlines()]
         transaction.map.add_revision_history(history)
         # this call is disabled because revision_history is 
         # not really an object yet, and the transaction is for objects.
@@ -992,28 +1001,26 @@
 
     def update_revisions(self, other, stop_revision=None):
         """See Branch.update_revisions."""
-        from bzrlib.fetch import greedy_fetch
         if stop_revision is None:
             stop_revision = other.last_revision()
         ### Should this be checking is_ancestor instead of revision_history?
         if (stop_revision is not None and 
             stop_revision in self.revision_history()):
             return
-        greedy_fetch(to_branch=self, from_branch=other,
-                     revision=stop_revision)
+        self.fetch(other, stop_revision)
         pullable_revs = self.pullable_revisions(other, stop_revision)
         if len(pullable_revs) > 0:
             self.append_revision(*pullable_revs)
 
     def pullable_revisions(self, other, stop_revision):
-        """See Branch.pullable_revisions."""
         other_revno = other.revision_id_to_revno(stop_revision)
         try:
             return self.missing_revisions(other, other_revno)
         except DivergedBranches, e:
             try:
                 pullable_revs = get_intervening_revisions(self.last_revision(),
-                                                          stop_revision, self)
+                                                          stop_revision, 
+                                                          self.repository)
                 assert self.last_revision() not in pullable_revs
                 return pullable_revs
             except bzrlib.errors.NotAncestor:
@@ -1022,41 +1029,28 @@
                 else:
                     raise e
         
-    def revision_tree(self, revision_id):
-        """See Branch.revision_tree."""
-        # TODO: refactor this to use an existing revision object
-        # so we don't need to read it in twice.
-        if revision_id == None or revision_id == NULL_REVISION:
-            return EmptyTree()
-        else:
-            inv = self.get_revision_inventory(revision_id)
-            return RevisionTree(self, inv, revision_id)
-
     def basis_tree(self):
         """See Branch.basis_tree."""
-        try:
-            revision_id = self.revision_history()[-1]
-            xml = self.working_tree().read_basis_inventory(revision_id)
-            inv = bzrlib.xml5.serializer_v5.read_inventory_from_string(xml)
-            return RevisionTree(self, inv, revision_id)
-        except (IndexError, NoSuchFile, NoWorkingTree), e:
-            return self.revision_tree(self.last_revision())
+        return self.repository.revision_tree(self.last_revision())
 
+    @deprecated_method(zero_eight)
     def working_tree(self):
-        """See Branch.working_tree."""
+        """Create a Working tree object for this branch."""
         from bzrlib.workingtree import WorkingTree
-        if self._transport.base.find('://') != -1:
+        from bzrlib.transport.local import LocalTransport
+        if (self.base.find('://') != -1 or 
+            not isinstance(self._transport, LocalTransport)):
             raise NoWorkingTree(self.base)
-        return WorkingTree(self.base, branch=self)
+        return self.bzrdir.open_workingtree()
 
     @needs_write_lock
-    def pull(self, source, overwrite=False):
+    def pull(self, source, overwrite=False, stop_revision=None):
         """See Branch.pull."""
         source.lock_read()
         try:
             old_count = len(self.revision_history())
             try:
-                self.update_revisions(source)
+                self.update_revisions(source,stop_revision)
             except DivergedBranches:
                 if not overwrite:
                     raise
@@ -1073,7 +1067,7 @@
         _locs = ['parent', 'pull', 'x-pull']
         for l in _locs:
             try:
-                return self.controlfile(l, 'r').read().strip('\n')
+                return self.control_files.get_utf8(l).read().strip('\n')
             except NoSuchFile:
                 pass
         return None
@@ -1093,96 +1087,194 @@
     def set_parent(self, url):
         """See Branch.set_parent."""
         # TODO: Maybe delete old location files?
-        from bzrlib.atomicfile import AtomicFile
-        f = AtomicFile(self.controlfilename('parent'))
-        try:
-            f.write(url + '\n')
-            f.commit()
-        finally:
-            f.close()
+        # URLs should never be unicode, even on the local fs,
+        # FIXUP this and get_parent in a future branch format bump:
+        # read and rewrite the file, and have the new format code read
+        # using .get not .get_utf8. RBC 20060125
+        self.control_files.put_utf8('parent', url + '\n')
 
     def tree_config(self):
         return TreeConfig(self)
 
-    def sign_revision(self, revision_id, gpg_strategy):
-        """See Branch.sign_revision."""
-        plaintext = Testament.from_revision(self, revision_id).as_short_text()
-        self.store_revision_signature(gpg_strategy, plaintext, revision_id)
-
-    @needs_write_lock
-    def store_revision_signature(self, gpg_strategy, plaintext, revision_id):
-        """See Branch.store_revision_signature."""
-        self.revision_store.add(StringIO(gpg_strategy.sign(plaintext)), 
-                                revision_id, "sig")
-
-
-class ScratchBranch(BzrBranch):
-    """Special test class: a branch that cleans up after itself.
-
-    >>> b = ScratchBranch()
-    >>> isdir(b.base)
-    True
-    >>> bd = b.base
-    >>> b._transport.__del__()
-    >>> isdir(bd)
-    False
+
+class BzrBranch5(BzrBranch):
+    """A format 5 branch. This supports new features over plan branches.
+
+    It has support for a master_branch which is the data for bound branches.
     """
 
-    def __init__(self, files=[], dirs=[], transport=None):
-        """Make a test branch.
-
-        This creates a temporary directory and runs init-tree in it.
-
-        If any files are listed, they are created in the working copy.
-        """
-        if transport is None:
-            transport = bzrlib.transport.local.ScratchTransport()
-            super(ScratchBranch, self).__init__(transport, init=True)
+    def __init__(self,
+                 _format,
+                 _control_files,
+                 a_bzrdir,
+                 _repository):
+        super(BzrBranch5, self).__init__(_format=_format,
+                                         _control_files=_control_files,
+                                         a_bzrdir=a_bzrdir,
+                                         _repository=_repository)
+        
+    @needs_write_lock
+    def pull(self, source, overwrite=False, stop_revision=None):
+        """Updates branch.pull to be bound branch aware."""
+        bound_location = self.get_bound_location()
+        if source.base != bound_location:
+            # not pulling from master, so we need to update master.
+            master_branch = self.get_master_branch()
+            if master_branch:
+                master_branch.pull(source)
+                source = master_branch
+        return super(BzrBranch5, self).pull(source, overwrite, stop_revision)
+
+    def get_bound_location(self):
+        try:
+            return self.control_files.get_utf8('bound').read()[:-1]
+        except errors.NoSuchFile:
+            return None
+
+    @needs_read_lock
+    def get_master_branch(self):
+        """Return the branch we are bound to.
+        
+        :return: Either a Branch, or None
+
+        This could memoise the branch, but if thats done
+        it must be revalidated on each new lock.
+        So for now we just dont memoise it.
+        # RBC 20060304 review this decision.
+        """
+        bound_loc = self.get_bound_location()
+        if not bound_loc:
+            return None
+        try:
+            return Branch.open(bound_loc)
+        except (errors.NotBranchError, errors.ConnectionError), e:
+            raise errors.BoundBranchConnectionFailure(
+                    self, bound_loc, e)
+
+    @needs_write_lock
+    def set_bound_location(self, location):
+        """Set the target where this branch is bound to.
+
+        :param location: URL to the target branch
+        """
+        if location:
+            self.control_files.put_utf8('bound', location+'\n')
         else:
-            super(ScratchBranch, self).__init__(transport)
-
-        for d in dirs:
-            self._transport.mkdir(d)
-            
-        for f in files:
-            self._transport.put(f, 'content of %s' % f)
-
-
-    def clone(self):
-        """
-        >>> orig = ScratchBranch(files=["file1", "file2"])
-        >>> clone = orig.clone()
-        >>> if os.name != 'nt':
-        ...   os.path.samefile(orig.base, clone.base)
-        ... else:
-        ...   orig.base == clone.base
-        ...
-        False
-        >>> os.path.isfile(pathjoin(clone.base, "file1"))
-        True
-        """
-        from shutil import copytree
-        from bzrlib.osutils import mkdtemp
-        base = mkdtemp()
-        os.rmdir(base)
-        copytree(self.base, base, symlinks=True)
-        return ScratchBranch(
-            transport=bzrlib.transport.local.ScratchTransport(base))
+            try:
+                self.control_files._transport.delete('bound')
+            except NoSuchFile:
+                return False
+            return True
+
+    @needs_write_lock
+    def bind(self, other):
+        """Bind the local branch the other branch.
+
+        :param other: The branch to bind to
+        :type other: Branch
+        """
+        # TODO: jam 20051230 Consider checking if the target is bound
+        #       It is debatable whether you should be able to bind to
+        #       a branch which is itself bound.
+        #       Committing is obviously forbidden,
+        #       but binding itself may not be.
+        #       Since we *have* to check at commit time, we don't
+        #       *need* to check here
+        self.pull(other)
+
+        # we are now equal to or a suffix of other.
+
+        # Since we have 'pulled' from the remote location,
+        # now we should try to pull in the opposite direction
+        # in case the local tree has more revisions than the
+        # remote one.
+        # There may be a different check you could do here
+        # rather than actually trying to install revisions remotely.
+        # TODO: capture an exception which indicates the remote branch
+        #       is not writeable. 
+        #       If it is up-to-date, this probably should not be a failure
+        
+        # lock other for write so the revision-history syncing cannot race
+        other.lock_write()
+        try:
+            other.pull(self)
+            # if this does not error, other now has the same last rev we do
+            # it can only error if the pull from other was concurrent with
+            # a commit to other from someone else.
+
+            # until we ditch revision-history, we need to sync them up:
+            self.set_revision_history(other.revision_history())
+            # now other and self are up to date with each other and have the
+            # same revision-history.
+        finally:
+            other.unlock()
+
+        self.set_bound_location(other.base)
+
+    @needs_write_lock
+    def unbind(self):
+        """If bound, unbind"""
+        return self.set_bound_location(None)
+
+    @needs_write_lock
+    def update(self):
+        """Synchronise this branch with the master branch if any. 
+
+        :return: None or the last_revision that was pivoted out during the
+                 update.
+        """
+        master = self.get_master_branch()
+        if master is not None:
+            old_tip = self.last_revision()
+            self.pull(master, overwrite=True)
+            if old_tip in self.repository.get_ancestry(self.last_revision()):
+                return None
+            return old_tip
+        return None
+
+
+class BranchTestProviderAdapter(object):
+    """A tool to generate a suite testing multiple branch formats at once.
+
+    This is done by copying the test once for each transport and injecting
+    the transport_server, transport_readonly_server, and branch_format
+    classes into each copy. Each copy is also given a new id() to make it
+    easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, formats):
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self._formats = formats
     
+    def adapt(self, test):
+        result = TestSuite()
+        for branch_format, bzrdir_format in self._formats:
+            new_test = deepcopy(test)
+            new_test.transport_server = self._transport_server
+            new_test.transport_readonly_server = self._transport_readonly_server
+            new_test.bzrdir_format = bzrdir_format
+            new_test.branch_format = branch_format
+            def make_new_test_id():
+                new_id = "%s(%s)" % (new_test.id(), branch_format.__class__.__name__)
+                return lambda: new_id
+            new_test.id = make_new_test_id()
+            result.addTest(new_test)
+        return result
+
 
 ######################################################################
 # predicates
 
 
-def is_control_file(filename):
-    ## FIXME: better check
-    filename = normpath(filename)
-    while filename != '':
-        head, tail = os.path.split(filename)
-        ## mutter('check %r for control file' % ((head, tail), ))
-        if tail == bzrlib.BZRDIR:
-            return True
-        if filename == head:
-            break
-        filename = head
-    return False
+@deprecated_function(zero_eight)
+def ScratchBranch(*args, **kwargs):
+    """See bzrlib.bzrdir.ScratchDir."""
+    d = ScratchDir(*args, **kwargs)
+    return d.open_branch()
+
+
+@deprecated_function(zero_eight)
+def is_control_file(*args, **kwargs):
+    """See bzrlib.workingtree.is_control_file."""
+    return bzrlib.workingtree.is_control_file(*args, **kwargs)

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2006-01-25 14:30:06 +0000
+++ bzrlib/builtins.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
+# Copyright (C) 2004, 2005, 2006 by Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,30 +16,33 @@
 
 """builtin bzr commands"""
 
-# DO NOT change this to cStringIO - it results in control files 
-# written as UCS4
-# FIXIT! (Only deal with byte streams OR unicode at any one layer.)
-# RBC 20051018
 
-from StringIO import StringIO
+import errno
+import os
+from shutil import rmtree
 import sys
-import os
 
 import bzrlib
-from bzrlib import BZRDIR
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
 from bzrlib.commands import Command, display_command
-from bzrlib.branch import Branch
 from bzrlib.revision import common_ancestor
 import bzrlib.errors as errors
 from bzrlib.errors import (BzrError, BzrCheckError, BzrCommandError, 
                            NotBranchError, DivergedBranches, NotConflicted,
-                           NoSuchFile, NoWorkingTree, FileInWrongBranch)
+                           NoSuchFile, NoWorkingTree, FileInWrongBranch,
+                           NotVersionedError)
+from bzrlib.log import show_one_log
+from bzrlib.merge import Merge3Merger
 from bzrlib.option import Option
+from bzrlib.progress import DummyProgress
 from bzrlib.revisionspec import RevisionSpec
 import bzrlib.trace
 from bzrlib.trace import mutter, note, log_error, warning, is_quiet
+from bzrlib.transport.local import LocalTransport
+import bzrlib.ui
 from bzrlib.workingtree import WorkingTree
-from bzrlib.log import show_one_log
 
 
 def tree_files(file_list, default_branch=u'.'):
@@ -123,9 +126,9 @@
     def run(self, all=False, show_ids=False, file_list=None, revision=None):
         tree, file_list = tree_files(file_list)
             
-        from bzrlib.status import show_status
-        show_status(tree.branch, show_unchanged=all, show_ids=show_ids,
-                    specific_files=file_list, revision=revision)
+        from bzrlib.status import show_tree_status
+        show_tree_status(tree, show_unchanged=all, show_ids=show_ids,
+                         specific_files=file_list, revision=revision)
 
 
 class cmd_cat_revision(Command):
@@ -148,13 +151,13 @@
             raise BzrCommandError('You must supply either --revision or a revision_id')
         b = WorkingTree.open_containing(u'.')[0].branch
         if revision_id is not None:
-            sys.stdout.write(b.get_revision_xml(revision_id))
+            sys.stdout.write(b.repository.get_revision_xml(revision_id))
         elif revision is not None:
             for rev in revision:
                 if rev is None:
                     raise BzrCommandError('You cannot specify a NULL revision.')
                 revno, rev_id = rev.in_history(b)
-                sys.stdout.write(b.get_revision_xml(rev_id))
+                sys.stdout.write(b.repository.get_revision_xml(rev_id))
     
 
 class cmd_revno(Command):
@@ -298,7 +301,7 @@
             if len(revision) > 1:
                 raise BzrCommandError('bzr inventory --revision takes'
                     ' exactly one revision identifier')
-            inv = tree.branch.get_revision_inventory(
+            inv = tree.branch.repository.get_revision_inventory(
                 revision[0].in_history(tree.branch).rev_id)
 
         for path, entry in inv.entries():
@@ -395,13 +398,10 @@
     If you want to forget your local changes and just update your branch to
     match the remote one, use --overwrite.
     """
-    takes_options = ['remember', 'overwrite', 'verbose']
+    takes_options = ['remember', 'overwrite', 'revision', 'verbose']
     takes_args = ['location?']
 
-    def run(self, location=None, remember=False, overwrite=False, verbose=False):
-        from bzrlib.merge import merge
-        from shutil import rmtree
-        import errno
+    def run(self, location=None, remember=False, overwrite=False, revision=None, verbose=False):
         # FIXME: too much stuff is in the command class        
         tree_to = WorkingTree.open_containing(u'.')[0]
         stored_loc = tree_to.branch.get_parent()
@@ -415,8 +415,15 @@
         br_from = Branch.open(location)
         br_to = tree_to.branch
 
+        if revision is None:
+            rev_id = None
+        elif len(revision) == 1:
+            rev_id = revision[0].in_history(br_from).rev_id
+        else:
+            raise BzrCommandError('bzr pull --revision takes one value.')
+
         old_rh = br_to.revision_history()
-        count = tree_to.pull(br_from, overwrite)
+        count = tree_to.pull(br_from, overwrite, rev_id)
 
         if br_to.get_parent() is None or remember:
             br_to.set_parent(location)
@@ -463,8 +470,6 @@
             create_prefix=False, verbose=False):
         # FIXME: Way too big!  Put this into a function called from the
         # command.
-        import errno
-        from shutil import rmtree
         from bzrlib.transport import get_transport
         
         tree_from = WorkingTree.open_containing(u'.')[0]
@@ -502,7 +507,7 @@
                         if new_transport.base == transport.base:
                             raise BzrCommandError("Could not creeate "
                                                   "path prefix.")
-            br_to = Branch.initialize(location)
+            br_to = bzrlib.bzrdir.BzrDir.create_branch_convenience(location)
         old_rh = br_to.revision_history()
         try:
             try:
@@ -548,9 +553,6 @@
     aliases = ['get', 'clone']
 
     def run(self, from_location, to_location=None, revision=None, basis=None):
-        from bzrlib.clone import copy_branch
-        import errno
-        from shutil import rmtree
         if revision is None:
             revision = [None]
         elif len(revision) > 1:
@@ -567,13 +569,16 @@
         br_from.lock_read()
         try:
             if basis is not None:
-                basis_branch = WorkingTree.open_containing(basis)[0].branch
+                basis_dir = bzrdir.BzrDir.open_containing(basis)[0]
             else:
-                basis_branch = None
+                basis_dir = None
             if len(revision) == 1 and revision[0] is not None:
                 revision_id = revision[0].in_history(br_from)[1]
             else:
-                revision_id = None
+                # FIXME - wt.last_revision, fallback to branch, fall back to
+                # None or perhaps NULL_REVISION to mean copy nothing
+                # RBC 20060209
+                revision_id = br_from.last_revision()
             if to_location is None:
                 to_location = os.path.basename(from_location.rstrip("/\\"))
                 name = None
@@ -591,24 +596,95 @@
                 else:
                     raise
             try:
-                copy_branch(br_from, to_location, revision_id, basis_branch)
+                # preserve whatever source format we have.
+                dir = br_from.bzrdir.sprout(to_location, revision_id, basis_dir)
+                branch = dir.open_branch()
             except bzrlib.errors.NoSuchRevision:
                 rmtree(to_location)
                 msg = "The branch %s has no revision %s." % (from_location, revision[0])
                 raise BzrCommandError(msg)
             except bzrlib.errors.UnlistableBranch:
                 rmtree(to_location)
-                msg = "The branch %s cannot be used as a --basis"
+                msg = "The branch %s cannot be used as a --basis" % (basis,)
                 raise BzrCommandError(msg)
-            branch = Branch.open(to_location)
             if name:
-                name = StringIO(name)
-                branch.put_controlfile('branch-name', name)
+                branch.control_files.put_utf8('branch-name', name)
+
             note('Branched %d revision(s).' % branch.revno())
         finally:
             br_from.unlock()
 
 
+class cmd_checkout(Command):
+    """Create a new checkout of an existing branch.
+
+    If the TO_LOCATION is omitted, the last component of the BRANCH_LOCATION will
+    be used.  In other words, "checkout ../foo/bar" will attempt to create ./bar.
+
+    To retrieve the branch as of a particular revision, supply the --revision
+    parameter, as in "checkout foo/bar -r 5". Note that this will be immediately
+    out of date [so you cannot commit] but it may be useful (i.e. to examine old
+    code.)
+
+    --basis is to speed up checking out from remote branches.  When specified, it
+    uses the inventory and file contents from the basis branch in preference to the
+    branch being checked out. [Not implemented yet.]
+    """
+    takes_args = ['branch_location', 'to_location?']
+    takes_options = ['revision', # , 'basis']
+                     Option('lightweight',
+                            help="perform a lightweight checkout. Lightweight "
+                                 "checkouts depend on access to the branch for "
+                                 "every operation. Normal checkouts can perform "
+                                 "common operations like diff and status without "
+                                 "such access, and also support local commits."
+                            ),
+                     ]
+
+    def run(self, branch_location, to_location=None, revision=None, basis=None,
+            lightweight=False):
+        if revision is None:
+            revision = [None]
+        elif len(revision) > 1:
+            raise BzrCommandError(
+                'bzr checkout --revision takes exactly 1 revision value')
+        source = Branch.open(branch_location)
+        if len(revision) == 1 and revision[0] is not None:
+            revision_id = revision[0].in_history(source)[1]
+        else:
+            revision_id = None
+        if to_location is None:
+            to_location = os.path.basename(branch_location.rstrip("/\\"))
+        try:
+            os.mkdir(to_location)
+        except OSError, e:
+            if e.errno == errno.EEXIST:
+                raise BzrCommandError('Target directory "%s" already'
+                                      ' exists.' % to_location)
+            if e.errno == errno.ENOENT:
+                raise BzrCommandError('Parent of "%s" does not exist.' %
+                                      to_location)
+            else:
+                raise
+        old_format = bzrlib.bzrdir.BzrDirFormat.get_default_format()
+        bzrlib.bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            if lightweight:
+                checkout = bzrdir.BzrDirMetaFormat1().initialize(to_location)
+                bzrlib.branch.BranchReferenceFormat().initialize(checkout, source)
+            else:
+                checkout_branch =  bzrlib.bzrdir.BzrDir.create_branch_convenience(
+                    to_location, force_new_tree=False)
+                checkout = checkout_branch.bzrdir
+                checkout_branch.bind(source)
+                if revision_id is not None:
+                    rh = checkout_branch.revision_history()
+                    checkout_branch.set_revision_history(rh[:rh.index(revision_id) + 1])
+            checkout.create_workingtree(revision_id)
+        finally:
+            bzrlib.bzrdir.BzrDirFormat.set_default_format(old_format)
+
+
 class cmd_renames(Command):
     """Show list of renamed files.
     """
@@ -620,7 +696,7 @@
     @display_command
     def run(self, dir=u'.'):
         tree = WorkingTree.open_containing(dir)[0]
-        old_inv = tree.branch.basis_tree().inventory
+        old_inv = tree.basis_tree().inventory
         new_inv = tree.read_working_inventory()
 
         renames = list(bzrlib.tree.find_renames(old_inv, new_inv))
@@ -629,15 +705,47 @@
             print "%s => %s" % (old_name, new_name)        
 
 
+class cmd_update(Command):
+    """Update a tree to have the latest code committed to its branch.
+    
+    This will perform a merge into the working tree, and may generate
+    conflicts. If you have any local changes, you will still 
+    need to commit them after the update for the update to be complete.
+    
+    If you want to discard your local changes, you can just do a 
+    'bzr revert' instead of 'bzr commit' after the update.
+    """
+    takes_args = ['dir?']
+
+    def run(self, dir='.'):
+        tree = WorkingTree.open_containing(dir)[0]
+        tree.lock_write()
+        try:
+            if tree.last_revision() == tree.branch.last_revision():
+                # may be up to date, check master too.
+                master = tree.branch.get_master_branch()
+                if master is None or master.last_revision == tree.last_revision():
+                    note("Tree is up to date.")
+                    return
+            conflicts = tree.update()
+            note('Updated to revision %d.' %
+                 (tree.branch.revision_id_to_revno(tree.last_revision()),))
+            if conflicts != 0:
+                return 1
+            else:
+                return 0
+        finally:
+            tree.unlock()
+
+
 class cmd_info(Command):
     """Show statistical information about a branch."""
     takes_args = ['branch?']
     
     @display_command
     def run(self, branch=None):
-        import info
-        b = WorkingTree.open_containing(branch)[0].branch
-        info.show_info(b)
+        import bzrlib.info
+        bzrlib.info.show_bzrdir_info(bzrdir.BzrDir.open_containing(branch)[0])
 
 
 class cmd_remove(Command):
@@ -692,6 +800,32 @@
             print fip
 
 
+class cmd_reconcile(Command):
+    """Reconcile bzr metadata in a branch.
+
+    This can correct data mismatches that may have been caused by
+    previous ghost operations or bzr upgrades. You should only
+    need to run this command if 'bzr check' or a bzr developer 
+    advises you to run it.
+
+    If a second branch is provided, cross-branch reconciliation is
+    also attempted, which will check that data like the tree root
+    id which was not present in very early bzr versions is represented
+    correctly in both branches.
+
+    At the same time it is run it may recompress data resulting in 
+    a potential saving in disk space or performance gain.
+
+    The branch *MUST* be on a listable system such as local disk or sftp.
+    """
+    takes_args = ['branch?']
+
+    def run(self, branch="."):
+        from bzrlib.reconcile import reconcile
+        dir = bzrlib.bzrdir.BzrDir.open(branch)
+        reconcile(dir)
+
+
 class cmd_revision_history(Command):
     """Display list of revision ids on this branch."""
     hidden = True
@@ -710,7 +844,7 @@
         tree = WorkingTree.open_containing(u'.')[0]
         b = tree.branch
         # FIXME. should be tree.last_revision
-        for revision_id in b.get_ancestry(b.last_revision()):
+        for revision_id in b.repository.get_ancestry(b.last_revision()):
             print revision_id
 
 
@@ -740,7 +874,7 @@
             # locations if the user supplies an extended path
             if not os.path.exists(location):
                 os.mkdir(location)
-        Branch.initialize(location)
+        bzrdir.BzrDir.create_standalone_workingtree(location)
 
 
 class cmd_diff(Command):
@@ -774,40 +908,40 @@
 
     @display_command
     def run(self, revision=None, file_list=None, diff_options=None):
-        from bzrlib.diff import show_diff
+        from bzrlib.diff import diff_cmd_helper, show_diff_trees
         try:
-            tree, file_list = internal_tree_files(file_list)
+            tree1, file_list = internal_tree_files(file_list)
+            tree2 = None
             b = None
             b2 = None
         except FileInWrongBranch:
             if len(file_list) != 2:
                 raise BzrCommandError("Files are in different branches")
 
-            b, file1 = Branch.open_containing(file_list[0])
-            b2, file2 = Branch.open_containing(file_list[1])
+            tree1, file1 = WorkingTree.open_containing(file_list[0])
+            tree2, file2 = WorkingTree.open_containing(file_list[1])
             if file1 != "" or file2 != "":
                 # FIXME diff those two files. rbc 20051123
                 raise BzrCommandError("Files are in different branches")
             file_list = None
         if revision is not None:
-            if b2 is not None:
+            if tree2 is not None:
                 raise BzrCommandError("Can't specify -r with two branches")
-            if len(revision) == 1:
-                return show_diff(tree.branch, revision[0], specific_files=file_list,
-                                 external_diff_options=diff_options)
+            if (len(revision) == 1) or (revision[1].spec is None):
+                return diff_cmd_helper(tree1, file_list, diff_options,
+                                       revision[0])
             elif len(revision) == 2:
-                return show_diff(tree.branch, revision[0], specific_files=file_list,
-                                 external_diff_options=diff_options,
-                                 revision2=revision[1])
+                return diff_cmd_helper(tree1, file_list, diff_options,
+                                       revision[0], revision[1])
             else:
                 raise BzrCommandError('bzr diff --revision takes exactly one or two revision identifiers')
         else:
-            if b is not None:
-                return show_diff(b, None, specific_files=file_list,
-                                 external_diff_options=diff_options, b2=b2)
+            if tree2 is not None:
+                return show_diff_trees(tree1, tree2, sys.stdout, 
+                                       specific_files=file_list,
+                                       external_diff_options=diff_options)
             else:
-                return show_diff(tree.branch, None, specific_files=file_list,
-                                 external_diff_options=diff_options)
+                return diff_cmd_helper(tree1, file_list, diff_options)
 
 
 class cmd_deleted(Command):
@@ -822,7 +956,7 @@
     @display_command
     def run(self, show_ids=False):
         tree = WorkingTree.open_containing(u'.')[0]
-        old = tree.branch.basis_tree()
+        old = tree.basis_tree()
         for path, ie in old.inventory.iter_entries():
             if not tree.has_id(ie.file_id):
                 if show_ids:
@@ -839,7 +973,7 @@
         from bzrlib.delta import compare_trees
 
         tree = WorkingTree.open_containing(u'.')[0]
-        td = compare_trees(tree.branch.basis_tree(), tree)
+        td = compare_trees(tree.basis_tree(), tree)
 
         for path, id, kind, text_modified, meta_modified in td.modified:
             print path
@@ -852,7 +986,7 @@
     @display_command
     def run(self):
         wt = WorkingTree.open_containing(u'.')[0]
-        basis_inv = wt.branch.basis_tree().inventory
+        basis_inv = wt.basis_tree().inventory
         inv = wt.inventory
         for file_id in inv:
             if file_id in basis_inv:
@@ -892,6 +1026,7 @@
                             help='show from oldest to newest'),
                      'timezone', 'verbose', 
                      'show-ids', 'revision',
+                     'log-format',
                      'line', 'long', 
                      Option('message',
                             help='show revisions whose message matches this regexp',
@@ -904,6 +1039,7 @@
             show_ids=False,
             forward=False,
             revision=None,
+            log_format=None,
             message=None,
             long=False,
             short=False,
@@ -914,28 +1050,26 @@
             "invalid message argument %r" % message
         direction = (forward and 'forward') or 'reverse'
         
+        # log everything
+        file_id = None
         if filename:
-            # might be a tree:
-            tree = None
-            try:
-                tree, fp = WorkingTree.open_containing(filename)
-                b = tree.branch
-                if fp != '':
-                    inv = tree.read_working_inventory()
-            except NotBranchError:
-                pass
-            if tree is None:
-                b, fp = Branch.open_containing(filename)
-                if fp != '':
-                    inv = b.get_inventory(b.last_revision())
+            # find the file id to log:
+
+            dir, fp = bzrdir.BzrDir.open_containing(filename)
+            b = dir.open_branch()
             if fp != '':
+                try:
+                    # might be a tree:
+                    inv = dir.open_workingtree().inventory
+                except (errors.NotBranchError, errors.NotLocalUrl):
+                    # either no tree, or is remote.
+                    inv = b.basis_tree().inventory
                 file_id = inv.path2id(fp)
-            else:
-                file_id = None  # points to branch root
         else:
-            tree, relpath = WorkingTree.open_containing(u'.')
-            b = tree.branch
-            file_id = None
+            # local dir only
+            # FIXME ? log the current subdir only RBC 20060203 
+            dir, relpath = bzrdir.BzrDir.open_containing('.')
+            b = dir.open_branch()
 
         if revision is None:
             rev1 = None
@@ -943,7 +1077,12 @@
         elif len(revision) == 1:
             rev1 = rev2 = revision[0].in_history(b).revno
         elif len(revision) == 2:
-            rev1 = revision[0].in_history(b).revno
+            if revision[0].spec is None:
+                # missing begin-range means first revision
+                rev1 = 1
+            else:
+                rev1 = revision[0].in_history(b).revno
+
             if revision[1].spec is None:
                 # missing end-range means last known revision
                 rev2 = b.revno()
@@ -964,7 +1103,10 @@
         # in e.g. the default C locale.
         outf = codecs.getwriter(bzrlib.user_encoding)(sys.stdout, errors='replace')
 
-        log_format = get_log_format(long=long, short=short, line=line)
+        if (log_format == None):
+            default = bzrlib.config.BranchConfig(b).log_format()
+            log_format = get_log_format(long=long, short=short, line=line, default=default)
+
         lf = log_formatter(log_format,
                            show_ids=show_ids,
                            to_file=outf,
@@ -979,6 +1121,7 @@
                  end_revision=rev2,
                  search=message)
 
+
 def get_log_format(long=False, short=False, line=False, default='long'):
     log_format = default
     if long:
@@ -1040,7 +1183,7 @@
         elif relpath:
             relpath += '/'
         if revision is not None:
-            tree = tree.branch.revision_tree(
+            tree = tree.branch.repository.revision_tree(
                 revision[0].in_history(tree.branch).rev_id)
         for fp, fc, kind, fid, entry in tree.list_files():
             if fp.startswith(relpath):
@@ -1176,8 +1319,8 @@
 
     Note: export of tree with non-ascii filenames to zip is not supported.
 
-    Supported formats       Autodetected by extension
-    -----------------       -------------------------
+     Supported formats       Autodetected by extension
+     -----------------       -------------------------
          dir                            -
          tar                          .tar
          tbz2                    .tar.bz2, .tbz2
@@ -1198,7 +1341,7 @@
             if len(revision) != 1:
                 raise BzrError('bzr export --revision takes exactly 1 argument')
             rev_id = revision[0].in_history(b).rev_id
-        t = b.revision_tree(rev_id)
+        t = b.repository.revision_tree(rev_id)
         try:
             export(t, dest, format, root)
         except errors.NoSuchExportFormat, e:
@@ -1272,16 +1415,21 @@
                      Option('strict',
                             help="refuse to commit if there are unknown "
                             "files in the working tree."),
+                     Option('local',
+                            help="perform a local only commit in a bound "
+                                 "branch. Such commits are not pushed to "
+                                 "the master branch until a normal commit "
+                                 "is performed."
+                            ),
                      ]
     aliases = ['ci', 'checkin']
 
     def run(self, message=None, file=None, verbose=True, selected_list=None,
-            unchanged=False, strict=False):
+            unchanged=False, strict=False, local=False):
         from bzrlib.errors import (PointlessCommit, ConflictsInTree,
                 StrictCommitFailed)
         from bzrlib.msgeditor import edit_commit_message, \
                 make_commit_message_template
-        from bzrlib.status import show_status
         from tempfile import TemporaryFile
         import codecs
 
@@ -1294,6 +1442,8 @@
         # TODO: if the commit *does* happen to fail, then save the commit 
         # message to a temporary file where it can be recovered
         tree, selected_list = tree_files(selected_list)
+        if local and not tree.branch.get_bound_location():
+            raise errors.LocalRequiresBoundBranch()
         if message is None and not file:
             template = make_commit_message_template(tree, selected_list)
             message = edit_commit_message(template)
@@ -1312,7 +1462,7 @@
             
         try:
             tree.commit(message, specific_files=selected_list,
-                        allow_pointless=unchanged, strict=strict)
+                        allow_pointless=unchanged, strict=strict, local=local)
         except PointlessCommit:
             # FIXME: This should really happen before the file is read in;
             # perhaps prepare the commit; get the message; then actually commit
@@ -1324,6 +1474,11 @@
         except StrictCommitFailed:
             raise BzrCommandError("Commit refused because there are unknown "
                                   "files in the working tree.")
+        except errors.BoundBranchOutOfDate, e:
+            raise BzrCommandError(str(e)
+                                  + ' Either unbind, update, or'
+                                    ' pass --local to commit.')
+
         note('Committed revision %d.' % (tree.branch.revno(),))
 
 
@@ -1363,23 +1518,41 @@
 
         if c.needs_write:
             c.write()
-            
+
+
+def get_format_type(typestring):
+    """Parse and return a format specifier."""
+    if typestring == "metadir":
+        return bzrdir.BzrDirMetaFormat1()
+    if typestring == "knit":
+        format = bzrdir.BzrDirMetaFormat1()
+        format.repository_format = bzrlib.repository.RepositoryFormatKnit1()
+        return format
+    msg = "No known bzr-dir format %s. Supported types are: metadir\n" %\
+        (typestring)
+    raise BzrCommandError(msg)
 
 
 class cmd_upgrade(Command):
     """Upgrade branch storage to current format.
 
     The check command or bzr developers may sometimes advise you to run
-    this command.
-
-    This version of this command upgrades from the full-text storage
-    used by bzr 0.0.8 and earlier to the weave format (v5).
+    this command. When the default format has changed you may also be warned
+    during other operations to upgrade.
     """
-    takes_args = ['dir?']
-
-    def run(self, dir=u'.'):
+    takes_args = ['url?']
+    takes_options = [
+                     Option('format', 
+                            help='Upgrade to a specific format rather than the'
+                                 ' current default format. Currently this '
+                                 ' option only accepts =metadir',
+                            type=get_format_type),
+                    ]
+
+
+    def run(self, url='.', format=None):
         from bzrlib.upgrade import upgrade
-        upgrade(dir)
+        upgrade(url, format)
 
 
 class cmd_whoami(Command):
@@ -1399,9 +1572,10 @@
         else:
             print config.username()
 
+
 class cmd_nick(Command):
-    """\
-    Print or set the branch nickname.  
+    """Print or set the branch nickname.  
+
     If unset, the tree root directory name is used as the nickname
     To print the current nickname, execute with no argument.  
     """
@@ -1417,6 +1591,7 @@
     def printme(self, branch):
         print branch.nick 
 
+
 class cmd_selftest(Command):
     """Run internal test suite.
     
@@ -1427,18 +1602,46 @@
     
     If arguments are given, they are regular expressions that say
     which tests should run.
+
+    If the global option '--no-plugins' is given, plugins are not loaded
+    before running the selftests.  This has two effects: features provided or
+    modified by plugins will not be tested, and tests provided by plugins will
+    not be run.
+
+    examples:
+        bzr selftest ignore
+        bzr --no-plugins selftest -v
     """
     # TODO: --list should give a list of all available tests
+
+    # NB: this is used from the class without creating an instance, which is
+    # why it does not have a self parameter.
+    def get_transport_type(typestring):
+        """Parse and return a transport specifier."""
+        if typestring == "sftp":
+            from bzrlib.transport.sftp import SFTPAbsoluteServer
+            return SFTPAbsoluteServer
+        if typestring == "memory":
+            from bzrlib.transport.memory import MemoryServer
+            return MemoryServer
+        msg = "No known transport type %s. Supported types are: sftp\n" %\
+            (typestring)
+        raise BzrCommandError(msg)
+
     hidden = True
     takes_args = ['testspecs*']
-    takes_options = ['verbose', 
+    takes_options = ['verbose',
                      Option('one', help='stop when one test fails'),
                      Option('keep-output', 
-                            help='keep output directories when tests fail')
+                            help='keep output directories when tests fail'),
+                     Option('transport', 
+                            help='Use a different transport by default '
+                                 'throughout the test suite.',
+                            type=get_transport_type),
                     ]
 
     def run(self, testspecs_list=None, verbose=False, one=False,
-            keep_output=False):
+            keep_output=False, transport=None):
         import bzrlib.ui
         from bzrlib.tests import selftest
         # we don't want progress meters from the tests to go to the
@@ -1455,7 +1658,8 @@
             result = selftest(verbose=verbose, 
                               pattern=pattern,
                               stop_on_failure=one, 
-                              keep_output=keep_output)
+                              keep_output=keep_output,
+                              transport=transport)
             if result:
                 bzrlib.trace.info('tests passed')
             else:
@@ -1533,7 +1737,8 @@
         last1 = branch1.last_revision()
         last2 = branch2.last_revision()
 
-        source = MultipleRevisionSources(branch1, branch2)
+        source = MultipleRevisionSources(branch1.repository, 
+                                         branch2.repository)
         
         base_rev_id = common_ancestor(last1, last2, source)
 
@@ -1586,10 +1791,8 @@
 
     def run(self, branch=None, revision=None, force=False, merge_type=None,
             show_base=False, reprocess=False):
-        from bzrlib.merge import merge
-        from bzrlib.merge_core import ApplyMerge3
         if merge_type is None:
-            merge_type = ApplyMerge3
+            merge_type = Merge3Merger
         if branch is None:
             branch = WorkingTree.open_containing(u'.')[0].branch.get_parent()
             if branch is None:
@@ -1618,7 +1821,8 @@
         try:
             conflict_count = merge(other, base, check_clean=(not force),
                                    merge_type=merge_type, reprocess=reprocess,
-                                   show_base=show_base)
+                                   show_base=show_base, 
+                                   pb=bzrlib.ui.ui_factory.progress_bar())
             if conflict_count != 0:
                 return 1
             else:
@@ -1644,9 +1848,8 @@
     def run(self, file_list=None, merge_type=None, show_base=False,
             reprocess=False):
         from bzrlib.merge import merge_inner, transform_tree
-        from bzrlib.merge_core import ApplyMerge3
         if merge_type is None:
-            merge_type = ApplyMerge3
+            merge_type = Merge3Merger
         tree, file_list = tree_files(file_list)
         tree.lock_write()
         try:
@@ -1655,22 +1858,25 @@
                 raise BzrCommandError("Sorry, remerge only works after normal"
                                       + " merges.  Not cherrypicking or"
                                       + "multi-merges.")
+            repository = tree.branch.repository
             base_revision = common_ancestor(tree.branch.last_revision(), 
-                                            pending_merges[0], tree.branch)
-            base_tree = tree.branch.revision_tree(base_revision)
-            other_tree = tree.branch.revision_tree(pending_merges[0])
+                                            pending_merges[0], repository)
+            base_tree = repository.revision_tree(base_revision)
+            other_tree = repository.revision_tree(pending_merges[0])
             interesting_ids = None
             if file_list is not None:
                 interesting_ids = set()
                 for filename in file_list:
                     file_id = tree.path2id(filename)
+                    if file_id is None:
+                        raise NotVersionedError(filename)
                     interesting_ids.add(file_id)
                     if tree.kind(file_id) != "directory":
                         continue
                     
                     for name, ie in tree.inventory.iter_entries(file_id):
                         interesting_ids.add(ie.file_id)
-            transform_tree(tree, tree.branch.basis_tree(), interesting_ids)
+            transform_tree(tree, tree.basis_tree(), interesting_ids)
             if file_list is None:
                 restore_files = list(tree.iter_conflicts())
             else:
@@ -1705,25 +1911,23 @@
     aliases = ['merge-revert']
 
     def run(self, revision=None, no_backup=False, file_list=None):
-        from bzrlib.merge import merge_inner
         from bzrlib.commands import parse_spec
         if file_list is not None:
             if len(file_list) == 0:
                 raise BzrCommandError("No files specified")
         else:
             file_list = []
+        
+        tree, file_list = tree_files(file_list)
         if revision is None:
-            revno = -1
-            tree = WorkingTree.open_containing(u'.')[0]
             # FIXME should be tree.last_revision
             rev_id = tree.branch.last_revision()
         elif len(revision) != 1:
             raise BzrCommandError('bzr revert --revision takes exactly 1 argument')
         else:
-            tree, file_list = tree_files(file_list)
             rev_id = revision[0].in_history(tree.branch).rev_id
-        tree.revert(file_list, tree.branch.revision_tree(rev_id),
-                                not no_backup)
+        tree.revert(file_list, tree.branch.repository.revision_tree(rev_id),
+                    not no_backup, bzrlib.ui.ui_factory.progress_bar())
 
 
 class cmd_assert_fail(Command):
@@ -1737,7 +1941,7 @@
     """Show help on a command or other topic.
 
     For a list of all available commands, say 'bzr help commands'."""
-    takes_options = ['long']
+    takes_options = [Option('long', 'show help on all commands')]
     takes_args = ['topic?']
     aliases = ['?']
     
@@ -1774,15 +1978,7 @@
         from bzrlib.branch import Branch
         from_b = Branch.open(from_branch)
         to_b = Branch.open(to_branch)
-        from_b.lock_read()
-        try:
-            to_b.lock_write()
-            try:
-                Fetcher(to_b, from_b)
-            finally:
-                to_b.unlock()
-        finally:
-            from_b.unlock()
+        Fetcher(to_b, from_b)
 
 
 class cmd_missing(Command):
@@ -1795,6 +1991,7 @@
                             'Display changes in the local branch only'),
                      Option('theirs-only', 
                             'Display changes in the remote branch only'), 
+                     'log-format',
                      'line',
                      'long', 
                      'short',
@@ -1803,7 +2000,7 @@
                      ]
 
     def run(self, other_branch=None, reverse=False, mine_only=False,
-            theirs_only=False, long=True, short=False, line=False, 
+            theirs_only=False, log_format=None, long=False, short=False, line=False, 
             show_ids=False, verbose=False):
         from bzrlib.missing import find_unmerged, iter_log_data
         from bzrlib.log import log_formatter
@@ -1816,7 +2013,9 @@
             print "Using last location: " + local_branch.get_parent()
         remote_branch = bzrlib.branch.Branch.open(other_branch)
         local_extra, remote_extra = find_unmerged(local_branch, remote_branch)
-        log_format = get_log_format(long=long, short=short, line=line)
+        if (log_format == None):
+            default = bzrlib.config.BranchConfig(local_branch).log_format()
+            log_format = get_log_format(long=long, short=short, line=line, default=default)
         lf = log_formatter(log_format, sys.stdout,
                            show_ids=show_ids,
                            show_timezone='original')
@@ -1825,7 +2024,8 @@
             remote_extra.reverse()
         if local_extra and not theirs_only:
             print "You have %d extra revision(s):" % len(local_extra)
-            for data in iter_log_data(local_extra, local_branch, verbose):
+            for data in iter_log_data(local_extra, local_branch.repository,
+                                      verbose):
                 lf.show(*data)
             printed_local = True
         else:
@@ -1834,7 +2034,8 @@
             if printed_local is True:
                 print "\n\n"
             print "You are missing %d revision(s):" % len(remote_extra)
-            for data in iter_log_data(remote_extra, remote_branch, verbose):
+            for data in iter_log_data(remote_extra, remote_branch.repository, 
+                                      verbose):
                 lf.show(*data)
         if not remote_extra and not local_extra:
             status_code = 0
@@ -1880,7 +2081,7 @@
                 rev_id = b.last_revision()
             else:
                 rev_id = revision[0].in_history(b).rev_id
-            t = Testament.from_revision(b, rev_id)
+            t = Testament.from_revision(b.repository, rev_id)
             if long:
                 sys.stdout.writelines(t.as_text_lines())
             else:
@@ -1916,7 +2117,7 @@
         branch.lock_read()
         try:
             file_id = tree.inventory.path2id(relpath)
-            tree = branch.revision_tree(branch.last_revision())
+            tree = branch.repository.revision_tree(branch.last_revision())
             file_version = tree.inventory[file_id].revision
             annotate_file(branch, file_version, file_id, long, all, sys.stdout)
         finally:
@@ -1928,24 +2129,25 @@
     # TODO be able to replace existing ones.
 
     hidden = True # is this right ?
-    takes_args = ['revision_id?']
+    takes_args = ['revision_id*']
     takes_options = ['revision']
     
-    def run(self, revision_id=None, revision=None):
+    def run(self, revision_id_list=None, revision=None):
         import bzrlib.config as config
         import bzrlib.gpg as gpg
-        if revision_id is not None and revision is not None:
+        if revision_id_list is not None and revision is not None:
             raise BzrCommandError('You can only supply one of revision_id or --revision')
-        if revision_id is None and revision is None:
+        if revision_id_list is None and revision is None:
             raise BzrCommandError('You must supply either --revision or a revision_id')
         b = WorkingTree.open_containing(u'.')[0].branch
         gpg_strategy = gpg.GPGStrategy(config.BranchConfig(b))
-        if revision_id is not None:
-            b.sign_revision(revision_id, gpg_strategy)
+        if revision_id_list is not None:
+            for revision_id in revision_id_list:
+                b.repository.sign_revision(revision_id, gpg_strategy)
         elif revision is not None:
             if len(revision) == 1:
                 revno, rev_id = revision[0].in_history(b)
-                b.sign_revision(rev_id, gpg_strategy)
+                b.repository.sign_revision(rev_id, gpg_strategy)
             elif len(revision) == 2:
                 # are they both on rh- if so we can walk between them
                 # might be nice to have a range helper for arbitrary
@@ -1957,11 +2159,47 @@
                 if from_revno is None or to_revno is None:
                     raise BzrCommandError('Cannot sign a range of non-revision-history revisions')
                 for revno in range(from_revno, to_revno + 1):
-                    b.sign_revision(b.get_rev_id(revno), gpg_strategy)
+                    b.repository.sign_revision(b.get_rev_id(revno), 
+                                               gpg_strategy)
             else:
                 raise BzrCommandError('Please supply either one revision, or a range.')
 
 
+class cmd_bind(Command):
+    """Bind the current branch to a master branch.
+
+    After binding, commits must succeed on the master branch
+    before they are executed on the local one.
+    """
+
+    takes_args = ['location']
+    takes_options = []
+
+    def run(self, location=None):
+        b, relpath = Branch.open_containing(u'.')
+        b_other = Branch.open(location)
+        try:
+            b.bind(b_other)
+        except DivergedBranches:
+            raise BzrCommandError('These branches have diverged.'
+                                  ' Try merging, and then bind again.')
+
+
+class cmd_unbind(Command):
+    """Bind the current branch to its parent.
+
+    After unbinding, the local branch is considered independent.
+    """
+
+    takes_args = []
+    takes_options = []
+
+    def run(self):
+        b, relpath = Branch.open_containing(u'.')
+        if not b.unbind():
+            raise BzrCommandError('Local branch is not bound')
+
+
 class cmd_uncommit(bzrlib.commands.Command):
     """Remove the last committed revision.
 
@@ -1976,13 +2214,18 @@
     In the future, uncommit will create a changeset, which can then
     be re-applied.
     """
-    takes_options = ['all', 'verbose', 'revision',
+
+    # TODO: jam 20060108 Add an option to allow uncommit to remove
+    # unreferenced information in 'branch-as-repostory' branches.
+    # TODO: jam 20060108 Add the ability for uncommit to remove unreferenced
+    # information in shared branches as well.
+    takes_options = ['verbose', 'revision',
                     Option('dry-run', help='Don\'t actually make changes'),
                     Option('force', help='Say yes to all questions.')]
     takes_args = ['location?']
     aliases = []
 
-    def run(self, location=None, all=False,
+    def run(self, location=None, 
             dry_run=False, verbose=False,
             revision=None, force=False):
         from bzrlib.branch import Branch
@@ -1992,7 +2235,12 @@
 
         if location is None:
             location = u'.'
-        b, relpath = Branch.open_containing(location)
+        control, relpath = bzrdir.BzrDir.open_containing(location)
+        b = control.open_branch()
+        try:
+            tree = control.open_workingtree()
+        except (errors.NoWorkingTree, errors.NotLocalUrl):
+            tree = None
 
         if revision is None:
             revno = b.revno()
@@ -2005,7 +2253,7 @@
         for r in range(revno, b.revno()+1):
             rev_id = b.get_rev_id(r)
             lf = log_formatter('short', to_file=sys.stdout,show_timezone='original')
-            lf.show(r, b.get_revision(rev_id), None)
+            lf.show(r, b.repository.get_revision(rev_id), None)
 
         if dry_run:
             print 'Dry-run, pretending to remove the above revisions.'
@@ -2019,13 +2267,96 @@
                     print 'Canceled'
                     return 0
 
-        uncommit(b, remove_files=all,
-                dry_run=dry_run, verbose=verbose,
+        uncommit(b, tree=tree, dry_run=dry_run, verbose=verbose,
                 revno=revno)
 
 
+class cmd_break_lock(Command):
+    """Break a dead lock on a repository, branch or working directory.
+
+    CAUTION: Locks should only be broken when you are sure that the process
+    holding the lock has been stopped.
+    
+    example:
+        bzr break-lock .
+    """
+    takes_args = ['location']
+    takes_options = [Option('show',
+                            help="just show information on the lock, " \
+                                 "don't break it"),
+                    ]
+    def run(self, location, show=False):
+        d = bzrdir.BzrDir.open(location)
+        repo = d.open_repository()
+        if not repo.is_locked():
+            raise errors.ObjectNotLocked(repo)
+
+
+# command-line interpretation helper for merge-related commands
+def merge(other_revision, base_revision,
+          check_clean=True, ignore_zero=False,
+          this_dir=None, backup_files=False, merge_type=Merge3Merger,
+          file_list=None, show_base=False, reprocess=False,
+          pb=DummyProgress()):
+    """Merge changes into a tree.
+
+    base_revision
+        list(path, revno) Base for three-way merge.  
+        If [None, None] then a base will be automatically determined.
+    other_revision
+        list(path, revno) Other revision for three-way merge.
+    this_dir
+        Directory to merge changes into; '.' by default.
+    check_clean
+        If true, this_dir must have no uncommitted changes before the
+        merge begins.
+    ignore_zero - If true, suppress the "zero conflicts" message when 
+        there are no conflicts; should be set when doing something we expect
+        to complete perfectly.
+    file_list - If supplied, merge only changes to selected files.
+
+    All available ancestors of other_revision and base_revision are
+    automatically pulled into the branch.
+
+    The revno may be -1 to indicate the last revision on the branch, which is
+    the typical case.
+
+    This function is intended for use from the command line; programmatic
+    clients might prefer to call merge.merge_inner(), which has less magic 
+    behavior.
+    """
+    from bzrlib.merge import Merger
+    if this_dir is None:
+        this_dir = u'.'
+    this_tree = WorkingTree.open_containing(this_dir)[0]
+    if show_base and not merge_type is Merge3Merger:
+        raise BzrCommandError("Show-base is not supported for this merge"
+                              " type. %s" % merge_type)
+    if reprocess and not merge_type is Merge3Merger:
+        raise BzrCommandError("Reprocess is not supported for this merge"
+                              " type. %s" % merge_type)
+    if reprocess and show_base:
+        raise BzrCommandError("Cannot reprocess and show base.")
+    merger = Merger(this_tree.branch, this_tree=this_tree, pb=pb)
+    merger.check_basis(check_clean)
+    merger.set_other(other_revision)
+    merger.set_base(base_revision)
+    if merger.base_rev_id == merger.other_rev_id:
+        note('Nothing to do.')
+        return 0
+    merger.backup_files = backup_files
+    merger.merge_type = merge_type 
+    merger.set_interesting_files(file_list)
+    merger.show_base = show_base 
+    merger.reprocess = reprocess
+    conflicts = merger.do_merge()
+    merger.set_pending()
+    return conflicts
+
+
 # these get imported and then picked up by the scan for cmd_*
 # TODO: Some more consistent way to split command definitions across files;
 # we do need to load at least some information about them to know of 
 # aliases.
 from bzrlib.conflicts import cmd_resolve, cmd_conflicts, restore
+from bzrlib.sign_my_commits import cmd_sign_my_commits

=== added file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	1970-01-01 00:00:00 +0000
+++ bzrlib/bzrdir.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,1652 @@
+# Copyright (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""BzrDir logic. The BzrDir is the basic control directory used by bzr.
+
+At format 7 this was split out into Branch, Repository and Checkout control
+directories.
+"""
+
+from copy import deepcopy
+import os
+from cStringIO import StringIO
+from unittest import TestSuite
+
+import bzrlib
+import bzrlib.errors as errors
+from bzrlib.lockable_files import LockableFiles, TransportLock
+from bzrlib.osutils import safe_unicode
+from bzrlib.osutils import (
+                            abspath,
+                            pathjoin,
+                            safe_unicode,
+                            sha_strings,
+                            sha_string,
+                            )
+from bzrlib.store.text import TextStore
+from bzrlib.store.weave import WeaveStore
+from bzrlib.symbol_versioning import *
+from bzrlib.trace import mutter
+from bzrlib.transactions import PassThroughTransaction
+from bzrlib.transport import get_transport
+from bzrlib.transport.local import LocalTransport
+from bzrlib.weave import Weave
+from bzrlib.weavefile import read_weave, write_weave
+from bzrlib.xml4 import serializer_v4
+from bzrlib.xml5 import serializer_v5
+
+
+class BzrDir(object):
+    """A .bzr control diretory.
+    
+    BzrDir instances let you create or open any of the things that can be
+    found within .bzr - checkouts, branches and repositories.
+    
+    transport
+        the transport which this bzr dir is rooted at (i.e. file:///.../.bzr/)
+    root_transport
+        a transport connected to the directory this bzr was opened from.
+    """
+
+    def can_convert_format(self):
+        """Return true if this bzrdir is one whose format we can convert from."""
+        return True
+
+    def _check_supported(self, format, allow_unsupported):
+        """Check whether format is a supported format.
+
+        If allow_unsupported is True, this is a no-op.
+        """
+        if not allow_unsupported and not format.is_supported():
+            raise errors.UnsupportedFormatError(format)
+
+    def clone(self, url, revision_id=None, basis=None, force_new_repo=False):
+        """Clone this bzrdir and its contents to url verbatim.
+
+        If urls last component does not exist, it will be created.
+
+        if revision_id is not None, then the clone operation may tune
+            itself to download less data.
+        :param force_new_repo: Do not use a shared repository for the target 
+                               even if one is available.
+        """
+        self._make_tail(url)
+        basis_repo, basis_branch, basis_tree = self._get_basis_components(basis)
+        result = self._format.initialize(url)
+        try:
+            local_repo = self.find_repository()
+        except errors.NoRepositoryPresent:
+            local_repo = None
+        if local_repo:
+            # may need to copy content in
+            if force_new_repo:
+                local_repo.clone(result, revision_id=revision_id, basis=basis_repo)
+            else:
+                try:
+                    result_repo = result.find_repository()
+                    # fetch content this dir needs.
+                    if basis_repo:
+                        # XXX FIXME RBC 20060214 need tests for this when the basis
+                        # is incomplete
+                        result_repo.fetch(basis_repo, revision_id=revision_id)
+                    result_repo.fetch(local_repo, revision_id=revision_id)
+                except errors.NoRepositoryPresent:
+                    # needed to make one anyway.
+                    local_repo.clone(result, revision_id=revision_id, basis=basis_repo)
+        # 1 if there is a branch present
+        #   make sure its content is available in the target repository
+        #   clone it.
+        try:
+            self.open_branch().clone(result, revision_id=revision_id)
+        except errors.NotBranchError:
+            pass
+        try:
+            self.open_workingtree().clone(result, basis=basis_tree)
+        except (errors.NoWorkingTree, errors.NotLocalUrl):
+            pass
+        return result
+
+    def _get_basis_components(self, basis):
+        """Retrieve the basis components that are available at basis."""
+        if basis is None:
+            return None, None, None
+        try:
+            basis_tree = basis.open_workingtree()
+            basis_branch = basis_tree.branch
+            basis_repo = basis_branch.repository
+        except (errors.NoWorkingTree, errors.NotLocalUrl):
+            basis_tree = None
+            try:
+                basis_branch = basis.open_branch()
+                basis_repo = basis_branch.repository
+            except errors.NotBranchError:
+                basis_branch = None
+                try:
+                    basis_repo = basis.open_repository()
+                except errors.NoRepositoryPresent:
+                    basis_repo = None
+        return basis_repo, basis_branch, basis_tree
+
+    def _make_tail(self, url):
+        segments = url.split('/')
+        if segments and segments[-1] not in ('', '.'):
+            parent = '/'.join(segments[:-1])
+            t = bzrlib.transport.get_transport(parent)
+            try:
+                t.mkdir(segments[-1])
+            except errors.FileExists:
+                pass
+
+    @staticmethod
+    def create(base):
+        """Create a new BzrDir at the url 'base'.
+        
+        This will call the current default formats initialize with base
+        as the only parameter.
+
+        If you need a specific format, consider creating an instance
+        of that and calling initialize().
+        """
+        segments = base.split('/')
+        if segments and segments[-1] not in ('', '.'):
+            parent = '/'.join(segments[:-1])
+            t = bzrlib.transport.get_transport(parent)
+            try:
+                t.mkdir(segments[-1])
+            except errors.FileExists:
+                pass
+        return BzrDirFormat.get_default_format().initialize(safe_unicode(base))
+
+    def create_branch(self):
+        """Create a branch in this BzrDir.
+
+        The bzrdirs format will control what branch format is created.
+        For more control see BranchFormatXX.create(a_bzrdir).
+        """
+        raise NotImplementedError(self.create_branch)
+
+    @staticmethod
+    def create_branch_and_repo(base, force_new_repo=False):
+        """Create a new BzrDir, Branch and Repository at the url 'base'.
+
+        This will use the current default BzrDirFormat, and use whatever 
+        repository format that that uses via bzrdir.create_branch and
+        create_repository. If a shared repository is available that is used
+        preferentially.
+
+        The created Branch object is returned.
+
+        :param base: The URL to create the branch at.
+        :param force_new_repo: If True a new repository is always created.
+        """
+        bzrdir = BzrDir.create(base)
+        bzrdir._find_or_create_repository(force_new_repo)
+        return bzrdir.create_branch()
+
+    def _find_or_create_repository(self, force_new_repo):
+        """Create a new repository if needed, returning the repository."""
+        if force_new_repo:
+            return self.create_repository()
+        try:
+            return self.find_repository()
+        except errors.NoRepositoryPresent:
+            return self.create_repository()
+        
+    @staticmethod
+    def create_branch_convenience(base, force_new_repo=False, force_new_tree=None):
+        """Create a new BzrDir, Branch and Repository at the url 'base'.
+
+        This is a convenience function - it will use an existing repository
+        if possible, can be told explicitly whether to create a working tree or
+        not.
+
+        This will use the current default BzrDirFormat, and use whatever 
+        repository format that that uses via bzrdir.create_branch and
+        create_repository. If a shared repository is available that is used
+        preferentially. Whatever repository is used, its tree creation policy
+        is followed.
+
+        The created Branch object is returned.
+        If a working tree cannot be made due to base not being a file:// url,
+        no error is raised unless force_new_tree is True, in which case no 
+        data is created on disk and NotLocalUrl is raised.
+
+        :param base: The URL to create the branch at.
+        :param force_new_repo: If True a new repository is always created.
+        :param force_new_tree: If True or False force creation of a tree or 
+                               prevent such creation respectively.
+        """
+        if force_new_tree:
+            # check for non local urls
+            t = get_transport(safe_unicode(base))
+            if not isinstance(t, LocalTransport):
+                raise errors.NotLocalUrl(base)
+        bzrdir = BzrDir.create(base)
+        repo = bzrdir._find_or_create_repository(force_new_repo)
+        result = bzrdir.create_branch()
+        if force_new_tree or (repo.make_working_trees() and 
+                              force_new_tree is None):
+            try:
+                bzrdir.create_workingtree()
+            except errors.NotLocalUrl:
+                pass
+        return result
+        
+    @staticmethod
+    def create_repository(base, shared=False):
+        """Create a new BzrDir and Repository at the url 'base'.
+
+        This will use the current default BzrDirFormat, and use whatever 
+        repository format that that uses for bzrdirformat.create_repository.
+
+        ;param shared: Create a shared repository rather than a standalone
+                       repository.
+        The Repository object is returned.
+
+        This must be overridden as an instance method in child classes, where
+        it should take no parameters and construct whatever repository format
+        that child class desires.
+        """
+        bzrdir = BzrDir.create(base)
+        return bzrdir.create_repository()
+
+    @staticmethod
+    def create_standalone_workingtree(base):
+        """Create a new BzrDir, WorkingTree, Branch and Repository at 'base'.
+
+        'base' must be a local path or a file:// url.
+
+        This will use the current default BzrDirFormat, and use whatever 
+        repository format that that uses for bzrdirformat.create_workingtree,
+        create_branch and create_repository.
+
+        The WorkingTree object is returned.
+        """
+        t = get_transport(safe_unicode(base))
+        if not isinstance(t, LocalTransport):
+            raise errors.NotLocalUrl(base)
+        bzrdir = BzrDir.create_branch_and_repo(safe_unicode(base),
+                                               force_new_repo=True).bzrdir
+        return bzrdir.create_workingtree()
+
+    def create_workingtree(self, revision_id=None):
+        """Create a working tree at this BzrDir.
+        
+        revision_id: create it as of this revision id.
+        """
+        raise NotImplementedError(self.create_workingtree)
+
+    def find_repository(self):
+        """Find the repository that should be used for a_bzrdir.
+
+        This does not require a branch as we use it to find the repo for
+        new branches as well as to hook existing branches up to their
+        repository.
+        """
+        try:
+            return self.open_repository()
+        except errors.NoRepositoryPresent:
+            pass
+        next_transport = self.root_transport.clone('..')
+        while True:
+            try:
+                found_bzrdir = BzrDir.open_containing_from_transport(
+                    next_transport)[0]
+            except errors.NotBranchError:
+                raise errors.NoRepositoryPresent(self)
+            try:
+                repository = found_bzrdir.open_repository()
+            except errors.NoRepositoryPresent:
+                next_transport = found_bzrdir.root_transport.clone('..')
+                continue
+            if ((found_bzrdir.root_transport.base == 
+                 self.root_transport.base) or repository.is_shared()):
+                return repository
+            else:
+                raise errors.NoRepositoryPresent(self)
+        raise errors.NoRepositoryPresent(self)
+
+    def get_branch_transport(self, branch_format):
+        """Get the transport for use by branch format in this BzrDir.
+
+        Note that bzr dirs that do not support format strings will raise
+        IncompatibleFormat if the branch format they are given has
+        a format string, and vice verca.
+
+        If branch_format is None, the transport is returned with no 
+        checking. if it is not None, then the returned transport is
+        guaranteed to point to an existing directory ready for use.
+        """
+        raise NotImplementedError(self.get_branch_transport)
+        
+    def get_repository_transport(self, repository_format):
+        """Get the transport for use by repository format in this BzrDir.
+
+        Note that bzr dirs that do not support format strings will raise
+        IncompatibleFormat if the repository format they are given has
+        a format string, and vice verca.
+
+        If repository_format is None, the transport is returned with no 
+        checking. if it is not None, then the returned transport is
+        guaranteed to point to an existing directory ready for use.
+        """
+        raise NotImplementedError(self.get_repository_transport)
+        
+    def get_workingtree_transport(self, tree_format):
+        """Get the transport for use by workingtree format in this BzrDir.
+
+        Note that bzr dirs that do not support format strings will raise
+        IncompatibleFormat if the workingtree format they are given has
+        a format string, and vice verca.
+
+        If workingtree_format is None, the transport is returned with no 
+        checking. if it is not None, then the returned transport is
+        guaranteed to point to an existing directory ready for use.
+        """
+        raise NotImplementedError(self.get_workingtree_transport)
+        
+    def __init__(self, _transport, _format):
+        """Initialize a Bzr control dir object.
+        
+        Only really common logic should reside here, concrete classes should be
+        made with varying behaviours.
+
+        :param _format: the format that is creating this BzrDir instance.
+        :param _transport: the transport this dir is based at.
+        """
+        self._format = _format
+        self.transport = _transport.clone('.bzr')
+        self.root_transport = _transport
+
+    def needs_format_conversion(self, format=None):
+        """Return true if this bzrdir needs convert_format run on it.
+        
+        For instance, if the repository format is out of date but the 
+        branch and working tree are not, this should return True.
+
+        :param format: Optional parameter indicating a specific desired
+                       format we plan to arrive at.
+        """
+        raise NotImplementedError(self.needs_format_conversion)
+
+    @staticmethod
+    def open_unsupported(base):
+        """Open a branch which is not supported."""
+        return BzrDir.open(base, _unsupported=True)
+        
+    @staticmethod
+    def open(base, _unsupported=False):
+        """Open an existing bzrdir, rooted at 'base' (url)
+        
+        _unsupported is a private parameter to the BzrDir class.
+        """
+        t = get_transport(base)
+        mutter("trying to open %r with transport %r", base, t)
+        format = BzrDirFormat.find_format(t)
+        if not _unsupported and not format.is_supported():
+            # see open_downlevel to open legacy branches.
+            raise errors.UnsupportedFormatError(
+                    'sorry, format %s not supported' % format,
+                    ['use a different bzr version',
+                     'or remove the .bzr directory'
+                     ' and "bzr init" again'])
+        return format.open(t, _found=True)
+
+    def open_branch(self, unsupported=False):
+        """Open the branch object at this BzrDir if one is present.
+
+        If unsupported is True, then no longer supported branch formats can
+        still be opened.
+        
+        TODO: static convenience version of this?
+        """
+        raise NotImplementedError(self.open_branch)
+
+    @staticmethod
+    def open_containing(url):
+        """Open an existing branch which contains url.
+        
+        :param url: url to search from.
+        See open_containing_from_transport for more detail.
+        """
+        return BzrDir.open_containing_from_transport(get_transport(url))
+    
+    @staticmethod
+    def open_containing_from_transport(a_transport):
+        """Open an existing branch which contains a_transport.base
+
+        This probes for a branch at a_transport, and searches upwards from there.
+
+        Basically we keep looking up until we find the control directory or
+        run into the root.  If there isn't one, raises NotBranchError.
+        If there is one and it is either an unrecognised format or an unsupported 
+        format, UnknownFormatError or UnsupportedFormatError are raised.
+        If there is one, it is returned, along with the unused portion of url.
+        """
+        # this gets the normalised url back. I.e. '.' -> the full path.
+        url = a_transport.base
+        while True:
+            try:
+                format = BzrDirFormat.find_format(a_transport)
+                return format.open(a_transport), a_transport.relpath(url)
+            except errors.NotBranchError, e:
+                mutter('not a branch in: %r %s', a_transport.base, e)
+            new_t = a_transport.clone('..')
+            if new_t.base == a_transport.base:
+                # reached the root, whatever that may be
+                raise errors.NotBranchError(path=url)
+            a_transport = new_t
+
+    def open_repository(self, _unsupported=False):
+        """Open the repository object at this BzrDir if one is present.
+
+        This will not follow the Branch object pointer - its strictly a direct
+        open facility. Most client code should use open_branch().repository to
+        get at a repository.
+
+        _unsupported is a private parameter, not part of the api.
+        TODO: static convenience version of this?
+        """
+        raise NotImplementedError(self.open_repository)
+
+    def open_workingtree(self, _unsupported=False):
+        """Open the workingtree object at this BzrDir if one is present.
+        
+        TODO: static convenience version of this?
+        """
+        raise NotImplementedError(self.open_workingtree)
+
+    def sprout(self, url, revision_id=None, basis=None, force_new_repo=False):
+        """Create a copy of this bzrdir prepared for use as a new line of
+        development.
+
+        If urls last component does not exist, it will be created.
+
+        Attributes related to the identity of the source branch like
+        branch nickname will be cleaned, a working tree is created
+        whether one existed before or not; and a local branch is always
+        created.
+
+        if revision_id is not None, then the clone operation may tune
+            itself to download less data.
+        """
+        self._make_tail(url)
+        result = self._format.initialize(url)
+        basis_repo, basis_branch, basis_tree = self._get_basis_components(basis)
+        try:
+            source_branch = self.open_branch()
+            source_repository = source_branch.repository
+        except errors.NotBranchError:
+            source_branch = None
+            try:
+                source_repository = self.open_repository()
+            except errors.NoRepositoryPresent:
+                # copy the entire basis one if there is one
+                # but there is no repository.
+                source_repository = basis_repo
+        if force_new_repo:
+            result_repo = None
+        else:
+            try:
+                result_repo = result.find_repository()
+            except errors.NoRepositoryPresent:
+                result_repo = None
+        if source_repository is None and result_repo is not None:
+            pass
+        elif source_repository is None and result_repo is None:
+            # no repo available, make a new one
+            result.create_repository()
+        elif source_repository is not None and result_repo is None:
+            # have soure, and want to make a new target repo
+            source_repository.clone(result,
+                                    revision_id=revision_id,
+                                    basis=basis_repo)
+        else:
+            # fetch needed content into target.
+            if basis_repo:
+                # XXX FIXME RBC 20060214 need tests for this when the basis
+                # is incomplete
+                result_repo.fetch(basis_repo, revision_id=revision_id)
+            result_repo.fetch(source_repository, revision_id=revision_id)
+        if source_branch is not None:
+            source_branch.sprout(result, revision_id=revision_id)
+        else:
+            result.create_branch()
+        result.create_workingtree()
+        return result
+
+
+class BzrDirPreSplitOut(BzrDir):
+    """A common class for the all-in-one formats."""
+
+    def __init__(self, _transport, _format):
+        """See BzrDir.__init__."""
+        super(BzrDirPreSplitOut, self).__init__(_transport, _format)
+        self._control_files = LockableFiles(self.get_branch_transport(None),
+                                            'branch-lock',
+                                            TransportLock)
+
+    def clone(self, url, revision_id=None, basis=None, force_new_repo=False):
+        """See BzrDir.clone()."""
+        from bzrlib.workingtree import WorkingTreeFormat2
+        self._make_tail(url)
+        result = self._format.initialize(url, _cloning=True)
+        basis_repo, basis_branch, basis_tree = self._get_basis_components(basis)
+        self.open_repository().clone(result, revision_id=revision_id, basis=basis_repo)
+        self.open_branch().clone(result, revision_id=revision_id)
+        try:
+            self.open_workingtree().clone(result, basis=basis_tree)
+        except errors.NotLocalUrl:
+            # make a new one, this format always has to have one.
+            WorkingTreeFormat2().initialize(result)
+        return result
+
+    def create_branch(self):
+        """See BzrDir.create_branch."""
+        return self.open_branch()
+
+    def create_repository(self, shared=False):
+        """See BzrDir.create_repository."""
+        if shared:
+            raise errors.IncompatibleFormat('shared repository', self._format)
+        return self.open_repository()
+
+    def create_workingtree(self, revision_id=None):
+        """See BzrDir.create_workingtree."""
+        # this looks buggy but is not -really-
+        # clone and sprout will have set the revision_id
+        # and that will have set it for us, its only
+        # specific uses of create_workingtree in isolation
+        # that can do wonky stuff here, and that only
+        # happens for creating checkouts, which cannot be 
+        # done on this format anyway. So - acceptable wart.
+        result = self.open_workingtree()
+        if revision_id is not None:
+            result.set_last_revision(revision_id)
+        return result
+
+    def get_branch_transport(self, branch_format):
+        """See BzrDir.get_branch_transport()."""
+        if branch_format is None:
+            return self.transport
+        try:
+            branch_format.get_format_string()
+        except NotImplementedError:
+            return self.transport
+        raise errors.IncompatibleFormat(branch_format, self._format)
+
+    def get_repository_transport(self, repository_format):
+        """See BzrDir.get_repository_transport()."""
+        if repository_format is None:
+            return self.transport
+        try:
+            repository_format.get_format_string()
+        except NotImplementedError:
+            return self.transport
+        raise errors.IncompatibleFormat(repository_format, self._format)
+
+    def get_workingtree_transport(self, workingtree_format):
+        """See BzrDir.get_workingtree_transport()."""
+        if workingtree_format is None:
+            return self.transport
+        try:
+            workingtree_format.get_format_string()
+        except NotImplementedError:
+            return self.transport
+        raise errors.IncompatibleFormat(workingtree_format, self._format)
+
+    def needs_format_conversion(self, format=None):
+        """See BzrDir.needs_format_conversion()."""
+        # if the format is not the same as the system default,
+        # an upgrade is needed.
+        if format is None:
+            format = BzrDirFormat.get_default_format()
+        return not isinstance(self._format, format.__class__)
+
+    def open_branch(self, unsupported=False):
+        """See BzrDir.open_branch."""
+        from bzrlib.branch import BzrBranchFormat4
+        format = BzrBranchFormat4()
+        self._check_supported(format, unsupported)
+        return format.open(self, _found=True)
+
+    def sprout(self, url, revision_id=None, basis=None):
+        """See BzrDir.sprout()."""
+        from bzrlib.workingtree import WorkingTreeFormat2
+        self._make_tail(url)
+        result = self._format.initialize(url, _cloning=True)
+        basis_repo, basis_branch, basis_tree = self._get_basis_components(basis)
+        try:
+            self.open_repository().clone(result, revision_id=revision_id, basis=basis_repo)
+        except errors.NoRepositoryPresent:
+            pass
+        try:
+            self.open_branch().sprout(result, revision_id=revision_id)
+        except errors.NotBranchError:
+            pass
+        # we always want a working tree
+        WorkingTreeFormat2().initialize(result)
+        return result
+
+
+class BzrDir4(BzrDirPreSplitOut):
+    """A .bzr version 4 control object.
+    
+    This is a deprecated format and may be removed after sept 2006.
+    """
+
+    def create_repository(self, shared=False):
+        """See BzrDir.create_repository."""
+        return self._format.repository_format.initialize(self, shared)
+
+    def needs_format_conversion(self, format=None):
+        """Format 4 dirs are always in need of conversion."""
+        return True
+
+    def open_repository(self):
+        """See BzrDir.open_repository."""
+        from bzrlib.repository import RepositoryFormat4
+        return RepositoryFormat4().open(self, _found=True)
+
+
+class BzrDir5(BzrDirPreSplitOut):
+    """A .bzr version 5 control object.
+
+    This is a deprecated format and may be removed after sept 2006.
+    """
+
+    def open_repository(self):
+        """See BzrDir.open_repository."""
+        from bzrlib.repository import RepositoryFormat5
+        return RepositoryFormat5().open(self, _found=True)
+
+    def open_workingtree(self, _unsupported=False):
+        """See BzrDir.create_workingtree."""
+        from bzrlib.workingtree import WorkingTreeFormat2
+        return WorkingTreeFormat2().open(self, _found=True)
+
+
+class BzrDir6(BzrDirPreSplitOut):
+    """A .bzr version 6 control object.
+
+    This is a deprecated format and may be removed after sept 2006.
+    """
+
+    def open_repository(self):
+        """See BzrDir.open_repository."""
+        from bzrlib.repository import RepositoryFormat6
+        return RepositoryFormat6().open(self, _found=True)
+
+    def open_workingtree(self, _unsupported=False):
+        """See BzrDir.create_workingtree."""
+        from bzrlib.workingtree import WorkingTreeFormat2
+        return WorkingTreeFormat2().open(self, _found=True)
+
+
+class BzrDirMeta1(BzrDir):
+    """A .bzr meta version 1 control object.
+    
+    This is the first control object where the 
+    individual formats are really split out.
+    """
+
+    def can_convert_format(self):
+        """See BzrDir.can_convert_format()."""
+        return True
+
+    def create_branch(self):
+        """See BzrDir.create_branch."""
+        from bzrlib.branch import BranchFormat
+        return BranchFormat.get_default_format().initialize(self)
+
+    def create_repository(self, shared=False):
+        """See BzrDir.create_repository."""
+        return self._format.repository_format.initialize(self, shared)
+
+    def create_workingtree(self, revision_id=None):
+        """See BzrDir.create_workingtree."""
+        from bzrlib.workingtree import WorkingTreeFormat
+        return WorkingTreeFormat.get_default_format().initialize(self, revision_id)
+
+    def get_branch_transport(self, branch_format):
+        """See BzrDir.get_branch_transport()."""
+        if branch_format is None:
+            return self.transport.clone('branch')
+        try:
+            branch_format.get_format_string()
+        except NotImplementedError:
+            raise errors.IncompatibleFormat(branch_format, self._format)
+        try:
+            self.transport.mkdir('branch')
+        except errors.FileExists:
+            pass
+        return self.transport.clone('branch')
+
+    def get_repository_transport(self, repository_format):
+        """See BzrDir.get_repository_transport()."""
+        if repository_format is None:
+            return self.transport.clone('repository')
+        try:
+            repository_format.get_format_string()
+        except NotImplementedError:
+            raise errors.IncompatibleFormat(repository_format, self._format)
+        try:
+            self.transport.mkdir('repository')
+        except errors.FileExists:
+            pass
+        return self.transport.clone('repository')
+
+    def get_workingtree_transport(self, workingtree_format):
+        """See BzrDir.get_workingtree_transport()."""
+        if workingtree_format is None:
+            return self.transport.clone('checkout')
+        try:
+            workingtree_format.get_format_string()
+        except NotImplementedError:
+            raise errors.IncompatibleFormat(workingtree_format, self._format)
+        try:
+            self.transport.mkdir('checkout')
+        except errors.FileExists:
+            pass
+        return self.transport.clone('checkout')
+
+    def needs_format_conversion(self, format=None):
+        """See BzrDir.needs_format_conversion()."""
+        if format is None:
+            format = BzrDirFormat.get_default_format()
+        if not isinstance(self._format, format.__class__):
+            # it is not a meta dir format, conversion is needed.
+            return True
+        # we might want to push this down to the repository?
+        try:
+            if not isinstance(self.open_repository()._format,
+                              format.repository_format.__class__):
+                # the repository needs an upgrade.
+                return True
+        except errors.NoRepositoryPresent:
+            pass
+        # currently there are no other possible conversions for meta1 formats.
+        return False
+
+    def open_branch(self, unsupported=False):
+        """See BzrDir.open_branch."""
+        from bzrlib.branch import BranchFormat
+        format = BranchFormat.find_format(self)
+        self._check_supported(format, unsupported)
+        return format.open(self, _found=True)
+
+    def open_repository(self, unsupported=False):
+        """See BzrDir.open_repository."""
+        from bzrlib.repository import RepositoryFormat
+        format = RepositoryFormat.find_format(self)
+        self._check_supported(format, unsupported)
+        return format.open(self, _found=True)
+
+    def open_workingtree(self, unsupported=False):
+        """See BzrDir.open_workingtree."""
+        from bzrlib.workingtree import WorkingTreeFormat
+        format = WorkingTreeFormat.find_format(self)
+        self._check_supported(format, unsupported)
+        return format.open(self, _found=True)
+
+
+class BzrDirFormat(object):
+    """An encapsulation of the initialization and open routines for a format.
+
+    Formats provide three things:
+     * An initialization routine,
+     * a format string,
+     * an open routine.
+
+    Formats are placed in an dict by their format string for reference 
+    during bzrdir opening. These should be subclasses of BzrDirFormat
+    for consistency.
+
+    Once a format is deprecated, just deprecate the initialize and open
+    methods on the format class. Do not deprecate the object, as the 
+    object will be created every system load.
+    """
+
+    _default_format = None
+    """The default format used for new .bzr dirs."""
+
+    _formats = {}
+    """The known formats."""
+
+    @classmethod
+    def find_format(klass, transport):
+        """Return the format registered for URL."""
+        try:
+            format_string = transport.get(".bzr/branch-format").read()
+            return klass._formats[format_string]
+        except errors.NoSuchFile:
+            raise errors.NotBranchError(path=transport.base)
+        except KeyError:
+            raise errors.UnknownFormatError(format_string)
+
+    @classmethod
+    def get_default_format(klass):
+        """Return the current default format."""
+        return klass._default_format
+
+    def get_format_string(self):
+        """Return the ASCII format string that identifies this format."""
+        raise NotImplementedError(self.get_format_string)
+
+    def get_converter(self, format=None):
+        """Return the converter to use to convert bzrdirs needing converts.
+
+        This returns a bzrlib.bzrdir.Converter object.
+
+        This should return the best upgrader to step this format towards the
+        current default format. In the case of plugins we can/shouold provide
+        some means for them to extend the range of returnable converters.
+
+        :param format: Optional format to override the default foramt of the 
+                       library.
+        """
+        raise NotImplementedError(self.get_converter)
+
+    def initialize(self, url):
+        """Create a bzr control dir at this url and return an opened copy."""
+        # Since we don't have a .bzr directory, inherit the
+        # mode from the root directory
+        t = get_transport(url)
+        temp_control = LockableFiles(t, '', TransportLock)
+        temp_control._transport.mkdir('.bzr',
+                                      # FIXME: RBC 20060121 dont peek under
+                                      # the covers
+                                      mode=temp_control._dir_mode)
+        file_mode = temp_control._file_mode
+        del temp_control
+        mutter('created control directory in ' + t.base)
+        control = t.clone('.bzr')
+        lock_file = 'branch-lock'
+        utf8_files = [('README', 
+                       "This is a Bazaar-NG control directory.\n"
+                       "Do not change any files in this directory.\n"),
+                      ('branch-format', self.get_format_string()),
+                      ]
+        # NB: no need to escape relative paths that are url safe.
+        control_files = LockableFiles(control, lock_file, TransportLock)
+        control_files.create_lock()
+        control_files.lock_write()
+        try:
+            for file, content in utf8_files:
+                control_files.put_utf8(file, content)
+        finally:
+            control_files.unlock()
+        return self.open(t, _found=True)
+
+    def is_supported(self):
+        """Is this format supported?
+
+        Supported formats must be initializable and openable.
+        Unsupported formats may not support initialization or committing or 
+        some other features depending on the reason for not being supported.
+        """
+        return True
+
+    def open(self, transport, _found=False):
+        """Return an instance of this format for the dir transport points at.
+        
+        _found is a private parameter, do not use it.
+        """
+        if not _found:
+            assert isinstance(BzrDirFormat.find_format(transport),
+                              self.__class__)
+        return self._open(transport)
+
+    def _open(self, transport):
+        """Template method helper for opening BzrDirectories.
+
+        This performs the actual open and any additional logic or parameter
+        passing.
+        """
+        raise NotImplementedError(self._open)
+
+    @classmethod
+    def register_format(klass, format):
+        klass._formats[format.get_format_string()] = format
+
+    @classmethod
+    def set_default_format(klass, format):
+        klass._default_format = format
+
+    def __str__(self):
+        return self.get_format_string()[:-1]
+
+    @classmethod
+    def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
+        del klass._formats[format.get_format_string()]
+
+
+class BzrDirFormat4(BzrDirFormat):
+    """Bzr dir format 4.
+
+    This format is a combined format for working tree, branch and repository.
+    It has:
+     - Format 1 working trees [always]
+     - Format 4 branches [always]
+     - Format 4 repositories [always]
+
+    This format is deprecated: it indexes texts using a text it which is
+    removed in format 5; write support for this format has been removed.
+    """
+
+    def get_format_string(self):
+        """See BzrDirFormat.get_format_string()."""
+        return "Bazaar-NG branch, format 0.0.4\n"
+
+    def get_converter(self, format=None):
+        """See BzrDirFormat.get_converter()."""
+        # there is one and only one upgrade path here.
+        return ConvertBzrDir4To5()
+        
+    def initialize(self, url):
+        """Format 4 branches cannot be created."""
+        raise errors.UninitializableFormat(self)
+
+    def is_supported(self):
+        """Format 4 is not supported.
+
+        It is not supported because the model changed from 4 to 5 and the
+        conversion logic is expensive - so doing it on the fly was not 
+        feasible.
+        """
+        return False
+
+    def _open(self, transport):
+        """See BzrDirFormat._open."""
+        return BzrDir4(transport, self)
+
+    def __return_repository_format(self):
+        """Circular import protection."""
+        from bzrlib.repository import RepositoryFormat4
+        return RepositoryFormat4(self)
+    repository_format = property(__return_repository_format)
+
+
+class BzrDirFormat5(BzrDirFormat):
+    """Bzr control format 5.
+
+    This format is a combined format for working tree, branch and repository.
+    It has:
+     - Format 2 working trees [always] 
+     - Format 4 branches [always] 
+     - Format 5 repositories [always]
+       Unhashed stores in the repository.
+    """
+
+    def get_format_string(self):
+        """See BzrDirFormat.get_format_string()."""
+        return "Bazaar-NG branch, format 5\n"
+
+    def get_converter(self, format=None):
+        """See BzrDirFormat.get_converter()."""
+        # there is one and only one upgrade path here.
+        return ConvertBzrDir5To6()
+        
+    def initialize(self, url, _cloning=False):
+        """Format 5 dirs always have working tree, branch and repository.
+        
+        Except when they are being cloned.
+        """
+        from bzrlib.branch import BzrBranchFormat4
+        from bzrlib.repository import RepositoryFormat5
+        from bzrlib.workingtree import WorkingTreeFormat2
+        result = super(BzrDirFormat5, self).initialize(url)
+        RepositoryFormat5().initialize(result, _internal=True)
+        if not _cloning:
+            BzrBranchFormat4().initialize(result)
+            WorkingTreeFormat2().initialize(result)
+        return result
+
+    def _open(self, transport):
+        """See BzrDirFormat._open."""
+        return BzrDir5(transport, self)
+
+    def __return_repository_format(self):
+        """Circular import protection."""
+        from bzrlib.repository import RepositoryFormat5
+        return RepositoryFormat5(self)
+    repository_format = property(__return_repository_format)
+
+
+class BzrDirFormat6(BzrDirFormat):
+    """Bzr control format 6.
+
+    This format is a combined format for working tree, branch and repository.
+    It has:
+     - Format 2 working trees [always] 
+     - Format 4 branches [always] 
+     - Format 6 repositories [always]
+    """
+
+    def get_format_string(self):
+        """See BzrDirFormat.get_format_string()."""
+        return "Bazaar-NG branch, format 6\n"
+
+    def get_converter(self, format=None):
+        """See BzrDirFormat.get_converter()."""
+        # there is one and only one upgrade path here.
+        return ConvertBzrDir6ToMeta()
+        
+    def initialize(self, url, _cloning=False):
+        """Format 6 dirs always have working tree, branch and repository.
+        
+        Except when they are being cloned.
+        """
+        from bzrlib.branch import BzrBranchFormat4
+        from bzrlib.repository import RepositoryFormat6
+        from bzrlib.workingtree import WorkingTreeFormat2
+        result = super(BzrDirFormat6, self).initialize(url)
+        RepositoryFormat6().initialize(result, _internal=True)
+        if not _cloning:
+            BzrBranchFormat4().initialize(result)
+            try:
+                WorkingTreeFormat2().initialize(result)
+            except errors.NotLocalUrl:
+                # emulate pre-check behaviour for working tree and silently 
+                # fail.
+                pass
+        return result
+
+    def _open(self, transport):
+        """See BzrDirFormat._open."""
+        return BzrDir6(transport, self)
+
+    def __return_repository_format(self):
+        """Circular import protection."""
+        from bzrlib.repository import RepositoryFormat6
+        return RepositoryFormat6(self)
+    repository_format = property(__return_repository_format)
+
+
+class BzrDirMetaFormat1(BzrDirFormat):
+    """Bzr meta control format 1
+
+    This is the first format with split out working tree, branch and repository
+    disk storage.
+    It has:
+     - Format 3 working trees [optional]
+     - Format 5 branches [optional]
+     - Format 7 repositories [optional]
+    """
+
+    def get_converter(self, format=None):
+        """See BzrDirFormat.get_converter()."""
+        if format is None:
+            format = BzrDirFormat.get_default_format()
+        if not isinstance(self, format.__class__):
+            # converting away from metadir is not implemented
+            raise NotImplementedError(self.get_converter)
+        return ConvertMetaToMeta(format)
+
+    def get_format_string(self):
+        """See BzrDirFormat.get_format_string()."""
+        return "Bazaar-NG meta directory, format 1\n"
+
+    def _open(self, transport):
+        """See BzrDirFormat._open."""
+        return BzrDirMeta1(transport, self)
+
+    def __return_repository_format(self):
+        """Circular import protection."""
+        if getattr(self, '_repository_format', None):
+            return self._repository_format
+        from bzrlib.repository import RepositoryFormat
+        return RepositoryFormat.get_default_format()
+
+    def __set_repository_format(self, value):
+        """Allow changint the repository format for metadir formats."""
+        self._repository_format = value
+    repository_format = property(__return_repository_format, __set_repository_format)
+
+
+BzrDirFormat.register_format(BzrDirFormat4())
+BzrDirFormat.register_format(BzrDirFormat5())
+BzrDirFormat.register_format(BzrDirMetaFormat1())
+__default_format = BzrDirFormat6()
+BzrDirFormat.register_format(__default_format)
+BzrDirFormat.set_default_format(__default_format)
+
+
+class BzrDirTestProviderAdapter(object):
+    """A tool to generate a suite testing multiple bzrdir formats at once.
+
+    This is done by copying the test once for each transport and injecting
+    the transport_server, transport_readonly_server, and bzrdir_format
+    classes into each copy. Each copy is also given a new id() to make it
+    easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, formats):
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self._formats = formats
+    
+    def adapt(self, test):
+        result = TestSuite()
+        for format in self._formats:
+            new_test = deepcopy(test)
+            new_test.transport_server = self._transport_server
+            new_test.transport_readonly_server = self._transport_readonly_server
+            new_test.bzrdir_format = format
+            def make_new_test_id():
+                new_id = "%s(%s)" % (new_test.id(), format.__class__.__name__)
+                return lambda: new_id
+            new_test.id = make_new_test_id()
+            result.addTest(new_test)
+        return result
+
+
+class ScratchDir(BzrDir6):
+    """Special test class: a bzrdir that cleans up itself..
+
+    >>> d = ScratchDir()
+    >>> base = d.transport.base
+    >>> isdir(base)
+    True
+    >>> b.transport.__del__()
+    >>> isdir(base)
+    False
+    """
+
+    def __init__(self, files=[], dirs=[], transport=None):
+        """Make a test branch.
+
+        This creates a temporary directory and runs init-tree in it.
+
+        If any files are listed, they are created in the working copy.
+        """
+        if transport is None:
+            transport = bzrlib.transport.local.ScratchTransport()
+            # local import for scope restriction
+            BzrDirFormat6().initialize(transport.base)
+            super(ScratchDir, self).__init__(transport, BzrDirFormat6())
+            self.create_repository()
+            self.create_branch()
+            self.create_workingtree()
+        else:
+            super(ScratchDir, self).__init__(transport, BzrDirFormat6())
+
+        # BzrBranch creates a clone to .bzr and then forgets about the
+        # original transport. A ScratchTransport() deletes itself and
+        # everything underneath it when it goes away, so we need to
+        # grab a local copy to prevent that from happening
+        self._transport = transport
+
+        for d in dirs:
+            self._transport.mkdir(d)
+            
+        for f in files:
+            self._transport.put(f, 'content of %s' % f)
+
+    def clone(self):
+        """
+        >>> orig = ScratchDir(files=["file1", "file2"])
+        >>> os.listdir(orig.base)
+        [u'.bzr', u'file1', u'file2']
+        >>> clone = orig.clone()
+        >>> if os.name != 'nt':
+        ...   os.path.samefile(orig.base, clone.base)
+        ... else:
+        ...   orig.base == clone.base
+        ...
+        False
+        >>> os.listdir(clone.base)
+        [u'.bzr', u'file1', u'file2']
+        """
+        from shutil import copytree
+        from bzrlib.osutils import mkdtemp
+        base = mkdtemp()
+        os.rmdir(base)
+        copytree(self.base, base, symlinks=True)
+        return ScratchDir(
+            transport=bzrlib.transport.local.ScratchTransport(base))
+
+
+class Converter(object):
+    """Converts a disk format object from one format to another."""
+
+    def convert(self, to_convert, pb):
+        """Perform the conversion of to_convert, giving feedback via pb.
+
+        :param to_convert: The disk object to convert.
+        :param pb: a progress bar to use for progress information.
+        """
+
+    def step(self, message):
+        """Update the pb by a step."""
+        self.count +=1
+        self.pb.update(message, self.count, self.total)
+
+
+class ConvertBzrDir4To5(Converter):
+    """Converts format 4 bzr dirs to format 5."""
+
+    def __init__(self):
+        super(ConvertBzrDir4To5, self).__init__()
+        self.converted_revs = set()
+        self.absent_revisions = set()
+        self.text_count = 0
+        self.revisions = {}
+        
+    def convert(self, to_convert, pb):
+        """See Converter.convert()."""
+        self.bzrdir = to_convert
+        self.pb = pb
+        self.pb.note('starting upgrade from format 4 to 5')
+        if isinstance(self.bzrdir.transport, LocalTransport):
+            self.bzrdir.get_workingtree_transport(None).delete('stat-cache')
+        self._convert_to_weaves()
+        return BzrDir.open(self.bzrdir.root_transport.base)
+
+    def _convert_to_weaves(self):
+        self.pb.note('note: upgrade may be faster if all store files are ungzipped first')
+        try:
+            # TODO permissions
+            stat = self.bzrdir.transport.stat('weaves')
+            if not S_ISDIR(stat.st_mode):
+                self.bzrdir.transport.delete('weaves')
+                self.bzrdir.transport.mkdir('weaves')
+        except errors.NoSuchFile:
+            self.bzrdir.transport.mkdir('weaves')
+        self.inv_weave = Weave('inventory')
+        # holds in-memory weaves for all files
+        self.text_weaves = {}
+        self.bzrdir.transport.delete('branch-format')
+        self.branch = self.bzrdir.open_branch()
+        self._convert_working_inv()
+        rev_history = self.branch.revision_history()
+        # to_read is a stack holding the revisions we still need to process;
+        # appending to it adds new highest-priority revisions
+        self.known_revisions = set(rev_history)
+        self.to_read = rev_history[-1:]
+        while self.to_read:
+            rev_id = self.to_read.pop()
+            if (rev_id not in self.revisions
+                and rev_id not in self.absent_revisions):
+                self._load_one_rev(rev_id)
+        self.pb.clear()
+        to_import = self._make_order()
+        for i, rev_id in enumerate(to_import):
+            self.pb.update('converting revision', i, len(to_import))
+            self._convert_one_rev(rev_id)
+        self.pb.clear()
+        self._write_all_weaves()
+        self._write_all_revs()
+        self.pb.note('upgraded to weaves:')
+        self.pb.note('  %6d revisions and inventories', len(self.revisions))
+        self.pb.note('  %6d revisions not present', len(self.absent_revisions))
+        self.pb.note('  %6d texts', self.text_count)
+        self._cleanup_spare_files_after_format4()
+        self.branch.control_files.put_utf8('branch-format', BzrDirFormat5().get_format_string())
+
+    def _cleanup_spare_files_after_format4(self):
+        # FIXME working tree upgrade foo.
+        for n in 'merged-patches', 'pending-merged-patches':
+            try:
+                ## assert os.path.getsize(p) == 0
+                self.bzrdir.transport.delete(n)
+            except errors.NoSuchFile:
+                pass
+        self.bzrdir.transport.delete_tree('inventory-store')
+        self.bzrdir.transport.delete_tree('text-store')
+
+    def _convert_working_inv(self):
+        inv = serializer_v4.read_inventory(self.branch.control_files.get('inventory'))
+        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
+        # FIXME inventory is a working tree change.
+        self.branch.control_files.put('inventory', new_inv_xml)
+
+    def _write_all_weaves(self):
+        controlweaves = WeaveStore(self.bzrdir.transport, prefixed=False)
+        weave_transport = self.bzrdir.transport.clone('weaves')
+        weaves = WeaveStore(weave_transport, prefixed=False)
+        transaction = PassThroughTransaction()
+
+        controlweaves.put_weave('inventory', self.inv_weave, transaction)
+        i = 0
+        try:
+            for file_id, file_weave in self.text_weaves.items():
+                self.pb.update('writing weave', i, len(self.text_weaves))
+                weaves.put_weave(file_id, file_weave, transaction)
+                i += 1
+        finally:
+            self.pb.clear()
+
+    def _write_all_revs(self):
+        """Write all revisions out in new form."""
+        self.bzrdir.transport.delete_tree('revision-store')
+        self.bzrdir.transport.mkdir('revision-store')
+        revision_transport = self.bzrdir.transport.clone('revision-store')
+        # TODO permissions
+        revision_store = TextStore(revision_transport,
+                                   prefixed=False,
+                                   compressed=True)
+        try:
+            for i, rev_id in enumerate(self.converted_revs):
+                self.pb.update('write revision', i, len(self.converted_revs))
+                rev_tmp = StringIO()
+                serializer_v5.write_revision(self.revisions[rev_id], rev_tmp)
+                rev_tmp.seek(0)
+                revision_store.add(rev_tmp, rev_id)
+        finally:
+            self.pb.clear()
+            
+    def _load_one_rev(self, rev_id):
+        """Load a revision object into memory.
+
+        Any parents not either loaded or abandoned get queued to be
+        loaded."""
+        self.pb.update('loading revision',
+                       len(self.revisions),
+                       len(self.known_revisions))
+        if not self.branch.repository.revision_store.has_id(rev_id):
+            self.pb.clear()
+            self.pb.note('revision {%s} not present in branch; '
+                         'will be converted as a ghost',
+                         rev_id)
+            self.absent_revisions.add(rev_id)
+        else:
+            rev_xml = self.branch.repository.revision_store.get(rev_id).read()
+            rev = serializer_v4.read_revision_from_string(rev_xml)
+            for parent_id in rev.parent_ids:
+                self.known_revisions.add(parent_id)
+                self.to_read.append(parent_id)
+            self.revisions[rev_id] = rev
+
+    def _load_old_inventory(self, rev_id):
+        assert rev_id not in self.converted_revs
+        old_inv_xml = self.branch.repository.inventory_store.get(rev_id).read()
+        inv = serializer_v4.read_inventory_from_string(old_inv_xml)
+        rev = self.revisions[rev_id]
+        if rev.inventory_sha1:
+            assert rev.inventory_sha1 == sha_string(old_inv_xml), \
+                'inventory sha mismatch for {%s}' % rev_id
+        return inv
+
+    def _load_updated_inventory(self, rev_id):
+        assert rev_id in self.converted_revs
+        inv_xml = self.inv_weave.get_text(rev_id)
+        inv = serializer_v5.read_inventory_from_string(inv_xml)
+        return inv
+
+    def _convert_one_rev(self, rev_id):
+        """Convert revision and all referenced objects to new format."""
+        rev = self.revisions[rev_id]
+        inv = self._load_old_inventory(rev_id)
+        present_parents = [p for p in rev.parent_ids
+                           if p not in self.absent_revisions]
+        self._convert_revision_contents(rev, inv, present_parents)
+        self._store_new_weave(rev, inv, present_parents)
+        self.converted_revs.add(rev_id)
+
+    def _store_new_weave(self, rev, inv, present_parents):
+        # the XML is now updated with text versions
+        if __debug__:
+            for file_id in inv:
+                ie = inv[file_id]
+                if ie.kind == 'root_directory':
+                    continue
+                assert hasattr(ie, 'revision'), \
+                    'no revision on {%s} in {%s}' % \
+                    (file_id, rev.revision_id)
+        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
+        new_inv_sha1 = sha_string(new_inv_xml)
+        self.inv_weave.add(rev.revision_id, 
+                           present_parents,
+                           new_inv_xml.splitlines(True),
+                           new_inv_sha1)
+        rev.inventory_sha1 = new_inv_sha1
+
+    def _convert_revision_contents(self, rev, inv, present_parents):
+        """Convert all the files within a revision.
+
+        Also upgrade the inventory to refer to the text revision ids."""
+        rev_id = rev.revision_id
+        mutter('converting texts of revision {%s}',
+               rev_id)
+        parent_invs = map(self._load_updated_inventory, present_parents)
+        for file_id in inv:
+            ie = inv[file_id]
+            self._convert_file_version(rev, ie, parent_invs)
+
+    def _convert_file_version(self, rev, ie, parent_invs):
+        """Convert one version of one file.
+
+        The file needs to be added into the weave if it is a merge
+        of >=2 parents or if it's changed from its parent.
+        """
+        if ie.kind == 'root_directory':
+            return
+        file_id = ie.file_id
+        rev_id = rev.revision_id
+        w = self.text_weaves.get(file_id)
+        if w is None:
+            w = Weave(file_id)
+            self.text_weaves[file_id] = w
+        text_changed = False
+        previous_entries = ie.find_previous_heads(parent_invs, w)
+        for old_revision in previous_entries:
+                # if this fails, its a ghost ?
+                assert old_revision in self.converted_revs 
+        self.snapshot_ie(previous_entries, ie, w, rev_id)
+        del ie.text_id
+        assert getattr(ie, 'revision', None) is not None
+
+    def snapshot_ie(self, previous_revisions, ie, w, rev_id):
+        # TODO: convert this logic, which is ~= snapshot to
+        # a call to:. This needs the path figured out. rather than a work_tree
+        # a v4 revision_tree can be given, or something that looks enough like
+        # one to give the file content to the entry if it needs it.
+        # and we need something that looks like a weave store for snapshot to 
+        # save against.
+        #ie.snapshot(rev, PATH, previous_revisions, REVISION_TREE, InMemoryWeaveStore(self.text_weaves))
+        if len(previous_revisions) == 1:
+            previous_ie = previous_revisions.values()[0]
+            if ie._unchanged(previous_ie):
+                ie.revision = previous_ie.revision
+                return
+        parent_indexes = map(w.lookup, previous_revisions)
+        if ie.has_text():
+            text = self.branch.repository.text_store.get(ie.text_id)
+            file_lines = text.readlines()
+            assert sha_strings(file_lines) == ie.text_sha1
+            assert sum(map(len, file_lines)) == ie.text_size
+            w.add(rev_id, parent_indexes, file_lines, ie.text_sha1)
+            self.text_count += 1
+        else:
+            w.add(rev_id, parent_indexes, [], None)
+        ie.revision = rev_id
+
+    def _make_order(self):
+        """Return a suitable order for importing revisions.
+
+        The order must be such that an revision is imported after all
+        its (present) parents.
+        """
+        todo = set(self.revisions.keys())
+        done = self.absent_revisions.copy()
+        order = []
+        while todo:
+            # scan through looking for a revision whose parents
+            # are all done
+            for rev_id in sorted(list(todo)):
+                rev = self.revisions[rev_id]
+                parent_ids = set(rev.parent_ids)
+                if parent_ids.issubset(done):
+                    # can take this one now
+                    order.append(rev_id)
+                    todo.remove(rev_id)
+                    done.add(rev_id)
+        return order
+
+
+class ConvertBzrDir5To6(Converter):
+    """Converts format 5 bzr dirs to format 6."""
+
+    def convert(self, to_convert, pb):
+        """See Converter.convert()."""
+        self.bzrdir = to_convert
+        self.pb = pb
+        self.pb.note('starting upgrade from format 5 to 6')
+        self._convert_to_prefixed()
+        return BzrDir.open(self.bzrdir.root_transport.base)
+
+    def _convert_to_prefixed(self):
+        from bzrlib.store import hash_prefix
+        self.bzrdir.transport.delete('branch-format')
+        for store_name in ["weaves", "revision-store"]:
+            self.pb.note("adding prefixes to %s" % store_name) 
+            store_transport = self.bzrdir.transport.clone(store_name)
+            for filename in store_transport.list_dir('.'):
+                if (filename.endswith(".weave") or
+                    filename.endswith(".gz") or
+                    filename.endswith(".sig")):
+                    file_id = os.path.splitext(filename)[0]
+                else:
+                    file_id = filename
+                prefix_dir = hash_prefix(file_id)
+                # FIXME keep track of the dirs made RBC 20060121
+                try:
+                    store_transport.move(filename, prefix_dir + '/' + filename)
+                except errors.NoSuchFile: # catches missing dirs strangely enough
+                    store_transport.mkdir(prefix_dir)
+                    store_transport.move(filename, prefix_dir + '/' + filename)
+        self.bzrdir._control_files.put_utf8('branch-format', BzrDirFormat6().get_format_string())
+
+
+class ConvertBzrDir6ToMeta(Converter):
+    """Converts format 6 bzr dirs to metadirs."""
+
+    def convert(self, to_convert, pb):
+        """See Converter.convert()."""
+        self.bzrdir = to_convert
+        self.pb = pb
+        self.count = 0
+        self.total = 20 # the steps we know about
+        self.garbage_inventories = []
+
+        self.pb.note('starting upgrade from format 6 to metadir')
+        self.bzrdir._control_files.put_utf8('branch-format', "Converting to format 6")
+        # its faster to move specific files around than to open and use the apis...
+        # first off, nuke ancestry.weave, it was never used.
+        try:
+            self.step('Removing ancestry.weave')
+            self.bzrdir.transport.delete('ancestry.weave')
+        except errors.NoSuchFile:
+            pass
+        # find out whats there
+        self.step('Finding branch files')
+        last_revision = self.bzrdir.open_workingtree().last_revision()
+        bzrcontents = self.bzrdir.transport.list_dir('.')
+        for name in bzrcontents:
+            if name.startswith('basis-inventory.'):
+                self.garbage_inventories.append(name)
+        # create new directories for repository, working tree and branch
+        dir_mode = self.bzrdir._control_files._dir_mode
+        self.file_mode = self.bzrdir._control_files._file_mode
+        repository_names = [('inventory.weave', True),
+                            ('revision-store', True),
+                            ('weaves', True)]
+        self.step('Upgrading repository  ')
+        self.bzrdir.transport.mkdir('repository', mode=dir_mode)
+        self.make_lock('repository')
+        # we hard code the formats here because we are converting into
+        # the meta format. The meta format upgrader can take this to a 
+        # future format within each component.
+        self.put_format('repository', bzrlib.repository.RepositoryFormat7())
+        for entry in repository_names:
+            self.move_entry('repository', entry)
+
+        self.step('Upgrading branch      ')
+        self.bzrdir.transport.mkdir('branch', mode=dir_mode)
+        self.make_lock('branch')
+        self.put_format('branch', bzrlib.branch.BzrBranchFormat5())
+        branch_files = [('revision-history', True),
+                        ('branch-name', True),
+                        ('parent', False)]
+        for entry in branch_files:
+            self.move_entry('branch', entry)
+
+        self.step('Upgrading working tree')
+        self.bzrdir.transport.mkdir('checkout', mode=dir_mode)
+        self.make_lock('checkout')
+        self.put_format('checkout', bzrlib.workingtree.WorkingTreeFormat3())
+        self.bzrdir.transport.delete_multi(self.garbage_inventories, self.pb)
+        checkout_files = [('pending-merges', True),
+                          ('inventory', True),
+                          ('stat-cache', False)]
+        for entry in checkout_files:
+            self.move_entry('checkout', entry)
+        if last_revision is not None:
+            self.bzrdir._control_files.put_utf8('checkout/last-revision',
+                                                last_revision)
+        self.bzrdir._control_files.put_utf8('branch-format', BzrDirMetaFormat1().get_format_string())
+        return BzrDir.open(self.bzrdir.root_transport.base)
+
+    def make_lock(self, name):
+        """Make a lock for the new control dir name."""
+        self.step('Make %s lock' % name)
+        self.bzrdir.transport.put('%s/lock' % name, StringIO(), mode=self.file_mode)
+
+    def move_entry(self, new_dir, entry):
+        """Move then entry name into new_dir."""
+        name = entry[0]
+        mandatory = entry[1]
+        self.step('Moving %s' % name)
+        try:
+            self.bzrdir.transport.move(name, '%s/%s' % (new_dir, name))
+        except errors.NoSuchFile:
+            if mandatory:
+                raise
+
+    def put_format(self, dirname, format):
+        self.bzrdir._control_files.put_utf8('%s/format' % dirname, format.get_format_string())
+
+
+class ConvertMetaToMeta(Converter):
+    """Converts the components of metadirs."""
+
+    def __init__(self, target_format):
+        """Create a metadir to metadir converter.
+
+        :param target_format: The final metadir format that is desired.
+        """
+        self.target_format = target_format
+
+    def convert(self, to_convert, pb):
+        """See Converter.convert()."""
+        self.bzrdir = to_convert
+        self.pb = pb
+        self.count = 0
+        self.total = 1
+        self.step('checking repository format')
+        try:
+            repo = self.bzrdir.open_repository()
+        except errors.NoRepositoryPresent:
+            pass
+        else:
+            if not isinstance(repo._format, self.target_format.repository_format.__class__):
+                from bzrlib.repository import CopyConverter
+                self.pb.note('starting repository conversion')
+                converter = CopyConverter(self.target_format.repository_format)
+                converter.convert(repo, pb)
+        return to_convert

=== removed file 'bzrlib/changeset.py'
--- bzrlib/changeset.py	2006-01-25 14:30:06 +0000
+++ bzrlib/changeset.py	1970-01-01 00:00:00 +0000
@@ -1,1411 +0,0 @@
-# Copyright (C) 2004 Aaron Bentley <aaron.bentley@utoronto.ca>
-#
-#    This program is free software; you can redistribute it and/or modify
-#    it under the terms of the GNU General Public License as published by
-#    the Free Software Foundation; either version 2 of the License, or
-#    (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU General Public License for more details.
-#
-#    You should have received a copy of the GNU General Public License
-#    along with this program; if not, write to the Free Software
-#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Represent and apply a changeset.
-
-Conflicts in applying a changeset are represented as exceptions.
-
-This only handles the in-memory objects representing changesets, which are
-primarily used by the merge code. 
-"""
-
-import os.path
-import errno
-import stat
-from shutil import rmtree
-from itertools import izip
-
-from bzrlib.trace import mutter, warning
-from bzrlib.osutils import rename, sha_file, pathjoin, mkdtemp
-import bzrlib
-from bzrlib.errors import BzrCheckError
-
-__docformat__ = "restructuredtext"
-
-
-NULL_ID = "!NULL"
-
-
-class OldFailedTreeOp(Exception):
-    def __init__(self):
-        Exception.__init__(self, "bzr-tree-change contains files from a"
-                           " previous failed merge operation.")
-
-
-def invert_dict(dict):
-    newdict = {}
-    for (key,value) in dict.iteritems():
-        newdict[value] = key
-    return newdict
-
-       
-class ChangeExecFlag(object):
-    """This is two-way change, suitable for file modification, creation,
-    deletion"""
-    def __init__(self, old_exec_flag, new_exec_flag):
-        self.old_exec_flag = old_exec_flag
-        self.new_exec_flag = new_exec_flag
-
-    def apply(self, filename, conflict_handler):
-        from_exec_flag = self.old_exec_flag
-        to_exec_flag = self.new_exec_flag
-        try:
-            current_exec_flag = bool(os.stat(filename).st_mode & 0111)
-        except OSError, e:
-            if e.errno == errno.ENOENT:
-                if conflict_handler.missing_for_exec_flag(filename) == "skip":
-                    return
-                else:
-                    current_exec_flag = from_exec_flag
-
-        if from_exec_flag is not None and current_exec_flag != from_exec_flag:
-            if conflict_handler.wrong_old_exec_flag(filename,
-                        from_exec_flag, current_exec_flag) != "continue":
-                return
-
-        if to_exec_flag is not None:
-            current_mode = os.stat(filename).st_mode
-            if to_exec_flag:
-                umask = os.umask(0)
-                os.umask(umask)
-                to_mode = current_mode | (0100 & ~umask)
-                # Enable x-bit for others only if they can read it.
-                if current_mode & 0004:
-                    to_mode |= 0001 & ~umask
-                if current_mode & 0040:
-                    to_mode |= 0010 & ~umask
-            else:
-                to_mode = current_mode & ~0111
-            try:
-                os.chmod(filename, to_mode)
-            except IOError, e:
-                if e.errno == errno.ENOENT:
-                    conflict_handler.missing_for_exec_flag(filename)
-
-    def __eq__(self, other):
-        return (isinstance(other, ChangeExecFlag) and
-                self.old_exec_flag == other.old_exec_flag and
-                self.new_exec_flag == other.new_exec_flag)
-
-    def __ne__(self, other):
-        return not (self == other)
-
-
-def dir_create(filename, conflict_handler, reverse=False):
-    """Creates the directory, or deletes it if reverse is true.  Intended to be
-    used with ReplaceContents.
-
-    :param filename: The name of the directory to create
-    :type filename: str
-    :param reverse: If true, delete the directory, instead
-    :type reverse: bool
-    """
-    if not reverse:
-        try:
-            os.mkdir(filename)
-        except OSError, e:
-            if e.errno != errno.EEXIST:
-                raise
-            if conflict_handler.dir_exists(filename) == "continue":
-                os.mkdir(filename)
-        except IOError, e:
-            if e.errno == errno.ENOENT:
-                if conflict_handler.missing_parent(filename)=="continue":
-                    file(filename, "wb").write(self.contents)
-    else:
-        try:
-            os.rmdir(filename)
-        except OSError, e:
-            if e.errno != errno.ENOTEMPTY:
-                raise
-            if conflict_handler.rmdir_non_empty(filename) == "skip":
-                return
-            os.rmdir(filename)
-
-
-class SymlinkCreate(object):
-    """Creates or deletes a symlink (for use with ReplaceContents)"""
-    def __init__(self, contents):
-        """Constructor.
-
-        :param contents: The filename of the target the symlink should point to
-        :type contents: str
-        """
-        self.target = contents
-
-    def __repr__(self):
-        return "SymlinkCreate(%s)" % self.target
-
-    def __call__(self, filename, conflict_handler, reverse=False):
-        """Creates or destroys the symlink.
-
-        :param filename: The name of the symlink to create
-        :type filename: str
-        """
-        if reverse:
-            assert(os.readlink(filename) == self.target)
-            os.unlink(filename)
-        else:
-            try:
-                os.symlink(self.target, filename)
-            except OSError, e:
-                if e.errno != errno.EEXIST:
-                    raise
-                if conflict_handler.link_name_exists(filename) == "continue":
-                    os.symlink(self.target, filename)
-
-    def __eq__(self, other):
-        if not isinstance(other, SymlinkCreate):
-            return False
-        elif self.target != other.target:
-            return False
-        else:
-            return True
-
-    def __ne__(self, other):
-        return not (self == other)
-
-
-class FileCreate(object):
-    """Create or delete a file (for use with ReplaceContents)"""
-    def __init__(self, contents):
-        """Constructor
-
-        :param contents: The contents of the file to write
-        :type contents: str
-        """
-        self.contents = contents
-
-    def __repr__(self):
-        return "FileCreate(%i b)" % len(self.contents)
-
-    def __eq__(self, other):
-        if not isinstance(other, FileCreate):
-            return False
-        elif self.contents != other.contents:
-            return False
-        else:
-            return True
-
-    def __ne__(self, other):
-        return not (self == other)
-
-    def __call__(self, filename, conflict_handler, reverse=False):
-        """Create or delete a file
-
-        :param filename: The name of the file to create
-        :type filename: str
-        :param reverse: Delete the file instead of creating it
-        :type reverse: bool
-        """
-        if not reverse:
-            try:
-                file(filename, "wb").write(self.contents)
-            except IOError, e:
-                if e.errno == errno.ENOENT:
-                    if conflict_handler.missing_parent(filename)=="continue":
-                        file(filename, "wb").write(self.contents)
-                else:
-                    raise
-
-        else:
-            try:
-                if (file(filename, "rb").read() != self.contents):
-                    direction = conflict_handler.wrong_old_contents(filename,
-                                                                    self.contents)
-                    if  direction != "continue":
-                        return
-                os.unlink(filename)
-            except IOError, e:
-                if e.errno != errno.ENOENT:
-                    raise
-                if conflict_handler.missing_for_rm(filename, undo) == "skip":
-                    return
-
-
-class TreeFileCreate(object):
-    """Create or delete a file (for use with ReplaceContents)"""
-    def __init__(self, tree, file_id):
-        """Constructor
-
-        :param contents: The contents of the file to write
-        :type contents: str
-        """
-        self.tree = tree
-        self.file_id = file_id
-
-    def __repr__(self):
-        return "TreeFileCreate(%s)" % self.file_id
-
-    def __eq__(self, other):
-        if not isinstance(other, TreeFileCreate):
-            return False
-        return self.tree.get_file_sha1(self.file_id) == \
-            other.tree.get_file_sha1(other.file_id)
-
-    def __ne__(self, other):
-        return not (self == other)
-
-    def write_file(self, filename):
-        outfile = file(filename, "wb")
-        for line in self.tree.get_file(self.file_id):
-            outfile.write(line)
-
-    def same_text(self, filename):
-        in_file = file(filename, "rb")
-        return sha_file(in_file) == self.tree.get_file_sha1(self.file_id)
-
-    def __call__(self, filename, conflict_handler, reverse=False):
-        """Create or delete a file
-
-        :param filename: The name of the file to create
-        :type filename: str
-        :param reverse: Delete the file instead of creating it
-        :type reverse: bool
-        """
-        if not reverse:
-            try:
-                self.write_file(filename)
-            except IOError, e:
-                if e.errno == errno.ENOENT:
-                    if conflict_handler.missing_parent(filename)=="continue":
-                        self.write_file(filename)
-                else:
-                    raise
-
-        else:
-            try:
-                if not self.same_text(filename):
-                    direction = conflict_handler.wrong_old_contents(filename,
-                        self.tree.get_file(self.file_id).read())
-                    if  direction != "continue":
-                        return
-                os.unlink(filename)
-            except IOError, e:
-                if e.errno != errno.ENOENT:
-                    raise
-                if conflict_handler.missing_for_rm(filename, undo) == "skip":
-                    return
-
-
-class ReplaceContents(object):
-    """A contents-replacement framework.  It allows a file/directory/symlink to
-    be created, deleted, or replaced with another file/directory/symlink.
-    Arguments must be callable with (filename, reverse).
-    """
-    def __init__(self, old_contents, new_contents):
-        """Constructor.
-
-        :param old_contents: The change to reverse apply (e.g. a deletion), \
-        when going forwards.
-        :type old_contents: `dir_create`, `SymlinkCreate`, `FileCreate`, \
-        NoneType, etc.
-        :param new_contents: The second change to apply (e.g. a creation), \
-        when going forwards.
-        :type new_contents: `dir_create`, `SymlinkCreate`, `FileCreate`, \
-        NoneType, etc.
-        """
-        self.old_contents=old_contents
-        self.new_contents=new_contents
-
-    def __repr__(self):
-        return "ReplaceContents(%r -> %r)" % (self.old_contents,
-                                              self.new_contents)
-
-    def __eq__(self, other):
-        if not isinstance(other, ReplaceContents):
-            return False
-        elif self.old_contents != other.old_contents:
-            return False
-        elif self.new_contents != other.new_contents:
-            return False
-        else:
-            return True
-    def __ne__(self, other):
-        return not (self == other)
-
-    def apply(self, filename, conflict_handler):
-        """Applies the FileReplacement to the specified filename
-
-        :param filename: The name of the file to apply changes to
-        :type filename: str
-        """
-        undo = self.old_contents
-        perform = self.new_contents
-        mode = None
-        if undo is not None:
-            try:
-                mode = os.lstat(filename).st_mode
-                if stat.S_ISLNK(mode):
-                    mode = None
-            except OSError, e:
-                if e.errno != errno.ENOENT:
-                    raise
-                if conflict_handler.missing_for_rm(filename, undo) == "skip":
-                    return
-            undo(filename, conflict_handler, reverse=True)
-        if perform is not None:
-            perform(filename, conflict_handler)
-            if mode is not None:
-                os.chmod(filename, mode)
-
-    def is_creation(self):
-        return self.new_contents is not None and self.old_contents is None
-
-    def is_deletion(self):
-        return self.old_contents is not None and self.new_contents is None
-
-
-class Diff3Merge(object):
-    history_based = False
-    def __init__(self, file_id, base, other):
-        self.file_id = file_id
-        self.base = base
-        self.other = other
-
-    def is_creation(self):
-        return False
-
-    def is_deletion(self):
-        return False
-
-    def __eq__(self, other):
-        if not isinstance(other, Diff3Merge):
-            return False
-        return (self.base == other.base and 
-                self.other == other.other and self.file_id == other.file_id)
-
-    def __ne__(self, other):
-        return not (self == other)
-
-    def dump_file(self, temp_dir, name, tree):
-        out_path = pathjoin(temp_dir, name)
-        out_file = file(out_path, "wb")
-        in_file = tree.get_file(self.file_id)
-        for line in in_file:
-            out_file.write(line)
-        return out_path
-
-    def apply(self, filename, conflict_handler):
-        import bzrlib.patch
-        temp_dir = mkdtemp(prefix="bzr-")
-        try:
-            new_file = filename+".new"
-            base_file = self.dump_file(temp_dir, "base", self.base)
-            other_file = self.dump_file(temp_dir, "other", self.other)
-            base = base_file
-            other = other_file
-            status = bzrlib.patch.diff3(new_file, filename, base, other)
-            if status == 0:
-                os.chmod(new_file, os.stat(filename).st_mode)
-                rename(new_file, filename)
-                return
-            else:
-                assert(status == 1)
-                def get_lines(filename):
-                    my_file = file(filename, "rb")
-                    lines = my_file.readlines()
-                    my_file.close()
-                    return lines
-                base_lines = get_lines(base)
-                other_lines = get_lines(other)
-                conflict_handler.merge_conflict(new_file, filename, base_lines, 
-                                                other_lines)
-        finally:
-            rmtree(temp_dir)
-
-
-def CreateDir():
-    """Convenience function to create a directory.
-
-    :return: A ReplaceContents that will create a directory
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(None, dir_create)
-
-
-def DeleteDir():
-    """Convenience function to delete a directory.
-
-    :return: A ReplaceContents that will delete a directory
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(dir_create, None)
-
-
-def CreateFile(contents):
-    """Convenience fucntion to create a file.
-    
-    :param contents: The contents of the file to create 
-    :type contents: str
-    :return: A ReplaceContents that will create a file 
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(None, FileCreate(contents))
-
-
-def DeleteFile(contents):
-    """Convenience fucntion to delete a file.
-    
-    :param contents: The contents of the file to delete
-    :type contents: str
-    :return: A ReplaceContents that will delete a file 
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(FileCreate(contents), None)
-
-
-def ReplaceFileContents(old_tree, new_tree, file_id):
-    """Convenience fucntion to replace the contents of a file.
-    
-    :param old_contents: The contents of the file to replace 
-    :type old_contents: str
-    :param new_contents: The contents to replace the file with
-    :type new_contents: str
-    :return: A ReplaceContents that will replace the contents of a file a file 
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(TreeFileCreate(old_tree, file_id), 
-                           TreeFileCreate(new_tree, file_id))
-
-
-def CreateSymlink(target):
-    """Convenience fucntion to create a symlink.
-    
-    :param target: The path the link should point to
-    :type target: str
-    :return: A ReplaceContents that will delete a file 
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(None, SymlinkCreate(target))
-
-
-def DeleteSymlink(target):
-    """Convenience fucntion to delete a symlink.
-    
-    :param target: The path the link should point to
-    :type target: str
-    :return: A ReplaceContents that will delete a file 
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(SymlinkCreate(target), None)
-
-
-def ChangeTarget(old_target, new_target):
-    """Convenience fucntion to change the target of a symlink.
-    
-    :param old_target: The current link target
-    :type old_target: str
-    :param new_target: The new link target to use
-    :type new_target: str
-    :return: A ReplaceContents that will delete a file 
-    :rtype: `ReplaceContents`
-    """
-    return ReplaceContents(SymlinkCreate(old_target), SymlinkCreate(new_target))
-
-
-class InvalidEntry(Exception):
-    """Raise when a ChangesetEntry is invalid in some way"""
-    def __init__(self, entry, problem):
-        """Constructor.
-
-        :param entry: The invalid ChangesetEntry
-        :type entry: `ChangesetEntry`
-        :param problem: The problem with the entry
-        :type problem: str
-        """
-        msg = "Changeset entry for %s (%s) is invalid.\n%s" % (entry.id, 
-                                                               entry.path, 
-                                                               problem)
-        Exception.__init__(self, msg)
-        self.entry = entry
-
-
-class SourceRootHasName(InvalidEntry):
-    """This changeset entry has a name other than "", but its parent is !NULL"""
-    def __init__(self, entry, name):
-        """Constructor.
-
-        :param entry: The invalid ChangesetEntry
-        :type entry: `ChangesetEntry`
-        :param name: The name of the entry
-        :type name: str
-        """
-        msg = 'Child of !NULL is named "%s", not "./.".' % name
-        InvalidEntry.__init__(self, entry, msg)
-
-
-class NullIDAssigned(InvalidEntry):
-    """The id !NULL was assigned to a real entry"""
-    def __init__(self, entry):
-        """Constructor.
-
-        :param entry: The invalid ChangesetEntry
-        :type entry: `ChangesetEntry`
-        """
-        msg = '"!NULL" id assigned to a file "%s".' % entry.path
-        InvalidEntry.__init__(self, entry, msg)
-
-
-class ParentIDIsSelf(InvalidEntry):
-    """An entry is marked as its own parent"""
-    def __init__(self, entry):
-        """Constructor.
-
-        :param entry: The invalid ChangesetEntry
-        :type entry: `ChangesetEntry`
-        """
-        msg = 'file %s has "%s" id for both self id and parent id.' % \
-            (entry.path, entry.id)
-        InvalidEntry.__init__(self, entry, msg)
-
-
-class ChangesetEntry(object):
-    """An entry the changeset"""
-    def __init__(self, id, parent, path):
-        """Constructor. Sets parent and name assuming it was not
-        renamed/created/deleted.
-        :param id: The id associated with the entry
-        :param parent: The id of the parent of this entry (or !NULL if no
-        parent)
-        :param path: The file path relative to the tree root of this entry
-        """
-        self.id = id
-        self.path = path 
-        self.new_path = path
-        self.parent = parent
-        self.new_parent = parent
-        self.contents_change = None
-        self.metadata_change = None
-        if parent == NULL_ID and path !='./.':
-            raise SourceRootHasName(self, path)
-        if self.id == NULL_ID:
-            raise NullIDAssigned(self)
-        if self.id  == self.parent:
-            raise ParentIDIsSelf(self)
-
-    def __repr__(self):
-        return "ChangesetEntry(%s)" % self.id
-
-    __str__ = __repr__
-
-    def __get_dir(self):
-        if self.path is None:
-            return None
-        return os.path.dirname(self.path)
-
-    def __set_dir(self, dir):
-        self.path = pathjoin(dir, os.path.basename(self.path))
-
-    dir = property(__get_dir, __set_dir)
-    
-    def __get_name(self):
-        if self.path is None:
-            return None
-        return os.path.basename(self.path)
-
-    def __set_name(self, name):
-        self.path = pathjoin(os.path.dirname(self.path), name)
-
-    name = property(__get_name, __set_name)
-
-    def __get_new_dir(self):
-        if self.new_path is None:
-            return None
-        return os.path.dirname(self.new_path)
-
-    def __set_new_dir(self, dir):
-        self.new_path = pathjoin(dir, os.path.basename(self.new_path))
-
-    new_dir = property(__get_new_dir, __set_new_dir)
-
-    def __get_new_name(self):
-        if self.new_path is None:
-            return None
-        return os.path.basename(self.new_path)
-
-    def __set_new_name(self, name):
-        self.new_path = pathjoin(os.path.dirname(self.new_path), name)
-
-    new_name = property(__get_new_name, __set_new_name)
-
-    def needs_rename(self):
-        """Determines whether the entry requires renaming.
-
-        :rtype: bool
-        """
-
-        return (self.parent != self.new_parent or self.name != self.new_name)
-
-    def is_deletion(self, reverse=False):
-        """Return true if applying the entry would delete a file/directory.
-
-        :param reverse: if true, the changeset is being applied in reverse
-        :rtype: bool
-        """
-        return self.is_creation(not reverse)
-
-    def is_creation(self, reverse=False):
-        """Return true if applying the entry would create a file/directory.
-
-        :param reverse: if true, the changeset is being applied in reverse
-        :rtype: bool
-        """
-        if self.contents_change is None:
-            return False
-        if reverse:
-            return self.contents_change.is_deletion()
-        else:
-            return self.contents_change.is_creation()
-
-    def is_creation_or_deletion(self):
-        """Return true if applying the entry would create or delete a 
-        file/directory.
-
-        :rtype: bool
-        """
-        return self.is_creation() or self.is_deletion()
-
-    def get_cset_path(self, mod=False):
-        """Determine the path of the entry according to the changeset.
-
-        :param changeset: The changeset to derive the path from
-        :type changeset: `Changeset`
-        :param mod: If true, generate the MOD path.  Otherwise, generate the \
-        ORIG path.
-        :return: the path of the entry, or None if it did not exist in the \
-        requested tree.
-        :rtype: str or NoneType
-        """
-        if mod:
-            if self.new_parent == NULL_ID:
-                return "./."
-            elif self.new_parent is None:
-                return None
-            return self.new_path
-        else:
-            if self.parent == NULL_ID:
-                return "./."
-            elif self.parent is None:
-                return None
-            return self.path
-
-    def summarize_name(self):
-        """Produce a one-line summary of the filename.  Indicates renames as
-        old => new, indicates creation as None => new, indicates deletion as
-        old => None.
-
-        :rtype: str
-        """
-        orig_path = self.get_cset_path(False)
-        mod_path = self.get_cset_path(True)
-        if orig_path and orig_path.startswith('./'):
-            orig_path = orig_path[2:]
-        if mod_path and mod_path.startswith('./'):
-            mod_path = mod_path[2:]
-        if orig_path == mod_path:
-            return orig_path
-        else:
-            return "%s => %s" % (orig_path, mod_path)
-
-    def get_new_path(self, id_map, changeset):
-        """Determine the full pathname to rename to
-
-        :param id_map: The map of ids to filenames for the tree
-        :type id_map: Dictionary
-        :param changeset: The changeset to get data from
-        :type changeset: `Changeset`
-        :rtype: str
-        """
-        mutter("Finding new path for %s", self.summarize_name())
-        parent = self.new_parent
-        to_dir = self.new_dir
-        from_dir = self.dir
-        to_name = self.new_name
-        from_name = self.name
-
-        if to_name is None:
-            return None
-
-        if parent == NULL_ID or parent is None:
-            if to_name != u'.':
-                raise SourceRootHasName(self, to_name)
-            else:
-                return u'.'
-        parent_entry = changeset.entries.get(parent)
-        if parent_entry is None:
-            dir = os.path.dirname(id_map[self.id])
-        else:
-            mutter("path, new_path: %r %r", self.path, self.new_path)
-            dir = parent_entry.get_new_path(id_map, changeset)
-        if from_name == to_name:
-            name = os.path.basename(id_map[self.id])
-        else:
-            name = to_name
-            assert(from_name is None or from_name == os.path.basename(id_map[self.id]))
-        return pathjoin(dir, name)
-
-    def is_boring(self):
-        """Determines whether the entry does nothing
-        
-        :return: True if the entry does no renames or content changes
-        :rtype: bool
-        """
-        if self.contents_change is not None:
-            return False
-        elif self.metadata_change is not None:
-            return False
-        elif self.parent != self.new_parent:
-            return False
-        elif self.name != self.new_name:
-            return False
-        else:
-            return True
-
-    def apply(self, filename, conflict_handler):
-        """Applies the file content and/or metadata changes.
-
-        :param filename: the filename of the entry
-        :type filename: str
-        """
-        if self.is_deletion() and self.metadata_change is not None:
-            self.metadata_change.apply(filename, conflict_handler)
-        if self.contents_change is not None:
-            self.contents_change.apply(filename, conflict_handler)
-        if not self.is_deletion() and self.metadata_change is not None:
-            self.metadata_change.apply(filename, conflict_handler)
-
-
-class IDPresent(Exception):
-    def __init__(self, id):
-        msg = "Cannot add entry because that id has already been used:\n%s" %\
-            id
-        Exception.__init__(self, msg)
-        self.id = id
-
-
-class Changeset(object):
-    """A set of changes to apply"""
-    def __init__(self):
-        self.entries = {}
-
-    def add_entry(self, entry):
-        """Add an entry to the list of entries"""
-        if self.entries.has_key(entry.id):
-            raise IDPresent(entry.id)
-        self.entries[entry.id] = entry
-
-
-def get_rename_entries(changeset, inventory):
-    """Return a list of entries that will be renamed.  Entries are sorted from
-    longest to shortest source path and from shortest to longest target path.
-
-    :param changeset: The changeset to look in
-    :type changeset: `Changeset`
-    :param inventory: The source of current tree paths for the given ids
-    :type inventory: Dictionary
-    :return: source entries and target entries as a tuple
-    :rtype: (List, List)
-    """
-    source_entries = [x for x in changeset.entries.itervalues() 
-                      if x.needs_rename() or x.is_creation_or_deletion()]
-    # these are done from longest path to shortest, to avoid deleting a
-    # parent before its children are deleted/renamed 
-    def longest_to_shortest(entry):
-        path = inventory.get(entry.id)
-        if path is None:
-            return 0
-        else:
-            return len(path)
-    source_entries.sort(None, longest_to_shortest, True)
-
-    target_entries = source_entries[:]
-    # These are done from shortest to longest path, to avoid creating a
-    # child before its parent has been created/renamed
-    def shortest_to_longest(entry):
-        path = entry.get_new_path(inventory, changeset)
-        if path is None:
-            return 0
-        else:
-            return len(path)
-    target_entries.sort(None, shortest_to_longest)
-    return (source_entries, target_entries)
-
-
-def rename_to_temp_delete(source_entries, inventory, dir, temp_dir, 
-                          conflict_handler):
-    """Delete and rename entries as appropriate.  Entries are renamed to temp
-    names.  A map of id -> temp name (or None, for deletions) is returned.
-
-    :param source_entries: The entries to rename and delete
-    :type source_entries: List of `ChangesetEntry`
-    :param inventory: The map of id -> filename in the current tree
-    :type inventory: Dictionary
-    :param dir: The directory to apply changes to
-    :type dir: str
-    :return: a mapping of id to temporary name
-    :rtype: Dictionary
-    """
-    temp_name = {}
-    for i in range(len(source_entries)):
-        entry = source_entries[i]
-        if entry.is_deletion():
-            path = pathjoin(dir, inventory[entry.id])
-            entry.apply(path, conflict_handler)
-            temp_name[entry.id] = None
-
-        elif entry.needs_rename():
-            if entry.is_creation():
-                continue
-            to_name = pathjoin(temp_dir, str(i))
-            src_path = inventory.get(entry.id)
-            if src_path is not None:
-                src_path = pathjoin(dir, src_path)
-                try:
-                    rename(src_path, to_name)
-                    temp_name[entry.id] = to_name
-                except OSError, e:
-                    if e.errno != errno.ENOENT:
-                        raise
-                    if conflict_handler.missing_for_rename(src_path, to_name) \
-                        == "skip":
-                        continue
-
-    return temp_name
-
-
-def rename_to_new_create(changed_inventory, target_entries, inventory, 
-                         changeset, dir, conflict_handler):
-    """Rename entries with temp names to their final names, create new files.
-
-    :param changed_inventory: A mapping of id to temporary name
-    :type changed_inventory: Dictionary
-    :param target_entries: The entries to apply changes to
-    :type target_entries: List of `ChangesetEntry`
-    :param changeset: The changeset to apply
-    :type changeset: `Changeset`
-    :param dir: The directory to apply changes to
-    :type dir: str
-    """
-    for entry in target_entries:
-        new_tree_path = entry.get_new_path(inventory, changeset)
-        if new_tree_path is None:
-            continue
-        new_path = pathjoin(dir, new_tree_path)
-        old_path = changed_inventory.get(entry.id)
-        if bzrlib.osutils.lexists(new_path):
-            if conflict_handler.target_exists(entry, new_path, old_path) == \
-                "skip":
-                continue
-        if entry.is_creation():
-            entry.apply(new_path, conflict_handler)
-            changed_inventory[entry.id] = new_tree_path
-        elif entry.needs_rename():
-            if entry.is_deletion():
-                continue
-            if old_path is None:
-                continue
-            try:
-                mutter('rename %s to final name %s', old_path, new_path)
-                rename(old_path, new_path)
-                changed_inventory[entry.id] = new_tree_path
-            except OSError, e:
-                raise BzrCheckError('failed to rename %s to %s for changeset entry %s: %s'
-                        % (old_path, new_path, entry, e))
-
-
-class TargetExists(Exception):
-    def __init__(self, entry, target):
-        msg = "The path %s already exists" % target
-        Exception.__init__(self, msg)
-        self.entry = entry
-        self.target = target
-
-
-class RenameConflict(Exception):
-    def __init__(self, id, this_name, base_name, other_name):
-        msg = """Trees all have different names for a file
- this: %s
- base: %s
-other: %s
-   id: %s""" % (this_name, base_name, other_name, id)
-        Exception.__init__(self, msg)
-        self.this_name = this_name
-        self.base_name = base_name
-        self_other_name = other_name
-
-
-class MoveConflict(Exception):
-    def __init__(self, id, this_parent, base_parent, other_parent):
-        msg = """The file is in different directories in every tree
- this: %s
- base: %s
-other: %s
-   id: %s""" % (this_parent, base_parent, other_parent, id)
-        Exception.__init__(self, msg)
-        self.this_parent = this_parent
-        self.base_parent = base_parent
-        self_other_parent = other_parent
-
-
-class MergeConflict(Exception):
-    def __init__(self, this_path):
-        Exception.__init__(self, "Conflict applying changes to %s" % this_path)
-        self.this_path = this_path
-
-
-class WrongOldContents(Exception):
-    def __init__(self, filename):
-        msg = "Contents mismatch deleting %s" % filename
-        self.filename = filename
-        Exception.__init__(self, msg)
-
-
-class WrongOldExecFlag(Exception):
-    def __init__(self, filename, old_exec_flag, new_exec_flag):
-        msg = "Executable flag missmatch on %s:\n" \
-        "Expected %s, got %s." % (filename, old_exec_flag, new_exec_flag)
-        self.filename = filename
-        Exception.__init__(self, msg)
-
-
-class RemoveContentsConflict(Exception):
-    def __init__(self, filename):
-        msg = "Conflict deleting %s, which has different contents in BASE"\
-            " and THIS" % filename
-        self.filename = filename
-        Exception.__init__(self, msg)
-
-
-class DeletingNonEmptyDirectory(Exception):
-    def __init__(self, filename):
-        msg = "Trying to remove dir %s while it still had files" % filename
-        self.filename = filename
-        Exception.__init__(self, msg)
-
-
-class PatchTargetMissing(Exception):
-    def __init__(self, filename):
-        msg = "Attempt to patch %s, which does not exist" % filename
-        Exception.__init__(self, msg)
-        self.filename = filename
-
-
-class MissingForSetExec(Exception):
-    def __init__(self, filename):
-        msg = "Attempt to change permissions on  %s, which does not exist" %\
-            filename
-        Exception.__init__(self, msg)
-        self.filename = filename
-
-
-class MissingForRm(Exception):
-    def __init__(self, filename):
-        msg = "Attempt to remove missing path %s" % filename
-        Exception.__init__(self, msg)
-        self.filename = filename
-
-
-class MissingForRename(Exception):
-    def __init__(self, filename, to_path):
-        msg = "Attempt to move missing path %s to %s" % (filename, to_path)
-        Exception.__init__(self, msg)
-        self.filename = filename
-
-
-class NewContentsConflict(Exception):
-    def __init__(self, filename):
-        msg = "Conflicting contents for new file %s" % (filename)
-        Exception.__init__(self, msg)
-
-
-class WeaveMergeConflict(Exception):
-    def __init__(self, filename):
-        msg = "Conflicting contents for file %s" % (filename)
-        Exception.__init__(self, msg)
-
-
-class ThreewayContentsConflict(Exception):
-    def __init__(self, filename):
-        msg = "Conflicting contents for file %s" % (filename)
-        Exception.__init__(self, msg)
-
-
-class MissingForMerge(Exception):
-    def __init__(self, filename):
-        msg = "The file %s was modified, but does not exist in this tree"\
-            % (filename)
-        Exception.__init__(self, msg)
-
-
-class ExceptionConflictHandler(object):
-    """Default handler for merge exceptions.
-
-    This throws an error on any kind of conflict.  Conflict handlers can
-    descend from this class if they have a better way to handle some or
-    all types of conflict.
-    """
-    def missing_parent(self, pathname):
-        parent = os.path.dirname(pathname)
-        raise Exception("Parent directory missing for %s" % pathname)
-
-    def dir_exists(self, pathname):
-        raise Exception("Directory already exists for %s" % pathname)
-
-    def failed_hunks(self, pathname):
-        raise Exception("Failed to apply some hunks for %s" % pathname)
-
-    def target_exists(self, entry, target, old_path):
-        raise TargetExists(entry, target)
-
-    def rename_conflict(self, id, this_name, base_name, other_name):
-        raise RenameConflict(id, this_name, base_name, other_name)
-
-    def move_conflict(self, id, this_dir, base_dir, other_dir):
-        raise MoveConflict(id, this_dir, base_dir, other_dir)
-
-    def merge_conflict(self, new_file, this_path, base_lines, other_lines):
-        os.unlink(new_file)
-        raise MergeConflict(this_path)
-
-    def wrong_old_contents(self, filename, expected_contents):
-        raise WrongOldContents(filename)
-
-    def rem_contents_conflict(self, filename, this_contents, base_contents):
-        raise RemoveContentsConflict(filename)
-
-    def wrong_old_exec_flag(self, filename, old_exec_flag, new_exec_flag):
-        raise WrongOldExecFlag(filename, old_exec_flag, new_exec_flag)
-
-    def rmdir_non_empty(self, filename):
-        raise DeletingNonEmptyDirectory(filename)
-
-    def link_name_exists(self, filename):
-        raise TargetExists(filename)
-
-    def patch_target_missing(self, filename, contents):
-        raise PatchTargetMissing(filename)
-
-    def missing_for_exec_flag(self, filename):
-        raise MissingForExecFlag(filename)
-
-    def missing_for_rm(self, filename, change):
-        raise MissingForRm(filename)
-
-    def missing_for_rename(self, filename, to_path):
-        raise MissingForRename(filename, to_path)
-
-    def missing_for_merge(self, file_id, other_path):
-        raise MissingForMerge(other_path)
-
-    def new_contents_conflict(self, filename, other_contents):
-        raise NewContentsConflict(filename)
-
-    def weave_merge_conflict(self, filename, weave, other_i, out_file):
-        raise WeaveMergeConflict(filename)
- 
-    def threeway_contents_conflict(self, filename, this_contents,
-                                   base_contents, other_contents):
-        raise ThreewayContentsConflict(filename)
-
-    def finalize(self):
-        pass
-
-
-def apply_changeset(changeset, inventory, dir, conflict_handler=None):
-    """Apply a changeset to a directory.
-
-    :param changeset: The changes to perform
-    :type changeset: `Changeset`
-    :param inventory: The mapping of id to filename for the directory
-    :type inventory: Dictionary
-    :param dir: The path of the directory to apply the changes to
-    :type dir: str
-    :return: The mapping of the changed entries
-    :rtype: Dictionary
-    """
-    if conflict_handler is None:
-        conflict_handler = ExceptionConflictHandler()
-    temp_dir = pathjoin(dir, "bzr-tree-change")
-    try:
-        os.mkdir(temp_dir)
-    except OSError, e:
-        if e.errno == errno.EEXIST:
-            try:
-                os.rmdir(temp_dir)
-            except OSError, e:
-                if e.errno == errno.ENOTEMPTY:
-                    raise OldFailedTreeOp()
-            os.mkdir(temp_dir)
-        else:
-            raise
-    
-    #apply changes that don't affect filenames
-    for entry in changeset.entries.itervalues():
-        if not entry.is_creation_or_deletion() and not entry.is_boring():
-            if entry.id not in inventory:
-                warning("entry {%s} no longer present, can't be updated",
-                        entry.id)
-                continue
-            path = pathjoin(dir, inventory[entry.id])
-            entry.apply(path, conflict_handler)
-
-    # Apply renames in stages, to minimize conflicts:
-    # Only files whose name or parent change are interesting, because their
-    # target name may exist in the source tree.  If a directory's name changes,
-    # that doesn't make its children interesting.
-    (source_entries, target_entries) = get_rename_entries(changeset, inventory)
-
-    changed_inventory = rename_to_temp_delete(source_entries, inventory, dir,
-                                              temp_dir, conflict_handler)
-
-    rename_to_new_create(changed_inventory, target_entries, inventory,
-                         changeset, dir, conflict_handler)
-    os.rmdir(temp_dir)
-    return changed_inventory
-
-
-def print_changeset(cset):
-    """Print all non-boring changeset entries
-    
-    :param cset: The changeset to print
-    :type cset: `Changeset`
-    """
-    for entry in cset.entries.itervalues():
-        if entry.is_boring():
-            continue
-        print entry.id
-        print entry.summarize_name(cset)
-
-
-class UnsupportedFiletype(Exception):
-    def __init__(self, kind, full_path):
-        msg = "The file \"%s\" is a %s, which is not a supported filetype." \
-            % (full_path, kind)
-        Exception.__init__(self, msg)
-        self.full_path = full_path
-        self.kind = kind
-
-
-def generate_changeset(tree_a, tree_b, interesting_ids=None):
-    return ChangesetGenerator(tree_a, tree_b, interesting_ids)()
-
-
-class ChangesetGenerator(object):
-    def __init__(self, tree_a, tree_b, interesting_ids=None):
-        object.__init__(self)
-        self.tree_a = tree_a
-        self.tree_b = tree_b
-        self._interesting_ids = interesting_ids
-
-    def iter_both_tree_ids(self):
-        for file_id in self.tree_a:
-            yield file_id
-        for file_id in self.tree_b:
-            if file_id not in self.tree_a:
-                yield file_id
-
-    def __call__(self):
-        cset = Changeset()
-        for file_id in self.iter_both_tree_ids():
-            cs_entry = self.make_entry(file_id)
-            if cs_entry is not None and not cs_entry.is_boring():
-                cset.add_entry(cs_entry)
-
-        for entry in list(cset.entries.itervalues()):
-            if entry.parent != entry.new_parent:
-                if not cset.entries.has_key(entry.parent) and\
-                    entry.parent != NULL_ID and entry.parent is not None:
-                    parent_entry = self.make_boring_entry(entry.parent)
-                    cset.add_entry(parent_entry)
-                if not cset.entries.has_key(entry.new_parent) and\
-                    entry.new_parent != NULL_ID and \
-                    entry.new_parent is not None:
-                    parent_entry = self.make_boring_entry(entry.new_parent)
-                    cset.add_entry(parent_entry)
-        return cset
-
-    def iter_inventory(self, tree):
-        for file_id in tree:
-            yield self.get_entry(file_id, tree)
-
-    def get_entry(self, file_id, tree):
-        if not tree.has_or_had_id(file_id):
-            return None
-        return tree.inventory[file_id]
-
-    def get_entry_parent(self, entry):
-        if entry is None:
-            return None
-        return entry.parent_id
-
-    def get_path(self, file_id, tree):
-        if not tree.has_or_had_id(file_id):
-            return None
-        path = tree.id2path(file_id)
-        if path == '':
-            return './.'
-        else:
-            return path
-
-    def make_basic_entry(self, file_id, only_interesting):
-        entry_a = self.get_entry(file_id, self.tree_a)
-        entry_b = self.get_entry(file_id, self.tree_b)
-        if only_interesting and not self.is_interesting(entry_a, entry_b):
-            return None
-        parent = self.get_entry_parent(entry_a)
-        path = self.get_path(file_id, self.tree_a)
-        cs_entry = ChangesetEntry(file_id, parent, path)
-        new_parent = self.get_entry_parent(entry_b)
-
-        new_path = self.get_path(file_id, self.tree_b)
-
-        cs_entry.new_path = new_path
-        cs_entry.new_parent = new_parent
-        return cs_entry
-
-    def is_interesting(self, entry_a, entry_b):
-        if self._interesting_ids is None:
-            return True
-        if entry_a is not None:
-            file_id = entry_a.file_id
-        elif entry_b is not None:
-            file_id = entry_b.file_id
-        else:
-            return False
-        return file_id in self._interesting_ids
-
-    def make_boring_entry(self, id):
-        cs_entry = self.make_basic_entry(id, only_interesting=False)
-        if cs_entry.is_creation_or_deletion():
-            return self.make_entry(id, only_interesting=False)
-        else:
-            return cs_entry
-
-    def make_entry(self, id, only_interesting=True):
-        cs_entry = self.make_basic_entry(id, only_interesting)
-
-        if cs_entry is None:
-            return None
-
-        cs_entry.metadata_change = self.make_exec_flag_change(id)
-
-        if id in self.tree_a and id in self.tree_b:
-            a_sha1 = self.tree_a.get_file_sha1(id)
-            b_sha1 = self.tree_b.get_file_sha1(id)
-            if None not in (a_sha1, b_sha1) and a_sha1 == b_sha1:
-                return cs_entry
-
-        cs_entry.contents_change = self.make_contents_change(id)
-        return cs_entry
-
-    def make_exec_flag_change(self, file_id):
-        exec_flag_a = exec_flag_b = None
-        if file_id in self.tree_a and self.tree_a.kind(file_id) == "file":
-            exec_flag_a = self.tree_a.is_executable(file_id)
-
-        if file_id in self.tree_b and self.tree_b.kind(file_id) == "file":
-            exec_flag_b = self.tree_b.is_executable(file_id)
-
-        if exec_flag_a == exec_flag_b:
-            return None
-        return ChangeExecFlag(exec_flag_a, exec_flag_b)
-
-    def make_contents_change(self, file_id):
-        a_contents = get_contents(self.tree_a, file_id)
-        b_contents = get_contents(self.tree_b, file_id)
-        if a_contents == b_contents:
-            return None
-        return ReplaceContents(a_contents, b_contents)
-
-
-def get_contents(tree, file_id):
-    """Return the appropriate contents to create a copy of file_id from tree"""
-    if file_id not in tree:
-        return None
-    kind = tree.kind(file_id)
-    if kind == "file":
-        return TreeFileCreate(tree, file_id)
-    elif kind in ("directory", "root_directory"):
-        return dir_create
-    elif kind == "symlink":
-        return SymlinkCreate(tree.get_symlink_target(file_id))
-    else:
-        raise UnsupportedFiletype(kind, tree.id2path(file_id))
-
-
-def full_path(entry, tree):
-    return pathjoin(tree.basedir, entry.path)
-
-
-def new_delete_entry(entry, tree, inventory, delete):
-    if entry.path == "":
-        parent = NULL_ID
-    else:
-        parent = inventory[dirname(entry.path)].id
-    cs_entry = ChangesetEntry(parent, entry.path)
-    if delete:
-        cs_entry.new_path = None
-        cs_entry.new_parent = None
-    else:
-        cs_entry.path = None
-        cs_entry.parent = None
-    full_path = full_path(entry, tree)
-    status = os.lstat(full_path)
-    if stat.S_ISDIR(file_stat.st_mode):
-        action = dir_create
-
-
-# XXX: Can't we unify this with the regular inventory object
-class Inventory(object):
-    def __init__(self, inventory):
-        self.inventory = inventory
-        self.rinventory = None
-
-    def get_rinventory(self):
-        if self.rinventory is None:
-            self.rinventory  = invert_dict(self.inventory)
-        return self.rinventory
-
-    def get_path(self, id):
-        return self.inventory.get(id)
-
-    def get_name(self, id):
-        path = self.get_path(id)
-        if path is None:
-            return None
-        else:
-            return os.path.basename(path)
-
-    def get_dir(self, id):
-        path = self.get_path(id)
-        if path == "":
-            return None
-        if path is None:
-            return None
-        return os.path.dirname(path)
-
-    def get_parent(self, id):
-        if self.get_path(id) is None:
-            return None
-        directory = self.get_dir(id)
-        if directory == '.':
-            directory = u'./.'
-        if directory is None:
-            return NULL_ID
-        return self.get_rinventory().get(directory)
-
-

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2006-01-25 14:30:06 +0000
+++ bzrlib/check.py	2006-03-20 08:31:00 +0000
@@ -41,6 +41,7 @@
 
     def __init__(self, branch):
         self.branch = branch
+        self.repository = branch.repository
         self.checked_text_cnt = 0
         self.checked_rev_cnt = 0
         self.ghosts = []
@@ -59,7 +60,7 @@
             self.progress.update('retrieving inventory', 0, 0)
             # do not put in init, as it should be done with progess,
             # and inside the lock.
-            self.inventory_weave = self.branch._get_inventory_weave()
+            self.inventory_weave = self.branch.repository.get_inventory_weave()
             self.history = self.branch.revision_history()
             if not len(self.history):
                 # nothing to see here
@@ -78,8 +79,9 @@
             self.branch.unlock()
 
     def plan_revisions(self):
-        if not self.branch.revision_store.listable():
-            self.planned_revisions = self.branch.get_ancestry(self.history[-1])
+        repository = self.branch.repository
+        if not repository.revision_store.listable():
+            self.planned_revisions = repository.get_ancestry(self.history[-1])
             self.planned_revisions.remove(None)
             # FIXME progress bars should support this more nicely.
             self.progress.clear()
@@ -87,7 +89,7 @@
                    " for a complete check use a local branch.")
             return
         
-        self.planned_revisions = set(self.branch.revision_store)
+        self.planned_revisions = set(repository.revision_store)
         inventoried = set(self.inventory_weave.names())
         awol = self.planned_revisions - inventoried
         if len(awol) > 0:
@@ -96,9 +98,9 @@
         self.planned_revisions = list(self.planned_revisions)
 
     def report_results(self, verbose):
-        note('checked branch %s format %d',
+        note('checked branch %s format %s',
              self.branch.base, 
-             self.branch._branch_format)
+             self.branch._format)
 
         note('%6d revisions', self.checked_rev_cnt)
         note('%6d unique file texts', self.checked_text_cnt)
@@ -140,11 +142,11 @@
             rev_history_position = None
         last_rev_id = None
         if rev_history_position:
-            rev = branch.get_revision(rev_id)
+            rev = branch.repository.get_revision(rev_id)
             if rev_history_position > 0:
                 last_rev_id = self.history[rev_history_position - 1]
         else:
-            rev = branch.get_revision(rev_id)
+            rev = branch.repository.get_revision(rev_id)
                 
         if rev.revision_id != rev_id:
             raise BzrCheckError('wrong internal revision id in revision {%s}'
@@ -167,8 +169,8 @@
                     self.missing_parent_links[parent] = missing_links
                     # list based so somewhat slow,
                     # TODO have a planned_revisions list and set.
-                    if self.branch.has_revision(parent):
-                        missing_ancestry = self.branch.get_ancestry(parent)
+                    if self.branch.repository.has_revision(parent):
+                        missing_ancestry = self.repository.get_ancestry(parent)
                         for missing in missing_ancestry:
                             if (missing is not None 
                                 and missing not in self.planned_revisions):
@@ -181,7 +183,7 @@
                                 % (rev_id, last_rev_id))
 
         if rev.inventory_sha1:
-            inv_sha1 = branch.get_inventory_sha1(rev_id)
+            inv_sha1 = branch.repository.get_inventory_sha1(rev_id)
             if inv_sha1 != rev.inventory_sha1:
                 raise BzrCheckError('Inventory sha1 hash doesn\'t match'
                     ' value in revision {%s}' % rev_id)
@@ -196,21 +198,21 @@
         """
         n_weaves = 1
         weave_ids = []
-        if self.branch.weave_store.listable():
-            weave_ids = list(self.branch.weave_store)
+        if self.branch.repository.weave_store.listable():
+            weave_ids = list(self.branch.repository.weave_store)
             n_weaves = len(weave_ids)
         self.progress.update('checking weave', 0, n_weaves)
         self.inventory_weave.check(progress_bar=self.progress)
         for i, weave_id in enumerate(weave_ids):
             self.progress.update('checking weave', i, n_weaves)
-            w = self.branch.weave_store.get_weave(weave_id,
-                    self.branch.get_transaction())
+            w = self.branch.repository.weave_store.get_weave(weave_id,
+                    self.branch.repository.get_transaction())
             # No progress here, because it looks ugly.
             w.check()
             self.checked_weaves[weave_id] = True
 
     def _check_revision_tree(self, rev_id):
-        tree = self.branch.revision_tree(rev_id)
+        tree = self.branch.repository.revision_tree(rev_id)
         inv = tree.inventory
         seen_ids = {}
         for file_id in inv:

=== removed file 'bzrlib/clone.py'
--- bzrlib/clone.py	2006-01-25 14:30:06 +0000
+++ bzrlib/clone.py	1970-01-01 00:00:00 +0000
@@ -1,162 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Make a copy of an entire branch and all its history.
-
-This is the underlying function for the branch/get/clone commands."""
-
-# TODO: This could be done *much* more efficiently by just copying
-# all the whole weaves and revisions, rather than getting one
-# revision at a time.
-
-# TODO: Optionally, after copying, discard any irrelevant information from
-# the destination, such as revisions committed after the last one we're interested 
-# in.  This needs to apply a weave prune operation (not written yet) to each
-# weave one by one.
-
-# Copying must be done in a way that supports http transports, where we
-# can't list a directory, and therefore have to rely on information
-# retrieved from top-level objects whose names we do know.
-#
-# In practice this means we first fetch the revision history and ancestry.
-# These give us a list of all the revisions that need to be fetched.  We 
-# also get the inventory weave.  We then just need to get a list of all 
-# file-ids ever referenced by this tree.  (It might be nice to keep a list
-# of them directly.)  This is done by walking over the inventories of all
-# copied revisions and accumulating a list of file ids.
-#
-# For local branches it is possible to optimize this considerably in two
-# ways.  One is to hardlink the files (if possible and requested), rather
-# than copying them.  Another is to simply list the directory rather than
-# walking through the inventories to find out what files are present -- but
-# there it may be better to just be consistent with remote branches.
-
-import os
-import sys
-
-import bzrlib
-from bzrlib.merge import build_working_dir
-from bzrlib.branch import Branch
-from bzrlib.trace import mutter, note
-from bzrlib.store import copy_all
-from bzrlib.errors import InvalidRevisionId
-
-def copy_branch(branch_from, to_location, revision=None, basis_branch=None):
-    """Copy branch_from into the existing directory to_location.
-
-    Returns the newly created branch object.
-
-    revision
-        If not None, only revisions up to this point will be copied.
-        The head of the new branch will be that revision.  Must be a
-        revid or None.
-
-    to_location -- The destination directory; must either exist and be 
-        empty, or not exist, in which case it is created.
-
-    basis_branch
-        A local branch to copy revisions from, related to branch_from. 
-        This is used when branching from a remote (slow) branch, and we have
-        a local branch that might contain some relevant revisions.
-    """
-    assert isinstance(branch_from, Branch)
-    assert isinstance(to_location, basestring)
-    if basis_branch is not None:
-        note("basis_branch is not supported for fast weave copy yet.")
-    branch_from.lock_read()
-    try:
-        if not (branch_from.weave_store.listable()
-                and branch_from.revision_store.listable()):
-            return copy_branch_slower(branch_from, to_location, revision,
-                                      basis_branch)
-        history = _get_truncated_history(branch_from, revision)
-        if not bzrlib.osutils.lexists(to_location):
-            os.mkdir(to_location)
-        branch_to = Branch.initialize(to_location)
-        mutter("copy branch from %s to %s", branch_from, branch_to)
-        branch_to.working_tree().set_root_id(branch_from.get_root_id())
-        _copy_control_weaves(branch_from, branch_to)
-        _copy_text_weaves(branch_from, branch_to)
-        _copy_revision_store(branch_from, branch_to)
-        branch_to.set_parent(branch_from.base)
-        # must be done *after* history is copied across
-        branch_to.append_revision(*history)
-        build_working_dir(to_location)
-        mutter("copied")
-        return branch_to
-    finally:
-        branch_from.unlock()
-
-
-def _get_truncated_history(branch_from, revision_id):
-    history = branch_from.revision_history()
-    if revision_id is None:
-        return history
-    try:
-        idx = history.index(revision_id)
-    except ValueError:
-        raise InvalidRevisionId(revision_id=revision, branch=branch_from)
-    return history[:idx+1]
-
-def _copy_text_weaves(branch_from, branch_to):
-    copy_all(branch_from.weave_store, branch_to.weave_store)
-
-
-def _copy_revision_store(branch_from, branch_to):
-    copy_all(branch_from.revision_store, branch_to.revision_store)
-
-
-def _copy_control_weaves(branch_from, branch_to):
-    to_control = branch_to.control_weaves
-    from_control = branch_from.control_weaves
-    to_control.copy_multi(from_control, ['inventory'])
-
-    
-def copy_branch_slower(branch_from, to_location, revision=None, basis_branch=None):
-    """Copy branch_from into the existing directory to_location.
-
-    revision
-        If not None, only revisions up to this point will be copied.
-        The head of the new branch will be that revision.  Must be a
-        revid or None.
-
-    to_location -- The destination directory; must either exist and be 
-        empty, or not exist, in which case it is created.
-
-    revno
-        The revision to copy up to
-
-    basis_branch
-        A local branch to copy revisions from, related to branch_from. 
-        This is used when branching from a remote (slow) branch, and we have
-        a local branch that might contain some relevant revisions.
-    """
-    assert isinstance(branch_from, Branch)
-    assert isinstance(to_location, basestring)
-    if not bzrlib.osutils.lexists(to_location):
-        os.mkdir(to_location)
-    br_to = Branch.initialize(to_location)
-    mutter("copy branch from %s to %s", branch_from, br_to)
-    if basis_branch is not None:
-        basis_branch.push_stores(br_to)
-    br_to.working_tree().set_root_id(branch_from.get_root_id())
-    if revision is None:
-        revision = branch_from.last_revision()
-    br_to.update_revisions(branch_from, stop_revision=revision)
-    build_working_dir(to_location)
-    br_to.set_parent(branch_from.base)
-    mutter("copied")
-    return br_to

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2006-01-25 14:30:06 +0000
+++ bzrlib/commands.py	2006-03-20 08:31:00 +0000
@@ -34,16 +34,16 @@
 import errno
 
 import bzrlib
-import bzrlib.trace
-from bzrlib.trace import mutter, note, log_error, warning, be_quiet
 from bzrlib.errors import (BzrError, 
                            BzrCheckError,
                            BzrCommandError,
                            BzrOptionError,
                            NotBranchError)
+from bzrlib.option import Option
 from bzrlib.revisionspec import RevisionSpec
-from bzrlib import BZRDIR
-from bzrlib.option import Option
+from bzrlib.symbol_versioning import *
+import bzrlib.trace
+from bzrlib.trace import mutter, note, log_error, warning, be_quiet
 
 plugin_cmds = {}
 
@@ -168,13 +168,13 @@
         List of argument forms, marked with whether they are optional,
         repeated, etc.
 
-		Examples:
-
-		['to_location', 'from_branch?', 'file*']
-
-		'to_location' is required
-		'from_branch' is optional
-		'file' can be specified 0 or more times
+                Examples:
+
+                ['to_location', 'from_branch?', 'file*']
+
+                'to_location' is required
+                'from_branch' is optional
+                'file' can be specified 0 or more times
 
     takes_options
         List of options that may be given for this command.  These can
@@ -208,9 +208,17 @@
             r[o.name] = o
         return r
 
+    @deprecated_method(zero_eight)
     def run_argv(self, argv):
-        """Parse command line and run."""
-        args, opts = parse_args(self, argv)
+        """Parse command line and run.
+        
+        See run_argv_aliases for the 0.8 and beyond api.
+        """
+        return self.run_argv_aliases(argv)
+
+    def run_argv_aliases(self, argv, alias_argv=None):
+        """Parse the command line and run with extra aliases in alias_argv."""
+        args, opts = parse_args(self, argv, alias_argv)
         if 'help' in opts:  # e.g. bzr add --help
             from bzrlib.help import help_on_command
             help_on_command(self.name())
@@ -219,8 +227,8 @@
         allowed_names = self.options().keys()
         for oname in opts:
             if oname not in allowed_names:
-                raise BzrCommandError("option '--%s' is not allowed for command %r"
-                                      % (oname, self.name()))
+                raise BzrCommandError("option '--%s' is not allowed for"
+                                      " command %r" % (oname, self.name()))
         # mix arguments and options into one dictionary
         cmdargs = _match_argform(self.name(), self.takes_args, args)
         cmdopts = {}
@@ -286,7 +294,7 @@
         parsed = [spec, None]
     return parsed
 
-def parse_args(command, argv):
+def parse_args(command, argv, alias_argv=None):
     """Parse command line.
     
     Arguments and options are parsed at this level before being passed
@@ -297,85 +305,105 @@
     # TODO: chop up this beast; make it a method of the Command
     args = []
     opts = {}
+    alias_opts = {}
 
     cmd_options = command.options()
     argsover = False
-    while argv:
-        a = argv.pop(0)
-        if argsover:
-            args.append(a)
-            continue
-        elif a == '--':
-            # We've received a standalone -- No more flags
-            argsover = True
-            continue
-        if a[0] == '-':
-            # option names must not be unicode
-            a = str(a)
-            optarg = None
-            if a[1] == '-':
-                mutter("  got option %r", a)
-                if '=' in a:
-                    optname, optarg = a[2:].split('=', 1)
-                else:
-                    optname = a[2:]
-                if optname not in cmd_options:
-                    raise BzrOptionError('unknown long option %r for command %s'
-                        % (a, command.name()))
-            else:
-                shortopt = a[1:]
-                if shortopt in Option.SHORT_OPTIONS:
-                    # Multi-character options must have a space to delimit
-                    # their value
-                    # ^^^ what does this mean? mbp 20051014
-                    optname = Option.SHORT_OPTIONS[shortopt].name
-                else:
-                    # Single character short options, can be chained,
-                    # and have their value appended to their name
-                    shortopt = a[1:2]
-                    if shortopt not in Option.SHORT_OPTIONS:
-                        # We didn't find the multi-character name, and we
-                        # didn't find the single char name
-                        raise BzrError('unknown short option %r' % a)
-                    optname = Option.SHORT_OPTIONS[shortopt].name
+    proc_aliasarg = True # Are we processing alias_argv now?
+    for proc_argv in alias_argv, argv:
+        while proc_argv:
+            a = proc_argv.pop(0)
+            if argsover:
+                args.append(a)
+                continue
+            elif a == '--':
+                # We've received a standalone -- No more flags
+                argsover = True
+                continue
+            if a[0] == '-':
+                # option names must not be unicode
+                a = str(a)
+                optarg = None
+                if a[1] == '-':
+                    mutter("  got option %r", a)
+                    if '=' in a:
+                        optname, optarg = a[2:].split('=', 1)
+                    else:
+                        optname = a[2:]
+                    if optname not in cmd_options:
+                        raise BzrOptionError('unknown long option %r for'
+                                             ' command %s' % 
+                                             (a, command.name()))
+                else:
+                    shortopt = a[1:]
+                    if shortopt in Option.SHORT_OPTIONS:
+                        # Multi-character options must have a space to delimit
+                        # their value
+                        # ^^^ what does this mean? mbp 20051014
+                        optname = Option.SHORT_OPTIONS[shortopt].name
+                    else:
+                        # Single character short options, can be chained,
+                        # and have their value appended to their name
+                        shortopt = a[1:2]
+                        if shortopt not in Option.SHORT_OPTIONS:
+                            # We didn't find the multi-character name, and we
+                            # didn't find the single char name
+                            raise BzrError('unknown short option %r' % a)
+                        optname = Option.SHORT_OPTIONS[shortopt].name
 
-                    if a[2:]:
-                        # There are extra things on this option
-                        # see if it is the value, or if it is another
-                        # short option
-                        optargfn = Option.OPTIONS[optname].type
-                        if optargfn is None:
-                            # This option does not take an argument, so the
-                            # next entry is another short option, pack it back
-                            # into the list
-                            argv.insert(0, '-' + a[2:])
+                        if a[2:]:
+                            # There are extra things on this option
+                            # see if it is the value, or if it is another
+                            # short option
+                            optargfn = Option.OPTIONS[optname].type
+                            if optargfn is None:
+                                # This option does not take an argument, so the
+                                # next entry is another short option, pack it
+                                # back into the list
+                                proc_argv.insert(0, '-' + a[2:])
+                            else:
+                                # This option takes an argument, so pack it
+                                # into the array
+                                optarg = a[2:]
+                
+                    if optname not in cmd_options:
+                        raise BzrOptionError('unknown short option %r for'
+                                             ' command %s' % 
+                                             (shortopt, command.name()))
+                if optname in opts:
+                    # XXX: Do we ever want to support this, e.g. for -r?
+                    if proc_aliasarg:
+                        raise BzrError('repeated option %r' % a)
+                    elif optname in alias_opts:
+                        # Replace what's in the alias with what's in the real
+                        # argument
+                        del alias_opts[optname]
+                        del opts[optname]
+                        proc_argv.insert(0, a)
+                        continue
+                    else:
+                        raise BzrError('repeated option %r' % a)
+                    
+                option_obj = cmd_options[optname]
+                optargfn = option_obj.type
+                if optargfn:
+                    if optarg == None:
+                        if not proc_argv:
+                            raise BzrError('option %r needs an argument' % a)
                         else:
-                            # This option takes an argument, so pack it
-                            # into the array
-                            optarg = a[2:]
-            
-                if optname not in cmd_options:
-                    raise BzrOptionError('unknown short option %r for command'
-                        ' %s' % (shortopt, command.name()))
-            if optname in opts:
-                # XXX: Do we ever want to support this, e.g. for -r?
-                raise BzrError('repeated option %r' % a)
-                
-            option_obj = cmd_options[optname]
-            optargfn = option_obj.type
-            if optargfn:
-                if optarg == None:
-                    if not argv:
-                        raise BzrError('option %r needs an argument' % a)
-                    else:
-                        optarg = argv.pop(0)
-                opts[optname] = optargfn(optarg)
+                            optarg = proc_argv.pop(0)
+                    opts[optname] = optargfn(optarg)
+                    if proc_aliasarg:
+                        alias_opts[optname] = optargfn(optarg)
+                else:
+                    if optarg != None:
+                        raise BzrError('option %r takes no argument' % optname)
+                    opts[optname] = True
+                    if proc_aliasarg:
+                        alias_opts[optname] = True
             else:
-                if optarg != None:
-                    raise BzrError('option %r takes no argument' % optname)
-                opts[optname] = True
-        else:
-            args.append(a)
+                args.append(a)
+        proc_aliasarg = False # Done with alias argv
     return args, opts
 
 
@@ -447,13 +475,29 @@
         os.remove(pfname)
 
 
-def apply_lsprofiled(the_callable, *args, **kwargs):
+def apply_lsprofiled(filename, the_callable, *args, **kwargs):
     from bzrlib.lsprof import profile
-    ret,stats = profile(the_callable,*args,**kwargs)
+    import cPickle
+    ret, stats = profile(the_callable, *args, **kwargs)
     stats.sort()
-    stats.pprint()
+    if filename is None:
+        stats.pprint()
+    else:
+        stats.freeze()
+        cPickle.dump(stats, open(filename, 'w'), 2)
+        print 'Profile data written to %r.' % filename
     return ret
 
+
+def get_alias(cmd):
+    """Return an expanded alias, or None if no alias exists"""
+    import bzrlib.config
+    alias = bzrlib.config.GlobalConfig().get_alias(cmd)
+    if (alias):
+        return alias.split(' ')
+    return None
+
+
 def run_bzr(argv):
     """Execute a command.
 
@@ -471,6 +515,9 @@
     --no-plugins
         Do not load plugin modules at all
 
+    --no-aliases
+        Do not allow aliases
+
     --builtin
         Only use builtin commands.  (Plugins are still allowed to change
         other behaviour.)
@@ -483,27 +530,38 @@
     """
     argv = [a.decode(bzrlib.user_encoding) for a in argv]
 
-    opt_lsprof = opt_profile = opt_no_plugins = opt_builtin = False
+    opt_lsprof = opt_profile = opt_no_plugins = opt_builtin =  \
+                opt_no_aliases = False
+    opt_lsprof_file = None
 
     # --no-plugins is handled specially at a very early stage. We need
     # to load plugins before doing other command parsing so that they
     # can override commands, but this needs to happen first.
 
-    for a in argv:
+    argv_copy = []
+    i = 0
+    while i < len(argv):
+        a = argv[i]
         if a == '--profile':
             opt_profile = True
         elif a == '--lsprof':
             opt_lsprof = True
+        elif a == '--lsprof-file':
+            opt_lsprof_file = argv[i + 1]
+            i += 1
         elif a == '--no-plugins':
             opt_no_plugins = True
+        elif a == '--no-aliases':
+            opt_no_aliases = True
         elif a == '--builtin':
             opt_builtin = True
         elif a in ('--quiet', '-q'):
             be_quiet()
         else:
-            continue
-        argv.remove(a)
+            argv_copy.append(a)
+        i += 1
 
+    argv = argv_copy
     if (not argv) or (argv[0] == '--help'):
         from bzrlib.help import help
         if len(argv) > 1:
@@ -520,18 +578,35 @@
     if not opt_no_plugins:
         from bzrlib.plugin import load_plugins
         load_plugins()
+    else:
+        from bzrlib.plugin import disable_plugins
+        disable_plugins()
+
+    alias_argv = None
+
+    if not opt_no_aliases:
+        alias_argv = get_alias(argv[0])
+        if alias_argv:
+            alias_argv = [a.decode(bzrlib.user_encoding) for a in alias_argv]
+            argv[0] = alias_argv.pop(0)
 
     cmd = str(argv.pop(0))
 
     cmd_obj = get_cmd_object(cmd, plugins_override=not opt_builtin)
+    if not getattr(cmd_obj.run_argv, 'is_deprecated', False):
+        run = cmd_obj.run_argv
+        run_argv = [argv]
+    else:
+        run = cmd_obj.run_argv_aliases
+        run_argv = [argv, alias_argv]
 
     try:
         if opt_lsprof:
-            ret = apply_lsprofiled(cmd_obj.run_argv, argv)
+            ret = apply_lsprofiled(opt_lsprof_file, run, *run_argv)
         elif opt_profile:
-            ret = apply_profiled(cmd_obj.run_argv, argv)
+            ret = apply_profiled(run, *run_argv)
         else:
-            ret = cmd_obj.run_argv(argv)
+            ret = run(*run_argv)
         return ret or 0
     finally:
         # reset, in case we may do other commands later within the same process

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2006-01-25 14:30:06 +0000
+++ bzrlib/commit.py	2006-03-20 08:31:00 +0000
@@ -76,25 +76,27 @@
 from bzrlib.osutils import (local_time_offset,
                             rand_bytes, compact_date,
                             kind_marker, is_inside_any, quotefn,
-                            sha_string, sha_strings, sha_file, isdir, isfile,
+                            sha_file, isdir, isfile,
                             split_lines)
 import bzrlib.config
+import bzrlib.errors as errors
 from bzrlib.errors import (BzrError, PointlessCommit,
                            HistoryMissing,
                            ConflictsInTree,
                            StrictCommitFailed
                            )
-import bzrlib.gpg as gpg
 from bzrlib.revision import Revision
 from bzrlib.testament import Testament
 from bzrlib.trace import mutter, note, warning
 from bzrlib.xml5 import serializer_v5
 from bzrlib.inventory import Inventory, ROOT_ID
+from bzrlib.symbol_versioning import *
 from bzrlib.weave import Weave
 from bzrlib.weavefile import read_weave, write_weave_v5
 from bzrlib.workingtree import WorkingTree
 
 
+@deprecated_function(zero_seven)
 def commit(*args, **kwargs):
     """Commit a new revision to a branch.
 
@@ -168,7 +170,7 @@
             self.config = None
         
     def commit(self,
-               branch, message,
+               branch=DEPRECATED_PARAMETER, message=None,
                timestamp=None,
                timezone=None,
                committer=None,
@@ -177,9 +179,16 @@
                allow_pointless=True,
                strict=False,
                verbose=False,
-               revprops=None):
+               revprops=None,
+               working_tree=None,
+               local=False):
         """Commit working copy as a new revision.
 
+        branch -- the deprecated branch to commit to. New callers should pass in 
+                  working_tree instead
+
+        message -- the commit message, a mandatory parameter
+
         timestamp -- if not None, seconds-since-epoch for a
              postdated/predated commit.
 
@@ -198,58 +207,83 @@
             contains unknown files.
 
         revprops -- Properties for new revision
+        :param local: Perform a local only commit.
         """
         mutter('preparing to commit')
 
-        self.branch = branch
-        self.weave_store = branch.weave_store
+        if deprecated_passed(branch):
+            warn("Commit.commit (branch, ...): The branch parameter is "
+                 "deprecated as of bzr 0.8. Please use working_tree= instead.",
+                 DeprecationWarning, stacklevel=2)
+            self.branch = branch
+            self.work_tree = self.branch.bzrdir.open_workingtree()
+        elif working_tree is None:
+            raise BzrError("One of branch and working_tree must be passed into commit().")
+        else:
+            self.work_tree = working_tree
+            self.branch = self.work_tree.branch
+        if message is None:
+            raise BzrError("The message keyword parameter is required for commit().")
+
+        self.weave_store = self.branch.repository.weave_store
+        self.bound_branch = None
+        self.local = local
+        self.master_branch = None
         self.rev_id = rev_id
         self.specific_files = specific_files
         self.allow_pointless = allow_pointless
-        self.revprops = {'branch-nick': branch.nick}
-        if revprops:
+        self.revprops = {}
+        if revprops is not None:
             self.revprops.update(revprops)
-        self.work_tree = WorkingTree(branch.base, branch)
-
-        if strict:
-            # raise an exception as soon as we find a single unknown.
-            for unknown in self.work_tree.unknowns():
-                raise StrictCommitFailed()
-
-        if timestamp is None:
-            self.timestamp = time.time()
-        else:
-            self.timestamp = long(timestamp)
-            
-        if self.config is None:
-            self.config = bzrlib.config.BranchConfig(self.branch)
-
-        if rev_id is None:
-            self.rev_id = _gen_revision_id(self.config, self.timestamp)
-        else:
-            self.rev_id = rev_id
-
-        if committer is None:
-            self.committer = self.config.username()
-        else:
-            assert isinstance(committer, basestring), type(committer)
-            self.committer = committer
-
-        if timezone is None:
-            self.timezone = local_time_offset()
-        else:
-            self.timezone = int(timezone)
-
-        if isinstance(message, str):
-            message = message.decode(bzrlib.user_encoding)
-        assert isinstance(message, unicode), type(message)
-        self.message = message
-        self._escape_commit_message()
-
-        self.branch.lock_write()
+
+        self.work_tree.lock_write()
         try:
+            # setup the bound branch variables as needed.
+            self._check_bound_branch()
+
+            # check for out of date working trees
+            # if we are bound, then self.branch is the master branch and this
+            # test is thus all we need.
+            if self.work_tree.last_revision() != self.master_branch.last_revision():
+                raise errors.OutOfDateTree(self.work_tree)
+    
+            if strict:
+                # raise an exception as soon as we find a single unknown.
+                for unknown in self.work_tree.unknowns():
+                    raise StrictCommitFailed()
+    
+            if timestamp is None:
+                self.timestamp = time.time()
+            else:
+                self.timestamp = long(timestamp)
+                
+            if self.config is None:
+                self.config = bzrlib.config.BranchConfig(self.branch)
+    
+            if rev_id is None:
+                self.rev_id = _gen_revision_id(self.config, self.timestamp)
+            else:
+                self.rev_id = rev_id
+    
+            if committer is None:
+                self.committer = self.config.username()
+            else:
+                assert isinstance(committer, basestring), type(committer)
+                self.committer = committer
+    
+            if timezone is None:
+                self.timezone = local_time_offset()
+            else:
+                self.timezone = int(timezone)
+    
+            if isinstance(message, str):
+                message = message.decode(bzrlib.user_encoding)
+            assert isinstance(message, unicode), type(message)
+            self.message = message
+            self._escape_commit_message()
+
             self.work_inv = self.work_tree.inventory
-            self.basis_tree = self.branch.basis_tree()
+            self.basis_tree = self.work_tree.basis_tree()
             self.basis_inv = self.basis_tree.inventory
 
             self._gather_parents()
@@ -270,10 +304,35 @@
             if len(list(self.work_tree.iter_conflicts()))>0:
                 raise ConflictsInTree
 
-            self._record_inventory()
+            self.inv_sha1 = self.branch.repository.add_inventory(
+                self.rev_id,
+                self.new_inv,
+                self.present_parents
+                )
             self._make_revision()
+            # revision data is in the local branch now.
+            
+            # upload revision data to the master.
+            # this will propogate merged revisions too if needed.
+            if self.bound_branch:
+                self.master_branch.repository.fetch(self.branch.repository,
+                                                    revision_id=self.rev_id)
+                # now the master has the revision data
+                # 'commit' to the master first so a timeout here causes the local
+                # branch to be out of date
+                self.master_branch.append_revision(self.rev_id)
+
+            # and now do the commit locally.
+            self.branch.append_revision(self.rev_id)
+
             self.work_tree.set_pending_merges([])
-            self.branch.append_revision(self.rev_id)
+            if len(self.parents):
+                precursor = self.parents[0]
+            else:
+                precursor = None
+            self.work_tree.set_last_revision(self.rev_id, precursor)
+            # now the work tree is up to date with the branch
+            
             self.reporter.completed(self.branch.revno()+1, self.rev_id)
             if self.config.post_commit() is not None:
                 hooks = self.config.post_commit().split(' ')
@@ -284,16 +343,68 @@
                                    'bzrlib':bzrlib,
                                    'rev_id':self.rev_id})
         finally:
-            self.branch.unlock()
-
-    def _record_inventory(self):
-        """Store the inventory for the new revision."""
-        inv_text = serializer_v5.write_inventory_to_string(self.new_inv)
-        self.inv_sha1 = sha_string(inv_text)
-        s = self.branch.control_weaves
-        s.add_text('inventory', self.rev_id,
-                   split_lines(inv_text), self.present_parents,
-                   self.branch.get_transaction())
+            self._cleanup_bound_branch()
+            self.work_tree.unlock()
+
+    def _check_bound_branch(self):
+        """Check to see if the local branch is bound.
+
+        If it is bound, then most of the commit will actually be
+        done using the remote branch as the target branch.
+        Only at the end will the local branch be updated.
+        """
+        if self.local and not self.branch.get_bound_location():
+            raise errors.LocalRequiresBoundBranch()
+
+        if not self.local:
+            self.master_branch = self.branch.get_master_branch()
+
+        if not self.master_branch:
+            # make this branch the reference branch for out of date checks.
+            self.master_branch = self.branch
+            return
+
+        # If the master branch is bound, we must fail
+        master_bound_location = self.master_branch.get_bound_location()
+        if master_bound_location:
+            raise errors.CommitToDoubleBoundBranch(self.branch,
+                    self.master_branch, master_bound_location)
+
+        # TODO: jam 20051230 We could automatically push local
+        #       commits to the remote branch if they would fit.
+        #       But for now, just require remote to be identical
+        #       to local.
+        
+        # Make sure the local branch is identical to the master
+        master_rh = self.master_branch.revision_history()
+        local_rh = self.branch.revision_history()
+        if local_rh != master_rh:
+            raise errors.BoundBranchOutOfDate(self.branch,
+                    self.master_branch)
+
+        # Now things are ready to change the master branch
+        # so grab the lock
+        self.bound_branch = self.branch
+        self.master_branch.lock_write()
+####        
+####        # Check to see if we have any pending merges. If we do
+####        # those need to be pushed into the master branch
+####        pending_merges = self.work_tree.pending_merges()
+####        if pending_merges:
+####            for revision_id in pending_merges:
+####                self.master_branch.repository.fetch(self.bound_branch.repository,
+####                                                    revision_id=revision_id)
+
+    def _cleanup_bound_branch(self):
+        """Executed at the end of a try/finally to cleanup a bound branch.
+
+        If the branch wasn't bound, this is a no-op.
+        If it was, it resents self.branch to the local branch, instead
+        of being the master.
+        """
+        if not self.bound_branch:
+            return
+        self.master_branch.unlock()
 
     def _escape_commit_message(self):
         """Replace xml-incompatible control characters."""
@@ -319,14 +430,15 @@
             self.parents.append(precursor_id)
         self.parents += pending_merges
         for revision in self.parents:
-            if self.branch.has_revision(revision):
-                self.parent_invs.append(self.branch.get_inventory(revision))
+            if self.branch.repository.has_revision(revision):
+                inventory = self.branch.repository.get_inventory(revision)
+                self.parent_invs.append(inventory)
                 self.present_parents.append(revision)
 
     def _check_parents_present(self):
         for parent_id in self.parents:
             mutter('commit parent revision {%s}', parent_id)
-            if not self.branch.has_revision(parent_id):
+            if not self.branch.repository.has_revision(parent_id):
                 if parent_id == self.branch.last_revision():
                     warning("parent is missing %r", parent_id)
                     raise HistoryMissing(self.branch, 'revision', parent_id)
@@ -335,23 +447,15 @@
             
     def _make_revision(self):
         """Record a new revision object for this commit."""
-        self.rev = Revision(timestamp=self.timestamp,
-                            timezone=self.timezone,
-                            committer=self.committer,
-                            message=self.message,
-                            inventory_sha1=self.inv_sha1,
-                            revision_id=self.rev_id,
-                            properties=self.revprops)
-        self.rev.parent_ids = self.parents
-        rev_tmp = StringIO()
-        serializer_v5.write_revision(self.rev, rev_tmp)
-        rev_tmp.seek(0)
-        if self.config.signature_needed():
-            plaintext = Testament(self.rev, self.new_inv).as_short_text()
-            self.branch.store_revision_signature(gpg.GPGStrategy(self.config),
-                                                 plaintext, self.rev_id)
-        self.branch.revision_store.add(rev_tmp, self.rev_id)
-        mutter('new revision_id is {%s}', self.rev_id)
+        rev = Revision(timestamp=self.timestamp,
+                       timezone=self.timezone,
+                       committer=self.committer,
+                       message=self.message,
+                       inventory_sha1=self.inv_sha1,
+                       revision_id=self.rev_id,
+                       properties=self.revprops)
+        rev.parent_ids = self.parents
+        self.branch.repository.add_revision(self.rev_id, rev, self.new_inv, self.config)
 
     def _remove_deleted(self):
         """Remove deleted files from the working inventories.

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2006-01-25 14:30:06 +0000
+++ bzrlib/config.py	2006-03-20 08:31:00 +0000
@@ -27,6 +27,7 @@
 check_signatures=require|ignore|check-available(default)
 create_signatures=always|never|when-required(default)
 gpg_signing_command=name-of-program
+log_format=name-of-format
 
 in branches.conf, you specify the url of a branch and options for it.
 Wildcards may be used - * and ? as normal in shell completion. Options
@@ -49,6 +50,16 @@
                     gpg signatures, never create them, or create them if the
                     branch is configured to require them.
                     NB: This option is planned, but not implemented yet.
+log_format - This options set the default log format.  Options are long, 
+             short, line, or a plugin can register new formats
+
+In bazaar.conf you can also define aliases in the ALIASES sections, example
+
+[ALIASES]
+lastlog=log --line -r-10..-1
+ll=log --line -r-10..-1
+h=help
+up=pull
 """
 
 
@@ -73,13 +84,7 @@
 class ConfigObj(configobj.ConfigObj):
 
     def get_bool(self, section, key):
-        val = self[section][key].lower()
-        if val in ('1', 'yes', 'true', 'on'):
-            return True
-        elif val in ('0', 'no', 'false', 'off'):
-            return False
-        else:
-            raise ValueError("Value %r is not boolean" % val)
+        return self[section].as_bool(key)
 
     def get_value(self, section, name):
         # Try [] for the old DEFAULT section.
@@ -120,6 +125,17 @@
         """See gpg_signing_command()."""
         return None
 
+    def log_format(self):
+        """What log format should be used"""
+        result = self._log_format()
+        if result is None:
+            result = "long"
+        return result
+
+    def _log_format(self):
+        """See log_format()."""
+        return None
+
     def __init__(self):
         super(Config, self).__init__()
 
@@ -183,6 +199,12 @@
             return True
         return False
 
+    def get_alias(self, value):
+        return self._get_alias(value)
+
+    def _get_alias(self, value):
+        pass
+
 
 class IniBasedConfig(Config):
     """A configuration policy that draws from ini files."""
@@ -226,6 +248,10 @@
         """See Config.gpg_signing_command."""
         return self._get_user_option('gpg_signing_command')
 
+    def _log_format(self):
+        """See Config.log_format."""
+        return self._get_user_option('log_format')
+
     def __init__(self, get_filename):
         super(IniBasedConfig, self).__init__()
         self._get_filename = get_filename
@@ -246,6 +272,13 @@
         raise errors.BzrError("Invalid signatures policy '%s'"
                               % signature_string)
 
+    def _get_alias(self, value):
+        try:
+            return self._get_parser().get_value("ALIASES", 
+                                                value)
+        except KeyError:
+            pass
+
 
 class GlobalConfig(IniBasedConfig):
     """The configuration that should be used for a specific location."""
@@ -318,6 +351,13 @@
             return command
         return self._get_global_config()._gpg_signing_command()
 
+    def _log_format(self):
+        """See Config.log_format."""
+        command = super(LocationConfig, self)._log_format()
+        if command is not None:
+            return command
+        return self._get_global_config()._log_format()
+
     def _get_user_id(self):
         user_id = super(LocationConfig, self)._get_user_id()
         if user_id is not None:
@@ -379,7 +419,7 @@
         This is looked up in the email controlfile for the branch.
         """
         try:
-            return (self.branch.controlfile("email", "r") 
+            return (self.branch.control_files.get_utf8("email") 
                     .read()
                     .decode(bzrlib.user_encoding)
                     .rstrip("\r\n"))
@@ -409,6 +449,10 @@
         """See Config.post_commit."""
         return self._get_location_config()._post_commit()
 
+    def _log_format(self):
+        """See Config.log_format."""
+        return self._get_location_config()._log_format()
+
 
 def ensure_config_dir_exists(path=None):
     """Make sure a configuration directory exists.
@@ -520,11 +564,10 @@
 
     def _get_config(self):
         try:
-            obj = ConfigObj(self.branch.controlfile('branch.conf',
-                                                    'rb').readlines())
-            obj.decode('UTF-8')
+            obj = ConfigObj(self.branch.control_files.get('branch.conf'), 
+                            encoding='utf-8')
         except errors.NoSuchFile:
-            obj = ConfigObj()
+            obj = ConfigObj(encoding='utf=8')
         return obj
 
     def get_option(self, name, section=None, default=None):
@@ -555,9 +598,9 @@
                     cfg_obj[section] = {}
                     obj = cfg_obj[section]
             obj[name] = value
-            cfg_obj.encode('UTF-8')
-            out_file = StringIO(''.join([l+'\n' for l in cfg_obj.write()]))
+            out_file = StringIO()
+            cfg_obj.write(out_file)
             out_file.seek(0)
-            self.branch.put_controlfile('branch.conf', out_file, encode=False)
+            self.branch.control_files.put('branch.conf', out_file)
         finally:
             self.branch.unlock()

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2006-01-25 14:30:06 +0000
+++ bzrlib/conflicts.py	2006-03-20 08:31:00 +0000
@@ -26,10 +26,9 @@
 import errno
 
 import bzrlib.status
-from bzrlib.branch import Branch
 from bzrlib.errors import BzrCommandError, NotConflicted
 from bzrlib.commands import register_command
-from bzrlib.workingtree import CONFLICT_SUFFIXES
+from bzrlib.workingtree import CONFLICT_SUFFIXES, WorkingTree
 from bzrlib.osutils import rename
 
 class cmd_conflicts(bzrlib.commands.Command):
@@ -38,7 +37,7 @@
     files.)
     """
     def run(self):
-        for path in Branch.open_containing(u'.')[0].working_tree().iter_conflicts():
+        for path in WorkingTree.open_containing(u'.')[0].iter_conflicts():
             print path
 
 class cmd_resolve(bzrlib.commands.Command):
@@ -52,7 +51,7 @@
             if not all:
                 raise BzrCommandError(
                     "command 'resolve' needs one or more FILE, or --all")
-            tree = Branch.open_containing(u'.')[0].working_tree()
+            tree = WorkingTree.open_containing(u'.')[0]
             file_list = list(tree.abspath(f) for f in tree.iter_conflicts())
         else:
             if all:

=== added file 'bzrlib/decorators.py'
--- bzrlib/decorators.py	1970-01-01 00:00:00 +0000
+++ bzrlib/decorators.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,57 @@
+# Copyright (C) 2005 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+__all__ = ['needs_read_lock',
+           'needs_write_lock',
+           ]
+
+def needs_read_lock(unbound):
+    """Decorate unbound to take out and release a read lock.
+
+    This decorator can be applied to methods of any class with lock_read() and
+    unlock() methods.
+    
+    Typical usage:
+        
+    class Branch(...):
+        @needs_read_lock
+        def branch_method(self, ...):
+            stuff
+    """
+    def read_locked(self, *args, **kwargs):
+        self.lock_read()
+        try:
+            return unbound(self, *args, **kwargs)
+        finally:
+            self.unlock()
+    read_locked.__doc__ = unbound.__doc__
+    read_locked.__name__ = unbound.__name__
+    return read_locked
+
+
+def needs_write_lock(unbound):
+    """Decorate unbound to take out and release a write lock."""
+    def write_locked(self, *args, **kwargs):
+        self.lock_write()
+        try:
+            return unbound(self, *args, **kwargs)
+        finally:
+            self.unlock()
+    write_locked.__doc__ = unbound.__doc__
+    write_locked.__name__ = unbound.__name__
+    return write_locked
+

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2006-01-25 14:30:06 +0000
+++ bzrlib/diff.py	2006-03-20 08:31:00 +0000
@@ -14,9 +14,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from bzrlib.delta import compare_trees
+from bzrlib.errors import BzrError
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter
-from bzrlib.errors import BzrError
-from bzrlib.delta import compare_trees
 
 # TODO: Rather than building a changeset object, we should probably
 # invoke callbacks on an object.  That object can either accumulate a
@@ -141,10 +142,14 @@
         oldtmpf.close()                 # and delete
         newtmpf.close()
 
+
+@deprecated_function(zero_eight)
 def show_diff(b, from_spec, specific_files, external_diff_options=None,
               revision2=None, output=None, b2=None):
     """Shortcut for showing the diff to the working tree.
 
+    Please use show_diff_trees instead.
+
     b
         Branch.
 
@@ -159,25 +164,66 @@
         output = sys.stdout
 
     if from_spec is None:
+        old_tree = b.bzrdir.open_workingtree()
         if b2 is None:
-            old_tree = b.basis_tree()
-        else:
-            old_tree = b.working_tree()
+            old_tree = old_tree = old_tree.basis_tree()
     else:
-        old_tree = b.revision_tree(from_spec.in_history(b).rev_id)
+        old_tree = b.repository.revision_tree(from_spec.in_history(b).rev_id)
 
     if revision2 is None:
         if b2 is None:
-            new_tree = b.working_tree()
+            new_tree = b.bzrdir.open_workingtree()
         else:
-            new_tree = b2.working_tree()
+            new_tree = b2.bzrdir.open_workingtree()
     else:
-        new_tree = b.revision_tree(revision2.in_history(b).rev_id)
+        new_tree = b.repository.revision_tree(revision2.in_history(b).rev_id)
 
     return show_diff_trees(old_tree, new_tree, output, specific_files,
                            external_diff_options)
 
 
+def diff_cmd_helper(tree, specific_files, external_diff_options, 
+                    old_revision_spec=None, new_revision_spec=None):
+    """Helper for cmd_diff.
+
+   tree 
+        A WorkingTree
+
+    specific_files
+        The specific files to compare, or None
+
+    external_diff_options
+        If non-None, run an external diff, and pass it these options
+
+    old_revision_spec
+        If None, use basis tree as old revision, otherwise use the tree for
+        the specified revision. 
+
+    new_revision_spec
+        If None, use working tree as new revision, otherwise use the tree for
+        the specified revision.
+    
+    The more general form is show_diff_trees(), where the caller
+    supplies any two trees.
+    """
+    import sys
+    output = sys.stdout
+    def spec_tree(spec):
+        revision_id = spec.in_store(tree.branch).rev_id
+        return tree.branch.repository.revision_tree(revision_id)
+    if old_revision_spec is None:
+        old_tree = tree.basis_tree()
+    else:
+        old_tree = spec_tree(old_revision_spec)
+
+    if new_revision_spec is None:
+        new_tree = tree
+    else:
+        new_tree = spec_tree(new_revision_spec)
+
+    return show_diff_trees(old_tree, new_tree, sys.stdout, specific_files,
+                           external_diff_options)
+
 
 def show_diff_trees(old_tree, new_tree, to_file, specific_files=None,
                     external_diff_options=None):
@@ -205,9 +251,10 @@
 def _show_diff_trees(old_tree, new_tree, to_file,
                      specific_files, external_diff_options):
 
-    # TODO: Options to control putting on a prefix or suffix, perhaps as a format string
-    old_label = ''
-    new_label = ''
+    # TODO: Options to control putting on a prefix or suffix, perhaps
+    # as a format string?
+    old_label = 'a/'
+    new_label = 'b/'
 
     DEVNULL = '/dev/null'
     # Windows users, don't panic about this filename -- it is a
@@ -232,12 +279,12 @@
     has_changes = 0
     for path, file_id, kind in delta.removed:
         has_changes = 1
-        print >>to_file, '=== removed %s %r' % (kind, path)
+        print >>to_file, '=== removed %s %r' % (kind, old_label + path)
         old_tree.inventory[file_id].diff(diff_file, old_label + path, old_tree,
                                          DEVNULL, None, None, to_file)
     for path, file_id, kind in delta.added:
         has_changes = 1
-        print >>to_file, '=== added %s %r' % (kind, path)
+        print >>to_file, '=== added %s %r' % (kind, new_label + path)
         new_tree.inventory[file_id].diff(diff_file, new_label + path, new_tree,
                                          DEVNULL, None, None, to_file, 
                                          reverse=True)
@@ -246,14 +293,15 @@
         has_changes = 1
         prop_str = get_prop_change(meta_modified)
         print >>to_file, '=== renamed %s %r => %r%s' % (
-                          kind, old_path, new_path, prop_str)
+                    kind, old_label + old_path, new_label + new_path, prop_str)
         _maybe_diff_file_or_symlink(old_label, old_path, old_tree, file_id,
                                     new_label, new_path, new_tree,
                                     text_modified, kind, to_file, diff_file)
     for path, file_id, kind, text_modified, meta_modified in delta.modified:
         has_changes = 1
         prop_str = get_prop_change(meta_modified)
-        print >>to_file, '=== modified %s %r%s' % (kind, path, prop_str)
+        print >>to_file, '=== modified %s %r%s' % (kind, old_label + path,
+                    prop_str)
         if text_modified:
             _maybe_diff_file_or_symlink(old_label, path, old_tree, file_id,
                                         new_label, path, new_tree,

=== added directory 'bzrlib/doc'
=== added file 'bzrlib/doc/__init__.py'
--- bzrlib/doc/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,26 @@
+# (C) 2005 Canonical Development Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Documentation for bzrlib.
+
+See bzrlib.doc.api for api documentation and in the future bzrlib.doc.man
+for man page generation.
+"""
+
+    
+def test_suite():
+    import bzrlib.doc.api
+    return bzrlib.doc.api.test_suite()

=== added directory 'bzrlib/doc/api'
=== added file 'bzrlib/doc/api/__init__.py'
--- bzrlib/doc/api/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc/api/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,34 @@
+# (C) 2005 Canonical Development Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""API Documentation for bzrlib.
+
+This documentation is made up of doctest testable examples.
+
+Look for bzrlib/doc/api/*.txt to read it.
+
+This documentation documents the current best practice in using the library.
+For details on specific apis, see pydoc on the api, or read the source.
+"""
+
+import doctest
+import os
+    
+def test_suite():
+    candidates = os.listdir(os.path.dirname(__file__))
+    scripts = [candidate for candidate in candidates 
+               if candidate.endswith('.txt')]
+    return doctest.DocFileSuite(*scripts)

=== added file 'bzrlib/doc/api/branch.txt'
--- bzrlib/doc/api/branch.txt	1970-01-01 00:00:00 +0000
+++ bzrlib/doc/api/branch.txt	2006-03-20 08:31:00 +0000
@@ -0,0 +1,29 @@
+The Branch API in bzrlib provides creation and management of Branches.
+
+A Branch represents a series of commits and merges carried out by a user.
+
+Branches are created by BzrDir's:
+
+   >>> from bzrlib.bzrdir import ScratchDir
+   >>> from bzrlib.branch import Branch
+   >>> dir = ScratchDir()
+   >>> new_branch = dir.create_branch()
+
+
+Existing Branches can be opened directly:
+
+   >>> another_instance = Branch.open(dir.transport.clone('..').base)
+
+or via the BzrDir:
+
+   >>> still_the_same_branch = dir.open_branch()
+
+
+A branch has a history of revisions on it:
+
+   >>> new_branch.revision_history()
+   []
+
+
+We need to write some more documentation, showing
+push and pull operations. Cloning might also be nice.

=== added file 'bzrlib/doc/api/transport.txt'
--- bzrlib/doc/api/transport.txt	1970-01-01 00:00:00 +0000
+++ bzrlib/doc/api/transport.txt	2006-03-20 08:31:00 +0000
@@ -0,0 +1,18 @@
+The Transport API in bzrlib provides URL based access to network resources.
+
+   >>> import os
+   >>> import bzrlib.transport as transport
+   >>> root = transport.get_transport("file:///")
+   >>>
+
+Each Transport instance represents a single logical directory.
+
+   >>> dir = transport.get_transport(".")
+   >>> dir.base == os.getcwdu() + '/'
+   True
+
+You can change directories via the clone method:
+
+   >>> parent = dir.clone('..')
+   >>> parent.base == os.path.dirname(os.getcwdu()) + '/'
+   True

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2006-01-25 14:30:06 +0000
+++ bzrlib/errors.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# (C) 2005 Canonical
+# Copyright (C) 2005, 2006 Canonical
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -105,6 +105,7 @@
 
 class BzrCheckError(BzrNewError):
     """Internal check failed: %(message)s"""
+
     def __init__(self, message):
         BzrNewError.__init__(self)
         self.message = message
@@ -140,6 +141,14 @@
         self.base = base
 
 
+class NotLocalUrl(BzrNewError):
+    """%s(url) is not a local path."""
+    
+    def __init__(self, url):
+        BzrNewError.__init__(self)
+        self.url = url
+
+
 class BzrCommandError(BzrError):
     # Error from malformed user command
     # This is being misused as a generic exception
@@ -180,6 +189,10 @@
     """File exists: %(path)r%(extra)s"""
 
 
+class DirectoryNotEmpty(PathError):
+    """Directory not empty: %(path)r%(extra)s"""
+
+
 class PermissionDenied(PathError):
     """Permission denied: %(path)r%(extra)s"""
 
@@ -203,8 +216,16 @@
         self.path = path
 
 
+class NoRepositoryPresent(BzrNewError):
+    """Not repository present: %(path)r"""
+    def __init__(self, bzrdir):
+        BzrNewError.__init__(self)
+        self.path = bzrdir.transport.clone('..').base
+
+
 class FileInWrongBranch(BzrNewError):
     """File %(path)s in not in branch %(branch_base)s."""
+
     def __init__(self, branch, path):
         BzrNewError.__init__(self)
         self.branch = branch
@@ -213,11 +234,26 @@
 
 
 class UnsupportedFormatError(BzrError):
-    """Specified path is a bzr branch that we cannot read."""
+    """Specified path is a bzr branch that we recognize but cannot read."""
     def __str__(self):
         return 'unsupported branch format: %s' % self.args[0]
 
 
+class UnknownFormatError(BzrError):
+    """Specified path is a bzr branch whose format we do not recognize."""
+    def __str__(self):
+        return 'unknown branch format: %s' % self.args[0]
+
+
+class IncompatibleFormat(BzrNewError):
+    """Format %(format)s is not compatible with .bzr version %(bzrdir)s."""
+
+    def __init__(self, format, bzrdir_format):
+        BzrNewError.__init__(self)
+        self.format = format
+        self.bzrdir = bzrdir_format
+
+
 class NotVersionedError(BzrNewError):
     """%(path)s is not versioned"""
     def __init__(self, path):
@@ -235,31 +271,104 @@
     """Cannot operate on a file because it is a control file."""
 
 
-class LockError(Exception):
-    """Lock error"""
+class LockError(BzrNewError):
+    """Lock error: %(message)s"""
     # All exceptions from the lock/unlock functions should be from
     # this exception class.  They will be translated as necessary. The
     # original exception is available as e.original_error
+    #
+    # New code should prefer to raise specific subclasses
+    def __init__(self, message):
+        self.message = message
 
 
 class CommitNotPossible(LockError):
     """A commit was attempted but we do not have a write lock open."""
+    def __init__(self):
+        pass
 
 
 class AlreadyCommitted(LockError):
     """A rollback was requested, but is not able to be accomplished."""
+    def __init__(self):
+        pass
 
 
 class ReadOnlyError(LockError):
-    """A write attempt was made in a read only transaction."""
+    """A write attempt was made in a read only transaction on %(obj)s"""
+    def __init__(self, obj):
+        self.obj = obj
+
+
+class ObjectNotLocked(LockError):
+    """%(obj)r is not locked"""
+    # this can indicate that any particular object is not locked; see also
+    # LockNotHeld which means that a particular *lock* object is not held by
+    # the caller -- perhaps they should be unified.
+    def __init__(self, obj):
+        self.obj = obj
+
+
+class ReadOnlyObjectDirtiedError(ReadOnlyError):
+    """Cannot change object %(obj)r in read only transaction"""
+    def __init__(self, obj):
+        self.obj = obj
+
+
+class UnlockableTransport(LockError):
+    """Cannot lock: transport is read only: %(transport)s"""
+    def __init__(self, transport):
+        self.transport = transport
+
+
+class LockContention(LockError):
+    """Could not acquire lock %(lock)s"""
+    # TODO: show full url for lock, combining the transport and relative bits?
+    def __init__(self, lock):
+        self.lock = lock
+
+
+class LockBroken(LockError):
+    """Lock was broken while still open: %(lock)s - check storage consistency!"""
+    def __init__(self, lock):
+        self.lock = lock
+
+
+class LockBreakMismatch(LockError):
+    """Lock was released and re-acquired before being broken: %(lock)s: held by %(holder)r, wanted to break %(target)r"""
+    def __init__(self, lock, holder, target):
+        self.lock = lock
+        self.holder = holder
+        self.target = target
+
+
+class LockNotHeld(LockError):
+    """Lock not held: %(lock)s"""
+    def __init__(self, lock):
+        self.lock = lock
 
 
 class PointlessCommit(BzrNewError):
     """No changes to commit"""
 
+
+class UpgradeReadonly(BzrNewError):
+    """Upgrade URL cannot work with readonly URL's."""
+
+
+class UpToDateFormat(BzrNewError):
+    """The branch format %(format)s is already at the most recent format."""
+
+    def __init__(self, format):
+        BzrNewError.__init__(self)
+        self.format = format
+
+
+
 class StrictCommitFailed(Exception):
     """Commit refused because there are unknowns in the tree."""
 
+
 class NoSuchRevision(BzrError):
     def __init__(self, branch, revision):
         self.branch = branch
@@ -289,18 +398,22 @@
             " specified."
         BzrCommandError.__init__(self, msg)
 
+
 class NoCommonAncestor(BzrError):
     def __init__(self, revision_a, revision_b):
         msg = "Revisions have no common ancestor: %s %s." \
             % (revision_a, revision_b) 
         BzrError.__init__(self, msg)
 
+
 class NoCommonRoot(BzrError):
     def __init__(self, revision_a, revision_b):
         msg = "Revisions are not derived from the same root: %s %s." \
             % (revision_a, revision_b) 
         BzrError.__init__(self, msg)
 
+
+
 class NotAncestor(BzrError):
     def __init__(self, rev_id, not_ancestor_id):
         msg = "Revision %s is not an ancestor of %s" % (not_ancestor_id, 
@@ -324,20 +437,57 @@
         BzrError.__init__(self, msg)
         self.bases = bases
 
+
 class NoCommits(BzrError):
     def __init__(self, branch):
         msg = "Branch %s has no commits." % branch
         BzrError.__init__(self, msg)
 
+
 class UnlistableStore(BzrError):
     def __init__(self, store):
         BzrError.__init__(self, "Store %s is not listable" % store)
 
+
+
 class UnlistableBranch(BzrError):
     def __init__(self, br):
         BzrError.__init__(self, "Stores for branch %s are not listable" % br)
 
 
+class BoundBranchOutOfDate(BzrNewError):
+    """Bound branch %(branch)s is out of date with master branch %(master)s."""
+    def __init__(self, branch, master):
+        BzrNewError.__init__(self)
+        self.branch = branch
+        self.master = master
+
+        
+class CommitToDoubleBoundBranch(BzrNewError):
+    """Cannot commit to branch %(branch)s. It is bound to %(master)s, which is bound to %(remote)s."""
+    def __init__(self, branch, master, remote):
+        BzrNewError.__init__(self)
+        self.branch = branch
+        self.master = master
+        self.remote = remote
+
+
+class OverwriteBoundBranch(BzrNewError):
+    """Cannot pull --overwrite to a branch which is bound %(branch)s"""
+    def __init__(self, branch):
+        BzrNewError.__init__(self)
+        self.branch = branch
+
+
+class BoundBranchConnectionFailure(BzrNewError):
+    """Unable to connect to target of bound branch %(branch)s => %(target)s: %(error)s"""
+    def __init__(self, branch, target, error):
+        BzrNewError.__init__(self)
+        self.branch = branch
+        self.target = target
+        self.error = error
+
+
 class WeaveError(BzrNewError):
     """Error in processing weave: %(message)s"""
     def __init__(self, message=None):
@@ -376,6 +526,26 @@
     """Text did not match it's checksum: %(message)s"""
 
 
+class WeaveTextDiffers(WeaveError):
+    """Weaves differ on text content. Revision: {%(revision_id)s}, %(weave_a)s, %(weave_b)s"""
+
+    def __init__(self, revision_id, weave_a, weave_b):
+        WeaveError.__init__(self)
+        self.revision_id = revision_id
+        self.weave_a = weave_a
+        self.weave_b = weave_b
+
+
+class WeaveTextDiffers(WeaveError):
+    """Weaves differ on text content. Revision: {%(revision_id)s}, %(weave_a)s, %(weave_b)s"""
+
+    def __init__(self, revision_id, weave_a, weave_b):
+        WeaveError.__init__(self)
+        self.revision_id = revision_id
+        self.weave_a = weave_a
+        self.weave_b = weave_b
+
+
 class NoSuchExportFormat(BzrNewError):
     """Export format %(format)r not supported"""
     def __init__(self, format):
@@ -394,6 +564,7 @@
         self.msg = msg
         self.orig_error = orig_error
 
+
 # A set of semi-meaningful errors which can be thrown
 class TransportNotPossible(TransportError):
     """This is for transports where a specific function is explicitly not
@@ -415,10 +586,12 @@
     """The connection has been closed."""
     pass
 
+
 class ConflictsInTree(BzrError):
     def __init__(self):
         BzrError.__init__(self, "Working tree has conflicts.")
 
+
 class ParseConfigError(BzrError):
     def __init__(self, errors, filename):
         if filename is None:
@@ -427,21 +600,25 @@
             (filename, ('\n'.join(e.message for e in errors)))
         BzrError.__init__(self, message)
 
+
 class SigningFailed(BzrError):
     def __init__(self, command_line):
         BzrError.__init__(self, "Failed to gpg sign data with command '%s'"
                                % command_line)
 
+
 class WorkingTreeNotRevision(BzrError):
     def __init__(self, tree):
         BzrError.__init__(self, "The working tree for %s has changed since"
                           " last commit, but weave merge requires that it be"
                           " unchanged." % tree.basedir)
 
+
 class CantReprocessAndShowBase(BzrNewError):
     """Can't reprocess and show base.
 Reprocessing obscures relationship of conflicting lines to base."""
 
+
 class GraphCycleError(BzrNewError):
     """Cycle in graph %(graph)r"""
     def __init__(self, graph):
@@ -463,6 +640,7 @@
     This should never escape bzr, so does not need to be printable.
     """
 
+
 class MissingText(BzrNewError):
     """Branch %(base)s is missing revision %(text_revision)s of %(file_id)s"""
 
@@ -474,9 +652,115 @@
         self.file_id = file_id
 
 
+class DuplicateKey(BzrNewError):
+    """Key %(key)s is already present in map"""
+
+
+class MalformedTransform(BzrNewError):
+    """Tree transform is malformed %(conflicts)r"""
+
+
 class BzrBadParameter(BzrNewError):
-    """Parameter %(param)s is neither unicode nor utf8."""
+    """A bad parameter : %(param)s is not usable.
     
+    This exception should never be thrown, but it is a base class for all
+    parameter-to-function errors.
+    """
     def __init__(self, param):
         BzrNewError.__init__(self)
         self.param = param
+
+
+class BzrBadParameterNotUnicode(BzrBadParameter):
+    """Parameter %(param)s is neither unicode nor utf8."""
+
+
+class ReusingTransform(BzrNewError):
+    """Attempt to reuse a transform that has already been applied."""
+
+
+class CantMoveRoot(BzrNewError):
+    """Moving the root directory is not supported at this time"""
+
+
+class BzrBadParameterNotString(BzrBadParameter):
+    """Parameter %(param)s is not a string or unicode string."""
+
+
+class BzrBadParameterMissing(BzrBadParameter):
+    """Parameter $(param)s is required but not present."""
+
+
+class DependencyNotPresent(BzrNewError):
+    """Unable to import library: %(library)s, %(error)s"""
+
+    def __init__(self, library, error):
+        BzrNewError.__init__(self, library=library, error=error)
+
+
+class ParamikoNotPresent(DependencyNotPresent):
+    """Unable to import paramiko (required for sftp support): %(error)s"""
+
+    def __init__(self, error):
+        DependencyNotPresent.__init__(self, 'paramiko', error)
+
+
+class UninitializableFormat(BzrNewError):
+    """Format %(format)s cannot be initialised by this version of bzr."""
+
+    def __init__(self, format):
+        BzrNewError.__init__(self)
+        self.format = format
+
+
+class NoDiff3(BzrNewError):
+    """Diff3 is not installed on this machine."""
+
+
+class ExistingLimbo(BzrNewError):
+    """This tree contains left-over files from a failed operation.
+    Please examine %(limbo_dir)s to see if it contains any files you wish to
+    keep, and delete it when you are done.
+    """
+    def __init__(self, limbo_dir):
+       BzrNewError.__init__(self)
+       self.limbo_dir = limbo_dir
+
+
+class ImmortalLimbo(BzrNewError):
+    """Unable to delete transform temporary directory $(limbo_dir)s.
+    Please examine %(limbo_dir)s to see if it contains any files you wish to
+    keep, and delete it when you are done.
+    """
+    def __init__(self, limbo_dir):
+       BzrNewError.__init__(self)
+       self.limbo_dir = limbo_dir
+
+
+class OutOfDateTree(BzrNewError):
+    """Working tree is out of date, please run 'bzr update'."""
+
+    def __init__(self, tree):
+        BzrNewError.__init__(self)
+        self.tree = tree
+
+
+class CorruptRepository(BzrNewError):
+    """An error has been detected in the repository %(repo_path)s.
+Please run bzr reconcile on this repository."""
+
+    def __init__(self, repo):
+        BzrNewError.__init__(self)
+        self.repo_path = repo.bzrdir.root_transport.base
+
+
+class UpgradeRequired(BzrNewError):
+    """To use this feature you must upgrade your branch at %(path)s."""
+
+    def __init__(self, path):
+        BzrNewError.__init__(self)
+        self.path = path
+
+
+class LocalRequiresBoundBranch(BzrNewError):
+    """Cannot perform local-only commits on unbound branches."""

=== modified file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2006-01-25 14:30:06 +0000
+++ bzrlib/externalcommand.py	2006-03-20 08:31:00 +0000
@@ -56,7 +56,7 @@
     def run(self, *args, **kwargs):
         raise NotImplementedError('should not be called on %r' % self)
 
-    def run_argv(self, argv):
+    def run_argv(self, argv, alias_argv=None):
         return os.spawnv(os.P_WAIT, self.path, [self.path] + argv)
 
     def help(self):

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2006-01-25 14:30:06 +0000
+++ bzrlib/fetch.py	2006-03-20 08:31:00 +0000
@@ -14,19 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from copy import copy
-import os
-from cStringIO import StringIO
-
-import bzrlib
-import bzrlib.errors as errors
-from bzrlib.errors import (InstallFailed, NoSuchRevision, WeaveError,
-                           MissingText)
-from bzrlib.trace import mutter, note, warning
-from bzrlib.branch import Branch
-from bzrlib.progress import ProgressBar
-from bzrlib.xml5 import serializer_v5
-from bzrlib.osutils import sha_string, split_lines
 
 """Copying of history from one branch to another.
 
@@ -43,6 +30,17 @@
 memory until we've updated all of the files referenced.
 """
 
+import bzrlib
+import bzrlib.errors as errors
+from bzrlib.errors import (InstallFailed, NoSuchRevision, WeaveError,
+                           MissingText)
+from bzrlib.trace import mutter
+from bzrlib.progress import ProgressBar
+from bzrlib.reconcile import RepoReconciler
+from bzrlib.revision import NULL_REVISION
+from bzrlib.symbol_versioning import *
+
+
 # TODO: Avoid repeatedly opening weaves so many times.
 
 # XXX: This doesn't handle ghost (not present in branch) revisions at
@@ -61,194 +59,163 @@
 #   and add in all file versions
 
 
-
+@deprecated_function(zero_eight)
 def greedy_fetch(to_branch, from_branch, revision=None, pb=None):
+    """Legacy API, please see branch.fetch(from_branch, last_revision, pb)."""
     f = Fetcher(to_branch, from_branch, revision, pb)
     return f.count_copied, f.failed_revisions
 
-
-
-class Fetcher(object):
-    """Pull revisions and texts from one branch to another.
-
-    This doesn't update the destination's history; that can be done
-    separately if desired.  
-
-    revision_limit
-        If set, pull only up to this revision_id.
-
-    After running:
-
-    last_revision -- if last_revision
-        is given it will be that, otherwise the last revision of
-        from_branch
-
+fetch = greedy_fetch
+
+
+class RepoFetcher(object):
+    """Pull revisions and texts from one repository to another.
+
+    last_revision
+        if set, try to limit to the data this revision references.
+
+    after running:
     count_copied -- number of revisions copied
 
-    count_weaves -- number of file weaves copied
+    This should not be used directory, its essential a object to encapsulate
+    the logic in InterRepository.fetch().
     """
-    def __init__(self, to_branch, from_branch, last_revision=None, pb=None):
-        if to_branch == from_branch:
-            raise Exception("can't fetch from a branch to itself")
-        self.to_branch = to_branch
-        self.to_weaves = to_branch.weave_store
-        self.to_control = to_branch.control_weaves
-        self.from_branch = from_branch
-        self.from_weaves = from_branch.weave_store
-        self.from_control = from_branch.control_weaves
+    def __init__(self, to_repository, from_repository, last_revision=None, pb=None):
+        # result variables.
         self.failed_revisions = []
         self.count_copied = 0
-        self.count_total = 0
-        self.count_weaves = 0
-        self.copied_file_ids = set()
-        self.file_ids_names = {}
+        if to_repository.control_files._transport.base == from_repository.control_files._transport.base:
+            # check that last_revision is in 'from' and then return a no-operation.
+            if last_revision not in (None, NULL_REVISION):
+                from_repository.get_revision(last_revision)
+            return
+        self.to_repository = to_repository
+        self.from_repository = from_repository
+        # must not mutate self._last_revision as its potentially a shared instance
+        self._last_revision = last_revision
         if pb is None:
             self.pb = bzrlib.ui.ui_factory.progress_bar()
         else:
             self.pb = pb
-        self.from_branch.lock_read()
-        try:
-            self._fetch_revisions(last_revision)
-        finally:
-            self.from_branch.unlock()
+        self.from_repository.lock_read()
+        try:
+            self.to_repository.lock_write()
+            try:
+                self.__fetch()
+            finally:
+                self.to_repository.unlock()
+        finally:
+            self.from_repository.unlock()
+
+    def __fetch(self):
+        """Primary worker function.
+
+        This initialises all the needed variables, and then fetches the 
+        requested revisions, finally clearing the progress bar.
+        """
+        self.to_weaves = self.to_repository.weave_store
+        self.to_control = self.to_repository.control_weaves
+        self.from_weaves = self.from_repository.weave_store
+        self.from_control = self.from_repository.control_weaves
+        self.count_total = 0
+        self.file_ids_names = {}
+        try:
+            revs = self._revids_to_fetch()
+            # nothing to do
+            if revs: 
+                self._fetch_weave_texts(revs)
+                self._fetch_inventory_weave(revs)
+                self._fetch_revision_texts(revs)
+                self.count_copied += len(revs)
+        finally:
             self.pb.clear()
 
-    def _fetch_revisions(self, last_revision):
-        self.last_revision = self._find_last_revision(last_revision)
-        mutter('fetch up to rev {%s}', self.last_revision)
-        if (self.last_revision is not None and 
-            self.to_branch.has_revision(self.last_revision)):
-            return
-        try:
-            revs_to_fetch = self._compare_ancestries()
-        except WeaveError:
-            raise InstallFailed([self.last_revision])
-        self._copy_revisions(revs_to_fetch)
-        self.new_ancestry = revs_to_fetch
-
-    def _find_last_revision(self, last_revision):
-        """Find the limiting source revision.
-
-        Every ancestor of that revision will be merged across.
-
-        Returns the revision_id, or returns None if there's no history
-        in the source branch."""
-        if last_revision:
-            return last_revision
-        self.pb.update('get source history')
-        from_history = self.from_branch.revision_history()
+    def _revids_to_fetch(self):
         self.pb.update('get destination history')
-        if from_history:
-            return from_history[-1]
-        else:
-            return None                 # no history in the source branch
+        mutter('fetch up to rev {%s}', self._last_revision)
+        if self._last_revision is NULL_REVISION:
+            # explicit limit of no revisions needed
+            return None
+        if (self._last_revision != None and
+            self.to_repository.has_revision(self._last_revision)):
+            return None
             
-
-    def _compare_ancestries(self):
-        """Get a list of revisions that must be copied.
-
-        That is, every revision that's in the ancestry of the source
-        branch and not in the destination branch."""
-        self.pb.update('get source ancestry')
-        self.from_ancestry = self.from_branch.get_ancestry(self.last_revision)
-
-        dest_last_rev = self.to_branch.last_revision()
-        self.pb.update('get destination ancestry')
-        if dest_last_rev:
-            dest_ancestry = self.to_branch.get_ancestry(dest_last_rev)
-        else:
-            dest_ancestry = []
-        ss = set(dest_ancestry)
-        to_fetch = []
-        for rev_id in self.from_ancestry:
-            if rev_id not in ss:
-                to_fetch.append(rev_id)
-                mutter('need to get revision {%s}', rev_id)
-        mutter('need to get %d revisions in total', len(to_fetch))
-        self.count_total = len(to_fetch)
-        return to_fetch
-
-    def _copy_revisions(self, revs_to_fetch):
-        i = 0
-        for rev_id in revs_to_fetch:
-            i += 1
-            if rev_id is None:
-                continue
-            if self.to_branch.has_revision(rev_id):
-                continue
-            self.pb.update('copy revision', i, self.count_total)
-            self._copy_one_revision(rev_id)
-            self.count_copied += 1
-
-
-    def _copy_one_revision(self, rev_id):
-        """Copy revision and everything referenced by it."""
-        mutter('copying revision {%s}', rev_id)
-        rev_xml = self.from_branch.get_revision_xml(rev_id)
-        inv_xml = self.from_branch.get_inventory_xml(rev_id)
-        rev = serializer_v5.read_revision_from_string(rev_xml)
-        inv = serializer_v5.read_inventory_from_string(inv_xml)
-        assert rev.revision_id == rev_id
-        assert rev.inventory_sha1 == sha_string(inv_xml)
-        mutter('  commiter %s, %d parents',
-               rev.committer,
-               len(rev.parent_ids))
-        self._copy_new_texts(rev_id, inv)
-        parents = rev.parent_ids
-        new_parents = copy(parents)
-        for parent in parents:
-            if not self.to_branch.has_revision(parent):
-                new_parents.pop(new_parents.index(parent))
-        self._copy_inventory(rev_id, inv_xml, new_parents)
-        self.to_branch.revision_store.add(StringIO(rev_xml), rev_id)
-        mutter('copied revision %s', rev_id)
-
-    def _copy_inventory(self, rev_id, inv_xml, parent_ids):
-        self.to_control.add_text('inventory', rev_id,
-                                split_lines(inv_xml), parent_ids,
-                                self.to_branch.get_transaction())
-
-    def _copy_new_texts(self, rev_id, inv):
-        """Copy any new texts occuring in this revision."""
-        # TODO: Rather than writing out weaves every time, hold them
-        # in memory until everything's done?  But this way is nicer
-        # if it's interrupted.
-        for path, ie in inv.iter_entries():
-            self._copy_one_weave(rev_id, ie.file_id, ie.revision)
-
-    def _copy_one_weave(self, rev_id, file_id, text_revision):
-        """Copy one file weave, esuring the result contains text_revision."""
-        # check if the revision is already there
-        if file_id in self.file_ids_names.keys( ) and \
-            text_revision in self.file_ids_names[file_id]:
-                return        
-        to_weave = self.to_weaves.get_weave_or_empty(file_id,
-            self.to_branch.get_transaction())
-        if not file_id in self.file_ids_names.keys( ):
-            self.file_ids_names[file_id] = to_weave.names( )
-        if text_revision in to_weave:
-            return
-        from_weave = self.from_weaves.get_weave(file_id,
-            self.from_branch.get_transaction())
-        if text_revision not in from_weave:
-            raise MissingText(self.from_branch, text_revision, file_id)
-        mutter('copy file {%s} modified in {%s}', file_id, rev_id)
-
-        if to_weave.numversions() > 0:
+        try:
+            return self.to_repository.missing_revision_ids(self.from_repository,
+                                                           self._last_revision)
+        except errors.NoSuchRevision:
+            raise InstallFailed([self._last_revision])
+
+    def _fetch_revision_texts(self, revs):
+        self.to_repository.revision_store.copy_multi(
+            self.from_repository.revision_store,
+            revs,
+            pb=self.pb)
+        # fixup inventory if needed:
+        # this is expensive because we have no inverse index to current ghosts.
+        # but on local disk its a few seconds and sftp push is already insane.
+        # so we just-do-it.
+        # FIXME: the generic code path should not need this, if it truely is
+        # generic.
+        reconciler = RepoReconciler(self.to_repository)
+        reconciler.reconcile()
+
+    def _fetch_weave_texts(self, revs):
+        file_ids = self.from_repository.fileid_involved_by_set(revs)
+        count = 0
+        num_file_ids = len(file_ids)
+        for file_id in file_ids:
+            self.pb.update("merge weaves", count, num_file_ids)
+            count +=1
+            to_weave = self.to_weaves.get_weave_or_empty(file_id,
+                self.to_repository.get_transaction())
+            from_weave = self.from_weaves.get_weave(file_id,
+                self.from_repository.get_transaction())
+
+            if to_weave.numversions() > 0:
+                # destination has contents, must merge
+                try:
+                    to_weave.join(from_weave)
+                except errors.WeaveParentMismatch:
+                    to_weave.reweave(from_weave)
+            else:
+                # destination is empty, just replace it
+                to_weave = from_weave.copy()
+
+            self.to_weaves.put_weave(file_id, to_weave,
+                self.to_repository.get_transaction())
+        self.pb.clear()
+
+    def _fetch_inventory_weave(self, revs):
+        self.pb.update("inventory fetch", 0, 2)
+        from_weave = self.from_repository.get_inventory_weave()
+        self.to_inventory_weave = self.to_repository.get_inventory_weave()
+        self.pb.update("inventory fetch", 1, 2)
+        self.to_inventory_weave = self.to_control.get_weave('inventory',
+                self.to_repository.get_transaction())
+        self.pb.update("inventory fetch", 2, 2)
+
+        if self.to_inventory_weave.numversions() > 0:
             # destination has contents, must merge
             try:
-                to_weave.join(from_weave)
+                self.to_inventory_weave.join(from_weave, pb=self.pb, msg='merge inventory')
             except errors.WeaveParentMismatch:
-                to_weave.reweave(from_weave)
+                self.to_inventory_weave.reweave(from_weave, pb=self.pb, msg='reweave inventory')
         else:
             # destination is empty, just replace it
-            to_weave = from_weave.copy( )
-        self.to_weaves.put_weave(file_id, to_weave,
-            self.to_branch.get_transaction())
-        self.count_weaves += 1
-        self.copied_file_ids.add(file_id)
-        self.file_ids_names[file_id] = to_weave.names()
-        mutter('copied file {%s}', file_id)
-
-
-fetch = Fetcher
+            self.to_inventory_weave = from_weave.copy()
+
+        # must be written before pulling any revisions
+        self.to_control.put_weave('inventory', self.to_inventory_weave,
+            self.to_repository.get_transaction())
+
+        self.pb.clear()
+
+
+class Fetcher(object):
+    """Backwards compatability glue for branch.fetch()."""
+
+    @deprecated_method(zero_eight)
+    def __init__(self, to_branch, from_branch, last_revision=None, pb=None):
+        """Please see branch.fetch()."""
+        to_branch.fetch(from_branch, last_revision, pb)

=== modified file 'bzrlib/hashcache.py'
--- bzrlib/hashcache.py	2006-01-25 14:30:06 +0000
+++ bzrlib/hashcache.py	2006-03-20 08:31:00 +0000
@@ -32,7 +32,7 @@
 import os, stat, time
 import sha
 
-from bzrlib.osutils import sha_file, pathjoin
+from bzrlib.osutils import sha_file, pathjoin, safe_unicode
 from bzrlib.trace import mutter, warning
 from bzrlib.atomicfile import AtomicFile
 from bzrlib.errors import BzrError
@@ -94,8 +94,9 @@
     """
     needs_write = False
 
-    def __init__(self, basedir):
-        self.basedir = basedir
+    def __init__(self, root, cache_file_name, mode=None):
+        """Create a hash cache in base dir, and set the file mode to mode."""
+        self.root = safe_unicode(root)
         self.hit_count = 0
         self.miss_count = 0
         self.stat_count = 0
@@ -103,11 +104,11 @@
         self.removed_count = 0
         self.update_count = 0
         self._cache = {}
+        self._mode = mode
+        self._cache_file_name = safe_unicode(cache_file_name)
 
     def cache_file_name(self):
-        # FIXME: duplicate path logic here, this should be 
-        # something like 'branch.controlfile'.
-        return pathjoin(self.basedir, '.bzr', 'stat-cache')
+        return self._cache_file_name
 
     def clear(self):
         """Discard all cached information.
@@ -117,18 +118,19 @@
             self.needs_write = True
             self._cache = {}
 
-
     def scan(self):
         """Scan all files and remove entries where the cache entry is obsolete.
         
         Obsolete entries are those where the file has been modified or deleted
         since the entry was inserted.        
         """
+        # FIXME optimisation opportunity, on linux [and check other oses]:
+        # rather than iteritems order, stat in inode order.
         prep = [(ce[1][3], path, ce) for (path, ce) in self._cache.iteritems()]
         prep.sort()
         
         for inum, path, cache_entry in prep:
-            abspath = pathjoin(self.basedir, path)
+            abspath = pathjoin(self.root, path)
             fp = _fingerprint(abspath)
             self.stat_count += 1
             
@@ -144,7 +146,7 @@
     def get_sha1(self, path):
         """Return the sha1 of a file.
         """
-        abspath = pathjoin(self.basedir, path)
+        abspath = pathjoin(self.root, path)
         self.stat_count += 1
         file_fp = _fingerprint(abspath)
         
@@ -202,7 +204,7 @@
         
     def write(self):
         """Write contents of cache to file."""
-        outf = AtomicFile(self.cache_file_name(), 'wb')
+        outf = AtomicFile(self.cache_file_name(), 'wb', new_mode=self._mode)
         try:
             print >>outf, CACHE_HEADER,
 

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2006-01-25 14:30:06 +0000
+++ bzrlib/help.py	2006-03-20 08:31:00 +0000
@@ -162,5 +162,5 @@
         cmd_help = cmd_object.help()
         if cmd_help:
             firstline = cmd_help.split('\n', 1)[0]
-            print >>outfile, '    ' + firstline
+            print >>outfile, '        ' + firstline
         

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2005-11-07 13:17:53 +0000
+++ bzrlib/info.py	2006-03-20 08:31:00 +0000
@@ -16,9 +16,15 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+__all__ = ['show_bzrdir_info']
+
 import time
 
+
+import bzrlib.diff as diff
+from bzrlib.missing import find_unmerged
 from bzrlib.osutils import format_date
+from bzrlib.symbol_versioning import *
 
 
 def _countiter(it):
@@ -29,11 +35,13 @@
     return i        
 
 
-
+@deprecated_function(zero_eight)
 def show_info(b):
-    import diff
-    
-    print 'branch format:', b.controlfile('branch-format', 'r').readline().rstrip('\n')
+    """Please see show_bzrdir_info."""
+    return show_bzrdir_info(b.bzrdir)
+
+def show_bzrdir_info(a_bzrdir):
+    """Output to stdout the 'info' for a_bzrdir."""
 
     def plural(n, base='', pl=None):
         if n == 1:
@@ -43,14 +51,46 @@
         else:
             return 's'
 
+    working = a_bzrdir.open_workingtree()
+    b = a_bzrdir.open_branch()
+    
+    if working.bzrdir != b.bzrdir:
+        print 'working tree format:', working._format
+        print 'branch location:', b.bzrdir.root_transport.base
+    try:
+        b._format.get_format_string()
+        format = b._format
+    except NotImplementedError:
+        format = b.bzrdir._format
+    print 'branch format:', format
+
+    if b.get_bound_location():
+        print 'bound to branch:',  b.get_bound_location()
+
     count_version_dirs = 0
 
-    basis = b.basis_tree()
-    working = b.working_tree()
+    basis = working.basis_tree()
     work_inv = working.inventory
     delta = diff.compare_trees(basis, working, want_unchanged=True)
+    history = b.revision_history()
     
     print
+    # Try with inaccessible branch ?
+    master = b.get_master_branch()
+    if master:
+        local_extra, remote_extra = find_unmerged(b, b.get_master_branch())
+        if remote_extra:
+            print 'Branch is out of date: missing %d revision%s.' % (
+                len(remote_extra), plural(len(remote_extra)))
+
+    if len(history) and working.last_revision() != history[-1]:
+        try:
+            missing_count = len(history) - history.index(working.last_revision())
+        except ValueError:
+            # consider it all out of date
+            missing_count = len(history)
+        print 'Working tree is out of date: missing %d revision%s.' % (
+            missing_count, plural(missing_count))
     print 'in the working tree:'
     print '  %8s unchanged' % len(delta.unchanged)
     print '  %8d modified' % len(delta.modified)
@@ -78,21 +118,20 @@
 
     print
     print 'branch history:'
-    history = b.revision_history()
     revno = len(history)
     print '  %8d revision%s' % (revno, plural(revno))
     committers = {}
     for rev in history:
-        committers[b.get_revision(rev).committer] = True
+        committers[b.repository.get_revision(rev).committer] = True
     print '  %8d committer%s' % (len(committers), plural(len(committers)))
     if revno > 0:
-        firstrev = b.get_revision(history[0])
+        firstrev = b.repository.get_revision(history[0])
         age = int((time.time() - firstrev.timestamp) / 3600 / 24)
         print '  %8d day%s old' % (age, plural(age))
         print '   first revision: %s' % format_date(firstrev.timestamp,
                                                     firstrev.timezone)
 
-        lastrev = b.get_revision(history[-1])
+        lastrev = b.repository.get_revision(history[-1])
         print '  latest revision: %s' % format_date(lastrev.timestamp,
                                                     lastrev.timezone)
 
@@ -104,8 +143,8 @@
 
     print
     print 'revision store:'
-    c, t = b.revision_store.total_size()
-    print '  %8d revisions' % c
+    c, t = b.repository.revision_store.total_size()
+    print '  %8d revision%s' % (c, plural(c))
     print '  %8d kB' % (t/1024)
 
 

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2006-01-25 14:30:06 +0000
+++ bzrlib/inventory.py	2006-03-20 08:31:00 +0000
@@ -407,6 +407,9 @@
         # first requested, or preload them if they're already known
         pass            # nothing to do by default
 
+    def _forget_tree_state(self):
+        pass
+
 
 class RootEntry(InventoryEntry):
 
@@ -570,6 +573,10 @@
         self.text_sha1 = work_tree.get_file_sha1(self.file_id)
         self.executable = work_tree.is_executable(self.file_id)
 
+    def _forget_tree_state(self):
+        self.text_sha1 = None
+        self.executable = None
+
     def _snapshot_text(self, file_parents, work_tree, weave_store, transaction):
         """See InventoryEntry._snapshot_text."""
         mutter('storing file {%s} in revision {%s}',
@@ -679,6 +686,9 @@
         """See InventoryEntry._read_tree_state."""
         self.symlink_target = work_tree.get_symlink_target(self.file_id)
 
+    def _forget_tree_state(self):
+        self.symlink_target = None
+
     def _unchanged(self, previous_ie):
         """See InventoryEntry._unchanged."""
         compatible = super(InventoryLink, self)._unchanged(previous_ie)
@@ -735,7 +745,7 @@
         The inventory is created with a default root directory, with
         an id of None.
         """
-        # We are letting Branch.initialize() create a unique inventory
+        # We are letting Branch.create() create a unique inventory
         # root id. Rather than generating a random one here.
         #if root_id is None:
         #    root_id = bzrlib.branch.gen_file_id('TREE_ROOT')
@@ -893,16 +903,19 @@
         from bzrlib.workingtree import gen_file_id
         
         parts = bzrlib.osutils.splitpath(relpath)
-        if len(parts) == 0:
-            raise BzrError("cannot re-add root of inventory")
 
         if file_id == None:
             file_id = gen_file_id(relpath)
 
-        parent_path = parts[:-1]
-        parent_id = self.path2id(parent_path)
-        if parent_id == None:
-            raise NotVersionedError(path=parent_path)
+        if len(parts) == 0:
+            self.root = RootEntry(file_id)
+            self._byid = {self.root.file_id: self.root}
+            return
+        else:
+            parent_path = parts[:-1]
+            parent_id = self.path2id(parent_path)
+            if parent_id == None:
+                raise NotVersionedError(path=parent_path)
         if kind == 'directory':
             ie = InventoryDirectory(file_id, parts[-1], parent_id)
         elif kind == 'file':
@@ -928,17 +941,12 @@
         """
         ie = self[file_id]
 
-        assert self[ie.parent_id].children[ie.name] == ie
+        assert ie.parent_id is None or \
+            self[ie.parent_id].children[ie.name] == ie
         
-        # TODO: Test deleting all children; maybe hoist to a separate
-        # deltree method?
-        if ie.kind == 'directory':
-            for cie in ie.children.values():
-                del self[cie.file_id]
-            del ie.children
-
         del self._byid[file_id]
-        del self[ie.parent_id].children[ie.name]
+        if ie.parent_id is not None:
+            del self[ie.parent_id].children[ie.name]
 
 
     def __eq__(self, other):

=== added file 'bzrlib/iterablefile.py'
--- bzrlib/iterablefile.py	1970-01-01 00:00:00 +0000
+++ bzrlib/iterablefile.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,257 @@
+# Copyright (C) 2005 Aaron Bentley
+# <aaron.bentley@utoronto.ca>
+#
+#    This program is free software; you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation; either version 2 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program; if not, write to the Free Software
+#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import doctest
+
+class IterableFileBase(object):
+    """Create a file-like object from any iterable"""
+
+    def __init__(self, iterable):
+        object.__init__(self)
+        self._iter = iterable.__iter__()
+        self._buffer = ""
+        self.done = False
+
+    def read_n(self, length):
+        """
+        >>> IterableFileBase(['This ', 'is ', 'a ', 'test.']).read_n(8)
+        'This is '
+        """
+        def test_length(result):
+            if len(result) >= length:
+                return length
+            else:
+                return None
+        return self._read(test_length)
+
+    def read_to(self, sequence, length=None):
+        """
+        >>> f = IterableFileBase(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f.read_to('\\n')
+        'Th\\n'
+        >>> f.read_to('\\n')
+        'is is \\n'
+        """
+        def test_contents(result):
+            if length is not None:
+                if len(result) >= length:
+                    return length
+            try:
+                return result.index(sequence)+len(sequence)
+            except ValueError:
+                return None
+        return self._read(test_contents)
+
+    def _read(self, result_length):
+        """
+        Read data until result satisfies the condition result_length.
+        result_length is a callable that returns None until the condition
+        is satisfied, and returns the length of the result to use when
+        the condition is satisfied.  (i.e. it returns the length of the
+        subset of the first condition match.)
+        """
+        result = self._buffer
+        while result_length(result) is None:
+            try:
+                result += self._iter.next()
+            except StopIteration:
+                self.done = True
+                self._buffer = ""
+                return result
+        output_length = result_length(result)
+        self._buffer = result[output_length:]
+        return result[:output_length]
+
+    def read_all(self):
+        """
+        >>> IterableFileBase(['This ', 'is ', 'a ', 'test.']).read_all()
+        'This is a test.'
+        """
+        def no_stop(result):
+            return None
+        return self._read(no_stop)
+
+
+    def push_back(self, contents):
+        """
+        >>> f = IterableFileBase(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f.read_to('\\n')
+        'Th\\n'
+        >>> f.push_back("Sh")
+        >>> f.read_all()
+        'Shis is \\na te\\nst.'
+        """
+        self._buffer = contents + self._buffer
+
+
+class IterableFile(object):
+    """This class supplies all File methods that can be implemented cheaply."""
+    def __init__(self, iterable):
+        object.__init__(self)
+        self._file_base = IterableFileBase(iterable)
+        self._iter = self._make_iterator()
+        self._closed = False
+        self.softspace = 0
+
+    def _make_iterator(self):
+        while not self._file_base.done:
+            self._check_closed()
+            result = self._file_base.read_to('\n')
+            if result != '':
+                yield result
+
+    def _check_closed(self):
+        if self.closed:
+            raise ValueError("File is closed.")
+
+    def close(self):
+        """
+        >>> f = IterableFile(['This ', 'is ', 'a ', 'test.'])
+        >>> f.closed
+        False
+        >>> f.close()
+        >>> f.closed
+        True
+        """
+        self._file_base.done = True
+        self._closed = True
+
+    closed = property(lambda x: x._closed)
+
+    def flush(self):
+        """No-op for standard compliance.
+        >>> f = IterableFile([])
+        >>> f.close()
+        >>> f.flush()
+        Traceback (most recent call last):
+        ValueError: File is closed.
+        """
+        self._check_closed()
+
+    def next(self):
+        """Implementation of the iterator protocol's next()
+
+        >>> f = IterableFile(['This \\n', 'is ', 'a ', 'test.'])
+        >>> f.next()
+        'This \\n'
+        >>> f.close()
+        >>> f.next()
+        Traceback (most recent call last):
+        ValueError: File is closed.
+        >>> f = IterableFile(['This \\n', 'is ', 'a ', 'test.\\n'])
+        >>> f.next()
+        'This \\n'
+        >>> f.next()
+        'is a test.\\n'
+        >>> f.next()
+        Traceback (most recent call last):
+        StopIteration
+        """
+        self._check_closed()
+        return self._iter.next()
+
+    def __iter__(self):
+        """
+        >>> list(IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.']))
+        ['Th\\n', 'is is \\n', 'a te\\n', 'st.']
+        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f.close()
+        >>> list(f)
+        Traceback (most recent call last):
+        ValueError: File is closed.
+        """
+        return self
+
+    def read(self, length=None):
+        """
+        >>> IterableFile(['This ', 'is ', 'a ', 'test.']).read()
+        'This is a test.'
+        >>> f = IterableFile(['This ', 'is ', 'a ', 'test.'])
+        >>> f.read(10)
+        'This is a '
+        >>> f = IterableFile(['This ', 'is ', 'a ', 'test.'])
+        >>> f.close()
+        >>> f.read(10)
+        Traceback (most recent call last):
+        ValueError: File is closed.
+        """
+        self._check_closed()
+        if length is None:
+            return self._file_base.read_all()
+        else:
+            return self._file_base.read_n(length)
+
+    def read_to(self, sequence, size=None):
+        """
+        Read characters until a sequence is found, with optional max size.
+        The specified sequence, if found, will be included in the result
+
+        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f.read_to('i')
+        'Th\\ni'
+        >>> f.read_to('i')
+        's i'
+        >>> f.close()
+        >>> f.read_to('i')
+        Traceback (most recent call last):
+        ValueError: File is closed.
+        """
+        self._check_closed()
+        return self._file_base.read_to(sequence, size)
+
+    def readline(self, size=None):
+        """
+        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f.readline()
+        'Th\\n'
+        >>> f.readline(4)
+        'is i'
+        >>> f.close()
+        >>> f.readline()
+        Traceback (most recent call last):
+        ValueError: File is closed.
+        """
+        return self.read_to('\n', size)
+
+    def readlines(self, sizehint=None):
+        """
+        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f.readlines()
+        ['Th\\n', 'is is \\n', 'a te\\n', 'st.']
+        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f.close()
+        >>> f.readlines()
+        Traceback (most recent call last):
+        ValueError: File is closed.
+        """
+        lines = []
+        while True:
+            line = self.readline()
+            if line == "":
+                return lines
+            if sizehint is None:
+                lines.append(line)
+            elif len(line) < sizehint:
+                lines.append(line)
+                sizehint -= len(line)
+            else:
+                self._file_base.push_back(line)
+                return lines
+
+        
+if __name__ == "__main__":
+    doctest.testmod()

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2006-01-25 14:30:06 +0000
+++ bzrlib/lock.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,35 +15,34 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""Locking wrappers.
+"""Locking using OS file locks or file existence.
 
-This only does local locking using OS locks for now.
+Note: This method of locking is generally deprecated in favour of LockDir, but
+is used to lock local WorkingTrees, and by some old formats.  It's accessed
+through Transport.lock_read(), etc.
 
 This module causes two methods, lock() and unlock() to be defined in
 any way that works on the current platform.
 
 It is not specified whether these locks are reentrant (i.e. can be
 taken repeatedly by a single process) or whether they exclude
-different threads in a single process.  
-
-Eventually we may need to use some kind of lock representation that
-will work on a dumb filesystem without actual locking primitives.
+different threads in a single process.  That reentrancy is provided by 
+LockableFiles.
 
 This defines two classes: ReadLock and WriteLock, which can be
 implemented in different ways on different platforms.  Both have an
 unlock() method.
 """
 
-
+import errno
+import os
 import sys
-import os
 
 from bzrlib.trace import mutter, note, warning
 from bzrlib.errors import LockError
 
 class _base_Lock(object):
     def _open(self, filename, filemode):
-        import errno
         try:
             self.f = open(filename, filemode)
             return self.f
@@ -54,17 +53,15 @@
             # maybe this is an old branch (before may 2005)
             mutter("trying to create missing branch lock %r", filename)
             
-            self.f = open(filename, 'wb')
+            self.f = open(filename, 'wb+')
             return self.f
 
-
     def __del__(self):
         if self.f:
             from warnings import warn
             warn("lock on %r not released" % self.f)
             self.unlock()
             
-
     def unlock(self):
         raise NotImplementedError()
 
@@ -88,25 +85,33 @@
             self.f.close()
             del self.f 
 
-
     class _fcntl_WriteLock(_fcntl_FileLock):
         def __init__(self, filename):
+            # standard IO errors get exposed directly.
+            self._open(filename, 'wb')
             try:
-                fcntl.lockf(self._open(filename, 'wb'), fcntl.LOCK_EX)
-            except Exception, e:
+                fcntl.lockf(self.f, fcntl.LOCK_EX)
+            except IOError, e:
+                # we should be more precise about whats a locking
+                # error and whats a random-other error
                 raise LockError(e)
 
-
     class _fcntl_ReadLock(_fcntl_FileLock):
+
         def __init__(self, filename):
+            # standard IO errors get exposed directly.
+            self._open(filename, 'rb')
             try:
-                fcntl.lockf(self._open(filename, 'rb'), fcntl.LOCK_SH)
-            except Exception, e:
+                fcntl.lockf(self.f, fcntl.LOCK_SH)
+            except IOError, e:
+                # we should be more precise about whats a locking
+                # error and whats a random-other error
                 raise LockError(e)
 
     WriteLock = _fcntl_WriteLock
     ReadLock = _fcntl_ReadLock
 
+
 except ImportError:
     try:
         import win32con, win32file, pywintypes
@@ -245,10 +250,3 @@
         except ImportError:
             raise NotImplementedError("please write a locking method "
                                       "for platform %r" % sys.platform)
-
-
-
-
-
-
-

=== added file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	1970-01-01 00:00:00 +0000
+++ bzrlib/lockable_files.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,296 @@
+# Copyright (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from cStringIO import StringIO
+import codecs
+
+import bzrlib
+from bzrlib.decorators import *
+import bzrlib.errors as errors
+from bzrlib.errors import LockError, ReadOnlyError
+from bzrlib.osutils import file_iterator, safe_unicode
+from bzrlib.symbol_versioning import *
+from bzrlib.trace import mutter
+import bzrlib.transactions as transactions
+
+# XXX: The tracking here of lock counts and whether the lock is held is
+# somewhat redundant with what's done in LockDir; the main difference is that
+# LockableFiles permits reentrancy.
+
+class LockableFiles(object):
+    """Object representing a set of related files locked within the same scope.
+
+    These files are used by a WorkingTree, Repository or Branch, and should
+    generally only be touched by that object.
+
+    LockableFiles also provides some policy on top of Transport for encoding
+    control files as utf-8.
+
+    LockableFiles manage a lock count and can be locked repeatedly by
+    a single caller.  (The underlying lock implementation generally does not
+    support this.)
+
+    Instances of this class are often called control_files.
+    
+    This object builds on top of a Transport, which is used to actually write
+    the files to disk, and an OSLock or LockDir, which controls how access to
+    the files is controlled.  The particular type of locking used is set when
+    the object is constructed.  In older formats OSLocks are used everywhere.
+    in newer formats a LockDir is used for Repositories and Branches, and 
+    OSLocks for the local filesystem.
+    """
+
+    # _lock_mode: None, or 'r' or 'w'
+
+    # _lock_count: If _lock_mode is true, a positive count of the number of
+    # times the lock has been taken *by this process*.   
+    
+    # If set to False (by a plugin, etc) BzrBranch will not set the
+    # mode on created files or directories
+    _set_file_mode = True
+    _set_dir_mode = True
+
+    def __init__(self, transport, lock_name, lock_class):
+        """Create a LockableFiles group
+
+        :param transport: Transport pointing to the directory holding the 
+            control files and lock.
+        :param lock_name: Name of the lock guarding these files.
+        :param lock_class: Class of lock strategy to use: typically
+            either LockDir or TransportLock.
+        """
+        object.__init__(self)
+        self._transport = transport
+        self.lock_name = lock_name
+        self._transaction = None
+        self._find_modes()
+        self._lock_mode = None
+        self._lock_count = 0
+        esc_name = self._escape(lock_name)
+        self._lock = lock_class(transport, esc_name, 
+                                file_modebits=self._file_mode,
+                                dir_modebits=self._dir_mode)
+
+    def create_lock(self):
+        """Create the lock.
+
+        This should normally be called only when the LockableFiles directory
+        is first created on disk.
+        """
+        self._lock.create()
+
+    def __repr__(self):
+        return '%s(%r)' % (self.__class__.__name__,
+                           self._transport)
+
+    def _escape(self, file_or_path):
+        if not isinstance(file_or_path, basestring):
+            file_or_path = '/'.join(file_or_path)
+        if file_or_path == '':
+            return u''
+        return bzrlib.transport.urlescape(safe_unicode(file_or_path))
+
+    def _find_modes(self):
+        """Determine the appropriate modes for files and directories."""
+        try:
+            st = self._transport.stat('.')
+        except errors.TransportNotPossible:
+            self._dir_mode = 0755
+            self._file_mode = 0644
+        else:
+            self._dir_mode = st.st_mode & 07777
+            # Remove the sticky and execute bits for files
+            self._file_mode = self._dir_mode & ~07111
+        if not self._set_dir_mode:
+            self._dir_mode = None
+        if not self._set_file_mode:
+            self._file_mode = None
+
+    def controlfilename(self, file_or_path):
+        """Return location relative to branch."""
+        return self._transport.abspath(self._escape(file_or_path))
+
+    @deprecated_method(zero_eight)
+    def controlfile(self, file_or_path, mode='r'):
+        """Open a control file for this branch.
+
+        There are two classes of file in a lockable directory: text
+        and binary.  binary files are untranslated byte streams.  Text
+        control files are stored with Unix newlines and in UTF-8, even
+        if the platform or locale defaults are different.
+
+        Such files are not openable in write mode : they are managed via
+        put and put_utf8 which atomically replace old versions using
+        atomicfile.
+        """
+
+        relpath = self._escape(file_or_path)
+        # TODO: codecs.open() buffers linewise, so it was overloaded with
+        # a much larger buffer, do we need to do the same for getreader/getwriter?
+        if mode == 'rb': 
+            return self.get(relpath)
+        elif mode == 'wb':
+            raise BzrError("Branch.controlfile(mode='wb') is not supported, use put[_utf8]")
+        elif mode == 'r':
+            return self.get_utf8(relpath)
+        elif mode == 'w':
+            raise BzrError("Branch.controlfile(mode='w') is not supported, use put[_utf8]")
+        else:
+            raise BzrError("invalid controlfile mode %r" % mode)
+
+    @needs_read_lock
+    def get(self, relpath):
+        """Get a file as a bytestream."""
+        relpath = self._escape(relpath)
+        return self._transport.get(relpath)
+
+    @needs_read_lock
+    def get_utf8(self, relpath):
+        """Get a file as a unicode stream."""
+        relpath = self._escape(relpath)
+        # DO NOT introduce an errors=replace here.
+        return codecs.getreader('utf-8')(self._transport.get(relpath))
+
+    @needs_write_lock
+    def put(self, path, file):
+        """Write a file.
+        
+        :param path: The path to put the file, relative to the .bzr control
+                     directory
+        :param f: A file-like or string object whose contents should be copied.
+        """
+        self._transport.put(self._escape(path), file, mode=self._file_mode)
+
+    @needs_write_lock
+    def put_utf8(self, path, a_string):
+        """Write a string, encoding as utf-8.
+
+        :param path: The path to put the string, relative to the transport root.
+        :param string: A file-like or string object whose contents should be copied.
+        """
+        # IterableFile would not be needed if Transport.put took iterables
+        # instead of files.  ADHB 2005-12-25
+        # RBC 20060103 surely its not needed anyway, with codecs transcode
+        # file support ?
+        # JAM 20060103 We definitely don't want encode(..., 'replace')
+        # these are valuable files which should have exact contents.
+        if not isinstance(a_string, basestring):
+            raise errors.BzrBadParameterNotString(a_string)
+        self.put(path, StringIO(a_string.encode('utf-8')))
+
+    def lock_write(self):
+        # mutter("lock write: %s (%s)", self, self._lock_count)
+        # TODO: Upgrade locking to support using a Transport,
+        # and potentially a remote locking protocol
+        if self._lock_mode:
+            if self._lock_mode != 'w':
+                raise ReadOnlyError(self)
+            self._lock_count += 1
+        else:
+            self._lock.lock_write()
+            self._lock_mode = 'w'
+            self._lock_count = 1
+            self._set_transaction(transactions.PassThroughTransaction())
+
+    def lock_read(self):
+        # mutter("lock read: %s (%s)", self, self._lock_count)
+        if self._lock_mode:
+            assert self._lock_mode in ('r', 'w'), \
+                   "invalid lock mode %r" % self._lock_mode
+            self._lock_count += 1
+        else:
+            self._lock.lock_read()
+            self._lock_mode = 'r'
+            self._lock_count = 1
+            self._set_transaction(transactions.ReadOnlyTransaction())
+            # 5K may be excessive, but hey, its a knob.
+            self.get_transaction().set_cache_size(5000)
+                        
+    def unlock(self):
+        # mutter("unlock: %s (%s)", self, self._lock_count)
+        if not self._lock_mode:
+            raise errors.LockNotHeld(self)
+        if self._lock_count > 1:
+            self._lock_count -= 1
+        else:
+            self._finish_transaction()
+            self._lock.unlock()
+            self._lock_mode = self._lock_count = None
+
+    def is_locked(self):
+        """Return true if this LockableFiles group is locked"""
+        return self._lock_count >= 1
+
+    def get_transaction(self):
+        """Return the current active transaction.
+
+        If no transaction is active, this returns a passthrough object
+        for which all data is immediately flushed and no caching happens.
+        """
+        if self._transaction is None:
+            return transactions.PassThroughTransaction()
+        else:
+            return self._transaction
+
+    def _set_transaction(self, new_transaction):
+        """Set a new active transaction."""
+        if self._transaction is not None:
+            raise errors.LockError('Branch %s is in a transaction already.' %
+                                   self)
+        self._transaction = new_transaction
+
+    def _finish_transaction(self):
+        """Exit the current transaction."""
+        if self._transaction is None:
+            raise errors.LockError('Branch %s is not in a transaction' %
+                                   self)
+        transaction = self._transaction
+        self._transaction = None
+        transaction.finish()
+
+
+class TransportLock(object):
+    """Locking method which uses transport-dependent locks.
+
+    On the local filesystem these transform into OS-managed locks.
+
+    These do not guard against concurrent access via different
+    transports.
+
+    This is suitable for use only in WorkingTrees (which are at present
+    always local).
+    """
+    def __init__(self, transport, escaped_name, file_modebits, dir_modebits):
+        self._transport = transport
+        self._escaped_name = escaped_name
+        self._file_modebits = file_modebits
+        self._dir_modebits = dir_modebits
+
+    def lock_write(self):
+        self._lock = self._transport.lock_write(self._escaped_name)
+
+    def lock_read(self):
+        self._lock = self._transport.lock_read(self._escaped_name)
+
+    def unlock(self):
+        self._lock.unlock()
+        self._lock = None
+
+    def create(self):
+        """Create lock mechanism"""
+        # for old-style locks, create the file now
+        self._transport.put(self._escaped_name, StringIO(), 
+                            mode=self._file_modebits)

=== added file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	1970-01-01 00:00:00 +0000
+++ bzrlib/lockdir.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,377 @@
+# Copyright (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""On-disk mutex protecting a resource
+
+bzr on-disk objects are locked by the existence of a directory with a
+particular name within the control directory.  We use this rather than OS
+internal locks (such as flock etc) because they can be seen across all
+transports, including http.
+
+Objects can be read if there is only physical read access; therefore 
+readers can never be required to create a lock, though they will
+check whether a writer is using the lock.  Writers can't detect
+whether anyone else is reading from the resource as they write.
+This works because of ordering constraints that make sure readers
+see a consistent view of existing data.
+
+Waiting for a lock must be done by polling; this can be aborted after
+a timeout.
+
+Locks must always be explicitly released, typically from a try/finally
+block -- they are not released from a finalizer or when Python
+exits.
+
+Locks may fail to be released if the process is abruptly terminated
+(machine stop, SIGKILL) or if a remote transport becomes permanently
+disconnected.  There is therefore a method to break an existing lock.
+This should rarely be used, and generally only with user approval.
+Locks contain some information on when the lock was taken and by who
+which may guide in deciding whether it can safely be broken.  (This is
+similar to the messages displayed by emacs and vim.) Note that if the
+lock holder is still alive they will get no notification that the lock
+has been broken and will continue their work -- so it is important to be
+sure they are actually dead.
+
+A lock is represented on disk by a directory of a particular name,
+containing an information file.  Taking a lock is done by renaming a
+temporary directory into place.  We use temporary directories because
+for all known transports and filesystems we believe that exactly one
+attempt to claim the lock will succeed and the others will fail.  (Files
+won't do because some filesystems or transports only have
+rename-and-overwrite, making it hard to tell who won.)
+
+The desired characteristics are:
+
+* Locks are not reentrant.  (That is, a client that tries to take a 
+  lock it already holds may deadlock or fail.)
+* Stale locks can be guessed at by a heuristic
+* Lost locks can be broken by any client
+* Failed lock operations leave little or no mess
+* Deadlocks are avoided by having a timeout always in use, clients
+  desiring indefinite waits can retry or set a silly big timeout.
+
+Storage formats use the locks, and also need to consider concurrency
+issues underneath the lock.  A format may choose not to use a lock
+at all for some operations.
+
+LockDirs always operate over a Transport.  The transport may be readonly, in
+which case the lock can be queried but not acquired.
+
+Locks are identified by a path name, relative to a base transport.
+
+Calling code will typically want to make sure there is exactly one LockDir
+object per actual lock on disk.  This module does nothing to prevent aliasing
+and deadlocks will likely occur if the locks are aliased.
+
+In the future we may add a "freshen" method which can be called
+by a lock holder to check that their lock has not been broken, and to 
+update the timestamp within it.
+
+Example usage:
+
+>>> from bzrlib.transport.memory import MemoryTransport
+>>> # typically will be obtained from a BzrDir, Branch, etc
+>>> t = MemoryTransport()
+>>> l = LockDir(t, 'sample-lock')
+>>> l.create()
+>>> l.wait_lock()
+>>> # do something here
+>>> l.unlock()
+
+"""
+
+import os
+import time
+from warnings import warn
+from StringIO import StringIO
+
+import bzrlib.config
+from bzrlib.errors import (
+        DirectoryNotEmpty,
+        FileExists,
+        LockBreakMismatch,
+        LockBroken,
+        LockContention,
+        LockError,
+        LockNotHeld,
+        NoSuchFile,
+        UnlockableTransport,
+        )
+from bzrlib.transport import Transport
+from bzrlib.osutils import rand_chars
+from bzrlib.rio import RioWriter, read_stanza, Stanza
+
+# XXX: At the moment there is no consideration of thread safety on LockDir
+# objects.  This should perhaps be updated - e.g. if two threads try to take a
+# lock at the same time they should *both* get it.  But then that's unlikely
+# to be a good idea.
+
+# TODO: Transport could offer a simpler put() method that avoids the
+# rename-into-place for cases like creating the lock template, where there is
+# no chance that the file already exists.
+
+# TODO: Perhaps store some kind of note like the bzr command line in the lock
+# info?
+
+# TODO: Some kind of callback run while polling a lock to show progress
+# indicators.
+
+# TODO: Make sure to pass the right file and directory mode bits to all
+# files/dirs created.
+
+_DEFAULT_TIMEOUT_SECONDS = 300
+_DEFAULT_POLL_SECONDS = 0.5
+
+class LockDir(object):
+    """Write-lock guarding access to data."""
+
+    __INFO_NAME = '/info'
+
+    def __init__(self, transport, path, file_modebits=0644, dir_modebits=0755):
+        """Create a new LockDir object.
+
+        The LockDir is initially unlocked - this just creates the object.
+
+        :param transport: Transport which will contain the lock
+
+        :param path: Path to the lock within the base directory of the 
+            transport.
+        """
+        assert isinstance(transport, Transport), \
+            ("not a transport: %r" % transport)
+        self.transport = transport
+        self.path = path
+        self._lock_held = False
+        self._fake_read_lock = False
+        self._held_dir = path + '/held'
+        self._held_info_path = self._held_dir + self.__INFO_NAME
+        self._file_modebits = file_modebits
+        self._dir_modebits = dir_modebits
+        self.nonce = rand_chars(20)
+
+    def __repr__(self):
+        return '%s(%s%s)' % (self.__class__.__name__,
+                             self.transport.base,
+                             self.path)
+
+    is_held = property(lambda self: self._lock_held)
+
+    def create(self):
+        """Create the on-disk lock.
+
+        This is typically only called when the object/directory containing the 
+        directory is first created.  The lock is not held when it's created.
+        """
+        if self.transport.is_readonly():
+            raise UnlockableTransport(self.transport)
+        self.transport.mkdir(self.path)
+
+    def attempt_lock(self):
+        """Take the lock; fail if it's already held.
+        
+        If you wish to block until the lock can be obtained, call wait_lock()
+        instead.
+        """
+        if self._fake_read_lock:
+            raise LockContention(self)
+        if self.transport.is_readonly():
+            raise UnlockableTransport(self.transport)
+        try:
+            tmpname = '%s/pending.%s.tmp' % (self.path, rand_chars(20))
+            self.transport.mkdir(tmpname)
+            sio = StringIO()
+            self._prepare_info(sio)
+            sio.seek(0)
+            self.transport.put(tmpname + self.__INFO_NAME, sio)
+            self.transport.rename(tmpname, self._held_dir)
+            self._lock_held = True
+            self.confirm()
+            return
+        except (DirectoryNotEmpty, FileExists), e:
+            pass
+        # fall through to here on contention
+        raise LockContention(self)
+
+    def unlock(self):
+        """Release a held lock
+        """
+        if self._fake_read_lock:
+            self._fake_read_lock = False
+            return
+        if not self._lock_held:
+            raise LockNotHeld(self)
+        # rename before deleting, because we can't atomically remove the whole
+        # tree
+        tmpname = '%s/releasing.%s.tmp' % (self.path, rand_chars(20))
+        self.transport.rename(self._held_dir, tmpname)
+        self._lock_held = False
+        self.transport.delete(tmpname + self.__INFO_NAME)
+        self.transport.rmdir(tmpname)
+
+    def force_break(self, dead_holder_info):
+        """Release a lock held by another process.
+
+        WARNING: This should only be used when the other process is dead; if
+        it still thinks it has the lock there will be two concurrent writers.
+        In general the user's approval should be sought for lock breaks.
+
+        dead_holder_info must be the result of a previous LockDir.peek() call;
+        this is used to check that it's still held by the same process that
+        the user decided was dead.  If this is not the current holder,
+        LockBreakMismatch is raised.
+
+        After the lock is broken it will not be held by any process.
+        It is possible that another process may sneak in and take the 
+        lock before the breaking process acquires it.
+        """
+        if not isinstance(dead_holder_info, dict):
+            raise ValueError("dead_holder_info: %r" % dead_holder_info)
+        if self._lock_held:
+            raise AssertionError("can't break own lock: %r" % self)
+        current_info = self.peek()
+        if current_info is None:
+            # must have been recently released
+            return
+        if current_info != dead_holder_info:
+            raise LockBreakMismatch(self, current_info, dead_holder_info)
+        tmpname = '%s/broken.%s.tmp' % (self.path, rand_chars(20))
+        self.transport.rename(self._held_dir, tmpname)
+        # check that we actually broke the right lock, not someone else;
+        # there's a small race window between checking it and doing the 
+        # rename.
+        broken_info_path = tmpname + self.__INFO_NAME
+        broken_info = self._read_info_file(broken_info_path)
+        if broken_info != dead_holder_info:
+            raise LockBreakMismatch(self, broken_info, dead_holder_info)
+        self.transport.delete(broken_info_path)
+        self.transport.rmdir(tmpname)
+
+    def confirm(self):
+        """Make sure that the lock is still held by this locker.
+
+        This should only fail if the lock was broken by user intervention,
+        or if the lock has been affected by a bug.
+
+        If the lock is not thought to be held, raises LockNotHeld.  If
+        the lock is thought to be held but has been broken, raises 
+        LockBroken.
+        """
+        if not self._lock_held:
+            raise LockNotHeld(self)
+        info = self.peek()
+        if info is None:
+            # no lock there anymore!
+            raise LockBroken(self)
+        if info.get('nonce') != self.nonce:
+            # there is a lock, but not ours
+            raise LockBroken(self)
+        
+    def _read_info_file(self, path):
+        """Read one given info file.
+
+        peek() reads the info file of the lock holder, if any.
+        """
+        return self._parse_info(self.transport.get(path))
+
+    def peek(self):
+        """Check if the lock is held by anyone.
+        
+        If it is held, this returns the lock info structure as a rio Stanza,
+        which contains some information about the current lock holder.
+        Otherwise returns None.
+        """
+        try:
+            info = self._read_info_file(self._held_info_path)
+            assert isinstance(info, dict), \
+                    "bad parse result %r" % info
+            return info
+        except NoSuchFile, e:
+            return None
+
+    def _prepare_info(self, outf):
+        """Write information about a pending lock to a temporary file.
+        """
+        import socket
+        # XXX: is creating this here inefficient?
+        config = bzrlib.config.GlobalConfig()
+        s = Stanza(hostname=socket.gethostname(),
+                   pid=str(os.getpid()),
+                   start_time=str(int(time.time())),
+                   nonce=self.nonce,
+                   user=config.user_email(),
+                   )
+        RioWriter(outf).write_stanza(s)
+
+    def _parse_info(self, info_file):
+        return read_stanza(info_file.readlines()).as_dict()
+
+    def wait_lock(self, timeout=_DEFAULT_TIMEOUT_SECONDS,
+                  poll=_DEFAULT_POLL_SECONDS):
+        """Wait a certain period for a lock.
+
+        If the lock can be acquired within the bounded time, it
+        is taken and this returns.  Otherwise, LockContention
+        is raised.  Either way, this function should return within
+        approximately `timeout` seconds.  (It may be a bit more if
+        a transport operation takes a long time to complete.)
+        """
+        # XXX: the transport interface doesn't let us guard 
+        # against operations there taking a long time.
+        deadline = time.time() + timeout
+        while True:
+            try:
+                self.attempt_lock()
+                return
+            except LockContention:
+                pass
+            if time.time() + poll < deadline:
+                time.sleep(poll)
+            else:
+                raise LockContention(self)
+
+    def lock_write(self):
+        """Wait for and acquire the lock."""
+        self.attempt_lock()
+
+    def lock_read(self):
+        """Compatability-mode shared lock.
+
+        LockDir doesn't support shared read-only locks, so this 
+        just pretends that the lock is taken but really does nothing.
+        """
+        # At the moment Branches are commonly locked for read, but 
+        # we can't rely on that remotely.  Once this is cleaned up,
+        # reenable this warning to prevent it coming back in 
+        # -- mbp 20060303
+        ## warn("LockDir.lock_read falls back to write lock")
+        if self._lock_held or self._fake_read_lock:
+            raise LockContention(self)
+        self._fake_read_lock = True
+
+    def wait(self, timeout=20, poll=0.5):
+        """Wait a certain period for a lock to be released."""
+        # XXX: the transport interface doesn't let us guard 
+        # against operations there taking a long time.
+        deadline = time.time() + timeout
+        while True:
+            if self.peek():
+                return
+            if time.time() + poll < deadline:
+                time.sleep(poll)
+            else:
+                raise LockContention(self)
+

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2006-01-25 14:30:06 +0000
+++ bzrlib/log.py	2006-03-20 08:31:00 +0000
@@ -74,7 +74,7 @@
     last_path = None
     revno = 1
     for revision_id in branch.revision_history():
-        this_inv = branch.get_revision_inventory(revision_id)
+        this_inv = branch.repository.get_revision_inventory(revision_id)
         if file_id in this_inv:
             this_ie = this_inv[file_id]
             this_path = this_inv.id2path(file_id)
@@ -223,7 +223,7 @@
             # although we calculated it, throw it away without display
             delta = None
 
-        rev = branch.get_revision(rev_id)
+        rev = branch.repository.get_revision(rev_id)
 
         if searchRE:
             if not searchRE.search(rev.message):
@@ -235,7 +235,9 @@
                 excludes = set()
             else:
                 # revno is 1 based, so -2 to get back 1 less.
-                excludes = set(branch.get_ancestry(revision_history[revno - 2]))
+                repository = branch.repository
+                excludes = repository.get_ancestry(revision_history[revno - 2])
+                excludes = set(excludes)
             pending = list(rev.parent_ids)
             while pending:
                 rev_id = pending.pop()
@@ -244,7 +246,7 @@
                 # prevent showing merged revs twice if they multi-path.
                 excludes.add(rev_id)
                 try:
-                    rev = branch.get_revision(rev_id)
+                    rev = branch.repository.get_revision(rev_id)
                 except errors.NoSuchRevision:
                     continue
                 pending.extend(rev.parent_ids)
@@ -448,11 +450,14 @@
     lf = LineLogFormatter(None)
     return lf.log_string(rev, max_chars)
 
-FORMATTERS = {'long': LongLogFormatter,
+FORMATTERS = {
+              'long': LongLogFormatter,
               'short': ShortLogFormatter,
               'line': LineLogFormatter,
               }
 
+def register_formatter(name, formatter):
+    FORMATTERS[name] = formatter
 
 def log_formatter(name, *args, **kwargs):
     """Construct a formatter from arguments.
@@ -463,7 +468,7 @@
     from bzrlib.errors import BzrCommandError
     try:
         return FORMATTERS[name](*args, **kwargs)
-    except IndexError:
+    except KeyError:
         raise BzrCommandError("unknown log formatter: %r" % name)
 
 def show_one_log(revno, rev, delta, verbose, to_file, show_timezone):
@@ -510,7 +515,7 @@
         to_file.write('*'*60)
         to_file.write('\nRemoved Revisions:\n')
         for i in range(base_idx, len(old_rh)):
-            rev = branch.get_revision(old_rh[i])
+            rev = branch.repository.get_revision(old_rh[i])
             lf.show(i+1, rev, None)
         to_file.write('*'*60)
         to_file.write('\n\n')

=== modified file 'bzrlib/merge.py' (properties changed: +x to -x)
--- bzrlib/merge.py	2006-01-25 14:30:06 +0000
+++ bzrlib/merge.py	2006-03-20 08:31:00 +0000
@@ -16,217 +16,38 @@
 
 
 import os
-import shutil
 import errno
+from shutil import rmtree
+from tempfile import mkdtemp
 
-import bzrlib.osutils
-import bzrlib.revision
-from bzrlib.merge_core import merge_flex, ApplyMerge3, BackupBeforeChange
-from bzrlib.merge_core import WeaveMerge
-from bzrlib.changeset import generate_changeset, ExceptionConflictHandler
-from bzrlib.changeset import Inventory, Diff3Merge, ReplaceContents
+import bzrlib
 from bzrlib.branch import Branch
+from bzrlib.delta import compare_trees
 from bzrlib.errors import (BzrCommandError,
-                           UnrelatedBranches,
+                           BzrError,
                            NoCommonAncestor,
                            NoCommits,
-                           WorkingTreeNotRevision,
+                           NoSuchRevision,
+                           NoSuchFile,
                            NotBranchError,
                            NotVersionedError,
-                           BzrError)
-from bzrlib.delta import compare_trees
+                           UnrelatedBranches,
+                           WorkingTreeNotRevision,
+                           )
+from bzrlib.merge3 import Merge3
+import bzrlib.osutils
+from bzrlib.osutils import rename, pathjoin
+from progress import DummyProgress
+from bzrlib.revision import common_ancestor, is_ancestor, NULL_REVISION
+from bzrlib.symbol_versioning import *
 from bzrlib.trace import mutter, warning, note
-from bzrlib.fetch import greedy_fetch, fetch
-from bzrlib.revision import is_ancestor, NULL_REVISION
-from bzrlib.osutils import rename, pathjoin
-from bzrlib.revision import common_ancestor, MultipleRevisionSources
-from bzrlib.errors import NoSuchRevision
+from bzrlib.transform import (TreeTransform, resolve_conflicts, cook_conflicts,
+                              conflicts_strings, FinalPaths, create_by_entry,
+                              unique_add)
 
 # TODO: Report back as changes are merged in
 
-# TODO: build_working_dir can be built on something simpler than merge()
-
-# FIXME: merge() parameters seem oriented towards the command line
-# NOTABUG: merge is a helper for commandline functions.  merge_inner is the
-#          the core functionality.
-
-# comments from abentley on irc: merge happens in two stages, each
-# of which generates a changeset object
-
-# stage 1: generate OLD->OTHER,
-# stage 2: use MINE and OLD->OTHER to generate MINE -> RESULT
-
-class MergeConflictHandler(ExceptionConflictHandler):
-    """Handle conflicts encountered while merging.
-
-    This subclasses ExceptionConflictHandler, so that any types of
-    conflict that are not explicitly handled cause an exception and
-    terminate the merge.
-    """
-    def __init__(self, this_tree, base_tree, other_tree, ignore_zero=False):
-        ExceptionConflictHandler.__init__(self)
-        self.conflicts = 0
-        self.ignore_zero = ignore_zero
-        self.this_tree = this_tree
-        self.base_tree = base_tree
-        self.other_tree = other_tree
-
-    def copy(self, source, dest):
-        """Copy the text and mode of a file
-        :param source: The path of the file to copy
-        :param dest: The distination file to create
-        """
-        s_file = file(source, "rb")
-        d_file = file(dest, "wb")
-        for line in s_file:
-            d_file.write(line)
-        os.chmod(dest, 0777 & os.stat(source).st_mode)
-
-    def dump(self, lines, dest):
-        """Copy the text and mode of a file
-        :param source: The path of the file to copy
-        :param dest: The distination file to create
-        """
-        d_file = file(dest, "wb")
-        for line in lines:
-            d_file.write(line)
-
-    def add_suffix(self, name, suffix, last_new_name=None, fix_inventory=True):
-        """Rename a file to append a suffix.  If the new name exists, the
-        suffix is added repeatedly until a non-existant name is found
-
-        :param name: The path of the file
-        :param suffix: The suffix to append
-        :param last_new_name: (used for recursive calls) the last name tried
-        """
-        if last_new_name is None:
-            last_new_name = name
-        new_name = last_new_name+suffix
-        try:
-            rename(name, new_name)
-            if fix_inventory is True:
-                try:
-                    relpath = self.this_tree.relpath(name)
-                except NotBranchError:
-                    relpath = None
-                if relpath is not None:
-                    file_id = self.this_tree.path2id(relpath)
-                    if file_id is not None:
-                        new_path = self.this_tree.relpath(new_name)
-                        rename(new_name, name)
-                        self.this_tree.rename_one(relpath, new_path)
-                        assert self.this_tree.id2path(file_id) == new_path
-        except OSError, e:
-            if e.errno != errno.EEXIST and e.errno != errno.ENOTEMPTY:
-                raise
-            return self.add_suffix(name, suffix, last_new_name=new_name, 
-                                   fix_inventory=fix_inventory)
-        return new_name
-
-    def conflict(self, text):
-        warning(text)
-        self.conflicts += 1
-        
-
-    def merge_conflict(self, new_file, this_path, base_lines, other_lines):
-        """
-        Handle diff3 conflicts by producing a .THIS, .BASE and .OTHER.  The
-        main file will be a version with diff3 conflicts.
-        :param new_file: Path to the output file with diff3 markers
-        :param this_path: Path to the file text for the THIS tree
-        :param base_path: Path to the file text for the BASE tree
-        :param other_path: Path to the file text for the OTHER tree
-        """
-        self.add_suffix(this_path, ".THIS", fix_inventory=False)
-        self.dump(base_lines, this_path+".BASE")
-        self.dump(other_lines, this_path+".OTHER")
-        rename(new_file, this_path)
-        self.conflict("Diff3 conflict encountered in %s" % this_path)
-
-    def weave_merge_conflict(self, filename, weave, other_i, out_file):
-        """
-        Handle weave conflicts by producing a .THIS, and .OTHER.  The
-        main file will be a version with diff3-style conflicts.
-        """
-        self.add_suffix(filename, ".THIS", fix_inventory=False)
-        out_file.commit()
-        self.dump(weave.get_iter(other_i), filename+".OTHER")
-        self.conflict("Text conflict encountered in %s" % filename)
-
-    def new_contents_conflict(self, filename, other_contents):
-        """Conflicting contents for newly added file."""
-        other_contents(filename + ".OTHER", self, False)
-        self.conflict("Conflict in newly added file %s" % filename)
-    
-
-    def target_exists(self, entry, target, old_path):
-        """Handle the case when the target file or dir exists"""
-        moved_path = self.add_suffix(target, ".moved")
-        self.conflict("Moved existing %s to %s" % (target, moved_path))
-
-    def rmdir_non_empty(self, filename):
-        """Handle the case where the dir to be removed still has contents"""
-        self.conflict("Directory %s not removed because it is not empty"\
-            % filename)
-        return "skip"
-
-    def rem_contents_conflict(self, filename, this_contents, base_contents):
-        base_contents(filename+".BASE", self)
-        this_contents(filename+".THIS", self)
-        self.conflict("Other branch deleted locally modified file %s" %
-                      filename)
-        return ReplaceContents(this_contents, None)
-
-    def abs_this_path(self, file_id):
-        """Return the absolute path for a file_id in the this tree."""
-        return self.this_tree.id2abspath(file_id)
-
-    def add_missing_parents(self, file_id, tree):
-        """If some of the parents for file_id are missing, add them."""
-        entry = tree.inventory[file_id]
-        if entry.parent_id not in self.this_tree:
-            return self.create_all_missing(entry.parent_id, tree)
-        else:
-            return self.abs_this_path(entry.parent_id)
-
-    def create_all_missing(self, file_id, tree):
-        """Add contents for a file_id and all its parents to a tree."""
-        entry = tree.inventory[file_id]
-        if entry.parent_id is not None and entry.parent_id not in self.this_tree:
-            abspath = self.create_all_missing(entry.parent_id, tree)
-        else:
-            abspath = self.abs_this_path(entry.parent_id)
-        entry_path = pathjoin(abspath, entry.name)
-        if not os.path.isdir(entry_path):
-            self.create(file_id, entry_path, tree)
-        return entry_path
-
-    def create(self, file_id, path, tree):
-        """Uses tree data to create a filesystem object for the file_id"""
-        from changeset import get_contents
-        get_contents(tree, file_id)(path, self)
-
-    def missing_for_merge(self, file_id, other_path):
-        """The file_id doesn't exist in THIS, but does in OTHER and BASE"""
-        self.conflict("Other branch modified locally deleted file %s" %
-                      other_path)
-        parent_dir = self.add_missing_parents(file_id, self.other_tree)
-        stem = pathjoin(parent_dir, os.path.basename(other_path))
-        self.create(file_id, stem+".OTHER", self.other_tree)
-        self.create(file_id, stem+".BASE", self.base_tree)
-
-    def threeway_contents_conflict(filename, this_contents, base_contents,
-                                   other_contents):
-        self.conflict("Three-way conflict merging %s" % filename)
-
-    def finalize(self):
-        if self.conflicts == 0:
-            if not self.ignore_zero:
-                note("All changes applied successfully.")
-        else:
-            note("%d conflicts encountered." % self.conflicts)
-            
-def get_tree(treespec, local_branch=None):
+def _get_tree(treespec, local_branch=None):
     location, revno = treespec
     branch = Branch.open_containing(location)[0]
     if revno is None:
@@ -237,145 +58,36 @@
         revision = branch.get_rev_id(revno)
         if revision is None:
             revision = NULL_REVISION
-    return branch, get_revid_tree(branch, revision, local_branch)
-
-def get_revid_tree(branch, revision, local_branch):
+    return branch, _get_revid_tree(branch, revision, local_branch)
+
+
+def _get_revid_tree(branch, revision, local_branch):
     if revision is None:
-        base_tree = branch.working_tree()
+        base_tree = branch.bzrdir.open_workingtree()
     else:
         if local_branch is not None:
-            greedy_fetch(local_branch, branch, revision)
-            base_tree = local_branch.revision_tree(revision)
+            if local_branch.base != branch.base:
+                local_branch.fetch(branch, revision)
+            base_tree = local_branch.repository.revision_tree(revision)
         else:
-            base_tree = branch.revision_tree(revision)
+            base_tree = branch.repository.revision_tree(revision)
     return base_tree
 
 
-def file_exists(tree, file_id):
-    return tree.has_filename(tree.id2path(file_id))
-    
-
-def build_working_dir(to_dir):
-    """Build a working directory in an empty directory.
-
-    to_dir is a directory containing branch metadata but no working files,
-    typically constructed by cloning an existing branch. 
-
-    This is split out as a special idiomatic case of merge.  It could
-    eventually be done by just building the tree directly calling into 
-    lower-level code (e.g. constructing a changeset).
-    """
-    # RBC 20051019 is this not just 'export' ?
-    # AB Well, export doesn't take care of inventory...
-    this_branch = Branch.open_containing(to_dir)[0]
-    transform_tree(this_branch.working_tree(), this_branch.basis_tree())
-
-
 def transform_tree(from_tree, to_tree, interesting_ids=None):
     merge_inner(from_tree.branch, to_tree, from_tree, ignore_zero=True,
-                interesting_ids=interesting_ids)
-
-
-def merge(other_revision, base_revision,
-          check_clean=True, ignore_zero=False,
-          this_dir=None, backup_files=False, merge_type=ApplyMerge3,
-          file_list=None, show_base=False, reprocess=False):
-    """Merge changes into a tree.
-
-    base_revision
-        list(path, revno) Base for three-way merge.  
-        If [None, None] then a base will be automatically determined.
-    other_revision
-        list(path, revno) Other revision for three-way merge.
-    this_dir
-        Directory to merge changes into; '.' by default.
-    check_clean
-        If true, this_dir must have no uncommitted changes before the
-        merge begins.
-    ignore_zero - If true, suppress the "zero conflicts" message when 
-        there are no conflicts; should be set when doing something we expect
-        to complete perfectly.
-    file_list - If supplied, merge only changes to selected files.
-
-    All available ancestors of other_revision and base_revision are
-    automatically pulled into the branch.
-
-    The revno may be -1 to indicate the last revision on the branch, which is
-    the typical case.
-
-    This function is intended for use from the command line; programmatic
-    clients might prefer to call merge_inner(), which has less magic behavior.
-    """
-    if this_dir is None:
-        this_dir = u'.'
-    this_branch = Branch.open_containing(this_dir)[0]
-    if show_base and not merge_type is ApplyMerge3:
-        raise BzrCommandError("Show-base is not supported for this merge"
-                              " type. %s" % merge_type)
-    if reprocess and not merge_type is ApplyMerge3:
-        raise BzrCommandError("Reprocess is not supported for this merge"
-                              " type. %s" % merge_type)
-    if reprocess and show_base:
-        raise BzrCommandError("Cannot reprocess and show base.")
-    merger = Merger(this_branch)
-    merger.check_basis(check_clean)
-    merger.set_other(other_revision)
-    merger.set_base(base_revision)
-    if merger.base_rev_id == merger.other_rev_id:
-        note('Nothing to do.')
-        return 0
-    merger.backup_files = backup_files
-    merger.merge_type = merge_type 
-    merger.set_interesting_files(file_list)
-    merger.show_base = show_base 
-    merger.reprocess = reprocess
-    merger.conflict_handler = MergeConflictHandler(merger.this_tree, 
-                                                   merger.base_tree, 
-                                                   merger.other_tree,
-                                                   ignore_zero=ignore_zero)
-    conflicts = merger.do_merge()
-    merger.set_pending()
-    return conflicts
-
-def merge_inner(this_branch, other_tree, base_tree, ignore_zero=False,
-                backup_files=False, 
-                merge_type=ApplyMerge3, 
-                interesting_ids=None, 
-                show_base=False, 
-                reprocess=False, 
-                other_rev_id=None,
-                interesting_files=None):
-    """Primary interface for merging. 
-
-        typical use is probably 
-        'merge_inner(branch, branch.get_revision_tree(other_revision),
-                     branch.get_revision_tree(base_revision))'
-        """
-    merger = Merger(this_branch, other_tree, base_tree)
-    merger.backup_files = backup_files
-    merger.merge_type = merge_type
-    merger.interesting_ids = interesting_ids
-    if interesting_files:
-        assert not interesting_ids, ('Only supply interesting_ids'
-                                     ' or interesting_files')
-        merger._set_interesting_files(interesting_files)
-    merger.show_base = show_base 
-    merger.reprocess = reprocess
-    merger.conflict_handler = MergeConflictHandler(merger.this_tree, base_tree, 
-                                                   other_tree,
-                                                   ignore_zero=ignore_zero)
-    merger.other_rev_id = other_rev_id
-    merger.other_basis = other_rev_id
-    return merger.do_merge()
+                interesting_ids=interesting_ids, this_tree=from_tree)
 
 
 class Merger(object):
-    def __init__(self, this_branch, other_tree=None, base_tree=None):
+    def __init__(self, this_branch, other_tree=None, base_tree=None, 
+                 this_tree=None, pb=DummyProgress()):
         object.__init__(self)
+        assert this_tree is not None, "this_tree is required"
         self.this_branch = this_branch
         self.this_basis = this_branch.last_revision()
         self.this_rev_id = None
-        self.this_tree = this_branch.working_tree()
+        self.this_tree = this_tree
         self.this_revision_tree = None
         self.this_basis_tree = None
         self.other_tree = other_tree
@@ -385,20 +97,18 @@
         self.interesting_ids = None
         self.show_base = False
         self.reprocess = False
-        self.conflict_handler = MergeConflictHandler(self.this_tree, base_tree, 
-                                                     other_tree)
+        self._pb = pb 
 
     def revision_tree(self, revision_id):
-        return self.this_branch.revision_tree(revision_id)
+        return self.this_branch.repository.revision_tree(revision_id)
 
     def ensure_revision_trees(self):
         if self.this_revision_tree is None:
-            self.this_basis_tree = self.this_branch.revision_tree(
+            self.this_basis_tree = self.this_branch.repository.revision_tree(
                 self.this_basis)
             if self.this_basis == self.this_rev_id:
                 self.this_revision_tree = self.this_basis_tree
 
-
         if self.other_rev_id is None:
             other_basis_tree = self.revision_tree(self.other_basis)
             changes = compare_trees(self.other_tree, other_basis_tree)
@@ -407,7 +117,6 @@
             other_rev_id = other_basis
             self.other_tree = other_basis_tree
 
-
     def file_revisions(self, file_id):
         self.ensure_revision_trees()
         def get_id(tree, file_id):
@@ -421,28 +130,6 @@
 
         trees = (self.this_basis_tree, self.other_tree)
         return [get_id(tree, file_id) for tree in trees]
-            
-
-    def merge_factory(self, file_id, base, other):
-        if self.merge_type.history_based:
-            if self.show_base is True:
-                raise BzrError("Cannot show base for hisory-based merges")
-            if self.reprocess is True:
-                raise BzrError("Cannot reprocess history-based merges")
-                
-            t_revid, o_revid = self.file_revisions(file_id)
-            weave = self.this_basis_tree.get_weave(file_id)
-            contents_change = self.merge_type(weave, t_revid, o_revid)
-        else:
-            if self.show_base is True or self.reprocess is True:
-                contents_change = self.merge_type(file_id, base, other, 
-                                                  show_base=self.show_base, 
-                                                  reprocess=self.reprocess)
-            else:
-                contents_change = self.merge_type(file_id, base, other)
-        if self.backup_files:
-            contents_change = BackupBeforeChange(contents_change)
-        return contents_change
 
     def check_basis(self, check_clean):
         if self.this_basis is None:
@@ -453,8 +140,8 @@
                 raise BzrCommandError("Working tree has uncommitted changes.")
 
     def compare_basis(self):
-        changes = compare_trees(self.this_branch.working_tree(), 
-                                self.this_branch.basis_tree(), False)
+        changes = compare_trees(self.this_tree, 
+                                self.this_tree.basis_tree(), False)
         if not changes.has_changed():
             self.this_rev_id = self.this_basis
 
@@ -472,8 +159,7 @@
             return
 
         interesting_ids = set()
-        for fname in file_list:
-            path = self.this_tree.relpath(fname)
+        for path in file_list:
             found_id = False
             for tree in (self.this_tree, self.base_tree, self.other_tree):
                 file_id = tree.inventory.path2id(path)
@@ -481,7 +167,7 @@
                     interesting_ids.add(file_id)
                     found_id = True
             if not found_id:
-                raise NotVersionedError(path=fname)
+                raise NotVersionedError(path=path)
         self.interesting_ids = interesting_ids
 
     def set_pending(self):
@@ -489,13 +175,14 @@
             return
         if self.other_rev_id is None:
             return
-        if self.other_rev_id in self.this_branch.get_ancestry(self.this_basis):
+        ancestry = self.this_branch.repository.get_ancestry(self.this_basis)
+        if self.other_rev_id in ancestry:
             return
-        self.this_branch.working_tree().add_pending_merge(self.other_rev_id)
+        self.this_tree.add_pending_merge(self.other_rev_id)
 
     def set_other(self, other_revision):
-        other_branch, self.other_tree = get_tree(other_revision, 
-                                                 self.this_branch)
+        other_branch, self.other_tree = _get_tree(other_revision, 
+                                                  self.this_branch)
         if other_revision[1] == -1:
             self.other_rev_id = other_branch.last_revision()
             if self.other_rev_id is None:
@@ -509,8 +196,8 @@
             self.other_basis = other_branch.last_revision()
             if self.other_basis is None:
                 raise NoCommits(other_branch)
-        fetch(from_branch=other_branch, to_branch=self.this_branch, 
-              last_revision=self.other_basis)
+        if other_branch.base != self.this_branch.base:
+            self.this_branch.fetch(other_branch, last_revision=self.other_basis)
 
     def set_base(self, base_revision):
         mutter("doing merge() with no base_revision specified")
@@ -518,53 +205,53 @@
             try:
                 self.base_rev_id = common_ancestor(self.this_basis, 
                                                    self.other_basis, 
-                                                   self.this_branch)
+                                                   self.this_branch.repository,
+                                                   self._pb)
             except NoCommonAncestor:
                 raise UnrelatedBranches()
-            self.base_tree = get_revid_tree(self.this_branch, self.base_rev_id,
+            self.base_tree = _get_revid_tree(self.this_branch, self.base_rev_id,
                                             None)
             self.base_is_ancestor = True
         else:
-            base_branch, self.base_tree = get_tree(base_revision)
+            base_branch, self.base_tree = _get_tree(base_revision)
             if base_revision[1] == -1:
                 self.base_rev_id = base_branch.last_revision()
             elif base_revision[1] is None:
                 self.base_rev_id = None
             else:
                 self.base_rev_id = base_branch.get_rev_id(base_revision[1])
-            fetch(from_branch=base_branch, to_branch=self.this_branch)
+            self.this_branch.fetch(base_branch)
             self.base_is_ancestor = is_ancestor(self.this_basis, 
                                                 self.base_rev_id,
                                                 self.this_branch)
 
     def do_merge(self):
-        def get_inventory(tree):
-            return tree.inventory
-        
-        inv_changes = merge_flex(self.this_tree, self.base_tree, 
-                                 self.other_tree,
-                                 generate_changeset, get_inventory,
-                                 self.conflict_handler,
-                                 merge_factory=self.merge_factory, 
-                                 interesting_ids=self.interesting_ids)
+        kwargs = {'working_tree':self.this_tree, 'this_tree': self.this_tree, 
+                  'other_tree': self.other_tree, 
+                  'interesting_ids': self.interesting_ids}
+        if self.merge_type.requires_base:
+            kwargs['base_tree'] = self.base_tree
+        if self.merge_type.supports_reprocess:
+            kwargs['reprocess'] = self.reprocess
+        elif self.reprocess:
+            raise BzrError("Reprocess is not supported for this merge"
+                                  " type. %s" % merge_type)
+        if self.merge_type.supports_show_base:
+            kwargs['show_base'] = self.show_base
+        elif self.show_base:
+            raise BzrError("Showing base is not supported for this"
+                                  " merge type. %s" % self.merge_type)
+        merge = self.merge_type(pb=self._pb, **kwargs)
+        if len(merge.cooked_conflicts) == 0:
+            if not self.ignore_zero:
+                note("All changes applied successfully.")
+        else:
+            note("%d conflicts encountered." % len(merge.cooked_conflicts))
 
-        adjust_ids = []
-        for id, path in inv_changes.iteritems():
-            if path is not None:
-                if path == u'.':
-                    path = u''
-                else:
-                    assert path.startswith('.' + '/') or path.startswith('.' + '\\'), "path is %s" % path
-                path = path[2:]
-            adjust_ids.append((path, id))
-        if len(adjust_ids) > 0:
-            self.this_branch.working_tree().set_inventory(self.regen_inventory(adjust_ids))
-        conflicts = self.conflict_handler.conflicts
-        self.conflict_handler.finalize()
-        return conflicts
+        return len(merge.cooked_conflicts)
 
     def regen_inventory(self, new_entries):
-        old_entries = self.this_branch.working_tree().read_working_inventory()
+        old_entries = self.this_tree.read_working_inventory()
         new_inventory = {}
         by_path = {}
         new_entries_map = {} 
@@ -623,8 +310,543 @@
         new_inventory_list.sort()
         return new_inventory_list
 
-merge_types = {     "merge3": (ApplyMerge3, "Native diff3-style merge"), 
-                     "diff3": (Diff3Merge,  "Merge using external diff3"),
-                     'weave': (WeaveMerge, "Weave-based merge")
+
+class Merge3Merger(object):
+    """Three-way merger that uses the merge3 text merger"""
+    requires_base = True
+    supports_reprocess = True
+    supports_show_base = True
+    history_based = False
+
+    def __init__(self, working_tree, this_tree, base_tree, other_tree, 
+                 interesting_ids=None, reprocess=False, show_base=False,
+                 pb=DummyProgress()):
+        """Initialize the merger object and perform the merge."""
+        object.__init__(self)
+        self.this_tree = working_tree
+        self.base_tree = base_tree
+        self.other_tree = other_tree
+        self._raw_conflicts = []
+        self.cooked_conflicts = []
+        self.reprocess = reprocess
+        self.show_base = show_base
+        self.pb = pb
+
+        if interesting_ids is not None:
+            all_ids = interesting_ids
+        else:
+            all_ids = set(base_tree)
+            all_ids.update(other_tree)
+        self.tt = TreeTransform(working_tree, self.pb)
+        try:
+            for num, file_id in enumerate(all_ids):
+                self.pb.update('Preparing file merge', num+1, len(all_ids))
+                self.merge_names(file_id)
+                file_status = self.merge_contents(file_id)
+                self.merge_executable(file_id, file_status)
+            self.pb.clear()
+                
+            fs_conflicts = resolve_conflicts(self.tt, self.pb)
+            self.cook_conflicts(fs_conflicts)
+            for line in conflicts_strings(self.cooked_conflicts):
+                warning(line)
+            self.tt.apply()
+        finally:
+            try:
+                self.tt.finalize()
+            except:
+                pass
+       
+    @staticmethod
+    def parent(entry, file_id):
+        """Determine the parent for a file_id (used as a key method)"""
+        if entry is None:
+            return None
+        return entry.parent_id
+
+    @staticmethod
+    def name(entry, file_id):
+        """Determine the name for a file_id (used as a key method)"""
+        if entry is None:
+            return None
+        return entry.name
+    
+    @staticmethod
+    def contents_sha1(tree, file_id):
+        """Determine the sha1 of the file contents (used as a key method)."""
+        if file_id not in tree:
+            return None
+        return tree.get_file_sha1(file_id)
+
+    @staticmethod
+    def executable(tree, file_id):
+        """Determine the executability of a file-id (used as a key method)."""
+        if file_id not in tree:
+            return None
+        if tree.kind(file_id) != "file":
+            return False
+        return tree.is_executable(file_id)
+
+    @staticmethod
+    def kind(tree, file_id):
+        """Determine the kind of a file-id (used as a key method)."""
+        if file_id not in tree:
+            return None
+        return tree.kind(file_id)
+
+    @staticmethod
+    def scalar_three_way(this_tree, base_tree, other_tree, file_id, key):
+        """Do a three-way test on a scalar.
+        Return "this", "other" or "conflict", depending whether a value wins.
+        """
+        key_base = key(base_tree, file_id)
+        key_other = key(other_tree, file_id)
+        #if base == other, either they all agree, or only THIS has changed.
+        if key_base == key_other:
+            return "this"
+        key_this = key(this_tree, file_id)
+        if key_this not in (key_base, key_other):
+            return "conflict"
+        # "Ambiguous clean merge"
+        elif key_this == key_other:
+            return "this"
+        else:
+            assert key_this == key_base
+            return "other"
+
+    def merge_names(self, file_id):
+        """Perform a merge on file_id names and parents"""
+        def get_entry(tree):
+            if file_id in tree.inventory:
+                return tree.inventory[file_id]
+            else:
+                return None
+        this_entry = get_entry(self.this_tree)
+        other_entry = get_entry(self.other_tree)
+        base_entry = get_entry(self.base_tree)
+        name_winner = self.scalar_three_way(this_entry, base_entry, 
+                                            other_entry, file_id, self.name)
+        parent_id_winner = self.scalar_three_way(this_entry, base_entry, 
+                                                 other_entry, file_id, 
+                                                 self.parent)
+        if this_entry is None:
+            if name_winner == "this":
+                name_winner = "other"
+            if parent_id_winner == "this":
+                parent_id_winner = "other"
+        if name_winner == "this" and parent_id_winner == "this":
+            return
+        if name_winner == "conflict":
+            trans_id = self.tt.trans_id_file_id(file_id)
+            self._raw_conflicts.append(('name conflict', trans_id, 
+                                        self.name(this_entry, file_id), 
+                                        self.name(other_entry, file_id)))
+        if parent_id_winner == "conflict":
+            trans_id = self.tt.trans_id_file_id(file_id)
+            self._raw_conflicts.append(('parent conflict', trans_id, 
+                                        self.parent(this_entry, file_id), 
+                                        self.parent(other_entry, file_id)))
+        if other_entry is None:
+            # it doesn't matter whether the result was 'other' or 
+            # 'conflict'-- if there's no 'other', we leave it alone.
+            return
+        # if we get here, name_winner and parent_winner are set to safe values.
+        winner_entry = {"this": this_entry, "other": other_entry, 
+                        "conflict": other_entry}
+        trans_id = self.tt.trans_id_file_id(file_id)
+        parent_id = winner_entry[parent_id_winner].parent_id
+        parent_trans_id = self.tt.trans_id_file_id(parent_id)
+        self.tt.adjust_path(winner_entry[name_winner].name, parent_trans_id,
+                            trans_id)
+
+    def merge_contents(self, file_id):
+        """Performa a merge on file_id contents."""
+        def contents_pair(tree):
+            if file_id not in tree:
+                return (None, None)
+            kind = tree.kind(file_id)
+            if kind == "root_directory":
+                kind = "directory"
+            if kind == "file":
+                contents = tree.get_file_sha1(file_id)
+            elif kind == "symlink":
+                contents = tree.get_symlink_target(file_id)
+            else:
+                contents = None
+            return kind, contents
+        # See SPOT run.  run, SPOT, run.
+        # So we're not QUITE repeating ourselves; we do tricky things with
+        # file kind...
+        base_pair = contents_pair(self.base_tree)
+        other_pair = contents_pair(self.other_tree)
+        if base_pair == other_pair:
+            # OTHER introduced no changes
+            return "unmodified"
+        this_pair = contents_pair(self.this_tree)
+        if this_pair == other_pair:
+            # THIS and OTHER introduced the same changes
+            return "unmodified"
+        else:
+            trans_id = self.tt.trans_id_file_id(file_id)
+            if this_pair == base_pair:
+                # only OTHER introduced changes
+                if file_id in self.this_tree:
+                    # Remove any existing contents
+                    self.tt.delete_contents(trans_id)
+                if file_id in self.other_tree:
+                    # OTHER changed the file
+                    create_by_entry(self.tt, 
+                                    self.other_tree.inventory[file_id], 
+                                    self.other_tree, trans_id)
+                    if file_id not in self.this_tree.inventory:
+                        self.tt.version_file(file_id, trans_id)
+                    return "modified"
+                elif file_id in self.this_tree.inventory:
+                    # OTHER deleted the file
+                    self.tt.unversion_file(trans_id)
+                    return "deleted"
+            #BOTH THIS and OTHER introduced changes; scalar conflict
+            elif this_pair[0] == "file" and other_pair[0] == "file":
+                # THIS and OTHER are both files, so text merge.  Either
+                # BASE is a file, or both converted to files, so at least we
+                # have agreement that output should be a file.
+                if file_id not in self.this_tree.inventory:
+                    self.tt.version_file(file_id, trans_id)
+                self.text_merge(file_id, trans_id)
+                try:
+                    self.tt.tree_kind(trans_id)
+                    self.tt.delete_contents(trans_id)
+                except NoSuchFile:
+                    pass
+                return "modified"
+            else:
+                # Scalar conflict, can't text merge.  Dump conflicts
+                trans_id = self.tt.trans_id_file_id(file_id)
+                name = self.tt.final_name(trans_id)
+                parent_id = self.tt.final_parent(trans_id)
+                if file_id in self.this_tree.inventory:
+                    self.tt.unversion_file(trans_id)
+                    self.tt.delete_contents(trans_id)
+                file_group = self._dump_conflicts(name, parent_id, file_id, 
+                                                  set_version=True)
+                self._raw_conflicts.append(('contents conflict', file_group))
+
+    def get_lines(self, tree, file_id):
+        """Return the lines in a file, or an empty list."""
+        if file_id in tree:
+            return tree.get_file(file_id).readlines()
+        else:
+            return []
+
+    def text_merge(self, file_id, trans_id):
+        """Perform a three-way text merge on a file_id"""
+        # it's possible that we got here with base as a different type.
+        # if so, we just want two-way text conflicts.
+        if file_id in self.base_tree and \
+            self.base_tree.kind(file_id) == "file":
+            base_lines = self.get_lines(self.base_tree, file_id)
+        else:
+            base_lines = []
+        other_lines = self.get_lines(self.other_tree, file_id)
+        this_lines = self.get_lines(self.this_tree, file_id)
+        m3 = Merge3(base_lines, this_lines, other_lines)
+        start_marker = "!START OF MERGE CONFLICT!" + "I HOPE THIS IS UNIQUE"
+        if self.show_base is True:
+            base_marker = '|' * 7
+        else:
+            base_marker = None
+
+        def iter_merge3(retval):
+            retval["text_conflicts"] = False
+            for line in m3.merge_lines(name_a = "TREE", 
+                                       name_b = "MERGE-SOURCE", 
+                                       name_base = "BASE-REVISION",
+                                       start_marker=start_marker, 
+                                       base_marker=base_marker,
+                                       reprocess=self.reprocess):
+                if line.startswith(start_marker):
+                    retval["text_conflicts"] = True
+                    yield line.replace(start_marker, '<' * 7)
+                else:
+                    yield line
+        retval = {}
+        merge3_iterator = iter_merge3(retval)
+        self.tt.create_file(merge3_iterator, trans_id)
+        if retval["text_conflicts"] is True:
+            self._raw_conflicts.append(('text conflict', trans_id))
+            name = self.tt.final_name(trans_id)
+            parent_id = self.tt.final_parent(trans_id)
+            file_group = self._dump_conflicts(name, parent_id, file_id, 
+                                              this_lines, base_lines,
+                                              other_lines)
+            file_group.append(trans_id)
+
+    def _dump_conflicts(self, name, parent_id, file_id, this_lines=None, 
+                        base_lines=None, other_lines=None, set_version=False,
+                        no_base=False):
+        """Emit conflict files.
+        If this_lines, base_lines, or other_lines are omitted, they will be
+        determined automatically.  If set_version is true, the .OTHER, .THIS
+        or .BASE (in that order) will be created as versioned files.
+        """
+        data = [('OTHER', self.other_tree, other_lines), 
+                ('THIS', self.this_tree, this_lines)]
+        if not no_base:
+            data.append(('BASE', self.base_tree, base_lines))
+        versioned = False
+        file_group = []
+        for suffix, tree, lines in data:
+            if file_id in tree:
+                trans_id = self._conflict_file(name, parent_id, tree, file_id,
+                                               suffix, lines)
+                file_group.append(trans_id)
+                if set_version and not versioned:
+                    self.tt.version_file(file_id, trans_id)
+                    versioned = True
+        return file_group
+           
+    def _conflict_file(self, name, parent_id, tree, file_id, suffix, 
+                       lines=None):
+        """Emit a single conflict file."""
+        name = name + '.' + suffix
+        trans_id = self.tt.create_path(name, parent_id)
+        entry = tree.inventory[file_id]
+        create_by_entry(self.tt, entry, tree, trans_id, lines)
+        return trans_id
+
+    def merge_executable(self, file_id, file_status):
+        """Perform a merge on the execute bit."""
+        if file_status == "deleted":
+            return
+        trans_id = self.tt.trans_id_file_id(file_id)
+        try:
+            if self.tt.final_kind(trans_id) != "file":
+                return
+        except NoSuchFile:
+            return
+        winner = self.scalar_three_way(self.this_tree, self.base_tree, 
+                                       self.other_tree, file_id, 
+                                       self.executable)
+        if winner == "conflict":
+        # There must be a None in here, if we have a conflict, but we
+        # need executability since file status was not deleted.
+            if self.other_tree.is_executable(file_id) is None:
+                winner = "this"
+            else:
+                winner = "other"
+        if winner == "this":
+            if file_status == "modified":
+                executability = self.this_tree.is_executable(file_id)
+                if executability is not None:
+                    trans_id = self.tt.trans_id_file_id(file_id)
+                    self.tt.set_executability(executability, trans_id)
+        else:
+            assert winner == "other"
+            if file_id in self.other_tree:
+                executability = self.other_tree.is_executable(file_id)
+            elif file_id in self.this_tree:
+                executability = self.this_tree.is_executable(file_id)
+            elif file_id in self.base_tree:
+                executability = self.base_tree.is_executable(file_id)
+            if executability is not None:
+                trans_id = self.tt.trans_id_file_id(file_id)
+                self.tt.set_executability(executability, trans_id)
+
+    def cook_conflicts(self, fs_conflicts):
+        """Convert all conflicts into a form that doesn't depend on trans_id"""
+        name_conflicts = {}
+        self.cooked_conflicts.extend(cook_conflicts(fs_conflicts, self.tt))
+        fp = FinalPaths(self.tt)
+        for conflict in self._raw_conflicts:
+            conflict_type = conflict[0]
+            if conflict_type in ('name conflict', 'parent conflict'):
+                trans_id = conflict[1]
+                conflict_args = conflict[2:]
+                if trans_id not in name_conflicts:
+                    name_conflicts[trans_id] = {}
+                unique_add(name_conflicts[trans_id], conflict_type, 
+                           conflict_args)
+            if conflict_type == 'contents conflict':
+                for trans_id in conflict[1]:
+                    file_id = self.tt.final_file_id(trans_id)
+                    if file_id is not None:
+                        break
+                path = fp.get_path(trans_id)
+                for suffix in ('.BASE', '.THIS', '.OTHER'):
+                    if path.endswith(suffix):
+                        path = path[:-len(suffix)]
+                        break
+                self.cooked_conflicts.append((conflict_type, file_id, path))
+            if conflict_type == 'text conflict':
+                trans_id = conflict[1]
+                path = fp.get_path(trans_id)
+                file_id = self.tt.final_file_id(trans_id)
+                self.cooked_conflicts.append((conflict_type, file_id, path))
+
+        for trans_id, conflicts in name_conflicts.iteritems():
+            try:
+                this_parent, other_parent = conflicts['parent conflict']
+                assert this_parent != other_parent
+            except KeyError:
+                this_parent = other_parent = \
+                    self.tt.final_file_id(self.tt.final_parent(trans_id))
+            try:
+                this_name, other_name = conflicts['name conflict']
+                assert this_name != other_name
+            except KeyError:
+                this_name = other_name = self.tt.final_name(trans_id)
+            other_path = fp.get_path(trans_id)
+            if this_parent is not None:
+                this_parent_path = \
+                    fp.get_path(self.tt.trans_id_file_id(this_parent))
+                this_path = pathjoin(this_parent_path, this_name)
+            else:
+                this_path = "<deleted>"
+            file_id = self.tt.final_file_id(trans_id)
+            self.cooked_conflicts.append(('path conflict', file_id, this_path, 
+                                         other_path))
+
+
+class WeaveMerger(Merge3Merger):
+    """Three-way tree merger, text weave merger."""
+    supports_reprocess = False
+    supports_show_base = False
+
+    def __init__(self, working_tree, this_tree, base_tree, other_tree, 
+                 interesting_ids=None, pb=DummyProgress()):
+        self.this_revision_tree = self._get_revision_tree(this_tree)
+        self.other_revision_tree = self._get_revision_tree(other_tree)
+        super(WeaveMerger, self).__init__(working_tree, this_tree, 
+                                          base_tree, other_tree, 
+                                          interesting_ids=interesting_ids, 
+                                          pb=pb)
+
+    def _get_revision_tree(self, tree):
+        """Return a revision tree releated to this tree.
+        If the tree is a WorkingTree, the basis will be returned.
+        """
+        if getattr(tree, 'get_weave', False) is False:
+            # If we have a WorkingTree, try using the basis
+            return tree.branch.basis_tree()
+        else:
+            return tree
+
+    def _check_file(self, file_id):
+        """Check that the revision tree's version of the file matches."""
+        for tree, rt in ((self.this_tree, self.this_revision_tree), 
+                         (self.other_tree, self.other_revision_tree)):
+            if rt is tree:
+                continue
+            if tree.get_file_sha1(file_id) != rt.get_file_sha1(file_id):
+                raise WorkingTreeNotRevision(self.this_tree)
+
+    def _merged_lines(self, file_id):
+        """Generate the merged lines.
+        There is no distinction between lines that are meant to contain <<<<<<<
+        and conflicts.
+        """
+        weave = self.this_revision_tree.get_weave(file_id)
+        this_revision_id = self.this_revision_tree.inventory[file_id].revision
+        other_revision_id = \
+            self.other_revision_tree.inventory[file_id].revision
+        this_i = weave.lookup(this_revision_id)
+        other_i = weave.lookup(other_revision_id)
+        plan =  weave.plan_merge(this_i, other_i)
+        return weave.weave_merge(plan, '<<<<<<< TREE\n', 
+                                       '>>>>>>> MERGE-SOURCE\n')
+
+    def text_merge(self, file_id, trans_id):
+        """Perform a (weave) text merge for a given file and file-id.
+        If conflicts are encountered, .THIS and .OTHER files will be emitted,
+        and a conflict will be noted.
+        """
+        self._check_file(file_id)
+        lines = self._merged_lines(file_id)
+        conflicts = '<<<<<<< TREE\n' in lines
+        self.tt.create_file(lines, trans_id)
+        if conflicts:
+            self._raw_conflicts.append(('text conflict', trans_id))
+            name = self.tt.final_name(trans_id)
+            parent_id = self.tt.final_parent(trans_id)
+            file_group = self._dump_conflicts(name, parent_id, file_id, 
+                                              no_base=True)
+            file_group.append(trans_id)
+
+
+class Diff3Merger(Merge3Merger):
+    """Three-way merger using external diff3 for text merging"""
+    def dump_file(self, temp_dir, name, tree, file_id):
+        out_path = pathjoin(temp_dir, name)
+        out_file = file(out_path, "wb")
+        in_file = tree.get_file(file_id)
+        for line in in_file:
+            out_file.write(line)
+        return out_path
+
+    def text_merge(self, file_id, trans_id):
+        """Perform a diff3 merge using a specified file-id and trans-id.
+        If conflicts are encountered, .BASE, .THIS. and .OTHER conflict files
+        will be dumped, and a will be conflict noted.
+        """
+        import bzrlib.patch
+        temp_dir = mkdtemp(prefix="bzr-")
+        try:
+            new_file = pathjoin(temp_dir, "new")
+            this = self.dump_file(temp_dir, "this", self.this_tree, file_id)
+            base = self.dump_file(temp_dir, "base", self.base_tree, file_id)
+            other = self.dump_file(temp_dir, "other", self.other_tree, file_id)
+            status = bzrlib.patch.diff3(new_file, this, base, other)
+            if status not in (0, 1):
+                raise BzrError("Unhandled diff3 exit code")
+            self.tt.create_file(file(new_file, "rb"), trans_id)
+            if status == 1:
+                name = self.tt.final_name(trans_id)
+                parent_id = self.tt.final_parent(trans_id)
+                self._dump_conflicts(name, parent_id, file_id)
+            self._raw_conflicts.append(('text conflict', trans_id))
+        finally:
+            rmtree(temp_dir)
+
+
+def merge_inner(this_branch, other_tree, base_tree, ignore_zero=False,
+                backup_files=False, 
+                merge_type=Merge3Merger, 
+                interesting_ids=None, 
+                show_base=False, 
+                reprocess=False, 
+                other_rev_id=None,
+                interesting_files=None,
+                this_tree=None,
+                pb=DummyProgress()):
+    """Primary interface for merging. 
+
+        typical use is probably 
+        'merge_inner(branch, branch.get_revision_tree(other_revision),
+                     branch.get_revision_tree(base_revision))'
+        """
+    if this_tree is None:
+        warn("bzrlib.merge.merge_inner requires a this_tree parameter as of "
+             "bzrlib version 0.8.",
+             DeprecationWarning,
+             stacklevel=2)
+        this_tree = this_branch.bzrdir.open_workingtree()
+    merger = Merger(this_branch, other_tree, base_tree, this_tree=this_tree, 
+                    pb=pb)
+    merger.backup_files = backup_files
+    merger.merge_type = merge_type
+    merger.interesting_ids = interesting_ids
+    if interesting_files:
+        assert not interesting_ids, ('Only supply interesting_ids'
+                                     ' or interesting_files')
+        merger._set_interesting_files(interesting_files)
+    merger.show_base = show_base 
+    merger.reprocess = reprocess
+    merger.other_rev_id = other_rev_id
+    merger.other_basis = other_rev_id
+    return merger.do_merge()
+
+
+merge_types = {     "merge3": (Merge3Merger, "Native diff3-style merge"), 
+                     "diff3": (Diff3Merger,  "Merge using external diff3"),
+                     'weave': (WeaveMerger, "Weave-based merge")
               }
-

=== removed file 'bzrlib/merge_core.py'
--- bzrlib/merge_core.py	2006-01-25 14:30:06 +0000
+++ bzrlib/merge_core.py	1970-01-01 00:00:00 +0000
@@ -1,362 +0,0 @@
-import os.path
-
-import changeset
-from changeset import Inventory, apply_changeset, invert_dict
-from bzrlib.osutils import backup_file, rename, pathjoin
-from bzrlib.merge3 import Merge3
-import bzrlib
-from bzrlib.atomicfile import AtomicFile
-from changeset import get_contents
-
-
-class ApplyMerge3:
-    """Contents-change wrapper around merge3.Merge3"""
-
-    history_based = False
-
-    def __init__(self, file_id, base, other, show_base=False, reprocess=False):
-        self.file_id = file_id
-        self.base = base
-        self.other = other
-        self.show_base = show_base
-        self.reprocess = reprocess
-
-    def is_creation(self):
-        return False
-
-    def is_deletion(self):
-        return False
-
-    def __eq__(self, other):
-        if not isinstance(other, ApplyMerge3):
-            return False
-        return (self.base == other.base and 
-                self.other == other.other and self.file_id == other.file_id)
-
-    def __ne__(self, other):
-        return not (self == other)
-
-    def apply(self, filename, conflict_handler):
-        new_file = filename+".new" 
-        base = self.base
-        other = self.other
-        def get_lines(tree):
-            if self.file_id not in tree:
-                raise Exception("%s not in tree" % self.file_id)
-                return ()
-            return tree.get_file(self.file_id).readlines()
-        base_lines = get_lines(base)
-        other_lines = get_lines(other)
-        m3 = Merge3(base_lines, file(filename, "rb").readlines(), other_lines)
-
-        new_conflicts = False
-        output_file = file(new_file, "wb")
-        start_marker = "!START OF MERGE CONFLICT!" + "I HOPE THIS IS UNIQUE"
-        if self.show_base is True:
-            base_marker = '|' * 7
-        else:
-            base_marker = None
-        for line in m3.merge_lines(name_a = "TREE", name_b = "MERGE-SOURCE", 
-                       name_base = "BASE-REVISION",
-                       start_marker=start_marker, base_marker=base_marker,
-                       reprocess = self.reprocess):
-            if line.startswith(start_marker):
-                new_conflicts = True
-                output_file.write(line.replace(start_marker, '<' * 7))
-            else:
-                output_file.write(line)
-        output_file.close()
-        if not new_conflicts:
-            os.chmod(new_file, os.stat(filename).st_mode)
-            rename(new_file, filename)
-            return
-        else:
-            conflict_handler.merge_conflict(new_file, filename, base_lines,
-                                            other_lines)
-
-
-class WeaveMerge:
-    """Contents-change wrapper around weave merge"""
-
-    history_based = True
-
-    def __init__(self, weave, this_revision_id, other_revision_id):
-        self.weave = weave
-        self.this_revision_id = this_revision_id
-        self.other_revision_id = other_revision_id
-
-    def is_creation(self):
-        return False
-
-    def is_deletion(self):
-        return False
-
-    def __eq__(self, other):
-        if not isinstance(other, WeaveMerge):
-            return False
-        return self.weave == other.weave and\
-            self.this_revision_id == other.this_revision_id and\
-            self.other_revision_id == other.other_revision_id
-
-    def __ne__(self, other):
-        return not (self == other)
-
-    def apply(self, filename, conflict_handler):
-        this_i = self.weave.lookup(self.this_revision_id)
-        other_i = self.weave.lookup(self.other_revision_id)
-        plan = self.weave.plan_merge(this_i, other_i)
-        lines = self.weave.weave_merge(plan)
-        conflicts = False
-        out_file = AtomicFile(filename, mode='wb')
-        for line in lines:
-            if line == '<<<<<<<\n':
-                conflicts = True
-            out_file.write(line)
-        if conflicts:
-            conflict_handler.weave_merge_conflict(filename, self.weave,
-                                                  other_i, out_file)
-        else:
-            out_file.commit()
-
-
-class BackupBeforeChange:
-    """Contents-change wrapper to back up file first"""
-
-    def __init__(self, contents_change):
-        self.contents_change = contents_change
-
-    def is_creation(self):
-        return self.contents_change.is_creation()
-
-    def is_deletion(self):
-        return self.contents_change.is_deletion()
-
-    def __eq__(self, other):
-        if not isinstance(other, BackupBeforeChange):
-            return False
-        return (self.contents_change == other.contents_change)
-
-    def __ne__(self, other):
-        return not (self == other)
-
-    def apply(self, filename, conflict_handler):
-        backup_file(filename)
-        self.contents_change.apply(filename, conflict_handler)
-
-
-def invert_invent(inventory):
-    invert_invent = {}
-    for file_id in inventory:
-        path = inventory.id2path(file_id)
-        if path == '':
-            path = './.'
-        else:
-            path = './' + path
-        invert_invent[file_id] = path
-    return invert_invent
-
-
-def merge_flex(this, base, other, changeset_function, inventory_function,
-               conflict_handler, merge_factory, interesting_ids):
-    cset = changeset_function(base, other, interesting_ids)
-    new_cset = make_merge_changeset(cset, this, base, other, 
-                                    conflict_handler, merge_factory)
-    result = apply_changeset(new_cset, invert_invent(this.inventory),
-                             this.basedir, conflict_handler)
-    return result
-    
-
-def make_merge_changeset(cset, this, base, other, 
-                         conflict_handler, merge_factory):
-    new_cset = changeset.Changeset()
-
-    for entry in cset.entries.itervalues():
-        if entry.is_boring():
-            new_cset.add_entry(entry)
-        else:
-            new_entry = make_merged_entry(entry, this, base, other, 
-                                          conflict_handler)
-            new_contents = make_merged_contents(entry, this, base, other, 
-                                                conflict_handler,
-                                                merge_factory)
-            new_entry.contents_change = new_contents
-            new_entry.metadata_change = make_merged_metadata(entry, base, other)
-            new_cset.add_entry(new_entry)
-
-    return new_cset
-
-
-class ThreeWayConflict(Exception):
-    def __init__(self, this, base, other):
-        self.this = this
-        self.base = base
-        self.other = other
-        msg = "Conflict merging %s %s and %s" % (this, base, other)
-        Exception.__init__(self, msg)
-
-
-def threeway_select(this, base, other):
-    """Returns a value selected by the three-way algorithm.
-    Raises ThreewayConflict if the algorithm yields a conflict"""
-    if base == other:
-        return this
-    elif base == this:
-        return other
-    elif other == this:
-        return this
-    else:
-        raise ThreeWayConflict(this, base, other)
-
-
-def make_merged_entry(entry, this, base, other, conflict_handler):
-    from bzrlib.trace import mutter
-    def entry_data(file_id, tree):
-        assert hasattr(tree, "__contains__"), "%s" % tree
-        if not tree.has_or_had_id(file_id):
-            return (None, None, "")
-        entry = tree.inventory[file_id]
-        my_dir = tree.id2path(entry.parent_id)
-        if my_dir is None:
-            my_dir = ""
-        return entry.name, entry.parent_id, my_dir 
-    this_name, this_parent, this_dir = entry_data(entry.id, this)
-    base_name, base_parent, base_dir = entry_data(entry.id, base)
-    other_name, other_parent, other_dir = entry_data(entry.id, other)
-    mutter("Dirs: this, base, other %r %r %r", this_dir, base_dir, other_dir)
-    mutter("Names: this, base, other %r %r %r", this_name, base_name, other_name)
-    old_name = this_name
-    try:
-        new_name = threeway_select(this_name, base_name, other_name)
-    except ThreeWayConflict:
-        new_name = conflict_handler.rename_conflict(entry.id, this_name, 
-                                                    base_name, other_name)
-
-    old_parent = this_parent
-    try:
-        new_parent = threeway_select(this_parent, base_parent, other_parent)
-    except ThreeWayConflict:
-        new_parent = conflict_handler.move_conflict(entry.id, this_dir,
-                                                    base_dir, other_dir)
-    def get_path(name, parent):
-        if name is not None:
-            if name == "":
-                assert parent is None
-                return './.'
-            parent_dir = {this_parent: this_dir, other_parent: other_dir, 
-                          base_parent: base_dir}
-            directory = parent_dir[parent]
-            return pathjoin(directory, name)
-        else:
-            assert parent is None
-            return None
-
-    old_path = get_path(old_name, old_parent)
-        
-    new_entry = changeset.ChangesetEntry(entry.id, old_parent, old_path)
-    new_entry.new_path = get_path(new_name, new_parent)
-    new_entry.new_parent = new_parent
-    mutter(repr(new_entry))
-    return new_entry
-
-
-def make_merged_contents(entry, this, base, other, conflict_handler,
-                         merge_factory):
-    contents = entry.contents_change
-    if contents is None:
-        return None
-    if entry.id in this:
-        this_path = this.id2abspath(entry.id)
-    else:
-        this_path = None
-    def make_merge():
-        if this_path is None:
-            return conflict_handler.missing_for_merge(entry.id, 
-                                                      other.id2path(entry.id))
-        return merge_factory(entry.id, base, other)
-
-    if isinstance(contents, changeset.ReplaceContents):
-        base_contents = contents.old_contents
-        other_contents = contents.new_contents
-        if base_contents is None and other_contents is None:
-            return None
-        if other_contents is None:
-            this_contents = get_contents(this, entry.id)
-            if this_path is not None and bzrlib.osutils.lexists(this_path):
-                if this_contents != base_contents:
-                    return conflict_handler.rem_contents_conflict(this_path, 
-                        this_contents, base_contents)
-                return contents
-            else:
-                return None
-        elif base_contents is None:
-            if this_path is None or not bzrlib.osutils.lexists(this_path):
-                return contents
-            else:
-                this_contents = get_contents(this, entry.id)
-                if this_contents == other_contents:
-                    return None
-                else:
-                    conflict_handler.new_contents_conflict(this_path, 
-                        other_contents)
-        elif isinstance(base_contents, changeset.TreeFileCreate) and \
-            isinstance(other_contents, changeset.TreeFileCreate):
-            return make_merge()
-        else:
-            this_contents = get_contents(this, entry.id)
-            if this_contents == base_contents:
-                return contents
-            elif this_contents == other_contents:
-                return None
-            elif base_contents == other_contents:
-                return None
-            else:
-                conflict_handler.threeway_contents_conflict(this_path,
-                                                            this_contents,
-                                                            base_contents,
-                                                            other_contents)
-                
-
-def make_merged_metadata(entry, base, other):
-    metadata = entry.metadata_change
-    if metadata is None:
-        return None
-    assert isinstance(metadata, changeset.ChangeExecFlag)
-    if metadata.new_exec_flag is None:
-        return None
-    elif metadata.old_exec_flag is None:
-        return metadata
-    else:
-        return ExecFlagMerge(base, other, entry.id)
-    
-
-class ExecFlagMerge(object):
-    def __init__(self, base_tree, other_tree, file_id):
-        self.base_tree = base_tree
-        self.other_tree = other_tree
-        self.file_id = file_id
-
-    def apply(self, filename, conflict_handler):
-        base = self.base_tree
-        other = self.other_tree
-        base_exec_flag = base.is_executable(self.file_id)
-        other_exec_flag = other.is_executable(self.file_id)
-        this_mode = os.stat(filename).st_mode
-        this_exec_flag = bool(this_mode & 0111)
-        if (base_exec_flag != other_exec_flag and
-            this_exec_flag != other_exec_flag):
-            assert this_exec_flag == base_exec_flag
-            current_mode = os.stat(filename).st_mode
-            if other_exec_flag:
-                umask = os.umask(0)
-                os.umask(umask)
-                to_mode = current_mode | (0100 & ~umask)
-                # Enable x-bit for others only if they can read it.
-                if current_mode & 0004:
-                    to_mode |= 0001 & ~umask
-                if current_mode & 0040:
-                    to_mode |= 0010 & ~umask
-            else:
-                to_mode = current_mode & ~0111
-            os.chmod(filename, to_mode)
-
-

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2006-01-25 14:30:06 +0000
+++ bzrlib/missing.py	2006-03-20 08:31:00 +0000
@@ -1,7 +1,8 @@
-"""\
-A plugin for displaying what revisions are in 'other' but not in local.
-"""
-from bzrlib.ui import ui_factory
+"""Display what revisions are missing in 'other' from 'this' and vice verca."""
+
+import bzrlib.ui as ui
+
+
 def iter_log_data(revisions, revision_source, verbose):
     from bzrlib.diff import compare_trees
     from bzrlib.tree import EmptyTree
@@ -10,6 +11,7 @@
     for revno, rev_id in revisions:
         rev = revision_source.get_revision(rev_id)
         if verbose:
+            remote_tree = revision_source.revision_tree(rev_id)
             parent_rev_id = rev.parent_ids[0]
             if last_rev_id == parent_rev_id:
                 parent_tree = last_tree
@@ -25,7 +27,7 @@
 
 
 def find_unmerged(local_branch, remote_branch):
-    progress = ui_factory.progress_bar()
+    progress = ui.ui_factory.progress_bar()
     local_branch.lock_read()
     try:
         remote_branch.lock_read()
@@ -43,10 +45,10 @@
                                                 remote_rev_history_map)
                 return local_extra, remote_extra
 
-            local_ancestry = _get_ancestry(local_branch, progress, "local",
-                                           2, local_rev_history)
-            remote_ancestry = _get_ancestry(remote_branch, progress, "remote",
-                                            3, remote_rev_history)
+            local_ancestry = _get_ancestry(local_branch.repository, progress, 
+                                           "local", 2, local_rev_history)
+            remote_ancestry = _get_ancestry(remote_branch.repository, progress,
+                                            "remote", 3, remote_rev_history)
             progress.update('pondering', 4, 5)
             extras = local_ancestry.symmetric_difference(remote_ancestry) 
             local_extra = extras.intersection(set(local_rev_history))
@@ -87,10 +89,10 @@
          for rev in rev_history])
     return rev_history, rev_history_map
 
-def _get_ancestry(branch, progress, label, step, rev_history):
+def _get_ancestry(repository, progress, label, step, rev_history):
     progress.update('%s ancestry' % label, step, 5)
     if len(rev_history) > 0:
-        ancestry = set(branch.get_ancestry(rev_history[-1]))
+        ancestry = set(repository.get_ancestry(rev_history[-1]))
     else:
         ancestry = set()
     return ancestry

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2006-01-25 14:30:06 +0000
+++ bzrlib/msgeditor.py	2006-03-20 08:31:00 +0000
@@ -20,6 +20,7 @@
 """Commit message editor support."""
 
 import os
+import errno
 from subprocess import call
 
 import bzrlib.config as config
@@ -51,7 +52,13 @@
     """Try to execute an editor to edit the commit message."""
     for e in _get_editor():
         edargs = e.split(' ')
-        x = call(edargs + [filename])
+        try:
+            x = call(edargs + [filename])
+        except OSError, e:
+           # ENOENT means no such editor
+           if e.errno == errno.ENOENT:
+               continue
+           raise
         if x == 0:
             return True
         elif x == 127:
@@ -141,7 +148,8 @@
     # the revision to be committed, then pause and ask the user to
     # confirm/write a message.
     from StringIO import StringIO       # must be unicode-safe
-    from bzrlib.status import show_status
+    from bzrlib.status import show_tree_status
     status_tmp = StringIO()
-    show_status(working_tree.branch, specific_files=specific_files, to_file=status_tmp)
+    show_tree_status(working_tree, specific_files=specific_files, 
+                     to_file=status_tmp)
     return status_tmp.getvalue()

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2006-01-25 14:30:06 +0000
+++ bzrlib/option.py	2006-03-20 08:31:00 +0000
@@ -71,6 +71,10 @@
     BzrError: No namespace registered for string: 'abc'
     >>> _parse_revision_str('branch:../branch2')
     [<RevisionSpec_branch branch:../branch2>]
+    >>> _parse_revision_str('branch:../../branch2')
+    [<RevisionSpec_branch branch:../../branch2>]
+    >>> _parse_revision_str('branch:../../branch2..23')
+    [<RevisionSpec_branch branch:../../branch2>, <RevisionSpec_int 23>]
     """
     # TODO: Maybe move this into revisionspec.py
     old_format_re = re.compile('\d*:\d*')
@@ -85,20 +89,9 @@
             else:
                 revs.append(RevisionSpec(None))
     else:
-        next_prefix = None
-        for x in revstr.split('..'):
-            if not x:
-                revs.append(RevisionSpec(None))
-            elif x[-1] == ':':
-                # looks like a namespace:.. has happened
-                next_prefix = x + '..'
-            else:
-                if next_prefix is not None:
-                    x = next_prefix + x
-                revs.append(RevisionSpec(x))
-                next_prefix = None
-        if next_prefix is not None:
-            revs.append(RevisionSpec(next_prefix))
+        sep = re.compile("\\.\\.(?!/)")
+        for x in sep.split(revstr):
+            revs.append(RevisionSpec(x or None))
     return revs
 
 
@@ -168,6 +161,7 @@
 _global_option('overwrite', help='Ignore differences between branches and '
                'overwrite unconditionally')
 _global_option('basis', type=str)
+_global_option('bound')
 _global_option('diff-options', type=str)
 _global_option('help',
                help='show help message')
@@ -186,14 +180,16 @@
 _global_option('timezone', 
                type=str,
                help='display timezone as local, original, or utc')
+_global_option('unbound')
 _global_option('verbose',
                help='display more information')
 _global_option('version')
 _global_option('email')
 _global_option('update')
-_global_option('long', help='Use detailed log format')
-_global_option('short', help='Use moderately short log format')
-_global_option('line', help='Use log format with one line per revision')
+_global_option('log-format', type=str, help="Use this log format")
+_global_option('long', help='Use detailed log format. Same as --log-format long')
+_global_option('short', help='Use moderately short log format. Same as --log-format short')
+_global_option('line', help='Use log format with one line per revision. Same as --log-format line')
 _global_option('root', type=str)
 _global_option('no-backup')
 _global_option('merge-type', type=_parse_merge_type)

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2006-01-25 14:30:06 +0000
+++ bzrlib/osutils.py	2006-03-20 08:31:00 +0000
@@ -32,7 +32,7 @@
 
 import bzrlib
 from bzrlib.errors import (BzrError,
-                           BzrBadParameter,
+                           BzrBadParameterNotUnicode,
                            NoSuchFile,
                            PathNotChild,
                            )
@@ -129,7 +129,7 @@
     import random
     base = os.path.basename(new)
     dirname = os.path.dirname(new)
-    tmp_name = u'tmp.%s.%.9f.%d.%d' % (base, time.time(), os.getpid(), random.randint(0, 0x7FFFFFFF))
+    tmp_name = u'tmp.%s.%.9f.%d.%s' % (base, time.time(), os.getpid(), rand_chars(10))
     tmp_name = pathjoin(dirname, tmp_name)
 
     # Rename the file out of the way, but keep track if it didn't exist
@@ -336,6 +336,14 @@
         tofile.write(b)
 
 
+def file_iterator(input_file, readsize=32768):
+    while True:
+        b = input_file.read(readsize)
+        if len(b) == 0:
+            break
+        yield b
+
+
 def sha_file(f):
     if hasattr(f, 'tell'):
         assert f.tell() == 0
@@ -433,6 +441,7 @@
     """Return size of given open file."""
     return os.fstat(f.fileno())[ST_SIZE]
 
+
 # Define rand_bytes based on platform.
 try:
     # Python 2.4 and later have os.urandom,
@@ -455,6 +464,20 @@
                 n -= 1
             return s
 
+
+ALNUM = '0123456789abcdefghijklmnopqrstuvwxyz'
+def rand_chars(num):
+    """Return a random string of num alphanumeric characters
+    
+    The result only contains lowercase chars because it may be used on 
+    case-insensitive filesystems.
+    """
+    s = ''
+    for raw_byte in rand_bytes(num):
+        s += ALNUM[ord(raw_byte) % 36]
+    return s
+
+
 ## TODO: We could later have path objects that remember their list
 ## decomposition (might be too tricksy though.)
 
@@ -595,7 +618,7 @@
     try:
         return unicode_or_utf8_string.decode('utf8')
     except UnicodeDecodeError:
-        raise BzrBadParameter(unicode_or_utf8_string)
+        raise BzrBadParameterNotUnicode(unicode_or_utf8_string)
 
 
 def terminal_width():
@@ -610,3 +633,6 @@
         return int(os.environ['COLUMNS'])
     except (IndexError, KeyError, ValueError):
         return 80
+
+def supports_executable():
+    return sys.platform != "win32"

=== modified file 'bzrlib/patch.py'
--- bzrlib/patch.py	2005-11-07 13:17:53 +0000
+++ bzrlib/patch.py	2006-03-20 08:31:00 +0000
@@ -1,5 +1,8 @@
+import errno
 import os
 from subprocess import Popen, PIPE
+
+from bzrlib.errors import NoDiff3
 """
 Diff and patch functionality
 """
@@ -53,7 +56,13 @@
     add_label(args, "ANCESTOR")
     add_label(args, "MERGE-SOURCE")
     args.extend((mine_path, older_path, yours_path))
-    output, stderr, status = write_to_cmd(args)
+    try:
+        output, stderr, status = write_to_cmd(args)
+    except OSError, e:
+        if e.errno == errno.ENOENT:
+            raise NoDiff3
+        else:
+            raise
     if status not in (0, 1):
         raise Exception(stderr)
     file(out_file, "wb").write(output)

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2006-01-25 14:30:06 +0000
+++ bzrlib/plugin.py	2006-03-20 08:31:00 +0000
@@ -66,6 +66,17 @@
     return result
 
 
+def disable_plugins():
+    """Disable loading plugins.
+
+    Future calls to load_plugins() will be ignored.
+    """
+    # TODO: jam 20060131 This should probably also disable
+    #       load_from_dirs()
+    global _loaded
+    _loaded = True
+
+
 def load_plugins():
     """Load bzrlib plugins.
 

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2006-01-25 14:30:06 +0000
+++ bzrlib/progress.py	2006-03-20 08:31:00 +0000
@@ -69,10 +69,11 @@
                  show_spinner=False,
                  show_eta=True,
                  show_bar=True,
-                 show_count=True):
+                 show_count=True,
+                 to_messages_file=sys.stdout):
         object.__init__(self)
         self.to_file = to_file
- 
+        self.to_messages_file = to_messages_file
         self.last_msg = None
         self.last_cnt = None
         self.last_total = None
@@ -82,6 +83,11 @@
         self.show_bar = show_bar
         self.show_count = show_count
 
+    def note(self, fmt_string, *args, **kwargs):
+        """Record a note without disrupting the progress bar."""
+        self.clear()
+        self.to_messages_file.write(fmt_string % args)
+        self.to_messages_file.write('\n')
 
 
 class DummyProgress(_BaseProgressBar):
@@ -98,7 +104,10 @@
     def clear(self):
         pass
         
-    
+    def note(self, fmt_string, *args, **kwargs):
+        """See _BaseProgressBar.note()."""
+
+
 class DotsProgressBar(_BaseProgressBar):
     def __init__(self, **kwargs):
         _BaseProgressBar.__init__(self, **kwargs)
@@ -186,13 +195,14 @@
             
         if current_cnt > total_cnt:
             total_cnt = current_cnt
-
+        
+        old_msg = self.last_msg
         # save these for the tick() function
         self.last_msg = msg
         self.last_cnt = current_cnt
         self.last_total = total_cnt
             
-        if self.throttle():
+        if old_msg == self.last_msg and self.throttle():
             return 
         
         if self.show_eta and self.start_time and total_cnt:
@@ -255,11 +265,9 @@
         self.to_file.write('\r' + m.ljust(self.width - 1))
         #self.to_file.flush()
             
-
     def clear(self):        
         self.to_file.write('\r%s\r' % (' ' * (self.width - 1)))
         #self.to_file.flush()        
-    
 
         
 def str_tdelta(delt):

=== added file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	1970-01-01 00:00:00 +0000
+++ bzrlib/reconcile.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,184 @@
+# (C) 2005, 2006 Canonical Limited.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Reconcilers are able to fix some potential data errors in a branch."""
+
+
+__all__ = ['reconcile', 'Reconciler', 'RepoReconciler']
+
+
+import bzrlib.branch
+import bzrlib.errors as errors
+import bzrlib.progress
+from bzrlib.trace import mutter
+from bzrlib.tsort import TopoSorter
+import bzrlib.ui as ui
+
+
+def reconcile(dir):
+    """Reconcile the data in dir.
+
+    Currently this is limited to a inventory 'reweave'.
+
+    This is a convenience method, for using a Reconciler object.
+
+    Directly using Reconciler is recommended for library users that
+    desire fine grained control or analysis of the found issues.
+    """
+    reconciler = Reconciler(dir)
+    reconciler.reconcile()
+
+
+class Reconciler(object):
+    """Reconcilers are used to reconcile existing data."""
+
+    def __init__(self, dir):
+        self.bzrdir = dir
+
+    def reconcile(self):
+        """Perform reconciliation.
+        
+        After reconciliation the following attributes document found issues:
+        inconsistent_parents: The number of revisions in the repository whose
+                              ancestry was being reported incorrectly.
+        garbage_inventories: The number of inventory objects without revisions
+                             that were garbage collected.
+        """
+        self.pb = ui.ui_factory.progress_bar()
+        self.repo = self.bzrdir.find_repository()
+        self.pb.note('Reconciling repository %s',
+                     self.repo.bzrdir.root_transport.base)
+        repo_reconciler = RepoReconciler(self.repo)
+        repo_reconciler.reconcile()
+        self.inconsistent_parents = repo_reconciler.inconsistent_parents
+        self.garbage_inventories = repo_reconciler.garbage_inventories
+        self.pb.note('Reconciliation complete.')
+
+
+class RepoReconciler(object):
+    """Reconciler that reconciles a repository.
+
+    Currently this consists of an inventory reweave with revision cross-checks.
+    """
+
+    def __init__(self, repo):
+        self.repo = repo
+
+    def reconcile(self):
+        """Perform reconciliation.
+        
+        After reconciliation the following attributes document found issues:
+        inconsistent_parents: The number of revisions in the repository whose
+                              ancestry was being reported incorrectly.
+        garbage_inventories: The number of inventory objects without revisions
+                             that were garbage collected.
+        """
+        self.pb = ui.ui_factory.progress_bar()
+        self.repo.lock_write()
+        try:
+            self._reweave_inventory()
+        finally:
+            self.repo.unlock()
+
+    def _reweave_inventory(self):
+        """Regenerate the inventory weave for the repository from scratch."""
+        self.pb.update('Reading inventory data.')
+        self.inventory = self.repo.get_inventory_weave()
+        # the total set of revisions to process
+        self.pending = set([file_id for file_id in self.repo.revision_store])
+
+        # mapping from revision_id to parents
+        self._rev_graph = {}
+        # errors that we detect
+        self.inconsistent_parents = 0
+        # we need the revision id of each revision and its available parents list
+        self._setup_steps(len(self.pending))
+        for rev_id in self.pending:
+            # put a revision into the graph.
+            self._graph_revision(rev_id)
+        # we gc unreferenced inventories too
+        self.garbage_inventories = len(self.inventory.names()) \
+                                   - len(self._rev_graph)
+
+        if not self.inconsistent_parents and not self.garbage_inventories:
+            self.pb.note('Inventory ok.')
+            return
+        self.pb.update('Backing up inventory...', 0, 0)
+        self.repo.control_weaves.put_weave('inventory.backup',
+                                           self.inventory,
+                                           self.repo.get_transaction())
+        self.pb.note('Backup Inventory created.')
+        # asking for '' should never return a non-empty weave
+        new_inventory = self.repo.control_weaves.get_weave_or_empty('',
+            self.repo.get_transaction())
+
+        # we have topological order of revisions and non ghost parents ready.
+        self._setup_steps(len(self._rev_graph))
+        for rev_id in TopoSorter(self._rev_graph.items()).iter_topo_order():
+            parents = self._rev_graph[rev_id]
+            # double check this really is in topological order.
+            unavailable = [p for p in parents if p not in new_inventory]
+            assert len(unavailable) == 0
+            # this entry has all the non ghost parents in the inventory
+            # file already.
+            self._reweave_step('adding inventories')
+            new_inventory.add(rev_id, parents, self.inventory.get(rev_id))
+
+        # if this worked, the set of new_inventory.names should equal
+        # self.pending
+        assert set(new_inventory.names()) == self.pending
+        self.pb.update('Writing weave')
+        self.repo.control_weaves.put_weave('inventory',
+                                           new_inventory,
+                                           self.repo.get_transaction())
+        self.inventory = None
+        self.pb.note('Inventory regenerated.')
+
+    def _setup_steps(self, new_total):
+        """Setup the markers we need to control the progress bar."""
+        self.total = new_total
+        self.count = 0
+
+    def _graph_revision(self, rev_id):
+        """Load a revision into the revision graph."""
+        # pick a random revision
+        # analyse revision id rev_id and put it in the stack.
+        self._reweave_step('loading revisions')
+        rev = self.repo.get_revision_reconcile(rev_id)
+        assert rev.revision_id == rev_id
+        parents = []
+        for parent in rev.parent_ids:
+            if self._parent_is_available(parent):
+                parents.append(parent)
+            else:
+                mutter('found ghost %s', parent)
+        self._rev_graph[rev_id] = parents   
+        if set(self.inventory.parent_names(rev_id)) != set(parents):
+            self.inconsistent_parents += 1
+
+    def _parent_is_available(self, parent):
+        """True if parent is a fully available revision
+
+        A fully available revision has a inventory and a revision object in the
+        repository.
+        """
+        return (parent in self._rev_graph or 
+                (parent in self.inventory and self.repo.has_revision(parent)))
+
+    def _reweave_step(self, message):
+        """Mark a single step of regeneration complete."""
+        self.pb.update(message, self.count, self.total)
+        self.count += 1

=== added file 'bzrlib/repository.py'
--- bzrlib/repository.py	1970-01-01 00:00:00 +0000
+++ bzrlib/repository.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,1488 @@
+# Copyright (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from copy import deepcopy
+from cStringIO import StringIO
+from unittest import TestSuite
+import xml.sax.saxutils
+
+import bzrlib.bzrdir as bzrdir
+from bzrlib.decorators import needs_read_lock, needs_write_lock
+from bzrlib.errors import InvalidRevisionId
+from bzrlib.lockable_files import LockableFiles, TransportLock
+from bzrlib.lockdir import LockDir
+from bzrlib.osutils import safe_unicode
+from bzrlib.revision import NULL_REVISION
+import bzrlib.errors as errors
+import bzrlib.gpg as gpg
+from bzrlib.store import copy_all
+from bzrlib.store.weave import WeaveStore
+from bzrlib.store.text import TextStore
+from bzrlib.symbol_versioning import *
+from bzrlib.trace import mutter
+from bzrlib.tree import RevisionTree
+from bzrlib.testament import Testament
+from bzrlib.tree import EmptyTree
+import bzrlib.ui
+import bzrlib.xml5
+
+
+class Repository(object):
+    """Repository holding history for one or more branches.
+
+    The repository holds and retrieves historical information including
+    revisions and file history.  It's normally accessed only by the Branch,
+    which views a particular line of development through that history.
+
+    The Repository builds on top of Stores and a Transport, which respectively 
+    describe the disk data format and the way of accessing the (possibly 
+    remote) disk.
+    """
+
+    @needs_write_lock
+    def add_inventory(self, revid, inv, parents):
+        """Add the inventory inv to the repository as revid.
+        
+        :param parents: The revision ids of the parents that revid
+                        is known to have and are in the repository already.
+
+        returns the sha1 of the serialized inventory.
+        """
+        inv_text = bzrlib.xml5.serializer_v5.write_inventory_to_string(inv)
+        inv_sha1 = bzrlib.osutils.sha_string(inv_text)
+        self.control_weaves.add_text('inventory', revid,
+                   bzrlib.osutils.split_lines(inv_text), parents,
+                   self.get_transaction())
+        return inv_sha1
+
+    @needs_write_lock
+    def add_revision(self, rev_id, rev, inv=None, config=None):
+        """Add rev to the revision store as rev_id.
+
+        :param rev_id: the revision id to use.
+        :param rev: The revision object.
+        :param inv: The inventory for the revision. if None, it will be looked
+                    up in the inventory storer
+        :param config: If None no digital signature will be created.
+                       If supplied its signature_needed method will be used
+                       to determine if a signature should be made.
+        """
+        if config is not None and config.signature_needed():
+            if inv is None:
+                inv = self.get_inventory(rev_id)
+            plaintext = Testament(rev, inv).as_short_text()
+            self.store_revision_signature(
+                gpg.GPGStrategy(config), plaintext, rev_id)
+        if not rev_id in self.get_inventory_weave():
+            if inv is None:
+                raise errors.WeaveRevisionNotPresent(rev_id,
+                                                     self.get_inventory_weave())
+            else:
+                # yes, this is not suitable for adding with ghosts.
+                self.add_inventory(rev_id, inv, rev.parent_ids)
+            
+        rev_tmp = StringIO()
+        bzrlib.xml5.serializer_v5.write_revision(rev, rev_tmp)
+        rev_tmp.seek(0)
+        self.revision_store.add(rev_tmp, rev_id)
+        mutter('added revision_id {%s}', rev_id)
+
+    @needs_read_lock
+    def _all_possible_ids(self):
+        """Return all the possible revisions that we could find."""
+        return self.get_inventory_weave().names()
+
+    @needs_read_lock
+    def all_revision_ids(self):
+        """Returns a list of all the revision ids in the repository. 
+
+        These are in as much topological order as the underlying store can 
+        present: for weaves ghosts may lead to a lack of correctness until
+        the reweave updates the parents list.
+        """
+        result = self._all_possible_ids()
+        return self._eliminate_revisions_not_present(result)
+
+    @needs_read_lock
+    def _eliminate_revisions_not_present(self, revision_ids):
+        """Check every revision id in revision_ids to see if we have it.
+
+        Returns a set of the present revisions.
+        """
+        result = []
+        for id in revision_ids:
+            if self.has_revision(id):
+               result.append(id)
+        return result
+
+    @staticmethod
+    def create(a_bzrdir):
+        """Construct the current default format repository in a_bzrdir."""
+        return RepositoryFormat.get_default_format().initialize(a_bzrdir)
+
+    def __init__(self, _format, a_bzrdir, control_files, revision_store):
+        """instantiate a Repository.
+
+        :param _format: The format of the repository on disk.
+        :param a_bzrdir: The BzrDir of the repository.
+
+        In the future we will have a single api for all stores for
+        getting file texts, inventories and revisions, then
+        this construct will accept instances of those things.
+        """
+        object.__init__(self)
+        self._format = _format
+        # the following are part of the public API for Repository:
+        self.bzrdir = a_bzrdir
+        self.control_files = control_files
+        self.revision_store = revision_store
+
+    def lock_write(self):
+        self.control_files.lock_write()
+
+    def lock_read(self):
+        self.control_files.lock_read()
+
+    def is_locked(self):
+        return self.control_files.is_locked()
+
+    @needs_read_lock
+    def missing_revision_ids(self, other, revision_id=None):
+        """Return the revision ids that other has that this does not.
+        
+        These are returned in topological order.
+
+        revision_id: only return revision ids included by revision_id.
+        """
+        return InterRepository.get(other, self).missing_revision_ids(revision_id)
+
+    @staticmethod
+    def open(base):
+        """Open the repository rooted at base.
+
+        For instance, if the repository is at URL/.bzr/repository,
+        Repository.open(URL) -> a Repository instance.
+        """
+        control = bzrlib.bzrdir.BzrDir.open(base)
+        return control.open_repository()
+
+    def copy_content_into(self, destination, revision_id=None, basis=None):
+        """Make a complete copy of the content in self into destination.
+        
+        This is a destructive operation! Do not use it on existing 
+        repositories.
+        """
+        return InterRepository.get(self, destination).copy_content(revision_id, basis)
+
+    def fetch(self, source, revision_id=None, pb=None):
+        """Fetch the content required to construct revision_id from source.
+
+        If revision_id is None all content is copied.
+        """
+        return InterRepository.get(source, self).fetch(revision_id=revision_id,
+                                                       pb=pb)
+
+    def unlock(self):
+        self.control_files.unlock()
+
+    @needs_read_lock
+    def clone(self, a_bzrdir, revision_id=None, basis=None):
+        """Clone this repository into a_bzrdir using the current format.
+
+        Currently no check is made that the format of this repository and
+        the bzrdir format are compatible. FIXME RBC 20060201.
+        """
+        if not isinstance(a_bzrdir._format, self.bzrdir._format.__class__):
+            # use target default format.
+            result = a_bzrdir.create_repository()
+        # FIXME RBC 20060209 split out the repository type to avoid this check ?
+        elif isinstance(a_bzrdir._format,
+                      (bzrlib.bzrdir.BzrDirFormat4,
+                       bzrlib.bzrdir.BzrDirFormat5,
+                       bzrlib.bzrdir.BzrDirFormat6)):
+            result = a_bzrdir.open_repository()
+        else:
+            result = self._format.initialize(a_bzrdir, shared=self.is_shared())
+        self.copy_content_into(result, revision_id, basis)
+        return result
+
+    def has_revision(self, revision_id):
+        """True if this branch has a copy of the revision.
+
+        This does not necessarily imply the revision is merge
+        or on the mainline."""
+        return (revision_id is None
+                or self.revision_store.has_id(revision_id))
+
+    @needs_read_lock
+    def get_revision_xml_file(self, revision_id):
+        """Return XML file object for revision object."""
+        if not revision_id or not isinstance(revision_id, basestring):
+            raise InvalidRevisionId(revision_id=revision_id, branch=self)
+        try:
+            return self.revision_store.get(revision_id)
+        except (IndexError, KeyError):
+            raise bzrlib.errors.NoSuchRevision(self, revision_id)
+
+    @needs_read_lock
+    def get_revision_xml(self, revision_id):
+        return self.get_revision_xml_file(revision_id).read()
+
+    @needs_read_lock
+    def get_revision_reconcile(self, revision_id):
+        """'reconcile' helper routine that allows access to a revision always.
+        
+        This variant of get_revision does not cross check the weave graph
+        against the revision one as get_revision does: but it should only
+        be used by reconcile, or reconcile-alike commands that are correcting
+        or testing the revision graph.
+        """
+        xml_file = self.get_revision_xml_file(revision_id)
+
+        try:
+            r = bzrlib.xml5.serializer_v5.read_revision(xml_file)
+        except SyntaxError, e:
+            raise bzrlib.errors.BzrError('failed to unpack revision_xml',
+                                         [revision_id,
+                                          str(e)])
+            
+        assert r.revision_id == revision_id
+        return r
+
+    @needs_read_lock
+    def get_revision(self, revision_id):
+        """Return the Revision object for a named revision"""
+        r = self.get_revision_reconcile(revision_id)
+        # weave corruption can lead to absent revision markers that should be
+        # present.
+        # the following test is reasonably cheap (it needs a single weave read)
+        # and the weave is cached in read transactions. In write transactions
+        # it is not cached but typically we only read a small number of
+        # revisions. For knits when they are introduced we will probably want
+        # to ensure that caching write transactions are in use.
+        inv = self.get_inventory_weave()
+        self._check_revision_parents(r, inv)
+        return r
+
+    def _check_revision_parents(self, revision, inventory):
+        """Private to Repository and Fetch.
+        
+        This checks the parentage of revision in an inventory weave for 
+        consistency and is only applicable to inventory-weave-for-ancestry
+        using repository formats & fetchers.
+        """
+        weave_parents = inventory.parent_names(revision.revision_id)
+        weave_names = inventory.names()
+        for parent_id in revision.parent_ids:
+            if parent_id in weave_names:
+                # this parent must not be a ghost.
+                if not parent_id in weave_parents:
+                    # but it is a ghost
+                    raise errors.CorruptRepository(self)
+
+    @needs_read_lock
+    def get_revision_sha1(self, revision_id):
+        """Hash the stored value of a revision, and return it."""
+        # In the future, revision entries will be signed. At that
+        # point, it is probably best *not* to include the signature
+        # in the revision hash. Because that lets you re-sign
+        # the revision, (add signatures/remove signatures) and still
+        # have all hash pointers stay consistent.
+        # But for now, just hash the contents.
+        return bzrlib.osutils.sha_file(self.get_revision_xml_file(revision_id))
+
+    @needs_write_lock
+    def store_revision_signature(self, gpg_strategy, plaintext, revision_id):
+        self.revision_store.add(StringIO(gpg_strategy.sign(plaintext)), 
+                                revision_id, "sig")
+
+    def fileid_involved_between_revs(self, from_revid, to_revid):
+        """Find file_id(s) which are involved in the changes between revisions.
+
+        This determines the set of revisions which are involved, and then
+        finds all file ids affected by those revisions.
+        """
+        # TODO: jam 20060119 This code assumes that w.inclusions will
+        #       always be correct. But because of the presence of ghosts
+        #       it is possible to be wrong.
+        #       One specific example from Robert Collins:
+        #       Two branches, with revisions ABC, and AD
+        #       C is a ghost merge of D.
+        #       Inclusions doesn't recognize D as an ancestor.
+        #       If D is ever merged in the future, the weave
+        #       won't be fixed, because AD never saw revision C
+        #       to cause a conflict which would force a reweave.
+        w = self.get_inventory_weave()
+        from_set = set(w.inclusions([w.lookup(from_revid)]))
+        to_set = set(w.inclusions([w.lookup(to_revid)]))
+        included = to_set.difference(from_set)
+        changed = map(w.idx_to_name, included)
+        return self._fileid_involved_by_set(changed)
+
+    def fileid_involved(self, last_revid=None):
+        """Find all file_ids modified in the ancestry of last_revid.
+
+        :param last_revid: If None, last_revision() will be used.
+        """
+        w = self.get_inventory_weave()
+        if not last_revid:
+            changed = set(w._names)
+        else:
+            included = w.inclusions([w.lookup(last_revid)])
+            changed = map(w.idx_to_name, included)
+        return self._fileid_involved_by_set(changed)
+
+    def fileid_involved_by_set(self, changes):
+        """Find all file_ids modified by the set of revisions passed in.
+
+        :param changes: A set() of revision ids
+        """
+        # TODO: jam 20060119 This line does *nothing*, remove it.
+        #       or better yet, change _fileid_involved_by_set so
+        #       that it takes the inventory weave, rather than
+        #       pulling it out by itself.
+        return self._fileid_involved_by_set(changes)
+
+    def _fileid_involved_by_set(self, changes):
+        """Find the set of file-ids affected by the set of revisions.
+
+        :param changes: A set() of revision ids.
+        :return: A set() of file ids.
+        
+        This peaks at the Weave, interpreting each line, looking to
+        see if it mentions one of the revisions. And if so, includes
+        the file id mentioned.
+        This expects both the Weave format, and the serialization
+        to have a single line per file/directory, and to have
+        fileid="" and revision="" on that line.
+        """
+        assert isinstance(self._format, (RepositoryFormat5,
+                                         RepositoryFormat6,
+                                         RepositoryFormat7,
+                                         RepositoryFormatKnit1)), \
+            "fileid_involved only supported for branches which store inventory as unnested xml"
+
+        w = self.get_inventory_weave()
+        file_ids = set()
+        for line in w._weave:
+
+            # it is ugly, but it is due to the weave structure
+            if not isinstance(line, basestring): continue
+
+            start = line.find('file_id="')+9
+            if start < 9: continue
+            end = line.find('"', start)
+            assert end>= 0
+            file_id = xml.sax.saxutils.unescape(line[start:end])
+
+            # check if file_id is already present
+            if file_id in file_ids: continue
+
+            start = line.find('revision="')+10
+            if start < 10: continue
+            end = line.find('"', start)
+            assert end>= 0
+            revision_id = xml.sax.saxutils.unescape(line[start:end])
+
+            if revision_id in changes:
+                file_ids.add(file_id)
+        return file_ids
+
+    @needs_read_lock
+    def get_inventory_weave(self):
+        return self.control_weaves.get_weave('inventory',
+            self.get_transaction())
+
+    @needs_read_lock
+    def get_inventory(self, revision_id):
+        """Get Inventory object by hash."""
+        xml = self.get_inventory_xml(revision_id)
+        return bzrlib.xml5.serializer_v5.read_inventory_from_string(xml)
+
+    @needs_read_lock
+    def get_inventory_xml(self, revision_id):
+        """Get inventory XML as a file object."""
+        try:
+            assert isinstance(revision_id, basestring), type(revision_id)
+            iw = self.get_inventory_weave()
+            return iw.get_text(iw.lookup(revision_id))
+        except IndexError:
+            raise bzrlib.errors.HistoryMissing(self, 'inventory', revision_id)
+
+    @needs_read_lock
+    def get_inventory_sha1(self, revision_id):
+        """Return the sha1 hash of the inventory entry
+        """
+        return self.get_revision(revision_id).inventory_sha1
+
+    @needs_read_lock
+    def get_revision_graph(self, revision_id=None):
+        """Return a dictionary containing the revision graph.
+        
+        :return: a dictionary of revision_id->revision_parents_list.
+        """
+        weave = self.get_inventory_weave()
+        all_revisions = self._eliminate_revisions_not_present(weave.names())
+        entire_graph = dict([(node, weave.parent_names(node)) for 
+                             node in all_revisions])
+        if revision_id is None:
+            return entire_graph
+        elif revision_id not in entire_graph:
+            raise errors.NoSuchRevision(self, revision_id)
+        else:
+            # add what can be reached from revision_id
+            result = {}
+            pending = set([revision_id])
+            while len(pending) > 0:
+                node = pending.pop()
+                result[node] = entire_graph[node]
+                for revision_id in result[node]:
+                    if revision_id not in result:
+                        pending.add(revision_id)
+            return result
+
+    @needs_read_lock
+    def get_revision_inventory(self, revision_id):
+        """Return inventory of a past revision."""
+        # TODO: Unify this with get_inventory()
+        # bzr 0.0.6 and later imposes the constraint that the inventory_id
+        # must be the same as its revision, so this is trivial.
+        if revision_id is None:
+            # This does not make sense: if there is no revision,
+            # then it is the current tree inventory surely ?!
+            # and thus get_root_id() is something that looks at the last
+            # commit on the branch, and the get_root_id is an inventory check.
+            raise NotImplementedError
+            # return Inventory(self.get_root_id())
+        else:
+            return self.get_inventory(revision_id)
+
+    @needs_read_lock
+    def is_shared(self):
+        """Return True if this repository is flagged as a shared repository."""
+        # FIXME format 4-6 cannot be shared, this is technically faulty.
+        return self.control_files._transport.has('shared-storage')
+
+    @needs_read_lock
+    def revision_tree(self, revision_id):
+        """Return Tree for a revision on this branch.
+
+        `revision_id` may be None for the null revision, in which case
+        an `EmptyTree` is returned."""
+        # TODO: refactor this to use an existing revision object
+        # so we don't need to read it in twice.
+        if revision_id is None or revision_id == NULL_REVISION:
+            return EmptyTree()
+        else:
+            inv = self.get_revision_inventory(revision_id)
+            return RevisionTree(self, inv, revision_id)
+
+    @needs_read_lock
+    def get_ancestry(self, revision_id):
+        """Return a list of revision-ids integrated by a revision.
+        
+        This is topologically sorted.
+        """
+        if revision_id is None:
+            return [None]
+        if not self.has_revision(revision_id):
+            raise errors.NoSuchRevision(self, revision_id)
+        w = self.get_inventory_weave()
+        return [None] + map(w.idx_to_name,
+                            w.inclusions([w.lookup(revision_id)]))
+
+    @needs_read_lock
+    def print_file(self, file, revision_id):
+        """Print `file` to stdout.
+        
+        FIXME RBC 20060125 as John Meinel points out this is a bad api
+        - it writes to stdout, it assumes that that is valid etc. Fix
+        by creating a new more flexible convenience function.
+        """
+        tree = self.revision_tree(revision_id)
+        # use inventory as it was in that revision
+        file_id = tree.inventory.path2id(file)
+        if not file_id:
+            raise BzrError("%r is not present in revision %s" % (file, revno))
+            try:
+                revno = self.revision_id_to_revno(revision_id)
+            except errors.NoSuchRevision:
+                # TODO: This should not be BzrError,
+                # but NoSuchFile doesn't fit either
+                raise BzrError('%r is not present in revision %s' 
+                                % (file, revision_id))
+            else:
+                raise BzrError('%r is not present in revision %s'
+                                % (file, revno))
+        tree.print_file(file_id)
+
+    def get_transaction(self):
+        return self.control_files.get_transaction()
+
+    def revision_parents(self, revid):
+        return self.get_inventory_weave().parent_names(revid)
+
+    @needs_write_lock
+    def set_make_working_trees(self, new_value):
+        """Set the policy flag for making working trees when creating branches.
+
+        This only applies to branches that use this repository.
+
+        The default is 'True'.
+        :param new_value: True to restore the default, False to disable making
+                          working trees.
+        """
+        # FIXME: split out into a new class/strategy ?
+        if isinstance(self._format, (RepositoryFormat4,
+                                     RepositoryFormat5,
+                                     RepositoryFormat6)):
+            raise NotImplementedError(self.set_make_working_trees)
+        if new_value:
+            try:
+                self.control_files._transport.delete('no-working-trees')
+            except errors.NoSuchFile:
+                pass
+        else:
+            self.control_files.put_utf8('no-working-trees', '')
+    
+    def make_working_trees(self):
+        """Returns the policy for making working trees on new branches."""
+        # FIXME: split out into a new class/strategy ?
+        if isinstance(self._format, (RepositoryFormat4,
+                                     RepositoryFormat5,
+                                     RepositoryFormat6)):
+            return True
+        return not self.control_files._transport.has('no-working-trees')
+
+    @needs_write_lock
+    def sign_revision(self, revision_id, gpg_strategy):
+        plaintext = Testament.from_revision(self, revision_id).as_short_text()
+        self.store_revision_signature(gpg_strategy, plaintext, revision_id)
+
+
+class AllInOneRepository(Repository):
+    """Legacy support - the repository behaviour for all-in-one branches."""
+
+    def __init__(self, _format, a_bzrdir, revision_store):
+        # we reuse one control files instance.
+        dir_mode = a_bzrdir._control_files._dir_mode
+        file_mode = a_bzrdir._control_files._file_mode
+
+        def get_weave(name, prefixed=False):
+            if name:
+                name = safe_unicode(name)
+            else:
+                name = ''
+            relpath = a_bzrdir._control_files._escape(name)
+            weave_transport = a_bzrdir._control_files._transport.clone(relpath)
+            ws = WeaveStore(weave_transport, prefixed=prefixed,
+                            dir_mode=dir_mode,
+                            file_mode=file_mode)
+            if a_bzrdir._control_files._transport.should_cache():
+                ws.enable_cache = True
+            return ws
+
+        def get_store(name, compressed=True, prefixed=False):
+            # FIXME: This approach of assuming stores are all entirely compressed
+            # or entirely uncompressed is tidy, but breaks upgrade from 
+            # some existing branches where there's a mixture; we probably 
+            # still want the option to look for both.
+            relpath = a_bzrdir._control_files._escape(name)
+            store = TextStore(a_bzrdir._control_files._transport.clone(relpath),
+                              prefixed=prefixed, compressed=compressed,
+                              dir_mode=dir_mode,
+                              file_mode=file_mode)
+            #if self._transport.should_cache():
+            #    cache_path = os.path.join(self.cache_root, name)
+            #    os.mkdir(cache_path)
+            #    store = bzrlib.store.CachedStore(store, cache_path)
+            return store
+
+        # not broken out yet because the controlweaves|inventory_store
+        # and text_store | weave_store bits are still different.
+        if isinstance(_format, RepositoryFormat4):
+            self.inventory_store = get_store('inventory-store')
+            self.text_store = get_store('text-store')
+        elif isinstance(_format, RepositoryFormat5):
+            self.control_weaves = get_weave('')
+            self.weave_store = get_weave('weaves')
+        elif isinstance(_format, RepositoryFormat6):
+            self.control_weaves = get_weave('')
+            self.weave_store = get_weave('weaves', prefixed=True)
+        else:
+            raise errors.BzrError('unreachable code: unexpected repository'
+                                  ' format.')
+        revision_store.register_suffix('sig')
+        super(AllInOneRepository, self).__init__(_format, a_bzrdir, a_bzrdir._control_files, revision_store)
+
+
+class MetaDirRepository(Repository):
+    """Repositories in the new meta-dir layout."""
+
+    def __init__(self, _format, a_bzrdir, control_files, revision_store):
+        super(MetaDirRepository, self).__init__(_format,
+                                                a_bzrdir,
+                                                control_files,
+                                                revision_store)
+
+        dir_mode = self.control_files._dir_mode
+        file_mode = self.control_files._file_mode
+
+        def get_weave(name, prefixed=False):
+            if name:
+                name = safe_unicode(name)
+            else:
+                name = ''
+            relpath = self.control_files._escape(name)
+            weave_transport = self.control_files._transport.clone(relpath)
+            ws = WeaveStore(weave_transport, prefixed=prefixed,
+                            dir_mode=dir_mode,
+                            file_mode=file_mode)
+            if self.control_files._transport.should_cache():
+                ws.enable_cache = True
+            return ws
+
+        if isinstance(self._format, RepositoryFormat7):
+            self.control_weaves = get_weave('')
+            self.weave_store = get_weave('weaves', prefixed=True)
+        elif isinstance(self._format, RepositoryFormatKnit1):
+            self.control_weaves = get_weave('')
+            self.weave_store = get_weave('knits', prefixed=True)
+        else:
+            raise errors.BzrError('unreachable code: unexpected repository'
+                                  ' format.')
+
+
+class RepositoryFormat(object):
+    """A repository format.
+
+    Formats provide three things:
+     * An initialization routine to construct repository data on disk.
+     * a format string which is used when the BzrDir supports versioned
+       children.
+     * an open routine which returns a Repository instance.
+
+    Formats are placed in an dict by their format string for reference 
+    during opening. These should be subclasses of RepositoryFormat
+    for consistency.
+
+    Once a format is deprecated, just deprecate the initialize and open
+    methods on the format class. Do not deprecate the object, as the 
+    object will be created every system load.
+
+    Common instance attributes:
+    _matchingbzrdir - the bzrdir format that the repository format was
+    originally written to work with. This can be used if manually
+    constructing a bzrdir and repository, or more commonly for test suite
+    parameterisation.
+    """
+
+    _default_format = None
+    """The default format used for new repositories."""
+
+    _formats = {}
+    """The known formats."""
+
+    @classmethod
+    def find_format(klass, a_bzrdir):
+        """Return the format for the repository object in a_bzrdir."""
+        try:
+            transport = a_bzrdir.get_repository_transport(None)
+            format_string = transport.get("format").read()
+            return klass._formats[format_string]
+        except errors.NoSuchFile:
+            raise errors.NoRepositoryPresent(a_bzrdir)
+        except KeyError:
+            raise errors.UnknownFormatError(format_string)
+
+    @classmethod
+    def get_default_format(klass):
+        """Return the current default format."""
+        return klass._default_format
+
+    def get_format_string(self):
+        """Return the ASCII format string that identifies this format.
+        
+        Note that in pre format ?? repositories the format string is 
+        not permitted nor written to disk.
+        """
+        raise NotImplementedError(self.get_format_string)
+
+    def _get_revision_store(self, repo_transport, control_files):
+        """Return the revision store object for this a_bzrdir."""
+        raise NotImplementedError(self._get_revision_store)
+
+    def _get_rev_store(self,
+                   transport,
+                   control_files,
+                   name,
+                   compressed=True,
+                   prefixed=False):
+        """Common logic for getting a revision store for a repository.
+        
+        see self._get_revision_store for the method to 
+        get the store for a repository.
+        """
+        if name:
+            name = safe_unicode(name)
+        else:
+            name = ''
+        dir_mode = control_files._dir_mode
+        file_mode = control_files._file_mode
+        revision_store =TextStore(transport.clone(name),
+                                  prefixed=prefixed,
+                                  compressed=compressed,
+                                  dir_mode=dir_mode,
+                                  file_mode=file_mode)
+        revision_store.register_suffix('sig')
+        return revision_store
+
+    def initialize(self, a_bzrdir, shared=False):
+        """Initialize a repository of this format in a_bzrdir.
+
+        :param a_bzrdir: The bzrdir to put the new repository in it.
+        :param shared: The repository should be initialized as a sharable one.
+
+        This may raise UninitializableFormat if shared repository are not
+        compatible the a_bzrdir.
+        """
+
+    def is_supported(self):
+        """Is this format supported?
+
+        Supported formats must be initializable and openable.
+        Unsupported formats may not support initialization or committing or 
+        some other features depending on the reason for not being supported.
+        """
+        return True
+
+    def open(self, a_bzrdir, _found=False):
+        """Return an instance of this format for the bzrdir a_bzrdir.
+        
+        _found is a private parameter, do not use it.
+        """
+        raise NotImplementedError(self.open)
+
+    @classmethod
+    def register_format(klass, format):
+        klass._formats[format.get_format_string()] = format
+
+    @classmethod
+    def set_default_format(klass, format):
+        klass._default_format = format
+
+    @classmethod
+    def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
+        del klass._formats[format.get_format_string()]
+
+
+class PreSplitOutRepositoryFormat(RepositoryFormat):
+    """Base class for the pre split out repository formats."""
+
+    def initialize(self, a_bzrdir, shared=False, _internal=False):
+        """Create a weave repository.
+        
+        TODO: when creating split out bzr branch formats, move this to a common
+        base for Format5, Format6. or something like that.
+        """
+        from bzrlib.weavefile import write_weave_v5
+        from bzrlib.weave import Weave
+
+        if shared:
+            raise errors.IncompatibleFormat(self, a_bzrdir._format)
+
+        if not _internal:
+            # always initialized when the bzrdir is.
+            return self.open(a_bzrdir, _found=True)
+        
+        # Create an empty weave
+        sio = StringIO()
+        bzrlib.weavefile.write_weave_v5(Weave(), sio)
+        empty_weave = sio.getvalue()
+
+        mutter('creating repository in %s.', a_bzrdir.transport.base)
+        dirs = ['revision-store', 'weaves']
+        files = [('inventory.weave', StringIO(empty_weave)),
+                 ]
+        
+        # FIXME: RBC 20060125 dont peek under the covers
+        # NB: no need to escape relative paths that are url safe.
+        control_files = LockableFiles(a_bzrdir.transport, 'branch-lock',
+                                      TransportLock)
+        control_files.create_lock()
+        control_files.lock_write()
+        control_files._transport.mkdir_multi(dirs,
+                mode=control_files._dir_mode)
+        try:
+            for file, content in files:
+                control_files.put(file, content)
+        finally:
+            control_files.unlock()
+        return self.open(a_bzrdir, _found=True)
+
+    def open(self, a_bzrdir, _found=False):
+        """See RepositoryFormat.open()."""
+        if not _found:
+            # we are being called directly and must probe.
+            raise NotImplementedError
+
+        repo_transport = a_bzrdir.get_repository_transport(None)
+        control_files = a_bzrdir._control_files
+        revision_store = self._get_revision_store(repo_transport, control_files)
+        return AllInOneRepository(_format=self,
+                                  a_bzrdir=a_bzrdir,
+                                  revision_store=revision_store)
+
+
+class RepositoryFormat4(PreSplitOutRepositoryFormat):
+    """Bzr repository format 4.
+
+    This repository format has:
+     - flat stores
+     - TextStores for texts, inventories,revisions.
+
+    This format is deprecated: it indexes texts using a text id which is
+    removed in format 5; initializationa and write support for this format
+    has been removed.
+    """
+
+    def __init__(self):
+        super(RepositoryFormat4, self).__init__()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat4()
+
+    def initialize(self, url, shared=False, _internal=False):
+        """Format 4 branches cannot be created."""
+        raise errors.UninitializableFormat(self)
+
+    def is_supported(self):
+        """Format 4 is not supported.
+
+        It is not supported because the model changed from 4 to 5 and the
+        conversion logic is expensive - so doing it on the fly was not 
+        feasible.
+        """
+        return False
+
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        return self._get_rev_store(repo_transport,
+                                   control_files,
+                                   'revision-store')
+
+
+class RepositoryFormat5(PreSplitOutRepositoryFormat):
+    """Bzr control format 5.
+
+    This repository format has:
+     - weaves for file texts and inventory
+     - flat stores
+     - TextStores for revisions and signatures.
+    """
+
+    def __init__(self):
+        super(RepositoryFormat5, self).__init__()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat5()
+
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        """Return the revision store object for this a_bzrdir."""
+        return self._get_rev_store(repo_transport,
+                                   control_files,
+                                   'revision-store',
+                                   compressed=False)
+
+
+class RepositoryFormat6(PreSplitOutRepositoryFormat):
+    """Bzr control format 6.
+
+    This repository format has:
+     - weaves for file texts and inventory
+     - hash subdirectory based stores.
+     - TextStores for revisions and signatures.
+    """
+
+    def __init__(self):
+        super(RepositoryFormat6, self).__init__()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirFormat6()
+
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        return self._get_rev_store(repo_transport,
+                                   control_files,
+                                   'revision-store',
+                                   compressed=False,
+                                   prefixed=True)
+
+
+class MetaDirRepositoryFormat(RepositoryFormat):
+    """Common base class for the new repositories using the metadir layour."""
+
+    def __init__(self):
+        super(MetaDirRepositoryFormat, self).__init__()
+        self._matchingbzrdir = bzrlib.bzrdir.BzrDirMetaFormat1()
+
+    def _create_control_files(self, a_bzrdir):
+        """Create the required files and the initial control_files object."""
+        # FIXME: RBC 20060125 dont peek under the covers
+        # NB: no need to escape relative paths that are url safe.
+        repository_transport = a_bzrdir.get_repository_transport(self)
+        control_files = LockableFiles(repository_transport, 'lock', LockDir)
+        control_files.create_lock()
+        return control_files
+
+    def _get_revision_store(self, repo_transport, control_files):
+        """See RepositoryFormat._get_revision_store()."""
+        return self._get_rev_store(repo_transport,
+                                   control_files,
+                                   'revision-store',
+                                   compressed=False,
+                                   prefixed=True,
+                                   )
+
+    def open(self, a_bzrdir, _found=False, _override_transport=None):
+        """See RepositoryFormat.open().
+        
+        :param _override_transport: INTERNAL USE ONLY. Allows opening the
+                                    repository at a slightly different url
+                                    than normal. I.e. during 'upgrade'.
+        """
+        if not _found:
+            format = RepositoryFormat.find_format(a_bzrdir)
+            assert format.__class__ ==  self.__class__
+        if _override_transport is not None:
+            repo_transport = _override_transport
+        else:
+            repo_transport = a_bzrdir.get_repository_transport(None)
+        control_files = LockableFiles(repo_transport, 'lock', LockDir)
+        revision_store = self._get_revision_store(repo_transport, control_files)
+        return MetaDirRepository(_format=self,
+                                 a_bzrdir=a_bzrdir,
+                                 control_files=control_files,
+                                 revision_store=revision_store)
+
+    def _upload_blank_content(self, a_bzrdir, dirs, files, utf8_files, shared):
+        """Upload the initial blank content."""
+        control_files = self._create_control_files(a_bzrdir)
+        control_files.lock_write()
+        try:
+            control_files._transport.mkdir_multi(dirs,
+                    mode=control_files._dir_mode)
+            for file, content in files:
+                control_files.put(file, content)
+            for file, content in utf8_files:
+                control_files.put_utf8(file, content)
+            if shared == True:
+                control_files.put_utf8('shared-storage', '')
+        finally:
+            control_files.unlock()
+
+
+class RepositoryFormat7(MetaDirRepositoryFormat):
+    """Bzr repository 7.
+
+    This repository format has:
+     - weaves for file texts and inventory
+     - hash subdirectory based stores.
+     - TextStores for revisions and signatures.
+     - a format marker of its own
+     - an optional 'shared-storage' flag
+     - an optional 'no-working-trees' flag
+    """
+
+    def get_format_string(self):
+        """See RepositoryFormat.get_format_string()."""
+        return "Bazaar-NG Repository format 7"
+
+    def initialize(self, a_bzrdir, shared=False):
+        """Create a weave repository.
+
+        :param shared: If true the repository will be initialized as a shared
+                       repository.
+        """
+        from bzrlib.weavefile import write_weave_v5
+        from bzrlib.weave import Weave
+
+        # Create an empty weave
+        sio = StringIO()
+        bzrlib.weavefile.write_weave_v5(Weave(), sio)
+        empty_weave = sio.getvalue()
+
+        mutter('creating repository in %s.', a_bzrdir.transport.base)
+        dirs = ['revision-store', 'weaves']
+        files = [('inventory.weave', StringIO(empty_weave)), 
+                 ]
+        utf8_files = [('format', self.get_format_string())]
+ 
+        self._upload_blank_content(a_bzrdir, dirs, files, utf8_files, shared)
+        return self.open(a_bzrdir=a_bzrdir, _found=True)
+
+
+class RepositoryFormatKnit1(MetaDirRepositoryFormat):
+    """Bzr repository knit format 1.
+
+    This repository format has:
+     - knits for file texts and inventory
+     - hash subdirectory based stores.
+     - knits for revisions and signatures
+     - TextStores for revisions and signatures.
+     - a format marker of its own
+     - an optional 'shared-storage' flag
+     - an optional 'no-working-trees' flag
+     - a LockDir lock
+    """
+
+    def get_format_string(self):
+        """See RepositoryFormat.get_format_string()."""
+        return "Bazaar-NG Knit Repository Format 1"
+
+    def initialize(self, a_bzrdir, shared=False):
+        """Create a knit format 1 repository.
+
+        :param shared: If true the repository will be initialized as a shared
+                       repository.
+        XXX NOTE that this current uses a Weave for testing and will become 
+            A Knit in due course.
+        """
+        from bzrlib.weavefile import write_weave_v5
+        from bzrlib.weave import Weave
+
+        # Create an empty weave
+        sio = StringIO()
+        bzrlib.weavefile.write_weave_v5(Weave(), sio)
+        empty_weave = sio.getvalue()
+
+        mutter('creating repository in %s.', a_bzrdir.transport.base)
+        dirs = ['revision-store', 'knits']
+        files = [('inventory.weave', StringIO(empty_weave)), 
+                 ]
+        utf8_files = [('format', self.get_format_string())]
+        
+        self._upload_blank_content(a_bzrdir, dirs, files, utf8_files, shared)
+        return self.open(a_bzrdir=a_bzrdir, _found=True)
+
+
+# formats which have no format string are not discoverable
+# and not independently creatable, so are not registered.
+_default_format = RepositoryFormat7()
+RepositoryFormat.register_format(_default_format)
+RepositoryFormat.register_format(RepositoryFormatKnit1())
+RepositoryFormat.set_default_format(_default_format)
+_legacy_formats = [RepositoryFormat4(),
+                   RepositoryFormat5(),
+                   RepositoryFormat6()]
+
+
+class InterRepository(object):
+    """This class represents operations taking place between two repositories.
+
+    Its instances have methods like copy_content and fetch, and contain
+    references to the source and target repositories these operations can be 
+    carried out on.
+
+    Often we will provide convenience methods on 'repository' which carry out
+    operations with another repository - they will always forward to
+    InterRepository.get(other).method_name(parameters).
+    """
+    # XXX: FIXME: FUTURE: robertc
+    # testing of these probably requires a factory in optimiser type, and 
+    # then a test adapter to test each type thoroughly.
+    #
+
+    _optimisers = set()
+    """The available optimised InterRepository types."""
+
+    def __init__(self, source, target):
+        """Construct a default InterRepository instance. Please use 'get'.
+        
+        Only subclasses of InterRepository should call 
+        InterRepository.__init__ - clients should call InterRepository.get
+        instead which will create an optimised InterRepository if possible.
+        """
+        self.source = source
+        self.target = target
+
+    @needs_write_lock
+    def copy_content(self, revision_id=None, basis=None):
+        """Make a complete copy of the content in self into destination.
+        
+        This is a destructive operation! Do not use it on existing 
+        repositories.
+
+        :param revision_id: Only copy the content needed to construct
+                            revision_id and its parents.
+        :param basis: Copy the needed data preferentially from basis.
+        """
+        try:
+            self.target.set_make_working_trees(self.source.make_working_trees())
+        except NotImplementedError:
+            pass
+        # grab the basis available data
+        if basis is not None:
+            self.target.fetch(basis, revision_id=revision_id)
+        # but dont both fetching if we have the needed data now.
+        if (revision_id not in (None, NULL_REVISION) and 
+            self.target.has_revision(revision_id)):
+            return
+        self.target.fetch(self.source, revision_id=revision_id)
+
+    def _double_lock(self, lock_source, lock_target):
+        """Take out too locks, rolling back the first if the second throws."""
+        lock_source()
+        try:
+            lock_target()
+        except Exception:
+            # we want to ensure that we don't leave source locked by mistake.
+            # and any error on target should not confuse source.
+            self.source.unlock()
+            raise
+
+    @needs_write_lock
+    def fetch(self, revision_id=None, pb=None):
+        """Fetch the content required to construct revision_id.
+
+        The content is copied from source to target.
+
+        :param revision_id: if None all content is copied, if NULL_REVISION no
+                            content is copied.
+        :param pb: optional progress bar to use for progress reports. If not
+                   provided a default one will be created.
+
+        Returns the copied revision count and the failed revisions in a tuple:
+        (copied, failures).
+        """
+        from bzrlib.fetch import RepoFetcher
+        mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
+               self.source, self.source._format, self.target, self.target._format)
+        f = RepoFetcher(to_repository=self.target,
+                        from_repository=self.source,
+                        last_revision=revision_id,
+                        pb=pb)
+        return f.count_copied, f.failed_revisions
+
+    @classmethod
+    def get(klass, repository_source, repository_target):
+        """Retrieve a InterRepository worker object for these repositories.
+
+        :param repository_source: the repository to be the 'source' member of
+                                  the InterRepository instance.
+        :param repository_target: the repository to be the 'target' member of
+                                the InterRepository instance.
+        If an optimised InterRepository worker exists it will be used otherwise
+        a default InterRepository instance will be created.
+        """
+        for provider in klass._optimisers:
+            if provider.is_compatible(repository_source, repository_target):
+                return provider(repository_source, repository_target)
+        return InterRepository(repository_source, repository_target)
+
+    def lock_read(self):
+        """Take out a logical read lock.
+
+        This will lock the source branch and the target branch. The source gets
+        a read lock and the target a read lock.
+        """
+        self._double_lock(self.source.lock_read, self.target.lock_read)
+
+    def lock_write(self):
+        """Take out a logical write lock.
+
+        This will lock the source branch and the target branch. The source gets
+        a read lock and the target a write lock.
+        """
+        self._double_lock(self.source.lock_read, self.target.lock_write)
+
+    @needs_read_lock
+    def missing_revision_ids(self, revision_id=None):
+        """Return the revision ids that source has that target does not.
+        
+        These are returned in topological order.
+
+        :param revision_id: only return revision ids included by this
+                            revision_id.
+        """
+        # generic, possibly worst case, slow code path.
+        target_ids = set(self.target.all_revision_ids())
+        if revision_id is not None:
+            source_ids = self.source.get_ancestry(revision_id)
+            assert source_ids.pop(0) == None
+        else:
+            source_ids = self.source.all_revision_ids()
+        result_set = set(source_ids).difference(target_ids)
+        # this may look like a no-op: its not. It preserves the ordering
+        # other_ids had while only returning the members from other_ids
+        # that we've decided we need.
+        return [rev_id for rev_id in source_ids if rev_id in result_set]
+
+    @classmethod
+    def register_optimiser(klass, optimiser):
+        """Register an InterRepository optimiser."""
+        klass._optimisers.add(optimiser)
+
+    def unlock(self):
+        """Release the locks on source and target."""
+        try:
+            self.target.unlock()
+        finally:
+            self.source.unlock()
+
+    @classmethod
+    def unregister_optimiser(klass, optimiser):
+        """Unregister an InterRepository optimiser."""
+        klass._optimisers.remove(optimiser)
+
+
+class InterWeaveRepo(InterRepository):
+    """Optimised code paths between Weave based repositories."""
+
+    _matching_repo_format = _default_format
+    """Repository format for testing with."""
+
+    @staticmethod
+    def is_compatible(source, target):
+        """Be compatible with known Weave formats.
+        
+        We dont test for the stores being of specific types becase that
+        could lead to confusing results, and there is no need to be 
+        overly general.
+        """
+        try:
+            return (isinstance(source._format, (RepositoryFormat5,
+                                                RepositoryFormat6,
+                                                RepositoryFormat7)) and
+                    isinstance(target._format, (RepositoryFormat5,
+                                                RepositoryFormat6,
+                                                RepositoryFormat7)))
+        except AttributeError:
+            return False
+    
+    @needs_write_lock
+    def copy_content(self, revision_id=None, basis=None):
+        """See InterRepository.copy_content()."""
+        # weave specific optimised path:
+        if basis is not None:
+            # copy the basis in, then fetch remaining data.
+            basis.copy_content_into(self.target, revision_id)
+            # the basis copy_content_into could misset this.
+            try:
+                self.target.set_make_working_trees(self.source.make_working_trees())
+            except NotImplementedError:
+                pass
+            self.target.fetch(self.source, revision_id=revision_id)
+        else:
+            try:
+                self.target.set_make_working_trees(self.source.make_working_trees())
+            except NotImplementedError:
+                pass
+            # FIXME do not peek!
+            if self.source.control_files._transport.listable():
+                pb = bzrlib.ui.ui_factory.progress_bar()
+                copy_all(self.source.weave_store,
+                    self.target.weave_store, pb=pb)
+                pb.update('copying inventory', 0, 1)
+                self.target.control_weaves.copy_multi(
+                    self.source.control_weaves, ['inventory'])
+                copy_all(self.source.revision_store,
+                    self.target.revision_store, pb=pb)
+            else:
+                self.target.fetch(self.source, revision_id=revision_id)
+
+    @needs_write_lock
+    def fetch(self, revision_id=None, pb=None):
+        """See InterRepository.fetch()."""
+        from bzrlib.fetch import RepoFetcher
+        mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
+               self.source, self.source._format, self.target, self.target._format)
+        f = RepoFetcher(to_repository=self.target,
+                        from_repository=self.source,
+                        last_revision=revision_id,
+                        pb=pb)
+        return f.count_copied, f.failed_revisions
+
+    @needs_read_lock
+    def missing_revision_ids(self, revision_id=None):
+        """See InterRepository.missing_revision_ids()."""
+        # we want all revisions to satisfy revision_id in source.
+        # but we dont want to stat every file here and there.
+        # we want then, all revisions other needs to satisfy revision_id 
+        # checked, but not those that we have locally.
+        # so the first thing is to get a subset of the revisions to 
+        # satisfy revision_id in source, and then eliminate those that
+        # we do already have. 
+        # this is slow on high latency connection to self, but as as this
+        # disk format scales terribly for push anyway due to rewriting 
+        # inventory.weave, this is considered acceptable.
+        # - RBC 20060209
+        if revision_id is not None:
+            source_ids = self.source.get_ancestry(revision_id)
+            assert source_ids.pop(0) == None
+        else:
+            source_ids = self.source._all_possible_ids()
+        source_ids_set = set(source_ids)
+        # source_ids is the worst possible case we may need to pull.
+        # now we want to filter source_ids against what we actually
+        # have in target, but dont try to check for existence where we know
+        # we do not have a revision as that would be pointless.
+        target_ids = set(self.target._all_possible_ids())
+        possibly_present_revisions = target_ids.intersection(source_ids_set)
+        actually_present_revisions = set(self.target._eliminate_revisions_not_present(possibly_present_revisions))
+        required_revisions = source_ids_set.difference(actually_present_revisions)
+        required_topo_revisions = [rev_id for rev_id in source_ids if rev_id in required_revisions]
+        if revision_id is not None:
+            # we used get_ancestry to determine source_ids then we are assured all
+            # revisions referenced are present as they are installed in topological order.
+            # and the tip revision was validated by get_ancestry.
+            return required_topo_revisions
+        else:
+            # if we just grabbed the possibly available ids, then 
+            # we only have an estimate of whats available and need to validate
+            # that against the revision records.
+            return self.source._eliminate_revisions_not_present(required_topo_revisions)
+
+
+InterRepository.register_optimiser(InterWeaveRepo)
+
+
+class RepositoryTestProviderAdapter(object):
+    """A tool to generate a suite testing multiple repository formats at once.
+
+    This is done by copying the test once for each transport and injecting
+    the transport_server, transport_readonly_server, and bzrdir_format and
+    repository_format classes into each copy. Each copy is also given a new id()
+    to make it easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, formats):
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self._formats = formats
+    
+    def adapt(self, test):
+        result = TestSuite()
+        for repository_format, bzrdir_format in self._formats:
+            new_test = deepcopy(test)
+            new_test.transport_server = self._transport_server
+            new_test.transport_readonly_server = self._transport_readonly_server
+            new_test.bzrdir_format = bzrdir_format
+            new_test.repository_format = repository_format
+            def make_new_test_id():
+                new_id = "%s(%s)" % (new_test.id(), repository_format.__class__.__name__)
+                return lambda: new_id
+            new_test.id = make_new_test_id()
+            result.addTest(new_test)
+        return result
+
+
+class InterRepositoryTestProviderAdapter(object):
+    """A tool to generate a suite testing multiple inter repository formats.
+
+    This is done by copying the test once for each interrepo provider and injecting
+    the transport_server, transport_readonly_server, repository_format and 
+    repository_to_format classes into each copy.
+    Each copy is also given a new id() to make it easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, formats):
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self._formats = formats
+    
+    def adapt(self, test):
+        result = TestSuite()
+        for interrepo_class, repository_format, repository_format_to in self._formats:
+            new_test = deepcopy(test)
+            new_test.transport_server = self._transport_server
+            new_test.transport_readonly_server = self._transport_readonly_server
+            new_test.interrepo_class = interrepo_class
+            new_test.repository_format = repository_format
+            new_test.repository_format_to = repository_format_to
+            def make_new_test_id():
+                new_id = "%s(%s)" % (new_test.id(), interrepo_class.__name__)
+                return lambda: new_id
+            new_test.id = make_new_test_id()
+            result.addTest(new_test)
+        return result
+
+    @staticmethod
+    def default_test_list():
+        """Generate the default list of interrepo permutations to test."""
+        result = []
+        # test the default InterRepository between format 6 and the current 
+        # default format.
+        # XXX: robertc 20060220 reinstate this when there are two supported
+        # formats which do not have an optimal code path between them.
+        result.append((InterRepository,
+                       RepositoryFormat6(),
+                       RepositoryFormatKnit1()))
+        for optimiser in InterRepository._optimisers:
+            result.append((optimiser,
+                           optimiser._matching_repo_format,
+                           optimiser._matching_repo_format
+                           ))
+        # if there are specific combinations we want to use, we can add them 
+        # here.
+        return result
+
+
+class CopyConverter(object):
+    """A repository conversion tool which just performs a copy of the content.
+    
+    This is slow but quite reliable.
+    """
+
+    def __init__(self, target_format):
+        """Create a CopyConverter.
+
+        :param target_format: The format the resulting repository should be.
+        """
+        self.target_format = target_format
+        
+    def convert(self, repo, pb):
+        """Perform the conversion of to_convert, giving feedback via pb.
+
+        :param to_convert: The disk object to convert.
+        :param pb: a progress bar to use for progress information.
+        """
+        self.pb = pb
+        self.count = 0
+        self.total = 3
+        # this is only useful with metadir layouts - separated repo content.
+        # trigger an assertion if not such
+        repo._format.get_format_string()
+        self.repo_dir = repo.bzrdir
+        self.step('Moving repository to repository.backup')
+        self.repo_dir.transport.move('repository', 'repository.backup')
+        backup_transport =  self.repo_dir.transport.clone('repository.backup')
+        self.source_repo = repo._format.open(self.repo_dir,
+            _found=True,
+            _override_transport=backup_transport)
+        self.step('Creating new repository')
+        converted = self.target_format.initialize(self.repo_dir,
+                                                  self.source_repo.is_shared())
+        converted.lock_write()
+        try:
+            self.step('Copying content into repository.')
+            self.source_repo.copy_content_into(converted)
+        finally:
+            converted.unlock()
+        self.step('Deleting old repository content.')
+        self.repo_dir.transport.delete_tree('repository.backup')
+        self.pb.note('repository converted')
+
+    def step(self, message):
+        """Update the pb by a step."""
+        self.count +=1
+        self.pb.update(message, self.count, self.total)

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2006-01-25 14:30:06 +0000
+++ bzrlib/revision.py	2006-03-20 08:31:00 +0000
@@ -17,9 +17,12 @@
 # TODO: Some kind of command-line display of revision properties: 
 # perhaps show them in log -v and allow them as options to the commit command.
 
+
 import bzrlib.errors
+import bzrlib.errors as errors
 from bzrlib.graph import node_distances, select_farthest, all_descendants
 from bzrlib.osutils import contains_whitespace
+from bzrlib.progress import DummyProgress
 
 NULL_REVISION="null:"
 
@@ -78,6 +81,25 @@
                 raise ValueError("invalid property value %r for %r" % 
                                  (name, value))
 
+    def get_history(self, repository):
+        """Return the canonical line-of-history for this revision.
+
+        If ghosts are present this may differ in result from a ghost-free
+        repository.
+        """
+        current_revision = self
+        reversed_result = []
+        while current_revision is not None:
+            reversed_result.append(current_revision.revision_id)
+            if not len (current_revision.parent_ids):
+                reversed_result.append(None)
+                current_revision = None
+            else:
+                next_revision_id = current_revision.parent_ids[0]
+                current_revision = repository.get_revision(next_revision_id)
+        reversed_result.reverse()
+        return reversed_result
+
 
 def is_ancestor(revision_id, candidate_id, branch):
     """Return true if candidate_id is an ancestor of revision_id.
@@ -88,7 +110,7 @@
     revisions_source is an object supporting a get_revision operation that
     behaves like Branch's.
     """
-    return candidate_id in branch.get_ancestry(revision_id)
+    return candidate_id in branch.repository.get_ancestry(revision_id)
 
 
 def iter_ancestors(revision_id, revision_source, only_present=False):
@@ -138,101 +160,46 @@
     return matches
 
 
-def old_common_ancestor(revision_a, revision_b, revision_source):
-    """Find the ancestor common to both revisions that is closest to both.
-    """
-    from bzrlib.trace import mutter
-    a_ancestors = find_present_ancestors(revision_a, revision_source)
-    b_ancestors = find_present_ancestors(revision_b, revision_source)
-    a_intersection = []
-    b_intersection = []
-    # a_order is used as a tie-breaker when two equally-good bases are found
-    for revision, (a_order, a_distance) in a_ancestors.iteritems():
-        if b_ancestors.has_key(revision):
-            a_intersection.append((a_distance, a_order, revision))
-            b_intersection.append((b_ancestors[revision][1], a_order, revision))
-    mutter("a intersection: %r", a_intersection)
-    mutter("b intersection: %r", b_intersection)
-
-    a_closest = __get_closest(a_intersection)
-    if len(a_closest) == 0:
-        return None
-    b_closest = __get_closest(b_intersection)
-    assert len(b_closest) != 0
-    mutter ("a_closest %r", a_closest)
-    mutter ("b_closest %r", b_closest)
-    if a_closest[0] in b_closest:
-        return a_closest[0]
-    elif b_closest[0] in a_closest:
-        return b_closest[0]
-    else:
-        raise bzrlib.errors.AmbiguousBase((a_closest[0], b_closest[0]))
-    return a_closest[0]
-
 def revision_graph(revision, revision_source):
     """Produce a graph of the ancestry of the specified revision.
-    Return root, ancestors map, descendants map
-
-    TODO: Produce graphs with the NULL revision as root, so that we can find
-    a common even when trees are not branches don't represent a single line
-    of descent.
-    RBC: 20051024: note that when we have two partial histories, this may not
-         be possible. But if we are willing to pretend :)... sure.
+    
+    :return: root, ancestors map, descendants map
     """
+    revision_source.lock_read()
+    try:
+        return _revision_graph(revision, revision_source)
+    finally:
+        revision_source.unlock()
+
+
+def _revision_graph(revision, revision_source):
+    """See revision_graph."""
+    from bzrlib.tsort import topo_sort
+    graph = revision_source.get_revision_graph(revision)
+    # mark all no-parent revisions as being NULL_REVISION parentage.
+    for node, parents in graph.items():
+        if len(parents) == 0:
+            graph[node] = [NULL_REVISION]
+    # add NULL_REVISION to the graph
+    graph[NULL_REVISION] = []
+
+    # pick a root. If there are multiple roots
+    # this could pick a random one.
+    topo_order = topo_sort(graph.items())
+    root = topo_order[0]
+
     ancestors = {}
     descendants = {}
-    lines = [revision]
-    root = None
-    descendants[revision] = {}
-    while len(lines) > 0:
-        new_lines = set()
-        for line in lines:
-            if line == NULL_REVISION:
-                parents = []
-                root = NULL_REVISION
-            else:
-                try:
-                    rev = revision_source.get_revision(line)
-                    parents = list(rev.parent_ids)
-                    if len(parents) == 0:
-                        parents = [NULL_REVISION]
-                except bzrlib.errors.NoSuchRevision:
-                    if line == revision:
-                        raise
-                    parents = None
-            if parents is not None:
-                for parent in parents:
-                    if parent not in ancestors:
-                        new_lines.add(parent)
-                    if parent not in descendants:
-                        descendants[parent] = {}
-                    descendants[parent][line] = 1
-            if parents is not None:
-                ancestors[line] = set(parents)
-        lines = new_lines
-    if root is None:
-        # The history for revision becomes inaccessible without
-        # actually hitting a no-parents revision. This then
-        # makes these asserts below trigger. So, if root is None
-        # determine the actual root by walking the accessible tree
-        # and then stash NULL_REVISION at the end.
-        root = NULL_REVISION
-        descendants[root] = {}
-        # for every revision, check we can access at least
-        # one parent, if we cant, add NULL_REVISION and
-        # a link
-        for rev in ancestors:
-            if len(ancestors[rev]) == 0:
-                raise RuntimeError('unreachable code ?!')
-            ok = False
-            for parent in ancestors[rev]:
-                if parent in ancestors:
-                    ok = True
-            if ok:
-                continue
-            descendants[root][rev] = 1
-            ancestors[rev].add(root)
-        ancestors[root] = set()
+
+    # map the descendants of the graph.
+    # and setup our set based return graph.
+    for node in graph.keys():
+        descendants[node] = {}
+    for node, parents in graph.items():
+        for parent in parents:
+            descendants[parent][node] = 1
+        ancestors[node] = set(parents)
+
     assert root not in descendants[root]
     assert root not in ancestors[root]
     return root, ancestors, descendants
@@ -241,9 +208,10 @@
 def combined_graph(revision_a, revision_b, revision_source):
     """Produce a combined ancestry graph.
     Return graph root, ancestors map, descendants map, set of common nodes"""
-    root, ancestors, descendants = revision_graph(revision_a, revision_source)
-    root_b, ancestors_b, descendants_b = revision_graph(revision_b, 
-                                                        revision_source)
+    root, ancestors, descendants = revision_graph(
+        revision_a, revision_source)
+    root_b, ancestors_b, descendants_b = revision_graph(
+        revision_b, revision_source)
     if root != root_b:
         raise bzrlib.errors.NoCommonRoot(revision_a, revision_b)
     common = set()
@@ -260,17 +228,28 @@
     return root, ancestors, descendants, common
 
 
-def common_ancestor(revision_a, revision_b, revision_source):
+def common_ancestor(revision_a, revision_b, revision_source, 
+                    pb=DummyProgress()):
+    if None in (revision_a, revision_b):
+        return None
     try:
-        root, ancestors, descendants, common = \
-            combined_graph(revision_a, revision_b, revision_source)
-    except bzrlib.errors.NoCommonRoot:
-        raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
-        
-    distances = node_distances (descendants, ancestors, root)
-    farthest = select_farthest(distances, common)
-    if farthest is None or farthest == NULL_REVISION:
-        raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
+        try:
+            pb.update('Picking ancestor', 1, 3)
+            root, ancestors, descendants, common = \
+                combined_graph(revision_a,
+                               revision_b,
+                               revision_source)
+        except bzrlib.errors.NoCommonRoot:
+            raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
+            
+        pb.update('Picking ancestor', 2, 3)
+        distances = node_distances (descendants, ancestors, root)
+        pb.update('Picking ancestor', 3, 2)
+        farthest = select_farthest(distances, common)
+        if farthest is None or farthest == NULL_REVISION:
+            raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
+    finally:
+        pb.clear()
     return farthest
 
 
@@ -281,6 +260,14 @@
         assert len(args) != 0
         self._revision_sources = args
 
+    def revision_parents(self, revision_id):
+        for source in self._revision_sources:
+            try:
+                return source.revision_parents(revision_id)
+            except (errors.WeaveRevisionNotPresent, errors.NoSuchRevision), e:
+                pass
+        raise e
+
     def get_revision(self, revision_id):
         for source in self._revision_sources:
             try:
@@ -289,6 +276,26 @@
                 pass
         raise e
 
+    def get_revision_graph(self, revision_id):
+        result = {}
+        for source in self._revision_sources:
+            try:
+                result.update(source.get_revision_graph(revision_id))
+            except (errors.WeaveRevisionNotPresent, errors.NoSuchRevision), e:
+                pass
+        if result:
+            return result
+        raise e
+
+    def lock_read(self):
+        for source in self._revision_sources:
+            source.lock_read()
+
+    def unlock(self):
+        for source in self._revision_sources:
+            source.unlock()
+
+
 def get_intervening_revisions(ancestor_id, rev_id, rev_source, 
                               revision_history=None):
     """Find the longest line of descent from maybe_ancestor to revision.

=== modified file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2006-01-25 14:30:06 +0000
+++ bzrlib/revisionspec.py	2006-03-20 08:31:00 +0000
@@ -57,7 +57,7 @@
         # TODO: otherwise, it should depend on how I was built -
         # if it's in_history(branch), then check revision_history(),
         # if it's in_store(branch), do the check below
-        return self.branch.revision_store.has_id(self.rev_id)
+        return self.branch.repository.has_revision(self.rev_id)
 
     def __len__(self):
         return 2
@@ -68,7 +68,7 @@
         raise IndexError(index)
 
     def get(self):
-        return self.branch.get_revision(self.rev_id)
+        return self.branch.repository.get_revision(self.rev_id)
 
     def __eq__(self, other):
         if type(other) not in (tuple, list, type(self)):
@@ -297,7 +297,7 @@
                     hour=hour, minute=minute, second=second)
         first = dt
         for i in range(len(revs)):
-            r = branch.get_revision(revs[i])
+            r = branch.repository.get_revision(revs[i])
             # TODO: Handle timezone.
             dt = datetime.datetime.fromtimestamp(r.timestamp)
             if first <= dt:
@@ -319,7 +319,8 @@
         for r, b in ((revision_a, branch), (revision_b, other_branch)):
             if r is None:
                 raise NoCommits(b)
-        revision_source = MultipleRevisionSources(branch, other_branch)
+        revision_source = MultipleRevisionSources(branch.repository,
+                                                  other_branch.repository)
         rev_id = common_ancestor(revision_a, revision_b, revision_source)
         try:
             revno = branch.revision_id_to_revno(rev_id)
@@ -338,13 +339,12 @@
 
     def _match_on(self, branch, revs):
         from branch import Branch
-        from fetch import greedy_fetch
         other_branch = Branch.open_containing(self.spec)[0]
         revision_b = other_branch.last_revision()
         if revision_b is None:
             raise NoCommits(other_branch)
         # pull in the remote revisions so we can diff
-        greedy_fetch(branch, other_branch, revision=revision_b)
+        branch.fetch(other_branch, revision_b)
         try:
             revno = branch.revision_id_to_revno(revision_b)
         except NoSuchRevision:

=== modified file 'bzrlib/rio.py'
--- bzrlib/rio.py	2006-01-25 14:30:06 +0000
+++ bzrlib/rio.py	2006-03-20 08:31:00 +0000
@@ -1,7 +1,7 @@
 # Copyright (C) 2005 by Canonical Ltd
 #
 # Distributed under the GNU General Public Licence v2
-#
+
 # \subsection{\emph{rio} - simple text metaformat}
 # 
 # \emph{r} stands for `restricted', `reproducible', or `rfc822-like'.
@@ -18,10 +18,6 @@
 # stream representation of an object and vice versa, and that this relation
 # will continue to hold for future versions of bzr.
 
-# In comments, $\min(1,10)$
-
-min(1,10)
- 
 import re
 
 # XXX: some redundancy is allowing to write stanzas in isolation as well as
@@ -92,12 +88,15 @@
         """Append a name and value to the stanza."""
         assert valid_tag(tag), \
             ("invalid tag %r" % tag)
-        if isinstance(value, (str, unicode)):
+        if isinstance(value, str):
+            value = unicode(value)
+        elif isinstance(value, unicode):
             pass
         ## elif isinstance(value, (int, long)):
         ##    value = str(value)           # XXX: python2.4 without L-suffix
         else:
-            raise ValueError("invalid value %r" % value)
+            raise TypeError("invalid type for rio value: %r of type %s"
+                            % (value, type(value)))
         self.items.append((tag, value))
         
     def __contains__(self, find_tag):
@@ -127,23 +126,27 @@
         return iter(self.items)
 
     def to_lines(self):
-        """Generate sequence of lines for external version of this file."""
+        """Generate sequence of lines for external version of this file.
+        
+        The lines are always utf-8 encoded strings.
+        """
         if not self.items:
             # max() complains if sequence is empty
             return []
         result = []
         for tag, value in self.items:
-            assert isinstance(value, (str, unicode))
+            assert isinstance(tag, str)
+            assert isinstance(value, unicode)
             if value == '':
                 result.append(tag + ': \n')
             elif '\n' in value:
                 # don't want splitlines behaviour on empty lines
                 val_lines = value.split('\n')
-                result.append(tag + ': ' + val_lines[0] + '\n')
+                result.append(tag + ': ' + val_lines[0].encode('utf-8') + '\n')
                 for line in val_lines[1:]:
-                    result.append('\t' + line + '\n')
+                    result.append('\t' + line.encode('utf-8') + '\n')
             else:
-                result.append(tag + ': ' + value + '\n')
+                result.append(tag + ': ' + value.encode('utf-8') + '\n')
         return result
 
     def to_string(self):
@@ -174,6 +177,15 @@
             if t == tag:
                 r.append(v)
         return r
+
+    def as_dict(self):
+        """Return a dict containing the unique values of the stanza.
+        """
+        d = {}
+        for tag, value in self.items:
+            assert tag not in d
+            d[tag] = value
+        return d
          
 _tag_re = re.compile(r'^[-a-zA-Z0-9_]+$')
 def valid_tag(tag):
@@ -190,6 +202,8 @@
 
     Only the stanza lines and the trailing blank (if any) are consumed
     from the line_iter.
+
+    The raw lines must be in utf-8 encoding.
     """
     items = []
     stanza = Stanza()
@@ -200,6 +214,7 @@
             break       # end of file
         if line == '\n':
             break       # end of stanza
+        line = line.decode('utf-8')
         assert line[-1] == '\n'
         real_l = line
         if line[0] == '\t': # continues previous value

=== added file 'bzrlib/sign_my_commits.py'
--- bzrlib/sign_my_commits.py	1970-01-01 00:00:00 +0000
+++ bzrlib/sign_my_commits.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,81 @@
+# Copyright (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+"""Command which looks for unsigned commits by the current user, and signs them.
+"""
+
+from bzrlib.commands import Command
+import bzrlib.config
+import bzrlib.errors as errors
+import bzrlib.gpg
+from bzrlib.option import Option
+
+
+class cmd_sign_my_commits(Command):
+    """Sign all commits by a given committer.
+
+    If location is not specified the local tree is used.
+    If committer is not specified the default committer is used.
+
+    This does not sign commits that already have signatures.
+    """
+
+    takes_options = [Option('dry-run'
+                            , help='Don\'t actually sign anything, just print'
+                                   ' the revisions that would be signed')
+                    ]
+    takes_args = ['location?', 'committer?']
+
+    def run(self, location=None, committer=None, dry_run=False):
+        if location is None:
+            from bzrlib.workingtree import WorkingTree
+            # Open the containing directory
+            wt = WorkingTree.open_containing('.')[0]
+            b = wt.branch
+        else:
+            # Passed in locations should be exact
+            from bzrlib.branch import Branch
+            b = Branch.open(location)
+        repo = getattr(b, 'repository', b)
+
+        config = bzrlib.config.BranchConfig(b)
+
+        if committer is None:
+            committer = config.username()
+
+        gpg_strategy = bzrlib.gpg.GPGStrategy(config)
+
+        if not repo.revision_store.listable():
+            raise errors.BzrCommandError('cannot sign revisions on non-listable transports')
+
+        count = 0
+        # return in partial topological order for the sake of reproducibility
+        for rev_id in repo.all_revision_ids():
+            if repo.revision_store.has_id(rev_id, suffix='sig'):
+                continue
+            
+            rev = repo.get_revision(rev_id)
+            if rev.committer != committer:
+                continue
+
+            # We have a revision without a signature who has a 
+            # matching committer, start signing
+            print rev_id
+            count += 1
+            if not dry_run:
+                repo.sign_revision(rev_id, gpg_strategy)
+        print 'Signed %d revisions' % (count,)
+
+

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2006-01-25 14:30:06 +0000
+++ bzrlib/status.py	2006-03-20 08:31:00 +0000
@@ -15,15 +15,18 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import sys
-from bzrlib.osutils import is_inside_any
+
 from bzrlib.delta import compare_trees
+from bzrlib.errors import NoSuchRevision
 from bzrlib.log import line_log
-from bzrlib.errors import NoSuchRevision
+from bzrlib.osutils import is_inside_any
+from bzrlib.symbol_versioning import *
 
 # TODO: when showing single-line logs, truncate to the width of the terminal
 # if known, but only if really going to the terminal (not into a file)
 
 
+@deprecated_function(zero_eight)
 def show_status(branch, show_unchanged=False,
                 specific_files=None,
                 show_ids=False,
@@ -32,6 +35,47 @@
                 revision=None):
     """Display summary of changes.
 
+    Please use show_tree_status instead.
+
+    By default this compares the working tree to a previous revision. 
+    If the revision argument is given, summarizes changes between the 
+    working tree and another, or between two revisions.
+
+    The result is written out as Unicode and to_file should be able 
+    to encode that.
+
+    show_unchanged
+        If set, includes unchanged files.
+
+    specific_files
+        If set, only show the status of files in this list.
+
+    show_ids
+        If set, includes each file's id.
+
+    to_file
+        If set, write to this file (default stdout.)
+
+    show_pending
+        If set, write pending merges.
+
+    revision
+        If None the compare latest revision with working tree
+        If one revision show compared it with working tree.
+        If two revisions show status between first and second.
+    """
+    show_tree_status(branch.bzrdir.open_workingtree(), show_unchanged, 
+                     specific_files, show_ids, to_file, show_pending, revision)
+
+
+def show_tree_status(wt, show_unchanged=False,
+                     specific_files=None,
+                     show_ids=False,
+                     to_file=None,
+                     show_pending=True,
+                     revision=None):
+    """Display summary of changes.
+
     By default this compares the working tree to a previous revision. 
     If the revision argument is given, summarizes changes between the 
     working tree and another, or between two revisions.
@@ -62,32 +106,30 @@
     if to_file == None:
         to_file = sys.stdout
     
-    branch.lock_read()
+    wt.lock_read()
     try:
         new_is_working_tree = True
         if revision is None:
-            old = branch.basis_tree()
-            new = branch.working_tree()
+            new = wt
+            old = new.basis_tree()
         elif len(revision) > 0:
             try:
-                rev_id = revision[0].in_history(branch).rev_id
-                old = branch.revision_tree(rev_id)
+                rev_id = revision[0].in_history(wt.branch).rev_id
+                old = wt.branch.repository.revision_tree(rev_id)
             except NoSuchRevision, e:
                 raise BzrCommandError(str(e))
             if (len(revision) > 1) and (revision[1].spec is not None):
                 try:
-                    rev_id = revision[1].in_history(branch).rev_id
-                    new = branch.revision_tree(rev_id)
+                    rev_id = revision[1].in_history(wt.branch).rev_id
+                    new = wt.branch.repository.revision_tree(rev_id)
                     new_is_working_tree = False
                 except NoSuchRevision, e:
                     raise BzrCommandError(str(e))
             else:
-                new = branch.working_tree()
+                new = wt
                 
-
         delta = compare_trees(old, new, want_unchanged=show_unchanged,
                               specific_files=specific_files)
-
         delta.show(to_file,
                    show_ids=show_ids,
                    show_unchanged=show_unchanged)
@@ -98,7 +140,7 @@
         if new_is_working_tree and show_pending:
             show_pending_merges(new, to_file)
     finally:
-        branch.unlock()
+        wt.unlock()
 
 def show_pending_merges(new, to_file):
     """Write out a display of pending merges in a working tree."""
@@ -109,20 +151,20 @@
     print >>to_file, 'pending merges:'
     last_revision = branch.last_revision()
     if last_revision is not None:
-        ignore = set(branch.get_ancestry(last_revision))
+        ignore = set(branch.repository.get_ancestry(last_revision))
     else:
         ignore = set()
     for merge in new.pending_merges():
         ignore.add(merge)
         try:
-            m_revision = branch.get_revision(merge)
+            m_revision = branch.repository.get_revision(merge)
             print >> to_file, ' ', line_log(m_revision, 77)
-            inner_merges = branch.get_ancestry(merge)
+            inner_merges = branch.repository.get_ancestry(merge)
             inner_merges.reverse()
             for mmerge in inner_merges:
                 if mmerge in ignore:
                     continue
-                mm_revision = branch.get_revision(mmerge)
+                mm_revision = branch.repository.get_revision(mmerge)
                 print >> to_file, '   ', line_log(mm_revision, 75)
                 ignore.add(mmerge)
         except NoSuchRevision:

=== modified file 'bzrlib/store/__init__.py'
--- bzrlib/store/__init__.py	2006-01-25 14:30:06 +0000
+++ bzrlib/store/__init__.py	2006-03-20 08:31:00 +0000
@@ -101,9 +101,8 @@
             followed by a list of entries which could not be copied (because they
             were missing)
         """
-        if pb is None:
-            pb = bzrlib.ui.ui_factory.progress_bar()
-        pb.update('preparing to copy')
+        if pb:
+            pb.update('preparing to copy')
         failed = set()
         count = 0
         ids = list(ids) # get the list for showing a length.
@@ -118,14 +117,16 @@
                         self._copy_one(fileid, suffix, other, pb)
                     except KeyError:
                         pass
-                pb.update('copy', count, len(ids))
+                if pb:
+                    pb.update('copy', count, len(ids))
             except KeyError:
                 if permit_failure:
                     failed.add(fileid)
                 else:
                     raise
         assert count == len(ids)
-        pb.clear()
+        if pb:
+            pb.clear()
         return count, failed
 
     def _copy_one(self, fileid, suffix, other, pb):
@@ -181,6 +182,7 @@
         else:
             fn = self._relpath(fileid)
 
+        # FIXME RBC 20051128 this belongs in TextStore.
         fn_gz = fn + '.gz'
         if self._compressed:
             return fn_gz, fn
@@ -226,6 +228,7 @@
         super(TransportStore, self).__init__()
         self._transport = a_transport
         self._prefixed = prefixed
+        # FIXME RBC 20051128 this belongs in TextStore.
         self._compressed = compressed
         self._suffixes = set()
 
@@ -309,15 +312,23 @@
     return bzrlib.store.text.TextStore(transport.memory.MemoryTransport())
         
 
-def copy_all(store_from, store_to):
+def copy_all(store_from, store_to, pb=None):
     """Copy all ids from one store to another."""
     # TODO: Optional progress indicator
     if not store_from.listable():
         raise UnlistableStore(store_from)
-    ids = [f for f in store_from]
+    ids = []
+    for count, file_id in enumerate(store_from):
+        if pb:
+            pb.update('listing files', count, count)
+        ids.append(file_id)
+    if pb:
+        pb.clear()
     mutter('copy_all ids: %r', ids)
-    store_to.copy_multi(store_from, ids)
+    store_to.copy_multi(store_from, ids, pb=pb)
+
 
 def hash_prefix(fileid):
     return "%02x/" % (adler32(fileid) & 0xff)
 
+

=== modified file 'bzrlib/store/text.py'
--- bzrlib/store/text.py	2006-01-25 14:30:06 +0000
+++ bzrlib/store/text.py	2006-03-20 08:31:00 +0000
@@ -95,7 +95,7 @@
             raise KeyError(fileid + '-' + str(suffix))
 
         try:
-            result = other._transport.copy_to([path], self._transport, pb=pb,
+            result = other._transport.copy_to([path], self._transport, 
                                               mode=self._file_mode)
         except NoSuchFile:
             if not self._prefixed:
@@ -104,7 +104,7 @@
                 self._transport.mkdir(hash_prefix(fileid)[:-1], mode=self._dir_mode)
             except FileExists:
                 pass
-            result = other._transport.copy_to([path], self._transport, pb=pb,
+            result = other._transport.copy_to([path], self._transport,
                                               mode=self._file_mode)
 
         if result != 1:

=== modified file 'bzrlib/store/weave.py'
--- bzrlib/store/weave.py	2006-01-25 14:30:06 +0000
+++ bzrlib/store/weave.py	2006-03-20 08:31:00 +0000
@@ -1,5 +1,3 @@
-#! /usr/bin/python
-
 # Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
@@ -67,12 +65,14 @@
         return self._transport.get(self.filename(file_id))
 
     def _put(self, file_id, f):
-        if self._prefixed:
-            try:
-                self._transport.mkdir(hash_prefix(file_id), mode=self._dir_mode)
-            except FileExists:
-                pass
-        return self._transport.put(self.filename(file_id), f, mode=self._file_mode)
+        # less round trips to mkdir on failure than mkdir always
+        try:
+            return self._transport.put(self.filename(file_id), f, mode=self._file_mode)
+        except NoSuchFile:
+            if not self._prefixed:
+                raise
+            self._transport.mkdir(hash_prefix(file_id), mode=self._dir_mode)
+            return self._transport.put(self.filename(file_id), f, mode=self._file_mode)
 
     def get_weave(self, file_id, transaction):
         weave = transaction.map.find_weave(file_id)
@@ -162,8 +162,12 @@
         w.add_identical(old_rev_id, new_rev_id, parent_idxs)
         self.put_weave(file_id, w, transaction)
      
-    def copy_multi(self, from_store, file_ids):
+    def copy_multi(self, from_store, file_ids, pb=None):
         assert isinstance(from_store, WeaveStore)
-        for f in file_ids:
+        for count, f in enumerate(file_ids):
             mutter("copy weave {%s} into %s", f, self)
+            if pb:
+                pb.update('copy', count, len(file_ids))
             self._put(f, from_store._get(f))
+        if pb:
+            pb.clear()

=== modified file 'bzrlib/symbol_versioning.py'
--- bzrlib/symbol_versioning.py	2006-01-25 14:30:06 +0000
+++ bzrlib/symbol_versioning.py	2006-03-20 08:31:00 +0000
@@ -20,12 +20,20 @@
 The methods here allow for api symbol versioning.
 """
 
-__all__ = ['warn', 'set_warning_method', 'zero_seven']
+__all__ = ['deprecated_function',
+           'deprecated_method',
+           'DEPRECATED_PARAMETER',
+           'deprecated_passed',
+           'warn', 'set_warning_method', 'zero_seven',
+           'zero_eight',
+           ]
 
 from warnings import warn
 
 
+DEPRECATED_PARAMETER = "A deprecated parameter marker."
 zero_seven = "%s was deprecated in version 0.7."
+zero_eight = "%s was deprecated in version 0.8."
 
 
 def set_warning_method(method):
@@ -53,7 +61,7 @@
             symbol = "%s.%s" % (callable.__module__, 
                                 callable.__name__
                                 )
-            warn(deprecation_version % symbol, DeprecationWarning)
+            warn(deprecation_version % symbol, DeprecationWarning, stacklevel=2)
             return callable(*args, **kwargs)
         _populate_decorated(callable, deprecation_version, "function",
                             decorated_function)
@@ -76,7 +84,7 @@
                                    self.__class__.__name__,
                                    callable.__name__
                                    )
-            warn(deprecation_version % symbol, DeprecationWarning)
+            warn(deprecation_version % symbol, DeprecationWarning, stacklevel=2)
             return callable(self, *args, **kwargs)
         _populate_decorated(callable, deprecation_version, "method",
                             decorated_method)
@@ -84,6 +92,25 @@
     return method_decorator
 
 
+def deprecated_passed(parameter_value):
+    """Return True if parameter_value was used."""
+    # FIXME: it might be nice to have a parameter deprecation decorator. 
+    # it would need to handle positional and *args and **kwargs parameters,
+    # which means some mechanism to describe how the parameter was being
+    # passed before deprecation, and some way to deprecate parameters that
+    # were not at the end of the arg list. Thats needed for __init__ where
+    # we cannot just forward to a new method name.I.e. in the following
+    # examples we would want to have callers that pass any value to 'bad' be
+    # given a warning - because we have applied:
+    # @deprecated_parameter('bad', zero_seven)
+    #
+    # def __init__(self, bad=None)
+    # def __init__(self, bad, other)
+    # def __init__(self, **kwargs)
+    # RBC 20060116
+    return not parameter_value is DEPRECATED_PARAMETER
+
+
 def _decorate_docstring(callable, deprecation_version, label,
                         decorated_callable):
     docstring_lines = callable.__doc__.split('\n')
@@ -112,3 +139,4 @@
                         decorated_callable)
     decorated_callable.__module__ = callable.__module__
     decorated_callable.__name__ = callable.__name__
+    decorated_callable.is_deprecated = True

=== modified file 'bzrlib/testament.py'
--- bzrlib/testament.py	2005-11-07 13:17:53 +0000
+++ bzrlib/testament.py	2006-03-20 08:31:00 +0000
@@ -88,10 +88,10 @@
     """
 
     @classmethod
-    def from_revision(cls, branch, revision_id):
+    def from_revision(cls, repository, revision_id):
         """Produce a new testament from a historical revision"""
-        rev = branch.get_revision(revision_id)
-        inventory = branch.get_inventory(revision_id)
+        rev = repository.get_revision(revision_id)
+        inventory = repository.get_inventory(revision_id)
         return cls(rev, inventory)
 
     def __init__(self, rev, inventory):
@@ -114,8 +114,7 @@
         hashed in that encoding.
         """
         r = []
-        def a(s):
-            r.append(s)
+        a = r.append
         a('bazaar-ng testament version 1\n')
         a('revision-id: %s\n' % self.revision_id)
         a('committer: %s\n' % self.committer)
@@ -137,7 +136,7 @@
             for l in r:
                 assert isinstance(l, basestring), \
                     '%r of type %s is not a plain string' % (l, type(l))
-        return r
+        return [line.encode('utf-8') for line in r]
 
     def _escape_path(self, path):
         assert not contains_linebreaks(path)

=== modified file 'bzrlib/tests/HTTPTestUtil.py'
--- bzrlib/tests/HTTPTestUtil.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/HTTPTestUtil.py	2006-03-20 08:31:00 +0000
@@ -14,133 +14,20 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import BaseHTTPServer, SimpleHTTPServer, socket, errno, time
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib.osutils import relpath
-
-
-class WebserverNotAvailable(Exception):
-    pass
-
-class TestingHTTPRequestHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
-    def log_message(self, format, *args):
-        self.server.test_case.log("webserver - %s - - [%s] %s",
-                                  self.address_string(),
-                                  self.log_date_time_string(),
-                                  format%args)
-
-    def handle_one_request(self):
-        """Handle a single HTTP request.
-
-        You normally don't need to override this method; see the class
-        __doc__ string for information on how to handle specific HTTP
-        commands such as GET and POST.
-
-        """
-        for i in xrange(1,11): # Don't try more than 10 times
-            try:
-                self.raw_requestline = self.rfile.readline()
-            except socket.error, e:
-                if e.args[0] in (errno.EAGAIN, errno.EWOULDBLOCK):
-                    # omitted for now because some tests look at the log of
-                    # the server and expect to see no errors.  see recent
-                    # email thread. -- mbp 20051021. 
-                    ## self.log_message('EAGAIN (%d) while reading from raw_requestline' % i)
-                    time.sleep(0.01)
-                    continue
-                raise
-            else:
-                break
-        if not self.raw_requestline:
-            self.close_connection = 1
-            return
-        if not self.parse_request(): # An error code has been sent, just exit
-            return
-        mname = 'do_' + self.command
-        if not hasattr(self, mname):
-            self.send_error(501, "Unsupported method (%r)" % self.command)
-            return
-        method = getattr(self, mname)
-        method()
-
-class TestingHTTPServer(BaseHTTPServer.HTTPServer):
-    def __init__(self, server_address, RequestHandlerClass, test_case):
-        BaseHTTPServer.HTTPServer.__init__(self, server_address,
-                                                RequestHandlerClass)
-        self.test_case = test_case
-
-
-class TestCaseWithWebserver(TestCaseInTempDir):
-    """Derived class that starts a localhost-only webserver
-    (in addition to what TestCaseInTempDir does).
-
-    This is useful for testing RemoteBranch.
+import os
+
+import bzrlib
+from bzrlib.tests import TestCaseWithTransport
+
+
+class TestCaseWithWebserver(TestCaseWithTransport):
+    """A support class that provides readonly urls that are http://.
+
+    This is done by forcing the readonly server to be an http one. This 
+    will current fail if the primary transport is not backed by regular disk
+    files.
     """
 
-    _HTTP_PORTS = range(13000, 0x8000)
-
-    def _http_start(self):
-        import SimpleHTTPServer, BaseHTTPServer, socket, errno
-        httpd = None
-        for port in self._HTTP_PORTS:
-            try:
-                httpd = TestingHTTPServer(('localhost', port),
-                                          TestingHTTPRequestHandler,
-                                          self)
-            except socket.error, e:
-                if e.args[0] == errno.EADDRINUSE:
-                    continue
-                print >>sys.stderr, "Cannot run webserver :-("
-                raise
-            else:
-                break
-
-        if httpd is None:
-            raise WebserverNotAvailable("Cannot run webserver :-( "
-                                        "no free ports in range %s..%s" %
-                                        (_HTTP_PORTS[0], _HTTP_PORTS[-1]))
-
-        self._http_base_url = 'http://localhost:%s/' % port
-        self._http_starting.release()
-        httpd.socket.settimeout(0.1)
-
-        while self._http_running:
-            try:
-                httpd.handle_request()
-            except socket.timeout:
-                pass
-
-    def get_remote_url(self, path):
-        import os
-
-        if os.path.isabs(path):
-            remote_path = relpath(self.test_dir, path)
-        else:
-            remote_path = path
-
-        self._http_starting.acquire()
-        self._http_starting.release()
-        return self._http_base_url + remote_path
-
     def setUp(self):
-        TestCaseInTempDir.setUp(self)
-        import threading, os
-        self._http_starting = threading.Lock()
-        self._http_starting.acquire()
-        self._http_running = True
-        self._http_base_url = None
-        self._http_thread = threading.Thread(target=self._http_start)
-        self._http_thread.setDaemon(True)
-        self._http_thread.start()
-        self._http_proxy = os.environ.get("http_proxy")
-        if self._http_proxy is not None:
-            del os.environ["http_proxy"]
-
-    def tearDown(self):
-        self._http_running = False
-        self._http_thread.join()
-        if self._http_proxy is not None:
-            import os
-            os.environ["http_proxy"] = self._http_proxy
-        TestCaseInTempDir.tearDown(self)
-
+        super(TestCaseWithWebserver, self).setUp()
+        self.transport_readonly_server = bzrlib.transport.http.HttpServer

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/__init__.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 by Canonical Ltd
+# Copyright (C) 2005, 2006 by Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,6 +21,7 @@
 # little as possible, so this should be used rarely if it's added at all.
 # (Suggestion from j-a-meinel, 2005-11-24)
 
+import codecs
 from cStringIO import StringIO
 import difflib
 import errno
@@ -28,25 +29,36 @@
 import os
 import re
 import shutil
+import stat
 import sys
 import tempfile
 import unittest
 import time
-import codecs
+
 
 import bzrlib.branch
+import bzrlib.bzrdir as bzrdir
 import bzrlib.commands
-from bzrlib.errors import BzrError
+import bzrlib.errors as errors
 import bzrlib.inventory
+import bzrlib.iterablefile
+import bzrlib.lockdir
 import bzrlib.merge3
 import bzrlib.osutils
 import bzrlib.osutils as osutils
 import bzrlib.plugin
 import bzrlib.store
 import bzrlib.trace
+from bzrlib.transport import urlescape, get_transport
+import bzrlib.transport
+from bzrlib.transport.local import LocalRelpathServer
+from bzrlib.transport.readonly import ReadonlyServer
 from bzrlib.trace import mutter
 from bzrlib.tests.TestUtil import TestLoader, TestSuite
 from bzrlib.tests.treeshape import build_tree_contents
+from bzrlib.workingtree import WorkingTree, WorkingTreeFormat2
+
+default_transport = LocalRelpathServer
 
 MODULES_TO_TEST = []
 MODULES_TO_DOCTEST = [
@@ -54,45 +66,43 @@
                       bzrlib.commands,
                       bzrlib.errors,
                       bzrlib.inventory,
+                      bzrlib.iterablefile,
+                      bzrlib.lockdir,
                       bzrlib.merge3,
+                      bzrlib.option,
                       bzrlib.osutils,
-                      bzrlib.store,
+                      bzrlib.store
                       ]
 def packages_to_test():
+    """Return a list of packages to test.
+
+    The packages are not globally imported so that import failures are
+    triggered when running selftest, not when importing the command.
+    """
+    import bzrlib.doc
     import bzrlib.tests.blackbox
+    import bzrlib.tests.branch_implementations
+    import bzrlib.tests.bzrdir_implementations
+    import bzrlib.tests.interrepository_implementations
+    import bzrlib.tests.repository_implementations
+    import bzrlib.tests.workingtree_implementations
     return [
-            bzrlib.tests.blackbox
+            bzrlib.doc,
+            bzrlib.tests.blackbox,
+            bzrlib.tests.branch_implementations,
+            bzrlib.tests.bzrdir_implementations,
+            bzrlib.tests.interrepository_implementations,
+            bzrlib.tests.repository_implementations,
+            bzrlib.tests.workingtree_implementations,
             ]
 
 
-class EarlyStoppingTestResultAdapter(object):
-    """An adapter for TestResult to stop at the first first failure or error"""
-
-    def __init__(self, result):
-        self._result = result
-
-    def addError(self, test, err):
-        self._result.addError(test, err)
-        self._result.stop()
-
-    def addFailure(self, test, err):
-        self._result.addFailure(test, err)
-        self._result.stop()
-
-    def __getattr__(self, name):
-        return getattr(self._result, name)
-
-    def __setattr__(self, name, value):
-        if name == '_result':
-            object.__setattr__(self, name, value)
-        return setattr(self._result, name, value)
-
-
 class _MyResult(unittest._TextTestResult):
     """Custom TestResult.
 
     Shows output in a different format, including displaying runtime for tests.
     """
+    stop_early = False
 
     def _elapsedTime(self):
         return "%5dms" % (1000 * (time.time() - self._start_time))
@@ -132,6 +142,8 @@
         elif self.dots:
             self.stream.write('E')
         self.stream.flush()
+        if self.stop_early:
+            self.stop()
 
     def addFailure(self, test, err):
         unittest.TestResult.addFailure(self, test, err)
@@ -140,6 +152,8 @@
         elif self.dots:
             self.stream.write('F')
         self.stream.flush()
+        if self.stop_early:
+            self.stop()
 
     def addSuccess(self, test):
         if self.showAll:
@@ -163,14 +177,14 @@
     def printErrorList(self, flavour, errors):
         for test, err in errors:
             self.stream.writeln(self.separator1)
-            self.stream.writeln("%s: %s" % (flavour,self.getDescription(test)))
-            if hasattr(test, '_get_log'):
+            self.stream.writeln("%s: %s" % (flavour, self.getDescription(test)))
+            if getattr(test, '_get_log', None) is not None:
                 print >>self.stream
                 print >>self.stream, \
-                        ('vvvv[log from %s]' % test).ljust(78,'-')
+                        ('vvvv[log from %s]' % test.id()).ljust(78,'-')
                 print >>self.stream, test._get_log()
                 print >>self.stream, \
-                        ('^^^^[log from %s]' % test).ljust(78,'-')
+                        ('^^^^[log from %s]' % test.id()).ljust(78,'-')
             self.stream.writeln(self.separator2)
             self.stream.writeln("%s" % err)
 
@@ -180,8 +194,7 @@
 
     def _makeResult(self):
         result = _MyResult(self.stream, self.descriptions, self.verbosity)
-        if self.stop_on_failure:
-            result = EarlyStoppingTestResultAdapter(result)
+        result.stop_early = self.stop_on_failure
         return result
 
 
@@ -231,9 +244,12 @@
     _log_file_name = None
     _log_contents = ''
 
+    def __init__(self, methodName='testMethod'):
+        super(TestCase, self).__init__(methodName)
+        self._cleanups = []
+
     def setUp(self):
         unittest.TestCase.setUp(self)
-        self._cleanups = []
         self._cleanEnvironment()
         bzrlib.trace.disable_default_logging()
         self._startLogFile()
@@ -253,7 +269,7 @@
                                   charjunk=lambda x: False)
         return ''.join(difflines)
 
-    def assertEqualDiff(self, a, b):
+    def assertEqualDiff(self, a, b, message=None):
         """Assert two texts are equal, if not raise an exception.
         
         This is intended for use with multi-line strings where it can 
@@ -262,9 +278,15 @@
         # TODO: perhaps override assertEquals to call this for strings?
         if a == b:
             return
-        raise AssertionError("texts not equal:\n" + 
+        if message is None:
+            message = "texts not equal:\n"
+        raise AssertionError(message + 
                              self._ndiff_strings(a, b))      
         
+    def assertEqualMode(self, mode, mode_test):
+        self.assertEqual(mode, mode_test,
+                         'mode mismatch %o != %o' % (mode, mode_test))
+
     def assertStartsWith(self, s, prefix):
         if not s.startswith(prefix):
             raise AssertionError('string %r does not start with %r' % (s, prefix))
@@ -279,7 +301,7 @@
             raise AssertionError('pattern "%s" not found in "%s"'
                     % (needle_re, haystack))
 
-    def AssertSubset(self, sublist, superlist):
+    def assertSubset(self, sublist, superlist):
         """Assert that every entry in sublist is present in superlist."""
         missing = []
         for entry in sublist:
@@ -289,6 +311,22 @@
             raise AssertionError("value(s) %r not present in container %r" % 
                                  (missing, superlist))
 
+    def assertIs(self, left, right):
+        if not (left is right):
+            raise AssertionError("%r is not %r." % (left, right))
+
+    def assertTransportMode(self, transport, path, mode):
+        """Fail if a path does not have mode mode.
+        
+        If modes are not supported on this platform, the test is skipped.
+        """
+        if sys.platform == 'win32':
+            return
+        path_stat = transport.stat(path)
+        actual_mode = stat.S_IMODE(path_stat.st_mode)
+        self.assertEqual(mode, actual_mode,
+            'mode of %r incorrect (%o != %o)' % (path, mode, actual_mode))
+
     def _startLogFile(self):
         """Send bzr and test log messages to a temporary file.
 
@@ -297,7 +335,7 @@
         fileno, name = tempfile.mkstemp(suffix='.log', prefix='testbzr')
         encoder, decoder, stream_reader, stream_writer = codecs.lookup('UTF-8')
         self._log_file = stream_writer(os.fdopen(fileno, 'w+'))
-        bzrlib.trace.enable_test_log(self._log_file)
+        self._log_nonce = bzrlib.trace.enable_test_log(self._log_file)
         self._log_file_name = name
         self.addCleanup(self._finishLogFile)
 
@@ -306,7 +344,7 @@
 
         Read contents into memory, close, and delete.
         """
-        bzrlib.trace.disable_test_log()
+        bzrlib.trace.disable_test_log(self._log_nonce)
         self._log_file.seek(0)
         self._log_contents = self._log_file.read()
         self._log_file.close()
@@ -367,6 +405,8 @@
 
         This should only be called from TestCase.tearDown.
         """
+        # TODO: Perhaps this should keep running cleanups even if 
+        # one of them fails?
         for cleanup_fn in reversed(self._cleanups):
             cleanup_fn()
 
@@ -473,12 +513,12 @@
         if stdin is None:
             stdin = StringIO("")
         if stdout is None:
-            if hasattr(self, "_log_file"):
+            if getattr(self, "_log_file", None) is not None:
                 stdout = self._log_file
             else:
                 stdout = StringIO()
         if stderr is None:
-            if hasattr(self, "_log_file"):
+            if getattr(self, "_log_file", None is not None):
                 stderr = self._log_file
             else:
                 stderr = StringIO()
@@ -543,7 +583,7 @@
             break
         # make a fake bzr directory there to prevent any tests propagating
         # up onto the source directory's real branch
-        os.mkdir(osutils.pathjoin(TestCaseInTempDir.TEST_ROOT, '.bzr'))
+        bzrdir.BzrDir.create_standalone_workingtree(TestCaseInTempDir.TEST_ROOT)
 
     def setUp(self):
         super(TestCaseInTempDir, self).setUp()
@@ -560,7 +600,7 @@
             os.chdir(_currentdir)
         self.addCleanup(_leaveDirectory)
         
-    def build_tree(self, shape, line_endings='native'):
+    def build_tree(self, shape, line_endings='native', transport=None):
         """Build a test tree according to a pattern.
 
         shape is a sequence of file specifications.  If the final
@@ -571,21 +611,27 @@
                              in binary mode, exact contents are written
                              in native mode, the line endings match the
                              default platform endings.
+
+        :param transport: A transport to write to, for building trees on 
+                          VFS's. If the transport is readonly or None,
+                          "." is opened automatically.
         """
         # XXX: It's OK to just create them using forward slashes on windows?
+        if transport is None or transport.is_readonly():
+            transport = get_transport(".")
         for name in shape:
             self.assert_(isinstance(name, basestring))
             if name[-1] == '/':
-                os.mkdir(name[:-1])
+                transport.mkdir(urlescape(name[:-1]))
             else:
                 if line_endings == 'binary':
-                    f = file(name, 'wb')
+                    end = '\n'
                 elif line_endings == 'native':
-                    f = file(name, 'wt')
+                    end = os.linesep
                 else:
-                    raise BzrError('Invalid line ending request %r' % (line_endings,))
-                print >>f, "contents of", name
-                f.close()
+                    raise errors.BzrError('Invalid line ending request %r' % (line_endings,))
+                content = "contents of %s%s" % (name, end)
+                transport.put(urlescape(name), StringIO(content))
 
     def build_tree_contents(self, shape):
         build_tree_contents(shape)
@@ -604,6 +650,166 @@
         self.assertEqualDiff(content, open(path, 'r').read())
 
 
+class TestCaseWithTransport(TestCaseInTempDir):
+    """A test case that provides get_url and get_readonly_url facilities.
+
+    These back onto two transport servers, one for readonly access and one for
+    read write access.
+
+    If no explicit class is provided for readonly access, a
+    ReadonlyTransportDecorator is used instead which allows the use of non disk
+    based read write transports.
+
+    If an explicit class is provided for readonly access, that server and the 
+    readwrite one must both define get_url() as resolving to os.getcwd().
+    """
+
+    def __init__(self, methodName='testMethod'):
+        super(TestCaseWithTransport, self).__init__(methodName)
+        self.__readonly_server = None
+        self.__server = None
+        self.transport_server = default_transport
+        self.transport_readonly_server = None
+
+    def get_readonly_url(self, relpath=None):
+        """Get a URL for the readonly transport.
+
+        This will either be backed by '.' or a decorator to the transport 
+        used by self.get_url()
+        relpath provides for clients to get a path relative to the base url.
+        These should only be downwards relative, not upwards.
+        """
+        base = self.get_readonly_server().get_url()
+        if relpath is not None:
+            if not base.endswith('/'):
+                base = base + '/'
+            base = base + relpath
+        return base
+
+    def get_readonly_server(self):
+        """Get the server instance for the readonly transport
+
+        This is useful for some tests with specific servers to do diagnostics.
+        """
+        if self.__readonly_server is None:
+            if self.transport_readonly_server is None:
+                # readonly decorator requested
+                # bring up the server
+                self.get_url()
+                self.__readonly_server = ReadonlyServer()
+                self.__readonly_server.setUp(self.__server)
+            else:
+                self.__readonly_server = self.transport_readonly_server()
+                self.__readonly_server.setUp()
+            self.addCleanup(self.__readonly_server.tearDown)
+        return self.__readonly_server
+
+    def get_server(self):
+        """Get the read/write server instance.
+
+        This is useful for some tests with specific servers that need
+        diagnostics.
+        """
+        if self.__server is None:
+            self.__server = self.transport_server()
+            self.__server.setUp()
+            self.addCleanup(self.__server.tearDown)
+        return self.__server
+
+    def get_url(self, relpath=None):
+        """Get a URL for the readwrite transport.
+
+        This will either be backed by '.' or to an equivalent non-file based
+        facility.
+        relpath provides for clients to get a path relative to the base url.
+        These should only be downwards relative, not upwards.
+        """
+        base = self.get_server().get_url()
+        if relpath is not None and relpath != '.':
+            if not base.endswith('/'):
+                base = base + '/'
+            base = base + relpath
+        return base
+
+    def get_transport(self):
+        """Return a writeable transport for the test scratch space"""
+        t = get_transport(self.get_url())
+        self.assertFalse(t.is_readonly())
+        return t
+
+    def get_readonly_transport(self):
+        """Return a readonly transport for the test scratch space
+        
+        This can be used to test that operations which should only need
+        readonly access in fact do not try to write.
+        """
+        t = get_transport(self.get_readonly_url())
+        self.assertTrue(t.is_readonly())
+        return t
+
+    def make_branch(self, relpath):
+        """Create a branch on the transport at relpath."""
+        repo = self.make_repository(relpath)
+        return repo.bzrdir.create_branch()
+
+    def make_bzrdir(self, relpath):
+        try:
+            url = self.get_url(relpath)
+            segments = relpath.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = self.get_url('/'.join(segments[:-1]))
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except errors.FileExists:
+                    pass
+            return bzrlib.bzrdir.BzrDir.create(url)
+        except errors.UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable.")
+
+    def make_repository(self, relpath, shared=False):
+        """Create a repository on our default transport at relpath."""
+        made_control = self.make_bzrdir(relpath)
+        return made_control.create_repository(shared=shared)
+
+    def make_branch_and_tree(self, relpath):
+        """Create a branch on the transport and a tree locally.
+
+        Returns the tree.
+        """
+        # TODO: always use the local disk path for the working tree,
+        # this obviously requires a format that supports branch references
+        # so check for that by checking bzrdir.BzrDirFormat.get_default_format()
+        # RBC 20060208
+        b = self.make_branch(relpath)
+        try:
+            return b.bzrdir.create_workingtree()
+        except errors.NotLocalUrl:
+            # new formats - catch No tree error and create
+            # a branch reference and a checkout.
+            # old formats at that point - raise TestSkipped.
+            # TODO: rbc 20060208
+            return WorkingTreeFormat2().initialize(bzrdir.BzrDir.open(relpath))
+
+
+class ChrootedTestCase(TestCaseWithTransport):
+    """A support class that provides readonly urls outside the local namespace.
+
+    This is done by checking if self.transport_server is a MemoryServer. if it
+    is then we are chrooted already, if it is not then an HttpServer is used
+    for readonly urls.
+
+    TODO RBC 20060127: make this an option to TestCaseWithTransport so it can
+                       be used without needed to redo it when a different 
+                       subclass is in use ?
+    """
+
+    def setUp(self):
+        super(ChrootedTestCase, self).setUp()
+        if not self.transport_server == bzrlib.transport.memory.MemoryServer:
+            self.transport_readonly_server = bzrlib.transport.http.HttpServer
+
+
 def filter_suite_by_re(suite, pattern):
     result = TestSuite()
     filter_re = re.compile(pattern)
@@ -614,7 +820,8 @@
 
 
 def run_suite(suite, name='test', verbose=False, pattern=".*",
-              stop_on_failure=False, keep_output=False):
+              stop_on_failure=False, keep_output=False,
+              transport=None):
     TestCaseInTempDir._TEST_NAME = name
     if verbose:
         verbosity = 2
@@ -632,21 +839,29 @@
     # have to delete their temp directories themselves.
     if result.wasSuccessful() or not keep_output:
         if TestCaseInTempDir.TEST_ROOT is not None:
-            if sys.platform != "win32":
-                shutil.rmtree(TestCaseInTempDir.TEST_ROOT)
-            else:
-                shutil.rmtree(TestCaseInTempDir.TEST_ROOT,
-                              onerror=_win32_delete_readonly)
+            shutil.rmtree(TestCaseInTempDir.TEST_ROOT) 
     else:
         print "Failed tests working directories are in '%s'\n" % TestCaseInTempDir.TEST_ROOT
     return result.wasSuccessful()
 
 
 def selftest(verbose=False, pattern=".*", stop_on_failure=True,
-             keep_output=False):
+             keep_output=False,
+             transport=None):
     """Run the whole test suite under the enhanced runner"""
-    return run_suite(test_suite(), 'testbzr', verbose=verbose, pattern=pattern,
-                     stop_on_failure=stop_on_failure, keep_output=keep_output)
+    global default_transport
+    if transport is None:
+        transport = default_transport
+    old_transport = default_transport
+    default_transport = transport
+    suite = test_suite()
+    try:
+        return run_suite(suite, 'testbzr', verbose=verbose, pattern=pattern,
+                     stop_on_failure=stop_on_failure, keep_output=keep_output,
+                     transport=transport)
+    finally:
+        default_transport = old_transport
+
 
 
 def test_suite():
@@ -662,12 +877,16 @@
                    'bzrlib.tests.test_bad_files',
                    'bzrlib.tests.test_basis_inventory',
                    'bzrlib.tests.test_branch',
+                   'bzrlib.tests.test_bzrdir',
                    'bzrlib.tests.test_command',
                    'bzrlib.tests.test_commit',
                    'bzrlib.tests.test_commit_merge',
                    'bzrlib.tests.test_config',
                    'bzrlib.tests.test_conflicts',
+                   'bzrlib.tests.test_decorators',
                    'bzrlib.tests.test_diff',
+                   'bzrlib.tests.test_doc_generate',
+                   'bzrlib.tests.test_errors',
                    'bzrlib.tests.test_fetch',
                    'bzrlib.tests.test_gpg',
                    'bzrlib.tests.test_graph',
@@ -675,6 +894,8 @@
                    'bzrlib.tests.test_http',
                    'bzrlib.tests.test_identitymap',
                    'bzrlib.tests.test_inv',
+                   'bzrlib.tests.test_lockdir',
+                   'bzrlib.tests.test_lockable_files',
                    'bzrlib.tests.test_log',
                    'bzrlib.tests.test_merge',
                    'bzrlib.tests.test_merge3',
@@ -684,10 +905,10 @@
                    'bzrlib.tests.test_nonascii',
                    'bzrlib.tests.test_options',
                    'bzrlib.tests.test_osutils',
-                   'bzrlib.tests.test_parent',
                    'bzrlib.tests.test_permissions',
                    'bzrlib.tests.test_plugins',
-                   'bzrlib.tests.test_remove',
+                   'bzrlib.tests.test_reconcile',
+                   'bzrlib.tests.test_repository',
                    'bzrlib.tests.test_revision',
                    'bzrlib.tests.test_revisionnamespaces',
                    'bzrlib.tests.test_revprops',
@@ -699,12 +920,12 @@
                    'bzrlib.tests.test_sftp_transport',
                    'bzrlib.tests.test_smart_add',
                    'bzrlib.tests.test_source',
-                   'bzrlib.tests.test_status',
                    'bzrlib.tests.test_store',
                    'bzrlib.tests.test_symbol_versioning',
                    'bzrlib.tests.test_testament',
                    'bzrlib.tests.test_trace',
                    'bzrlib.tests.test_transactions',
+                   'bzrlib.tests.test_transform',
                    'bzrlib.tests.test_transport',
                    'bzrlib.tests.test_tsort',
                    'bzrlib.tests.test_ui',
@@ -715,6 +936,8 @@
                    'bzrlib.tests.test_workingtree',
                    'bzrlib.tests.test_xml',
                    ]
+    test_transport_implementations = [
+        'bzrlib.tests.test_transport_implementations']
 
     TestCase.BZRPATH = osutils.pathjoin(
             osutils.realpath(osutils.dirname(bzrlib.__path__[0])), 'bzr')
@@ -727,6 +950,9 @@
     # actually wrong, just "no such module".  We should probably override that
     # class, but for the moment just load them ourselves. (mbp 20051202)
     loader = TestLoader()
+    from bzrlib.transport import TransportTestProviderAdapter
+    adapter = TransportTestProviderAdapter()
+    adapt_modules(test_transport_implementations, adapter, loader, suite)
     for mod_name in testmod_names:
         mod = _load_module_by_name(mod_name)
         suite.addTest(loader.loadTestsFromModule(mod))
@@ -737,11 +963,19 @@
     for m in (MODULES_TO_DOCTEST):
         suite.addTest(DocTestSuite(m))
     for name, plugin in bzrlib.plugin.all_plugins().items():
-        if hasattr(plugin, 'test_suite'):
+        if getattr(plugin, 'test_suite', None) is not None:
             suite.addTest(plugin.test_suite())
     return suite
 
 
+def adapt_modules(mods_list, adapter, loader, suite):
+    """Adapt the modules in mods_list using adapter and add to suite."""
+    for mod_name in mods_list:
+        mod = _load_module_by_name(mod_name)
+        for test in iter_suite_tests(loader.loadTestsFromModule(mod)):
+            suite.addTests(adapter.adapt(test))
+
+
 def _load_module_by_name(mod_name):
     parts = mod_name.split('.')
     module = __import__(mod_name)
@@ -751,17 +985,3 @@
     while parts:
         module = getattr(module, parts.pop(0))
     return module
-
-
-def _win32_delete_readonly(function, path, excinfo):
-    """Error handler for shutil.rmtree function [for win32]
-    Helps to remove files marked as read-only.
-    """
-    type_, value = excinfo[:2]
-    if function in (os.remove, os.rmdir) \
-        and type_ == OSError \
-        and value.errno == errno.EACCES:
-        bzrlib.osutils.make_writable(path)
-        function(path)
-    else:
-        raise

=== modified file 'bzrlib/tests/blackbox/__init__.py'
--- bzrlib/tests/blackbox/__init__.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/blackbox/__init__.py	2006-03-20 08:31:00 +0000
@@ -23,27 +23,59 @@
 rather starts again from the run_bzr function.
 """
 
-from bzrlib.tests import TestLoader
-from bzrlib.tests import TestCaseInTempDir, BzrTestBase
+from bzrlib.tests import (
+                          _load_module_by_name,
+                          TestCaseWithTransport,
+                          TestSuite,
+                          TestLoader,
+                          )
+import bzrlib.ui as ui
+
 
 def test_suite():
     testmod_names = [
                      'bzrlib.tests.blackbox.test_added',
+                     'bzrlib.tests.blackbox.test_aliases',
+                     'bzrlib.tests.blackbox.test_ancestry',
+                     'bzrlib.tests.blackbox.test_break_lock',
+                     'bzrlib.tests.blackbox.test_bound_branches',
                      'bzrlib.tests.blackbox.test_cat',
+                     'bzrlib.tests.blackbox.test_checkout',
+                     'bzrlib.tests.blackbox.test_commit',
+                     'bzrlib.tests.blackbox.test_conflicts',
+                     'bzrlib.tests.blackbox.test_diff',
                      'bzrlib.tests.blackbox.test_export',
+                     'bzrlib.tests.blackbox.test_find_merge_base',
+                     'bzrlib.tests.blackbox.test_help',
+                     'bzrlib.tests.blackbox.test_info',
                      'bzrlib.tests.blackbox.test_log',
+                     'bzrlib.tests.blackbox.test_logformats',
                      'bzrlib.tests.blackbox.test_missing',
+                     'bzrlib.tests.blackbox.test_outside_wt',
                      'bzrlib.tests.blackbox.test_pull',
+                     'bzrlib.tests.blackbox.test_reconcile',
+                     'bzrlib.tests.blackbox.test_re_sign',
+                     'bzrlib.tests.blackbox.test_revert',
                      'bzrlib.tests.blackbox.test_revno',
                      'bzrlib.tests.blackbox.test_revision_info',
+                     'bzrlib.tests.blackbox.test_selftest',
+                     'bzrlib.tests.blackbox.test_sign_my_commits',
                      'bzrlib.tests.blackbox.test_status',
                      'bzrlib.tests.blackbox.test_too_much',
+                     'bzrlib.tests.blackbox.test_update',
+                     'bzrlib.tests.blackbox.test_upgrade',
                      'bzrlib.tests.blackbox.test_versioning',
                      ]
-    return TestLoader().loadTestsFromNames(testmod_names)
-
-
-class ExternalBase(TestCaseInTempDir):
+
+    suite = TestSuite()
+    loader = TestLoader()
+    for mod_name in testmod_names:
+        mod = _load_module_by_name(mod_name)
+        suite.addTest(loader.loadTestsFromModule(mod))
+    return suite
+
+
+class ExternalBase(TestCaseWithTransport):
 
     def runbzr(self, args, retcode=0, backtick=False):
         if isinstance(args, basestring):
@@ -52,3 +84,20 @@
             return self.run_bzr_captured(args, retcode=retcode)[0]
         else:
             return self.run_bzr_captured(args, retcode=retcode)
+
+
+class TestUIFactory(ui.UIFactory):
+    """A UI Factory for testing - hide the progress bar but emit note()s."""
+
+    def clear(self):
+        """See progress.ProgressBar.clear()."""
+
+    def note(self, fmt_string, *args, **kwargs):
+        """See progress.ProgressBar.note()."""
+        print fmt_string % args
+
+    def progress_bar(self):
+        return self
+        
+    def update(self, message, count=None, total=None):
+        """See progress.ProgressBar.update()."""

=== added file 'bzrlib/tests/blackbox/test_aliases.py'
--- bzrlib/tests/blackbox/test_aliases.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_aliases.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,67 @@
+"""Black-box tests for bzr aliases.
+"""
+
+import os
+
+from bzrlib.branch import Branch
+from bzrlib.tests import TestCaseInTempDir
+from bzrlib.trace import mutter
+from bzrlib.config import (config_dir, config_filename)
+
+
+class TestAliases(TestCaseInTempDir):
+
+    def test_aliases(self):
+
+        def bzr(*args, **kwargs):
+            return self.run_bzr(*args, **kwargs)[0]
+
+        def bzr_catch_error(*args, **kwargs):
+            return self.run_bzr(*args, **kwargs)[1]
+
+
+        if os.path.isfile(config_filename()):
+            # Something is wrong in environment, 
+            # we risk overwriting users config 
+            self.assert_(config_filename() + "exists, abort")
+            
+        os.mkdir(config_dir())
+        CONFIG=("[ALIASES]\n"
+                "c=cat\n"
+                "c1=cat -r 1\n"
+                "c2=cat -r 1 -r2\n")
+
+        open(config_filename(),'wb').write(CONFIG)
+
+
+        str1 = 'foo\n'
+        str2 = 'bar\n'
+
+        bzr('init')
+        open('a', 'wb').write(str1)
+        bzr('add', 'a')
+
+        bzr('commit', '-m', '1')
+
+        self.assertEquals(bzr('c', 'a'), str1)
+
+        open('a', 'wb').write(str2)
+        bzr('commit', '-m', '2')
+
+        self.assertEquals(bzr('c', 'a'), str2)
+        self.assertEquals(bzr('c1', 'a'), str1)
+        self.assertEquals(bzr('c1', '--revision', '2', 'a'), str2)
+
+        # If --no-aliases isn't working, we will not get retcode=3
+        bzr('--no-aliases', 'c', 'a', retcode=3)
+
+        # If --no-aliases breaks all of bzr, we also get retcode=3
+        # So we need to catch the output as well
+        self.assertEquals(bzr_catch_error('--no-aliases', 'c', 'a', 
+                                          retcode=None), 
+                          "bzr: ERROR: unknown command 'c'\n")
+
+        bzr('c', '-r1', '-r2', retcode=3)
+        bzr('c1', '-r1', '-r2', retcode=3)
+        bzr('c2', retcode=3)
+        bzr('c2', '-r1', retcode=3)

=== added file 'bzrlib/tests/blackbox/test_ancestry.py'
--- bzrlib/tests/blackbox/test_ancestry.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_ancestry.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,40 @@
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+
+from bzrlib.builtins import merge
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.workingtree import WorkingTree
+
+
+class TestAncestry(TestCaseWithTransport):
+
+    def test_ancestry(self):
+        """Tests 'ancestry' command"""
+        a_wt = self.make_branch_and_tree('A')
+        open('A/foo', 'wb').write('1111\n')
+        a_wt.add('foo')
+        a_wt.commit('added foo',rev_id='A1')
+        self.run_bzr_captured(['branch', 'A', 'B'])
+        b_wt = WorkingTree.open('B')
+        open('B/foo','wb').write('1111\n22\n')
+        b_wt.commit('modified B/foo',rev_id='B1')
+        open('A/foo', 'wb').write('000\n1111\n')
+        a_wt.commit('modified A/foo',rev_id='A2')
+        merge(['B',-1],['B',1],this_dir='A')
+        a_wt.commit('merged B into A',rev_id='A3')
+        self.run_bzr('ancestry')

=== added file 'bzrlib/tests/blackbox/test_bound_branches.py'
--- bzrlib/tests/blackbox/test_bound_branches.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_bound_branches.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,391 @@
+# Copyright (C) 2005 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests of bound branches (binding, unbinding, commit, etc) command.
+"""
+
+import os
+from cStringIO import StringIO
+
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.branch import Branch
+from bzrlib.bzrdir import (BzrDir,
+                           BzrDirFormat,
+                           BzrDirFormat6,
+                           BzrDirMetaFormat1,
+                           )
+from bzrlib.workingtree import WorkingTree
+
+
+class TestLegacyFormats(TestCaseWithTransport):
+    
+    def setUp(self):
+        super(TestLegacyFormats, self).setUp()
+        self.build_tree(['master/', 'child/'])
+        self.run_bzr('init', 'master')
+        old_format = BzrDirFormat.get_default_format()
+        BzrDirFormat.set_default_format(BzrDirFormat6())
+        try:
+            self.run_bzr('init', 'child')
+        finally:
+            BzrDirFormat.set_default_format(old_format)
+        os.chdir('child')
+    
+    def test_bind_format_6_bzrdir(self):
+        # bind on a format 6 bzrdir should error
+        out,err = self.run_bzr('bind', '../master', retcode=3)
+        self.assertEqual('', out)
+        self.assertEqual('bzr: ERROR: To use this feature you must '
+                         'upgrade your branch at %s/.\n' % os.getcwdu(), err)
+    
+    def test_unbind_format_6_bzrdir(self):
+        # bind on a format 6 bzrdir should error
+        out,err = self.run_bzr('unbind', retcode=3)
+        self.assertEqual('', out)
+        self.assertEqual('bzr: ERROR: To use this feature you must '
+                         'upgrade your branch at %s/.\n' % os.getcwdu(), err)
+
+
+class TestBoundBranches(TestCaseWithTransport):
+
+    def create_branches(self):
+        bzr = self.run_bzr
+        self.build_tree(['base/', 'base/a', 'base/b'])
+
+        self.init_meta_branch('base')
+        os.chdir('base')
+        bzr('add')
+        bzr('commit', '-m', 'init')
+
+        os.chdir('..')
+
+        bzr('checkout', 'base', 'child')
+
+        self.failUnlessExists('child')
+
+        self.check_revno(1, 'child')
+        d = BzrDir.open('child')
+        self.assertNotEqual(None, d.open_branch().get_master_branch())
+
+    def check_revno(self, val, loc=None):
+        if loc is not None:
+            cwd = os.getcwd()
+            os.chdir(loc)
+        self.assertEquals(str(val), self.run_bzr('revno')[0].strip())
+        if loc is not None:
+            os.chdir(cwd)
+
+    def test_simple_binding(self):
+        self.build_tree(['base/', 'base/a', 'base/b'])
+
+        self.init_meta_branch('base')
+        self.run_bzr('add', 'base')
+        self.run_bzr('commit', '-m', 'init', 'base')
+
+        self.run_bzr('branch', 'base', 'child')
+
+        os.chdir('child')
+        self.run_bzr('bind', '../base')
+
+        d = BzrDir.open('')
+        self.assertNotEqual(None, d.open_branch().get_master_branch())
+
+        self.run_bzr('unbind')
+        self.assertEqual(None, d.open_branch().get_master_branch())
+
+        self.run_bzr('unbind', retcode=3)
+
+    def init_meta_branch(self, path):
+        old_format = BzrDirFormat.get_default_format()
+        BzrDirFormat.set_default_format(BzrDirMetaFormat1())
+        try:
+            self.run_bzr('init', path)
+        finally:
+            BzrDirFormat.set_default_format(old_format)
+
+    def test_bound_commit(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        os.chdir('child')
+        open('a', 'wb').write('new contents\n')
+        bzr('commit', '-m', 'child')
+
+        self.check_revno(2)
+
+        # Make sure it committed on the parent
+        self.check_revno(2, '../base')
+
+    def test_bound_fail(self):
+        # Make sure commit fails if out of date.
+        bzr = self.run_bzr
+        self.create_branches()
+
+        os.chdir('base')
+        open('a', 'wb').write('new base contents\n')
+        bzr('commit', '-m', 'base')
+        self.check_revno(2)
+
+        os.chdir('../child')
+        self.check_revno(1)
+        open('b', 'wb').write('new b child contents\n')
+        bzr('commit', '-m', 'child', retcode=3)
+        self.check_revno(1)
+
+        bzr('update')
+        self.check_revno(2)
+
+        bzr('commit', '-m', 'child')
+        self.check_revno(3)
+        self.check_revno(3, '../base')
+
+    def test_double_binding(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        bzr('branch', 'child', 'child2')
+        os.chdir('child2')
+
+        # Double binding succeeds, but committing to child2 should fail
+        bzr('bind', '../child')
+
+        bzr('commit', '-m', 'child2', '--unchanged', retcode=3)
+
+    def test_unbinding(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        os.chdir('base')
+        open('a', 'wb').write('new base contents\n')
+        bzr('commit', '-m', 'base')
+        self.check_revno(2)
+
+        os.chdir('../child')
+        open('b', 'wb').write('new b child contents\n')
+        self.check_revno(1)
+        bzr('commit', '-m', 'child', retcode=3)
+        self.check_revno(1)
+        bzr('unbind')
+        bzr('commit', '-m', 'child')
+        self.check_revno(2)
+
+        bzr('bind', retcode=3)
+
+    def test_commit_remote_bound(self):
+        # It is not possible to commit to a branch
+        # which is bound to a branch which is bound
+        bzr = self.run_bzr
+        self.create_branches()
+        bzr('branch', 'base', 'newbase')
+        os.chdir('base')
+        
+        # There is no way to know that B has already
+        # been bound by someone else, otherwise it
+        # might be nice if this would fail
+        bzr('bind', '../newbase')
+
+        os.chdir('../child')
+        bzr('commit', '-m', 'failure', '--unchanged', retcode=3)
+
+    def test_pull_updates_both(self):
+        bzr = self.run_bzr
+        self.create_branches()
+        bzr('branch', 'base', 'newchild')
+        os.chdir('newchild')
+        open('b', 'wb').write('newchild b contents\n')
+        bzr('commit', '-m', 'newchild')
+        self.check_revno(2)
+
+        os.chdir('../child')
+        # The pull should succeed, and update
+        # the bound parent branch
+        bzr('pull', '../newchild')
+        self.check_revno(2)
+
+        self.check_revno(2, '../base')
+
+    def test_bind_diverged(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        os.chdir('child')
+        bzr('unbind')
+
+        bzr('commit', '-m', 'child', '--unchanged')
+        self.check_revno(2)
+
+        os.chdir('../base')
+        self.check_revno(1)
+        bzr('commit', '-m', 'base', '--unchanged')
+        self.check_revno(2)
+
+        os.chdir('../child')
+        # These branches have diverged
+        bzr('bind', '../base', retcode=3)
+
+        # TODO: In the future, this might require actual changes
+        # to have occurred, rather than just a new revision entry
+        bzr('merge', '../base')
+        bzr('commit', '-m', 'merged')
+        self.check_revno(3)
+
+        # After a merge, trying to bind again should succeed
+        # by pushing the new change to base
+        bzr('bind', '../base')
+        self.check_revno(3)
+        self.check_revno(3, '../base')
+
+        # After binding, the revision history should be identical
+        child_rh = bzr('revision-history')[0]
+        os.chdir('../base')
+        base_rh = bzr('revision-history')[0]
+        self.assertEquals(child_rh, base_rh)
+
+    def test_bind_parent_ahead(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        os.chdir('child')
+        bzr('unbind')
+
+        os.chdir('../base')
+        bzr('commit', '-m', 'base', '--unchanged')
+
+        os.chdir('../child')
+        self.check_revno(1)
+        bzr('bind', '../base')
+
+        self.check_revno(2)
+        bzr('unbind')
+
+        # Check and make sure it also works if parent is ahead multiple
+        os.chdir('../base')
+        bzr('commit', '-m', 'base 3', '--unchanged')
+        bzr('commit', '-m', 'base 4', '--unchanged')
+        bzr('commit', '-m', 'base 5', '--unchanged')
+        self.check_revno(5)
+
+        os.chdir('../child')
+        self.check_revno(2)
+        bzr('bind', '../base')
+        self.check_revno(5)
+
+    def test_bind_child_ahead(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        os.chdir('child')
+        bzr('unbind')
+        bzr('commit', '-m', 'child', '--unchanged')
+        self.check_revno(2)
+        self.check_revno(1, '../base')
+
+        bzr('bind', '../base')
+        self.check_revno(2, '../base')
+
+        # Check and make sure it also works if child is ahead multiple
+        bzr('unbind')
+        bzr('commit', '-m', 'child 3', '--unchanged')
+        bzr('commit', '-m', 'child 4', '--unchanged')
+        bzr('commit', '-m', 'child 5', '--unchanged')
+        self.check_revno(5)
+
+        self.check_revno(2, '../base')
+        bzr('bind', '../base')
+        self.check_revno(5, '../base')
+
+    def test_commit_after_merge(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        # We want merge to be able to be a local only
+        # operation, because it can be without violating
+        # the binding invariants.
+        # But we can't fail afterwards
+
+        bzr('branch', 'child', 'other')
+
+        os.chdir('other')
+        open('c', 'wb').write('file c\n')
+        bzr('add', 'c')
+        bzr('commit', '-m', 'adding c')
+        new_rev_id = bzr('revision-history')[0].strip().split('\n')[-1]
+
+        os.chdir('../child')
+        bzr('merge', '../other')
+
+        self.failUnlessExists('c')
+        tree = WorkingTree.open('.')
+        self.assertEqual([new_rev_id], tree.pending_merges())
+
+        # Make sure the local branch has the installed revision
+        bzr('cat-revision', new_rev_id)
+        
+        # And make sure that the base tree does not
+        os.chdir('../base')
+        bzr('cat-revision', new_rev_id, retcode=3)
+
+        # Commit should succeed, and cause merged revisions to
+        # be pulled into base
+        os.chdir('../child')
+        bzr('commit', '-m', 'merge other')
+
+        self.check_revno(2)
+
+        os.chdir('../base')
+        self.check_revno(2)
+
+        bzr('cat-revision', new_rev_id)
+
+    def test_pull_overwrite_fails(self):
+        bzr = self.run_bzr
+        self.create_branches()
+
+        bzr('branch', 'child', 'other')
+        
+        os.chdir('other')
+        open('a', 'wb').write('new contents\n')
+        bzr('commit', '-m', 'changed a')
+        self.check_revno(2)
+        open('a', 'ab').write('and then some\n')
+        bzr('commit', '-m', 'another a')
+        self.check_revno(3)
+        open('a', 'ab').write('and some more\n')
+        bzr('commit', '-m', 'yet another a')
+        self.check_revno(4)
+
+        os.chdir('../child')
+        open('a', 'wb').write('also changed a\n')
+        bzr('commit', '-m', 'child modified a')
+
+        self.check_revno(2)
+        self.check_revno(2, '../base')
+
+        # It might be possible that we want pull --overwrite to
+        # actually succeed.
+        # If we want it, just change this test to make sure that 
+        # both base and child are updated properly
+        bzr('pull', '--overwrite', '../other', retcode=3)
+
+        # It should fail without changing the local revision
+        self.check_revno(2)
+        self.check_revno(2, '../base')
+
+    # TODO: jam 20051230 Test that commit & pull fail when the branch we 
+    #       are bound to is not available
+
+

=== added file 'bzrlib/tests/blackbox/test_break_lock.py'
--- bzrlib/tests/blackbox/test_break_lock.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_break_lock.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,34 @@
+# Copyright (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for lock-breaking user interface"""
+
+import os
+
+from bzrlib.branch import Branch
+from bzrlib.bzrdir import BzrDir
+from bzrlib.tests import TestCaseInTempDir
+
+class TestBreakLock(TestCaseInTempDir):
+    def test_break_lock_help(self):
+        self.run_bzr('break-lock', '--help')
+        # shouldn't fail
+
+    def test_show_no_lock(self):
+        wt = BzrDir.create_standalone_workingtree('.')
+        # out, err = self.run_bzr('break-lock', '--show', '.', retcode=3)
+        # shouldn't see any information
+        # self.assertContainsRe(err, 'not locked')

=== added file 'bzrlib/tests/blackbox/test_checkout.py'
--- bzrlib/tests/blackbox/test_checkout.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_checkout.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,71 @@
+# Copyright (C) 2005 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for the 'checkout' CLI command."""
+
+from cStringIO import StringIO
+import os
+import re
+import shutil
+import sys
+
+import bzrlib.bzrdir as bzrdir
+from bzrlib.tests.blackbox import ExternalBase
+
+
+class TestCheckout(ExternalBase):
+    
+    def setUp(self):
+        super(TestCheckout, self).setUp()
+        tree = bzrdir.BzrDir.create_standalone_workingtree('branch')
+        tree.commit('1', rev_id='1', allow_pointless=True)
+        self.build_tree(['branch/added_in_2'])
+        tree.add('added_in_2')
+        tree.commit('2', rev_id='2')
+
+    def test_checkout_makes_bound_branch(self):
+        self.runbzr('checkout branch checkout')
+        # if we have a checkout, the branch base should be 'branch'
+        source = bzrdir.BzrDir.open('branch')
+        result = bzrdir.BzrDir.open('checkout')
+        self.assertEqual(source.open_branch().bzrdir.root_transport.base,
+                         result.open_branch().get_bound_location())
+
+    def test_checkout_light_makes_checkout(self):
+        self.runbzr('checkout --lightweight branch checkout')
+        # if we have a checkout, the branch base should be 'branch'
+        source = bzrdir.BzrDir.open('branch')
+        result = bzrdir.BzrDir.open('checkout')
+        self.assertEqual(source.open_branch().bzrdir.root_transport.base,
+                         result.open_branch().bzrdir.root_transport.base)
+
+    def test_checkout_dash_r(self):
+        self.runbzr('checkout -r -2 branch checkout')
+        # the working tree should now be at revision '1' with the content
+        # from 1.
+        result = bzrdir.BzrDir.open('checkout')
+        self.assertEqual('1', result.open_workingtree().last_revision())
+        self.failIfExists('checkout/added_in_2')
+
+    def test_checkout_light_dash_r(self):
+        self.runbzr('checkout --lightweight -r -2 branch checkout')
+        # the working tree should now be at revision '1' with the content
+        # from 1.
+        result = bzrdir.BzrDir.open('checkout')
+        self.assertEqual('1', result.open_workingtree().last_revision())
+        self.failIfExists('checkout/added_in_2')
+

=== added file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,92 @@
+# Copyright (C) 2005, 2006 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests for the commit CLI of bzr."""
+
+from cStringIO import StringIO
+import os
+import re
+import shutil
+import sys
+
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.errors import BzrCommandError
+from bzrlib.tests.blackbox import ExternalBase
+from bzrlib.workingtree import WorkingTree
+
+
+class TestCommit(ExternalBase):
+
+    def test_empty_commit(self):
+        self.runbzr("init")
+        self.build_tree(['hello.txt'])
+        self.runbzr("commit -m empty", retcode=3)
+        self.runbzr("add hello.txt")
+        self.runbzr("commit -m added")       
+
+    def test_empty_commit_message(self):
+        self.runbzr("init")
+        file('foo.c', 'wt').write('int main() {}')
+        self.runbzr(['add', 'foo.c'])
+        self.runbzr(["commit", "-m", ""] , retcode=3) 
+
+    def test_other_branch_commit(self):
+        # this branch is to ensure consistent behaviour, whether we're run
+        # inside a branch, or not.
+        os.mkdir('empty_branch')
+        os.chdir('empty_branch')
+        self.runbzr('init')
+        os.mkdir('branch')
+        os.chdir('branch')
+        self.runbzr('init')
+        file('foo.c', 'wt').write('int main() {}')
+        file('bar.c', 'wt').write('int main() {}')
+        os.chdir('..')
+        self.runbzr(['add', 'branch/foo.c'])
+        self.runbzr(['add', 'branch'])
+        # can't commit files in different trees; sane error
+        self.runbzr('commit -m newstuff branch/foo.c .', retcode=3)
+        self.runbzr('commit -m newstuff branch/foo.c')
+        self.runbzr('commit -m newstuff branch')
+        self.runbzr('commit -m newstuff branch', retcode=3)
+
+    def test_out_of_date_tree_commit(self):
+        # check we get an error code and a clear message committing with an out
+        # of date checkout
+        self.make_branch_and_tree('branch')
+        # make a checkout
+        self.runbzr('checkout --lightweight branch checkout')
+        # commit to the original branch to make the checkout out of date
+        self.runbzr('commit --unchanged -m message branch')
+        # now commit to the checkout should emit
+        # ERROR: Out of date with the branch, 'bzr update' is suggested
+        output = self.runbzr('commit --unchanged -m checkout_message '
+                             'checkout', retcode=3)
+        self.assertEqual(output,
+                         ('',
+                          "bzr: ERROR: Working tree is out of date, please run "
+                          "'bzr update'.\n"))
+
+    def test_local_commit_unbound(self):
+        # a --local commit on an unbound branch is an error
+        self.make_branch_and_tree('.')
+        out, err = self.run_bzr('commit', '--local', retcode=3)
+        self.assertEqualDiff('', out)
+        self.assertEqualDiff('bzr: ERROR: Cannot perform local-only commits '
+                             'on unbound branches.\n', err)

=== added file 'bzrlib/tests/blackbox/test_conflicts.py'
--- bzrlib/tests/blackbox/test_conflicts.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_conflicts.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,64 @@
+# Copyright (C) 2006 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+
+from bzrlib.tests.blackbox import ExternalBase
+
+class TestConflicts(ExternalBase):
+    def setUp(self):
+        super(ExternalBase, self).setUp()
+        try:
+            os.mkdir('a')
+        except:
+            raise os.getcwd()
+        os.chdir('a')
+        self.runbzr('init')
+        file('myfile', 'wb').write('contentsa\n')
+        file('my_other_file', 'wb').write('contentsa\n')
+        self.runbzr('add')
+        self.runbzr('commit -m new')
+        os.chdir('..')
+        self.runbzr('branch a b')
+        os.chdir('b')
+        file('myfile', 'wb').write('contentsb\n')
+        file('my_other_file', 'wb').write('contentsb\n')
+        self.runbzr('commit -m change')
+        os.chdir('../a')
+        file('myfile', 'wb').write('contentsa2\n')
+        file('my_other_file', 'wb').write('contentsa2\n')
+        self.runbzr('commit -m change')
+        self.runbzr('merge ../b', retcode=1)
+
+    def test_conflicts(self):
+        conflicts = self.runbzr('conflicts', backtick=True)
+        self.assertEqual(len(conflicts.splitlines()), 2)
+
+    def test_resolve(self):
+        self.runbzr('resolve', retcode=3)
+        self.runbzr('resolve myfile')
+        conflicts = self.runbzr('conflicts', backtick=True)
+        self.assertEqual(len(conflicts.splitlines()), 1)
+        self.runbzr('resolve my_other_file')
+        conflicts = self.runbzr('conflicts', backtick=True)
+        self.assertEqual(len(conflicts.splitlines()), 0)
+
+    def test_resolve_all(self):
+        self.runbzr('resolve --all')
+        conflicts = self.runbzr('conflicts', backtick=True)
+        self.assertEqual(len(conflicts.splitlines()), 0)
+

=== added file 'bzrlib/tests/blackbox/test_diff.py'
--- bzrlib/tests/blackbox/test_diff.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_diff.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,148 @@
+# Copyright (C) 2005 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Black-box tests for bzr diff.
+"""
+
+import os
+
+import bzrlib
+from bzrlib.branch import Branch
+from bzrlib.tests.blackbox import ExternalBase
+
+
+class TestDiff(ExternalBase):
+    def example_branch(test):
+        # FIXME: copied from test_too_much -- share elsewhere?
+        test.runbzr('init')
+        file('hello', 'wt').write('foo')
+        test.runbzr('add hello')
+        test.runbzr('commit -m setup hello')
+        file('goodbye', 'wt').write('baz')
+        test.runbzr('add goodbye')
+        test.runbzr('commit -m setup goodbye')
+
+    def test_diff(self):
+        self.example_branch()
+        file('hello', 'wt').write('hello world!')
+        self.runbzr('commit -m fixing hello')
+        output = self.runbzr('diff -r 2..3', backtick=1, retcode=1)
+        self.assert_('\n+hello world!' in output)
+        output = self.runbzr('diff -r last:3..last:1', backtick=1, retcode=1)
+        self.assert_('\n+baz' in output)
+        file('moo', 'wb').write('moo')
+        self.runbzr('add moo')
+        os.unlink('moo')
+        self.runbzr('diff')
+
+    def example_branches(self):
+        self.build_tree(['branch1/', 'branch1/file'], line_endings='binary')
+        self.capture('init branch1')
+        self.capture('add branch1/file')
+        self.run_bzr_captured(['commit', '-m', 'add file', 'branch1'])
+        self.capture('branch branch1 branch2')
+        print >> open('branch2/file', 'wb'), 'new content'
+        self.run_bzr_captured(['commit', '-m', 'update file', 'branch2'])
+
+    def test_diff_branches(self):
+        self.example_branches()
+        # should open branch1 and diff against branch2, 
+        output = self.run_bzr_captured(['diff', '-r', 'branch:branch2', 
+                                        'branch1'],
+                                       retcode=1)
+        self.assertEquals(("=== modified file 'a/file'\n"
+                           "--- a/file\t\n"
+                           "+++ b/file\t\n"
+                           "@@ -1,1 +1,1 @@\n"
+                           "-new content\n"
+                           "+contents of branch1/file\n"
+                           "\n", ''), output)
+        output = self.run_bzr_captured(['diff', 'branch2', 'branch1'],
+                                       retcode=1)
+        self.assertEqualDiff(("=== modified file 'a/file'\n"
+                              "--- a/file\t\n"
+                              "+++ b/file\t\n"
+                              "@@ -1,1 +1,1 @@\n"
+                              "-new content\n"
+                              "+contents of branch1/file\n"
+                              "\n", ''), output)
+
+    def example_branch2(self):
+        self.build_tree(['branch1/', 'branch1/file1'], line_endings='binary')
+        self.capture('init branch1')
+        self.capture('add branch1/file1')
+        print >> open('branch1/file1', 'wb'), 'original line'
+        self.run_bzr_captured(['commit', '-m', 'first commit', 'branch1'])
+        
+        print >> open('branch1/file1', 'wb'), 'repo line'
+        self.run_bzr_captured(['commit', '-m', 'second commit', 'branch1'])
+
+    def test_diff_to_working_tree(self):
+        self.example_branch2()
+        
+        print >> open('branch1/file1', 'wb'), 'new line'
+        output = self.run_bzr_captured(['diff', '-r', '1..', 'branch1'], retcode=1)
+        self.assertTrue('\n-original line\n+new line\n' in output[0])
+
+
+class TestCheckoutDiff(TestDiff):
+
+    def example_branch(self):
+        super(TestCheckoutDiff, self).example_branch()
+        self.runbzr('checkout . checkout')
+        os.chdir('checkout')
+
+    def example_branch2(self):
+        super(TestCheckoutDiff, self).example_branch2()
+        os.mkdir('checkouts')
+        self.runbzr('checkout branch1 checkouts/branch1')
+        os.chdir('checkouts')
+
+    def example_branches(self):
+        super(TestCheckoutDiff, self).example_branches()
+        os.mkdir('checkouts')
+        self.runbzr('checkout branch1 checkouts/branch1')
+        self.runbzr('checkout branch2 checkouts/branch2')
+        os.chdir('checkouts')
+
+class TestDiffLabels(TestDiff):
+
+    def test_diff_label_removed(self):
+        super(TestDiffLabels, self).example_branch()
+        self.runbzr('remove hello')
+        diff = self.run_bzr_captured(['diff'], retcode=1)
+        self.assertTrue("=== removed file 'a/hello'" in diff[0])
+
+    def test_diff_label_added(self):
+        super(TestDiffLabels, self).example_branch()
+        file('barbar', 'wt').write('barbar')
+        self.runbzr('add barbar')
+        diff = self.run_bzr_captured(['diff'], retcode=1)
+        self.assertTrue("=== added file 'b/barbar'" in diff[0])
+
+    def test_diff_label_modified(self):
+        super(TestDiffLabels, self).example_branch()
+        file('hello', 'wt').write('barbar')
+        diff = self.run_bzr_captured(['diff'], retcode=1)
+        self.assertTrue("=== modified file 'a/hello'" in diff[0])
+
+    def test_diff_label_renamed(self):
+        super(TestDiffLabels, self).example_branch()
+        self.runbzr('rename hello gruezi')
+        diff = self.run_bzr_captured(['diff'], retcode=1)
+        self.assertTrue("=== renamed file 'a/hello' => 'b/gruezi'" in diff[0])

=== added file 'bzrlib/tests/blackbox/test_find_merge_base.py'
--- bzrlib/tests/blackbox/test_find_merge_base.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_find_merge_base.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,34 @@
+# Copyright (C) 2005 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+from bzrlib.tests.blackbox import ExternalBase
+import os
+
+
+class TestFindMergeBase(ExternalBase):
+    def test_find_merge_base(self):
+        os.mkdir('a')
+        os.chdir('a')
+        self.runbzr('init')
+        self.runbzr('commit -m foo --unchanged')
+        self.runbzr('branch . ../b')
+        q = self.run_bzr('find-merge-base', '.', '../b', backtick=True)
+        self.runbzr('commit -m bar --unchanged')
+        os.chdir('../b')
+        self.runbzr('commit -m baz --unchanged')
+        r = self.run_bzr('find-merge-base', '.', '../a', backtick=True)
+        self.assertEqual(q, r)
+        

=== added file 'bzrlib/tests/blackbox/test_help.py'
--- bzrlib/tests/blackbox/test_help.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_help.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,59 @@
+# Copyright (C) 2005 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Black-box tests for bzr help.
+"""
+
+
+from bzrlib.tests.blackbox import ExternalBase
+
+
+class TestHelp(ExternalBase):
+
+    def test_help_basic(self):
+        dash_help = self.runbzr('--help')[0]
+        just_help = self.runbzr('help')[0]
+        quest_mk  = self.runbzr('?')[0]
+        self.assertEquals(dash_help, just_help)
+        self.assertEquals(dash_help, quest_mk)
+
+    def test_help_commands(self):
+        dash_help  = self.runbzr('--help commands')[0]
+        commands   = self.runbzr('help commands')[0]
+        long_help  = self.runbzr('help --long')[0]
+        qmark_long = self.runbzr('? --long')[0]
+        qmark_cmds = self.runbzr('? commands')[0]
+        self.assertEquals(dash_help, commands)
+        self.assertEquals(dash_help, long_help)
+        self.assertEquals(dash_help, qmark_long)
+        self.assertEquals(dash_help, qmark_cmds)
+
+    def test_help_detail(self):
+        dash_h  = self.runbzr('commit -h')[0]
+        help_x  = self.runbzr('help commit')[0]
+        qmark_x = self.runbzr('help commit')[0]
+        self.assertEquals(dash_h, help_x)
+        self.assertEquals(dash_h, qmark_x)
+
+    def test_help_help(self):
+        help = self.runbzr('help help')[0]
+        qmark = self.runbzr('? ?')[0]
+        self.assertEquals(help, qmark)
+        for line in help.split('\n'):
+            if '--long' in line:
+                self.assertTrue('show help on all commands' in line)

=== added file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_info.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,240 @@
+# Copyright (C) 2006 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests for the info command of bzr."""
+
+
+from bzrlib.osutils import format_date
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.blackbox import ExternalBase
+
+
+class TestInfo(ExternalBase):
+
+    def test_info_standalone_trivial(self):
+        self.runbzr("init")
+        out, err = self.runbzr('info')
+        self.assertEqualDiff(
+"""branch format: Bazaar-NG branch, format 6
+
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""",
+        out)
+        self.assertEqual('', err)
+
+    def test_info_up_to_date_checkout(self):
+        a_branch = self.make_branch_and_tree('branch')
+        self.runbzr('checkout branch checkout')
+        out, err = self.runbzr('info checkout')
+        self.assertEqualDiff(
+"""branch format: Bazaar-NG Metadir branch format 5
+bound to branch: %s
+
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""" % a_branch.bzrdir.root_transport.base,
+        out)
+        self.assertEqual('', err)
+
+    def test_info_up_to_date_light_checkout(self):
+        a_branch = self.make_branch_and_tree('branch')
+        self.runbzr('checkout --lightweight branch checkout')
+        out, err = self.runbzr('info checkout')
+        self.assertEqualDiff(
+"""working tree format: Bazaar-NG Working Tree format 3
+branch location: %s
+branch format: Bazaar-NG branch, format 6
+
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""" % a_branch.bzrdir.root_transport.base,
+        out)
+        self.assertEqual('', err)
+
+    def test_info_out_of_date_standalone_tree(self):
+        # FIXME the default format has to change for this to pass
+        # because it currently uses the branch last-revision marker.
+        raise TestSkipped('default format too old')
+        self.make_branch_and_tree('branch')
+        # make a checkout
+        self.runbzr('checkout branch checkout')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        # now branch should be out of date
+        out,err = self.runbzr('update branch')
+        self.assertEqualDiff(
+"""branch format: Bazaar-NG branch, format 6
+
+Working tree is out of date: missing 1 revision.
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""" % a_branch.bzrdir.root_transport.base,
+        out)
+        self.assertEqual('', err)
+
+    def test_info_out_of_date_checkout(self):
+        # note this deliberately uses a checkout at 'None' to 
+        # test the out of date message with a revision notin the 
+        # revision history.
+        a_branch = self.make_branch('branch')
+        # make two checkouts
+        self.runbzr('checkout branch checkout')
+        self.runbzr('checkout branch checkout2')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        # now checkout2 should be out of date
+        out,err = self.runbzr('info checkout2')
+        rev = a_branch.repository.get_revision(a_branch.revision_history()[0])
+        datestring = format_date(rev.timestamp, rev.timezone)
+        self.assertEqualDiff(
+"""branch format: Bazaar-NG Metadir branch format 5
+bound to branch: %s
+
+Branch is out of date: missing 1 revision.
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         0 revisions
+         0 committers
+
+revision store:
+         0 revisions
+         0 kB
+""" % (a_branch.bzrdir.root_transport.base,
+       ),
+            out)
+        self.assertEqual('', err)
+
+    def test_info_out_of_date_light_checkout(self):
+        # note this deliberately uses a checkout at 'None' to 
+        # test the out of date message with a revision notin the 
+        # revision history.
+        a_branch = self.make_branch('branch')
+        # make two checkouts
+        self.runbzr('checkout --lightweight branch checkout')
+        self.runbzr('checkout --lightweight branch checkout2')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        # now checkout2 should be out of date
+        out,err = self.runbzr('info checkout2')
+        rev = a_branch.repository.get_revision(a_branch.revision_history()[0])
+        datestring = format_date(rev.timestamp, rev.timezone)
+        self.assertEqualDiff(
+"""working tree format: Bazaar-NG Working Tree format 3
+branch location: %s
+branch format: Bazaar-NG branch, format 6
+
+Working tree is out of date: missing 1 revision.
+in the working tree:
+         0 unchanged
+         0 modified
+         0 added
+         0 removed
+         0 renamed
+         0 unknown
+         0 ignored
+         0 versioned subdirectories
+
+branch history:
+         1 revision
+         1 committer
+         0 days old
+   first revision: %s
+  latest revision: %s
+
+revision store:
+         1 revision
+         0 kB
+""" % (a_branch.bzrdir.root_transport.base,
+       datestring,
+       datestring,
+       ),
+            out)
+        self.assertEqual('', err)

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/blackbox/test_log.py	2006-03-20 08:31:00 +0000
@@ -19,22 +19,70 @@
 """Black-box tests for bzr log.
 """
 
-import os
 
-import bzrlib
 from bzrlib.tests.blackbox import ExternalBase
 
 
 class TestLog(ExternalBase):
 
-    def test_log(self):
+    def _prepare(self):
         self.runbzr("init")
-        self.build_tree(['hello.txt'])
+        self.build_tree(['hello.txt', 'goodbye.txt', 'meep.txt'])
         self.runbzr("add hello.txt")
-        self.runbzr("commit -m message hello.txt")
-        result = self.runbzr("log")[0]
-        self.assertTrue('revno: 1\n' in result)
-        self.assertTrue('message:\n  message\n' in result)
-        
-        result2 = self.runbzr("log -r 1..")[0]
-        self.assertEquals(result2, result)
+        self.runbzr("commit -m message1 hello.txt")
+        self.runbzr("add goodbye.txt")
+        self.runbzr("commit -m message2 goodbye.txt")
+        self.runbzr("add meep.txt")
+        self.runbzr("commit -m message3 meep.txt")
+        self.full_log = self.runbzr("log")[0]
+
+    def test_log_null_end_revspec(self):
+        self._prepare()
+        self.assertTrue('revno: 1\n' in self.full_log)
+        self.assertTrue('revno: 2\n' in self.full_log)
+        self.assertTrue('revno: 3\n' in self.full_log)
+        self.assertTrue('message:\n  message1\n' in self.full_log)
+        self.assertTrue('message:\n  message2\n' in self.full_log)
+        self.assertTrue('message:\n  message3\n' in self.full_log)
+
+        log = self.runbzr("log -r 1..")[0]
+        self.assertEquals(log, self.full_log)
+
+    def test_log_null_begin_revspec(self):
+        self._prepare()
+        log = self.runbzr("log -r ..3")[0]
+        self.assertEquals(self.full_log, log)
+
+    def test_log_null_both_revspecs(self):
+        self._prepare()
+        log = self.runbzr("log -r ..")[0]
+        self.assertEquals(self.full_log, log)
+
+    def test_log_negative_begin_revspec_full_log(self):
+        self._prepare()
+        log = self.runbzr("log -r -3..")[0]
+        self.assertEquals(self.full_log, log)
+
+    def test_log_negative_both_revspec_full_log(self):
+        self._prepare()
+        log = self.runbzr("log -r -3..-1")[0]
+        self.assertEquals(self.full_log, log)
+
+    def test_log_negative_both_revspec_partial(self):
+        self._prepare()
+        log = self.runbzr("log -r -3..-2")[0]
+        self.assertTrue('revno: 1\n' in log)
+        self.assertTrue('revno: 2\n' in log)
+        self.assertTrue('revno: 3\n' not in log)
+
+    def test_log_negative_begin_revspec(self):
+        self._prepare()
+        log = self.runbzr("log -r -2..")[0]
+        self.assertTrue('revno: 1\n' not in log)
+        self.assertTrue('revno: 2\n' in log)
+        self.assertTrue('revno: 3\n' in log)
+
+    def test_log_postive_revspecs(self):
+        self._prepare()
+        log = self.runbzr("log -r 1..3")[0]
+        self.assertEquals(self.full_log, log)

=== added file 'bzrlib/tests/blackbox/test_logformats.py'
--- bzrlib/tests/blackbox/test_logformats.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_logformats.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,111 @@
+"""Black-box tests for default log_formats/log_formatters
+"""
+
+import os
+
+from bzrlib.branch import Branch
+from bzrlib.tests import TestCaseInTempDir
+from bzrlib.config import (config_dir, config_filename)
+
+
+class TestLogFormats(TestCaseInTempDir):
+
+    def bzr(self, *args, **kwargs):
+        return self.run_bzr(*args, **kwargs)[0]
+
+    def test_log_default_format(self):
+        setup_config()
+
+        self.bzr('init')
+        open('a', 'wb').write('foo\n')
+        self.bzr('add', 'a')
+
+        self.bzr('commit', '-m', '1')
+        open('a', 'wb').write('baz\n')
+
+        self.bzr('commit', '-m', '2')
+
+        # only the lines formatter is this short
+        self.assertEquals(3, len(self.bzr('log').split('\n')))
+
+    def test_log_format_arg(self):
+        self.bzr('init')
+        open('a', 'wb').write('foo\n')
+        self.bzr('add', 'a')
+
+        self.bzr('commit', '-m', '1')
+        open('a', 'wb').write('baz\n')
+
+        self.bzr('commit', '-m', '2')
+
+        # only the lines formatter is this short
+        self.assertEquals(7, len(self.bzr('log', '--log-format', 'short').split('\n')))
+
+    def test_missing_default_format(self):
+        setup_config()
+
+        os.mkdir('a')
+        os.chdir('a')
+        self.bzr('init')
+
+        open('a', 'wb').write('foo\n')
+        self.bzr('add', 'a')
+        self.bzr('commit', '-m', '1')
+
+        os.chdir('..')
+        self.bzr('branch', 'a', 'b')
+        os.chdir('a')
+
+        open('a', 'wb').write('bar\n')
+        self.bzr('commit', '-m', '2')
+
+        open('a', 'wb').write('baz\n')
+        self.bzr('commit', '-m', '3')
+
+        os.chdir('../b')
+        
+        self.assertEquals(5, len(self.bzr('missing', retcode=1).split('\n')))
+        
+        os.chdir('..')
+
+    def test_missing_format_arg(self):
+        setup_config()
+
+        os.mkdir('a')
+        os.chdir('a')
+        self.bzr('init')
+
+        open('a', 'wb').write('foo\n')
+        self.bzr('add', 'a')
+        self.bzr('commit', '-m', '1')
+
+        os.chdir('..')
+        self.bzr('branch', 'a', 'b')
+        os.chdir('a')
+
+        open('a', 'wb').write('bar\n')
+        self.bzr('commit', '-m', '2')
+
+        open('a', 'wb').write('baz\n')
+        self.bzr('commit', '-m', '3')
+
+        os.chdir('../b')
+        
+        self.assertEquals(9, len(self.bzr('missing', '--log-format', 'short', retcode=1).split('\n')))
+        
+        os.chdir('..')
+
+
+def setup_config():
+        if os.path.isfile(config_filename()):
+                # Something is wrong in environment, 
+                # we risk overwriting users config 
+                self.assert_(config_filename() + "exists, abort")
+            
+        os.mkdir(config_dir())
+        CONFIG=("[DEFAULT]\n"
+                "email=Joe Foo <joe@foo.com>\n"
+                "log_format=line\n")
+
+        open(config_filename(),'wb').write(CONFIG)
+

=== added file 'bzrlib/tests/blackbox/test_outside_wt.py'
--- bzrlib/tests/blackbox/test_outside_wt.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_outside_wt.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,42 @@
+# Copyright (C) 2006 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Black-box tests for running bzr outside of a working tree."""
+
+import os
+
+from bzrlib.tests import ChrootedTestCase
+
+
+class TestOutsideWT(ChrootedTestCase):
+    """Test that bzr gives proper errors outside of a working tree."""
+
+    def test_cwd_log(self):
+        os.chdir('/tmp')
+        cwd = os.getcwdu()
+        out, err = self.run_bzr('log', retcode=3)
+
+        self.assertEqual(u'bzr: ERROR: Not a branch: %s/\n' % (cwd,),
+                         err)
+
+    def test_url_log(self):
+        url = self.get_readonly_url() + 'subdir/'
+        out, err = self.run_bzr('log', 
+                                url, retcode=3)
+        self.assertEqual(u'bzr: ERROR: Not a branch:'
+                         u' %s\n' % url, err)

=== modified file 'bzrlib/tests/blackbox/test_pull.py'
--- bzrlib/tests/blackbox/test_pull.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/blackbox/test_pull.py	2006-03-20 08:31:00 +0000
@@ -101,6 +101,33 @@
         self.runbzr('pull ../b')
         self.runbzr('pull ../b')
 
+    def test_pull_revision(self):
+        """Pull some changes from one branch to another."""
+        os.mkdir('a')
+        os.chdir('a')
+
+        self.example_branch()
+        file('hello2', 'wt').write('foo')
+        self.runbzr('add hello2')
+        self.runbzr('commit -m setup hello2')
+        file('goodbye2', 'wt').write('baz')
+        self.runbzr('add goodbye2')
+        self.runbzr('commit -m setup goodbye2')
+
+        os.chdir('..')
+        self.runbzr('branch -r 1 a b')
+        os.chdir('b')
+        self.runbzr('pull -r 2')
+        a = Branch.open('../a')
+        b = Branch.open('.')
+        self.assertEquals(a.revno(),4)
+        self.assertEquals(b.revno(),2)
+        self.runbzr('pull -r 3')
+        self.assertEquals(b.revno(),3)
+        self.runbzr('pull -r 4')
+        self.assertEquals(a.revision_history(), b.revision_history())
+
+
     def test_overwrite_uptodate(self):
         # Make sure pull --overwrite overwrites
         # even if the target branch has merged

=== added file 'bzrlib/tests/blackbox/test_re_sign.py'
--- bzrlib/tests/blackbox/test_re_sign.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_re_sign.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,105 @@
+# Copyright (C) 2005 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Black-box tests for bzr re-sign.
+"""
+
+import os
+
+import bzrlib.gpg
+from bzrlib.bzrdir import BzrDir
+from bzrlib.testament import Testament
+from bzrlib.tests import TestCaseInTempDir
+
+
+class ReSign(TestCaseInTempDir):
+
+    def monkey_patch_gpg(self):
+        """Monkey patch the gpg signing strategy to be a loopback.
+
+        This also registers the cleanup, so that we will revert to
+        the original gpg strategy when done.
+        """
+        self._oldstrategy = bzrlib.gpg.GPGStrategy
+
+        # monkey patch gpg signing mechanism
+        bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
+
+        self.addCleanup(self._fix_gpg_strategy)
+
+    def _fix_gpg_strategy(self):
+        bzrlib.gpg.GPGStrategy = self._oldstrategy
+
+    def setup_tree(self):
+        wt = BzrDir.create_standalone_workingtree('.')
+        wt.commit("base A", allow_pointless=True, rev_id='A')
+        wt.commit("base B", allow_pointless=True, rev_id='B')
+        wt.commit("base C", allow_pointless=True, rev_id='C')
+
+        return wt
+
+    def test_resign(self):
+        #Test re signing of data.
+        wt = self.setup_tree()
+        repo = wt.branch.repository
+
+        self.monkey_patch_gpg()
+        self.run_bzr('re-sign', '-r', 'revid:A')
+
+        self.assertEqual(
+            Testament.from_revision(repo, 'A').as_short_text(),
+            repo.revision_store.get('A', 'sig').read())
+
+        self.run_bzr('re-sign', 'B')
+        self.assertEqual(
+            Testament.from_revision(repo, 'B').as_short_text(),
+            repo.revision_store.get('B', 'sig').read())
+            
+    def test_resign_range(self):
+        wt = self.setup_tree()
+        repo = wt.branch.repository
+
+        self.monkey_patch_gpg()
+        self.run_bzr('re-sign', '-r', '1..')
+        self.assertEqual(
+            Testament.from_revision(repo, 'A').as_short_text(),
+            repo.revision_store.get('A', 'sig').read())
+        self.assertEqual(
+            Testament.from_revision(repo, 'B').as_short_text(),
+            repo.revision_store.get('B', 'sig').read())
+        self.assertEqual(
+            Testament.from_revision(repo, 'C').as_short_text(),
+            repo.revision_store.get('C', 'sig').read())
+
+    def test_resign_multiple(self):
+        wt = self.setup_tree()
+        repo = wt.branch.repository
+
+        self.monkey_patch_gpg()
+        self.run_bzr('re-sign', 'A', 'B', 'C')
+        self.assertEqual(
+            Testament.from_revision(repo, 'A').as_short_text(),
+            repo.revision_store.get('A', 'sig').read())
+        self.assertEqual(
+            Testament.from_revision(repo, 'B').as_short_text(),
+            repo.revision_store.get('B', 'sig').read())
+        self.assertEqual(
+            Testament.from_revision(repo, 'C').as_short_text(),
+            repo.revision_store.get('C', 'sig').read())
+
+

=== added file 'bzrlib/tests/blackbox/test_reconcile.py'
--- bzrlib/tests/blackbox/test_reconcile.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_reconcile.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,63 @@
+# Copyright (C) 2006 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Black box tests for the reconcile command."""
+
+
+import bzrlib
+import bzrlib.bzrdir as bzrdir
+import bzrlib.repository as repository
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tests.blackbox import TestUIFactory
+from bzrlib.transport import get_transport
+import bzrlib.ui as ui
+
+
+class TrivialTest(TestCaseWithTransport):
+
+    def setUp(self):
+        super(TrivialTest, self).setUp()
+        self.old_format = bzrdir.BzrDirFormat.get_default_format()
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
+        ui.ui_factory = TestUIFactory()
+
+    def restoreDefaults(self):
+        ui.ui_factory = self.old_ui_factory
+
+    def test_trivial_reconcile(self):
+        t = bzrdir.BzrDir.create_standalone_workingtree('.')
+        (out, err) = self.run_bzr_captured(['reconcile'])
+        self.assertEqualDiff(out, "Reconciling repository %s\n"
+                                  "Inventory ok.\n"
+                                  "Reconciliation complete.\n" %
+                                  t.bzrdir.root_transport.base)
+        self.assertEqualDiff(err, "")
+
+    def test_does_something_reconcile(self):
+        t = bzrdir.BzrDir.create_standalone_workingtree('.')
+        # an empty inventory with no revision will trigger reconciliation.
+        repo = t.branch.repository
+        inv = bzrlib.tree.EmptyTree().inventory
+        repo.add_inventory('missing', inv, [])
+        (out, err) = self.run_bzr_captured(['reconcile'])
+        self.assertEqualDiff(out, "Reconciling repository %s\n"
+                                  "Backup Inventory created.\n"
+                                  "Inventory regenerated.\n"
+                                  "Reconciliation complete.\n" %
+                                  t.bzrdir.root_transport.base)
+        self.assertEqualDiff(err, "")
+

=== added file 'bzrlib/tests/blackbox/test_revert.py'
--- bzrlib/tests/blackbox/test_revert.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_revert.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,63 @@
+# Copyright (C) 2005 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Black-box tests for bzr revert."""
+
+import os
+
+from bzrlib.tests.blackbox import ExternalBase
+from bzrlib.trace import mutter
+
+
+class TestRevert(ExternalBase):
+
+    def _prepare_tree(self):
+        self.runbzr('init')
+        self.runbzr('mkdir dir')
+
+        f = file('dir/file', 'wb')
+        f.write('spam')
+        f.close()
+        self.runbzr('add dir/file')
+
+        self.runbzr('commit -m1')
+
+        # modify file
+        f = file('dir/file', 'wb')
+        f.write('eggs')
+        f.close()
+
+        # check status
+        self.assertEquals('modified:\n  dir/file\n', self.capture('status'))
+
+    def helper(self, param=''):
+        self._prepare_tree()
+        # change dir
+        # revert to default revision for file in subdir does work
+        os.chdir('dir')
+        mutter('cd dir\n')
+
+        self.assertEquals('1\n', self.capture('revno'))
+        self.runbzr('revert %s file' % param)
+        self.assertEquals('spam', open('file', 'rb').read())
+
+    def test_revert_in_subdir(self):
+        self.helper()
+
+    def test_revert_to_revision_in_subdir(self):
+        # test case for bug #29424:
+        # revert to specific revision for file in subdir does not work
+        self.helper('-r 1')

=== modified file 'bzrlib/tests/blackbox/test_revision_info.py'
--- bzrlib/tests/blackbox/test_revision_info.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/blackbox/test_revision_info.py	2006-03-20 08:31:00 +0000
@@ -15,12 +15,14 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-from bzrlib.tests import TestCaseInTempDir
+
 from bzrlib.errors import BzrCommandError, NoSuchRevision
-from bzrlib.branch import Branch
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.revisionspec import RevisionSpec
-
-class TestRevisionInfo(TestCaseInTempDir):
+from bzrlib.workingtree import WorkingTree
+
+
+class TestRevisionInfo(TestCaseWithTransport):
     
     def check_error(self, output, *args):
         """Verify that the expected error matches what bzr says.
@@ -39,14 +41,12 @@
         self.assertEquals(self.run_bzr_captured(args)[0], output)
 
     def test_revision_info(self):
-        """Test that 'bzr revision-info' reports the correct thing.
-        """
-
-        b = Branch.initialize(u'.')
-
-        b.working_tree().commit('Commit one', rev_id='a@r-0-1')
-        b.working_tree().commit('Commit two', rev_id='a@r-0-2')
-        b.working_tree().commit('Commit three', rev_id='a@r-0-3')
+        """Test that 'bzr revision-info' reports the correct thing."""
+        wt = self.make_branch_and_tree('.')
+
+        wt.commit('Commit one', rev_id='a@r-0-1')
+        wt.commit('Commit two', rev_id='a@r-0-2')
+        wt.commit('Commit three', rev_id='a@r-0-3')
 
         # Make sure revision-info without any arguments throws an exception
         self.check_error('bzr: ERROR: '
@@ -85,16 +85,17 @@
     def test_cat_revision(self):
         """Test bzr cat-revision.
         """
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        r = wt.branch.repository
 
-        b.working_tree().commit('Commit one', rev_id='a@r-0-1')
-        b.working_tree().commit('Commit two', rev_id='a@r-0-2')
-        b.working_tree().commit('Commit three', rev_id='a@r-0-3')
+        wt.commit('Commit one', rev_id='a@r-0-1')
+        wt.commit('Commit two', rev_id='a@r-0-2')
+        wt.commit('Commit three', rev_id='a@r-0-3')
 
         revs = {
-            1:b.get_revision_xml('a@r-0-1'),
-            2:b.get_revision_xml('a@r-0-2'),
-            3:b.get_revision_xml('a@r-0-3')
+            1:r.get_revision_xml('a@r-0-1'),
+            2:r.get_revision_xml('a@r-0-2'),
+            3:r.get_revision_xml('a@r-0-3'),
         }
 
         self.check_output(revs[1], 'cat-revision', 'a@r-0-1')

=== added file 'bzrlib/tests/blackbox/test_selftest.py'
--- bzrlib/tests/blackbox/test_selftest.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_selftest.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,69 @@
+# Copyright (C) 2005 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as published by
+# the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""UI tests for the test framework."""
+
+import bzrlib
+from bzrlib.tests import (
+                          TestCase,
+                          TestCaseInTempDir,
+                          TestSkipped,
+                          )
+
+
+class TestOptions(TestCase):
+
+    current_test = None
+
+    def test_transport_set_to_sftp(self):
+        # test the --transport option has taken effect from within the
+        # test_transport test
+        import bzrlib.transport.sftp
+        if TestOptions.current_test != "test_transport_set_to_sftp":
+            return
+        self.assertEqual(bzrlib.transport.sftp.SFTPAbsoluteServer,
+                         bzrlib.tests.default_transport)
+
+    def test_transport_set_to_memory(self):
+        # test the --transport option has taken effect from within the
+        # test_transport test
+        import bzrlib.transport.memory
+        if TestOptions.current_test != "test_transport_set_to_memory":
+            return
+        self.assertEqual(bzrlib.transport.memory.MemoryServer,
+                         bzrlib.tests.default_transport)
+
+    def test_transport(self):
+        # test that --transport=sftp works
+        # FIXME RBC 20060123 this should raise TestSkipped if sftp is not
+        # available.
+        old_transport = bzrlib.tests.default_transport
+        old_root = TestCaseInTempDir.TEST_ROOT
+        TestCaseInTempDir.TEST_ROOT = None
+        try:
+            TestOptions.current_test = "test_transport_set_to_sftp"
+            stdout = self.capture('selftest --transport=sftp test_transport_set_to_sftp')
+            
+            self.assertContainsRe(stdout, 'Ran 1 test')
+            self.assertEqual(old_transport, bzrlib.tests.default_transport)
+
+            TestOptions.current_test = "test_transport_set_to_memory"
+            stdout = self.capture('selftest --transport=memory test_transport_set_to_memory')
+            self.assertContainsRe(stdout, 'Ran 1 test')
+            self.assertEqual(old_transport, bzrlib.tests.default_transport)
+        finally:
+            bzrlib.tests.default_transport = old_transport
+            TestOptions.current_test = None
+            TestCaseInTempDir.TEST_ROOT = old_root

=== added file 'bzrlib/tests/blackbox/test_sign_my_commits.py'
--- bzrlib/tests/blackbox/test_sign_my_commits.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_sign_my_commits.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,114 @@
+# Copyright (C) 2005 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Black-box tests for bzr sign-my-commits."""
+
+import os
+
+import bzrlib.gpg
+from bzrlib.testament import Testament
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.workingtree import WorkingTree
+
+
+class SignMyCommits(TestCaseWithTransport):
+
+    def monkey_patch_gpg(self):
+        """Monkey patch the gpg signing strategy to be a loopback.
+
+        This also registers the cleanup, so that we will revert to
+        the original gpg strategy when done.
+        """
+        self._oldstrategy = bzrlib.gpg.GPGStrategy
+
+        # monkey patch gpg signing mechanism
+        bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
+
+        self.addCleanup(self._fix_gpg_strategy)
+
+    def _fix_gpg_strategy(self):
+        bzrlib.gpg.GPGStrategy = self._oldstrategy
+
+    def setup_tree(self, location='.'):
+        wt = self.make_branch_and_tree(location)
+        wt.commit("base A", allow_pointless=True, rev_id='A')
+        wt.commit("base B", allow_pointless=True, rev_id='B')
+        wt.commit("base C", allow_pointless=True, rev_id='C')
+        wt.commit("base D", allow_pointless=True, rev_id='D',
+                committer='Alternate <alt@foo.com>')
+
+        return wt
+
+    def test_sign_my_commits(self):
+        #Test re signing of data.
+        wt = self.setup_tree()
+        repo = wt.branch.repository
+
+        self.monkey_patch_gpg()
+
+        self.assertFalse(repo.revision_store.has_id('A', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('B', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('C', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('D', 'sig'))
+
+        self.run_bzr('sign-my-commits')
+
+        self.assertTrue(repo.revision_store.has_id('A', 'sig'))
+        self.assertTrue(repo.revision_store.has_id('B', 'sig'))
+        self.assertTrue(repo.revision_store.has_id('C', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('D', 'sig'))
+            
+    def test_sign_my_commits_location(self):
+        wt = self.setup_tree('other')
+        repo = wt.branch.repository
+
+        self.monkey_patch_gpg()
+
+        self.run_bzr('sign-my-commits', 'other')
+
+        self.assertTrue(repo.revision_store.has_id('A', 'sig'))
+        self.assertTrue(repo.revision_store.has_id('B', 'sig'))
+        self.assertTrue(repo.revision_store.has_id('C', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('D', 'sig'))
+
+    def test_sign_diff_committer(self):
+        wt = self.setup_tree()
+        repo = wt.branch.repository
+
+        self.monkey_patch_gpg()
+
+        self.run_bzr('sign-my-commits', '.', 'Alternate <alt@foo.com>')
+
+        self.assertFalse(repo.revision_store.has_id('A', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('B', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('C', 'sig'))
+        self.assertTrue(repo.revision_store.has_id('D', 'sig'))
+
+    def test_sign_dry_run(self):
+        wt = self.setup_tree()
+        repo = wt.branch.repository
+
+        self.monkey_patch_gpg()
+
+        out = self.run_bzr('sign-my-commits', '--dry-run')[0]
+
+        self.assertEquals('A\nB\nC\nSigned 3 revisions\n', out)
+        self.assertFalse(repo.revision_store.has_id('A', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('B', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('C', 'sig'))
+        self.assertFalse(repo.revision_store.has_id('D', 'sig'))
+

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/blackbox/test_status.py	2006-03-20 08:31:00 +0000
@@ -1,5 +1,4 @@
 # Copyright (C) 2005 by Canonical Ltd
-# -*- coding: utf-8 -*-
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,32 +15,202 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""Black-box tests for bzr status.
+"""Tests of status command.
+
+Most of these depend on the particular formatting used.
+As such they really are blackbox tests even though some of the 
+tests are not using self.capture. If we add tests for the programmatic
+interface later, they will be non blackbox tests.
 """
 
-import os
-
-import bzrlib
-from bzrlib.tests.blackbox import ExternalBase
-
-
-class TestStatus(ExternalBase):
+
+from cStringIO import StringIO
+from os import mkdir, chdir
+from tempfile import TemporaryFile
+import codecs
+
+import bzrlib.branch
+from bzrlib.builtins import merge
+import bzrlib.bzrdir as bzrdir
+from bzrlib.osutils import pathjoin
+from bzrlib.revisionspec import RevisionSpec
+from bzrlib.status import show_tree_status
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.workingtree import WorkingTree
+
+
+class BranchStatus(TestCaseWithTransport):
+    
+    def test_branch_status(self): 
+        """Test basic branch status"""
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+
+        # status with nothing
+        tof = StringIO()
+        show_tree_status(wt, to_file=tof)
+        self.assertEquals(tof.getvalue(), "")
+
+        tof = StringIO()
+        self.build_tree(['hello.c', 'bye.c'])
+        wt.add_pending_merge('pending@pending-0-0')
+        show_tree_status(wt, to_file=tof)
+        tof.seek(0)
+        self.assertEquals(tof.readlines(),
+                          ['unknown:\n',
+                           '  bye.c\n',
+                           '  hello.c\n',
+                           'pending merges:\n',
+                           '  pending@pending-0-0\n'
+                           ])
+
+    def test_branch_status_revisions(self):
+        """Tests branch status with revisions"""
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+
+        tof = StringIO()
+        self.build_tree(['hello.c', 'bye.c'])
+        wt.add('hello.c')
+        wt.add('bye.c')
+        wt.commit('Test message')
+
+        tof = StringIO()
+        revs =[]
+        revs.append(RevisionSpec(0))
+        
+        show_tree_status(wt, to_file=tof, revision=revs)
+        
+        tof.seek(0)
+        self.assertEquals(tof.readlines(),
+                          ['added:\n',
+                           '  bye.c\n',
+                           '  hello.c\n'])
+
+        self.build_tree(['more.c'])
+        wt.add('more.c')
+        wt.commit('Another test message')
+        
+        tof = StringIO()
+        revs.append(RevisionSpec(1))
+        
+        show_tree_status(wt, to_file=tof, revision=revs)
+        
+        tof.seek(0)
+        self.assertEquals(tof.readlines(),
+                          ['added:\n',
+                           '  bye.c\n',
+                           '  hello.c\n'])
+
+    def status_string(self, wt):
+        # use a real file rather than StringIO because it doesn't handle
+        # Unicode very well.
+        tof = codecs.getwriter('utf-8')(TemporaryFile())
+        show_tree_status(wt, to_file=tof)
+        tof.seek(0)
+        return tof.read().decode('utf-8')
+
+    def test_pending(self):
+        """Pending merges display works, including Unicode"""
+        mkdir("./branch")
+        wt = self.make_branch_and_tree('branch')
+        b = wt.branch
+        wt.commit("Empty commit 1")
+        b_2_dir = b.bzrdir.sprout('./copy')
+        b_2 = b_2_dir.open_branch()
+        wt2 = b_2_dir.open_workingtree()
+        wt.commit(u"\N{TIBETAN DIGIT TWO} Empty commit 2")
+        merge(["./branch", -1], [None, None], this_dir = './copy')
+        message = self.status_string(wt2)
+        self.assert_(message.startswith("pending merges:\n"))
+        self.assert_(message.endswith("Empty commit 2\n")) 
+        wt2.commit("merged")
+        # must be long to make sure we see elipsis at the end
+        wt.commit("Empty commit 3 " + 
+                   "blah blah blah blah " * 10)
+        merge(["./branch", -1], [None, None], this_dir = './copy')
+        message = self.status_string(wt2)
+        self.assert_(message.startswith("pending merges:\n"))
+        self.assert_("Empty commit 3" in message)
+        self.assert_(message.endswith("...\n")) 
+
+    def test_branch_status_specific_files(self): 
+        """Tests branch status with given specific files"""
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+
+        self.build_tree(['directory/','directory/hello.c', 'bye.c','test.c','dir2/'])
+        wt.add('directory')
+        wt.add('test.c')
+        wt.commit('testing')
+        
+        tof = StringIO()
+        show_tree_status(wt, to_file=tof)
+        tof.seek(0)
+        self.assertEquals(tof.readlines(),
+                          ['unknown:\n',
+                           '  bye.c\n',
+                           '  dir2\n',
+                           '  directory/hello.c\n'
+                           ])
+
+        tof = StringIO()
+        show_tree_status(wt, specific_files=['bye.c','test.c','absent.c'], 
+                         to_file=tof)
+        tof.seek(0)
+        self.assertEquals(tof.readlines(),
+                          ['unknown:\n',
+                           '  bye.c\n'
+                           ])
+        
+        tof = StringIO()
+        show_tree_status(wt, specific_files=['directory'], to_file=tof)
+        tof.seek(0)
+        self.assertEquals(tof.readlines(),
+                          ['unknown:\n',
+                           '  directory/hello.c\n'
+                           ])
+        tof = StringIO()
+        show_tree_status(wt, specific_files=['dir2'], to_file=tof)
+        tof.seek(0)
+        self.assertEquals(tof.readlines(),
+                          ['unknown:\n',
+                           '  dir2\n'
+                           ])
+
+class CheckoutStatus(BranchStatus):
+
+    def setUp(self):
+        super(CheckoutStatus, self).setUp()
+        mkdir('codir')
+        chdir('codir')
+        
+    def make_branch_and_tree(self, relpath):
+        source = self.make_branch(pathjoin('..', relpath))
+        checkout = bzrdir.BzrDirMetaFormat1().initialize(relpath)
+        bzrlib.branch.BranchReferenceFormat().initialize(checkout, source)
+        return checkout.create_workingtree()
+
+
+class TestStatus(TestCaseWithTransport):
 
     def test_status(self):
-        self.runbzr("init")
+        self.run_bzr("init")
         self.build_tree(['hello.txt'])
-        result = self.runbzr("status")
+        result = self.run_bzr("status")[0]
         self.assert_("unknown:\n  hello.txt\n" in result, result)
-        self.runbzr("add hello.txt")
-        result = self.runbzr("status")
+        self.run_bzr("add", "hello.txt")
+        result = self.run_bzr("status")[0]
         self.assert_("added:\n  hello.txt\n" in result, result)
-        self.runbzr("commit -m added")
-        result = self.runbzr("status -r 0..1")
+        self.run_bzr("commit", "-m", "added")
+        result = self.run_bzr("status", "-r", "0..1")[0]
         self.assert_("added:\n  hello.txt\n" in result, result)
         self.build_tree(['world.txt'])
-        result = self.runbzr("status -r 0")
+        result = self.run_bzr("status", "-r", "0")[0]
         self.assert_("added:\n  hello.txt\n" \
                      "unknown:\n  world.txt\n" in result, result)
 
-        result2 = self.runbzr("status -r 0..")
+        result2 = self.run_bzr("status", "-r", "0..")[0]
         self.assertEquals(result2, result)
+
+

=== modified file 'bzrlib/tests/blackbox/test_too_much.py'
--- bzrlib/tests/blackbox/test_too_much.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/blackbox/test_too_much.py	2006-03-20 08:31:00 +0000
@@ -41,21 +41,17 @@
 import sys
 
 from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
+import bzrlib.bzrdir as bzrdir
 from bzrlib.errors import BzrCommandError
 from bzrlib.osutils import has_symlinks, pathjoin
 from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
+from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.tests.blackbox import ExternalBase
+from bzrlib.workingtree import WorkingTree
+
 
 class TestCommands(ExternalBase):
 
-    def test_help_commands(self):
-        self.runbzr('--help')
-        self.runbzr('help')
-        self.runbzr('help commands')
-        self.runbzr('help help')
-        self.runbzr('commit -h')
-
     def test_init_branch(self):
         self.runbzr(['init'])
 
@@ -115,25 +111,11 @@
         nick = self.runbzr("nick",backtick=True)
         self.assertEqual(nick, 'moo\n')
 
-
     def test_invalid_commands(self):
         self.runbzr("pants", retcode=3)
         self.runbzr("--pants off", retcode=3)
         self.runbzr("diff --message foo", retcode=3)
 
-    def test_empty_commit(self):
-        self.runbzr("init")
-        self.build_tree(['hello.txt'])
-        self.runbzr("commit -m empty", retcode=3)
-        self.runbzr("add hello.txt")
-        self.runbzr("commit -m added")       
-
-    def test_empty_commit_message(self):
-        self.runbzr("init")
-        file('foo.c', 'wt').write('int main() {}')
-        self.runbzr(['add', 'foo.c'])
-        self.runbzr(["commit", "-m", ""] , retcode=3) 
-
     def test_remove_deleted(self):
         self.runbzr("init")
         self.build_tree(['a'])
@@ -142,29 +124,8 @@
         os.unlink('a')
         self.runbzr(['remove', 'a'])
 
-    def test_other_branch_commit(self):
-        # this branch is to ensure consistent behaviour, whether we're run
-        # inside a branch, or not.
-        os.mkdir('empty_branch')
-        os.chdir('empty_branch')
-        self.runbzr('init')
-        os.mkdir('branch')
-        os.chdir('branch')
-        self.runbzr('init')
-        file('foo.c', 'wt').write('int main() {}')
-        file('bar.c', 'wt').write('int main() {}')
-        os.chdir('..')
-        self.runbzr(['add', 'branch/foo.c'])
-        self.runbzr(['add', 'branch'])
-        # can't commit files in different trees; sane error
-        self.runbzr('commit -m newstuff branch/foo.c .', retcode=3)
-        self.runbzr('commit -m newstuff branch/foo.c')
-        self.runbzr('commit -m newstuff branch')
-        self.runbzr('commit -m newstuff branch', retcode=3)
-
     def test_ignore_patterns(self):
-        from bzrlib.branch import Branch
-        Branch.initialize('.')
+        self.runbzr('init')
         self.assertEquals(self.capture('unknowns'), '')
 
         file('foo.tmp', 'wt').write('tmp files are ignored')
@@ -242,8 +203,7 @@
 
     def test_mv_modes(self):
         """Test two modes of operation for mv"""
-        from bzrlib.branch import Branch
-        b = Branch.initialize('.')
+        self.runbzr('init')
         self.build_tree(['a', 'c', 'subdir/'])
         self.run_bzr_captured(['add', self.test_dir])
         self.run_bzr_captured(['mv', 'a', 'b'])
@@ -329,50 +289,6 @@
         zf = ZipFile('../first-zip')
         self.assert_('first-zip/hello' in zf.namelist(), zf.namelist())
 
-    def test_diff(self):
-        self.example_branch()
-        file('hello', 'wt').write('hello world!')
-        self.runbzr('commit -m fixing hello')
-        output = self.runbzr('diff -r 2..3', backtick=1, retcode=1)
-        self.assert_('\n+hello world!' in output)
-        output = self.runbzr('diff -r last:3..last:1', backtick=1, retcode=1)
-        self.assert_('\n+baz' in output)
-        file('moo', 'wb').write('moo')
-        self.runbzr('add moo')
-        os.unlink('moo')
-        self.runbzr('diff')
-
-    def test_diff_branches(self):
-        self.build_tree(['branch1/', 'branch1/file', 'branch2/'], line_endings='binary')
-        branch = Branch.initialize('branch1')
-        branch.working_tree().add(['file'])
-        branch.working_tree().commit('add file')
-        copy_branch(branch, 'branch2')
-        print >> open('branch2/file', 'wb'), 'new content'
-        branch2 = Branch.open('branch2')
-        branch2.working_tree().commit('update file')
-        # should open branch1 and diff against branch2, 
-        output = self.run_bzr_captured(['diff', '-r', 'branch:branch2', 
-                                        'branch1'],
-                                       retcode=1)
-        self.assertEquals(("=== modified file 'file'\n"
-                           "--- file\t\n"
-                           "+++ file\t\n"
-                           "@@ -1,1 +1,1 @@\n"
-                           "-new content\n"
-                           "+contents of branch1/file\n"
-                           "\n", ''), output)
-        output = self.run_bzr_captured(['diff', 'branch2', 'branch1'],
-                                       retcode=1)
-        self.assertEqualDiff(("=== modified file 'file'\n"
-                              "--- file\t\n"
-                              "+++ file\t\n"
-                              "@@ -1,1 +1,1 @@\n"
-                              "-new content\n"
-                              "+contents of branch1/file\n"
-                              "\n", ''), output)
-
-
     def test_branch(self):
         """Branch from one branch to another."""
         os.mkdir('a')
@@ -385,12 +301,26 @@
         os.chdir('b')
         self.runbzr('commit -m foo --unchanged')
         os.chdir('..')
-        # naughty - abstraction violations RBC 20050928  
-        print "test_branch used to delete the stores, how is this meant to work ?"
-        #shutil.rmtree('a/.bzr/revision-store')
-        #shutil.rmtree('a/.bzr/inventory-store', ignore_errors=True)
-        #shutil.rmtree('a/.bzr/text-store', ignore_errors=True)
-        self.runbzr('branch a d --basis b')
+
+    def test_branch_basis(self):
+        # ensure that basis really does grab from the basis by having incomplete source
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_branch_and_tree('source')
+        # this gives us an incomplete repository
+        tree.bzrdir.open_repository().copy_content_into(source.branch.repository)
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        tree.bzrdir.open_branch().copy_content_into(source.branch)
+        tree.copy_content_into(source)
+        self.assertFalse(source.branch.repository.has_revision('2'))
+        dir = source.bzrdir
+        self.runbzr('branch source target --basis commit_tree')
+        target = bzrdir.BzrDir.open('target')
+        self.assertEqual('2', target.open_branch().last_revision())
+        self.assertEqual('2', target.open_workingtree().last_revision())
+        self.assertTrue(target.open_branch().repository.has_revision('2'))
 
     def test_merge(self):
         from bzrlib.branch import Branch
@@ -420,15 +350,15 @@
         self.runbzr('merge ../b -r last:1')
         self.check_file_contents('goodbye', 'quux')
         # Merging a branch pulls its revision into the tree
-        a = Branch.open('.')
+        a = WorkingTree.open('.')
         b = Branch.open('../b')
-        a.get_revision_xml(b.last_revision())
-        self.log('pending merges: %s', a.working_tree().pending_merges())
-        self.assertEquals(a.working_tree().pending_merges(),
+        a.branch.repository.get_revision_xml(b.last_revision())
+        self.log('pending merges: %s', a.pending_merges())
+        self.assertEquals(a.pending_merges(),
                           [b.last_revision()])
         self.runbzr('commit -m merged')
         self.runbzr('merge ../b -r last:1')
-        self.assertEqual(Branch.open('.').working_tree().pending_merges(), [])
+        self.assertEqual(a.pending_merges(), [])
 
     def test_merge_with_missing_file(self):
         """Merge handles missing file conflicts"""
@@ -581,6 +511,13 @@
                   'subdir/b\n'
                   , '--versioned')
 
+    def test_cat(self):
+        self.runbzr('init')
+        file("myfile", "wb").write("My contents\n")
+        self.runbzr('add')
+        self.runbzr('commit -m myfile')
+        self.run_bzr_captured('cat -r 1 myfile'.split(' '))
+
     def test_pull_verbose(self):
         """Pull changes from one branch to another and watch the output."""
 
@@ -653,7 +590,7 @@
         
     def test_add_reports(self):
         """add command prints the names of added files."""
-        b = Branch.initialize('.')
+        self.runbzr('init')
         self.build_tree(['top.txt', 'dir/', 'dir/sub.txt', 'CVS'])
         out = self.run_bzr_captured(['add'], retcode=0)[0]
         # the ordering is not defined at the moment
@@ -674,7 +611,7 @@
 
     def test_add_quiet_is(self):
         """add -q does not print the names of added files."""
-        b = Branch.initialize('.')
+        self.runbzr('init')
         self.build_tree(['top.txt', 'dir/', 'dir/sub.txt'])
         out = self.run_bzr_captured(['add', '-q'], retcode=0)[0]
         # the ordering is not defined at the moment
@@ -686,8 +623,7 @@
 
         "bzr add" should add the parent(s) as necessary.
         """
-        from bzrlib.branch import Branch
-        Branch.initialize('.')
+        self.runbzr('init')
         self.build_tree(['inertiatic/', 'inertiatic/esp'])
         self.assertEquals(self.capture('unknowns'), 'inertiatic\n')
         self.run_bzr('add', 'inertiatic/esp')
@@ -710,8 +646,7 @@
 
         "bzr add" should do this happily.
         """
-        from bzrlib.branch import Branch
-        Branch.initialize('.')
+        self.runbzr('init')
         self.build_tree(['inertiatic/', 'inertiatic/esp'])
         self.assertEquals(self.capture('unknowns'), 'inertiatic\n')
         self.run_bzr('add', '--no-recurse', 'inertiatic')
@@ -721,14 +656,14 @@
 
     def test_subdir_add(self):
         """Add in subdirectory should add only things from there down"""
-        from bzrlib.branch import Branch
+        from bzrlib.workingtree import WorkingTree
         
         eq = self.assertEqual
         ass = self.assert_
         chdir = os.chdir
         
-        b = Branch.initialize('.')
-        t = b.working_tree()
+        t = self.make_branch_and_tree('.')
+        b = t.branch
         self.build_tree(['src/', 'README'])
         
         eq(sorted(t.unknowns()),
@@ -790,8 +725,11 @@
         assert '|||||||' not in conflict_text
         assert 'hi world' not in conflict_text
         os.unlink('hello.OTHER')
+        os.unlink('question.OTHER')
+        self.runbzr('remerge jello --merge-type weave', retcode=3)
         self.runbzr('remerge hello --merge-type weave', retcode=1)
         assert os.path.exists('hello.OTHER')
+        self.assertIs(False, os.path.exists('question.OTHER'))
         file_id = self.runbzr('file-id hello')
         file_id = self.runbzr('file-id hello.THIS', retcode=3)
         self.runbzr('remerge --merge-type weave', retcode=1)
@@ -808,6 +746,21 @@
         self.runbzr('commit -m done',)
         self.runbzr('remerge', retcode=3)
 
+    def test_status(self):
+        os.mkdir('branch1')
+        os.chdir('branch1')
+        self.runbzr('init')
+        self.runbzr('commit --unchanged --message f')
+        self.runbzr('branch . ../branch2')
+        self.runbzr('branch . ../branch3')
+        self.runbzr('commit --unchanged --message peter')
+        os.chdir('../branch2')
+        self.runbzr('merge ../branch1')
+        self.runbzr('commit --unchanged --message pumpkin')
+        os.chdir('../branch3')
+        self.runbzr('merge ../branch2')
+        message = self.capture('status')
+
 
     def test_conflicts(self):
         """Handling of merge conflicts"""
@@ -838,43 +791,6 @@
         self.runbzr('commit -m conflicts')
         self.assertEquals(result, "")
 
-    def test_resign(self):
-        """Test re signing of data."""
-        import bzrlib.gpg
-        oldstrategy = bzrlib.gpg.GPGStrategy
-        branch = Branch.initialize('.')
-        branch.working_tree().commit("base", allow_pointless=True, rev_id='A')
-        try:
-            # monkey patch gpg signing mechanism
-            from bzrlib.testament import Testament
-            bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
-            self.runbzr('re-sign -r revid:A')
-            self.assertEqual(Testament.from_revision(branch,'A').as_short_text(),
-                             branch.revision_store.get('A', 'sig').read())
-        finally:
-            bzrlib.gpg.GPGStrategy = oldstrategy
-            
-    def test_resign_range(self):
-        import bzrlib.gpg
-        oldstrategy = bzrlib.gpg.GPGStrategy
-        branch = Branch.initialize('.')
-        branch.working_tree().commit("base", allow_pointless=True, rev_id='A')
-        branch.working_tree().commit("base", allow_pointless=True, rev_id='B')
-        branch.working_tree().commit("base", allow_pointless=True, rev_id='C')
-        try:
-            # monkey patch gpg signing mechanism
-            from bzrlib.testament import Testament
-            bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
-            self.runbzr('re-sign -r 1..')
-            self.assertEqual(Testament.from_revision(branch,'A').as_short_text(),
-                             branch.revision_store.get('A', 'sig').read())
-            self.assertEqual(Testament.from_revision(branch,'B').as_short_text(),
-                             branch.revision_store.get('B', 'sig').read())
-            self.assertEqual(Testament.from_revision(branch,'C').as_short_text(),
-                             branch.revision_store.get('C', 'sig').read())
-        finally:
-            bzrlib.gpg.GPGStrategy = oldstrategy
-
     def test_push(self):
         # create a source branch
         os.mkdir('my-branch')
@@ -921,19 +837,17 @@
         self.runbzr('missing ../missing/new-branch')
 
     def test_external_command(self):
-        """test that external commands can be run by setting the path"""
+        """Test that external commands can be run by setting the path
+        """
+        # We don't at present run bzr in a subprocess for blackbox tests, and so 
+        # don't really capture stdout, only the internal python stream.
+        # Therefore we don't use a subcommand that produces any output or does
+        # anything -- we just check that it can be run successfully.  
         cmd_name = 'test-command'
-        output = 'Hello from test-command'
         if sys.platform == 'win32':
             cmd_name += '.bat'
-            output += '\r\n'
-        else:
-            output += '\n'
-
         oldpath = os.environ.get('BZRPATH', None)
-
         bzr = self.capture
-
         try:
             if os.environ.has_key('BZRPATH'):
                 del os.environ['BZRPATH']
@@ -943,7 +857,7 @@
                 f.write('@echo off\n')
             else:
                 f.write('#!/bin/sh\n')
-            f.write('echo Hello from test-command')
+            # f.write('echo Hello from test-command')
             f.close()
             os.chmod(cmd_name, 0755)
 
@@ -955,11 +869,6 @@
             os.environ['BZRPATH'] = '.'
 
             bzr(cmd_name)
-            # The test suite does not capture stdout for external commands
-            # this is because you have to have a real file object
-            # to pass to Popen(stdout=FOO), and StringIO is not one of those.
-            # (just replacing sys.stdout does not change a spawned objects stdout)
-            #self.assertEquals(bzr(cmd_name), output)
 
             # Make sure empty path elements are ignored
             os.environ['BZRPATH'] = os.pathsep
@@ -1250,31 +1159,70 @@
             progress("skipping symlink tests")
 
 
-class HttpTests(TestCaseWithWebserver):
+class RemoteTests(object):
     """Test bzr ui commands against remote branches."""
 
     def test_branch(self):
         os.mkdir('from')
-        branch = Branch.initialize('from')
-        branch.working_tree().commit('empty commit for nonsense', allow_pointless=True)
-        url = self.get_remote_url('from')
+        wt = self.make_branch_and_tree('from')
+        branch = wt.branch
+        wt.commit('empty commit for nonsense', allow_pointless=True)
+        url = self.get_readonly_url('from')
         self.run_bzr('branch', url, 'to')
         branch = Branch.open('to')
         self.assertEqual(1, len(branch.revision_history()))
+        # the branch should be set in to to from
+        self.assertEqual(url + '/', branch.get_parent())
 
     def test_log(self):
         self.build_tree(['branch/', 'branch/file'])
-        branch = Branch.initialize('branch')
-        branch.working_tree().add(['file'])
-        branch.working_tree().commit('add file', rev_id='A')
-        url = self.get_remote_url('branch/file')
+        self.capture('init branch')
+        self.capture('add branch/file')
+        self.capture('commit -m foo branch')
+        url = self.get_readonly_url('branch/file')
         output = self.capture('log %s' % url)
         self.assertEqual(8, len(output.split('\n')))
         
     def test_check(self):
         self.build_tree(['branch/', 'branch/file'])
-        branch = Branch.initialize('branch')
-        branch.working_tree().add(['file'])
-        branch.working_tree().commit('add file', rev_id='A')
-        url = self.get_remote_url('branch/')
+        self.capture('init branch')
+        self.capture('add branch/file')
+        self.capture('commit -m foo branch')
+        url = self.get_readonly_url('branch/')
         self.run_bzr('check', url)
+    
+    def test_push(self):
+        # create a source branch
+        os.mkdir('my-branch')
+        os.chdir('my-branch')
+        self.run_bzr('init')
+        file('hello', 'wt').write('foo')
+        self.run_bzr('add', 'hello')
+        self.run_bzr('commit', '-m', 'setup')
+
+        # with an explicit target work
+        self.run_bzr('push', self.get_url('output-branch'))
+
+    
+class HTTPTests(TestCaseWithWebserver, RemoteTests):
+    """Test various commands against a HTTP server."""
+    
+    
+class SFTPTestsAbsolute(TestCaseWithSFTPServer, RemoteTests):
+    """Test various commands against a SFTP server using abs paths."""
+
+    
+class SFTPTestsAbsoluteSibling(TestCaseWithSFTPServer, RemoteTests):
+    """Test various commands against a SFTP server using abs paths."""
+
+    def setUp(self):
+        super(SFTPTestsAbsoluteSibling, self).setUp()
+        self._override_home = '/dev/noone/runs/tests/here'
+
+    
+class SFTPTestsRelative(TestCaseWithSFTPServer, RemoteTests):
+    """Test various commands against a SFTP server using homedir rel paths."""
+
+    def setUp(self):
+        super(SFTPTestsRelative, self).setUp()
+        self._get_remote_is_absolute = False

=== added file 'bzrlib/tests/blackbox/test_update.py'
--- bzrlib/tests/blackbox/test_update.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_update.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,132 @@
+# Copyright (C) 2006 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests for the update command of bzr."""
+
+
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.blackbox import ExternalBase
+from bzrlib.workingtree import WorkingTree
+
+
+class TestUpdate(ExternalBase):
+
+    def test_update_standalone_trivial(self):
+        self.runbzr("init")
+        out, err = self.runbzr('update')
+        self.assertEqual('Tree is up to date.\n', err)
+        self.assertEqual('', out)
+
+    def test_update_up_to_date_light_checkout(self):
+        self.make_branch_and_tree('branch')
+        self.runbzr('checkout --lightweight branch checkout')
+        out, err = self.runbzr('update checkout')
+        self.assertEqual('Tree is up to date.\n', err)
+        self.assertEqual('', out)
+
+    def test_update_out_of_date_standalone_tree(self):
+        # FIXME the default format has to change for this to pass
+        # because it currently uses the branch last-revision marker.
+        raise TestSkipped('default format too old')
+        self.make_branch_and_tree('branch')
+        # make a checkout
+        self.runbzr('checkout --lightweight branch checkout')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        # now branch should be out of date
+        out,err = self.runbzr('update branch')
+        self.assertEqual('Updated to revision 1.\n', out)
+        self.assertEqual('', err)
+        self.failUnlessExists('branch/file')
+
+    def test_update_out_of_date_light_checkout(self):
+        self.make_branch_and_tree('branch')
+        # make two checkouts
+        self.runbzr('checkout --lightweight branch checkout')
+        self.runbzr('checkout --lightweight branch checkout2')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        # now checkout2 should be out of date
+        out,err = self.runbzr('update checkout2')
+        self.assertEqual('All changes applied successfully.\n'
+                         'Updated to revision 1.\n',
+                         err)
+        self.assertEqual('', out)
+
+    def test_update_conflicts_returns_2(self):
+        self.make_branch_and_tree('branch')
+        # make two checkouts
+        self.runbzr('checkout --lightweight branch checkout')
+        self.build_tree(['checkout/file'])
+        self.runbzr('add checkout/file')
+        self.runbzr('commit -m add-file checkout')
+        self.runbzr('checkout --lightweight branch checkout2')
+        # now alter file in checkout
+        a_file = file('checkout/file', 'wt')
+        a_file.write('Foo')
+        a_file.close()
+        self.runbzr('commit -m checnge-file checkout')
+        # now checkout2 should be out of date
+        # make a local change to file
+        a_file = file('checkout2/file', 'wt')
+        a_file.write('Bar')
+        a_file.close()
+        out,err = self.runbzr('update checkout2', retcode=1)
+        self.assertEqual(['1 conflicts encountered.',
+                          'Updated to revision 2.'],
+                         err.split('\n')[1:3])
+        self.assertContainsRe(err, 'Text conflict in file\n')
+        self.assertEqual('', out)
+
+    def test_smoke_update_checkout_bound_branch_local_commits(self):
+        # smoke test for doing an update of a checkout of a bound
+        # branch with local commits.
+        self.make_branch_and_tree('master')
+        # make a bound branch
+        self.run_bzr('checkout', 'master', 'child')
+        # check that out
+        self.run_bzr('checkout', '--lightweight', 'child', 'checkout')
+        # change master
+        a_file = file('master/file', 'wt')
+        a_file.write('Foo')
+        a_file.close()
+        self.run_bzr('add', 'master')
+        self.run_bzr('commit', '-m', 'add file', 'master')
+        # change child
+        a_file = file('child/file_b', 'wt')
+        a_file.write('Foo')
+        a_file.close()
+        self.run_bzr('add', 'child')
+        self.run_bzr('commit', '--local', '-m', 'add file_b', 'child')
+        # check checkout
+        a_file = file('checkout/file_c', 'wt')
+        a_file.write('Foo')
+        a_file.close()
+        self.run_bzr('add', 'checkout')
+
+        # now, update checkout ->
+        # get all three files and a pending merge.
+        self.run_bzr('update', 'checkout')
+        wt = WorkingTree.open('checkout')
+        self.assertNotEqual([], wt.pending_merges())
+        self.failUnlessExists('checkout/file')
+        self.failUnlessExists('checkout/file_b')
+        self.failUnlessExists('checkout/file_c')
+        self.assertTrue(wt.has_filename('file_c'))

=== added file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,147 @@
+# Copyright (C) 2006 by Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Black box tests for the upgrade ui."""
+
+import os
+
+import bzrlib.bzrdir as bzrdir
+import bzrlib.repository as repository
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tests.blackbox import TestUIFactory
+from bzrlib.transport import get_transport
+import bzrlib.ui as ui
+
+
+class TestWithUpgradableBranches(TestCaseWithTransport):
+
+    def setUp(self):
+        super(TestWithUpgradableBranches, self).setUp()
+        self.old_format = bzrdir.BzrDirFormat.get_default_format()
+        self.old_ui_factory = ui.ui_factory
+        self.addCleanup(self.restoreDefaults)
+
+        ui.ui_factory = TestUIFactory()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        # FIXME RBC 20060120 we should be able to do this via ui calls only.
+        # setup a format 5 branch we can upgrade from.
+        t = get_transport(self.get_url())
+        t.mkdir('format_5_branch')
+        bzrdir.BzrDirFormat5().initialize(self.get_url('format_5_branch'))
+        bzrdir.BzrDir.create_standalone_workingtree('current_format_branch')
+        d = bzrdir.BzrDir.create('metadir_weave_branch')
+        d.create_repository()
+        d.create_branch()
+        d.create_workingtree()
+        self.run_bzr('checkout',
+                     '--lightweight',
+                     self.get_url('current_format_branch'),
+                     'current_format_checkout')
+
+    def restoreDefaults(self):
+        bzrdir.BzrDirFormat.set_default_format(self.old_format)
+        ui.ui_factory = self.old_ui_factory
+
+    def test_readonly_url_error(self):
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', self.get_readonly_url('format_5_branch')], 3)
+        self.assertEqual(out, "")
+        self.assertEqual(err, "bzr: ERROR: Upgrade URL cannot work with readonly URL's.\n")
+
+    def test_upgrade_up_to_date(self):
+        # when up to date we should get a message to that effect
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', 'current_format_branch'], 3)
+        self.assertEqual("", out)
+        self.assertEqualDiff("bzr: ERROR: The branch format Bazaar-NG meta "
+                             "directory, format 1 is already at the most "
+                             "recent format.\n", err)
+
+    def test_upgrade_up_to_date_checkout_warns_branch_left_alone(self):
+        # when upgrading a checkout, the branch location and a suggestion
+        # to upgrade it should be emitted even if the checkout is up to 
+        # date
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', 'current_format_checkout'], 3)
+        self.assertEqual("This is a checkout. The branch (%s) needs to be "
+                         "upgraded separately.\n" 
+                         % get_transport(self.get_url('current_format_branch')).base,
+                         out)
+        self.assertEqualDiff("bzr: ERROR: The branch format Bazaar-NG meta "
+                             "directory, format 1 is already at the most "
+                             "recent format.\n", err)
+
+    def test_upgrade_checkout(self):
+        # upgrading a checkout should work
+        pass
+
+    def test_upgrade_repository_scans_branches(self):
+        # we should get individual upgrade notes for each branch even the 
+        # anonymous branch
+        pass
+
+    def test_ugrade_branch_in_repo(self):
+        # upgrading a branch in a repo should warn about not upgrading the repo
+        pass
+
+    def test_upgrade_explicit_metaformat(self):
+        # users can force an upgrade to metadir format.
+        url = get_transport(self.get_url('format_5_branch')).base
+        # check --format takes effect
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirFormat5())
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', '--format=metadir', url])
+        self.assertEqualDiff("""starting upgrade of %s
+making backup of tree history
+%s.bzr has been backed up to %s.bzr.backup
+if conversion fails, you can move this directory back to .bzr
+if it succeeds, you can remove this directory if you wish
+starting upgrade from format 5 to 6
+adding prefixes to weaves
+adding prefixes to revision-store
+starting upgrade from format 6 to metadir
+finished
+""" % (url, url, url), out)
+        self.assertEqualDiff("", err)
+        self.assertTrue(isinstance(
+            bzrdir.BzrDir.open(self.get_url('format_5_branch'))._format,
+            bzrdir.BzrDirMetaFormat1))
+
+    def test_upgrade_explicit_knit(self):
+        # users can force an upgrade to knit format from a metadir weave 
+        # branch
+        url = get_transport(self.get_url('metadir_weave_branch')).base
+        # check --format takes effect
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirFormat5())
+        (out, err) = self.run_bzr_captured(
+            ['upgrade', '--format=knit', url])
+        self.assertEqualDiff("""starting upgrade of %s
+making backup of tree history
+%s.bzr has been backed up to %s.bzr.backup
+if conversion fails, you can move this directory back to .bzr
+if it succeeds, you can remove this directory if you wish
+starting repository conversion
+repository converted
+finished
+""" % (url, url, url), out)
+        self.assertEqualDiff("", err)
+        converted_dir = bzrdir.BzrDir.open(self.get_url('metadir_weave_branch'))
+        self.assertTrue(isinstance(converted_dir._format,
+                                   bzrdir.BzrDirMetaFormat1))
+        self.assertTrue(isinstance(converted_dir.open_repository()._format,
+                                   repository.RepositoryFormatKnit1))

=== modified file 'bzrlib/tests/blackbox/test_versioning.py'
--- bzrlib/tests/blackbox/test_versioning.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/blackbox/test_versioning.py	2006-03-20 08:31:00 +0000
@@ -26,6 +26,7 @@
 from bzrlib.branch import Branch
 from bzrlib.trace import mutter
 from bzrlib.osutils import pathjoin
+from bzrlib.workingtree import WorkingTree
 
 
 class TestVersioning(TestCaseInTempDir):
@@ -40,10 +41,9 @@
         self.run_bzr('mkdir', 'foo', retcode=3)
 
         from bzrlib.diff import compare_trees
-        from bzrlib.branch import Branch
-        b = Branch.open(u'.')
+        wt = WorkingTree.open('.')
         
-        delta = compare_trees(b.basis_tree(), b.working_tree())
+        delta = compare_trees(wt.basis_tree(), wt)
 
         self.log('delta.added = %r' % delta.added)
 
@@ -65,10 +65,9 @@
         os.chdir('..')
 
         from bzrlib.diff import compare_trees
-        from bzrlib.branch import Branch
-        b = Branch.open(u'.')
+        wt = WorkingTree.open('.')
         
-        delta = compare_trees(b.basis_tree(), b.working_tree())
+        delta = compare_trees(wt.basis_tree(), wt)
 
         self.log('delta.added = %r' % delta.added)
 
@@ -95,45 +94,24 @@
         self.failUnless(os.path.isdir('a/b/dir'))
 
         from bzrlib.diff import compare_trees
-        b = Branch.open(u'.')
-        b_a = Branch.open('a')
-        b_b = Branch.open('a/b')
-        
-        delta = compare_trees(b.basis_tree(), b.working_tree())
-        self.assertEquals(len(delta.added), 1)
-        self.assertEquals(delta.added[0][0], 'dir')
-        self.failIf(delta.modified)
-
-        delta = compare_trees(b_a.basis_tree(), b_a.working_tree())
-        self.assertEquals(len(delta.added), 1)
-        self.assertEquals(delta.added[0][0], 'dir')
-        self.failIf(delta.modified)
-
-        delta = compare_trees(b_b.basis_tree(), b_b.working_tree())
-        self.assertEquals(len(delta.added), 1)
-        self.assertEquals(delta.added[0][0], 'dir')
-        self.failIf(delta.modified)
-
-    def test_working_tree_add_in_unversioned(self):
-        """Try to add a file in an unversioned directory.
-
-        "bzr add" adds the parent as necessary, but simple working tree add
-        doesn't do that.
-        """
-        from bzrlib.branch import Branch
-        from bzrlib.errors import NotVersionedError
-        from bzrlib.workingtree import WorkingTree
-
-        b = Branch.initialize(u'.')
-
-        self.build_tree(['foo/',
-                         'foo/hello'])
-
-        self.assertRaises(NotVersionedError,
-                          WorkingTree(b.base, b).add,
-                          'foo/hello')
-        
-        self.check_branch()
+        wt = WorkingTree.open('.')
+        wt_a = WorkingTree.open('a')
+        wt_b = WorkingTree.open('a/b')
+        
+        delta = compare_trees(wt.basis_tree(), wt)
+        self.assertEquals(len(delta.added), 1)
+        self.assertEquals(delta.added[0][0], 'dir')
+        self.failIf(delta.modified)
+
+        delta = compare_trees(wt_a.basis_tree(), wt_a)
+        self.assertEquals(len(delta.added), 1)
+        self.assertEquals(delta.added[0][0], 'dir')
+        self.failIf(delta.modified)
+
+        delta = compare_trees(wt_b.basis_tree(), wt_b)
+        self.assertEquals(len(delta.added), 1)
+        self.assertEquals(delta.added[0][0], 'dir')
+        self.failIf(delta.modified)
 
     def check_branch(self):
         """After all the above changes, run the check and upgrade commands.
@@ -171,8 +149,8 @@
         mutter('start selective subdir commit')
         run_bzr('commit', 'a', '-m', 'commit a only')
         
-        old = b.revision_tree(b.get_rev_id(1))
-        new = b.revision_tree(b.get_rev_id(2))
+        old = b.repository.revision_tree(b.get_rev_id(1))
+        new = b.repository.revision_tree(b.get_rev_id(2))
         
         eq(new.get_file_by_path('b/two').read(), 'old contents')
         eq(new.get_file_by_path('top').read(), 'old contents')
@@ -181,14 +159,14 @@
         os.chdir('a')
         # commit from here should do nothing
         run_bzr('commit', '.', '-m', 'commit subdir only', '--unchanged')
-        v3 = b.revision_tree(b.get_rev_id(3))
+        v3 = b.repository.revision_tree(b.get_rev_id(3))
         eq(v3.get_file_by_path('b/two').read(), 'old contents')
         eq(v3.get_file_by_path('top').read(), 'old contents')
         eq(v3.get_file_by_path('a/one').read(), 'new contents')
                 
         # commit in subdirectory commits whole tree
         run_bzr('commit', '-m', 'commit whole tree from subdir')
-        v4 = b.revision_tree(b.get_rev_id(4))
+        v4 = b.repository.revision_tree(b.get_rev_id(4))
         eq(v4.get_file_by_path('b/two').read(), 'new contents')        
         eq(v4.get_file_by_path('top').read(), 'new contents')
         

=== added directory 'bzrlib/tests/branch_implementations'
=== added file 'bzrlib/tests/branch_implementations/__init__.py'
--- bzrlib/tests/branch_implementations/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,57 @@
+# Copyright (C) 2006 by Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Branch implementation tests for bzr.
+
+These test the conformance of all the branch variations to the expected API.
+Specific tests for individual formats are in the tests/test_branch file 
+rather than in tests/branch_implementations/*.py.
+"""
+
+from bzrlib.branch import (BranchFormat,
+                           BranchTestProviderAdapter,
+                           _legacy_formats,
+                           )
+from bzrlib.tests import (
+                          adapt_modules,
+                          default_transport,
+                          TestLoader,
+                          TestSuite,
+                          )
+
+
+def test_suite():
+    result = TestSuite()
+    test_branch_implementations = [
+        'bzrlib.tests.branch_implementations.test_bound_sftp',
+        'bzrlib.tests.branch_implementations.test_branch',
+        'bzrlib.tests.branch_implementations.test_parent',
+        'bzrlib.tests.branch_implementations.test_permissions',
+        'bzrlib.tests.branch_implementations.test_update',
+        ]
+    adapter = BranchTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        [(format, format._matchingbzrdir) for format in 
+         BranchFormat._formats.values() + _legacy_formats])
+    loader = TestLoader()
+    adapt_modules(test_branch_implementations, adapter, loader, result)
+    return result

=== added file 'bzrlib/tests/branch_implementations/test_bound_sftp.py'
--- bzrlib/tests/branch_implementations/test_bound_sftp.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_bound_sftp.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,366 @@
+# Copyright (C) 2005 Robey Pointer <robey@lag.net>, Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for branches bound to an sftp branch."""
+
+
+import os
+
+
+from bzrlib.branch import Branch
+from bzrlib.bzrdir import (BzrDir,
+                           BzrDirFormat,
+                           BzrDirFormat6,
+                           BzrDirMetaFormat1,
+                           )
+import bzrlib.errors as errors
+from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer, paramiko_loaded
+
+
+class BoundSFTPBranch(TestCaseWithSFTPServer):
+
+    def create_branches(self):
+        self.build_tree(['base/', 'base/a', 'base/b'])
+        old_format = BzrDirFormat.get_default_format()
+        BzrDirFormat.set_default_format(BzrDirMetaFormat1())
+        try:
+            wt_base = BzrDir.create_standalone_workingtree('base')
+        finally:
+            BzrDirFormat.set_default_format(old_format)
+    
+        b_base = wt_base.branch
+
+        wt_base.add('a')
+        wt_base.add('b')
+        wt_base.commit('first', rev_id='r@b-1')
+
+        wt_child = b_base.bzrdir.sprout('child').open_workingtree()
+        self.sftp_base = Branch.open(self.get_url('base'))
+        wt_child.branch.bind(self.sftp_base)
+
+        self.assertEqual(['r@b-1'], b_base.revision_history())
+        self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
+
+        return b_base, wt_child
+
+    def test_simple_binding(self):
+        self.build_tree(['base/', 'base/a', 'base/b', 'child/'])
+        wt_base = BzrDir.create_standalone_workingtree('base')
+
+        wt_base.add('a')
+        wt_base.add('b')
+        wt_base.commit('first', rev_id='r@b-1')
+
+        b_base = wt_base.branch
+        old_format = BzrDirFormat.get_default_format()
+        BzrDirFormat.set_default_format(BzrDirMetaFormat1())
+        try:
+            b_child = BzrDir.create_branch_convenience('child')
+        finally:
+            BzrDirFormat.set_default_format(old_format)
+        self.assertEqual(None, b_child.get_bound_location())
+        self.assertEqual(None, b_child.get_master_branch())
+
+        sftp_b_base = Branch.open(self.get_url('base'))
+        b_child.bind(sftp_b_base)
+        self.assertEqual(sftp_b_base.base, b_child.get_bound_location())
+        # this line is more of a working tree test line, but - what the hey.
+        b_child.bzrdir.open_workingtree().update()
+        self.failUnlessExists('child/a')
+        self.failUnlessExists('child/b')
+
+        b_child.unbind()
+        self.assertEqual(None, b_child.get_bound_location())
+
+    def test_bound_commit(self):
+        b_base, wt_child = self.create_branches()
+
+        open('child/a', 'wb').write('new contents\n')
+        wt_child.commit('modified a', rev_id='r@c-2')
+
+        self.assertEqual(['r@b-1', 'r@c-2'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1', 'r@c-2'], b_base.revision_history())
+
+    def test_bound_fail(self):
+        # Make sure commit fails if out of date.
+        b_base, wt_child = self.create_branches()
+
+        open('base/a', 'wb').write('new base contents\n')
+        b_base.bzrdir.open_workingtree().commit('base', rev_id='r@b-2')
+
+        open('child/b', 'wb').write('new b child contents\n')
+        self.assertRaises(errors.BoundBranchOutOfDate,
+                wt_child.commit, 'child', rev_id='r@c-2')
+
+        sftp_b_base = Branch.open(self.get_url('base'))
+
+        # This is all that cmd_update does
+        wt_child.pull(sftp_b_base, overwrite=False)
+
+        wt_child.commit('child', rev_id='r@c-3')
+
+        self.assertEqual(['r@b-1', 'r@b-2', 'r@c-3'],
+                wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1', 'r@b-2', 'r@c-3'],
+                b_base.revision_history())
+        self.assertEqual(['r@b-1', 'r@b-2', 'r@c-3'],
+                sftp_b_base.revision_history())
+
+    def test_double_binding(self):
+        b_base, wt_child = self.create_branches()
+
+        wt_child2 = wt_child.bzrdir.sprout('child2').open_workingtree()
+
+        wt_child2.branch.bind(wt_child.branch)
+
+        open('child2/a', 'wb').write('new contents\n')
+        self.assertRaises(errors.CommitToDoubleBoundBranch,
+                wt_child2.commit, 'child2', rev_id='r@d-2')
+
+    def test_unbinding(self):
+        from bzrlib.transport import get_transport
+        b_base, wt_child = self.create_branches()
+
+        # TestCaseWithSFTPServer only allows you to connect one time
+        # to the SFTP server. So we have to create a connection and
+        # keep it around, so that it can be reused
+        __unused_t = get_transport(self.get_url('.'))
+
+        wt_base = b_base.bzrdir.open_workingtree()
+        open('base/a', 'wb').write('new base contents\n')
+        wt_base.commit('base', rev_id='r@b-2')
+
+        open('child/b', 'wb').write('new b child contents\n')
+        self.assertRaises(errors.BoundBranchOutOfDate,
+                wt_child.commit, 'child', rev_id='r@c-2')
+        self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
+        wt_child.branch.unbind()
+        wt_child.commit('child', rev_id='r@c-2')
+        self.assertEqual(['r@b-1', 'r@c-2'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1', 'r@b-2'], b_base.revision_history())
+
+        sftp_b_base = Branch.open(self.get_url('base'))
+        self.assertRaises(errors.DivergedBranches,
+                wt_child.branch.bind, sftp_b_base)
+
+    def test_commit_remote_bound(self):
+        # Make sure it is detected if the current base
+        # suddenly is bound when child goes to commit
+        b_base, wt_child = self.create_branches()
+
+        b_base.bzrdir.sprout('newbase')
+
+        sftp_b_base = Branch.open(self.get_url('base'))
+        sftp_b_newbase = Branch.open(self.get_url('newbase'))
+
+        sftp_b_base.bind(sftp_b_newbase)
+
+        open('child/a', 'wb').write('new contents\n')
+        self.assertRaises(errors.CommitToDoubleBoundBranch,
+                wt_child.commit, 'failure', rev_id='r@c-2')
+
+        self.assertEqual(['r@b-1'], b_base.revision_history())
+        self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1'], sftp_b_newbase.revision_history())
+
+    def test_pull_updates_both(self):
+        b_base, wt_child = self.create_branches()
+
+        wt_newchild = b_base.bzrdir.sprout('newchild').open_workingtree()
+        open('newchild/b', 'wb').write('newchild b contents\n')
+        wt_newchild.commit('newchild', rev_id='r@d-2')
+        self.assertEqual(['r@b-1', 'r@d-2'], wt_newchild.branch.revision_history())
+
+        wt_child.pull(wt_newchild.branch)
+        self.assertEqual(['r@b-1', 'r@d-2'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1', 'r@d-2'], b_base.revision_history())
+
+    def test_bind_diverged(self):
+        from bzrlib.builtins import merge
+
+        b_base, wt_child = self.create_branches()
+
+        wt_child.branch.unbind()
+        open('child/a', 'ab').write('child contents\n')
+        wt_child.commit('child', rev_id='r@c-2')
+
+        self.assertEqual(['r@b-1', 'r@c-2'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1'], b_base.revision_history())
+
+        open('base/b', 'ab').write('base contents\n')
+        b_base.bzrdir.open_workingtree().commit('base', rev_id='r@b-2')
+        self.assertEqual(['r@b-1', 'r@b-2'], b_base.revision_history())
+
+        sftp_b_base = Branch.open(self.get_url('base'))
+
+        self.assertRaises(errors.DivergedBranches,
+                wt_child.branch.bind, sftp_b_base)
+
+        # TODO: jam 20051230 merge_inner doesn't set pending merges
+        #       Is this on purpose?
+        #       merge_inner also doesn't fetch any missing revisions
+        #merge_inner(wt_child.branch, sftp_b_base.revision_tree('r@b-2'), 
+        #        wt_child.branch.revision_tree('r@b-1'))
+        # TODO: jam 20051230 merge(..., (None, None), ...) seems to
+        #       cause an infinite loop of some sort. It definitely doesn't
+        #       work, you have to use list notation
+        merge((sftp_b_base.base, 2), [None, None], this_dir=wt_child.branch.base)
+
+        self.assertEqual(['r@b-2'], wt_child.pending_merges())
+        wt_child.commit('merged', rev_id='r@c-3')
+
+        # After a merge, trying to bind again should succeed
+        # by pushing the new change to base
+        wt_child.branch.bind(sftp_b_base)
+
+        self.assertEqual(['r@b-1', 'r@b-2', 'r@c-3'],
+                b_base.revision_history())
+        self.assertEqual(['r@b-1', 'r@b-2', 'r@c-3'],
+                wt_child.branch.revision_history())
+
+    def test_bind_parent_ahead(self):
+        b_base, wt_child = self.create_branches()
+
+        wt_child.branch.unbind()
+
+        open('a', 'ab').write('base changes\n')
+        wt_base = b_base.bzrdir.open_workingtree()
+        wt_base.commit('base', rev_id='r@b-2')
+        self.assertEqual(['r@b-1', 'r@b-2'], b_base.revision_history())
+        self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
+
+        sftp_b_base = Branch.open(self.get_url('base'))
+        wt_child.branch.bind(sftp_b_base)
+
+        self.assertEqual(['r@b-1', 'r@b-2'], wt_child.branch.revision_history())
+
+        wt_child.branch.unbind()
+
+        # Check and make sure it also works if parent is ahead multiple
+        wt_base.commit('base 3', rev_id='r@b-3', allow_pointless=True)
+        wt_base.commit('base 4', rev_id='r@b-4', allow_pointless=True)
+        wt_base.commit('base 5', rev_id='r@b-5', allow_pointless=True)
+
+        self.assertEqual(['r@b-1', 'r@b-2', 'r@b-3', 'r@b-4', 'r@b-5'],
+                b_base.revision_history())
+
+        self.assertEqual(['r@b-1', 'r@b-2'], wt_child.branch.revision_history())
+
+        wt_child.branch.bind(sftp_b_base)
+        self.assertEqual(['r@b-1', 'r@b-2', 'r@b-3', 'r@b-4', 'r@b-5'],
+                wt_child.branch.revision_history())
+
+    def test_bind_child_ahead(self):
+        b_base, wt_child = self.create_branches()
+
+        wt_child.branch.unbind()
+
+        wt_child.commit('child', rev_id='r@c-2', allow_pointless=True)
+        self.assertEqual(['r@b-1', 'r@c-2'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1'], b_base.revision_history())
+
+        sftp_b_base = Branch.open(self.get_url('base'))
+        wt_child.branch.bind(sftp_b_base)
+
+        self.assertEqual(['r@b-1', 'r@c-2'], b_base.revision_history())
+
+        # Check and make sure it also works if child is ahead multiple
+        wt_child.branch.unbind()
+        wt_child.commit('child 3', rev_id='r@c-3', allow_pointless=True)
+        wt_child.commit('child 4', rev_id='r@c-4', allow_pointless=True)
+        wt_child.commit('child 5', rev_id='r@c-5', allow_pointless=True)
+
+        self.assertEqual(['r@b-1', 'r@c-2', 'r@c-3', 'r@c-4', 'r@c-5'],
+                wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1', 'r@c-2'], b_base.revision_history())
+
+        wt_child.branch.bind(sftp_b_base)
+        self.assertEqual(['r@b-1', 'r@c-2', 'r@c-3', 'r@c-4', 'r@c-5'],
+                b_base.revision_history())
+
+    def test_commit_after_merge(self):
+        from bzrlib.builtins import merge
+
+        b_base, wt_child = self.create_branches()
+
+        # We want merge to be able to be a local only
+        # operation, because it does not alter the branch data.
+
+        # But we can't fail afterwards
+
+        wt_other = wt_child.bzrdir.sprout('other').open_workingtree()
+
+        open('other/c', 'wb').write('file c\n')
+        wt_other.add('c')
+        wt_other.commit('adding c', rev_id='r@d-2')
+
+        self.failIf(wt_child.branch.repository.has_revision('r@d-2'))
+        self.failIf(b_base.repository.has_revision('r@d-2'))
+
+        # TODO: jam 20051230 merge_inner doesn't set pending merges
+        #       Is this on purpose?
+        #       merge_inner also doesn't fetch any missing revisions
+        #merge_inner(wt_child.branch, b_other.revision_tree('r@d-2'),
+        #        wt_child.branch.revision_tree('r@b-1'))
+        merge((wt_other.branch.base, 2), [None, None], this_dir=wt_child.branch.base)
+
+        self.failUnlessExists('child/c')
+        self.assertEqual(['r@d-2'], wt_child.pending_merges())
+        self.failUnless(wt_child.branch.repository.has_revision('r@d-2'))
+        self.failIf(b_base.repository.has_revision('r@d-2'))
+
+        # Commit should succeed, and cause merged revisions to
+        # be pulled into base
+        wt_child.commit('merge other', rev_id='r@c-2')
+        self.assertEqual(['r@b-1', 'r@c-2'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1', 'r@c-2'], b_base.revision_history())
+        self.failUnless(b_base.repository.has_revision('r@d-2'))
+
+    def test_commit_fails(self):
+        b_base, wt_child = self.create_branches()
+
+        open('a', 'ab').write('child adds some text\n')
+
+        del b_base
+        os.rename('base', 'hidden_base')
+
+        self.assertRaises(errors.BoundBranchConnectionFailure,
+                wt_child.commit, 'added text', rev_id='r@c-2')
+
+    def test_pull_fails(self):
+        b_base, wt_child = self.create_branches()
+
+        wt_other = wt_child.bzrdir.sprout('other').open_workingtree()
+        open('other/a', 'wb').write('new contents\n')
+        wt_other.commit('changed a', rev_id='r@d-2')
+
+        self.assertEqual(['r@b-1'], b_base.revision_history())
+        self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
+        self.assertEqual(['r@b-1', 'r@d-2'], wt_other.branch.revision_history())
+
+        del b_base
+        os.rename('base', 'hidden_base')
+
+        self.assertRaises(errors.BoundBranchConnectionFailure,
+                wt_child.pull, wt_other.branch)
+
+    # TODO: jam 20051231 We need invasive failure tests, so that we can show
+    #       performance even when something fails.
+
+
+if not paramiko_loaded:
+    del BoundSFTPBranch
+

=== added file 'bzrlib/tests/branch_implementations/test_branch.py'
--- bzrlib/tests/branch_implementations/test_branch.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_branch.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,544 @@
+# (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for branch implementations - tests a branch format."""
+
+import os
+import sys
+
+import bzrlib.branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.commit import commit
+import bzrlib.errors as errors
+from bzrlib.errors import (FileExists,
+                           NoSuchRevision,
+                           NoSuchFile,
+                           UninitializableFormat,
+                           NotBranchError,
+                           )
+import bzrlib.gpg
+from bzrlib.osutils import getcwd
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
+from bzrlib.trace import mutter
+import bzrlib.transactions as transactions
+from bzrlib.transport import get_transport
+from bzrlib.transport.http import HttpServer
+from bzrlib.transport.memory import MemoryServer
+from bzrlib.upgrade import upgrade
+from bzrlib.workingtree import WorkingTree
+
+
+# TODO: Make a branch using basis branch, and check that it 
+# doesn't request any files that could have been avoided, by 
+# hooking into the Transport.
+
+
+class TestCaseWithBranch(TestCaseWithTransport):
+
+    def setUp(self):
+        super(TestCaseWithBranch, self).setUp()
+        self.branch = None
+
+    def get_branch(self):
+        if self.branch is None:
+            self.branch = self.make_branch(None)
+        return self.branch
+
+    def make_branch(self, relpath):
+        repo = self.make_repository(relpath)
+        # fixme RBC 20060210 this isnt necessarily a fixable thing,
+        # Skipped is the wrong exception to raise.
+        try:
+            return self.branch_format.initialize(repo.bzrdir)
+        except errors.UninitializableFormat:
+            raise TestSkipped('Uninitializable branch format')
+
+    def make_repository(self, relpath, shared=False):
+        try:
+            url = self.get_url(relpath)
+            segments = url.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = '/'.join(segments[:-1])
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except FileExists:
+                    pass
+            made_control = self.bzrdir_format.initialize(url)
+            return made_control.create_repository(shared=shared)
+        except UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable.")
+
+
+class TestBranch(TestCaseWithBranch):
+
+    def test_append_revisions(self):
+        """Test appending more than one revision"""
+        br = self.get_branch()
+        br.append_revision("rev1")
+        self.assertEquals(br.revision_history(), ["rev1",])
+        br.append_revision("rev2", "rev3")
+        self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
+
+    def test_fetch_revisions(self):
+        """Test fetch-revision operation."""
+        get_transport(self.get_url()).mkdir('b1')
+        get_transport(self.get_url()).mkdir('b2')
+        wt = self.make_branch_and_tree('b1')
+        b1 = wt.branch
+        b2 = self.make_branch('b2')
+        file('b1/foo', 'w').write('hello')
+        wt.add(['foo'], ['foo-id'])
+        wt.commit('lala!', rev_id='revision-1', allow_pointless=False)
+
+        mutter('start fetch')
+        self.assertEqual((1, []), b2.fetch(b1))
+
+        rev = b2.repository.get_revision('revision-1')
+        tree = b2.repository.revision_tree('revision-1')
+        self.assertEqual(tree.get_file_text('foo-id'), 'hello')
+
+    def get_unbalanced_tree_pair(self):
+        """Return two branches, a and b, with one file in a."""
+        get_transport(self.get_url()).mkdir('a')
+        tree_a = self.make_branch_and_tree('a')
+        file('a/b', 'wb').write('b')
+        tree_a.add('b')
+        tree_a.commit("silly commit", rev_id='A')
+
+        get_transport(self.get_url()).mkdir('b')
+        tree_b = self.make_branch_and_tree('b')
+        return tree_a, tree_b
+
+    def get_balanced_branch_pair(self):
+        """Returns br_a, br_b as with one commit in a, and b has a's stores."""
+        tree_a, tree_b = self.get_unbalanced_tree_pair()
+        tree_b.branch.repository.fetch(tree_a.branch.repository)
+        return tree_a, tree_b
+
+    def test_clone_branch(self):
+        """Copy the stores from one branch to another"""
+        tree_a, tree_b = self.get_balanced_branch_pair()
+        tree_b.commit("silly commit")
+        os.mkdir('c')
+        # this fails to test that the history from a was not used.
+        dir_c = tree_a.bzrdir.clone('c', basis=tree_b.bzrdir)
+        self.assertEqual(tree_a.branch.revision_history(),
+                         dir_c.open_branch().revision_history())
+
+    def test_clone_partial(self):
+        """Copy only part of the history of a branch."""
+        # TODO: RBC 20060208 test with a revision not on revision-history.
+        #       what should that behaviour be ? Emailed the list.
+        wt_a = self.make_branch_and_tree('a')
+        self.build_tree(['a/one'])
+        wt_a.add(['one'])
+        wt_a.commit('commit one', rev_id='1')
+        self.build_tree(['a/two'])
+        wt_a.add(['two'])
+        wt_a.commit('commit two', rev_id='2')
+        repo_b = self.make_repository('b')
+        wt_a.bzrdir.open_repository().copy_content_into(repo_b)
+        br_b = wt_a.bzrdir.open_branch().clone(repo_b.bzrdir, revision_id='1')
+        self.assertEqual(br_b.last_revision(), '1')
+
+    def test_sprout_partial(self):
+        # test sprouting with a prefix of the revision-history.
+        # also needs not-on-revision-history behaviour defined.
+        wt_a = self.make_branch_and_tree('a')
+        self.build_tree(['a/one'])
+        wt_a.add(['one'])
+        wt_a.commit('commit one', rev_id='1')
+        self.build_tree(['a/two'])
+        wt_a.add(['two'])
+        wt_a.commit('commit two', rev_id='2')
+        repo_b = self.make_repository('b')
+        wt_a.bzrdir.open_repository().copy_content_into(repo_b)
+        br_b = wt_a.bzrdir.open_branch().sprout(repo_b.bzrdir, revision_id='1')
+        self.assertEqual(br_b.last_revision(), '1')
+
+    def test_clone_branch_nickname(self):
+        # test the nick name is preserved always
+        raise TestSkipped('XXX branch cloning is not yet tested..')
+
+    def test_clone_branch_parent(self):
+        # test the parent is preserved always
+        raise TestSkipped('XXX branch cloning is not yet tested..')
+        
+    def test_sprout_branch_nickname(self):
+        # test the nick name is reset always
+        raise TestSkipped('XXX branch sprouting is not yet tested..')
+
+    def test_sprout_branch_parent(self):
+        source = self.make_branch('source')
+        target = source.bzrdir.sprout(self.get_url('target')).open_branch()
+        self.assertEqual(source.bzrdir.root_transport.base, target.get_parent())
+        
+    def test_record_initial_ghost_merge(self):
+        """A pending merge with no revision present is still a merge."""
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        wt.add_pending_merge('non:existent@rev--ision--0--2')
+        wt.commit('pretend to merge nonexistent-revision', rev_id='first')
+        rev = branch.repository.get_revision(branch.last_revision())
+        self.assertEqual(len(rev.parent_ids), 1)
+        # parent_sha1s is not populated now, WTF. rbc 20051003
+        self.assertEqual(len(rev.parent_sha1s), 0)
+        self.assertEqual(rev.parent_ids[0], 'non:existent@rev--ision--0--2')
+
+    def test_bad_revision(self):
+        self.assertRaises(errors.InvalidRevisionId,
+                          self.get_branch().repository.get_revision,
+                          None)
+
+# TODO 20051003 RBC:
+# compare the gpg-to-sign info for a commit with a ghost and 
+#     an identical tree without a ghost
+# fetch missing should rewrite the TOC of weaves to list newly available parents.
+        
+    def test_pending_merges(self):
+        """Tracking pending-merged revisions."""
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+        self.assertEquals(wt.pending_merges(), [])
+        wt.add_pending_merge('foo@azkhazan-123123-abcabc')
+        self.assertEquals(wt.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+        wt.add_pending_merge('foo@azkhazan-123123-abcabc')
+        self.assertEquals(wt.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+        wt.add_pending_merge('wibble@fofof--20050401--1928390812')
+        self.assertEquals(wt.pending_merges(),
+                          ['foo@azkhazan-123123-abcabc',
+                           'wibble@fofof--20050401--1928390812'])
+        wt.commit("commit from base with two merges")
+        rev = b.repository.get_revision(b.revision_history()[0])
+        self.assertEquals(len(rev.parent_ids), 2)
+        self.assertEquals(rev.parent_ids[0],
+                          'foo@azkhazan-123123-abcabc')
+        self.assertEquals(rev.parent_ids[1],
+                           'wibble@fofof--20050401--1928390812')
+        # list should be cleared when we do a commit
+        self.assertEquals(wt.pending_merges(), [])
+
+    def test_sign_existing_revision(self):
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        wt.commit("base", allow_pointless=True, rev_id='A')
+        from bzrlib.testament import Testament
+        strategy = bzrlib.gpg.LoopbackGPGStrategy(None)
+        branch.repository.sign_revision('A', strategy)
+        self.assertEqual(Testament.from_revision(branch.repository, 
+                         'A').as_short_text(),
+                         branch.repository.revision_store.get('A', 
+                         'sig').read())
+
+    def test_store_signature(self):
+        branch = self.get_branch()
+        branch.repository.store_revision_signature(
+            bzrlib.gpg.LoopbackGPGStrategy(None), 'FOO', 'A')
+        self.assertEqual('FOO', 
+                         branch.repository.revision_store.get('A', 
+                         'sig').read())
+
+    def test_branch_keeps_signatures(self):
+        wt = self.make_branch_and_tree('source')
+        wt.commit('A', allow_pointless=True, rev_id='A')
+        wt.branch.repository.sign_revision('A',
+            bzrlib.gpg.LoopbackGPGStrategy(None))
+        #FIXME: clone should work to urls,
+        # wt.clone should work to disks.
+        self.build_tree(['target/'])
+        d2 = wt.bzrdir.clone('target')
+        self.assertEqual(wt.branch.repository.revision_store.get('A', 
+                            'sig').read(),
+                         d2.open_repository().revision_store.get('A', 
+                            'sig').read())
+
+    def test_nicks(self):
+        """Branch nicknames"""
+        t = get_transport(self.get_url())
+        t.mkdir('bzr.dev')
+        branch = self.make_branch('bzr.dev')
+        self.assertEqual(branch.nick, 'bzr.dev')
+        t.move('bzr.dev', 'bzr.ab')
+        branch = Branch.open(self.get_url('bzr.ab'))
+        self.assertEqual(branch.nick, 'bzr.ab')
+        branch.nick = "Aaron's branch"
+        branch.nick = "Aaron's branch"
+        self.failUnless(
+            t.has(
+                t.relpath(
+                    branch.control_files.controlfilename("branch.conf")
+                    )
+                )
+            )
+        self.assertEqual(branch.nick, "Aaron's branch")
+        t.move('bzr.ab', 'integration')
+        branch = Branch.open(self.get_url('integration'))
+        self.assertEqual(branch.nick, "Aaron's branch")
+        branch.nick = u"\u1234"
+        self.assertEqual(branch.nick, u"\u1234")
+
+    def test_commit_nicks(self):
+        """Nicknames are committed to the revision"""
+        get_transport(self.get_url()).mkdir('bzr.dev')
+        wt = self.make_branch_and_tree('bzr.dev')
+        branch = wt.branch
+        branch.nick = "My happy branch"
+        wt.commit('My commit respect da nick.')
+        committed = branch.repository.get_revision(branch.last_revision())
+        self.assertEqual(committed.properties["branch-nick"], 
+                         "My happy branch")
+
+    def test_create_open_branch_uses_repository(self):
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        repo.bzrdir.root_transport.mkdir('child')
+        child_dir = self.bzrdir_format.initialize('child')
+        try:
+            child_branch = self.branch_format.initialize(child_dir)
+        except errors.UninitializableFormat:
+            # branch references are not default init'able.
+            return
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         child_branch.repository.bzrdir.root_transport.base)
+        child_branch = bzrlib.branch.Branch.open(self.get_url('child'))
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         child_branch.repository.bzrdir.root_transport.base)
+
+
+class ChrootedTests(TestCaseWithBranch):
+    """A support class that provides readonly urls outside the local namespace.
+
+    This is done by checking if self.transport_server is a MemoryServer. if it
+    is then we are chrooted already, if it is not then an HttpServer is used
+    for readonly urls.
+    """
+
+    def setUp(self):
+        super(ChrootedTests, self).setUp()
+        if not self.transport_server == MemoryServer:
+            self.transport_readonly_server = HttpServer
+
+    def test_open_containing(self):
+        self.assertRaises(NotBranchError, Branch.open_containing,
+                          self.get_readonly_url(''))
+        self.assertRaises(NotBranchError, Branch.open_containing,
+                          self.get_readonly_url('g/p/q'))
+        branch = self.make_branch('.')
+        branch, relpath = Branch.open_containing(self.get_readonly_url(''))
+        self.assertEqual('', relpath)
+        branch, relpath = Branch.open_containing(self.get_readonly_url('g/p/q'))
+        self.assertEqual('g/p/q', relpath)
+        
+# TODO: rewrite this as a regular unittest, without relying on the displayed output        
+#         >>> from bzrlib.commit import commit
+#         >>> bzrlib.trace.silent = True
+#         >>> br1 = ScratchBranch(files=['foo', 'bar'])
+#         >>> br1.working_tree().add('foo')
+#         >>> br1.working_tree().add('bar')
+#         >>> commit(br1, "lala!", rev_id="REVISION-ID-1", verbose=False)
+#         >>> br2 = ScratchBranch()
+#         >>> br2.update_revisions(br1)
+#         Added 2 texts.
+#         Added 1 inventories.
+#         Added 1 revisions.
+#         >>> br2.revision_history()
+#         [u'REVISION-ID-1']
+#         >>> br2.update_revisions(br1)
+#         Added 0 revisions.
+#         >>> br1.text_store.total_size() == br2.text_store.total_size()
+#         True
+
+class InstrumentedTransaction(object):
+
+    def finish(self):
+        self.calls.append('finish')
+
+    def __init__(self):
+        self.calls = []
+
+
+class TestDecorator(object):
+
+    def __init__(self):
+        self._calls = []
+
+    def lock_read(self):
+        self._calls.append('lr')
+
+    def lock_write(self):
+        self._calls.append('lw')
+
+    def unlock(self):
+        self._calls.append('ul')
+
+    @needs_read_lock
+    def do_with_read(self):
+        return 1
+
+    @needs_read_lock
+    def except_with_read(self):
+        raise RuntimeError
+
+    @needs_write_lock
+    def do_with_write(self):
+        return 2
+
+    @needs_write_lock
+    def except_with_write(self):
+        raise RuntimeError
+
+
+class TestDecorators(TestCase):
+
+    def test_needs_read_lock(self):
+        branch = TestDecorator()
+        self.assertEqual(1, branch.do_with_read())
+        self.assertEqual(['lr', 'ul'], branch._calls)
+
+    def test_excepts_in_read_lock(self):
+        branch = TestDecorator()
+        self.assertRaises(RuntimeError, branch.except_with_read)
+        self.assertEqual(['lr', 'ul'], branch._calls)
+
+    def test_needs_write_lock(self):
+        branch = TestDecorator()
+        self.assertEqual(2, branch.do_with_write())
+        self.assertEqual(['lw', 'ul'], branch._calls)
+
+    def test_excepts_in_write_lock(self):
+        branch = TestDecorator()
+        self.assertRaises(RuntimeError, branch.except_with_write)
+        self.assertEqual(['lw', 'ul'], branch._calls)
+
+
+class TestBranchTransaction(TestCaseWithBranch):
+
+    def setUp(self):
+        super(TestBranchTransaction, self).setUp()
+        self.branch = None
+        
+    def test_default_get_transaction(self):
+        """branch.get_transaction on a new branch should give a PassThrough."""
+        self.failUnless(isinstance(self.get_branch().get_transaction(),
+                                   transactions.PassThroughTransaction))
+
+    def test__set_new_transaction(self):
+        self.get_branch()._set_transaction(transactions.ReadOnlyTransaction())
+
+    def test__set_over_existing_transaction_raises(self):
+        self.get_branch()._set_transaction(transactions.ReadOnlyTransaction())
+        self.assertRaises(errors.LockError,
+                          self.get_branch()._set_transaction,
+                          transactions.ReadOnlyTransaction())
+
+    def test_finish_no_transaction_raises(self):
+        self.assertRaises(errors.LockError, self.get_branch()._finish_transaction)
+
+    def test_finish_readonly_transaction_works(self):
+        self.get_branch()._set_transaction(transactions.ReadOnlyTransaction())
+        self.get_branch()._finish_transaction()
+        self.assertEqual(None, self.get_branch().control_files._transaction)
+
+    def test_unlock_calls_finish(self):
+        self.get_branch().lock_read()
+        transaction = InstrumentedTransaction()
+        self.get_branch().control_files._transaction = transaction
+        self.get_branch().unlock()
+        self.assertEqual(['finish'], transaction.calls)
+
+    def test_lock_read_acquires_ro_transaction(self):
+        self.get_branch().lock_read()
+        self.failUnless(isinstance(self.get_branch().get_transaction(),
+                                   transactions.ReadOnlyTransaction))
+        self.get_branch().unlock()
+        
+    def test_lock_write_acquires_passthrough_transaction(self):
+        self.get_branch().lock_write()
+        # cannot use get_transaction as its magic
+        self.failUnless(isinstance(self.get_branch().control_files._transaction,
+                                   transactions.PassThroughTransaction))
+        self.get_branch().unlock()
+
+
+class TestBranchPushLocations(TestCaseWithBranch):
+
+    def test_get_push_location_unset(self):
+        self.assertEqual(None, self.get_branch().get_push_location())
+
+    def test_get_push_location_exact(self):
+        from bzrlib.config import (branches_config_filename,
+                                   ensure_config_dir_exists)
+        ensure_config_dir_exists()
+        fn = branches_config_filename()
+        print >> open(fn, 'wt'), ("[%s]\n"
+                                  "push_location=foo" %
+                                  self.get_branch().base[:-1])
+        self.assertEqual("foo", self.get_branch().get_push_location())
+
+    def test_set_push_location(self):
+        from bzrlib.config import (branches_config_filename,
+                                   ensure_config_dir_exists)
+        ensure_config_dir_exists()
+        fn = branches_config_filename()
+        self.get_branch().set_push_location('foo')
+        self.assertFileEqual("[%s]\n"
+                             "push_location = foo" % self.get_branch().base[:-1],
+                             fn)
+
+    # TODO RBC 20051029 test getting a push location from a branch in a 
+    # recursive section - that is, it appends the branch name.
+
+
+class TestFormat(TestCaseWithBranch):
+    """Tests for the format itself."""
+
+    def test_format_initialize_find_open(self):
+        # loopback test to check the current format initializes to itself.
+        if not self.branch_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        # supported formats must be able to init and open
+        t = get_transport(self.get_url())
+        readonly_t = get_transport(self.get_readonly_url())
+        made_branch = self.make_branch('.')
+        self.failUnless(isinstance(made_branch, bzrlib.branch.Branch))
+
+        # find it via bzrdir opening:
+        opened_control = bzrdir.BzrDir.open(readonly_t.base)
+        direct_opened_branch = opened_control.open_branch()
+        self.assertEqual(direct_opened_branch.__class__, made_branch.__class__)
+        self.assertEqual(opened_control, direct_opened_branch.bzrdir)
+        self.failUnless(isinstance(direct_opened_branch._format,
+                        self.branch_format.__class__))
+
+        # find it via Branch.open
+        opened_branch = bzrlib.branch.Branch.open(readonly_t.base)
+        self.failUnless(isinstance(opened_branch, made_branch.__class__))
+        self.assertEqual(made_branch._format.__class__,
+                         opened_branch._format.__class__)
+        # if it has a unique id string, can we probe for it ?
+        try:
+            self.branch_format.get_format_string()
+        except NotImplementedError:
+            return
+        self.assertEqual(self.branch_format,
+                         bzrlib.branch.BranchFormat.find_format(opened_control))

=== added file 'bzrlib/tests/branch_implementations/test_parent.py'
--- bzrlib/tests/branch_implementations/test_parent.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_parent.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,40 @@
+# Copyright (C) 2004, 2005 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+import os
+
+from bzrlib.branch import Branch
+from bzrlib.osutils import abspath, realpath
+from bzrlib.tests import TestCaseWithTransport
+
+
+"""Tests for Branch parent URL"""
+
+
+class TestParent(TestCaseWithTransport):
+
+    def test_no_default_parent(self):
+        """Branches should have no parent by default"""
+        b = self.make_branch('.')
+        self.assertEquals(b.get_parent(), None)
+        
+    def test_set_get_parent(self):
+        """Set and then re-get the parent"""
+        b = self.make_branch('.')
+        url = 'http://bazaar-ng.org/bzr/bzr.dev'
+        b.set_parent(url)
+        self.assertEquals(b.get_parent(), url)

=== added file 'bzrlib/tests/branch_implementations/test_permissions.py'
--- bzrlib/tests/branch_implementations/test_permissions.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_permissions.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,112 @@
+# Copyright (C) 2005 by Canonical Ltd
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests for bzr setting permissions.
+
+Files in the branch control directory (.bzr or .bzr/branch) should inherit
+the .bzr directory permissions.
+So if the directory is group writable, the files and subdirs should be as well.
+"""
+
+# TODO: jam 20051215 Currently the default behavior for 'bzr branch' is just 
+#                    defined by the local umask. This isn't terrible, is it
+#                    the truly desired behavior?
+ 
+import os
+import sys
+import stat
+from StringIO import StringIO
+
+from bzrlib.branch import Branch
+from bzrlib.bzrdir import BzrDir
+from bzrlib.lockable_files import LockableFiles
+from bzrlib.tests import TestCaseWithTransport, TestSkipped
+from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
+from bzrlib.transport import get_transport
+from bzrlib.workingtree import WorkingTree
+
+# TODO RBC consolidate the helper methods here and in tests/test_permissions.py
+
+def chmod_r(base, file_mode, dir_mode):
+    """Recursively chmod from a base directory"""
+    assert os.path.isdir(base)
+    os.chmod(base, dir_mode)
+    for root, dirs, files in os.walk(base):
+        for d in dirs:
+            p = os.path.join(root, d)
+            os.chmod(p, dir_mode)
+        for f in files:
+            p = os.path.join(root, f)
+            os.chmod(p, file_mode)
+
+
+def check_mode_r(test, base, file_mode, dir_mode, include_base=True):
+    """Check that all permissions match
+
+    :param test: The TestCase being run
+    :param base: The path to the root directory to check
+    :param file_mode: The mode for all files
+    :param dir_mode: The mode for all directories
+    :param include_base: If false, only check the subdirectories
+    """
+    assert os.path.isdir(base)
+    t = get_transport(".")
+    if include_base:
+        test.assertTransportMode(t, base, dir_mode)
+    for root, dirs, files in os.walk(base):
+        for d in dirs:
+            p = os.path.join(root, d)
+            test.assertTransportMode(t, p, dir_mode)
+        for f in files:
+            p = os.path.join(root, f)
+            test.assertTransportMode(t, p, file_mode)
+
+
+class TestPermissions(TestCaseWithTransport):
+
+    def test_new_branch(self):
+        if sys.platform == 'win32':
+            raise TestSkipped('chmod has no effect on win32')
+        # also, these are BzrBranch format specific things..
+        os.mkdir('a')
+        mode = stat.S_IMODE(os.stat('a').st_mode)
+        t = self.make_branch_and_tree('.')
+        b = t.branch
+        self.assertEqualMode(mode, b.control_files._dir_mode)
+        self.assertEqualMode(mode & ~07111, b.control_files._file_mode)
+
+        os.mkdir('b')
+        os.chmod('b', 02777)
+        b = BzrDir.create('b').create_branch()
+        self.assertEqualMode(02777, b.control_files._dir_mode)
+        self.assertEqualMode(00666, b.control_files._file_mode)
+        check_mode_r(self, b.control_files._transport.base, 00666, 02777)
+
+        os.mkdir('c')
+        os.chmod('c', 02750)
+        b = BzrDir.create('c').create_branch()
+        self.assertEqualMode(02750, b.control_files._dir_mode)
+        self.assertEqualMode(00640, b.control_files._file_mode)
+        check_mode_r(self, b.control_files._transport.base, 00640, 02750)
+
+        os.mkdir('d')
+        os.chmod('d', 0700)
+        b = BzrDir.create('d').create_branch()
+        self.assertEqualMode(0700, b.control_files._dir_mode)
+        self.assertEqualMode(0600, b.control_files._file_mode)
+        check_mode_r(self, b.control_files._transport.base, 00600, 00700)

=== added file 'bzrlib/tests/branch_implementations/test_update.py'
--- bzrlib/tests/branch_implementations/test_update.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_update.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,65 @@
+# Copyright (C) 2006 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+import bzrlib.errors as errors
+from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
+
+
+"""Tests for branch.update()"""
+
+
+class TestUpdate(TestCaseWithBranch):
+
+    def test_update_unbound_works(self):
+        b = self.make_branch('.')
+        b.update()
+        self.assertEqual(None, b.last_revision())
+
+    def test_update_prefix_returns_none(self):
+        # update in a branch when its a prefix of the master should
+        # indicate that no local changes were present.
+        master_tree = self.make_branch_and_tree('master')
+        child_tree = self.make_branch_and_tree('child')
+        try:
+            child_tree.branch.bind(master_tree.branch)
+        except errors.UpgradeRequired:
+            # old branch, cant test.
+            return
+        # commit to the child to make the last rev not-None.
+        child_tree.commit('foo', rev_id='foo', allow_pointless=True)
+        # update the master so we can commit there.
+        master_tree.update()
+        # commit to the master making the child tree out of date and a prefix.
+        master_tree.commit('bar', rev_id='bar', allow_pointless=True)
+        self.assertEqual(None, child_tree.branch.update())
+
+    def test_update_local_commits_returns_old_tip(self):
+        # update in a branch when its not a prefix of the master should
+        # return the previous tip and reset the revision history.
+        master_tree = self.make_branch_and_tree('master')
+        child_tree = self.make_branch_and_tree('child')
+        try:
+            child_tree.branch.bind(master_tree.branch)
+        except errors.UpgradeRequired:
+            # old branch, cant test.
+            return
+        # commit to the child to make the last rev not-None and skew it from master.
+        child_tree.commit('foo', rev_id='foo', allow_pointless=True, local=True)
+        # commit to the master making the child tree out of date and not a prefix.
+        master_tree.commit('bar', rev_id='bar', allow_pointless=True)
+        self.assertEqual('foo', child_tree.branch.update())
+        self.assertEqual(['bar'], child_tree.branch.revision_history())

=== added directory 'bzrlib/tests/bzrdir_implementations'
=== added file 'bzrlib/tests/bzrdir_implementations/__init__.py'
--- bzrlib/tests/bzrdir_implementations/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/bzrdir_implementations/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,49 @@
+# Copyright (C) 2006 by Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""BzrDir implementation tests for bzr.
+
+These test the conformance of all the bzrdir variations to the expected API.
+Specific tests for individual formats are in the tests/test_bzrdir.py file 
+rather than in tests/branch_implementations/*.py.
+"""
+
+from bzrlib.bzrdir import BzrDirTestProviderAdapter, BzrDirFormat
+from bzrlib.tests import (
+                          adapt_modules,
+                          default_transport,
+                          TestLoader,
+                          TestSuite,
+                          )
+
+
+def test_suite():
+    result = TestSuite()
+    test_bzrdir_implementations = [
+        'bzrlib.tests.bzrdir_implementations.test_bzrdir',
+        ]
+    adapter = BzrDirTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        BzrDirFormat._formats.values())
+    loader = TestLoader()
+    adapt_modules(test_bzrdir_implementations, adapter, loader, result)
+    return result

=== added file 'bzrlib/tests/bzrdir_implementations/test_bzrdir.py'
--- bzrlib/tests/bzrdir_implementations/test_bzrdir.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,1107 @@
+# (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for bzrdir implementations - tests a bzrdir format."""
+
+import os
+from stat import *
+import sys
+
+import bzrlib.branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.check import check
+from bzrlib.commit import commit
+import bzrlib.errors as errors
+from bzrlib.errors import (FileExists,
+                           NoSuchRevision,
+                           NoSuchFile,
+                           UninitializableFormat,
+                           NotBranchError,
+                           )
+import bzrlib.repository as repository
+from bzrlib.tests import (
+                          ChrootedTestCase,
+                          TestCase,
+                          TestCaseWithTransport,
+                          TestSkipped,
+                          )
+from bzrlib.trace import mutter
+import bzrlib.transactions as transactions
+import bzrlib.transport as transport
+from bzrlib.transport import get_transport
+import bzrlib.ui as ui
+from bzrlib.upgrade import upgrade
+import bzrlib.workingtree as workingtree
+
+
+class TestCaseWithBzrDir(TestCaseWithTransport):
+
+    def setUp(self):
+        super(TestCaseWithBzrDir, self).setUp()
+        self.bzrdir = None
+
+    def get_bzrdir(self):
+        if self.bzrdir is None:
+            self.bzrdir = self.make_bzrdir(None)
+        return self.bzrdir
+
+    def make_bzrdir(self, relpath):
+        try:
+            url = self.get_url(relpath)
+            segments = url.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = '/'.join(segments[:-1])
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except FileExists:
+                    pass
+            return self.bzrdir_format.initialize(url)
+        except UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable.")
+
+
+class TestBzrDir(TestCaseWithBzrDir):
+    # Many of these tests test for disk equality rather than checking
+    # for semantic equivalence. This works well for some tests but
+    # is not good at handling changes in representation or the addition
+    # or removal of control data. It would be nice to for instance:
+    # sprout a new branch, check that the nickname has been reset by hand
+    # and then set the nickname to match the source branch, at which point
+    # a semantic equivalence should pass
+
+    def assertDirectoriesEqual(self, source, target, ignore_list=[]):
+        """Assert that the content of source and target are identical.
+
+        paths in ignore list will be completely ignored.
+        """
+        files = []
+        directories = ['.']
+        while directories:
+            dir = directories.pop()
+            for path in source.list_dir(dir):
+                path = dir + '/' + path
+                if path in ignore_list:
+                    continue
+                stat = source.stat(path)
+                if S_ISDIR(stat.st_mode):
+                    self.assertTrue(S_ISDIR(target.stat(path).st_mode))
+                    directories.append(path)
+                else:
+                    self.assertEqualDiff(source.get(path).read(),
+                                         target.get(path).read(),
+                                         "text for file %r differs:\n" % path)
+
+    def test_clone_bzrdir_empty(self):
+        dir = self.make_bzrdir('source')
+        target = dir.clone(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+    
+    def test_clone_bzrdir_empty_force_new_ignored(self):
+        # the force_new_repo parameter should have no effect on an empty
+        # bzrdir's clone logic
+        dir = self.make_bzrdir('source')
+        target = dir.clone(self.get_url('target'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+    
+    def test_clone_bzrdir_repository(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        dir = self.make_bzrdir('source')
+        repo = dir.create_repository()
+        repo.fetch(tree.branch.repository)
+        self.assertTrue(repo.has_revision('1'))
+        target = dir.clone(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+
+    def test_clone_bzrdir_repository_under_shared(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        dir = self.make_bzrdir('source')
+        repo = dir.create_repository()
+        repo.fetch(tree.branch.repository)
+        self.assertTrue(repo.has_revision('1'))
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.clone(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertRaises(errors.NoRepositoryPresent, target.open_repository)
+
+    def test_clone_bzrdir_repository_branch_both_under_shared(self):
+        try:
+            shared_repo = self.make_repository('shared', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        tree.bzrdir.open_repository().copy_content_into(shared_repo)
+        dir = self.make_bzrdir('shared/source')
+        dir.create_branch()
+        target = dir.clone(self.get_url('shared/target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertNotEqual(dir.transport.base, shared_repo.bzrdir.transport.base)
+        self.assertTrue(shared_repo.has_revision('1'))
+        
+    def test_clone_bzrdir_repository_under_shared_force_new_repo(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        dir = self.make_bzrdir('source')
+        repo = dir.create_repository()
+        repo.fetch(tree.branch.repository)
+        self.assertTrue(repo.has_revision('1'))
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.clone(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+
+    def test_clone_bzrdir_repository_revision(self):
+        # test for revision limiting, [smoke test, not corner case checks].
+        # make a repository with some revisions,
+        # and clone it with a revision limit.
+        # 
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        source = self.make_repository('source')
+        tree.bzrdir.open_repository().copy_content_into(source)
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target'), revision_id='2')
+        raise TestSkipped('revision limiting not strict yet')
+
+    def test_clone_bzrdir_branch_and_repo(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/stat-cache', './.bzr/checkout/stat-cache'])
+
+    def test_clone_bzrdir_branch_and_repo_into_shared_repo(self):
+        # by default cloning into a shared repo uses the shared repo.
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertRaises(errors.NoRepositoryPresent, target.open_repository)
+        self.assertEqual(source.revision_history(),
+                         target.open_branch().revision_history())
+
+    def test_clone_bzrdir_branch_and_repo_into_shared_repo_force_new_repo(self):
+        # by default cloning into a shared repo uses the shared repo.
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        target.open_repository()
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+
+    def test_clone_bzrdir_branch_reference(self):
+        # cloning should preserve the reference status of the branch in a bzrdir
+        referenced_branch = self.make_branch('referencced')
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        target = dir.clone(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+
+    def test_clone_bzrdir_branch_revision(self):
+        # test for revision limiting, [smoke test, not corner case checks].
+        # make a branch with some revisions,
+        # and clone it with a revision limit.
+        # 
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target'), revision_id='1')
+        self.assertEqual('1', target.open_branch().last_revision())
+        
+    def test_clone_bzrdir_tree_branch_repo(self):
+        tree = self.make_branch_and_tree('sourcce')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        dir = tree.bzrdir
+        target = dir.clone(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/stat-cache', './.bzr/checkout/stat-cache'])
+        target.open_workingtree().revert([])
+
+    def test_revert_inventory(self):
+        tree = self.make_branch_and_tree('sourcce')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        dir = tree.bzrdir
+        target = dir.clone(self.get_url('target'))
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/stat-cache', './.bzr/checkout/stat-cache'])
+        target.open_workingtree().revert([])
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/stat-cache', './.bzr/checkout/stat-cache'])
+
+    def test_clone_bzrdir_tree_branch_reference(self):
+        # a tree with a branch reference (aka a checkout) 
+        # should stay a checkout on clone.
+        referenced_branch = self.make_branch('referencced')
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        dir.create_workingtree()
+        target = dir.clone(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/stat-cache', './.bzr/checkout/stat-cache'])
+
+    def test_clone_bzrdir_tree_revision(self):
+        # test for revision limiting, [smoke test, not corner case checks].
+        # make a tree with a revision with a last-revision
+        # and clone it with a revision limit.
+        # This smoke test just checks the revision-id is right. Tree specific
+        # tests will check corner cases.
+        tree = self.make_branch_and_tree('source')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        dir = tree.bzrdir
+        target = dir.clone(self.get_url('target'), revision_id='1')
+        self.assertEqual('1', target.open_workingtree().last_revision())
+
+    def test_clone_bzrdir_incomplete_source_with_basis(self):
+        # ensure that basis really does grab from the basis by having incomplete source
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_branch_and_tree('source')
+        # this gives us an incomplete repository
+        tree.bzrdir.open_repository().copy_content_into(source.branch.repository)
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        tree.bzrdir.open_branch().copy_content_into(source.branch)
+        tree.copy_content_into(source)
+        self.assertFalse(source.branch.repository.has_revision('2'))
+        dir = source.bzrdir
+        target = dir.clone(self.get_url('target'), basis=tree.bzrdir)
+        self.assertEqual('2', target.open_branch().last_revision())
+        self.assertEqual('2', target.open_workingtree().last_revision())
+        self.assertTrue(target.open_branch().repository.has_revision('2'))
+
+    def test_sprout_bzrdir_empty(self):
+        dir = self.make_bzrdir('source')
+        target = dir.sprout(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # creates a new repository branch and tree
+        target.open_repository()
+        target.open_branch()
+        target.open_workingtree()
+
+    def test_sprout_bzrdir_empty_under_shared_repo(self):
+        # sprouting an empty dir into a repo uses the repo
+        dir = self.make_bzrdir('source')
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertRaises(errors.NoRepositoryPresent, target.open_repository)
+        target.open_branch()
+        target.open_workingtree()
+
+    def test_sprout_bzrdir_empty_under_shared_repo(self):
+        # the force_new_repo parameter should force use of a new repo in an empty
+        # bzrdir's sprout logic
+        dir = self.make_bzrdir('source')
+        try:
+            self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        target.open_repository()
+        target.open_branch()
+        target.open_workingtree()
+    
+    def test_sprout_bzrdir_repository(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        dir = self.make_bzrdir('source')
+        repo = dir.create_repository()
+        repo.fetch(tree.branch.repository)
+        self.assertTrue(repo.has_revision('1'))
+        target = dir.sprout(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport)
+
+    def test_sprout_bzrdir_with_repository_to_shared(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        source = self.make_repository('source')
+        tree.bzrdir.open_repository().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_repository_branch_both_under_shared(self):
+        try:
+            shared_repo = self.make_repository('shared', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        tree.bzrdir.open_repository().copy_content_into(shared_repo)
+        dir = self.make_bzrdir('shared/source')
+        dir.create_branch()
+        target = dir.sprout(self.get_url('shared/target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertNotEqual(dir.transport.base, shared_repo.bzrdir.transport.base)
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_repository_under_shared_force_new_repo(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        source = self.make_repository('source')
+        tree.bzrdir.open_repository().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertFalse(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_repository_revision(self):
+        # test for revision limiting, [smoke test, not corner case checks].
+        # make a repository with some revisions,
+        # and sprout it with a revision limit.
+        # 
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.bzrdir.open_branch().set_revision_history([])
+        tree.set_last_revision(None)
+        tree.commit('revision 2', rev_id='2')
+        source = self.make_repository('source')
+        tree.bzrdir.open_repository().copy_content_into(source)
+        dir = source.bzrdir
+        target = dir.sprout(self.get_url('target'), revision_id='2')
+        raise TestSkipped('revision limiting not strict yet')
+
+    def test_sprout_bzrdir_branch_and_repo(self):
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        target = dir.sprout(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/stat-cache',
+                                     './.bzr/checkout/stat-cache',
+                                     './.bzr/inventory',
+                                     './.bzr/checkout/inventory',
+                                     ])
+
+    def test_sprout_bzrdir_branch_and_repo_shared(self):
+        # sprouting a branch with a repo into a shared repo uses the shared
+        # repo
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_branch_and_repo_shared_force_new_repo(self):
+        # sprouting a branch with a repo into a shared repo uses the shared
+        # repo
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertFalse(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_branch_reference(self):
+        # sprouting should create a repository if needed and a sprouted branch.
+        referenced_branch = self.make_branch('referencced')
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        target = dir.sprout(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # we want target to have a branch that is in-place.
+        self.assertEqual(target, target.open_branch().bzrdir)
+        # and as we dont support repositories being detached yet, a repo in 
+        # place
+        target.open_repository()
+
+    def test_sprout_bzrdir_branch_reference_shared(self):
+        # sprouting should create a repository if needed and a sprouted branch.
+        referenced_tree = self.make_branch_and_tree('referenced')
+        referenced_tree.commit('1', rev_id='1', allow_pointless=True)
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_tree.branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # we want target to have a branch that is in-place.
+        self.assertEqual(target, target.open_branch().bzrdir)
+        # and we want no repository as the target is shared
+        self.assertRaises(errors.NoRepositoryPresent, 
+                          target.open_repository)
+        # and we want revision '1' in the shared repo
+        self.assertTrue(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_branch_reference_shared_force_new_repo(self):
+        # sprouting should create a repository if needed and a sprouted branch.
+        referenced_tree = self.make_branch_and_tree('referenced')
+        referenced_tree.commit('1', rev_id='1', allow_pointless=True)
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_tree.branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        try:
+            shared_repo = self.make_repository('target', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        target = dir.sprout(self.get_url('target/child'), force_new_repo=True)
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # we want target to have a branch that is in-place.
+        self.assertEqual(target, target.open_branch().bzrdir)
+        # and we want revision '1' in the new repo
+        self.assertTrue(target.open_repository().has_revision('1'))
+        # but not the shared one
+        self.assertFalse(shared_repo.has_revision('1'))
+
+    def test_sprout_bzrdir_branch_revision(self):
+        # test for revision limiting, [smoke test, not corner case checks].
+        # make a repository with some revisions,
+        # and sprout it with a revision limit.
+        # 
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        source = self.make_branch('source')
+        tree.bzrdir.open_repository().copy_content_into(source.repository)
+        tree.bzrdir.open_branch().copy_content_into(source)
+        dir = source.bzrdir
+        target = dir.sprout(self.get_url('target'), revision_id='1')
+        self.assertEqual('1', target.open_branch().last_revision())
+        
+    def test_sprout_bzrdir_tree_branch_repo(self):
+        tree = self.make_branch_and_tree('sourcce')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1')
+        dir = tree.bzrdir
+        target = dir.sprout(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        self.assertDirectoriesEqual(dir.root_transport, target.root_transport,
+                                    ['./.bzr/stat-cache',
+                                     './.bzr/checkout/stat-cache',
+                                     './.bzr/inventory',
+                                     './.bzr/checkout/inventory',
+                                     ])
+
+    def test_sprout_bzrdir_tree_branch_reference(self):
+        # sprouting should create a repository if needed and a sprouted branch.
+        # the tree state should not be copied.
+        referenced_branch = self.make_branch('referencced')
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        tree = dir.create_workingtree()
+        tree.bzrdir.root_transport.mkdir('subdir')
+        tree.add('subdir')
+        target = dir.sprout(self.get_url('target'))
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # we want target to have a branch that is in-place.
+        self.assertEqual(target, target.open_branch().bzrdir)
+        # and as we dont support repositories being detached yet, a repo in 
+        # place
+        target.open_repository()
+        result_tree = target.open_workingtree()
+        self.assertFalse(result_tree.has_filename('subdir'))
+
+    def test_sprout_bzrdir_tree_branch_reference_revision(self):
+        # sprouting should create a repository if needed and a sprouted branch.
+        # the tree state should not be copied but the revision changed,
+        # and the likewise the new branch should be truncated too
+        referenced_branch = self.make_branch('referencced')
+        dir = self.make_bzrdir('source')
+        try:
+            reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
+                referenced_branch)
+        except errors.IncompatibleFormat:
+            # this is ok too, not all formats have to support references.
+            return
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        tree = dir.create_workingtree()
+        self.build_tree(['foo'], transport=dir.root_transport)
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        target = dir.sprout(self.get_url('target'), revision_id='1')
+        self.assertNotEqual(dir.transport.base, target.transport.base)
+        # we want target to have a branch that is in-place.
+        self.assertEqual(target, target.open_branch().bzrdir)
+        # and as we dont support repositories being detached yet, a repo in 
+        # place
+        target.open_repository()
+        # we trust that the working tree sprouting works via the other tests.
+        self.assertEqual('1', target.open_workingtree().last_revision())
+        self.assertEqual('1', target.open_branch().last_revision())
+
+    def test_sprout_bzrdir_tree_revision(self):
+        # test for revision limiting, [smoke test, not corner case checks].
+        # make a tree with a revision with a last-revision
+        # and sprout it with a revision limit.
+        # This smoke test just checks the revision-id is right. Tree specific
+        # tests will check corner cases.
+        tree = self.make_branch_and_tree('source')
+        self.build_tree(['foo'], transport=tree.bzrdir.root_transport)
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        dir = tree.bzrdir
+        target = dir.sprout(self.get_url('target'), revision_id='1')
+        self.assertEqual('1', target.open_workingtree().last_revision())
+
+    def test_sprout_bzrdir_incomplete_source_with_basis(self):
+        # ensure that basis really does grab from the basis by having incomplete source
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.root_transport)
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_branch_and_tree('source')
+        # this gives us an incomplete repository
+        tree.bzrdir.open_repository().copy_content_into(source.branch.repository)
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        tree.bzrdir.open_branch().copy_content_into(source.branch)
+        tree.copy_content_into(source)
+        self.assertFalse(source.branch.repository.has_revision('2'))
+        dir = source.bzrdir
+        target = dir.sprout(self.get_url('target'), basis=tree.bzrdir)
+        self.assertEqual('2', target.open_branch().last_revision())
+        self.assertEqual('2', target.open_workingtree().last_revision())
+        self.assertTrue(target.open_branch().repository.has_revision('2'))
+
+    def test_format_initialize_find_open(self):
+        # loopback test to check the current format initializes to itself.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        # supported formats must be able to init and open
+        t = get_transport(self.get_url())
+        readonly_t = get_transport(self.get_readonly_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        self.failUnless(isinstance(made_control, bzrdir.BzrDir))
+        self.assertEqual(self.bzrdir_format,
+                         bzrdir.BzrDirFormat.find_format(readonly_t))
+        direct_opened_dir = self.bzrdir_format.open(readonly_t)
+        opened_dir = bzrdir.BzrDir.open(t.base)
+        self.assertEqual(made_control._format,
+                         opened_dir._format)
+        self.assertEqual(direct_opened_dir._format,
+                         opened_dir._format)
+        self.failUnless(isinstance(opened_dir, bzrdir.BzrDir))
+
+    def test_open_not_bzrdir(self):
+        # test the formats specific behaviour for no-content or similar dirs.
+        self.assertRaises(NotBranchError,
+                          self.bzrdir_format.open,
+                          get_transport(self.get_readonly_url()))
+
+    def test_create_branch(self):
+        # a bzrdir can construct a branch and repository for itself.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        t = get_transport(self.get_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = made_control.create_repository()
+        made_branch = made_control.create_branch()
+        self.failUnless(isinstance(made_branch, bzrlib.branch.Branch))
+        self.assertEqual(made_control, made_branch.bzrdir)
+        
+    def test_open_branch(self):
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        t = get_transport(self.get_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = made_control.create_repository()
+        made_branch = made_control.create_branch()
+        opened_branch = made_control.open_branch()
+        self.assertEqual(made_control, opened_branch.bzrdir)
+        self.failUnless(isinstance(opened_branch, made_branch.__class__))
+        self.failUnless(isinstance(opened_branch._format, made_branch._format.__class__))
+
+    def test_create_repository(self):
+        # a bzrdir can construct a repository for itself.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        t = get_transport(self.get_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = made_control.create_repository()
+        self.failUnless(isinstance(made_repo, repository.Repository))
+        self.assertEqual(made_control, made_repo.bzrdir)
+        
+    def test_open_repository(self):
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        t = get_transport(self.get_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = made_control.create_repository()
+        opened_repo = made_control.open_repository()
+        self.assertEqual(made_control, opened_repo.bzrdir)
+        self.failUnless(isinstance(opened_repo, made_repo.__class__))
+        self.failUnless(isinstance(opened_repo._format, made_repo._format.__class__))
+
+    def test_create_workingtree(self):
+        # a bzrdir can construct a working tree for itself.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        # this has to be tested with local access as we still support creating 
+        # format 6 bzrdirs
+        t = get_transport('.')
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = made_control.create_repository()
+        made_branch = made_control.create_branch()
+        made_tree = made_control.create_workingtree()
+        self.failUnless(isinstance(made_tree, workingtree.WorkingTree))
+        self.assertEqual(made_control, made_tree.bzrdir)
+        
+    def test_create_workingtree_revision(self):
+        # a bzrdir can construct a working tree for itself @ a specific revision.
+        source = self.make_branch_and_tree('source')
+        source.commit('a', rev_id='a', allow_pointless=True)
+        source.commit('b', rev_id='b', allow_pointless=True)
+        self.build_tree(['new/'])
+        made_control = self.bzrdir_format.initialize('new')
+        source.branch.repository.clone(made_control)
+        source.branch.clone(made_control)
+        made_tree = made_control.create_workingtree(revision_id='a')
+        self.assertEqual('a', made_tree.last_revision())
+        
+    def test_open_workingtree(self):
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        # this has to be tested with local access as we still support creating 
+        # format 6 bzrdirs
+        t = get_transport('.')
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = made_control.create_repository()
+        made_branch = made_control.create_branch()
+        made_tree = made_control.create_workingtree()
+        opened_tree = made_control.open_workingtree()
+        self.assertEqual(made_control, opened_tree.bzrdir)
+        self.failUnless(isinstance(opened_tree, made_tree.__class__))
+        self.failUnless(isinstance(opened_tree._format, made_tree._format.__class__))
+
+    def test_get_branch_transport(self):
+        dir = self.make_bzrdir('.')
+        # without a format, get_branch_transport gives use a transport
+        # which -may- point to an existing dir.
+        self.assertTrue(isinstance(dir.get_branch_transport(None),
+                                   transport.Transport))
+        # with a given format, either the bzr dir supports identifiable
+        # branches, or it supports anonymous  branch formats, but not both.
+        anonymous_format = bzrlib.branch.BzrBranchFormat4()
+        identifiable_format = bzrlib.branch.BzrBranchFormat5()
+        try:
+            found_transport = dir.get_branch_transport(anonymous_format)
+            self.assertRaises(errors.IncompatibleFormat,
+                              dir.get_branch_transport,
+                              identifiable_format)
+        except errors.IncompatibleFormat:
+            found_transport = dir.get_branch_transport(identifiable_format)
+        self.assertTrue(isinstance(found_transport, transport.Transport))
+        # and the dir which has been initialized for us must be statable.
+        found_transport.stat('.')
+
+    def test_get_repository_transport(self):
+        dir = self.make_bzrdir('.')
+        # without a format, get_repository_transport gives use a transport
+        # which -may- point to an existing dir.
+        self.assertTrue(isinstance(dir.get_repository_transport(None),
+                                   transport.Transport))
+        # with a given format, either the bzr dir supports identifiable
+        # repositoryes, or it supports anonymous  repository formats, but not both.
+        anonymous_format = repository.RepositoryFormat6()
+        identifiable_format = repository.RepositoryFormat7()
+        try:
+            found_transport = dir.get_repository_transport(anonymous_format)
+            self.assertRaises(errors.IncompatibleFormat,
+                              dir.get_repository_transport,
+                              identifiable_format)
+        except errors.IncompatibleFormat:
+            found_transport = dir.get_repository_transport(identifiable_format)
+        self.assertTrue(isinstance(found_transport, transport.Transport))
+        # and the dir which has been initialized for us must be statable.
+        found_transport.stat('.')
+
+    def test_get_workingtree_transport(self):
+        dir = self.make_bzrdir('.')
+        # without a format, get_workingtree_transport gives use a transport
+        # which -may- point to an existing dir.
+        self.assertTrue(isinstance(dir.get_workingtree_transport(None),
+                                   transport.Transport))
+        # with a given format, either the bzr dir supports identifiable
+        # trees, or it supports anonymous tree formats, but not both.
+        anonymous_format = workingtree.WorkingTreeFormat2()
+        identifiable_format = workingtree.WorkingTreeFormat3()
+        try:
+            found_transport = dir.get_workingtree_transport(anonymous_format)
+            self.assertRaises(errors.IncompatibleFormat,
+                              dir.get_workingtree_transport,
+                              identifiable_format)
+        except errors.IncompatibleFormat:
+            found_transport = dir.get_workingtree_transport(identifiable_format)
+        self.assertTrue(isinstance(found_transport, transport.Transport))
+        # and the dir which has been initialized for us must be statable.
+        found_transport.stat('.')
+
+    def test_root_transport(self):
+        dir = self.make_bzrdir('.')
+        self.assertEqual(dir.root_transport.base,
+                         get_transport(self.get_url('.')).base)
+
+    def test_find_repository_no_repo_under_standalone_branch(self):
+        # finding a repo stops at standalone branches even if there is a
+        # higher repository available.
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate/child')
+        made_control = self.bzrdir_format.initialize(url)
+        made_control.create_repository()
+        innermost_control = self.bzrdir_format.initialize(
+            self.get_url('intermediate/child'))
+        try:
+            child_repo = innermost_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        self.assertRaises(errors.NoRepositoryPresent,
+                          innermost_control.find_repository)
+
+    def test_find_repository_containing_shared_repository(self):
+        # find repo inside a shared repo with an empty control dir
+        # returns the shared repo.
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('childbzrdir')
+        get_transport(self.get_url()).mkdir('childbzrdir')
+        made_control = self.bzrdir_format.initialize(url)
+        try:
+            child_repo = made_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        found_repo = made_control.find_repository()
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+        
+    def test_find_repository_standalone_with_containing_shared_repository(self):
+        # find repo inside a standalone repo inside a shared repo finds the standalone repo
+        try:
+            containing_repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        child_repo = self.make_repository('childrepo')
+        opened_control = bzrdir.BzrDir.open(self.get_url('childrepo'))
+        found_repo = opened_control.find_repository()
+        self.assertEqual(child_repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+
+    def test_find_repository_shared_within_shared_repository(self):
+        # find repo at a shared repo inside a shared repo finds the inner repo
+        try:
+            containing_repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('childrepo')
+        get_transport(self.get_url()).mkdir('childrepo')
+        child_control = self.bzrdir_format.initialize(url)
+        child_repo = child_control.create_repository(shared=True)
+        opened_control = bzrdir.BzrDir.open(self.get_url('childrepo'))
+        found_repo = opened_control.find_repository()
+        self.assertEqual(child_repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+        self.assertNotEqual(child_repo.bzrdir.root_transport.base,
+                            containing_repo.bzrdir.root_transport.base)
+
+    def test_find_repository_with_nested_dirs_works(self):
+        # find repo inside a bzrdir inside a bzrdir inside a shared repo 
+        # finds the outer shared repo.
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            # need a shared repository to test this.
+            return
+        url = self.get_url('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate')
+        get_transport(self.get_url()).mkdir('intermediate/child')
+        made_control = self.bzrdir_format.initialize(url)
+        try:
+            child_repo = made_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        innermost_control = self.bzrdir_format.initialize(
+            self.get_url('intermediate/child'))
+        try:
+            child_repo = innermost_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        found_repo = innermost_control.find_repository()
+        self.assertEqual(repo.bzrdir.root_transport.base,
+                         found_repo.bzrdir.root_transport.base)
+        
+    def test_can_and_needs_format_conversion(self):
+        # check that we can ask an instance if its upgradable
+        dir = self.make_bzrdir('.')
+        if dir.can_convert_format():
+            # if its default updatable there must be an updater 
+            # (we change the default to match the lastest known format
+            # as downgrades may not be available
+            old_format = bzrdir.BzrDirFormat.get_default_format()
+            bzrdir.BzrDirFormat.set_default_format(dir._format)
+            try:
+                self.assertTrue(isinstance(dir._format.get_converter(),
+                                           bzrdir.Converter))
+            finally:
+                bzrdir.BzrDirFormat.set_default_format(old_format)
+        dir.needs_format_conversion(None)
+
+    def test_upgrade_new_instance(self):
+        """Does an available updater work ?."""
+        dir = self.make_bzrdir('.')
+        # for now, check is not ready for partial bzrdirs.
+        dir.create_repository()
+        dir.create_branch()
+        dir.create_workingtree()
+        if dir.can_convert_format():
+            # if its default updatable there must be an updater 
+            # (we change the default to match the lastest known format
+            # as downgrades may not be available
+            old_format = bzrdir.BzrDirFormat.get_default_format()
+            bzrdir.BzrDirFormat.set_default_format(dir._format)
+            try:
+                dir._format.get_converter(None).convert(dir,
+                    ui.ui_factory.progress_bar())
+            finally:
+                bzrdir.BzrDirFormat.set_default_format(old_format)
+            # and it should pass 'check' now.
+            check(bzrdir.BzrDir.open(self.get_url('.')).open_branch(), False)
+
+
+class ChrootedBzrDirTests(ChrootedTestCase):
+
+    def test_find_repository_no_repository(self):
+        # loopback test to check the current format fails to find a 
+        # share repository correctly.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        # supported formats must be able to init and open
+        url = self.get_url('subdir')
+        get_transport(self.get_url()).mkdir('subdir')
+        made_control = self.bzrdir_format.initialize(url)
+        try:
+            repo = made_control.open_repository()
+            # if there is a repository, then the format cannot ever hit this 
+            # code path.
+            return
+        except errors.NoRepositoryPresent:
+            pass
+        opened_control = bzrdir.BzrDir.open(self.get_readonly_url('subdir'))
+        self.assertRaises(errors.NoRepositoryPresent,
+                          opened_control.find_repository)
+

=== added directory 'bzrlib/tests/interrepository_implementations'
=== added file 'bzrlib/tests/interrepository_implementations/__init__.py'
--- bzrlib/tests/interrepository_implementations/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/interrepository_implementations/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,54 @@
+# Copyright (C) 2006 by Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""InterRepository implementation tests for bzr.
+
+These test the conformance of all the interrepository variations to the
+expected API including generally applicable corner cases.
+Specific tests for individual formats are in the tests/test_repository.py file 
+rather than in tests/interrepository_implementations/*.py.
+"""
+
+from bzrlib.repository import (_legacy_formats,
+                               InterRepositoryTestProviderAdapter,
+                               )
+                            
+from bzrlib.tests import (
+                          adapt_modules,
+                          default_transport,
+                          TestLoader,
+                          TestSuite,
+                          )
+
+
+def test_suite():
+    result = TestSuite()
+    test_interrepository_implementations = [
+        'bzrlib.tests.interrepository_implementations.test_interrepository',
+        ]
+    adapter = InterRepositoryTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        InterRepositoryTestProviderAdapter.default_test_list()
+        )
+    loader = TestLoader()
+    adapt_modules(test_interrepository_implementations, adapter, loader, result)
+    return result

=== added file 'bzrlib/tests/interrepository_implementations/test_interrepository.py'
--- bzrlib/tests/interrepository_implementations/test_interrepository.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/interrepository_implementations/test_interrepository.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,213 @@
+# (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for InterRepository implementastions."""
+
+
+import bzrlib
+import bzrlib.bzrdir as bzrdir
+from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+import bzrlib.errors as errors
+from bzrlib.errors import (FileExists,
+                           NoSuchRevision,
+                           NoSuchFile,
+                           UninitializableFormat,
+                           NotBranchError,
+                           )
+import bzrlib.repository as repository
+from bzrlib.revision import NULL_REVISION
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
+from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
+from bzrlib.transport import get_transport
+
+
+class TestCaseWithInterRepository(TestCaseWithBzrDir):
+
+    def setUp(self):
+        super(TestCaseWithInterRepository, self).setUp()
+
+    def make_branch(self, relpath):
+        repo = self.make_repository(relpath)
+        return repo.bzrdir.create_branch()
+
+    def make_bzrdir(self, relpath, bzrdir_format=None):
+        try:
+            url = self.get_url(relpath)
+            segments = url.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = '/'.join(segments[:-1])
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except FileExists:
+                    pass
+            if bzrdir_format is None:
+                bzrdir_format = self.repository_format._matchingbzrdir
+            return bzrdir_format.initialize(url)
+        except UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable.")
+
+    def make_repository(self, relpath):
+        made_control = self.make_bzrdir(relpath)
+        return self.repository_format.initialize(made_control)
+
+    def make_to_repository(self, relpath):
+        made_control = self.make_bzrdir(relpath,
+            self.repository_format_to._matchingbzrdir)
+        return self.repository_format_to.initialize(made_control)
+
+
+class TestInterRepository(TestCaseWithInterRepository):
+
+    def test_interrepository_get_returns_correct_optimiser(self):
+        # we assume the optimising code paths are triggered
+        # by the type of the repo not the transport - at this point.
+        # we may need to update this test if this changes.
+        source_repo = self.make_repository("source")
+        target_repo = self.make_to_repository("target")
+        interrepo = repository.InterRepository.get(source_repo, target_repo)
+        self.assertEqual(self.interrepo_class, interrepo.__class__)
+
+    def test_fetch(self):
+        tree_a = self.make_branch_and_tree('a')
+        self.build_tree(['a/foo'])
+        tree_a.add('foo', 'file1')
+        tree_a.commit('rev1', rev_id='rev1')
+        def check_push_rev1(repo):
+            # ensure the revision is missing.
+            self.assertRaises(NoSuchRevision, repo.get_revision, 'rev1')
+            # fetch with a limit of NULL_REVISION and an explicit progress bar.
+            repo.fetch(tree_a.branch.repository,
+                       revision_id=NULL_REVISION,
+                       pb=bzrlib.progress.DummyProgress())
+            # nothing should have been pushed
+            self.assertFalse(repo.has_revision('rev1'))
+            # fetch with a default limit (grab everything)
+            repo.fetch(tree_a.branch.repository)
+            # check that b now has all the data from a's first commit.
+            rev = repo.get_revision('rev1')
+            tree = repo.revision_tree('rev1')
+            tree.get_file_text('file1')
+            for file_id in tree:
+                if tree.inventory[file_id].kind == "file":
+                    tree.get_file(file_id).read()
+
+        # makes a target version repo 
+        repo_b = self.make_to_repository('b')
+        check_push_rev1(repo_b)
+        
+    def test_fetch_missing_revision_same_location_fails(self):
+        repo_a = self.make_repository('.')
+        repo_b = repository.Repository.open('.')
+        self.assertRaises(errors.NoSuchRevision, repo_b.fetch, repo_a, revision_id='XXX')
+
+    def test_fetch_same_location_trivial_works(self):
+        repo_a = self.make_repository('.')
+        repo_b = repository.Repository.open('.')
+        repo_a.fetch(repo_b)
+
+
+class TestCaseWithComplexRepository(TestCaseWithInterRepository):
+
+    def setUp(self):
+        super(TestCaseWithComplexRepository, self).setUp()
+        tree_a = self.make_branch_and_tree('a')
+        self.bzrdir = tree_a.branch.bzrdir
+        # add a corrupt inventory 'orphan'
+        tree_a.branch.repository.control_weaves.add_text(
+            'inventory', 'orphan', [], [],
+            tree_a.branch.repository.get_transaction())
+        # add a real revision 'rev1'
+        tree_a.commit('rev1', rev_id='rev1', allow_pointless=True)
+        # add a real revision 'rev2' based on rev1
+        tree_a.commit('rev2', rev_id='rev2', allow_pointless=True)
+        # and sign 'rev2'
+        tree_a.branch.repository.sign_revision('rev2',
+            bzrlib.gpg.LoopbackGPGStrategy(None))
+
+    def test_missing_revision_ids(self):
+        # revision ids in repository A but not B are returned, fake ones
+        # are stripped. (fake meaning no revision object, but an inventory 
+        # as some formats keyed off inventory data in the past.
+        # make a repository to compare against that claims to have rev1
+        repo_b = self.make_to_repository('rev1_only')
+        repo_a = self.bzrdir.open_repository()
+        repo_b.fetch(repo_a, 'rev1')
+        # check the test will be valid
+        self.assertFalse(repo_b.has_revision('rev2'))
+        self.assertEqual(['rev2'],
+                         repo_b.missing_revision_ids(repo_a))
+
+    def test_missing_revision_ids_revision_limited(self):
+        # revision ids in repository A that are not referenced by the
+        # requested revision are not returned.
+        # make a repository to compare against that is empty
+        repo_b = self.make_to_repository('empty')
+        repo_a = self.bzrdir.open_repository()
+        self.assertEqual(['rev1'],
+                         repo_b.missing_revision_ids(repo_a, revision_id='rev1'))
+        
+    def test_fetch_preserves_signatures(self):
+        from_repo = self.bzrdir.open_repository()
+        from_signature = from_repo.revision_store.get('rev2', 'sig').read()
+        to_repo = self.make_to_repository('target')
+        to_repo.fetch(from_repo)
+        to_signature = to_repo.revision_store.get('rev2', 'sig').read()
+        self.assertEqual(from_signature, to_signature)
+
+
+class TestCaseWithGhosts(TestCaseWithInterRepository):
+
+    def setUp(self):
+        super(TestCaseWithGhosts, self).setUp()
+        # we want two repositories at this point
+        # one with a revision that is a ghost in the other
+        # repository.
+
+        # 'ghost' is a ghost in missing_ghost and not in with_ghost_rev
+        inv = bzrlib.tree.EmptyTree().inventory
+        repo = self.make_repository('with_ghost_rev')
+        sha1 = repo.add_inventory('ghost', inv, [])
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       inventory_sha1=sha1,
+                                       revision_id='ghost')
+        rev.parent_ids = []
+        repo.add_revision('ghost', rev)
+         
+        repo = self.make_to_repository('missing_ghost')
+        sha1 = repo.add_inventory('with_ghost', inv, [])
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       inventory_sha1=sha1,
+                                       revision_id='with_ghost')
+        rev.parent_ids = ['ghost']
+        repo.add_revision('with_ghost', rev)
+
+    def test_fetch_all_fixes_up_ghost(self):
+        # fetching from a repo with a current ghost unghosts it in referencing
+        # revisions.
+        repo = repository.Repository.open('missing_ghost')
+        rev = repo.get_revision('with_ghost')
+        from_repo = repository.Repository.open('with_ghost_rev')
+        repo.fetch(from_repo)
+        # rev must not be corrupt now
+        rev = repo.get_revision('with_ghost')
+        self.assertEqual([None, 'ghost', 'with_ghost'], repo.get_ancestry('with_ghost'))

=== added directory 'bzrlib/tests/repository_implementations'
=== added file 'bzrlib/tests/repository_implementations/__init__.py'
--- bzrlib/tests/repository_implementations/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/repository_implementations/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,56 @@
+# Copyright (C) 2006 by Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""BzrDir implementation tests for bzr.
+
+These test the conformance of all the repository variations to the expected API.
+Specific tests for individual formats are in the tests/test_repository.py file 
+rather than in tests/branch_implementations/*.py.
+"""
+
+from bzrlib.repository import (_legacy_formats,
+                               RepositoryFormat,
+                               RepositoryTestProviderAdapter,
+                               )
+                            
+from bzrlib.tests import (
+                          adapt_modules,
+                          default_transport,
+                          TestLoader,
+                          TestSuite,
+                          )
+
+
+def test_suite():
+    result = TestSuite()
+    test_repository_implementations = [
+        'bzrlib.tests.repository_implementations.test_fileid_involved',
+        'bzrlib.tests.repository_implementations.test_reconcile',
+        'bzrlib.tests.repository_implementations.test_repository',
+        ]
+    adapter = RepositoryTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        [(format, format._matchingbzrdir) for format in 
+         RepositoryFormat._formats.values() + _legacy_formats])
+    loader = TestLoader()
+    adapt_modules(test_repository_implementations, adapter, loader, result)
+    return result

=== added file 'bzrlib/tests/repository_implementations/test_fileid_involved.py'
--- bzrlib/tests/repository_implementations/test_fileid_involved.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/repository_implementations/test_fileid_involved.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,227 @@
+# Copyright (C) 2005 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+
+from bzrlib.add import smart_add
+from bzrlib.builtins import merge
+from bzrlib.delta import compare_trees
+from bzrlib.merge import merge_inner
+from bzrlib.revision import common_ancestor
+from bzrlib.tests.repository_implementations.test_repository import TestCaseWithRepository
+from bzrlib.workingtree import WorkingTree
+
+
+class FileIdInvolvedBase(TestCaseWithRepository):
+
+    def touch(self,filename):
+        f = file(filename,"a")
+        f.write("appended line\n")
+        f.close( )
+
+    def merge(self, branch_from, wt_to):
+        # minimal ui-less merge.
+        wt_to.branch.fetch(branch_from)
+        base_rev = common_ancestor(branch_from.last_revision(),
+                                    wt_to.branch.last_revision(),
+                                    wt_to.branch.repository)
+        merge_inner(wt_to.branch, branch_from.basis_tree(), 
+                    wt_to.branch.repository.revision_tree(base_rev),
+                    this_tree=wt_to)
+        wt_to.add_pending_merge(branch_from.last_revision())
+
+    def compare_tree_fileids(self, branch, old_rev, new_rev):
+        old_tree = self.branch.repository.revision_tree(old_rev)
+        new_tree = self.branch.repository.revision_tree(new_rev)
+        delta = compare_trees(old_tree, new_tree)
+
+        l2 = [id for path, id, kind in delta.added] + \
+             [id for oldpath, newpath, id, kind, text_modified, \
+                meta_modified in delta.renamed] + \
+             [id for path, id, kind, text_modified, meta_modified in \
+                delta.modified]
+        return set(l2)
+
+    
+class TestFileIdInvolved(FileIdInvolvedBase):
+
+    def setUp(self):
+        super(TestFileIdInvolved, self).setUp()
+        # create three branches, and merge it
+        #
+        #           /-->J ------>K                (branch2)
+        #          /              \
+        #  A ---> B --->C ---->D->G               (main)
+        #  \           /      /
+        #   \---> E---/----> F                 (branch1)
+
+        main_wt = self.make_branch_and_tree('main')
+        main_branch = main_wt.branch
+        self.build_tree(["main/a","main/b","main/c"])
+
+        main_wt.add(['a', 'b', 'c'], ['a-file-id-2006-01-01-abcd',
+                                 'b-file-id-2006-01-01-defg',
+                                 'c-funky<file-id> quiji%bo'])
+        main_wt.commit("Commit one", rev_id="rev-A")
+        #-------- end A -----------
+
+        d1 = main_branch.bzrdir.clone('branch1')
+        b1 = d1.open_branch()
+        self.build_tree(["branch1/d"])
+        bt1 = d1.open_workingtree()
+        bt1.add('d')
+        bt1.commit("branch1, Commit one", rev_id="rev-E")
+
+        #-------- end E -----------
+
+        self.touch("main/a")
+        main_wt.commit("Commit two", rev_id="rev-B")
+
+        #-------- end B -----------
+
+        d2 = main_branch.bzrdir.clone('branch2')
+        branch2_branch = d2.open_branch()
+        bt2 = d2.open_workingtree()
+        os.chmod("branch2/b",0770)
+        bt2.commit("branch2, Commit one", rev_id="rev-J")
+
+        #-------- end J -----------
+
+        self.merge(b1, main_wt)
+        main_wt.commit("merge branch1, rev-11", rev_id="rev-C")
+
+        #-------- end C -----------
+
+        bt1.rename_one("d","e")
+        bt1.commit("branch1, commit two", rev_id="rev-F")
+
+        #-------- end F -----------
+
+        self.touch("branch2/c")
+        bt2.commit("branch2, commit two", rev_id="rev-K")
+
+        #-------- end K -----------
+
+        self.touch("main/b")
+        self.merge(b1, main_wt)
+        # D gets some funky characters to make sure the unescaping works
+        main_wt.commit("merge branch1, rev-12", rev_id="rev-<D>")
+
+        # end D
+
+        self.merge(branch2_branch, main_wt)
+        main_wt.commit("merge branch1, rev-22",  rev_id="rev-G")
+
+        # end G
+        self.branch = main_branch
+
+
+    def test_fileid_involved_all_revs(self):
+
+        l = self.branch.repository.fileid_involved( )
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["a","b","c","d"])
+
+    def test_fileid_involved_one_rev(self):
+
+        l = self.branch.repository.fileid_involved("rev-B" )
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["a","b","c"])
+
+    def test_fileid_involved_two_revs(self):
+
+        l = self.branch.repository.fileid_involved_between_revs("rev-B","rev-K" )
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["b","c"])
+
+        l = self.branch.repository.fileid_involved_between_revs("rev-C","rev-<D>" )
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["b","d"])
+
+        l = self.branch.repository.fileid_involved_between_revs("rev-C","rev-G" )
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["b","c","d"])
+
+        l = self.branch.repository.fileid_involved_between_revs("rev-E","rev-G" )
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["a", "b","c","d"])
+
+    def test_fileid_involved_sets(self):
+
+        l = self.branch.repository.fileid_involved_by_set(set(["rev-B"]))
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["a"])
+
+        l = self.branch.repository.fileid_involved_by_set(set(["rev-<D>"]))
+        self.assertEquals( sorted(map( lambda x: x[0], l )), ["b"])
+
+    def test_fileid_involved_compare(self):
+
+        l1 = self.branch.repository.fileid_involved_between_revs("rev-E", "rev-<D>")
+        l2 = self.branch.repository.fileid_involved_by_set(set(["rev-<D>","rev-F","rev-C","rev-B"]))
+        self.assertEquals( l1, l2 )
+
+        l1 = self.branch.repository.fileid_involved_between_revs("rev-C", "rev-G")
+        l2 = self.branch.repository.fileid_involved_by_set(
+            set(["rev-G","rev-<D>","rev-F","rev-K","rev-J"]))
+        self.assertEquals( l1, l2 )
+
+    def test_fileid_involved_full_compare(self):
+        pp=[]
+        history = self.branch.revision_history( )
+
+        if len(history) < 2: return
+
+        for start in range(0,len(history)-1):
+            start_id = history[start]
+            for end in range(start+1,len(history)):
+                end_id = history[end]
+                l1 = self.branch.repository.fileid_involved_between_revs(
+                    start_id, end_id)
+                l2 = self.compare_tree_fileids(self.branch, start_id, end_id)
+                self.assertEquals(l1, l2)
+
+
+class TestFileIdInvolvedSuperset(FileIdInvolvedBase):
+
+    def setUp(self):
+        super(TestFileIdInvolvedSuperset, self).setUp()
+
+        main_wt = self.make_branch_and_tree('main')
+        main_branch = main_wt.branch
+        self.build_tree(["main/a","main/b","main/c"])
+
+        main_wt.add(['a', 'b', 'c'], ['a-file-id-2006-01-01-abcd',
+                                 'b-file-id-2006-01-01-defg',
+                                 'c-funky<file-id> quiji%bo'])
+        main_wt.commit("Commit one", rev_id="rev-A")
+
+        branch2_bzrdir = main_branch.bzrdir.sprout("branch2")
+        branch2_branch = branch2_bzrdir.open_branch()
+        branch2_wt = branch2_bzrdir.open_workingtree()
+        os.chmod("branch2/b",0770)
+        branch2_wt.commit("branch2, Commit one", rev_id="rev-J")
+
+        self.merge(branch2_branch, main_wt)
+        os.chmod("main/b",0660)
+        main_wt.commit("merge branch1, rev-22",  rev_id="rev-G")
+
+        # end G
+        self.branch = main_branch
+
+    def test_fileid_involved_full_compare2(self):
+        history = self.branch.revision_history()
+        old_rev = history[0]
+        new_rev = history[1]
+
+        l1 = self.branch.repository.fileid_involved_between_revs(old_rev, new_rev)
+
+        l2 = self.compare_tree_fileids(self.branch, old_rev, new_rev)
+        self.assertNotEqual(l2, l1)
+        self.assertSubset(l2, l1)

=== added file 'bzrlib/tests/repository_implementations/test_reconcile.py'
--- bzrlib/tests/repository_implementations/test_reconcile.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/repository_implementations/test_reconcile.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,177 @@
+# Copyright (C) 2006 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for reconiliation of repositories."""
+
+
+import bzrlib
+import bzrlib.errors as errors
+from bzrlib.reconcile import reconcile, Reconciler, RepoReconciler
+from bzrlib.revision import Revision
+from bzrlib.tests.repository_implementations.test_repository import TestCaseWithRepository
+from bzrlib.transport import get_transport
+from bzrlib.tree import EmptyTree
+from bzrlib.workingtree import WorkingTree
+
+
+class TestsNeedingReweave(TestCaseWithRepository):
+
+    def setUp(self):
+        super(TestsNeedingReweave, self).setUp()
+        
+        t = get_transport(self.get_url())
+        # an empty inventory with no revision for testing with.
+        # this is referenced by 'references_missing' to let us test
+        # that all the cached data is correctly converted into ghost links
+        # and the referenced inventory still cleaned.
+        repo = self.make_repository('inventory_without_revision')
+        inv = EmptyTree().inventory
+        repo.add_inventory('missing', inv, [])
+        sha1 = repo.add_inventory('references_missing', inv, ['missing'])
+        rev = Revision(timestamp=0,
+                       timezone=None,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1=sha1,
+                       revision_id='references_missing')
+        rev.parent_ids = ['missing']
+        repo.add_revision('references_missing', rev)
+
+        # a inventory with no parents and the revision has parents..
+        # i.e. a ghost.
+        repo = self.make_repository('inventory_one_ghost')
+        sha1 = repo.add_inventory('ghost', inv, [])
+        rev = Revision(timestamp=0,
+                       timezone=None,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1=sha1,
+                       revision_id='ghost')
+        rev.parent_ids = ['the_ghost']
+        repo.add_revision('ghost', rev)
+         
+        # a inventory with a ghost that can be corrected now.
+        t.copy_tree('inventory_one_ghost', 'inventory_ghost_present')
+        repo = bzrlib.repository.Repository.open('inventory_ghost_present')
+        sha1 = repo.add_inventory('the_ghost', inv, [])
+        rev = Revision(timestamp=0,
+                       timezone=None,
+                       committer="Foo Bar <foo@example.com>",
+                       message="Message",
+                       inventory_sha1=sha1,
+                       revision_id='the_ghost')
+        rev.parent_ids = []
+        repo.add_revision('the_ghost', rev)
+
+    def test_reweave_empty(self):
+        self.make_repository('empty')
+        d = bzrlib.bzrdir.BzrDir.open('empty')
+        # calling on a empty repository should do nothing
+        reconciler = RepoReconciler(d.find_repository())
+        reconciler.reconcile()
+        # no inconsistent parents should have been found
+        self.assertEqual(0, reconciler.inconsistent_parents)
+        # and no garbage inventories
+        self.assertEqual(0, reconciler.garbage_inventories)
+        # and no backup weave should have been needed/made.
+        repo = d.open_repository()
+        self.assertRaises(errors.NoSuchFile,
+                          repo.control_weaves.get_weave,
+                          'inventory.backup',
+                          repo.get_transaction())
+
+    def test_reweave_inventory_without_revision_reconcile(self):
+        # smoke test for the all in one ui tool
+        d = bzrlib.bzrdir.BzrDir.open('inventory_without_revision')
+        reconcile(d)
+        # now the backup should have it but not the current inventory
+        repo = d.open_repository()
+        backup = repo.control_weaves.get_weave('inventory.backup',
+                                               repo.get_transaction())
+        self.assertTrue('missing' in backup.names())
+        self.assertRaises(errors.WeaveRevisionNotPresent,
+                          repo.get_inventory, 'missing')
+
+    def test_reweave_inventory_without_revision_reconciler(self):
+        # smoke test for the all in one Reconciler class,
+        # other tests use the lower level RepoReconciler.
+        d = bzrlib.bzrdir.BzrDir.open('inventory_without_revision')
+        reconciler = Reconciler(d)
+        reconciler.reconcile()
+        # no inconsistent parents should have been found
+        self.assertEqual(1, reconciler.inconsistent_parents)
+        # and one garbage inventories
+        self.assertEqual(1, reconciler.garbage_inventories)
+        # now the backup should have it but not the current inventory
+        repo = d.open_repository()
+        backup = repo.control_weaves.get_weave('inventory.backup',
+                                               repo.get_transaction())
+        self.assertTrue('missing' in backup.names())
+        self.assertRaises(errors.WeaveRevisionNotPresent,
+                          repo.get_inventory, 'missing')
+
+    def test_reweave_inventory_without_revision(self):
+        # actual low level test.
+        d = bzrlib.bzrdir.BzrDir.open('inventory_without_revision')
+        reconciler = RepoReconciler(d.open_repository())
+        reconciler.reconcile()
+        # no inconsistent parents should have been found
+        self.assertEqual(1, reconciler.inconsistent_parents)
+        # and one garbage inventories
+        self.assertEqual(1, reconciler.garbage_inventories)
+        # now the backup should have it but not the current inventory
+        repo = d.open_repository()
+        backup = repo.control_weaves.get_weave('inventory.backup',
+                                               repo.get_transaction())
+        self.assertTrue('missing' in backup.names())
+        self.assertRaises(errors.WeaveRevisionNotPresent,
+                          repo.get_inventory, 'missing')
+        # and the parent list for 'references_missing' should have that
+        # revision a ghost now.
+        self.assertEqual([None, 'references_missing'],
+                         repo.get_ancestry('references_missing'))
+
+    def test_reweave_inventory_preserves_a_revision_with_ghosts(self):
+        d = bzrlib.bzrdir.BzrDir.open('inventory_one_ghost')
+        reconciler = RepoReconciler(d.open_repository())
+        reconciler.reconcile()
+        # no inconsistent parents should have been found: 
+        # the lack of a parent for ghost is normal
+        self.assertEqual(0, reconciler.inconsistent_parents)
+        # and one garbage inventories
+        self.assertEqual(0, reconciler.garbage_inventories)
+        # now the current inventory should still have 'ghost'
+        repo = d.open_repository()
+        repo.get_inventory('ghost')
+        self.assertEqual([None, 'ghost'], repo.get_ancestry('ghost'))
+        
+    def test_reweave_inventory_fixes_ancestryfor_a_present_ghost(self):
+        d = bzrlib.bzrdir.BzrDir.open('inventory_ghost_present')
+        repo = d.open_repository()
+        self.assertEqual([None, 'ghost'], repo.get_ancestry('ghost'))
+        reconciler = RepoReconciler(repo)
+        reconciler.reconcile()
+        # one inconsistent parents should have been found : the
+        # available but not reference parent for ghost.
+        self.assertEqual(1, reconciler.inconsistent_parents)
+        # and no garbage inventories
+        self.assertEqual(0, reconciler.garbage_inventories)
+        # now the current inventory should still have 'ghost'
+        repo = d.open_repository()
+        repo.get_inventory('ghost')
+        repo.get_inventory('the_ghost')
+        self.assertEqual([None, 'the_ghost', 'ghost'], repo.get_ancestry('ghost'))
+        self.assertEqual([None, 'the_ghost'], repo.get_ancestry('the_ghost'))

=== added file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,326 @@
+# (C) 2005, 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for bzrdir implementations - tests a bzrdir format."""
+
+import os
+import sys
+
+import bzrlib
+import bzrlib.bzrdir as bzrdir
+from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
+from bzrlib.commit import commit
+import bzrlib.errors as errors
+from bzrlib.errors import (FileExists,
+                           NoSuchRevision,
+                           NoSuchFile,
+                           UninitializableFormat,
+                           NotBranchError,
+                           )
+import bzrlib.repository as repository
+from bzrlib.revision import NULL_REVISION
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
+from bzrlib.tests.bzrdir_implementations.test_bzrdir import TestCaseWithBzrDir
+from bzrlib.trace import mutter
+import bzrlib.transactions as transactions
+from bzrlib.transport import get_transport
+from bzrlib.upgrade import upgrade
+from bzrlib.workingtree import WorkingTree
+
+
+class TestCaseWithRepository(TestCaseWithBzrDir):
+
+    def setUp(self):
+        super(TestCaseWithRepository, self).setUp()
+
+    def make_branch(self, relpath):
+        repo = self.make_repository(relpath)
+        return repo.bzrdir.create_branch()
+
+    def make_bzrdir(self, relpath):
+        try:
+            url = self.get_url(relpath)
+            segments = url.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = '/'.join(segments[:-1])
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except FileExists:
+                    pass
+            return self.bzrdir_format.initialize(url)
+        except UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable.")
+
+    def make_repository(self, relpath):
+        made_control = self.make_bzrdir(relpath)
+        return self.repository_format.initialize(made_control)
+
+
+class TestRepository(TestCaseWithRepository):
+
+    def test_clone_to_default_format(self):
+        #TODO: Test that cloning a repository preserves all the information
+        # such as signatures[not tested yet] etc etc.
+        # when changing to the current default format.
+        tree_a = self.make_branch_and_tree('a')
+        self.build_tree(['a/foo'])
+        tree_a.add('foo', 'file1')
+        tree_a.commit('rev1', rev_id='rev1')
+        bzrdirb = self.make_bzrdir('b')
+        repo_b = tree_a.branch.repository.clone(bzrdirb)
+        tree_b = repo_b.revision_tree('rev1')
+        tree_b.get_file_text('file1')
+        rev1 = repo_b.get_revision('rev1')
+
+    def test_clone_specific_format(self):
+        """todo"""
+
+    def test_format_initialize_find_open(self):
+        # loopback test to check the current format initializes to itself.
+        if not self.repository_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        # supported formats must be able to init and open
+        t = get_transport(self.get_url())
+        readonly_t = get_transport(self.get_readonly_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = self.repository_format.initialize(made_control)
+        self.failUnless(isinstance(made_repo, repository.Repository))
+        self.assertEqual(made_control, made_repo.bzrdir)
+
+        # find it via bzrdir opening:
+        opened_control = bzrdir.BzrDir.open(readonly_t.base)
+        direct_opened_repo = opened_control.open_repository()
+        self.assertEqual(direct_opened_repo.__class__, made_repo.__class__)
+        self.assertEqual(opened_control, direct_opened_repo.bzrdir)
+
+        self.failUnless(isinstance(direct_opened_repo._format,
+                        self.repository_format.__class__))
+        # find it via Repository.open
+        opened_repo = repository.Repository.open(readonly_t.base)
+        self.failUnless(isinstance(opened_repo, made_repo.__class__))
+        self.assertEqual(made_repo._format.__class__,
+                         opened_repo._format.__class__)
+        # if it has a unique id string, can we probe for it ?
+        try:
+            self.repository_format.get_format_string()
+        except NotImplementedError:
+            return
+        self.assertEqual(self.repository_format,
+                         repository.RepositoryFormat.find_format(opened_control))
+
+    def test_create_repository(self):
+        # bzrdir can construct a repository for itself.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        t = get_transport(self.get_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        made_repo = made_control.create_repository()
+        self.failUnless(isinstance(made_repo, repository.Repository))
+        self.assertEqual(made_control, made_repo.bzrdir)
+        
+    def test_create_repository_shared(self):
+        # bzrdir can construct a shared repository.
+        if not self.bzrdir_format.is_supported():
+            # unsupported formats are not loopback testable
+            # because the default open will not open them and
+            # they may not be initializable.
+            return
+        t = get_transport(self.get_url())
+        made_control = self.bzrdir_format.initialize(t.base)
+        try:
+            made_repo = made_control.create_repository(shared=True)
+        except errors.IncompatibleFormat:
+            # not all repository formats understand being shared, or
+            # may only be shared in some circumstances.
+            return
+        self.failUnless(isinstance(made_repo, repository.Repository))
+        self.assertEqual(made_control, made_repo.bzrdir)
+        self.assertTrue(made_repo.is_shared())
+
+    def test_revision_tree(self):
+        wt = self.make_branch_and_tree('.')
+        wt.commit('lala!', rev_id='revision-1', allow_pointless=True)
+        tree = wt.branch.repository.revision_tree('revision-1')
+        self.assertEqual(list(tree.list_files()), [])
+        tree = wt.branch.repository.revision_tree(None)
+        self.assertEqual(len(tree.list_files()), 0)
+        tree = wt.branch.repository.revision_tree(NULL_REVISION)
+        self.assertEqual(len(tree.list_files()), 0)
+
+    def test_fetch(self):
+        # smoke test fetch to ensure that the convenience function works.
+        # it is defined as a convenience function with the underlying 
+        # functionality provided by an InterRepository
+        tree_a = self.make_branch_and_tree('a')
+        self.build_tree(['a/foo'])
+        tree_a.add('foo', 'file1')
+        tree_a.commit('rev1', rev_id='rev1')
+        # fetch with a default limit (grab everything)
+        repo = bzrdir.BzrDir.create_repository(self.get_url('b'))
+        repo.fetch(tree_a.branch.repository,
+                   revision_id=None,
+                   pb=bzrlib.progress.DummyProgress())
+
+    def test_clone_bzrdir_repository_revision(self):
+        # make a repository with some revisions,
+        # and clone it, this should not have unreferenced revisions.
+        # also: test cloning with a revision id of NULL_REVISION -> empty repo.
+        raise TestSkipped('revision limiting is not implemented yet.')
+
+    def test_clone_repository_basis_revision(self):
+        raise TestSkipped('the use of a basis should not add noise data to the result.')
+
+    def test_clone_repository_incomplete_source_with_basis(self):
+        # ensure that basis really does grab from the basis by having incomplete source
+        tree = self.make_branch_and_tree('commit_tree')
+        self.build_tree(['foo'], transport=tree.bzrdir.transport.clone('..'))
+        tree.add('foo')
+        tree.commit('revision 1', rev_id='1')
+        source = self.make_repository('source')
+        # this gives us an incomplete repository
+        tree.bzrdir.open_repository().copy_content_into(source)
+        tree.commit('revision 2', rev_id='2', allow_pointless=True)
+        self.assertFalse(source.has_revision('2'))
+        target = source.bzrdir.clone(self.get_url('target'), basis=tree.bzrdir)
+        self.assertTrue(target.open_repository().has_revision('2'))
+
+    def test_clone_shared_no_tree(self):
+        # cloning a shared repository keeps it shared
+        # and preserves the make_working_tree setting.
+        made_control = self.make_bzrdir('source')
+        try:
+            made_repo = made_control.create_repository(shared=True)
+        except errors.IncompatibleFormat:
+            # not all repository formats understand being shared, or
+            # may only be shared in some circumstances.
+            return
+        made_repo.set_make_working_trees(False)
+        result = made_control.clone(self.get_url('target'))
+        self.failUnless(isinstance(made_repo, repository.Repository))
+        self.assertEqual(made_control, made_repo.bzrdir)
+        self.assertTrue(result.open_repository().is_shared())
+        self.assertFalse(result.open_repository().make_working_trees())
+
+    def test_upgrade_preserves_signatures(self):
+        wt = self.make_branch_and_tree('source')
+        wt.commit('A', allow_pointless=True, rev_id='A')
+        wt.branch.repository.sign_revision('A',
+            bzrlib.gpg.LoopbackGPGStrategy(None))
+        old_signature = wt.branch.repository.revision_store.get('A',
+            'sig').read()
+        try:
+            old_format = bzrdir.BzrDirFormat.get_default_format()
+            # This gives metadir branches something they can convert to.
+            # it would be nice to have a 'latest' vs 'default' concept.
+            bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+            try:
+                upgrade(wt.basedir)
+            finally:
+                bzrdir.BzrDirFormat.set_default_format(old_format)
+        except errors.UpToDateFormat:
+            # this is in the most current format already.
+            return
+        wt = WorkingTree.open(wt.basedir)
+        new_signature = wt.branch.repository.revision_store.get('A',
+            'sig').read()
+        self.assertEqual(old_signature, new_signature)
+
+
+class TestCaseWithComplexRepository(TestCaseWithRepository):
+
+    def setUp(self):
+        super(TestCaseWithComplexRepository, self).setUp()
+        tree_a = self.make_branch_and_tree('a')
+        self.bzrdir = tree_a.branch.bzrdir
+        # add a corrupt inventory 'orphan'
+        # this may need some generalising for knits.
+        tree_a.branch.repository.control_weaves.add_text(
+            'inventory', 'orphan', [], [],
+            tree_a.branch.repository.get_transaction())
+        # add a real revision 'rev1'
+        tree_a.commit('rev1', rev_id='rev1', allow_pointless=True)
+        # add a real revision 'rev2' based on rev1
+        tree_a.commit('rev2', rev_id='rev2', allow_pointless=True)
+
+    def test_all_revision_ids(self):
+        # all_revision_ids -> all revisions
+        self.assertEqual(['rev1', 'rev2'],
+                         self.bzrdir.open_repository().all_revision_ids())
+
+    def test_get_ancestry_missing_revision(self):
+        # get_ancestry(revision that is in some data but not fully installed
+        # -> NoSuchRevision
+        self.assertRaises(errors.NoSuchRevision,
+                          self.bzrdir.open_repository().get_ancestry, 'orphan')
+
+    def test_get_revision_graph(self):
+        # we can get a mapping of id->parents for the entire revision graph or bits thereof.
+        self.assertEqual({'rev1':[], 'rev2':['rev1']},
+                         self.bzrdir.open_repository().get_revision_graph(None))
+        self.assertEqual({'rev1':[]},
+                         self.bzrdir.open_repository().get_revision_graph('rev1'))
+        self.assertEqual({'rev1':[], 'rev2':['rev1']},
+                         self.bzrdir.open_repository().get_revision_graph('rev2'))
+        self.assertRaises(NoSuchRevision,
+                          self.bzrdir.open_repository().get_revision_graph,
+                          'orphan')
+
+
+class TestCaseWithCorruptRepository(TestCaseWithRepository):
+
+    def setUp(self):
+        super(TestCaseWithCorruptRepository, self).setUp()
+        # a inventory with no parents and the revision has parents..
+        # i.e. a ghost.
+        repo = self.make_repository('inventory_with_unnecessary_ghost')
+        inv = bzrlib.tree.EmptyTree().inventory
+        sha1 = repo.add_inventory('ghost', inv, [])
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       inventory_sha1=sha1,
+                                       revision_id='ghost')
+        rev.parent_ids = ['the_ghost']
+        repo.add_revision('ghost', rev)
+         
+        sha1 = repo.add_inventory('the_ghost', inv, [])
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       inventory_sha1=sha1,
+                                       revision_id='the_ghost')
+        rev.parent_ids = []
+        repo.add_revision('the_ghost', rev)
+        # check its setup usefully
+        inv_weave = repo.get_inventory_weave()
+        self.assertEqual(['ghost'], map(inv_weave.idx_to_name, inv_weave.inclusions([inv_weave.lookup('ghost')])))
+
+    def test_corrupt_revision_access_asserts(self):
+        repo = repository.Repository.open('inventory_with_unnecessary_ghost')
+        self.assertRaises(errors.CorruptRepository, repo.get_revision, 'ghost')
+
+    def test_corrupt_revision_get_revision_reconsile(self):
+        repo = repository.Repository.open('inventory_with_unnecessary_ghost')
+        repo.get_revision_reconcile('ghost')

=== modified file 'bzrlib/tests/stub_sftp.py'
--- bzrlib/tests/stub_sftp.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/stub_sftp.py	2006-03-20 08:31:00 +0000
@@ -59,13 +59,26 @@
 
 
 class StubSFTPServer (SFTPServerInterface):
-    def __init__(self, server, root):
+    def __init__(self, server, root, home=None):
         SFTPServerInterface.__init__(self, server)
         self.root = root
-        
+        if home is None:
+            self.home = self.root
+        else:
+            self.home = home[len(self.root):]
+        if (len(self.home) > 0) and (self.home[0] == '/'):
+            self.home = self.home[1:]
+        server._test_case.log('sftpserver - new connection')
+
     def _realpath(self, path):
         return self.root + self.canonicalize(path)
 
+    def canonicalize(self, path):
+        if os.path.isabs(path):
+            return os.path.normpath(path)
+        else:
+            return os.path.normpath('/' + os.path.join(self.home, path))
+
     def chattr(self, path, attr):
         try:
             SFTPServer.set_file_attr(path, attr)

=== modified file 'bzrlib/tests/test_ancestry.py'
--- bzrlib/tests/test_ancestry.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_ancestry.py	2006-03-20 08:31:00 +0000
@@ -14,22 +14,22 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+
+from cStringIO import StringIO
+import os
 import sys
-import os
-
-from cStringIO import StringIO
-
-from bzrlib.tests import TestCase, TestCaseInTempDir
+
+from bzrlib.tests import TestCase, TestCaseWithTransport
 from bzrlib.branch import Branch
 from bzrlib.revision import is_ancestor
 
 
-class TestAncestry(TestCaseInTempDir):
+class TestAncestry(TestCaseWithTransport):
 
     def test_straightline_ancestry(self):
         """Test ancestry file when just committing."""
-        b = Branch.initialize(u'.')
-        wt = b.working_tree()
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
 
         wt.commit(message='one',
                   allow_pointless=True,
@@ -39,16 +39,16 @@
                   allow_pointless=True,
                   rev_id='tester@foo--2')
 
-        ancs = b.get_ancestry('tester@foo--2')
+        ancs = b.repository.get_ancestry('tester@foo--2')
         self.assertEqual([None, 'tester@foo--1', 'tester@foo--2'], ancs)
         self.assertEqual([None, 'tester@foo--1'], 
-                         b.get_ancestry('tester@foo--1'))
+                         b.repository.get_ancestry('tester@foo--1'))
 
     def test_none_is_always_an_ancestor(self):
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         # note this is tested before any commits are done.
         self.assertEqual(True, is_ancestor(None, None, b))
-        wt = b.working_tree()
         wt.commit(message='one',
                   allow_pointless=True,
                   rev_id='tester@foo--1')

=== modified file 'bzrlib/tests/test_annotate.py'
--- bzrlib/tests/test_annotate.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_annotate.py	2006-03-20 08:31:00 +0000
@@ -31,24 +31,25 @@
 import os
 
 from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
 from bzrlib.errors import BzrCommandError
 from bzrlib.osutils import has_symlinks
-from bzrlib.tests import TestCaseInTempDir, BzrTestBase
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.annotate import annotate_file
 
 
-class TestAnnotate(TestCaseInTempDir):
+class TestAnnotate(TestCaseWithTransport):
+
     def setUp(self):
         super(TestAnnotate, self).setUp()
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         self.build_tree_contents([('hello.txt', 'my helicopter\n'),
                                   ('nomail.txt', 'nomail\n')])
-        b.working_tree().add(['hello.txt'])
-        b.working_tree().commit('add hello', 
+        wt.add(['hello.txt'])
+        wt.commit('add hello', 
                                 committer='test@user')
-        b.working_tree().add(['nomail.txt'])
-        b.working_tree().commit('add nomail', committer='no mail')
+        wt.add(['nomail.txt'])
+        wt.commit('add nomail', committer='no mail')
 
     def test_help_annotate(self):
         """Annotate command exists"""

=== modified file 'bzrlib/tests/test_bad_files.py'
--- bzrlib/tests/test_bad_files.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_bad_files.py	2006-03-20 08:31:00 +0000
@@ -18,39 +18,40 @@
 """Tests being able to ignore mad filetypes.
 """
 
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.errors import BadFileKindError
 import os
 
-def verify_status(tester, branch, value):
-    from bzrlib.status import show_status
+def verify_status(tester, tree, value):
+    from bzrlib.status import show_tree_status
     from cStringIO import StringIO
 
     tof = StringIO()
-    show_status(branch, to_file=tof)
+    show_tree_status(tree, to_file=tof)
     tof.seek(0)
     tester.assertEquals(tof.readlines(), value)
 
 
-class TestBadFiles(TestCaseInTempDir):
+class TestBadFiles(TestCaseWithTransport):
     
     def test_bad_files(self): 
         """Test that bzr will ignore files it doesn't like"""
-        from bzrlib.commit import commit
-        from bzrlib.add import smart_add
+        from bzrlib.add import smart_add_tree
         from bzrlib.branch import Branch
 
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
 
-        self.build_tree(['one', 'two', 'three'])
-        smart_add(u'.')
-        commit(b, "Commit one", rev_id="a@u-0-0")
+        files = ['one', 'two', 'three']
+        self.build_tree(files)
+        wt.add(files)
+        wt.commit("Commit one", rev_id="a@u-0-0")
         self.build_tree(['four'])
-        smart_add(u'.')
-        commit(b, "Commit two", rev_id="a@u-0-1")
+        wt.add(['four'])
+        wt.commit("Commit two", rev_id="a@u-0-1")
         self.build_tree(['five'])
-        smart_add(u'.')
-        commit(b, "Commit three", rev_id="a@u-0-2")
+        wt.add(['five'])
+        wt.commit("Commit three", rev_id="a@u-0-2")
 
         # We should now have a few files, lets try to
         # put some bogus stuff in the tree
@@ -60,12 +61,12 @@
             return
 
         # status with nothing
-        verify_status(self, b, [])
+        verify_status(self, wt, [])
 
         os.mkfifo('a-fifo')
         self.build_tree(['six'])
 
-        verify_status(self, b,
+        verify_status(self, wt,
                           ['unknown:\n',
                            '  a-fifo\n',
                            '  six\n'
@@ -73,16 +74,16 @@
         
         # Make sure smart_add can handle having a bogus
         # file in the way
-        smart_add(u'.')
-        verify_status(self, b,
+        smart_add_tree(wt, '.')
+        verify_status(self, wt,
                           ['added:\n',
                            '  six\n',
                            'unknown:\n',
                            '  a-fifo\n',
                            ])
-        commit(b, "Commit four", rev_id="a@u-0-3")
+        wt.commit("Commit four", rev_id="a@u-0-3")
 
-        verify_status(self, b,
+        verify_status(self, wt,
                           ['unknown:\n',
                            '  a-fifo\n',
                            ])

=== modified file 'bzrlib/tests/test_basis_inventory.py'
--- bzrlib/tests/test_basis_inventory.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_basis_inventory.py	2006-03-20 08:31:00 +0000
@@ -16,17 +16,17 @@
 
 import os
 
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.branch import Branch
 from bzrlib.xml5 import serializer_v5
 
 
-class TestBasisInventory(TestCaseInTempDir):
+class TestBasisInventory(TestCaseWithTransport):
 
     def test_create(self):
         # Make sure the basis file is created by a commit
-        b = Branch.initialize(u'.')
-        t = b.working_tree()
+        t = self.make_branch_and_tree('.')
+        b = t.branch
         open('a', 'wb').write('a\n')
         t.add('a')
         t.commit('a', rev_id='r1')
@@ -37,7 +37,7 @@
         basis_inv = serializer_v5.read_inventory_from_string(basis_inv_txt)
         #self.assertEquals('r1', basis_inv.revision_id)
         
-        store_inv = b.get_inventory('r1')
+        store_inv = b.repository.get_inventory('r1')
         self.assertEquals(store_inv._byid, basis_inv._byid)
 
         open('b', 'wb').write('b\n')
@@ -49,7 +49,7 @@
 
         basis_inv_txt = t.read_basis_inventory('r2')
         basis_inv = serializer_v5.read_inventory_from_string(basis_inv_txt)
-        store_inv = b.get_inventory('r2')
+        store_inv = b.repository.get_inventory('r2')
 
         self.assertEquals(store_inv._byid, basis_inv._byid)
 

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_branch.py	2006-03-20 08:31:00 +0000
@@ -14,386 +14,126 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import os
-import sys
-
-from bzrlib.branch import Branch, needs_read_lock, needs_write_lock
-from bzrlib.clone import copy_branch
-from bzrlib.commit import commit
-import bzrlib.errors as errors
-from bzrlib.errors import NoSuchRevision, UnlistableBranch, NotBranchError
-import bzrlib.gpg
-from bzrlib.osutils import getcwd
-from bzrlib.tests import TestCase, TestCaseInTempDir
-from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
-from bzrlib.trace import mutter
-import bzrlib.transactions as transactions
-from bzrlib.revision import NULL_REVISION
-
-# TODO: Make a branch using basis branch, and check that it 
-# doesn't request any files that could have been avoided, by 
-# hooking into the Transport.
-
-class TestBranch(TestCaseInTempDir):
-
-    def test_append_revisions(self):
-        """Test appending more than one revision"""
-        br = Branch.initialize(u".")
-        br.append_revision("rev1")
-        self.assertEquals(br.revision_history(), ["rev1",])
-        br.append_revision("rev2", "rev3")
-        self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
-
-    def test_fetch_revisions(self):
-        """Test fetch-revision operation."""
-        from bzrlib.fetch import Fetcher
-        os.mkdir('b1')
-        os.mkdir('b2')
-        b1 = Branch.initialize('b1')
-        b2 = Branch.initialize('b2')
-        file('b1/foo', 'w').write('hello')
-        b1.working_tree().add(['foo'], ['foo-id'])
-        b1.working_tree().commit('lala!', rev_id='revision-1', allow_pointless=False)
-
-        mutter('start fetch')
-        f = Fetcher(from_branch=b1, to_branch=b2)
-        eq = self.assertEquals
-        eq(f.count_copied, 1)
-        eq(f.last_revision, 'revision-1')
-
-        rev = b2.get_revision('revision-1')
-        tree = b2.revision_tree('revision-1')
-        eq(tree.get_file_text('foo-id'), 'hello')
-
-    def test_revision_tree(self):
-        b1 = Branch.initialize(u'.')
-        b1.working_tree().commit('lala!', rev_id='revision-1', allow_pointless=True)
-        tree = b1.revision_tree('revision-1')
-        tree = b1.revision_tree(None)
-        self.assertEqual(len(tree.list_files()), 0)
-        tree = b1.revision_tree(NULL_REVISION)
-        self.assertEqual(len(tree.list_files()), 0)
-
-    def get_unbalanced_branch_pair(self):
-        """Return two branches, a and b, with one file in a."""
-        os.mkdir('a')
-        br_a = Branch.initialize("a")
-        file('a/b', 'wb').write('b')
-        br_a.working_tree().add('b')
-        commit(br_a, "silly commit", rev_id='A')
-        os.mkdir('b')
-        br_b = Branch.initialize("b")
-        return br_a, br_b
-
-    def get_balanced_branch_pair(self):
-        """Returns br_a, br_b as with one commit in a, and b has a's stores."""
-        br_a, br_b = self.get_unbalanced_branch_pair()
-        br_a.push_stores(br_b)
-        return br_a, br_b
-
-    def test_push_stores(self):
-        """Copy the stores from one branch to another"""
-        br_a, br_b = self.get_unbalanced_branch_pair()
-        # ensure the revision is missing.
-        self.assertRaises(NoSuchRevision, br_b.get_revision, 
-                          br_a.revision_history()[0])
-        br_a.push_stores(br_b)
-        # check that b now has all the data from a's first commit.
-        rev = br_b.get_revision(br_a.revision_history()[0])
-        tree = br_b.revision_tree(br_a.revision_history()[0])
-        for file_id in tree:
-            if tree.inventory[file_id].kind == "file":
-                tree.get_file(file_id).read()
-        return br_a, br_b
-
-    def test_copy_branch(self):
-        """Copy the stores from one branch to another"""
-        br_a, br_b = self.get_balanced_branch_pair()
-        commit(br_b, "silly commit")
-        os.mkdir('c')
-        br_c = copy_branch(br_a, 'c', basis_branch=br_b)
-        self.assertEqual(br_a.revision_history(), br_c.revision_history())
-
-    def test_copy_partial(self):
-        """Copy only part of the history of a branch."""
-        self.build_tree(['a/', 'a/one'])
-        br_a = Branch.initialize('a')
-        br_a.working_tree().add(['one'])
-        br_a.working_tree().commit('commit one', rev_id='u@d-1')
-        self.build_tree(['a/two'])
-        br_a.working_tree().add(['two'])
-        br_a.working_tree().commit('commit two', rev_id='u@d-2')
-        br_b = copy_branch(br_a, 'b', revision='u@d-1')
-        self.assertEqual(br_b.last_revision(), 'u@d-1')
-        self.assertTrue(os.path.exists('b/one'))
-        self.assertFalse(os.path.exists('b/two'))
-        
-    def test_record_initial_ghost_merge(self):
-        """A pending merge with no revision present is still a merge."""
-        branch = Branch.initialize(u'.')
-        branch.working_tree().add_pending_merge('non:existent@rev--ision--0--2')
-        branch.working_tree().commit('pretend to merge nonexistent-revision', rev_id='first')
-        rev = branch.get_revision(branch.last_revision())
-        self.assertEqual(len(rev.parent_ids), 1)
-        # parent_sha1s is not populated now, WTF. rbc 20051003
-        self.assertEqual(len(rev.parent_sha1s), 0)
-        self.assertEqual(rev.parent_ids[0], 'non:existent@rev--ision--0--2')
-
-    def test_bad_revision(self):
-        branch = Branch.initialize(u'.')
-        self.assertRaises(errors.InvalidRevisionId, branch.get_revision, None)
-
-# TODO 20051003 RBC:
-# compare the gpg-to-sign info for a commit with a ghost and 
-#     an identical tree without a ghost
-# fetch missing should rewrite the TOC of weaves to list newly available parents.
-        
-    def test_pending_merges(self):
-        """Tracking pending-merged revisions."""
-        b = Branch.initialize(u'.')
-        wt = b.working_tree()
-        self.assertEquals(wt.pending_merges(), [])
-        wt.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(wt.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        wt.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(wt.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        wt.add_pending_merge('wibble@fofof--20050401--1928390812')
-        self.assertEquals(wt.pending_merges(),
-                          ['foo@azkhazan-123123-abcabc',
-                           'wibble@fofof--20050401--1928390812'])
-        b.working_tree().commit("commit from base with two merges")
-        rev = b.get_revision(b.revision_history()[0])
-        self.assertEquals(len(rev.parent_ids), 2)
-        self.assertEquals(rev.parent_ids[0],
-                          'foo@azkhazan-123123-abcabc')
-        self.assertEquals(rev.parent_ids[1],
-                           'wibble@fofof--20050401--1928390812')
-        # list should be cleared when we do a commit
-        self.assertEquals(wt.pending_merges(), [])
-
-    def test_sign_existing_revision(self):
-        branch = Branch.initialize(u'.')
-        branch.working_tree().commit("base", allow_pointless=True, rev_id='A')
-        from bzrlib.testament import Testament
-        branch.sign_revision('A', bzrlib.gpg.LoopbackGPGStrategy(None))
-        self.assertEqual(Testament.from_revision(branch, 'A').as_short_text(),
-                         branch.revision_store.get('A', 'sig').read())
-
-    def test_store_signature(self):
-        branch = Branch.initialize(u'.')
-        branch.store_revision_signature(bzrlib.gpg.LoopbackGPGStrategy(None),
-                                        'FOO', 'A')
-        self.assertEqual('FOO', branch.revision_store.get('A', 'sig').read())
-
-    def test__relcontrolfilename(self):
-        branch = Branch.initialize(u'.')
-        self.assertEqual('.bzr/%25', branch._rel_controlfilename('%'))
-        
-    def test__relcontrolfilename_empty(self):
-        branch = Branch.initialize(u'.')
-        self.assertEqual('.bzr', branch._rel_controlfilename(''))
-
-    def test_nicks(self):
-        """Branch nicknames"""
-        os.mkdir('bzr.dev')
-        branch = Branch.initialize('bzr.dev')
-        self.assertEqual(branch.nick, 'bzr.dev')
-        os.rename('bzr.dev', 'bzr.ab')
-        branch = Branch.open('bzr.ab')
-        self.assertEqual(branch.nick, 'bzr.ab')
-        branch.nick = "Aaron's branch"
-        branch.nick = "Aaron's branch"
-        self.failUnless(os.path.exists(branch.controlfilename("branch.conf")))
-        self.assertEqual(branch.nick, "Aaron's branch")
-        os.rename('bzr.ab', 'integration')
-        branch = Branch.open('integration')
-        self.assertEqual(branch.nick, "Aaron's branch")
-        branch.nick = u"\u1234"
-        self.assertEqual(branch.nick, u"\u1234")
-
-    def test_commit_nicks(self):
-        """Nicknames are committed to the revision"""
-        os.mkdir('bzr.dev')
-        branch = Branch.initialize('bzr.dev')
-        branch.nick = "My happy branch"
-        branch.working_tree().commit('My commit respect da nick.')
-        committed = branch.get_revision(branch.last_revision())
-        self.assertEqual(committed.properties["branch-nick"], 
-                         "My happy branch")
-
-
-class TestRemote(TestCaseWithWebserver):
-
-    def test_open_containing(self):
-        self.assertRaises(NotBranchError, Branch.open_containing,
-                          self.get_remote_url(''))
-        self.assertRaises(NotBranchError, Branch.open_containing,
-                          self.get_remote_url('g/p/q'))
-        b = Branch.initialize(u'.')
-        branch, relpath = Branch.open_containing(self.get_remote_url(''))
-        self.assertEqual('', relpath)
-        branch, relpath = Branch.open_containing(self.get_remote_url('g/p/q'))
-        self.assertEqual('g/p/q', relpath)
-        
-# TODO: rewrite this as a regular unittest, without relying on the displayed output        
-#         >>> from bzrlib.commit import commit
-#         >>> bzrlib.trace.silent = True
-#         >>> br1 = ScratchBranch(files=['foo', 'bar'])
-#         >>> br1.working_tree().add('foo')
-#         >>> br1.working_tree().add('bar')
-#         >>> commit(br1, "lala!", rev_id="REVISION-ID-1", verbose=False)
-#         >>> br2 = ScratchBranch()
-#         >>> br2.update_revisions(br1)
-#         Added 2 texts.
-#         Added 1 inventories.
-#         Added 1 revisions.
-#         >>> br2.revision_history()
-#         [u'REVISION-ID-1']
-#         >>> br2.update_revisions(br1)
-#         Added 0 revisions.
-#         >>> br1.text_store.total_size() == br2.text_store.total_size()
-#         True
-
-class InstrumentedTransaction(object):
-
-    def finish(self):
-        self.calls.append('finish')
-
-    def __init__(self):
-        self.calls = []
-
-
-class TestDecorator(object):
-
-    def __init__(self):
-        self._calls = []
-
-    def lock_read(self):
-        self._calls.append('lr')
-
-    def lock_write(self):
-        self._calls.append('lw')
-
-    def unlock(self):
-        self._calls.append('ul')
-
-    @needs_read_lock
-    def do_with_read(self):
-        return 1
-
-    @needs_read_lock
-    def except_with_read(self):
-        raise RuntimeError
-
-    @needs_write_lock
-    def do_with_write(self):
-        return 2
-
-    @needs_write_lock
-    def except_with_write(self):
-        raise RuntimeError
-
-
-class TestDecorators(TestCase):
-
-    def test_needs_read_lock(self):
-        branch = TestDecorator()
-        self.assertEqual(1, branch.do_with_read())
-        self.assertEqual(['lr', 'ul'], branch._calls)
-
-    def test_excepts_in_read_lock(self):
-        branch = TestDecorator()
-        self.assertRaises(RuntimeError, branch.except_with_read)
-        self.assertEqual(['lr', 'ul'], branch._calls)
-
-    def test_needs_write_lock(self):
-        branch = TestDecorator()
-        self.assertEqual(2, branch.do_with_write())
-        self.assertEqual(['lw', 'ul'], branch._calls)
-
-    def test_excepts_in_write_lock(self):
-        branch = TestDecorator()
-        self.assertRaises(RuntimeError, branch.except_with_write)
-        self.assertEqual(['lw', 'ul'], branch._calls)
-
-
-class TestBranchTransaction(TestCaseInTempDir):
-
-    def setUp(self):
-        super(TestBranchTransaction, self).setUp()
-        self.branch = Branch.initialize(u'.')
-        
-    def test_default_get_transaction(self):
-        """branch.get_transaction on a new branch should give a PassThrough."""
-        self.failUnless(isinstance(self.branch.get_transaction(),
-                                   transactions.PassThroughTransaction))
-
-    def test__set_new_transaction(self):
-        self.branch._set_transaction(transactions.ReadOnlyTransaction())
-
-    def test__set_over_existing_transaction_raises(self):
-        self.branch._set_transaction(transactions.ReadOnlyTransaction())
-        self.assertRaises(errors.LockError,
-                          self.branch._set_transaction,
-                          transactions.ReadOnlyTransaction())
-
-    def test_finish_no_transaction_raises(self):
-        self.assertRaises(errors.LockError, self.branch._finish_transaction)
-
-    def test_finish_readonly_transaction_works(self):
-        self.branch._set_transaction(transactions.ReadOnlyTransaction())
-        self.branch._finish_transaction()
-        self.assertEqual(None, self.branch._transaction)
-
-    def test_unlock_calls_finish(self):
-        self.branch.lock_read()
-        transaction = InstrumentedTransaction()
-        self.branch._transaction = transaction
-        self.branch.unlock()
-        self.assertEqual(['finish'], transaction.calls)
-
-    def test_lock_read_acquires_ro_transaction(self):
-        self.branch.lock_read()
-        self.failUnless(isinstance(self.branch.get_transaction(),
-                                   transactions.ReadOnlyTransaction))
-        self.branch.unlock()
-        
-    def test_lock_write_acquires_passthrough_transaction(self):
-        self.branch.lock_write()
-        # cannot use get_transaction as its magic
-        self.failUnless(isinstance(self.branch._transaction,
-                                   transactions.PassThroughTransaction))
-        self.branch.unlock()
-
-
-class TestBranchPushLocations(TestCaseInTempDir):
-
-    def setUp(self):
-        super(TestBranchPushLocations, self).setUp()
-        self.branch = Branch.initialize(u'.')
-        
-    def test_get_push_location_unset(self):
-        self.assertEqual(None, self.branch.get_push_location())
-
-    def test_get_push_location_exact(self):
-        from bzrlib.config import (branches_config_filename,
-                                   ensure_config_dir_exists)
-        ensure_config_dir_exists()
-        fn = branches_config_filename()
-        print >> open(fn, 'wt'), ("[%s]\n"
-                                  "push_location=foo" %
-                                  getcwd())
-        self.assertEqual("foo", self.branch.get_push_location())
-
-    def test_set_push_location(self):
-        from bzrlib.config import (branches_config_filename,
-                                   ensure_config_dir_exists)
-        ensure_config_dir_exists()
-        fn = branches_config_filename()
-        self.branch.set_push_location('foo')
-        self.assertFileEqual("[%s]\n"
-                             "push_location = foo" % getcwd(),
-                             fn)
-
-    # TODO RBC 20051029 test getting a push location from a branch in a 
-    # recursive section - that is, it appends the branch name.
+"""Tests for the Branch facility that are not interface  tests.
+
+For interface tests see tests/branch_implementations/*.py.
+
+For concrete class tests see this file, and for meta-branch tests
+also see this file.
+"""
+
+from StringIO import StringIO
+
+import bzrlib.branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.errors import (NotBranchError,
+                           UnknownFormatError,
+                           UnsupportedFormatError,
+                           )
+
+from bzrlib.tests import TestCase, TestCaseWithTransport
+from bzrlib.transport import get_transport
+
+class TestDefaultFormat(TestCase):
+
+    def test_get_set_default_format(self):
+        old_format = bzrlib.branch.BranchFormat.get_default_format()
+        # default is 5
+        self.assertTrue(isinstance(old_format, bzrlib.branch.BzrBranchFormat5))
+        bzrlib.branch.BranchFormat.set_default_format(SampleBranchFormat())
+        try:
+            # the default branch format is used by the meta dir format
+            # which is not the default bzrdir format at this point
+            dir = bzrdir.BzrDirMetaFormat1().initialize('memory:/')
+            result = dir.create_branch()
+            self.assertEqual(result, 'A branch')
+        finally:
+            bzrlib.branch.BranchFormat.set_default_format(old_format)
+        self.assertEqual(old_format, bzrlib.branch.BranchFormat.get_default_format())
+
+
+class SampleBranchFormat(bzrlib.branch.BranchFormat):
+    """A sample format
+
+    this format is initializable, unsupported to aid in testing the 
+    open and open_downlevel routines.
+    """
+
+    def get_format_string(self):
+        """See BzrBranchFormat.get_format_string()."""
+        return "Sample branch format."
+
+    def initialize(self, a_bzrdir):
+        """Format 4 branches cannot be created."""
+        t = a_bzrdir.get_branch_transport(self)
+        t.put('format', StringIO(self.get_format_string()))
+        return 'A branch'
+
+    def is_supported(self):
+        return False
+
+    def open(self, transport, _found=False):
+        return "opened branch."
+
+
+class TestBzrBranchFormat(TestCaseWithTransport):
+    """Tests for the BzrBranchFormat facility."""
+
+    def test_find_format(self):
+        # is the right format object found for a branch?
+        # create a branch with a few known format objects.
+        # this is not quite the same as 
+        self.build_tree(["foo/", "bar/"])
+        def check_format(format, url):
+            dir = format._matchingbzrdir.initialize(url)
+            dir.create_repository()
+            format.initialize(dir)
+            found_format = bzrlib.branch.BranchFormat.find_format(dir)
+            self.failUnless(isinstance(found_format, format.__class__))
+        check_format(bzrlib.branch.BzrBranchFormat5(), "bar")
+        
+    def test_find_format_not_branch(self):
+        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        self.assertRaises(NotBranchError,
+                          bzrlib.branch.BranchFormat.find_format,
+                          dir)
+
+    def test_find_format_unknown_format(self):
+        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        SampleBranchFormat().initialize(dir)
+        self.assertRaises(UnknownFormatError,
+                          bzrlib.branch.BranchFormat.find_format,
+                          dir)
+
+    def test_register_unregister_format(self):
+        format = SampleBranchFormat()
+        # make a control dir
+        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        # make a branch
+        format.initialize(dir)
+        # register a format for it.
+        bzrlib.branch.BranchFormat.register_format(format)
+        # which branch.Open will refuse (not supported)
+        self.assertRaises(UnsupportedFormatError, bzrlib.branch.Branch.open, self.get_url())
+        # but open_downlevel will work
+        self.assertEqual(format.open(dir), bzrdir.BzrDir.open(self.get_url()).open_branch(unsupported=True))
+        # unregister the format
+        bzrlib.branch.BranchFormat.unregister_format(format)
+
+
+class TestBranchReference(TestCaseWithTransport):
+    """Tests for the branch reference facility."""
+
+    def test_create_open_reference(self):
+        bzrdirformat = bzrdir.BzrDirMetaFormat1()
+        t = get_transport(self.get_url('.'))
+        t.mkdir('repo')
+        dir = bzrdirformat.initialize(self.get_url('repo'))
+        dir.create_repository()
+        target_branch = dir.create_branch()
+        t.mkdir('branch')
+        branch_dir = bzrdirformat.initialize(self.get_url('branch'))
+        made_branch = bzrlib.branch.BranchReferenceFormat().initialize(branch_dir, target_branch)
+        self.assertEqual(made_branch.base, target_branch.base)
+        opened_branch = branch_dir.open_branch()
+        self.assertEqual(opened_branch.base, target_branch.base)

=== added file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_bzrdir.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,494 @@
+# (C) 2005 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for the BzrDir facility and any format specific tests.
+
+For interface contract tests, see tests/bzr_dir_implementations.
+"""
+
+from StringIO import StringIO
+
+import bzrlib.branch
+import bzrlib.bzrdir as bzrdir
+import bzrlib.errors as errors
+from bzrlib.errors import (NotBranchError,
+                           UnknownFormatError,
+                           UnsupportedFormatError,
+                           )
+import bzrlib.repository as repository
+from bzrlib.tests import TestCase, TestCaseWithTransport
+from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
+from bzrlib.transport import get_transport
+from bzrlib.transport.http import HttpServer
+from bzrlib.transport.memory import MemoryServer
+import bzrlib.workingtree as workingtree
+
+
+class TestDefaultFormat(TestCase):
+
+    def test_get_set_default_format(self):
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        # default is BzrDirFormat6
+        self.failUnless(isinstance(old_format, bzrdir.BzrDirFormat6))
+        bzrdir.BzrDirFormat.set_default_format(SampleBzrDirFormat())
+        # creating a bzr dir should now create an instrumented dir.
+        try:
+            result = bzrdir.BzrDir.create('memory:/')
+            self.failUnless(isinstance(result, SampleBzrDir))
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+        self.assertEqual(old_format, bzrdir.BzrDirFormat.get_default_format())
+
+
+class SampleBranch(bzrlib.branch.Branch):
+    """A dummy branch for guess what, dummy use."""
+
+    def __init__(self, dir):
+        self.bzrdir = dir
+
+
+class SampleBzrDir(bzrdir.BzrDir):
+    """A sample BzrDir implementation to allow testing static methods."""
+
+    def create_repository(self):
+        """See BzrDir.create_repository."""
+        return "A repository"
+
+    def open_repository(self):
+        """See BzrDir.open_repository."""
+        return "A repository"
+
+    def create_branch(self):
+        """See BzrDir.create_branch."""
+        return SampleBranch(self)
+
+    def create_workingtree(self):
+        """See BzrDir.create_workingtree."""
+        return "A tree"
+
+
+class SampleBzrDirFormat(bzrdir.BzrDirFormat):
+    """A sample format
+
+    this format is initializable, unsupported to aid in testing the 
+    open and open_downlevel routines.
+    """
+
+    def get_format_string(self):
+        """See BzrDirFormat.get_format_string()."""
+        return "Sample .bzr dir format."
+
+    def initialize(self, url):
+        """Create a bzr dir."""
+        t = get_transport(url)
+        t.mkdir('.bzr')
+        t.put('.bzr/branch-format', StringIO(self.get_format_string()))
+        return SampleBzrDir(t, self)
+
+    def is_supported(self):
+        return False
+
+    def open(self, transport, _found=None):
+        return "opened branch."
+
+
+class TestBzrDirFormat(TestCaseWithTransport):
+    """Tests for the BzrDirFormat facility."""
+
+    def test_find_format(self):
+        # is the right format object found for a branch?
+        # create a branch with a few known format objects.
+        # this is not quite the same as 
+        t = get_transport(self.get_url())
+        self.build_tree(["foo/", "bar/"], transport=t)
+        def check_format(format, url):
+            format.initialize(url)
+            t = get_transport(url)
+            found_format = bzrdir.BzrDirFormat.find_format(t)
+            self.failUnless(isinstance(found_format, format.__class__))
+        check_format(bzrdir.BzrDirFormat5(), "foo")
+        check_format(bzrdir.BzrDirFormat6(), "bar")
+        
+    def test_find_format_nothing_there(self):
+        self.assertRaises(NotBranchError,
+                          bzrdir.BzrDirFormat.find_format,
+                          get_transport('.'))
+
+    def test_find_format_unknown_format(self):
+        t = get_transport(self.get_url())
+        t.mkdir('.bzr')
+        t.put('.bzr/branch-format', StringIO())
+        self.assertRaises(UnknownFormatError,
+                          bzrdir.BzrDirFormat.find_format,
+                          get_transport('.'))
+
+    def test_register_unregister_format(self):
+        format = SampleBzrDirFormat()
+        url = self.get_url()
+        # make a bzrdir
+        format.initialize(url)
+        # register a format for it.
+        bzrdir.BzrDirFormat.register_format(format)
+        # which bzrdir.Open will refuse (not supported)
+        self.assertRaises(UnsupportedFormatError, bzrdir.BzrDir.open, url)
+        # but open_downlevel will work
+        t = get_transport(url)
+        self.assertEqual(format.open(t), bzrdir.BzrDir.open_unsupported(url))
+        # unregister the format
+        bzrdir.BzrDirFormat.unregister_format(format)
+        # now open_downlevel should fail too.
+        self.assertRaises(UnknownFormatError, bzrdir.BzrDir.open_unsupported, url)
+
+    def test_create_repository(self):
+        format = SampleBzrDirFormat()
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(format)
+        try:
+            repo = bzrdir.BzrDir.create_repository(self.get_url())
+            self.assertEqual('A repository', repo)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_repository_under_shared(self):
+        # an explicit create_repository always does so.
+        # we trust the format is right from the 'create_repository test'
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            repo = bzrdir.BzrDir.create_repository(self.get_url('child'))
+            self.assertTrue(isinstance(repo, repository.Repository))
+            self.assertTrue(repo.bzrdir.root_transport.base.endswith('child/'))
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_and_repo_uses_default(self):
+        format = SampleBzrDirFormat()
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(format)
+        try:
+            branch = bzrdir.BzrDir.create_branch_and_repo(self.get_url())
+            self.assertTrue(isinstance(branch, SampleBranch))
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_and_repo_under_shared(self):
+        # creating a branch and repo in a shared repo uses the
+        # shared repository
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_and_repo(self.get_url('child'))
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_and_repo_under_shared_force_new(self):
+        # creating a branch and repo in a shared repo can be forced to 
+        # make a new repo
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_and_repo(self.get_url('child'),
+                                                          force_new_repo=True)
+            branch.bzrdir.open_repository()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_standalone_working_tree(self):
+        format = SampleBzrDirFormat()
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(format)
+        try:
+            # note this is deliberately readonly, as this failure should 
+            # occur before any writes.
+            self.assertRaises(errors.NotLocalUrl,
+                              bzrdir.BzrDir.create_standalone_workingtree,
+                              self.get_readonly_url())
+            tree = bzrdir.BzrDir.create_standalone_workingtree('.')
+            self.assertEqual('A tree', tree)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_standalone_working_tree_under_shared_repo(self):
+        # create standalone working tree always makes a repo.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            # note this is deliberately readonly, as this failure should 
+            # occur before any writes.
+            self.assertRaises(errors.NotLocalUrl,
+                              bzrdir.BzrDir.create_standalone_workingtree,
+                              self.get_readonly_url('child'))
+            tree = bzrdir.BzrDir.create_standalone_workingtree('child')
+            tree.bzrdir.open_repository()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience(self):
+        # outside a repo the default convenience output is a repo+branch_tree
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            branch = bzrdir.BzrDir.create_branch_convenience('.')
+            branch.bzrdir.open_workingtree()
+            branch.bzrdir.open_repository()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience_under_shared_repo(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_convenience('child')
+            branch.bzrdir.open_workingtree()
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+            
+    def test_create_branch_convenience_under_shared_repo_force_no_tree(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy but we can override that
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_convenience('child',
+                force_new_tree=False)
+            self.assertRaises(errors.NoWorkingTree,
+                              branch.bzrdir.open_workingtree)
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+            
+    def test_create_branch_convenience_under_shared_repo_no_tree_policy(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            repo = self.make_repository('.', shared=True)
+            repo.set_make_working_trees(False)
+            branch = bzrdir.BzrDir.create_branch_convenience('child')
+            self.assertRaises(errors.NoWorkingTree,
+                              branch.bzrdir.open_workingtree)
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience_under_shared_repo_no_tree_policy_force_tree(self):
+        # inside a repo the default convenience output is a branch+ follow the
+        # repo tree policy but we can override that
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            repo = self.make_repository('.', shared=True)
+            repo.set_make_working_trees(False)
+            branch = bzrdir.BzrDir.create_branch_convenience('child',
+                force_new_tree=True)
+            branch.bzrdir.open_workingtree()
+            self.assertRaises(errors.NoRepositoryPresent,
+                              branch.bzrdir.open_repository)
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience_under_shared_repo_force_new_repo(self):
+        # inside a repo the default convenience output is overridable to give
+        # repo+branch+tree
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.make_repository('.', shared=True)
+            branch = bzrdir.BzrDir.create_branch_convenience('child',
+                force_new_repo=True)
+            branch.bzrdir.open_repository()
+            branch.bzrdir.open_workingtree()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+
+class ChrootedTests(TestCaseWithTransport):
+    """A support class that provides readonly urls outside the local namespace.
+
+    This is done by checking if self.transport_server is a MemoryServer. if it
+    is then we are chrooted already, if it is not then an HttpServer is used
+    for readonly urls.
+    """
+
+    def setUp(self):
+        super(ChrootedTests, self).setUp()
+        if not self.transport_server == MemoryServer:
+            self.transport_readonly_server = HttpServer
+
+    def test_open_containing(self):
+        self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing,
+                          self.get_readonly_url(''))
+        self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing,
+                          self.get_readonly_url('g/p/q'))
+        control = bzrdir.BzrDir.create(self.get_url())
+        branch, relpath = bzrdir.BzrDir.open_containing(self.get_readonly_url(''))
+        self.assertEqual('', relpath)
+        branch, relpath = bzrdir.BzrDir.open_containing(self.get_readonly_url('g/p/q'))
+        self.assertEqual('g/p/q', relpath)
+
+    def test_open_containing_from_transport(self):
+        self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing_from_transport,
+                          get_transport(self.get_readonly_url('')))
+        self.assertRaises(NotBranchError, bzrdir.BzrDir.open_containing_from_transport,
+                          get_transport(self.get_readonly_url('g/p/q')))
+        control = bzrdir.BzrDir.create(self.get_url())
+        branch, relpath = bzrdir.BzrDir.open_containing_from_transport(
+            get_transport(self.get_readonly_url('')))
+        self.assertEqual('', relpath)
+        branch, relpath = bzrdir.BzrDir.open_containing_from_transport(
+            get_transport(self.get_readonly_url('g/p/q')))
+        self.assertEqual('g/p/q', relpath)
+
+
+class TestMeta1DirFormat(TestCaseWithTransport):
+    """Tests specific to the meta1 dir format."""
+
+    def test_right_base_dirs(self):
+        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        t = dir.transport
+        branch_base = t.clone('branch').base
+        self.assertEqual(branch_base, dir.get_branch_transport(None).base)
+        self.assertEqual(branch_base,
+                         dir.get_branch_transport(bzrlib.branch.BzrBranchFormat5()).base)
+        repository_base = t.clone('repository').base
+        self.assertEqual(repository_base, dir.get_repository_transport(None).base)
+        self.assertEqual(repository_base,
+                         dir.get_repository_transport(repository.RepositoryFormat7()).base)
+        checkout_base = t.clone('checkout').base
+        self.assertEqual(checkout_base, dir.get_workingtree_transport(None).base)
+        self.assertEqual(checkout_base,
+                         dir.get_workingtree_transport(workingtree.WorkingTreeFormat3()).base)
+
+        
+class TestFormat5(TestCaseWithTransport):
+    """Tests specific to the version 5 bzrdir format."""
+
+    def test_same_lockfiles_between_tree_repo_branch(self):
+        # this checks that only a single lockfiles instance is created 
+        # for format 5 objects
+        dir = bzrdir.BzrDirFormat5().initialize(self.get_url())
+        def check_dir_components_use_same_lock(dir):
+            ctrl_1 = dir.open_repository().control_files
+            ctrl_2 = dir.open_branch().control_files
+            ctrl_3 = dir.open_workingtree()._control_files
+            self.assertTrue(ctrl_1 is ctrl_2)
+            self.assertTrue(ctrl_2 is ctrl_3)
+        check_dir_components_use_same_lock(dir)
+        # and if we open it normally.
+        dir = bzrdir.BzrDir.open(self.get_url())
+        check_dir_components_use_same_lock(dir)
+    
+    def test_can_convert(self):
+        # format 5 dirs are convertable
+        dir = bzrdir.BzrDirFormat5().initialize(self.get_url())
+        self.assertTrue(dir.can_convert_format())
+    
+    def test_needs_conversion(self):
+        # format 5 dirs need a conversion if they are not the default.
+        # and they start of not the default.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirFormat5())
+        try:
+            dir = bzrdir.BzrDirFormat5().initialize(self.get_url())
+            self.assertFalse(dir.needs_format_conversion())
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+        self.assertTrue(dir.needs_format_conversion())
+
+
+class TestFormat6(TestCaseWithTransport):
+    """Tests specific to the version 6 bzrdir format."""
+
+    def test_same_lockfiles_between_tree_repo_branch(self):
+        # this checks that only a single lockfiles instance is created 
+        # for format 6 objects
+        dir = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        def check_dir_components_use_same_lock(dir):
+            ctrl_1 = dir.open_repository().control_files
+            ctrl_2 = dir.open_branch().control_files
+            ctrl_3 = dir.open_workingtree()._control_files
+            self.assertTrue(ctrl_1 is ctrl_2)
+            self.assertTrue(ctrl_2 is ctrl_3)
+        check_dir_components_use_same_lock(dir)
+        # and if we open it normally.
+        dir = bzrdir.BzrDir.open(self.get_url())
+        check_dir_components_use_same_lock(dir)
+    
+    def test_can_convert(self):
+        # format 6 dirs are convertable
+        dir = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        self.assertTrue(dir.can_convert_format())
+    
+    def test_needs_conversion(self):
+        # format 6 dirs need an conversion if they are not the default.
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            dir = bzrdir.BzrDirFormat6().initialize(self.get_url())
+            self.assertTrue(dir.needs_format_conversion())
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+        self.assertFalse(dir.needs_format_conversion())
+
+
+class NonLocalTests(TestCaseWithTransport):
+    """Tests for bzrdir static behaviour on non local paths."""
+
+    def setUp(self):
+        super(NonLocalTests, self).setUp()
+        self.transport_server = MemoryServer
+    
+    def test_create_branch_convenience(self):
+        # outside a repo the default convenience output is a repo+branch_tree
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            branch = bzrdir.BzrDir.create_branch_convenience(self.get_url('foo'))
+            self.assertRaises(errors.NoWorkingTree,
+                              branch.bzrdir.open_workingtree)
+            branch.bzrdir.open_repository()
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+
+    def test_create_branch_convenience_force_tree_not_local_fails(self):
+        # outside a repo the default convenience output is a repo+branch_tree
+        old_format = bzrdir.BzrDirFormat.get_default_format()
+        bzrdir.BzrDirFormat.set_default_format(bzrdir.BzrDirMetaFormat1())
+        try:
+            self.assertRaises(errors.NotLocalUrl,
+                bzrdir.BzrDir.create_branch_convenience,
+                self.get_url('foo'),
+                force_new_tree=True)
+            t = get_transport(self.get_url('.'))
+            self.assertFalse(t.has('foo'))
+        finally:
+            bzrdir.BzrDirFormat.set_default_format(old_format)
+

=== modified file 'bzrlib/tests/test_commit.py'
--- bzrlib/tests/test_commit.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_commit.py	2006-03-20 08:31:00 +0000
@@ -18,7 +18,7 @@
 import os
 
 import bzrlib
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.branch import Branch
 from bzrlib.workingtree import WorkingTree
 from bzrlib.commit import Commit
@@ -43,88 +43,92 @@
         return "bzrlib.ahook bzrlib.ahook"
 
 
-class TestCommit(TestCaseInTempDir):
+class TestCommit(TestCaseWithTransport):
 
     def test_simple_commit(self):
         """Commit and check two versions of a single file."""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello world')
-        b.working_tree().add('hello')
-        b.working_tree().commit(message='add hello')
-        file_id = b.working_tree().path2id('hello')
+        wt.add('hello')
+        wt.commit(message='add hello')
+        file_id = wt.path2id('hello')
 
         file('hello', 'w').write('version 2')
-        b.working_tree().commit(message='commit 2')
+        wt.commit(message='commit 2')
 
         eq = self.assertEquals
         eq(b.revno(), 2)
         rh = b.revision_history()
-        rev = b.get_revision(rh[0])
+        rev = b.repository.get_revision(rh[0])
         eq(rev.message, 'add hello')
 
-        tree1 = b.revision_tree(rh[0])
+        tree1 = b.repository.revision_tree(rh[0])
         text = tree1.get_file_text(file_id)
         eq(text, 'hello world')
 
-        tree2 = b.revision_tree(rh[1])
+        tree2 = b.repository.revision_tree(rh[1])
         eq(tree2.get_file_text(file_id), 'version 2')
 
     def test_delete_commit(self):
         """Test a commit with a deleted file"""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello world')
-        b.working_tree().add(['hello'], ['hello-id'])
-        b.working_tree().commit(message='add hello')
+        wt.add(['hello'], ['hello-id'])
+        wt.commit(message='add hello')
 
         os.remove('hello')
-        b.working_tree().commit('removed hello', rev_id='rev2')
+        wt.commit('removed hello', rev_id='rev2')
 
-        tree = b.revision_tree('rev2')
+        tree = b.repository.revision_tree('rev2')
         self.assertFalse(tree.has_id('hello-id'))
 
     def test_pointless_commit(self):
         """Commit refuses unless there are changes or it's forced."""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello')
-        b.working_tree().add(['hello'])
-        b.working_tree().commit(message='add hello')
+        wt.add(['hello'])
+        wt.commit(message='add hello')
         self.assertEquals(b.revno(), 1)
         self.assertRaises(PointlessCommit,
-                          b.working_tree().commit,
+                          wt.commit,
                           message='fails',
                           allow_pointless=False)
         self.assertEquals(b.revno(), 1)
         
     def test_commit_empty(self):
         """Commiting an empty tree works."""
-        b = Branch.initialize(u'.')
-        b.working_tree().commit(message='empty tree', allow_pointless=True)
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+        wt.commit(message='empty tree', allow_pointless=True)
         self.assertRaises(PointlessCommit,
-                          b.working_tree().commit,
+                          wt.commit,
                           message='empty tree',
                           allow_pointless=False)
-        b.working_tree().commit(message='empty tree', allow_pointless=True)
+        wt.commit(message='empty tree', allow_pointless=True)
         self.assertEquals(b.revno(), 2)
 
-
     def test_selective_delete(self):
         """Selective commit in tree with deletions"""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello')
         file('buongia', 'w').write('buongia')
-        b.working_tree().add(['hello', 'buongia'],
+        wt.add(['hello', 'buongia'],
               ['hello-id', 'buongia-id'])
-        b.working_tree().commit(message='add files',
+        wt.commit(message='add files',
                  rev_id='test@rev-1')
         
         os.remove('hello')
         file('buongia', 'w').write('new text')
-        b.working_tree().commit(message='update text',
+        wt.commit(message='update text',
                  specific_files=['buongia'],
                  allow_pointless=False,
                  rev_id='test@rev-2')
 
-        b.working_tree().commit(message='remove hello',
+        wt.commit(message='remove hello',
                  specific_files=['hello'],
                  allow_pointless=False,
                  rev_id='test@rev-3')
@@ -132,20 +136,19 @@
         eq = self.assertEquals
         eq(b.revno(), 3)
 
-        tree2 = b.revision_tree('test@rev-2')
+        tree2 = b.repository.revision_tree('test@rev-2')
         self.assertTrue(tree2.has_filename('hello'))
         self.assertEquals(tree2.get_file_text('hello-id'), 'hello')
         self.assertEquals(tree2.get_file_text('buongia-id'), 'new text')
         
-        tree3 = b.revision_tree('test@rev-3')
+        tree3 = b.repository.revision_tree('test@rev-3')
         self.assertFalse(tree3.has_filename('hello'))
         self.assertEquals(tree3.get_file_text('buongia-id'), 'new text')
 
-
     def test_commit_rename(self):
         """Test commit of a revision where a file is renamed."""
-        b = Branch.initialize(u'.')
-        tree = WorkingTree(u'.', b)
+        tree = self.make_branch_and_tree('.')
+        b = tree.branch
         self.build_tree(['hello'], line_endings='binary')
         tree.add(['hello'], ['hello-id'])
         tree.commit(message='one', rev_id='test@rev-1', allow_pointless=False)
@@ -154,7 +157,7 @@
         tree.commit(message='renamed', rev_id='test@rev-2', allow_pointless=False)
 
         eq = self.assertEquals
-        tree1 = b.revision_tree('test@rev-1')
+        tree1 = b.repository.revision_tree('test@rev-1')
         eq(tree1.id2path('hello-id'), 'hello')
         eq(tree1.get_file_text('hello-id'), 'contents of hello\n')
         self.assertFalse(tree1.has_filename('fruity'))
@@ -162,7 +165,7 @@
         ie = tree1.inventory['hello-id']
         eq(ie.revision, 'test@rev-1')
 
-        tree2 = b.revision_tree('test@rev-2')
+        tree2 = b.repository.revision_tree('test@rev-2')
         eq(tree2.id2path('hello-id'), 'fruity')
         eq(tree2.get_file_text('hello-id'), 'contents of hello\n')
         self.check_inventory_shape(tree2.inventory, ['fruity'])
@@ -171,10 +174,11 @@
 
     def test_reused_rev_id(self):
         """Test that a revision id cannot be reused in a branch"""
-        b = Branch.initialize(u'.')
-        b.working_tree().commit('initial', rev_id='test@rev-1', allow_pointless=True)
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+        wt.commit('initial', rev_id='test@rev-1', allow_pointless=True)
         self.assertRaises(Exception,
-                          b.working_tree().commit,
+                          wt.commit,
                           message='reused id',
                           rev_id='test@rev-1',
                           allow_pointless=True)
@@ -182,77 +186,77 @@
     def test_commit_move(self):
         """Test commit of revisions with moved files and directories"""
         eq = self.assertEquals
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         r1 = 'test@rev-1'
         self.build_tree(['hello', 'a/', 'b/'])
-        b.working_tree().add(['hello', 'a', 'b'], ['hello-id', 'a-id', 'b-id'])
-        b.working_tree().commit('initial', rev_id=r1, allow_pointless=False)
-        b.working_tree().move(['hello'], 'a')
+        wt.add(['hello', 'a', 'b'], ['hello-id', 'a-id', 'b-id'])
+        wt.commit('initial', rev_id=r1, allow_pointless=False)
+        wt.move(['hello'], 'a')
         r2 = 'test@rev-2'
-        b.working_tree().commit('two', rev_id=r2, allow_pointless=False)
-        self.check_inventory_shape(b.working_tree().read_working_inventory(),
+        wt.commit('two', rev_id=r2, allow_pointless=False)
+        self.check_inventory_shape(wt.read_working_inventory(),
                                    ['a', 'a/hello', 'b'])
 
-        b.working_tree().move(['b'], 'a')
+        wt.move(['b'], 'a')
         r3 = 'test@rev-3'
-        b.working_tree().commit('three', rev_id=r3, allow_pointless=False)
-        self.check_inventory_shape(b.working_tree().read_working_inventory(),
+        wt.commit('three', rev_id=r3, allow_pointless=False)
+        self.check_inventory_shape(wt.read_working_inventory(),
                                    ['a', 'a/hello', 'a/b'])
-        self.check_inventory_shape(b.get_revision_inventory(r3),
+        self.check_inventory_shape(b.repository.get_revision_inventory(r3),
                                    ['a', 'a/hello', 'a/b'])
 
-        b.working_tree().move(['a/hello'], 'a/b')
+        wt.move(['a/hello'], 'a/b')
         r4 = 'test@rev-4'
-        b.working_tree().commit('four', rev_id=r4, allow_pointless=False)
-        self.check_inventory_shape(b.working_tree().read_working_inventory(),
+        wt.commit('four', rev_id=r4, allow_pointless=False)
+        self.check_inventory_shape(wt.read_working_inventory(),
                                    ['a', 'a/b/hello', 'a/b'])
 
-        inv = b.get_revision_inventory(r4)
+        inv = b.repository.get_revision_inventory(r4)
         eq(inv['hello-id'].revision, r4)
         eq(inv['a-id'].revision, r1)
         eq(inv['b-id'].revision, r3)
         
     def test_removed_commit(self):
         """Commit with a removed file"""
-        b = Branch.initialize(u'.')
-        wt = b.working_tree()
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello world')
-        b.working_tree().add(['hello'], ['hello-id'])
-        b.working_tree().commit(message='add hello')
-
-        wt = b.working_tree()  # FIXME: kludge for aliasing of working inventory
+        wt.add(['hello'], ['hello-id'])
+        wt.commit(message='add hello')
         wt.remove('hello')
-        b.working_tree().commit('removed hello', rev_id='rev2')
+        wt.commit('removed hello', rev_id='rev2')
 
-        tree = b.revision_tree('rev2')
+        tree = b.repository.revision_tree('rev2')
         self.assertFalse(tree.has_id('hello-id'))
 
-
     def test_committed_ancestry(self):
         """Test commit appends revisions to ancestry."""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         rev_ids = []
         for i in range(4):
             file('hello', 'w').write((str(i) * 4) + '\n')
             if i == 0:
-                b.working_tree().add(['hello'], ['hello-id'])
+                wt.add(['hello'], ['hello-id'])
             rev_id = 'test@rev-%d' % (i+1)
             rev_ids.append(rev_id)
-            b.working_tree().commit(message='rev %d' % (i+1),
+            wt.commit(message='rev %d' % (i+1),
                      rev_id=rev_id)
         eq = self.assertEquals
         eq(b.revision_history(), rev_ids)
         for i in range(4):
-            anc = b.get_ancestry(rev_ids[i])
+            anc = b.repository.get_ancestry(rev_ids[i])
             eq(anc, [None] + rev_ids[:i+1])
 
     def test_commit_new_subdir_child_selective(self):
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         self.build_tree(['dir/', 'dir/file1', 'dir/file2'])
-        b.working_tree().add(['dir', 'dir/file1', 'dir/file2'],
+        wt.add(['dir', 'dir/file1', 'dir/file2'],
               ['dirid', 'file1id', 'file2id'])
-        b.working_tree().commit('dir/file1', specific_files=['dir/file1'], rev_id='1')
-        inv = b.get_inventory('1')
+        wt.commit('dir/file1', specific_files=['dir/file1'], rev_id='1')
+        inv = b.repository.get_inventory('1')
         self.assertEqual('1', inv['dirid'].revision)
         self.assertEqual('1', inv['file1id'].revision)
         # FIXME: This should raise a KeyError I think, rbc20051006
@@ -261,54 +265,62 @@
     def test_strict_commit(self):
         """Try and commit with unknown files and strict = True, should fail."""
         from bzrlib.errors import StrictCommitFailed
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello world')
-        b.working_tree().add('hello')
+        wt.add('hello')
         file('goodbye', 'w').write('goodbye cruel world!')
-        self.assertRaises(StrictCommitFailed, b.working_tree().commit,
+        self.assertRaises(StrictCommitFailed, wt.commit,
             message='add hello but not goodbye', strict=True)
 
     def test_strict_commit_without_unknowns(self):
         """Try and commit with no unknown files and strict = True,
         should work."""
         from bzrlib.errors import StrictCommitFailed
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello world')
-        b.working_tree().add('hello')
-        b.working_tree().commit(message='add hello', strict=True)
+        wt.add('hello')
+        wt.commit(message='add hello', strict=True)
 
     def test_nonstrict_commit(self):
         """Try and commit with unknown files and strict = False, should work."""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello world')
-        b.working_tree().add('hello')
+        wt.add('hello')
         file('goodbye', 'w').write('goodbye cruel world!')
-        b.working_tree().commit(message='add hello but not goodbye', strict=False)
+        wt.commit(message='add hello but not goodbye', strict=False)
 
     def test_nonstrict_commit_without_unknowns(self):
         """Try and commit with no unknown files and strict = False,
         should work."""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         file('hello', 'w').write('hello world')
-        b.working_tree().add('hello')
-        b.working_tree().commit(message='add hello', strict=False)
+        wt.add('hello')
+        wt.commit(message='add hello', strict=False)
 
     def test_signed_commit(self):
         import bzrlib.gpg
         import bzrlib.commit as commit
         oldstrategy = bzrlib.gpg.GPGStrategy
-        branch = Branch.initialize(u'.')
-        branch.working_tree().commit("base", allow_pointless=True, rev_id='A')
-        self.failIf(branch.revision_store.has_id('A', 'sig'))
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        wt.commit("base", allow_pointless=True, rev_id='A')
+        self.failIf(branch.repository.revision_store.has_id('A', 'sig'))
         try:
             from bzrlib.testament import Testament
             # monkey patch gpg signing mechanism
             bzrlib.gpg.GPGStrategy = bzrlib.gpg.LoopbackGPGStrategy
-            commit.Commit(config=MustSignConfig(branch)).commit(branch, "base",
+            commit.Commit(config=MustSignConfig(branch)).commit(message="base",
                                                       allow_pointless=True,
-                                                      rev_id='B')
-            self.assertEqual(Testament.from_revision(branch,'B').as_short_text(),
-                             branch.revision_store.get('B', 'sig').read())
+                                                      rev_id='B',
+                                                      working_tree=wt)
+            self.assertEqual(Testament.from_revision(branch.repository,
+                             'B').as_short_text(),
+                             branch.repository.revision_store.get('B', 
+                                                               'sig').read())
         finally:
             bzrlib.gpg.GPGStrategy = oldstrategy
 
@@ -316,9 +328,10 @@
         import bzrlib.gpg
         import bzrlib.commit as commit
         oldstrategy = bzrlib.gpg.GPGStrategy
-        branch = Branch.initialize(u'.')
-        branch.working_tree().commit("base", allow_pointless=True, rev_id='A')
-        self.failIf(branch.revision_store.has_id('A', 'sig'))
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        wt.commit("base", allow_pointless=True, rev_id='A')
+        self.failIf(branch.repository.revision_store.has_id('A', 'sig'))
         try:
             from bzrlib.testament import Testament
             # monkey patch gpg signing mechanism
@@ -326,18 +339,20 @@
             config = MustSignConfig(branch)
             self.assertRaises(SigningFailed,
                               commit.Commit(config=config).commit,
-                              branch, "base",
+                              message="base",
                               allow_pointless=True,
-                              rev_id='B')
-            branch = Branch.open(u'.')
+                              rev_id='B',
+                              working_tree=wt)
+            branch = Branch.open(self.get_url('.'))
             self.assertEqual(branch.revision_history(), ['A'])
-            self.failIf(branch.revision_store.has_id('B'))
+            self.failIf(branch.repository.revision_store.has_id('B'))
         finally:
             bzrlib.gpg.GPGStrategy = oldstrategy
 
     def test_commit_invokes_hooks(self):
         import bzrlib.commit as commit
-        branch = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
         calls = []
         def called(branch, rev_id):
             calls.append('called')
@@ -345,9 +360,21 @@
         try:
             config = BranchWithHooks(branch)
             commit.Commit(config=config).commit(
-                            branch, "base",
+                            message = "base",
                             allow_pointless=True,
-                            rev_id='A')
+                            rev_id='A', working_tree = wt)
             self.assertEqual(['called', 'called'], calls)
         finally:
             del bzrlib.ahook
+
+    def test_commit_object_doesnt_set_nick(self):
+        # using the Commit object directly does not set the branch nick.
+        wt = self.make_branch_and_tree('.')
+        c = Commit()
+        c.commit(working_tree=wt, message='empty tree', allow_pointless=True)
+        self.assertEquals(wt.branch.revno(), 1)
+        self.assertEqual({},
+                         wt.branch.repository.get_revision(
+                            wt.branch.last_revision()).properties)
+
+

=== modified file 'bzrlib/tests/test_commit_merge.py'
--- bzrlib/tests/test_commit_merge.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_commit_merge.py	2006-03-20 08:31:00 +0000
@@ -18,16 +18,14 @@
 import os
 import shutil
 
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.branch import Branch
-from bzrlib.commit import commit
 from bzrlib.errors import PointlessCommit, BzrError, PointlessCommit
 from bzrlib.tests.test_revision import make_branches
-from bzrlib.fetch import fetch
 from bzrlib.check import check
 
 
-class TestCommitMerge(TestCaseInTempDir):
+class TestCommitMerge(TestCaseWithTransport):
     """Tests for committing the results of a merge.
 
     These don't currently test the merge code, which is intentional to
@@ -36,60 +34,61 @@
 
     def test_merge_commit_empty(self):
         """Simple commit of two-way merge of empty trees."""
-        os.mkdir('x')
-        os.mkdir('y')
-        bx = Branch.initialize('x')
-        by = Branch.initialize('y')
-
-        commit(bx, 'commit one', rev_id='x@u-0-1', allow_pointless=True)
-        commit(by, 'commit two', rev_id='y@u-0-1', allow_pointless=True)
-
-        fetcher = fetch(from_branch=bx, to_branch=by)
-        self.assertEqual(1, fetcher.count_copied)
-        self.assertEqual([], fetcher.failed_revisions)
+        wtx = self.make_branch_and_tree('x')
+        bx = wtx.branch
+        wty = self.make_branch_and_tree('y')
+        by = wty.branch
+
+        wtx.commit('commit one', rev_id='x@u-0-1', allow_pointless=True)
+        wty.commit('commit two', rev_id='y@u-0-1', allow_pointless=True)
+
+        self.assertEqual((1, []), by.fetch(bx))
         # just having the history there does nothing
         self.assertRaises(PointlessCommit,
-                          commit,
-                          by, 'no changes yet', rev_id='y@u-0-2',
+                          wty.commit,
+                          'no changes yet', rev_id='y@u-0-2',
                           allow_pointless=False)
-        by.working_tree().add_pending_merge('x@u-0-1')
-        commit(by, 'merge from x', rev_id='y@u-0-2', allow_pointless=False)
+        wty.add_pending_merge('x@u-0-1')
+        wty.commit('merge from x', rev_id='y@u-0-2', allow_pointless=False)
 
         self.assertEquals(by.revno(), 2)
         self.assertEquals(list(by.revision_history()),
                           ['y@u-0-1', 'y@u-0-2'])
-        rev = by.get_revision('y@u-0-2')
+        rev = by.repository.get_revision('y@u-0-2')
         self.assertEquals(rev.parent_ids,
                           ['y@u-0-1', 'x@u-0-1'])
 
     def test_merge_new_file(self):
         """Commit merge of two trees with no overlapping files."""
-        self.build_tree(['x/', 'x/ecks', 'y/', 'y/why'])
-
-        bx = Branch.initialize('x')
-        by = Branch.initialize('y')
-        bx.working_tree().add(['ecks'], ['ecks-id'])
-        by.working_tree().add(['why'], ['why-id'])
-
-        commit(bx, 'commit one', rev_id='x@u-0-1', allow_pointless=True)
-        commit(by, 'commit two', rev_id='y@u-0-1', allow_pointless=True)
-
-        fetch(from_branch=bx, to_branch=by)
+        wtx = self.make_branch_and_tree('x')
+        bx = wtx.branch
+        wty = self.make_branch_and_tree('y')
+        by = wty.branch
+
+        self.build_tree(['x/ecks', 'y/why'])
+
+        wtx.add(['ecks'], ['ecks-id'])
+        wty.add(['why'], ['why-id'])
+
+        wtx.commit('commit one', rev_id='x@u-0-1', allow_pointless=True)
+        wty.commit('commit two', rev_id='y@u-0-1', allow_pointless=True)
+
+        by.fetch(bx)
         # we haven't merged the texts, but let's fake it
         shutil.copyfile('x/ecks', 'y/ecks')
-        by.working_tree().add(['ecks'], ['ecks-id'])
-        by.working_tree().add_pending_merge('x@u-0-1')
+        wty.add(['ecks'], ['ecks-id'])
+        wty.add_pending_merge('x@u-0-1')
 
         # partial commit of merges is currently not allowed, because
         # it would give different merge graphs for each file which
         # might be complex.  it can be allowed in the future.
         self.assertRaises(Exception,
-                          commit,
-                          by, 'partial commit', allow_pointless=False,
+                          wty.commit,
+                          'partial commit', allow_pointless=False,
                           specific_files=['ecks'])
         
-        commit(by, 'merge from x', rev_id='y@u-0-2', allow_pointless=False)
-        tree = by.revision_tree('y@u-0-2')
+        wty.commit('merge from x', rev_id='y@u-0-2', allow_pointless=False)
+        tree = by.repository.revision_tree('y@u-0-2')
         inv = tree.inventory
         self.assertEquals(inv['ecks-id'].revision, 'x@u-0-1')
         self.assertEquals(inv['why-id'].revision, 'y@u-0-1')

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_config.py	2006-03-20 08:31:00 +0000
@@ -28,11 +28,16 @@
 from bzrlib.tests import TestCase, TestCaseInTempDir
 
 
+sample_long_alias="log -r-15..-1 --line"
 sample_config_text = ("[DEFAULT]\n"
                       "email=Robert Collins <robertc@example.com>\n"
                       "editor=vim\n"
                       "gpg_signing_command=gnome-gpg\n"
-                      "user_global_option=something\n")
+                      "log_format=short\n"
+                      "user_global_option=something\n"
+                      "[ALIASES]\n"
+                      "h=help\n"
+                      "ll=" + sample_long_alias + "\n")
 
 
 sample_always_signatures = ("[DEFAULT]\n"
@@ -70,6 +75,7 @@
                         "#testing explicit beats globs\n")
 
 
+
 class InstrumentedConfigObj(object):
     """A config obj look-enough-alike to record calls made to it."""
 
@@ -95,9 +101,15 @@
 
     def __init__(self):
         self.base = "http://example.com/branches/demo"
+        self.control_files = FakeControlFiles()
+
+
+class FakeControlFiles(object):
+
+    def __init__(self):
         self.email = 'Robert Collins <robertc@example.net>\n'
 
-    def controlfile(self, filename, mode):
+    def get_utf8(self, filename):
         if filename != 'email':
             raise NotImplementedError
         if self.email is not None:
@@ -122,6 +134,23 @@
         return self._signatures
 
 
+bool_config = """[DEFAULT]
+active = true
+inactive = false
+[UPPERCASE]
+active = True
+nonactive = False
+"""
+class TestConfigObj(TestCase):
+    def test_get_bool(self):
+        from bzrlib.config import ConfigObj
+        co = ConfigObj(StringIO(bool_config))
+        self.assertIs(co.get_bool('DEFAULT', 'active'), True)
+        self.assertIs(co.get_bool('DEFAULT', 'inactive'), False)
+        self.assertIs(co.get_bool('UPPERCASE', 'active'), True)
+        self.assertIs(co.get_bool('UPPERCASE', 'nonactive'), False)
+
+
 class TestConfig(TestCase):
 
     def test_constructs(self):
@@ -170,6 +199,10 @@
         my_config = config.Config()
         self.assertEqual(None, my_config.post_commit())
 
+    def test_log_format_default(self):
+        my_config = config.Config()
+        self.assertEqual('long', my_config.log_format())
+
 
 class TestConfigPath(TestCase):
 
@@ -346,6 +379,21 @@
         my_config = self._get_sample_config()
         self.assertEqual(None, my_config.post_commit())
 
+    def test_configured_logformat(self):
+        my_config = self._get_sample_config()
+        self.assertEqual("short", my_config.log_format())
+
+    def test_get_alias(self):
+        my_config = self._get_sample_config()
+        self.assertEqual('help', my_config.get_alias('h'))
+
+    def test_get_no_alias(self):
+        my_config = self._get_sample_config()
+        self.assertEqual(None, my_config.get_alias('foo'))
+
+    def test_get_long_alias(self):
+        my_config = self._get_sample_config()
+        self.assertEqual(sample_long_alias, my_config.get_alias('ll'))
 
 class TestLocationConfig(TestCase):
 
@@ -541,19 +589,19 @@
         my_config = config.BranchConfig(branch)
         self.assertEqual("Robert Collins <robertc@example.net>",
                          my_config._get_user_id())
-        branch.email = "John"
+        branch.control_files.email = "John"
         self.assertEqual("John", my_config._get_user_id())
 
     def test_not_set_in_branch(self):
         branch = FakeBranch()
         my_config = config.BranchConfig(branch)
-        branch.email = None
+        branch.control_files.email = None
         config_file = StringIO(sample_config_text)
         (my_config._get_location_config().
             _get_global_config()._get_parser(config_file))
         self.assertEqual("Robert Collins <robertc@example.com>",
                          my_config._get_user_id())
-        branch.email = "John"
+        branch.control_files.email = "John"
         self.assertEqual("John", my_config._get_user_id())
 
     def test_BZREMAIL_OVERRIDES(self):

=== modified file 'bzrlib/tests/test_conflicts.py'
--- bzrlib/tests/test_conflicts.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_conflicts.py	2006-03-20 08:31:00 +0000
@@ -17,26 +17,26 @@
 
 import os
 
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.branch import Branch
-from bzrlib.commit import Commit
 from bzrlib.conflicts import restore
 from bzrlib.errors import NotConflicted
 
 # TODO: Test commit with some added, and added-but-missing files
+# RBC 20060124 is that not tested in test_commit.py ?
 
-class TestConflicts(TestCaseInTempDir):
+class TestConflicts(TestCaseWithTransport):
 
     def test_conflicts(self):
         """Conflicts are detected properly"""
-        b = Branch.initialize(u'.')
+        tree = self.make_branch_and_tree('.')
+        b = tree.branch
         file('hello', 'w').write('hello world4')
         file('hello.THIS', 'w').write('hello world2')
         file('hello.BASE', 'w').write('hello world1')
         file('hello.OTHER', 'w').write('hello world3')
         file('hello.sploo.BASE', 'w').write('yellow world')
         file('hello.sploo.OTHER', 'w').write('yellow world2')
-        tree = b.working_tree()
         self.assertEqual(len(list(tree.list_files())), 6)
         conflicts = list(tree.iter_conflicts())
         self.assertEqual(len(conflicts), 2)

=== added file 'bzrlib/tests/test_decorators.py'
--- bzrlib/tests/test_decorators.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_decorators.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,44 @@
+# Copyright (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests for decorator functions"""
+
+from bzrlib.decorators import needs_read_lock
+from bzrlib.tests import TestCase
+
+
+class DecoratorSample(object):
+    """Sample class that uses decorators.
+
+    This doesn't actually work because the class doesn't have the 
+    requiste lock_read()/unlock() methods.
+    """
+
+    @needs_read_lock
+    def frob(self):
+        """Frob the sample object"""
+
+
+class TestDecoratorDocs(TestCase):
+    """Test method decorators"""
+
+    def test_read_lock_passthrough(self):
+        """@needs_read_lock exposes underlying name and doc."""
+        sam = DecoratorSample()
+        self.assertEqual(sam.frob.__name__, 'frob')
+        self.assertEqual(sam.frob.__doc__, 
+                'Frob the sample object')

=== added file 'bzrlib/tests/test_doc_generate.py'
--- bzrlib/tests/test_doc_generate.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_doc_generate.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,28 @@
+# Copyright (C) 2006 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib.tests import TestCaseInTempDir
+from bzrlib.branch import Branch
+import tools.doc_generate
+
+
+class TestDocGenerate(TestCaseInTempDir):
+
+    def test_generate_manpage(self):
+        """Simple smoke test for doc_generate"""
+        infogen_mod = tools.doc_generate.get_module("man")
+
+

=== added file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_errors.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,46 @@
+# Copyright (C) 2006 by Canonical Ltd
+#   Authors: Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for the formatting and construction of errors."""
+
+import bzrlib.bzrdir as bzrdir
+import bzrlib.errors as errors
+from bzrlib.tests import TestCaseWithTransport
+
+
+class TestErrors(TestCaseWithTransport):
+
+    def test_no_repo(self):
+        dir = bzrdir.BzrDir.create(self.get_url())
+        error = errors.NoRepositoryPresent(dir)
+        self.assertNotEqual(-1, str(error).find(repr(dir.transport.clone('..').base)))
+        self.assertEqual(-1, str(error).find(repr(dir.transport.base)))
+
+    def test_up_to_date(self):
+        error = errors.UpToDateFormat(bzrdir.BzrDirFormat4())
+        self.assertEqualDiff("The branch format Bazaar-NG branch, "
+                             "format 0.0.4 is already at the most "
+                             "recent format.",
+                             str(error))
+
+    def test_corrupt_repository(self):
+        repo = self.make_repository('.')
+        error = errors.CorruptRepository(repo)
+        self.assertEqualDiff("An error has been detected in the repository %s.\n"
+                             "Please run bzr reconcile on this repository." %
+                             repo.bzrdir.root_transport.base,
+                             str(error))

=== modified file 'bzrlib/tests/test_fetch.py'
--- bzrlib/tests/test_fetch.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_fetch.py	2006-03-20 08:31:00 +0000
@@ -17,90 +17,86 @@
 import os
 import sys
 
+from bzrlib.branch import Branch
+from bzrlib.bzrdir import BzrDir
+from bzrlib.builtins import merge
 import bzrlib.errors
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
 from bzrlib.tests.test_revision import make_branches
 from bzrlib.trace import mutter
-from bzrlib.branch import Branch
-from bzrlib.fetch import greedy_fetch
-from bzrlib.merge import merge
-from bzrlib.clone import copy_branch
-
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
+from bzrlib.workingtree import WorkingTree
 
 
 def has_revision(branch, revision_id):
-    try:
-        branch.get_revision_xml(revision_id)
-        return True
-    except bzrlib.errors.NoSuchRevision:
-        return False
+    return branch.repository.has_revision(revision_id)
 
 def fetch_steps(self, br_a, br_b, writable_a):
     """A foreign test method for testing fetch locally and remotely."""
-    def new_branch(name):
-        os.mkdir(name)
-        return Branch.initialize(name)
-            
-    self.assertFalse(has_revision(br_b, br_a.revision_history()[3]))
-    self.assert_(has_revision(br_b, br_a.revision_history()[2]))
-    self.assertEquals(len(br_b.revision_history()), 7)
-    self.assertEquals(greedy_fetch(br_b, br_a, br_a.revision_history()[2])[0], 0)
-
-    # greedy_fetch is not supposed to alter the revision history
-    self.assertEquals(len(br_b.revision_history()), 7)
-    self.assertFalse(has_revision(br_b, br_a.revision_history()[3]))
-
-    self.assertEquals(len(br_b.revision_history()), 7)
-    self.assertEquals(greedy_fetch(br_b, br_a, br_a.revision_history()[3])[0], 1)
-    self.assert_(has_revision(br_b, br_a.revision_history()[3]))
+     
+    # TODO RBC 20060201 make this a repository test.
+    repo_b = br_b.repository
+    self.assertFalse(repo_b.has_revision(br_a.revision_history()[3]))
+    self.assertTrue(repo_b.has_revision(br_a.revision_history()[2]))
+    self.assertEquals(len(br_b.revision_history()), 7)
+    self.assertEquals(br_b.fetch(br_a, br_a.revision_history()[2])[0], 0)
+    # branch.fetch is not supposed to alter the revision history
+    self.assertEquals(len(br_b.revision_history()), 7)
+    self.assertFalse(repo_b.has_revision(br_a.revision_history()[3]))
+
+    # fetching the next revision up in sample data copies one revision
+    self.assertEquals(br_b.fetch(br_a, br_a.revision_history()[3])[0], 1)
+    self.assertTrue(repo_b.has_revision(br_a.revision_history()[3]))
     self.assertFalse(has_revision(br_a, br_b.revision_history()[6]))
-    self.assert_(has_revision(br_a, br_b.revision_history()[5]))
+    self.assertTrue(br_a.repository.has_revision(br_b.revision_history()[5]))
 
     # When a non-branch ancestor is missing, it should be unlisted...
     # as its not reference from the inventory weave.
-    br_b4 = new_branch('br_4')
-    count, failures = greedy_fetch(br_b4, br_b)
+    br_b4 = self.make_branch('br_4')
+    count, failures = br_b4.fetch(br_b)
     self.assertEqual(count, 7)
     self.assertEqual(failures, [])
 
-    self.assertEqual(greedy_fetch(writable_a, br_b)[0], 1)
-    self.assert_(has_revision(br_a, br_b.revision_history()[3]))
-    self.assert_(has_revision(br_a, br_b.revision_history()[4]))
+    self.assertEqual(writable_a.fetch(br_b)[0], 1)
+    self.assertTrue(has_revision(br_a, br_b.revision_history()[3]))
+    self.assertTrue(has_revision(br_a, br_b.revision_history()[4]))
         
-    br_b2 = new_branch('br_b2')
-    self.assertEquals(greedy_fetch(br_b2, br_b)[0], 7)
-    self.assert_(has_revision(br_b2, br_b.revision_history()[4]))
-    self.assert_(has_revision(br_b2, br_a.revision_history()[2]))
+    br_b2 = self.make_branch('br_b2')
+    self.assertEquals(br_b2.fetch(br_b)[0], 7)
+    self.assertTrue(has_revision(br_b2, br_b.revision_history()[4]))
+    self.assertTrue(has_revision(br_b2, br_a.revision_history()[2]))
     self.assertFalse(has_revision(br_b2, br_a.revision_history()[3]))
 
-    br_a2 = new_branch('br_a2')
-    self.assertEquals(greedy_fetch(br_a2, br_a)[0], 9)
-    self.assert_(has_revision(br_a2, br_b.revision_history()[4]))
-    self.assert_(has_revision(br_a2, br_a.revision_history()[3]))
-    self.assert_(has_revision(br_a2, br_a.revision_history()[2]))
+    br_a2 = self.make_branch('br_a2')
+    self.assertEquals(br_a2.fetch(br_a)[0], 9)
+    self.assertTrue(has_revision(br_a2, br_b.revision_history()[4]))
+    self.assertTrue(has_revision(br_a2, br_a.revision_history()[3]))
+    self.assertTrue(has_revision(br_a2, br_a.revision_history()[2]))
 
-    br_a3 = new_branch('br_a3')
-    self.assertEquals(greedy_fetch(br_a3, br_a2)[0], 0)
+    br_a3 = self.make_branch('br_a3')
+    # pulling a branch with no revisions grabs nothing, regardless of 
+    # whats in the inventory.
+    self.assertEquals(br_a3.fetch(br_a2)[0], 0)
     for revno in range(4):
-        self.assertFalse(has_revision(br_a3, br_a.revision_history()[revno]))
-    self.assertEqual(greedy_fetch(br_a3, br_a2, br_a.revision_history()[2])[0], 3)
-    fetched = greedy_fetch(br_a3, br_a2, br_a.revision_history()[3])[0]
+        self.assertFalse(
+            br_a3.repository.has_revision(br_a.revision_history()[revno]))
+    self.assertEqual(br_a3.fetch(br_a2, br_a.revision_history()[2])[0], 3)
+    # pull the 3 revisions introduced by a@u-0-3
+    fetched = br_a3.fetch(br_a2, br_a.revision_history()[3])[0]
     self.assertEquals(fetched, 3, "fetched %d instead of 3" % fetched)
     # InstallFailed should be raised if the branch is missing the revision
     # that was requested.
-    self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
-                      br_a2, 'pizza')
+    self.assertRaises(bzrlib.errors.InstallFailed, br_a3.fetch, br_a2, 'pizza')
     # InstallFailed should be raised if the branch is missing a revision
     # from its own revision history
     br_a2.append_revision('a-b-c')
-    self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
-                      br_a2)
-
-
+    self.assertRaises(bzrlib.errors.InstallFailed, br_a3.fetch, br_a2)
     #TODO: test that fetch correctly does reweaving when needed. RBC 20051008
-
-class TestFetch(TestCaseInTempDir):
+    # Note that this means - updating the weave when ghosts are filled in to 
+    # add the right parents.
+
+
+class TestFetch(TestCaseWithTransport):
 
     def test_fetch(self):
         #highest indices a: 5, b: 7
@@ -108,61 +104,62 @@
         fetch_steps(self, br_a, br_b, br_a)
 
 
-class TestMergeFetch(TestCaseInTempDir):
+class TestMergeFetch(TestCaseWithTransport):
 
     def test_merge_fetches_unrelated(self):
         """Merge brings across history from unrelated source"""
-        os.mkdir('br1')
-        br1 = Branch.initialize('br1')
-        br1.working_tree().commit(message='rev 1-1', rev_id='1-1')
-        br1.working_tree().commit(message='rev 1-2', rev_id='1-2')
-        os.mkdir('br2')
-        br2 = Branch.initialize('br2')
-        br2.working_tree().commit(message='rev 2-1', rev_id='2-1')
+        wt1 = self.make_branch_and_tree('br1')
+        br1 = wt1.branch
+        wt1.commit(message='rev 1-1', rev_id='1-1')
+        wt1.commit(message='rev 1-2', rev_id='1-2')
+        wt2 = self.make_branch_and_tree('br2')
+        br2 = wt2.branch
+        wt2.commit(message='rev 2-1', rev_id='2-1')
         merge(other_revision=['br1', -1], base_revision=['br1', 0],
               this_dir='br2')
         self._check_revs_present(br2)
 
     def test_merge_fetches(self):
         """Merge brings across history from source"""
-        os.mkdir('br1')
-        br1 = Branch.initialize('br1')
-        br1.working_tree().commit(message='rev 1-1', rev_id='1-1')
-        copy_branch(br1, 'br2')
-        br2 = Branch.open('br2')
-        br1.working_tree().commit(message='rev 1-2', rev_id='1-2')
-        br2.working_tree().commit(message='rev 2-1', rev_id='2-1')
+        wt1 = self.make_branch_and_tree('br1')
+        br1 = wt1.branch
+        wt1.commit(message='rev 1-1', rev_id='1-1')
+        dir_2 = br1.bzrdir.sprout('br2')
+        br2 = dir_2.open_branch()
+        wt1.commit(message='rev 1-2', rev_id='1-2')
+        dir_2.open_workingtree().commit(message='rev 2-1', rev_id='2-1')
         merge(other_revision=['br1', -1], base_revision=[None, None], 
               this_dir='br2')
         self._check_revs_present(br2)
 
     def _check_revs_present(self, br2):
         for rev_id in '1-1', '1-2', '2-1':
-            self.assertTrue(br2.has_revision(rev_id))
-            rev = br2.get_revision(rev_id)
+            self.assertTrue(br2.repository.has_revision(rev_id))
+            rev = br2.repository.get_revision(rev_id)
             self.assertEqual(rev.revision_id, rev_id)
-            self.assertTrue(br2.get_inventory(rev_id))
-
-
-
-class TestMergeFileHistory(TestCaseInTempDir):
+            self.assertTrue(br2.repository.get_inventory(rev_id))
+
+
+class TestMergeFileHistory(TestCaseWithTransport):
+
     def setUp(self):
-        TestCaseInTempDir.setUp(self)
-        os.mkdir('br1')
-        br1 = Branch.initialize('br1')
+        super(TestMergeFileHistory, self).setUp()
+        wt1 = self.make_branch_and_tree('br1')
+        br1 = wt1.branch
         self.build_tree_contents([('br1/file', 'original contents\n')])
-        br1.working_tree().add(['file'], ['this-file-id'])
-        br1.working_tree().commit(message='rev 1-1', rev_id='1-1')
-        copy_branch(br1, 'br2')
-        br2 = Branch.open('br2')
+        wt1.add('file', 'this-file-id')
+        wt1.commit(message='rev 1-1', rev_id='1-1')
+        dir_2 = br1.bzrdir.sprout('br2')
+        br2 = dir_2.open_branch()
+        wt2 = dir_2.open_workingtree()
         self.build_tree_contents([('br1/file', 'original from 1\n')])
-        br1.working_tree().commit(message='rev 1-2', rev_id='1-2')
+        wt1.commit(message='rev 1-2', rev_id='1-2')
         self.build_tree_contents([('br1/file', 'agreement\n')])
-        br1.working_tree().commit(message='rev 1-3', rev_id='1-3')
+        wt1.commit(message='rev 1-3', rev_id='1-3')
         self.build_tree_contents([('br2/file', 'contents in 2\n')])
-        br2.working_tree().commit(message='rev 2-1', rev_id='2-1')
+        wt2.commit(message='rev 2-1', rev_id='2-1')
         self.build_tree_contents([('br2/file', 'agreement\n')])
-        br2.working_tree().commit(message='rev 2-2', rev_id='2-2')
+        wt2.commit(message='rev 2-2', rev_id='2-2')
 
     def test_merge_fetches_file_history(self):
         """Merge brings across file histories"""
@@ -173,61 +170,55 @@
                              ('1-3', 'agreement\n'),
                              ('2-1', 'contents in 2\n'),
                              ('2-2', 'agreement\n')]:
-            self.assertEqualDiff(br2.revision_tree(rev_id).get_file_text('this-file-id'),
-                                 text)
-
-
+            self.assertEqualDiff(
+                br2.repository.revision_tree(
+                    rev_id).get_file_text('this-file-id'), text)
 
 
 class TestHttpFetch(TestCaseWithWebserver):
-
-    def setUp(self):
-        super(TestHttpFetch, self).setUp()
-        self.weblogs = []
+    # FIXME RBC 20060124 this really isn't web specific, perhaps an
+    # instrumented readonly transport? Can we do an instrumented
+    # adapter and use self.get_readonly_url ?
 
     def test_fetch(self):
         #highest indices a: 5, b: 7
         br_a, br_b = make_branches(self)
-        br_rem_a = Branch.open(self.get_remote_url(br_a._transport.base))
+        br_rem_a = Branch.open(self.get_readonly_url('branch1'))
         fetch_steps(self, br_rem_a, br_b, br_a)
 
-    def log(self, *args):
-        """Capture web server log messages for introspection."""
-        super(TestHttpFetch, self).log(*args)
-        # if this call indicates a url being fetched, save it specially
-        if args[0].startswith("webserver"):
-            self.weblogs.append(args[3])
-
     def test_weaves_are_retrieved_once(self):
         self.build_tree(("source/", "source/file", "target/"))
-        branch = Branch.initialize("source")
-        branch.working_tree().add(["file"], ["id"])
-        branch.working_tree().commit("added file")
+        wt = self.make_branch_and_tree('source')
+        branch = wt.branch
+        wt.add(["file"], ["id"])
+        wt.commit("added file")
         print >>open("source/file", 'w'), "blah"
-        branch.working_tree().commit("changed file")
-        target = Branch.initialize("target/")
-        source = Branch.open(self.get_remote_url("source/"))
-        self.assertEqual(greedy_fetch(target, source), (2, []))
+        wt.commit("changed file")
+        target = BzrDir.create_branch_and_repo("target/")
+        source = Branch.open(self.get_readonly_url("source/"))
+        self.assertEqual(target.fetch(source), (2, []))
+        log_pattern = '%%s HTTP/1.1" 200 - "-" "bzr/%s"' % bzrlib.__version__
         # this is the path to the literal file. As format changes 
         # occur it needs to be updated. FIXME: ask the store for the
         # path.
-        weave_suffix = 'weaves/ce/id.weave HTTP/1.1" 200 -'
-        self.assertEqual(1,
-            len([log for log in self.weblogs if log.endswith(weave_suffix)]))
-        inventory_weave_suffix = 'inventory.weave HTTP/1.1" 200 -'
-        self.assertEqual(1,
-            len([log for log in self.weblogs if log.endswith(
+        weave_suffix = log_pattern % 'weaves/ce/id.weave'
+        self.assertEqual(1,
+            len([log for log in self.get_readonly_server().logs if log.endswith(weave_suffix)]))
+        inventory_weave_suffix = log_pattern % 'inventory.weave'
+        self.assertEqual(1,
+            len([log for log in self.get_readonly_server().logs if log.endswith(
                 inventory_weave_suffix)]))
         # this r-h check test will prevent regressions, but it currently already 
         # passes, before the patch to cache-rh is applied :[
-        revision_history_suffix = 'revision-history HTTP/1.1" 200 -'
+        revision_history_suffix = log_pattern % 'revision-history'
         self.assertEqual(1,
-            len([log for log in self.weblogs if log.endswith(
+            len([log for log in self.get_readonly_server().logs if log.endswith(
                 revision_history_suffix)]))
-        self.weblogs = []
+        # FIXME naughty poking in there.
+        self.get_readonly_server().logs = []
         # check there is nothing more to fetch
-        source = Branch.open(self.get_remote_url("source/"))
-        self.assertEqual(greedy_fetch(target, source), (0, []))
-        self.failUnless(self.weblogs[0].endswith('branch-format HTTP/1.1" 200 -'))
-        self.failUnless(self.weblogs[1].endswith('revision-history HTTP/1.1" 200 -'))
-        self.assertEqual(2, len(self.weblogs))
+        source = Branch.open(self.get_readonly_url("source/"))
+        self.assertEqual(target.fetch(source), (0, []))
+        self.failUnless(self.get_readonly_server().logs[0].endswith(log_pattern % 'branch-format'))
+        self.failUnless(self.get_readonly_server().logs[1].endswith(log_pattern % 'revision-history'))
+        self.assertEqual(2, len(self.get_readonly_server().logs))

=== modified file 'bzrlib/tests/test_hashcache.py'
--- bzrlib/tests/test_hashcache.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_hashcache.py	2006-03-20 08:31:00 +0000
@@ -15,14 +15,16 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
+import sha
 import sys
 import time
+
+from bzrlib.errors import BzrError
+from bzrlib.hashcache import HashCache
 from bzrlib.tests import TestCaseInTempDir
 
 
-
 def sha1(t):
-    import sha
     return sha.new(t).hexdigest()
 
 
@@ -36,18 +38,20 @@
     start = int(time.time())
     while int(time.time()) == start:
         time.sleep(0.2)
+
+
+class FixThisError(Exception):
+    pass
     
 
 class TestHashCache(TestCaseInTempDir):
 
     def test_hashcache(self):
         """Functional tests for hashcache"""
-        from bzrlib.hashcache import HashCache
-        import os
 
         # make a dummy bzr directory just to hold the cache
         os.mkdir('.bzr')
-        hc = HashCache(u'.')
+        hc = HashCache('.', '.bzr/stat-cache')
 
         file('foo', 'wb').write('hello')
         os.mkdir('subdir')
@@ -110,7 +114,7 @@
         hc.write()
         del hc
 
-        hc = HashCache(u'.')
+        hc = HashCache('.', '.bzr/stat-cache')
         hc.read()
 
         self.assertEquals(len(hc._cache), 2)
@@ -118,3 +122,25 @@
         self.assertEquals(hc.hit_count, 1)
         self.assertEquals(hc.miss_count, 0)
         self.assertEquals(hc.get_sha1('foo2'), sha1('new content'))
+
+    def test_hashcache_raise(self):
+        """check that hashcache can raise BzrError"""
+
+        os.mkdir('.bzr')
+        hc = HashCache('.', '.bzr/stat-cache')
+        ok = False
+
+        # make a best effort to create a weird kind of file
+        funcs = (os.mkfifo, os.mknod)
+        for func in funcs:
+            try:
+                func('a')
+                ok = True
+                break
+            except FixThisError:
+                pass
+
+        if ok:
+            self.assertRaises(BzrError, hc.get_sha1, 'a')
+        else:
+            raise BzrError("no weird file type could be created: extend this test case for your os")

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_http.py	2006-03-20 08:31:00 +0000
@@ -1,6 +1,8 @@
 # (C) 2005 Canonical
 
+import bzrlib
 from bzrlib.tests import TestCase
+from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
 from bzrlib.transport.http import HttpTransport, extract_auth
 
 class FakeManager (object):
@@ -10,7 +12,7 @@
     def add_password(self, realm, host, username, password):
         self.credentials.append([realm, host, username, password])
 
-        
+
 class TestHttpUrls(TestCase):
     def test_url_parsing(self):
         f = FakeManager()
@@ -51,3 +53,35 @@
         eq = self.assertEqualDiff
         eq(t.abspath('.bzr/tree-version'),
            'http://bzr.ozlabs.org/.bzr/tree-version')
+
+
+class TestHttpConnections(TestCaseWithWebserver):
+
+    def setUp(self):
+        super(TestHttpConnections, self).setUp()
+        self.build_tree(['xxx', 'foo/', 'foo/bar'], line_endings='binary')
+
+    def test_http_has(self):
+        server = self.get_readonly_server()
+        t = HttpTransport(server.get_url())
+        self.assertEqual(t.has('foo/bar'), True)
+        self.assertEqual(len(server.logs), 1)
+        self.assertTrue(server.logs[0].endswith(
+            '"HEAD /foo/bar HTTP/1.1" 200 - "-" "bzr/%s"'
+            % bzrlib.__version__))
+
+        self.assertEqual(t.has('not-found'), False)
+        self.assertTrue(server.logs[-1].endswith(
+            '"HEAD /not-found HTTP/1.1" 404 - "-" "bzr/%s"'
+            % bzrlib.__version__))
+
+    def test_http_get(self):
+        server = self.get_readonly_server()
+        t = HttpTransport(server.get_url())
+        fp = t.get('foo/bar')
+        self.assertEqualDiff(
+            fp.read(),
+            'contents of foo/bar\n')
+        self.assertEqual(len(server.logs), 1)
+        self.assertTrue(server.logs[0].endswith(
+            '"GET /foo/bar HTTP/1.1" 200 - "-" "bzr/%s"' % bzrlib.__version__))

=== modified file 'bzrlib/tests/test_inv.py'
--- bzrlib/tests/test_inv.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_inv.py	2006-03-20 08:31:00 +0000
@@ -18,13 +18,12 @@
 import os
 
 from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
 import bzrlib.errors as errors
 from bzrlib.diff import internal_diff
 from bzrlib.inventory import Inventory, ROOT_ID
 import bzrlib.inventory as inventory
 from bzrlib.osutils import has_symlinks, rename, pathjoin
-from bzrlib.tests import TestCase, TestCaseInTempDir
+from bzrlib.tests import TestCase, TestCaseWithTransport
 
 
 class TestInventory(TestCase):
@@ -133,26 +132,26 @@
         self.failIf(link.has_text())
 
 
-class TestEntryDiffing(TestCaseInTempDir):
+class TestEntryDiffing(TestCaseWithTransport):
 
     def setUp(self):
         super(TestEntryDiffing, self).setUp()
-        self.branch = Branch.initialize(u'.')
-        self.wt = self.branch.working_tree()
+        self.wt = self.make_branch_and_tree('.')
+        self.branch = self.wt.branch
         print >> open('file', 'wb'), 'foo'
-        self.branch.working_tree().add(['file'], ['fileid'])
+        self.wt.add(['file'], ['fileid'])
         if has_symlinks():
             os.symlink('target1', 'symlink')
-            self.branch.working_tree().add(['symlink'], ['linkid'])
+            self.wt.add(['symlink'], ['linkid'])
         self.wt.commit('message_1', rev_id = '1')
         print >> open('file', 'wb'), 'bar'
         if has_symlinks():
             os.unlink('symlink')
             os.symlink('target2', 'symlink')
-        self.tree_1 = self.branch.revision_tree('1')
-        self.inv_1 = self.branch.get_inventory('1')
+        self.tree_1 = self.branch.repository.revision_tree('1')
+        self.inv_1 = self.branch.repository.get_inventory('1')
         self.file_1 = self.inv_1['fileid']
-        self.tree_2 = self.branch.working_tree()
+        self.tree_2 = self.wt
         self.inv_2 = self.tree_2.read_working_inventory()
         self.file_2 = self.inv_2['fileid']
         if has_symlinks():
@@ -230,7 +229,7 @@
                          "=== target changed 'target1' => 'target2'\n")
 
 
-class TestSnapshot(TestCaseInTempDir):
+class TestSnapshot(TestCaseWithTransport):
 
     def setUp(self):
         # for full testing we'll need a branch
@@ -240,32 +239,31 @@
         # to change, and then test merge patterns
         # with fake parent entries.
         super(TestSnapshot, self).setUp()
-        self.branch = Branch.initialize(u'.')
+        self.wt = self.make_branch_and_tree('.')
+        self.branch = self.wt.branch
         self.build_tree(['subdir/', 'subdir/file'], line_endings='binary')
-        self.branch.working_tree().add(['subdir', 'subdir/file'],
+        self.wt.add(['subdir', 'subdir/file'],
                                        ['dirid', 'fileid'])
         if has_symlinks():
             pass
-        self.wt = self.branch.working_tree()
         self.wt.commit('message_1', rev_id = '1')
-        self.tree_1 = self.branch.revision_tree('1')
-        self.inv_1 = self.branch.get_inventory('1')
+        self.tree_1 = self.branch.repository.revision_tree('1')
+        self.inv_1 = self.branch.repository.get_inventory('1')
         self.file_1 = self.inv_1['fileid']
-        self.work_tree = self.branch.working_tree()
-        self.file_active = self.work_tree.inventory['fileid']
+        self.file_active = self.wt.inventory['fileid']
 
     def test_snapshot_new_revision(self):
         # This tests that a simple commit with no parents makes a new
         # revision value in the inventory entry
-        self.file_active.snapshot('2', 'subdir/file', {}, self.work_tree, 
-                                  self.branch.weave_store,
+        self.file_active.snapshot('2', 'subdir/file', {}, self.wt, 
+                                  self.branch.repository.weave_store,
                                   self.branch.get_transaction())
         # expected outcome - file_1 has a revision id of '2', and we can get
         # its text of 'file contents' out of the weave.
         self.assertEqual(self.file_1.revision, '1')
         self.assertEqual(self.file_active.revision, '2')
         # this should be a separate test probably, but lets check it once..
-        lines = self.branch.weave_store.get_lines('fileid','2',
+        lines = self.branch.repository.weave_store.get_lines('fileid','2',
             self.branch.get_transaction())
         self.assertEqual(lines, ['contents of subdir/file\n'])
 
@@ -273,13 +271,14 @@
         #This tests that a simple commit does not make a new entry for
         # an unchanged inventory entry
         self.file_active.snapshot('2', 'subdir/file', {'1':self.file_1},
-                                  self.work_tree, self.branch.weave_store,
+                                  self.wt, 
+                                  self.branch.repository.weave_store,
                                   self.branch.get_transaction())
         self.assertEqual(self.file_1.revision, '1')
         self.assertEqual(self.file_active.revision, '1')
         self.assertRaises(errors.WeaveError,
-                          self.branch.weave_store.get_lines, 'fileid', '2',
-                          self.branch.get_transaction())
+                          self.branch.repository.weave_store.get_lines, 
+                          'fileid', '2', self.branch.get_transaction())
 
     def test_snapshot_merge_identical_different_revid(self):
         # This tests that a commit with two identical parents, one of which has
@@ -293,11 +292,12 @@
         self.assertEqual(self.file_1, other_ie)
         other_ie.revision = 'other'
         self.assertNotEqual(self.file_1, other_ie)
-        self.branch.weave_store.add_identical_text('fileid', '1', 'other', ['1'],
-            self.branch.get_transaction())
+        self.branch.repository.weave_store.add_identical_text('fileid', '1', 
+            'other', ['1'], self.branch.get_transaction())
         self.file_active.snapshot('2', 'subdir/file', 
                                   {'1':self.file_1, 'other':other_ie},
-                                  self.work_tree, self.branch.weave_store,
+                                  self.wt, 
+                                  self.branch.repository.weave_store,
                                   self.branch.get_transaction())
         self.assertEqual(self.file_active.revision, '2')
 
@@ -307,14 +307,14 @@
         self.file_active.name='newname'
         rename('subdir/file', 'subdir/newname')
         self.file_active.snapshot('2', 'subdir/newname', {'1':self.file_1}, 
-                                  self.work_tree, 
-                                  self.branch.weave_store,
+                                  self.wt,
+                                  self.branch.repository.weave_store,
                                   self.branch.get_transaction())
         # expected outcome - file_1 has a revision id of '2'
         self.assertEqual(self.file_active.revision, '2')
 
 
-class TestPreviousHeads(TestCaseInTempDir):
+class TestPreviousHeads(TestCaseWithTransport):
 
     def setUp(self):
         # we want several inventories, that respectively
@@ -326,23 +326,27 @@
         # D) fileid present in two inventories and one is
         #   a descendent of the other. (B, D)
         super(TestPreviousHeads, self).setUp()
+        self.wt = self.make_branch_and_tree('.')
+        self.branch = self.wt.branch
         self.build_tree(['file'])
-        self.branch = Branch.initialize(u'.')
-        self.wt = self.branch.working_tree()
         self.wt.commit('new branch', allow_pointless=True, rev_id='A')
-        self.inv_A = self.branch.get_inventory('A')
-        self.branch.working_tree().add(['file'], ['fileid'])
+        self.inv_A = self.branch.repository.get_inventory('A')
+        self.wt.add(['file'], ['fileid'])
         self.wt.commit('add file', rev_id='B')
-        self.inv_B = self.branch.get_inventory('B')
-        self.branch.put_controlfile('revision-history', 'A\n')
+        self.inv_B = self.branch.repository.get_inventory('B')
+        self.branch.lock_write()
+        try:
+            self.branch.control_files.put_utf8('revision-history', 'A\n')
+        finally:
+            self.branch.unlock()
         self.assertEqual(self.branch.revision_history(), ['A'])
         self.wt.commit('another add of file', rev_id='C')
-        self.inv_C = self.branch.get_inventory('C')
+        self.inv_C = self.branch.repository.get_inventory('C')
         self.wt.add_pending_merge('B')
         self.wt.commit('merge in B', rev_id='D')
-        self.inv_D = self.branch.get_inventory('D')
+        self.inv_D = self.branch.repository.get_inventory('D')
         self.file_active = self.wt.inventory['fileid']
-        self.weave = self.branch.weave_store.get_weave('fileid',
+        self.weave = self.branch.repository.weave_store.get_weave('fileid',
             self.branch.get_transaction())
         
     def get_previous_heads(self, inventories):
@@ -376,7 +380,7 @@
     # TODO: test two inventories with the same file revision 
 
 
-class TestExecutable(TestCaseInTempDir):
+class TestExecutable(TestCaseWithTransport):
 
     def test_stays_executable(self):
         basic_inv = """<inventory format="5">
@@ -384,8 +388,8 @@
 <file file_id="b-20051208024829-849e76f7968d7a86" name="b" />
 </inventory>
 """
-        os.mkdir('b1')
-        b = Branch.initialize('b1')
+        wt = self.make_branch_and_tree('b1')
+        b = wt.branch
         open('b1/a', 'wb').write('a test\n')
         open('b1/b', 'wb').write('b test\n')
         os.chmod('b1/a', 0755)
@@ -396,15 +400,15 @@
 
         a_id = "a-20051208024829-849e76f7968d7a86"
         b_id = "b-20051208024829-849e76f7968d7a86"
-        t = b.working_tree()
-        self.assertEqual(['a', 'b'], [cn for cn,ie in t.inventory.iter_entries()])
-
-        self.failUnless(t.is_executable(a_id), "'a' lost the execute bit")
-        self.failIf(t.is_executable(b_id), "'b' gained an execute bit")
-
-        t.commit('adding a,b', rev_id='r1')
-
-        rev_tree = b.revision_tree('r1')
+        wt = wt.bzrdir.open_workingtree()
+        self.assertEqual(['a', 'b'], [cn for cn,ie in wt.inventory.iter_entries()])
+
+        self.failUnless(wt.is_executable(a_id), "'a' lost the execute bit")
+        self.failIf(wt.is_executable(b_id), "'b' gained an execute bit")
+
+        wt.commit('adding a,b', rev_id='r1')
+
+        rev_tree = b.repository.revision_tree('r1')
         self.failUnless(rev_tree.is_executable(a_id), "'a' lost the execute bit")
         self.failIf(rev_tree.is_executable(b_id), "'b' gained an execute bit")
 
@@ -414,55 +418,46 @@
         # Make sure the entries are gone
         os.remove('b1/a')
         os.remove('b1/b')
-        self.failIf(t.has_id(a_id))
-        self.failIf(t.has_filename('a'))
-        self.failIf(t.has_id(b_id))
-        self.failIf(t.has_filename('b'))
+        self.failIf(wt.has_id(a_id))
+        self.failIf(wt.has_filename('a'))
+        self.failIf(wt.has_id(b_id))
+        self.failIf(wt.has_filename('b'))
 
         # Make sure that revert is able to bring them back,
         # and sets 'a' back to being executable
 
-        t.revert(['b1/a', 'b1/b'], rev_tree, backups=False)
-        self.assertEqual(['a', 'b'], [cn for cn,ie in t.inventory.iter_entries()])
+        wt.revert(['a', 'b'], rev_tree, backups=False)
+        self.assertEqual(['a', 'b'], [cn for cn,ie in wt.inventory.iter_entries()])
 
-        self.failUnless(t.is_executable(a_id), "'a' lost the execute bit")
-        self.failIf(t.is_executable(b_id), "'b' gained an execute bit")
+        self.failUnless(wt.is_executable(a_id), "'a' lost the execute bit")
+        self.failIf(wt.is_executable(b_id), "'b' gained an execute bit")
 
         # Now remove them again, and make sure that after a
         # commit, they are still marked correctly
         os.remove('b1/a')
         os.remove('b1/b')
-        t.commit('removed', rev_id='r2')
+        wt.commit('removed', rev_id='r2')
 
-        self.assertEqual([], [cn for cn,ie in t.inventory.iter_entries()])
-        self.failIf(t.has_id(a_id))
-        self.failIf(t.has_filename('a'))
-        self.failIf(t.has_id(b_id))
-        self.failIf(t.has_filename('b'))
+        self.assertEqual([], [cn for cn,ie in wt.inventory.iter_entries()])
+        self.failIf(wt.has_id(a_id))
+        self.failIf(wt.has_filename('a'))
+        self.failIf(wt.has_id(b_id))
+        self.failIf(wt.has_filename('b'))
 
         # Now revert back to the previous commit
-        t.revert([], rev_tree, backups=False)
-        # TODO: FIXME: For some reason, after revert, the tree does not 
-        # regenerate its working inventory, so we have to manually delete
-        # the working tree, and create a new one
-        # This seems to happen any time you do a merge operation on the
-        # working tree
-        del t
-        t = b.working_tree()
-
-        self.assertEqual(['a', 'b'], [cn for cn,ie in t.inventory.iter_entries()])
-
-        self.failUnless(t.is_executable(a_id), "'a' lost the execute bit")
-        self.failIf(t.is_executable(b_id), "'b' gained an execute bit")
+        wt.revert([], rev_tree, backups=False)
+        self.assertEqual(['a', 'b'], [cn for cn,ie in wt.inventory.iter_entries()])
+
+        self.failUnless(wt.is_executable(a_id), "'a' lost the execute bit")
+        self.failIf(wt.is_executable(b_id), "'b' gained an execute bit")
 
         # Now make sure that 'bzr branch' also preserves the
         # executable bit
         # TODO: Maybe this should be a blackbox test
-        from bzrlib.clone import copy_branch
-        copy_branch(b, 'b2', revision='r1')
-        b2 = Branch.open('b2')
+        d2 = b.bzrdir.clone('b2', revision_id='r1')
+        t2 = d2.open_workingtree()
+        b2 = t2.branch
         self.assertEquals('r1', b2.last_revision())
-        t2 = b2.working_tree()
 
         self.assertEqual(['a', 'b'], [cn for cn,ie in t2.inventory.iter_entries()])
         self.failUnless(t2.is_executable(a_id), "'a' lost the execute bit")
@@ -471,22 +466,27 @@
         # Make sure pull will delete the files
         t2.pull(b)
         self.assertEquals('r2', b2.last_revision())
-        # FIXME: Same thing here, t2 needs to be recreated
-        del t2
-        t2 = b2.working_tree()
         self.assertEqual([], [cn for cn,ie in t2.inventory.iter_entries()])
 
         # Now commit the changes on the first branch
         # so that the second branch can pull the changes
         # and make sure that the executable bit has been copied
-        t.commit('resurrected', rev_id='r3')
+        wt.commit('resurrected', rev_id='r3')
 
         t2.pull(b)
-        # FIXME: And here
-        del t2
-        t2 = b2.working_tree()
         self.assertEquals('r3', b2.last_revision())
         self.assertEqual(['a', 'b'], [cn for cn,ie in t2.inventory.iter_entries()])
 
         self.failUnless(t2.is_executable(a_id), "'a' lost the execute bit")
         self.failIf(t2.is_executable(b_id), "'b' gained an execute bit")
+
+class TestRevert(TestCaseWithTransport):
+    def test_dangling_id(self):
+        wt = self.make_branch_and_tree('b1')
+        self.assertEqual(len(wt.inventory), 1)
+        open('b1/a', 'wb').write('a test\n')
+        wt.add('a')
+        self.assertEqual(len(wt.inventory), 2)
+        os.unlink('b1/a')
+        wt.revert([])
+        self.assertEqual(len(wt.inventory), 1)

=== added file 'bzrlib/tests/test_lockable_files.py'
--- bzrlib/tests/test_lockable_files.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_lockable_files.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,135 @@
+# Copyright (C) 2005, 2006 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from StringIO import StringIO
+
+from bzrlib.branch import Branch
+from bzrlib.errors import BzrBadParameterNotString, NoSuchFile, ReadOnlyError
+from bzrlib.lockable_files import LockableFiles, TransportLock
+from bzrlib.lockdir import LockDir
+from bzrlib.tests import TestCaseInTempDir
+from bzrlib.transactions import PassThroughTransaction, ReadOnlyTransaction
+from bzrlib.transport import get_transport
+
+
+# these tests are applied in each parameterized suite for LockableFiles
+class _TestLockableFiles_mixin(object):
+
+    def test_read_write(self):
+        self.assertRaises(NoSuchFile, self.lockable.get, 'foo')
+        self.assertRaises(NoSuchFile, self.lockable.get_utf8, 'foo')
+        self.lockable.lock_write()
+        try:
+            unicode_string = u'bar\u1234'
+            self.assertEqual(4, len(unicode_string))
+            byte_string = unicode_string.encode('utf-8')
+            self.assertEqual(6, len(byte_string))
+            self.assertRaises(UnicodeEncodeError, self.lockable.put, 'foo', 
+                              StringIO(unicode_string))
+            self.lockable.put('foo', StringIO(byte_string))
+            self.assertEqual(byte_string,
+                             self.lockable.get('foo').read())
+            self.assertEqual(unicode_string,
+                             self.lockable.get_utf8('foo').read())
+            self.assertRaises(BzrBadParameterNotString,
+                              self.lockable.put_utf8,
+                              'bar',
+                              StringIO(unicode_string)
+                              )
+            self.lockable.put_utf8('bar', unicode_string)
+            self.assertEqual(unicode_string, 
+                             self.lockable.get_utf8('bar').read())
+            self.assertEqual(byte_string, 
+                             self.lockable.get('bar').read())
+        finally:
+            self.lockable.unlock()
+
+    def test_locks(self):
+        self.lockable.lock_read()
+        try:
+            self.assertRaises(ReadOnlyError, self.lockable.put, 'foo', 
+                              StringIO('bar\u1234'))
+        finally:
+            self.lockable.unlock()
+
+    def test_transactions(self):
+        self.assertIs(self.lockable.get_transaction().__class__,
+                      PassThroughTransaction)
+        self.lockable.lock_read()
+        try:
+            self.assertIs(self.lockable.get_transaction().__class__,
+                          ReadOnlyTransaction)
+        finally:
+            self.lockable.unlock()
+        self.assertIs(self.lockable.get_transaction().__class__,
+                      PassThroughTransaction)
+        self.lockable.lock_write()
+        self.assertIs(self.lockable.get_transaction().__class__,
+                      PassThroughTransaction)
+        self.lockable.unlock()
+
+    def test__escape(self):
+        self.assertEqual('%25', self.lockable._escape('%'))
+        
+    def test__escape_empty(self):
+        self.assertEqual('', self.lockable._escape(''))
+
+
+# This method of adapting tests to parameters is different to 
+# the TestProviderAdapters used elsewhere, but seems simpler for this 
+# case.  
+class TestLockableFiles_TransportLock(TestCaseInTempDir,
+                                      _TestLockableFiles_mixin):
+
+    def setUp(self):
+        super(TestLockableFiles_TransportLock, self).setUp()
+        transport = get_transport('.')
+        transport.mkdir('.bzr')
+        sub_transport = transport.clone('.bzr')
+        self.lockable = LockableFiles(sub_transport, 'my-lock', TransportLock)
+        self.lockable.create_lock()
+        
+
+class TestLockableFiles_LockDir(TestCaseInTempDir,
+                              _TestLockableFiles_mixin):
+    """LockableFile tests run with LockDir underneath"""
+
+    def setUp(self):
+        super(TestLockableFiles_LockDir, self).setUp()
+        self.transport = get_transport('.')
+        self.lockable = LockableFiles(self.transport, 'my-lock', LockDir)
+        self.lockable.create_lock()
+
+    def test_lock_is_lockdir(self):
+        """Created instance should use a LockDir.
+        
+        This primarily tests the mixin adapter works properly.
+        """
+        ## self.assertIsInstance(self.lockable, LockableFiles)
+        ## self.assertIsInstance(self.lockable._lock_strategy,
+                              ## LockDirStrategy)
+
+    def test_lock_created(self):
+        self.assertTrue(self.transport.has('my-lock'))
+        self.lockable.lock_write()
+        self.assertTrue(self.transport.has('my-lock/held/info'))
+        self.lockable.unlock()
+        self.assertFalse(self.transport.has('my-lock/held/info'))
+        self.assertTrue(self.transport.has('my-lock'))
+
+
+    # TODO: Test the lockdir inherits the right file and directory permissions
+    # from the LockableFiles.

=== added file 'bzrlib/tests/test_lockdir.py'
--- bzrlib/tests/test_lockdir.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_lockdir.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,319 @@
+# Copyright (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for LockDir"""
+
+from threading import Thread
+import time
+
+from bzrlib.errors import (
+        LockBreakMismatch,
+        LockContention, LockError, UnlockableTransport,
+        LockNotHeld, LockBroken
+        )
+from bzrlib.lockdir import LockDir
+from bzrlib.tests import TestCaseWithTransport
+
+# These tests sometimes use threads to test the behaviour of lock files with
+# concurrent actors.  This is not a typical (or necessarily supported) use;
+# they're really meant for guarding between processes.
+
+# These tests are run on the default transport provided by the test framework
+# (typically a local disk transport).  That can be changed by the --transport
+# option to bzr selftest.  The required properties of the transport
+# implementation are tested separately.  (The main requirement is just that
+# they don't allow overwriting nonempty directories.)
+
+class TestLockDir(TestCaseWithTransport):
+    """Test LockDir operations"""
+
+    def test_00_lock_creation(self):
+        """Creation of lock file on a transport"""
+        t = self.get_transport()
+        lf = LockDir(t, 'test_lock')
+        self.assertFalse(lf.is_held)
+
+    def test_01_lock_repr(self):
+        """Lock string representation"""
+        lf = LockDir(self.get_transport(), 'test_lock')
+        r = repr(lf)
+        self.assertContainsRe(r, r'^LockDir\(.*/test_lock\)$')
+
+    def test_02_unlocked_peek(self):
+        lf = LockDir(self.get_transport(), 'test_lock')
+        self.assertEqual(lf.peek(), None)
+
+    def test_03_readonly_peek(self):
+        lf = LockDir(self.get_readonly_transport(), 'test_lock')
+        self.assertEqual(lf.peek(), None)
+
+    def test_10_lock_uncontested(self):
+        """Acquire and release a lock"""
+        t = self.get_transport()
+        lf = LockDir(t, 'test_lock')
+        lf.create()
+        lf.attempt_lock()
+        try:
+            self.assertTrue(lf.is_held)
+        finally:
+            lf.unlock()
+            self.assertFalse(lf.is_held)
+
+    def test_11_create_readonly_transport(self):
+        """Fail to create lock on readonly transport"""
+        t = self.get_readonly_transport()
+        lf = LockDir(t, 'test_lock')
+        self.assertRaises(UnlockableTransport, lf.create)
+
+    def test_12_lock_readonly_transport(self):
+        """Fail to lock on readonly transport"""
+        lf = LockDir(self.get_transport(), 'test_lock')
+        lf.create()
+        lf = LockDir(self.get_readonly_transport(), 'test_lock')
+        self.assertRaises(UnlockableTransport, lf.attempt_lock)
+
+    def test_20_lock_contested(self):
+        """Contention to get a lock"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+        lf2 = LockDir(t, 'test_lock')
+        try:
+            # locking is between LockDir instances; aliases within 
+            # a single process are not detected
+            lf2.attempt_lock()
+            self.fail('Failed to detect lock collision')
+        except LockContention, e:
+            self.assertEqual(e.lock, lf2)
+            self.assertContainsRe(str(e),
+                    r'^Could not acquire.*test_lock.*$')
+        lf1.unlock()
+
+    def test_20_lock_peek(self):
+        """Peek at the state of a lock"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+        # lock is held, should get some info on it
+        info1 = lf1.peek()
+        self.assertEqual(set(info1.keys()),
+                         set(['user', 'nonce', 'hostname', 'pid', 'start_time']))
+        # should get the same info if we look at it through a different
+        # instance
+        info2 = LockDir(t, 'test_lock').peek()
+        self.assertEqual(info1, info2)
+        # locks which are never used should be not-held
+        self.assertEqual(LockDir(t, 'other_lock').peek(), None)
+
+    def test_21_peek_readonly(self):
+        """Peek over a readonly transport"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf2 = LockDir(self.get_readonly_transport(), 'test_lock')
+        self.assertEqual(lf2.peek(), None)
+        lf1.attempt_lock()
+        info2 = lf2.peek()
+        self.assertTrue(info2)
+        self.assertEqual(info2['nonce'], lf1.nonce)
+
+    def test_30_lock_wait_fail(self):
+        """Wait on a lock, then fail
+        
+        We ask to wait up to 400ms; this should fail within at most one
+        second.  (Longer times are more realistic but we don't want the test
+        suite to take too long, and this should do for now.)
+        """
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf2 = LockDir(t, 'test_lock')
+        lf1.attempt_lock()
+        try:
+            before = time.time()
+            self.assertRaises(LockContention, lf2.wait_lock,
+                              timeout=0.4, poll=0.1)
+            after = time.time()
+            self.assertTrue(after - before <= 1.0)
+        finally:
+            lf1.unlock()
+
+    def test_31_lock_wait_easy(self):
+        """Succeed when waiting on a lock with no contention.
+        """
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        try:
+            before = time.time()
+            lf1.wait_lock(timeout=0.4, poll=0.1)
+            after = time.time()
+            self.assertTrue(after - before <= 1.0)
+        finally:
+            lf1.unlock()
+
+    def test_32_lock_wait_succeed(self):
+        """Succeed when trying to acquire a lock that gets released
+
+        One thread holds on a lock and then releases it; another tries to lock it.
+        """
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+
+        def wait_and_unlock():
+            time.sleep(0.1)
+            lf1.unlock()
+        unlocker = Thread(target=wait_and_unlock)
+        unlocker.start()
+        try:
+            lf2 = LockDir(t, 'test_lock')
+            before = time.time()
+            # wait and then lock
+            lf2.wait_lock(timeout=0.4, poll=0.1)
+            after = time.time()
+            self.assertTrue(after - before <= 1.0)
+        finally:
+            unlocker.join()
+
+    def test_33_wait(self):
+        """Succeed when waiting on a lock that gets released
+
+        The difference from test_32_lock_wait_succeed is that the second 
+        caller does not actually acquire the lock, but just waits for it
+        to be released.  This is done over a readonly transport.
+        """
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+
+        def wait_and_unlock():
+            time.sleep(0.1)
+            lf1.unlock()
+        unlocker = Thread(target=wait_and_unlock)
+        unlocker.start()
+        try:
+            lf2 = LockDir(self.get_readonly_transport(), 'test_lock')
+            before = time.time()
+            # wait but don't lock
+            lf2.wait(timeout=0.4, poll=0.1)
+            after = time.time()
+            self.assertTrue(after - before <= 1.0)
+        finally:
+            unlocker.join()
+
+    def test_40_confirm_easy(self):
+        """Confirm a lock that's already held"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+        lf1.confirm()
+
+    def test_41_confirm_not_held(self):
+        """Confirm a lock that's already held"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        self.assertRaises(LockNotHeld, lf1.confirm)
+
+    def test_42_confirm_broken_manually(self):
+        """Confirm a lock broken by hand"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+        t.move('test_lock', 'lock_gone_now')
+        self.assertRaises(LockBroken, lf1.confirm)
+
+    def test_43_break(self):
+        """Break a lock whose caller has forgotten it"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+        # we incorrectly discard the lock object without unlocking it
+        del lf1
+        # someone else sees it's still locked
+        lf2 = LockDir(t, 'test_lock')
+        holder_info = lf2.peek()
+        self.assertTrue(holder_info)
+        lf2.force_break(holder_info)
+        # now we should be able to take it
+        lf2.attempt_lock()
+        lf2.confirm()
+
+    def test_44_break_already_released(self):
+        """Lock break races with regular release"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+        # someone else sees it's still locked
+        lf2 = LockDir(t, 'test_lock')
+        holder_info = lf2.peek()
+        # in the interim the lock is released
+        lf1.unlock()
+        # break should succeed
+        lf2.force_break(holder_info)
+        # now we should be able to take it
+        lf2.attempt_lock()
+        lf2.confirm()
+
+    def test_45_break_mismatch(self):
+        """Lock break races with someone else acquiring it"""
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.attempt_lock()
+        # someone else sees it's still locked
+        lf2 = LockDir(t, 'test_lock')
+        holder_info = lf2.peek()
+        # in the interim the lock is released
+        lf1.unlock()
+        lf3 = LockDir(t, 'test_lock')
+        lf3.attempt_lock()
+        # break should now *fail*
+        self.assertRaises(LockBreakMismatch, lf2.force_break,
+                          holder_info)
+        lf3.unlock()
+
+    def test_46_fake_read_lock(self):
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        lf1.lock_read()
+        lf1.unlock()
+
+    def test_50_lockdir_representation(self):
+        """Check the on-disk representation of LockDirs is as expected.
+
+        There should always be a top-level directory named by the lock.
+        When the lock is held, there should be a lockname/held directory 
+        containing an info file.
+        """
+        t = self.get_transport()
+        lf1 = LockDir(t, 'test_lock')
+        lf1.create()
+        self.assertTrue(t.has('test_lock'))
+        lf1.lock_write()
+        self.assertTrue(t.has('test_lock/held/info'))
+        lf1.unlock()
+        self.assertFalse(t.has('test_lock/held/info'))

=== modified file 'bzrlib/tests/test_log.py'
--- bzrlib/tests/test_log.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_log.py	2006-03-20 08:31:00 +0000
@@ -17,7 +17,7 @@
 import os
 from cStringIO import StringIO
 
-from bzrlib.tests import BzrTestBase, TestCaseInTempDir
+from bzrlib.tests import BzrTestBase, TestCaseWithTransport
 from bzrlib.log import LogFormatter, show_log, LongLogFormatter, ShortLogFormatter
 from bzrlib.branch import Branch
 from bzrlib.errors import InvalidRevisionNumber
@@ -49,7 +49,7 @@
         self.logs.append(le)
 
 
-class SimpleLogTest(TestCaseInTempDir):
+class SimpleLogTest(TestCaseWithTransport):
 
     def checkDelta(self, delta, **kw):
         """Check the filenames touched by a delta are as expected."""
@@ -65,10 +65,11 @@
             self.assertEquals(expected, got)
 
     def test_cur_revno(self):
-        b = Branch(u'.', init=True)
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
 
         lf = LogCatcher()
-        b.working_tree().commit('empty commit')
+        wt.commit('empty commit')
         show_log(b, lf, verbose=True, start_revision=1, end_revision=1)
         self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
                           start_revision=2, end_revision=1) 
@@ -84,10 +85,11 @@
                           start_revision=1, end_revision=-1) 
 
     def test_cur_revno(self):
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
 
         lf = LogCatcher()
-        b.working_tree().commit('empty commit')
+        wt.commit('empty commit')
         show_log(b, lf, verbose=True, start_revision=1, end_revision=1)
         self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
                           start_revision=2, end_revision=1) 
@@ -105,14 +107,15 @@
     def test_simple_log(self):
         eq = self.assertEquals
         
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
 
         lf = LogCatcher()
         show_log(b, lf)
         # no entries yet
         eq(lf.logs, [])
 
-        b.working_tree().commit('empty commit')
+        wt.commit('empty commit')
         lf = LogCatcher()
         show_log(b, lf, verbose=True)
         eq(len(lf.logs), 1)
@@ -123,8 +126,8 @@
         self.checkDelta(d)
 
         self.build_tree(['hello'])
-        b.working_tree().add('hello')
-        b.working_tree().commit('add one file')
+        wt.add('hello')
+        wt.commit('add one file')
 
         lf = StringIO()
         # log using regular thing
@@ -152,7 +155,7 @@
         # commit a log message with control characters
         msg = "All 8-bit chars: " +  ''.join([unichr(x) for x in range(256)])
         self.log("original commit message: %r", msg)
-        b.working_tree().commit(msg)
+        wt.commit(msg)
         lf = LogCatcher()
         show_log(b, lf, verbose=True)
         committed_msg = lf.logs[0].rev.message
@@ -167,7 +170,7 @@
         # valid XML 1.0 characters.
         msg = "\x09" + ''.join([unichr(x) for x in range(0x20, 256)])
         self.log("original commit message: %r", msg)
-        b.working_tree().commit(msg)
+        wt.commit(msg)
         lf = LogCatcher()
         show_log(b, lf, verbose=True)
         committed_msg = lf.logs[0].rev.message
@@ -175,9 +178,9 @@
         self.assert_(msg == committed_msg)
 
     def test_trailing_newlines(self):
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         b.nick='test'
-        wt = b.working_tree()
         open('a', 'wb').write('hello moto\n')
         wt.add('a')
         wt.commit('simple log message', rev_id='a1'
@@ -246,9 +249,9 @@
         
         bug #4676
         """
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         self.build_tree(['a'])
-        wt = b.working_tree()
         wt.add('a')
         # XXX: why does a longer nick show up?
         b.nick = 'test_verbose_log'

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_merge.py	2006-03-20 08:31:00 +0000
@@ -1,74 +1,74 @@
 import os
 
 from bzrlib.branch import Branch
+from bzrlib.builtins import merge
 from bzrlib.commit import commit
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib.merge import merge, transform_tree
 from bzrlib.errors import UnrelatedBranches, NoCommits, BzrCommandError
+from bzrlib.merge import transform_tree
+from bzrlib.osutils import pathjoin
 from bzrlib.revision import common_ancestor
-from bzrlib.fetch import fetch
-from bzrlib.osutils import pathjoin
-
-
-class TestMerge(TestCaseInTempDir):
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.workingtree import WorkingTree
+
+
+class TestMerge(TestCaseWithTransport):
     """Test appending more than one revision"""
+
     def test_pending(self):
-        br = Branch.initialize(u".")
-        commit(br, "lala!")
-        self.assertEquals(len(br.working_tree().pending_merges()), 0)
+        wt = self.make_branch_and_tree('.')
+        wt.commit("lala!")
+        self.assertEquals(len(wt.pending_merges()), 0)
         merge([u'.', -1], [None, None])
-        self.assertEquals(len(br.working_tree().pending_merges()), 0)
+        self.assertEquals(len(wt.pending_merges()), 0)
 
     def test_nocommits(self):
         self.test_pending()
-        os.mkdir('branch2')
-        br2 = Branch.initialize('branch2')
+        wt2 = self.make_branch_and_tree('branch2')
         self.assertRaises(NoCommits, merge, ['branch2', -1], 
                           [None, None])
-        return br2
+        return wt2
 
     def test_unrelated(self):
-        br2 = self.test_nocommits()
-        commit(br2, "blah")
+        wt2 = self.test_nocommits()
+        wt2.commit("blah")
         self.assertRaises(UnrelatedBranches, merge, ['branch2', -1], 
                           [None, None])
-        return br2
+        return wt2
 
     def test_pending_with_null(self):
         """When base is forced to revno 0, pending_merges is set"""
-        br2 = self.test_unrelated()
-        br1 = Branch.open(u'.')
-        fetch(from_branch=br2, to_branch=br1)
+        wt2 = self.test_unrelated()
+        wt1 = WorkingTree.open('.')
+        br1 = wt1.branch
+        br1.fetch(wt2.branch)
         # merge all of branch 2 into branch 1 even though they 
         # are not related.
         self.assertRaises(BzrCommandError, merge, ['branch2', -1], 
                           ['branch2', 0], reprocess=True, show_base=True)
         merge(['branch2', -1], ['branch2', 0], reprocess=True)
-        self.assertEquals(len(br1.working_tree().pending_merges()), 1)
-        return (br1, br2)
+        self.assertEquals(len(wt1.pending_merges()), 1)
+        return (wt1, wt2.branch)
 
     def test_two_roots(self):
         """Merge base is sane when two unrelated branches are merged"""
-        br1, br2 = self.test_pending_with_null()
-        commit(br1, "blah")
-        last = br1.last_revision()
-        self.assertEquals(common_ancestor(last, last, br1), last)
+        wt1, br2 = self.test_pending_with_null()
+        wt1.commit("blah")
+        last = wt1.branch.last_revision()
+        self.assertEquals(common_ancestor(last, last, wt1.branch.repository), last)
 
     def test_create_rename(self):
         """Rename an inventory entry while creating the file"""
-        b = Branch.initialize(u'.')
+        tree =self.make_branch_and_tree('.')
         file('name1', 'wb').write('Hello')
-        tree = b.working_tree()
         tree.add('name1')
         tree.commit(message="hello")
         tree.rename_one('name1', 'name2')
         os.unlink('name2')
-        transform_tree(tree, b.basis_tree())
+        transform_tree(tree, tree.branch.basis_tree())
 
     def test_layered_rename(self):
         """Rename both child and parent at same time"""
-        b = Branch.initialize(u'.')
-        tree = b.working_tree()
+        tree =self.make_branch_and_tree('.')
         os.mkdir('dirname1')
         tree.add('dirname1')
         filename = pathjoin('dirname1', 'name1')
@@ -78,4 +78,4 @@
         filename2 = pathjoin('dirname1', 'name2')
         tree.rename_one(filename, filename2)
         tree.rename_one('dirname1', 'dirname2')
-        transform_tree(tree, b.basis_tree())
+        transform_tree(tree, tree.branch.basis_tree())

=== modified file 'bzrlib/tests/test_merge_core.py'
--- bzrlib/tests/test_merge_core.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_merge_core.py	2006-03-20 08:31:00 +0000
@@ -3,152 +3,32 @@
 import stat
 import sys
 
-from bzrlib.tests import TestCaseInTempDir, TestCase
-from bzrlib.branch import ScratchBranch, Branch
+import bzrlib
+from bzrlib.add import smart_add_tree
+from bzrlib.builtins import merge
 from bzrlib.errors import (NotBranchError, NotVersionedError,
-                           WorkingTreeNotRevision, BzrCommandError)
+                           WorkingTreeNotRevision, BzrCommandError, NoDiff3)
 from bzrlib.inventory import RootEntry
 import bzrlib.inventory as inventory
+from bzrlib.merge import Merge3Merger, Diff3Merger, WeaveMerger
 from bzrlib.osutils import file_kind, rename, sha_file, pathjoin, mkdtemp
-from bzrlib import changeset
-from bzrlib.merge_core import (ApplyMerge3, make_merge_changeset,
-                               BackupBeforeChange, ExecFlagMerge, WeaveMerge)
-from bzrlib.changeset import Inventory, apply_changeset, invert_dict, \
-    get_contents, ReplaceContents, ChangeExecFlag
-from bzrlib.clone import copy_branch
-from bzrlib.merge import merge
+from bzrlib.transform import TreeTransform
+from bzrlib.tests import TestCaseWithTransport, TestCase, TestSkipped
 from bzrlib.workingtree import WorkingTree
 
 
-class FalseTree(object):
-    def __init__(self, realtree):
-        self._realtree = realtree
-        self.inventory = self
-
-    def __getitem__(self, file_id):
-        entry = self.make_inventory_entry(file_id)
-        if entry is None:
-            raise KeyError(file_id)
-        return entry
-        
-    def make_inventory_entry(self, file_id):
-        path = self._realtree.inventory_dict.get(file_id)
-        if path is None:
-            return None
-        if path == "":
-            return RootEntry(file_id)
-        dir, name = os.path.split(path)
-        kind = file_kind(self._realtree.abs_path(path))
-        for parent_id, path in self._realtree.inventory_dict.iteritems():
-            if path == dir:
-                break
-        if path != dir:
-            raise Exception("Can't find parent for %s" % name)
-        if kind not in ('directory', 'file', 'symlink'):
-            raise ValueError('unknown kind %r' % kind)
-        if kind == 'directory':
-            return inventory.InventoryDirectory(file_id, name, parent_id)
-        elif kind == 'file':
-            return inventory.InventoryFile(file_id, name, parent_id)
-        else:
-            return inventory.InventoryLink(file_id, name, parent_id)
-
-
-class MergeTree(object):
-    def __init__(self, dir):
-        self.dir = dir;
-        os.mkdir(dir)
-        self.inventory_dict = {'0': ""}
-        self.inventory = FalseTree(self)
-    
-    def child_path(self, parent, name):
-        return pathjoin(self.inventory_dict[parent], name)
-
-    def add_file(self, id, parent, name, contents, mode):
-        path = self.child_path(parent, name)
-        full_path = self.abs_path(path)
-        assert not os.path.exists(full_path)
-        file(full_path, "wb").write(contents)
-        os.chmod(self.abs_path(path), mode)
-        self.inventory_dict[id] = path
-
-    def add_symlink(self, id, parent, name, target):
-        path = self.child_path(parent, name)
-        full_path = self.abs_path(path)
-        assert not os.path.exists(full_path)
-        os.symlink(target, full_path)
-        self.inventory_dict[id] = path
-
-    def remove_file(self, id):
-        os.unlink(self.full_path(id))
-        del self.inventory_dict[id]
-
-    def add_dir(self, id, parent, name, mode):
-        path = self.child_path(parent, name)
-        full_path = self.abs_path(path)
-        assert not os.path.exists(full_path)
-        os.mkdir(self.abs_path(path))
-        os.chmod(self.abs_path(path), mode)
-        self.inventory_dict[id] = path
-
-    def abs_path(self, path):
-        return pathjoin(self.dir, path)
-
-    def full_path(self, id):
-        try:
-            tree_path = self.inventory_dict[id]
-        except KeyError:
-            return None
-        return self.abs_path(tree_path)
-
-    def readonly_path(self, id):
-        return self.full_path(id)
-
-    def __contains__(self, file_id):
-        return file_id in self.inventory_dict
-
-    def has_or_had_id(self, file_id):
-        return file_id in self
-
-    def get_file(self, file_id):
-        path = self.full_path(file_id)
-        return file(path, "rb")
-
-    def id2path(self, file_id):
-        return self.inventory_dict[file_id]
-
-    def id2abspath(self, id):
-        return self.full_path(id)
-
-    def change_path(self, id, path):
-        old_path = pathjoin(self.dir, self.inventory_dict[id])
-        rename(old_path, self.abs_path(path))
-        self.inventory_dict[id] = path
-
-    def is_executable(self, file_id):
-        mode = os.lstat(self.full_path(file_id)).st_mode
-        return bool(stat.S_ISREG(mode) and stat.S_IEXEC & mode)
-
-    def kind(self, file_id):
-        return file_kind(self.full_path(file_id))
-
-    def get_symlink_target(self, file_id):
-        return os.readlink(self.full_path(file_id))
-
-    def get_file_sha1(self, file_id):
-        return sha_file(file(self.full_path(file_id), "rb"))
-
-
 class MergeBuilder(object):
     def __init__(self):
-        self.dir = mkdtemp(prefix="BaZing")
-        self.base = MergeTree(pathjoin(self.dir, "base"))
-        self.this = MergeTree(pathjoin(self.dir, "this"))
-        self.other = MergeTree(pathjoin(self.dir, "other"))
-        
-        self.cset = changeset.Changeset()
-        self.cset.add_entry(changeset.ChangesetEntry("0", 
-                                                     changeset.NULL_ID, "./."))
+        self.dir = mkdtemp(prefix="merge-test")
+        def wt(name):
+           path = pathjoin(self.dir, name)
+           os.mkdir(path)
+           wt = bzrlib.bzrdir.BzrDir.create_standalone_workingtree(path)
+           tt = TreeTransform(wt)
+           return wt, tt
+        self.base, self.base_tt = wt('base') 
+        self.this, self.this_tt = wt('this')
+        self.other, self.other_tt = wt('other')
 
     def get_cset_path(self, parent, name):
         if name is None:
@@ -156,145 +36,85 @@
             return None
         return pathjoin(self.cset.entries[parent].path, name)
 
-    def add_file(self, id, parent, name, contents, mode):
-        self.base.add_file(id, parent, name, contents, mode)
-        self.this.add_file(id, parent, name, contents, mode)
-        self.other.add_file(id, parent, name, contents, mode)
-        path = self.get_cset_path(parent, name)
-        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
+    def add_file(self, id, parent, name, contents, executable):
+        def new_file(tt):
+            parent_id = tt.trans_id_file_id(parent)
+            tt.new_file(name, parent_id, contents, id, executable)
+        for tt in (self.this_tt, self.base_tt, self.other_tt):
+            new_file(tt)
+
+    def merge(self, merge_type=Merge3Merger, interesting_ids=None):
+        self.base_tt.apply()
+        self.base.commit('base commit')
+        for tt, wt in ((self.this_tt, self.this), (self.other_tt, self.other)):
+            wt.branch.pull(self.base.branch)
+            tt.apply()
+            wt.commit('branch commit')
+            assert len(wt.branch.revision_history()) == 2
+        self.this.branch.fetch(self.other.branch)
+        other_basis = self.other.branch.basis_tree()
+        merger = merge_type(self.this, self.this, self.base, other_basis, 
+                            interesting_ids=interesting_ids)
+        return merger.cooked_conflicts
+
+    def list_transforms(self):
+        return [self.this_tt, self.base_tt, self.other_tt]
+
+    def selected_transforms(self, this, base, other):
+        pairs = [(this, self.this_tt), (base, self.base_tt), 
+                 (other, self.other_tt)]
+        return [(v, tt) for (v, tt) in pairs if v is not None]
 
     def add_symlink(self, id, parent, name, contents):
-        self.base.add_symlink(id, parent, name, contents)
-        self.this.add_symlink(id, parent, name, contents)
-        self.other.add_symlink(id, parent, name, contents)
-        path = self.get_cset_path(parent, name)
-        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
-
-    def remove_file(self, id, base=False, this=False, other=False):
-        for option, tree in ((base, self.base), (this, self.this), 
-                             (other, self.other)):
-            if option:
-                tree.remove_file(id)
-            if other or base:
-                change = self.cset.entries[id].contents_change
-                if change is None:
-                    change = changeset.ReplaceContents(None, None)
-                    self.cset.entries[id].contents_change = change
-                    def create_file(tree):
-                        return changeset.TreeFileCreate(tree, id)
-                    if not other:
-                        change.new_contents = create_file(self.other)
-                    if not base:
-                        change.old_contents = create_file(self.base)
-                else:
-                    assert isinstance(change, changeset.ReplaceContents)
-                if other:
-                    change.new_contents=None
-                if base:
-                    change.old_contents=None
-                if change.old_contents is None and change.new_contents is None:
-                    change = None
-
-    def add_dir(self, id, parent, name, mode):
-        path = self.get_cset_path(parent, name)
-        self.base.add_dir(id, parent, name, mode)
-        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
-        self.this.add_dir(id, parent, name, mode)
-        self.other.add_dir(id, parent, name, mode)
+        for tt in self.list_transforms():
+            parent_id = tt.trans_id_file_id(parent)
+            tt.new_symlink(name, parent_id, contents, id)
+
+    def remove_file(self, file_id, base=False, this=False, other=False):
+        for option, tt in self.selected_transforms(this, base, other):
+            if option is True:
+                trans_id = tt.trans_id_file_id(file_id)
+                tt.cancel_creation(trans_id)
+                tt.cancel_versioning(trans_id)
+                tt.set_executability(None, trans_id)
+
+    def add_dir(self, file_id, parent, name):
+        for tt in self.list_transforms():
+            parent_id = tt.trans_id_file_id(parent)
+            tt.new_directory(name, parent_id, file_id)
 
     def change_name(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_name_tree(id, self.base, base)
-            self.cset.entries[id].name = base
-
-        if this is not None:
-            self.change_name_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_name_tree(id, self.other, other)
-            self.cset.entries[id].new_name = other
-
-    def change_parent(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_parent_tree(id, self.base, base)
-            self.cset.entries[id].parent = base
-            self.cset.entries[id].dir = self.cset.entries[base].path
-
-        if this is not None:
-            self.change_parent_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_parent_tree(id, self.other, other)
-            self.cset.entries[id].new_parent = other
-            self.cset.entries[id].new_dir = \
-                self.cset.entries[other].new_path
-
-    def change_contents(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_contents_tree(id, self.base, base)
-
-        if this is not None:
-            self.change_contents_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_contents_tree(id, self.other, other)
-
-        if base is not None or other is not None:
-            old_contents = file(self.base.full_path(id)).read()
-            new_contents = file(self.other.full_path(id)).read()
-            contents = changeset.ReplaceFileContents(self.base, self.other, id)
-            self.cset.entries[id].contents_change = contents
+        for val, tt in ((base, self.base_tt), (this, self.this_tt), 
+                        (other, self.other_tt)):
+            if val is None:
+                continue
+            trans_id = tt.trans_id_file_id(id)
+            parent_id = tt.final_parent(trans_id)
+            tt.adjust_path(val, parent_id, trans_id)
+
+    def change_parent(self, file_id, base=None, this=None, other=None):
+        for parent, tt in self.selected_transforms(this, base, other):
+            trans_id  = tt.trans_id_file_id(file_id)
+            parent_id = tt.trans_id_file_id(parent)
+            tt.adjust_path(tt.final_name(trans_id), parent_id, trans_id)
+
+    def change_contents(self, file_id, base=None, this=None, other=None):
+        for contents, tt in self.selected_transforms(this, base, other):
+            trans_id = tt.trans_id_file_id(file_id)
+            tt.cancel_creation(trans_id)
+            tt.create_file(contents, trans_id)
 
     def change_target(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_target_tree(id, self.base, base)
-
-        if this is not None:
-            self.change_target_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_target_tree(id, self.other, other)
-
-        if base is not None or other is not None:
-            old_contents = get_contents(self.base, id)
-            new_contents = get_contents(self.other, id)
-            contents = ReplaceContents(old_contents, new_contents)
-            self.cset.entries[id].contents_change = contents
+        for target, tt in self.selected_transforms(this, base, other):
+            trans_id = tt.trans_id_file_id(id)
+            tt.cancel_creation(trans_id)
+            tt.create_symlink(target, trans_id)
 
     def change_perms(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_perms_tree(id, self.base, base)
-
-        if this is not None:
-            self.change_perms_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_perms_tree(id, self.other, other)
-
-        if base is not None or other is not None:
-            old_exec = self.base.is_executable(id)
-            new_exec = self.other.is_executable(id)
-            metadata = changeset.ChangeExecFlag(old_exec, new_exec)
-            self.cset.entries[id].metadata_change = metadata
-
-    def change_name_tree(self, id, tree, name):
-        new_path = tree.child_path(self.cset.entries[id].parent, name)
-        tree.change_path(id, new_path)
-
-    def change_parent_tree(self, id, tree, parent):
-        new_path = tree.child_path(parent, self.cset.entries[id].name)
-        tree.change_path(id, new_path)
-
-    def change_contents_tree(self, id, tree, contents):
-        path = tree.full_path(id)
-        mode = os.stat(path).st_mode
-        file(path, "w").write(contents)
-        os.chmod(path, mode)
-
-    def change_target_tree(self, id, tree, target):
-        path = tree.full_path(id)
-        os.unlink(path)
-        os.symlink(target, path)
+        for executability, tt in self.selected_transforms(this, base, other):
+            trans_id = tt.trans_id_file_id(id)
+            tt.set_executability(None, trans_id)
+            tt.set_executability(executability, trans_id)
 
     def change_perms_tree(self, id, tree, mode):
         os.chmod(tree.full_path(id), mode)
@@ -359,85 +179,71 @@
     def test_change_name(self):
         """Test renames"""
         builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "hello1", 0755)
+        builder.add_file("1", "TREE_ROOT", "name1", "hello1", True)
         builder.change_name("1", other="name2")
-        builder.add_file("2", "0", "name3", "hello2", 0755)
+        builder.add_file("2", "TREE_ROOT", "name3", "hello2", True)
         builder.change_name("2", base="name4")
-        builder.add_file("3", "0", "name5", "hello3", 0755)
+        builder.add_file("3", "TREE_ROOT", "name5", "hello3", True)
         builder.change_name("3", this="name6")
-        cset = builder.merge_changeset(ApplyMerge3)
-        self.failUnless(cset.entries["2"].is_boring())
-        self.assertEqual(cset.entries["1"].name, "name1")
-        self.assertEqual(cset.entries["1"].new_name, "name2")
-        self.failUnless(cset.entries["3"].is_boring())
-        for tree in (builder.this, builder.other, builder.base):
-            self.assertNotEqual(tree.dir, builder.dir)
-            self.assertStartsWith(tree.dir, builder.dir)
-            for path in tree.inventory_dict.itervalues():
-                fullpath = tree.abs_path(path)
-                self.assertStartsWith(fullpath, tree.dir)
-                self.failIf(path.startswith(tree.dir))
-                self.failUnless(os.path.lexists(fullpath))
-        builder.apply_changeset(cset)
+        builder.merge()
         builder.cleanup()
         builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "hello1", 0644)
+        builder.add_file("1", "TREE_ROOT", "name1", "hello1", False)
         builder.change_name("1", other="name2", this="name3")
-        self.assertRaises(changeset.RenameConflict, 
-                          builder.merge_changeset, ApplyMerge3)
+        conflicts = builder.merge()
+        self.assertEqual(conflicts, [('path conflict', '1', 'name3', 'name2')])
         builder.cleanup()
+
+    def test_merge_one(self):
+        builder = MergeBuilder()
+        builder.add_file("1", "TREE_ROOT", "name1", "hello1", True)
+        builder.change_contents("1", other="text4")
+        builder.add_file("2", "TREE_ROOT", "name2", "hello1", True)
+        builder.change_contents("2", other="text4")
+        builder.merge(interesting_ids=["1"])
+        self.assertEqual(builder.this.get_file("1").read(), "text4" )
+        self.assertEqual(builder.this.get_file("2").read(), "hello1" )
         
     def test_file_moves(self):
         """Test moves"""
         builder = MergeBuilder()
-        builder.add_dir("1", "0", "dir1", 0755)
-        builder.add_dir("2", "0", "dir2", 0755)
-        builder.add_file("3", "1", "file1", "hello1", 0644)
-        builder.add_file("4", "1", "file2", "hello2", 0644)
-        builder.add_file("5", "1", "file3", "hello3", 0644)
+        builder.add_dir("1", "TREE_ROOT", "dir1")
+        builder.add_dir("2", "TREE_ROOT", "dir2")
+        builder.add_file("3", "1", "file1", "hello1", True)
+        builder.add_file("4", "1", "file2", "hello2", True)
+        builder.add_file("5", "1", "file3", "hello3", True)
         builder.change_parent("3", other="2")
-        self.assert_(Inventory(builder.other.inventory_dict).get_parent("3") == "2")
         builder.change_parent("4", this="2")
-        self.assert_(Inventory(builder.this.inventory_dict).get_parent("4") == "2")
         builder.change_parent("5", base="2")
-        self.assert_(Inventory(builder.base.inventory_dict).get_parent("5") == "2")
-        cset = builder.merge_changeset(ApplyMerge3)
-        for id in ("1", "2", "4", "5"):
-            self.assert_(cset.entries[id].is_boring())
-        self.assert_(cset.entries["3"].parent == "1")
-        self.assert_(cset.entries["3"].new_parent == "2")
-        builder.apply_changeset(cset)
+        builder.merge()
         builder.cleanup()
 
         builder = MergeBuilder()
-        builder.add_dir("1", "0", "dir1", 0755)
-        builder.add_dir("2", "0", "dir2", 0755)
-        builder.add_dir("3", "0", "dir3", 0755)
-        builder.add_file("4", "1", "file1", "hello1", 0644)
+        builder.add_dir("1", "TREE_ROOT", "dir1")
+        builder.add_dir("2", "TREE_ROOT", "dir2")
+        builder.add_dir("3", "TREE_ROOT", "dir3")
+        builder.add_file("4", "1", "file1", "hello1", False)
         builder.change_parent("4", other="2", this="3")
-        self.assertRaises(changeset.MoveConflict, 
-                          builder.merge_changeset, ApplyMerge3)
+        conflicts = builder.merge()
+        path2 = pathjoin('dir2', 'file1')
+        path3 = pathjoin('dir3', 'file1')
+        self.assertEqual(conflicts, [('path conflict', '4', path3, path2)])
         builder.cleanup()
 
     def test_contents_merge(self):
         """Test merge3 merging"""
-        self.do_contents_test(ApplyMerge3)
+        self.do_contents_test(Merge3Merger)
 
     def test_contents_merge2(self):
         """Test diff3 merging"""
-        self.do_contents_test(changeset.Diff3Merge)
+        try:
+            self.do_contents_test(Diff3Merger)
+        except NoDiff3:
+            raise TestSkipped("diff3 not available")
 
     def test_contents_merge3(self):
         """Test diff3 merging"""
-        def backup_merge(file_id, base, other):
-            return BackupBeforeChange(ApplyMerge3(file_id, base, other))
-        builder = self.contents_test_success(backup_merge)
-        def backup_exists(file_id):
-            return os.path.exists(builder.this.full_path(file_id)+"~")
-        self.assert_(backup_exists("1"))
-        self.assert_(backup_exists("2"))
-        self.assert_(not backup_exists("3"))
-        builder.cleanup()
+        self.do_contents_test(WeaveMerger)
 
     def do_contents_test(self, merge_factory):
         """Test merging with specified ContentsChange factory"""
@@ -446,125 +252,119 @@
         self.contents_test_conflicts(merge_factory)
 
     def contents_test_success(self, merge_factory):
-        from inspect import isclass
         builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.add_file("1", "TREE_ROOT", "name1", "text1", True)
         builder.change_contents("1", other="text4")
-        builder.add_file("2", "0", "name3", "text2", 0655)
+        builder.add_file("2", "TREE_ROOT", "name3", "text2", False)
         builder.change_contents("2", base="text5")
-        builder.add_file("3", "0", "name5", "text3", 0744)
-        builder.add_file("4", "0", "name6", "text4", 0744)
+        builder.add_file("3", "TREE_ROOT", "name5", "text3", True)
+        builder.add_file("4", "TREE_ROOT", "name6", "text4", True)
         builder.remove_file("4", base=True)
-        self.assert_(not builder.cset.entries["4"].is_boring())
-        builder.change_contents("3", this="text6")
-        cset = builder.merge_changeset(merge_factory)
-        self.assert_(cset.entries["1"].contents_change is not None)
-        if isclass(merge_factory):
-            self.assert_(isinstance(cset.entries["1"].contents_change,
-                          merge_factory))
-            self.assert_(isinstance(cset.entries["2"].contents_change,
-                          merge_factory))
-        self.assert_(cset.entries["3"].is_boring())
-        self.assert_(cset.entries["4"].is_boring())
-        builder.apply_changeset(cset)
-        self.assert_(file(builder.this.full_path("1"), "rb").read() == "text4" )
-        self.assert_(file(builder.this.full_path("2"), "rb").read() == "text2" )
-        if sys.platform != "win32":
-            self.assert_(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
-            self.assert_(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
-            self.assert_(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
+        builder.merge()
+        self.assertEqual(builder.this.get_file("1").read(), "text4" )
+        self.assertEqual(builder.this.get_file("2").read(), "text2" )
+        self.assertIs(builder.this.is_executable("1"), True)
+        self.assertIs(builder.this.is_executable("2"), False)
+        self.assertIs(builder.this.is_executable("3"), True)
         return builder
 
     def contents_test_conflicts(self, merge_factory):
         builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.add_file("1", "TREE_ROOT", "name1", "text1", True)
         builder.change_contents("1", other="text4", this="text3")
-        cset = builder.merge_changeset(merge_factory)
-        self.assertRaises(changeset.MergeConflict, builder.apply_changeset,
-                          cset)
+        conflicts = builder.merge(merge_factory)
+        self.assertEqual(conflicts, [('text conflict', '1', 'name1')])
         builder.cleanup()
 
     def test_symlink_conflicts(self):
         if sys.platform != "win32":
             builder = MergeBuilder()
-            builder.add_symlink("2", "0", "name2", "target1")
+            builder.add_symlink("2", "TREE_ROOT", "name2", "target1")
             builder.change_target("2", other="target4", base="text3")
-            self.assertRaises(changeset.ThreewayContentsConflict,
-                              builder.merge_changeset, ApplyMerge3)
+            conflicts = builder.merge()
+            self.assertEqual(conflicts, [('contents conflict', '2', 'name2')])
             builder.cleanup()
 
     def test_symlink_merge(self):
         if sys.platform != "win32":
             builder = MergeBuilder()
-            builder.add_symlink("1", "0", "name1", "target1")
-            builder.add_symlink("2", "0", "name2", "target1")
-            builder.add_symlink("3", "0", "name3", "target1")
+            builder.add_symlink("1", "TREE_ROOT", "name1", "target1")
+            builder.add_symlink("2", "TREE_ROOT", "name2", "target1")
+            builder.add_symlink("3", "TREE_ROOT", "name3", "target1")
             builder.change_target("1", this="target2")
             builder.change_target("2", base="target2")
             builder.change_target("3", other="target2")
-            self.assertNotEqual(builder.cset.entries['2'].contents_change,
-                                builder.cset.entries['3'].contents_change)
-            cset = builder.merge_changeset(ApplyMerge3)
-            builder.apply_changeset(cset)
+            builder.merge()
             self.assertEqual(builder.this.get_symlink_target("1"), "target2")
             self.assertEqual(builder.this.get_symlink_target("2"), "target1")
             self.assertEqual(builder.this.get_symlink_target("3"), "target2")
             builder.cleanup()
 
+    def test_no_passive_add(self):
+        builder = MergeBuilder()
+        builder.add_file("1", "TREE_ROOT", "name1", "text1", True)
+        builder.remove_file("1", this=True)
+        builder.merge()
+        builder.cleanup()
+
     def test_perms_merge(self):
         builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_perms("1", other=0644)
-        builder.add_file("2", "0", "name2", "text2", 0755)
-        builder.change_perms("2", base=0644)
-        builder.add_file("3", "0", "name3", "text3", 0755)
-        builder.change_perms("3", this=0644)
-        cset = builder.merge_changeset(ApplyMerge3)
-        self.assert_(cset.entries["1"].metadata_change is not None)
-        self.assert_(isinstance(cset.entries["1"].metadata_change, ExecFlagMerge))
-        self.assert_(isinstance(cset.entries["2"].metadata_change, ExecFlagMerge))
-        self.assert_(cset.entries["3"].is_boring())
-        builder.apply_changeset(cset)
-        if sys.platform != "win32":
-            self.assert_(os.lstat(builder.this.full_path("1")).st_mode &0100 == 0000)
-            self.assert_(os.lstat(builder.this.full_path("2")).st_mode &0100 == 0100)
-            self.assert_(os.lstat(builder.this.full_path("3")).st_mode &0100 == 0000)
+        builder.add_file("1", "TREE_ROOT", "name1", "text1", True)
+        builder.change_perms("1", other=False)
+        builder.add_file("2", "TREE_ROOT", "name2", "text2", True)
+        builder.change_perms("2", base=False)
+        builder.add_file("3", "TREE_ROOT", "name3", "text3", True)
+        builder.change_perms("3", this=False)
+        builder.add_file('4', 'TREE_ROOT', 'name4', 'text4', False)
+        builder.change_perms('4', this=True)
+        builder.remove_file('4', base=True)
+        builder.merge()
+        self.assertIs(builder.this.is_executable("1"), False)
+        self.assertIs(builder.this.is_executable("2"), True)
+        self.assertIs(builder.this.is_executable("3"), False)
         builder.cleanup();
 
-
-class FunctionalMergeTest(TestCaseInTempDir):
+    def test_new_suffix(self):
+        builder = MergeBuilder()
+        builder.add_file("1", "TREE_ROOT", "name1", "text1", True)
+        builder.change_contents("1", other="text3")
+        builder.add_file("2", "TREE_ROOT", "name1.new", "text2", True)
+        builder.merge()
+        os.lstat(builder.this.id2abspath("2"))
+        builder.cleanup()
+
+
+class FunctionalMergeTest(TestCaseWithTransport):
 
     def test_trivial_star_merge(self):
         """Test that merges in a star shape Just Work.""" 
-        from bzrlib.add import smart_add_tree
-        from bzrlib.clone import copy_branch
-        from bzrlib.merge import merge
         # John starts a branch
         self.build_tree(("original/", "original/file1", "original/file2"))
-        branch = Branch.initialize("original")
-        tree = WorkingTree('original', branch)
+        tree = self.make_branch_and_tree('original')
+        branch = tree.branch
         smart_add_tree(tree, ["original"])
         tree.commit("start branch.", verbose=False)
         # Mary branches it.
         self.build_tree(("mary/",))
-        copy_branch(branch, "mary")
+        branch.bzrdir.clone("mary")
         # Now John commits a change
         file = open("original/file1", "wt")
         file.write("John\n")
         file.close()
-        branch.working_tree().commit("change file1")
+        tree.commit("change file1")
         # Mary does too
-        mary_branch = Branch.open("mary")
+        mary_tree = WorkingTree.open('mary')
+        mary_branch = mary_tree.branch
         file = open("mary/file2", "wt")
         file.write("Mary\n")
         file.close()
-        mary_branch.working_tree().commit("change file2")
+        mary_tree.commit("change file2")
         # john should be able to merge with no conflicts.
-        merge_type = ApplyMerge3
+        merge_type = Merge3Merger
         base = [None, None]
         other = ("mary", -1)
         self.assertRaises(BzrCommandError, merge, other, base, check_clean=True,
-                          merge_type=WeaveMerge, this_dir="original",
+                          merge_type=WeaveMerger, this_dir="original",
                           show_base=True)
         merge(other, base, check_clean=True, merge_type=merge_type,
               this_dir="original")
@@ -573,28 +373,31 @@
  
     def test_conflicts(self):
         os.mkdir('a')
-        a = Branch.initialize('a')
+        wta = self.make_branch_and_tree('a')
+        a = wta.branch
         file('a/file', 'wb').write('contents\n')
-        a.working_tree().add('file')
-        a.working_tree().commit('base revision', allow_pointless=False)
-        b = copy_branch(a, 'b')
+        wta.add('file')
+        wta.commit('base revision', allow_pointless=False)
+        d_b = a.bzrdir.clone('b')
+        b = d_b.open_branch()
         file('a/file', 'wb').write('other contents\n')
-        a.working_tree().commit('other revision', allow_pointless=False)
+        wta.commit('other revision', allow_pointless=False)
         file('b/file', 'wb').write('this contents contents\n')
-        b.working_tree().commit('this revision', allow_pointless=False)
+        wtb = d_b.open_workingtree()
+        wtb.commit('this revision', allow_pointless=False)
         self.assertEqual(merge(['a', -1], [None, None], this_dir='b'), 1)
         self.assert_(os.path.lexists('b/file.THIS'))
         self.assert_(os.path.lexists('b/file.BASE'))
         self.assert_(os.path.lexists('b/file.OTHER'))
         self.assertRaises(WorkingTreeNotRevision, merge, ['a', -1], 
                           [None, None], this_dir='b', check_clean=False,
-                          merge_type=WeaveMerge)
-        merge(['b', -1], ['b', None], this_dir='b', check_clean=False)
+                          merge_type=WeaveMerger)
+        wtb.revert([])
         os.unlink('b/file.THIS')
         os.unlink('b/file.OTHER')
         os.unlink('b/file.BASE')
         self.assertEqual(merge(['a', -1], [None, None], this_dir='b', 
-                               check_clean=False, merge_type=WeaveMerge), 1)
+                               check_clean=False, merge_type=WeaveMerger), 1)
         self.assert_(os.path.lexists('b/file'))
         self.assert_(os.path.lexists('b/file.THIS'))
         self.assert_(not os.path.lexists('b/file.BASE'))
@@ -602,108 +405,96 @@
 
     def test_merge_unrelated(self):
         """Sucessfully merges unrelated branches with no common names"""
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        wta = self.make_branch_and_tree('a')
+        a = wta.branch
         file('a/a_file', 'wb').write('contents\n')
-        a.working_tree().add('a_file')
-        a.working_tree().commit('a_revision', allow_pointless=False)
-        os.mkdir('b')
-        b = Branch.initialize('b')
+        wta.add('a_file')
+        wta.commit('a_revision', allow_pointless=False)
+        wtb = self.make_branch_and_tree('b')
+        b = wtb.branch
         file('b/b_file', 'wb').write('contents\n')
-        b.working_tree().add('b_file')
-        b.working_tree().commit('b_revision', allow_pointless=False)
+        wtb.add('b_file')
+        wtb.commit('b_revision', allow_pointless=False)
         merge(['b', -1], ['b', 0], this_dir='a')
         self.assert_(os.path.lexists('a/b_file'))
-        self.assertEqual(a.working_tree().pending_merges(),
+        self.assertEqual(wta.pending_merges(),
                          [b.last_revision()]) 
 
     def test_merge_unrelated_conflicting(self):
         """Sucessfully merges unrelated branches with common names"""
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        wta = self.make_branch_and_tree('a')
+        a = wta.branch
         file('a/file', 'wb').write('contents\n')
-        a.working_tree().add('file')
-        a.working_tree().commit('a_revision', allow_pointless=False)
-        os.mkdir('b')
-        b = Branch.initialize('b')
+        wta.add('file')
+        wta.commit('a_revision', allow_pointless=False)
+        wtb = self.make_branch_and_tree('b')
+        b = wtb.branch
         file('b/file', 'wb').write('contents\n')
-        b.working_tree().add('file')
-        b.working_tree().commit('b_revision', allow_pointless=False)
+        wtb.add('file')
+        wtb.commit('b_revision', allow_pointless=False)
         merge(['b', -1], ['b', 0], this_dir='a')
         self.assert_(os.path.lexists('a/file'))
         self.assert_(os.path.lexists('a/file.moved'))
-        self.assertEqual(a.working_tree().pending_merges(), [b.last_revision()])
+        self.assertEqual(wta.pending_merges(), [b.last_revision()])
 
     def test_merge_deleted_conflicts(self):
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        wta = self.make_branch_and_tree('a')
         file('a/file', 'wb').write('contents\n')
-        a.working_tree().add('file')
-        a.working_tree().commit('a_revision', allow_pointless=False)
-        del a
+        wta.add('file')
+        wta.commit('a_revision', allow_pointless=False)
         self.run_bzr('branch', 'a', 'b')
-        a = Branch.open('a')
         os.remove('a/file')
-        a.working_tree().commit('removed file', allow_pointless=False)
+        wta.commit('removed file', allow_pointless=False)
         file('b/file', 'wb').write('changed contents\n')
-        b = Branch.open('b')
-        b.working_tree().commit('changed file', allow_pointless=False)
+        wtb = WorkingTree.open('b')
+        wtb.commit('changed file', allow_pointless=False)
         merge(['a', -1], ['a', 1], this_dir='b')
         self.failIf(os.path.lexists('b/file'))
 
     def test_merge_metadata_vs_deletion(self):
         """Conflict deletion vs metadata change"""
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        a_wt = self.make_branch_and_tree('a')
         file('a/file', 'wb').write('contents\n')
-        a_wt = a.working_tree()
         a_wt.add('file')
         a_wt.commit('r0')
-        copy_branch(a, 'b')
-        b = Branch.open('b')
-        b_wt = b.working_tree()
+        self.run_bzr('branch', 'a', 'b')
+        b_wt = WorkingTree.open('b')
         os.chmod('b/file', 0755)
         os.remove('a/file')
         a_wt.commit('removed a')
-        self.assertEqual(a.revno(), 2)
+        self.assertEqual(a_wt.branch.revno(), 2)
         self.assertFalse(os.path.exists('a/file'))
         b_wt.commit('exec a')
         merge(['b', -1], ['b', 0], this_dir='a')
         self.assert_(os.path.exists('a/file'))
 
     def test_merge_swapping_renames(self):
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        a_wt = self.make_branch_and_tree('a')
         file('a/un','wb').write('UN')
         file('a/deux','wb').write('DEUX')
-        a_wt = a.working_tree()
-        a_wt.add('un')
-        a_wt.add('deux')
-        a_wt.commit('r0')
-        copy_branch(a,'b')
-        b = Branch.open('b')
-        b_wt = b.working_tree()
+        a_wt.add('un', 'un')
+        a_wt.add('deux', 'deux')
+        a_wt.commit('r0', rev_id='r0')
+        self.run_bzr('branch', 'a', 'b')
+        b_wt = WorkingTree.open('b')
         b_wt.rename_one('un','tmp')
         b_wt.rename_one('deux','un')
         b_wt.rename_one('tmp','deux')
-        b_wt.commit('r1')
-        merge(['b', -1],['b', 1],this_dir='a')
-        self.assert_(os.path.exists('a/un'))
-        self.assert_(os.path.exists('a/deux'))
+        b_wt.commit('r1', rev_id='r1')
+        self.assertEqual(0, merge(['b', -1], ['b', 1], this_dir='a'))
+        self.failUnlessExists('a/un')
+        self.failUnless('a/deux')
         self.assertFalse(os.path.exists('a/tmp'))
         self.assertEqual(file('a/un').read(),'DEUX')
         self.assertEqual(file('a/deux').read(),'UN')
 
     def test_merge_delete_and_add_same(self):
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        a_wt = self.make_branch_and_tree('a')
         file('a/file', 'wb').write('THIS')
-        a_wt = a.working_tree()
         a_wt.add('file')
         a_wt.commit('r0')
-        copy_branch(a, 'b')
-        b = Branch.open('b')
-        b_wt = b.working_tree()
+        self.run_bzr('branch', 'a', 'b')
+        b_wt = WorkingTree.open('b')
         os.remove('b/file')
         b_wt.commit('r1')
         file('b/file', 'wb').write('THAT')
@@ -727,15 +518,12 @@
         $ bzr add foo
         $ bzr commit
         """
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        a_wt = self.make_branch_and_tree('a')
         file('a/foo', 'wb').write('A/FOO')
-        a_wt = a.working_tree()
         a_wt.add('foo')
         a_wt.commit('added foo')
-        copy_branch(a, 'b')
-        b = Branch.open('b')
-        b_wt = b.working_tree()
+        self.run_bzr('branch', 'a', 'b')
+        b_wt = WorkingTree.open('b')
         b_wt.rename_one('foo', 'bar')
         file('b/foo', 'wb').write('B/FOO')
         b_wt.add('foo')
@@ -758,14 +546,12 @@
         $ bzr commit
         """
         os.mkdir('a')
-        a = Branch.initialize('a')
+        a_wt = self.make_branch_and_tree('a')
         file('a/foo', 'wb').write('A/FOO')
-        a_wt = a.working_tree()
         a_wt.add('foo')
         a_wt.commit('added foo')
-        copy_branch(a, 'b')
-        b = Branch.open('b')
-        b_wt = b.working_tree()
+        self.run_bzr('branch', 'a', 'b')
+        b_wt = WorkingTree.open('b')
         os.mkdir('b/bar')
         b_wt.add('bar')
         b_wt.rename_one('foo', 'bar/foo')
@@ -787,17 +573,14 @@
         $ rmdir foo
         $ bzr commit
         """
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        a_wt = self.make_branch_and_tree('a')
         os.mkdir('a/foo')
         file('a/foo/bar', 'wb').write('A/FOO/BAR')
-        a_wt = a.working_tree()
         a_wt.add('foo')
         a_wt.add('foo/bar')
         a_wt.commit('added foo/bar')
-        copy_branch(a, 'b')
-        b = Branch.open('b')
-        b_wt = b.working_tree()
+        self.run_bzr('branch', 'a', 'b')
+        b_wt = WorkingTree.open('b')
         b_wt.rename_one('foo/bar', 'bar')
         os.rmdir('b/foo')
         b_wt.remove('foo')
@@ -819,17 +602,14 @@
         $ bzr mv bar foo
         $ bzr commit
         """
-        os.mkdir('a')
-        a = Branch.initialize('a')
+        a_wt = self.make_branch_and_tree('a')
         file('a/foo', 'wb').write('A/FOO')
         file('a/bar', 'wb').write('A/BAR')
-        a_wt = a.working_tree()
         a_wt.add('foo')
         a_wt.add('bar')
         a_wt.commit('added foo and bar')
-        copy_branch(a, 'b')
-        b = Branch.open('b')
-        b_wt = b.working_tree()
+        self.run_bzr('branch', 'a', 'b')
+        b_wt = WorkingTree.open('b')
         os.unlink('b/foo')
         b_wt.remove('foo')
         b_wt.rename_one('bar', 'foo')

=== modified file 'bzrlib/tests/test_missing.py'
--- bzrlib/tests/test_missing.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_missing.py	2006-03-20 08:31:00 +0000
@@ -13,28 +13,33 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+
+
+from bzrlib.builtins import merge
 from bzrlib.missing import find_unmerged
-from bzrlib.branch import Branch
-from bzrlib.merge import merge
-from bzrlib.tests import TestCaseInTempDir
-import os
-
-class TestMissing(TestCaseInTempDir):
+from bzrlib.tests import TestCaseWithTransport
+from bzrlib.workingtree import WorkingTree
+
+
+class TestMissing(TestCaseWithTransport):
+
     def test_find_unmerged(self):
-        os.mkdir('original')
-        os.mkdir('puller')
-        os.mkdir('merger')
-        original = Branch.initialize('original')
-        puller = Branch.initialize('puller')
-        merger = Branch.initialize('merger')
+        original_tree = self.make_branch_and_tree('original')
+        original = original_tree.branch
+        puller_tree = self.make_branch_and_tree('puller')
+        puller = puller_tree.branch
+        merger_tree = self.make_branch_and_tree('merger')
+        merger = merger_tree.branch
         self.assertEqual(find_unmerged(original, puller), ([], []))
-        original.working_tree().commit('a', rev_id='a')
+        original_tree.commit('a', rev_id='a')
         self.assertEqual(find_unmerged(original, puller), ([(1, u'a')], []))
         puller.pull(original)
         self.assertEqual(find_unmerged(original, puller), ([], []))
         merger.pull(original)
-        original.working_tree().commit('b', rev_id='b')
-        original.working_tree().commit('c', rev_id='c')
+        original_tree.commit('b', rev_id='b')
+        original_tree.commit('c', rev_id='c')
         self.assertEqual(find_unmerged(original, puller), ([(2, u'b'), 
                                                             (3, u'c')], []))
 
@@ -45,5 +50,5 @@
         merge(['original', -1], [None, None], this_dir='merger')
         self.assertEqual(find_unmerged(original, merger), ([(2, u'b'), 
                                                             (3, u'c')], []))
-        merger.working_tree().commit('d', rev_id='d')
+        merger_tree.commit('d', rev_id='d')
         self.assertEqual(find_unmerged(original, merger), ([], [(2, 'd')]))

=== modified file 'bzrlib/tests/test_msgeditor.py'
--- bzrlib/tests/test_msgeditor.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_msgeditor.py	2006-03-20 08:31:00 +0000
@@ -21,15 +21,15 @@
 
 from bzrlib.branch import Branch
 from bzrlib.msgeditor import make_commit_message_template
-from bzrlib.tests import TestCaseInTempDir, TestSkipped
-
-
-class MsgEditorTest(TestCaseInTempDir):
+from bzrlib.tests import TestCaseWithTransport, TestSkipped
+
+
+class MsgEditorTest(TestCaseWithTransport):
 
     def make_uncommitted_tree(self):
         """Build a branch with uncommitted unicode named changes in the cwd."""
-        b = Branch.initialize('.')
-        working_tree = b.working_tree()
+        working_tree = self.make_branch_and_tree('.')
+        b = working_tree.branch
         filename = u'hell\u00d8'
         try:
             self.build_tree_contents([(filename, 'contents of hello')])

=== modified file 'bzrlib/tests/test_nonascii.py'
--- bzrlib/tests/test_nonascii.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_nonascii.py	2006-03-20 08:31:00 +0000
@@ -18,21 +18,20 @@
 
 import os
 
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib.branch import Branch
-
-
-class NonAsciiTest(TestCaseInTempDir):
+from bzrlib.osutils import pathjoin
+from bzrlib.tests import TestCaseWithTransport, TestSkipped
+from bzrlib.workingtree import WorkingTree
+
+
+class NonAsciiTest(TestCaseWithTransport):
 
     def test_add_in_nonascii_branch(self):
         """Test adding in a non-ASCII branch."""
         br_dir = u"\u1234"
         try:
-            os.mkdir(br_dir)
-            os.chdir(br_dir)
+            wt = self.make_branch_and_tree(br_dir)
         except UnicodeEncodeError:
-            self.log("filesystem can't accomodate nonascii names")
+            raise TestSkipped("filesystem can't accomodate nonascii names")
             return
-        br = Branch.initialize(u".")
-        file("a", "w").write("hello")
-        br.working_tree().add(["a"], ["a-id"])
+        file(pathjoin(br_dir, "a"), "w").write("hello")
+        wt.add(["a"], ["a-id"])

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_osutils.py	2006-03-20 08:31:00 +0000
@@ -21,7 +21,7 @@
 import sys
 
 import bzrlib
-from bzrlib.errors import BzrBadParameter
+from bzrlib.errors import BzrBadParameterNotUnicode
 import bzrlib.osutils as osutils
 from bzrlib.tests import TestCaseInTempDir, TestCase
 
@@ -59,9 +59,18 @@
 
         self.check_file_contents('a', 'something in a\n')
 
-
     # TODO: test fancy_rename using a MemoryTransport
 
+    def test_01_rand_chars_empty(self):
+        result = osutils.rand_chars(0)
+        self.assertEqual(result, '')
+
+    def test_02_rand_chars_100(self):
+        result = osutils.rand_chars(100)
+        self.assertEqual(len(result), 100)
+        self.assertEqual(type(result), str)
+        self.assertContainsRe(result, r'^[a-z0-9]{100}$')
+
 
 class TestSafeUnicode(TestCase):
 
@@ -78,4 +87,6 @@
         self.assertEqual(u'foo\xae', osutils.safe_unicode('foo\xc2\xae'))
 
     def test_bad_utf8_string(self):
-        self.assertRaises(BzrBadParameter, osutils.safe_unicode, '\xbb\xbb')
+        self.assertRaises(BzrBadParameterNotUnicode,
+                          osutils.safe_unicode,
+                          '\xbb\xbb')

=== removed file 'bzrlib/tests/test_parent.py'
--- bzrlib/tests/test_parent.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_parent.py	1970-01-01 00:00:00 +0000
@@ -1,59 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import os
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
-from bzrlib.osutils import abspath, realpath
-
-
-"""Tests for Branch parent URL"""
-
-
-class TestParent(TestCaseInTempDir):
-    def test_no_default_parent(self):
-        """Branches should have no parent by default"""
-        b = Branch.initialize(u'.')
-        self.assertEquals(b.get_parent(), None)
-        
-    
-    def test_set_get_parent(self):
-        """Set and then re-get the parent"""
-        b = Branch.initialize(u'.')
-        url = 'http://bazaar-ng.org/bzr/bzr.dev'
-        b.set_parent(url)
-        self.assertEquals(b.get_parent(), url)
-
-    def test_branch_sets_parent(self):
-        """The branch command should set the new branch's parent"""
-        from bzrlib.commands import run_bzr
-
-        os.mkdir('from')
-        branch_from = Branch.initialize('from')
-        file('from/foo', 'wt').write('contents of foo')
-        branch_from.working_tree().add('foo')
-        branch_from.working_tree().commit('initial commit')
-        
-        os.mkdir('to')
-        copy_branch(branch_from, 'to', None)
-
-        branch_to = Branch.open('to')
-        abs = abspath('from')
-        self.assertEquals(branch_to.get_parent(), abs)
-        
-

=== modified file 'bzrlib/tests/test_permissions.py'
--- bzrlib/tests/test_permissions.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_permissions.py	2006-03-20 08:31:00 +0000
@@ -23,21 +23,25 @@
 
 In the future, when we have Repository/Branch/Checkout information, the
 permissions should be inherited individually, rather than all be the same.
-
-TODO: jam 20051215 There are no tests for ftp yet, because we have no ftp server
-TODO: jam 20051215 Currently the default behavior for 'bzr branch' is just 
-                   defined by the local umask. This isn't terrible, is it
-                   the truly desired behavior?
 """
 
+# TODO: jam 20051215 There are no tests for ftp yet, because we have no ftp server
+# TODO: jam 20051215 Currently the default behavior for 'bzr branch' is just 
+#                    defined by the local umask. This isn't terrible, is it
+#                    the truly desired behavior?
+ 
 import os
 import sys
 import stat
+from StringIO import StringIO
 
 from bzrlib.branch import Branch
-from bzrlib.tests import TestCaseInTempDir, TestSkipped
+from bzrlib.bzrdir import BzrDir
+from bzrlib.lockable_files import LockableFiles, TransportLock
+from bzrlib.tests import TestCaseWithTransport, TestSkipped
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
-from bzrlib.tests.test_transport import check_mode
+from bzrlib.transport import get_transport
+from bzrlib.workingtree import WorkingTree
 
 
 def chmod_r(base, file_mode, dir_mode):
@@ -63,43 +67,42 @@
     :param include_base: If false, only check the subdirectories
     """
     assert os.path.isdir(base)
+    t = get_transport(".")
     if include_base:
-        check_mode(test, base, dir_mode)
+        test.assertTransportMode(t, base, dir_mode)
     for root, dirs, files in os.walk(base):
         for d in dirs:
             p = os.path.join(root, d)
-            check_mode(test, p, dir_mode)
+            test.assertTransportMode(t, p, dir_mode)
         for f in files:
             p = os.path.join(root, f)
-            check_mode(test, p, file_mode)
-
-
-def assertEqualMode(test, mode, mode_test):
-    test.assertEqual(mode, mode_test,
-                     'mode mismatch %o != %o' % (mode, mode_test))
-
-
-class TestPermissions(TestCaseInTempDir):
+            test.assertTransportMode(t, p, file_mode)
+
+
+class TestPermissions(TestCaseWithTransport):
 
     def test_new_files(self):
         if sys.platform == 'win32':
             raise TestSkipped('chmod has no effect on win32')
 
-        b = Branch.initialize(u'.')
-        t = b.working_tree()
+        t = self.make_branch_and_tree('.')
+        b = t.branch
         open('a', 'wb').write('foo\n')
         t.add('a')
         t.commit('foo')
 
-        # Delete them because we are modifying the filesystem underneath them
-        del b, t 
         chmod_r('.bzr', 0644, 0755)
         check_mode_r(self, '.bzr', 0644, 0755)
 
-        b = Branch.open('.')
-        t = b.working_tree()
-        assertEqualMode(self, 0755, b._dir_mode)
-        assertEqualMode(self, 0644, b._file_mode)
+        # although we are modifying the filesystem
+        # underneath the objects, they are not locked, and thus it must
+        # be safe for most operations. But here we want to observe a 
+        # mode change in the control bits, which current do not refresh
+        # when a new lock is taken out.
+        t = WorkingTree.open('.')
+        b = t.branch
+        self.assertEqualMode(0755, b.control_files._dir_mode)
+        self.assertEqualMode(0644, b.control_files._file_mode)
 
         # Modifying a file shouldn't break the permissions
         open('a', 'wb').write('foo2\n')
@@ -113,14 +116,13 @@
         t.commit('new b')
         check_mode_r(self, '.bzr', 0644, 0755)
 
-        del b, t
         # Recursively update the modes of all files
         chmod_r('.bzr', 0664, 0775)
         check_mode_r(self, '.bzr', 0664, 0775)
-        b = Branch.open('.')
-        t = b.working_tree()
-        assertEqualMode(self, 0775, b._dir_mode)
-        assertEqualMode(self, 0664, b._file_mode)
+        t = WorkingTree.open('.')
+        b = t.branch
+        self.assertEqualMode(0775, b.control_files._dir_mode)
+        self.assertEqualMode(0664, b.control_files._file_mode)
 
         open('a', 'wb').write('foo3\n')
         t.commit('foo3')
@@ -132,14 +134,13 @@
         check_mode_r(self, '.bzr', 0664, 0775)
 
         # Test the group sticky bit
-        del b, t
         # Recursively update the modes of all files
         chmod_r('.bzr', 0664, 02775)
         check_mode_r(self, '.bzr', 0664, 02775)
-        b = Branch.open('.')
-        t = b.working_tree()
-        assertEqualMode(self, 02775, b._dir_mode)
-        assertEqualMode(self, 0664, b._file_mode)
+        t = WorkingTree.open('.')
+        b = t.branch
+        self.assertEqualMode(02775, b.control_files._dir_mode)
+        self.assertEqualMode(0664, b.control_files._file_mode)
 
         open('a', 'wb').write('foo4\n')
         t.commit('foo4')
@@ -153,65 +154,39 @@
     def test_disable_set_mode(self):
         # TODO: jam 20051215 Ultimately, this test should probably test that
         #                    extra chmod calls aren't being made
-        import bzrlib.branch
         try:
-            b = Branch.initialize(u'.')
-            self.assertNotEqual(None, b._dir_mode)
-            self.assertNotEqual(None, b._file_mode)
-
-            bzrlib.branch.BzrBranch._set_dir_mode = False
-            b = Branch.open(u'.')
-            self.assertEqual(None, b._dir_mode)
-            self.assertNotEqual(None, b._file_mode)
-
-            bzrlib.branch.BzrBranch._set_file_mode = False
-            b = Branch.open(u'.')
-            self.assertEqual(None, b._dir_mode)
-            self.assertEqual(None, b._file_mode)
-
-            bzrlib.branch.BzrBranch._set_dir_mode = True
-            b = Branch.open(u'.')
-            self.assertNotEqual(None, b._dir_mode)
-            self.assertEqual(None, b._file_mode)
-
-            bzrlib.branch.BzrBranch._set_file_mode = True
-            b = Branch.open(u'.')
-            self.assertNotEqual(None, b._dir_mode)
-            self.assertNotEqual(None, b._file_mode)
+            transport = get_transport(self.get_url())
+            transport.put('my-lock', StringIO(''))
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertNotEqual(None, lockable._dir_mode)
+            self.assertNotEqual(None, lockable._file_mode)
+
+            LockableFiles._set_dir_mode = False
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertEqual(None, lockable._dir_mode)
+            self.assertNotEqual(None, lockable._file_mode)
+
+            LockableFiles._set_file_mode = False
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertEqual(None, lockable._dir_mode)
+            self.assertEqual(None, lockable._file_mode)
+
+            LockableFiles._set_dir_mode = True
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertNotEqual(None, lockable._dir_mode)
+            self.assertEqual(None, lockable._file_mode)
+
+            LockableFiles._set_file_mode = True
+            transport = get_transport('.')
+            lockable = LockableFiles(transport, 'my-lock', TransportLock)
+            self.assertNotEqual(None, lockable._dir_mode)
+            self.assertNotEqual(None, lockable._file_mode)
         finally:
-            bzrlib.branch.BzrBranch._set_dir_mode = True
-            bzrlib.branch.BzrBranch._set_file_mode = True
-
-    def test_new_branch(self):
-        if sys.platform == 'win32':
-            raise TestSkipped('chmod has no effect on win32')
-
-        os.mkdir('a')
-        mode = stat.S_IMODE(os.stat('a').st_mode)
-        b = Branch.initialize('a')
-        assertEqualMode(self, mode, b._dir_mode)
-        assertEqualMode(self, mode & ~07111, b._file_mode)
-
-        os.mkdir('b')
-        os.chmod('b', 02777)
-        b = Branch.initialize('b')
-        assertEqualMode(self, 02777, b._dir_mode)
-        assertEqualMode(self, 00666, b._file_mode)
-        check_mode_r(self, 'b/.bzr', 00666, 02777)
-
-        os.mkdir('c')
-        os.chmod('c', 02750)
-        b = Branch.initialize('c')
-        assertEqualMode(self, 02750, b._dir_mode)
-        assertEqualMode(self, 00640, b._file_mode)
-        check_mode_r(self, 'c/.bzr', 00640, 02750)
-
-        os.mkdir('d')
-        os.chmod('d', 0700)
-        b = Branch.initialize('d')
-        assertEqualMode(self, 0700, b._dir_mode)
-        assertEqualMode(self, 0600, b._file_mode)
-        check_mode_r(self, 'd/.bzr', 00600, 0700)
+            LockableFiles._set_dir_mode = True
+            LockableFiles._set_file_mode = True
 
 
 class TestSftpPermissions(TestCaseWithSFTPServer):
@@ -222,35 +197,29 @@
         # Though it would be nice to test that SFTP to a server
         # which does support chmod has the right effect
 
-        from bzrlib.transport.sftp import SFTPTransport
-
-        # We don't actually use it directly, we just want to
-        # keep the connection open, since StubSFTPServer only
-        # allows 1 connection
-        self.delayed_setup()
-        _transport = SFTPTransport(self._sftp_url)
+        # bodge around for stubsftpserver not letting use connect
+        # more than once
+        _t = get_transport(self.get_url())
 
         os.mkdir('local')
-        b_local = Branch.initialize(u'local')
-        t_local = b_local.working_tree()
+        t_local = self.make_branch_and_tree('local')
+        b_local = t_local.branch
         open('local/a', 'wb').write('foo\n')
         t_local.add('a')
         t_local.commit('foo')
 
         # Delete them because we are modifying the filesystem underneath them
-        del b_local, t_local 
         chmod_r('local/.bzr', 0644, 0755)
         check_mode_r(self, 'local/.bzr', 0644, 0755)
 
-        b_local = Branch.open(u'local')
-        t_local = b_local.working_tree()
-        assertEqualMode(self, 0755, b_local._dir_mode)
-        assertEqualMode(self, 0644, b_local._file_mode)
+        t = WorkingTree.open('local')
+        b_local = t.branch
+        self.assertEqualMode(0755, b_local.control_files._dir_mode)
+        self.assertEqualMode(0644, b_local.control_files._file_mode)
 
         os.mkdir('sftp')
-        # Why does self._sftp_url end with a slash????
-        sftp_url = self._sftp_url + 'sftp'
-        b_sftp = Branch.initialize(sftp_url)
+        sftp_url = self.get_url('sftp')
+        b_sftp = BzrDir.create_branch_and_repo(sftp_url)
 
         b_sftp.pull(b_local)
         del b_sftp
@@ -258,8 +227,8 @@
         check_mode_r(self, 'sftp/.bzr', 0644, 0755)
 
         b_sftp = Branch.open(sftp_url)
-        assertEqualMode(self, 0755, b_sftp._dir_mode)
-        assertEqualMode(self, 0644, b_sftp._file_mode)
+        self.assertEqualMode(0755, b_sftp.control_files._dir_mode)
+        self.assertEqualMode(0644, b_sftp.control_files._file_mode)
 
         open('local/a', 'wb').write('foo2\n')
         t_local.commit('foo2')
@@ -279,8 +248,8 @@
         check_mode_r(self, 'sftp/.bzr', 0664, 0775)
 
         b_sftp = Branch.open(sftp_url)
-        assertEqualMode(self, 0775, b_sftp._dir_mode)
-        assertEqualMode(self, 0664, b_sftp._file_mode)
+        self.assertEqualMode(0775, b_sftp.control_files._dir_mode)
+        self.assertEqualMode(0664, b_sftp.control_files._file_mode)
 
         open('local/a', 'wb').write('foo3\n')
         t_local.commit('foo3')
@@ -301,23 +270,19 @@
         original_umask = os.umask(umask)
 
         try:
-            from bzrlib.transport.sftp import SFTPTransport
-            self.delayed_setup()
-            t = SFTPTransport(self._sftp_url)
+            t = get_transport(self.get_url())
             # Direct access should be masked by umask
             t._sftp_open_exclusive('a', mode=0666).write('foo\n')
-            check_mode(self, 'a', 0666 &~umask)
+            self.assertTransportMode(t, 'a', 0666 &~umask)
 
             # but Transport overrides umask
             t.put('b', 'txt', mode=0666)
-            check_mode(self, 'b', 0666)
+            self.assertTransportMode(t, 'b', 0666)
 
             t._sftp.mkdir('c', mode=0777)
-            check_mode(self, 'c', 0777 &~umask)
+            self.assertTransportMode(t, 'c', 0777 &~umask)
 
             t.mkdir('d', mode=0777)
-            check_mode(self, 'd', 0777)
+            self.assertTransportMode(t, 'd', 0777)
         finally:
             os.umask(original_umask)
-
-

=== added file 'bzrlib/tests/test_reconcile.py'
--- bzrlib/tests/test_reconcile.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_reconcile.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,47 @@
+# Copyright (C) 2006 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for reconiliation behaviour that is repository independent."""
+
+
+import bzrlib
+import bzrlib.errors as errors
+from bzrlib.reconcile import reconcile, Reconciler
+from bzrlib.revision import Revision
+from bzrlib.tests.repository_implementations.test_repository import TestCaseWithRepository
+from bzrlib.transport import get_transport
+from bzrlib.tree import EmptyTree
+from bzrlib.workingtree import WorkingTree
+
+
+class TestWorksWithSharedRepositories(TestCaseWithRepository):
+
+    def test_reweave_empty(self):
+        # we want a repo capable format
+        parent = bzrlib.bzrdir.BzrDirMetaFormat1().initialize('.')
+        parent.create_repository(shared=True)
+        parent.root_transport.mkdir('child')
+        child = bzrlib.bzrdir.BzrDirMetaFormat1().initialize('child')
+        self.assertRaises(errors.NoRepositoryPresent, child.open_repository)
+        reconciler = Reconciler(child)
+        reconciler.reconcile()
+        # smoke test for reconcile appears to work too.
+        reconcile(child)
+        # no inconsistent parents should have been found
+        # but the values should have been set.
+        self.assertEqual(0, reconciler.inconsistent_parents)
+        # and no garbage inventories
+        self.assertEqual(0, reconciler.garbage_inventories)

=== removed file 'bzrlib/tests/test_remove.py'
--- bzrlib/tests/test_remove.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_remove.py	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib.branch import Branch
-
-class TestRemove(TestCaseInTempDir):
-    def test_remove_verbose(self):
-        b = Branch.initialize(u'.')
-        self.build_tree(['hello'])
-        wt = b.working_tree() 
-        wt.add(['hello'])
-        wt.commit(message='add hello')
-        eq = self.assertEquals
-        wt.remove(['hello'], verbose=True)

=== added file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_repository.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,431 @@
+# (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for the Repository facility that are not interface tests.
+
+For interface tests see tests/repository_implementations/*.py.
+
+For concrete class tests see this file, and for storage formats tests
+also see this file.
+"""
+
+from stat import *
+from StringIO import StringIO
+
+import bzrlib
+import bzrlib.bzrdir as bzrdir
+import bzrlib.errors as errors
+from bzrlib.errors import (NotBranchError,
+                           NoSuchFile,
+                           UnknownFormatError,
+                           UnsupportedFormatError,
+                           )
+import bzrlib.repository as repository
+from bzrlib.tests import TestCase, TestCaseWithTransport
+from bzrlib.transport import get_transport
+from bzrlib.transport.http import HttpServer
+from bzrlib.transport.memory import MemoryServer
+
+
+class TestDefaultFormat(TestCase):
+
+    def test_get_set_default_format(self):
+        old_format = repository.RepositoryFormat.get_default_format()
+        # default is None - we cannot create a Repository independently yet
+        self.assertTrue(isinstance(old_format, repository.RepositoryFormat7))
+        repository.RepositoryFormat.set_default_format(SampleRepositoryFormat())
+        # creating a repository should now create an instrumented dir.
+        try:
+            # the default branch format is used by the meta dir format
+            # which is not the default bzrdir format at this point
+            dir = bzrdir.BzrDirMetaFormat1().initialize('memory:/')
+            result = dir.create_repository()
+            self.assertEqual(result, 'A bzr repository dir')
+        finally:
+            repository.RepositoryFormat.set_default_format(old_format)
+        self.assertEqual(old_format, repository.RepositoryFormat.get_default_format())
+
+
+class SampleRepositoryFormat(repository.RepositoryFormat):
+    """A sample format
+
+    this format is initializable, unsupported to aid in testing the 
+    open and open(unsupported=True) routines.
+    """
+
+    def get_format_string(self):
+        """See RepositoryFormat.get_format_string()."""
+        return "Sample .bzr repository format."
+
+    def initialize(self, a_bzrdir, shared=False):
+        """Initialize a repository in a BzrDir"""
+        t = a_bzrdir.get_repository_transport(self)
+        t.put('format', StringIO(self.get_format_string()))
+        return 'A bzr repository dir'
+
+    def is_supported(self):
+        return False
+
+    def open(self, a_bzrdir, _found=False):
+        return "opened repository."
+
+
+class TestRepositoryFormat(TestCaseWithTransport):
+    """Tests for the Repository format detection used by the bzr meta dir facility.BzrBranchFormat facility."""
+
+    def test_find_format(self):
+        # is the right format object found for a repository?
+        # create a branch with a few known format objects.
+        # this is not quite the same as 
+        self.build_tree(["foo/", "bar/"])
+        def check_format(format, url):
+            dir = format._matchingbzrdir.initialize(url)
+            format.initialize(dir)
+            t = get_transport(url)
+            found_format = repository.RepositoryFormat.find_format(dir)
+            self.failUnless(isinstance(found_format, format.__class__))
+        check_format(repository.RepositoryFormat7(), "bar")
+        
+    def test_find_format_no_repository(self):
+        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        self.assertRaises(errors.NoRepositoryPresent,
+                          repository.RepositoryFormat.find_format,
+                          dir)
+
+    def test_find_format_unknown_format(self):
+        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        SampleRepositoryFormat().initialize(dir)
+        self.assertRaises(UnknownFormatError,
+                          repository.RepositoryFormat.find_format,
+                          dir)
+
+    def test_register_unregister_format(self):
+        format = SampleRepositoryFormat()
+        # make a control dir
+        dir = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        # make a repo
+        format.initialize(dir)
+        # register a format for it.
+        repository.RepositoryFormat.register_format(format)
+        # which repository.Open will refuse (not supported)
+        self.assertRaises(UnsupportedFormatError, repository.Repository.open, self.get_url())
+        # but open(unsupported) will work
+        self.assertEqual(format.open(dir), "opened repository.")
+        # unregister the format
+        repository.RepositoryFormat.unregister_format(format)
+
+
+class TestFormat6(TestCaseWithTransport):
+
+    def test_no_ancestry_weave(self):
+        control = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        repo = repository.RepositoryFormat6().initialize(control)
+        # We no longer need to create the ancestry.weave file
+        # since it is *never* used.
+        self.assertRaises(NoSuchFile,
+                          control.transport.get,
+                          'ancestry.weave')
+
+
+class TestFormat7(TestCaseWithTransport):
+    
+    def test_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormat7().initialize(control)
+        # in case of side effects of locking.
+        repo.lock_write()
+        repo.unlock()
+        # we want:
+        # format 'Bazaar-NG Repository format 7'
+        # lock ''
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Repository format 7',
+                             t.get('format').read())
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('weaves').st_mode))
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+
+    def test_shared_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormat7().initialize(control, shared=True)
+        # we want:
+        # format 'Bazaar-NG Repository format 7'
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        # a 'shared-storage' marker file.
+        # lock is not present when unlocked
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Repository format 7',
+                             t.get('format').read())
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('weaves').st_mode))
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+        self.assertFalse(t.has('branch-lock'))
+
+    def test_creates_lockdir(self):
+        """Make sure it appears to be controlled by a LockDir existence"""
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormat7().initialize(control, shared=True)
+        t = control.get_repository_transport(None)
+        # TODO: Should check there is a 'lock' toplevel directory, 
+        # regardless of contents
+        self.assertFalse(t.has('lock/held/info'))
+        repo.lock_write()
+        self.assertTrue(t.has('lock/held/info'))
+
+    def test_uses_lockdir(self):
+        """repo format 7 actually locks on lockdir"""
+        base_url = self.get_url()
+        control = bzrdir.BzrDirMetaFormat1().initialize(base_url)
+        repo = repository.RepositoryFormat7().initialize(control, shared=True)
+        t = control.get_repository_transport(None)
+        repo.lock_write()
+        repo.unlock()
+        del repo
+        # make sure the same lock is created by opening it
+        repo = repository.Repository.open(base_url)
+        repo.lock_write()
+        self.assertTrue(t.has('lock/held/info'))
+        repo.unlock()
+        self.assertFalse(t.has('lock/held/info'))
+
+    def test_shared_no_tree_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormat7().initialize(control, shared=True)
+        repo.set_make_working_trees(False)
+        # we want:
+        # format 'Bazaar-NG Repository format 7'
+        # lock ''
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        # a 'shared-storage' marker file.
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Repository format 7',
+                             t.get('format').read())
+        ## self.assertEqualDiff('', t.get('lock').read())
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        self.assertEqualDiff('', t.get('no-working-trees').read())
+        repo.set_make_working_trees(True)
+        self.assertFalse(t.has('no-working-trees'))
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('weaves').st_mode))
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+
+
+class TestFormatKnit1(TestCaseWithTransport):
+    
+    def test_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormatKnit1().initialize(control)
+        # in case of side effects of locking.
+        repo.lock_write()
+        repo.unlock()
+        # we want:
+        # format 'Bazaar-NG Knit Repository Format 1'
+        # lock: is a directory
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Knit Repository Format 1',
+                             t.get('format').read())
+        # XXX: no locks left when unlocked at the moment
+        # self.assertEqualDiff('', t.get('lock').read())
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('knits').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('lock').st_mode))
+        # cheating and using a weave for now.
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+
+    def test_shared_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormatKnit1().initialize(control, shared=True)
+        # we want:
+        # format 'Bazaar-NG Knit Repository Format 1'
+        # lock: is a directory
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        # a 'shared-storage' marker file.
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Knit Repository Format 1',
+                             t.get('format').read())
+        # XXX: no locks left when unlocked at the moment
+        # self.assertEqualDiff('', t.get('lock').read())
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('knits').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('lock').st_mode))
+        # cheating and using a weave for now.
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+
+    def test_shared_no_tree_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = repository.RepositoryFormatKnit1().initialize(control, shared=True)
+        repo.set_make_working_trees(False)
+        # we want:
+        # format 'Bazaar-NG Knit Repository Format 1'
+        # lock ''
+        # inventory.weave == empty_weave
+        # empty revision-store directory
+        # empty weaves directory
+        # a 'shared-storage' marker file.
+        t = control.get_repository_transport(None)
+        self.assertEqualDiff('Bazaar-NG Knit Repository Format 1',
+                             t.get('format').read())
+        # XXX: no locks left when unlocked at the moment
+        # self.assertEqualDiff('', t.get('lock').read())
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        self.assertEqualDiff('', t.get('no-working-trees').read())
+        repo.set_make_working_trees(True)
+        self.assertFalse(t.has('no-working-trees'))
+        self.assertTrue(S_ISDIR(t.stat('revision-store').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('knits').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('lock').st_mode))
+        # cheating and using a weave for now.
+        self.assertEqualDiff('# bzr weave file v5\n'
+                             'w\n'
+                             'W\n',
+                             t.get('inventory.weave').read())
+
+
+class InterString(repository.InterRepository):
+    """An inter-repository optimised code path for strings.
+
+    This is for use during testing where we use strings as repositories
+    so that none of the default regsitered inter-repository classes will
+    match.
+    """
+
+    @staticmethod
+    def is_compatible(repo_source, repo_target):
+        """InterString is compatible with strings-as-repos."""
+        return isinstance(repo_source, str) and isinstance(repo_target, str)
+
+
+class TestInterRepository(TestCaseWithTransport):
+
+    def test_get_default_inter_repository(self):
+        # test that the InterRepository.get(repo_a, repo_b) probes
+        # for a inter_repo class where is_compatible(repo_a, repo_b) returns
+        # true and returns a default inter_repo otherwise.
+        # This also tests that the default registered optimised interrepository
+        # classes do not barf inappropriately when a surprising repository type
+        # is handed to them.
+        dummy_a = "Repository 1."
+        dummy_b = "Repository 2."
+        self.assertGetsDefaultInterRepository(dummy_a, dummy_b)
+
+    def assertGetsDefaultInterRepository(self, repo_a, repo_b):
+        """Asserts that InterRepository.get(repo_a, repo_b) -> the default."""
+        inter_repo = repository.InterRepository.get(repo_a, repo_b)
+        self.assertEqual(repository.InterRepository,
+                         inter_repo.__class__)
+        self.assertEqual(repo_a, inter_repo.source)
+        self.assertEqual(repo_b, inter_repo.target)
+
+    def test_register_inter_repository_class(self):
+        # test that a optimised code path provider - a
+        # InterRepository subclass can be registered and unregistered
+        # and that it is correctly selected when given a repository
+        # pair that it returns true on for the is_compatible static method
+        # check
+        dummy_a = "Repository 1."
+        dummy_b = "Repository 2."
+        repository.InterRepository.register_optimiser(InterString)
+        try:
+            # we should get the default for something InterString returns False
+            # to
+            self.assertFalse(InterString.is_compatible(dummy_a, None))
+            self.assertGetsDefaultInterRepository(dummy_a, None)
+            # and we should get an InterString for a pair it 'likes'
+            self.assertTrue(InterString.is_compatible(dummy_a, dummy_b))
+            inter_repo = repository.InterRepository.get(dummy_a, dummy_b)
+            self.assertEqual(InterString, inter_repo.__class__)
+            self.assertEqual(dummy_a, inter_repo.source)
+            self.assertEqual(dummy_b, inter_repo.target)
+        finally:
+            repository.InterRepository.unregister_optimiser(InterString)
+        # now we should get the default InterRepository object again.
+        self.assertGetsDefaultInterRepository(dummy_a, dummy_b)
+
+
+class TestInterWeaveRepo(TestCaseWithTransport):
+
+    def test_is_compatible_and_registered(self):
+        # InterWeaveRepo is compatible when either side
+        # is a format 5/6/7 branch
+        formats = [repository.RepositoryFormat5(),
+                   repository.RepositoryFormat6(),
+                   repository.RepositoryFormat7()]
+        incompatible_formats = [repository.RepositoryFormat4(),
+                                repository.RepositoryFormatKnit1(),
+                                ]
+        repo_a = self.make_repository('a')
+        repo_b = self.make_repository('b')
+        is_compatible = repository.InterWeaveRepo.is_compatible
+        for source in incompatible_formats:
+            # force incompatible left then right
+            repo_a._format = source
+            repo_b._format = formats[0]
+            self.assertFalse(is_compatible(repo_a, repo_b))
+            self.assertFalse(is_compatible(repo_b, repo_a))
+        for source in formats:
+            repo_a._format = source
+            for target in formats:
+                repo_b._format = target
+                self.assertTrue(is_compatible(repo_a, repo_b))
+        self.assertEqual(repository.InterWeaveRepo,
+                         repository.InterRepository.get(repo_a,
+                                                        repo_b).__class__)
+
+
+class TestRepositoryConverter(TestCaseWithTransport):
+
+    def test_convert_empty(self):
+        t = get_transport(self.get_url('.'))
+        t.mkdir('repository')
+        repo_dir = bzrdir.BzrDirMetaFormat1().initialize('repository')
+        repo = repository.RepositoryFormat7().initialize(repo_dir)
+        target_format = repository.RepositoryFormatKnit1()
+        pb = bzrlib.ui.ui_factory.progress_bar()
+
+        converter = repository.CopyConverter(target_format)
+        converter.convert(repo, pb)
+        repo = repo_dir.open_repository()
+        self.assertTrue(isinstance(target_format, repo._format.__class__))
+

=== modified file 'bzrlib/tests/test_revision.py'
--- bzrlib/tests/test_revision.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_revision.py	2006-03-20 08:31:00 +0000
@@ -17,14 +17,14 @@
 
 import os
 
-from bzrlib.tests import TestCaseInTempDir
 from bzrlib.branch import Branch
+from bzrlib.errors import NoSuchRevision
 from bzrlib.commit import commit
-from bzrlib.fetch import fetch
 from bzrlib.revision import (find_present_ancestors, combined_graph,
                              is_ancestor, MultipleRevisionSources)
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.trace import mutter
-from bzrlib.errors import NoSuchRevision
+from bzrlib.workingtree import WorkingTree
 
 # XXX: Make this a method of a merge base case
 def make_branches(self):
@@ -48,39 +48,40 @@
     so A is missing b6 at the start
     and B is missing a3, a4, a5
     """
-    os.mkdir("branch1")
-    br1 = Branch.initialize("branch1")
+    tree1 = self.make_branch_and_tree("branch1")
+    br1 = tree1.branch
     
-    commit(br1, "Commit one", rev_id="a@u-0-0")
-    commit(br1, "Commit two", rev_id="a@u-0-1")
-    commit(br1, "Commit three", rev_id="a@u-0-2")
+    tree1.commit("Commit one", rev_id="a@u-0-0")
+    tree1.commit("Commit two", rev_id="a@u-0-1")
+    tree1.commit("Commit three", rev_id="a@u-0-2")
 
-    os.mkdir("branch2")
-    br2 = Branch.initialize("branch2")
+    tree2 = self.make_branch_and_tree("branch2")
+    br2 = tree2.branch
     br2.update_revisions(br1)
-    commit(br2, "Commit four", rev_id="b@u-0-3")
-    commit(br2, "Commit five", rev_id="b@u-0-4")
+    tree2.commit("Commit four", rev_id="b@u-0-3")
+    tree2.commit("Commit five", rev_id="b@u-0-4")
     revisions_2 = br2.revision_history()
     
-    fetch(from_branch=br2, to_branch=br1)
-    br1.working_tree().add_pending_merge(revisions_2[4])
+    br1.fetch(br2)
+    tree1.add_pending_merge(revisions_2[4])
     self.assertEquals(revisions_2[4], 'b@u-0-4')
-    commit(br1, "Commit six", rev_id="a@u-0-3")
-    commit(br1, "Commit seven", rev_id="a@u-0-4")
-    commit(br2, "Commit eight", rev_id="b@u-0-5")
+    tree1.commit("Commit six", rev_id="a@u-0-3")
+    tree1.commit("Commit seven", rev_id="a@u-0-4")
+    tree2.commit("Commit eight", rev_id="b@u-0-5")
     
-    fetch(from_branch=br2, to_branch=br1)
-    br1.working_tree().add_pending_merge(br2.revision_history()[5])
-    commit(br1, "Commit nine", rev_id="a@u-0-5")
+    br1.fetch(br2)
+    tree1.add_pending_merge(br2.revision_history()[5])
+    tree1.commit("Commit nine", rev_id="a@u-0-5")
     # DO NOT FETCH HERE - we WANT a GHOST.
-    #fetch(from_branch=br1, to_branch=br2)
-    br2.working_tree().add_pending_merge(br1.revision_history()[4])
-    commit(br2, "Commit ten - ghost merge", rev_id="b@u-0-6")
+    # br2.fetch(br1)
+    tree2.add_pending_merge(br1.revision_history()[4])
+    tree2.commit("Commit ten - ghost merge", rev_id="b@u-0-6")
     
     return br1, br2
 
 
-class TestIsAncestor(TestCaseInTempDir):
+class TestIsAncestor(TestCaseWithTransport):
+
     def test_recorded_ancestry(self):
         """Test that commit records all ancestors"""
         br1, br2 = make_branches(self)
@@ -112,9 +113,9 @@
                 if rev_id in br2_only and not branch is br2:
                     continue
                 mutter('ancestry of {%s}: %r',
-                       rev_id, branch.get_ancestry(rev_id))
-                self.assertEquals(sorted(branch.get_ancestry(rev_id)),
-                                  [None] + sorted(anc))
+                       rev_id, branch.repository.get_ancestry(rev_id))
+                result = sorted(branch.repository.get_ancestry(rev_id))
+                self.assertEquals(result, [None] + sorted(anc))
     
     
     def test_is_ancestor(self):
@@ -137,27 +138,29 @@
         ## self.assert_(not is_ancestor(revisions[3], revisions_2[3], br1))
 
 
-class TestIntermediateRevisions(TestCaseInTempDir):
+class TestIntermediateRevisions(TestCaseWithTransport):
 
     def setUp(self):
         from bzrlib.commit import commit
-        TestCaseInTempDir.setUp(self)
+        TestCaseWithTransport.setUp(self)
         self.br1, self.br2 = make_branches(self)
-
-        self.br2.working_tree().commit("Commit eleven", rev_id="b@u-0-7")
-        self.br2.working_tree().commit("Commit twelve", rev_id="b@u-0-8")
-        self.br2.working_tree().commit("Commit thirtteen", rev_id="b@u-0-9")
-
-        fetch(from_branch=self.br2, to_branch=self.br1)
-        self.br1.working_tree().add_pending_merge(self.br2.revision_history()[6])
-        self.br1.working_tree().commit("Commit fourtten", rev_id="a@u-0-6")
-
-        fetch(from_branch=self.br1, to_branch=self.br2)
-        self.br2.working_tree().add_pending_merge(self.br1.revision_history()[6])
-        self.br2.working_tree().commit("Commit fifteen", rev_id="b@u-0-10")
+        wt1 = self.br1.bzrdir.open_workingtree()
+        wt2 = self.br2.bzrdir.open_workingtree()
+        wt2.commit("Commit eleven", rev_id="b@u-0-7")
+        wt2.commit("Commit twelve", rev_id="b@u-0-8")
+        wt2.commit("Commit thirtteen", rev_id="b@u-0-9")
+
+        self.br1.fetch(self.br2)
+        wt1.add_pending_merge(self.br2.revision_history()[6])
+        wt1.commit("Commit fourtten", rev_id="a@u-0-6")
+
+        self.br2.fetch(self.br1)
+        wt2.add_pending_merge(self.br1.revision_history()[6])
+        wt2.commit("Commit fifteen", rev_id="b@u-0-10")
 
         from bzrlib.revision import MultipleRevisionSources
-        self.sources = MultipleRevisionSources(self.br1, self.br2)
+        self.sources = MultipleRevisionSources(self.br1.repository,
+                                               self.br2.repository)
 
     def intervene(self, ancestor, revision, revision_history=None):
         from bzrlib.revision import get_intervening_revisions
@@ -205,55 +208,16 @@
                           'c@u-0-6', self.br2.revision_history())
 
 
-class TestCommonAncestor(TestCaseInTempDir):
+class TestCommonAncestor(TestCaseWithTransport):
     """Test checking whether a revision is an ancestor of another revision"""
 
-    def test_old_common_ancestor(self):
-        """Pick a resonable merge base using the old functionality"""
-        from bzrlib.revision import old_common_ancestor as common_ancestor
-        br1, br2 = make_branches(self)
-        revisions = br1.revision_history()
-        revisions_2 = br2.revision_history()
-        sources = br1
-
-        expected_ancestors_list = {revisions[3]:(0, 0), 
-                                   revisions[2]:(1, 1),
-                                   revisions_2[4]:(2, 1), 
-                                   revisions[1]:(3, 2),
-                                   revisions_2[3]:(4, 2),
-                                   revisions[0]:(5, 3) }
-        ancestors_list = find_present_ancestors(revisions[3], sources)
-        self.assertEquals(len(expected_ancestors_list), len(ancestors_list))
-        for key, value in expected_ancestors_list.iteritems():
-            self.assertEqual(ancestors_list[key], value, 
-                              "key %r, %r != %r" % (key, ancestors_list[key],
-                                                    value))
-
-        self.assertEqual(common_ancestor(revisions[0], revisions[0], sources),
-                          revisions[0])
-        self.assertEqual(common_ancestor(revisions[1], revisions[2], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[1], revisions[1], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[2], revisions_2[4], sources),
-                          revisions[2])
-        self.assertEqual(common_ancestor(revisions[3], revisions_2[4], sources),
-                          revisions_2[4])
-        self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
-                          revisions_2[4])
-        fetch(from_branch=br2, to_branch=br1)
-        self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions[4]) # revisions_2[5] is equally valid
-        self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
-                          revisions_2[5])
-
     def test_common_ancestor(self):
         """Pick a reasonable merge base"""
         from bzrlib.revision import common_ancestor
         br1, br2 = make_branches(self)
         revisions = br1.revision_history()
         revisions_2 = br2.revision_history()
-        sources = MultipleRevisionSources(br1, br2)
+        sources = MultipleRevisionSources(br1.repository, br2.repository)
         expected_ancestors_list = {revisions[3]:(0, 0), 
                                    revisions[2]:(1, 1),
                                    revisions_2[4]:(2, 1), 
@@ -278,17 +242,18 @@
                           revisions_2[4])
         self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
                           revisions_2[4])
-        self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions[4]) # revisions_2[5] is equally valid
-        self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
-                          revisions[4]) # revisions_2[5] is equally valid
+        self.assertTrue(common_ancestor(revisions[5], revisions_2[6], sources) in
+                        (revisions[4], revisions_2[5]))
+        self.assertTrue(common_ancestor(revisions_2[6], revisions[5], sources),
+                        (revisions[4], revisions_2[5]))
+        self.assertEqual(None, common_ancestor(None, revisions[5], sources))
 
     def test_combined(self):
         """combined_graph
         Ensure it's not order-sensitive
         """
         br1, br2 = make_branches(self)
-        source = MultipleRevisionSources(br1, br2)
+        source = MultipleRevisionSources(br1.repository, br2.repository)
         combined_1 = combined_graph(br1.last_revision(), 
                                     br2.last_revision(), source)
         combined_2 = combined_graph(br2.last_revision(),
@@ -297,3 +262,22 @@
         self.assertEquals(combined_1[2], combined_2[2])
         self.assertEquals(combined_1[3], combined_2[3])
         self.assertEquals(combined_1, combined_2)
+
+    def test_get_history(self):
+        # TODO: test ghosts on the left hand branch's impact
+        # TODO: test ghosts on all parents, we should get some
+        # indicator. i.e. NULL_REVISION
+        # RBC 20060608
+        tree = self.make_branch_and_tree('.')
+        tree.commit('1', rev_id = '1', allow_pointless=True)
+        tree.commit('2', rev_id = '2', allow_pointless=True)
+        tree.commit('3', rev_id = '3', allow_pointless=True)
+        rev = tree.branch.repository.get_revision('1')
+        history = rev.get_history(tree.branch.repository)
+        self.assertEqual([None, '1'], history)
+        rev = tree.branch.repository.get_revision('2')
+        history = rev.get_history(tree.branch.repository)
+        self.assertEqual([None, '1', '2'], history)
+        rev = tree.branch.repository.get_revision('3')
+        history = rev.get_history(tree.branch.repository)
+        self.assertEqual([None, '1', '2' ,'3'], history)

=== modified file 'bzrlib/tests/test_revisionnamespaces.py'
--- bzrlib/tests/test_revisionnamespaces.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_revisionnamespaces.py	2006-03-20 08:31:00 +0000
@@ -17,26 +17,26 @@
 import os
 import time
 
+from bzrlib.builtins import merge
 from bzrlib.branch import Branch
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.errors import NoCommonAncestor, NoCommits
 from bzrlib.errors import NoSuchRevision
-from bzrlib.clone import copy_branch
-from bzrlib.merge import merge
 from bzrlib.revisionspec import RevisionSpec
 
-class TestRevisionNamespaces(TestCaseInTempDir):
+
+class TestRevisionNamespaces(TestCaseWithTransport):
 
     def test_revision_namespaces(self):
         """Test revision specifiers.
 
         These identify revisions by date, etc."""
-
-        b = Branch.initialize(u'.')
-
-        b.working_tree().commit('Commit one', rev_id='a@r-0-1', timestamp=time.time() - 60*60*24)
-        b.working_tree().commit('Commit two', rev_id='a@r-0-2')
-        b.working_tree().commit('Commit three', rev_id='a@r-0-3')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+
+        wt.commit('Commit one', rev_id='a@r-0-1', timestamp=time.time() - 60*60*24)
+        wt.commit('Commit two', rev_id='a@r-0-2')
+        wt.commit('Commit three', rev_id='a@r-0-3')
 
         self.assertEquals(RevisionSpec(None).in_history(b), (0, None))
         self.assertEquals(RevisionSpec(1).in_history(b), (1, 'a@r-0-1'))
@@ -65,16 +65,18 @@
                           'a@r-0-3')
 
         os.mkdir('newbranch')
-        b2 = Branch.initialize('newbranch')
+        wt2 = self.make_branch_and_tree('newbranch')
+        b2 = wt2.branch
         self.assertRaises(NoCommits, RevisionSpec('ancestor:.').in_history, b2)
 
-        os.mkdir('copy')
-        b3 = copy_branch(b, 'copy')
-        b3.working_tree().commit('Commit four', rev_id='b@r-0-4')
+        d3 = b.bzrdir.sprout('copy')
+        b3 = d3.open_branch()
+        wt3 = d3.open_workingtree()
+        wt3.commit('Commit four', rev_id='b@r-0-4')
         self.assertEquals(RevisionSpec('ancestor:.').in_history(b3).rev_id,
                           'a@r-0-3')
         merge(['copy', -1], [None, None])
-        b.working_tree().commit('Commit five', rev_id='a@r-0-4')
+        wt.commit('Commit five', rev_id='a@r-0-4')
         self.assertEquals(RevisionSpec('ancestor:copy').in_history(b).rev_id,
                           'b@r-0-4')
         self.assertEquals(RevisionSpec('ancestor:.').in_history(b3).rev_id,
@@ -87,13 +89,14 @@
     def test_branch_namespace(self):
         """Ensure that the branch namespace pulls in the requisite content."""
         self.build_tree(['branch1/', 'branch1/file', 'branch2/'])
-        branch = Branch.initialize('branch1')
-        branch.working_tree().add(['file'])
-        branch.working_tree().commit('add file')
-        copy_branch(branch, 'branch2')
+        wt = self.make_branch_and_tree('branch1')
+        branch = wt.branch
+        wt.add(['file'])
+        wt.commit('add file')
+        d2 = branch.bzrdir.sprout('branch2')
         print >> open('branch2/file', 'w'), 'new content'
-        branch2 = Branch.open('branch2')
-        branch2.working_tree().commit('update file', rev_id='A')
+        branch2 = d2.open_branch()
+        d2.open_workingtree().commit('update file', rev_id='A')
         spec = RevisionSpec('branch:./branch2/.bzr/../')
         rev_info = spec.in_history(branch)
         self.assertEqual(rev_info, (None, 'A'))

=== modified file 'bzrlib/tests/test_revprops.py'
--- bzrlib/tests/test_revprops.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_revprops.py	2006-03-20 08:31:00 +0000
@@ -2,21 +2,22 @@
 
 """Tests for revision properties."""
 
-from bzrlib.branch import Branch
-from bzrlib.tests import TestCaseInTempDir
-
-class TestRevProps(TestCaseInTempDir):
+from bzrlib.tests import TestCaseWithTransport
+
+class TestRevProps(TestCaseWithTransport):
+
     def test_simple_revprops(self):
         """Simple revision properties"""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         b.nick = 'Nicholas'
         props = dict(flavor='choc-mint', 
                      condiment='orange\n  mint\n\tcandy')
-        b.working_tree().commit(message='initial null commit', 
+        wt.commit(message='initial null commit', 
                  revprops=props,
                  allow_pointless=True,
                  rev_id='test@user-1')
-        rev = b.get_revision('test@user-1')
+        rev = b.repository.get_revision('test@user-1')
         self.assertTrue('flavor' in rev.properties)
         self.assertEquals(rev.properties['flavor'], 'choc-mint')
         self.assertEquals(sorted(rev.properties.items()),
@@ -26,12 +27,13 @@
 
     def test_invalid_revprops(self):
         """Invalid revision properties"""
-        b = Branch.initialize(u'.')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
         self.assertRaises(ValueError,
-                          b.working_tree().commit, 
+                          wt.commit, 
                           message='invalid',
                           revprops={'what a silly property': 'fine'})
         self.assertRaises(ValueError,
-                          b.working_tree().commit, 
+                          wt.commit, 
                           message='invalid',
                           revprops=dict(number=13))

=== modified file 'bzrlib/tests/test_rio.py'
--- bzrlib/tests/test_rio.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_rio.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 by Canonical Ltd
+# Copyright (C) 2005, 2006 by Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,6 +22,7 @@
 but this depends on the transport.
 """
 
+import cStringIO
 import os
 import sys
 from tempfile import TemporaryFile
@@ -64,6 +65,12 @@
                 ['name: fred\n',
                  'number: 42\n'])
 
+    def test_as_dict(self):
+        """Convert rio Stanza to dictionary"""
+        s = Stanza(number='42', name='fred')
+        sd = s.as_dict()
+        self.assertEquals(sd, dict(number='42', name='fred'))
+
     def test_to_file(self):
         """Write rio to file"""
         tmpf = TemporaryFile()
@@ -280,3 +287,26 @@
         """Write empty stanza"""
         l = list(Stanza().to_lines())
         self.assertEquals(l, [])
+
+    def test_rio_raises_type_error(self):
+        """TypeError on adding invalid type to Stanza"""
+        s = Stanza()
+        self.assertRaises(TypeError, s.add, 'foo', {})
+
+    def test_rio_raises_type_error_key(self):
+        """TypeError on adding invalid type to Stanza"""
+        s = Stanza()
+        self.assertRaises(TypeError, s.add, 10, {})
+
+    def test_rio_unicode(self):
+        # intentionally use cStringIO which doesn't accomodate unencoded unicode objects
+        sio = cStringIO.StringIO()
+        uni_data = u'\N{KATAKANA LETTER O}'
+        s = Stanza(foo=uni_data)
+        self.assertEquals(s.get('foo'), uni_data)
+        raw_lines = s.to_lines()
+        self.assertEquals(raw_lines,
+                ['foo: ' + uni_data.encode('utf-8') + '\n'])
+        new_s = read_stanza(raw_lines)
+        self.assertEquals(new_s.get('foo'), uni_data)
+

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_selftest.py	2006-03-20 08:31:00 +0000
@@ -19,14 +19,19 @@
 import os
 import sys
 import unittest
+import warnings
 
+import bzrlib
 from bzrlib.tests import (
                           _load_module_by_name,
+                          ChrootedTestCase,
                           TestCase,
                           TestCaseInTempDir,
+                          TestCaseWithTransport,
                           TestSkipped,
                           TextTestRunner,
                           )
+import bzrlib.errors as errors
 
 
 class SelftestTests(TestCase):
@@ -64,6 +69,7 @@
 
 class TestSkippedTest(TestCase):
     """Try running a test which is skipped, make sure it's reported properly."""
+
     def test_skipped_test(self):
         # must be hidden in here so it's not run as a real test
         def skipping_test():
@@ -72,3 +78,327 @@
         test = unittest.FunctionTestCase(skipping_test)
         result = runner.run(test)
         self.assertTrue(result.wasSuccessful())
+
+
+class TestTransportProviderAdapter(TestCase):
+    """A group of tests that test the transport implementation adaption core.
+
+    This is a meta test that the tests are applied to all available 
+    transports.
+
+    This will be generalised in the future which is why it is in this 
+    test file even though it is specific to transport tests at the moment.
+    """
+
+    def test_get_transport_permutations(self):
+        # this checks that we the module get_test_permutations call
+        # is made by the adapter get_transport_test_permitations method.
+        class MockModule(object):
+            def get_test_permutations(self):
+                return sample_permutation
+        sample_permutation = [(1,2), (3,4)]
+        from bzrlib.transport import TransportTestProviderAdapter
+        adapter = TransportTestProviderAdapter()
+        self.assertEqual(sample_permutation,
+                         adapter.get_transport_test_permutations(MockModule()))
+
+    def test_adapter_checks_all_modules(self):
+        # this checks that the adapter returns as many permurtations as
+        # there are in all the registered# transport modules for there
+        # - we assume if this matches its probably doing the right thing
+        # especially in combination with the tests for setting the right
+        # classes below.
+        from bzrlib.transport import (TransportTestProviderAdapter,
+                                      _get_transport_modules
+                                      )
+        modules = _get_transport_modules()
+        permutation_count = 0
+        for module in modules:
+            try:
+                permutation_count += len(reduce(getattr, 
+                    (module + ".get_test_permutations").split('.')[1:],
+                     __import__(module))())
+            except errors.DependencyNotPresent:
+                pass
+        input_test = TestTransportProviderAdapter(
+            "test_adapter_sets_transport_class")
+        adapter = TransportTestProviderAdapter()
+        self.assertEqual(permutation_count,
+                         len(list(iter(adapter.adapt(input_test)))))
+
+    def test_adapter_sets_transport_class(self):
+        # when the adapter adapts a test it needs to 
+        # place one of the permutations from the transport
+        # providers in each test case copy. This checks
+        # that it does not just use the same one all the time.
+        # and that the id is set correctly so that debugging is
+        # easy.
+        # 
+        # An instance of this test is actually used as the input
+        # for adapting it to all the available transports
+        # (or i think so - ??? mbp)
+        from bzrlib.transport.local import (LocalTransport,
+                                            LocalRelpathServer,
+                                            LocalAbspathServer,
+                                            LocalURLServer
+                                            )
+        try:
+            from bzrlib.transport.sftp import (SFTPTransport,
+                                               SFTPAbsoluteServer,
+                                               SFTPHomeDirServer,
+                                               SFTPSiblingAbsoluteServer,
+                                               )
+        except errors.ParamikoNotPresent, e:
+            warnings.warn(str(e))
+            has_paramiko = False
+        else:
+            has_paramiko = True
+        from bzrlib.transport.http import (HttpTransport,
+                                           HttpServer
+                                           )
+        from bzrlib.transport.ftp import FtpTransport
+        from bzrlib.transport.memory import (MemoryTransport,
+                                             MemoryServer
+                                             )
+        from bzrlib.transport import TransportTestProviderAdapter
+        # FIXME. What we want is a factory for the things
+        # needed to test the implementation. I.e. for transport we want:
+        # the class that connections should get; a local server factory
+        # so we would want the following permutations:
+        # LocalTransport relpath-factory
+        # LocalTransport abspath-factory
+        # LocalTransport file://-factory
+        # SFTPTransport homedir-factory
+        # SFTPTransport abssolute-factory
+        # HTTPTransport http-factory
+        # HTTPTransport https-factory
+        # etc, but we are currently lacking in this, so print out that
+        # this should be fixed.
+        input_test = TestTransportProviderAdapter(
+            "test_adapter_sets_transport_class")
+        suite = TransportTestProviderAdapter().adapt(input_test)
+        # tests are generated in collation order. 
+        # XXX: but i'm not sure the order should really be part of the 
+        # contract of the adapter, should it -- mbp 20060201
+        test_iter = iter(suite)
+        http_test = test_iter.next()
+        local_relpath_test = test_iter.next()
+        local_abspath_test = test_iter.next()
+        local_urlpath_test = test_iter.next()
+        memory_test = test_iter.next()
+        readonly_test = test_iter.next()
+        if has_paramiko:
+            sftp_abs_test = test_iter.next()
+            sftp_homedir_test = test_iter.next()
+            sftp_sibling_abs_test = test_iter.next()
+        # ftp_test = test_iter.next()
+        # should now be at the end of the test
+        self.assertRaises(StopIteration, test_iter.next)
+        self.assertEqual(LocalTransport, local_relpath_test.transport_class)
+        self.assertEqual(LocalRelpathServer, local_relpath_test.transport_server)
+        
+        self.assertEqual(LocalTransport, local_abspath_test.transport_class)
+        self.assertEqual(LocalAbspathServer, local_abspath_test.transport_server)
+
+        self.assertEqual(LocalTransport, local_urlpath_test.transport_class)
+        self.assertEqual(LocalURLServer, local_urlpath_test.transport_server)
+
+        if has_paramiko:
+            self.assertEqual(SFTPTransport, sftp_abs_test.transport_class)
+            self.assertEqual(SFTPAbsoluteServer, sftp_abs_test.transport_server)
+            self.assertEqual(SFTPTransport, sftp_homedir_test.transport_class)
+            self.assertEqual(SFTPHomeDirServer, sftp_homedir_test.transport_server)
+            self.assertEqual(SFTPTransport, sftp_sibling_abs_test.transport_class)
+            self.assertEqual(SFTPSiblingAbsoluteServer,
+                             sftp_sibling_abs_test.transport_server)
+
+        self.assertEqual(HttpTransport, http_test.transport_class)
+        self.assertEqual(HttpServer, http_test.transport_server)
+        # self.assertEqual(FtpTransport, ftp_test.transport_class)
+
+        self.assertEqual(MemoryTransport, memory_test.transport_class)
+        self.assertEqual(MemoryServer, memory_test.transport_server)
+        
+        # we could test all of them for .id, but two is probably sufficient.
+        self.assertEqual("bzrlib.tests.test_selftest."
+                         "TestTransportProviderAdapter."
+                         "test_adapter_sets_transport_class(MemoryServer)",
+                         memory_test.id())
+        self.assertEqual("bzrlib.tests.test_selftest."
+                         "TestTransportProviderAdapter."
+                         "test_adapter_sets_transport_class(LocalRelpathServer)",
+                         local_relpath_test.id())
+
+
+class TestBranchProviderAdapter(TestCase):
+    """A group of tests that test the branch implementation test adapter."""
+
+    def test_adapted_tests(self):
+        # check that constructor parameters are passed through to the adapted
+        # test.
+        from bzrlib.branch import BranchTestProviderAdapter
+        input_test = TestBranchProviderAdapter(
+            "test_adapted_tests")
+        server1 = "a"
+        server2 = "b"
+        formats = [("c", "C"), ("d", "D")]
+        adapter = BranchTestProviderAdapter(server1, server2, formats)
+        suite = adapter.adapt(input_test)
+        tests = list(iter(suite))
+        self.assertEqual(2, len(tests))
+        self.assertEqual(tests[0].branch_format, formats[0][0])
+        self.assertEqual(tests[0].bzrdir_format, formats[0][1])
+        self.assertEqual(tests[0].transport_server, server1)
+        self.assertEqual(tests[0].transport_readonly_server, server2)
+        self.assertEqual(tests[1].branch_format, formats[1][0])
+        self.assertEqual(tests[1].bzrdir_format, formats[1][1])
+        self.assertEqual(tests[1].transport_server, server1)
+        self.assertEqual(tests[1].transport_readonly_server, server2)
+
+
+class TestBzrDirProviderAdapter(TestCase):
+    """A group of tests that test the bzr dir implementation test adapter."""
+
+    def test_adapted_tests(self):
+        # check that constructor parameters are passed through to the adapted
+        # test.
+        from bzrlib.bzrdir import BzrDirTestProviderAdapter
+        input_test = TestBzrDirProviderAdapter(
+            "test_adapted_tests")
+        server1 = "a"
+        server2 = "b"
+        formats = ["c", "d"]
+        adapter = BzrDirTestProviderAdapter(server1, server2, formats)
+        suite = adapter.adapt(input_test)
+        tests = list(iter(suite))
+        self.assertEqual(2, len(tests))
+        self.assertEqual(tests[0].bzrdir_format, formats[0])
+        self.assertEqual(tests[0].transport_server, server1)
+        self.assertEqual(tests[0].transport_readonly_server, server2)
+        self.assertEqual(tests[1].bzrdir_format, formats[1])
+        self.assertEqual(tests[1].transport_server, server1)
+        self.assertEqual(tests[1].transport_readonly_server, server2)
+
+
+class TestRepositoryProviderAdapter(TestCase):
+    """A group of tests that test the repository implementation test adapter."""
+
+    def test_adapted_tests(self):
+        # check that constructor parameters are passed through to the adapted
+        # test.
+        from bzrlib.repository import RepositoryTestProviderAdapter
+        input_test = TestRepositoryProviderAdapter(
+            "test_adapted_tests")
+        server1 = "a"
+        server2 = "b"
+        formats = [("c", "C"), ("d", "D")]
+        adapter = RepositoryTestProviderAdapter(server1, server2, formats)
+        suite = adapter.adapt(input_test)
+        tests = list(iter(suite))
+        self.assertEqual(2, len(tests))
+        self.assertEqual(tests[0].bzrdir_format, formats[0][1])
+        self.assertEqual(tests[0].repository_format, formats[0][0])
+        self.assertEqual(tests[0].transport_server, server1)
+        self.assertEqual(tests[0].transport_readonly_server, server2)
+        self.assertEqual(tests[1].bzrdir_format, formats[1][1])
+        self.assertEqual(tests[1].repository_format, formats[1][0])
+        self.assertEqual(tests[1].transport_server, server1)
+        self.assertEqual(tests[1].transport_readonly_server, server2)
+
+
+class TestInterRepositoryProviderAdapter(TestCase):
+    """A group of tests that test the InterRepository test adapter."""
+
+    def test_adapted_tests(self):
+        # check that constructor parameters are passed through to the adapted
+        # test.
+        from bzrlib.repository import InterRepositoryTestProviderAdapter
+        input_test = TestInterRepositoryProviderAdapter(
+            "test_adapted_tests")
+        server1 = "a"
+        server2 = "b"
+        formats = [(str, "C1", "C2"), (str, "D1", "D2")]
+        adapter = InterRepositoryTestProviderAdapter(server1, server2, formats)
+        suite = adapter.adapt(input_test)
+        tests = list(iter(suite))
+        self.assertEqual(2, len(tests))
+        self.assertEqual(tests[0].interrepo_class, formats[0][0])
+        self.assertEqual(tests[0].repository_format, formats[0][1])
+        self.assertEqual(tests[0].repository_format_to, formats[0][2])
+        self.assertEqual(tests[0].transport_server, server1)
+        self.assertEqual(tests[0].transport_readonly_server, server2)
+        self.assertEqual(tests[0].interrepo_class, formats[1][0])
+        self.assertEqual(tests[1].repository_format, formats[1][1])
+        self.assertEqual(tests[1].repository_format_to, formats[1][2])
+        self.assertEqual(tests[1].transport_server, server1)
+        self.assertEqual(tests[1].transport_readonly_server, server2)
+
+
+class TestWorkingTreeProviderAdapter(TestCase):
+    """A group of tests that test the workingtree implementation test adapter."""
+
+    def test_adapted_tests(self):
+        # check that constructor parameters are passed through to the adapted
+        # test.
+        from bzrlib.workingtree import WorkingTreeTestProviderAdapter
+        input_test = TestWorkingTreeProviderAdapter(
+            "test_adapted_tests")
+        server1 = "a"
+        server2 = "b"
+        formats = [("c", "C"), ("d", "D")]
+        adapter = WorkingTreeTestProviderAdapter(server1, server2, formats)
+        suite = adapter.adapt(input_test)
+        tests = list(iter(suite))
+        self.assertEqual(2, len(tests))
+        self.assertEqual(tests[0].workingtree_format, formats[0][0])
+        self.assertEqual(tests[0].bzrdir_format, formats[0][1])
+        self.assertEqual(tests[0].transport_server, server1)
+        self.assertEqual(tests[0].transport_readonly_server, server2)
+        self.assertEqual(tests[1].workingtree_format, formats[1][0])
+        self.assertEqual(tests[1].bzrdir_format, formats[1][1])
+        self.assertEqual(tests[1].transport_server, server1)
+        self.assertEqual(tests[1].transport_readonly_server, server2)
+
+
+class TestTestCaseWithTransport(TestCaseWithTransport):
+    """Tests for the convenience functions TestCaseWithTransport introduces."""
+
+    def test_get_readonly_url_none(self):
+        from bzrlib.transport import get_transport
+        from bzrlib.transport.memory import MemoryServer
+        from bzrlib.transport.readonly import ReadonlyTransportDecorator
+        self.transport_server = MemoryServer
+        self.transport_readonly_server = None
+        # calling get_readonly_transport() constructs a decorator on the url
+        # for the server
+        url = self.get_readonly_url()
+        url2 = self.get_readonly_url('foo/bar')
+        t = get_transport(url)
+        t2 = get_transport(url2)
+        self.failUnless(isinstance(t, ReadonlyTransportDecorator))
+        self.failUnless(isinstance(t2, ReadonlyTransportDecorator))
+        self.assertEqual(t2.base[:-1], t.abspath('foo/bar'))
+
+    def test_get_readonly_url_http(self):
+        from bzrlib.transport import get_transport
+        from bzrlib.transport.local import LocalRelpathServer
+        from bzrlib.transport.http import HttpServer, HttpTransport
+        self.transport_server = LocalRelpathServer
+        self.transport_readonly_server = HttpServer
+        # calling get_readonly_transport() gives us a HTTP server instance.
+        url = self.get_readonly_url()
+        url2 = self.get_readonly_url('foo/bar')
+        t = get_transport(url)
+        t2 = get_transport(url2)
+        self.failUnless(isinstance(t, HttpTransport))
+        self.failUnless(isinstance(t2, HttpTransport))
+        self.assertEqual(t2.base[:-1], t.abspath('foo/bar'))
+
+
+class TestChrootedTest(ChrootedTestCase):
+
+    def test_root_is_root(self):
+        from bzrlib.transport import get_transport
+        t = get_transport(self.get_readonly_url())
+        url = t.base
+        self.assertEqual(url, t.clone('..').base)

=== modified file 'bzrlib/tests/test_sftp_transport.py'
--- bzrlib/tests/test_sftp_transport.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_sftp_transport.py	2006-03-20 08:31:00 +0000
@@ -18,135 +18,42 @@
 import socket
 import threading
 
-from bzrlib.tests import TestCaseInTempDir, TestCase, TestSkipped
-from bzrlib.tests.test_transport import TestTransportMixIn
+import bzrlib.bzrdir as bzrdir
 import bzrlib.errors as errors
 from bzrlib.osutils import pathjoin, lexists
+from bzrlib.tests import TestCaseWithTransport, TestCase, TestSkipped
+import bzrlib.transport
+from bzrlib.workingtree import WorkingTree
 
 try:
     import paramiko
-    from stub_sftp import StubServer, StubSFTPServer
     paramiko_loaded = True
 except ImportError:
     paramiko_loaded = False
 
-# XXX: 20051124 jamesh
-# The tests currently pop up a password prompt when an external ssh
-# is used.  This forces the use of the paramiko implementation.
-if paramiko_loaded:
-    import bzrlib.transport.sftp
-    bzrlib.transport.sftp._ssh_vendor = 'none'
-
-
-STUB_SERVER_KEY = """
------BEGIN RSA PRIVATE KEY-----
-MIICWgIBAAKBgQDTj1bqB4WmayWNPB+8jVSYpZYk80Ujvj680pOTh2bORBjbIAyz
-oWGW+GUjzKxTiiPvVmxFgx5wdsFvF03v34lEVVhMpouqPAYQ15N37K/ir5XY+9m/
-d8ufMCkjeXsQkKqFbAlQcnWMCRnOoPHS3I4vi6hmnDDeeYTSRvfLbW0fhwIBIwKB
-gBIiOqZYaoqbeD9OS9z2K9KR2atlTxGxOJPXiP4ESqP3NVScWNwyZ3NXHpyrJLa0
-EbVtzsQhLn6rF+TzXnOlcipFvjsem3iYzCpuChfGQ6SovTcOjHV9z+hnpXvQ/fon
-soVRZY65wKnF7IAoUwTmJS9opqgrN6kRgCd3DASAMd1bAkEA96SBVWFt/fJBNJ9H
-tYnBKZGw0VeHOYmVYbvMSstssn8un+pQpUm9vlG/bp7Oxd/m+b9KWEh2xPfv6zqU
-avNwHwJBANqzGZa/EpzF4J8pGti7oIAPUIDGMtfIcmqNXVMckrmzQ2vTfqtkEZsA
-4rE1IERRyiJQx6EJsz21wJmGV9WJQ5kCQQDwkS0uXqVdFzgHO6S++tjmjYcxwr3g
-H0CoFYSgbddOT6miqRskOQF3DZVkJT3kyuBgU2zKygz52ukQZMqxCb1fAkASvuTv
-qfpH87Qq5kQhNKdbbwbmd2NxlNabazPijWuphGTdW0VfJdWfklyS2Kr+iqrs/5wV
-HhathJt636Eg7oIjAkA8ht3MQ+XSl9yIJIS8gVpbPxSw5OMfw0PjVE7tBdQruiSc
-nvuQES5C9BMHjF39LZiGH1iLQy7FgdHyoP+eodI7
------END RSA PRIVATE KEY-----
-"""
-    
-
-class SingleListener (threading.Thread):
-    def __init__(self, callback):
-        threading.Thread.__init__(self)
-        self._callback = callback
-        self._socket = socket.socket()
-        self._socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
-        self._socket.bind(('localhost', 0))
-        self._socket.listen(1)
-        self.port = self._socket.getsockname()[1]
-        self.stop_event = threading.Event()
-
-    def run(self):
-        s, _ = self._socket.accept()
-        # now close the listen socket
-        self._socket.close()
-        self._callback(s, self.stop_event)
-    
-    def stop(self):
-        self.stop_event.set()
-        # We should consider waiting for the other thread
-        # to stop, because otherwise we get spurious
-        #   bzr: ERROR: Socket exception: Connection reset by peer (54)
-        # because the test suite finishes before the thread has a chance
-        # to close. (Especially when only running a few tests)
-        
-        
-class TestCaseWithSFTPServer (TestCaseInTempDir):
-    """
-    Execute a test case with a stub SFTP server, serving files from the local
-    filesystem over the loopback network.
-    """
-    
-    def _run_server(self, s, stop_event):
-        ssh_server = paramiko.Transport(s)
-        key_file = pathjoin(self._root, 'test_rsa.key')
-        file(key_file, 'w').write(STUB_SERVER_KEY)
-        host_key = paramiko.RSAKey.from_private_key_file(key_file)
-        ssh_server.add_server_key(host_key)
-        server = StubServer(self)
-        ssh_server.set_subsystem_handler('sftp', paramiko.SFTPServer, StubSFTPServer, root=self._root)
-        event = threading.Event()
-        ssh_server.start_server(event, server)
-        event.wait(5.0)
-        stop_event.wait(30.0)
+
+class TestCaseWithSFTPServer(TestCaseWithTransport):
+    """A test case base class that provides a sftp server on localhost."""
 
     def setUp(self):
         if not paramiko_loaded:
             raise TestSkipped('you must have paramiko to run this test')
-        TestCaseInTempDir.setUp(self)
-        self._root = self.test_dir
-        self._is_setup = False
-
-    def delayed_setup(self):
-        # some tests are just stubs that call setUp and then immediately call
-        # tearDwon.  so don't create the port listener until get_transport is
-        # called and we know we're in an actual test.
-        if self._is_setup:
-            return
-        self._listener = SingleListener(self._run_server)
-        self._listener.setDaemon(True)
-        self._listener.start()        
-        self._sftp_url = 'sftp://foo:bar@localhost:%d/' % (self._listener.port,)
-        self._is_setup = True
-        
-    def tearDown(self):
-        try:
-            self._listener.stop()
-        except AttributeError:
-            pass
-        TestCaseInTempDir.tearDown(self)
-
-        
-class SFTPTransportTest (TestCaseWithSFTPServer, TestTransportMixIn):
-    readonly = False
-
-    def setUp(self):
-        TestCaseWithSFTPServer.setUp(self)
-        self.sftplogs = []
-
-    def log(self, *args):
-        """Override the default log to grab sftp server messages"""
-        TestCaseWithSFTPServer.log(self, *args)
-        if args and args[0].startswith('sftpserver'):
-            self.sftplogs.append(args[0])
-
-    def get_transport(self):
-        self.delayed_setup()
-        from bzrlib.transport.sftp import SFTPTransport
-        url = self._sftp_url
-        return SFTPTransport(url)
+        super(TestCaseWithSFTPServer, self).setUp()
+        from bzrlib.transport.sftp import SFTPAbsoluteServer, SFTPHomeDirServer
+        if getattr(self, '_get_remote_is_absolute', None) is None:
+            self._get_remote_is_absolute = True
+        if self._get_remote_is_absolute:
+            self.transport_server = SFTPAbsoluteServer
+        else:
+            self.transport_server = SFTPHomeDirServer
+        self.transport_readonly_server = bzrlib.transport.http.HttpServer
+
+    def get_transport(self, path=None):
+        """Return a transport relative to self._test_root."""
+        return bzrlib.transport.get_transport(self.get_url(path))
+
+
+class SFTPLockTests (TestCaseWithSFTPServer):
 
     def test_sftp_locks(self):
         from bzrlib.errors import LockError
@@ -175,15 +82,43 @@
 
     def test_multiple_connections(self):
         t = self.get_transport()
-        self.assertEquals(self.sftplogs, 
-                ['sftpserver - authorizing: foo'
-               , 'sftpserver - channel request: session, 1'])
-        self.sftplogs = []
+        self.assertTrue('sftpserver - new connection' in self.get_server().logs)
+        self.get_server().logs = []
         # The second request should reuse the first connection
         # SingleListener only allows for a single connection,
         # So the next line fails unless the connection is reused
         t2 = self.get_transport()
-        self.assertEquals(self.sftplogs, [])
+        self.assertEquals(self.get_server().logs, [])
+
+
+class SFTPTransportTestRelative(TestCaseWithSFTPServer):
+    """Test the SFTP transport with homedir based relative paths."""
+
+    def test__remote_path(self):
+        t = self.get_transport()
+        # try what is currently used:
+        # remote path = self._abspath(relpath)
+        self.assertEqual(self.test_dir + '/relative', t._remote_path('relative'))
+        # we dont os.path.join because windows gives us the wrong path
+        root_segments = self.test_dir.split('/')
+        root_parent = '/'.join(root_segments[:-1])
+        # .. should be honoured
+        self.assertEqual(root_parent + '/sibling', t._remote_path('../sibling'))
+        # /  should be illegal ?
+        ### FIXME decide and then test for all transports. RBC20051208
+
+
+class SFTPTransportTestRelative(TestCaseWithSFTPServer):
+    """Test the SFTP transport with homedir based relative paths."""
+
+    def setUp(self):
+        self._get_remote_is_absolute = False
+        super(SFTPTransportTestRelative, self).setUp()
+
+    def test__remote_path_relative_root(self):
+        # relative paths are preserved
+        t = self.get_transport('')
+        self.assertEqual('a', t._remote_path('a'))
 
 
 class FakeSFTPTransport (object):
@@ -199,15 +134,15 @@
 
     def test_parse_url(self):
         from bzrlib.transport.sftp import SFTPTransport
-        s = SFTPTransport('sftp://simple.example.com/%2fhome/source', clone_from=fake)
+        s = SFTPTransport('sftp://simple.example.com/home/source', clone_from=fake)
         self.assertEquals(s._host, 'simple.example.com')
         self.assertEquals(s._port, None)
         self.assertEquals(s._path, '/home/source')
         self.failUnless(s._password is None)
 
-        self.assertEquals(s.base, 'sftp://simple.example.com/%2Fhome/source')
-        
-        s = SFTPTransport('sftp://ro%62ey:h%40t@example.com:2222/relative', clone_from=fake)
+        self.assertEquals(s.base, 'sftp://simple.example.com/home/source/')
+
+        s = SFTPTransport('sftp://ro%62ey:h%40t@example.com:2222/~/relative', clone_from=fake)
         self.assertEquals(s._host, 'example.com')
         self.assertEquals(s._port, 2222)
         self.assertEquals(s._username, 'robey')
@@ -215,36 +150,25 @@
         self.assertEquals(s._path, 'relative')
 
         # Base should not keep track of the password
-        self.assertEquals(s.base, 'sftp://robey@example.com:2222/relative')
-
-        # Double slash should be accepted instead of using %2F
-        s = SFTPTransport('sftp://user@example.com:22//absolute/path', clone_from=fake)
-        self.assertEquals(s._host, 'example.com')
-        self.assertEquals(s._port, 22)
-        self.assertEquals(s._username, 'user')
-        self.assertEquals(s._password, None)
-        self.assertEquals(s._path, '/absolute/path')
-
-        # Also, don't show the port if it is the default 22
-        self.assertEquals(s.base, 'sftp://user@example.com:22/%2Fabsolute/path')
+        self.assertEquals(s.base, 'sftp://robey@example.com:2222/~/relative/')
 
     def test_relpath(self):
         from bzrlib.transport.sftp import SFTPTransport
         from bzrlib.errors import PathNotChild
 
-        s = SFTPTransport('sftp://user@host.com//abs/path', clone_from=fake)
-        self.assertEquals(s.relpath('sftp://user@host.com//abs/path/sub'), 'sub')
+        s = SFTPTransport('sftp://user@host.com/abs/path', clone_from=fake)
+        self.assertEquals(s.relpath('sftp://user@host.com/abs/path/sub'), 'sub')
         # Can't test this one, because we actually get an AssertionError
         # TODO: Consider raising an exception rather than an assert
-        #self.assertRaises(PathNotChild, s.relpath, 'http://user@host.com//abs/path/sub')
-        self.assertRaises(PathNotChild, s.relpath, 'sftp://user2@host.com//abs/path/sub')
-        self.assertRaises(PathNotChild, s.relpath, 'sftp://user@otherhost.com//abs/path/sub')
-        self.assertRaises(PathNotChild, s.relpath, 'sftp://user@host.com:33//abs/path/sub')
-        self.assertRaises(PathNotChild, s.relpath, 'sftp://user@host.com/abs/path/sub')
+        #self.assertRaises(PathNotChild, s.relpath, 'http://user@host.com/abs/path/sub')
+        self.assertRaises(PathNotChild, s.relpath, 'sftp://user2@host.com/abs/path/sub')
+        self.assertRaises(PathNotChild, s.relpath, 'sftp://user@otherhost.com/abs/path/sub')
+        self.assertRaises(PathNotChild, s.relpath, 'sftp://user@host.com:33/abs/path/sub')
+        self.assertRaises(PathNotChild, s.relpath, 'sftp://user@host.com/~/rel/path/sub')
 
         # Make sure it works when we don't supply a username
-        s = SFTPTransport('sftp://host.com//abs/path', clone_from=fake)
-        self.assertEquals(s.relpath('sftp://host.com//abs/path/sub'), 'sub')
+        s = SFTPTransport('sftp://host.com/abs/path', clone_from=fake)
+        self.assertEquals(s.relpath('sftp://host.com/abs/path/sub'), 'sub')
 
         # Make sure it works when parts of the path will be url encoded
         # TODO: These may be incorrect, we might need to urllib.urlencode() before
@@ -270,10 +194,7 @@
 
     def test_lock_file(self):
         """Make sure that a Branch accessed over sftp tries to lock itself."""
-        from bzrlib.branch import Branch
-
-        self.delayed_setup()
-        b = Branch.initialize(self._sftp_url)
+        b = bzrdir.BzrDir.create_branch_and_repo(self.get_url())
         self.failUnlessExists('.bzr/')
         self.failUnlessExists('.bzr/branch-format')
         self.failUnlessExists('.bzr/branch-lock')
@@ -284,24 +205,14 @@
         b.unlock()
         self.failIf(lexists('.bzr/branch-lock.write-lock'))
 
-    def test_no_working_tree(self):
-        from bzrlib.branch import Branch
-        self.delayed_setup()
-        b = Branch.initialize(self._sftp_url)
-        self.assertRaises(errors.NoWorkingTree, b.working_tree)
-
     def test_push_support(self):
-        from bzrlib.branch import Branch
-        self.delayed_setup()
-
         self.build_tree(['a/', 'a/foo'])
-        b = Branch.initialize('a')
-        t = b.working_tree()
+        t = bzrdir.BzrDir.create_standalone_workingtree('a')
+        b = t.branch
         t.add('foo')
         t.commit('foo', rev_id='a1')
 
-        os.mkdir('b')
-        b2 = Branch.initialize(self._sftp_url + 'b')
+        b2 = bzrdir.BzrDir.create_branch_and_repo(self.get_url('/b'))
         b2.pull(b)
 
         self.assertEquals(b2.revision_history(), ['a1'])
@@ -313,3 +224,10 @@
         self.assertEquals(b2.revision_history(), ['a1', 'a2'])
 
 
+class SFTPFullHandshakingTest(TestCaseWithSFTPServer):
+    """Verify that a full-handshake (SSH over loopback TCP) sftp connection works."""
+    
+    def test_connection(self):
+        from bzrlib.transport.sftp import SFTPFullAbsoluteServer
+        self.transport_server = SFTPFullAbsoluteServer
+        self.get_transport()

=== modified file 'bzrlib/tests/test_smart_add.py'
--- bzrlib/tests/test_smart_add.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_smart_add.py	2006-03-20 08:31:00 +0000
@@ -1,35 +1,37 @@
 import os
 import unittest
 
-from bzrlib.tests import TestCaseInTempDir, TestCase
+from bzrlib.add import smart_add, smart_add_tree
+from bzrlib.tests import TestCaseWithTransport, TestCase
 from bzrlib.branch import Branch
 from bzrlib.errors import NotBranchError, NoSuchFile
 from bzrlib.inventory import InventoryFile, Inventory
 from bzrlib.workingtree import WorkingTree
-from bzrlib.add import smart_add
 
-class TestSmartAdd(TestCaseInTempDir):
+class TestSmartAdd(TestCaseWithTransport):
 
     def test_add_dot_from_root(self):
         """Test adding . from the root of the tree.""" 
         from bzrlib.add import smart_add
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        branch = Branch.initialize(u".")
-        smart_add((u".",))
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        smart_add_tree(wt, (u".",))
         for path in paths:
-            self.assertNotEqual(branch.working_tree().path2id(path), None)
+            self.assertNotEqual(wt.path2id(path), None)
 
     def test_add_dot_from_subdir(self):
         """Test adding . from a subdir of the tree.""" 
         from bzrlib.add import smart_add
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        branch = Branch.initialize(u".")
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
         os.chdir("original")
-        smart_add((u".",))
+        smart_add_tree(wt, (u".",))
         for path in paths:
-            self.assertNotEqual(branch.working_tree().path2id(path), None)
+            self.assertNotEqual(wt.path2id(path), None)
 
     def test_add_tree_from_above_tree(self):
         """Test adding a tree from above the tree.""" 
@@ -38,10 +40,11 @@
         branch_paths = ("branch/", "branch/original/", "branch/original/file1",
                         "branch/original/file2")
         self.build_tree(branch_paths)
-        branch = Branch.initialize("branch")
-        smart_add(("branch",))
+        wt = self.make_branch_and_tree('branch')
+        branch = wt.branch
+        smart_add_tree(wt, ("branch",))
         for path in paths:
-            self.assertNotEqual(branch.working_tree().path2id(path), None)
+            self.assertNotEqual(wt.path2id(path), None)
 
     def test_add_above_tree_preserves_tree(self):
         """Test nested trees are not affect by an add above them."""
@@ -53,84 +56,86 @@
                        "original/child/", "original/child/path")
         
         self.build_tree(build_paths)
-        branch = Branch.initialize(u".")
-        child_branch = Branch.initialize("original/child")
-        smart_add((u".",))
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        child_tree = self.make_branch_and_tree('original/child')
+        smart_add_tree(wt, (u".",))
         for path in paths:
-            self.assertNotEqual((path, branch.working_tree().path2id(path)),
+            self.assertNotEqual((path, wt.path2id(path)),
                                 (path, None))
         for path in full_child_paths:
-            self.assertEqual((path, branch.working_tree().path2id(path)),
+            self.assertEqual((path, wt.path2id(path)),
                              (path, None))
         for path in child_paths:
-            self.assertEqual(child_branch.working_tree().path2id(path), None)
+            self.assertEqual(child_tree.path2id(path), None)
 
     def test_add_paths(self):
         """Test smart-adding a list of paths."""
         from bzrlib.add import smart_add
         paths = ("file1", "file2")
         self.build_tree(paths)
-        branch = Branch.initialize(u".")
-        smart_add(paths)
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        smart_add_tree(wt, paths)
         for path in paths:
-            self.assertNotEqual(branch.working_tree().path2id(path), None)
+            self.assertNotEqual(wt.path2id(path), None)
 
     def test_add_dry_run(self):
         """Test a dry run add, make sure nothing is added."""
         from bzrlib.commands import run_bzr
         eq = self.assertEqual
-        b = Branch.initialize(u'.')
-        t = b.working_tree()
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
         self.build_tree(['inertiatic/', 'inertiatic/esp'])
-        eq(list(t.unknowns()), ['inertiatic'])
+        eq(list(wt.unknowns()), ['inertiatic'])
         self.capture('add --dry-run .')
-        eq(list(t.unknowns()), ['inertiatic'])
+        eq(list(wt.unknowns()), ['inertiatic'])
 
     def test_add_non_existant(self):
         """Test smart-adding a file that does not exist."""
         from bzrlib.add import smart_add
-        branch = Branch.initialize(u".")
-        self.assertRaises(NoSuchFile, smart_add, 'non-existant-file')
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        self.assertRaises(NoSuchFile, smart_add_tree, wt, 'non-existant-file')
 
     def test_returns(self):
         """Correctly returns added/ignored files"""
         from bzrlib.commands import run_bzr
-        b = Branch.initialize(u'.')
-        t = b.working_tree()
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
         self.build_tree(['inertiatic/', 'inertiatic/esp', 'inertiatic/CVS', 
                         'inertiatic/foo.pyc'])
-        added, ignored = smart_add(u'.')
-        self.AssertSubset(('inertiatic', 'inertiatic/esp'), added)
-        self.AssertSubset(('CVS', '*.py[oc]'), ignored)
-        self.AssertSubset(('inertiatic/CVS',), ignored['CVS'])
-        self.AssertSubset(('inertiatic/foo.pyc',), ignored['*.py[oc]'])
-
-
-class TestSmartAddBranch(TestCaseInTempDir):
+        added, ignored = smart_add_tree(wt, u'.')
+        self.assertSubset(('inertiatic', 'inertiatic/esp'), added)
+        self.assertSubset(('CVS', '*.py[oc]'), ignored)
+        self.assertSubset(('inertiatic/CVS',), ignored['CVS'])
+        self.assertSubset(('inertiatic/foo.pyc',), ignored['*.py[oc]'])
+
+
+class TestSmartAddBranch(TestCaseWithTransport):
     """Test smart adds with a specified branch."""
 
     def test_add_dot_from_root(self):
         """Test adding . from the root of the tree.""" 
-        from bzrlib.add import smart_add_tree
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        Branch.initialize(u".")
-        tree = WorkingTree()
-        smart_add_tree(tree, (u".",))
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        smart_add_tree(wt, (u".",))
         for path in paths:
-            self.assertNotEqual(tree.path2id(path), None)
+            self.assertNotEqual(wt.path2id(path), None)
 
     def test_add_dot_from_subdir(self):
         """Test adding . from a subdir of the tree.""" 
         from bzrlib.add import smart_add_tree
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        Branch.initialize(u".")
-        tree = WorkingTree()
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
         os.chdir("original")
-        smart_add_tree(tree, (u".",))
+        smart_add_tree(wt, (u".",))
         for path in paths:
-            self.assertNotEqual(tree.path2id(path), None)
+            self.assertNotEqual(wt.path2id(path), None)
 
     def test_add_tree_from_above_tree(self):
         """Test adding a tree from above the tree.""" 
@@ -139,8 +144,8 @@
         branch_paths = ("branch/", "branch/original/", "branch/original/file1",
                         "branch/original/file2")
         self.build_tree(branch_paths)
-        Branch.initialize("branch")
-        tree = WorkingTree("branch")
+        tree = self.make_branch_and_tree('branch')
+        branch = tree.branch
         smart_add_tree(tree, ("branch",))
         for path in paths:
             self.assertNotEqual(tree.path2id(path), None)
@@ -154,9 +159,9 @@
         build_paths = ("original/", "original/file1", "original/file2", 
                        "original/child/", "original/child/path")
         self.build_tree(build_paths)
-        Branch.initialize(u".")
-        tree = WorkingTree()
-        child_branch = Branch.initialize("original/child")
+        tree = self.make_branch_and_tree('.')
+        branch = tree.branch
+        child_tree = self.make_branch_and_tree("original/child")
         smart_add_tree(tree, (u".",))
         for path in paths:
             self.assertNotEqual((path, tree.path2id(path)),
@@ -165,21 +170,21 @@
             self.assertEqual((path, tree.path2id(path)),
                              (path, None))
         for path in child_paths:
-            self.assertEqual(child_branch.working_tree().path2id(path), None)
+            self.assertEqual(child_tree.path2id(path), None)
 
     def test_add_paths(self):
         """Test smart-adding a list of paths."""
         from bzrlib.add import smart_add_tree
         paths = ("file1", "file2")
         self.build_tree(paths)
-        Branch.initialize(u".")
-        tree = WorkingTree()
-        smart_add_tree(tree, paths)
+        wt = self.make_branch_and_tree('.')
+        branch = wt.branch
+        smart_add_tree(wt, paths)
         for path in paths:
-            self.assertNotEqual(tree.path2id(path), None)
-
-
-class TestAddActions(TestCaseInTempDir):
+            self.assertNotEqual(wt.path2id(path), None)
+
+
+class TestAddActions(TestCase):
 
     def test_null(self):
         from bzrlib.add import add_action_null

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_source.py	2006-03-20 08:31:00 +0000
@@ -55,11 +55,9 @@
         # do not even think of increasing this number. If you think you need to
         # increase it, then you almost certainly are doing something wrong as
         # the relationship from working_tree to branch is one way.
-        # This number should be 0, but the basis_inventory merge was done
-        # before this test was written. Note that this is an exact equality
-        # so that when the number drops, it is not given a buffer but rather
-        # this test updated immediately.
-        self.assertEqual(2, occurences)
+        # Note that this is an exact equality so that when the number drops, 
+        #it is not given a buffer but rather has this test updated immediately.
+        self.assertEqual(0, occurences)
 
     def test_branch_WorkingTree(self):
         """Test that the number of uses of working_tree in branch is stable."""
@@ -74,4 +72,4 @@
         # written. Note that this is an exact equality so that when the number
         # drops, it is not given a buffer but rather this test updated
         # immediately.
-        self.assertEqual(6, occurences)
+        self.assertEqual(4, occurences)

=== removed file 'bzrlib/tests/test_status.py'
--- bzrlib/tests/test_status.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_status.py	1970-01-01 00:00:00 +0000
@@ -1,174 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests of status command.
-
-Most of these depend on the particular formatting used.
-"""
-
-
-from cStringIO import StringIO
-from os import mkdir
-from tempfile import TemporaryFile
-import codecs
-
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib.revisionspec import RevisionSpec
-from bzrlib.merge import merge
-from bzrlib.status import show_status
-from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
-
-class BranchStatus(TestCaseInTempDir):
-    
-    def test_branch_status(self): 
-        """Test basic branch status"""
-        from bzrlib.status import show_status
-        from bzrlib.branch import Branch
-        
-        b = Branch.initialize(u'.')
-
-        # status with nothing
-        tof = StringIO()
-        show_status(b, to_file=tof)
-        self.assertEquals(tof.getvalue(), "")
-
-        tof = StringIO()
-        self.build_tree(['hello.c', 'bye.c'])
-        b.working_tree().add_pending_merge('pending@pending-0-0')
-        show_status(b, to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  bye.c\n',
-                           '  hello.c\n',
-                           'pending merges:\n',
-                           '  pending@pending-0-0\n'
-                           ])
-
-    def test_branch_status_revisions(self):
-        """Tests branch status with revisions"""
-        
-        b = Branch.initialize(u'.')
-
-        tof = StringIO()
-        self.build_tree(['hello.c', 'bye.c'])
-        b.working_tree().add('hello.c')
-        b.working_tree().add('bye.c')
-        b.working_tree().commit('Test message')
-
-        tof = StringIO()
-        revs =[]
-        revs.append(RevisionSpec(0))
-        
-        show_status(b, to_file=tof, revision=revs)
-        
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['added:\n',
-                           '  bye.c\n',
-                           '  hello.c\n'])
-
-        self.build_tree(['more.c'])
-        b.working_tree().add('more.c')
-        b.working_tree().commit('Another test message')
-        
-        tof = StringIO()
-        revs.append(RevisionSpec(1))
-        
-        show_status(b, to_file=tof, revision=revs)
-        
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['added:\n',
-                           '  bye.c\n',
-                           '  hello.c\n'])
-
-    def status_string(self, branch):
-        # use a real file rather than StringIO because it doesn't handle
-        # Unicode very well.
-        tof = codecs.getwriter('utf-8')(TemporaryFile())
-        show_status(branch, to_file=tof)
-        tof.seek(0)
-        return tof.read().decode('utf-8')
-
-    def test_pending(self):
-        """Pending merges display works, including Unicode"""
-        mkdir("./branch")
-        b = Branch.initialize('./branch')
-        b.working_tree().commit("Empty commit 1")
-        b_2 = copy_branch(b, './copy')
-        b.working_tree().commit(u"\N{TIBETAN DIGIT TWO} Empty commit 2")
-        merge(["./branch", -1], [None, None], this_dir = './copy')
-        message = self.status_string(b_2)
-        self.assert_(message.startswith("pending merges:\n"))
-        self.assert_(message.endswith("Empty commit 2\n")) 
-        b_2.working_tree().commit("merged")
-        # must be long to make sure we see elipsis at the end
-        b.working_tree().commit("Empty commit 3 " + 
-                                "blah blah blah blah " * 10)
-        merge(["./branch", -1], [None, None], this_dir = './copy')
-        message = self.status_string(b_2)
-        self.assert_(message.startswith("pending merges:\n"))
-        self.assert_("Empty commit 3" in message)
-        self.assert_(message.endswith("...\n")) 
-
-    def test_branch_status_specific_files(self): 
-        """Tests branch status with given specific files"""
-        from cStringIO import StringIO
-        from bzrlib.status import show_status
-        from bzrlib.branch import Branch
-        
-        b = Branch.initialize(u'.')
-
-        self.build_tree(['directory/','directory/hello.c', 'bye.c','test.c','dir2/'])
-        b.working_tree().add('directory')
-        b.working_tree().add('test.c')
-        b.working_tree().commit('testing')
-        
-        tof = StringIO()
-        show_status(b, to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  bye.c\n',
-                           '  dir2\n',
-                           '  directory/hello.c\n'
-                           ])
-
-        tof = StringIO()
-        show_status(b, specific_files=['bye.c','test.c','absent.c'], to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  bye.c\n'
-                           ])
-        
-        tof = StringIO()
-        show_status(b, specific_files=['directory'], to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  directory/hello.c\n'
-                           ])
-        tof = StringIO()
-        show_status(b, specific_files=['dir2'], to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  dir2\n'
-                           ])

=== modified file 'bzrlib/tests/test_symbol_versioning.py'
--- bzrlib/tests/test_symbol_versioning.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_symbol_versioning.py	2006-03-20 08:31:00 +0000
@@ -29,8 +29,8 @@
 
 class TestDeprecationWarnings(TestCase):
 
-    def capture_warning(self, message, category):
-        self._warnings.append((message, category))
+    def capture_warning(self, message, category, stacklevel=None):
+        self._warnings.append((message, category, stacklevel))
 
     def setUp(self):
         super(TestDeprecationWarnings, self).setUp()
@@ -48,7 +48,7 @@
         expected_warning = (
             "bzrlib.tests.test_symbol_versioning."
             "TestDeprecationWarnings.deprecated_method "
-            "was deprecated in version 0.7.", DeprecationWarning)
+            "was deprecated in version 0.7.", DeprecationWarning, 2)
         expected_docstring = ('Deprecated method docstring.\n'
                               '        \n'
                               '        This might explain stuff.\n'
@@ -63,7 +63,7 @@
     def test_deprecated_function(self):
         expected_warning = (
             "bzrlib.tests.test_symbol_versioning.deprecated_function "
-            "was deprecated in version 0.7.", DeprecationWarning)
+            "was deprecated in version 0.7.", DeprecationWarning, 2)
         expected_docstring = ('Deprecated function docstring.\n'
                               '\n'
                               'This function was deprecated in version 0.7.\n'
@@ -87,5 +87,14 @@
             self.assertEqualDiff(expected_docstring, deprecated_callable.__doc__)
             self.assertEqualDiff(expected_name, deprecated_callable.__name__)
             self.assertEqualDiff(expected_module, deprecated_callable.__module__)
+            self.assertTrue(deprecated_callable.is_deprecated)
         finally:
             symbol_versioning.set_warning_method(old_warning_method)
+    
+    def test_deprecated_passed(self):
+        self.assertEqual(True, symbol_versioning.deprecated_passed(None))
+        self.assertEqual(True, symbol_versioning.deprecated_passed(True))
+        self.assertEqual(True, symbol_versioning.deprecated_passed(False))
+        self.assertEqual(False,
+                         symbol_versioning.deprecated_passed(
+                            symbol_versioning.DEPRECATED_PARAMETER))

=== modified file 'bzrlib/tests/test_testament.py'
--- bzrlib/tests/test_testament.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_testament.py	2006-03-20 08:31:00 +0000
@@ -22,20 +22,21 @@
 from sha import sha
 import sys
 
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.branch import Branch
 from bzrlib.testament import Testament
 from bzrlib.trace import mutter
 from bzrlib.osutils import has_symlinks
 
 
-class TestamentTests(TestCaseInTempDir):
+class TestamentTests(TestCaseWithTransport):
 
     def setUp(self):
         super(TestamentTests, self).setUp()
-        b = self.b = Branch.initialize(u'.')
+        self.wt = self.make_branch_and_tree('.')
+        b = self.b = self.wt.branch
         b.nick = "test branch"
-        b.working_tree().commit(message='initial null commit',
+        self.wt.commit(message='initial null commit',
                  committer='test@user',
                  timestamp=1129025423, # 'Tue Oct 11 20:10:23 2005'
                  timezone=0,
@@ -43,9 +44,9 @@
         self.build_tree_contents([('hello', 'contents of hello file'),
                              ('src/', ),
                              ('src/foo.c', 'int main()\n{\n}\n')])
-        b.working_tree().add(['hello', 'src', 'src/foo.c'],
+        self.wt.add(['hello', 'src', 'src/foo.c'],
                              ['hello-id', 'src-id', 'foo.c-id'])
-        b.working_tree().commit(message='add files and directories',
+        self.wt.commit(message='add files and directories',
                  timestamp=1129025483,
                  timezone=36000,
                  rev_id='test@user-2',
@@ -53,7 +54,7 @@
 
     def test_null_testament(self):
         """Testament for a revision with no contents."""
-        t = Testament.from_revision(self.b, 'test@user-1')
+        t = Testament.from_revision(self.b.repository, 'test@user-1')
         ass = self.assertTrue
         eq = self.assertEqual
         ass(isinstance(t, Testament))
@@ -64,14 +65,14 @@
 
     def test_testment_text_form(self):
         """Conversion of testament to canonical text form."""
-        t = Testament.from_revision(self.b, 'test@user-1')
+        t = Testament.from_revision(self.b.repository, 'test@user-1')
         text_form = t.as_text()
         self.log('testament text form:\n' + text_form)
         self.assertEqual(text_form, REV_1_TESTAMENT)
 
     def test_testament_with_contents(self):
         """Testament containing a file and a directory."""
-        t = Testament.from_revision(self.b, 'test@user-2')
+        t = Testament.from_revision(self.b.repository, 'test@user-2')
         text_form = t.as_text()
         self.log('testament text form:\n' + text_form)
         self.assertEqualDiff(text_form, REV_2_TESTAMENT)
@@ -95,33 +96,44 @@
         if not has_symlinks():
             return
         os.symlink('wibble/linktarget', 'link')
-        self.b.working_tree().add(['link'], ['link-id'])
-        self.b.working_tree().commit(message='add symlink',
+        self.wt.add(['link'], ['link-id'])
+        self.wt.commit(message='add symlink',
                  timestamp=1129025493,
                  timezone=36000,
                  rev_id='test@user-3',
                  committer='test@user')
-        t = Testament.from_revision(self.b, 'test@user-3')
+        t = Testament.from_revision(self.b.repository, 'test@user-3')
         self.assertEqualDiff(t.as_text(), REV_3_TESTAMENT)
 
     def test_testament_revprops(self):
         """Testament to revision with extra properties"""
         props = dict(flavor='sour cherry\ncream cheese',
                      size='medium')
-        self.b.working_tree().commit(message='revision with properties',
+        self.wt.commit(message='revision with properties',
                       timestamp=1129025493,
                       timezone=36000,
                       rev_id='test@user-3',
                       committer='test@user',
                       revprops=props)
-        t = Testament.from_revision(self.b, 'test@user-3')
+        t = Testament.from_revision(self.b.repository, 'test@user-3')
         self.assertEqualDiff(t.as_text(), REV_PROPS_TESTAMENT)
 
+    def test_testament_unicode_commit_message(self):
+        self.wt.commit(
+            message=u'non-ascii commit \N{COPYRIGHT SIGN} me',
+            timestamp=1129025493,
+            timezone=36000,
+            rev_id='test@user-3',
+            committer='test@user')
+        t = Testament.from_revision(self.b.repository, 'test@user-3')
+        self.assertEqualDiff(
+            SAMPLE_UNICODE_TESTAMENT.encode('utf-8'), t.as_text())
+
     def test___init__(self):
-        revision = self.b.get_revision('test@user-2')
-        inventory = self.b.get_inventory('test@user-2')
+        revision = self.b.repository.get_revision('test@user-2')
+        inventory = self.b.repository.get_inventory('test@user-2')
         testament_1 = Testament(revision, inventory).as_short_text()
-        testament_2 = Testament.from_revision(self.b, 
+        testament_2 = Testament.from_revision(self.b.repository, 
                                               'test@user-2').as_short_text()
         self.assertEqual(testament_1, testament_2)
                     
@@ -219,3 +231,23 @@
   branch-nick:
     test branch
 """
+
+
+SAMPLE_UNICODE_TESTAMENT = u"""\
+bazaar-ng testament version 1
+revision-id: test@user-3
+committer: test@user
+timestamp: 1129025493
+timezone: 36000
+parents:
+  test@user-2
+message:
+  non-ascii commit \N{COPYRIGHT SIGN} me
+inventory:
+  file hello hello-id 34dd0ac19a24bf80c4d33b5c8960196e8d8d1f73
+  directory src src-id
+  file src/foo.c foo.c-id a2a049c20f908ae31b231d98779eb63c66448f24
+properties:
+  branch-nick:
+    test branch
+"""

=== added file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_transform.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,677 @@
+# Copyright (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+
+from bzrlib.bzrdir import BzrDir
+from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
+                           ReusingTransform, CantMoveRoot, NotVersionedError,
+                           ExistingLimbo, ImmortalLimbo, LockError)
+from bzrlib.osutils import file_kind, has_symlinks, pathjoin
+from bzrlib.merge import Merge3Merger
+from bzrlib.tests import TestCaseInTempDir, TestSkipped
+from bzrlib.transform import (TreeTransform, ROOT_PARENT, FinalPaths, 
+                              resolve_conflicts, cook_conflicts, 
+                              conflicts_strings, find_interesting, build_tree)
+
+class TestTreeTransform(TestCaseInTempDir):
+    def setUp(self):
+        super(TestTreeTransform, self).setUp()
+        self.wt = BzrDir.create_standalone_workingtree('.')
+        os.chdir('..')
+
+    def get_transform(self):
+        transform = TreeTransform(self.wt)
+        #self.addCleanup(transform.finalize)
+        return transform, transform.trans_id_tree_file_id(self.wt.get_root_id())
+
+    def test_existing_limbo(self):
+        limbo_name = self.wt._control_files.controlfilename('limbo')
+        transform, root = self.get_transform()
+        os.mkdir(pathjoin(limbo_name, 'hehe'))
+        self.assertRaises(ImmortalLimbo, transform.apply)
+        self.assertRaises(LockError, self.wt.unlock)
+        self.assertRaises(ExistingLimbo, self.get_transform)
+        self.assertRaises(LockError, self.wt.unlock)
+        os.rmdir(pathjoin(limbo_name, 'hehe'))
+        os.rmdir(limbo_name)
+        transform, root = self.get_transform()
+        transform.apply()
+
+    def test_build(self):
+        transform, root = self.get_transform() 
+        self.assertIs(transform.get_tree_parent(root), ROOT_PARENT)
+        imaginary_id = transform.trans_id_tree_path('imaginary')
+        self.assertEqual(transform.get_tree_parent(imaginary_id), root)
+        self.assertEqual(transform.final_kind(root), 'directory')
+        self.assertEqual(transform.final_file_id(root), self.wt.get_root_id())
+        trans_id = transform.create_path('name', root)
+        self.assertIs(transform.final_file_id(trans_id), None)
+        self.assertRaises(NoSuchFile, transform.final_kind, trans_id)
+        transform.create_file('contents', trans_id)
+        transform.set_executability(True, trans_id)
+        transform.version_file('my_pretties', trans_id)
+        self.assertRaises(DuplicateKey, transform.version_file,
+                          'my_pretties', trans_id)
+        self.assertEqual(transform.final_file_id(trans_id), 'my_pretties')
+        self.assertEqual(transform.final_parent(trans_id), root)
+        self.assertIs(transform.final_parent(root), ROOT_PARENT)
+        self.assertIs(transform.get_tree_parent(root), ROOT_PARENT)
+        oz_id = transform.create_path('oz', root)
+        transform.create_directory(oz_id)
+        transform.version_file('ozzie', oz_id)
+        trans_id2 = transform.create_path('name2', root)
+        transform.create_file('contents', trans_id2)
+        transform.set_executability(False, trans_id2)
+        transform.version_file('my_pretties2', trans_id2)
+        transform.apply()
+        self.assertEqual('contents', self.wt.get_file_byname('name').read())
+        self.assertEqual(self.wt.path2id('name'), 'my_pretties')
+        self.assertIs(self.wt.is_executable('my_pretties'), True)
+        self.assertIs(self.wt.is_executable('my_pretties2'), False)
+        self.assertEqual('directory', file_kind(self.wt.abspath('oz')))
+        # is it safe to finalize repeatedly?
+        transform.finalize()
+        transform.finalize()
+
+    def test_convenience(self):
+        transform, root = self.get_transform()
+        trans_id = transform.new_file('name', root, 'contents', 
+                                      'my_pretties', True)
+        oz = transform.new_directory('oz', root, 'oz-id')
+        dorothy = transform.new_directory('dorothy', oz, 'dorothy-id')
+        toto = transform.new_file('toto', dorothy, 'toto-contents', 
+                                  'toto-id', False)
+
+        self.assertEqual(len(transform.find_conflicts()), 0)
+        transform.apply()
+        self.assertRaises(ReusingTransform, transform.find_conflicts)
+        self.assertEqual('contents', file(self.wt.abspath('name')).read())
+        self.assertEqual(self.wt.path2id('name'), 'my_pretties')
+        self.assertIs(self.wt.is_executable('my_pretties'), True)
+        self.assertEqual(self.wt.path2id('oz'), 'oz-id')
+        self.assertEqual(self.wt.path2id('oz/dorothy'), 'dorothy-id')
+        self.assertEqual(self.wt.path2id('oz/dorothy/toto'), 'toto-id')
+
+        self.assertEqual('toto-contents', 
+                         self.wt.get_file_byname('oz/dorothy/toto').read())
+        self.assertIs(self.wt.is_executable('toto-id'), False)
+
+    def test_conflicts(self):
+        transform, root = self.get_transform()
+        trans_id = transform.new_file('name', root, 'contents', 
+                                      'my_pretties')
+        self.assertEqual(len(transform.find_conflicts()), 0)
+        trans_id2 = transform.new_file('name', root, 'Crontents', 'toto')
+        self.assertEqual(transform.find_conflicts(), 
+                         [('duplicate', trans_id, trans_id2, 'name')])
+        self.assertRaises(MalformedTransform, transform.apply)
+        transform.adjust_path('name', trans_id, trans_id2)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('non-directory parent', trans_id)])
+        tinman_id = transform.trans_id_tree_path('tinman')
+        transform.adjust_path('name', tinman_id, trans_id2)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('unversioned parent', tinman_id), 
+                          ('missing parent', tinman_id)])
+        lion_id = transform.create_path('lion', root)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('unversioned parent', tinman_id), 
+                          ('missing parent', tinman_id)])
+        transform.adjust_path('name', lion_id, trans_id2)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('unversioned parent', lion_id),
+                          ('missing parent', lion_id)])
+        transform.version_file("Courage", lion_id)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('missing parent', lion_id), 
+                          ('versioning no contents', lion_id)])
+        transform.adjust_path('name2', root, trans_id2)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('versioning no contents', lion_id)])
+        transform.create_file('Contents, okay?', lion_id)
+        transform.adjust_path('name2', trans_id2, trans_id2)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('parent loop', trans_id2), 
+                          ('non-directory parent', trans_id2)])
+        transform.adjust_path('name2', root, trans_id2)
+        oz_id = transform.new_directory('oz', root)
+        transform.set_executability(True, oz_id)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('unversioned executability', oz_id)])
+        transform.version_file('oz-id', oz_id)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('non-file executability', oz_id)])
+        transform.set_executability(None, oz_id)
+        tip_id = transform.new_file('tip', oz_id, 'ozma', 'tip-id')
+        transform.apply()
+        self.assertEqual(self.wt.path2id('name'), 'my_pretties')
+        self.assertEqual('contents', file(self.wt.abspath('name')).read())
+        transform2, root = self.get_transform()
+        oz_id = transform2.trans_id_tree_file_id('oz-id')
+        newtip = transform2.new_file('tip', oz_id, 'other', 'tip-id')
+        result = transform2.find_conflicts()
+        fp = FinalPaths(transform2)
+        self.assert_('oz/tip' in transform2._tree_path_ids)
+        self.assertEqual(fp.get_path(newtip), pathjoin('oz', 'tip'))
+        self.assertEqual(len(result), 2)
+        self.assertEqual((result[0][0], result[0][1]), 
+                         ('duplicate', newtip))
+        self.assertEqual((result[1][0], result[1][2]), 
+                         ('duplicate id', newtip))
+        transform2.finalize()
+        transform3 = TreeTransform(self.wt)
+        self.addCleanup(transform3.finalize)
+        oz_id = transform3.trans_id_tree_file_id('oz-id')
+        transform3.delete_contents(oz_id)
+        self.assertEqual(transform3.find_conflicts(), 
+                         [('missing parent', oz_id)])
+        root_id = transform3.trans_id_tree_file_id('TREE_ROOT')
+        tip_id = transform3.trans_id_tree_file_id('tip-id')
+        transform3.adjust_path('tip', root_id, tip_id)
+        transform3.apply()
+
+    def test_unversioning(self):
+        create_tree, root = self.get_transform()
+        parent_id = create_tree.new_directory('parent', root, 'parent-id')
+        create_tree.new_file('child', parent_id, 'child', 'child-id')
+        create_tree.apply()
+        unversion = TreeTransform(self.wt)
+        self.addCleanup(unversion.finalize)
+        parent = unversion.trans_id_tree_path('parent')
+        unversion.unversion_file(parent)
+        self.assertEqual(unversion.find_conflicts(), 
+                         [('unversioned parent', parent_id)])
+        file_id = unversion.trans_id_tree_file_id('child-id')
+        unversion.unversion_file(file_id)
+        unversion.apply()
+
+    def test_name_invariants(self):
+        create_tree, root = self.get_transform()
+        # prepare tree
+        root = create_tree.trans_id_tree_file_id('TREE_ROOT')
+        create_tree.new_file('name1', root, 'hello1', 'name1')
+        create_tree.new_file('name2', root, 'hello2', 'name2')
+        ddir = create_tree.new_directory('dying_directory', root, 'ddir')
+        create_tree.new_file('dying_file', ddir, 'goodbye1', 'dfile')
+        create_tree.new_file('moving_file', ddir, 'later1', 'mfile')
+        create_tree.new_file('moving_file2', root, 'later2', 'mfile2')
+        create_tree.apply()
+
+        mangle_tree,root = self.get_transform()
+        root = mangle_tree.trans_id_tree_file_id('TREE_ROOT')
+        #swap names
+        name1 = mangle_tree.trans_id_tree_file_id('name1')
+        name2 = mangle_tree.trans_id_tree_file_id('name2')
+        mangle_tree.adjust_path('name2', root, name1)
+        mangle_tree.adjust_path('name1', root, name2)
+
+        #tests for deleting parent directories 
+        ddir = mangle_tree.trans_id_tree_file_id('ddir')
+        mangle_tree.delete_contents(ddir)
+        dfile = mangle_tree.trans_id_tree_file_id('dfile')
+        mangle_tree.delete_versioned(dfile)
+        mangle_tree.unversion_file(dfile)
+        mfile = mangle_tree.trans_id_tree_file_id('mfile')
+        mangle_tree.adjust_path('mfile', root, mfile)
+
+        #tests for adding parent directories
+        newdir = mangle_tree.new_directory('new_directory', root, 'newdir')
+        mfile2 = mangle_tree.trans_id_tree_file_id('mfile2')
+        mangle_tree.adjust_path('mfile2', newdir, mfile2)
+        mangle_tree.new_file('newfile', newdir, 'hello3', 'dfile')
+        self.assertEqual(mangle_tree.final_file_id(mfile2), 'mfile2')
+        self.assertEqual(mangle_tree.final_parent(mfile2), newdir)
+        self.assertEqual(mangle_tree.final_file_id(mfile2), 'mfile2')
+        mangle_tree.apply()
+        self.assertEqual(file(self.wt.abspath('name1')).read(), 'hello2')
+        self.assertEqual(file(self.wt.abspath('name2')).read(), 'hello1')
+        mfile2_path = self.wt.abspath(pathjoin('new_directory','mfile2'))
+        self.assertEqual(mangle_tree.final_parent(mfile2), newdir)
+        self.assertEqual(file(mfile2_path).read(), 'later2')
+        self.assertEqual(self.wt.id2path('mfile2'), 'new_directory/mfile2')
+        self.assertEqual(self.wt.path2id('new_directory/mfile2'), 'mfile2')
+        newfile_path = self.wt.abspath(pathjoin('new_directory','newfile'))
+        self.assertEqual(file(newfile_path).read(), 'hello3')
+        self.assertEqual(self.wt.path2id('dying_directory'), 'ddir')
+        self.assertIs(self.wt.path2id('dying_directory/dying_file'), None)
+        mfile2_path = self.wt.abspath(pathjoin('new_directory','mfile2'))
+
+    def test_both_rename(self):
+        create_tree,root = self.get_transform()
+        newdir = create_tree.new_directory('selftest', root, 'selftest-id')
+        create_tree.new_file('blackbox.py', newdir, 'hello1', 'blackbox-id')
+        create_tree.apply()        
+        mangle_tree,root = self.get_transform()
+        selftest = mangle_tree.trans_id_tree_file_id('selftest-id')
+        blackbox = mangle_tree.trans_id_tree_file_id('blackbox-id')
+        mangle_tree.adjust_path('test', root, selftest)
+        mangle_tree.adjust_path('test_too_much', root, selftest)
+        mangle_tree.set_executability(True, blackbox)
+        mangle_tree.apply()
+
+    def test_both_rename2(self):
+        create_tree,root = self.get_transform()
+        bzrlib = create_tree.new_directory('bzrlib', root, 'bzrlib-id')
+        tests = create_tree.new_directory('tests', bzrlib, 'tests-id')
+        blackbox = create_tree.new_directory('blackbox', tests, 'blackbox-id')
+        create_tree.new_file('test_too_much.py', blackbox, 'hello1', 
+                             'test_too_much-id')
+        create_tree.apply()        
+        mangle_tree,root = self.get_transform()
+        bzrlib = mangle_tree.trans_id_tree_file_id('bzrlib-id')
+        tests = mangle_tree.trans_id_tree_file_id('tests-id')
+        test_too_much = mangle_tree.trans_id_tree_file_id('test_too_much-id')
+        mangle_tree.adjust_path('selftest', bzrlib, tests)
+        mangle_tree.adjust_path('blackbox.py', tests, test_too_much) 
+        mangle_tree.set_executability(True, test_too_much)
+        mangle_tree.apply()
+
+    def test_both_rename3(self):
+        create_tree,root = self.get_transform()
+        tests = create_tree.new_directory('tests', root, 'tests-id')
+        create_tree.new_file('test_too_much.py', tests, 'hello1', 
+                             'test_too_much-id')
+        create_tree.apply()        
+        mangle_tree,root = self.get_transform()
+        tests = mangle_tree.trans_id_tree_file_id('tests-id')
+        test_too_much = mangle_tree.trans_id_tree_file_id('test_too_much-id')
+        mangle_tree.adjust_path('selftest', root, tests)
+        mangle_tree.adjust_path('blackbox.py', tests, test_too_much) 
+        mangle_tree.set_executability(True, test_too_much)
+        mangle_tree.apply()
+
+    def test_move_dangling_ie(self):
+        create_tree, root = self.get_transform()
+        # prepare tree
+        root = create_tree.trans_id_tree_file_id('TREE_ROOT')
+        create_tree.new_file('name1', root, 'hello1', 'name1')
+        create_tree.apply()
+        delete_contents, root = self.get_transform()
+        file = delete_contents.trans_id_tree_file_id('name1')
+        delete_contents.delete_contents(file)
+        delete_contents.apply()
+        move_id, root = self.get_transform()
+        name1 = move_id.trans_id_tree_file_id('name1')
+        newdir = move_id.new_directory('dir', root, 'newdir')
+        move_id.adjust_path('name2', newdir, name1)
+        move_id.apply()
+        
+    def test_replace_dangling_ie(self):
+        create_tree, root = self.get_transform()
+        # prepare tree
+        root = create_tree.trans_id_tree_file_id('TREE_ROOT')
+        create_tree.new_file('name1', root, 'hello1', 'name1')
+        create_tree.apply()
+        delete_contents = TreeTransform(self.wt)
+        self.addCleanup(delete_contents.finalize)
+        file = delete_contents.trans_id_tree_file_id('name1')
+        delete_contents.delete_contents(file)
+        delete_contents.apply()
+        delete_contents.finalize()
+        replace = TreeTransform(self.wt)
+        self.addCleanup(replace.finalize)
+        name2 = replace.new_file('name2', root, 'hello2', 'name1')
+        conflicts = replace.find_conflicts()
+        name1 = replace.trans_id_tree_file_id('name1')
+        self.assertEqual(conflicts, [('duplicate id', name1, name2)])
+        resolve_conflicts(replace)
+        replace.apply()
+
+    def test_symlinks(self):
+        if not has_symlinks():
+            raise TestSkipped('Symlinks are not supported on this platform')
+        transform,root = self.get_transform()
+        oz_id = transform.new_directory('oz', root, 'oz-id')
+        wizard = transform.new_symlink('wizard', oz_id, 'wizard-target', 
+                                       'wizard-id')
+        wiz_id = transform.create_path('wizard2', oz_id)
+        transform.create_symlink('behind_curtain', wiz_id)
+        transform.version_file('wiz-id2', wiz_id)            
+        transform.set_executability(True, wiz_id)
+        self.assertEqual(transform.find_conflicts(), 
+                         [('non-file executability', wiz_id)])
+        transform.set_executability(None, wiz_id)
+        transform.apply()
+        self.assertEqual(self.wt.path2id('oz/wizard'), 'wizard-id')
+        self.assertEqual(file_kind(self.wt.abspath('oz/wizard')), 'symlink')
+        self.assertEqual(os.readlink(self.wt.abspath('oz/wizard2')), 
+                         'behind_curtain')
+        self.assertEqual(os.readlink(self.wt.abspath('oz/wizard')),
+                         'wizard-target')
+
+
+    def get_conflicted(self):
+        create,root = self.get_transform()
+        create.new_file('dorothy', root, 'dorothy', 'dorothy-id')
+        oz = create.new_directory('oz', root, 'oz-id')
+        create.new_directory('emeraldcity', oz, 'emerald-id')
+        create.apply()
+        conflicts,root = self.get_transform()
+        # set up duplicate entry, duplicate id
+        new_dorothy = conflicts.new_file('dorothy', root, 'dorothy', 
+                                         'dorothy-id')
+        old_dorothy = conflicts.trans_id_tree_file_id('dorothy-id')
+        oz = conflicts.trans_id_tree_file_id('oz-id')
+        # set up missing, unversioned parent
+        conflicts.delete_versioned(oz)
+        emerald = conflicts.trans_id_tree_file_id('emerald-id')
+        # set up parent loop
+        conflicts.adjust_path('emeraldcity', emerald, emerald)
+        return conflicts, emerald, oz, old_dorothy, new_dorothy
+
+    def test_conflict_resolution(self):
+        conflicts, emerald, oz, old_dorothy, new_dorothy =\
+            self.get_conflicted()
+        resolve_conflicts(conflicts)
+        self.assertEqual(conflicts.final_name(old_dorothy), 'dorothy.moved')
+        self.assertIs(conflicts.final_file_id(old_dorothy), None)
+        self.assertEqual(conflicts.final_name(new_dorothy), 'dorothy')
+        self.assertEqual(conflicts.final_file_id(new_dorothy), 'dorothy-id')
+        self.assertEqual(conflicts.final_parent(emerald), oz)
+        conflicts.apply()
+
+    def test_cook_conflicts(self):
+        tt, emerald, oz, old_dorothy, new_dorothy = self.get_conflicted()
+        raw_conflicts = resolve_conflicts(tt)
+        cooked_conflicts = cook_conflicts(raw_conflicts, tt)
+        duplicate = ('duplicate', 'Moved existing file to', 'dorothy.moved', 
+                     None, 'dorothy', 'dorothy-id')
+        self.assertEqual(cooked_conflicts[0], duplicate)
+        duplicate_id = ('duplicate id', 'Unversioned existing file', 
+                        'dorothy.moved', None, 'dorothy', 'dorothy-id')
+        self.assertEqual(cooked_conflicts[1], duplicate_id)
+        missing_parent = ('missing parent', 'Not deleting', 'oz', 'oz-id')
+        self.assertEqual(cooked_conflicts[2], missing_parent)
+        unversioned_parent = ('unversioned parent', 
+                              'Versioned directory', 'oz', 'oz-id')
+        self.assertEqual(cooked_conflicts[3], unversioned_parent)
+        parent_loop = ('parent loop', 'Cancelled move', 'oz/emeraldcity', 
+                       'emerald-id', 'oz/emeraldcity', 'emerald-id')
+        self.assertEqual(cooked_conflicts[4], parent_loop)
+        self.assertEqual(len(cooked_conflicts), 5)
+        tt.finalize()
+
+    def test_string_conflicts(self):
+        tt, emerald, oz, old_dorothy, new_dorothy = self.get_conflicted()
+        raw_conflicts = resolve_conflicts(tt)
+        cooked_conflicts = cook_conflicts(raw_conflicts, tt)
+        tt.finalize()
+        conflicts_s = list(conflicts_strings(cooked_conflicts))
+        self.assertEqual(len(cooked_conflicts), len(conflicts_s))
+        self.assertEqual(conflicts_s[0], 'Conflict adding file dorothy.  '
+                                         'Moved existing file to '
+                                         'dorothy.moved.')
+        self.assertEqual(conflicts_s[1], 'Conflict adding id to dorothy.  '
+                                         'Unversioned existing file '
+                                         'dorothy.moved.')
+        self.assertEqual(conflicts_s[2], 'Conflict adding files to oz.  '
+                                         'Not deleting.')
+        self.assertEqual(conflicts_s[3], 'Conflict adding versioned files to '
+                                         'oz.  Versioned directory.')
+        self.assertEqual(conflicts_s[4], 'Conflict moving oz/emeraldcity into'
+                                         ' oz/emeraldcity.  Cancelled move.')
+
+    def test_moving_versioned_directories(self):
+        create, root = self.get_transform()
+        kansas = create.new_directory('kansas', root, 'kansas-id')
+        create.new_directory('house', kansas, 'house-id')
+        create.new_directory('oz', root, 'oz-id')
+        create.apply()
+        cyclone, root = self.get_transform()
+        oz = cyclone.trans_id_tree_file_id('oz-id')
+        house = cyclone.trans_id_tree_file_id('house-id')
+        cyclone.adjust_path('house', oz, house)
+        cyclone.apply()
+
+    def test_moving_root(self):
+        create, root = self.get_transform()
+        fun = create.new_directory('fun', root, 'fun-id')
+        create.new_directory('sun', root, 'sun-id')
+        create.new_directory('moon', root, 'moon')
+        create.apply()
+        transform, root = self.get_transform()
+        transform.adjust_root_path('oldroot', fun)
+        new_root=transform.trans_id_tree_path('')
+        transform.version_file('new-root', new_root)
+        transform.apply()
+
+    def test_renames(self):
+        create, root = self.get_transform()
+        old = create.new_directory('old-parent', root, 'old-id')
+        intermediate = create.new_directory('intermediate', old, 'im-id')
+        myfile = create.new_file('myfile', intermediate, 'myfile-text',
+                                 'myfile-id')
+        create.apply()
+        rename, root = self.get_transform()
+        old = rename.trans_id_file_id('old-id')
+        rename.adjust_path('new', root, old)
+        myfile = rename.trans_id_file_id('myfile-id')
+        rename.set_executability(True, myfile)
+        rename.apply()
+
+    def test_find_interesting(self):
+        create, root = self.get_transform()
+        wt = create._tree
+        create.new_file('vfile', root, 'myfile-text', 'myfile-id')
+        create.new_file('uvfile', root, 'othertext')
+        create.apply()
+        self.assertEqual(find_interesting(wt, wt, ['vfile']),
+                         set(['myfile-id']))
+        self.assertRaises(NotVersionedError, find_interesting, wt, wt,
+                          ['uvfile'])
+
+
+class TransformGroup(object):
+    def __init__(self, dirname):
+        self.name = dirname
+        os.mkdir(dirname)
+        self.wt = BzrDir.create_standalone_workingtree(dirname)
+        self.b = self.wt.branch
+        self.tt = TreeTransform(self.wt)
+        self.root = self.tt.trans_id_tree_file_id(self.wt.get_root_id())
+
+def conflict_text(tree, merge):
+    template = '%s TREE\n%s%s\n%s%s MERGE-SOURCE\n'
+    return template % ('<' * 7, tree, '=' * 7, merge, '>' * 7)
+
+
+class TestTransformMerge(TestCaseInTempDir):
+    def test_text_merge(self):
+        base = TransformGroup("base")
+        base.tt.new_file('a', base.root, 'a\nb\nc\nd\be\n', 'a')
+        base.tt.new_file('b', base.root, 'b1', 'b')
+        base.tt.new_file('c', base.root, 'c', 'c')
+        base.tt.new_file('d', base.root, 'd', 'd')
+        base.tt.new_file('e', base.root, 'e', 'e')
+        base.tt.new_file('f', base.root, 'f', 'f')
+        base.tt.new_directory('g', base.root, 'g')
+        base.tt.new_directory('h', base.root, 'h')
+        base.tt.apply()
+        other = TransformGroup("other")
+        other.tt.new_file('a', other.root, 'y\nb\nc\nd\be\n', 'a')
+        other.tt.new_file('b', other.root, 'b2', 'b')
+        other.tt.new_file('c', other.root, 'c2', 'c')
+        other.tt.new_file('d', other.root, 'd', 'd')
+        other.tt.new_file('e', other.root, 'e2', 'e')
+        other.tt.new_file('f', other.root, 'f', 'f')
+        other.tt.new_file('g', other.root, 'g', 'g')
+        other.tt.new_file('h', other.root, 'h\ni\nj\nk\n', 'h')
+        other.tt.new_file('i', other.root, 'h\ni\nj\nk\n', 'i')
+        other.tt.apply()
+        this = TransformGroup("this")
+        this.tt.new_file('a', this.root, 'a\nb\nc\nd\bz\n', 'a')
+        this.tt.new_file('b', this.root, 'b', 'b')
+        this.tt.new_file('c', this.root, 'c', 'c')
+        this.tt.new_file('d', this.root, 'd2', 'd')
+        this.tt.new_file('e', this.root, 'e2', 'e')
+        this.tt.new_file('f', this.root, 'f', 'f')
+        this.tt.new_file('g', this.root, 'g', 'g')
+        this.tt.new_file('h', this.root, '1\n2\n3\n4\n', 'h')
+        this.tt.new_file('i', this.root, '1\n2\n3\n4\n', 'i')
+        this.tt.apply()
+        Merge3Merger(this.wt, this.wt, base.wt, other.wt)
+        # textual merge
+        self.assertEqual(this.wt.get_file('a').read(), 'y\nb\nc\nd\bz\n')
+        # three-way text conflict
+        self.assertEqual(this.wt.get_file('b').read(), 
+                         conflict_text('b', 'b2'))
+        # OTHER wins
+        self.assertEqual(this.wt.get_file('c').read(), 'c2')
+        # THIS wins
+        self.assertEqual(this.wt.get_file('d').read(), 'd2')
+        # Ambigious clean merge
+        self.assertEqual(this.wt.get_file('e').read(), 'e2')
+        # No change
+        self.assertEqual(this.wt.get_file('f').read(), 'f')
+        # Correct correct results when THIS == OTHER 
+        self.assertEqual(this.wt.get_file('g').read(), 'g')
+        # Text conflict when THIS & OTHER are text and BASE is dir
+        self.assertEqual(this.wt.get_file('h').read(), 
+                         conflict_text('1\n2\n3\n4\n', 'h\ni\nj\nk\n'))
+        self.assertEqual(this.wt.get_file_byname('h.THIS').read(),
+                         '1\n2\n3\n4\n')
+        self.assertEqual(this.wt.get_file_byname('h.OTHER').read(),
+                         'h\ni\nj\nk\n')
+        self.assertEqual(file_kind(this.wt.abspath('h.BASE')), 'directory')
+        self.assertEqual(this.wt.get_file('i').read(), 
+                         conflict_text('1\n2\n3\n4\n', 'h\ni\nj\nk\n'))
+        self.assertEqual(this.wt.get_file_byname('i.THIS').read(),
+                         '1\n2\n3\n4\n')
+        self.assertEqual(this.wt.get_file_byname('i.OTHER').read(),
+                         'h\ni\nj\nk\n')
+        self.assertEqual(os.path.exists(this.wt.abspath('i.BASE')), False)
+
+    def test_file_merge(self):
+        if not has_symlinks():
+            raise TestSkipped('Symlinks are not supported on this platform')
+        base = TransformGroup("BASE")
+        this = TransformGroup("THIS")
+        other = TransformGroup("OTHER")
+        for tg in this, base, other:
+            tg.tt.new_directory('a', tg.root, 'a')
+            tg.tt.new_symlink('b', tg.root, 'b', 'b')
+            tg.tt.new_file('c', tg.root, 'c', 'c')
+            tg.tt.new_symlink('d', tg.root, tg.name, 'd')
+        targets = ((base, 'base-e', 'base-f', None, None), 
+                   (this, 'other-e', 'this-f', 'other-g', 'this-h'), 
+                   (other, 'other-e', None, 'other-g', 'other-h'))
+        for tg, e_target, f_target, g_target, h_target in targets:
+            for link, target in (('e', e_target), ('f', f_target), 
+                                 ('g', g_target), ('h', h_target)):
+                if target is not None:
+                    tg.tt.new_symlink(link, tg.root, target, link)
+
+        for tg in this, base, other:
+            tg.tt.apply()
+        Merge3Merger(this.wt, this.wt, base.wt, other.wt)
+        self.assertIs(os.path.isdir(this.wt.abspath('a')), True)
+        self.assertIs(os.path.islink(this.wt.abspath('b')), True)
+        self.assertIs(os.path.isfile(this.wt.abspath('c')), True)
+        for suffix in ('THIS', 'BASE', 'OTHER'):
+            self.assertEqual(os.readlink(this.wt.abspath('d.'+suffix)), suffix)
+        self.assertIs(os.path.lexists(this.wt.abspath('d')), False)
+        self.assertEqual(this.wt.id2path('d'), 'd.OTHER')
+        self.assertEqual(this.wt.id2path('f'), 'f.THIS')
+        self.assertEqual(os.readlink(this.wt.abspath('e')), 'other-e')
+        self.assertIs(os.path.lexists(this.wt.abspath('e.THIS')), False)
+        self.assertIs(os.path.lexists(this.wt.abspath('e.OTHER')), False)
+        self.assertIs(os.path.lexists(this.wt.abspath('e.BASE')), False)
+        self.assertIs(os.path.lexists(this.wt.abspath('g')), True)
+        self.assertIs(os.path.lexists(this.wt.abspath('g.BASE')), False)
+        self.assertIs(os.path.lexists(this.wt.abspath('h')), False)
+        self.assertIs(os.path.lexists(this.wt.abspath('h.BASE')), False)
+        self.assertIs(os.path.lexists(this.wt.abspath('h.THIS')), True)
+        self.assertIs(os.path.lexists(this.wt.abspath('h.OTHER')), True)
+
+    def test_filename_merge(self):
+        base = TransformGroup("BASE")
+        this = TransformGroup("THIS")
+        other = TransformGroup("OTHER")
+        base_a, this_a, other_a = [t.tt.new_directory('a', t.root, 'a') 
+                                   for t in [base, this, other]]
+        base_b, this_b, other_b = [t.tt.new_directory('b', t.root, 'b') 
+                                   for t in [base, this, other]]
+        base.tt.new_directory('c', base_a, 'c')
+        this.tt.new_directory('c1', this_a, 'c')
+        other.tt.new_directory('c', other_b, 'c')
+
+        base.tt.new_directory('d', base_a, 'd')
+        this.tt.new_directory('d1', this_b, 'd')
+        other.tt.new_directory('d', other_a, 'd')
+
+        base.tt.new_directory('e', base_a, 'e')
+        this.tt.new_directory('e', this_a, 'e')
+        other.tt.new_directory('e1', other_b, 'e')
+
+        base.tt.new_directory('f', base_a, 'f')
+        this.tt.new_directory('f1', this_b, 'f')
+        other.tt.new_directory('f1', other_b, 'f')
+
+        for tg in [this, base, other]:
+            tg.tt.apply()
+        Merge3Merger(this.wt, this.wt, base.wt, other.wt)
+        self.assertEqual(this.wt.id2path('c'), pathjoin('b/c1'))
+        self.assertEqual(this.wt.id2path('d'), pathjoin('b/d1'))
+        self.assertEqual(this.wt.id2path('e'), pathjoin('b/e1'))
+        self.assertEqual(this.wt.id2path('f'), pathjoin('b/f1'))
+
+    def test_filename_merge_conflicts(self):
+        base = TransformGroup("BASE")
+        this = TransformGroup("THIS")
+        other = TransformGroup("OTHER")
+        base_a, this_a, other_a = [t.tt.new_directory('a', t.root, 'a') 
+                                   for t in [base, this, other]]
+        base_b, this_b, other_b = [t.tt.new_directory('b', t.root, 'b') 
+                                   for t in [base, this, other]]
+
+        base.tt.new_file('g', base_a, 'g', 'g')
+        other.tt.new_file('g1', other_b, 'g1', 'g')
+
+        base.tt.new_file('h', base_a, 'h', 'h')
+        this.tt.new_file('h1', this_b, 'h1', 'h')
+
+        base.tt.new_file('i', base.root, 'i', 'i')
+        other.tt.new_directory('i1', this_b, 'i')
+
+        for tg in [this, base, other]:
+            tg.tt.apply()
+        Merge3Merger(this.wt, this.wt, base.wt, other.wt)
+
+        self.assertEqual(this.wt.id2path('g'), pathjoin('b/g1.OTHER'))
+        self.assertIs(os.path.lexists(this.wt.abspath('b/g1.BASE')), True)
+        self.assertIs(os.path.lexists(this.wt.abspath('b/g1.THIS')), False)
+        self.assertEqual(this.wt.id2path('h'), pathjoin('b/h1.THIS'))
+        self.assertIs(os.path.lexists(this.wt.abspath('b/h1.BASE')), True)
+        self.assertIs(os.path.lexists(this.wt.abspath('b/h1.OTHER')), False)
+        self.assertEqual(this.wt.id2path('i'), pathjoin('b/i1.OTHER'))
+
+class TestBuildTree(TestCaseInTempDir):
+    def test_build_tree(self):
+        if not has_symlinks():
+            raise TestSkipped('Test requires symlink support')
+        os.mkdir('a')
+        a = BzrDir.create_standalone_workingtree('a')
+        os.mkdir('a/foo')
+        file('a/foo/bar', 'wb').write('contents')
+        os.symlink('a/foo/bar', 'a/foo/baz')
+        a.add(['foo', 'foo/bar', 'foo/baz'])
+        a.commit('initial commit')
+        b = BzrDir.create_standalone_workingtree('b')
+        build_tree(a.basis_tree(), b)
+        self.assertIs(os.path.isdir('b/foo'), True)
+        self.assertEqual(file('b/foo/bar', 'rb').read(), "contents")
+        self.assertEqual(os.readlink('b/foo/baz'), 'a/foo/bar')

=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_transport.py	2006-03-20 08:31:00 +0000
@@ -22,33 +22,14 @@
 
 from bzrlib.errors import (NoSuchFile, FileExists,
                            TransportNotPossible, ConnectionError)
-from bzrlib.tests import TestCase, TestCaseInTempDir
-from bzrlib.tests.HTTPTestUtil import TestCaseWithWebserver
-from bzrlib.transport import memory, urlescape
-from bzrlib.osutils import pathjoin
-
-
-def _append(fn, txt):
-    """Append the given text (file-like object) to the supplied filename."""
-    f = open(fn, 'ab')
-    f.write(txt)
-    f.flush()
-    f.close()
-    del f
-
-
-if sys.platform != 'win32':
-    def check_mode(test, path, mode):
-        """Check that a particular path has the correct mode."""
-        actual_mode = stat.S_IMODE(os.stat(path).st_mode)
-        test.assertEqual(mode, actual_mode,
-            'mode of %r incorrect (%o != %o)' % (path, mode, actual_mode))
-else:
-    def check_mode(test, path, mode):
-        """On win32 chmod doesn't have any effect, 
-        so don't actually check anything
-        """
-        return
+from bzrlib.tests import TestCase
+from bzrlib.transport import (_get_protocol_handlers,
+                              _get_transport_modules,
+                              get_transport,
+                              register_lazy_transport,
+                              _set_protocol_handlers,
+                              urlescape,
+                              )
 
 
 class TestTransport(TestCase):
@@ -57,857 +38,64 @@
     def test_urlescape(self):
         self.assertEqual('%25', urlescape('%'))
 
-
-class TestTransportMixIn(object):
-    """Subclass this, and it will provide a series of tests for a Transport.
-    It assumes that the Transport object is connected to the 
-    current working directory.  So that whatever is done 
-    through the transport, should show up in the working 
-    directory, and vice-versa.
-
-    This also tests to make sure that the functions work with both
-    generators and lists (assuming iter(list) is effectively a generator)
-    """
-    readonly = False
-    def get_transport(self):
-        """Children should override this to return the Transport object.
-        """
-        raise NotImplementedError
-
-    def assertListRaises(self, excClass, func, *args, **kwargs):
-        """Many transport functions can return generators this makes sure
-        to wrap them in a list() call to make sure the whole generator
-        is run, and that the proper exception is raised.
-        """
-        try:
-            list(func(*args, **kwargs))
-        except excClass:
-            return
-        else:
-            if hasattr(excClass,'__name__'): excName = excClass.__name__
-            else: excName = str(excClass)
-            raise self.failureException, "%s not raised" % excName
-
-    def test_has(self):
-        t = self.get_transport()
-
-        files = ['a', 'b', 'e', 'g', '%']
-        self.build_tree(files)
-        self.assertEqual(True, t.has('a'))
-        self.assertEqual(False, t.has('c'))
-        self.assertEqual(True, t.has(urlescape('%')))
-        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'])),
-                [True, True, False, False, True, False, True, False])
-        self.assertEqual(True, t.has_any(['a', 'b', 'c']))
-        self.assertEqual(False, t.has_any(['c', 'd', 'f', urlescape('%%')]))
-        self.assertEqual(list(t.has_multi(iter(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h']))),
-                [True, True, False, False, True, False, True, False])
-        self.assertEqual(False, t.has_any(['c', 'c', 'c']))
-        self.assertEqual(True, t.has_any(['b', 'b', 'b']))
-
-    def test_get(self):
-        t = self.get_transport()
-
-        files = ['a', 'b', 'e', 'g']
-        self.build_tree(files)
-        self.assertEqual(open('a', 'rb').read(), t.get('a').read())
-        content_f = t.get_multi(files)
-        for path,f in zip(files, content_f):
-            self.assertEqual(f.read(), open(path, 'rb').read())
-
-        content_f = t.get_multi(iter(files))
-        for path,f in zip(files, content_f):
-            self.assertEqual(f.read(), open(path, 'rb').read())
-
-        self.assertRaises(NoSuchFile, t.get, 'c')
-        self.assertListRaises(NoSuchFile, t.get_multi, ['a', 'b', 'c'])
-        self.assertListRaises(NoSuchFile, t.get_multi, iter(['a', 'b', 'c']))
-
-    def test_put(self):
-        t = self.get_transport()
-
-        # TODO: jam 20051215 No need to do anything if the test is readonly
-        #                    origininally it was thought that it would give
-        #                    more of a workout to readonly tests. By now the
-        #                    suite is probably thorough enough without testing
-        #                    readonly protocols in write sections
-        #                    The only thing that needs to be tested is that the
-        #                    right error is raised
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.put, 'a', 'some text for a\n')
-            open('a', 'wb').write('some text for a\n')
-        else:
-            t.put('a', 'some text for a\n')
-        self.assert_(os.path.exists('a'))
-        self.check_file_contents('a', 'some text for a\n')
-        self.assertEqual(t.get('a').read(), 'some text for a\n')
-        # Make sure 'has' is updated
-        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e'])),
-                [True, False, False, False, False])
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.put_multi,
-                    [('a', 'new\ncontents for\na\n'),
-                        ('d', 'contents\nfor d\n')])
-            open('a', 'wb').write('new\ncontents for\na\n')
-            open('d', 'wb').write('contents\nfor d\n')
-        else:
-            # Put also replaces contents
-            self.assertEqual(t.put_multi([('a', 'new\ncontents for\na\n'),
-                                          ('d', 'contents\nfor d\n')]),
-                             2)
-        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e'])),
-                [True, False, False, True, False])
-        self.check_file_contents('a', 'new\ncontents for\na\n')
-        self.check_file_contents('d', 'contents\nfor d\n')
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                t.put_multi, iter([('a', 'diff\ncontents for\na\n'),
-                                  ('d', 'another contents\nfor d\n')]))
-            open('a', 'wb').write('diff\ncontents for\na\n')
-            open('d', 'wb').write('another contents\nfor d\n')
-        else:
-            self.assertEqual(
-                t.put_multi(iter([('a', 'diff\ncontents for\na\n'),
-                                  ('d', 'another contents\nfor d\n')]))
-                             , 2)
-        self.check_file_contents('a', 'diff\ncontents for\na\n')
-        self.check_file_contents('d', 'another contents\nfor d\n')
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.put, 'path/doesnt/exist/c', 'contents')
-        else:
-            self.assertRaises(NoSuchFile,
-                    t.put, 'path/doesnt/exist/c', 'contents')
-
-        if not self.readonly:
-            t.put('mode644', 'test text\n', mode=0644)
-            check_mode(self, 'mode644', 0644)
-
-            t.put('mode666', 'test text\n', mode=0666)
-            check_mode(self, 'mode666', 0666)
-
-            t.put('mode600', 'test text\n', mode=0600)
-            check_mode(self, 'mode600', 0600)
-
-            # Yes, you can put a file such that it becomes readonly
-            t.put('mode400', 'test text\n', mode=0400)
-            check_mode(self, 'mode400', 0400)
-
-            t.put_multi([('mmode644', 'text\n')], mode=0644)
-            check_mode(self, 'mmode644', 0644)
-
-        # TODO: jam 20051215 test put_multi with a mode. I didn't bother because
-        #                    it seems most people don't like the _multi functions
-
-    def test_put_file(self):
-        t = self.get_transport()
-
-        # Test that StringIO can be used as a file-like object with put
-        f1 = StringIO('this is a string\nand some more stuff\n')
-        if self.readonly:
-            open('f1', 'wb').write(f1.read())
-        else:
-            t.put('f1', f1)
-
-        del f1
-
-        self.check_file_contents('f1', 
-                'this is a string\nand some more stuff\n')
-
-        f2 = StringIO('here is some text\nand a bit more\n')
-        f3 = StringIO('some text for the\nthird file created\n')
-
-        if self.readonly:
-            open('f2', 'wb').write(f2.read())
-            open('f3', 'wb').write(f3.read())
-        else:
-            t.put_multi([('f2', f2), ('f3', f3)])
-
-        del f2, f3
-
-        self.check_file_contents('f2', 'here is some text\nand a bit more\n')
-        self.check_file_contents('f3', 'some text for the\nthird file created\n')
-
-        # Test that an actual file object can be used with put
-        f4 = open('f1', 'rb')
-        if self.readonly:
-            open('f4', 'wb').write(f4.read())
-        else:
-            t.put('f4', f4)
-
-        del f4
-
-        self.check_file_contents('f4', 
-                'this is a string\nand some more stuff\n')
-
-        f5 = open('f2', 'rb')
-        f6 = open('f3', 'rb')
-        if self.readonly:
-            open('f5', 'wb').write(f5.read())
-            open('f6', 'wb').write(f6.read())
-        else:
-            t.put_multi([('f5', f5), ('f6', f6)])
-
-        del f5, f6
-
-        self.check_file_contents('f5', 'here is some text\nand a bit more\n')
-        self.check_file_contents('f6', 'some text for the\nthird file created\n')
-
-        if not self.readonly:
-            sio = StringIO('test text\n')
-            t.put('mode644', sio, mode=0644)
-            check_mode(self, 'mode644', 0644)
-
-            a = open('mode644', 'rb')
-            t.put('mode666', a, mode=0666)
-            check_mode(self, 'mode666', 0666)
-
-            a = open('mode644', 'rb')
-            t.put('mode600', a, mode=0600)
-            check_mode(self, 'mode600', 0600)
-
-            # Yes, you can put a file such that it becomes readonly
-            a = open('mode644', 'rb')
-            t.put('mode400', a, mode=0400)
-            check_mode(self, 'mode400', 0400)
-
-    def test_mkdir(self):
-        t = self.get_transport()
-
-        # Test mkdir
-        os.mkdir('dir_a')
-        self.assertEqual(t.has('dir_a'), True)
-        self.assertEqual(t.has('dir_b'), False)
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.mkdir, 'dir_b')
-            os.mkdir('dir_b')
-        else:
-            t.mkdir('dir_b')
-        self.assertEqual(t.has('dir_b'), True)
-        self.assert_(os.path.isdir('dir_b'))
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.mkdir_multi, ['dir_c', 'dir_d'])
-            os.mkdir('dir_c')
-            os.mkdir('dir_d')
-        else:
-            t.mkdir_multi(['dir_c', 'dir_d'])
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.mkdir_multi, iter(['dir_e', 'dir_f']))
-            os.mkdir('dir_e')
-            os.mkdir('dir_f')
-        else:
-            t.mkdir_multi(iter(['dir_e', 'dir_f']))
-        self.assertEqual(list(t.has_multi(
-            ['dir_a', 'dir_b', 'dir_c', 'dir_q',
-             'dir_d', 'dir_e', 'dir_f', 'dir_b'])),
-            [True, True, True, False,
-             True, True, True, True])
-        for d in ['dir_a', 'dir_b', 'dir_c', 'dir_d', 'dir_e', 'dir_f']:
-            self.assert_(os.path.isdir(d))
-
-        if not self.readonly:
-            self.assertRaises(NoSuchFile, t.mkdir, 'path/doesnt/exist')
-            self.assertRaises(FileExists, t.mkdir, 'dir_a') # Creating a directory again should fail
-
-        # Make sure the transport recognizes when a
-        # directory is created by other means
-        # Caching Transports will fail, because dir_e was already seen not
-        # to exist. So instead, we will search for a new directory
-        #os.mkdir('dir_e')
-        #if not self.readonly:
-        #    self.assertRaises(FileExists, t.mkdir, 'dir_e')
-
-        os.mkdir('dir_g')
-        if not self.readonly:
-            self.assertRaises(FileExists, t.mkdir, 'dir_g')
-
-        # Test get/put in sub-directories
-        if self.readonly:
-            open('dir_a/a', 'wb').write('contents of dir_a/a')
-            open('dir_b/b', 'wb').write('contents of dir_b/b')
-        else:
-            self.assertEqual(
-                t.put_multi([('dir_a/a', 'contents of dir_a/a'),
-                             ('dir_b/b', 'contents of dir_b/b')])
-                          , 2)
-        for f in ('dir_a/a', 'dir_b/b'):
-            self.assertEqual(t.get(f).read(), open(f, 'rb').read())
-
-        if not self.readonly:
-            # Test mkdir with a mode
-            t.mkdir('dmode755', mode=0755)
-            check_mode(self, 'dmode755', 0755)
-
-            t.mkdir('dmode555', mode=0555)
-            check_mode(self, 'dmode555', 0555)
-
-            t.mkdir('dmode777', mode=0777)
-            check_mode(self, 'dmode777', 0777)
-
-            t.mkdir('dmode700', mode=0700)
-            check_mode(self, 'dmode700', 0700)
-
-            # TODO: jam 20051215 test mkdir_multi with a mode
-            t.mkdir_multi(['mdmode755'], mode=0755)
-            check_mode(self, 'mdmode755', 0755)
-
-
-    def test_copy_to(self):
-        import tempfile
-        from bzrlib.transport.local import LocalTransport
-
-        t = self.get_transport()
-
-        files = ['a', 'b', 'c', 'd']
-        self.build_tree(files)
-
-        def get_temp_local():
-            dtmp = tempfile.mkdtemp(dir=u'.', prefix='test-transport-')
-            dtmp_base = os.path.basename(dtmp)
-            return dtmp_base, LocalTransport(dtmp)
-        dtmp_base, local_t = get_temp_local()
-
-        t.copy_to(files, local_t)
-        for f in files:
-            self.assertEquals(open(f, 'rb').read(),
-                    open(pathjoin(dtmp_base, f), 'rb').read())
-
-        # Test that copying into a missing directory raises
-        # NoSuchFile
-        os.mkdir('e')
-        open('e/f', 'wb').write('contents of e')
-        self.assertRaises(NoSuchFile, t.copy_to, ['e/f'], local_t)
-
-        os.mkdir(pathjoin(dtmp_base, 'e'))
-        t.copy_to(['e/f'], local_t)
-
-        del dtmp_base, local_t
-
-        dtmp_base, local_t = get_temp_local()
-
-        files = ['a', 'b', 'c', 'd']
-        t.copy_to(iter(files), local_t)
-        for f in files:
-            self.assertEquals(open(f, 'rb').read(),
-                    open(pathjoin(dtmp_base, f), 'rb').read())
-
-        del dtmp_base, local_t
-
-        for mode in (0666, 0644, 0600, 0400):
-            dtmp_base, local_t = get_temp_local()
-            t.copy_to(files, local_t, mode=mode)
-            for f in files:
-                check_mode(self, os.path.join(dtmp_base, f), mode)
-
-    def test_append(self):
-        t = self.get_transport()
-
-        if self.readonly:
-            open('a', 'wb').write('diff\ncontents for\na\n')
-            open('b', 'wb').write('contents\nfor b\n')
-        else:
-            t.put_multi([
-                    ('a', 'diff\ncontents for\na\n'),
-                    ('b', 'contents\nfor b\n')
-                    ])
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.append, 'a', 'add\nsome\nmore\ncontents\n')
-            _append('a', 'add\nsome\nmore\ncontents\n')
-        else:
-            t.append('a', 'add\nsome\nmore\ncontents\n')
-
-        self.check_file_contents('a', 
-            'diff\ncontents for\na\nadd\nsome\nmore\ncontents\n')
-
-        if self.readonly:
-            self.assertRaises(TransportNotPossible,
-                    t.append_multi,
-                        [('a', 'and\nthen\nsome\nmore\n'),
-                         ('b', 'some\nmore\nfor\nb\n')])
-            _append('a', 'and\nthen\nsome\nmore\n')
-            _append('b', 'some\nmore\nfor\nb\n')
-        else:
-            t.append_multi([('a', 'and\nthen\nsome\nmore\n'),
-                    ('b', 'some\nmore\nfor\nb\n')])
-        self.check_file_contents('a', 
-            'diff\ncontents for\na\n'
-            'add\nsome\nmore\ncontents\n'
-            'and\nthen\nsome\nmore\n')
-        self.check_file_contents('b', 
-                'contents\nfor b\n'
-                'some\nmore\nfor\nb\n')
-
-        if self.readonly:
-            _append('a', 'a little bit more\n')
-            _append('b', 'from an iterator\n')
-        else:
-            t.append_multi(iter([('a', 'a little bit more\n'),
-                    ('b', 'from an iterator\n')]))
-        self.check_file_contents('a', 
-            'diff\ncontents for\na\n'
-            'add\nsome\nmore\ncontents\n'
-            'and\nthen\nsome\nmore\n'
-            'a little bit more\n')
-        self.check_file_contents('b', 
-                'contents\nfor b\n'
-                'some\nmore\nfor\nb\n'
-                'from an iterator\n')
-
-        if self.readonly:
-            _append('c', 'some text\nfor a missing file\n')
-            _append('a', 'some text in a\n')
-            _append('d', 'missing file r\n')
-        else:
-            t.append('c', 'some text\nfor a missing file\n')
-            t.append_multi([('a', 'some text in a\n'),
-                            ('d', 'missing file r\n')])
-        self.check_file_contents('a', 
-            'diff\ncontents for\na\n'
-            'add\nsome\nmore\ncontents\n'
-            'and\nthen\nsome\nmore\n'
-            'a little bit more\n'
-            'some text in a\n')
-        self.check_file_contents('c', 'some text\nfor a missing file\n')
-        self.check_file_contents('d', 'missing file r\n')
-
-    def test_append_file(self):
-        t = self.get_transport()
-
-        contents = [
-            ('f1', 'this is a string\nand some more stuff\n'),
-            ('f2', 'here is some text\nand a bit more\n'),
-            ('f3', 'some text for the\nthird file created\n'),
-            ('f4', 'this is a string\nand some more stuff\n'),
-            ('f5', 'here is some text\nand a bit more\n'),
-            ('f6', 'some text for the\nthird file created\n')
-        ]
-        
-        if self.readonly:
-            for f, val in contents:
-                open(f, 'wb').write(val)
-        else:
-            t.put_multi(contents)
-
-        a1 = StringIO('appending to\none\n')
-        if self.readonly:
-            _append('f1', a1.read())
-        else:
-            t.append('f1', a1)
-
-        del a1
-
-        self.check_file_contents('f1', 
-                'this is a string\nand some more stuff\n'
-                'appending to\none\n')
-
-        a2 = StringIO('adding more\ntext to two\n')
-        a3 = StringIO('some garbage\nto put in three\n')
-
-        if self.readonly:
-            _append('f2', a2.read())
-            _append('f3', a3.read())
-        else:
-            t.append_multi([('f2', a2), ('f3', a3)])
-
-        del a2, a3
-
-        self.check_file_contents('f2',
-                'here is some text\nand a bit more\n'
-                'adding more\ntext to two\n')
-        self.check_file_contents('f3', 
-                'some text for the\nthird file created\n'
-                'some garbage\nto put in three\n')
-
-        # Test that an actual file object can be used with put
-        a4 = open('f1', 'rb')
-        if self.readonly:
-            _append('f4', a4.read())
-        else:
-            t.append('f4', a4)
-
-        del a4
-
-        self.check_file_contents('f4', 
-                'this is a string\nand some more stuff\n'
-                'this is a string\nand some more stuff\n'
-                'appending to\none\n')
-
-        a5 = open('f2', 'rb')
-        a6 = open('f3', 'rb')
-        if self.readonly:
-            _append('f5', a5.read())
-            _append('f6', a6.read())
-        else:
-            t.append_multi([('f5', a5), ('f6', a6)])
-
-        del a5, a6
-
-        self.check_file_contents('f5',
-                'here is some text\nand a bit more\n'
-                'here is some text\nand a bit more\n'
-                'adding more\ntext to two\n')
-        self.check_file_contents('f6',
-                'some text for the\nthird file created\n'
-                'some text for the\nthird file created\n'
-                'some garbage\nto put in three\n')
-
-        a5 = open('f2', 'rb')
-        a6 = open('f2', 'rb')
-        a7 = open('f3', 'rb')
-        if self.readonly:
-            _append('c', a5.read())
-            _append('a', a6.read())
-            _append('d', a7.read())
-        else:
-            t.append('c', a5)
-            t.append_multi([('a', a6), ('d', a7)])
-        del a5, a6, a7
-        self.check_file_contents('c', open('f2', 'rb').read())
-        self.check_file_contents('d', open('f3', 'rb').read())
-
-
-    def test_delete(self):
-        # TODO: Test Transport.delete
-        t = self.get_transport()
-
-        # Not much to do with a readonly transport
-        if self.readonly:
-            return
-
-        open('a', 'wb').write('a little bit of text\n')
-        self.failUnless(t.has('a'))
-        self.failUnlessExists('a')
-        t.delete('a')
-        self.failIf(os.path.lexists('a'))
-
-        self.assertRaises(NoSuchFile, t.delete, 'a')
-
-        open('a', 'wb').write('a text\n')
-        open('b', 'wb').write('b text\n')
-        open('c', 'wb').write('c text\n')
-        self.assertEqual([True, True, True],
-                list(t.has_multi(['a', 'b', 'c'])))
-        t.delete_multi(['a', 'c'])
-        self.assertEqual([False, True, False],
-                list(t.has_multi(['a', 'b', 'c'])))
-        self.failIf(os.path.lexists('a'))
-        self.failUnlessExists('b')
-        self.failIf(os.path.lexists('c'))
-
-        self.assertRaises(NoSuchFile,
-                t.delete_multi, ['a', 'b', 'c'])
-
-        self.assertRaises(NoSuchFile,
-                t.delete_multi, iter(['a', 'b', 'c']))
-
-        open('a', 'wb').write('another a text\n')
-        open('c', 'wb').write('another c text\n')
-        t.delete_multi(iter(['a', 'b', 'c']))
-
-        # We should have deleted everything
-        # SftpServer creates control files in the
-        # working directory, so we can just do a
-        # plain "listdir".
-        # self.assertEqual([], os.listdir('.'))
-
-    def test_move(self):
-        t = self.get_transport()
-
-        if self.readonly:
-            return
-
-        # TODO: I would like to use os.listdir() to
-        # make sure there are no extra files, but SftpServer
-        # creates control files in the working directory
-        # perhaps all of this could be done in a subdirectory
-
-        open('a', 'wb').write('a first file\n')
-        self.assertEquals([True, False], list(t.has_multi(['a', 'b'])))
-
-        t.move('a', 'b')
-        self.failUnlessExists('b')
-        self.failIf(os.path.lexists('a'))
-
-        self.check_file_contents('b', 'a first file\n')
-        self.assertEquals([False, True], list(t.has_multi(['a', 'b'])))
-
-        # Overwrite a file
-        open('c', 'wb').write('c this file\n')
-        t.move('c', 'b')
-        self.failIf(os.path.lexists('c'))
-        self.check_file_contents('b', 'c this file\n')
-
-        # TODO: Try to write a test for atomicity
-        # TODO: Test moving into a non-existant subdirectory
-        # TODO: Test Transport.move_multi
-
-    def test_copy(self):
-        t = self.get_transport()
-
-        if self.readonly:
-            return
-
-        open('a', 'wb').write('a file\n')
-        t.copy('a', 'b')
-        self.check_file_contents('b', 'a file\n')
-
-        self.assertRaises(NoSuchFile, t.copy, 'c', 'd')
-        os.mkdir('c')
-        # What should the assert be if you try to copy a
-        # file over a directory?
-        #self.assertRaises(Something, t.copy, 'a', 'c')
-        open('d', 'wb').write('text in d\n')
-        t.copy('d', 'b')
-        self.check_file_contents('b', 'text in d\n')
-
-        # TODO: test copy_multi
-
-    def test_connection_error(self):
-        """ConnectionError is raised when connection is impossible"""
-        if not hasattr(self, "get_bogus_transport"):
-            return
-        t = self.get_bogus_transport()
-        try:
-            t.get('.bzr/branch')
-        except (ConnectionError, NoSuchFile), e:
-            pass
-        except (Exception), e:
-            self.failIf(True, 'Wrong exception thrown: %s' % e)
-        else:
-            self.failIf(True, 'Did not get the expected exception.')
-
-    def test_stat(self):
-        # TODO: Test stat, just try once, and if it throws, stop testing
-        from stat import S_ISDIR, S_ISREG
-
-        t = self.get_transport()
-
-        try:
-            st = t.stat('.')
-        except TransportNotPossible, e:
-            # This transport cannot stat
-            return
-
-        paths = ['a', 'b/', 'b/c', 'b/d/', 'b/d/e']
-        self.build_tree(paths)
-
-        local_stats = []
-
-        for p in paths:
-            st = t.stat(p)
-            local_st = os.stat(p)
-            if p.endswith('/'):
-                self.failUnless(S_ISDIR(st.st_mode))
-            else:
-                self.failUnless(S_ISREG(st.st_mode))
-            self.assertEqual(local_st.st_size, st.st_size)
-            self.assertEqual(local_st.st_mode, st.st_mode)
-            local_stats.append(local_st)
-
-        remote_stats = list(t.stat_multi(paths))
-        remote_iter_stats = list(t.stat_multi(iter(paths)))
-
-        for local, remote, remote_iter in \
-            zip(local_stats, remote_stats, remote_iter_stats):
-            self.assertEqual(local.st_mode, remote.st_mode)
-            self.assertEqual(local.st_mode, remote_iter.st_mode)
-
-            self.assertEqual(local.st_size, remote.st_size)
-            self.assertEqual(local.st_size, remote_iter.st_size)
-            # Should we test UID/GID?
-
-        self.assertRaises(NoSuchFile, t.stat, 'q')
-        self.assertRaises(NoSuchFile, t.stat, 'b/a')
-
-        self.assertListRaises(NoSuchFile, t.stat_multi, ['a', 'c', 'd'])
-        self.assertListRaises(NoSuchFile, t.stat_multi, iter(['a', 'c', 'd']))
-
-    def test_list_dir(self):
-        # TODO: Test list_dir, just try once, and if it throws, stop testing
-        t = self.get_transport()
-        
-        if not t.listable():
-            self.assertRaises(TransportNotPossible, t.list_dir, '.')
-            return
-
-        def sorted_list(d):
-            l = list(t.list_dir(d))
-            l.sort()
-            return l
-
-        # SftpServer creates control files in the working directory
-        # so lets move down a directory to be safe
-        os.mkdir('wd')
-        os.chdir('wd')
-        t = t.clone('wd')
-
-        self.assertEqual([], sorted_list(u'.'))
-        self.build_tree(['a', 'b', 'c/', 'c/d', 'c/e'])
-
-        self.assertEqual([u'a', u'b', u'c'], sorted_list(u'.'))
-        self.assertEqual([u'd', u'e'], sorted_list(u'c'))
-
-        os.remove('c/d')
-        os.remove('b')
-        self.assertEqual([u'a', u'c'], sorted_list('.'))
-        self.assertEqual([u'e'], sorted_list(u'c'))
-
-        self.assertListRaises(NoSuchFile, t.list_dir, 'q')
-        self.assertListRaises(NoSuchFile, t.list_dir, 'c/f')
-        self.assertListRaises(NoSuchFile, t.list_dir, 'a')
-
-    def test_clone(self):
-        # TODO: Test that clone moves up and down the filesystem
-        t1 = self.get_transport()
-
-        self.build_tree(['a', 'b/', 'b/c'])
-
-        self.failUnless(t1.has('a'))
-        self.failUnless(t1.has('b/c'))
-        self.failIf(t1.has('c'))
-
-        t2 = t1.clone('b')
-        self.failUnless(t2.has('c'))
-        self.failIf(t2.has('a'))
-
-        t3 = t2.clone('..')
-        self.failUnless(t3.has('a'))
-        self.failIf(t3.has('c'))
-
-        self.failIf(t1.has('b/d'))
-        self.failIf(t2.has('d'))
-        self.failIf(t3.has('b/d'))
-
-        if self.readonly:
-            open('b/d', 'wb').write('newfile\n')
-        else:
-            t2.put('d', 'newfile\n')
-
-        self.failUnless(t1.has('b/d'))
-        self.failUnless(t2.has('d'))
-        self.failUnless(t3.has('b/d'))
-
-        
-class LocalTransportTest(TestCaseInTempDir, TestTransportMixIn):
-    def get_transport(self):
-        from bzrlib.transport.local import LocalTransport
-        return LocalTransport(u'.')
-
-
-class HttpTransportTest(TestCaseWithWebserver, TestTransportMixIn):
-
-    readonly = True
-
-    def get_transport(self):
-        from bzrlib.transport.http import HttpTransport
-        url = self.get_remote_url(u'.')
-        return HttpTransport(url)
-
-    def get_bogus_transport(self):
-        from bzrlib.transport.http import HttpTransport
-        return HttpTransport('http://jasldkjsalkdjalksjdkljasd')
-
-
-class TestMemoryTransport(TestCase):
-
-    def test_get_transport(self):
-        memory.MemoryTransport()
-
-    def test_clone(self):
-        transport = memory.MemoryTransport()
-        self.failUnless(transport.clone() is transport)
-
-    def test_abspath(self):
-        transport = memory.MemoryTransport()
-        self.assertEqual("in-memory:relpath", transport.abspath('relpath'))
-
-    def test_relpath(self):
-        transport = memory.MemoryTransport()
-
-    def test_append_and_get(self):
-        transport = memory.MemoryTransport()
-        transport.append('path', StringIO('content'))
-        self.assertEqual(transport.get('path').read(), 'content')
-        transport.append('path', StringIO('content'))
-        self.assertEqual(transport.get('path').read(), 'contentcontent')
-
-    def test_put_and_get(self):
-        transport = memory.MemoryTransport()
-        transport.put('path', StringIO('content'))
-        self.assertEqual(transport.get('path').read(), 'content')
-        transport.put('path', StringIO('content'))
-        self.assertEqual(transport.get('path').read(), 'content')
-
-    def test_append_without_dir_fails(self):
-        transport = memory.MemoryTransport()
-        self.assertRaises(NoSuchFile,
-                          transport.append, 'dir/path', StringIO('content'))
-
-    def test_put_without_dir_fails(self):
-        transport = memory.MemoryTransport()
-        self.assertRaises(NoSuchFile,
-                          transport.put, 'dir/path', StringIO('content'))
-
-    def test_get_missing(self):
-        transport = memory.MemoryTransport()
-        self.assertRaises(NoSuchFile, transport.get, 'foo')
-
-    def test_has_missing(self):
-        transport = memory.MemoryTransport()
-        self.assertEquals(False, transport.has('foo'))
-
-    def test_has_present(self):
-        transport = memory.MemoryTransport()
-        transport.append('foo', StringIO('content'))
-        self.assertEquals(True, transport.has('foo'))
-
-    def test_mkdir(self):
-        transport = memory.MemoryTransport()
-        transport.mkdir('dir')
-        transport.append('dir/path', StringIO('content'))
-        self.assertEqual(transport.get('dir/path').read(), 'content')
-
-    def test_mkdir_missing_parent(self):
-        transport = memory.MemoryTransport()
-        self.assertRaises(NoSuchFile,
-                          transport.mkdir, 'dir/dir')
-
-    def test_mkdir_twice(self):
-        transport = memory.MemoryTransport()
-        transport.mkdir('dir')
-        self.assertRaises(FileExists, transport.mkdir, 'dir')
+    def test__get_set_protocol_handlers(self):
+        handlers = _get_protocol_handlers()
+        self.assertNotEqual({}, handlers)
+        try:
+            _set_protocol_handlers({})
+            self.assertEqual({}, _get_protocol_handlers())
+        finally:
+            _set_protocol_handlers(handlers)
+
+    def test_get_transport_modules(self):
+        handlers = _get_protocol_handlers()
+        class SampleHandler(object):
+            """I exist, isnt that enough?"""
+        try:
+            my_handlers = {}
+            _set_protocol_handlers(my_handlers)
+            register_lazy_transport('foo', 'bzrlib.tests.test_transport', 'TestTransport.SampleHandler')
+            register_lazy_transport('bar', 'bzrlib.tests.test_transport', 'TestTransport.SampleHandler')
+            self.assertEqual([SampleHandler.__module__],
+                             _get_transport_modules())
+        finally:
+            _set_protocol_handlers(handlers)
+            
+
+class MemoryTransportTest(TestCase):
+    """Memory transport specific tests."""
 
     def test_parameters(self):
-        transport = memory.MemoryTransport()
-        self.assertEqual(True, transport.listable())
-        self.assertEqual(False, transport.should_cache())
-
-    def test_iter_files_recursive(self):
-        transport = memory.MemoryTransport()
-        transport.mkdir('dir')
-        transport.put('dir/foo', StringIO('content'))
-        transport.put('dir/bar', StringIO('content'))
-        transport.put('bar', StringIO('content'))
-        paths = set(transport.iter_files_recursive())
-        self.assertEqual(set(['dir/foo', 'dir/bar', 'bar']), paths)
-
-    def test_stat(self):
-        transport = memory.MemoryTransport()
-        transport.put('foo', StringIO('content'))
-        transport.put('bar', StringIO('phowar'))
-        self.assertEqual(7, transport.stat('foo').st_size)
-        self.assertEqual(6, transport.stat('bar').st_size)
-
+        import bzrlib.transport.memory as memory
+        transport = memory.MemoryTransport()
+        self.assertEqual(True, transport.listable())
+        self.assertEqual(False, transport.should_cache())
+        self.assertEqual(False, transport.is_readonly())
+        
+        
+class ReadonlyDecoratorTransportTest(TestCase):
+    """Readonly decoration specific tests."""
+
+    def test_local_parameters(self):
+        import bzrlib.transport.readonly as readonly
+        # connect to . in readonly mode
+        transport = readonly.ReadonlyTransportDecorator('readonly+.')
+        self.assertEqual(True, transport.listable())
+        self.assertEqual(False, transport.should_cache())
+        self.assertEqual(True, transport.is_readonly())
+
+    def test_http_parameters(self):
+        import bzrlib.transport.readonly as readonly
+        from bzrlib.transport.http import HttpServer
+        # connect to . via http which is not listable
+        server = HttpServer()
+        server.setUp()
+        try:
+            transport = get_transport('readonly+' + server.get_url())
+            self.failUnless(isinstance(transport,
+                                       readonly.ReadonlyTransportDecorator))
+            self.assertEqual(False, transport.listable())
+            self.assertEqual(True, transport.should_cache())
+            self.assertEqual(True, transport.is_readonly())
+        finally:
+            server.tearDown()

=== added file 'bzrlib/tests/test_transport_implementations.py'
--- bzrlib/tests/test_transport_implementations.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_transport_implementations.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,890 @@
+# Copyright (C) 2004, 2005, 2006 by Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for Transport implementations.
+
+Transport implementations tested here are supplied by
+TransportTestProviderAdapter.
+"""
+
+import os
+from cStringIO import StringIO
+import stat
+import sys
+
+from bzrlib.errors import (DirectoryNotEmpty, NoSuchFile, FileExists,
+                           LockError,
+                           PathError,
+                           TransportNotPossible, ConnectionError)
+from bzrlib.tests import TestCaseInTempDir, TestSkipped
+from bzrlib.transport import memory, urlescape
+import bzrlib.transport
+
+
+def _append(fn, txt):
+    """Append the given text (file-like object) to the supplied filename."""
+    f = open(fn, 'ab')
+    try:
+        f.write(txt.read())
+    finally:
+        f.close()
+
+
+class TestTransportImplementation(TestCaseInTempDir):
+    """Implementation verification for transports.
+    
+    To verify a transport we need a server factory, which is a callable
+    that accepts no parameters and returns an implementation of
+    bzrlib.transport.Server.
+    
+    That Server is then used to construct transport instances and test
+    the transport via loopback activity.
+
+    Currently this assumes that the Transport object is connected to the 
+    current working directory.  So that whatever is done 
+    through the transport, should show up in the working 
+    directory, and vice-versa. This is a bug, because its possible to have
+    URL schemes which provide access to something that may not be 
+    result in storage on the local disk, i.e. due to file system limits, or 
+    due to it being a database or some other non-filesystem tool.
+
+    This also tests to make sure that the functions work with both
+    generators and lists (assuming iter(list) is effectively a generator)
+    """
+    
+    def setUp(self):
+        super(TestTransportImplementation, self).setUp()
+        self._server = self.transport_server()
+        self._server.setUp()
+
+    def tearDown(self):
+        super(TestTransportImplementation, self).tearDown()
+        self._server.tearDown()
+        
+    def check_transport_contents(self, content, transport, relpath):
+        """Check that transport.get(relpath).read() == content."""
+        self.assertEqualDiff(content, transport.get(relpath).read())
+
+    def get_transport(self):
+        """Return a connected transport to the local directory."""
+        t = bzrlib.transport.get_transport(self._server.get_url())
+        self.failUnless(isinstance(t, self.transport_class), 
+                        "Got the wrong class from get_transport"
+                        "(%r, expected %r)" % (t.__class__, 
+                                               self.transport_class))
+        return t
+
+    def assertListRaises(self, excClass, func, *args, **kwargs):
+        """Fail unless excClass is raised when the iterator from func is used.
+        
+        Many transport functions can return generators this makes sure
+        to wrap them in a list() call to make sure the whole generator
+        is run, and that the proper exception is raised.
+        """
+        try:
+            list(func(*args, **kwargs))
+        except excClass:
+            return
+        else:
+            if hasattr(excClass,'__name__'): excName = excClass.__name__
+            else: excName = str(excClass)
+            raise self.failureException, "%s not raised" % excName
+
+    def test_has(self):
+        t = self.get_transport()
+
+        files = ['a', 'b', 'e', 'g', '%']
+        self.build_tree(files, transport=t)
+        self.assertEqual(True, t.has('a'))
+        self.assertEqual(False, t.has('c'))
+        self.assertEqual(True, t.has(urlescape('%')))
+        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'])),
+                [True, True, False, False, True, False, True, False])
+        self.assertEqual(True, t.has_any(['a', 'b', 'c']))
+        self.assertEqual(False, t.has_any(['c', 'd', 'f', urlescape('%%')]))
+        self.assertEqual(list(t.has_multi(iter(['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h']))),
+                [True, True, False, False, True, False, True, False])
+        self.assertEqual(False, t.has_any(['c', 'c', 'c']))
+        self.assertEqual(True, t.has_any(['b', 'b', 'b']))
+
+    def test_get(self):
+        t = self.get_transport()
+
+        files = ['a', 'b', 'e', 'g']
+        contents = ['contents of a\n',
+                    'contents of b\n',
+                    'contents of e\n',
+                    'contents of g\n',
+                    ]
+        self.build_tree(files, transport=t)
+        self.check_transport_contents('contents of a\n', t, 'a')
+        content_f = t.get_multi(files)
+        for content, f in zip(contents, content_f):
+            self.assertEqual(content, f.read())
+
+        content_f = t.get_multi(iter(files))
+        for content, f in zip(contents, content_f):
+            self.assertEqual(content, f.read())
+
+        self.assertRaises(NoSuchFile, t.get, 'c')
+        self.assertListRaises(NoSuchFile, t.get_multi, ['a', 'b', 'c'])
+        self.assertListRaises(NoSuchFile, t.get_multi, iter(['a', 'b', 'c']))
+
+    def test_put(self):
+        t = self.get_transport()
+
+        if t.is_readonly():
+            self.assertRaises(TransportNotPossible,
+                    t.put, 'a', 'some text for a\n')
+            return
+
+        t.put('a', StringIO('some text for a\n'))
+        self.failUnless(t.has('a'))
+        self.check_transport_contents('some text for a\n', t, 'a')
+        # Make sure 'has' is updated
+        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e'])),
+                [True, False, False, False, False])
+        # Put also replaces contents
+        self.assertEqual(t.put_multi([('a', StringIO('new\ncontents for\na\n')),
+                                      ('d', StringIO('contents\nfor d\n'))]),
+                         2)
+        self.assertEqual(list(t.has_multi(['a', 'b', 'c', 'd', 'e'])),
+                [True, False, False, True, False])
+        self.check_transport_contents('new\ncontents for\na\n', t, 'a')
+        self.check_transport_contents('contents\nfor d\n', t, 'd')
+
+        self.assertEqual(
+            t.put_multi(iter([('a', StringIO('diff\ncontents for\na\n')),
+                              ('d', StringIO('another contents\nfor d\n'))])),
+                        2)
+        self.check_transport_contents('diff\ncontents for\na\n', t, 'a')
+        self.check_transport_contents('another contents\nfor d\n', t, 'd')
+
+        self.assertRaises(NoSuchFile,
+                          t.put, 'path/doesnt/exist/c', 'contents')
+
+    def test_put_permissions(self):
+        t = self.get_transport()
+
+        if t.is_readonly():
+            return
+        t.put('mode644', StringIO('test text\n'), mode=0644)
+        self.assertTransportMode(t, 'mode644', 0644)
+        t.put('mode666', StringIO('test text\n'), mode=0666)
+        self.assertTransportMode(t, 'mode666', 0666)
+        t.put('mode600', StringIO('test text\n'), mode=0600)
+        self.assertTransportMode(t, 'mode600', 0600)
+        # Yes, you can put a file such that it becomes readonly
+        t.put('mode400', StringIO('test text\n'), mode=0400)
+        self.assertTransportMode(t, 'mode400', 0400)
+        t.put_multi([('mmode644', StringIO('text\n'))], mode=0644)
+        self.assertTransportMode(t, 'mmode644', 0644)
+        
+    def test_mkdir(self):
+        t = self.get_transport()
+
+        if t.is_readonly():
+            # cannot mkdir on readonly transports. We're not testing for 
+            # cache coherency because cache behaviour is not currently
+            # defined for the transport interface.
+            self.assertRaises(TransportNotPossible, t.mkdir, '.')
+            self.assertRaises(TransportNotPossible, t.mkdir, 'new_dir')
+            self.assertRaises(TransportNotPossible, t.mkdir_multi, ['new_dir'])
+            self.assertRaises(TransportNotPossible, t.mkdir, 'path/doesnt/exist')
+            return
+        # Test mkdir
+        t.mkdir('dir_a')
+        self.assertEqual(t.has('dir_a'), True)
+        self.assertEqual(t.has('dir_b'), False)
+
+        t.mkdir('dir_b')
+        self.assertEqual(t.has('dir_b'), True)
+
+        t.mkdir_multi(['dir_c', 'dir_d'])
+
+        t.mkdir_multi(iter(['dir_e', 'dir_f']))
+        self.assertEqual(list(t.has_multi(
+            ['dir_a', 'dir_b', 'dir_c', 'dir_q',
+             'dir_d', 'dir_e', 'dir_f', 'dir_b'])),
+            [True, True, True, False,
+             True, True, True, True])
+
+        # we were testing that a local mkdir followed by a transport
+        # mkdir failed thusly, but given that we * in one process * do not
+        # concurrently fiddle with disk dirs and then use transport to do 
+        # things, the win here seems marginal compared to the constraint on
+        # the interface. RBC 20051227
+        t.mkdir('dir_g')
+        self.assertRaises(FileExists, t.mkdir, 'dir_g')
+
+        # Test get/put in sub-directories
+        self.assertEqual(
+            t.put_multi([('dir_a/a', StringIO('contents of dir_a/a')),
+                         ('dir_b/b', StringIO('contents of dir_b/b'))])
+                        , 2)
+        self.check_transport_contents('contents of dir_a/a', t, 'dir_a/a')
+        self.check_transport_contents('contents of dir_b/b', t, 'dir_b/b')
+
+        # mkdir of a dir with an absent parent
+        self.assertRaises(NoSuchFile, t.mkdir, 'missing/dir')
+
+    def test_mkdir_permissions(self):
+        t = self.get_transport()
+        if t.is_readonly():
+            return
+        # Test mkdir with a mode
+        t.mkdir('dmode755', mode=0755)
+        self.assertTransportMode(t, 'dmode755', 0755)
+        t.mkdir('dmode555', mode=0555)
+        self.assertTransportMode(t, 'dmode555', 0555)
+        t.mkdir('dmode777', mode=0777)
+        self.assertTransportMode(t, 'dmode777', 0777)
+        t.mkdir('dmode700', mode=0700)
+        self.assertTransportMode(t, 'dmode700', 0700)
+        # TODO: jam 20051215 test mkdir_multi with a mode
+        t.mkdir_multi(['mdmode755'], mode=0755)
+        self.assertTransportMode(t, 'mdmode755', 0755)
+
+    def test_copy_to(self):
+        # FIXME: test:   same server to same server (partly done)
+        # same protocol two servers
+        # and    different protocols (done for now except for MemoryTransport.
+        # - RBC 20060122
+        from bzrlib.transport.memory import MemoryTransport
+
+        def simple_copy_files(transport_from, transport_to):
+            files = ['a', 'b', 'c', 'd']
+            self.build_tree(files, transport=transport_from)
+            transport_from.copy_to(files, transport_to)
+            for f in files:
+                self.check_transport_contents(transport_to.get(f).read(),
+                                              transport_from, f)
+
+        t = self.get_transport()
+        temp_transport = MemoryTransport('memory:/')
+        simple_copy_files(t, temp_transport)
+        if not t.is_readonly():
+            t.mkdir('copy_to_simple')
+            t2 = t.clone('copy_to_simple')
+            simple_copy_files(t, t2)
+
+
+        # Test that copying into a missing directory raises
+        # NoSuchFile
+        if t.is_readonly():
+            self.build_tree(['e/', 'e/f'])
+        else:
+            t.mkdir('e')
+            t.put('e/f', StringIO('contents of e'))
+        self.assertRaises(NoSuchFile, t.copy_to, ['e/f'], temp_transport)
+        temp_transport.mkdir('e')
+        t.copy_to(['e/f'], temp_transport)
+
+        del temp_transport
+        temp_transport = MemoryTransport('memory:/')
+
+        files = ['a', 'b', 'c', 'd']
+        t.copy_to(iter(files), temp_transport)
+        for f in files:
+            self.check_transport_contents(temp_transport.get(f).read(),
+                                          t, f)
+        del temp_transport
+
+        for mode in (0666, 0644, 0600, 0400):
+            temp_transport = MemoryTransport("memory:/")
+            t.copy_to(files, temp_transport, mode=mode)
+            for f in files:
+                self.assertTransportMode(temp_transport, f, mode)
+
+    def test_append(self):
+        t = self.get_transport()
+
+        if t.is_readonly():
+            open('a', 'wb').write('diff\ncontents for\na\n')
+            open('b', 'wb').write('contents\nfor b\n')
+        else:
+            t.put_multi([
+                    ('a', StringIO('diff\ncontents for\na\n')),
+                    ('b', StringIO('contents\nfor b\n'))
+                    ])
+
+        if t.is_readonly():
+            self.assertRaises(TransportNotPossible,
+                    t.append, 'a', 'add\nsome\nmore\ncontents\n')
+            _append('a', StringIO('add\nsome\nmore\ncontents\n'))
+        else:
+            t.append('a', StringIO('add\nsome\nmore\ncontents\n'))
+
+        self.check_transport_contents(
+            'diff\ncontents for\na\nadd\nsome\nmore\ncontents\n',
+            t, 'a')
+
+        if t.is_readonly():
+            self.assertRaises(TransportNotPossible,
+                    t.append_multi,
+                        [('a', 'and\nthen\nsome\nmore\n'),
+                         ('b', 'some\nmore\nfor\nb\n')])
+            _append('a', StringIO('and\nthen\nsome\nmore\n'))
+            _append('b', StringIO('some\nmore\nfor\nb\n'))
+        else:
+            t.append_multi([('a', StringIO('and\nthen\nsome\nmore\n')),
+                    ('b', StringIO('some\nmore\nfor\nb\n'))])
+        self.check_transport_contents(
+            'diff\ncontents for\na\n'
+            'add\nsome\nmore\ncontents\n'
+            'and\nthen\nsome\nmore\n',
+            t, 'a')
+        self.check_transport_contents(
+                'contents\nfor b\n'
+                'some\nmore\nfor\nb\n',
+                t, 'b')
+
+        if t.is_readonly():
+            _append('a', StringIO('a little bit more\n'))
+            _append('b', StringIO('from an iterator\n'))
+        else:
+            t.append_multi(iter([('a', StringIO('a little bit more\n')),
+                    ('b', StringIO('from an iterator\n'))]))
+        self.check_transport_contents(
+            'diff\ncontents for\na\n'
+            'add\nsome\nmore\ncontents\n'
+            'and\nthen\nsome\nmore\n'
+            'a little bit more\n',
+            t, 'a')
+        self.check_transport_contents(
+                'contents\nfor b\n'
+                'some\nmore\nfor\nb\n'
+                'from an iterator\n',
+                t, 'b')
+
+        if t.is_readonly():
+            _append('c', StringIO('some text\nfor a missing file\n'))
+            _append('a', StringIO('some text in a\n'))
+            _append('d', StringIO('missing file r\n'))
+        else:
+            t.append('c', StringIO('some text\nfor a missing file\n'))
+            t.append_multi([('a', StringIO('some text in a\n')),
+                            ('d', StringIO('missing file r\n'))])
+        self.check_transport_contents(
+            'diff\ncontents for\na\n'
+            'add\nsome\nmore\ncontents\n'
+            'and\nthen\nsome\nmore\n'
+            'a little bit more\n'
+            'some text in a\n',
+            t, 'a')
+        self.check_transport_contents('some text\nfor a missing file\n',
+                                      t, 'c')
+        self.check_transport_contents('missing file r\n', t, 'd')
+        
+        # a file with no parent should fail..
+        if not t.is_readonly():
+            self.assertRaises(NoSuchFile,
+                              t.append, 'missing/path', 
+                              StringIO('content'))
+
+    def test_append_file(self):
+        t = self.get_transport()
+
+        contents = [
+            ('f1', StringIO('this is a string\nand some more stuff\n')),
+            ('f2', StringIO('here is some text\nand a bit more\n')),
+            ('f3', StringIO('some text for the\nthird file created\n')),
+            ('f4', StringIO('this is a string\nand some more stuff\n')),
+            ('f5', StringIO('here is some text\nand a bit more\n')),
+            ('f6', StringIO('some text for the\nthird file created\n'))
+        ]
+        
+        if t.is_readonly():
+            for f, val in contents:
+                open(f, 'wb').write(val.read())
+        else:
+            t.put_multi(contents)
+
+        a1 = StringIO('appending to\none\n')
+        if t.is_readonly():
+            _append('f1', a1)
+        else:
+            t.append('f1', a1)
+
+        del a1
+
+        self.check_transport_contents(
+                'this is a string\nand some more stuff\n'
+                'appending to\none\n',
+                t, 'f1')
+
+        a2 = StringIO('adding more\ntext to two\n')
+        a3 = StringIO('some garbage\nto put in three\n')
+
+        if t.is_readonly():
+            _append('f2', a2)
+            _append('f3', a3)
+        else:
+            t.append_multi([('f2', a2), ('f3', a3)])
+
+        del a2, a3
+
+        self.check_transport_contents(
+                'here is some text\nand a bit more\n'
+                'adding more\ntext to two\n',
+                t, 'f2')
+        self.check_transport_contents( 
+                'some text for the\nthird file created\n'
+                'some garbage\nto put in three\n',
+                t, 'f3')
+
+        # Test that an actual file object can be used with put
+        a4 = t.get('f1')
+        if t.is_readonly():
+            _append('f4', a4)
+        else:
+            t.append('f4', a4)
+
+        del a4
+
+        self.check_transport_contents(
+                'this is a string\nand some more stuff\n'
+                'this is a string\nand some more stuff\n'
+                'appending to\none\n',
+                t, 'f4')
+
+        a5 = t.get('f2')
+        a6 = t.get('f3')
+        if t.is_readonly():
+            _append('f5', a5)
+            _append('f6', a6)
+        else:
+            t.append_multi([('f5', a5), ('f6', a6)])
+
+        del a5, a6
+
+        self.check_transport_contents(
+                'here is some text\nand a bit more\n'
+                'here is some text\nand a bit more\n'
+                'adding more\ntext to two\n',
+                t, 'f5')
+        self.check_transport_contents(
+                'some text for the\nthird file created\n'
+                'some text for the\nthird file created\n'
+                'some garbage\nto put in three\n',
+                t, 'f6')
+
+        a5 = t.get('f2')
+        a6 = t.get('f2')
+        a7 = t.get('f3')
+        if t.is_readonly():
+            _append('c', a5)
+            _append('a', a6)
+            _append('d', a7)
+        else:
+            t.append('c', a5)
+            t.append_multi([('a', a6), ('d', a7)])
+        del a5, a6, a7
+        self.check_transport_contents(t.get('f2').read(), t, 'c')
+        self.check_transport_contents(t.get('f3').read(), t, 'd')
+
+    def test_delete(self):
+        # TODO: Test Transport.delete
+        t = self.get_transport()
+
+        # Not much to do with a readonly transport
+        if t.is_readonly():
+            self.assertRaises(TransportNotPossible, t.delete, 'missing')
+            return
+
+        t.put('a', StringIO('a little bit of text\n'))
+        self.failUnless(t.has('a'))
+        t.delete('a')
+        self.failIf(t.has('a'))
+
+        self.assertRaises(NoSuchFile, t.delete, 'a')
+
+        t.put('a', StringIO('a text\n'))
+        t.put('b', StringIO('b text\n'))
+        t.put('c', StringIO('c text\n'))
+        self.assertEqual([True, True, True],
+                list(t.has_multi(['a', 'b', 'c'])))
+        t.delete_multi(['a', 'c'])
+        self.assertEqual([False, True, False],
+                list(t.has_multi(['a', 'b', 'c'])))
+        self.failIf(t.has('a'))
+        self.failUnless(t.has('b'))
+        self.failIf(t.has('c'))
+
+        self.assertRaises(NoSuchFile,
+                t.delete_multi, ['a', 'b', 'c'])
+
+        self.assertRaises(NoSuchFile,
+                t.delete_multi, iter(['a', 'b', 'c']))
+
+        t.put('a', StringIO('another a text\n'))
+        t.put('c', StringIO('another c text\n'))
+        t.delete_multi(iter(['a', 'b', 'c']))
+
+        # We should have deleted everything
+        # SftpServer creates control files in the
+        # working directory, so we can just do a
+        # plain "listdir".
+        # self.assertEqual([], os.listdir('.'))
+
+    def test_rmdir(self):
+        t = self.get_transport()
+        # Not much to do with a readonly transport
+        if t.is_readonly():
+            self.assertRaises(TransportNotPossible, t.rmdir, 'missing')
+            return
+        t.mkdir('adir')
+        t.mkdir('adir/bdir')
+        t.rmdir('adir/bdir')
+        self.assertRaises(NoSuchFile, t.stat, 'adir/bdir')
+        t.rmdir('adir')
+        self.assertRaises(NoSuchFile, t.stat, 'adir')
+
+    def test_rmdir_not_empty(self):
+        """Deleting a non-empty directory raises an exception
+        
+        sftp (and possibly others) don't give us a specific "directory not
+        empty" exception -- we can just see that the operation failed.
+        """
+        t = self.get_transport()
+        if t.is_readonly():
+            return
+        t.mkdir('adir')
+        t.mkdir('adir/bdir')
+        self.assertRaises(PathError, t.rmdir, 'adir')
+
+    def test_rename_dir_succeeds(self):
+        t = self.get_transport()
+        if t.is_readonly():
+            raise TestSkipped("transport is readonly")
+        t.mkdir('adir')
+        t.mkdir('adir/asubdir')
+        t.rename('adir', 'bdir')
+        self.assertTrue(t.has('bdir/asubdir'))
+        self.assertFalse(t.has('adir'))
+
+    def test_rename_dir_nonempty(self):
+        """Attempting to replace a nonemtpy directory should fail"""
+        t = self.get_transport()
+        if t.is_readonly():
+            raise TestSkipped("transport is readonly")
+        t.mkdir('adir')
+        t.mkdir('adir/asubdir')
+        t.mkdir('bdir')
+        t.mkdir('bdir/bsubdir')
+        self.assertRaises(PathError, t.rename, 'bdir', 'adir')
+        # nothing was changed so it should still be as before
+        self.assertTrue(t.has('bdir/bsubdir'))
+        self.assertFalse(t.has('adir/bdir'))
+        self.assertFalse(t.has('adir/bsubdir'))
+
+    def test_delete_tree(self):
+        t = self.get_transport()
+
+        # Not much to do with a readonly transport
+        if t.is_readonly():
+            self.assertRaises(TransportNotPossible, t.delete_tree, 'missing')
+            return
+
+        # and does it like listing ?
+        t.mkdir('adir')
+        try:
+            t.delete_tree('adir')
+        except TransportNotPossible:
+            # ok, this transport does not support delete_tree
+            return
+        
+        # did it delete that trivial case?
+        self.assertRaises(NoSuchFile, t.stat, 'adir')
+
+        self.build_tree(['adir/',
+                         'adir/file', 
+                         'adir/subdir/', 
+                         'adir/subdir/file', 
+                         'adir/subdir2/',
+                         'adir/subdir2/file',
+                         ], transport=t)
+
+        t.delete_tree('adir')
+        # adir should be gone now.
+        self.assertRaises(NoSuchFile, t.stat, 'adir')
+
+    def test_move(self):
+        t = self.get_transport()
+
+        if t.is_readonly():
+            return
+
+        # TODO: I would like to use os.listdir() to
+        # make sure there are no extra files, but SftpServer
+        # creates control files in the working directory
+        # perhaps all of this could be done in a subdirectory
+
+        t.put('a', StringIO('a first file\n'))
+        self.assertEquals([True, False], list(t.has_multi(['a', 'b'])))
+
+        t.move('a', 'b')
+        self.failUnless(t.has('b'))
+        self.failIf(t.has('a'))
+
+        self.check_transport_contents('a first file\n', t, 'b')
+        self.assertEquals([False, True], list(t.has_multi(['a', 'b'])))
+
+        # Overwrite a file
+        t.put('c', StringIO('c this file\n'))
+        t.move('c', 'b')
+        self.failIf(t.has('c'))
+        self.check_transport_contents('c this file\n', t, 'b')
+
+        # TODO: Try to write a test for atomicity
+        # TODO: Test moving into a non-existant subdirectory
+        # TODO: Test Transport.move_multi
+
+    def test_copy(self):
+        t = self.get_transport()
+
+        if t.is_readonly():
+            return
+
+        t.put('a', StringIO('a file\n'))
+        t.copy('a', 'b')
+        self.check_transport_contents('a file\n', t, 'b')
+
+        self.assertRaises(NoSuchFile, t.copy, 'c', 'd')
+        os.mkdir('c')
+        # What should the assert be if you try to copy a
+        # file over a directory?
+        #self.assertRaises(Something, t.copy, 'a', 'c')
+        t.put('d', StringIO('text in d\n'))
+        t.copy('d', 'b')
+        self.check_transport_contents('text in d\n', t, 'b')
+
+        # TODO: test copy_multi
+
+    def test_connection_error(self):
+        """ConnectionError is raised when connection is impossible"""
+        try:
+            url = self._server.get_bogus_url()
+        except NotImplementedError:
+            raise TestSkipped("Transport %s has no bogus URL support." %
+                              self._server.__class__)
+        t = bzrlib.transport.get_transport(url)
+        try:
+            t.get('.bzr/branch')
+        except (ConnectionError, NoSuchFile), e:
+            pass
+        except (Exception), e:
+            self.failIf(True, 'Wrong exception thrown: %s' % e)
+        else:
+            self.failIf(True, 'Did not get the expected exception.')
+
+    def test_stat(self):
+        # TODO: Test stat, just try once, and if it throws, stop testing
+        from stat import S_ISDIR, S_ISREG
+
+        t = self.get_transport()
+
+        try:
+            st = t.stat('.')
+        except TransportNotPossible, e:
+            # This transport cannot stat
+            return
+
+        paths = ['a', 'b/', 'b/c', 'b/d/', 'b/d/e']
+        sizes = [14, 0, 16, 0, 18] 
+        self.build_tree(paths, transport=t)
+
+        for path, size in zip(paths, sizes):
+            st = t.stat(path)
+            if path.endswith('/'):
+                self.failUnless(S_ISDIR(st.st_mode))
+                # directory sizes are meaningless
+            else:
+                self.failUnless(S_ISREG(st.st_mode))
+                self.assertEqual(size, st.st_size)
+
+        remote_stats = list(t.stat_multi(paths))
+        remote_iter_stats = list(t.stat_multi(iter(paths)))
+
+        self.assertRaises(NoSuchFile, t.stat, 'q')
+        self.assertRaises(NoSuchFile, t.stat, 'b/a')
+
+        self.assertListRaises(NoSuchFile, t.stat_multi, ['a', 'c', 'd'])
+        self.assertListRaises(NoSuchFile, t.stat_multi, iter(['a', 'c', 'd']))
+        self.build_tree(['subdir/', 'subdir/file'], transport=t)
+        subdir = t.clone('subdir')
+        subdir.stat('./file')
+        subdir.stat('.')
+
+    def test_list_dir(self):
+        # TODO: Test list_dir, just try once, and if it throws, stop testing
+        t = self.get_transport()
+        
+        if not t.listable():
+            self.assertRaises(TransportNotPossible, t.list_dir, '.')
+            return
+
+        def sorted_list(d):
+            l = list(t.list_dir(d))
+            l.sort()
+            return l
+
+        # SftpServer creates control files in the working directory
+        # so lets move down a directory to avoid those.
+        if not t.is_readonly():
+            t.mkdir('wd')
+        else:
+            os.mkdir('wd')
+        t = t.clone('wd')
+
+        self.assertEqual([], sorted_list(u'.'))
+        # c2 is precisely one letter longer than c here to test that
+        # suffixing is not confused.
+        if not t.is_readonly():
+            self.build_tree(['a', 'b', 'c/', 'c/d', 'c/e', 'c2/'], transport=t)
+        else:
+            self.build_tree(['wd/a', 'wd/b', 'wd/c/', 'wd/c/d', 'wd/c/e', 'wd/c2/'])
+
+        self.assertEqual([u'a', u'b', u'c', u'c2'], sorted_list(u'.'))
+        self.assertEqual([u'd', u'e'], sorted_list(u'c'))
+
+        if not t.is_readonly():
+            t.delete('c/d')
+            t.delete('b')
+        else:
+            os.unlink('wd/c/d')
+            os.unlink('wd/b')
+            
+        self.assertEqual([u'a', u'c', u'c2'], sorted_list('.'))
+        self.assertEqual([u'e'], sorted_list(u'c'))
+
+        self.assertListRaises(NoSuchFile, t.list_dir, 'q')
+        self.assertListRaises(NoSuchFile, t.list_dir, 'c/f')
+        self.assertListRaises(NoSuchFile, t.list_dir, 'a')
+
+    def test_clone(self):
+        # TODO: Test that clone moves up and down the filesystem
+        t1 = self.get_transport()
+
+        self.build_tree(['a', 'b/', 'b/c'], transport=t1)
+
+        self.failUnless(t1.has('a'))
+        self.failUnless(t1.has('b/c'))
+        self.failIf(t1.has('c'))
+
+        t2 = t1.clone('b')
+        self.assertEqual(t1.base + 'b/', t2.base)
+
+        self.failUnless(t2.has('c'))
+        self.failIf(t2.has('a'))
+
+        t3 = t2.clone('..')
+        self.failUnless(t3.has('a'))
+        self.failIf(t3.has('c'))
+
+        self.failIf(t1.has('b/d'))
+        self.failIf(t2.has('d'))
+        self.failIf(t3.has('b/d'))
+
+        if t1.is_readonly():
+            open('b/d', 'wb').write('newfile\n')
+        else:
+            t2.put('d', StringIO('newfile\n'))
+
+        self.failUnless(t1.has('b/d'))
+        self.failUnless(t2.has('d'))
+        self.failUnless(t3.has('b/d'))
+
+    def test_relpath(self):
+        t = self.get_transport()
+        self.assertEqual('', t.relpath(t.base))
+        # base ends with /
+        self.assertEqual('', t.relpath(t.base[:-1]))
+        # subdirs which dont exist should still give relpaths.
+        self.assertEqual('foo', t.relpath(t.base + 'foo'))
+        # trailing slash should be the same.
+        self.assertEqual('foo', t.relpath(t.base + 'foo/'))
+
+    def test_abspath(self):
+        # smoke test for abspath. Corner cases for backends like unix fs's
+        # that have aliasing problems like symlinks should go in backend
+        # specific test cases.
+        transport = self.get_transport()
+        self.assertEqual(transport.base + 'relpath',
+                         transport.abspath('relpath'))
+
+    def test_iter_files_recursive(self):
+        transport = self.get_transport()
+        if not transport.listable():
+            self.assertRaises(TransportNotPossible,
+                              transport.iter_files_recursive)
+            return
+        self.build_tree(['isolated/',
+                         'isolated/dir/',
+                         'isolated/dir/foo',
+                         'isolated/dir/bar',
+                         'isolated/bar'],
+                        transport=transport)
+        paths = set(transport.iter_files_recursive())
+        # nb the directories are not converted
+        self.assertEqual(paths,
+                    set(['isolated/dir/foo',
+                         'isolated/dir/bar',
+                         'isolated/bar']))
+        sub_transport = transport.clone('isolated')
+        paths = set(sub_transport.iter_files_recursive())
+        self.assertEqual(set(['dir/foo', 'dir/bar', 'bar']), paths)
+
+    def test_connect_twice_is_same_content(self):
+        # check that our server (whatever it is) is accessable reliably
+        # via get_transport and multiple connections share content.
+        transport = self.get_transport()
+        if transport.is_readonly():
+            return
+        transport.put('foo', StringIO('bar'))
+        transport2 = self.get_transport()
+        self.check_transport_contents('bar', transport2, 'foo')
+        # its base should be usable.
+        transport2 = bzrlib.transport.get_transport(transport.base)
+        self.check_transport_contents('bar', transport2, 'foo')
+
+        # now opening at a relative url should give use a sane result:
+        transport.mkdir('newdir')
+        transport2 = bzrlib.transport.get_transport(transport.base + "newdir")
+        transport2 = transport2.clone('..')
+        self.check_transport_contents('bar', transport2, 'foo')
+
+    def test_lock_write(self):
+        transport = self.get_transport()
+        if transport.is_readonly():
+            self.assertRaises(TransportNotPossible, transport.lock_write, 'foo')
+            return
+        transport.put('lock', StringIO())
+        lock = transport.lock_write('lock')
+        # TODO make this consistent on all platforms:
+        # self.assertRaises(LockError, transport.lock_write, 'lock')
+        lock.unlock()
+
+    def test_lock_read(self):
+        transport = self.get_transport()
+        if transport.is_readonly():
+            file('lock', 'w').close()
+        else:
+            transport.put('lock', StringIO())
+        lock = transport.lock_read('lock')
+        # TODO make this consistent on all platforms:
+        # self.assertRaises(LockError, transport.lock_read, 'lock')
+        lock.unlock()

=== modified file 'bzrlib/tests/test_tsort.py'
--- bzrlib/tests/test_tsort.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_tsort.py	2006-03-20 08:31:00 +0000
@@ -14,50 +14,59 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Tests for topological sort.
-"""
-
-import os
-import sys
+
+"""Tests for topological sort."""
+
 
 from bzrlib.tests import TestCase
-from bzrlib.tsort import topo_sort
+from bzrlib.tsort import topo_sort, TopoSorter
 from bzrlib.errors import GraphCycleError
 
+
 class TopoSortTests(TestCase):
 
+    def assertSortAndIterate(self, graph, result_list):
+        """Check that sorting and iter_topo_order on graph works."""
+        self.assertEquals(result_list, topo_sort(graph))
+        self.assertEqual(result_list,
+                         list(TopoSorter(graph).iter_topo_order()))
+
+    def assertSortAndIterateRaise(self, exception_type, graph):
+        """Try both iterating and topo_sorting graph and expect an exception."""
+        self.assertRaises(exception_type, topo_sort, graph)
+        self.assertRaises(exception_type,
+                          list,
+                          TopoSorter(graph).iter_topo_order())
+
     def test_tsort_empty(self):
         """TopoSort empty list"""
-        self.assertEquals(topo_sort([]), [])
+        self.assertSortAndIterate([], [])
 
     def test_tsort_easy(self):
         """TopoSort list with one node"""
-        self.assertEquals(topo_sort({0: []}.items()),
-                          [0])
+        self.assertSortAndIterate({0: []}.items(), [0])
 
     def test_tsort_cycle(self):
         """TopoSort traps graph with cycles"""
-        self.assertRaises(GraphCycleError,
-                          topo_sort,
-                          {0: [1], 
-                           1: [0]}.iteritems())
+        self.assertSortAndIterateRaise(GraphCycleError,
+                                       {0: [1], 
+                                        1: [0]}.items())
 
     def test_tsort_cycle_2(self):
         """TopoSort traps graph with longer cycle"""
-        self.assertRaises(GraphCycleError,
-                          topo_sort,
-                          {0: [1], 
-                           1: [2], 
-                           2: [0]}.iteritems())
+        self.assertSortAndIterateRaise(GraphCycleError,
+                                       {0: [1], 
+                                        1: [2], 
+                                        2: [0]}.items())
                  
     def test_tsort_1(self):
         """TopoSort simple nontrivial graph"""
-        self.assertEquals(topo_sort({0: [3], 
-                                     1: [4],
-                                     2: [1, 4],
-                                     3: [], 
-                                     4: [0, 3]}.iteritems()),
-                          [3, 0, 4, 1, 2])
+        self.assertSortAndIterate({0: [3], 
+                                   1: [4],
+                                   2: [1, 4],
+                                   3: [], 
+                                   4: [0, 3]}.items(),
+                                  [3, 0, 4, 1, 2])
 
     def test_tsort_partial(self):
         """Topological sort with partial ordering.
@@ -65,13 +74,13 @@
         If the graph does not give an order between two nodes, they are 
         returned in lexicographical order.
         """
-        self.assertEquals(topo_sort([(0, []),
-                                    (1, [0]),
-                                    (2, [0]),
-                                    (3, [0]),
-                                    (4, [1, 2, 3]),
-                                    (5, [1, 2]),
-                                    (6, [1, 2]),
-                                    (7, [2, 3]),
-                                    (8, [0, 1, 4, 5, 6])]),
-                          [0, 1, 2, 3, 4, 5, 6, 7, 8, ])
+        self.assertSortAndIterate(([(0, []),
+                                   (1, [0]),
+                                   (2, [0]),
+                                   (3, [0]),
+                                   (4, [1, 2, 3]),
+                                   (5, [1, 2]),
+                                   (6, [1, 2]),
+                                   (7, [2, 3]),
+                                   (8, [0, 1, 4, 5, 6])]),
+                                  [0, 1, 2, 3, 4, 5, 6, 7, 8])

=== modified file 'bzrlib/tests/test_ui.py'
--- bzrlib/tests/test_ui.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_ui.py	2006-03-20 08:31:00 +0000
@@ -18,8 +18,10 @@
 """
 
 import os
+from StringIO import StringIO
 import sys
 
+from bzrlib.progress import TTYProgressBar
 from bzrlib.tests import TestCase
 from bzrlib.ui import SilentUIFactory
 from bzrlib.ui.text import TextUIFactory
@@ -50,3 +52,16 @@
         #                                   user=u'some\u1234')
         #                  , 'bogus')
 
+
+    def test_progress_note(self):
+        stderr = StringIO()
+        stdout = StringIO()
+        ui = TextUIFactory()
+        pb = TTYProgressBar(to_file=stderr, to_messages_file=stdout)
+        result = pb.note('t')
+        self.assertEqual(None, result)
+        self.assertEqual("t\n", stdout.getvalue())
+        # the exact contents will depend on the terminal width and we don't
+        # care about that right now - but you're probably running it on at
+        # least a 10-character wide terminal :)
+        self.assertContainsRe(stderr.getvalue(), r'^\r {10,}\r$')

=== modified file 'bzrlib/tests/test_uncommit.py'
--- bzrlib/tests/test_uncommit.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_uncommit.py	2006-03-20 08:31:00 +0000
@@ -1,14 +1,18 @@
 """\
 Test the uncommit command.
 """
+
+import os
+
+from bzrlib.errors import BzrError
 from bzrlib.tests import TestCaseInTempDir
-from bzrlib.errors import BzrError
 
 class TestUncommit(TestCaseInTempDir):
     def test_uncommit(self):
         """Test uncommit functionality."""
         bzr = self.capture 
-
+        os.mkdir('branch')
+        os.chdir('branch')
         bzr('init')
         self.build_tree(['a', 'b', 'c'])
 
@@ -34,4 +38,26 @@
 
         self.assertEquals(bzr('revno'), '1\n')
         self.assertEquals(bzr('status'), 'modified:\n  a\n')
-
+        
+        bzr('checkout . ../checkout')
+        os.chdir('../checkout')
+        self.assertEquals("", bzr('status'))
+        self.assertEquals(bzr('revno'), '1\n')
+
+        open('a', 'wb').write('new contents of a\n')
+        self.assertEquals(bzr('status'), 'modified:\n  a\n')
+        bzr('commit -m second')
+
+        self.assertEquals(bzr('status'), '')
+        self.assertEquals(bzr('revno'), '2\n')
+
+        txt = bzr('uncommit --dry-run --force')
+        self.failIfEqual(txt.find('Dry-run'), -1)
+
+        self.assertEquals(bzr('status'), '')
+        self.assertEquals(bzr('revno'), '2\n')
+
+        txt = bzr('uncommit --force')
+
+        self.assertEquals(bzr('revno'), '1\n')
+        self.assertEquals(bzr('status'), 'modified:\n  a\n')

=== modified file 'bzrlib/tests/test_upgrade.py'
--- bzrlib/tests/test_upgrade.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_upgrade.py	2006-03-20 08:31:00 +0000
@@ -19,14 +19,22 @@
 This file contains canned versions of some old trees, which are instantiated 
 and then upgraded to the new format."""
 
+# TODO queue for upgrade:
+# test the error message when upgrading an unknown BzrDir format.
+
 import base64
 import os
 import sys
 
-from bzrlib.tests import TestCase, TestCaseInTempDir
+import bzrlib.branch
 from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+import bzrlib.repository as repository
 from bzrlib.revision import is_ancestor
+from bzrlib.tests import TestCase, TestCaseInTempDir
+from bzrlib.transport import get_transport
 from bzrlib.upgrade import upgrade
+import bzrlib.workingtree as workingtree
 
 
 class TestUpgrade(TestCaseInTempDir):
@@ -42,34 +50,63 @@
         eq = self.assertEquals
         self.build_tree_contents(_upgrade1_template)
         upgrade(u'.')
-        b = Branch.open(u'.')
-        eq(b._branch_format, 6)
+        control = bzrdir.BzrDir.open('.')
+        b = control.open_branch()
+        r = control.open_repository()
+        t = control.open_workingtree()
+        # tsk, peeking under the covers.
+        self.failUnless(isinstance(control._format, bzrdir.BzrDirFormat6))
+        self.failUnless(isinstance(b._format, bzrlib.branch.BzrBranchFormat4))
+        self.failUnless(isinstance(r._format, repository.RepositoryFormat6))
+        self.failUnless(isinstance(t._format, workingtree.WorkingTreeFormat2))
         rh = b.revision_history()
         eq(rh,
            ['mbp@sourcefrog.net-20051004035611-176b16534b086b3c',
             'mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd'])
-        t = b.revision_tree(rh[0])
+        rt = b.repository.revision_tree(rh[0])
         foo_id = 'foo-20051004035605-91e788d1875603ae'
-        eq(t.get_file_text(foo_id), 'initial contents\n')
-        t = b.revision_tree(rh[1])
-        eq(t.get_file_text(foo_id), 'new contents\n')
+        eq(rt.get_file_text(foo_id), 'initial contents\n')
+        rt = b.repository.revision_tree(rh[1])
+        eq(rt.get_file_text(foo_id), 'new contents\n')
+        # check a backup was made:
+        transport = get_transport(b.base)
+        transport.stat('.bzr.backup')
+        transport.stat('.bzr.backup/README')
+        transport.stat('.bzr.backup/branch-format')
+        transport.stat('.bzr.backup/revision-history')
+        transport.stat('.bzr.backup/merged-patches')
+        transport.stat('.bzr.backup/pending-merged-patches')
+        transport.stat('.bzr.backup/pending-merges')
+        transport.stat('.bzr.backup/branch-name')
+        transport.stat('.bzr.backup/branch-lock')
+        transport.stat('.bzr.backup/inventory')
+        transport.stat('.bzr.backup/stat-cache')
+        transport.stat('.bzr.backup/text-store')
+        transport.stat('.bzr.backup/text-store/foo-20051004035611-1591048e9dc7c2d4.gz')
+        transport.stat('.bzr.backup/text-store/foo-20051004035756-4081373d897c3453.gz')
+        transport.stat('.bzr.backup/inventory-store/')
+        transport.stat('.bzr.backup/inventory-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
+        transport.stat('.bzr.backup/inventory-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
+        transport.stat('.bzr.backup/revision-store/')
+        transport.stat('.bzr.backup/revision-store/mbp@sourcefrog.net-20051004035611-176b16534b086b3c.gz')
+        transport.stat('.bzr.backup/revision-store/mbp@sourcefrog.net-20051004035756-235f2b7dcdddd8dd.gz')
 
     def test_upgrade_with_ghosts(self):
         """Upgrade v0.0.4 tree containing ghost references.
 
         That is, some of the parents of revisions mentioned in the branch
-        aren't present in the branches storage. 
+        aren't present in the branch's storage. 
 
         This shouldn't normally happen in branches created entirely in 
-        bzr but can happen in imports from baz and arch, or from other  
-        systems, where the importer knows about a revision but not 
+        bzr, but can happen in branches imported from baz and arch, or from
+        other systems, where the importer knows about a revision but not 
         its contents."""
         eq = self.assertEquals
         self.build_tree_contents(_ghost_template)
         upgrade(u'.')
         b = Branch.open(u'.')
         revision_id = b.revision_history()[1]
-        rev = b.get_revision(revision_id)
+        rev = b.repository.get_revision(revision_id)
         eq(len(rev.parent_ids), 2)
         eq(rev.parent_ids[1], 'wibble@wobble-2')
 
@@ -82,6 +119,13 @@
         self.failUnlessExists(
             '.bzr/weaves/de/dir-20051005095101-da1441ea3fa6917a.weave')
 
+    def test_upgrade_to_meta_sets_workingtree_last_revision(self):
+        self.build_tree_contents(_upgrade_dir_template)
+        upgrade('.', bzrdir.BzrDirMetaFormat1())
+        tree = workingtree.WorkingTree.open('.')
+        self.assertEqual(tree.last_revision(),
+                         tree.branch.revision_history()[-1])
+
 
 _upgrade1_template = \
      [

=== modified file 'bzrlib/tests/test_weave.py'
--- bzrlib/tests/test_weave.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_weave.py	2006-03-20 08:31:00 +0000
@@ -765,8 +765,8 @@
         self.doMerge(['aaa', 'bbb'],
                      ['aaa', 'xxx', 'yyy', 'bbb'],
                      ['aaa', 'xxx', 'bbb'],
-                     ['aaa', '<<<<<<<', 'xxx', 'yyy', '=======', 'xxx', 
-                      '>>>>>>>', 'bbb'])
+                     ['aaa', '<<<<<<< ', 'xxx', 'yyy', '=======', 'xxx', 
+                      '>>>>>>> ', 'bbb'])
 
         # really it ought to reduce this to 
         # ['aaa', 'xxx', 'yyy', 'bbb']
@@ -776,15 +776,15 @@
         self.doMerge(['aaa'],
                      ['xxx'],
                      ['yyy', 'zzz'],
-                     ['<<<<<<<', 'xxx', '=======', 'yyy', 'zzz', 
-                      '>>>>>>>'])
+                     ['<<<<<<< ', 'xxx', '=======', 'yyy', 'zzz', 
+                      '>>>>>>> '])
 
     def testNonClashInsert(self):
         self.doMerge(['aaa'],
                      ['xxx', 'aaa'],
                      ['yyy', 'zzz'],
-                     ['<<<<<<<', 'xxx', 'aaa', '=======', 'yyy', 'zzz', 
-                      '>>>>>>>'])
+                     ['<<<<<<< ', 'xxx', 'aaa', '=======', 'yyy', 'zzz', 
+                      '>>>>>>> '])
 
         self.doMerge(['aaa'],
                      ['aaa'],
@@ -806,7 +806,7 @@
         self.doMerge(['aaa', 'bbb', 'ccc'],
                      ['aaa', 'ddd', 'ccc'],
                      ['aaa', 'ccc'],
-                     ['<<<<<<<<', 'aaa', '=======', '>>>>>>>', 'ccc'])
+                     ['<<<<<<<< ', 'aaa', '=======', '>>>>>>> ', 'ccc'])
 
 
 class JoinWeavesTests(TestBase):
@@ -991,3 +991,81 @@
         self.assertRaises(errors.WeaveInvalidChecksum, w.check)
 
 
+class InstrumentedWeave(Weave):
+    """Keep track of how many times functions are called."""
+    
+    def __init__(self, weave_name=None):
+        self._extract_count = 0
+        Weave.__init__(self, weave_name=weave_name)
+
+    def _extract(self, versions):
+        self._extract_count += 1
+        return Weave._extract(self, versions)
+
+
+class JoinOptimization(TestCase):
+    """Test that Weave.join() doesn't extract all texts, only what must be done."""
+
+    def test_join(self):
+        w1 = InstrumentedWeave()
+        w2 = InstrumentedWeave()
+
+        txt0 = ['a\n']
+        txt1 = ['a\n', 'b\n']
+        txt2 = ['a\n', 'c\n']
+        txt3 = ['a\n', 'b\n', 'c\n']
+
+        w1.add('txt0', [], txt0) # extract 1a
+        w2.add('txt0', [], txt0) # extract 1b
+        w1.add('txt1', [0], txt1)# extract 2a
+        w2.add('txt2', [0], txt2)# extract 2b
+        w1.join(w2) # extract 3a to add txt2 
+        w2.join(w1) # extract 3b to add txt1 
+
+        w1.add('txt3', [1, 2], txt3) # extract 4a 
+        w2.add('txt3', [1, 2], txt3) # extract 4b
+        # These secretly have inverted parents
+
+        # This should not have to do any extractions
+        w1.join(w2) # NO extract, texts already present with same parents
+        w2.join(w1) # NO extract, texts already present with same parents
+
+        self.assertEqual(4, w1._extract_count)
+        self.assertEqual(4, w2._extract_count)
+
+    def test_double_parent(self):
+        # It should not be considered illegal to add
+        # a revision with the same parent twice
+        w1 = InstrumentedWeave()
+        w2 = InstrumentedWeave()
+
+        txt0 = ['a\n']
+        txt1 = ['a\n', 'b\n']
+        txt2 = ['a\n', 'c\n']
+        txt3 = ['a\n', 'b\n', 'c\n']
+
+        w1.add('txt0', [], txt0)
+        w2.add('txt0', [], txt0)
+        w1.add('txt1', [0], txt1)
+        w2.add('txt1', [0,0], txt1)
+        # Same text, effectively the same, because the
+        # parent is only repeated
+        w1.join(w2) # extract 3a to add txt2 
+        w2.join(w1) # extract 3b to add txt1 
+
+
+class MismatchedTexts(TestCase):
+    """Test that merging two weaves with different texts fails."""
+
+    def test_reweave(self):
+        w1 = Weave('a')
+        w2 = Weave('b')
+
+        w1.add('txt0', [], ['a\n'])
+        w2.add('txt0', [], ['a\n'])
+        w1.add('txt1', [0], ['a\n', 'b\n'])
+        w2.add('txt1', [0], ['a\n', 'c\n'])
+
+        self.assertRaises(errors.WeaveTextDiffers, w1.reweave, w2)
+
+

=== modified file 'bzrlib/tests/test_whitebox.py'
--- bzrlib/tests/test_whitebox.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_whitebox.py	2006-03-20 08:31:00 +0000
@@ -1,74 +1,13 @@
 import os
 import unittest
 
-from bzrlib.tests import TestCaseInTempDir, TestCase
+from bzrlib.tests import TestCaseWithTransport, TestCase
 from bzrlib.branch import ScratchBranch, Branch
 from bzrlib.errors import PathNotChild
 from bzrlib.osutils import relpath, pathjoin, abspath, realpath
 
 
-class TestBranch(TestCaseInTempDir):
-
-    def test_no_changes(self):
-        from bzrlib.errors import PointlessCommit
-        
-        b = Branch.initialize(u'.')
-
-        self.build_tree(['hello.txt'])
-
-        self.assertRaises(PointlessCommit,
-                          b.working_tree().commit,
-                          'commit without adding',
-                          allow_pointless=False)
-
-        b.working_tree().commit('commit pointless tree',
-                 allow_pointless=True)
-
-        b.working_tree().add('hello.txt')
-        
-        b.working_tree().commit('commit first added file',
-                 allow_pointless=False)
-        
-        self.assertRaises(PointlessCommit,
-                          b.working_tree().commit,
-                          'commit after adding file',
-                          allow_pointless=False)
-        
-        b.working_tree().commit('commit pointless revision with one file',
-                 allow_pointless=True)
-
-
-class MoreTests(TestCaseInTempDir):
-
-    def test_rename_dirs(self):
-        """Test renaming directories and the files within them."""
-        b = Branch.initialize(u'.')
-        self.build_tree(['dir/', 'dir/sub/', 'dir/sub/file'])
-        b.working_tree().add(['dir', 'dir/sub', 'dir/sub/file'])
-
-        b.working_tree().commit('create initial state')
-
-        # TODO: lift out to a test helper that checks the shape of
-        # an inventory
-        
-        revid = b.revision_history()[0]
-        self.log('first revision_id is {%s}' % revid)
-        
-        inv = b.get_revision_inventory(revid)
-        self.log('contents of inventory: %r' % inv.entries())
-
-        self.check_inventory_shape(inv,
-                                   ['dir', 'dir/sub', 'dir/sub/file'])
-
-        b.working_tree().rename_one('dir', 'newdir')
-
-        self.check_inventory_shape(b.working_tree().read_working_inventory(),
-                                   ['newdir', 'newdir/sub', 'newdir/sub/file'])
-
-        b.working_tree().rename_one('newdir/sub', 'newdir/newsub')
-        self.check_inventory_shape(b.working_tree().read_working_inventory(),
-                                   ['newdir', 'newdir/newsub',
-                                    'newdir/newsub/file'])
+class MoreTests(TestCaseWithTransport):
 
     def test_relpath(self):
         """test for branch path lookups

=== modified file 'bzrlib/tests/test_workingtree.py'
--- bzrlib/tests/test_workingtree.py	2006-01-25 14:30:06 +0000
+++ bzrlib/tests/test_workingtree.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# (C) 2005 Canonical Ltd
+# (C) 2005,2006 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -15,173 +15,167 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from cStringIO import StringIO
 import os
+
+import bzrlib
 from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
 from bzrlib.errors import NotBranchError, NotVersionedError
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.osutils import pathjoin, getcwd, has_symlinks
+from bzrlib.tests import TestCaseWithTransport
 from bzrlib.trace import mutter
-from bzrlib.osutils import pathjoin, getcwd, has_symlinks
+from bzrlib.transport import get_transport
+import bzrlib.workingtree as workingtree
 from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
                                 WorkingTree)
 
-class TestTreeDirectory(TestCaseInTempDir):
+class TestTreeDirectory(TestCaseWithTransport):
 
     def test_kind_character(self):
         self.assertEqual(TreeDirectory().kind_character(), '/')
 
 
-class TestTreeEntry(TestCaseInTempDir):
+class TestTreeEntry(TestCaseWithTransport):
 
     def test_kind_character(self):
         self.assertEqual(TreeEntry().kind_character(), '???')
 
 
-class TestTreeFile(TestCaseInTempDir):
+class TestTreeFile(TestCaseWithTransport):
 
     def test_kind_character(self):
         self.assertEqual(TreeFile().kind_character(), '')
 
 
-class TestTreeLink(TestCaseInTempDir):
+class TestTreeLink(TestCaseWithTransport):
 
     def test_kind_character(self):
         self.assertEqual(TreeLink().kind_character(), '')
 
 
-class TestWorkingTree(TestCaseInTempDir):
-
-    def test_listfiles(self):
-        branch = Branch.initialize(u'.')
-        os.mkdir('dir')
-        print >> open('file', 'w'), "content"
-        if has_symlinks():
-            os.symlink('target', 'symlink')
-        tree = branch.working_tree()
-        files = list(tree.list_files())
-        self.assertEqual(files[0], ('dir', '?', 'directory', None, TreeDirectory()))
-        self.assertEqual(files[1], ('file', '?', 'file', None, TreeFile()))
-        if has_symlinks():
-            self.assertEqual(files[2], ('symlink', '?', 'symlink', None, TreeLink()))
-
-    def test_open_containing(self):
-        branch = Branch.initialize(u'.')
-        wt, relpath = WorkingTree.open_containing()
-        self.assertEqual('', relpath)
-        self.assertEqual(wt.basedir, branch.base)
-        wt, relpath = WorkingTree.open_containing(u'.')
-        self.assertEqual('', relpath)
-        self.assertEqual(wt.basedir, branch.base)
-        wt, relpath = WorkingTree.open_containing('./foo')
-        self.assertEqual('foo', relpath)
-        self.assertEqual(wt.basedir, branch.base)
-        # paths that are urls are just plain wrong for working trees.
-        self.assertRaises(NotBranchError,
-                          WorkingTree.open_containing, 
-                          'file:///' + getcwd())
-
-    def test_construct_with_branch(self):
-        branch = Branch.initialize(u'.')
-        tree = WorkingTree(branch.base, branch)
-        self.assertEqual(branch, tree.branch)
-        self.assertEqual(branch.base, tree.basedir)
-    
-    def test_construct_without_branch(self):
-        branch = Branch.initialize(u'.')
-        tree = WorkingTree(branch.base)
-        self.assertEqual(branch.base, tree.branch.base)
-        self.assertEqual(branch.base, tree.basedir)
-
-    def test_basic_relpath(self):
-        # for comprehensive relpath tests, see whitebox.py.
-        branch = Branch.initialize(u'.')
-        tree = WorkingTree(branch.base)
-        self.assertEqual('child',
-                         tree.relpath(pathjoin(getcwd(), 'child')))
-
-    def test_lock_locks_branch(self):
-        branch = Branch.initialize(u'.')
-        tree = WorkingTree(branch.base)
-        tree.lock_read()
-        self.assertEqual(1, tree.branch._lock_count)
-        self.assertEqual('r', tree.branch._lock_mode)
-        tree.unlock()
-        self.assertEqual(None, tree.branch._lock_count)
-        tree.lock_write()
-        self.assertEqual(1, tree.branch._lock_count)
-        self.assertEqual('w', tree.branch._lock_mode)
-        tree.unlock()
-        self.assertEqual(None, tree.branch._lock_count)
- 
-    def get_pullable_branches(self):
-        self.build_tree(['from/', 'from/file', 'to/'])
-        br_a = Branch.initialize('from')
-        tree = br_a.working_tree()
-        tree.add('file')
-        tree.commit('foo', rev_id='A')
-        br_b = Branch.initialize('to')
-        return br_a, br_b
- 
-    def test_pull(self):
-        br_a, br_b = self.get_pullable_branches()
-        br_b.working_tree().pull(br_a)
-        self.failUnless(br_b.has_revision('A'))
-        self.assertEqual(['A'], br_b.revision_history())
-
-    def test_pull_overwrites(self):
-        br_a, br_b = self.get_pullable_branches()
-        br_b.working_tree().commit('foo', rev_id='B')
-        self.assertEqual(['B'], br_b.revision_history())
-        br_b.working_tree().pull(br_a, overwrite=True)
-        self.failUnless(br_b.has_revision('A'))
-        self.failUnless(br_b.has_revision('B'))
-        self.assertEqual(['A'], br_b.revision_history())
-
-    def test_revert(self):
-        """Test selected-file revert"""
-        b = Branch.initialize(u'.')
-
-        self.build_tree(['hello.txt'])
-        file('hello.txt', 'w').write('initial hello')
-
-        self.assertRaises(NotVersionedError,
-                          b.working_tree().revert, ['hello.txt'])
-        tree = WorkingTree(b.base, b)
-        tree.add(['hello.txt'])
-        tree.commit('create initial hello.txt')
-
-        self.check_file_contents('hello.txt', 'initial hello')
-        file('hello.txt', 'w').write('new hello')
-        self.check_file_contents('hello.txt', 'new hello')
-
-        # revert file modified since last revision
-        tree.revert(['hello.txt'])
-        self.check_file_contents('hello.txt', 'initial hello')
-        self.check_file_contents('hello.txt~', 'new hello')
-
-        # reverting again does not clobber the backup
-        tree.revert(['hello.txt'])
-        self.check_file_contents('hello.txt', 'initial hello')
-        self.check_file_contents('hello.txt~', 'new hello')
-
-    def test_unknowns(self):
-        b = Branch.initialize(u'.')
-        tree = WorkingTree(u'.', b)
-        self.build_tree(['hello.txt',
-                         'hello.txt~'])
-        self.assertEquals(list(tree.unknowns()),
-                          ['hello.txt'])
-
-    def test_hashcache(self):
-        from bzrlib.tests.test_hashcache import pause
-        b = Branch.initialize(u'.')
-        tree = WorkingTree(u'.', b)
-        self.build_tree(['hello.txt',
-                         'hello.txt~'])
-        tree.add('hello.txt')
-        pause()
-        sha = tree.get_file_sha1(tree.path2id('hello.txt'))
-        self.assertEqual(1, tree._hashcache.miss_count)
-        tree2 = WorkingTree(u'.', b)
-        sha2 = tree2.get_file_sha1(tree2.path2id('hello.txt'))
-        self.assertEqual(0, tree2._hashcache.miss_count)
-        self.assertEqual(1, tree2._hashcache.hit_count)
+class TestDefaultFormat(TestCaseWithTransport):
+
+    def test_get_set_default_format(self):
+        old_format = workingtree.WorkingTreeFormat.get_default_format()
+        # default is 3
+        self.assertTrue(isinstance(old_format, workingtree.WorkingTreeFormat3))
+        workingtree.WorkingTreeFormat.set_default_format(SampleTreeFormat())
+        try:
+            # the default branch format is used by the meta dir format
+            # which is not the default bzrdir format at this point
+            dir = bzrdir.BzrDirMetaFormat1().initialize('.')
+            dir.create_repository()
+            dir.create_branch()
+            result = dir.create_workingtree()
+            self.assertEqual(result, 'A tree')
+        finally:
+            workingtree.WorkingTreeFormat.set_default_format(old_format)
+        self.assertEqual(old_format, workingtree.WorkingTreeFormat.get_default_format())
+
+
+class SampleTreeFormat(workingtree.WorkingTreeFormat):
+    """A sample format
+
+    this format is initializable, unsupported to aid in testing the 
+    open and open_downlevel routines.
+    """
+
+    def get_format_string(self):
+        """See WorkingTreeFormat.get_format_string()."""
+        return "Sample tree format."
+
+    def initialize(self, a_bzrdir, revision_id=None):
+        """Sample branches cannot be created."""
+        t = a_bzrdir.get_workingtree_transport(self)
+        t.put('format', StringIO(self.get_format_string()))
+        return 'A tree'
+
+    def is_supported(self):
+        return False
+
+    def open(self, transport, _found=False):
+        return "opened tree."
+
+
+class TestWorkingTreeFormat(TestCaseWithTransport):
+    """Tests for the WorkingTreeFormat facility."""
+
+    def test_find_format(self):
+        # is the right format object found for a working tree?
+        # create a branch with a few known format objects.
+        self.build_tree(["foo/", "bar/"])
+        def check_format(format, url):
+            dir = format._matchingbzrdir.initialize(url)
+            dir.create_repository()
+            dir.create_branch()
+            format.initialize(dir)
+            t = get_transport(url)
+            found_format = workingtree.WorkingTreeFormat.find_format(dir)
+            self.failUnless(isinstance(found_format, format.__class__))
+        check_format(workingtree.WorkingTreeFormat3(), "bar")
+        
+    def test_find_format_no_tree(self):
+        dir = bzrdir.BzrDirMetaFormat1().initialize('.')
+        self.assertRaises(errors.NoWorkingTree,
+                          workingtree.WorkingTreeFormat.find_format,
+                          dir)
+
+    def test_find_format_unknown_format(self):
+        dir = bzrdir.BzrDirMetaFormat1().initialize('.')
+        dir.create_repository()
+        dir.create_branch()
+        SampleTreeFormat().initialize(dir)
+        self.assertRaises(errors.UnknownFormatError,
+                          workingtree.WorkingTreeFormat.find_format,
+                          dir)
+
+    def test_register_unregister_format(self):
+        format = SampleTreeFormat()
+        # make a control dir
+        dir = bzrdir.BzrDirMetaFormat1().initialize('.')
+        dir.create_repository()
+        dir.create_branch()
+        # make a branch
+        format.initialize(dir)
+        # register a format for it.
+        workingtree.WorkingTreeFormat.register_format(format)
+        # which branch.Open will refuse (not supported)
+        self.assertRaises(errors.UnsupportedFormatError, workingtree.WorkingTree.open, '.')
+        # but open_downlevel will work
+        self.assertEqual(format.open(dir), workingtree.WorkingTree.open_downlevel('.'))
+        # unregister the format
+        workingtree.WorkingTreeFormat.unregister_format(format)
+
+
+class TestWorkingTreeFormat3(TestCaseWithTransport):
+    """Tests specific to WorkingTreeFormat3."""
+
+    def test_disk_layout(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        control.create_repository()
+        control.create_branch()
+        tree = workingtree.WorkingTreeFormat3().initialize(control)
+        # we want:
+        # format 'Bazaar-NG Working Tree format 3'
+        # lock ''
+        # inventory = blank inventory
+        # pending-merges = ''
+        # stat-cache = ??
+        # no inventory.basis yet
+        t = control.get_workingtree_transport(None)
+        self.assertEqualDiff('Bazaar-NG Working Tree format 3',
+                             t.get('format').read())
+        self.assertEqualDiff('', t.get('lock').read())
+        self.assertEqualDiff('<inventory format="5">\n'
+                             '</inventory>\n',
+                             t.get('inventory').read())
+        self.assertEqualDiff('### bzr hashcache v5\n',
+                             t.get('stat-cache').read())
+        self.assertFalse(t.has('inventory.basis'))
+        # no last-revision file means 'None' or 'NULLREVISION'
+        self.assertFalse(t.has('last-revision'))
+        # TODO RBC 20060210 do a commit, check the inventory.basis is created 
+        # correctly and last-revision file becomes present.

=== added directory 'bzrlib/tests/workingtree_implementations'
=== added file 'bzrlib/tests/workingtree_implementations/__init__.py'
--- bzrlib/tests/workingtree_implementations/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/workingtree_implementations/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,83 @@
+# Copyright (C) 2006 by Canonical Ltd
+# Authors: Robert Collins <robert.collins@canonical.com>
+# -*- coding: utf-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""WorkingTree implementation tests for bzr.
+
+These test the conformance of all the workingtre variations to the expected API.
+Specific tests for individual formats are in the tests/test_workingtree file 
+rather than in tests/workingtree_implementations/*.py.
+"""
+
+import bzrlib.errors as errors
+from bzrlib.transport import get_transport
+from bzrlib.tests import (
+                          adapt_modules,
+                          default_transport,
+                          TestCaseWithTransport,
+                          TestLoader,
+                          TestSuite,
+                          )
+from bzrlib.workingtree import (WorkingTreeFormat,
+                                WorkingTreeTestProviderAdapter,
+                                _legacy_formats,
+                                )
+
+
+class TestCaseWithWorkingTree(TestCaseWithTransport):
+
+    def make_bzrdir(self, relpath):
+        # todo factor out into bzrdir-using-implementations-tests-base-class
+        try:
+            url = self.get_url(relpath)
+            segments = url.split('/')
+            if segments and segments[-1] not in ('', '.'):
+                parent = '/'.join(segments[:-1])
+                t = get_transport(parent)
+                try:
+                    t.mkdir(segments[-1])
+                except errors.FileExists:
+                    pass
+            return self.bzrdir_format.initialize(url)
+        except errors.UninitializableFormat:
+            raise TestSkipped("Format %s is not initializable.")
+
+    def make_branch_and_tree(self, relpath):
+        made_control = self.make_bzrdir(relpath)
+        made_control.create_repository()
+        made_control.create_branch()
+        return self.workingtree_format.initialize(made_control)
+
+
+def test_suite():
+    result = TestSuite()
+    test_workingtree_implementations = [
+        'bzrlib.tests.workingtree_implementations.test_is_control_filename',
+        'bzrlib.tests.workingtree_implementations.test_pull',
+        'bzrlib.tests.workingtree_implementations.test_workingtree',
+        ]
+    adapter = WorkingTreeTestProviderAdapter(
+        default_transport,
+        # None here will cause a readonly decorator to be created
+        # by the TestCaseWithTransport.get_readonly_transport method.
+        None,
+        [(format, format._matchingbzrdir) for format in 
+         WorkingTreeFormat._formats.values() + _legacy_formats])
+    loader = TestLoader()
+    adapt_modules(test_workingtree_implementations, adapter, loader, result)
+    return result

=== added file 'bzrlib/tests/workingtree_implementations/test_is_control_filename.py'
--- bzrlib/tests/workingtree_implementations/test_is_control_filename.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/workingtree_implementations/test_is_control_filename.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,55 @@
+# (C) 2006 Canonical Ltd
+# Authors:  Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from cStringIO import StringIO
+import os
+
+import bzrlib
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
+from bzrlib.errors import NotBranchError, NotVersionedError
+from bzrlib.osutils import basename
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
+from bzrlib.trace import mutter
+from bzrlib.transport import get_transport
+import bzrlib.workingtree as workingtree
+from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
+                                WorkingTree)
+
+
+class TestIsControlFilename(TestCaseWithWorkingTree):
+
+    def validate_tree_is_controlfilename(self, tree):
+        """check that 'tree' obeys the contract for is_control_filename."""
+        bzrdirname = basename(tree.bzrdir.transport.base[:-1])
+        self.assertTrue(tree.is_control_filename(bzrdirname))
+        self.assertTrue(tree.is_control_filename(bzrdirname + '/subdir'))
+        self.assertFalse(tree.is_control_filename('dir/' + bzrdirname))
+        self.assertFalse(tree.is_control_filename('dir/' + bzrdirname + '/sub'))
+
+    def test_dotbzr_is_control_in_cwd(self):
+        tree = self.make_branch_and_tree('.')
+        self.validate_tree_is_controlfilename(tree)
+        
+    def test_dotbzr_is_control_in_subdir(self):
+        tree = self.make_branch_and_tree('subdir')
+        self.validate_tree_is_controlfilename(tree)
+        

=== added file 'bzrlib/tests/workingtree_implementations/test_pull.py'
--- bzrlib/tests/workingtree_implementations/test_pull.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/workingtree_implementations/test_pull.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,67 @@
+# (C) 2006 Canonical Ltd
+# Authors:  Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from cStringIO import StringIO
+import os
+
+import bzrlib
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
+from bzrlib.errors import NotBranchError, NotVersionedError
+from bzrlib.osutils import basename
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
+from bzrlib.trace import mutter
+from bzrlib.transport import get_transport
+import bzrlib.workingtree as workingtree
+from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
+                                WorkingTree)
+
+
+class TestPull(TestCaseWithWorkingTree):
+
+    def get_pullable_trees(self):
+        self.build_tree(['from/', 'from/file', 'to/'])
+        tree = self.make_branch_and_tree('from')
+        tree.add('file')
+        tree.commit('foo', rev_id='A')
+        tree_b = self.make_branch_and_tree('to')
+        return tree, tree_b
+ 
+    def test_pull(self):
+        tree_a, tree_b = self.get_pullable_trees()
+        tree_b.pull(tree_a.branch)
+        self.failUnless(tree_b.branch.repository.has_revision('A'))
+        self.assertEqual('A', tree_b.last_revision())
+
+    def test_pull_overwrites(self):
+        tree_a, tree_b = self.get_pullable_trees()
+        tree_b.commit('foo', rev_id='B')
+        self.assertEqual(['B'], tree_b.branch.revision_history())
+        tree_b.pull(tree_a.branch, overwrite=True)
+        self.failUnless(tree_b.branch.repository.has_revision('A'))
+        self.failUnless(tree_b.branch.repository.has_revision('B'))
+        self.assertEqual('A', tree_b.last_revision())
+
+    def test_pull_merges_tree_content(self):
+        tree_a, tree_b = self.get_pullable_trees()
+        tree_b.pull(tree_a.branch)
+        self.assertFileEqual('contents of from/file\n', 'to/file')
+

=== added file 'bzrlib/tests/workingtree_implementations/test_workingtree.py'
--- bzrlib/tests/workingtree_implementations/test_workingtree.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/workingtree_implementations/test_workingtree.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,475 @@
+# (C) 2005,2006 Canonical Ltd
+# Authors:  Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from cStringIO import StringIO
+import os
+
+import bzrlib
+import bzrlib.branch
+from bzrlib.branch import Branch
+import bzrlib.bzrdir as bzrdir
+from bzrlib.bzrdir import BzrDir
+import bzrlib.errors as errors
+from bzrlib.errors import NotBranchError, NotVersionedError
+from bzrlib.osutils import pathjoin, getcwd, has_symlinks
+from bzrlib.tests import TestSkipped
+from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
+from bzrlib.trace import mutter
+import bzrlib.workingtree as workingtree
+from bzrlib.workingtree import (TreeEntry, TreeDirectory, TreeFile, TreeLink,
+                                WorkingTree)
+
+
+class TestWorkingTree(TestCaseWithWorkingTree):
+
+    def test_listfiles(self):
+        tree = self.make_branch_and_tree('.')
+        os.mkdir('dir')
+        print >> open('file', 'w'), "content"
+        if has_symlinks():
+            os.symlink('target', 'symlink')
+        files = list(tree.list_files())
+        self.assertEqual(files[0], ('dir', '?', 'directory', None, TreeDirectory()))
+        self.assertEqual(files[1], ('file', '?', 'file', None, TreeFile()))
+        if has_symlinks():
+            self.assertEqual(files[2], ('symlink', '?', 'symlink', None, TreeLink()))
+
+    def test_open_containing(self):
+        branch = self.make_branch_and_tree('.').branch
+        wt, relpath = WorkingTree.open_containing()
+        self.assertEqual('', relpath)
+        self.assertEqual(wt.basedir + '/', branch.base)
+        wt, relpath = WorkingTree.open_containing(u'.')
+        self.assertEqual('', relpath)
+        self.assertEqual(wt.basedir + '/', branch.base)
+        wt, relpath = WorkingTree.open_containing('./foo')
+        self.assertEqual('foo', relpath)
+        self.assertEqual(wt.basedir + '/', branch.base)
+        wt, relpath = WorkingTree.open_containing('file://' + getcwd() + '/foo')
+        self.assertEqual('foo', relpath)
+        self.assertEqual(wt.basedir + '/', branch.base)
+
+    def test_basic_relpath(self):
+        # for comprehensive relpath tests, see whitebox.py.
+        tree = self.make_branch_and_tree('.')
+        self.assertEqual('child',
+                         tree.relpath(pathjoin(getcwd(), 'child')))
+
+    def test_lock_locks_branch(self):
+        tree = self.make_branch_and_tree('.')
+        tree.lock_read()
+        self.assertEqual('r', tree.branch.peek_lock_mode())
+        tree.unlock()
+        self.assertEqual(None, tree.branch.peek_lock_mode())
+        tree.lock_write()
+        self.assertEqual('w', tree.branch.peek_lock_mode())
+        tree.unlock()
+        self.assertEqual(None, tree.branch.peek_lock_mode())
+ 
+    def test_revert(self):
+        """Test selected-file revert"""
+        tree = self.make_branch_and_tree('.')
+
+        self.build_tree(['hello.txt'])
+        file('hello.txt', 'w').write('initial hello')
+
+        self.assertRaises(NotVersionedError,
+                          tree.revert, ['hello.txt'])
+        tree.add(['hello.txt'])
+        tree.commit('create initial hello.txt')
+
+        self.check_file_contents('hello.txt', 'initial hello')
+        file('hello.txt', 'w').write('new hello')
+        self.check_file_contents('hello.txt', 'new hello')
+
+        # revert file modified since last revision
+        tree.revert(['hello.txt'])
+        self.check_file_contents('hello.txt', 'initial hello')
+        self.check_file_contents('hello.txt~', 'new hello')
+
+        # reverting again does not clobber the backup
+        tree.revert(['hello.txt'])
+        self.check_file_contents('hello.txt', 'initial hello')
+        self.check_file_contents('hello.txt~', 'new hello')
+
+    def test_unknowns(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['hello.txt',
+                         'hello.txt~'])
+        self.assertEquals(list(tree.unknowns()),
+                          ['hello.txt'])
+
+    def test_hashcache(self):
+        from bzrlib.tests.test_hashcache import pause
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['hello.txt',
+                         'hello.txt~'])
+        tree.add('hello.txt')
+        pause()
+        sha = tree.get_file_sha1(tree.path2id('hello.txt'))
+        self.assertEqual(1, tree._hashcache.miss_count)
+        tree2 = WorkingTree.open('.')
+        sha2 = tree2.get_file_sha1(tree2.path2id('hello.txt'))
+        self.assertEqual(0, tree2._hashcache.miss_count)
+        self.assertEqual(1, tree2._hashcache.hit_count)
+
+    def test_initialize(self):
+        # initialize should create a working tree and branch in an existing dir
+        t = self.make_branch_and_tree('.')
+        b = Branch.open('.')
+        self.assertEqual(t.branch.base, b.base)
+        t2 = WorkingTree.open('.')
+        self.assertEqual(t.basedir, t2.basedir)
+        self.assertEqual(b.base, t2.branch.base)
+        # TODO maybe we should check the branch format? not sure if its
+        # appropriate here.
+
+    def test_rename_dirs(self):
+        """Test renaming directories and the files within them."""
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+        self.build_tree(['dir/', 'dir/sub/', 'dir/sub/file'])
+        wt.add(['dir', 'dir/sub', 'dir/sub/file'])
+
+        wt.commit('create initial state')
+
+        revid = b.revision_history()[0]
+        self.log('first revision_id is {%s}' % revid)
+        
+        inv = b.repository.get_revision_inventory(revid)
+        self.log('contents of inventory: %r' % inv.entries())
+
+        self.check_inventory_shape(inv,
+                                   ['dir', 'dir/sub', 'dir/sub/file'])
+
+        wt.rename_one('dir', 'newdir')
+
+        self.check_inventory_shape(wt.read_working_inventory(),
+                                   ['newdir', 'newdir/sub', 'newdir/sub/file'])
+
+        wt.rename_one('newdir/sub', 'newdir/newsub')
+        self.check_inventory_shape(wt.read_working_inventory(),
+                                   ['newdir', 'newdir/newsub',
+                                    'newdir/newsub/file'])
+
+    def test_add_in_unversioned(self):
+        """Try to add a file in an unversioned directory.
+
+        "bzr add" adds the parent as necessary, but simple working tree add
+        doesn't do that.
+        """
+        from bzrlib.errors import NotVersionedError
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['foo/',
+                         'foo/hello'])
+        self.assertRaises(NotVersionedError,
+                          wt.add,
+                          'foo/hello')
+
+    def test_add_missing(self):
+        # adding a msising file -> NoSuchFile
+        wt = self.make_branch_and_tree('.')
+        self.assertRaises(errors.NoSuchFile, wt.add, 'fpp')
+
+    def test_remove_verbose(self):
+        #FIXME the remove api should not print or otherwise depend on the
+        # text UI - RBC 20060124
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['hello'])
+        wt.add(['hello'])
+        wt.commit(message='add hello')
+        stdout = StringIO()
+        stderr = StringIO()
+        self.assertEqual(None, self.apply_redirected(None, stdout, stderr,
+                                                     wt.remove,
+                                                     ['hello'],
+                                                     verbose=True))
+        self.assertEqual('?       hello\n', stdout.getvalue())
+        self.assertEqual('', stderr.getvalue())
+
+    def test_clone_trivial(self):
+        wt = self.make_branch_and_tree('source')
+        cloned_dir = wt.bzrdir.clone('target')
+        cloned = cloned_dir.open_workingtree()
+        self.assertEqual(cloned.last_revision(), wt.last_revision())
+
+    def test_last_revision(self):
+        wt = self.make_branch_and_tree('source')
+        self.assertEqual(None, wt.last_revision())
+        wt.commit('A', allow_pointless=True, rev_id='A')
+        self.assertEqual('A', wt.last_revision())
+
+    def test_set_last_revision(self):
+        wt = self.make_branch_and_tree('source')
+        self.assertEqual(None, wt.last_revision())
+        # cannot set the last revision to one not in the branch history.
+        self.assertRaises(errors.NoSuchRevision, wt.set_last_revision, 'A')
+        wt.commit('A', allow_pointless=True, rev_id='A')
+        self.assertEqual('A', wt.last_revision())
+        # None is aways in the branch
+        wt.set_last_revision(None)
+        self.assertEqual(None, wt.last_revision())
+        # and now we can set it to 'A'
+        # because some formats mutate the branch to set it on the tree
+        # we need to alter the branch to let this pass.
+        wt.branch.set_revision_history(['A', 'B'])
+        wt.set_last_revision('A')
+        self.assertEqual('A', wt.last_revision())
+
+    def test_set_last_revision_different_to_branch(self):
+        # working tree formats from the meta-dir format and newer support
+        # setting the last revision on a tree independently of that on the 
+        # branch. Its concievable that some future formats may want to 
+        # couple them again (i.e. because its really a smart server and
+        # the working tree will always match the branch). So we test
+        # that formats where initialising a branch does not initialise a 
+        # tree - and thus have separable entities - support skewing the 
+        # two things.
+        branch = self.make_branch('tree')
+        try:
+            # if there is a working tree now, this is not supported.
+            branch.bzrdir.open_workingtree()
+            return
+        except errors.NoWorkingTree:
+            pass
+        wt = branch.bzrdir.create_workingtree()
+        wt.commit('A', allow_pointless=True, rev_id='A')
+        wt.set_last_revision(None)
+        self.assertEqual(None, wt.last_revision())
+        self.assertEqual('A', wt.branch.last_revision())
+        # and now we can set it back to 'A'
+        wt.set_last_revision('A')
+        self.assertEqual('A', wt.last_revision())
+        self.assertEqual('A', wt.branch.last_revision())
+
+    def test_clone_and_commit_preserves_last_revision(self):
+        wt = self.make_branch_and_tree('source')
+        cloned_dir = wt.bzrdir.clone('target')
+        wt.commit('A', allow_pointless=True, rev_id='A')
+        self.assertNotEqual(cloned_dir.open_workingtree().last_revision(),
+                            wt.last_revision())
+
+    def test_clone_preserves_content(self):
+        wt = self.make_branch_and_tree('source')
+        self.build_tree(['added', 'deleted', 'notadded'], transport=wt.bzrdir.transport.clone('..'))
+        wt.add('deleted', 'deleted')
+        wt.commit('add deleted')
+        wt.remove('deleted')
+        wt.add('added', 'added')
+        cloned_dir = wt.bzrdir.clone('target')
+        cloned = cloned_dir.open_workingtree()
+        cloned_transport = cloned.bzrdir.transport.clone('..')
+        self.assertFalse(cloned_transport.has('deleted'))
+        self.assertTrue(cloned_transport.has('added'))
+        self.assertFalse(cloned_transport.has('notadded'))
+        self.assertEqual('added', cloned.path2id('added'))
+        self.assertEqual(None, cloned.path2id('deleted'))
+        self.assertEqual(None, cloned.path2id('notadded'))
+        
+    def test_basis_tree_returns_last_revision(self):
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['foo'])
+        wt.add('foo', 'foo-id')
+        wt.commit('A', rev_id='A')
+        wt.rename_one('foo', 'bar')
+        wt.commit('B', rev_id='B')
+        wt.set_last_revision('B')
+        tree = wt.basis_tree()
+        self.failUnless(tree.has_filename('bar'))
+        wt.set_last_revision('A')
+        tree = wt.basis_tree()
+        self.failUnless(tree.has_filename('foo'))
+
+    def test_clone_tree_revision(self):
+        # make a tree with a last-revision,
+        # and clone it with a different last-revision, this should switch
+        # do it.
+        #
+        # also test that the content is merged
+        # and conflicts recorded.
+        # This should merge between the trees - local edits should be preserved
+        # but other changes occured.
+        # we test this by having one file that does
+        # not change between two revisions, and another that does -
+        # if the changed one is not changed, fail,
+        # if the one that did not change has lost a local change, fail.
+        # 
+        raise TestSkipped('revision limiting is not implemented yet.')
+
+    def test_initialize_with_revision_id(self):
+        # a bzrdir can construct a working tree for itself @ a specific revision.
+        source = self.make_branch_and_tree('source')
+        source.commit('a', rev_id='a', allow_pointless=True)
+        source.commit('b', rev_id='b', allow_pointless=True)
+        self.build_tree(['new/'])
+        made_control = self.bzrdir_format.initialize('new')
+        source.branch.repository.clone(made_control)
+        source.branch.clone(made_control)
+        made_tree = self.workingtree_format.initialize(made_control, revision_id='a')
+        self.assertEqual('a', made_tree.last_revision())
+
+    def test_commit_sets_last_revision(self):
+        tree = self.make_branch_and_tree('tree')
+        tree.commit('foo', rev_id='foo', allow_pointless=True)
+        self.assertEqual('foo', tree.last_revision())
+
+    def test_commit_local_unbound(self):
+        # using the library api to do a local commit on unbound branches is 
+        # also an error
+        tree = self.make_branch_and_tree('tree')
+        self.assertRaises(errors.LocalRequiresBoundBranch,
+                          tree.commit,
+                          'foo',
+                          local=True)
+ 
+    def test_local_commit_ignores_master(self):
+        # a --local commit does not require access to the master branch
+        # at all, or even for it to exist.
+        # we test this by setting up a bound branch and then corrupting
+        # the master.
+        master = self.make_branch('master')
+        tree = self.make_branch_and_tree('tree')
+        try:
+            tree.branch.bind(master)
+        except errors.UpgradeRequired:
+            # older format.
+            return
+        master.bzrdir.transport.put('branch-format', StringIO('garbage'))
+        del master
+        # check its corrupted.
+        self.assertRaises(errors.UnknownFormatError,
+                          bzrdir.BzrDir.open,
+                          'master')
+        tree.commit('foo', rev_id='foo', local=True)
+ 
+    def test_local_commit_does_not_push_to_master(self):
+        # a --local commit does not require access to the master branch
+        # at all, or even for it to exist.
+        # we test that even when its available it does not push to it.
+        master = self.make_branch('master')
+        tree = self.make_branch_and_tree('tree')
+        try:
+            tree.branch.bind(master)
+        except errors.UpgradeRequired:
+            # older format.
+            return
+        tree.commit('foo', rev_id='foo', local=True)
+        self.failIf(master.repository.has_revision('foo'))
+        self.assertEqual(None, master.last_revision())
+        
+    def test_update_sets_last_revision(self):
+        # working tree formats from the meta-dir format and newer support
+        # setting the last revision on a tree independently of that on the 
+        # branch. Its concievable that some future formats may want to 
+        # couple them again (i.e. because its really a smart server and
+        # the working tree will always match the branch). So we test
+        # that formats where initialising a branch does not initialise a 
+        # tree - and thus have separable entities - support skewing the 
+        # two things.
+        main_branch = self.make_branch('tree')
+        try:
+            # if there is a working tree now, this is not supported.
+            main_branch.bzrdir.open_workingtree()
+            return
+        except errors.NoWorkingTree:
+            pass
+        wt = main_branch.bzrdir.create_workingtree()
+        # create an out of date working tree by making a checkout in this
+        # current format
+        self.build_tree(['checkout/', 'tree/file'])
+        checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
+        bzrlib.branch.BranchReferenceFormat().initialize(checkout, main_branch)
+        old_tree = self.workingtree_format.initialize(checkout)
+        # now commit to 'tree'
+        wt.add('file')
+        wt.commit('A', rev_id='A')
+        # and update old_tree
+        self.assertEqual(0, old_tree.update())
+        self.failUnlessExists('checkout/file')
+        self.assertEqual('A', old_tree.last_revision())
+
+    def test_update_returns_conflict_count(self):
+        # working tree formats from the meta-dir format and newer support
+        # setting the last revision on a tree independently of that on the 
+        # branch. Its concievable that some future formats may want to 
+        # couple them again (i.e. because its really a smart server and
+        # the working tree will always match the branch). So we test
+        # that formats where initialising a branch does not initialise a 
+        # tree - and thus have separable entities - support skewing the 
+        # two things.
+        main_branch = self.make_branch('tree')
+        try:
+            # if there is a working tree now, this is not supported.
+            main_branch.bzrdir.open_workingtree()
+            return
+        except errors.NoWorkingTree:
+            pass
+        wt = main_branch.bzrdir.create_workingtree()
+        # create an out of date working tree by making a checkout in this
+        # current format
+        self.build_tree(['checkout/', 'tree/file'])
+        checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
+        bzrlib.branch.BranchReferenceFormat().initialize(checkout, main_branch)
+        old_tree = self.workingtree_format.initialize(checkout)
+        # now commit to 'tree'
+        wt.add('file')
+        wt.commit('A', rev_id='A')
+        # and add a file file to the checkout
+        self.build_tree(['checkout/file'])
+        old_tree.add('file')
+        # and update old_tree
+        self.assertEqual(1, old_tree.update())
+        self.assertEqual('A', old_tree.last_revision())
+
+    def test_update_updates_bound_branch_no_local_commits(self):
+        # doing an update in a tree updates the branch its bound to too.
+        master_tree = self.make_branch_and_tree('master')
+        tree = self.make_branch_and_tree('tree')
+        try:
+            tree.branch.bind(master_tree.branch)
+        except errors.UpgradeRequired:
+            # legacy branches cannot bind
+            return
+        master_tree.commit('foo', rev_id='foo', allow_pointless=True)
+        tree.update()
+        self.assertEqual('foo', tree.last_revision())
+        self.assertEqual('foo', tree.branch.last_revision())
+
+    def test_update_turns_local_commit_into_merge(self):
+        # doing an update with a few local commits and no master commits
+        # makes pending-merges. 
+        # this is done so that 'bzr update; bzr revert' will always produce
+        # an exact copy of the 'logical branch' - the referenced branch for
+        # a checkout, and the master for a bound branch.
+        # its possible that we should instead have 'bzr update' when there
+        # is nothing new on the master leave the current commits intact and
+        # alter 'revert' to revert to the master always. But for now, its
+        # good.
+        master_tree = self.make_branch_and_tree('master')
+        tree = self.make_branch_and_tree('tree')
+        try:
+            tree.branch.bind(master_tree.branch)
+        except errors.UpgradeRequired:
+            # legacy branches cannot bind
+            return
+        tree.commit('foo', rev_id='foo', allow_pointless=True, local=True)
+        tree.commit('bar', rev_id='bar', allow_pointless=True, local=True)
+        tree.update()
+        self.assertEqual(None, tree.last_revision())
+        self.assertEqual([], tree.branch.revision_history())
+        self.assertEqual(['bar'], tree.pending_merges())
+

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2006-01-25 14:30:06 +0000
+++ bzrlib/trace.py	2006-03-20 08:31:00 +0000
@@ -219,21 +219,26 @@
 
 
 def enable_test_log(to_file):
-    """Redirect logging to a temporary file for a test"""
+    """Redirect logging to a temporary file for a test
+    
+    returns an opaque reference that should be passed to disable_test_log
+    after the test complete.
+    """
     disable_default_logging()
-    global _test_log_hdlr, _trace_file
+    global _trace_file
     hdlr = logging.StreamHandler(to_file)
     hdlr.setLevel(logging.DEBUG)
     hdlr.setFormatter(logging.Formatter('%(levelname)8s  %(message)s'))
     _bzr_logger.addHandler(hdlr)
     _bzr_logger.setLevel(logging.DEBUG)
-    _test_log_hdlr = hdlr
+    result = hdlr, _trace_file
     _trace_file = to_file
-
-
-def disable_test_log():
-    _bzr_logger.removeHandler(_test_log_hdlr)
-    _trace_file = None
+    return result
+
+
+def disable_test_log((test_log_hdlr, old_trace_file)):
+    _bzr_logger.removeHandler(test_log_hdlr)
+    _trace_file = old_trace_file
     enable_default_logging()
 
 

=== modified file 'bzrlib/transactions.py'
--- bzrlib/transactions.py	2005-11-07 13:17:53 +0000
+++ bzrlib/transactions.py	2006-03-20 08:31:00 +0000
@@ -51,7 +51,7 @@
 
     def commit(self):
         """ReadOnlyTransactions cannot commit."""
-        raise errors.CommitNotPossible('In a read only transaction')
+        raise errors.CommitNotPossible()
 
     def finish(self):
         """Clean up this transaction
@@ -82,8 +82,7 @@
 
     def register_dirty(self, an_object):
         """Register an_object as being dirty."""
-        raise errors.ReadOnlyError(
-            "Cannot dirty objects in a read only transaction")
+        raise errors.ReadOnlyObjectDirtiedError(an_object)
 
     def rollback(self):
         """Let people call this even though nothing has to happen."""

=== added file 'bzrlib/transform.py'
--- bzrlib/transform.py	1970-01-01 00:00:00 +0000
+++ bzrlib/transform.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,1148 @@
+# Copyright (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+import errno
+from stat import S_ISREG
+
+from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
+                           ReusingTransform, NotVersionedError, CantMoveRoot,
+                           ExistingLimbo, ImmortalLimbo)
+from bzrlib.inventory import InventoryEntry
+from bzrlib.osutils import file_kind, supports_executable, pathjoin
+from bzrlib.progress import DummyProgress
+from bzrlib.trace import mutter, warning
+
+
+ROOT_PARENT = "root-parent"
+
+
+def unique_add(map, key, value):
+    if key in map:
+        raise DuplicateKey(key=key)
+    map[key] = value
+
+
+class TreeTransform(object):
+    """Represent a tree transformation.
+    
+    This object is designed to support incremental generation of the transform,
+    in any order.  
+    
+    It is easy to produce malformed transforms, but they are generally
+    harmless.  Attempting to apply a malformed transform will cause an
+    exception to be raised before any modifications are made to the tree.  
+
+    Many kinds of malformed transforms can be corrected with the 
+    resolve_conflicts function.  The remaining ones indicate programming error,
+    such as trying to create a file with no path.
+
+    Two sets of file creation methods are supplied.  Convenience methods are:
+     * new_file
+     * new_directory
+     * new_symlink
+
+    These are composed of the low-level methods:
+     * create_path
+     * create_file or create_directory or create_symlink
+     * version_file
+     * set_executability
+    """
+    def __init__(self, tree, pb=DummyProgress()):
+        """Note: a write lock is taken on the tree.
+        
+        Use TreeTransform.finalize() to release the lock
+        """
+        object.__init__(self)
+        self._tree = tree
+        self._tree.lock_write()
+        try:
+            control_files = self._tree._control_files
+            self._limbodir = control_files.controlfilename('limbo')
+            try:
+                os.mkdir(self._limbodir)
+            except OSError, e:
+                if e.errno == errno.EEXIST:
+                    raise ExistingLimbo(self._limbodir)
+        except: 
+            self._tree.unlock()
+            raise
+
+        self._id_number = 0
+        self._new_name = {}
+        self._new_parent = {}
+        self._new_contents = {}
+        self._removed_contents = set()
+        self._new_executability = {}
+        self._new_id = {}
+        self._non_present_ids = {}
+        self._r_new_id = {}
+        self._removed_id = set()
+        self._tree_path_ids = {}
+        self._tree_id_paths = {}
+        self._new_root = self.trans_id_tree_file_id(tree.get_root_id())
+        self.__done = False
+        self._pb = pb
+
+    def __get_root(self):
+        return self._new_root
+
+    root = property(__get_root)
+
+    def finalize(self):
+        """Release the working tree lock, if held, clean up limbo dir."""
+        if self._tree is None:
+            return
+        try:
+            for trans_id, kind in self._new_contents.iteritems():
+                path = self._limbo_name(trans_id)
+                if kind == "directory":
+                    os.rmdir(path)
+                else:
+                    os.unlink(path)
+            try:
+                os.rmdir(self._limbodir)
+            except OSError:
+                # We don't especially care *why* the dir is immortal.
+                raise ImmortalLimbo(self._limbodir)
+        finally:
+            self._tree.unlock()
+            self._tree = None
+
+    def _assign_id(self):
+        """Produce a new tranform id"""
+        new_id = "new-%s" % self._id_number
+        self._id_number +=1
+        return new_id
+
+    def create_path(self, name, parent):
+        """Assign a transaction id to a new path"""
+        trans_id = self._assign_id()
+        unique_add(self._new_name, trans_id, name)
+        unique_add(self._new_parent, trans_id, parent)
+        return trans_id
+
+    def adjust_path(self, name, parent, trans_id):
+        """Change the path that is assigned to a transaction id."""
+        if trans_id == self._new_root:
+            raise CantMoveRoot
+        self._new_name[trans_id] = name
+        self._new_parent[trans_id] = parent
+
+    def adjust_root_path(self, name, parent):
+        """Emulate moving the root by moving all children, instead.
+        
+        We do this by undoing the association of root's transaction id with the
+        current tree.  This allows us to create a new directory with that
+        transaction id.  We unversion the root directory and version the 
+        physically new directory, and hope someone versions the tree root
+        later.
+        """
+        old_root = self._new_root
+        old_root_file_id = self.final_file_id(old_root)
+        # force moving all children of root
+        for child_id in self.iter_tree_children(old_root):
+            if child_id != parent:
+                self.adjust_path(self.final_name(child_id), 
+                                 self.final_parent(child_id), child_id)
+            file_id = self.final_file_id(child_id)
+            if file_id is not None:
+                self.unversion_file(child_id)
+            self.version_file(file_id, child_id)
+        
+        # the physical root needs a new transaction id
+        self._tree_path_ids.pop("")
+        self._tree_id_paths.pop(old_root)
+        self._new_root = self.trans_id_tree_file_id(self._tree.get_root_id())
+        if parent == old_root:
+            parent = self._new_root
+        self.adjust_path(name, parent, old_root)
+        self.create_directory(old_root)
+        self.version_file(old_root_file_id, old_root)
+        self.unversion_file(self._new_root)
+
+    def trans_id_tree_file_id(self, inventory_id):
+        """Determine the transaction id of a working tree file.
+        
+        This reflects only files that already exist, not ones that will be
+        added by transactions.
+        """
+        path = self._tree.inventory.id2path(inventory_id)
+        return self.trans_id_tree_path(path)
+
+    def trans_id_file_id(self, file_id):
+        """Determine or set the transaction id associated with a file ID.
+        A new id is only created for file_ids that were never present.  If
+        a transaction has been unversioned, it is deliberately still returned.
+        (this will likely lead to an unversioned parent conflict.)
+        """
+        if file_id in self._r_new_id and self._r_new_id[file_id] is not None:
+            return self._r_new_id[file_id]
+        elif file_id in self._tree.inventory:
+            return self.trans_id_tree_file_id(file_id)
+        elif file_id in self._non_present_ids:
+            return self._non_present_ids[file_id]
+        else:
+            trans_id = self._assign_id()
+            self._non_present_ids[file_id] = trans_id
+            return trans_id
+
+    def canonical_path(self, path):
+        """Get the canonical tree-relative path"""
+        # don't follow final symlinks
+        dirname, basename = os.path.split(self._tree.abspath(path))
+        dirname = os.path.realpath(dirname)
+        return self._tree.relpath(pathjoin(dirname, basename))
+
+    def trans_id_tree_path(self, path):
+        """Determine (and maybe set) the transaction ID for a tree path."""
+        path = self.canonical_path(path)
+        if path not in self._tree_path_ids:
+            self._tree_path_ids[path] = self._assign_id()
+            self._tree_id_paths[self._tree_path_ids[path]] = path
+        return self._tree_path_ids[path]
+
+    def get_tree_parent(self, trans_id):
+        """Determine id of the parent in the tree."""
+        path = self._tree_id_paths[trans_id]
+        if path == "":
+            return ROOT_PARENT
+        return self.trans_id_tree_path(os.path.dirname(path))
+
+    def create_file(self, contents, trans_id, mode_id=None):
+        """Schedule creation of a new file.
+
+        See also new_file.
+        
+        Contents is an iterator of strings, all of which will be written
+        to the target destination.
+
+        New file takes the permissions of any existing file with that id,
+        unless mode_id is specified.
+        """
+        f = file(self._limbo_name(trans_id), 'wb')
+        unique_add(self._new_contents, trans_id, 'file')
+        for segment in contents:
+            f.write(segment)
+        f.close()
+        self._set_mode(trans_id, mode_id, S_ISREG)
+
+    def _set_mode(self, trans_id, mode_id, typefunc):
+        """Set the mode of new file contents.
+        The mode_id is the existing file to get the mode from (often the same
+        as trans_id).  The operation is only performed if there's a mode match
+        according to typefunc.
+        """
+        if mode_id is None:
+            mode_id = trans_id
+        try:
+            old_path = self._tree_id_paths[mode_id]
+        except KeyError:
+            return
+        try:
+            mode = os.stat(old_path).st_mode
+        except OSError, e:
+            if e.errno == errno.ENOENT:
+                return
+            else:
+                raise
+        if typefunc(mode):
+            os.chmod(self._limbo_name(trans_id), mode)
+
+    def create_directory(self, trans_id):
+        """Schedule creation of a new directory.
+        
+        See also new_directory.
+        """
+        os.mkdir(self._limbo_name(trans_id))
+        unique_add(self._new_contents, trans_id, 'directory')
+
+    def create_symlink(self, target, trans_id):
+        """Schedule creation of a new symbolic link.
+
+        target is a bytestring.
+        See also new_symlink.
+        """
+        os.symlink(target, self._limbo_name(trans_id))
+        unique_add(self._new_contents, trans_id, 'symlink')
+
+    @staticmethod
+    def delete_any(full_path):
+        """Delete a file or directory."""
+        try:
+            os.unlink(full_path)
+        except OSError, e:
+        # We may be renaming a dangling inventory id
+            if e.errno not in (errno.EISDIR, errno.EACCES, errno.EPERM):
+                raise
+            os.rmdir(full_path)
+
+    def cancel_creation(self, trans_id):
+        """Cancel the creation of new file contents."""
+        del self._new_contents[trans_id]
+        self.delete_any(self._limbo_name(trans_id))
+
+    def delete_contents(self, trans_id):
+        """Schedule the contents of a path entry for deletion"""
+        self.tree_kind(trans_id)
+        self._removed_contents.add(trans_id)
+
+    def cancel_deletion(self, trans_id):
+        """Cancel a scheduled deletion"""
+        self._removed_contents.remove(trans_id)
+
+    def unversion_file(self, trans_id):
+        """Schedule a path entry to become unversioned"""
+        self._removed_id.add(trans_id)
+
+    def delete_versioned(self, trans_id):
+        """Delete and unversion a versioned file"""
+        self.delete_contents(trans_id)
+        self.unversion_file(trans_id)
+
+    def set_executability(self, executability, trans_id):
+        """Schedule setting of the 'execute' bit
+        To unschedule, set to None
+        """
+        if executability is None:
+            del self._new_executability[trans_id]
+        else:
+            unique_add(self._new_executability, trans_id, executability)
+
+    def version_file(self, file_id, trans_id):
+        """Schedule a file to become versioned."""
+        assert file_id is not None
+        unique_add(self._new_id, trans_id, file_id)
+        unique_add(self._r_new_id, file_id, trans_id)
+
+    def cancel_versioning(self, trans_id):
+        """Undo a previous versioning of a file"""
+        file_id = self._new_id[trans_id]
+        del self._new_id[trans_id]
+        del self._r_new_id[file_id]
+
+    def new_paths(self):
+        """Determine the paths of all new and changed files"""
+        new_ids = set()
+        fp = FinalPaths(self)
+        for id_set in (self._new_name, self._new_parent, self._new_contents,
+                       self._new_id, self._new_executability):
+            new_ids.update(id_set)
+        new_paths = [(fp.get_path(t), t) for t in new_ids]
+        new_paths.sort()
+        return new_paths
+
+    def tree_kind(self, trans_id):
+        """Determine the file kind in the working tree.
+
+        Raises NoSuchFile if the file does not exist
+        """
+        path = self._tree_id_paths.get(trans_id)
+        if path is None:
+            raise NoSuchFile(None)
+        try:
+            return file_kind(self._tree.abspath(path))
+        except OSError, e:
+            if e.errno != errno.ENOENT:
+                raise
+            else:
+                raise NoSuchFile(path)
+
+    def final_kind(self, trans_id):
+        """Determine the final file kind, after any changes applied.
+        
+        Raises NoSuchFile if the file does not exist/has no contents.
+        (It is conceivable that a path would be created without the
+        corresponding contents insertion command)
+        """
+        if trans_id in self._new_contents:
+            return self._new_contents[trans_id]
+        elif trans_id in self._removed_contents:
+            raise NoSuchFile(None)
+        else:
+            return self.tree_kind(trans_id)
+
+    def tree_file_id(self, trans_id):
+        """Determine the file id associated with the trans_id in the tree"""
+        try:
+            path = self._tree_id_paths[trans_id]
+        except KeyError:
+            # the file is a new, unversioned file, or invalid trans_id
+            return None
+        # the file is old; the old id is still valid
+        if self._new_root == trans_id:
+            return self._tree.inventory.root.file_id
+        return self._tree.inventory.path2id(path)
+
+    def final_file_id(self, trans_id):
+        """Determine the file id after any changes are applied, or None.
+        
+        None indicates that the file will not be versioned after changes are
+        applied.
+        """
+        try:
+            # there is a new id for this file
+            assert self._new_id[trans_id] is not None
+            return self._new_id[trans_id]
+        except KeyError:
+            if trans_id in self._removed_id:
+                return None
+        return self.tree_file_id(trans_id)
+
+    def inactive_file_id(self, trans_id):
+        """Return the inactive file_id associated with a transaction id.
+        That is, the one in the tree or in non_present_ids.
+        The file_id may actually be active, too.
+        """
+        file_id = self.tree_file_id(trans_id)
+        if file_id is not None:
+            return file_id
+        for key, value in self._non_present_ids.iteritems():
+            if value == trans_id:
+                return key
+
+    def final_parent(self, trans_id):
+        """Determine the parent file_id, after any changes are applied.
+
+        ROOT_PARENT is returned for the tree root.
+        """
+        try:
+            return self._new_parent[trans_id]
+        except KeyError:
+            return self.get_tree_parent(trans_id)
+
+    def final_name(self, trans_id):
+        """Determine the final filename, after all changes are applied."""
+        try:
+            return self._new_name[trans_id]
+        except KeyError:
+            return os.path.basename(self._tree_id_paths[trans_id])
+
+    def _by_parent(self):
+        """Return a map of parent: children for known parents.
+        
+        Only new paths and parents of tree files with assigned ids are used.
+        """
+        by_parent = {}
+        items = list(self._new_parent.iteritems())
+        items.extend((t, self.final_parent(t)) for t in 
+                      self._tree_id_paths.keys())
+        for trans_id, parent_id in items:
+            if parent_id not in by_parent:
+                by_parent[parent_id] = set()
+            by_parent[parent_id].add(trans_id)
+        return by_parent
+
+    def path_changed(self, trans_id):
+        """Return True if a trans_id's path has changed."""
+        return trans_id in self._new_name or trans_id in self._new_parent
+
+    def find_conflicts(self):
+        """Find any violations of inventory or filesystem invariants"""
+        if self.__done is True:
+            raise ReusingTransform()
+        conflicts = []
+        # ensure all children of all existent parents are known
+        # all children of non-existent parents are known, by definition.
+        self._add_tree_children()
+        by_parent = self._by_parent()
+        conflicts.extend(self._unversioned_parents(by_parent))
+        conflicts.extend(self._parent_loops())
+        conflicts.extend(self._duplicate_entries(by_parent))
+        conflicts.extend(self._duplicate_ids())
+        conflicts.extend(self._parent_type_conflicts(by_parent))
+        conflicts.extend(self._improper_versioning())
+        conflicts.extend(self._executability_conflicts())
+        conflicts.extend(self._overwrite_conflicts())
+        return conflicts
+
+    def _add_tree_children(self):
+        """Add all the children of all active parents to the known paths.
+
+        Active parents are those which gain children, and those which are
+        removed.  This is a necessary first step in detecting conflicts.
+        """
+        parents = self._by_parent().keys()
+        parents.extend([t for t in self._removed_contents if 
+                        self.tree_kind(t) == 'directory'])
+        for trans_id in self._removed_id:
+            file_id = self.tree_file_id(trans_id)
+            if self._tree.inventory[file_id].kind in ('directory', 
+                                                      'root_directory'):
+                parents.append(trans_id)
+
+        for parent_id in parents:
+            # ensure that all children are registered with the transaction
+            list(self.iter_tree_children(parent_id))
+
+    def iter_tree_children(self, parent_id):
+        """Iterate through the entry's tree children, if any"""
+        try:
+            path = self._tree_id_paths[parent_id]
+        except KeyError:
+            return
+        try:
+            children = os.listdir(self._tree.abspath(path))
+        except OSError, e:
+            if e.errno != errno.ENOENT and e.errno != errno.ESRCH:
+                raise
+            return
+            
+        for child in children:
+            childpath = joinpath(path, child)
+            if self._tree.is_control_filename(childpath):
+                continue
+            yield self.trans_id_tree_path(childpath)
+
+    def _parent_loops(self):
+        """No entry should be its own ancestor"""
+        conflicts = []
+        for trans_id in self._new_parent:
+            seen = set()
+            parent_id = trans_id
+            while parent_id is not ROOT_PARENT:
+                seen.add(parent_id)
+                parent_id = self.final_parent(parent_id)
+                if parent_id == trans_id:
+                    conflicts.append(('parent loop', trans_id))
+                if parent_id in seen:
+                    break
+        return conflicts
+
+    def _unversioned_parents(self, by_parent):
+        """If parent directories are versioned, children must be versioned."""
+        conflicts = []
+        for parent_id, children in by_parent.iteritems():
+            if parent_id is ROOT_PARENT:
+                continue
+            if self.final_file_id(parent_id) is not None:
+                continue
+            for child_id in children:
+                if self.final_file_id(child_id) is not None:
+                    conflicts.append(('unversioned parent', parent_id))
+                    break;
+        return conflicts
+
+    def _improper_versioning(self):
+        """Cannot version a file with no contents, or a bad type.
+        
+        However, existing entries with no contents are okay.
+        """
+        conflicts = []
+        for trans_id in self._new_id.iterkeys():
+            try:
+                kind = self.final_kind(trans_id)
+            except NoSuchFile:
+                conflicts.append(('versioning no contents', trans_id))
+                continue
+            if not InventoryEntry.versionable_kind(kind):
+                conflicts.append(('versioning bad kind', trans_id, kind))
+        return conflicts
+
+    def _executability_conflicts(self):
+        """Check for bad executability changes.
+        
+        Only versioned files may have their executability set, because
+        1. only versioned entries can have executability under windows
+        2. only files can be executable.  (The execute bit on a directory
+           does not indicate searchability)
+        """
+        conflicts = []
+        for trans_id in self._new_executability:
+            if self.final_file_id(trans_id) is None:
+                conflicts.append(('unversioned executability', trans_id))
+            else:
+                try:
+                    non_file = self.final_kind(trans_id) != "file"
+                except NoSuchFile:
+                    non_file = True
+                if non_file is True:
+                    conflicts.append(('non-file executability', trans_id))
+        return conflicts
+
+    def _overwrite_conflicts(self):
+        """Check for overwrites (not permitted on Win32)"""
+        conflicts = []
+        for trans_id in self._new_contents:
+            try:
+                self.tree_kind(trans_id)
+            except NoSuchFile:
+                continue
+            if trans_id not in self._removed_contents:
+                conflicts.append(('overwrite', trans_id,
+                                 self.final_name(trans_id)))
+        return conflicts
+
+    def _duplicate_entries(self, by_parent):
+        """No directory may have two entries with the same name."""
+        conflicts = []
+        for children in by_parent.itervalues():
+            name_ids = [(self.final_name(t), t) for t in children]
+            name_ids.sort()
+            last_name = None
+            last_trans_id = None
+            for name, trans_id in name_ids:
+                if name == last_name:
+                    conflicts.append(('duplicate', last_trans_id, trans_id,
+                    name))
+                last_name = name
+                last_trans_id = trans_id
+        return conflicts
+
+    def _duplicate_ids(self):
+        """Each inventory id may only be used once"""
+        conflicts = []
+        removed_tree_ids = set((self.tree_file_id(trans_id) for trans_id in
+                                self._removed_id))
+        active_tree_ids = set((f for f in self._tree.inventory if
+                               f not in removed_tree_ids))
+        for trans_id, file_id in self._new_id.iteritems():
+            if file_id in active_tree_ids:
+                old_trans_id = self.trans_id_tree_file_id(file_id)
+                conflicts.append(('duplicate id', old_trans_id, trans_id))
+        return conflicts
+
+    def _parent_type_conflicts(self, by_parent):
+        """parents must have directory 'contents'."""
+        conflicts = []
+        for parent_id, children in by_parent.iteritems():
+            if parent_id is ROOT_PARENT:
+                continue
+            if not self._any_contents(children):
+                continue
+            for child in children:
+                try:
+                    self.final_kind(child)
+                except NoSuchFile:
+                    continue
+            try:
+                kind = self.final_kind(parent_id)
+            except NoSuchFile:
+                kind = None
+            if kind is None:
+                conflicts.append(('missing parent', parent_id))
+            elif kind != "directory":
+                conflicts.append(('non-directory parent', parent_id))
+        return conflicts
+
+    def _any_contents(self, trans_ids):
+        """Return true if any of the trans_ids, will have contents."""
+        for trans_id in trans_ids:
+            try:
+                kind = self.final_kind(trans_id)
+            except NoSuchFile:
+                continue
+            return True
+        return False
+            
+    def apply(self):
+        """Apply all changes to the inventory and filesystem.
+        
+        If filesystem or inventory conflicts are present, MalformedTransform
+        will be thrown.
+        """
+        conflicts = self.find_conflicts()
+        if len(conflicts) != 0:
+            raise MalformedTransform(conflicts=conflicts)
+        limbo_inv = {}
+        inv = self._tree.inventory
+        self._apply_removals(inv, limbo_inv)
+        self._apply_insertions(inv, limbo_inv)
+        self._tree._write_inventory(inv)
+        self.__done = True
+        self.finalize()
+
+    def _limbo_name(self, trans_id):
+        """Generate the limbo name of a file"""
+        return pathjoin(self._limbodir, trans_id)
+
+    def _apply_removals(self, inv, limbo_inv):
+        """Perform tree operations that remove directory/inventory names.
+        
+        That is, delete files that are to be deleted, and put any files that
+        need renaming into limbo.  This must be done in strict child-to-parent
+        order.
+        """
+        tree_paths = list(self._tree_path_ids.iteritems())
+        tree_paths.sort(reverse=True)
+        for num, data in enumerate(tree_paths):
+            path, trans_id = data
+            self._pb.update('removing file', num+1, len(tree_paths))
+            full_path = self._tree.abspath(path)
+            if trans_id in self._removed_contents:
+                self.delete_any(full_path)
+            elif trans_id in self._new_name or trans_id in self._new_parent:
+                try:
+                    os.rename(full_path, self._limbo_name(trans_id))
+                except OSError, e:
+                    if e.errno != errno.ENOENT:
+                        raise
+            if trans_id in self._removed_id:
+                if trans_id == self._new_root:
+                    file_id = self._tree.inventory.root.file_id
+                else:
+                    file_id = self.tree_file_id(trans_id)
+                del inv[file_id]
+            elif trans_id in self._new_name or trans_id in self._new_parent:
+                file_id = self.tree_file_id(trans_id)
+                if file_id is not None:
+                    limbo_inv[trans_id] = inv[file_id]
+                    del inv[file_id]
+        self._pb.clear()
+
+    def _apply_insertions(self, inv, limbo_inv):
+        """Perform tree operations that insert directory/inventory names.
+        
+        That is, create any files that need to be created, and restore from
+        limbo any files that needed renaming.  This must be done in strict
+        parent-to-child order.
+        """
+        new_paths = self.new_paths()
+        for num, (path, trans_id) in enumerate(new_paths):
+            self._pb.update('adding file', num+1, len(new_paths))
+            try:
+                kind = self._new_contents[trans_id]
+            except KeyError:
+                kind = contents = None
+            if trans_id in self._new_contents or self.path_changed(trans_id):
+                full_path = self._tree.abspath(path)
+                try:
+                    os.rename(self._limbo_name(trans_id), full_path)
+                except OSError, e:
+                    # We may be renaming a dangling inventory id
+                    if e.errno != errno.ENOENT:
+                        raise
+                if trans_id in self._new_contents:
+                    del self._new_contents[trans_id]
+
+            if trans_id in self._new_id:
+                if kind is None:
+                    kind = file_kind(self._tree.abspath(path))
+                inv.add_path(path, kind, self._new_id[trans_id])
+            elif trans_id in self._new_name or trans_id in self._new_parent:
+                entry = limbo_inv.get(trans_id)
+                if entry is not None:
+                    entry.name = self.final_name(trans_id)
+                    parent_path = os.path.dirname(path)
+                    entry.parent_id = self._tree.inventory.path2id(parent_path)
+                    inv.add(entry)
+
+            # requires files and inventory entries to be in place
+            if trans_id in self._new_executability:
+                self._set_executability(path, inv, trans_id)
+        self._pb.clear()
+
+    def _set_executability(self, path, inv, trans_id):
+        """Set the executability of versioned files """
+        file_id = inv.path2id(path)
+        new_executability = self._new_executability[trans_id]
+        inv[file_id].executable = new_executability
+        if supports_executable():
+            abspath = self._tree.abspath(path)
+            current_mode = os.stat(abspath).st_mode
+            if new_executability:
+                umask = os.umask(0)
+                os.umask(umask)
+                to_mode = current_mode | (0100 & ~umask)
+                # Enable x-bit for others only if they can read it.
+                if current_mode & 0004:
+                    to_mode |= 0001 & ~umask
+                if current_mode & 0040:
+                    to_mode |= 0010 & ~umask
+            else:
+                to_mode = current_mode & ~0111
+            os.chmod(abspath, to_mode)
+
+    def _new_entry(self, name, parent_id, file_id):
+        """Helper function to create a new filesystem entry."""
+        trans_id = self.create_path(name, parent_id)
+        if file_id is not None:
+            self.version_file(file_id, trans_id)
+        return trans_id
+
+    def new_file(self, name, parent_id, contents, file_id=None, 
+                 executable=None):
+        """Convenience method to create files.
+        
+        name is the name of the file to create.
+        parent_id is the transaction id of the parent directory of the file.
+        contents is an iterator of bytestrings, which will be used to produce
+        the file.
+        file_id is the inventory ID of the file, if it is to be versioned.
+        """
+        trans_id = self._new_entry(name, parent_id, file_id)
+        self.create_file(contents, trans_id)
+        if executable is not None:
+            self.set_executability(executable, trans_id)
+        return trans_id
+
+    def new_directory(self, name, parent_id, file_id=None):
+        """Convenience method to create directories.
+
+        name is the name of the directory to create.
+        parent_id is the transaction id of the parent directory of the
+        directory.
+        file_id is the inventory ID of the directory, if it is to be versioned.
+        """
+        trans_id = self._new_entry(name, parent_id, file_id)
+        self.create_directory(trans_id)
+        return trans_id 
+
+    def new_symlink(self, name, parent_id, target, file_id=None):
+        """Convenience method to create symbolic link.
+        
+        name is the name of the symlink to create.
+        parent_id is the transaction id of the parent directory of the symlink.
+        target is a bytestring of the target of the symlink.
+        file_id is the inventory ID of the file, if it is to be versioned.
+        """
+        trans_id = self._new_entry(name, parent_id, file_id)
+        self.create_symlink(target, trans_id)
+        return trans_id
+
+def joinpath(parent, child):
+    """Join tree-relative paths, handling the tree root specially"""
+    if parent is None or parent == "":
+        return child
+    else:
+        return pathjoin(parent, child)
+
+
+class FinalPaths(object):
+    """Make path calculation cheap by memoizing paths.
+
+    The underlying tree must not be manipulated between calls, or else
+    the results will likely be incorrect.
+    """
+    def __init__(self, transform):
+        object.__init__(self)
+        self._known_paths = {}
+        self.transform = transform
+
+    def _determine_path(self, trans_id):
+        if trans_id == self.transform.root:
+            return ""
+        name = self.transform.final_name(trans_id)
+        parent_id = self.transform.final_parent(trans_id)
+        if parent_id == self.transform.root:
+            return name
+        else:
+            return pathjoin(self.get_path(parent_id), name)
+
+    def get_path(self, trans_id):
+        """Find the final path associated with a trans_id"""
+        if trans_id not in self._known_paths:
+            self._known_paths[trans_id] = self._determine_path(trans_id)
+        return self._known_paths[trans_id]
+
+def topology_sorted_ids(tree):
+    """Determine the topological order of the ids in a tree"""
+    file_ids = list(tree)
+    file_ids.sort(key=tree.id2path)
+    return file_ids
+
+def build_tree(tree, wt):
+    """Create working tree for a branch, using a Transaction."""
+    file_trans_id = {}
+    tt = TreeTransform(wt)
+    try:
+        file_trans_id[wt.get_root_id()] = tt.trans_id_tree_file_id(wt.get_root_id())
+        file_ids = topology_sorted_ids(tree)
+        for file_id in file_ids:
+            entry = tree.inventory[file_id]
+            if entry.parent_id is None:
+                continue
+            if entry.parent_id not in file_trans_id:
+                raise repr(entry.parent_id)
+            parent_id = file_trans_id[entry.parent_id]
+            file_trans_id[file_id] = new_by_entry(tt, entry, parent_id, tree)
+        tt.apply()
+    finally:
+        tt.finalize()
+
+def new_by_entry(tt, entry, parent_id, tree):
+    """Create a new file according to its inventory entry"""
+    name = entry.name
+    kind = entry.kind
+    if kind == 'file':
+        contents = tree.get_file(entry.file_id).readlines()
+        executable = tree.is_executable(entry.file_id)
+        return tt.new_file(name, parent_id, contents, entry.file_id, 
+                           executable)
+    elif kind == 'directory':
+        return tt.new_directory(name, parent_id, entry.file_id)
+    elif kind == 'symlink':
+        target = tree.get_symlink_target(entry.file_id)
+        return tt.new_symlink(name, parent_id, target, entry.file_id)
+
+def create_by_entry(tt, entry, tree, trans_id, lines=None, mode_id=None):
+    """Create new file contents according to an inventory entry."""
+    if entry.kind == "file":
+        if lines == None:
+            lines = tree.get_file(entry.file_id).readlines()
+        tt.create_file(lines, trans_id, mode_id=mode_id)
+    elif entry.kind == "symlink":
+        tt.create_symlink(tree.get_symlink_target(entry.file_id), trans_id)
+    elif entry.kind == "directory":
+        tt.create_directory(trans_id)
+
+def create_entry_executability(tt, entry, trans_id):
+    """Set the executability of a trans_id according to an inventory entry"""
+    if entry.kind == "file":
+        tt.set_executability(entry.executable, trans_id)
+
+
+def find_interesting(working_tree, target_tree, filenames):
+    """Find the ids corresponding to specified filenames."""
+    if not filenames:
+        interesting_ids = None
+    else:
+        interesting_ids = set()
+        for tree_path in filenames:
+            for tree in (working_tree, target_tree):
+                not_found = True
+                file_id = tree.inventory.path2id(tree_path)
+                if file_id is not None:
+                    interesting_ids.add(file_id)
+                    not_found = False
+                if not_found:
+                    raise NotVersionedError(path=tree_path)
+    return interesting_ids
+
+
+def change_entry(tt, file_id, working_tree, target_tree, 
+                 trans_id_file_id, backups, trans_id):
+    """Replace a file_id's contents with those from a target tree."""
+    e_trans_id = trans_id_file_id(file_id)
+    entry = target_tree.inventory[file_id]
+    has_contents, contents_mod, meta_mod, = _entry_changes(file_id, entry, 
+                                                           working_tree)
+    if contents_mod:
+        mode_id = e_trans_id
+        if has_contents:
+            if not backups:
+                tt.delete_contents(e_trans_id)
+            else:
+                parent_trans_id = trans_id_file_id(entry.parent_id)
+                tt.adjust_path(entry.name+"~", parent_trans_id, e_trans_id)
+                tt.unversion_file(e_trans_id)
+                e_trans_id = tt.create_path(entry.name, parent_trans_id)
+                tt.version_file(file_id, e_trans_id)
+                trans_id[file_id] = e_trans_id
+        create_by_entry(tt, entry, target_tree, e_trans_id, mode_id=mode_id)
+        create_entry_executability(tt, entry, e_trans_id)
+
+    elif meta_mod:
+        tt.set_executability(entry.executable, e_trans_id)
+    if tt.final_name(e_trans_id) != entry.name:
+        adjust_path  = True
+    else:
+        parent_id = tt.final_parent(e_trans_id)
+        parent_file_id = tt.final_file_id(parent_id)
+        if parent_file_id != entry.parent_id:
+            adjust_path = True
+        else:
+            adjust_path = False
+    if adjust_path:
+        parent_trans_id = trans_id_file_id(entry.parent_id)
+        tt.adjust_path(entry.name, parent_trans_id, e_trans_id)
+
+
+def _entry_changes(file_id, entry, working_tree):
+    """Determine in which ways the inventory entry has changed.
+
+    Returns booleans: has_contents, content_mod, meta_mod
+    has_contents means there are currently contents, but they differ
+    contents_mod means contents need to be modified
+    meta_mod means the metadata needs to be modified
+    """
+    cur_entry = working_tree.inventory[file_id]
+    try:
+        working_kind = working_tree.kind(file_id)
+        has_contents = True
+    except OSError, e:
+        if e.errno != errno.ENOENT:
+            raise
+        has_contents = False
+        contents_mod = True
+        meta_mod = False
+    if has_contents is True:
+        real_e_kind = entry.kind
+        if real_e_kind == 'root_directory':
+            real_e_kind = 'directory'
+        if real_e_kind != working_kind:
+            contents_mod, meta_mod = True, False
+        else:
+            cur_entry._read_tree_state(working_tree.id2path(file_id), 
+                                       working_tree)
+            contents_mod, meta_mod = entry.detect_changes(cur_entry)
+            cur_entry._forget_tree_state()
+    return has_contents, contents_mod, meta_mod
+
+
+def revert(working_tree, target_tree, filenames, backups=False, 
+           pb=DummyProgress()):
+    """Revert a working tree's contents to those of a target tree."""
+    interesting_ids = find_interesting(working_tree, target_tree, filenames)
+    def interesting(file_id):
+        return interesting_ids is None or file_id in interesting_ids
+
+    tt = TreeTransform(working_tree, pb)
+    try:
+        trans_id = {}
+        def trans_id_file_id(file_id):
+            try:
+                return trans_id[file_id]
+            except KeyError:
+                return tt.trans_id_tree_file_id(file_id)
+
+        sorted_interesting = [i for i in topology_sorted_ids(target_tree) if
+                              interesting(i)]
+        for id_num, file_id in enumerate(sorted_interesting):
+            pb.update("Reverting file", id_num+1, len(sorted_interesting))
+            if file_id not in working_tree.inventory:
+                entry = target_tree.inventory[file_id]
+                parent_id = trans_id_file_id(entry.parent_id)
+                e_trans_id = new_by_entry(tt, entry, parent_id, target_tree)
+                trans_id[file_id] = e_trans_id
+            else:
+                change_entry(tt, file_id, working_tree, target_tree, 
+                             trans_id_file_id, backups, trans_id)
+        wt_interesting = [i for i in working_tree.inventory if interesting(i)]
+        for id_num, file_id in enumerate(wt_interesting):
+            pb.update("New file check", id_num+1, len(sorted_interesting))
+            if file_id not in target_tree:
+                tt.unversion_file(tt.trans_id_tree_file_id(file_id))
+        raw_conflicts = resolve_conflicts(tt, pb)
+        for line in conflicts_strings(cook_conflicts(raw_conflicts, tt)):
+            warning(line)
+        tt.apply()
+    finally:
+        tt.finalize()
+        pb.clear()
+
+
+def resolve_conflicts(tt, pb=DummyProgress()):
+    """Make many conflict-resolution attempts, but die if they fail"""
+    new_conflicts = set()
+    try:
+        for n in range(10):
+            pb.update('Resolution pass', n+1, 10)
+            conflicts = tt.find_conflicts()
+            if len(conflicts) == 0:
+                return new_conflicts
+            new_conflicts.update(conflict_pass(tt, conflicts))
+        raise MalformedTransform(conflicts=conflicts)
+    finally:
+        pb.clear()
+
+
+def conflict_pass(tt, conflicts):
+    """Resolve some classes of conflicts."""
+    new_conflicts = set()
+    for c_type, conflict in ((c[0], c) for c in conflicts):
+        if c_type == 'duplicate id':
+            tt.unversion_file(conflict[1])
+            new_conflicts.add((c_type, 'Unversioned existing file',
+                               conflict[1], conflict[2], ))
+        elif c_type == 'duplicate':
+            # files that were renamed take precedence
+            new_name = tt.final_name(conflict[1])+'.moved'
+            final_parent = tt.final_parent(conflict[1])
+            if tt.path_changed(conflict[1]):
+                tt.adjust_path(new_name, final_parent, conflict[2])
+                new_conflicts.add((c_type, 'Moved existing file to', 
+                                   conflict[2], conflict[1]))
+            else:
+                tt.adjust_path(new_name, final_parent, conflict[1])
+                new_conflicts.add((c_type, 'Moved existing file to', 
+                                  conflict[1], conflict[2]))
+        elif c_type == 'parent loop':
+            # break the loop by undoing one of the ops that caused the loop
+            cur = conflict[1]
+            while not tt.path_changed(cur):
+                cur = tt.final_parent(cur)
+            new_conflicts.add((c_type, 'Cancelled move', cur,
+                               tt.final_parent(cur),))
+            tt.adjust_path(tt.final_name(cur), tt.get_tree_parent(cur), cur)
+            
+        elif c_type == 'missing parent':
+            trans_id = conflict[1]
+            try:
+                tt.cancel_deletion(trans_id)
+                new_conflicts.add((c_type, 'Not deleting', trans_id))
+            except KeyError:
+                tt.create_directory(trans_id)
+                new_conflicts.add((c_type, 'Created directory.', trans_id))
+        elif c_type == 'unversioned parent':
+            tt.version_file(tt.inactive_file_id(conflict[1]), conflict[1])
+            new_conflicts.add((c_type, 'Versioned directory', conflict[1]))
+    return new_conflicts
+
+def cook_conflicts(raw_conflicts, tt):
+    """Generate a list of cooked conflicts, sorted by file path"""
+    def key(conflict):
+        if conflict[2] is not None:
+            return conflict[2], conflict[0]
+        elif len(conflict) == 6:
+            return conflict[4], conflict[0]
+        else:
+            return None, conflict[0]
+
+    return sorted(list(iter_cook_conflicts(raw_conflicts, tt)), key=key)
+
+def iter_cook_conflicts(raw_conflicts, tt):
+    cooked_conflicts = []
+    fp = FinalPaths(tt)
+    for conflict in raw_conflicts:
+        c_type = conflict[0]
+        action = conflict[1]
+        modified_path = fp.get_path(conflict[2])
+        modified_id = tt.final_file_id(conflict[2])
+        if len(conflict) == 3:
+            yield c_type, action, modified_path, modified_id
+        else:
+            conflicting_path = fp.get_path(conflict[3])
+            conflicting_id = tt.final_file_id(conflict[3])
+            yield (c_type, action, modified_path, modified_id, 
+                   conflicting_path, conflicting_id)
+
+
+def conflicts_strings(conflicts):
+    """Generate strings for the provided conflicts"""
+    for conflict in conflicts:
+        conflict_type = conflict[0]
+        if conflict_type == 'text conflict':
+            yield 'Text conflict in %s' % conflict[2]
+        elif conflict_type == 'contents conflict':
+            yield 'Contents conflict in %s' % conflict[2]
+        elif conflict_type == 'path conflict':
+            yield 'Path conflict: %s / %s' % conflict[2:]
+        elif conflict_type == 'duplicate id':
+            vals = (conflict[4], conflict[1], conflict[2])
+            yield 'Conflict adding id to %s.  %s %s.' % vals
+        elif conflict_type == 'duplicate':
+            vals = (conflict[4], conflict[1], conflict[2])
+            yield 'Conflict adding file %s.  %s %s.' % vals
+        elif conflict_type == 'parent loop':
+            vals = (conflict[4], conflict[2], conflict[1])
+            yield 'Conflict moving %s into %s.  %s.' % vals
+        elif conflict_type == 'unversioned parent':
+            vals = (conflict[2], conflict[1])
+            yield 'Conflict adding versioned files to %s.  %s.' % vals
+        elif conflict_type == 'missing parent':
+            vals = (conflict[2], conflict[1])
+            yield 'Conflict adding files to %s.  %s.' % vals

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2006-01-25 14:30:06 +0000
+++ bzrlib/transport/__init__.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,10 +19,14 @@
 as remote (such as http or sftp).
 """
 
+import errno
+from copy import deepcopy
+from stat import *
+import sys
+from unittest import TestSuite
+
 from bzrlib.trace import mutter
 import bzrlib.errors as errors
-import errno
-import sys
 
 _protocol_handlers = {
 }
@@ -40,6 +44,35 @@
         _protocol_handlers[prefix] = klass
 
 
+def _get_protocol_handlers():
+    """Return a dictionary of prefix:transport-factories."""
+    return _protocol_handlers
+
+
+def _set_protocol_handlers(new_handlers):
+    """Replace the current protocol handlers dictionary.
+
+    WARNING this will remove all build in protocols. Use with care.
+    """
+    global _protocol_handlers
+    _protocol_handlers = new_handlers
+
+
+def _get_transport_modules():
+    """Return a list of the modules providing transports."""
+    modules = set()
+    for prefix, factory in _protocol_handlers.items():
+        if factory.__module__ == "bzrlib.transport":
+            # this is a lazy load transport, because no real ones
+            # are directlry in bzrlib.transport
+            modules.add(factory.module)
+        else:
+            modules.add(factory.__module__)
+    result = list(modules)
+    result.sort()
+    return result
+
+
 class Transport(object):
     """This class encapsulates methods for retrieving or putting a file
     from/to a storage location.
@@ -74,6 +107,8 @@
                 raise errors.FileExists(path, extra=e)
             if e.errno == errno.EACCES:
                 raise errors.PermissionDenied(path, extra=e)
+            if e.errno == errno.ENOTEMPTY:
+                raise errors.DirectoryNotEmpty(path, extra=e)
         if raise_generic:
             raise errors.TransportError(orig_error=e)
 
@@ -159,11 +194,10 @@
         """
         # TODO: This might want to use bzrlib.osutils.relpath
         #       but we have to watch out because of the prefix issues
-        if not abspath.startswith(self.base):
+        if not (abspath == self.base[:-1] or abspath.startswith(self.base)):
             raise errors.PathNotChild(abspath, self.base)
         pl = len(self.base)
-        return abspath[pl:].lstrip('/')
-
+        return abspath[pl:].strip('/')
 
     def has(self, relpath):
         """Does the file relpath exist?
@@ -191,11 +225,16 @@
 
     def iter_files_recursive(self):
         """Iter the relative paths of files in the transports sub-tree.
+
+        *NOTE*: This only lists *files*, not subdirectories!
         
         As with other listing functions, only some transports implement this,.
         you may check via is_listable to determine if it will.
         """
-        raise NotImplementedError
+        raise errors.TransportNotPossible("This transport has not "
+                                          "implemented iter_files_recursive "
+                                          "(but must claim to be listable "
+                                          "to trigger this error).")
 
     def get(self, relpath):
         """Get the file at the given relative path.
@@ -232,7 +271,7 @@
         raise NotImplementedError
 
     def put_multi(self, files, mode=None, pb=None):
-        """Put a set of files or strings into the location.
+        """Put a set of files into the location.
 
         :param files: A list of tuples of relpath, file object [(path1, file1), (path2, file2),...]
         :param pb:  An optional ProgressBar for indicating percent done.
@@ -269,8 +308,12 @@
         return self._iterate_over(files, self.append, pb, 'append', expand=True)
 
     def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        raise NotImplementedError
+        """Copy the item at rel_from to the location at rel_to.
+        
+        Override this for efficiency if a specific transport can do it 
+        faster than this default implementation.
+        """
+        self.put(rel_to, self.get(rel_from))
 
     def copy_multi(self, relpaths, pb=None):
         """Copy a bunch of entries.
@@ -295,10 +338,64 @@
 
         return self._iterate_over(relpaths, copy_entry, pb, 'copy_to', expand=False)
 
+    def copy_tree(self, from_relpath, to_relpath):
+        """Copy a subtree from one relpath to another.
+
+        If a faster implementation is available, specific transports should 
+        implement it.
+        """
+        source = self.clone(from_relpath)
+        self.mkdir(to_relpath)
+        target = self.clone(to_relpath)
+        files = []
+        directories = ['.']
+        while directories:
+            dir = directories.pop()
+            if dir != '.':
+                target.mkdir(dir)
+            for path in source.list_dir(dir):
+                path = dir + '/' + path
+                stat = source.stat(path)
+                if S_ISDIR(stat.st_mode):
+                    directories.append(path)
+                else:
+                    files.append(path)
+        source.copy_to(files, target)
+
+    def rename(self, rel_from, rel_to):
+        """Rename a file or directory.
+
+        This *must* fail if the destination is a nonempty directory - it must
+        not automatically remove it.  It should raise DirectoryNotEmpty, or
+        some other PathError if the case can't be specifically detected.
+
+        If the destination is an empty directory or a file this function may
+        either fail or succeed, depending on the underlying transport.  It
+        should not attempt to remove the destination if overwriting is not the
+        native transport behaviour.  If at all possible the transport should
+        ensure that the rename either completes or not, without leaving the
+        destination deleted and the new file not moved in place.
+
+        This is intended mainly for use in implementing LockDir.
+        """
+        # transports may need to override this
+        raise NotImplementedError(self.rename)
 
     def move(self, rel_from, rel_to):
-        """Move the item at rel_from to the location at rel_to"""
-        raise NotImplementedError
+        """Move the item at rel_from to the location at rel_to.
+
+        The destination is deleted if possible, even if it's a non-empty
+        directory tree.
+        
+        If a transport can directly implement this it is suggested that
+        it do so for efficiency.
+        """
+        if S_ISDIR(self.stat(rel_from).st_mode):
+            self.copy_tree(rel_from, rel_to)
+            self.delete_tree(rel_from)
+        else:
+            self.copy(rel_from, rel_to)
+            self.delete(rel_from)
 
     def move_multi(self, relpaths, pb=None):
         """Move a bunch of entries.
@@ -328,6 +425,32 @@
         """
         return self._iterate_over(relpaths, self.delete, pb, 'delete', expand=False)
 
+    def delete_tree(self, relpath):
+        """Delete an entire tree. This may require a listable transport."""
+        subtree = self.clone(relpath)
+        files = []
+        directories = ['.']
+        pending_rmdirs = []
+        while directories:
+            dir = directories.pop()
+            if dir != '.':
+                pending_rmdirs.append(dir)
+            for path in subtree.list_dir(dir):
+                path = dir + '/' + path
+                stat = subtree.stat(path)
+                if S_ISDIR(stat.st_mode):
+                    directories.append(path)
+                else:
+                    files.append(path)
+        subtree.delete_multi(files)
+        pending_rmdirs.reverse()
+        for dir in pending_rmdirs:
+            subtree.rmdir(dir)
+        self.rmdir(relpath)
+
+    def __repr__(self):
+        return "<%s.%s url=%s>" % (self.__module__, self.__class__.__name__, self.base)
+
     def stat(self, relpath):
         """Return the stat information for a file.
         WARNING: This may not be implementable for all protocols, so use
@@ -340,6 +463,10 @@
         """
         raise NotImplementedError
 
+    def rmdir(self, relpath):
+        """Remove a directory at the given path."""
+        raise NotImplementedError
+
     def stat_multi(self, relpaths, pb=None):
         """Stat multiple files and return the information.
         """
@@ -362,7 +489,9 @@
         it if at all possible.
         """
         raise errors.TransportNotPossible("This transport has not "
-                                          "implemented list_dir.")
+                                          "implemented list_dir "
+                                          "(but must claim to be listable "
+                                          "to trigger this error).")
 
     def lock_read(self, relpath):
         """Lock the given file for shared (read) access.
@@ -380,8 +509,16 @@
         """
         raise NotImplementedError
 
+    def is_readonly(self):
+        """Return true if this connection cannot be written to."""
+        return False
+
 
 def get_transport(base):
+    """Open a transport to access a URL or directory.
+
+    base is either a URL or a directory name.  
+    """
     global _protocol_handlers
     if base is None:
         base = u'.'
@@ -405,6 +542,7 @@
         mod = __import__(module, globals(), locals(), [classname])
         klass = getattr(mod, classname)
         return klass(base)
+    _loader.module = module
     register_transport(scheme, _loader)
 
 
@@ -415,6 +553,82 @@
     return urllib.quote(relpath)
 
 
+class Server(object):
+    """A Transport Server.
+    
+    The Server interface provides a server for a given transport. We use
+    these servers as loopback testing tools. For any given transport the
+    Servers it provides must either allow writing, or serve the contents
+    of os.getcwdu() at the time setUp is called.
+    
+    Note that these are real servers - they must implement all the things
+    that we want bzr transports to take advantage of.
+    """
+
+    def setUp(self):
+        """Setup the server to service requests."""
+
+    def tearDown(self):
+        """Remove the server and cleanup any resources it owns."""
+
+    def get_url(self):
+        """Return a url for this server.
+        
+        If the transport does not represent a disk directory (i.e. it is 
+        a database like svn, or a memory only transport, it should return
+        a connection to a newly established resource for this Server.
+        Otherwise it should return a url that will provide access to the path
+        that was os.getcwdu() when setUp() was called.
+        
+        Subsequent calls will return the same resource.
+        """
+        raise NotImplementedError
+
+    def get_bogus_url(self):
+        """Return a url for this protocol, that will fail to connect."""
+        raise NotImplementedError
+
+
+class TransportTestProviderAdapter(object):
+    """A tool to generate a suite testing all transports for a single test.
+
+    This is done by copying the test once for each transport and injecting
+    the transport_class and transport_server classes into each copy. Each copy
+    is also given a new id() to make it easy to identify.
+    """
+
+    def adapt(self, test):
+        result = TestSuite()
+        for klass, server_factory in self._test_permutations():
+            new_test = deepcopy(test)
+            new_test.transport_class = klass
+            new_test.transport_server = server_factory
+            def make_new_test_id():
+                new_id = "%s(%s)" % (new_test.id(), server_factory.__name__)
+                return lambda: new_id
+            new_test.id = make_new_test_id()
+            result.addTest(new_test)
+        return result
+
+    def get_transport_test_permutations(self, module):
+        """Get the permutations module wants to have tested."""
+        return module.get_test_permutations()
+
+    def _test_permutations(self):
+        """Return a list of the klass, server_factory pairs to test."""
+        result = []
+        for module in _get_transport_modules():
+            try:
+                result.extend(self.get_transport_test_permutations(reduce(getattr, 
+                    (module).split('.')[1:],
+                     __import__(module))))
+            except errors.DependencyNotPresent, e:
+                # Continue even if a dependency prevents us 
+                # from running this test
+                pass
+        return result
+        
+
 # None is the default transport, for things with no url scheme
 register_lazy_transport(None, 'bzrlib.transport.local', 'LocalTransport')
 register_lazy_transport('file://', 'bzrlib.transport.local', 'LocalTransport')
@@ -423,3 +637,5 @@
 register_lazy_transport('https://', 'bzrlib.transport.http', 'HttpTransport')
 register_lazy_transport('ftp://', 'bzrlib.transport.ftp', 'FtpTransport')
 register_lazy_transport('aftp://', 'bzrlib.transport.ftp', 'FtpTransport')
+register_lazy_transport('memory:/', 'bzrlib.transport.memory', 'MemoryTransport')
+register_lazy_transport('readonly+', 'bzrlib.transport.readonly', 'ReadonlyTransportDecorator')

=== modified file 'bzrlib/transport/ftp.py'
--- bzrlib/transport/ftp.py	2006-01-25 14:30:06 +0000
+++ bzrlib/transport/ftp.py	2006-03-20 08:31:00 +0000
@@ -24,20 +24,37 @@
 active, in which case aftp:// will be your friend.
 """
 
-from bzrlib.transport import Transport
-
-from bzrlib.errors import (TransportNotPossible, TransportError,
-                           NoSuchFile, FileExists)
-
-import os, errno
 from cStringIO import StringIO
+import errno
 import ftplib
+import os
+import urllib
 import urlparse
-import urllib
 import stat
-
-from bzrlib.branch import Branch
-from bzrlib.trace import mutter
+import time
+import random
+from warnings import warn
+
+
+from bzrlib.transport import Transport
+from bzrlib.errors import (TransportNotPossible, TransportError,
+                           NoSuchFile, FileExists)
+from bzrlib.trace import mutter, warning
+
+
+_FTP_cache = {}
+def _find_FTP(hostname, username, password, is_active):
+    """Find an ftplib.FTP instance attached to this triplet."""
+    key = "%s|%s|%s|%s" % (hostname, username, password, is_active)
+    if key not in _FTP_cache:
+        mutter("Constructing FTP instance against %r" % key)
+        _FTP_cache[key] = ftplib.FTP(hostname, username, password)
+        _FTP_cache[key].set_pasv(not is_active)
+    return _FTP_cache[key]    
+
+
+class FtpTransportError(TransportError):
+    pass
 
 
 class FtpStatResult(object):
@@ -54,6 +71,9 @@
                 f.cwd(pwd)
 
 
+_number_of_retries = 2
+_sleep_between_retries = 5
+
 class FtpTransport(Transport):
     """This is the transport agent for ftp:// access."""
 
@@ -69,7 +89,6 @@
             self._query, self._fragment) = urlparse.urlparse(self.base)
         self._FTP_instance = _provided_instance
 
-
     def _get_FTP(self):
         """Return the ftplib.FTP instance for this object."""
         if self._FTP_instance is not None:
@@ -84,9 +103,8 @@
             if ':' in username:
                 username, password = username.split(":", 1)
 
-            mutter("Constructing FTP instance")
-            self._FTP_instance = ftplib.FTP(hostname, username, password)
-            self._FTP_instance.set_pasv(not self.is_active)
+            self._FTP_instance = _find_FTP(hostname, username, password,
+                                           self.is_active)
             return self._FTP_instance
         except ftplib.error_perm, e:
             raise TransportError(msg="Error setting up connection: %s"
@@ -161,10 +179,12 @@
             mutter("FTP has not: %s" % self._abspath(relpath))
             return False
 
-    def get(self, relpath, decode=False):
+    def get(self, relpath, decode=False, retries=0):
         """Get the file at the given relative path.
 
         :param relpath: The relative path to the file
+        :param retries: Number of retries after temporary failures so far
+                        for this operation.
 
         We're meant to return a file-like object which bzr will
         then read from. For now we do this via the magic of StringIO
@@ -177,24 +197,80 @@
             ret.seek(0)
             return ret
         except ftplib.error_perm, e:
-            raise NoSuchFile(self.abspath(relpath), extra=extra)
+            raise NoSuchFile(self.abspath(relpath), extra=str(e))
+        except ftplib.error_temp, e:
+            if retries > _number_of_retries:
+                raise TransportError(msg="FTP temporary error during GET %s. Aborting."
+                                     % self.abspath(relpath),
+                                     orig_error=e)
+            else:
+                warning("FTP temporary error: %s. Retrying." % str(e))
+                self._FTP_instance = None
+                return self.get(relpath, decode, retries+1)
+        except EOFError, e:
+            if retries > _number_of_retries:
+                raise TransportError("FTP control connection closed during GET %s."
+                                     % self.abspath(relpath),
+                                     orig_error=e)
+            else:
+                warning("FTP control connection closed. Trying to reopen.")
+                time.sleep(_sleep_between_retries)
+                self._FTP_instance = None
+                return self.get(relpath, decode, retries+1)
 
-    def put(self, relpath, fp, mode=None):
+    def put(self, relpath, fp, mode=None, retries=0):
         """Copy the file-like or string object into the location.
 
         :param relpath: Location to put the contents, relative to base.
-        :param f:       File-like or string object.
-        TODO: jam 20051215 This should be an atomic put, not overwritting files in place
+        :param fp:       File-like or string object.
+        :param retries: Number of retries after temporary failures so far
+                        for this operation.
+
         TODO: jam 20051215 ftp as a protocol seems to support chmod, but ftplib does not
         """
+        tmp_abspath = '%s.tmp.%.9f.%d.%d' % (self._abspath(relpath), time.time(),
+                        os.getpid(), random.randint(0,0x7FFFFFFF))
         if not hasattr(fp, 'read'):
             fp = StringIO(fp)
         try:
             mutter("FTP put: %s" % self._abspath(relpath))
             f = self._get_FTP()
-            f.storbinary('STOR '+self._abspath(relpath), fp, 8192)
+            try:
+                f.storbinary('STOR '+tmp_abspath, fp)
+                f.rename(tmp_abspath, self._abspath(relpath))
+            except (ftplib.error_temp,EOFError), e:
+                warning("Failure during ftp PUT. Deleting temporary file.")
+                try:
+                    f.delete(tmp_abspath)
+                except:
+                    warning("Failed to delete temporary file on the server.\nFile: %s"
+                            % tmp_abspath)
+                    raise e
+                raise
         except ftplib.error_perm, e:
-            raise TransportError(orig_error=e)
+            if "no such file" in str(e).lower():
+                raise NoSuchFile("Error storing %s: %s"
+                                 % (self.abspath(relpath), str(e)), extra=e)
+            else:
+                raise FtpTransportError(orig_error=e)
+        except ftplib.error_temp, e:
+            if retries > _number_of_retries:
+                raise TransportError("FTP temporary error during PUT %s. Aborting."
+                                     % self.abspath(relpath), orig_error=e)
+            else:
+                warning("FTP temporary error: %s. Retrying." % str(e))
+                self._FTP_instance = None
+                self.put(relpath, fp, mode, retries+1)
+        except EOFError:
+            if retries > _number_of_retries:
+                raise TransportError("FTP control connection closed during PUT %s."
+                                     % self.abspath(relpath), orig_error=e)
+            else:
+                warning("FTP control connection closed. Trying to reopen.")
+                time.sleep(_sleep_between_retries)
+                self._FTP_instance = None
+                self.put(relpath, fp, mode, retries+1)
+
 
     def mkdir(self, relpath, mode=None):
         """Create a directory at the given path."""
@@ -282,7 +358,11 @@
             f = self._get_FTP()
             return FtpStatResult(f, self._abspath(relpath))
         except ftplib.error_perm, e:
-            raise TransportError(orig_error=e)
+            if "no such file" in str(e).lower():
+                raise NoSuchFile("Error storing %s: %s"
+                                 % (self.abspath(relpath), str(e)), extra=e)
+            else:
+                raise FtpTransportError(orig_error=e)
 
     def lock_read(self, relpath):
         """Lock the given file for shared (read) access.
@@ -304,3 +384,9 @@
         :return: A lock object, which should be passed to Transport.unlock()
         """
         return self.lock_read(relpath)
+
+
+def get_test_permutations():
+    """Return the permutations to be used in testing."""
+    warn("There are no FTP transport provider tests yet.")
+    return []

=== modified file 'bzrlib/transport/http.py'
--- bzrlib/transport/http.py	2006-01-25 14:30:06 +0000
+++ bzrlib/transport/http.py	2006-03-20 08:31:00 +0000
@@ -16,17 +16,20 @@
 """Implementation of Transport over http.
 """
 
-from bzrlib.transport import Transport, register_transport
-from bzrlib.errors import (TransportNotPossible, NoSuchFile, 
-                           TransportError, ConnectionError)
 import os, errno
 from cStringIO import StringIO
 import urllib, urllib2
 import urlparse
+from warnings import warn
 
+import bzrlib
+from bzrlib.transport import Transport, Server
+from bzrlib.errors import (TransportNotPossible, NoSuchFile, 
+                           TransportError, ConnectionError)
 from bzrlib.errors import BzrError, BzrCheckError
 from bzrlib.branch import Branch
 from bzrlib.trace import mutter
+from bzrlib.ui import ui_factory
 
 
 def extract_auth(url, password_manager):
@@ -35,40 +38,56 @@
     password manager.  Return the url, minus those auth parameters (which
     confuse urllib2).
     """
-    assert url.startswith('http://') or url.startswith('https://')
-    scheme, host = url.split('//', 1)
-    if '/' in host:
-        host, path = host.split('/', 1)
-        path = '/' + path
-    else:
-        path = ''
-    port = ''
-    if '@' in host:
-        auth, host = host.split('@', 1)
+    scheme, netloc, path, query, fragment = urlparse.urlsplit(url)
+    assert (scheme == 'http') or (scheme == 'https')
+    
+    if '@' in netloc:
+        auth, netloc = netloc.split('@', 1)
         if ':' in auth:
             username, password = auth.split(':', 1)
         else:
             username, password = auth, None
-        if ':' in host:
-            host, port = host.split(':', 1)
-            port = ':' + port
-        # FIXME: if password isn't given, should we ask for it?
+        if ':' in netloc:
+            host = netloc.split(':', 1)[0]
+        else:
+            host = netloc
+        username = urllib.unquote(username)
         if password is not None:
-            username = urllib.unquote(username)
             password = urllib.unquote(password)
-            password_manager.add_password(None, host, username, password)
-    url = scheme + '//' + host + port + path
+        else:
+            password = ui_factory.get_password(prompt='HTTP %(user)@%(host) password',
+                                               user=username, host=host)
+        password_manager.add_password(None, host, username, password)
+    url = urlparse.urlunsplit((scheme, netloc, path, query, fragment))
     return url
-    
-def get_url(url):
+
+
+class Request(urllib2.Request):
+    """Request object for urllib2 that allows the method to be overridden."""
+
+    method = None
+
+    def get_method(self):
+        if self.method is not None:
+            return self.method
+        else:
+            return urllib2.Request.get_method(self)
+
+
+def get_url(url, method=None):
     import urllib2
-    mutter("get_url %s" % url)
+    mutter("get_url %s", url)
     manager = urllib2.HTTPPasswordMgrWithDefaultRealm()
     url = extract_auth(url, manager)
     auth_handler = urllib2.HTTPBasicAuthHandler(manager)
     opener = urllib2.build_opener(auth_handler)
-    url_f = opener.open(url)
-    return url_f
+
+    request = Request(url)
+    request.method = method
+    request.add_header('User-Agent', 'bzr/%s' % bzrlib.__version__)
+    response = opener.open(request)
+    return response
+
 
 class HttpTransport(Transport):
     """This is the transport agent for http:// access.
@@ -79,6 +98,8 @@
     def __init__(self, base):
         """Set the base path where files will be stored."""
         assert base.startswith('http://') or base.startswith('https://')
+        if base[-1] != '/':
+            base = base + '/'
         super(HttpTransport, self).__init__(base)
         # In the future we might actually connect to the remote host
         # rather than using get_url
@@ -143,9 +164,6 @@
     def has(self, relpath):
         """Does the target location exist?
 
-        TODO: HttpTransport.has() should use a HEAD request,
-        not a full GET request.
-
         TODO: This should be changed so that we don't use
         urllib2 and get an exception, the code path would be
         cleaner if we just do an http HEAD request, and parse
@@ -154,13 +172,13 @@
         path = relpath
         try:
             path = self.abspath(relpath)
-            f = get_url(path)
+            f = get_url(path, method='HEAD')
             # Without the read and then close()
             # we tend to have busy sockets.
             f.read()
             f.close()
             return True
-        except urllib2.URLError, e:
+        except urllib2.HTTPError, e:
             mutter('url error code: %s for has url: %r', e.code, path)
             if e.code == 404:
                 return False
@@ -208,6 +226,10 @@
         """Create a directory at the given path."""
         raise TransportNotPossible('http does not support mkdir()')
 
+    def rmdir(self, relpath):
+        """See Transport.rmdir."""
+        raise TransportNotPossible('http does not support rmdir()')
+
     def append(self, relpath, f):
         """Append the text in the file-like object into the final
         location.
@@ -242,6 +264,10 @@
         """Delete the item at relpath"""
         raise TransportNotPossible('http does not support delete()')
 
+    def is_readonly(self):
+        """See Transport.is_readonly."""
+        return True
+
     def listable(self):
         """See Transport.listable."""
         return False
@@ -271,3 +297,146 @@
         :return: A lock object, which should be passed to Transport.unlock()
         """
         raise TransportNotPossible('http does not support lock_write()')
+
+
+#---------------- test server facilities ----------------
+import BaseHTTPServer, SimpleHTTPServer, socket, time
+import threading
+
+
+class WebserverNotAvailable(Exception):
+    pass
+
+
+class BadWebserverPath(ValueError):
+    def __str__(self):
+        return 'path %s is not in %s' % self.args
+
+
+class TestingHTTPRequestHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
+
+    def log_message(self, format, *args):
+        self.server.test_case.log('webserver - %s - - [%s] %s "%s" "%s"',
+                                  self.address_string(),
+                                  self.log_date_time_string(),
+                                  format % args,
+                                  self.headers.get('referer', '-'),
+                                  self.headers.get('user-agent', '-'))
+
+    def handle_one_request(self):
+        """Handle a single HTTP request.
+
+        You normally don't need to override this method; see the class
+        __doc__ string for information on how to handle specific HTTP
+        commands such as GET and POST.
+
+        """
+        for i in xrange(1,11): # Don't try more than 10 times
+            try:
+                self.raw_requestline = self.rfile.readline()
+            except socket.error, e:
+                if e.args[0] in (errno.EAGAIN, errno.EWOULDBLOCK):
+                    # omitted for now because some tests look at the log of
+                    # the server and expect to see no errors.  see recent
+                    # email thread. -- mbp 20051021. 
+                    ## self.log_message('EAGAIN (%d) while reading from raw_requestline' % i)
+                    time.sleep(0.01)
+                    continue
+                raise
+            else:
+                break
+        if not self.raw_requestline:
+            self.close_connection = 1
+            return
+        if not self.parse_request(): # An error code has been sent, just exit
+            return
+        mname = 'do_' + self.command
+        if not hasattr(self, mname):
+            self.send_error(501, "Unsupported method (%r)" % self.command)
+            return
+        method = getattr(self, mname)
+        method()
+
+
+class TestingHTTPServer(BaseHTTPServer.HTTPServer):
+    def __init__(self, server_address, RequestHandlerClass, test_case):
+        BaseHTTPServer.HTTPServer.__init__(self, server_address,
+                                                RequestHandlerClass)
+        self.test_case = test_case
+
+
+class HttpServer(Server):
+    """A test server for http transports."""
+
+    def _http_start(self):
+        httpd = None
+        httpd = TestingHTTPServer(('localhost', 0),
+                                  TestingHTTPRequestHandler,
+                                  self)
+        host, port = httpd.socket.getsockname()
+        self._http_base_url = 'http://localhost:%s/' % port
+        self._http_starting.release()
+        httpd.socket.settimeout(0.1)
+
+        while self._http_running:
+            try:
+                httpd.handle_request()
+            except socket.timeout:
+                pass
+
+    def _get_remote_url(self, path):
+        path_parts = path.split(os.path.sep)
+        if os.path.isabs(path):
+            if path_parts[:len(self._local_path_parts)] != \
+                   self._local_path_parts:
+                raise BadWebserverPath(path, self.test_dir)
+            remote_path = '/'.join(path_parts[len(self._local_path_parts):])
+        else:
+            remote_path = '/'.join(path_parts)
+
+        self._http_starting.acquire()
+        self._http_starting.release()
+        return self._http_base_url + remote_path
+
+    def log(self, format, *args):
+        """Capture Server log output."""
+        self.logs.append(format % args)
+
+    def setUp(self):
+        """See bzrlib.transport.Server.setUp."""
+        self._home_dir = os.getcwdu()
+        self._local_path_parts = self._home_dir.split(os.path.sep)
+        self._http_starting = threading.Lock()
+        self._http_starting.acquire()
+        self._http_running = True
+        self._http_base_url = None
+        self._http_thread = threading.Thread(target=self._http_start)
+        self._http_thread.setDaemon(True)
+        self._http_thread.start()
+        self._http_proxy = os.environ.get("http_proxy")
+        if self._http_proxy is not None:
+            del os.environ["http_proxy"]
+        self.logs = []
+
+    def tearDown(self):
+        """See bzrlib.transport.Server.tearDown."""
+        self._http_running = False
+        self._http_thread.join()
+        if self._http_proxy is not None:
+            import os
+            os.environ["http_proxy"] = self._http_proxy
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self._get_remote_url(self._home_dir)
+        
+    def get_bogus_url(self):
+        """See bzrlib.transport.Server.get_bogus_url."""
+        return 'http://jasldkjsalkdjalksjdkljasd'
+
+
+def get_test_permutations():
+    """Return the permutations to be used in testing."""
+    warn("There are no HTTPS transport provider tests yet.")
+    return [(HttpTransport, HttpServer),
+            ]

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2006-01-25 14:30:06 +0000
+++ bzrlib/transport/local.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,7 +25,7 @@
 import urllib
 
 from bzrlib.trace import mutter
-from bzrlib.transport import Transport
+from bzrlib.transport import Transport, Server
 from bzrlib.osutils import abspath, realpath, normpath, pathjoin, rename
 
 
@@ -38,7 +38,10 @@
             base = base[7:]
         # realpath is incompatible with symlinks. When we traverse
         # up we might be able to normpath stuff. RBC 20051003
-        super(LocalTransport, self).__init__(normpath(abspath(base)))
+        base = normpath(abspath(base))
+        if base[-1] != '/':
+            base = base + '/'
+        super(LocalTransport, self).__init__(base)
 
     def should_cache(self):
         return False
@@ -66,7 +69,9 @@
         from bzrlib.osutils import relpath
         if abspath is None:
             abspath = u'.'
-        return relpath(self.base, abspath)
+        if abspath.endswith('/'):
+            abspath = abspath[:-1]
+        return relpath(self.base[:-1], abspath)
 
     def has(self, relpath):
         return os.access(self.abspath(relpath), os.F_OK)
@@ -129,7 +134,10 @@
         """Append the text in the file-like object into the final
         location.
         """
-        fp = open(self.abspath(relpath), 'ab')
+        try:
+            fp = open(self.abspath(relpath), 'ab')
+        except (IOError, OSError),e:
+            self._translate_error(e, relpath)
         self._pump(f, fp)
 
     def copy(self, rel_from, rel_to):
@@ -143,12 +151,23 @@
             # TODO: What about path_to?
             self._translate_error(e, path_from)
 
+    def rename(self, rel_from, rel_to):
+        path_from = self.abspath(rel_from)
+        try:
+            # *don't* call bzrlib.osutils.rename, because we want to 
+            # detect errors on rename
+            os.rename(path_from, self.abspath(rel_to))
+        except (IOError, OSError),e:
+            # TODO: What about path_to?
+            self._translate_error(e, path_from)
+
     def move(self, rel_from, rel_to):
         """Move the item at rel_from to the location at rel_to"""
         path_from = self.abspath(rel_from)
         path_to = self.abspath(rel_to)
 
         try:
+            # this version will delete the destination if necessary
             rename(path_from, path_to)
         except (IOError, OSError),e:
             # TODO: What about path_to?
@@ -223,7 +242,12 @@
         :return: A lock object, which should be passed to Transport.unlock()
         """
         from bzrlib.lock import ReadLock
-        return ReadLock(self.abspath(relpath))
+        path = relpath
+        try:
+            path = self.abspath(relpath)
+            return ReadLock(path)
+        except (IOError, OSError), e:
+            self._translate_error(e, path)
 
     def lock_write(self, relpath):
         """Lock the given file for exclusive (write) access.
@@ -234,6 +258,14 @@
         from bzrlib.lock import WriteLock
         return WriteLock(self.abspath(relpath))
 
+    def rmdir(self, relpath):
+        """See Transport.rmdir."""
+        path = relpath
+        try:
+            path = self.abspath(relpath)
+            os.rmdir(path)
+        except (IOError, OSError),e:
+            self._translate_error(e, path)
 
 class ScratchTransport(LocalTransport):
     """A transport that works in a temporary dir and cleans up after itself.
@@ -250,3 +282,36 @@
     def __del__(self):
         shutil.rmtree(self.base, ignore_errors=True)
         mutter("%r destroyed" % self)
+
+
+class LocalRelpathServer(Server):
+    """A pretend server for local transports, using relpaths."""
+
+    def get_url(self):
+        """See Transport.Server.get_url."""
+        return "."
+
+
+class LocalAbspathServer(Server):
+    """A pretend server for local transports, using absolute paths."""
+
+    def get_url(self):
+        """See Transport.Server.get_url."""
+        return os.path.abspath("")
+
+
+class LocalURLServer(Server):
+    """A pretend server for local transports, using file:// urls."""
+
+    def get_url(self):
+        """See Transport.Server.get_url."""
+        # FIXME: \ to / on windows
+        return "file://%s" % os.path.abspath("")
+
+
+def get_test_permutations():
+    """Return the permutations to be used in testing."""
+    return [(LocalTransport, LocalRelpathServer),
+            (LocalTransport, LocalAbspathServer),
+            (LocalTransport, LocalURLServer),
+            ]

=== modified file 'bzrlib/transport/memory.py'
--- bzrlib/transport/memory.py	2006-01-25 14:30:06 +0000
+++ bzrlib/transport/memory.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -13,88 +13,272 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-"""Implementation of Transport that uses memory for its storage."""
-
+
+"""Implementation of Transport that uses memory for its storage.
+
+The contents of the transport will be lost when the object is discarded,
+so this is primarily useful for testing.
+"""
+
+from copy import copy
 import os
 import errno
+import re
+from stat import *
 from cStringIO import StringIO
 
 from bzrlib.trace import mutter
-from bzrlib.errors import TransportError, NoSuchFile, FileExists
-from bzrlib.transport import Transport
+from bzrlib.errors import TransportError, NoSuchFile, FileExists, LockError
+from bzrlib.transport import Transport, register_transport, Server
 
 class MemoryStat(object):
 
-    def __init__(self, size):
+    def __init__(self, size, is_dir, perms):
         self.st_size = size
+        if perms is None:
+            perms = 0644
+        if not is_dir:
+            self.st_mode = S_IFREG | perms
+        else:
+            self.st_mode = S_IFDIR | perms
 
 
 class MemoryTransport(Transport):
-    """This is the transport agent for local filesystem access."""
+    """This is an in memory file system for transient data storage."""
 
-    def __init__(self):
+    def __init__(self, url=""):
         """Set the 'base' path where files will be stored."""
-        super(MemoryTransport, self).__init__('in-memory:')
-        self._dirs = set()
+        if url == "":
+            url = "memory:/"
+        if url[-1] != '/':
+            url = url + '/'
+        super(MemoryTransport, self).__init__(url)
+        self._cwd = url[url.find(':') + 1:]
+        # dictionaries from absolute path to file mode
+        self._dirs = {}
         self._files = {}
+        self._locks = {}
 
     def clone(self, offset=None):
         """See Transport.clone()."""
-        return self
+        if offset is None:
+            return copy(self)
+        segments = offset.split('/')
+        cwdsegments = self._cwd.split('/')[:-1]
+        while len(segments):
+            segment = segments.pop(0)
+            if segment == '.':
+                continue
+            if segment == '..':
+                if len(cwdsegments) > 1:
+                    cwdsegments.pop()
+                continue
+            cwdsegments.append(segment)
+        url = self.base[:self.base.find(':') + 1] + '/'.join(cwdsegments) + '/'
+        result = MemoryTransport(url)
+        result._dirs = self._dirs
+        result._files = self._files
+        result._locks = self._locks
+        return result
 
     def abspath(self, relpath):
         """See Transport.abspath()."""
-        return self.base + relpath
+        return self.base[:-1] + self._abspath(relpath)[len(self._cwd) - 1:]
 
     def append(self, relpath, f):
         """See Transport.append()."""
-        self._check_parent(relpath)
-        self._files[relpath] = self._files.get(relpath, "") + f.read()
+        _abspath = self._abspath(relpath)
+        self._check_parent(_abspath)
+        orig_content, orig_mode = self._files.get(_abspath, ("", None))
+        self._files[_abspath] = (orig_content + f.read(), orig_mode)
 
-    def _check_parent(self, relpath):
-        dir = os.path.dirname(relpath)
-        if dir != '':
+    def _check_parent(self, _abspath):
+        dir = os.path.dirname(_abspath)
+        if dir != '/':
             if not dir in self._dirs:
-                raise NoSuchFile(relpath)
+                raise NoSuchFile(_abspath)
 
     def has(self, relpath):
         """See Transport.has()."""
-        return relpath in self._files
+        _abspath = self._abspath(relpath)
+        return _abspath in self._files or _abspath in self._dirs
+
+    def delete(self, relpath):
+        """See Transport.delete()."""
+        _abspath = self._abspath(relpath)
+        if not _abspath in self._files:
+            raise NoSuchFile(relpath)
+        del self._files[_abspath]
 
     def get(self, relpath):
         """See Transport.get()."""
-        if not relpath in self._files:
+        _abspath = self._abspath(relpath)
+        if not _abspath in self._files:
             raise NoSuchFile(relpath)
-        return StringIO(self._files[relpath])
+        return StringIO(self._files[_abspath][0])
 
     def put(self, relpath, f, mode=None):
         """See Transport.put()."""
-        self._check_parent(relpath)
-        self._files[relpath] = f.read()
+        _abspath = self._abspath(relpath)
+        self._check_parent(_abspath)
+        self._files[_abspath] = (f.read(), mode)
 
     def mkdir(self, relpath, mode=None):
         """See Transport.mkdir()."""
-        self._check_parent(relpath)
-        if relpath in self._dirs:
+        _abspath = self._abspath(relpath)
+        self._check_parent(_abspath)
+        if _abspath in self._dirs:
             raise FileExists(relpath)
-        self._dirs.add(relpath)
+        self._dirs[_abspath]=mode
 
     def listable(self):
         """See Transport.listable."""
         return True
 
     def iter_files_recursive(self):
-        return iter(self._files)
-    
-#    def list_dir(self, relpath):
-#    TODO if needed
-    
+        for file in self._files:
+            if file.startswith(self._cwd):
+                yield file[len(self._cwd):]
+    
+    def list_dir(self, relpath):
+        """See Transport.list_dir()."""
+        _abspath = self._abspath(relpath)
+        if _abspath != '/' and _abspath not in self._dirs:
+            raise NoSuchFile(relpath)
+        result = []
+        for path in self._files:
+            if (path.startswith(_abspath) and 
+                path[len(_abspath) + 1:].find('/') == -1 and
+                len(path) > len(_abspath)):
+                result.append(path[len(_abspath) + 1:])
+        for path in self._dirs:
+            if (path.startswith(_abspath) and 
+                path[len(_abspath) + 1:].find('/') == -1 and
+                len(path) > len(_abspath) and
+                path[len(_abspath)] == '/'):
+                result.append(path[len(_abspath) + 1:])
+        return result
+
+    def rename(self, rel_from, rel_to):
+        """Rename a file or directory; fail if the destination exists"""
+        abs_from = self._abspath(rel_from)
+        abs_to = self._abspath(rel_to)
+        def replace(x):
+            if x == abs_from:
+                x = abs_to
+            elif x.startswith(abs_from + '/'):
+                x = abs_to + x[len(abs_from):]
+            return x
+        def do_renames(container):
+            for path in container:
+                new_path = replace(path)
+                if new_path != path:
+                    if new_path in container:
+                        raise FileExists(new_path)
+                    container[new_path] = container[path]
+                    del container[path]
+        do_renames(self._files)
+        do_renames(self._dirs)
+    
+    def rmdir(self, relpath):
+        """See Transport.rmdir."""
+        _abspath = self._abspath(relpath)
+        if _abspath in self._files:
+            self._translate_error(IOError(errno.ENOTDIR, relpath), relpath)
+        for path in self._files:
+            if path.startswith(_abspath):
+                self._translate_error(IOError(errno.ENOTEMPTY, relpath),
+                                      relpath)
+        for path in self._dirs:
+            if path.startswith(_abspath) and path != _abspath:
+                self._translate_error(IOError(errno.ENOTEMPTY, relpath), relpath)
+        if not _abspath in self._dirs:
+            raise NoSuchFile(relpath)
+        del self._dirs[_abspath]
+
     def stat(self, relpath):
         """See Transport.stat()."""
-        return MemoryStat(len(self._files[relpath]))
-
-#    def lock_read(self, relpath):
-#   TODO if needed
-#
-#    def lock_write(self, relpath):
-#   TODO if needed
+        _abspath = self._abspath(relpath)
+        if _abspath in self._files:
+            return MemoryStat(len(self._files[_abspath][0]), False, 
+                              self._files[_abspath][1])
+        elif _abspath == '':
+            return MemoryStat(0, True, None)
+        elif _abspath in self._dirs:
+            return MemoryStat(0, True, self._dirs[_abspath])
+        else:
+            raise NoSuchFile(_abspath)
+
+    def lock_read(self, relpath):
+        """See Transport.lock_read()."""
+        return _MemoryLock(self._abspath(relpath), self)
+
+    def lock_write(self, relpath):
+        """See Transport.lock_write()."""
+        return _MemoryLock(self._abspath(relpath), self)
+
+    def _abspath(self, relpath):
+        """Generate an internal absolute path."""
+        if relpath.find('..') != -1:
+            raise AssertionError('relpath contains ..')
+        if relpath == '.':
+            return self._cwd[:-1]
+        if relpath.endswith('/'):
+            relpath = relpath[:-1]
+        if relpath.startswith('./'):
+            relpath = relpath[2:]
+        return self._cwd + relpath
+
+
+class _MemoryLock(object):
+    """This makes a lock."""
+
+    def __init__(self, path, transport):
+        assert isinstance(transport, MemoryTransport)
+        self.path = path
+        self.transport = transport
+        if self.path in self.transport._locks:
+            raise LockError('File %r already locked' % (self.path,))
+        self.transport._locks[self.path] = self
+
+    def __del__(self):
+        # Should this warn, or actually try to cleanup?
+        if self.transport:
+            warn("MemoryLock %r not explicitly unlocked" % (self.path,))
+            self.unlock()
+
+    def unlock(self):
+        del self.transport._locks[self.path]
+        self.transport = None
+
+
+class MemoryServer(Server):
+    """Server for the MemoryTransport for testing with."""
+
+    def setUp(self):
+        """See bzrlib.transport.Server.setUp."""
+        self._dirs = {}
+        self._files = {}
+        self._locks = {}
+        self._scheme = "memory+%s:" % id(self)
+        def memory_factory(url):
+            result = MemoryTransport(url)
+            result._dirs = self._dirs
+            result._files = self._files
+            result._locks = self._locks
+            return result
+        register_transport(self._scheme, memory_factory)
+
+    def tearDown(self):
+        """See bzrlib.transport.Server.tearDown."""
+        # unregister this server
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self._scheme
+
+
+def get_test_permutations():
+    """Return the permutations to be used in testing."""
+    return [(MemoryTransport, MemoryServer),
+            ]

=== added file 'bzrlib/transport/readonly.py'
--- bzrlib/transport/readonly.py	1970-01-01 00:00:00 +0000
+++ bzrlib/transport/readonly.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,153 @@
+# Copyright (C) 2006 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Implementation of Transport that adapts another transport to be readonly."""
+
+from bzrlib.errors import TransportNotPossible
+from bzrlib.transport import get_transport, Transport, Server
+
+
+class ReadonlyTransportDecorator(Transport):
+    """A decorator that can convert any transport to be readonly.
+    
+    This does not use __getattr__ hacks as we need to ensure that
+    new writable methods are overridden correctly.
+    """
+
+    def __init__(self, url, _decorated=None):
+        """Set the 'base' path where files will be stored.
+        
+        _decorated is a private parameter for cloning."""
+        assert url.startswith('readonly+')
+        decorated_url = url[len('readonly+'):]
+        if _decorated is None:
+            self._decorated = get_transport(decorated_url)
+        else:
+            self._decorated = _decorated
+        super(ReadonlyTransportDecorator, self).__init__(
+            "readonly+" + self._decorated.base)
+
+    def clone(self, offset=None):
+        """See Transport.clone()."""
+        decorated_clone = self._decorated.clone(offset)
+        return ReadonlyTransportDecorator("readonly+" + decorated_clone.base,
+                                          decorated_clone)
+
+    def abspath(self, relpath):
+        """See Transport.abspath()."""
+        return "readonly+" + self._decorated.abspath(relpath)
+
+    def append(self, relpath, f):
+        """See Transport.append()."""
+        raise TransportNotPossible('readonly transport')
+
+    def has(self, relpath):
+        """See Transport.has()."""
+        return self._decorated.has(relpath)
+
+    def delete(self, relpath):
+        """See Transport.delete()."""
+        raise TransportNotPossible('readonly transport')
+
+    def delete_tree(self, relpath):
+        """See Transport.delete_tree()."""
+        raise TransportNotPossible('readonly transport')
+
+    def get(self, relpath):
+        """See Transport.get()."""
+        return self._decorated.get(relpath)
+
+    def put(self, relpath, f, mode=None):
+        """See Transport.put()."""
+        raise TransportNotPossible('readonly transport')
+
+    def mkdir(self, relpath, mode=None):
+        """See Transport.mkdir()."""
+        raise TransportNotPossible('readonly transport')
+
+    def is_readonly(self):
+        """See Transport.is_readonly."""
+        return True
+
+    def listable(self):
+        """See Transport.listable."""
+        return self._decorated.listable()
+
+    def iter_files_recursive(self):
+        """See Transport.iter_files_recursive()."""
+        return self._decorated.iter_files_recursive()
+    
+    def list_dir(self, relpath):
+        """See Transport.list_dir()."""
+        return self._decorated.list_dir(relpath)
+    
+    def rmdir(self, relpath):
+        """See Transport.rmdir."""
+        raise TransportNotPossible('readonly transport')
+
+    def should_cache(self):
+        """See Transport.should_cache()."""
+        return self._decorated.should_cache()
+
+    def stat(self, relpath):
+        """See Transport.stat()."""
+        return self._decorated.stat(relpath)
+
+    def lock_read(self, relpath):
+        """See Transport.lock_read."""
+        return self._decorated.lock_read(relpath)
+
+    def lock_write(self, relpath):
+        """See Transport.lock_write."""
+        raise TransportNotPossible('readonly transport')
+
+
+class ReadonlyServer(Server):
+    """Server for the ReadonlyTransportDecorator for testing with."""
+
+    def setUp(self, server=None):
+        """See bzrlib.transport.Server.setUp.
+
+        :server: decorate the urls given by server. If not provided a
+        LocalServer is created.
+        """
+        if server is not None:
+            self._made_server = False
+            self._server = server
+        else:
+            from bzrlib.transport.local import LocalRelpathServer
+            self._made_server = True
+            self._server = LocalRelpathServer()
+            self._server.setUp()
+
+    def tearDown(self):
+        """See bzrlib.transport.Server.tearDown."""
+        if self._made_server:
+            self._server.tearDown()
+
+    def get_bogus_url(self):
+        """See bzrlib.transport.Server.get_bogus_url."""
+        return "readonly+" + self._server.get_bogus_url()
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return "readonly+" + self._server.get_url()
+
+
+def get_test_permutations():
+    """Return the permutations to be used in testing."""
+    return [(ReadonlyTransportDecorator, ReadonlyServer),
+            ]

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2006-01-25 14:30:06 +0000
+++ bzrlib/transport/sftp.py	2006-03-20 08:31:00 +0000
@@ -19,31 +19,32 @@
 import errno
 import getpass
 import os
+import random
 import re
 import stat
+import subprocess
 import sys
+import time
 import urllib
 import urlparse
-import time
-import random
-import subprocess
 import weakref
 
-from bzrlib.errors import (FileExists, 
+from bzrlib.config import config_dir, ensure_config_dir_exists
+from bzrlib.errors import (ConnectionError,
+                           FileExists, 
                            TransportNotPossible, NoSuchFile, PathNotChild,
                            TransportError,
-                           LockError)
-from bzrlib.config import config_dir, ensure_config_dir_exists
+                           LockError, ParamikoNotPresent
+                           )
+from bzrlib.osutils import pathjoin, fancy_rename
 from bzrlib.trace import mutter, warning, error
-from bzrlib.transport import Transport, register_transport
-from bzrlib.osutils import pathjoin, fancy_rename
+from bzrlib.transport import Transport, Server, urlescape
 import bzrlib.ui
 
 try:
     import paramiko
-except ImportError:
-    error('The SFTP transport requires paramiko.')
-    raise
+except ImportError, e:
+    raise ParamikoNotPresent(e)
 else:
     from paramiko.sftp import (SFTP_FLAG_WRITE, SFTP_FLAG_CREATE,
                                SFTP_FLAG_EXCL, SFTP_FLAG_TRUNC,
@@ -52,7 +53,13 @@
     from paramiko.sftp_file import SFTPFile
     from paramiko.sftp_client import SFTPClient
 
-if 'sftp' not in urlparse.uses_netloc: urlparse.uses_netloc.append('sftp')
+if 'sftp' not in urlparse.uses_netloc:
+    urlparse.uses_netloc.append('sftp')
+
+# don't use prefetch unless paramiko version >= 1.5.2 (there were bugs earlier)
+_default_do_prefetch = False
+if getattr(paramiko, '__version_info__', (0, 0, 0)) >= (1, 5, 2):
+    _default_do_prefetch = True
 
 
 _close_fds = True
@@ -61,6 +68,7 @@
     _close_fds = False
 
 _ssh_vendor = None
+
 def _get_ssh_vendor():
     """Find out what version of SSH is on the system."""
     global _ssh_vendor
@@ -69,6 +77,12 @@
 
     _ssh_vendor = 'none'
 
+    if 'BZR_SSH' in os.environ:
+        _ssh_vendor = os.environ['BZR_SSH']
+        if _ssh_vendor == 'paramiko':
+            _ssh_vendor = 'none'
+        return _ssh_vendor
+
     try:
         p = subprocess.Popen(['ssh', '-V'],
                              close_fds=_close_fds,
@@ -99,8 +113,7 @@
 
 class SFTPSubprocess:
     """A socket-like object that talks to an ssh subprocess via pipes."""
-    def __init__(self, hostname, port=None, user=None):
-        vendor = _get_ssh_vendor()
+    def __init__(self, hostname, vendor, port=None, user=None):
         assert vendor in ['openssh', 'ssh']
         if vendor == 'openssh':
             args = ['ssh',
@@ -143,6 +156,25 @@
         self.proc.wait()
 
 
+class LoopbackSFTP(object):
+    """Simple wrapper for a socket that pretends to be a paramiko Channel."""
+
+    def __init__(self, sock):
+        self.__socket = sock
+ 
+    def send(self, data):
+        return self.__socket.send(data)
+
+    def recv(self, n):
+        return self.__socket.recv(n)
+
+    def recv_ready(self):
+        return True
+
+    def close(self):
+        self.__socket.close()
+
+
 SYSTEM_HOSTKEYS = {}
 BZR_HOSTKEYS = {}
 
@@ -152,6 +184,7 @@
 # X seconds. But that requires a lot more fanciness.
 _connected_hosts = weakref.WeakValueDictionary()
 
+
 def load_host_keys():
     """
     Load system host keys (probably doesn't work on windows) and any
@@ -169,6 +202,7 @@
         mutter('failed to load bzr host keys: ' + str(e))
         save_host_keys()
 
+
 def save_host_keys():
     """
     Save "discovered" host keys in $(config)/ssh_host_keys/.
@@ -199,7 +233,8 @@
         self.lock_path = path + '.write-lock'
         self.transport = transport
         try:
-            abspath = transport._abspath(self.lock_path)
+            # RBC 20060103 FIXME should we be using private methods here ?
+            abspath = transport._remote_path(self.lock_path)
             self.lock_file = transport._sftp_open_exclusive(abspath)
         except FileExists:
             raise LockError('File %r already locked' % (self.path,))
@@ -207,7 +242,7 @@
     def __del__(self):
         """Should this warn, or actually try to cleanup?"""
         if self.lock_file:
-            warn("SFTPLock %r not explicitly unlocked" % (self.path,))
+            warning("SFTPLock %r not explicitly unlocked" % (self.path,))
             self.unlock()
 
     def unlock(self):
@@ -225,12 +260,14 @@
     """
     Transport implementation for SFTP access.
     """
-    _do_prefetch = False # Right now Paramiko's prefetch support causes things to hang
+    _do_prefetch = _default_do_prefetch
 
     def __init__(self, base, clone_from=None):
         assert base.startswith('sftp://')
         self._parse_url(base)
         base = self._unparse_url()
+        if base[-1] != '/':
+            base = base + '/'
         super(SFTPTransport, self).__init__(base)
         if clone_from is None:
             self._sftp_connect()
@@ -263,13 +300,16 @@
         @param relpath: the relative path or path components
         @type relpath: str or list
         """
-        return self._unparse_url(self._abspath(relpath))
+        return self._unparse_url(self._remote_path(relpath))
     
-    def _abspath(self, relpath):
-        """Return the absolute path segment without the SFTP URL."""
+    def _remote_path(self, relpath):
+        """Return the path to be passed along the sftp protocol for relpath.
+        
+        relpath is a urlencoded string.
+        """
         # FIXME: share the common code across transports
         assert isinstance(relpath, basestring)
-        relpath = [urllib.unquote(relpath)]
+        relpath = urllib.unquote(relpath).split('/')
         basepath = self._path.split('/')
         if len(basepath) > 0 and basepath[-1] == '':
             basepath = basepath[:-1]
@@ -287,7 +327,6 @@
                 basepath.append(p)
 
         path = '/'.join(basepath)
-        # could still be a "relative" path here, but relative on the sftp server
         return path
 
     def relpath(self, abspath):
@@ -305,14 +344,14 @@
             extra = ': ' + ', '.join(error)
             raise PathNotChild(abspath, self.base, extra=extra)
         pl = len(self._path)
-        return path[pl:].lstrip('/')
+        return path[pl:].strip('/')
 
     def has(self, relpath):
         """
         Does the target location exist?
         """
         try:
-            self._sftp.stat(self._abspath(relpath))
+            self._sftp.stat(self._remote_path(relpath))
             return True
         except IOError:
             return False
@@ -324,9 +363,9 @@
         :param relpath: The relative path to the file
         """
         try:
-            path = self._abspath(relpath)
+            path = self._remote_path(relpath)
             f = self._sftp.file(path, mode='rb')
-            if self._do_prefetch and hasattr(f, 'prefetch'):
+            if self._do_prefetch and (getattr(f, 'prefetch', None) is not None):
                 f.prefetch()
             return f
         except (IOError, paramiko.SSHException), e:
@@ -359,7 +398,7 @@
         :param f:       File-like or string object.
         :param mode: The final mode for the file
         """
-        final_path = self._abspath(relpath)
+        final_path = self._remote_path(relpath)
         self._put(final_path, f, mode=mode)
 
     def _put(self, abspath, f, mode=None):
@@ -378,7 +417,7 @@
                 self._sftp.chmod(tmp_abspath, mode)
             fout.close()
             closed = True
-            self._rename(tmp_abspath, abspath)
+            self._rename_and_overwrite(tmp_abspath, abspath)
         except Exception, e:
             # If we fail, try to clean up the temporary file
             # before we throw the exception
@@ -412,7 +451,7 @@
     def mkdir(self, relpath, mode=None):
         """Create a directory at the given path."""
         try:
-            path = self._abspath(relpath)
+            path = self._remote_path(relpath)
             # In the paramiko documentation, it says that passing a mode flag 
             # will filtered against the server umask.
             # StubSFTPServer does not do this, which would be nice, because it is
@@ -460,61 +499,22 @@
         location.
         """
         try:
-            path = self._abspath(relpath)
+            path = self._remote_path(relpath)
             fout = self._sftp.file(path, 'ab')
             self._pump(f, fout)
         except (IOError, paramiko.SSHException), e:
             self._translate_io_exception(e, relpath, ': unable to append')
 
-    def copy(self, rel_from, rel_to):
-        """Copy the item at rel_from to the location at rel_to"""
-        path_from = self._abspath(rel_from)
-        path_to = self._abspath(rel_to)
-        self._copy_abspaths(path_from, path_to)
-
-    def _copy_abspaths(self, path_from, path_to, mode=None):
-        """Copy files given an absolute path
-
-        :param path_from: Path on remote server to read
-        :param path_to: Path on remote server to write
-        :return: None
-
-        TODO: Should the destination location be atomically created?
-              This has not been specified
-        TODO: This should use some sort of remote copy, rather than
-              pulling the data locally, and then writing it remotely
-        """
+    def rename(self, rel_from, rel_to):
+        """Rename without special overwriting"""
         try:
-            fin = self._sftp.file(path_from, 'rb')
-            try:
-                self._put(path_to, fin, mode=mode)
-            finally:
-                fin.close()
+            self._sftp.rename(self._remote_path(rel_from),
+                              self._remote_path(rel_to))
         except (IOError, paramiko.SSHException), e:
-            self._translate_io_exception(e, path_from, ': unable copy to: %r' % path_to)
-
-    def copy_to(self, relpaths, other, mode=None, pb=None):
-        """Copy a set of entries from self into another Transport.
-
-        :param relpaths: A list/generator of entries to be copied.
-        """
-        if isinstance(other, SFTPTransport) and other._sftp is self._sftp:
-            # Both from & to are on the same remote filesystem
-            # We can use a remote copy, instead of pulling locally, and pushing
-
-            total = self._get_total(relpaths)
-            count = 0
-            for path in relpaths:
-                path_from = self._abspath(relpath)
-                path_to = other._abspath(relpath)
-                self._update_pb(pb, 'copy-to', count, total)
-                self._copy_abspaths(path_from, path_to, mode=mode)
-                count += 1
-            return count
-        else:
-            return super(SFTPTransport, self).copy_to(relpaths, other, mode=mode, pb=pb)
-
-    def _rename(self, abs_from, abs_to):
+            self._translate_io_exception(e, rel_from,
+                    ': unable to rename to %r' % (rel_to))
+
+    def _rename_and_overwrite(self, abs_from, abs_to):
         """Do a fancy rename on the remote server.
         
         Using the implementation provided by osutils.
@@ -528,13 +528,13 @@
 
     def move(self, rel_from, rel_to):
         """Move the item at rel_from to the location at rel_to"""
-        path_from = self._abspath(rel_from)
-        path_to = self._abspath(rel_to)
-        self._rename(path_from, path_to)
+        path_from = self._remote_path(rel_from)
+        path_to = self._remote_path(rel_to)
+        self._rename_and_overwrite(path_from, path_to)
 
     def delete(self, relpath):
         """Delete the item at relpath"""
-        path = self._abspath(relpath)
+        path = self._remote_path(relpath)
         try:
             self._sftp.remove(path)
         except (IOError, paramiko.SSHException), e:
@@ -549,15 +549,23 @@
         Return a list of all files at the given location.
         """
         # does anything actually use this?
-        path = self._abspath(relpath)
+        path = self._remote_path(relpath)
         try:
             return self._sftp.listdir(path)
         except (IOError, paramiko.SSHException), e:
             self._translate_io_exception(e, path, ': failed to list_dir')
 
+    def rmdir(self, relpath):
+        """See Transport.rmdir."""
+        path = self._remote_path(relpath)
+        try:
+            return self._sftp.rmdir(path)
+        except (IOError, paramiko.SSHException), e:
+            self._translate_io_exception(e, path, ': failed to rmdir')
+
     def stat(self, relpath):
         """Return the stat information for a file."""
-        path = self._abspath(relpath)
+        path = self._remote_path(relpath)
         try:
             return self._sftp.stat(path)
         except (IOError, paramiko.SSHException), e:
@@ -589,15 +597,13 @@
         # that we have taken the lock.
         return SFTPLock(relpath, self)
 
-
     def _unparse_url(self, path=None):
         if path is None:
             path = self._path
         path = urllib.quote(path)
-        if path.startswith('/'):
-            path = '/%2F' + path[1:]
-        else:
-            path = '/' + path
+        # handle homedir paths
+        if not path.startswith('/'):
+            path = "/~/" + path
         netloc = urllib.quote(self._host)
         if self._username is not None:
             netloc = '%s@%s' % (urllib.quote(self._username), netloc)
@@ -637,9 +643,13 @@
         # as a homedir relative path (the path begins with a double slash
         # if it is absolute).
         # see draft-ietf-secsh-scp-sftp-ssh-uri-03.txt
-        if path.startswith('/'):
-            path = path[1:]
-
+        # RBC 20060118 we are not using this as its too user hostile. instead
+        # we are following lftp and using /~/foo to mean '~/foo'.
+        # handle homedir paths
+        if path.startswith('/~/'):
+            path = path[3:]
+        elif path == '/~':
+            path = ''
         return (username, password, host, port, path)
 
     def _parse_url(self, url):
@@ -663,8 +673,13 @@
             pass
         
         vendor = _get_ssh_vendor()
-        if vendor != 'none':
-            sock = SFTPSubprocess(self._host, self._port, self._username)
+        if vendor == 'loopback':
+            sock = socket.socket()
+            sock.connect((self._host, self._port))
+            self._sftp = SFTPClient(LoopbackSFTP(sock))
+        elif vendor != 'none':
+            sock = SFTPSubprocess(self._host, vendor, self._port,
+                                  self._username)
             self._sftp = SFTPClient(sock)
         else:
             self._paramiko_connect()
@@ -678,6 +693,7 @@
 
         try:
             t = paramiko.Transport((self._host, self._port or 22))
+            t.set_log_channel('bzr.paramiko')
             t.start_client()
         except paramiko.SSHException, e:
             raise ConnectionError('Unable to reach SSH host %s:%d' %
@@ -744,7 +760,6 @@
         if self._try_pkey_auth(transport, paramiko.DSSKey, username, 'id_dsa'):
             return
 
-
         if self._password:
             try:
                 transport.auth_password(username, self._password)
@@ -817,3 +832,178 @@
             self._translate_io_exception(e, abspath, ': unable to open',
                 failure_exc=FileExists)
 
+
+# ------------- server test implementation --------------
+import socket
+import threading
+
+from bzrlib.tests.stub_sftp import StubServer, StubSFTPServer
+
+STUB_SERVER_KEY = """
+-----BEGIN RSA PRIVATE KEY-----
+MIICWgIBAAKBgQDTj1bqB4WmayWNPB+8jVSYpZYk80Ujvj680pOTh2bORBjbIAyz
+oWGW+GUjzKxTiiPvVmxFgx5wdsFvF03v34lEVVhMpouqPAYQ15N37K/ir5XY+9m/
+d8ufMCkjeXsQkKqFbAlQcnWMCRnOoPHS3I4vi6hmnDDeeYTSRvfLbW0fhwIBIwKB
+gBIiOqZYaoqbeD9OS9z2K9KR2atlTxGxOJPXiP4ESqP3NVScWNwyZ3NXHpyrJLa0
+EbVtzsQhLn6rF+TzXnOlcipFvjsem3iYzCpuChfGQ6SovTcOjHV9z+hnpXvQ/fon
+soVRZY65wKnF7IAoUwTmJS9opqgrN6kRgCd3DASAMd1bAkEA96SBVWFt/fJBNJ9H
+tYnBKZGw0VeHOYmVYbvMSstssn8un+pQpUm9vlG/bp7Oxd/m+b9KWEh2xPfv6zqU
+avNwHwJBANqzGZa/EpzF4J8pGti7oIAPUIDGMtfIcmqNXVMckrmzQ2vTfqtkEZsA
+4rE1IERRyiJQx6EJsz21wJmGV9WJQ5kCQQDwkS0uXqVdFzgHO6S++tjmjYcxwr3g
+H0CoFYSgbddOT6miqRskOQF3DZVkJT3kyuBgU2zKygz52ukQZMqxCb1fAkASvuTv
+qfpH87Qq5kQhNKdbbwbmd2NxlNabazPijWuphGTdW0VfJdWfklyS2Kr+iqrs/5wV
+HhathJt636Eg7oIjAkA8ht3MQ+XSl9yIJIS8gVpbPxSw5OMfw0PjVE7tBdQruiSc
+nvuQES5C9BMHjF39LZiGH1iLQy7FgdHyoP+eodI7
+-----END RSA PRIVATE KEY-----
+"""
+    
+
+class SingleListener(threading.Thread):
+
+    def __init__(self, callback):
+        threading.Thread.__init__(self)
+        self._callback = callback
+        self._socket = socket.socket()
+        self._socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
+        self._socket.bind(('localhost', 0))
+        self._socket.listen(1)
+        self.port = self._socket.getsockname()[1]
+        self.stop_event = threading.Event()
+
+    def run(self):
+        s, _ = self._socket.accept()
+        # now close the listen socket
+        self._socket.close()
+        try:
+            self._callback(s, self.stop_event)
+        except socket.error:
+            pass #Ignore socket errors
+        except Exception, x:
+            # probably a failed test
+            warning('Exception from within unit test server thread: %r' % x)
+
+    def stop(self):
+        self.stop_event.set()
+        # use a timeout here, because if the test fails, the server thread may
+        # never notice the stop_event.
+        self.join(5.0)
+
+
+class SFTPServer(Server):
+    """Common code for SFTP server facilities."""
+
+    def __init__(self):
+        self._original_vendor = None
+        self._homedir = None
+        self._server_homedir = None
+        self._listener = None
+        self._root = None
+        self._vendor = 'none'
+        # sftp server logs
+        self.logs = []
+
+    def _get_sftp_url(self, path):
+        """Calculate an sftp url to this server for path."""
+        return 'sftp://foo:bar@localhost:%d/%s' % (self._listener.port, path)
+
+    def log(self, message):
+        """StubServer uses this to log when a new server is created."""
+        self.logs.append(message)
+
+    def _run_server(self, s, stop_event):
+        ssh_server = paramiko.Transport(s)
+        key_file = os.path.join(self._homedir, 'test_rsa.key')
+        file(key_file, 'w').write(STUB_SERVER_KEY)
+        host_key = paramiko.RSAKey.from_private_key_file(key_file)
+        ssh_server.add_server_key(host_key)
+        server = StubServer(self)
+        ssh_server.set_subsystem_handler('sftp', paramiko.SFTPServer,
+                                         StubSFTPServer, root=self._root,
+                                         home=self._server_homedir)
+        event = threading.Event()
+        ssh_server.start_server(event, server)
+        event.wait(5.0)
+        stop_event.wait(30.0)
+    
+    def setUp(self):
+        global _ssh_vendor
+        self._original_vendor = _ssh_vendor
+        _ssh_vendor = self._vendor
+        self._homedir = os.getcwdu()
+        if self._server_homedir is None:
+            self._server_homedir = self._homedir
+        self._root = '/'
+        # FIXME WINDOWS: _root should be _server_homedir[0]:/
+        self._listener = SingleListener(self._run_server)
+        self._listener.setDaemon(True)
+        self._listener.start()
+
+    def tearDown(self):
+        """See bzrlib.transport.Server.tearDown."""
+        global _ssh_vendor
+        self._listener.stop()
+        _ssh_vendor = self._original_vendor
+
+
+class SFTPFullAbsoluteServer(SFTPServer):
+    """A test server for sftp transports, using absolute urls and ssh."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self._get_sftp_url(urlescape(self._homedir[1:]))
+
+
+class SFTPServerWithoutSSH(SFTPServer):
+    """An SFTP server that uses a simple TCP socket pair rather than SSH."""
+
+    def __init__(self):
+        super(SFTPServerWithoutSSH, self).__init__()
+        self._vendor = 'loopback'
+
+    def _run_server(self, sock, stop_event):
+        class FakeChannel(object):
+            def get_transport(self):
+                return self
+            def get_log_channel(self):
+                return 'paramiko'
+            def get_name(self):
+                return '1'
+            def get_hexdump(self):
+                return False
+
+        server = paramiko.SFTPServer(FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
+                                     root=self._root, home=self._server_homedir)
+        server.start_subsystem('sftp', None, sock)
+        server.finish_subsystem()
+
+
+class SFTPAbsoluteServer(SFTPServerWithoutSSH):
+    """A test server for sftp transports, using absolute urls."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self._get_sftp_url(urlescape(self._homedir[1:]))
+
+
+class SFTPHomeDirServer(SFTPServerWithoutSSH):
+    """A test server for sftp transports, using homedir relative urls."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self._get_sftp_url("~/")
+
+
+class SFTPSiblingAbsoluteServer(SFTPAbsoluteServer):
+    """A test servere for sftp transports, using absolute urls to non-home."""
+
+    def setUp(self):
+        self._server_homedir = '/dev/noone/runs/tests/here'
+        super(SFTPSiblingAbsoluteServer, self).setUp()
+
+
+def get_test_permutations():
+    """Return the permutations to be used in testing."""
+    return [(SFTPTransport, SFTPAbsoluteServer),
+            (SFTPTransport, SFTPHomeDirServer),
+            (SFTPTransport, SFTPSiblingAbsoluteServer),
+            ]

=== modified file 'bzrlib/tsort.py'
--- bzrlib/tsort.py	2005-11-07 13:17:53 +0000
+++ bzrlib/tsort.py	2006-03-20 08:31:00 +0000
@@ -1,4 +1,4 @@
-# (C) 2005 Canonical
+# (C) 2005, 2006 Canonical Limited.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,9 +14,12 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import pdb
-
-from bzrlib.errors import GraphCycleError
+
+"""Topological sorting routines."""
+
+
+import bzrlib.errors as errors
+
 
 def topo_sort(graph):
     """Topological sort a graph.
@@ -30,31 +33,127 @@
 
     node identifiers can be any hashable object, and are typically strings.
     """
-    parents = {}  # node -> list of parents
-    children = {} # node -> list of children
-    for node, node_parents in graph:
-        assert node not in parents, \
-            ('node %r repeated in graph' % node)
-        parents[node] = set(node_parents)
-        if node not in children:
-            children[node] = set()
-        for parent in node_parents:
-            if parent in children:
-                children[parent].add(node)
-            else:
-                children[parent] = set([node])
-    result = []
-    while parents:
-        # find nodes with no parents, and take them now
-        no_parents = [n for n in parents if len(parents[n]) == 0]
-        no_parents.sort()
-        if not no_parents:
-            raise GraphCycleError(parents)
-        for n in no_parents:
-            result.append(n)
-            for child in children[n]:
-                assert n in parents[child]
-                parents[child].remove(n)
-            del children[n]
-            del parents[n]
-    return result
+    return TopoSorter(graph).sorted()
+
+
+class TopoSorter(object):
+
+    def __init__(self, graph):
+        """Topological sorting of a graph.
+    
+        :param graph: sequence of pairs of node_name->parent_names_list.
+                      i.e. [('C', ['B']), ('B', ['A']), ('A', [])]
+                      For this input the output from the sort or
+                      iter_topo_order routines will be:
+                      'A', 'B', 'C'
+        
+        node identifiers can be any hashable object, and are typically strings.
+
+        If you have a graph like [('a', ['b']), ('a', ['c'])] this will only use
+        one of the two values for 'a'.
+
+        The graph is sorted lazily: until you iterate or sort the input is
+        not processed other than to create an internal representation.
+
+        iteration or sorting may raise GraphCycleError if a cycle is present 
+        in the graph.
+        """
+        # a dict of the graph.
+        self._graph = dict(graph)
+        ### if debugging:
+        # self._original_graph = dict(graph)
+        
+        # this is a stack storing the depth first search into the graph.
+        self._node_name_stack = []
+        # at each level of 'recursion' we have to check each parent. This
+        # stack stores the parents we have not yet checked for the node at the 
+        # matching depth in _node_name_stack
+        self._pending_parents_stack = []
+        # this is a set of the completed nodes for fast checking whether a
+        # parent in a node we are processing on the stack has already been
+        # emitted and thus can be skipped.
+        self._completed_node_names = set()
+
+    def sorted(self):
+        """Sort the graph and return as a list.
+        
+        After calling this the sorter is empty and you must create a new one.
+        """
+        return list(self.iter_topo_order())
+
+###        Useful if fiddling with this code.
+###        # cross check
+###        sorted_names = list(self.iter_topo_order())
+###        for index in range(len(sorted_names)):
+###            rev = sorted_names[index]
+###            for left_index in range(index):
+###                if rev in self.original_graph[sorted_names[left_index]]:
+###                    print "revision in parent list of earlier revision"
+###                    import pdb;pdb.set_trace()
+
+    def iter_topo_order(self):
+        """Yield the nodes of the graph in a topological order.
+        
+        After finishing iteration the sorter is empty and you cannot continue
+        iteration.
+        """
+        while self._graph:
+            # now pick a random node in the source graph, and transfer it to the
+            # top of the depth first search stack.
+            node_name, parents = self._graph.popitem()
+            self._push_node(node_name, parents)
+            while self._node_name_stack:
+                # loop until this call completes.
+                parents_to_visit = self._pending_parents_stack[-1]
+                # if all parents are done, the revision is done
+                if not parents_to_visit:
+                    # append the revision to the topo sorted list
+                    # all the nodes parents have been added to the output, now
+                    # we can add it to the output.
+                    yield self._pop_node()
+                else:
+                    while self._pending_parents_stack[-1]:
+                        # recurse depth first into a single parent 
+                        next_node_name = self._pending_parents_stack[-1].pop()
+                        if next_node_name in self._completed_node_names:
+                            # this parent was completed by a child on the
+                            # call stack. skip it.
+                            continue
+                        # otherwise transfer it from the source graph into the
+                        # top of the current depth first search stack.
+                        try:
+                            parents = self._graph.pop(next_node_name)
+                        except KeyError:
+                            # if the next node is not in the source graph it has
+                            # already been popped from it and placed into the
+                            # current search stack (but not completed or we would
+                            # have hit the continue 4 lines up.
+                            # this indicates a cycle.
+                            raise errors.GraphCycleError(self._node_name_stack)
+                        self._push_node(next_node_name, parents)
+                        # and do not continue processing parents until this 'call' 
+                        # has recursed.
+                        break
+
+    def _push_node(self, node_name, parents):
+        """Add node_name to the pending node stack.
+        
+        Names in this stack will get emitted into the output as they are popped
+        off the stack.
+        """
+
+        self._node_name_stack.append(node_name)
+        self._pending_parents_stack.append(list(parents))
+
+    def _pop_node(self):
+        """Pop the top node off the stack 
+
+        The node is appended to the sorted output.
+        """
+        # we are returning from the flattened call frame:
+        # pop off the local variables
+        node_name = self._node_name_stack.pop()
+        self._pending_parents_stack.pop()
+
+        self._completed_node_names.add(node_name)
+        return node_name

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2006-01-25 14:30:06 +0000
+++ bzrlib/ui/__init__.py	2006-03-20 08:31:00 +0000
@@ -67,3 +67,5 @@
 
 
 ui_factory = SilentUIFactory()
+"""IMPORTANT: never import this symbol directly. ONLY ever access it as 
+ui.ui_factory."""

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2006-01-25 14:30:06 +0000
+++ bzrlib/uncommit.py	2006-03-20 08:31:00 +0000
@@ -13,13 +13,12 @@
         print '* file does not exist: %r' % filename
 
 
-def uncommit(branch, remove_files=False,
-        dry_run=False, verbose=False, revno=None):
+def uncommit(branch, dry_run=False, verbose=False, revno=None, tree=None):
     """Remove the last revision from the supplied branch.
 
-    :param remove_files: If True, remove files from the stores
-        as well.
-    :param force: Don't ask any questions
+    :param dry_run: Don't actually change anything
+    :param verbose: Print each step as you do it
+    :param revno: Remove back to this revision
     """
     from bzrlib.atomicfile import AtomicFile
     rh = branch.revision_history()
@@ -27,48 +26,11 @@
         revno = len(rh)
 
     files_to_remove = []
-    new_rev_history = AtomicFile(branch.controlfilename('revision-history'))
+    new_rev_history = AtomicFile(branch.control_files.controlfilename('revision-history'))
     for r in range(revno-1, len(rh)):
         rev_id = rh.pop()
         if verbose:
             print 'Removing revno %d: %s' % (len(rh)+1, rev_id)
-        rev = branch.get_revision(rev_id)
-        inv = branch.get_revision_inventory(rev_id)
-        inv_prev = []
-        for p in rev.parent_ids:
-            inv_prev.append(branch.get_revision_inventory(p))
-
-        if remove_files:
-            # Figure out what text-store entries are new
-
-            # In the future, when we have text_version instead of
-            # text_id, we can just check to see if the text_version
-            # equals the current revision id.
-            for file_id in inv:
-                ie = inv[file_id]
-                if not hasattr(ie, 'text_id'):
-                    continue
-                for other_inv in inv_prev:
-                    if file_id in other_inv:
-                        other_ie = other_inv[file_id]
-                        if other_ie.text_id == ie.text_id:
-                            break
-                else:
-                    # None of the previous ancestors used
-                    # the same inventory
-                    files_to_remove.append(branch.controlfilename(['text-store',
-                        ie.text_id + '.gz']))
-            rev_file = branch.controlfilename(['revision-store',
-                    rev_id + '.gz'])
-            files_to_remove.append(rev_file)
-            inv_file = branch.controlfilename(['inventory-store',
-                    rev.inventory_id + '.gz'])
-            files_to_remove.append(inv_file)
-
-    if verbose and files_to_remove:
-        print 'Removing files:'
-        for f in files_to_remove:
-            print '\t%s' % branch.relpath(f)
 
     new_rev_history.write('\n'.join(rh))
 
@@ -76,11 +38,8 @@
     # once we have removed at least one, all the rest are invalid.
     if not dry_run:
         new_rev_history.commit()
-        if remove_files:
-            # Actually start removing files
-            for f in files_to_remove:
-                test_remove(f)
-
+        if tree is not None:
+            tree.set_last_revision(branch.last_revision())
     else:
         new_rev_history.abort()
 

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2006-01-25 14:30:06 +0000
+++ bzrlib/upgrade.py	2006-03-20 08:31:00 +0000
@@ -14,393 +14,55 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Experiment in converting existing bzr branches to weaves."""
-
-# To make this properly useful
-#
-# 1. assign text version ids, and put those text versions into
-#    the inventory as they're converted.
-#
-# 2. keep track of the previous version of each file, rather than
-#    just using the last one imported
-#
-# 3. assign entry versions when files are added, renamed or moved.
-#
-# 4. when merged-in versions are observed, walk down through them
-#    to discover everything, then commit bottom-up
-#
-# 5. track ancestry as things are merged in, and commit that in each
-#    revision
-#
-# Perhaps it's best to first walk the whole graph and make a plan for
-# what should be imported in what order?  Need a kind of topological
-# sort of all revisions.  (Or do we, can we just before doing a revision
-# see that all its parents have either been converted or abandoned?)
-
-
-# Cannot import a revision until all its parents have been
-# imported.  in other words, we can only import revisions whose
-# parents have all been imported.  the first step must be to
-# import a revision with no parents, of which there must be at
-# least one.  (So perhaps it's useful to store forward pointers
-# from a list of parents to their children?)
-#
-# Another (equivalent?) approach is to build up the ordered
-# ancestry list for the last revision, and walk through that.  We
-# are going to need that.
-#
-# We don't want to have to recurse all the way back down the list.
-#
-# Suppose we keep a queue of the revisions able to be processed at
-# any point.  This starts out with all the revisions having no
-# parents.
-#
-# This seems like a generally useful algorithm...
-#
-# The current algorithm is dumb (O(n**2)?) but will do the job, and
-# takes less than a second on the bzr.dev branch.
-
-# This currently does a kind of lazy conversion of file texts, where a
-# new text is written in every version.  That's unnecessary but for
-# the moment saves us having to worry about when files need new
-# versions.
-
-
-import os
-import tempfile
-import sys
-import shutil
-
-from bzrlib.branch import Branch, find_branch
-from bzrlib.branch import BZR_BRANCH_FORMAT_5, BZR_BRANCH_FORMAT_6
-import bzrlib.hashcache as hashcache
-from bzrlib.weave import Weave
-from bzrlib.weavefile import read_weave, write_weave
-from bzrlib.ui import ui_factory
-from bzrlib.atomicfile import AtomicFile
-from bzrlib.xml4 import serializer_v4
-from bzrlib.xml5 import serializer_v5
-from bzrlib.trace import mutter, note, warning
-from bzrlib.osutils import sha_strings, sha_string, pathjoin, abspath
+"""bzr upgrade logic."""
+
+# change upgrade from .bzr to create a '.bzr-new', then do a bait and switch.
+
+
+from bzrlib.bzrdir import ConvertBzrDir4To5, ConvertBzrDir5To6, BzrDir, BzrDirFormat4, BzrDirFormat5
+import bzrlib.errors as errors
+from bzrlib.transport import get_transport
+import bzrlib.ui as ui
 
 
 class Convert(object):
-    def __init__(self, base_dir):
-        self.base = base_dir
-        self.converted_revs = set()
-        self.absent_revisions = set()
-        self.text_count = 0
-        self.revisions = {}
+
+    def __init__(self, url, format):
+        self.format = format
+        self.bzrdir = BzrDir.open_unsupported(url)
+        if self.bzrdir.root_transport.is_readonly():
+            raise errors.UpgradeReadonly
+        self.transport = self.bzrdir.root_transport
         self.convert()
 
-
     def convert(self):
-        if not self._open_branch():
-            return
-        note('starting upgrade of %s', os.path.abspath(self.base))
+        self.pb = ui.ui_factory.progress_bar()
+        branch = self.bzrdir.open_branch()
+        if branch.bzrdir.root_transport.base != self.bzrdir.root_transport.base:
+            self.pb.note("This is a checkout. The branch (%s) needs to be "
+                         "upgraded separately.",
+                         branch.bzrdir.root_transport.base)
+        if not self.bzrdir.needs_format_conversion(self.format):
+            raise errors.UpToDateFormat(self.bzrdir._format)
+        if not self.bzrdir.can_convert_format():
+            raise errors.BzrError("cannot upgrade from branch format %s" %
+                           self.bzrdir._format)
+        self.pb.note('starting upgrade of %s', self.transport.base)
         self._backup_control_dir()
-        self.pb = ui_factory.progress_bar()
-        if self.old_format == 4:
-            note('starting upgrade from format 4 to 5')
-            self._convert_to_weaves()
-            self._open_branch()
-        if self.old_format == 5:
-            note('starting upgrade from format 5 to 6')
-            self._convert_to_prefixed()
-            self._open_branch()
-        cache = hashcache.HashCache(abspath(self.base))
-        cache.clear()
-        cache.write()
-        note("finished")
-
-
-    def _convert_to_prefixed(self):
-        from bzrlib.store import hash_prefix
-        for store_name in ["weaves", "revision-store"]:
-            note("adding prefixes to %s" % store_name) 
-            store_dir = pathjoin(self.base, ".bzr", store_name)
-            for filename in os.listdir(store_dir):
-                if filename.endswith(".weave") or filename.endswith(".gz"):
-                    file_id = os.path.splitext(filename)[0]
-                else:
-                    file_id = filename
-                prefix_dir = pathjoin(store_dir, hash_prefix(file_id))
-                if not os.path.isdir(prefix_dir):
-                    os.mkdir(prefix_dir)
-                os.rename(pathjoin(store_dir, filename),
-                          pathjoin(prefix_dir, filename))
-        self._set_new_format(BZR_BRANCH_FORMAT_6)
-
-
-    def _convert_to_weaves(self):
-        note('note: upgrade may be faster if all store files are ungzipped first')
-        if not os.path.isdir(self.base + '/.bzr/weaves'):
-            os.mkdir(self.base + '/.bzr/weaves')
-        self.inv_weave = Weave('inventory')
-        # holds in-memory weaves for all files
-        self.text_weaves = {}
-        os.remove(self.branch.controlfilename('branch-format'))
-        self._convert_working_inv()
-        rev_history = self.branch.revision_history()
-        # to_read is a stack holding the revisions we still need to process;
-        # appending to it adds new highest-priority revisions
-        self.known_revisions = set(rev_history)
-        self.to_read = rev_history[-1:]
-        while self.to_read:
-            rev_id = self.to_read.pop()
-            if (rev_id not in self.revisions
-                and rev_id not in self.absent_revisions):
-                self._load_one_rev(rev_id)
-        self.pb.clear()
-        to_import = self._make_order()
-        for i, rev_id in enumerate(to_import):
-            self.pb.update('converting revision', i, len(to_import))
-            self._convert_one_rev(rev_id)
-        self.pb.clear()
-        note('upgraded to weaves:')
-        note('  %6d revisions and inventories' % len(self.revisions))
-        note('  %6d revisions not present' % len(self.absent_revisions))
-        note('  %6d texts' % self.text_count)
-        self._write_all_weaves()
-        self._write_all_revs()
-        self._cleanup_spare_files()
-        self._set_new_format(BZR_BRANCH_FORMAT_5)
-
-
-    def _open_branch(self):
-        self.branch = Branch.open_downlevel(self.base)
-        self.old_format = self.branch._branch_format
-        if self.old_format == 6:
-            note('this branch is in the most current format')
-            return False
-        if self.old_format not in (4, 5):
-            raise BzrError("cannot upgrade from branch format %r" %
-                           self.branch._branch_format)
-        return True
-
-
-    def _set_new_format(self, format):
-        self.branch.put_controlfile('branch-format', format)
-
-
-    def _cleanup_spare_files(self):
-        for n in 'merged-patches', 'pending-merged-patches':
-            p = self.branch.controlfilename(n)
-            if not os.path.exists(p):
-                continue
-            ## assert os.path.getsize(p) == 0
-            os.remove(p)
-        shutil.rmtree(self.base + '/.bzr/inventory-store')
-        shutil.rmtree(self.base + '/.bzr/text-store')
-
+        while self.bzrdir.needs_format_conversion(self.format):
+            converter = self.bzrdir._format.get_converter(self.format)
+            self.bzrdir = converter.convert(self.bzrdir, self.pb)
+        self.pb.note("finished")
 
     def _backup_control_dir(self):
-        orig = self.base + '/.bzr'
-        backup = orig + '.backup'
-        note('making backup of tree history')
-        shutil.copytree(orig, backup)
-        note('%s has been backed up to %s', orig, backup)
-        note('if conversion fails, you can move this directory back to .bzr')
-        note('if it succeeds, you can remove this directory if you wish')
-
-
-    def _convert_working_inv(self):
-        branch = self.branch
-        inv = serializer_v4.read_inventory(branch.controlfile('inventory', 'rb'))
-        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
-        branch.put_controlfile('inventory', new_inv_xml)
-
-
-
-    def _write_all_weaves(self):
-        write_a_weave(self.inv_weave, self.base + '/.bzr/inventory.weave')
-        i = 0
-        try:
-            for file_id, file_weave in self.text_weaves.items():
-                self.pb.update('writing weave', i, len(self.text_weaves))
-                write_a_weave(file_weave, self.base + '/.bzr/weaves/%s.weave' % file_id)
-                i += 1
-        finally:
-            self.pb.clear()
-
-
-    def _write_all_revs(self):
-        """Write all revisions out in new form."""
-        shutil.rmtree(self.base + '/.bzr/revision-store')
-        os.mkdir(self.base + '/.bzr/revision-store')
-        try:
-            for i, rev_id in enumerate(self.converted_revs):
-                self.pb.update('write revision', i, len(self.converted_revs))
-                f = file(self.base + '/.bzr/revision-store/%s' % rev_id, 'wb')
-                try:
-                    serializer_v5.write_revision(self.revisions[rev_id], f)
-                finally:
-                    f.close()
-        finally:
-            self.pb.clear()
-
-            
-    def _load_one_rev(self, rev_id):
-        """Load a revision object into memory.
-
-        Any parents not either loaded or abandoned get queued to be
-        loaded."""
-        self.pb.update('loading revision',
-                       len(self.revisions),
-                       len(self.known_revisions))
-        if not self.branch.revision_store.has_id(rev_id):
-            self.pb.clear()
-            note('revision {%s} not present in branch; '
-                 'will be converted as a ghost',
-                 rev_id)
-            self.absent_revisions.add(rev_id)
-        else:
-            rev_xml = self.branch.revision_store.get(rev_id).read()
-            rev = serializer_v4.read_revision_from_string(rev_xml)
-            for parent_id in rev.parent_ids:
-                self.known_revisions.add(parent_id)
-                self.to_read.append(parent_id)
-            self.revisions[rev_id] = rev
-
-
-    def _load_old_inventory(self, rev_id):
-        assert rev_id not in self.converted_revs
-        old_inv_xml = self.branch.inventory_store.get(rev_id).read()
-        inv = serializer_v4.read_inventory_from_string(old_inv_xml)
-        rev = self.revisions[rev_id]
-        if rev.inventory_sha1:
-            assert rev.inventory_sha1 == sha_string(old_inv_xml), \
-                'inventory sha mismatch for {%s}' % rev_id
-        return inv
-        
-
-    def _load_updated_inventory(self, rev_id):
-        assert rev_id in self.converted_revs
-        inv_xml = self.inv_weave.get_text(rev_id)
-        inv = serializer_v5.read_inventory_from_string(inv_xml)
-        return inv
-
-
-    def _convert_one_rev(self, rev_id):
-        """Convert revision and all referenced objects to new format."""
-        rev = self.revisions[rev_id]
-        inv = self._load_old_inventory(rev_id)
-        present_parents = [p for p in rev.parent_ids
-                           if p not in self.absent_revisions]
-        self._convert_revision_contents(rev, inv, present_parents)
-        self._store_new_weave(rev, inv, present_parents)
-        self.converted_revs.add(rev_id)
-
-
-    def _store_new_weave(self, rev, inv, present_parents):
-        # the XML is now updated with text versions
-        if __debug__:
-            for file_id in inv:
-                ie = inv[file_id]
-                if ie.kind == 'root_directory':
-                    continue
-                assert hasattr(ie, 'revision'), \
-                    'no revision on {%s} in {%s}' % \
-                    (file_id, rev.revision_id)
-        new_inv_xml = serializer_v5.write_inventory_to_string(inv)
-        new_inv_sha1 = sha_string(new_inv_xml)
-        self.inv_weave.add(rev.revision_id, 
-                           present_parents,
-                           new_inv_xml.splitlines(True),
-                           new_inv_sha1)
-        rev.inventory_sha1 = new_inv_sha1
-
-    def _convert_revision_contents(self, rev, inv, present_parents):
-        """Convert all the files within a revision.
-
-        Also upgrade the inventory to refer to the text revision ids."""
-        rev_id = rev.revision_id
-        mutter('converting texts of revision {%s}',
-               rev_id)
-        parent_invs = map(self._load_updated_inventory, present_parents)
-        for file_id in inv:
-            ie = inv[file_id]
-            self._convert_file_version(rev, ie, parent_invs)
-
-    def _convert_file_version(self, rev, ie, parent_invs):
-        """Convert one version of one file.
-
-        The file needs to be added into the weave if it is a merge
-        of >=2 parents or if it's changed from its parent.
-        """
-        if ie.kind == 'root_directory':
-            return
-        file_id = ie.file_id
-        rev_id = rev.revision_id
-        w = self.text_weaves.get(file_id)
-        if w is None:
-            w = Weave(file_id)
-            self.text_weaves[file_id] = w
-        text_changed = False
-        previous_entries = ie.find_previous_heads(parent_invs, w)
-        for old_revision in previous_entries:
-                # if this fails, its a ghost ?
-                assert old_revision in self.converted_revs 
-        self.snapshot_ie(previous_entries, ie, w, rev_id)
-        del ie.text_id
-        assert getattr(ie, 'revision', None) is not None
-
-    def snapshot_ie(self, previous_revisions, ie, w, rev_id):
-        # TODO: convert this logic, which is ~= snapshot to
-        # a call to:. This needs the path figured out. rather than a work_tree
-        # a v4 revision_tree can be given, or something that looks enough like
-        # one to give the file content to the entry if it needs it.
-        # and we need something that looks like a weave store for snapshot to 
-        # save against.
-        #ie.snapshot(rev, PATH, previous_revisions, REVISION_TREE, InMemoryWeaveStore(self.text_weaves))
-        if len(previous_revisions) == 1:
-            previous_ie = previous_revisions.values()[0]
-            if ie._unchanged(previous_ie):
-                ie.revision = previous_ie.revision
-                return
-        parent_indexes = map(w.lookup, previous_revisions)
-        if ie.has_text():
-            file_lines = self.branch.text_store.get(ie.text_id).readlines()
-            assert sha_strings(file_lines) == ie.text_sha1
-            assert sum(map(len, file_lines)) == ie.text_size
-            w.add(rev_id, parent_indexes, file_lines, ie.text_sha1)
-            self.text_count += 1
-        else:
-            w.add(rev_id, parent_indexes, [], None)
-        ie.revision = rev_id
-        ##mutter('import text {%s} of {%s}',
-        ##       ie.text_id, file_id)
-
-    def _make_order(self):
-        """Return a suitable order for importing revisions.
-
-        The order must be such that an revision is imported after all
-        its (present) parents.
-        """
-        todo = set(self.revisions.keys())
-        done = self.absent_revisions.copy()
-        o = []
-        while todo:
-            # scan through looking for a revision whose parents
-            # are all done
-            for rev_id in sorted(list(todo)):
-                rev = self.revisions[rev_id]
-                parent_ids = set(rev.parent_ids)
-                if parent_ids.issubset(done):
-                    # can take this one now
-                    o.append(rev_id)
-                    todo.remove(rev_id)
-                    done.add(rev_id)
-        return o
-
-
-def write_a_weave(weave, filename):
-    inv_wf = file(filename, 'wb')
-    try:
-        write_weave(weave, inv_wf)
-    finally:
-        inv_wf.close()
-
-
-def upgrade(base_dir):
-    Convert(base_dir)
+        self.pb.note('making backup of tree history')
+        self.transport.copy_tree('.bzr', '.bzr.backup')
+        self.pb.note('%s.bzr has been backed up to %s.bzr.backup',
+             self.transport.base,
+             self.transport.base)
+        self.pb.note('if conversion fails, you can move this directory back to .bzr')
+        self.pb.note('if it succeeds, you can remove this directory if you wish')
+
+def upgrade(url, format=None):
+    """Upgrade to format, or the default bzrdir format if not supplied."""
+    Convert(url, format)

=== modified file 'bzrlib/util/configobj/configobj.py'
--- bzrlib/util/configobj/configobj.py	2005-11-07 13:17:53 +0000
+++ bzrlib/util/configobj/configobj.py	2006-03-20 08:31:00 +0000
@@ -5,9 +5,10 @@
 #         nico AT tekNico DOT net
 
 # ConfigObj 4
+# http://www.voidspace.org.uk/python/configobj.html
 
 # Released subject to the BSD License
-# Please see http://www.voidspace.org.uk/documents/BSD-LICENSE.txt
+# Please see http://www.voidspace.org.uk/python/license.shtml
 
 # Scripts maintained at http://www.voidspace.org.uk/python/index.shtml
 # For information about bugfixes, updates and support, please join the
@@ -15,6 +16,8 @@
 # http://lists.sourceforge.net/lists/listinfo/configobj-develop
 # Comments, suggestions and bug reports welcome.
 
+from __future__ import generators
+
 """
     >>> z = ConfigObj()
     >>> z['a'] = 'a'
@@ -37,19 +40,81 @@
 
 import os, re
 from types import StringTypes
-
-# the UTF8 BOM - from codecs module
-BOM_UTF8 = '\xef\xbb\xbf'
-
-__version__ = '4.0.0'
-
-__revision__ = '$Id: configobj.py 135 2005-10-12 14:52:28Z fuzzyman $'
+from warnings import warn
+from codecs import BOM_UTF8, BOM_UTF16, BOM_UTF16_BE, BOM_UTF16_LE
+
+# A dictionary mapping BOM to
+# the encoding to decode with, and what to set the
+# encoding attribute to.
+BOMS = {
+    BOM_UTF8: ('utf_8', None),
+    BOM_UTF16_BE: ('utf16_be', 'utf_16'),
+    BOM_UTF16_LE: ('utf16_le', 'utf_16'),
+    BOM_UTF16: ('utf_16', 'utf_16'),
+    }
+# All legal variants of the BOM codecs.
+# TODO: the list of aliases is not meant to be exhaustive, is there a
+#   better way ?
+BOM_LIST = {
+    'utf_16': 'utf_16',
+    'u16': 'utf_16',
+    'utf16': 'utf_16',
+    'utf-16': 'utf_16',
+    'utf16_be': 'utf16_be',
+    'utf_16_be': 'utf16_be',
+    'utf-16be': 'utf16_be',
+    'utf16_le': 'utf16_le',
+    'utf_16_le': 'utf16_le',
+    'utf-16le': 'utf16_le',
+    'utf_8': 'utf_8',
+    'u8': 'utf_8',
+    'utf': 'utf_8',
+    'utf8': 'utf_8',
+    'utf-8': 'utf_8',
+    }
+
+# Map of encodings to the BOM to write.
+BOM_SET = {
+    'utf_8': BOM_UTF8,
+    'utf_16': BOM_UTF16,
+    'utf16_be': BOM_UTF16_BE,
+    'utf16_le': BOM_UTF16_LE,
+    None: BOM_UTF8
+    }
+
+try:
+    from validate import VdtMissingValue
+except ImportError:
+    VdtMissingValue = None
+
+try:
+    enumerate
+except NameError:
+    def enumerate(obj):
+        """enumerate for Python 2.2."""
+        i = -1
+        for item in obj:
+            i += 1
+            yield i, item
+
+try:
+    True, False
+except NameError:
+    True, False = 1, 0
+
+
+__version__ = '4.2.0beta2'
+
+__revision__ = '$Id: configobj.py 156 2006-01-31 14:57:08Z fuzzyman $'
 
 __docformat__ = "restructuredtext en"
 
+# NOTE: Does it make sense to have the following in __all__ ?
+# NOTE: DEFAULT_INDENT_TYPE, NUM_INDENT_SPACES, MAX_INTERPOL_DEPTH
+# NOTE: If used as from configobj import...
+# NOTE: They are effectively read only
 __all__ = (
     '__version__',
-    'BOM_UTF8',
     'DEFAULT_INDENT_TYPE',
     'NUM_INDENT_SPACES',
     'MAX_INTERPOL_DEPTH',
@@ -65,6 +130,7 @@
     'MissingInterpolationOption',
     'RepeatSectionError',
     '__docformat__',
+    'flatten_errors',
 )
 
 DEFAULT_INDENT_TYPE = ' '
@@ -81,6 +147,8 @@
     'stringify': True,
     # option may be set to one of ('', ' ', '\t')
     'indent_type': None,
+    'encoding': None,
+    'default_encoding': None,
 }
 
 class ConfigObjError(SyntaxError):
@@ -196,10 +264,10 @@
 
     def __init__(self, parent, depth, main, indict=None, name=None):
         """
-        parent is the section above
-        depth is the depth level of this section
-        main is the main ConfigObj
-        indict is a dictionary to initialise the section with
+        * parent is the section above
+        * depth is the depth level of this section
+        * main is the main ConfigObj
+        * indict is a dictionary to initialise the section with
         """
         if indict is None:
             indict = {}
@@ -284,8 +352,6 @@
         """
         if not isinstance(key, StringTypes):
             raise ValueError, 'The key "%s" is not a string.' % key
-##        if self.depth is None:
-##            self.depth = 0
         # add the comment
         if not self.comments.has_key(key):
             self.comments[key] = []
@@ -346,10 +412,13 @@
             return default
 
     def update(self, indict):
-        """A version of update that uses our ``__setitem__``."""
+        """
+        A version of update that uses our ``__setitem__``.
+        """
         for entry in indict:
             self[entry] = indict[entry]
 
+
     def pop(self, key, *args):
         """ """
         val = dict.pop(self, key, *args)
@@ -456,6 +525,32 @@
             newdict[entry] = this_entry
         return newdict
 
+    def merge(self, indict):
+        """
+        A recursive update - useful for merging config files.
+        
+        >>> a = '''[section1]
+        ...     option1 = True
+        ...     [[subsection]]
+        ...     more_options = False
+        ...     # end of file'''.splitlines()
+        >>> b = '''# File is user.ini
+        ...     [section1]
+        ...     option1 = False
+        ...     # end of file'''.splitlines()
+        >>> c1 = ConfigObj(b)
+        >>> c2 = ConfigObj(a)
+        >>> c2.merge(c1)
+        >>> c2
+        {'section1': {'option1': 'False', 'subsection': {'more_options': 'False'}}}
+        """
+        for key, val in indict.items():
+            if (key in self and isinstance(self[key], dict) and
+                                isinstance(val, dict)):
+                self[key].merge(val)
+            else:   
+                self[key] = val
+
     def rename(self, oldkey, newkey):
         """
         Change a keyname to another, without changing position in sequence.
@@ -507,19 +602,49 @@
         return value when called on the whole subsection has to be discarded.
         
         See  the encode and decode methods for examples, including functions.
+        
+        .. caution::
+        
+            You can use ``walk`` to transform the names of members of a section
+            but you mustn't add or delete members.
+        
+        >>> config = '''[XXXXsection]
+        ... XXXXkey = XXXXvalue'''.splitlines()
+        >>> cfg = ConfigObj(config)
+        >>> cfg
+        {'XXXXsection': {'XXXXkey': 'XXXXvalue'}}
+        >>> def transform(section, key):
+        ...     val = section[key]
+        ...     newkey = key.replace('XXXX', 'CLIENT1')
+        ...     section.rename(key, newkey)
+        ...     if isinstance(val, (tuple, list, dict)):
+        ...         pass
+        ...     else:
+        ...         val = val.replace('XXXX', 'CLIENT1')
+        ...         section[newkey] = val
+        >>> cfg.walk(transform, call_on_sections=True)
+        {'CLIENT1section': {'CLIENT1key': None}}
+        >>> cfg
+        {'CLIENT1section': {'CLIENT1key': 'CLIENT1value'}}
         """
         out = {}
         # scalars first
-        for entry in self.scalars[:]:
+        for i in range(len(self.scalars)):
+            entry = self.scalars[i]
             try:
-                out[entry] = function(self, entry, **keywargs)
+                val = function(self, entry, **keywargs)
+                # bound again in case name has changed
+                entry = self.scalars[i]
+                out[entry] = val
             except Exception:
                 if raise_errors:
                     raise
                 else:
+                    entry = self.scalars[i]
                     out[entry] = False
         # then sections
-        for entry in self.sections[:]:
+        for i in range(len(self.sections)):
+            entry = self.sections[i]
             if call_on_sections:
                 try:
                     function(self, entry, **keywargs)
@@ -527,7 +652,10 @@
                     if raise_errors:
                         raise
                     else:
+                        entry = self.sections[i]
                         out[entry] = False
+                # bound again in case name has changed
+                entry = self.sections[i]
             # previous result is discarded
             out[entry] = self[entry].walk(
                 function,
@@ -602,6 +730,98 @@
             section[newkey] = newval
         self.walk(encode, call_on_sections=True)
 
+    def istrue(self, key):
+        """A deprecated version of ``as_bool``."""
+        warn('use of ``istrue`` is deprecated. Use ``as_bool`` method '
+                'instead.', DeprecationWarning)
+        return self.as_bool(key)
+
+    def as_bool(self, key):
+        """
+        Accepts a key as input. The corresponding value must be a string or
+        the objects (``True`` or 1) or (``False`` or 0). We allow 0 and 1 to
+        retain compatibility with Python 2.2.
+        
+        If the string is one of  ``True``, ``On``, ``Yes``, or ``1`` it returns 
+        ``True``.
+        
+        If the string is one of  ``False``, ``Off``, ``No``, or ``0`` it returns 
+        ``False``.
+        
+        ``as_bool`` is not case sensitive.
+        
+        Any other input will raise a ``ValueError``.
+        
+        >>> a = ConfigObj()
+        >>> a['a'] = 'fish'
+        >>> a.as_bool('a')
+        Traceback (most recent call last):
+        ValueError: Value "fish" is neither True nor False
+        >>> a['b'] = 'True'
+        >>> a.as_bool('b')
+        1
+        >>> a['b'] = 'off'
+        >>> a.as_bool('b')
+        0
+        """
+        val = self[key]
+        if val == True:
+            return True
+        elif val == False:
+            return False
+        else:
+            try:
+                if not isinstance(val, StringTypes):
+                    raise KeyError
+                else:
+                    return self.main._bools[val.lower()]
+            except KeyError:
+                raise ValueError('Value "%s" is neither True nor False' % val)
+
+    def as_int(self, key):
+        """
+        A convenience method which coerces the specified value to an integer.
+        
+        If the value is an invalid literal for ``int``, a ``ValueError`` will
+        be raised.
+        
+        >>> a = ConfigObj()
+        >>> a['a'] = 'fish'
+        >>> a.as_int('a')
+        Traceback (most recent call last):
+        ValueError: invalid literal for int(): fish
+        >>> a['b'] = '1'
+        >>> a.as_int('b')
+        1
+        >>> a['b'] = '3.2'
+        >>> a.as_int('b')
+        Traceback (most recent call last):
+        ValueError: invalid literal for int(): 3.2
+        """
+        return int(self[key])
+
+    def as_float(self, key):
+        """
+        A convenience method which coerces the specified value to a float.
+        
+        If the value is an invalid literal for ``float``, a ``ValueError`` will
+        be raised.
+        
+        >>> a = ConfigObj()
+        >>> a['a'] = 'fish'
+        >>> a.as_float('a')
+        Traceback (most recent call last):
+        ValueError: invalid literal for float(): fish
+        >>> a['b'] = '1'
+        >>> a.as_float('b')
+        1.0
+        >>> a['b'] = '3.2'
+        >>> a.as_float('b')
+        3.2000000000000002
+        """
+        return float(self[key])
+    
+
 class ConfigObj(Section):
     """
     An object to read, create, and write config files.
@@ -722,6 +942,14 @@
         '"""': (_single_line_double, _multi_line_double),
     }
 
+    # Used by the ``istrue`` Section method
+    _bools = {
+        'yes': True, 'no': False,
+        'on': True, 'off': False,
+        '1': True, '0': False,
+        'true': True, 'false': False,
+        }
+
     def __init__(self, infile=None, options=None, **kwargs):
         """
         Parse or create a config file object.
@@ -741,11 +969,13 @@
         for entry in options.keys():
             if entry not in defaults.keys():
                 raise TypeError, 'Unrecognised option "%s".' % entry
-        # TODO: check the values too
-        # add the explicit options to the defaults
+        # TODO: check the values too.
+        #
+        # Add any explicit options to the defaults
         defaults.update(options)
         #
         # initialise a few variables
+        self.filename = None
         self._errors = []
         self.raise_errors = defaults['raise_errors']
         self.interpolation = defaults['interpolation']
@@ -754,16 +984,18 @@
         self.file_error = defaults['file_error']
         self.stringify = defaults['stringify']
         self.indent_type = defaults['indent_type']
-        # used by the write method
-        self.BOM = None
+        self.encoding = defaults['encoding']
+        self.default_encoding = defaults['default_encoding']
+        self.BOM = False
+        self.newlines = None
         #
         self.initial_comment = []
         self.final_comment = []
         #
         if isinstance(infile, StringTypes):
-            self.filename = os.path.abspath(infile)
-            if os.path.isfile(self.filename):
-                infile = open(self.filename).readlines()
+            self.filename = infile
+            if os.path.isfile(infile):
+                infile = open(infile).read() or []
             elif self.file_error:
                 # raise an error if the file doesn't exist
                 raise IOError, 'Config file not found: "%s".' % self.filename
@@ -772,12 +1004,12 @@
                 if self.create_empty:
                     # this is a good test that the filename specified
                     # isn't impossible - like on a non existent device
-                    h = open(self.filename)
+                    h = open(infile, 'w')
                     h.write('')
                     h.close()
                 infile = []
         elif isinstance(infile, (list, tuple)):
-            self.filename = None
+            infile = list(infile)
         elif isinstance(infile, dict):
             # initialise self
             # the Section class handles creating subsections
@@ -786,33 +1018,37 @@
                 infile = infile.dict()
             for entry in infile:
                 self[entry] = infile[entry]
-            self.filename = None
             del self._errors
             if defaults['configspec'] is not None:
                 self._handle_configspec(defaults['configspec'])
             else:
                 self.configspec = None
             return
-        elif hasattr(infile, 'seek'):
-            # this supports StringIO instances and even file objects
-            self.filename = infile
-            infile.seek(0)
-            infile = infile.readlines()
-            self.filename.seek(0)
+        elif hasattr(infile, 'read'):
+            # This supports file like objects
+            infile = infile.read() or []
+            # needs splitting into lines - but needs doing *after* decoding
+            # in case it's not an 8 bit encoding
         else:
             raise TypeError, ('infile must be a filename,'
-                ' StringIO instance, or a file as a list.')
-        #
-        # strip trailing '\n' from lines
-        infile = [line.rstrip('\n') for line in infile]
-        #
-        # remove the UTF8 BOM if it is there
-        # FIXME: support other BOM
-        if infile and infile[0].startswith(BOM_UTF8):
-            infile[0] = infile[0][3:]
-            self.BOM = BOM_UTF8
-        else:
-            self.BOM = None
+                ' file like object, or list of lines.')
+        #
+        if infile:
+            # don't do it for the empty ConfigObj
+            infile = self._handle_bom(infile)
+            # infile is now *always* a list
+            #
+            # Set the newlines attribute (first line ending it finds)
+            # and strip trailing '\n' or '\r' from lines
+            for line in infile:
+                if (not line) or (line[-1] not in '\r\n'):
+                    continue
+                for end in ('\r\n', '\n', '\r'):
+                    if line.endswith(end):
+                        self.newlines = end
+                        break
+                break
+            infile = [line.rstrip('\r\n') for line in infile]
         #
         self._parse(infile)
         # if we had any errors, now is the time to raise them
@@ -832,6 +1068,150 @@
         else:
             self._handle_configspec(defaults['configspec'])
 
+    def _handle_bom(self, infile):
+        """
+        Handle any BOM, and decode if necessary.
+        
+        If an encoding is specified, that *must* be used - but the BOM should
+        still be removed (and the BOM attribute set).
+        
+        (If the encoding is wrongly specified, then a BOM for an alternative
+        encoding won't be discovered or removed.)
+        
+        If an encoding is not specified, UTF8 or UTF16 BOM will be detected and
+        removed. The BOM attribute will be set. UTF16 will be decoded to
+        unicode.
+        
+        NOTE: This method must not be called with an empty ``infile``.
+        
+        Specifying the *wrong* encoding is likely to cause a
+        ``UnicodeDecodeError``.
+        
+        ``infile`` must always be returned as a list of lines, but may be
+        passed in as a single string.
+        """
+        if ((self.encoding is not None) and
+            (self.encoding.lower() not in BOM_LIST)):
+            # No need to check for a BOM
+            # encoding specified doesn't have one
+            # just decode
+            return self._decode(infile, self.encoding)
+        #
+        if isinstance(infile, (list, tuple)):
+            line = infile[0]
+        else:
+            line = infile
+        if self.encoding is not None:
+            # encoding explicitly supplied
+            # And it could have an associated BOM
+            # TODO: if encoding is just UTF16 - we ought to check for both
+            # TODO: big endian and little endian versions.
+            enc = BOM_LIST[self.encoding.lower()]
+            if enc == 'utf_16':
+                # For UTF16 we try big endian and little endian
+                for BOM, (encoding, final_encoding) in BOMS.items():
+                    if not final_encoding:
+                        # skip UTF8
+                        continue
+                    if infile.startswith(BOM):
+                        ### BOM discovered
+                        ##self.BOM = True
+                        # Don't need to remove BOM
+                        return self._decode(infile, encoding)
+                #
+                # If we get this far, will *probably* raise a DecodeError
+                # As it doesn't appear to start with a BOM
+                return self._decode(infile, self.encoding)
+            #
+            # Must be UTF8
+            BOM = BOM_SET[enc]
+            if not line.startswith(BOM):
+                return self._decode(infile, self.encoding)
+            #
+            newline = line[len(BOM):]
+            #
+            # BOM removed
+            if isinstance(infile, (list, tuple)):
+                infile[0] = newline
+            else:
+                infile = newline
+            self.BOM = True
+            return self._decode(infile, self.encoding)
+        #
+        # No encoding specified - so we need to check for UTF8/UTF16
+        for BOM, (encoding, final_encoding) in BOMS.items():
+            if not line.startswith(BOM):
+                continue
+            else:
+                # BOM discovered
+                self.encoding = final_encoding
+                if not final_encoding:
+                    self.BOM = True
+                    # UTF8
+                    # remove BOM
+                    newline = line[len(BOM):]
+                    if isinstance(infile, (list, tuple)):
+                        infile[0] = newline
+                    else:
+                        infile = newline
+                    # UTF8 - don't decode
+                    if isinstance(infile, StringTypes):
+                        return infile.splitlines(True)
+                    else:
+                        return infile
+                # UTF16 - have to decode
+                return self._decode(infile, encoding)
+        #
+        # No BOM discovered and no encoding specified, just return
+        if isinstance(infile, StringTypes):
+            # infile read from a file will be a single string
+            return infile.splitlines(True)
+        else:
+            return infile
+
+    def _a_to_u(self, string):
+        """Decode ascii strings to unicode if a self.encoding is specified."""
+        if not self.encoding:
+            return string
+        else:
+            return string.decode('ascii')
+
+    def _decode(self, infile, encoding):
+        """
+        Decode infile to unicode. Using the specified encoding.
+        
+        if is a string, it also needs converting to a list.
+        """
+        if isinstance(infile, StringTypes):
+            # can't be unicode
+            # NOTE: Could raise a ``UnicodeDecodeError``
+            return infile.decode(encoding).splitlines(True)
+        for i, line in enumerate(infile):
+            if not isinstance(line, unicode):
+                # NOTE: The isinstance test here handles mixed lists of unicode/string
+                # NOTE: But the decode will break on any non-string values
+                # NOTE: Or could raise a ``UnicodeDecodeError``
+                infile[i] = line.decode(encoding)
+        return infile
+
+    def _decode_element(self, line):
+        """Decode element to unicode if necessary."""
+        if not self.encoding:
+            return line
+        if isinstance(line, str) and self.default_encoding:
+            return line.decode(self.default_encoding)
+        return line
+
+    def _str(self, value):
+        """
+        Used by ``stringify`` within validate, to turn non-string values
+        into strings.
+        """
+        if not isinstance(value, StringTypes):
+            return str(value)
+        else:
+            return value
+
     def _parse(self, infile):
         """
         Actually parse the config file
@@ -1040,7 +1420,10 @@
             # no indentation used, set the type accordingly
             self.indent_type = ''
         # preserve the final comment
-        self.final_comment = comment_list
+        if not self and not self.initial_comment:
+            self.initial_comment = comment_list
+        else:
+            self.final_comment = comment_list
 
     def _match_depth(self, sect, depth):
         """
@@ -1095,13 +1478,16 @@
         Recursively quote members of a list and return a comma joined list.
         Multiline is ``False`` for lists.
         Obey list syntax for empty and single member lists.
+        
+        If ``list_values=False`` then the value is only quoted if it contains
+        a ``\n`` (is multiline).
         """
         if isinstance(value, (list, tuple)):
             if not value:
                 return ','
             elif len(value) == 1:
                 return self._quote(value[0], multiline=False) + ','
-            return ','.join([self._quote(val, multiline=False)
+            return ', '.join([self._quote(val, multiline=False)
                 for val in value])
         if not isinstance(value, StringTypes):
             if self.stringify:
@@ -1116,13 +1502,17 @@
         tdquot = "'''%s'''"
         if not value:
             return '""'
-        if not (multiline and
+        if (not self.list_values and '\n' not in value) or not (multiline and
                 ((("'" in value) and ('"' in value)) or ('\n' in value))):
+            if not self.list_values:
+                # we don't quote if ``list_values=False``
+                quot = noquot
             # for normal values either single or double quotes will do
-            if '\n' in value:
+            elif '\n' in value:
+                # will only happen if multiline is off - e.g. '\n' in key
                 raise ConfigObjError, ('Value "%s" cannot be safely quoted.' %
                     value)
-            if ((value[0] not in wspace_plus) and
+            elif ((value[0] not in wspace_plus) and
                     (value[-1] not in wspace_plus) and
                     (',' not in value)):
                 quot = noquot
@@ -1244,8 +1634,8 @@
             if mat is None:
                 raise SyntaxError
             (value, comment) = mat.groups()
-            # FIXME: unquoting here can be a source of error
-            return (self._unquote(value), comment)
+            # NOTE: we don't unquote here
+            return (value, comment)
         mat = self._valueexp.match(value)
         if mat is None:
             # the value is badly constructed, probably badly quoted,
@@ -1392,20 +1782,22 @@
 
     def _write_line(self, indent_string, entry, this_entry, comment):
         """Write an individual line, for the write method"""
-        return '%s%s = %s%s' % (
+        # NOTE: the calls to self._quote here handles non-StringType values.
+        return '%s%s%s%s%s' % (
             indent_string,
-            self._quote(entry, multiline=False),
-            self._quote(this_entry),
-            comment)
+            self._decode_element(self._quote(entry, multiline=False)),
+            self._a_to_u(' = '),
+            self._decode_element(self._quote(this_entry)),
+            self._decode_element(comment))
 
     def _write_marker(self, indent_string, depth, entry, comment):
         """Write a section marker line"""
         return '%s%s%s%s%s' % (
             indent_string,
-            '[' * depth,
-            self._quote(entry, multiline=False),
-            ']' * depth,
-            comment)
+            self._a_to_u('[' * depth),
+            self._quote(self._decode_element(entry), multiline=False),
+            self._a_to_u(']' * depth),
+            self._decode_element(comment))
 
     def _handle_comment(self, comment):
         """
@@ -1437,11 +1829,11 @@
         if not comment:
             return ''
         if self.indent_type == '\t':
-            start = '\t'
+            start = self._a_to_u('\t')
         else:
-            start = ' ' * NUM_INDENT_SPACES
+            start = self._a_to_u(' ' * NUM_INDENT_SPACES)
         if not comment.startswith('#'):
-            start += '# '
+            start += _a_to_u('# ')
         return (start + comment)
 
     def _compute_indent_string(self, depth):
@@ -1459,7 +1851,7 @@
 
     # Public methods
 
-    def write(self, section=None):
+    def write(self, outfile=None, section=None):
         """
         Write the current ConfigObj as a file
         
@@ -1488,33 +1880,34 @@
         >>> a.write()
         ['a = %(a)s', '[DEFAULT]', 'a = fish']
         """
-        int_val = 'test'
         if self.indent_type is None:
             # this can be true if initialised from a dictionary
             self.indent_type = DEFAULT_INDENT_TYPE
         #
         out = []
-        return_list = True
+        cs = self._a_to_u('#')
+        csp = self._a_to_u('# ')
         if section is None:
             int_val = self.interpolation
             self.interpolation = False
             section = self
-            return_list = False
             for line in self.initial_comment:
+                line = self._decode_element(line)
                 stripped_line = line.strip()
-                if stripped_line and not stripped_line.startswith('#'):
-                    line = '# ' + line
+                if stripped_line and not stripped_line.startswith(cs):
+                    line = csp + line
                 out.append(line)
         #
-        indent_string = self._compute_indent_string(section.depth)
+        indent_string = self._a_to_u(
+            self._compute_indent_string(section.depth))
         for entry in (section.scalars + section.sections):
             if entry in section.defaults:
                 # don't write out default values
                 continue
             for comment_line in section.comments[entry]:
-                comment_line = comment_line.lstrip()
-                if comment_line and not comment_line.startswith('#'):
-                    comment_line = '#' + comment_line
+                comment_line = self._decode_element(comment_line.lstrip())
+                if comment_line and not comment_line.startswith(cs):
+                    comment_line = csp + comment_line
                 out.append(indent_string + comment_line)
             this_entry = section[entry]
             comment = self._handle_comment(section.inline_comments[entry])
@@ -1526,7 +1919,7 @@
                     this_entry.depth,
                     entry,
                     comment))
-                out.extend(self.write(this_entry))
+                out.extend(self.write(section=this_entry))
             else:
                 out.append(self._write_line(
                     indent_string,
@@ -1534,32 +1927,49 @@
                     this_entry,
                     comment))
         #
-        if not return_list:
+        if section is self:
             for line in self.final_comment:
+                line = self._decode_element(line)
                 stripped_line = line.strip()
-                if stripped_line and not stripped_line.startswith('#'):
-                    line = '# ' + line
+                if stripped_line and not stripped_line.startswith(cs):
+                    line = csp + line
                 out.append(line)
-        #
-        if int_val != 'test':
             self.interpolation = int_val
         #
-        if (return_list) or (self.filename is None):
-            return out
-        #
-        if isinstance(self.filename, StringTypes):
+        if section is not self:
+            return out
+        #
+        if (self.filename is None) and (outfile is None):
+            # output a list of lines
+            # might need to encode
+            # NOTE: This will *screw* UTF16, each line will start with the BOM
+            if self.encoding:
+                out = [l.encode(self.encoding) for l in out]
+            if (self.BOM and ((self.encoding is None) or
+                (BOM_LIST.get(self.encoding.lower()) == 'utf_8'))):
+                # Add the UTF8 BOM
+                if not out:
+                    out.append('')
+                out[0] = BOM_UTF8 + out[0]
+            return out
+        #
+        # Turn the list to a string, joined with correct newlines
+        output = (self._a_to_u(self.newlines or os.linesep)
+            ).join(out)
+        if self.encoding:
+            output = output.encode(self.encoding)
+        if (self.BOM and ((self.encoding is None) or
+            (BOM_LIST.get(self.encoding.lower()) == 'utf_8'))):
+            # Add the UTF8 BOM
+            output = BOM_UTF8 + output
+        if outfile is not None:
+            outfile.write(output)
+        else:
             h = open(self.filename, 'w')
-            h.write(self.BOM or '')
-            h.write('\n'.join(out))
+            h.write(output)
             h.close()
-        else:
-            self.filename.seek(0)
-            self.filename.write(self.BOM or '')
-            self.filename.write('\n'.join(out))
-            # if we have a stored file object (or StringIO)
-            # we *don't* close it
 
-    def validate(self, validator, section=None):
+    def validate(self, validator, preserve_errors=False, section=None):
         """
         Test the ConfigObj against a configspec.
         
@@ -1581,10 +1991,23 @@
         In addition, it converts the values from strings to their native
         types if their checks pass (and ``stringify`` is set).
         
+        If ``preserve_errors`` is ``True`` (``False`` is default) then instead
+        of a marking a fail with a ``False``, it will preserve the actual
+        exception object. This can contain info about the reason for failure.
+        For example the ``VdtValueTooSmallError`` indeicates that the value
+        supplied was too small. If a value (or section) is missing it will
+        still be marked as ``False``.
+        
+        You must have the validate module to use ``preserve_errors=True``.
+        
+        You can then use the ``flatten_errors`` function to turn your nested
+        results dictionary into a flattened list of failures - useful for
+        displaying meaningful error messages.
+        
         >>> try:
         ...     from validate import Validator
         ... except ImportError:
-        ...     print >> sys.stderr, 'Cannot import the Validator object, skipping the realted tests'
+        ...     print >> sys.stderr, 'Cannot import the Validator object, skipping the related tests'
         ... else:
         ...     config = '''
         ...     test1=40
@@ -1603,20 +2026,20 @@
         ...             test4=5.0
         ... '''.split('\\n')
         ...     configspec = '''
-        ...     test1='integer(30,50)'
-        ...     test2='string'
-        ...     test3='integer'
-        ...     test4='float(6.0)'
+        ...     test1= integer(30,50)
+        ...     test2= string
+        ...     test3=integer
+        ...     test4=float(6.0)
         ...     [section ]
-        ...         test1='integer(30,50)'
-        ...         test2='string'
-        ...         test3='integer'
-        ...         test4='float(6.0)'
+        ...         test1=integer(30,50)
+        ...         test2=string
+        ...         test3=integer
+        ...         test4=float(6.0)
         ...         [[sub section]]
-        ...             test1='integer(30,50)'
-        ...             test2='string'
-        ...             test3='integer'
-        ...             test4='float(6.0)'
+        ...             test1=integer(30,50)
+        ...             test2=string
+        ...             test3=integer
+        ...             test4=float(6.0)
         ...     '''.split('\\n')
         ...     val = Validator()
         ...     c1 = ConfigObj(config, configspec=configspec)
@@ -1670,20 +2093,20 @@
         >>> val_res == {'key2': True, 'section': True, 'key': False}
         1
         >>> configspec = '''
-        ...     test1='integer(30,50, default=40)'
-        ...     test2='string(default="hello")'
-        ...     test3='integer(default=3)'
-        ...     test4='float(6.0, default=6.0)'
+        ...     test1=integer(30,50, default=40)
+        ...     test2=string(default="hello")
+        ...     test3=integer(default=3)
+        ...     test4=float(6.0, default=6.0)
         ...     [section ]
-        ...         test1='integer(30,50, default=40)'
-        ...         test2='string(default="hello")'
-        ...         test3='integer(default=3)'
-        ...         test4='float(6.0, default=6.0)'
+        ...         test1=integer(30,50, default=40)
+        ...         test2=string(default="hello")
+        ...         test3=integer(default=3)
+        ...         test4=float(6.0, default=6.0)
         ...         [[sub section]]
-        ...             test1='integer(30,50, default=40)'
-        ...             test2='string(default="hello")'
-        ...             test3='integer(default=3)'
-        ...             test4='float(6.0, default=6.0)'
+        ...             test1=integer(30,50, default=40)
+        ...             test2=string(default="hello")
+        ...             test3=integer(default=3)
+        ...             test4=float(6.0, default=6.0)
         ...     '''.split('\\n')
         >>> default_test = ConfigObj(['test1=30'], configspec=configspec)
         >>> default_test
@@ -1926,6 +2349,7 @@
         1
         
         Test that interpolation is preserved for validated string values.
+        Also check that interpolation works in configspecs.
         >>> t = ConfigObj()
         >>> t['DEFAULT'] = {}
         >>> t['DEFAULT']['test'] = 'a'
@@ -1939,6 +2363,16 @@
         >>> t.interpolation = False
         >>> t
         {'test': '%(test)s', 'DEFAULT': {'test': 'a'}}
+        >>> specs = [
+        ...    'interpolated string  = string(default="fuzzy-%(man)s")',
+        ...    '[DEFAULT]',
+        ...    'man = wuzzy',
+        ...    ]
+        >>> c = ConfigObj(configspec=specs)
+        >>> c.validate(v)
+        1
+        >>> c['interpolated string']
+        'fuzzy-wuzzy'
         
         FIXME: Above tests will fail if we couldn't import Validator (the ones
         that don't raise errors will produce different output and still fail as
@@ -1947,6 +2381,9 @@
         if section is None:
             if self.configspec is None:
                 raise ValueError, 'No configspec supplied.'
+            if preserve_errors:
+                if VdtMissingValue is None:
+                    raise ImportError('Missing validate module.')
             section = self
         #
         spec_section = section.configspec
@@ -1974,13 +2411,16 @@
             try:
                 check = validator.check(spec_section[entry],
                                         val,
-                                        missing=missing)
-            except validator.baseErrorClass:
-                out[entry] = False
+                                        missing=missing
+                                        )
+            except validator.baseErrorClass, e:
+                if not preserve_errors or isinstance(e, VdtMissingValue):
+                    out[entry] = False
+                else:
+                    # preserve the error
+                    out[entry] = e
+                    ret_false = False
                 ret_true = False
-            # MIKE: we want to raise all other exceptions, not just print ?
-##            except Exception, err:
-##                print err
             else:
                 ret_false = False
                 out[entry] = True
@@ -1990,19 +2430,23 @@
                     if not self.stringify:
                         if isinstance(check, (list, tuple)):
                             # preserve lists
-                            check = [str(item) for item in check]
+                            check = [self._str(item) for item in check]
                         elif missing and check is None:
                             # convert the None from a default to a ''
                             check = ''
                         else:
-                            check = str(check)
+                            check = self._str(check)
                     if (check != val) or missing:
                         section[entry] = check
                 if missing and entry not in section.defaults:
                     section.defaults.append(entry)
         #
+        # FIXME: Will this miss missing sections ?
         for entry in section.sections:
-            check = self.validate(validator, section[entry])
+            if section is self and entry == 'DEFAULT':
+                continue
+            check = self.validate(validator, preserve_errors=preserve_errors,
+                section=section[entry])
             out[entry] = check
             if check == False:
                 ret_true = False
@@ -2080,6 +2524,131 @@
             raise self.baseErrorClass
         return member
 
+# Check / processing functions for options
+def flatten_errors(cfg, res, levels=None, results=None):
+    """
+    An example function that will turn a nested dictionary of results
+    (as returned by ``ConfigObj.validate``) into a flat list.
+    
+    ``cfg`` is the ConfigObj instance being checked, ``res`` is the results
+    dictionary returned by ``validate``.
+    
+    (This is a recursive function, so you shouldn't use the ``levels`` or
+    ``results`` arguments - they are used by the function.
+    
+    Returns a list of keys that failed. Each member of the list is a tuple :
+    ::
+    
+        ([list of sections...], key, result)
+    
+    If ``validate`` was called with ``preserve_errors=False`` (the default)
+    then ``result`` will always be ``False``.
+
+    *list of sections* is a flattened list of sections that the key was found
+    in.
+    
+    If the section was missing then key will be ``None``.
+    
+    If the value (or section) was missing then ``result`` will be ``False``.
+    
+    If ``validate`` was called with ``preserve_errors=True`` and a value
+    was present, but failed the check, then ``result`` will be the exception
+    object returned. You can use this as a string that describes the failure.
+    
+    For example *The value "3" is of the wrong type*.
+    
+    # FIXME: is the ordering of the output arbitrary ?
+    >>> import validate
+    >>> vtor = validate.Validator()
+    >>> my_ini = '''
+    ...     option1 = True
+    ...     [section1]
+    ...     option1 = True
+    ...     [section2]
+    ...     another_option = Probably
+    ...     [section3]
+    ...     another_option = True
+    ...     [[section3b]]
+    ...     value = 3
+    ...     value2 = a
+    ...     value3 = 11
+    ...     '''
+    >>> my_cfg = '''
+    ...     option1 = boolean()
+    ...     option2 = boolean()
+    ...     option3 = boolean(default=Bad_value)
+    ...     [section1]
+    ...     option1 = boolean()
+    ...     option2 = boolean()
+    ...     option3 = boolean(default=Bad_value)
+    ...     [section2]
+    ...     another_option = boolean()
+    ...     [section3]
+    ...     another_option = boolean()
+    ...     [[section3b]]
+    ...     value = integer
+    ...     value2 = integer
+    ...     value3 = integer(0, 10)
+    ...         [[[section3b-sub]]]
+    ...         value = string
+    ...     [section4]
+    ...     another_option = boolean()
+    ...     '''
+    >>> cs = my_cfg.split('\\n')
+    >>> ini = my_ini.split('\\n')
+    >>> cfg = ConfigObj(ini, configspec=cs)
+    >>> res = cfg.validate(vtor, preserve_errors=True)
+    >>> errors = []
+    >>> for entry in flatten_errors(cfg, res):
+    ...     section_list, key, error = entry
+    ...     section_list.insert(0, '[root]')
+    ...     if key is not None:
+    ...        section_list.append(key)
+    ...     else:
+    ...         section_list.append('[missing]')
+    ...     section_string = ', '.join(section_list)
+    ...     errors.append((section_string, ' = ', error))
+    >>> errors.sort()
+    >>> for entry in errors:
+    ...     print entry[0], entry[1], (entry[2] or 0)
+    [root], option2  =  0
+    [root], option3  =  the value "Bad_value" is of the wrong type.
+    [root], section1, option2  =  0
+    [root], section1, option3  =  the value "Bad_value" is of the wrong type.
+    [root], section2, another_option  =  the value "Probably" is of the wrong type.
+    [root], section3, section3b, section3b-sub, [missing]  =  0
+    [root], section3, section3b, value2  =  the value "a" is of the wrong type.
+    [root], section3, section3b, value3  =  the value "11" is too big.
+    [root], section4, [missing]  =  0
+    """
+    if levels is None:
+        # first time called
+        levels = []
+        results = []
+    if res is True:
+        return results
+    if res is False:
+        results.append((levels[:], None, False))
+        if levels:
+            levels.pop()
+        return results
+    for (key, val) in res.items():
+        if val == True:
+            continue
+        if isinstance(cfg.get(key), dict):
+            # Go down one level
+            levels.append(key)
+            flatten_errors(cfg[key], val, levels, results)
+            continue
+        results.append((levels[:], key, val))
+    #
+    # Go up one level
+    if levels:
+        levels.pop()
+    #
+    return results
+
+
 # FIXME: test error code for badly built multiline values
 # FIXME: test handling of StringIO
 # FIXME: test interpolation with writing
@@ -2146,6 +2715,147 @@
     >>> t2.inline_comments['b'] = ''
     >>> del t2['a']
     >>> assert t2.write() == ['','b = b', '']
+    
+    # Test ``list_values=False`` stuff
+    >>> c = '''
+    ...     key1 = no quotes
+    ...     key2 = 'single quotes'
+    ...     key3 = "double quotes"
+    ...     key4 = "list", 'with', several, "quotes"
+    ...     '''
+    >>> cfg = ConfigObj(c.splitlines(), list_values=False)
+    >>> cfg == {'key1': 'no quotes', 'key2': "'single quotes'", 
+    ... 'key3': '"double quotes"', 
+    ... 'key4': '"list", \\'with\\', several, "quotes"'
+    ... }
+    1
+    >>> cfg = ConfigObj(list_values=False)
+    >>> cfg['key1'] = 'Multiline\\nValue'
+    >>> cfg['key2'] = '''"Value" with 'quotes' !'''
+    >>> cfg.write()
+    ["key1 = '''Multiline\\nValue'''", 'key2 = "Value" with \\'quotes\\' !']
+    >>> cfg.list_values = True
+    >>> cfg.write() == ["key1 = '''Multiline\\nValue'''",
+    ... 'key2 = \\'\\'\\'"Value" with \\'quotes\\' !\\'\\'\\'']
+    1
+    
+    Test flatten_errors:
+    
+    >>> from validate import Validator, VdtValueTooSmallError
+    >>> config = '''
+    ...     test1=40
+    ...     test2=hello
+    ...     test3=3
+    ...     test4=5.0
+    ...     [section]
+    ...         test1=40
+    ...         test2=hello
+    ...         test3=3
+    ...         test4=5.0
+    ...         [[sub section]]
+    ...             test1=40
+    ...             test2=hello
+    ...             test3=3
+    ...             test4=5.0
+    ... '''.split('\\n')
+    >>> configspec = '''
+    ...     test1= integer(30,50)
+    ...     test2= string
+    ...     test3=integer
+    ...     test4=float(6.0)
+    ...     [section ]
+    ...         test1=integer(30,50)
+    ...         test2=string
+    ...         test3=integer
+    ...         test4=float(6.0)
+    ...         [[sub section]]
+    ...             test1=integer(30,50)
+    ...             test2=string
+    ...             test3=integer
+    ...             test4=float(6.0)
+    ...     '''.split('\\n')
+    >>> val = Validator()
+    >>> c1 = ConfigObj(config, configspec=configspec)
+    >>> res = c1.validate(val)
+    >>> flatten_errors(c1, res) == [([], 'test4', False), (['section', 
+    ...     'sub section'], 'test4', False), (['section'], 'test4', False)]
+    True
+    >>> res = c1.validate(val, preserve_errors=True)
+    >>> check = flatten_errors(c1, res)
+    >>> check[0][:2]
+    ([], 'test4')
+    >>> check[1][:2]
+    (['section', 'sub section'], 'test4')
+    >>> check[2][:2]
+    (['section'], 'test4')
+    >>> for entry in check:
+    ...     isinstance(entry[2], VdtValueTooSmallError)
+    ...     print str(entry[2])
+    True
+    the value "5.0" is too small.
+    True
+    the value "5.0" is too small.
+    True
+    the value "5.0" is too small.
+    
+    Test unicode handling, BOM, write witha file like object and line endings :
+    >>> u_base = '''
+    ... # initial comment
+    ...     # inital comment 2
+    ... 
+    ... test1 = some value
+    ... # comment
+    ... test2 = another value    # inline comment
+    ... # section comment
+    ... [section]    # inline comment
+    ...     test = test    # another inline comment
+    ...     test2 = test2
+    ... 
+    ... # final comment
+    ... # final comment2
+    ... '''
+    >>> u = u_base.encode('utf_8').splitlines(True)
+    >>> u[0] = BOM_UTF8 + u[0]
+    >>> uc = ConfigObj(u)
+    >>> uc.encoding = None
+    >>> uc.BOM == True
+    1
+    >>> uc == {'test1': 'some value', 'test2': 'another value',
+    ... 'section': {'test': 'test', 'test2': 'test2'}}
+    1
+    >>> uc = ConfigObj(u, encoding='utf_8', default_encoding='latin-1')
+    >>> uc.BOM
+    1
+    >>> isinstance(uc['test1'], unicode)
+    1
+    >>> uc.encoding
+    'utf_8'
+    >>> uc.newlines
+    '\\n'
+    >>> uc['latin1'] = "This costs lot's of "
+    >>> a_list = uc.write()
+    >>> len(a_list)
+    15
+    >>> isinstance(a_list[0], str)
+    1
+    >>> a_list[0].startswith(BOM_UTF8)
+    1
+    >>> u = u_base.replace('\\n', '\\r\\n').encode('utf_8').splitlines(True)
+    >>> uc = ConfigObj(u)
+    >>> uc.newlines
+    '\\r\\n'
+    >>> uc.newlines = '\\r'
+    >>> from cStringIO import StringIO
+    >>> file_like = StringIO()
+    >>> uc.write(file_like)
+    >>> file_like.seek(0)
+    >>> uc2 = ConfigObj(file_like)
+    >>> uc2 == uc
+    1
+    >>> uc2.filename == None
+    1
+    >>> uc2.newlines == '\\r'
+    1
     """
 
 if __name__ == '__main__':
@@ -2235,16 +2945,35 @@
     BUGS
     ====
     
-    With list values off, ConfigObj can incorrectly unquote values. (This makes
-    it impossible to use listquote to handle your list values for you - for
-    nested lists. Not handling quotes at all would be better for this)
+    None known.
     
     TODO
     ====
     
+    Better support for configuration from multiple files, including tracking
+    *where* the original file came from and writing changes to the correct
+    file.
+    
+    
+    Make ``newline`` an option (as well as an attribute) ?
+    
+    ``UTF16`` encoded files, when returned as a list of lines, will have the
+    BOM at the start of every line. Should this be removed from all but the
+    first line ?
+    
+    Option to set warning type for unicode decode ? (Defaults to strict).
+    
     A method to optionally remove uniform indentation from multiline values.
     (do as an example of using ``walk`` - along with string-escape)
     
+    Should the results dictionary from validate be an ordered dictionary if
+    `odict <http://www.voidspace.org.uk/python/odict.html>`_ is available ?
+    
+    Implement a better ``__repr__`` ? (``ConfigObj({})``)
+    
+    Implement some of the sequence methods (which include slicing) from the
+    newer ``odict`` ?
+    
     INCOMPATIBLE CHANGES
     ====================
     
@@ -2304,9 +3033,15 @@
     ISSUES
     ======
     
+    ``validate`` doesn't report *extra* values or sections.
+    
     You can't have a keyword with the same name as a section (in the same
     section). They are both dictionary keys - so they would overlap.
     
+    ConfigObj doesn't quote and unquote values if ``list_values=False``.
+    This means that leading or trailing whitespace in values will be lost when
+    writing. (Unless you manually quote).
+    
     Interpolation checks first the 'DEFAULT' subsection of the current
     section, next it checks the 'DEFAULT' section of the parent section,
     last it checks the 'DEFAULT' section of the main section.
@@ -2325,13 +3060,6 @@
     Does it matter that we don't support the ':' divider, which is supported
     by ``ConfigParser`` ?
     
-    Following error with "list_values=False" : ::
-    
-        >>> a = ["a='hello', 'goodbye'"]
-        >>>
-        >>> c(a, list_values=False)
-        {'a': "hello', 'goodbye"}
-    
     The regular expression correctly removes the value -
     ``"'hello', 'goodbye'"`` and then unquote just removes the front and
     back quotes (called from ``_handle_value``). What should we do ??
@@ -2345,6 +3073,7 @@
     If the value is unchanged by validation (it's a string) - but other types
     will be.
     
+    
     List Value Syntax
     =================
     
@@ -2375,11 +3104,99 @@
     CHANGELOG
     =========
     
+    2006/02/04
+    ----------
+    
+    Removed ``BOM_UTF8`` from ``__all__``.
+    
+    The ``BOM`` attribute has become a boolean. (Defaults to ``False``.) It is
+    *only* ``True`` for the ``UTF16`` encoding.
+    
+    File like objects no longer need a ``seek`` attribute.
+    
+    ConfigObj no longer keeps a reference to file like objects. Instead the
+    ``write`` method takes a file like object as an optional argument. (Which
+    will be used in preference of the ``filename`` attribute if htat exists as
+    well.)
+    
+    Full unicode support added. New options/attributes ``encoding``,
+    ``default_encoding``.
+    
+    utf16 files decoded to unicode.
+    
+    If ``BOM`` is ``True``, but no encoding specified, then the utf8 BOM is
+    written out at the start of the file. (It will normally only be ``True`` if
+    the utf8 BOM was found when the file was read.)
+    
+    File paths are *not* converted to absolute paths, relative paths will
+    remain relative as the ``filename`` attribute.
+    
+    Fixed bug where ``final_comment`` wasn't returned if ``write`` is returning
+    a list of lines.
+    
+    2006/01/31
+    ----------
+    
+    Added ``True``, ``False``, and ``enumerate`` if they are not defined.
+    (``True`` and ``False`` are needed for *early* versions of Python 2.2,
+    ``enumerate`` is needed for all versions ofPython 2.2)
+    
+    Deprecated ``istrue``, replaced it with ``as_bool``.
+    
+    Added ``as_int`` and ``as_float``.
+    
+    utf8 and utf16 BOM handled in an endian agnostic way.
+    
+    2005/12/14
+    ----------
+    
+    Validation no longer done on the 'DEFAULT' section (only in the root
+    level). This allows interpolation in configspecs.
+    
+    Change in validation syntax implemented in validate 0.2.1
+    
+    4.1.0
+    
+    2005/12/10
+    ----------
+    
+    Added ``merge``, a recursive update.
+    
+    Added ``preserve_errors`` to ``validate`` and the ``flatten_errors``
+    example function.
+    
+    Thanks to Matthew Brett for suggestions and helping me iron out bugs.
+    
+    Fixed bug where a config file is *all* comment, the comment will now be
+    ``initial_comment`` rather than ``final_comment``.
+    
+    2005/12/02
+    ----------
+    
+    Fixed bug in ``create_empty``. Thanks to Paul Jimenez for the report.
+    
+    2005/11/04
+    ----------
+    
+    Fixed bug in ``Section.walk`` when transforming names as well as values.
+    
+    Added the ``istrue`` method. (Fetches the boolean equivalent of a string
+    value).
+    
+    Fixed ``list_values=False`` - they are now only quoted/unquoted if they
+    are multiline values.
+    
+    List values are written as ``item, item`` rather than ``item,item``.
+    
+    4.0.1
+    
     2005/10/09
     ----------
     
     Fixed typo in ``write`` method. (Testing for the wrong value when resetting
     ``interpolation``).
+
+    4.0.0 Final
     
     2005/09/16
     ----------
@@ -2410,7 +3227,7 @@
     2005/09/03
     ----------
     
-    Fixed bug in ``Section__delitem__`` oops.
+    Fixed bug in ``Section.__delitem__`` oops.
     
     2005/08/28
     ----------

=== modified file 'bzrlib/util/configobj/docs/configobj.txt'
--- bzrlib/util/configobj/docs/configobj.txt	2005-11-07 13:17:53 +0000
+++ bzrlib/util/configobj/docs/configobj.txt	2006-03-20 08:31:00 +0000
@@ -7,8 +7,8 @@
 ----------------------------------------
 
 :Authors: Michael Foord, Nicola Larosa
-:Version: ConfigObj 4.0.0
-:Date: 2005/10/17
+:Version: ConfigObj 4.2.0
+:Date: 2006/02/16
 :Homepage: `ConfigObj Homepage`_
 :Sourceforge: Sourceforge_
 :License: `BSD License`_
@@ -33,44 +33,68 @@
 straightforward programmer's interface and a simple syntax for config files.
 It has lots of other features though :
 
+.. sidebar:: ConfigObj in Bazaar
+
+    **ConfigObj** is now used as the config file parser for `Bazaar <http://bazaar-ng.org>`_.
+    
+    Bazaar is *the* Python  distributed {acro;VCS;Version Control System}. 
+    ConfigObj is used to read ``bazaar.conf`` and ``branches.conf``.
+    
+    Other projects that use **ConfigObj** include :
+    
+    * `Planet Plus <http://planetplus.python-hosting.com/>`_
+    
+        A new web application version of `Planet <http://www.planetplanet.org/>`_, 
+        the web aggregator.
+        
+    * `NeuroImaging in Python <http://projects.scipy.org/neuroimaging/ni/wiki>`_
+    
+        BrainSTAT is a project with the ultimate goal to produce a
+        platform-independent python environment for the analysis of brain
+        imaging data.
+        
+    * `Gruik <http://www.tracos.org/gruik/wiki>`_
+    
+        Gruik is a free software network packet sniffer.
+
 * Nested sections (subsections), to any level
 * List values
 * Multiple line values
 * String interpolation (substitution)
 * Integrated with a powerful validation system
 
-    * including automatic type checking/conversion
-    * repeated sections
-    * and allowing default values
+    - including automatic type checking/conversion
+    - repeated sections
+    - and allowing default values
 
 * All comments in the file are preserved
 * The order of keys/sections is preserved
 * No external dependencies
-
-ConfigObj 4 is a complete rewrite of ConfigObj. A great deal has been
-simplified and improved [#]_ since ConfigObj 3. If you have used ConfigObj
-before then you need to read the section on `backwards compatibility`_.
-
-ConfigObj now has a barrage [#]_ of doctests built into it, testing almost every
-feature. Run ``python configobj.py -v`` to see them in action. Despite the tests,
-ConfigObj 4 is actually smaller than version 3 and has no external dependencies.
+* Full unicode support.
+
+ConfigObj 4 is a complete rewrite of ConfigObj. ConfigObj now has a barrage [#]_
+of doctests built into it, testing almost every feature. Run ``python configobj.py -v``
+to see them in action. Despite the tests, ConfigObj 4 is smaller than version 3
+and has no external dependencies.
 
 For support and bug reports please use the ConfigObj `Mailing List`_.
 
 .. hint::
 
-    There is an article on using `ConfigObj for Data Persistence`_.
+    ConfigObj provides a convenient API for storing all sorts of data, not just
+    config files. There is an article on using `ConfigObj for Data Persistence`_.
     
     The code from that article is available as ConfigPersist.py_.
 
 .. _ConfigObj for Data Persistence: http://www.voidspace.org.uk/python/articles/configobj_for_data_persistence.shtml
 .. _ConfigPersist.py: http://www.voidspace.org.uk/python/configpersist.html
 
+
 Downloading
 ===========
 
-The current version is **4.0.0**, dated 17th October 2005. ConfigObj 4 is
-now stable. We may still expect to pick up a few bugs along the way though [#]_.
+The current version is **4.2.0**, dated 16th February 2006. ConfigObj 4 is
+now stable. We still expect to pick up a few bugs along the way though [#]_.
 {sm;:-)}
 
 You can get ConfigObj in the following ways :
@@ -112,7 +136,7 @@
 Projects`_.
 
 .. _configobj.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj.py
-.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.0.0.zip
+.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.2.0.zip
 .. _validate.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=validate.py
 .. _API Docs: http://www.voidspace.org.uk/python/configobj-api/
 .. _this document:
@@ -123,6 +147,7 @@
 .. _pythonutils: http://www.voidspace.org.uk/python/pythonutils.html
 .. _Voidspace Python Projects: http://www.voidspace.org.uk/python
 
+
 Getting Started
 ===============
 
@@ -267,6 +292,7 @@
     # The 'final_comment'
     # Which also may be several lines
 
+
 ConfigObj specifications
 ========================
 
@@ -291,14 +317,11 @@
   the options_ ``file_error`` and ``create_empty``. The filename will be
   preserved as the ``filename`` attribute. This can be changed at any time.
 
-* A list of lines. Any trailing ``\n`` will be removed from the lines. The
+* A list of lines. Any trailing newlines will be removed from the lines. The
   ``filename`` attribute of your ConfigObj will be ``None``.
 
-* A ``StringIO`` instance or file object, or any object with ``seek`` and
-  ``read`` methods. The object you pass in will be preserved as the
-  ``filename`` attribute of your ConfigObj. If it has a ``write`` method [#]_
-  then you can use the ConfigObj ``write`` method. Note that a file object
-  passed in won't have its ``close`` method called by ConfigObj.
+* A ``StringIO`` instance or file object, or any object with a ``read`` method.
+  The ``filename`` attribute of your ConfigObj will be ``None`` [#]_.
 
 * A dictionary. You can initialise a ConfigObj from a dictionary [#]_. The
   ``filename`` attribute of your ConfigObj will be ``None``. All keys must be
@@ -329,8 +352,12 @@
 
     If ``True`` (the default) then list values are possible. If ``False``, the
     values are not parsed for lists.
+	
+	If ``list_values = False`` then single line values are not quoted or
+	unqouted when reading and writing.
 
-    Altering this value after initial parsing has no effect.
+    Changing this value affects whether single line values will be quoted or 
+    not when writing.
 
 * 'create_empty': ``False``
 
@@ -402,6 +429,46 @@
     If this option *is* specified, the option value is used in the output
     config, overriding the type of indentation in the input config (if any).
 
+* 'encoding': ``None``
+
+    By default **ConfigObj** does not decode the file/strings you pass it into
+    Unicode [#]_. If you want your config file as Unicode (keys and members)
+    you need to provide an encoding to decode the file with. This encoding will
+    also be used to encode the config file when writing.
+    
+    You can change the encoding attribute at any time.
+    
+    Any characters in your strings that can't be encoded with the specified
+    encoding will raise a ``UnicodeEncodeError``.
+    
+    .. note::
+    
+        ``UTF16`` encoded files will automatically be detected and decoded,
+        even if ``encoding`` is ``None``.
+        
+        This is because it is a 16-bit encoding, and ConfigObj will mangle it
+        (split characters on byte boundaries) if it parses it without decoding.
+
+* 'default_encoding': ``None``
+
+    When using the ``write`` method, **ConfigObj** uses the ``encoding``
+    attribute to encode the Unicode strings. If any members (or keys) have
+    been set as byte strings instead of Unicode, these must first be decoded
+    to Unicode before outputting in the specified encoding.
+
+    ``default_encoding``, if specified, is the encoding used to decode byte
+    strings in the **ConfigObj** before writing. If this is ``None``, then
+    the Python default encoding (``sys.defaultencoding`` - usually ascii) is
+    used.
+    
+    For most Western European users, a value of ``latin-1`` is sensible.
+    
+    ``default_encoding`` is *only* used if an ``encoding`` is specified.
+    
+    Any characters in byte-strings that can't be decoded using the
+    ``default_encoding`` will raise a ``UnicodeDecodeError``.
+
+
 Methods
 -------
 
@@ -409,9 +476,30 @@
 subclass of ``dict``, the builtin dictionary type. This means it also has
 **all** the normal dictionary methods.
 
-In addition, the *encode*, *decode*, *walk*, and *dict* methods of section may
-be useful. The sections and subsections are also instances of ``Section``. Read
-about Sections_ for details of all the methods.
+In addition, the following `Section Methods`_ may be useful :
+
+* *encode*
+* *decode*
+* *walk*
+* *merge*
+* *dict* 
+* *as_bool*
+* *as_float*
+* *as_int*
+
+Read about Sections_ for details of all the methods.
+
+.. hint::
+
+    The *merge* method of sections is a recursive update.
+    
+    You can use this to merge sections, or even whole ConfigObjs, into each
+    other.
+    
+    You would typically use this to create a default ConfigObj and then merge
+    in user settings. This way users only need to specify values that are
+    different from the default.
+    
 
 The public methods available on ConfigObj are :
 
@@ -421,19 +509,27 @@
 write
 ~~~~~
 
-This method takes no arguments [#]_. It writes the current ConfigObj. What that
-means depends on the ``filename`` attribute of the ConfigObj.
-
-filename
-    ConfigObj will write the configuration to file.
+::
+
+    write(file_object=None)
+
+This method writes the current ConfigObj and takes a single, optional argument
+[#]_.
+
+If you pass in a file like object to the ``write`` method, the config file will
+be written to this. (The only method of this object that is used is its
+``write`` method, so a ``StringIO`` instance, or any other file like object
+will work.)
+
+Otherwise, the behaviour of this method depends on the ``filename`` attribute
+of the ConfigObj.
+
+``filename``
+    ConfigObj will write the configuration to the file specified.
 
 ``None``
     ``write`` returns a list of lines. (Not ``'\n'`` terminated)
 
-``StringIO``
-    If ``filename`` is an object with a seek attribute, then the config file is
-    written to that object.
-
 First the 'initial_comment' is written, then the config file, followed by the
 'final_comment'. Comment lines and inline comments are written with each
 key/value.
@@ -441,6 +537,10 @@
 validate
 ~~~~~~~~
 
+::
+
+    validate(validator, preserve_errors=False)
+
 .. raw:: html
 
     {+coloring}
@@ -458,6 +558,10 @@
 
     {-coloring}
 
+The validate method uses the `validate 
+<http://www.voidspace.org.uk/python/validate.html>`__ module to do the
+validation.
+    
 This method validates the ConfigObj against the configspec. By doing type
 conversion as well, it can abstract away the config file altogether and present
 the config *data* to your application (in the types it expects it to be).
@@ -483,12 +587,13 @@
     
     See `ConfigObj for Data Persistence`_.
 
+
 Return Value
 ############
 
-The validate method either returns ``True`` (everything passed) or a dictionary 
-of ``True``/``False`` representing pass/fail. The dictionary follows the 
-structure of the ConfigObj
+By default, the validate method either returns ``True`` (everything passed) 
+or a dictionary of ``True``/``False`` representing pass/fail. The dictionary 
+follows the structure of the ConfigObj.
 
 If a whole section passes then it is replaced with the value ``True``. If a 
 whole section fails, then it is replaced with the value ``False``.
@@ -496,6 +601,18 @@
 If a value is missing, and there is no default in the check, then the check 
 automatically fails.
 
+The ``validate`` method takes an optional keyword argument ``preserve_errors``.
+If you set this to ``True``, instead of getting ``False`` for failed checks you
+get the actual error object from the **validate** module. This usually contains
+useful information about why the check failed.
+
+See the `flatten_errors`_ function for how to turn your results dictionary into
+a useful list of error messages.
+
+Even if ``preserve_errors`` is ``True``, missing keys or sections will still be
+represented by a ``False`` in the results dictionary.
+
+
 Mentioning Default Values
 #########################
 
@@ -536,6 +653,11 @@
     ``None``. This is because setting a value to a non-string raises an error
     if stringify is unset.
 
+The default value can be a list. See `List Values`_ for the way to do this.
+
+Writing invalid default values is a *guaranteed* way of confusing your users.
+Default values **must** pass the check.
+
 Mentioning Repeated Sections
 ############################
 
@@ -554,6 +676,7 @@
 
 See `Repeated Sections`_ for examples.
 
+
 Mentioning SimpleVal
 ####################
 
@@ -575,6 +698,7 @@
 
     {-coloring}
 
+    
 Attributes
 ----------
 
@@ -586,6 +710,9 @@
 * BOM
 * initial_comment
 * final_comment
+* list_values
+* encoding
+* default_encoding
 
 .. note::
 
@@ -598,7 +725,6 @@
 * raise_errors
 * create_empty
 * file_error
-* list_values
 
 interpolate
 ~~~~~~~~~~~
@@ -623,10 +749,13 @@
 ~~~
 
 If the initial config file *started* with the UTF8 Unicode signature (known
-slightly incorrectly as the {acro;BOM;Byte Order Mark}), then this value will
-be set to the UTF8 BOM. Otherwise it is ``None``.
-
-If it is set, then it is  written out by the ``write`` method.
+slightly incorrectly as the {acro;BOM;Byte Order Mark}), or the UTF16 BOM, then
+this attribute is set to ``True``. Otherwise it is ``False``.
+
+If it is set to ``True`` when ``write`` is called then, if ``encoding`` is set
+to ``None`` *or* to ``utf_8`` (and variants) a UTF BOM will be written.
+
+For UTF16 encodings, a BOM is *always* written.
 
 initial_comment
 ~~~~~~~~~~~~~~~
@@ -649,6 +778,52 @@
 The ``write`` method puts these lines after it finishes writing out the
 members.
 
+list_values
+~~~~~~~~~~~
+
+This attribute is ``True`` or ``False``. If set to ``False`` then values are
+not parsed for list values. In addition single line values are not unquoted.
+
+This allows you to do your own parsing of values. It exists primarily to
+support the reading of the configspec_ - but has other use cases.
+
+For example you could use the ``LineParser`` from the
+`listquote module <http://www.voidspace.org.uk/python/listquote.html#lineparser>`_ 
+to read values for nested lists.
+
+Single line values aren't quoted when writing - but multiline values are
+handled as normal.
+
+.. caution::
+
+    Because values aren't quoted, leading or trailing whitespace can be
+	lost.
+
+    This behaviour was changed in version 4.0.1.
+	
+	Prior to this, single line values might have been quoted; even with
+	``list_values=False``. This means that files written by **ConfigObj**
+	*could* now be incompatible - and need the quotes removing by hand.
+
+encoding
+~~~~~~~~
+
+This is the encoding used to encode the output, when you call ``write``. It
+must be a valid encoding `recognised by Python <http://docs.python.org/lib/standard-encodings.html>`_.
+
+If this value is ``None`` then no encoding is done when ``write`` is called.
+
+
+default_encoding
+~~~~~~~~~~~~~~~~
+
+If encoding is set, any byte-strings in your ConfigObj instance (keys or
+members) will first be decoded to unicode using the encoding specified by the
+``default_encoding`` attribute. This ensures that the output is in the encoding
+specified.
+
+If this value is ``None`` then ``sys.defaultencoding`` is used instead.
+
 The Config File Format
 ======================
 
@@ -943,13 +1118,13 @@
 Section Methods
 ---------------
 
-* 'dict'
+* **dict**
 
     This method takes no arguments. It returns a deep copy of the section as a
     dictionary. All subsections will also be dictionaries, and list values will
     be copies, rather than references to the original [#]_.
 
-* rename
+* **rename**
 
     ``rename(oldkey, newkey)``
 
@@ -958,22 +1133,52 @@
     It is mainly implemented for the ``encode`` and ``decode`` methods, which
     provide some Unicode support.
 
-* walk
+* **merge**
+
+    ``merge(indict)``
+    
+    This method is a *recursive update* method. It allows you to merge two
+    config files together.
+    
+    You would typically use this to create a default ConfigObj and then merge
+    in user settings. This way users only need to specify values that are
+    different from the default.
+    
+    For example :
+    
+    .. raw:: html
+    
+        {+coloring}
+        
+        # def_cfg contains your default config settings
+        # user_cfg contains the user settings
+        cfg = ConfigObj(def_cfg)
+        usr = ConfigObj(user_cfg)
+        #
+        cfg.merge(usr)
+        
+        """
+        cfg now contains a combination of the default settings and the user
+        settings.
+        
+        The user settings will have overwritten any of the default ones.
+        """
+    
+        {-coloring}
+    
+* **walk**
 
     This method can be used to transform values and names. See `walking a
     section`_ for examples and explanation.
 
-* decode
+* **decode**
 
     ``decode(encoding)``
 
     This method decodes names and values into Unicode objects, using the
     supplied encoding.
 
-    Because of the way ConfigObj reads files, config files should be in an
-    ASCII compatible encoding. See encodings_ for more details.
-
-* encode
+* **encode**
 
     ``encode(encoding)``
 
@@ -981,10 +1186,51 @@
 
     It encodes names and values using the supplied encoding. If any of your
     names/values are strings rather than Unicode, Python will have to do an
-    implicit decode first.
-
-    See encodings_ for more details.
-
+    implicit decode first. (This method uses ``sys.defaultencoding`` for
+    implicit decodes.)
+
+* **as_bool**
+
+    ``as_bool(key)``
+    
+    Returns ``True`` if the key contains a string that represents ``True``, or
+    is the ``True`` object.
+    
+    Returns ``False`` if the key contains a string that represents ``False``, 
+    or is the ``False`` object. 
+
+    Raises a ``ValueError`` if the key contains anything else.
+    
+    Strings that represent ``True`` are (not case sensitive) : ::
+    
+        true, yes, on, 1
+        
+    Strings that represent ``False`` are : ::
+    
+        false, no, off, 0
+    
+    .. note::
+    
+        In ConfigObj 4.1.0, this method was called ``istrue``. That method is
+        now deprecated and will issue a warning when used. It will go away
+        in the next release.
+        
+* **as_int**
+
+    ``as_int(key)``
+    
+    This returns the value contained in the specified key as an integer.
+    
+    It raises a ``ValueError`` if the conversion can't be done.
+
+* **as_float**
+
+    ``as_float(key)``
+    
+    This returns the value contained in the specified key as a float.
+    
+    It raises a ``ValueError`` if the conversion can't be done.
+    
 Walking a Section
 -----------------
 
@@ -1028,6 +1274,12 @@
 If you are using the return value from ``walk`` *and* ``call_on_sections``,
 note that walk discards the return value when it calls your function.
 
+.. caution::
+
+    You can use ``walk`` to transform the names of members of a section
+    but you mustn't add or delete members.
+
+
 Examples
 --------
 
@@ -1040,7 +1292,7 @@
 
 You can use this for transforming all values in your ConfigObj. For example
 you might like the nested lists from ConfigObj 3. This was provided by the
-listquote_ module [#]_. You could switch off the parsing for list values
+listquote_ module. You could switch off the parsing for list values
 (``list_values=False``) and use listquote to parse every value.
 
 Another thing you might want to do is use the Python escape codes in your
@@ -1116,6 +1368,59 @@
 
     {-coloring}
 
+Here's a simple example of using ``walk`` to transform names and values. One
+usecase of this would be to create a *standard* config file with placeholders
+for section and keynames. You can then use walk to create new config files
+and change values and member names :
+
+.. raw:: html
+
+    {+coloring}
+
+    # We use 'XXXX' as a placeholder
+    config = '''
+    XXXXkey1 = XXXXvalue1
+    XXXXkey2 = XXXXvalue2
+    XXXXkey3 = XXXXvalue3
+    [XXXXsection1]
+    XXXXkey1 = XXXXvalue1
+    XXXXkey2 = XXXXvalue2
+    XXXXkey3 = XXXXvalue3
+    [XXXXsection2]
+    XXXXkey1 = XXXXvalue1
+    XXXXkey2 = XXXXvalue2
+    XXXXkey3 = XXXXvalue3
+        [[XXXXsection1]]
+        XXXXkey1 = XXXXvalue1
+        XXXXkey2 = XXXXvalue2
+        XXXXkey3 = XXXXvalue3
+    '''.splitlines()
+    cfg = ConfigObj(config)
+    #
+    def transform(section, key):
+        val = section[key]
+        newkey = key.replace('XXXX', 'CLIENT1')
+        section.rename(key, newkey)
+        if isinstance(val, (tuple, list, dict)):
+            pass
+        else:
+            val = val.replace('XXXX', 'CLIENT1')
+            section[newkey] = val
+    #
+    cfg.walk(transform, call_on_sections=True)
+    print cfg
+    {'CLIENT1key1': 'CLIENT1value1', 'CLIENT1key2': 'CLIENT1value2', 
+    'CLIENT1key3': 'CLIENT1value3', 
+    'CLIENT1section1': {'CLIENT1key1': 'CLIENT1value1', 
+        'CLIENT1key2': 'CLIENT1value2', 'CLIENT1key3': 'CLIENT1value3'}, 
+    'CLIENT1section2': {'CLIENT1key1': 'CLIENT1value1', 
+        'CLIENT1key2': 'CLIENT1value2', 'CLIENT1key3': 'CLIENT1value3', 
+        'CLIENT1section1': {'CLIENT1key1': 'CLIENT1value1', 
+            'CLIENT1key2': 'CLIENT1value2', 'CLIENT1key3': 'CLIENT1value3'}}}
+            
+    {-coloring}
+
+
 Exceptions
 ==========
 
@@ -1127,7 +1432,7 @@
     raised.
 
 2) If you try to set a non-string key, or a non string value when
-    ``stringify=False`, a ``TypeError`` will be raised.
+    ``stringify=False``, a ``TypeError`` will be raised.
 
 3) A badly built config file will cause parsing errors.
 
@@ -1204,6 +1509,7 @@
     list of all the lines that caused errors may not be as useful as it sounds.
     {sm;:-(}.
 
+
 Validation
 ==========
 
@@ -1262,6 +1568,15 @@
 For full details on writing configspecs, please refer to the `validate.py
 documentation`_.
 
+.. important::
+
+    Your configspec is read by ConfigObj in the same way as a config file.
+    
+    That means you can do interpolation *within* your configspec.
+    
+    In order to allow this, checks in the 'DEFAULT' section (of the root level
+    of your configspec) are *not* used.
+
 .. _validate.py documentation: http://www.voidspace.org.uk/python/validate.html
 
 Type Conversion
@@ -1305,6 +1620,20 @@
 
     Note that ``default=None`` is case sensitive.
 
+
+List Values
+~~~~~~~~~~~
+
+It's possible that you will want to specify a list as a default value. To avoid
+confusing syntax with commas and quotes you use a list constructor to specify 
+that keyword arguments are lists. This includes the ``default`` value. This 
+makes checks look something like : ::
+
+    checkname(default=list('val1', 'val2', 'val3'))
+
+This works with all keyword arguments, but is most useful for default values.
+
+
 Repeated Sections
 -----------------
 
@@ -1404,6 +1733,7 @@
 
     {-coloring}
 
+
 Interpolation
 =============
 
@@ -1434,6 +1764,7 @@
 See `Validation and Interpolation`_. (This can only happen if validation
 has to *change* the value).
 
+
 Comments
 ========
 
@@ -1459,36 +1790,78 @@
 
 These comments are all written back out by the ``write`` method.
 
-Encodings
-=========
-
-ConfigObj 4 is designed to work with ASCII compatible encodings [#]_. If you
-need support for other character sets, then I suggest you use the UTF8
-encoding for your config files.
-
-By default ConfigObj leaves keys/members as encoded byte strings (ordinary
-strings). If you want to access the config file members as Unicode objects
-rather than strings, you can use the ``decode`` method. This takes an encoding
-as its argument and decodes all members and keys into Unicode. It will only
-work if *all* members are byte strings (or lists of strings) , so you should do
-it before calling ``validate``.
-
-If you want to turn the Unicode strings back into byte strings, you can call
-the ``encode`` method. This also takes an encoding as its argument and assumes
-*all* keys/members are Unicode.
-
-If you start working with Unicode strings, you may find you get
-``UnicodeDecodeError`` or ``UnicodeEncodeError`` in unexpected places. This is
-because you have forced Python to do an *implicit* encode or decode.
-
-Implicit decodes (and encodes) use the encoding returned by
-``sys.getdefaultencoding()``. This is *usually* ASCII. This means that if you
-have any non-ASCII characters, Python doesn't know how to treat them and will
-raise an error.
-
-This happens if you add a byte string to a Unicode string, compare a byte
-string to a Unicode string, print a Unicode string, or write it to a file. If
-you work with Unicode, you should do the appropriate encode or decode first.
+
+flatten_errors
+==============
+
+::
+
+    flatten_errors(cfg, res)
+
+Validation_ is a powerful way of checking that the values supplied by the user
+make sense.
+
+The validate_ method returns a results dictionary that represents pass or fail
+for each value. This doesn't give you any information about *why* the check
+failed.
+
+``flatten_errors`` is an example function that turns a results dictionary into
+a flat list, that only contains vaues that *failed*.
+
+``cfg`` is the ConfigObj instance being checked, ``res`` is the results
+dictionary returned by ``validate``.
+
+It returns a list of keys that failed. Each member of the list is a tuple : ::
+
+    ([list of sections...], key, result)
+
+If ``validate`` was called with ``preserve_errors=False`` (the default)
+then ``result`` will always be ``False``.
+
+*list of sections* is a flattened list of sections that the key was found
+in.
+
+If the section was missing then key will be ``None``.
+
+If the value (or section) was missing then ``result`` will be ``False``.
+
+If ``validate`` was called with ``preserve_errors=True`` and a value
+was present, but failed the check, then ``result`` will be the exception
+object returned. You can use this as a string that describes the failure.
+
+For example :
+
+    *The value "3" is of the wrong type*.
+
+
+Example Usage
+-------------
+
+The output from ``flatten_errors`` is a list of tuples.
+
+Here is an example of how you could present this information to the user.
+
+.. raw:: html
+
+    {+coloring}
+    
+    vtor = validate.Validator()
+    # ini is your config file - cs is the configspec
+    cfg = ConfigObj(ini, configspec=cs)
+    res = cfg.validate(vtor, preserve_errors=True)
+    for entry in flatten_errors(cfg, res):
+        # each entry is a tuple
+        section_list, key, error = entry
+        if key is not None:
+           section_list.append(key)
+        else:
+            section_list.append('[missing section]')
+        section_string = ', '.join(section_list)
+        if error == False:
+            error = 'Missing value or section.'
+        print section_string, ' = ', error
+
+    {-coloring}
 
 Backwards Compatibility
 =======================
@@ -1546,9 +1919,6 @@
 
 The ``newline``, ``force_return``, and ``default`` options have gone.
 
-The ``encoding`` and ``backup_encoding`` methods have gone, replaced with the
-``encode`` and ``decode`` methods.
-
 ``fileerror`` and ``createempty`` options have become ``file_error`` and
 ``create_empty``.
 
@@ -1580,6 +1950,7 @@
 .. _ConfigObj 3.3.1: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj3.zip
 .. _ConfigObj 3 Docs: http://www.voidspace.org.uk/python/configobj3.html
 
+
 CREDITS
 =======
 
@@ -1593,6 +1964,7 @@
 
 Thanks to others for input and bugfixes.
 
+
 LICENSE
 =======
 
@@ -1602,7 +1974,7 @@
 Of course if it does, let us know and we'll fix the problem so it doesn't
 happen to anyone else {sm;:-)}. ::
 
-    Copyright (c) 2004 & 2005, Michael Foord & Nicola Larosa
+    Copyright (c) 2004 - 2006, Michael Foord & Nicola Larosa
     All rights reserved.
 
     Redistribution and use in source and binary forms, with or without
@@ -1636,7 +2008,8 @@
 
 You should also be able to find a copy of this license at : `BSD License`_
 
-.. _BSD License: http://www.voidspace.org.uk/documents/BSD-LICENSE.txt
+.. _BSD License: http://www.voidspace.org.uk/python/license.shtml
+
 
 TODO
 ====
@@ -1649,14 +2022,15 @@
 When initialising a section from a ConfigObj *or* an ``OrderedDictionary``
 we could preserve ordering.
 
-Add an *odict* method which returns an `OrderedDictionary``.
+Add an *odict* method which returns an ``OrderedDictionary``.
+
 
 ISSUES
 ======
 
 .. note::
 
-    Please file any bug reports to `Michael Foord`_ or the ConfigObj
+    Please file any bug reports to `Michael Foord`_ or the **ConfigObj**
     `Mailing List`_.
 
 You can't have a keyword with the same name as a section (in the same section).
@@ -1670,40 +2044,17 @@
 parent*: this means that checking the 'DEFAULT' sub-section in the *current
 section* is not necessarily logical ?
 
-In order to simplify Unicode support (which is possibly of limited value
-in a config file ?) I have removed automatic support, and added thev``encode``
-and ``decode`` methods. These can be used to transform keys and entries.
-Because the regex looks for specific values on inital parsing (i.e. the quotes
-and the equals signs) it can only read ASCII compatible encodings. For Unicode
-I suggest ``UTF8``, which is ASCII compatible.
-
-.. note::
-
-    There is no reason why you shouldn't decode your config file into Unicode
-    before passing them to ConfigObj (as a list of lines). This should give you
-    Unicode keys and values.
-
 Does it matter that we don't support the ':' divider, which is supported by
 ``ConfigParser`` ?
 
-Following error with "list_values=False" : ::
-
-    >>> a = ["a='hello', 'goodbye'"]
-    >>>
-    >>> c(a, list_values=False)
-    {'a': "hello', 'goodbye"}
-
-The regular expression correctly removes the value - ``"'hello', 'goodbye'"`` -
-and then unquote just removes the front and back quotes (called by
-``_handle_value``). What should we do ?? We *ought* to raise an exception - 
-because if lists are off it's an invalid value. This is not desired if you want 
-to do your own list processing e.g. using listquote for nested lists. It would
-be *better* in this case not to unquote. Raising an exception would require a
-new regex.
-
 String interpolation and validation don't play well together. See 
 `Validation and Interpolation`_.
 
+Validation is no longer done on the 'DEFAULT' section (on the root level). This
+allows interpolation from within your configspec - but also prevents you
+validating the 'DEFAULT' section.
+
+
 CHANGELOG
 =========
 
@@ -1711,6 +2062,78 @@
 From version 4 it lists all releases and changes. *More* data on individual
 changes may be found in the source code.
 
+2006/02/16 - Version 4.2.0
+--------------------------
+
+Removed ``BOM_UTF8`` from ``__all__``.
+
+The ``BOM`` attribute has become a boolean. (Defaults to ``False``.) It is
+*only* ``True`` for the ``UTF16`` encoding.
+
+File like objects no longer need a ``seek`` attribute.
+
+Full unicode support added. New options/attributes ``encoding``,
+``default_encoding``.
+
+ConfigObj no longer keeps a reference to file like objects. Instead the
+``write`` method takes a file like object as an optional argument. (Which
+will be used in preference of the ``filename`` attribute if that exists as
+well.)
+
+utf16 files decoded to unicode.
+
+If ``BOM`` is ``True``, but no encoding specified, then the utf8 BOM is
+written out at the start of the file. (It will normally only be ``True`` if
+the utf8 BOM was found when the file was read.)
+
+File paths are *not* converted to absolute paths, relative paths will
+remain relative as the ``filename`` attribute.
+
+Fixed bug where ``final_comment`` wasn't returned if ``write`` is returning
+a list of lines.
+
+Deprecated ``istrue``, replaced it with ``as_bool``.
+
+Added ``as_int`` and ``as_float``.
+
+2005/12/14 - Version 4.1.0
+--------------------------
+
+Added ``merge``, a recursive update.
+
+Added ``preserve_errors`` to ``validate`` and the ``flatten_errors``
+example function.
+
+Thanks to Matthew Brett for suggestions and helping me iron out bugs.
+    
+Fixed bug where a config file is *all* comment, the comment will now be
+``initial_comment`` rather than ``final_comment``.
+
+Validation no longer done on the 'DEFAULT' section (only in the root level).
+This allows interpolation in configspecs.
+
+Also use the new list syntax in validate_ 0.2.1. (For configspecs).
+
+2005/12/02 - Version 4.0.2
+--------------------------
+
+Fixed bug in ``create_empty``. Thanks to Paul Jimenez for the report.
+
+
+2005/11/05 - Version 4.0.1
+--------------------------
+
+Fixed bug in ``Section.walk`` when transforming names as well as values.
+
+Added the ``istrue`` method. (Fetches the boolean equivalent of a string
+value).
+
+Fixed ``list_values=False`` - they are now only quoted/unquoted if they
+are multiline values.
+
+List values are written as ``item, item`` rather than ``item,item``.
+
+
 2005/10/17 - Version 4.0.0
 --------------------------
 
@@ -1878,19 +2301,18 @@
 Footnotes
 =========
 
-.. [#] The core parser is now based on regular expressions, so it's a lot
-    faster.
-
-.. [#] 134 of them, at the time of writing.
+.. [#] 253 of them, at the time of writing.
 
 .. [#] And if you discover any bugs, let us know. We'll fix them quickly.
 
 .. [#] If you specify a filename that doesn't exist, ConfigObj will assume you
     are creating a new one. See the *create_empty* and *file_error* options_.
 
-.. [#] They can be byte strings ('ordinary' strings) or Unicode. If they are
-    Unicode then ConfigObj will have to do an implicit encode before writing.
-    See the encodings_ section for more details.
+.. [#] They can be byte strings ('ordinary' strings) or Unicode.
+
+.. [#] This is a change in ConfigObj 4.2.0. Note that ConfigObj doesn't call
+    the seek method of any file like object you pass in. You may want to call
+    ``file_object.seek(0)`` yourself, first.
 
 .. [#] Except we don't support the RFC822 style line continuations, nor ':' as
     a divider.
@@ -1901,26 +2323,26 @@
 
 .. [#] A side effect of this is that it enables you to copy a ConfigObj :
 
-.. raw:: html
-
-    {+coloring}
-
-    # only copies members
-    # not attributes/comments
-    config2 = ConfigObj(config1)
-
-    {-coloring}
-
-..
+    .. raw:: html
+    
+        {+coloring}
+    
+        # only copies members
+        # not attributes/comments
+        config2 = ConfigObj(config1)
+    
+        {-coloring}
 
     The order of values and sections will not be preserved, though.
 
+.. [#] The exception is if it detects a ``UTF16`` encoded file which it
+    must decode before parsing.
+     
 .. [#] Other than lists of strings.
 
-.. [#] The method signature in the API docs will show that it does in fact
-    take one argument: the section to be written. This is because the
-    ``write`` method is called recursively. Using this argument *forces* write
-    to return a list of lines, so it's probably not very useful to you.
+.. [#] The method signature in the API docs will show that this method takes
+    two arguments. The second is the section to be written. This is because the
+    ``write`` method is called recursively.
 
 .. [#] The dict method doesn't actually use the deepcopy mechanism. This means
     if you add nested lists (etc) to your ConfigObj, then the dictionary
@@ -1931,9 +2353,6 @@
     change the value by setting ``section[key] = newval``. It also gives you
     access to the *rename* method of the section.
 
-.. [#] A current bug in unquoting when ``list_values=False`` currently makes
-    this impossible. We are considering the best way to fix this.
-
 .. [#] Minimum required version of *validate.py* 0.2.0 .
 
 .. [#] There's nothing to stop you decoding the whole config file to Unicode
@@ -1959,7 +2378,7 @@
         <br />
         <a href="http://www.python.org">
             <img src="images/powered_by_python.jpg" width="602" height="186" border="0" />
-        </a>
+        </a><br /><br />
         <a href="http://www.opensource.org">
             <img src="images/osi-certified-120x100.gif" width="120" height="100" border="0" />
             <br /><strong>Certified Open Source</strong>
@@ -1972,10 +2391,9 @@
                 <img src="http://s16.sitemeter.com/meter.asp?site=s16atlantibots" alt="Site Meter" border=0 />
             </a>
         </noscript>
-        <br />
     </div>
 
 .. _listquote: http://www.voidspace.org.uk/python/modules.shtml#listquote
-.. _Michael Foord: http://www.voidspace.org.uk
+.. _Michael Foord: http://www.voidspace.org.uk/index2.shtml
 .. _Nicola Larosa: http://www.teknico.net
 .. _Mark Andrews: http://www.la-la.com

=== modified file 'bzrlib/util/configobj/docs/validate.txt'
--- bzrlib/util/configobj/docs/validate.txt	2005-11-07 13:17:53 +0000
+++ bzrlib/util/configobj/docs/validate.txt	2006-03-20 08:31:00 +0000
@@ -8,8 +8,8 @@
 
 
 :Authors: `Michael Foord`_, `Nicola Larosa`_, `Mark Andrews`_
-:Version: Validate 0.2.0
-:Date: 2005/08/25
+:Version: Validate 0.2.1
+:Date: 2005/12/16
 :Homepage: `Validate Homepage`_
 :License: `BSD License`_
 :Support: `Mailing List`_
@@ -20,7 +20,7 @@
 .. _Mark Andrews: mark@la-la.com
 .. _This Document:
 .. _Validate Homepage: http://www.voidspace.org.uk/python/validate.html
-.. _BSD License: http://www.voidspace.org.uk/documents/BSD-LICENSE.txt
+.. _BSD License: http://www.voidspace.org.uk/python/license.shtml
 
 
 .. contents:: Validate Manual
@@ -56,7 +56,7 @@
 into every validator. Additional checks are easy to write: they can be provided
 when the ``Validator`` is instantiated, or added afterwards.
 
-Validate was primarily written to support ConfigObj_, but was designed to be 
+Validate was primarily written to support ConfigObj_, but is designed to be 
 applicable to many other situations.
 
 For support and bug reports please use the ConfigObj `Mailing List`_.
@@ -66,7 +66,7 @@
 Downloading
 ===========
 
-The current version is **0.2.0**, dated 25th August 2005. 
+The current version is **0.2.1**, dated 16th December 2005. 
 
 You can get obtain validate in the following ways :
 
@@ -76,7 +76,7 @@
 * validate.py_ from Voidspace
 
 * configobj.zip from Voidspace - See the homepage of ConfigObj_ for the latest 
-  version and downlaod links.
+  version and download links.
 
     This contains validate.py and `this document`_. (As well as ConfigObj_ and 
     the ConfigObj documentation).
@@ -101,7 +101,7 @@
 Python Projects`_.
 
 .. _configobj.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj.py
-.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.0.0b4.zip
+.. _configobj.zip: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=configobj-4.1.0.zip
 .. _validate.py: http://www.voidspace.org.uk/cgi-bin/voidspace/downman.py?file=validate.py
 .. _API Docs: http://www.voidspace.org.uk/python/configobj-api/
 .. _Subversion Repository: http://svn.rest2web.python-hosting.com/branches/configobj4/
@@ -203,8 +203,8 @@
     from validate import Validator
     #
     vtor = Validator()
-    newval1 = vtor.check(value1, 'integer')
-    newval2 = vtor.check(value2, 'bool')
+    newval1 = vtor.check('integer', value1)
+    newval2 = vtor.check('bool', value2)
     # etc ...
 
     {-coloring}
@@ -215,6 +215,7 @@
     them in ``try...except`` blocks. Better still,  use ConfigObj for a higher
     level interface.
 
+
 Using Validator
 ===============
 
@@ -332,6 +333,7 @@
     Although the value can be a string, if it represents a list it should
     already have been turned into a list of strings.
 
+
 Default Values
 ~~~~~~~~~~~~~~
 
@@ -365,6 +367,20 @@
 that this check contains no useful value when missing, i.e. the value is
 optional, and may be omitted without harm.
 
+
+List Values
+~~~~~~~~~~~
+
+It's possible that you would like your default value to be a list. It's even
+possible that you will write your own check functions - and would like to pass
+them keyword arguments as lists from within the check.
+
+To avoid confusing syntax with commas and quotes you use a list constructor to
+specify that keyword arguments are lists. This includes the ``default`` value.
+This makes checks look something like : ::
+
+    checkname(default=list('val1', 'val2', 'val3'))
+
 Validator Exceptions
 ====================
 
@@ -539,7 +555,7 @@
 
 * A regex check function ?
 * A timestamp check function ? (Using the ``parse`` function from ``DateUtil``).
-* Allow triple quotes ? (getting a bit heavy for a single regex)
+* Allow triple quotes ? (getting a bit heavy for a regex)
 
 ISSUES
 ======
@@ -549,15 +565,25 @@
     Please file any bug reports to `Michael Foord`_ or the ConfigObj
     `Mailing List`_.
 
-Lists passed as function arguments need additional quotes. Ugly, could do
-with fixing this.
-
 If we could pull tuples out of arguments, it would be easier
 to specify arguments for 'mixed_lists'.
 
 CHANGELOG
 =========
 
+2005/12/16      Version 0.2.1
+-----------------------------
+
+Fixed bug so we can handle keyword argument values with commas.
+
+We now use a list constructor for passing list values to keyword arguments
+(including ``default``) : ::
+
+    default=list("val", "val", "val")
+
+Added the ``_test`` test. {sm;:-)}
+
+Moved a function call outside a try...except block.
 
 2005/08/18      Version 0.2.0
 -----------------------------

=== modified file 'bzrlib/util/configobj/validate.py'
--- bzrlib/util/configobj/validate.py	2005-11-07 13:17:53 +0000
+++ bzrlib/util/configobj/validate.py	2006-03-20 08:31:00 +0000
@@ -6,7 +6,7 @@
 #         nico AT tekNico DOT net
 
 # This software is licensed under the terms of the BSD license.
-# http://www.voidspace.org.uk/documents/BSD-LICENSE.txt
+# http://www.voidspace.org.uk/python/license.shtml
 # Basically you're free to copy, modify, distribute and relicense it,
 # So long as you keep a copy of the license with it.
 
@@ -112,11 +112,21 @@
                 You specify this check with : ::
     
                   option('option 1', 'option 2', 'option 3')
+    
+    You can supply a default value (returned if no value is supplied)
+    using the default keyword argument.
+    
+    You specify a list argument for default using a list constructor syntax in
+    the check : ::
+    
+        checkname(arg1, arg2, default=list('val 1', 'val 2', 'val 3'))
+    
+    A badly formatted set of arguments will raise a ``VdtParamError``.
 """
 
 __docformat__ = "restructuredtext en"
 
-__version__ = '0.2.0'
+__version__ = '0.2.1'
 
 __revision__ = '$Id: validate.py 123 2005-09-08 08:54:28Z fuzzyman $'
 
@@ -159,6 +169,84 @@
 import re
 StringTypes = (str, unicode)
 
+
+_list_arg = re.compile(r'''
+    (?:
+        ([a-zA-Z_][a-zA-Z0-9_]*)\s*=\s*list\(
+            (
+                (?:
+                    \s*
+                    (?:
+                        (?:".*?")|              # double quotes
+                        (?:'.*?')|              # single quotes
+                        (?:[^'",\s\)][^,\)]*?)  # unquoted
+                    )
+                    \s*,\s*
+                )*
+                (?:
+                    (?:".*?")|              # double quotes
+                    (?:'.*?')|              # single quotes
+                    (?:[^'",\s\)][^,\)]*?)  # unquoted
+                )?                          # last one
+            )
+        \)
+    )
+''', re.VERBOSE)    # two groups
+
+_list_members = re.compile(r'''
+    (
+        (?:".*?")|              # double quotes
+        (?:'.*?')|              # single quotes
+        (?:[^'",\s=][^,=]*?)       # unquoted
+    )
+    (?:
+    (?:\s*,\s*)|(?:\s*$)            # comma
+    )
+''', re.VERBOSE)    # one group
+
+_paramstring = r'''
+    (?:
+        (
+            (?:
+                [a-zA-Z_][a-zA-Z0-9_]*\s*=\s*list\(
+                    (?:
+                        \s*
+                        (?:
+                            (?:".*?")|              # double quotes
+                            (?:'.*?')|              # single quotes
+                            (?:[^'",\s\)][^,\)]*?)       # unquoted
+                        )
+                        \s*,\s*
+                    )*
+                    (?:
+                        (?:".*?")|              # double quotes
+                        (?:'.*?')|              # single quotes
+                        (?:[^'",\s\)][^,\)]*?)       # unquoted
+                    )?                              # last one
+                \)
+            )|
+            (?:
+                (?:".*?")|              # double quotes
+                (?:'.*?')|              # single quotes
+                (?:[^'",\s=][^,=]*?)|       # unquoted
+                (?:                         # keyword argument
+                    [a-zA-Z_][a-zA-Z0-9_]*\s*=\s*
+                    (?:
+                        (?:".*?")|              # double quotes
+                        (?:'.*?')|              # single quotes
+                        (?:[^'",\s=][^,=]*?)       # unquoted
+                    )
+                )
+            )
+        )
+        (?:
+            (?:\s*,\s*)|(?:\s*$)            # comma
+        )
+    )
+    '''
+
+_matchstring = '^%s*' % _paramstring
+
 # Python pre 2.2.1 doesn't have bool
 try:
     bool
@@ -433,13 +521,25 @@
         http://www.voidspace.org.uk/python/configobj.html
     """
 
-    # this regex pulls values out of a comma separated line
-    _paramfinder = re.compile(r'''(?:'.*?')|(?:".*?")|(?:[^'",\s][^,]*)''')
-    # this regex is used for finding keyword arguments
-    _key_arg = re.compile(r'^([a-zA-Z_][a-zA-Z0-9_]*)\s*=\s*(.*)$')
     # this regex does the initial parsing of the checks
     _func_re = re.compile(r'(.+?)\((.*)\)')
 
+    # this regex takes apart keyword arguments
+    _key_arg = re.compile(r'^([a-zA-Z_][a-zA-Z0-9_]*)\s*=\s*(.*)$')
+
+
+    # this regex finds keyword=list(....) type values
+    _list_arg = _list_arg
+
+    # this regex takes individual values out of lists - in one pass
+    _list_members = _list_members
+
+    # These regexes check a set of arguments for validity
+    # and then pull the members out
+    _paramfinder = re.compile(_paramstring, re.VERBOSE)
+    _matchfinder = re.compile(_matchstring, re.VERBOSE)
+
+
     def __init__(self, functions=None):
         """
         >>> vtri = Validator()
@@ -487,23 +587,29 @@
         fun_match = self._func_re.match(check)
         if fun_match:
             fun_name = fun_match.group(1)
+            arg_string = fun_match.group(2)
+            arg_match = self._matchfinder.match(arg_string)
+            if arg_match is None:
+                # Bad syntax
+                raise VdtParamError
             fun_args = []
             fun_kwargs = {}
             # pull out args of group 2
-            for arg in self._paramfinder.findall(fun_match.group(2)):
+            for arg in self._paramfinder.findall(arg_string):
                 # args may need whitespace removing (before removing quotes)
                 arg = arg.strip()
+                listmatch = self._list_arg.match(arg)
+                if listmatch:
+                    key, val = self._list_handle(listmatch)
+                    fun_kwargs[key] = val
+                    continue
                 keymatch = self._key_arg.match(arg)
                 if keymatch:
-                    val = keymatch.group(2)
-                    if (val[0] in ("'", '"')) and (val[0] == val[-1]):
-                        val = val[1:-1]
+                    val = self._unquote(keymatch.group(2))
                     fun_kwargs[keymatch.group(1)] = val
                     continue
                 #
-                if (arg[0] in ("'", '"')) and (arg[0] == arg[-1]):
-                    arg = arg[1:-1]
-                fun_args.append(arg)
+                fun_args.append(self._unquote(arg))
         else:
             # allows for function names without (args)
             (fun_name, fun_args, fun_kwargs) = (check, (), {})
@@ -524,9 +630,28 @@
         except KeyError:
             pass
         try:
-            return self.functions[fun_name](value, *fun_args, **fun_kwargs)
+            fun = self.functions[fun_name]
         except KeyError:
             raise VdtUnknownCheckError(fun_name)
+        else:
+##            print fun_args
+##            print fun_kwargs
+            return fun(value, *fun_args, **fun_kwargs)
+
+    def _unquote(self, val):
+        """Unquote a value if necessary."""
+        if (len(val) > 2) and (val[0] in ("'", '"')) and (val[0] == val[-1]):
+            val = val[1:-1]
+        return val
+
+    def _list_handle(self, listmatch):
+        """Take apart a ``keyword=list('val, 'val')`` type string."""
+        out = []
+        name = listmatch.group(1)
+        args = listmatch.group(2)
+        for arg in self._list_members.findall(args):
+            out.append(self._unquote(arg))
+        return name, out
 
     def _pass(self, value):
         """
@@ -1059,6 +1184,47 @@
         raise VdtValueError(value)
     return value
 
+def _test(value, *args, **keywargs):
+    """
+    A function that exists for test purposes.
+    
+    >>> checks = [
+    ...     '3, 6, min=1, max=3, test=list(a, b, c)',
+    ...     '3',
+    ...     '3, 6',
+    ...     '3,',
+    ...     'min=1, test="a b c"',
+    ...     'min=5, test="a, b, c"',
+    ...     'min=1, max=3, test="a, b, c"',
+    ...     'min=-100, test=-99',
+    ...     'min=1, max=3',
+    ...     '3, 6, test="36"',
+    ...     '3, 6, test="a, b, c"',
+    ...     '3, max=3, test=list("a", "b", "c")',
+    ...     '''3, max=3, test=list("'a'", 'b', "x=(c)")''',
+    ...     "test='x=fish(3)'",
+    ...    ]
+    >>> v = Validator({'test': _test})
+    >>> for entry in checks:
+    ...     print v.check(('test(%s)' % entry), 3)
+    (3, ('3', '6'), {'test': ['a', 'b', 'c'], 'max': '3', 'min': '1'})
+    (3, ('3',), {})
+    (3, ('3', '6'), {})
+    (3, ('3',), {})
+    (3, (), {'test': 'a b c', 'min': '1'})
+    (3, (), {'test': 'a, b, c', 'min': '5'})
+    (3, (), {'test': 'a, b, c', 'max': '3', 'min': '1'})
+    (3, (), {'test': '-99', 'min': '-100'})
+    (3, (), {'max': '3', 'min': '1'})
+    (3, ('3', '6'), {'test': '36'})
+    (3, ('3', '6'), {'test': 'a, b, c'})
+    (3, ('3',), {'test': ['a', 'b', 'c'], 'max': '3'})
+    (3, ('3',), {'test': ["'a'", 'b', 'x=(c)'], 'max': '3'})
+    (3, (), {'test': 'x=fish(3)'})
+    """
+    return (value, args, keywargs)
+
+
 if __name__ == '__main__':
     # run the code tests in doctest format
     import doctest
@@ -1081,15 +1247,31 @@
     ISSUES
     ======
     
-    Lists passed as function arguments need additional quotes. Ugly, could do
-    with fixing this.
-    
     If we could pull tuples out of arguments, it would be easier
     to specify arguments for 'mixed_lists'.
     
     CHANGELOG
     =========
     
+    2005/12/16
+    ----------
+    
+    Fixed bug so we can handle keyword argument values with commas.
+    
+    We now use a list constructor for passing list values to keyword arguments
+    (including ``default``) : ::
+    
+        default=list("val", "val", "val")
+    
+    Added the ``_test`` test. {sm;:-)}
+    
+    0.2.1
+    
+    2005/12/12
+    ----------
+    
+    Moved a function call outside a try...except block.
+    
     2005/08/25
     ----------
     

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2006-01-25 14:30:06 +0000
+++ bzrlib/weave.py	2006-03-20 08:31:00 +0000
@@ -279,6 +279,8 @@
 
         # if we abort after here the (in-memory) weave will be corrupt because only
         # some fields are updated
+        # XXX: FIXME implement a succeed-or-fail of the rest of this routine.
+        #      - Robert Collins 20060226
         self._parents.append(parents[:])
         self._sha1s.append(sha1)
         self._names.append(name)
@@ -318,7 +320,7 @@
         # another small special case: a merge, producing the same text
         # as auto-merge
         if text == basis_lines:
-            return new_version            
+            return new_version
 
         # add a sentinal, because we can also match against the final line
         basis_lineno.append(len(self._weave))
@@ -746,7 +748,7 @@
 
 
 
-    def weave_merge(self, plan):
+    def weave_merge(self, plan, a_marker='<<<<<<< \n', b_marker='>>>>>>> \n'):
         lines_a = []
         lines_b = []
         ch_a = ch_b = False
@@ -768,11 +770,11 @@
                 elif lines_a == lines_b:
                     for l in lines_a: yield l
                 else:
-                    yield '<<<<<<<\n'
+                    yield a_marker
                     for l in lines_a: yield l
                     yield '=======\n'
                     for l in lines_b: yield l
-                    yield '>>>>>>>\n'
+                    yield b_marker
 
                 del lines_a[:]
                 del lines_b[:]
@@ -799,7 +801,7 @@
                        state
 
 
-    def join(self, other):
+    def join(self, other, pb=None, msg=None):
         import sys, time
         """Integrate versions from other into this weave.
 
@@ -809,43 +811,55 @@
 
         It is illegal for the two weaves to contain different values 
         or different parents for any version.  See also reweave().
+
+        :param other: The other weave to pull into this one
+        :param pb: An optional progress bar
+        :param msg: An optional message to display for progress
         """
         if other.numversions() == 0:
             return          # nothing to update, easy
         # two loops so that we do not change ourselves before verifying it
         # will be ok
         # work through in index order to make sure we get all dependencies
+        names_to_join = []
+        processed = 0
         for other_idx, name in enumerate(other._names):
             self._check_version_consistent(other, other_idx, name)
+            sha1 = other._sha1s[other_idx]
+
+            processed += 1
+
+            if name in self._name_map:
+                idx = self.lookup(name)
+                n1 = set(map(other.idx_to_name, other._parents[other_idx]))
+                n2 = set(map(self.idx_to_name, self._parents[idx]))
+                if sha1 ==  self._sha1s[idx] and n1 == n2:
+                        continue
+
+            names_to_join.append((other_idx, name))
+
+        if pb and not msg:
+            msg = 'weave join'
 
         merged = 0
-        processed = 0
         time0 = time.time( )
-        for other_idx, name in enumerate(other._names):
+        for other_idx, name in names_to_join:
             # TODO: If all the parents of the other version are already
             # present then we can avoid some work by just taking the delta
             # and adjusting the offsets.
             new_parents = self._imported_parents(other, other_idx)
             sha1 = other._sha1s[other_idx]
 
-            processed += 1
+            merged += 1
+
+            if pb:
+                pb.update(msg, merged, len(names_to_join))
            
-            if name in self._names:
-                idx = self.lookup(name)
-                n1 = map(other.idx_to_name, other._parents[other_idx] )
-                n2 = map(self.idx_to_name, self._parents[other_idx] )
-                if sha1 ==  self._sha1s[idx] and n1 == n2:
-                        continue
-
-            merged += 1
             lines = other.get_lines(other_idx)
             self.add(name, new_parents, lines, sha1)
 
         mutter("merged = %d, processed = %d, file_id=%s; deltat=%d"%(
-                merged,processed,self._weave_name, time.time( )-time0))
-
-
-
+                merged, processed, self._weave_name, time.time( )-time0))
  
     def _imported_parents(self, other, other_idx):
         """Return list of parents in self corresponding to indexes in other."""
@@ -879,10 +893,8 @@
                                  % (name))
             self_parents = self._parents[this_idx]
             other_parents = other._parents[other_idx]
-            n1 = [self._names[i] for i in self_parents]
-            n2 = [other._names[i] for i in other_parents]
-            n1.sort()
-            n2.sort()
+            n1 = set([self._names[i] for i in self_parents])
+            n2 = set([other._names[i] for i in other_parents])
             if n1 != n2:
                 raise WeaveParentMismatch("inconsistent parents "
                     "for version {%s}: %s vs %s" % (name, n1, n2))
@@ -891,14 +903,19 @@
         else:
             return False
 
-    def reweave(self, other):
-        """Reweave self with other."""
-        new_weave = reweave(self, other)
+    def reweave(self, other, pb=None, msg=None):
+        """Reweave self with other.
+
+        :param other: The other weave to merge
+        :param pb: An optional progress bar, indicating how far done we are
+        :param msg: An optional message for the progress
+        """
+        new_weave = reweave(self, other, pb=pb, msg=msg)
         for attr in self.__slots__:
             setattr(self, attr, getattr(new_weave, attr))
 
 
-def reweave(wa, wb):
+def reweave(wa, wb, pb=None, msg=None):
     """Combine two weaves and return the result.
 
     This works even if a revision R has different parents in 
@@ -909,6 +926,9 @@
     might be possible but it should only be necessary to do 
     this operation rarely, when a new previously ghost version is 
     inserted.
+
+    :param pb: An optional progress bar, indicating how far done we are
+    :param msg: An optional message for the progress
     """
     wr = Weave()
     ia = ib = 0
@@ -920,11 +940,25 @@
     mutter("combined parents: %r", combined_parents)
     order = topo_sort(combined_parents.iteritems())
     mutter("order to reweave: %r", order)
-    for name in order:
+
+    if pb and not msg:
+        msg = 'reweave'
+
+    for idx, name in enumerate(order):
+        if pb:
+            pb.update(msg, idx, len(order))
         if name in wa._name_map:
             lines = wa.get_lines(name)
             if name in wb._name_map:
-                assert lines == wb.get_lines(name)
+                lines_b = wb.get_lines(name)
+                if lines != lines_b:
+                    mutter('Weaves differ on content. rev_id {%s}', name)
+                    mutter('weaves: %s, %s', wa._weave_name, wb._weave_name)
+                    import difflib
+                    lines = list(difflib.unified_diff(lines, lines_b,
+                            wa._weave_name, wb._weave_name))
+                    mutter('lines:\n%s', ''.join(lines))
+                    raise errors.WeaveTextDiffers(name, wa, wb)
         else:
             lines = wb.get_lines(name)
         wr.add(name, combined_parents[name], lines)

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2006-01-25 14:30:06 +0000
+++ bzrlib/workingtree.py	2006-03-20 08:31:00 +0000
@@ -25,13 +25,11 @@
 At the moment every WorkingTree has its own branch.  Remote
 WorkingTrees aren't supported.
 
-To get a WorkingTree, call Branch.working_tree():
+To get a WorkingTree, call bzrdir.open_workingtree() or
+WorkingTree.open(dir).
 """
 
 
-# TODO: Don't allow WorkingTrees to be constructed for remote branches if 
-# they don't work.
-
 # FIXME: I don't know if writing out the cache from the destructor is really a
 # good idea, because destructors are considered poor taste in Python, and it's
 # not predictable when it will be written out.
@@ -43,39 +41,57 @@
 # At the momenthey may alias the inventory and have old copies of it in memory.
 
 from copy import deepcopy
+from cStringIO import StringIO
+import errno
+import fnmatch
 import os
 import stat
-import fnmatch
  
+
+from bzrlib.atomicfile import AtomicFile
 from bzrlib.branch import (Branch,
-                           is_control_file,
-                           needs_read_lock,
-                           needs_write_lock,
                            quotefn)
+import bzrlib.bzrdir as bzrdir
+from bzrlib.decorators import needs_read_lock, needs_write_lock
+import bzrlib.errors as errors
 from bzrlib.errors import (BzrCheckError,
                            BzrError,
                            DivergedBranches,
                            WeaveRevisionNotPresent,
                            NotBranchError,
+                           NoSuchFile,
                            NotVersionedError)
-from bzrlib.inventory import InventoryEntry
-from bzrlib.osutils import (appendpath,
+from bzrlib.inventory import InventoryEntry, Inventory
+from bzrlib.lockable_files import LockableFiles, TransportLock
+from bzrlib.merge import merge_inner, transform_tree
+from bzrlib.osutils import (
+                            abspath,
+                            appendpath,
                             compact_date,
                             file_kind,
                             isdir,
                             getcwd,
                             pathjoin,
                             pumpfile,
+                            safe_unicode,
                             splitpath,
                             rand_bytes,
-                            abspath,
                             normpath,
                             realpath,
                             relpath,
-                            rename)
+                            rename,
+                            supports_executable,
+                            )
+from bzrlib.progress import DummyProgress
+from bzrlib.revision import NULL_REVISION
+from bzrlib.symbol_versioning import *
 from bzrlib.textui import show_status
 import bzrlib.tree
 from bzrlib.trace import mutter
+from bzrlib.transform import build_tree
+from bzrlib.transport import get_transport
+from bzrlib.transport.local import LocalTransport
+import bzrlib.ui
 import bzrlib.xml5
 
 
@@ -178,7 +194,13 @@
     not listed in the Inventory and vice versa.
     """
 
-    def __init__(self, basedir=u'.', branch=None):
+    def __init__(self, basedir='.',
+                 branch=DEPRECATED_PARAMETER,
+                 _inventory=None,
+                 _control_files=None,
+                 _internal=False,
+                 _format=None,
+                 _bzrdir=None):
         """Construct a WorkingTree for basedir.
 
         If the branch is not supplied, it is opened automatically.
@@ -186,16 +208,54 @@
         (branch.base is not cross checked, because for remote branches that
         would be meaningless).
         """
+        self._format = _format
+        self.bzrdir = _bzrdir
+        if not _internal:
+            # not created via open etc.
+            warn("WorkingTree() is deprecated as of bzr version 0.8. "
+                 "Please use bzrdir.open_workingtree or WorkingTree.open().",
+                 DeprecationWarning,
+                 stacklevel=2)
+            wt = WorkingTree.open(basedir)
+            self.branch = wt.branch
+            self.basedir = wt.basedir
+            self._control_files = wt._control_files
+            self._hashcache = wt._hashcache
+            self._set_inventory(wt._inventory)
+            self._format = wt._format
+            self.bzrdir = wt.bzrdir
         from bzrlib.hashcache import HashCache
         from bzrlib.trace import note, mutter
         assert isinstance(basedir, basestring), \
             "base directory %r is not a string" % basedir
-        if branch is None:
-            branch = Branch.open(basedir)
-        assert isinstance(branch, Branch), \
-            "branch %r is not a Branch" % branch
-        self.branch = branch
+        basedir = safe_unicode(basedir)
+        mutter("opening working tree %r", basedir)
+        if deprecated_passed(branch):
+            if not _internal:
+                warn("WorkingTree(..., branch=XXX) is deprecated as of bzr 0.8."
+                     " Please use bzrdir.open_workingtree() or WorkingTree.open().",
+                     DeprecationWarning,
+                     stacklevel=2
+                     )
+            self.branch = branch
+        else:
+            self.branch = self.bzrdir.open_branch()
+        assert isinstance(self.branch, Branch), \
+            "branch %r is not a Branch" % self.branch
         self.basedir = realpath(basedir)
+        # if branch is at our basedir and is a format 6 or less
+        if isinstance(self._format, WorkingTreeFormat2):
+            # share control object
+            self._control_files = self.branch.control_files
+        elif _control_files is not None:
+            assert False, "not done yet"
+#            self._control_files = _control_files
+        else:
+            # only ready for format 3
+            assert isinstance(self._format, WorkingTreeFormat3)
+            self._control_files = LockableFiles(
+                self.bzrdir.get_workingtree_transport(None),
+                'lock', TransportLock)
 
         # update the whole cache up front and write to disk if anything changed;
         # in the future we might want to do this more selectively
@@ -203,20 +263,48 @@
         # if needed, or, when the cache sees a change, append it to the hash
         # cache file, and have the parser take the most recent entry for a
         # given path only.
-        hc = self._hashcache = HashCache(basedir)
+        cache_filename = self.bzrdir.get_workingtree_transport(None).abspath('stat-cache')
+        hc = self._hashcache = HashCache(basedir, cache_filename, self._control_files._file_mode)
         hc.read()
+        # is this scan needed ? it makes things kinda slow.
         hc.scan()
 
         if hc.needs_write:
             mutter("write hc")
             hc.write()
 
-        self._set_inventory(self.read_working_inventory())
+        if _inventory is None:
+            self._set_inventory(self.read_working_inventory())
+        else:
+            self._set_inventory(_inventory)
 
     def _set_inventory(self, inv):
         self._inventory = inv
         self.path2id = self._inventory.path2id
 
+    def is_control_filename(self, filename):
+        """True if filename is the name of a control file in this tree.
+        
+        This is true IF and ONLY IF the filename is part of the meta data
+        that bzr controls in this tree. I.E. a random .bzr directory placed
+        on disk will not be a control file for this tree.
+        """
+        try:
+            self.bzrdir.transport.relpath(self.abspath(filename))
+            return True
+        except errors.PathNotChild:
+            return False
+
+    @staticmethod
+    def open(path=None, _unsupported=False):
+        """Open an existing working tree at path.
+
+        """
+        if path is None:
+            path = os.path.getcwdu()
+        control = bzrdir.BzrDir.open(path, _unsupported)
+        return control.open_workingtree(_unsupported)
+        
     @staticmethod
     def open_containing(path=None):
         """Open an existing working tree which has its root about path.
@@ -229,27 +317,17 @@
         If there is one, it is returned, along with the unused portion of path.
         """
         if path is None:
-            path = getcwd()
-        else:
-            # sanity check.
-            if path.find('://') != -1:
-                raise NotBranchError(path=path)
-        path = abspath(path)
-        tail = u''
-        while True:
-            try:
-                return WorkingTree(path), tail
-            except NotBranchError:
-                pass
-            if tail:
-                tail = pathjoin(os.path.basename(path), tail)
-            else:
-                tail = os.path.basename(path)
-            lastpath = path
-            path = os.path.dirname(path)
-            if lastpath == path:
-                # reached the root, whatever that may be
-                raise NotBranchError(path=path)
+            path = os.getcwdu()
+        control, relpath = bzrdir.BzrDir.open_containing(path)
+        return control.open_workingtree(), relpath
+
+    @staticmethod
+    def open_downlevel(path=None):
+        """Open an unsupported working tree.
+
+        Only intended for advanced situations like upgrading part of a bzrdir.
+        """
+        return WorkingTree.open(path, _unsupported=True)
 
     def __iter__(self):
         """Iterate through file_ids for this tree.
@@ -268,6 +346,57 @@
 
     def abspath(self, filename):
         return pathjoin(self.basedir, filename)
+    
+    def basis_tree(self):
+        """Return RevisionTree for the current last revision."""
+        revision_id = self.last_revision()
+        if revision_id is not None:
+            try:
+                xml = self.read_basis_inventory(revision_id)
+                inv = bzrlib.xml5.serializer_v5.read_inventory_from_string(xml)
+                return bzrlib.tree.RevisionTree(self.branch.repository, inv,
+                                                revision_id)
+            except NoSuchFile:
+                pass
+        return self.branch.repository.revision_tree(revision_id)
+
+    @staticmethod
+    @deprecated_method(zero_eight)
+    def create(branch, directory):
+        """Create a workingtree for branch at directory.
+
+        If existing_directory already exists it must have a .bzr directory.
+        If it does not exist, it will be created.
+
+        This returns a new WorkingTree object for the new checkout.
+
+        TODO FIXME RBC 20060124 when we have checkout formats in place this
+        should accept an optional revisionid to checkout [and reject this if
+        checking out into the same dir as a pre-checkout-aware branch format.]
+
+        XXX: When BzrDir is present, these should be created through that 
+        interface instead.
+        """
+        warn('delete WorkingTree.create', stacklevel=3)
+        transport = get_transport(directory)
+        if branch.bzrdir.root_transport.base == transport.base:
+            # same dir 
+            return branch.bzrdir.create_workingtree()
+        # different directory, 
+        # create a branch reference
+        # and now a working tree.
+        raise NotImplementedError
+ 
+    @staticmethod
+    @deprecated_method(zero_eight)
+    def create_standalone(directory):
+        """Create a checkout and a branch and a repo at directory.
+
+        Directory must exist and be empty.
+
+        please use BzrDir.create_standalone_workingtree
+        """
+        return bzrdir.BzrDir.create_standalone_workingtree(directory)
 
     def relpath(self, abs):
         """Return the local path portion from a given absolute path."""
@@ -291,10 +420,52 @@
         ## XXX: badly named; this is not in the store at all
         return self.abspath(self.id2path(file_id))
 
+    @needs_read_lock
+    def clone(self, to_bzrdir, revision_id=None, basis=None):
+        """Duplicate this working tree into to_bzr, including all state.
+        
+        Specifically modified files are kept as modified, but
+        ignored and unknown files are discarded.
+
+        If you want to make a new line of development, see bzrdir.sprout()
+
+        revision
+            If not None, the cloned tree will have its last revision set to 
+            revision, and and difference between the source trees last revision
+            and this one merged in.
+
+        basis
+            If not None, a closer copy of a tree which may have some files in
+            common, and which file content should be preferentially copied from.
+        """
+        # assumes the target bzr dir format is compatible.
+        result = self._format.initialize(to_bzrdir)
+        self.copy_content_into(result, revision_id)
+        return result
+
+    @needs_read_lock
+    def copy_content_into(self, tree, revision_id=None):
+        """Copy the current content and user files of this tree into tree."""
+        if revision_id is None:
+            transform_tree(tree, self)
+        else:
+            # TODO now merge from tree.last_revision to revision
+            transform_tree(tree, self)
+            tree.set_last_revision(revision_id)
+
     @needs_write_lock
-    def commit(self, *args, **kw):
+    def commit(self, message=None, revprops=None, *args, **kwargs):
+        # avoid circular imports
         from bzrlib.commit import Commit
-        Commit().commit(self.branch, *args, **kw)
+        if revprops is None:
+            revprops = {}
+        if not 'branch-nick' in revprops:
+            revprops['branch-nick'] = self.branch.nick
+        # args for wt.commit start at message from the Commit.commit method,
+        # but with branch a kwarg now, passing in args as is results in the
+        #message being used for the branch
+        args = (DEPRECATED_PARAMETER, message, ) + args
+        Commit().commit(working_tree=self, revprops=revprops, *args, **kwargs)
         self._set_inventory(self.read_working_inventory())
 
     def id2abspath(self, file_id):
@@ -324,7 +495,7 @@
         return self._hashcache.get_sha1(path)
 
     def is_executable(self, file_id):
-        if os.name == "nt":
+        if not supports_executable():
             return self._inventory[file_id].executable
         else:
             path = self._inventory.id2path(file_id)
@@ -369,7 +540,7 @@
 
         inv = self.read_working_inventory()
         for f,file_id in zip(files, ids):
-            if is_control_file(f):
+            if self.is_control_filename(f):
                 raise BzrError("cannot add control file %s" % quotefn(f))
 
             fp = splitpath(f)
@@ -381,7 +552,9 @@
 
             try:
                 kind = file_kind(fullpath)
-            except OSError:
+            except OSError, e:
+                if e.errno == errno.ENOENT:
+                    raise NoSuchFile(fullpath)
                 # maybe something better?
                 raise BzrError('cannot add: not a regular file, symlink or directory: %s' % quotefn(f))
 
@@ -410,23 +583,27 @@
         if updated:
             self.set_pending_merges(p)
 
+    @needs_read_lock
     def pending_merges(self):
         """Return a list of pending merges.
 
         These are revisions that have been merged into the working
         directory but not yet committed.
         """
-        cfn = self.branch._rel_controlfilename('pending-merges')
-        if not self.branch._transport.has(cfn):
+        try:
+            merges_file = self._control_files.get_utf8('pending-merges')
+        except OSError, e:
+            if e.errno != errno.ENOENT:
+                raise
             return []
         p = []
-        for l in self.branch.controlfile('pending-merges', 'r').readlines():
+        for l in merges_file.readlines():
             p.append(l.rstrip('\n'))
         return p
 
     @needs_write_lock
     def set_pending_merges(self, rev_list):
-        self.branch.put_controlfile('pending-merges', '\n'.join(rev_list))
+        self._control_files.put_utf8('pending-merges', '\n'.join(rev_list))
 
     def get_symlink_target(self, file_id):
         return os.readlink(self.id2abspath(file_id))
@@ -439,7 +616,6 @@
         else:
             return '?'
 
-
     def list_files(self):
         """Recursively list all files as (path, class, kind, id).
 
@@ -459,7 +635,9 @@
                 ## TODO: If we find a subdirectory with its own .bzr
                 ## directory, then that is a separate tree and we
                 ## should exclude it.
-                if bzrlib.BZRDIR == f:
+
+                # the bzrdir for this tree
+                if self.bzrdir.transport.base.endswith(f + '/'):
                     continue
 
                 # path within tree
@@ -636,9 +814,10 @@
         These are files in the working directory that are not versioned or
         control files or ignored.
         
-        >>> from bzrlib.branch import ScratchBranch
-        >>> b = ScratchBranch(files=['foo', 'foo~'])
-        >>> tree = WorkingTree(b.base, b)
+        >>> from bzrlib.bzrdir import ScratchDir
+        >>> d = ScratchDir(files=['foo', 'foo~'])
+        >>> b = d.open_branch()
+        >>> tree = d.open_workingtree()
         >>> map(str, tree.unknowns())
         ['foo']
         >>> tree.add('foo')
@@ -663,21 +842,25 @@
                 yield stem
 
     @needs_write_lock
-    def pull(self, source, overwrite=False):
-        from bzrlib.merge import merge_inner
+    def pull(self, source, overwrite=False, stop_revision=None):
         source.lock_read()
         try:
             old_revision_history = self.branch.revision_history()
-            count = self.branch.pull(source, overwrite)
+            basis_tree = self.basis_tree()
+            count = self.branch.pull(source, overwrite, stop_revision)
             new_revision_history = self.branch.revision_history()
             if new_revision_history != old_revision_history:
                 if len(old_revision_history):
                     other_revision = old_revision_history[-1]
                 else:
                     other_revision = None
+                repository = self.branch.repository
                 merge_inner(self.branch,
-                            self.branch.basis_tree(), 
-                            self.branch.revision_tree(other_revision))
+                            self.branch.basis_tree(),
+                            basis_tree, 
+                            this_tree=self, 
+                            pb=bzrlib.ui.ui_factory.progress_bar())
+                self.set_last_revision(self.branch.last_revision())
             return count
         finally:
             source.unlock()
@@ -776,44 +959,91 @@
     def kind(self, file_id):
         return file_kind(self.id2abspath(file_id))
 
+    @needs_read_lock
+    def last_revision(self):
+        """Return the last revision id of this working tree.
+
+        In early branch formats this was == the branch last_revision,
+        but that cannot be relied upon - for working tree operations,
+        always use tree.last_revision().
+        """
+        return self.branch.last_revision()
+
     def lock_read(self):
         """See Branch.lock_read, and WorkingTree.unlock."""
-        return self.branch.lock_read()
+        self.branch.lock_read()
+        try:
+            return self._control_files.lock_read()
+        except:
+            self.branch.unlock()
+            raise
 
     def lock_write(self):
         """See Branch.lock_write, and WorkingTree.unlock."""
-        return self.branch.lock_write()
+        self.branch.lock_write()
+        try:
+            return self._control_files.lock_write()
+        except:
+            self.branch.unlock()
+            raise
 
     def _basis_inventory_name(self, revision_id):
         return 'basis-inventory.%s' % revision_id
 
+    @needs_write_lock
     def set_last_revision(self, new_revision, old_revision=None):
-        if old_revision:
-            try:
-                path = self._basis_inventory_name(old_revision)
-                path = self.branch._rel_controlfilename(path)
-                self.branch._transport.delete(path)
-            except:
-                pass
-        try:
-            xml = self.branch.get_inventory_xml(new_revision)
+        """Change the last revision in the working tree."""
+        self._remove_old_basis(old_revision)
+        if self._change_last_revision(new_revision):
+            self._cache_basis_inventory(new_revision)
+
+    def _change_last_revision(self, new_revision):
+        """Template method part of set_last_revision to perform the change."""
+        if new_revision is None:
+            self.branch.set_revision_history([])
+            return False
+        # current format is locked in with the branch
+        revision_history = self.branch.revision_history()
+        try:
+            position = revision_history.index(new_revision)
+        except ValueError:
+            raise errors.NoSuchRevision(self.branch, new_revision)
+        self.branch.set_revision_history(revision_history[:position + 1])
+        return True
+
+    def _cache_basis_inventory(self, new_revision):
+        """Cache new_revision as the basis inventory."""
+        try:
+            xml = self.branch.repository.get_inventory_xml(new_revision)
             path = self._basis_inventory_name(new_revision)
-            self.branch.put_controlfile(path, xml)
+            self._control_files.put_utf8(path, xml)
         except WeaveRevisionNotPresent:
             pass
 
+    def _remove_old_basis(self, old_revision):
+        """Remove the old basis inventory 'old_revision'."""
+        if old_revision is not None:
+            try:
+                path = self._basis_inventory_name(old_revision)
+                path = self._control_files._escape(path)
+                self._control_files._transport.delete(path)
+            except NoSuchFile:
+                pass
+
     def read_basis_inventory(self, revision_id):
         """Read the cached basis inventory."""
         path = self._basis_inventory_name(revision_id)
-        return self.branch.controlfile(path, 'r').read()
+        return self._control_files.get_utf8(path).read()
         
     @needs_read_lock
     def read_working_inventory(self):
         """Read the working inventory."""
         # ElementTree does its own conversion from UTF-8, so open in
         # binary.
-        f = self.branch.controlfile('inventory', 'rb')
-        return bzrlib.xml5.serializer_v5.read_inventory(f)
+        result = bzrlib.xml5.serializer_v5.read_inventory(
+            self._control_files.get('inventory'))
+        self._set_inventory(result)
+        return result
 
     @needs_write_lock
     def remove(self, files, verbose=False):
@@ -857,14 +1087,12 @@
         self._write_inventory(inv)
 
     @needs_write_lock
-    def revert(self, filenames, old_tree=None, backups=True):
-        from bzrlib.merge import merge_inner
+    def revert(self, filenames, old_tree=None, backups=True, 
+               pb=DummyProgress()):
+        from transform import revert
         if old_tree is None:
-            old_tree = self.branch.basis_tree()
-        merge_inner(self.branch, old_tree,
-                    self, ignore_zero=True,
-                    backup_files=backups, 
-                    interesting_files=filenames)
+            old_tree = self.basis_tree()
+        revert(self, old_tree, filenames, backups, pb)
         if not len(filenames):
             self.set_pending_merges([])
 
@@ -901,7 +1129,7 @@
         inv._byid[inv.root.file_id] = inv.root
         for fid in inv:
             entry = inv[fid]
-            if entry.parent_id in (None, orig_root_id):
+            if entry.parent_id == orig_root_id:
                 entry.parent_id = inv.root.file_id
         self._write_inventory(inv)
 
@@ -914,30 +1142,376 @@
         between multiple working trees, i.e. via shared storage, then we 
         would probably want to lock both the local tree, and the branch.
         """
-        if self._hashcache.needs_write and self.branch._lock_count==1:
+        # FIXME: We want to write out the hashcache only when the last lock on
+        # this working copy is released.  Peeking at the lock count is a bit
+        # of a nasty hack; probably it's better to have a transaction object,
+        # which can do some finalization when it's either successfully or
+        # unsuccessfully completed.  (Denys's original patch did that.)
+        # RBC 20060206 hookinhg into transaction will couple lock and transaction
+        # wrongly. Hookinh into unllock on the control files object is fine though.
+        
+        # TODO: split this per format so there is no ugly if block
+        if self._hashcache.needs_write and (
+            # dedicated lock files
+            self._control_files._lock_count==1 or 
+            # shared lock files
+            (self._control_files is self.branch.control_files and 
+             self._control_files._lock_count==3)):
             self._hashcache.write()
-        return self.branch.unlock()
+        # reverse order of locking.
+        result = self._control_files.unlock()
+        try:
+            self.branch.unlock()
+        finally:
+            return result
+
+    @needs_write_lock
+    def update(self):
+        """Update a working tree along its branch.
+
+        This will update the branch if its bound too, which means we have multiple trees involved:
+        The new basis tree of the master.
+        The old basis tree of the branch.
+        The old basis tree of the working tree.
+        The current working tree state.
+        pathologically all three may be different, and non ancestors of each other.
+        Conceptually we want to:
+        Preserve the wt.basis->wt.state changes
+        Transform the wt.basis to the new master basis.
+        Apply a merge of the old branch basis to get any 'local' changes from it into the tree.
+        Restore the wt.basis->wt.state changes.
+
+        There isn't a single operation at the moment to do that, so we:
+        Merge current state -> basis tree of the master w.r.t. the old tree basis.
+        Do a 'normal' merge of the old branch basis if it is relevant.
+        """
+        old_tip = self.branch.update()
+        if old_tip is not None:
+            self.add_pending_merge(old_tip)
+        self.branch.lock_read()
+        try:
+            result = 0
+            if self.last_revision() != self.branch.last_revision():
+                # merge tree state up to new branch tip.
+                basis = self.basis_tree()
+                to_tree = self.branch.basis_tree()
+                result += merge_inner(self.branch,
+                                      to_tree,
+                                      basis,
+                                      this_tree=self)
+                self.set_last_revision(self.branch.last_revision())
+            if old_tip and old_tip != self.last_revision():
+                # our last revision was not the prior branch last reivison
+                # and we have converted that last revision to a pending merge.
+                # base is somewhere between the branch tip now
+                # and the now pending merge
+                from bzrlib.revision import common_ancestor
+                try:
+                    base_rev_id = common_ancestor(self.branch.last_revision(),
+                                                  old_tip,
+                                                  self.branch.repository)
+                except errors.NoCommonAncestor:
+                    base_rev_id = None
+                base_tree = self.branch.repository.revision_tree(base_rev_id)
+                other_tree = self.branch.repository.revision_tree(old_tip)
+                result += merge_inner(self.branch,
+                                      other_tree,
+                                      base_tree,
+                                      this_tree=self)
+            return result
+        finally:
+            self.branch.unlock()
 
     @needs_write_lock
     def _write_inventory(self, inv):
         """Write inventory as the current inventory."""
-        from cStringIO import StringIO
-        from bzrlib.atomicfile import AtomicFile
         sio = StringIO()
         bzrlib.xml5.serializer_v5.write_inventory(inv, sio)
         sio.seek(0)
-        f = AtomicFile(self.branch.controlfilename('inventory'))
-        try:
-            pumpfile(sio, f)
-            f.commit()
-        finally:
-            f.close()
+        self._control_files.put('inventory', sio)
         self._set_inventory(inv)
         mutter('wrote working inventory')
-            
+
+
+class WorkingTree3(WorkingTree):
+    """This is the Format 3 working tree.
+
+    This differs from the base WorkingTree by:
+     - having its own file lock
+     - having its own last-revision property.
+    """
+
+    @needs_read_lock
+    def last_revision(self):
+        """See WorkingTree.last_revision."""
+        try:
+            return self._control_files.get_utf8('last-revision').read()
+        except NoSuchFile:
+            return None
+
+    def _change_last_revision(self, revision_id):
+        """See WorkingTree._change_last_revision."""
+        if revision_id is None or revision_id == NULL_REVISION:
+            try:
+                self._control_files._transport.delete('last-revision')
+            except errors.NoSuchFile:
+                pass
+            return False
+        else:
+            try:
+                self.branch.revision_history().index(revision_id)
+            except ValueError:
+                raise errors.NoSuchRevision(self.branch, revision_id)
+            self._control_files.put_utf8('last-revision', revision_id)
+            return True
+
 
 CONFLICT_SUFFIXES = ('.THIS', '.BASE', '.OTHER')
 def get_conflicted_stem(path):
     for suffix in CONFLICT_SUFFIXES:
         if path.endswith(suffix):
             return path[:-len(suffix)]
+
+@deprecated_function(zero_eight)
+def is_control_file(filename):
+    """See WorkingTree.is_control_filename(filename)."""
+    ## FIXME: better check
+    filename = normpath(filename)
+    while filename != '':
+        head, tail = os.path.split(filename)
+        ## mutter('check %r for control file' % ((head, tail),))
+        if tail == '.bzr':
+            return True
+        if filename == head:
+            break
+        filename = head
+    return False
+
+
+class WorkingTreeFormat(object):
+    """An encapsulation of the initialization and open routines for a format.
+
+    Formats provide three things:
+     * An initialization routine,
+     * a format string,
+     * an open routine.
+
+    Formats are placed in an dict by their format string for reference 
+    during workingtree opening. Its not required that these be instances, they
+    can be classes themselves with class methods - it simply depends on 
+    whether state is needed for a given format or not.
+
+    Once a format is deprecated, just deprecate the initialize and open
+    methods on the format class. Do not deprecate the object, as the 
+    object will be created every time regardless.
+    """
+
+    _default_format = None
+    """The default format used for new trees."""
+
+    _formats = {}
+    """The known formats."""
+
+    @classmethod
+    def find_format(klass, a_bzrdir):
+        """Return the format for the working tree object in a_bzrdir."""
+        try:
+            transport = a_bzrdir.get_workingtree_transport(None)
+            format_string = transport.get("format").read()
+            return klass._formats[format_string]
+        except NoSuchFile:
+            raise errors.NoWorkingTree(base=transport.base)
+        except KeyError:
+            raise errors.UnknownFormatError(format_string)
+
+    @classmethod
+    def get_default_format(klass):
+        """Return the current default format."""
+        return klass._default_format
+
+    def get_format_string(self):
+        """Return the ASCII format string that identifies this format."""
+        raise NotImplementedError(self.get_format_string)
+
+    def is_supported(self):
+        """Is this format supported?
+
+        Supported formats can be initialized and opened.
+        Unsupported formats may not support initialization or committing or 
+        some other features depending on the reason for not being supported.
+        """
+        return True
+
+    @classmethod
+    def register_format(klass, format):
+        klass._formats[format.get_format_string()] = format
+
+    @classmethod
+    def set_default_format(klass, format):
+        klass._default_format = format
+
+    @classmethod
+    def unregister_format(klass, format):
+        assert klass._formats[format.get_format_string()] is format
+        del klass._formats[format.get_format_string()]
+
+
+
+class WorkingTreeFormat2(WorkingTreeFormat):
+    """The second working tree format. 
+
+    This format modified the hash cache from the format 1 hash cache.
+    """
+
+    def initialize(self, a_bzrdir, revision_id=None):
+        """See WorkingTreeFormat.initialize()."""
+        if not isinstance(a_bzrdir.transport, LocalTransport):
+            raise errors.NotLocalUrl(a_bzrdir.transport.base)
+        branch = a_bzrdir.open_branch()
+        if revision_id is not None:
+            branch.lock_write()
+            try:
+                revision_history = branch.revision_history()
+                try:
+                    position = revision_history.index(revision_id)
+                except ValueError:
+                    raise errors.NoSuchRevision(branch, revision_id)
+                branch.set_revision_history(revision_history[:position + 1])
+            finally:
+                branch.unlock()
+        revision = branch.last_revision()
+        inv = Inventory() 
+        wt = WorkingTree(a_bzrdir.root_transport.base,
+                         branch,
+                         inv,
+                         _internal=True,
+                         _format=self,
+                         _bzrdir=a_bzrdir)
+        wt._write_inventory(inv)
+        wt.set_root_id(inv.root.file_id)
+        wt.set_last_revision(revision)
+        wt.set_pending_merges([])
+        build_tree(wt.basis_tree(), wt)
+        return wt
+
+    def __init__(self):
+        super(WorkingTreeFormat2, self).__init__()
+        self._matchingbzrdir = bzrdir.BzrDirFormat6()
+
+    def open(self, a_bzrdir, _found=False):
+        """Return the WorkingTree object for a_bzrdir
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already been done.
+        """
+        if not _found:
+            # we are being called directly and must probe.
+            raise NotImplementedError
+        if not isinstance(a_bzrdir.transport, LocalTransport):
+            raise errors.NotLocalUrl(a_bzrdir.transport.base)
+        return WorkingTree(a_bzrdir.root_transport.base,
+                           _internal=True,
+                           _format=self,
+                           _bzrdir=a_bzrdir)
+
+
+class WorkingTreeFormat3(WorkingTreeFormat):
+    """The second working tree format updated to record a format marker.
+
+    This format modified the hash cache from the format 1 hash cache.
+    """
+
+    def get_format_string(self):
+        """See WorkingTreeFormat.get_format_string()."""
+        return "Bazaar-NG Working Tree format 3"
+
+    def initialize(self, a_bzrdir, revision_id=None):
+        """See WorkingTreeFormat.initialize().
+        
+        revision_id allows creating a working tree at a differnet
+        revision than the branch is at.
+        """
+        if not isinstance(a_bzrdir.transport, LocalTransport):
+            raise errors.NotLocalUrl(a_bzrdir.transport.base)
+        transport = a_bzrdir.get_workingtree_transport(self)
+        control_files = LockableFiles(transport, 'lock', TransportLock)
+        control_files.put_utf8('format', self.get_format_string())
+        branch = a_bzrdir.open_branch()
+        if revision_id is None:
+            revision_id = branch.last_revision()
+        inv = Inventory() 
+        wt = WorkingTree3(a_bzrdir.root_transport.base,
+                         branch,
+                         inv,
+                         _internal=True,
+                         _format=self,
+                         _bzrdir=a_bzrdir)
+        wt._write_inventory(inv)
+        wt.set_root_id(inv.root.file_id)
+        wt.set_last_revision(revision_id)
+        wt.set_pending_merges([])
+        build_tree(wt.basis_tree(), wt)
+        return wt
+
+    def __init__(self):
+        super(WorkingTreeFormat3, self).__init__()
+        self._matchingbzrdir = bzrdir.BzrDirMetaFormat1()
+
+    def open(self, a_bzrdir, _found=False):
+        """Return the WorkingTree object for a_bzrdir
+
+        _found is a private parameter, do not use it. It is used to indicate
+               if format probing has already been done.
+        """
+        if not _found:
+            # we are being called directly and must probe.
+            raise NotImplementedError
+        if not isinstance(a_bzrdir.transport, LocalTransport):
+            raise errors.NotLocalUrl(a_bzrdir.transport.base)
+        return WorkingTree3(a_bzrdir.root_transport.base,
+                           _internal=True,
+                           _format=self,
+                           _bzrdir=a_bzrdir)
+
+    def __str__(self):
+        return self.get_format_string()
+
+
+# formats which have no format string are not discoverable
+# and not independently creatable, so are not registered.
+__default_format = WorkingTreeFormat3()
+WorkingTreeFormat.register_format(__default_format)
+WorkingTreeFormat.set_default_format(__default_format)
+_legacy_formats = [WorkingTreeFormat2(),
+                   ]
+
+
+class WorkingTreeTestProviderAdapter(object):
+    """A tool to generate a suite testing multiple workingtree formats at once.
+
+    This is done by copying the test once for each transport and injecting
+    the transport_server, transport_readonly_server, and workingtree_format
+    classes into each copy. Each copy is also given a new id() to make it
+    easy to identify.
+    """
+
+    def __init__(self, transport_server, transport_readonly_server, formats):
+        self._transport_server = transport_server
+        self._transport_readonly_server = transport_readonly_server
+        self._formats = formats
+    
+    def adapt(self, test):
+        from bzrlib.tests import TestSuite
+        result = TestSuite()
+        for workingtree_format, bzrdir_format in self._formats:
+            new_test = deepcopy(test)
+            new_test.transport_server = self._transport_server
+            new_test.transport_readonly_server = self._transport_readonly_server
+            new_test.bzrdir_format = bzrdir_format
+            new_test.workingtree_format = workingtree_format
+            def make_new_test_id():
+                new_id = "%s(%s)" % (new_test.id(), workingtree_format.__class__.__name__)
+                return lambda: new_id
+            new_test.id = make_new_test_id()
+            result.addTest(new_test)
+        return result

=== removed file 'bzrlib/xml.py'
--- bzrlib/xml.py	2006-01-25 14:30:06 +0000
+++ bzrlib/xml.py	1970-01-01 00:00:00 +0000
@@ -1,73 +0,0 @@
-# -*- coding: UTF-8 -*-
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""XML externalization support."""
-
-# "XML is like violence: if it doesn't solve your problem, you aren't
-# using enough of it." -- various
-
-# importing this module is fairly slow because it has to load several
-# ElementTree bits
-
-from bzrlib.trace import mutter, warning
-
-try:
-    from cElementTree import (ElementTree, SubElement, Element,
-                              XMLTreeBuilder, fromstring, tostring)
-except ImportError:
-    mutter('WARNING: using slower ElementTree; consider installing cElementTree'
-           " and make sure it's on your PYTHONPATH")
-    from util.elementtree.ElementTree import (ElementTree, SubElement,
-                                              Element, XMLTreeBuilder,
-                                              fromstring, tostring)
-
-from bzrlib.errors import BzrError
-
-
-class Serializer(object):
-    """Abstract object serialize/deserialize"""
-    def write_inventory(self, inv, f):
-        """Write inventory to a file"""
-        elt = self._pack_inventory(inv)
-        self._write_element(elt, f)
-
-    def write_inventory_to_string(self, inv):
-        return tostring(self._pack_inventory(inv)) + '\n'
-
-    def read_inventory_from_string(self, xml_string):
-        return self._unpack_inventory(fromstring(xml_string))
-
-    def read_inventory(self, f):
-        return self._unpack_inventory(self._read_element(f))
-
-    def write_revision(self, rev, f):
-        self._write_element(self._pack_revision(rev), f)
-
-    def write_revision_to_string(self, rev):
-        return tostring(self._pack_revision(rev)) + '\n'
-
-    def read_revision(self, f):
-        return self._unpack_revision(self._read_element(f))
-
-    def read_revision_from_string(self, xml_string):
-        return self._unpack_revision(fromstring(xml_string))
-
-    def _write_element(self, elt, f):
-        ElementTree(elt).write(f, 'utf-8')
-        f.write('\n')
-
-    def _read_element(self, f):
-        return ElementTree().parse(f)

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2006-01-25 14:30:06 +0000
+++ bzrlib/xml4.py	2006-03-20 08:31:00 +0000
@@ -13,7 +13,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib.xml import ElementTree, SubElement, Element, Serializer
+from bzrlib.xml_serializer import ElementTree, SubElement, Element, Serializer
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
 from bzrlib.revision import Revision        

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2006-01-25 14:30:06 +0000
+++ bzrlib/xml5.py	2006-03-20 08:31:00 +0000
@@ -13,7 +13,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib.xml import ElementTree, SubElement, Element, Serializer
+from bzrlib.xml_serializer import ElementTree, SubElement, Element, Serializer
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
 from bzrlib.revision import Revision        

=== added file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	1970-01-01 00:00:00 +0000
+++ bzrlib/xml_serializer.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,73 @@
+# -*- coding: UTF-8 -*-
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""XML externalization support."""
+
+# "XML is like violence: if it doesn't solve your problem, you aren't
+# using enough of it." -- various
+
+# importing this module is fairly slow because it has to load several
+# ElementTree bits
+
+from bzrlib.trace import mutter, warning
+
+try:
+    from cElementTree import (ElementTree, SubElement, Element,
+                              XMLTreeBuilder, fromstring, tostring)
+except ImportError:
+    mutter('WARNING: using slower ElementTree; consider installing cElementTree'
+           " and make sure it's on your PYTHONPATH")
+    from util.elementtree.ElementTree import (ElementTree, SubElement,
+                                              Element, XMLTreeBuilder,
+                                              fromstring, tostring)
+
+from bzrlib.errors import BzrError
+
+
+class Serializer(object):
+    """Abstract object serialize/deserialize"""
+    def write_inventory(self, inv, f):
+        """Write inventory to a file"""
+        elt = self._pack_inventory(inv)
+        self._write_element(elt, f)
+
+    def write_inventory_to_string(self, inv):
+        return tostring(self._pack_inventory(inv)) + '\n'
+
+    def read_inventory_from_string(self, xml_string):
+        return self._unpack_inventory(fromstring(xml_string))
+
+    def read_inventory(self, f):
+        return self._unpack_inventory(self._read_element(f))
+
+    def write_revision(self, rev, f):
+        self._write_element(self._pack_revision(rev), f)
+
+    def write_revision_to_string(self, rev):
+        return tostring(self._pack_revision(rev)) + '\n'
+
+    def read_revision(self, f):
+        return self._unpack_revision(self._read_element(f))
+
+    def read_revision_from_string(self, xml_string):
+        return self._unpack_revision(fromstring(xml_string))
+
+    def _write_element(self, elt, f):
+        ElementTree(elt).write(f, 'utf-8')
+        f.write('\n')
+
+    def _read_element(self, f):
+        return ElementTree().parse(f)

=== modified file 'contrib/pwk'
--- contrib/pwk	2005-11-07 13:17:53 +0000
+++ contrib/pwk	2006-03-20 08:31:00 +0000
@@ -10,9 +10,6 @@
 PWK_ROOT='http://patchwork.ozlabs.org/bazaar-ng'
 PWK_AUTH_ROOT='https://patchwork.ozlabs.org/bazaar-ng'
 
-# bzr uses -p0 style; others use -p1
-PATCH_OPTS='-p0'
-
 usage() {
     cat <<EOF
 usage: 
@@ -42,12 +39,12 @@
     catpatch $2 | ${PAGER:-less}
     ;;
 try)
-    catpatch $2 | patch -p0 --dry-run
+    catpatch $2 | patch -p1 --dry-run
     ;;
 apply)
-    catpatch $2 | patch -p0
+    catpatch $2 | patch -p1
     ;;
 *)
     usage
     exit 1
-esac
\ No newline at end of file
+esac

=== added file 'debian/bzr.dirs'
--- debian/bzr.dirs	1970-01-01 00:00:00 +0000
+++ debian/bzr.dirs	2006-03-20 08:31:00 +0000
@@ -0,0 +1,2 @@
+etc/bash_completion.d/
+usr/share/lintian/overrides/

=== modified file 'debian/changelog'
--- debian/changelog	2006-01-25 14:30:06 +0000
+++ debian/changelog	2006-03-20 08:31:00 +0000
@@ -1,3 +1,12 @@
+bzr (0.8~200603200831-0ubuntu1) dapper; urgency=low
+
+  * Snapshot uploaded to Dapper at Martin Pool's request.
+  
+  * Disable testsuite for upload.  Fakeroot and the testsuite don't
+    play along.
+
+ -- Jeff Bailey <jbailey@ubuntu.com>  Mon, 20 Mar 2006 08:31:00 -0500
+
 bzr (0.7-2) unstable; urgency=low
 
   * Update copyright file (closes: #345128).

=== modified file 'debian/control'
--- debian/control	2006-01-25 14:30:06 +0000
+++ debian/control	2006-03-20 08:31:00 +0000
@@ -8,7 +8,9 @@
 
 Package: bzr
 Architecture: all
-Depends: python2.4-celementtree, python2.4
+Depends: python2.4-elementtree, python2.4, python2.4-paramiko
+Recommends: python-pycurl
+Conflicts: bzr-integration
 Suggests: libxml2-utils
 Description: bazaar-ng, the next-generation distributed version control system
  Open source distributed version control system that is powerful, friendly,

=== modified file 'debian/overrides/bzr'
--- debian/overrides/bzr	2005-11-07 13:17:53 +0000
+++ debian/overrides/bzr	2006-03-20 08:31:00 +0000
@@ -16,4 +16,6 @@
 bzr: script-not-executable ./usr/lib/python2.4/site-packages/bzrlib/selftest/test_weave.py
 bzr: script-not-executable ./usr/lib/python2.4/site-packages/bzrlib/store/weave.py
 bzr: script-not-executable ./usr/lib/python2.4/site-packages/bzrlib/xml5.py
+bzr: script-not-executable ./usr/lib/python2.4/site-packages/bzrlib/uncommit.py
+bzr: script-not-executable ./usr/lib/python2.4/site-packages/bzrlib/tests/test_weave.py
 

=== modified file 'debian/rules'
--- debian/rules	2006-01-25 14:30:06 +0000
+++ debian/rules	2006-03-20 08:31:00 +0000
@@ -12,8 +12,4 @@
 	rm -f ./bzr.1
 
 common-post-build-indep::	
-	./bzr selftest
-
-build/bzr::
-	python2.4 ./bzr_man.py
-
+	#./bzr selftest -v

=== removed file 'doc/Makefile'
--- doc/Makefile	2005-11-07 13:17:53 +0000
+++ doc/Makefile	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-all: $(addsuffix .html,$(basename $(wildcard *.txt))) todo.html
-
-clean:
-	-rm *.html
-
-%.html: %.txt
-	rest2html $^ > $@.tmp && mv $@.tmp $@
-
-todo.html: ../TODO
-	rest2html $^ > $@.tmp && mv $@.tmp $@
-
-
-
-upload: all
-	rsync -av \
-	./ \
-	escudero.ubuntu.com:/srv/www.bazaar-ng.org/www/doc/ \
-	--delete \
-	--include \*.html --exclude \* 
-

=== removed file 'doc/adoption.txt'
--- doc/adoption.txt	2005-11-07 13:17:53 +0000
+++ doc/adoption.txt	1970-01-01 00:00:00 +0000
@@ -1,118 +0,0 @@
-****************
-Driving adoption
-****************
-
-Getting adoption means persuading people that it's a good choice.
-
-
-I think the key is to have something that key project leaders see as
-worth using.  Imagine what it would take to get tridge, havoc, or akpm
-to switch.  Or not even to switch, but to even just try it out.
-
-* Simple operations must be simple.
-
-* The project and the implementation must not have bad smells.
-
-* Given their current understanding of the problem, there must be at
-  one feature that's clearly better than what they're currently
-  using.
-
-
-What holds it back now?
-
-* Too complex on initial impression
-
-* Bad smell from having so many forks/wrappers/kooky opinions
-
-* Some of the more exotic features can only be appreciated on
-  familiarity
-
-* It doesn't actually achieve by default a lot of the advantages that
-  it ought to: for example it still blocks on the network
-
-
-Good features at the moment
-
-* Archive storage is clean; probably makes a favorable impression on
-  people who look at it
-
-* Relatively few dependencies (if you don't look too closely at
-  hackerlab, etc)
-
-
-From `Ben Collins-Sussman`__
-
-__ http://www.red-bean.com/sussman/svn-anti-fud.html
-
-   If you're learning about Subversion and thinking of using it in
-   your group or company, please approach it the way you'd approach
-   any new product: with caution. This isn't to say that Subversion is
-   unreliable... but that doesn't mean you shouldn't use some common
-   sense either. Don't blindly jump into the deep end without a
-   test-drive. No user wants a new product forced upon them, and if
-   you're going to be responsible for administering the system, you
-   better have some familiarity with it before rolling it out to
-   everyone. Find a smallish project, and set it up as a "pilot" for
-   Subversion. Ask for enthusiastic volunteers to test-drive the
-   experiment. In the end, if Subversion turns out to be a good fit,
-   you'll have much happier developers (who have been part of the
-   process from the start) and you'll be ready to support a larger
-   installation as well. [...]
-
-   When Subversion hit "alpha" it was already being used by dozens of private developers and shops for real work. Any other project probably would have called the product "1.0" at that point, but we deliberately decided to delay that label as long as possible. Because we're talking managing people's irreplaceable data, the project was extremely conservative about labeling something 1.0. We were aware that many people were waiting for that label before using Subversion, and had very specific expectations about the meaning of that label. So we stuck to that standard. All it takes is one high-profile case of data loss to destroy an SCM's reputation.
-
-
-`John S. Yates, Jr.`__:
-
-__ http://lists.gnu.org/archive/html/gnu-arch-users/2004-10/msg00370.html
-
-  First let me say that I have nothing but increasing respect for
-  Tom's skills and accomplishments.
-  
-  That said I see Gnu Arch as really just emerging from a period
-  of prototype development.  If the project really wants to take
-  over the world, and especially supplant projects with momentum
-  and commercial customers (e.g. Subversion, BitKeeper, etc) then
-  I would warn against two mistakes I have experienced repeatedly
-  in my career:
-  
-  1) Deferring to a tiny installed base instead of focusing on
-     eliminating barriers to adoption
-  
-  2) Believing that great technology will be irresistible no matter
-     how it is presented
-  
-  Appearances matter.  Expectations matter.  Standards (official
-  or de facto) matter.
-
-There is also a `reply from Tom`__.
-
-__ http://lists.gnu.org/archive/html/gnu-arch-users/2004-10/msg00430.html
-
-Clear wins
-----------
-
-To convince people to use Baz, there has to be some feature they can
-clearly understand which will be much better under Baz.  It must be
-something they do today.
-
-* Offline support
-
-* Almost no network delays
-
-* Atomic changes (svn already has this)
-
-* Correct repeated merges
-
-* Read-only mirroring archives (not really important) 
-
-My model is that people will consider changing if 
-
-1. it's at least as good as cvs/svn
-2. AND there are no big concerns about implementation/safety
-3. AND there is at least one feature which is easy to use and a big win
-
-This gets you to some people at least trying it.  Will people migrate
-big projects to it?  Maybe, if it looks safe, it fixes there problem,
-and it doesn't look like something substantially better is on the
-horizon.

=== removed file 'doc/bitkeeper.txt'
--- doc/bitkeeper.txt	2005-11-07 13:17:53 +0000
+++ doc/bitkeeper.txt	1970-01-01 00:00:00 +0000
@@ -1,24 +0,0 @@
-Bitkeeper compared to Arch
-==========================
-
-BK has a default GUI, which is good, but it's ugly and not all that
-friendly to the new user.  It does pay attention to allowing quick
-keyboard navigation.
-
-The tool itself is also a bit unfriendly in terms of emitting a lot of
-noise messages and having lots of weird commands.
-
-Bitkeeper always requires both per-file and per-changeset commands.
-It seems bad to always require this; at most per-file messages should
-be optional.  Are they really the best option?
-
-Claimed to have extremely space-efficient storage, keeping 19 years of
-history in slightly more than twice the size of the working copy. 
-
-Hashes: does Baz always have these even without signing?  It really
-should.
-
-Fine-grained event triggers, pre- and post-event.
-
-Can remotely find status of a tree, e.g. parent, number of comitters,
-versioned files, extras, modified, etc. 

=== removed file 'doc/changelogs.txt'
--- doc/changelogs.txt	2005-11-07 13:17:53 +0000
+++ doc/changelogs.txt	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-**********
-ChangeLogs
-**********
-
-Changelogs have an interesting relation to version control systems.
-They are, for some projects, the primary way of examining history.
-They provide a pattern and standard for writing commit history, which
-may encourage people to enter more details (function names, etc) in a
-systematic way than they otherwise might.  The ChangeLog is available
-offline, in tarfiles, or even when the project has been switched into
-a different VCS.
-
-GNU ChangeLog format is only the most important, not the only such
-file.  Debian uses a different format for packages.  At a higher
-level, 
-
-At the same time the information there is some redundancy: both the
-ChangeLog and the VCS want to hold the description of what has been
-done, including descriptive text, names of files changed, etc.
-
-Some people say__ that ChangeLogs are mostly needed because of the
-limitations of CVS (and originally RCS): if it was easy to read the VC
-history when disconnected and at local speed, and if there are atomic
-commits then they might be needed rather less.
-
-__ http://gcc.gnu.org/ml/gcc/2004-06/msg00270.html
-
-There should be hooks called to create the log message template and
-before committing it.  These might, for example, populate it with
-space for per-file comments, or check that it is in the right format.

=== removed file 'doc/cherry-picking.txt'
--- doc/cherry-picking.txt	2005-11-07 13:17:53 +0000
+++ doc/cherry-picking.txt	1970-01-01 00:00:00 +0000
@@ -1,42 +0,0 @@
-**************
-Cherry picking
-**************
-
-Bazaar-NG allows you to try to 'cherry pick' changes from one branch
-to another.  That is to say that you can merge across only the changes
-from a particular commit, without getting anything else from that
-branch.
-
-However, because of dependencies in the source, it's not always very
-practical to pick changes out of a widely-diverged branch.  The
-general principle is that it's easier to keep things separate and
-combine them later than to mix things up and try to separate them.
-
-Therefore, we suggest using branches for each line of development that
-might want to separately merge.  Create a branch for each major
-feature; create branches for code that is ready to go upstream and for
-code that is very experimental.  Branches are cheap.  As changes pass
-through these branches they accumulate interesting metadata.
-
-Design
-------
-
-There is little that a tool can do to help with merges once you start
-cherry-picking changes; we need to rely on the merge tool detecting
-that some changes have already been applied.
-
-We should note that the changes have already come across, but I don't
-see many places where that will be terribly helpful.
-
-Sometimes a succession of cherry picks will be equivalent to merging
-the whole history up to some point, in which case we can fall back to
-a proper merge.
-
-When choosing a merge ancestor I think knowing non-contiguous
-cherry-picked changes will not help.
-
-Cherry-picking is equivalent to putting the merge ancestor just before
-the changeset(s) to be picked in.  So we can do this regardless of
-whether we have the whole history of the tree.
-
-

=== removed file 'doc/cmdref.txt'
--- doc/cmdref.txt	2005-11-07 13:17:53 +0000
+++ doc/cmdref.txt	1970-01-01 00:00:00 +0000
@@ -1,789 +0,0 @@
-***********************
-Reference for Bazaar-NG
-***********************
-
-:Author: Martin Pool
-:Copyright: Copyright 2004, 2005 Martin Pool; GNU GPL v2
-
-.. contents::
-
-
-
-Generalities
-------------
-
-Note that this document refers to many features which are not
-implemented yet.  Some may never be implemented.
-
-The top level command is ``bzr``.  Everything else is invoked as a
-subcommand of that, as is common in version control systems.
-
-A source directory containing some files to be versioned is called a
-*tree*; this contains a number of *files* and possibly some
-subdirectories.  The point of bzr is to keep track of the *versions*
-(or *revisions*) of the tree at various points in time.  A sequence of
-versions of a tree form a *branch*.  All branches begin with the empty
-directory, called the null revision.  Two branches may have some
-revisions in common and then *diverge* later -- which is why they're
-called branches.  We can distinguish the *working copy* of the files,
-which is available for modification, from their previous versions.
-
-Each file has a unique *file-id*, which remains the same for the life
-of the file, even when files are renamed.  Files also have a *kind*,
-which can currently be *file* or *directory*, and which cannot change
-for any file-id.
-
-The difference between two revisions is a *changeset*.  Changesets
-include the textual changes to files, the affected file-ids, the date
-of the change, the author, the name of the branch.  Changesets have a
-globally unique identifier.
-
-A changeset committed to a branch is *local* to that branch; otherwise
-it is foreign.  (Note that a changeset may be local to several
-different branches if it was created prior to their divergence.)
-
-Changesets may include a note that they *incorporate* other
-changesets; this is used when changes are merged from one branch into
-another.  After changes have been merged but before they are committed
-they are listed as *pending merges*; when they are committed they are
-listed within their changeset.
-
-All files in a versioned directory can be divided into four classes:
-
-Versioned
-  Anything assigned a file-id.  Changes to these files are tracked.
-Control
-  Anything under ``.bzr/``.  Should not be edited by users.
-Ignored
-  Anything matching an ignore pattern.  As the name suggests, ignored
-  by Bazaar.
-Unknown
-  Everything else.  Generally ignored, except that they are reported
-  as 'unknown' and can be added by a recursive add_.
-
-We say a tree, or a file, is *unmodified* if it is the same as in the
-most recent version, or *modified* otherwise.
-
-*Committing* creates a new revision equal to the current state of the
-tree.  Immediately after committing, all files are unmodified, since
-they are the same as the just-committed state.
-
-
-
-
-File states
------------
-
-A file is in exactly one of these *states*.  These are identified by
-single characters which should be familiar to people used to svn/cvs.
-
-?, Unknown
-    Not versioned, ignored, or control.
-    Typically new files that should be versioned or
-    ignored but have not been marked as either yet.
-., Up-to-date
-    This versioned file is the same as in the last revision on this
-    branch.  (The file had the same name and text and properties in
-    the previous revision.)
-A, Added
-    This file will be added by the next commit.  (The file ID was not
-    present in the previous revision.)
-M, Modified
-    This file has been changed from the previous revision and will be
-    recorded in the next commit.  (The file had the same name but
-    different text in the previous revision.)  Directories have no 
-    text and so can never be in this state.
-D, Deleted
-    This file has been removed from the inventory or deleted in the 
-    working copy and will be removed in the next revision.
-R, Renamed
-    This file had a different name in the previous revision; the next
-    commit will record the new name.  The file text may also have been
-    modified.
-
-These are only summaries, not complete descriptions.  For example the
-'D' state does not distinguish between a file removed by the remove_
-command and one whose text has been deleted.  (There should perhaps be
-a variation of the ``info`` command, or a ``file-info`` that shows
-enough details.)
-
-A directory may be up-to-date even if some files inside it have
-different states.
-
-.. _pinned: pinned.html
-
-
-
-Global options
---------------
-
-These can be applied to many or all commands.
-
---help     Show help, either globally or for the selected command.
-
--v, --verbose  Show progress/explanatory information.  This is good if
-               for example using a slow network and you want to see
-               that something is happening.
-
---debug    Show way too much detail about files being opened, locking,
-           etc.  Intended for
-
---silent   Show nothing but errors.  (Perhaps unnecessary; you could
-           just redirect stdout to /dev/null.)
-
---version  Show version and quit.
-
---dry-run         Show what would be done, but don't make any
-                  permanent changes.
-
---directory DIR   Operate in given directory rather than cwd.
-                  (Perhaps this should be ``-d``, but that might be
-                  better saved for ``--delete``.  Perhaps -b?)
-
---recurse, -R     When a directory name is given, operate not only on
-                  that directory but also any files or directories
-                  contained within it.
-
-                  (XXX: Should this be on by default?  It will often
-                  be what people want, but also possibly more
-                  surprising.  If it is, we will want a
-                  ``--no-recurse``.)
-
---force           Relax safety checks.
-
---format=FORMAT
-   Choose output format; options might include XML, YAML, text.
-
---id-only
-    Only update the inventory, don't touch the working copy.  (May
-    need a better name.)
-
---show-ids
-    List file ids, as well as names.
-
-
-
-init
-----
-
-Create bzr control files in the current directory::
-
-    bzr init
-
-Use this, followed by add_ and then commit_ to import or start a new
-project.
-
-
-
-add
----
-
-Add one or more files or directories to the branch::
-
-    bzr add FILE...
-
-Each added file is assigned a new file-id, and will be in the Added
-state.  They will be recorded in the next commit that covers that
-file, and then in the Up-to-date state.
-
-+-------------+-------------------------------------------------+
-|File state   |Action                                           |
-+=============+=================================================+
-|?            |New file id given to file; now in A state        |
-+-------------+-------------------------------------------------+
-|I            |"Adding previously ignored file"; now in A       |
-+-------------+-------------------------------------------------+
-|Z, ZM        |Add file with new ID; now in A state.            |
-|             |(To get the old ID back, use revert_ on that     |
-|             |file.)                                           |
-+-------------+-------------------------------------------------+
-|U, A, M, R,  |Warning "already added"; no change               |
-|RM           |                                                 |
-+-------------+-------------------------------------------------+
-|!, D         |Error "no such file"; no change                  |
-+-------------+-------------------------------------------------+
-|#            |Error "cannot add control file"; no change       |
-+-------------+-------------------------------------------------+
-
---id ID
-      Add file with given ID rather than a random UUID.  Error if this
-      id is assigned to any other file.  (not implemented yet)
-
---recurse
-    Add directory and all Unknown children, recursively.  This
-    includes U children of previously-added subdirectories.
-    (not implemented yet)
-
-This command will add any new source files, except for those matching
-ignore rules::
-
-  $ bzr add --recurse .
-
-(Note: I hope this might satisfy people who are fond of arch
-name-based tagging, and who dislike individually adding & removing
-files.  All they need to do is set up the appropriate ignore patterns,
-then 'add -R .' and they're done.)
-
-
-remove
-------
-
-Make a file no longer be versioned, and record its deletion from the
-inventory::
-
-    $ bzr remove FILE...
-
-This does not remove the working copy.  If you wish to both remove the
-working copy and unregister the file, you can simply delete it using
-regular ``rm``.  This is the opposite of add_.
-
-:State table:
-
-+--------------+--------------------------------------------------+
-| File state   | Action                                           |
-+==============+==================================================+
-| M, R, RM, .  | File to D state.                                 |
-+--------------+--------------------------------------------------+
-| A            | File back to I or ? state                        |
-+--------------+--------------------------------------------------+
-| I, ?, Z, ZM  | Error, no change                                 |
-+--------------+--------------------------------------------------+
-| !            | Change to D                                      |
-+--------------+--------------------------------------------------+
-| D            | Warning "already deleted"                        |
-+--------------+--------------------------------------------------+
-| #            | "Cannot remove control file"                     |
-+--------------+--------------------------------------------------+
-
-
-
-diff
-----
-
-Show all changes compared to the pristine as a text changeset.
-
---full      Include details for even binary files, uuencoded.  Makes the
-            diff long but lossless.
-
-
-
-export
-------
-
-::
-
-    bzr export TO-DIR
-
-Copy the tree, but leave out Bazaar-NG control files.  This includes copying
-uncommitted changes.
-
-This is equivalent to copying the branch and then deleting the control
-directory (except more efficient).
-
-Should this also delete any other control files like ``.bzrignore``?
-
-
-
-status
-------
-
-Show which files are added/deleted/modified/unknown/missing/etc, as in
-subversion.
-
-Given the ``--check`` option, returns non-zero if there are any
-uncommitted changes.
-
-
-
-info
-----
-
-Display various information items about the branch.  Can be given
-various options to pull out particular fields for easier use in
-scripts.
-
-Should include:
-
-* branch name
-* parent
-* number of revisions
-* number of files that are versioned/modified/deleted/added/unknown
-* number of versioned directories
-* branch format version
-* number of people who have made commits
-* date of last commit
-
-
-
-delta
------
-
-Compute a two-way non-history-sensitive delta from one branch or
-version to another.  Basically a smart diff between the two.
-
-(Perhaps this should just be a ``--format`` option to diff_?)
-
-
-
-merge
------
-
-Merge changes in from another branch, and leave them uncommitted in
-this tree::
-
-   merge [FROM-BRANCH]
-
-This makes a note of the revisions which were merged.
-
-A range of revisions may be specified to cherry-pick changes from that
-branch, or to merge changes only up to a certain point.
-
-Merge refuses to run if there are uncommitted changes unless forced,
-so that merged changes don't get mixed up with your own changes.
-
-You can use a merge rather than an update to accomplish any of several
-things:
-
-* Merge in a patch, but modify it to either suit your taste or fix
-  textual or semantic conflicts.
-
-* Collapse several merged patches into a single changeset.  A feature
-  may go through many revisions when being developed on its own
-  branch, but you might want to hide that detail when it merges onto a
-  main branch.
-
---revision RANGE  Merge only selected revisions, rather than
-                  everything that's not present yet.
-
-Before a merge is committed, it may be reversed with the revert_
-command.
-
-
-
-sync
-----
-
-::
-
-    sync [OTHER-BRANCH]
-
---revision RANGE  Pull only selected revisions.
-
-Synchronize mirrored branches.
-
-A mirror branch is a branch that strictly follows a parent branch,
-without any changes being committed to it.  This is useful in several
-ways:
-
-* Moving a backup of a branch onto another machine to protect against
-  disk failure or laptop theft.
-
-* Making the complete history of a upstream branch available for
-  offline use.
-
-The result is the same as copying the whole branch, but it is more
-efficient for remote branches because only newly-added changesets are
-moved.   The result is similar to rsync except it respects Bzr locking.
-
-The same command can be used for push mirrors (changesets are moved
-from this branch to the other) or pull mirrors (vice versa).  Bzr
-automatically determines which to do by looking at which branch has
-more patches.   (Perhaps it would be clearer to have separate *push*
-and *pull* commands?)
-
-This command can only be used when the history of one branch is a
-subset of the other.  If you commit different changes to both
-branches, then ``sync`` will say that the branches have diverged and
-it will refuse to run.  This command also refuses to run if the
-destination branch has any uncommitted changes.  Uncommitted changes
-on the origin are not copied.
-
-Method:
-
-* Get the ordered list of change ids on both branches.
-
-* One list should be a prefix of the other; if not, fail.  The shorter
-  list will be the destination branch.
-
-* Check the destination has no uncommitted changes.
-
-* For each change present only in the origin, download it to the
-  destination, add to the changeset history and update the tree and
-  control files.
-
-
-
-commit
-------
-
-::
-
-   commit MESSAGE [WHAT]
-
-Commit changes from the working copy into the branch.  By default
-commits everything, but can be given a list of files directories or
-files.
-
-Partial commits (not implemented yet) should ideally be allowed even when the partial thing
-you want to commit is an add, delete or rename.  Partial commits are
-**not** allowed if patches have been merged in this change.
-
-Method:
-
-* check preconditions
-* get log, if not present or given on command line
-* re-check preconditions
-* calculate diff from pristine to working copy
-* store this diff, plus headers, into the patches directory
-* add the diff to the list of applied patches
-* update pristine tree
-
-Commit can optionally run some pre-commit and post-commit hooks,
-passing them the delta which will be applied; this might mail the
-delta or apply it to an export and run a test case there.
-
-:State table:
-
-+-------------+-------------------------------------------------+
-|File state   |After commit                                     |
-+=============+=================================================+
-|?, I, #      |Unchanged                                        |
-+-------------+-------------------------------------------------+
-|A, M, R, RM  |Recorded, U                                      |
-+-------------+-------------------------------------------------+
-|D            |Gone                                             |
-+-------------+-------------------------------------------------+
-|Z, ZM        |Recorded, working copy remains as I or ?         |
-+-------------+-------------------------------------------------+
-|!            |Error "file is missing"; must be deleted or      |
-|             |reverted before commit                           |
-+-------------+-------------------------------------------------+
-
-
-
-lint
-----
-
-Check for problems in the working copy.
-
-+-------------+-------------------------------------------------+
-|File state   |Lint output                                      |
-+=============+=================================================+
-|?            |"Unknown file, please add/ignore/remove"         |
-+-------------+-------------------------------------------------+
-|Z, ZM        |"Zombie file, please add/ignore/remove/revert"   |
-+-------------+-------------------------------------------------+
-|!            |"File is missing, please recreate, delete or     |
-|             |revert."                                         |
-+-------------+-------------------------------------------------+
-|A, M, D, R,  |No output                                        |
-|RM, #, I     |                                                 |
-+-------------+-------------------------------------------------+
-
-
-
-check
------
-
-Run various consistency/sanity checks on the branch.  These might
-include:
-
-* Make sure all patches named by the inventory exist.
-
-* No patch IDs are duplicated.
-
-* Make sure hash of each patch is correct.
-
-* Starting at zero, apply each patch and make sure it does not
-  conflict.
-
-* All files named in inventory are reasonable.
-
-* No file IDs are duplicated in inventory.
-
-* Possibly many more.
-
-* No patches are in both ``patch-history`` and ``merged-patches``.
-
-* The patches in the bag are exactly those listed in ``patch-history``.
-
-Maybe add a separate option to say that you believe the tree is clean.
-
-
-
-backout
--------
-
-Reverse the changes made by previous changesets::
-
-   bzr backout REVISION
-   bzr backout REV1 REV2
-
-If a single revision is given, that single changeset is backed out.
-If two revisions are given, all changes in that range are backed out.
-
-The change that is reversed need not be the most recently committed
-change, but if there are revisions after the ones to be reverse which
-depend on them this command may cause conflicts.
-
-This undoes the changes but remembers that it was once applied, so it
-will not be merged again.  Anyone who pulls from later versions of
-this tree will also have that patch reversed.
-
-You can backout a backout patch, etc, which will restore the previous changes.
-
-This leaves the changeset prepared but not committed; after doing this
-you should commit it if you want.
-
-You can also backout only the parts of  a changeset touching a
-particular file or subdirectory::
-
-  bzr reverse foo.c@31
-
-
-revert
-------
-
-Undo changes to the working copy of files or directories, and discard
-any pending merge notes::
-
-  $ bzr revert [FILE...]
-
-If no files are specified, the entire tree is reverted, which is
-equivalent to specifying the top-level directory.  In either case, the
-list of pending merges is also cleared.
-
-This does not affect history, only the working copy.  A corollary is
-that if no changes have been made to the working copy, this does
-nothing.
-
-If a file was Modified, it is returned to the last committed state,
-reversing changes to the working copy.  If the file has been Added, it
-is un-added but the working copy is not removed, so it returns to
-either the Unknown or Ignored state.  If the file has been Deleted, it
-is resurrected and returns to the Up-to-date state.  If the file is
-Unknown, Ignored, or a Control file then it is not changed and a
-warning is issued::
-
-  bzr: warning: cannot revert ignored file foo.c
-
-If the file has been Renamed, it is returned to its original name and
-any textual changes are reversed.  This may cause an error if the
-rename clashes with an existing file::
-
-  bzr: error: cannot revert foo.c to old name bar.c: file exists
-
-If a directory is listed, by default only changes to the directory
-itself are undone.
-
-Ideally this would not lose any changes, but rather just set them
-aside, so that the revert command would be undoable.  One way is to
-follow Arch and write out the discarded changes to a changeset file
-which can be either re-applied or discarded at a later date.  This
-very nicely allows for arbitrarily nested undo.  A simpler
-intermediate mechanism would be to just move the discarded files to
-GNU-style tilde backups.
-
---merges        Clear the list of pending merges.  If files are
-                specified, their text is also reverted, otherwise no
-                files are changed.
-
---id-only       Don't touch the working text, only the inventory.
-
-
-+-------------+-------------------------------------------------+
-| File state  | Actions                                         |
-+=============+=================================================+
-| A           | Returned to ? or I state, working text unchanged|
-+-------------+-------------------------------------------------+
-| D           | Working copy restored, returned to U            |
-+-------------+-------------------------------------------------+
-| Z           | Returned to U                                   |
-+-------------+-------------------------------------------------+
-| ZM          | Working copy restored to previous               |
-|             | version, returned to U                          |
-+-------------+-------------------------------------------------+
-| R           | Moved back to old                               |
-|             | name.                                           |
-+-------------+-------------------------------------------------+
-| RM          | Moved back to old name and restored to previous |
-|             | text.                                           |
-+-------------+-------------------------------------------------+
-|I, #, ?      | "Cannot revert"                                 |
-+-------------+-------------------------------------------------+
-
-
-log
----
-
-Show a log of changes::
-
-    bzr log
-
-By default shows all changes on this branch.
-
-The default format shows merged changes indented under the change that
-merged them.
-
-Alternatively changes can be sorted by date disregarding merges, which
-shows the order in which they were written not the order they were
-merged.  Changes which were merged are flagged as such.  Such an order
-is needed for a GNU-style ChangeLog.  The option is comparable to
-choosing a threaded or unthreaded display in an email client, and
-should perhaps have those names.
-
-Another option is to show just short descriptions of the merged
-changes, similar to arch.
-
-The log can be filtered in any of these ways:
-
-* Logs touching a particular file or directory.
-
-* Changes touching a particular file-id, regardless of what name it
-  had in the past.
-
-* Changes by a particular author.
-
-* Changes from a particular branch name (not necessarily the same
-  branch).
-
-Another option is to also include diffs (which may make it quite
-large).
-
-
-ignore
-------
-
-Mark a file pattern to be ignored and not versioned::
-
-    bzr ignore PATTERN
-
-The pattern should be quoted on Unix to protect it against shell
-expansion.
-
-The pattern is appended to ``.bzr-ignore``.  This file is created if
-it does not already exist, and added if it is not already versioned.
-bzr prints a message showing the pattern added so that people can see
-where to go to remove it::
-
-    $ bzr ignore \*.pyc
-    bzr: notice: created .bzr-ignored
-    bzr: notice: added pattern '*.pyc' to .bzr-ignore
-    $ bzr status
-    A      .bzr-ignore
-
-If the wrong pattern is added it can be removed by either editing
-``.bzr-ignore`` or by reverting__ that file.
-
-__ revert_
-
-
-is
---
-
-Test various predicates against a branch, similar to the Unix shell
-``test`` command::
-
-    bzr is TEST [ARGS]
-
-Takes a third-level command:
-
-``clean``
-  Tree has no uncommitted changes.
-
-``in-tree``
-  Pwd is in a versioned tree.
-
-``in-control-dir``
-  Pwd is inside a Bazaar-NG control directory (and therefore should
-  not be modified directly).
-
-``tree-top``
-  Pwd is the top of a working tree.
-
-
-protect
--------
-
-(Proposed idea, may not be implemented or may need a better name.)
-
-Sets a voluntary write-protect flag on a branch, to protect against
-accidental changes::
-
-    bzr protect
-    bzr unprotect
-
-This is typically used on branches functioning as tags, which should
-not normally be committed to or updated.
-
-There may, in the future, be a mechanism to allow only particular
-users to protect/unprotect a branch.
-
-
-uncommit
---------
-
-(It is not certain this command will be implemented.)
-
-This command removes the most recent revision from the branch::
-
-    bzr uncommit
-
-This does not affect the working copy, which can be fixed up and a new
-commit run.  The new commit will have a different revision ID.
-
-Removal of the revision will not propagate to any other branches.
-
-The command may be repeated to successively remove more and more
-revisions.
-
-This command should perhaps have a more obviously dangerous name,
-since it can lose information or cause confusion.
-
-By default the revision is removed from the history, but its text is
-left in the store, which allows some chance of recovery.
-
-You cannot partially uncommit; you can however uncommit the whole
-revision and then re-commit just part of it.
-
-:Use cases:
-    `Wrong commit message`_
-
-
-.. _`Wrong commit message`: use-cases.html#wrong-commit-message
-
-
-
-find
-----
-
-Finds files, versions, etc in a branch::
-
-   bzr find [OPERATORS]
-
-The behaviour is similar to regular unix *find*, but this understands
-about bzr versioning.  Eventually this may gain all the
-and/or/grouping options of Unix find, but not yet.
-
-This does not have the quirky syntax of unix find, but rather just
-specifies commands as regular words.
-
-Operators:
-
-* ``directory``
-* ``file``
-* ``unknown``
-* ``ignored``
-
-By default the operators are anded together; there is also an ``or``
-operator.
-
-If no action is specified, just prints the file name.  Other actions:
-
-``print``
-    Print just the filename.
-``printf``
-    Print various fields about the object, using a formating system.
-``exec``
-    Execute a command on the file.
-

=== removed file 'doc/common-format.txt'
--- doc/common-format.txt	2005-11-07 13:17:53 +0000
+++ doc/common-format.txt	1970-01-01 00:00:00 +0000
@@ -1,39 +0,0 @@
-***********************
-Common changeset format
-***********************
-
-It might be useful to have a common changeset format for interchange
-between projects.
-
-It is not clear that you would be able to capture everything that
-every tool produces, but perhaps a lot could be done.
-
-Scenarios: (in order of difficulty?)
-
- * dump/load
-
- * convert repo from one tool to another
-
- * one-way sync from exotic tool into read-only CVS or Svn repo
-
- * two way sync between writable archives
-
-Perforce's RevML and ``vcp`` may be some use but apparently don't go
-all the way.
-
-Things like darcs and monotone may have such a different model that it
-may be hard to map them.
-
-Two-way sync may require keeping external state and is probably pretty
-hard.
-
-Apparently tlord tried to do something about this before but it
-stalled.
-
-Eventually perhaps we could arrange for someone to export key
-bitkeeper archives in this format, allowing all tools to read them in.
-
-Colin__ points the existing mailing list about this which is just a
-bunch of spam.
-
-__ http://web.verbum.org/blog/freesoftware/fsrc-responses

=== removed file 'doc/compared-aegis.txt'
--- doc/compared-aegis.txt	2005-11-07 13:17:53 +0000
+++ doc/compared-aegis.txt	1970-01-01 00:00:00 +0000
@@ -1,110 +0,0 @@
-****************
-Ideas from Aegis
-****************
-
-* Very mature -- in use for 14 years, many large projects, etc.
-
-* "Essential process can be learned in a day" -- which is still kind
-  of a long time; i'd like it to be well under an hour.
-
-* Good process integration; show who is supposed to be working on what
-  and how far through they are.
-
-* Very poor Windows support.
-
-* Distributed repositories. (??)
-
-* Very focussed on security -- can reproduce any previous revision;
-  availability/integrity/confidentiality; uses Unix permissions and
-  seteuid() to prevent users changing the database.
-
-* Does not itself track history -- assumes this will be done by some
-  other tool such as RCS operating on the baseline.
-
-* I think every individual project needs a single baseline. (??)
-
-* The baseline is always working and always releasable -- to the
-  extent that you have scripts which can enforce this.
-
-* Integration step is somewhat similar to that used by distributed
-  systems.  It seems that you could build some features of aegis as
-  policy macros on top of Bazaar-NG.
-
-* The baseline also contains object files built from current source,
-  which can be used to pre-populate working directories.  Also people
-  only need a copy of the source files they're changing.  I think the
-  economics of this have changed a bit.  Also tends to assume all
-  developers are on the same Unix host, which is no longer generally
-  true.
-
-* Only one review/integration can be in process at a time.
-
-* One process difference is that developers produce all changes;
-  reviewers/integrators can only accept or reject them.  This is
-  different from the integrator-makes-right model of many distributed
-  tools.  (Though the integrator still has the choice to reject, but
-  they have the option of fixing it too.)
-
-* Can automatically append Signed-off-by field.  Interesting idea.  I
-  wonder if we should have a metadata facility to include licence
-  data?
-
-* Much of the functionality of Aegis is to prevent people doing things
-  they could otherwise do.  That can be useful in enforcing a healthy
-  process but bazaar-ng is not the place for it. 
-
-* Can serialize an (in-progress) changeset to text, and then mail from
-  one place to another.
-
-* Branches are an extension of the 'change' concept; they can be
-  merged into the parent in the same way that a change can be.
-
-  Merging branches onto the mainline seems to hit a similar problem to
-  that of centralized branches.  If someone else has committed, you
-  need to make a new changeset reconciling all their changes, commit
-  that to the child branch, then commit everything to the parent.
-
-  This suggests a different way to do shared branches in Bazaar-NG:
-
-    You can push to the parent if you incorporate either directly or
-    by merger all changes on the parent.  That means that everything
-    someone has committed to the parent is present in some way in your
-    branch.  By extension, it is safe to transform the parent text
-    into your branch without losing anything.  We can therefore
-    remotely record that changeset to the parent.  This is more or
-    less what Aegis does.
-
-    The problem with this in the Bazaar-NG model is that then the new
-    commit will be only in the parent, and not on the child.  So if
-    you run ``bzr log`` on the child, you won't see what you just
-    committed.  We can't apply it to both because the predecessor is
-    different.  (darcs could do that, but it has a looser patch
-    history than I want.)
-
-
-
-
-Overall, the process model is good for a particular type of
-organization.  It would be good to build this on top of Bazaar-NG.  To
-support that we need:
-
- - patches are submitted, rather than being directly written in 
-
- - arbitrary levels of branching/review
-
- - users can submit changes to branches they are not directly allowed
-   to write to 
-
- - branches can be cleanly removed when they're no longer necessary
-
- - strong audit trail
-
-
-Interestingly, the BitKeeper model which is criticized__ by Greg
-Hudson is similar to that of Aegis: a single integrator (or small
-team?) who ultimately decide what gets into the main tree.
-
-__ http://web.mit.edu/ghudson/thoughts/bitkeeper.whynot
-
-
-The Aegis workflow can probably be `emulated in bzr <workflow.html>`_.

=== removed file 'doc/compared-codeville.txt'
--- doc/compared-codeville.txt	2005-11-07 13:17:53 +0000
+++ doc/compared-codeville.txt	1970-01-01 00:00:00 +0000
@@ -1,106 +0,0 @@
-Codeville
-*********
-
-Documentation on how this actually works is pretty scarce to say the
-least.
-
-I *think* I understand their merge algorithm though, and it's pretty
-clever.  Basically we do a two-way merge between annotated forms of
-the two files: that is, with each line marked with the revision in
-which it last changed.  (I am simplifying here by speaking of lines
-and changes, but I don't think it causes any essential problem.)
-
-Now we walk through each file, line by line.  If the change that
-introduced the line state in branch A is already merged into branch B,
-then we can just take B.
-
-Now is this actually better?
-
-It may be better in several ways:
-
-* Do not need to choose just a single ancestor, but rather can
-  take advantage of all possible previous changes.
-
-* Can handle OTHER containing changes which have been merged into
-  THIS, but have then been overwritten.
-
-* Can handle cherrypicks(!) by remembering which lines came in from
-  that cherrypick; then we don't need to merge them again.
-
-Some questions:
-
-* Do we actually need to store the annotations, or can we just infer
-  it at the time we do the merge?
-
-* Can this be accomodated in something like an SCCS weave format?  I
-  think something like a weave may work, in as much as it is basically
-  a concatenation of annotations, but I don't know if it represents
-  merges well enough to cope.
-
-Can this handle binaries or type-specific merges, and if so how?
-Unmergeable binaries are easy: just get the user to pick one.  Things
-like XML are harder; we probably need to punt out to a type-specific
-three-way merge.  Of course this approach does not forbid also
-offering a 3-way merge.
-
-----
-
-I suppose this could be accomodated by an annotation cache on top of
-plain history storage, or by using a storage format such as a weave
-that can efficiently produce annotation information.
-
-That is to say there is nothing inherently necessary about remembering
-the line history at the point when it is committed, except that it
-might be more efficient to do this once and remember it than to 
-
-----
-
-There is another interesting approach that can be used even in a tool
-that does not inherently remember annotations:
-
-Given two files to merge, find all regions of difference.  For each
-such, try to find a common ancestor having the same content for the
-region.  Subdivide the region if necessary.
-
-This naive approach is probably infeasible, since it would mean
-checking every possible predecessor.
-
-----
-
-Rather than storing or calculating annotations, we could try using a
-complex weave, which allows one file version to be represented as a
-weave of multiple disjoint previous versions.  It sounds complex but
-it might work.
-
-Essentially we store each file as a selection of lines that should be
-turned on in that file.  These files might come from any of the
-predecessors that were merged into that file.  Complex to get right
-but it might work.
-
-This is written in terms of lines, but it might make more sense to
-just use byte ranges: perhaps more efficient when handling long files,
-and makes binaries less of a special case.
-
-codeville in fact does *not* seem to do this, though to me it seems
-like a fairly natural corollary of their design.
-
-This seems to imply holding the file text and ancestry of every branch
-that ever merged into this one, rather than just finding them if we
-later want them.  Hm.  That is nice in terms of doing smart merges.
-That possibly causes trouble in terms of having a name for these
-branches floating around inside our space, and making sure we don't
-clash with them.  It may make sense in terms of having a working
-directory be just a view into a shared database, looking at a
-particular line of development.
-
-Indeed the main difficulty seems to be of naming branches in this
-space.  Perhaps we should move back to using repositories and named
-branches within them, but not rely on branch names being unique out of
-the context of a single repository.
-
-Wow, this seems to open a big can of worms.
-
-----
-
-So the conclusion is that this is very cool, but it does not require a
-fundamental change of model and can be implemented later.

=== removed file 'doc/compared-cvsnt.txt'
--- doc/compared-cvsnt.txt	2005-11-07 13:17:53 +0000
+++ doc/compared-cvsnt.txt	1970-01-01 00:00:00 +0000
@@ -1,32 +0,0 @@
-*****
-CVSNT
-*****
-
-
-http://www.cvsnt.com/cvspro/
-
- * Remembers last-merge-point__ between two branches, and uses this to
-   do smarter incremental merges.
-
-__ http://www.cvsnt.org/wiki/MergePoint
-
-http://www.cvsnt.org/wiki/CvsntAdvantages
-
- * SSPI authentication on Windows, and built-in Putty SSH code.
-
- * Branch ACLs.
- 
- * Remote user administration using cvs passwd command.
-
- * Repository browsing via cvs ls command (update: now provided in
-   standard CVS since version 1.12.9)
-
- * LockServer on a second port replaces filesystem-based locks &
-   provides file level locking
-
-
-Various other improvements relative to CVS, particularly for Windows
-users.  Worth looking at, but nothing apparently earth-shaking.
-
-Interesting that the advanced merge support is basically that it
-remembers what was pulled across.
\ No newline at end of file

=== removed file 'doc/compared-opencm.txt'
--- doc/compared-opencm.txt	2005-11-07 13:17:53 +0000
+++ doc/compared-opencm.txt	1970-01-01 00:00:00 +0000
@@ -1,36 +0,0 @@
-******************
-Compared to OpenCM
-******************
-
-  http://opencm.org/
-
-
-Not very stable; apparently inactive.  
-
-* Separated working copy & repository model.
-
-* Files have long-lived identifiers.
-
-* Files and revisions identified by the SHA-1 hash of their content
-  (as in monotone); explicitly makes it easier to be sure we have the
-  right one and prevents some tricks.
-
-* Binding of objects to external names done on the client, so you can
-  version e.g. database objects, instead of files.
-
-* Directories are inferred by having files that exist under them;
-  empty directories are a special case with an object of type DIR.
-  
-  This is a bit ugly.  I might rather have files given a name only
-  relative to their parent directory.  So renaming a directory will
-  only update the entry for the directory, and everything will move
-  with it.
-
-* Access-control rules about who can write to a central server. 
-
-* Their design is somewhat similar to ours and used a lot of disk
-  space -- enough to be a significant problem.
-
-* Assigning human names to branches proved problematic -- i think this
-  is a good reason to rely on the filesystem/URL space, which people
-  already know how to manage and deal with.

=== removed file 'doc/compared-prcs.txt'
--- doc/compared-prcs.txt	2005-11-07 13:17:53 +0000
+++ doc/compared-prcs.txt	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-********************
-Comparison with PRCS
-********************
-
-  http://prcs.sourceforge.net/
-
-* No network support; no Windows or Mac support.
-
-* Long-lived file IDs, generated from .  Files can be reintroduced
-  after they are deleted. 
-
-* Named branches.
-
-* Custom keyword replacement: can specify keywords such as the release
-  number.  Commands to update keywords, and to strip them out.
-  Separate ``rekey`` command can be used after a checkin to bring
-  keywords up to date.
-
-* Users are allowed to edit the manifest file, which also contains
-  some system-maintained data.  This apparently works OK but I think
-  it makes people uncomfotable.
-
-* ``populate`` command adds all unversioned files and unregister files
-  which are no longer present.
-
-* Merge algorithm is similar to the best-parent three-way merge we're
-  planning on using; in particular it remembers merged parents to help
-  with later choices.
-
-* ``$Format$`` feature useful in generating arbitrary tags inside text,
-  example__::
-
-    /* $Format: "static char* version = \"$ProjectVersion$\";"$ */
-    static char* version = "x.x";
-
-  transformed to::
-
-    /* $Format: "static char* version = \"$ProjectVersion$\";"$ */
-    static char* version = "1.2";
-
-  Also a good bundle of other keywords.
-
-* ``prcs execute`` is like find-xargs; perhaps easier to have a
-  find/exec pattern.
-
-__ http://svn.haxx.se/dev/archive-2004-12/1065.shtml
-
-
-Should have a look at their storage format; probably pretty efficient.
\ No newline at end of file

=== removed file 'doc/compared-teamware.txt'
--- doc/compared-teamware.txt	2005-11-07 13:17:53 +0000
+++ doc/compared-teamware.txt	1970-01-01 00:00:00 +0000
@@ -1,34 +0,0 @@
-Compared to Sun Teamware
-************************
-
-(**note**: I have never used Sun Teamware, so this document is just
-based on public documentation and information from other people.
-Corrections would be appreciated.)
-
-http://docs.sun.com/app/docs/doc/806-3573
-
-Needless to say bazaar-ng is currently far less mature, and some of
-the advantages listed below don't work in the current pre-1.0 code.
-But they are accounted for in the design.
-
-TeamWare has file locking.  Distributed systems can't easily support
-file locking because you can't prevent people diverging.  But perhaps
-we can have scripts or a higher-level tool to communicate that changes
-to a particular file are in train.  (One possibility: there is a
-development branch where that file has been changed, but not yet
-checked in.  Or if Bob can see Alice's work area, he can see that a
-particular file has been fetched read/write.)
-
-parent/child workspaces.
-
-Advantages of bazaar-ng:
-
-* Free / open source software
-
-* Prior tree revisions are always exactly reproducible (atomic
-  changesets, etc)
-
-* Can get whole-tree diff
-
-* Versioned, mergeable renames.
-

=== removed file 'doc/compression.txt'
--- doc/compression.txt	2005-11-07 13:17:53 +0000
+++ doc/compression.txt	1970-01-01 00:00:00 +0000
@@ -1,66 +0,0 @@
-Compression
-***********
-
-At the moment bzr just stores the full text of every file state ever.
-(Files unmodified from one revision are stored only once.)
-
-This is simple to write, and adequate for even reasonably large trees
-with many versions.  Disk is very cheap.  
-
-Eventually we might like something more compressed, but this is
-neither an interesting nor urgent problem.  (Not "interesting" in the
-sense that doing it is just a matter of coding; there is no
-theoretical problem or risk.)  
-
-There are various possibilities:
-
-* Store history of each file in RCS, relying on RCS to do line-by-line
-  delta compression.  (Does not handle binaries very well.)
-
-  OpenCMS paper has a horror story about using RCS for file storage.
-
-* Store full copies of each file in a container with gzip compression,
-  which should fairly efficiently eliminate unchanged areas.  This
-  works on binaries, and gives compression of file text as a side
-  benefit.
-
-  (Note that ``.zip`` will *not* do for this, because every file is
-  compressed independently.)
-  
-  The OpenCMS paper notes that RCS storage is only 20% more efficient
-  than gzip'd storage of individual file versions.
-
-* Store history of each file in SCCS; allows quick retrieval of any
-  previous state and may give more efficient storage than RCS.  Allows
-  for divergent branches within a single file.
-
-* Store xdeltas between consecutive file states.
-
-* Store xdeltas according to a spanning delta algorithm; this probably
-  requires files are stored with some kind of sequence number so that
-  we can predict related version names.
-
-* Store in something like XDFS.
-
-* Any of the above, but with the final storage in some kind of
-  database: psql, sqlite, mysql, whatever is convenient.   
-
-  It should be something that is safe across system crashes, which
-  rules out tdb at the moment.
-
-----
-
-These properties are seen as desirable in darcs and arch:
-
-* Passive HTTP downloads: without requiring any server-side
-  intelligence, a client can get updates from one version to the next
-  by requesting a set of self-contained files.  
-
-  The number of files necessary to do this must not be unfeasibly
-  large, and the size of each of those files should be proportionate
-  to the amount of actual change.  In other words the data downloaded
-  should be of comparable size to the actual edits between the trees.
-
-
-* Write-once storage: once a file is written to the repository, it is
-  not modified.

=== removed file 'doc/config-specs.txt'
--- doc/config-specs.txt	2005-11-07 13:17:53 +0000
+++ doc/config-specs.txt	1970-01-01 00:00:00 +0000
@@ -1,47 +0,0 @@
-************
-Config specs
-************
-
-A *config spec* is a set of instructions for assembling a source tree
-from separately maintained branches.  This is like CVS's "modules"
-format.  Config specs are very commonly used in Clearcase, and the
-main way of getting a new checkout.
-
-Scenarios:
-
- * One module is shared by several projects, and it needs to be
-   present in a subdirectory of their trees to build.
-
- * There are different commit or stability rules for different parts
-   of a tree.
-
-The simplest form is just a specification of branch sources, and where
-they should be assembled into the tree.  Example::
-
-  .              http://foo.net/fooapp
-  ./libbaz       http://foo.net/libbaz
-
-Normally the entire branch will be placed at this point, but sometimes
-subdirectory should be selected.  Selecting just a single file rather
-than subdirectory might be problematic because we wouldn't have
-anywhere to put the control files.
-
-Each branch will have a .bzr directory at the top level.  Changes on
-each branch can be pushed back independently.
-
-The tool needs to support (and be tested with) nested checkouts.
-Commands should normally only apply to a single tree, but there might
-be an option to descend into nested trees.
-
-One very important use case is a naive user checking out a tree that
-happens to use a configspec.  This is transparent in cvs, but not at
-all so in Arch.
-
-The ``svn:externals`` mechanism in Subversion works like this.
-
-One interesting idea from Aaron is that all branches should be like
-this: the latest-patch pointer can be generalized to in fact name
-several patches that should be assembled in subdirectories.  A
-simplest branch names just one, assembled to the base directory.  You
-might want to specify the parent branches for each one as well....
-

=== removed file 'doc/conflicts.txt'
--- doc/conflicts.txt	2005-11-07 13:17:53 +0000
+++ doc/conflicts.txt	1970-01-01 00:00:00 +0000
@@ -1,45 +0,0 @@
-Types of conflict
-*****************
-
-The following types of conflict can be encountered during a merge, or
-a merge-like operation (such as resyncing local changes with
-upstream):
-
-Aaron's list:
-
-* Parent directory missing when attempting to add a file
-
-* Attempt to create directory that already exists
-
-* Some patch hunks failed to apply
-
-* While changing permissions, the "old" permissions in the changeset do
-  not match the file.
-
-* While replacing contents of a file, the old contents of a file do not
-  match the changeset
-
-* Attempt to remove non-empty directory: This only occurs when the
-  directory has contents that it didn't have the last time it was deleted.
-  It's pretty easy to handle adds, renames and deletes for exact
-  patching.  There's no need to rm -rf directories as tla does.
-
-* Attempt to create a symlink when there is already a file/dir/etc with
-  that name
-
-* Attempt to apply a patch to a file that does not exist
-
-* Attempt to remove a file that does not exist
-
-* Attempt to rename a file that does not exist
-
-* Attempt to change permissions of a file that does not exist
-
-* Can't determine filename during three-way merging
-
-* Can't determine file parent directory during three-way merging
-
-* Can't determine file permissions during three-way merging
-
-Aaaron says: I have no doubt there are more.  For example, attempt to
-change permissions of a symlink.

=== removed file 'doc/costs.txt'
--- doc/costs.txt	2005-11-07 13:17:53 +0000
+++ doc/costs.txt	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-Costs
-=====
-
-User thought is most expensive.  User time spent waiting is next.
-Developer time for the version control system is also relatively
-expensive.  
-
-Machine resources are cheap.  In particular; disk is generally very
-cheap; an ordinary programmer earns enough to buy hundreds of GB of
-disk per day.  However, it is sometimes limited, as on a laptop.
-Therefore it is generally OK to trade off disk space for anything
-else, but it should be possible to be compact.
-
-Network round trips are very bad.
-
-Consider scalability also; avoid anything worse than O(n).  Try to
-avoid anything that needs e.g. to hold the whole tree in memory at any
-time, or to hold the entire history of the project.
-
-
-

=== removed file 'doc/darcs.txt'
--- doc/darcs.txt	2005-11-07 13:17:53 +0000
+++ doc/darcs.txt	1970-01-01 00:00:00 +0000
@@ -1,81 +0,0 @@
-Darcs compared to Arch
-======================
-
-Simpler to use; perhaps harder to completely understand.
-
-Always local; always fast.
-
-Patch commution is slow and perhaps doesn't clearly do what people
-want.  
-
-Too slow!
-
-Can't reliably get back to any previous point.  Explicitly not
-addressing source archive/librarian function.
-
-Loads everything into memory.
-
-Written in Haskell.
-
-A really simple pre-commit check hook is remarkably useful.
-
-http://www.scannedinavian.org/DarcsWiki/DifferencesFromArch
-
-
-
-Sometimes useful to be able to set email per-branch, for people who
-work on different projects under different personas.
-
-
-Token replace
--------------
-
-Very cute; possibly handy; not absolutely necessary in most places.
-Somewhat limited by the requirement that it be reversible.
-
-This is one of very few cases where it does seem necessary that we
-store deltas, rather than tree states.  But that seems to cause other
-problems in terms of being able to reliably sign revisions.
-
-This can perhaps be inferred by a smart 3-way merge tool.  Certainly
-you could have it do sub-line merges.
-
-Partial commit
---------------
-
-darcs allows you to commit only some of the changes to a single file.
-This is like the common feature of commiting only a subset of changed
-files, but taken to a higher level.
-
-It is useful more often than one might think: it is common to fix some
-documentation 'on the wing' and while strictly it should be in a
-separate commit it is not always worth the hassle to back out changes,
-fix the docs, then do the real change.  Similarly for making a
-separate branch.
-
-Although the idea is very good, the current darcs implementation is
-limited to selecting by patch hunk, which means that neighbouring
-changes cannot be separated.  Fixing this probably means having some
-kind of pluggable GUI to build the file-to-be-committed or an edited
-patch, possibly using something like meld, emacs, or dirdiff.  Another
-approach some people might like is editing the diff file to chop out
-hunks.
-
-I don't think this needs to be on by default, as it is in darcs.  It
-is usual to commit all the changes.
-
-For this to work safely, it is good to have a commit hook that
-builds/tests the tree.  Of course this needs to be evaluated against
-the tree as it will be committed (taking account of partial commits),
-not the working tree.
-
-
-Schwern
--------
-
-* http://www.scannedinavian.org/DarcsWiki/SchwernLikesDarcs
-* http://www.scannedinavian.org/DarcsWiki/SchwernHatesDarcs
-
-I think we hit most of these; more evidence for the hypothesis that
-what people really like about darcs is the simple interface not the
-patch-commutation model.
\ No newline at end of file

=== removed file 'doc/deadly-sins.txt'
--- doc/deadly-sins.txt	2005-11-07 13:17:53 +0000
+++ doc/deadly-sins.txt	1970-01-01 00:00:00 +0000
@@ -1,50 +0,0 @@
-**************************
-Deadly sins in tool design
-**************************
-
-http://gcc.gnu.org/wiki/DeadlySins
-
-They don't directly apply, but many do correspond.
-
-  The "Deadly Sins" from P. J. Brown's *Writing Interactive Compilers and Interpreters*, Wiley 1979. We've committed them all at least once in GCC.
-
-  The deadly sins are:
-
-  1. to code before you think.
-
-  2. to assume the user has all the knowledge the compiler writer has.
-
-  3. to not write proper documentation.
-
-  4. to ignore language standards.
-
-  5. to treat error diagnosis as an afterthought.
-
-  6. to equate the unlikely with the impossible.
-
-  7. to make the encoding of the compiler dependent on its data formats.
-
-  8. to use numbers for objects that are not numbers.
-
-  9. to pretend you are catering to everyone at the same time.
-
-  10. to have no strategy for processing break-ins.
-
-      (A break-in is when you interrupt an interactive compiler, and
-      then possibly continue it later. This is meaningful in an
-      environment in which the compiler is run dynamically, such as
-      many LISP and some BASIC environments. It is not meaningful for
-      typical uses of C/C++ (although there was at least one
-      interactive C environment, from Sabre).)
-
-      (Perhaps this corresponds to handling user interrupts during
-      operation -- they should not leave anything in an inconsistent
-      state.)
-
-  11. to rate the beauty of mathematics above the usability of your
-      compiler.
-
-  12. to let any error go undetected.
-
-  13. to leave users to find the errors in your compiler.
-

=== removed file 'doc/default.css'
--- doc/default.css	2005-11-07 13:17:53 +0000
+++ doc/default.css	1970-01-01 00:00:00 +0000
@@ -1,227 +0,0 @@
-/*
-:Author: David Goodger
-:Contact: goodger@users.sourceforge.net
-:date: $Date: 2004/01/28 20:46:38 $
-:version: $Revision: 1.36 $
-:copyright: This stylesheet has been placed in the public domain.
-
-Default cascading style sheet for the HTML output of Docutils.
-*/
-
-.first {
-  margin-top: 0 }
-
-.last {
-  margin-bottom: 0 }
-
-a.toc-backref {
-  text-decoration: none ;
-  color: black }
-
-blockquote.epigraph {
-  margin: 2em 5em ; }
-
-dd {
-  margin-bottom: 0.5em }
-
-div.abstract {
-  margin: 2em 5em }
-
-div.abstract p.topic-title {
-  font-weight: bold ;
-  text-align: center }
-
-div.attention, div.caution, div.danger, div.error, div.hint,
-div.important, div.note, div.tip, div.warning, div.admonition {
-  margin: 2em ;
-  border: medium outset ;
-  padding: 1em }
-
-div.attention p.admonition-title, div.caution p.admonition-title,
-div.danger p.admonition-title, div.error p.admonition-title,
-div.warning p.admonition-title {
-  color: red ;
-  font-weight: bold ;
-  font-family: sans-serif }
-
-div.hint p.admonition-title, div.important p.admonition-title,
-div.note p.admonition-title, div.tip p.admonition-title,
-div.admonition p.admonition-title {
-  font-weight: bold ;
-  font-family: sans-serif }
-
-div.dedication {
-  margin: 2em 5em ;
-  text-align: center ;
-  font-style: italic }
-
-div.dedication p.topic-title {
-  font-weight: bold ;
-  font-style: normal }
-
-div.figure {
-  margin-left: 2em }
-
-div.footer, div.header {
-  font-size: smaller }
-
-div.sidebar {
-  margin-left: 1em ;
-  border: medium outset ;
-  padding: 0em 1em ;
-  background-color: #ffffee ;
-  width: 40% ;
-  float: right ;
-  clear: right }
-
-div.sidebar p.rubric {
-  font-family: sans-serif ;
-  font-size: medium }
-
-div.system-messages {
-  margin: 5em }
-
-div.system-messages h1 {
-  color: red }
-
-div.system-message {
-  border: medium outset ;
-  padding: 1em }
-
-div.system-message p.system-message-title {
-  color: red ;
-  font-weight: bold }
-
-div.topic {
-  margin: 2em }
-
-h1.title {
-  text-align: center }
-
-h2.subtitle {
-  text-align: center }
-
-hr {
-  width: 75% }
-
-ol.simple, ul.simple {
-  margin-bottom: 1em }
-
-ol.arabic {
-  list-style: decimal }
-
-ol.loweralpha {
-  list-style: lower-alpha }
-
-ol.upperalpha {
-  list-style: upper-alpha }
-
-ol.lowerroman {
-  list-style: lower-roman }
-
-ol.upperroman {
-  list-style: upper-roman }
-
-p.attribution {
-  text-align: right ;
-  margin-left: 50% }
-
-p.caption {
-  font-style: italic }
-
-p.credits {
-  font-style: italic ;
-  font-size: smaller }
-
-p.label {
-  white-space: nowrap }
-
-p.rubric {
-  font-weight: bold ;
-  font-size: larger ;
-  color: maroon ;
-  text-align: center }
-
-p.sidebar-title {
-  font-family: sans-serif ;
-  font-weight: bold ;
-  font-size: larger }
-
-p.sidebar-subtitle {
-  font-family: sans-serif ;
-  font-weight: bold }
-
-p.topic-title {
-  font-weight: bold }
-
-pre.address {
-  margin-bottom: 0 ;
-  margin-top: 0 ;
-  font-family: serif ;
-  font-size: 100% }
-
-pre.line-block {
-  font-family: serif ;
-  font-size: 100% }
-
-pre.literal-block, pre.doctest-block {
-  margin-left: 2em ;
-  margin-right: 2em ;
-  background-color: #eeeeee }
-
-span.classifier {
-  font-family: sans-serif ;
-  font-style: oblique }
-
-span.classifier-delimiter {
-  font-family: sans-serif ;
-  font-weight: bold }
-
-span.interpreted {
-  font-family: sans-serif }
-
-span.option {
-  white-space: nowrap }
-
-span.option-argument {
-  font-style: italic }
-
-span.pre {
-  white-space: pre }
-
-span.problematic {
-  color: red }
-
-table {
-  margin-top: 0.5em ;
-  margin-bottom: 0.5em }
-
-table.citation {
-  border-left: solid thin gray ;
-  padding-left: 0.5ex }
-
-table.docinfo {
-  margin: 2em 4em }
-
-table.footnote {
-  border-left: solid thin black ;
-  padding-left: 0.5ex }
-
-td, th {
-  padding-left: 0.5em ;
-  padding-right: 0.5em ;
-  vertical-align: top }
-
-th.docinfo-name, th.field-name {
-  font-weight: bold ;
-  text-align: left ;
-  white-space: nowrap }
-
-h1 tt, h2 tt, h3 tt, h4 tt, h5 tt, h6 tt {
-  font-size: 100% }
-
-tt {
-  background-color: #eeeeee }
-
-ul.auto-toc {
-  list-style-type: none }

=== removed file 'doc/design.txt'
--- doc/design.txt	2005-11-07 13:17:53 +0000
+++ doc/design.txt	1970-01-01 00:00:00 +0000
@@ -1,1172 +0,0 @@
-****************
-Bazaar-NG design
-****************
-
-
-:Author:
-  Martin Pool <mbp@sourcefrog.net>
-
-:Date: December 2004, Noosa.
-
-.. sectnum::
-.. contents::
-
-
-Abstract
---------
-
-  *Bazaar-NG should be a joy to use.*
-
-  What if we started from scratch and tried to take the best features
-  from darcs, svn, arch, quilt, and bk?
-
-  Don't get the sum of all features; rather get the minimum features
-  that make it a joy to use.  Choose simplicity, in both interface and model.
-  Do not multiply entities
-  beyond necessity.
-
-  *Make it work; make it correct; make it fast* -- Ritchie(?)
-
-
-
-Design model
-------------
-
-* Unify archives and branches; one archive holds one branch.  If you
-  want to publish multiple branches, just put up multiple directories.
-
-* Explicitly add/remove files only; no names or tagline tagging.  If
-  someone wants to do heuristic detection of renames that's fine, but
-  it's not in the core model.
-
-Quilt indicates an interesting approach: patches themselves are the
-thing we're trying to build.  We don't just want a record of what
-happened, but we want to build up a good description of the change
-that will be implied when it's integrated.  This implies that we want
-to be able to change history quite a lot before merging upstream; or
-at least change our description of what will go up.
-
-
-Principles
-----------
-
-* Unix design philosophy (via Peter Miller), tempered by modern
-  expectations:
-
-  - least unnecessary output
-
-  - little dependence on *specific* external tools
-
-  - short command lines
-
-  - least overlap with cooperating tools
-
-* `Worse is better`__
-
-__ http://www.jwz.org/doc/worse-is-better.html
-
- - *Simplicity: the design must be simple, both in implementation and
-   interface. It is more important for the implementation to be
-   simple than the interface. Simplicity is the most important
-   consideration in a design.*
-
- - *Correctness: the design must be correct in all observable
-   aspects. It is slightly better to be simple than correct.*
-
-
- - *Consistency: the design must not be overly inconsistent. Consistency
-   can be sacrificed for simplicity in some cases, but it is better to
-   drop those parts of the design that deal with less common
-   circumstances than to introduce either implementational complexity
-   or inconsistency.*
-
- - *Completeness: the design must cover as many important situations as
-   is practical. All reasonably expected cases should be
-   covered. Completeness can be sacrificed in favor of any other
-   quality. In fact, completeness must sacrificed whenever implementation
-   simplicity is jeopardized. Consistency can be sacrificed to achieve
-   completeness if simplicity is retained; especially worthless is
-   consistency of interface.*
-
-* Try to get a reasonably tasteful balance between having something
-  that works out of the box but also has composable parts.  Provide
-  mechanism rather than policy but not to excess.
-
-* Files have ids to let us detect renames without having to walk the
-  whole path.  
-
-  If there are conflicts in ids they can in principle be resolved.
-  There might be a ``merge --by-name`` to allow you to force two trees
-  into agreement on IDs.  If the merge sees two files with the same
-  name and text then it should conclude that the files merged.
-
-  It would be nice if there were some way to make repeated imports of
-  the same tree give the same ids, but I don't think there is a safe
-  feasible way.  Sometimes files start out the same but really should
-  diverge; boilerplate files are one example. 
-
-* Archives are just directories; if you can read/write the files in
-  them you can do what you need.  This works even over http/sftp/etc.
-  Or at least this should work for read-only access; perhaps for
-  writing it is reasonable to require a svn+ssh style server invoked
-  over a socket.  
-
-  Of course people should not edit the files in there by hand but in
-  an emergency it should be possible.
-
-* Storing archives in plain directories means making some special
-  effort to make sure they can be rolled back if the commit is
-  interrupted any time.  On truly malicious filesystems (NFS) this may
-  be quite difficult, but at a minimum it should be possible to roll
-  back whatever was uncommitted and get to a reasonable state.  It
-  should also be reasonably possible to mirror branches using rsync,
-  which may transfer files in arbitrary order and cannot handle files
-  changing while in flight.  
-
-  Recovering from an interrupted commit may require a special ``bzr
-  fix`` command, which should write the results to a new branch to
-  avoid losing anything.
-
-* Branches carry enough information to recreate any previous state of
-  the branch (including its ancestors).  
-
-  This does not necessarily mean holding the complete text of all
-  those patches, but we do store at least a globally unique identifier
-  so that we can retrieve them.
-
-* Commands should correspond to svn or cvs as much as possible: add,
-  get, copy, commit, diff, status, log, merge. 
-
-* We have all the power of mirroring, but without needing to introduce
-  special concepts or commands.  If you want somebody's branch
-  available offline just copy it and keep updating to pull in their
-  changes; if you never make any changes the updates will always
-  succeed.
-
-* It is useful to be able to easily undo a previous change by
-  committing the opposite.  I had previously imagined requiring all
-  patches to be stored in a reversible form but it's enough to just do
-  backwards three-way merges.
-
-* Patches have globally unique IDs which uniquely identify them.
-
-* As a general principle we separate identification (which must be
-  globally unique) from naming (which must be meaningful to users).
-  Arch fuses them, which makes the human names long and prevents them
-  ever being reused.  Monotone doesn't have human-friendly names.
-
-* Users are identified by something like an email address;
-  ``user@domain``.  This need not actually be a working email
-  address; the point is just to piggyback on domain names to get
-  human-readable globally unique names.
-
-* Everything will be designed from the beginning to be safe and
-  reasonable on Windows and Unix.
-
-* History is append-only.  Patches are recorded along with the time at
-  which they were committed; if time steps backwards then we give a
-  warning (but probably commit anyhow.)  This means we can reliably
-  reproduce the state of the branch at any previous point, just by
-  backing out patches until we get back there.
-  
-  This is also true at a physical level as much as possible; once a
-  patch is committed we do not overwrite it.  This should make it less
-  likely that a failure will corrupt past history.  However, we may
-  need some indexes which are updated rather than replaced; they
-  should probably be atomically updated.
-
-* Storage should be reasonably transparent, as much as possible.  (ie
-  don't use SQLite or BDB.)  At the same time it should be reasonably
-  efficient on a wide range of systems (ie don't require reiserfs to
-  work well.)
-  
-  Programmers who look behind the covers should feel comfortable that
-  their data is safe, and hopefully pleased that the design is
-  elegant.
-
-* Unrecognized files cause a warning when you try to commit, but you
-  can still commit.  (Same behavior as CVS/Subversion; less discipline
-  than Arch.)
-
-  If you wish, you can change this to fail rather than just warn; this
-  can be done as tree policy or as an option (eg ``commit --strict``)
-
-* Files may be ignored by a glob; this can be applied globally (across
-  the whole tree) or for a particular directory.  As a special
-  convenience there is ``bzr ignore``. 
-
-* If branches move location (e.g. to a new host or a different
-  directory), then everyone who uses them needs to know the new URL by
-  some out-of-band method.
-
-* All operations on a branch or pair of branches can be done entirely
-  with the information stored in those branches.  Bazaar-NG never needs to
-  go and look at another branch, so we don't need unique branch names
-  or to remember the location of branches.
-
-* Store SHA-1 hashes of all patches, also store hashes of the tree
-  state in each revision.  (We need some defined way to make a hash of
-  a tree of files; for a start we can just cat them together in order
-  by filename.)
-  
-  Hashes are stored in such a way that we can switch hash algorithms
-  later if needed if SHA-1 is insecure.
-
-* You can also sign the hashes of patches or trees.
-
-* All branches carry all the patches leading up to their current
-  state, so you can recreate any previous state of that branch,
-  including the branches leading up to it.
-
-* A branch has an append-only history of patches committed on this
-  branch, and also an append-only history of patches that have been
-  merged in.
-
-* A commit log message file is present in .bzr-log all the time; you
-  can add notes to it as you go along.  Some commands automatically
-  add information to this file, such as when merging or reversing
-  changes. 
-  
-  The first line of the message is used as the summary.
-
-* Commands that make changes to the working copy will by default baulk
-  if you have any uncommitted changes.  Such commands include ``merge``
-  and ``reverse``.  This is done for two reasons: to avoid losing your
-  changes in the case where the merge causes problems, and to try to
-  keep merges relatively pure.  You can force it if you wish.
-
-  (*pull* is possibly a special case; perhaps it should set aside
-  local changes, update, and then reapply them/remerge them?)
-
-* Within a branch, you can refer to commits by their sequence number;
-  it's nice and friendly for the common case of looking at your
-  commits in order.
-
-* You can generate a changelog any time by looking at only local
-  files.  Automatically including a changelog in every commit is
-  redundant and so can be eliminated.  Of course if you want to
-  manually maintain a changelog you can do that too.
-
-* At the very least we should have ``undo`` as a reversible
-  ``revert``.  It might be even better to have a totally general undo
-  which will undo any operation; this is possible by keeping a journal
-  of all changes.
-
-* Perhaps eventually move to storing changesets in single text files,
-  containing file diffs and also information on renames, etc.  The
-  format should be similar to that of ``tla show-changeset``, but
-  lossless. 
-
-* Pristines are kept in the control directory; pristines are
-  relatively expensive to recreate so we might want to keep more than
-  one.  
-
-  (Robert says that keeping pristines under there can cause trouble
-  with people running recursive commands across the source tree, so
-  there should probably be some other way to do it.  If pristines are
-  identified by their hash then we can have a revlib without needing
-  unique branch names.)
-  
-* Can probably still have cacherevs for revisions; ideally
-  autogenerated in some sensible way.  We know the tree checksum for
-  each revision and can make sure we cached the right thing.
-
-* Bazaar-NG should ideally combine the best merging features of
-  Bitkeeper and Arch: both cherry-picking and arbitrary merging within
-  a graph.  The metaphor of a bazaar or souk is appropriate: many
-  independent agents, exchanging selected patches at will.
-
-* Code should be structured as a library plus a command-line client;
-  the library could be called from any other client.  Therefore
-  communication with the user should go through a layer, the library
-  should not arbitrarily exit() or abort(), etc.
-
-* Any of these details are open to change.  If you disagree, write and
-  say so, sooner rather than later.  There will be a day in the future
-  where we commit to compatibility, but that is a while off.
-
-* Timestamps obviously need to be in UTC to be meaningful on the
-  network.  I guess they should be displayed in localtime by default
-  and you can change that by setting $TZ or perhaps some option like
-  ``--utc``.  It might be cool to also capture the local time as an
-  indicator of what the committer was doing.
-
-* Should probably have some kind of progress indicator like --showdots
-  that is easy to ignore when run from a program (especially an
-  editor); that probably means avoiding tricks with carriage return.
-  (That might be a problem on Windows too.)
-
-* What date should be present on restored files?  We don't remember
-  the date of individual files, but we could set the date for the
-  entire commit.
-
-* One important layer is concerned with reproducing a previous
-  revision from a given branch; either the whole thing or just a
-  particular file or subdirectory.  This is used in many different
-  places.  We can potentially plug in different storage mechanisms
-  that can do this; either a very transparent and simple file-based
-  store as in darcs and arch, or perhaps a more tricky/fast
-  database-based system.         
-
-
-Entities and terminology
-------------------------
-
-The name of the project is *Bazaar-NG*; the top-level command is
-``bzr``.
-
-Branch
-''''''
-
-Development in Bazaar-NG takes places on branches.  A branch records
-the progress of a *tree* through various *revisions* by the
-accumulation of a series of *patches*.
-
-We can point to a branch by specifying its *location*.  At first this
-will be just a local directory name but it might grow to allow remote
-URLs with various schemes.
-
-Branches have a *name* which is for human convenience only; changesets
-are permanently labelled with the name of the branch on which they
-originated.  Branch names complement change descriptions by providing
-a broader context for the purpose of the change.  Typically the branch
-name will be the same as the last component of the directory or path.
-
-There is no higher-level grouping than branches.  (Nothing that
-corresponds to repositories in CVS or Subversion, or
-archives/categories/versions in Arch.)  Of course it may be a good
-practice to keep your branches organized into directories for each
-project, just as you might do with tarballs or cvs working
-directories.  
-
-Bazaar-NG makes forking branches very easy and common.  
-
-
-
-Revision
-''''''''
-
-The tree in a branch at a particular moment, after applying all the
-patches up to that point.
-
-
-File id
-'''''''
-
-A UUID for a versioned file, assigned by ``bzr add``.
-
-
-Delta
-'''''
-
-A smart diff, containing:
-
-* unidiff hunks for textual changes
-
-* for each affected file, the file id and the name of that file before
-  and after the delta (they will be the same if the file was not renamed)
-
-* in future, possibly other information describing symlinks,
-  permissions, etc
-
-A delta can be generated by comparing two trees without needing any
-additional input. 
-
-Although deltas have some diff context that would allow fuzzy
-application they are (almost?) always exactly applied to the correct
-predecessor. 
-
-
-Changeset
-'''''''''
-
-(also known as a patch)
-
-A changeset represents a commit to a particular branch; it
-incorporates a *delta* plus some header information such as the name
-of the committer, the date of the commit, and the commit message.
-
-
-Tree
-''''
-
-A tree of files and directories.  A branch minus the Bazaar-NG control files.
-
-
-
-
-Syntax
-------
-
-Branches
-''''''''
-
-Branches are identified by their directory name or URL::
-
-  bzr branch http://kernel.org/bzr/linux/linux-2.6
-  bzr branch ./linux-2.6 ./linux-2.6-mbp-partitions
-
-Branches have human-specified names used for tracing patches to their
-origin.  By default this is the last component of the directory name. 
-
-
-Revisions
-'''''''''
-
-Revisions within a branch may be identified by their sequence number
-on that branch, or by a tag name::
-
-  bzr branch ./linux-2.6@43 ./linux-2.6-old
-  bzr branch ./linux-2.6@rel6.8.1 ./linux-2.6.8.1
-
-You may also use the UUID of the patch or by the hash of that
-revision, though sane humans should never (need to) use these::
-
-  bzr log ./linux-2.6@uuid:6eaa1c41-34b8-4e0e-8819-acb5dfcabb78
-  bzr log ./linux-2.6@hash:4bf00930372cce9716411b266d2e03494f7fe7aa
-
-Revision ranges are given as two revisions separated by a colon (same
-as Svn):
-
-  bzr merge ../distcc-doc@4:10 
-
-
-Authors
-'''''''
-
-Authors are identified by their email address, taken from ``$EMAIL``
-or ``$BZR_EMAIL``.
-
-
-
-
-Tree inventory
---------------
-
-When a revision is committed, Bazaar-NG records an "inventory"  which
-essentially says which version of each file should be assembled into
-which location in the tree.  It also includes the SHA-1 hash and the
-size of each file.
-
-
-
-Merging
--------
-
-Merges are carried out in Bazaar-NG by a three-way merge of trees.  Users
-can choose to merge all changes from another branch, or a particular
-subset of changes.  In either case Bazaar-NG chooses an appropriate
-common base appropriately, although there should perhaps also be an
-option to specify a different base.
-
-I have not solved all the merge problems here.  I do think that this
-design preserves as much information as possible about the history of
-the code and so gives a good foundation for smart merging.
-The basic merge operation is a 3-way diff: we have three files *BASE*,
-*OTHER* and *MINE* and want to produce a result.  There are many
-different tools that could be used to resolve this interactively or
-automatically. 
-
-There are some cases where the best base is not a state that ever
-occurred on the two branches.  One such case is when there are two
-branches that have both tracked an upstream branch but have never
-previously synced with each other.  In this case we suggest that
-people manually specify the base::
-
-  bzr merge --base linus-2.6 my-2.6 
-
-Merges most commonly happen on files, but can also occur on metadata.
-For example we may need to resolve a conflict between file ids to
-decide what name a file should have, or conversely which id it should
-have.
-
-When merging an entire branch, the base is chosen as the last revision
-in which the trees manifests were identical.
-
-If merging only selected revisions from a branch (ie cherry picking)
-then the base is set just before the revisions to be merged.
-
-A three-way merge operates on three inputs: THIS, OTHER, and a BASE.
-Any regions which have been changed in only one of THIS and OTHER, or
-changed the same way in both will be carried across automatically.
-Regions which differ in all three trees are conflicts and must be
-manually resolved.
-
-The merge does not depend upon any states the trees may have
-passed through in between the revisions that are merged. 
-
-After the merge, the destination tree incorporates all the patches
-from the branch region that was merged in.  
-
-
-
-Sending patches by email
-------------------------
-
-Patches can be sent to someone else by email, just by posting the
-string representation of the changeset.  Could also post the GPG
-signature.
-
-The changeset cannot itself contain its uniquely-identifying hash.
-Therefore I suppose it needs some kind of super-header which says what
-the patch id is; this can be verified by comparing it to the hash of
-the actual changeset.  This in turn applies that the text must be
-exactly preserved in email, so possibly we need some kind of
-quoted-printable or ascii-armoured form.
-
-Another approach would be to not use the hash as the id, but rather
-something else which allows us to check the patch is actually what it
-claims to be.  For example giving a GPG key id and a UUID would do
-just as well, and *would* allow the id to be included within the
-patch, as would giving an arch-style revision ID, assuming we can
-either map the userid to a GPG key and/or check against a trusted
-archive. 
-
-There are two ways to apply such a received patch.  Ideally it tells
-us a revision of our branch from which it was based, probably by
-specifying the content hash.  We can use that as the base, make a
-branch there, apply the patch perfectly, and then merge that branch
-back in through a 3-way merge.  This gives a clean reconciliation of
-changes in the patch against any local changes in the branch since the
-base.
-
-If we do not have the base for the patch we can try apply it using
-a similar mechanism to regular patch, which might cause conflicts.  Or
-maybe it is not worth special-casing this; we could just require
-people to have the right basis to accept a patch.
-
-
-
-Rewriting history
------------------
-
-History is generally append-only; once something is committed it
-cannot be undone.  We need this to make several important guarantees
-about being able to reconstruct previous versions, about patches being
-consistent, and so on and on.
-
-However, pragmatically, there are a few cases where people will insist
-on being able to fudge it.  We need to accommodate those as best we
-can, within the limits of causality.  In other words, what is
-physically and logically possible should not be arbitrarily forbidden
-by the software (though it might be enormously discouraged).
-
-The basic transaction is a changeset/patch/commit.  There is little
-value and hellish complexity in introducing meta-changesets or trying
-to update already-committed changes.
-
-
-Wrong commit message
-''''''''''''''''''''
-
-*Oops, I pressed Save too soon, and the commit message is wrong.*  This
-happens all the time.
-
-If no other branch has taken that change, there is no harm in fixing
-the message.  Noticing the problem right away is probably a very
-common case.
-
-Therefore, you can change the descriptive text (but not any other
-metadata) of a changeset in your tree.  This will not propagate to
-anyone else who has already accepted the change.  Nothing will break,
-but they'll still see the original (incorrect/incomplete) commit.
-
-
-Committed confidential information
-''''''''''''''''''''''''''''''''''
-
-If you just added a file you didn't mean to add then you can simply
-commit a second changeset to remove it again.  However, sometimes
-people will accidentally commit sensitive/confidential information,
-and they need to remove it from the history. 
-
-If anyone else has already taken the changeset we can't prevent them
-seeing or keeping the information.  You need to find them and ask them
-nicely to remove it as well.  Similarly, if you've mirrored your
-branch elsewhere you need to fix it up by hand.  This additional
-manual work is a feature because it gives you some protection against
-accidentally destroying the wrong thing.
-
-A similar but related case is accidentally committing an enormous
-file; you don't want it to hang around in the archive for ever.  (In
-fact, it would need to be stored twice, once for the original commit
-and again for a reversible remove changeset.)
-
-Here is our suggestion for how to fix this: make a second branch from
-just before the undesired commit, typically by specifying a timestamp.
-If there are any later commits that need to be preserved, they can be
-merged in too.  Possibly that will cause conflicts if they depended on
-the removed changeset, and those changes then need to be resolved.
-
-
-
-
-
-
-History truncation
-------------------
-
-(I don't think we should implement this soon, if at all, but people
-might want to know it's possible.)
-
-Bazaar-NG relies on each branch being able to recreate any of its
-predecessor states.  This is needed to do really intelligent merging.
-
-However, you might eventually get sick of keeping all the history
-around forever.  Therefore, we can set a history horizon, ignoring all
-patches before that point. 
-
-The patches are still recorded as being merged but we do not keep the
-text of the patches.  Perhaps we add them to a special list.  
-
-Merges with a tree that have no history in common since the horizon
-will be somewhat harder.
-
-
-A development path
-------------------
-
-**See also work-log.txt for what I'm currently doing.**
-
-* Start by still using Arch changeset format, do-changeset and delta
-  commands, possibly also for merge.
-
-* Don't do any merges automatically at first but rather just build
-  some trees and let the user run dirdiff or something.
-
-* Don't handle renames at first.
-
-* Don't worry about actually being distributed yet; just work between
-  local directories.  There are no conceptual problems with accessing
-  remote directories.
-
-
-Compared to others
-------------------
-
-* History cannot be rewritten, aside from a couple of special
-  pragmatic cases.
-
-* Allows cherry-picking, which is not possible on bk or most others.
-
-* Allows merges within an arbitrary graph (rather than a line, star or
-  tree), which can be done by bk but not by arch or others.
-
-* History-sensitive merges allow safe repeated merges and mutual
-  merges between parallel lines.
-
-* Patches are labelled with the history of branches they traversed to
-  their current location, which is previously unique to Arch.
-
-* Would aim to be almost as small and simple as Quilt.
-
-* Does not need archives to be registered.  
-
-* Like darcs and bk, remembers the last archive you pulled from and
-  uses this as the default.  Also as a bonus remembers all branches
-  you previously pulled and their name, so that it is as if they were
-  registered.
-
-* Because patches do not change when they move around (as in Darcs),
-  they can be cryptographically signed.
-
-* Recognizes that textually non-conflicting merges may not be a
-  correct merge and may not work, and so should not be auto-committed.
-  The developer must have a chance to intervene after the merge and
-  before a commit.  (I think Monotone is wrong on this.)
-
-
-
-
-Best practices
---------------
-
-We recommend that people using Bazaar-NG follow these practices and
-protocols:
-
-* Develop independent features in separate branches.  It's easier to
-  keep them separate and merge later than to mix things together and
-  then try to separate them.  Although cherry picking is possible,
-  it's generally harder than keeping the code separate in the first
-  place.
-
-* Although you can merge in a graph, it can be easier to understand
-  things if you keep them roughly sorted into a star of downstream and
-  upstream branches.
-
-* Merge off your laptop/workstation into a personal stable tree at
-  regular changes; this protects against accidentally losing your
-  development branch for any reason. 
-
-* Try to have relatively "pure" merges: a single changeset that merges
-  changes should make only those merges and any edits needed to fix
-  them up. 
-
-* You can use reStructuredText (like this document) for commit
-  messages to allow nicer formatting and automatic detection of URLs,
-  email addreses, lists, etc.  Nothing requires this.
-
-
-
-Mechanics
----------
-
-Patch format
-''''''''''''
-
-A patch (i.e. commit to a branch) exists at three levels:
-
-* the hash of the patch, which is used as its globally-unique name
-
-* the headers of the patch, including:
-
-  - the human-readable name of the branch to which the changeset was committed
-
-  - free-form comments about the changeset
-
-  - the email address and name of the user who committed the changeset
-
-  - the date when the changeset was committed to the branch
-
-  - the UUIDs of any patches merged by this change
-
-  - the hash of the before and after trees
-
-  - the IDs of any files affected by the change, and their names
-    before and after the change, and their hash before and after the
-    change
-
-* the actual text of the patch, which may include
-
-  - unidiff hunks
-
-  - xdeltas (in reversible pairs?)
-
-  - complete files for adds/deletes, or for binaries
-
-At the simplest level a branch knows just the IDs of all of the
-patches committed to it.  More usually it will also have all their
-logs or all their text.
-
-Using the IDs, it can retrieve the patches when necessary from a
-shared or external store.  By this means we can have many checkouts,
-each of which looks like it holds all of its history, without actually
-using a lot of space.  When pulling down a remote branch by default
-everything will be mirrored, but there might be an option to only get
-the inventory or only the logs. 
-
-Keeping the relatively small header separate from the text makes it
-easy to get only the header information from a remote machine.  One
-might also when offline like to see only the logs but not necessarily
-have the text.
-
-Only the basic policy (keep everything everywhere) needs to be done in
-the first release of course.
-
-The headers need to be stored in some format that allows moderately
-structured data.  Ideally it would be both human readable and
-accessible from various languages.  In the prototype I think I'll use
-Python data format, but that's probably not good in the long term.  It
-may be better to use XML (tasteless though that is) or perhaps YAML or
-RFC-2822 style.  Python data is probably not secure in the face of
-untrusted patches.
-
-The date should probably be shown in ISO form (unoptimal though that
-is in some ways.)
-
-
-
-  
-
-Unresolved questions and other ideas
-------------------------------------
-
-
-Pulling in inexact matches
-''''''''''''''''''''''''''
-
-If ``update`` pulls in patches noninteractively onto the history, then
-there are some issues with patches that do not exactly match.  Some
-consequences:
-
-* You may pull in a patch which causes your tree to semantically
-  break.  This might be avoided by having a test case which is checked
-  before committing.
-
-* The patch may fuzzily apply; this is OK. 
-
-If we pull in a patch from elsewhere then we will have a signature on
-the patch but not a signature for the whole cacherev. 
-
-
-
-
-Have pristines/working directory by default?
-''''''''''''''''''''''''''''''''''''''''''''
-
-It seems a bit redundant to have two copies of the current version of
-each file in every repository, even ones in which you'll never edit.
-Some fixes are possible:
-
-* don't create working copy files 
-
-* hard link working copies into pristine directory (can detect
-  corruption by having SHA-1 sums for all pristine files)
-
-I think it's reasonable to have 
-
-
-
-Directory name
-''''''''''''''
-
-We have a single metadata directory at the top-level of the tree: ``.bzr``.
-There is no value in having it non-hidden, because it can't be seen
-from subdirectories anyhow.  Apparently three-letter names after a dot
-are fine on Windows -- it works for ``.svn``.
-
-
-File encodings
-''''''''''''''
-
-Unicode, line endings, etc.  Ignore this for now?
-
-Case-insensitive file names?  Maybe follow Darcs in forbidding files
-that differ only in case.
-
-
-Always use 3-way merge
-''''''''''''''''''''''
-
-I think using .rej files and fuzzy patches is confusing/unhelpful.  
-
-I would like to use 3-way merges between appropriate coordinates as
-the fundamental mechanism for all 'merge'-type operations.  
-
-Is there any case where .rej files are more useful?  Why would you
-ever want that?  Some people seem to `prefer them`__ in Arch.
-
-__ http://wiki.gnuarch.org/moin.cgi/Process_20_2a_2erej_20files 
- 
-I guess when cherry-picking you might not be able to find an
-appropriate ancestor for diff3?  I think you can; anyhow wiggle can
-transform rejects into diff3-style conflicts so why not do that?
-
-Miles says there that he prefers .rej files to conflict markers
-because they give better results for complex conflicts. 
-
-Perhaps we should just always produce both and let people use whatever
-they want.
-
-Another suggestion is the *rej_* tool, which helps fix up simple
-rejects:
-
-  There are four basic rejects fixable via rej.
-
-  1) missing context at the top or bottom of the hunk
-  2) different context in the middle of the hunk
-  3) slightly different lines removed by the hunk than exist in the file
-  4) Large hunks that might apply if they were broken up into smaller ones.
-
-.. _rej: ftp://ftp.suse.com/pub/people/mason/rej/
-
-
-Mirroring
-'''''''''
-
-One reason people say they like archives is that all new work in that
-archive will be automatically mirrored off your laptop, if it's
-already set up to mirror that archive.
-
-
-
-Control files out of tree
-'''''''''''''''''''''''''
-
-Some people would like to have absolutely no control files in their
-tree.  This is conceptually easy as long as we can find both the
-control files and working directory when a command is run.
-
-As a first step, the ``.bzr`` directory can be replaced by a symlink,
-which will prevent recursive commands looking into it.  Another
-approach is to put all actual source in a subdirectory of the tree, so
-that you never need to see the directory unless you look above the
-ceiling.
-
-If this is not enough, we might ask them to have an environment
-variable point to the control files, or have a map somewhere
-associating working directories with their control files.
-Unfortunately both of those seem likely to come loose and whip around
-dangerously.
-
-
-Representation of changesets
-''''''''''''''''''''''''''''
-
-Using patches is nice for plain text files.  In general we want the
-old and new names to correspond, but these are only for decoration;
-the file id determines where the patch really goes.
-
-* Should they be reversible?
-
-* How to represent binary diffs?
-
-* How to represent adds/removes?
-
-* How to zip up multiple changes into a single bundle?
-
-Reversibility is very important.  We do not need it for regular
-merges, since we can always recover the previous state.  We do need it
-for application of isolated patches, since we may not be able to
-recover the prior state.  It might also help when building a previous
-tree state.  
-
-Of course we can have an option to show deletes or to make the diff
-reversible even if it normally is not.
-
-It is very nice that plain diffs can be concatenated into a single
-text file.  This is not easily possible with binary files, xdeltas,
-etc.  Of course it is uncommon to display binary deltas directly or
-mail them, but if mailing is really required we could use base64 or
-MIME.
-
-Perhaps it would be reasonable to just store xdeltas between versions.
-
-Perhaps each changeset body should be a tar or zip holding the
-patches, though in simpler form than Arch.
-
-(Since these are free choices, perhaps stick closely to what Arch
-does?)
-
-
-Continuations
-'''''''''''''
-
-Do we need the generalized continuations currently present in Arch, or
-will a more restricted type do?  
-
-One use case for arch continuation tags is to make a release branch
-which contains only tags from the development branch.
-
-Maybe want darcs-style tags which just label the tree at various
-points; more familiar to users perhaps?
-
-::
-
-    bzr fork http://samba.org/bzr/samba/main ./my-samba
- 
-1. creates directory my-samba
-2. copies contents of samba main branch
-3. the parent becomes samba-main
-4. parent is the default place you'll pull from & push to
-   
-Is there a difference between "contains stuff from samba-main" and "is
-branched from samba-main"?
-
-
-
-File split/merge
-''''''''''''''''
-
-Is there any sense in having a command to copy a file, or to rejoin
-several files with different IDs?
-
-Joining might be useful when the same tree is imported several times,
-or the same new-file operation is done in different trees.
-
-
-
-Time skew
-'''''''''
-
-Local clocks can be wrong when they record a commit.  This means that
-changes may be irrevocably recorded with the wrong time, and that in
-turn means that later changes may seem to come from before earlier
-changes.  We can give a warning at the later time, but short of
-refusing the commit there is not much we can do about it.
-
-
-Annotate/blame/praise
----------------------
-
-``cvs annotate`` is pretty useful for understanding the history of
-development.  At the same time it is not quite trivial to implement,
-so I plan to make sure all the necessary data is easily accessible and
-then defer actually writing it.  Possibly the most complicated part is
-something to read in a diff and find which lines came from where. 
-
-What we need is a way to easily follow back through the history of a
-file, this is easily done by walking back along the branch.  Since we
-have revision numbers within a branch we have a short label which can
-be put against each line; we can also put a key at the bottom with
-some fields from each revision showing the committer and comment.
-
-For the case of merge commits people might be interested to know which
-merged patch brought in a change.  We cannot do this completely
-accurately since we don't know what the person did during the manual
-resolution of the merge, but by looking for identical lines we can
-probably get very close.  We can at the very least tell people the
-hash of all patches that were merged in so they can go and have a look
-at them.
-
-
-
-Performance
------------
-
-I think nothing here requires loading the whole tree into memory, as
-Darcs does.  We can detect renames and then diff files one by one.
-
-Because patches cannot change or be removed once they are committed or
-merged, we do not need to diff the patch-log, which is a problem in
-Arch.
-
-We do need to hold the whole list of patches in memory at various
-points but that should be at most perhaps 100,000 commits.
-
-We do need to pull down all patches since forever but that's not too
-unreasonable.
-
-Most heavy lifting can be done by GNU diff, patch and diff3, which are
-hopefully fast.
-
-Patches should be reasonably proportionate to the actual size of
-changes, not to the total size of the tree -- we should only list the
-hash and id for files that were touched by the change.  This implies
-that generating the manifest for any given revision means walking from
-the start of history to that revision.   Of course we can cache that
-manifest without necessarily caching the whole revision.
-
-* The dominant effect on performance in many cases will be network
-  round-trips; as Tom says "every one is like punching your user in
-  the face."
-
-  The network protocol can/should try to avoid them.
-
-  However, here's an even lazier idea: by making it possible to use
-  rsync for moving trees around, we get an insanely pipelined protocol
-  *for free*.
-
-  It's not always suitable (as when committing to a central tree), but
-  it will often work.  Cool!
-
-  Safely using rsync probably requires user intervention to make sure
-  that the tree is idle at the time the command runs; otherwise the
-  ordering of files arriving makes it really hard to know that we have
-  a consistent state.  I guess we can just ignore patches that are
-  missing...
-
-
-Hashing
--------
-
-It might be nice to present hashes in BubbleBabble or some similar
-form to make it a bit easier on humans who have to see them.  This can
-of course be translated to and from binary.  On the other hand there
-is something in favour of regular strings that can be easily verified
-with other tools.
-
-We can have a Henson Mode in which it never trusts that files with the
-same hash are identical but always checks it.  Of course if SHA-1 is
-broken then GPG will probably be broken too...
-
-Comparison:
-
-binary:
-  20 bytes
-bubblebabble
-  > xizif-segim-vipyz-dyzak-gatas-sifet-dynir-gegon-borad-cetit-tixux
-  65 bytes
-base64:
-  > qvTGHdzF6KLavt4PO0gs2a6pQ00=
-  28 bytes
-hex:
-  > aaf4c61ddcc5e8a2dabede0f3b482cd9aea9434d
-  40 bytes
-
-Hex is probably the most reasonable tradeoff.
-
-
-File metadata
--------------
-
-I don't want to get into general versioning of file metadata like
-permissions, at least in the first version; it's hard to say what
-should be propagated and what should not be.  This is a source code
-control system.
-
-It may be useful to carry some very restricted bits, like *read only*
-or *executable*; I think these are harmless.
-
-The only case where people generally want to remember permissions and
-ownership is when versioning ``/etc``, which is quite a special case.
-Perhaps this should be deferred to a special script such as the
-``cvs-conf`` package.
-
-
-Faster comparisons
-------------------
-
-There are many cases where we need to compare trees; perhaps the most
-common is just diffing the tree to see what changed.  For small to
-medium trees it is OK to just diff everything in the tree, and we can
-do just this in the first version.  This runs into trouble for
-kernel-sized trees, where reading every 
-
-
-Fear of forking
----------------
-
-There is some fear that distributed version control (many branches)
-will encourage projects to fork.  I don't think this is necessarily
-true of Bazaar.
-
-A fundamental principle of Bazaar is that is not the tool's place to
-make you run a project a particular way.  The tool enables you to do
-what you want.  The documentation and community might suggest some
-practices that have been useful for other projects, but the choice is
-up to you.  There are principles for running open source projects that
-are useful regardless of tool, and Bazaar supports them.  They include
-encouraging new contributors, building community, managing a good
-release schedule and so on, but I won't enumerate them all here (and I
-don't claim to know them all.)
-
-Bazaar reduces some pressures that can lead to forking.  There need
-not be fights about who gets commit access: everyone can have a branch
-and they can contribute their changes.  Radical new development can
-occur on one branch while stabilization occurs on another and a new
-feature or port on a third.  Both creating the branches and merging
-between them should be easier in the Bazaar than with existing
-systems.  (Though of course there may be technical difficulties that
-no tool can totally remove.)
-
-Sometimes there really is a time for a fork, for various reasons:
-irreconcilable differences on technical direction or personality.  If
-that happens, Bazaar makes the break less total: the projects can
-still merge patches, share bug fixes and features, and even eventually
-reunite.
-
-
-Why a new project?
-------------------
-
-A key goal is simplicity and user-friendliness; this is easier to
-build into a new tool than to fix in an existing tool.  Nevertheless
-we want to provide a smooth upgrade path from Arch, CVS, and other
-systems.
-
-
-References
-----------
-
-* http://www.dwheeler.com/essays/scm.html
-
-  Good analysis; should try to address everything there in a way he will like.
-
-
-.. Local variables:
-.. mode: indented-text
-.. End:
-
-.. Would like to use rst-mode, but it's too slow on a document of this
-.. size.
\ No newline at end of file

=== removed file 'doc/extra-commands.txt'
--- doc/extra-commands.txt	2005-11-07 13:17:53 +0000
+++ doc/extra-commands.txt	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-************************
-Bazaar-NG Extra Commands
-************************
-
-:Copyright: Copyright 2005 Canonical Ltd.
-
-.. contents::
-
-This document lists some "extra" commands that are intended for
-developer, debugging, or advanced-hacker use.  You should not need to
-know about them for normal operations.
-
-
-
-inventory
-    List files in the working copy, in an XML format including the
-    filename, id and content hash.
-
-unknowns
-    List unknown files.
-
-uuid
-    Emit a new UUID.
-
-add-to-store
-    Add given files to the full-text store, indexed by their hash.
-
-doctest
-    Run test suite.
-
-revno
-    Print number of revisions on this branch (or equivalently, the
-    latest revision number.)
\ No newline at end of file

=== removed file 'doc/formats.txt'
--- doc/formats.txt	2005-11-07 13:17:53 +0000
+++ doc/formats.txt	1970-01-01 00:00:00 +0000
@@ -1,261 +0,0 @@
-*****************
-Bazaar-NG formats
-*****************
-
-.. contents::
-
-Since branches are working directories there is just a single
-directory format.
-
-There is one metadata directory called ``.bzr`` at the top of each
-tree.  Control files inside ``.bzr`` are never touched by patches and
-should not normally be edited by the user.
-
-These files are designed so that repository-level operations are ACID
-without depending on atomic operations spanning multiple files.  There
-are two particular cases: aborting a transaction in the middle, and
-contention from multiple processes.  We also need to be careful to
-flush files to disk at appropriate points; even this may not be
-totally safe if the filesystem does not guarantee ordering between
-multiple file changes, so we need to be sure to roll back.
-
-The design must also be such that the directory can simply be copied
-and that hardlinked directories will work.  (So we must always replace
-files, never just append.)
-
-A cache is kept under here of easily-accessible information about
-previous revisions.  This should be under a single directory so that
-it can be easily identified, excluded from backups, removed, etc.
-This might contain pristine tree from previous revisions, manifests
-and inventories, etc.  It might also contain working directories when
-building a commit, etc.  Call this maybe ``cache`` or ``tmp``.
-
-I wonder if we should use .zip files for revisions and cacherevs
-rather than tar files so that random access is easier/more efficient.
-There is a Python library ``zipfile``.
-
-
-Signing XML files
-*****************
-
-bzr relies on storing hashes or GPG signatures of various XML files.
-There can be multiple equivalent representations of the same XML tree,
-but these will have different byte-by-byte hashes.
-
-Once signed files are written out, they must be stored byte-for-byte
-and never re-encoded or renormalized, because that would break their
-hash or signature.
-
-
-
-
-Branch metadata
-***************
-
-All inside ``.bzr``
-
-``README``
-  Tells people not to touch anything here.
-
-``branch-format``
-  Identifies the parent as a Bazaar-NG branch; contains the overall
-  branch metadata format as a string.
-
-``pristine-directory``
-  Identifies that this is a pristine directory and may not be
-  committed to.
-
-``patches/``
-  Directory containing all patches applied to this branch, one per
-  file.  Patches are stored as compressed deltas.  We also store the
-  hash of the delta, hash of the before and after manifests, and
-  optionally a GPG signature.
-
-``cache/``
-  Contains various cached data that can be destroyed and will be
-  recreated.  (It should not be modified.)
-
-``cache/pristine/``
-  Contains cached full trees for selected previous revisions, used
-  when generating diffs, etc.
-
-``cache/inventory/``
-  Contains cached inventories of previous revisions.
-
-``cache/snapshot/``
-  Contains tarballs of cached revisions of the tree, named by their
-  revision id.  These can also be removed, but 
-
-``patch-history``
-  File containing the UUIDs of all patches taken in this branch,
-  in the order they were taken.
-  Each commit adds exactly one line to this file; lines are
-  never removed or reordered.
-
-``merged-patches``
-  List of foreign patches that have been merged into this branch.
-  Must have no entries in common with ``patch-history``.  Commits that
-  include merges add to this file; lines are never removed or
-  reordered.
-
-``pending-merges`` 
-  List (one per line) of non-mainline revisions that
-  have been merged and are waiting to be committed.
-
-``branch-name``
-  User-qualified name of the branch, for the purpose of describing the
-  origin of patches, e.g. ``mbp@sourcefrog.net/distcc--main``.
-
-``friends``
-  List of branches from which we have pulled; file containing a list
-  of pairs of branch-name and location.
-
-``parent``
-  Default pull/push target.
-
-``pending-inventory``
-  Mapping from UUIDs to file name in the current working directory.  
-
-``branch-lock``
-  Lock held while modifying the branch, to protect against clashing
-  updates.
-
-
-Locking
-*******
-
-Is locking a good strategy?  Perhaps somekind of read-copy-update or
-seq-lock based mechanism would work better?
-
-If we do use a locking algorithm, is it OK to rely on filesystem
-locking or do we need our own mechanism?  I think most hosts should
-have reasonable ``flock()`` or equivalent, even on NFS.  One risk is
-that on NFS it is easy to have broken locking and not know it, so it
-might be better to have something that will fail safe.
-
-Filesystem locks go away if the machine crashes or the process is
-terminated; this can be a feature in that we do not need to deal with
-stale locks but also a feature in that the lock itself does not
-indicate cleanup may be needed.
-
-robertc points out that tla converged on renaming a directory as a
-mechanism: this is one thing which is known to be atomic on almost all
-filesystems.  Apparently renaming files, creating directories, making
-symlinks etc are not good enough.
-
-
-
-Delta
-*****
-
-XML document plus a bag of patches, expressing the difference between
-two revisions.  May be a partial delta.
-
-* list of entries
-
-  * entry
-  
-    * parent directory (if any)
-    * before-name or null if new
-    * after-name or null if deleted
-    * uuid
-    * type (dir, file, symlink, ...)
-    * patch type (patch, full-text, xdelta, ...)
-    * patch filename (?)
-
-
-Inventory
-*********
-
-XML document; series of entries.  (Quite similar to the svn
-``entries`` file; perhaps should even have that name.)
-Stored identified by its hash.
-
-An inventory is stored for recorded revisions, also a
-``pending-inventory`` for a working directory.
-
-Inventories always have the same id as the revision they correspond
-to.  bzr up to 0.0.5 explicitly stores an inventory-id; in future
-versions this may be implied.
-
-
-
-Revision
-********
-
-XML document.  Stored identified by its hash.
-
-committer
-  RFC-2822-style name of the committer.  Should match the key used to
-  sign the revision.
-
-comment
-  multi-line free-form text; whitespace and line breaks preserved
-
-timestamp
-  As floating-point seconds since epoch.
-
-branch name
-  Name of the branch to which this was originally committed.    
-
-  (I'm not totally satisfied that this is the right way to do it; the
-  results will be a bit weird when a series of revisions pass through
-  variously named branches.)
-
-inventory_hash
-  Acts as a pointer to the inventory for this revision.
-
-parents
-  Zero, one, or more references to parent revisions.   For each 
-  the revision-id and the revision file's hash are given.  The first
-  parent is by convention the revision in whose working tree the
-  new revision was created.
-
-precursor
-  Must be equal to the first parent, if any are given.  For
-  compatibility with bzr 0.0.5 and earlier; eventually will be
-  removed. 
-
-merged-branches
-  Revision ids of complete branches merged into this revision.  If a
-  revision is listed, that revision and transitively its predecessor
-  and all other merged-branches are merged.  This is empty except
-  where cherry-picks have occurred.
-
-merged-patches
-  Revision ids of cherry-picked patches.  Patches whose branches are
-  merged need not be listed here.  Listing a revision ID implies that
-  only the change of that particular revision from its predecessor has
-  been merged in.   This is empty except where cherry-picks have
-  occurred.
-
-The transitive closure avoids Arch's problem of needing to list a
-large number of previous revisions.  As ddaa writes:
-
-    Continuation revisions (created by tla tag or baz branch) are associated
-    to a patchlog whose New-patches header lists the revisions associated to
-    all the patchlogs present in the tree. That was introduced as an
-    optimisation so the set of patchlogs in any revision could be determined
-    solely by examining the patchlogs of ancestor revisions in the same
-    branch. This behaves well as long as the total count of patchlog is
-    reasonably small or new branches are not very frequent.
-
-    A continuation revision on $tree currently creates a patchlog of
-    about 500K. This patchlog is present in all descendent of the revision,
-    and all revisions that merges it.
-
-It may be useful at some times to keep a cache of all the branches, or
-all the revisions, present in the history of a branch, so that we do
-need to walk the whole history of the branch to build this list.
-  
-
-----
-
-Proposed changes
-****************
-
-* Don't store parent-id in all revisions, but rather have <DIRECTORY>
-  nodes that contain entries for children?
-
-* Assign an id to the root of the tree, perhaps listed in the top of
-  the inventory?

=== removed file 'doc/hashes.txt'
--- doc/hashes.txt	2005-11-07 13:17:53 +0000
+++ doc/hashes.txt	1970-01-01 00:00:00 +0000
@@ -1,73 +0,0 @@
-Use of hashes in Bazaar-NG
-**************************
-
-* http://infohost.nmt.edu/~val/review/hash.html
-* http://infohost.nmt.edu/~val/review/hash2.html
-
-The main attraction of hashes in bazaar-ng is as an easy way to get
-universally-unique IDs, or at least with a low chance of collision:
-
-The first paper is a bit paranoid; the second has some sensible
-advice:
-
-1. Will compare-by-hash provide significant benefit -- save time,
-   bandwidth, etc?
-
-2. Is the system usable if hash collisions can be generated at will?
-
-3. Can the hashes be regenerated with a different algorithm at any
-   time?
-
-We should try to abide by these rules.  I think they are possibly too
-paranoid -- a real break of SHA-1 would have much wider security
-implications -- but if a design that respects them is practical, it
-should be preferred.
-
-The first is probably true; the third is just a matter of making sure
-we allow for the choice of hash to be varied in the format.
-
-There are actually two variations on the second:
-
-2a. Is the system safe if an attacker can generate hash collisions?
-
-2b. Is the system safe if a user's own files contain collisions.
-
-Regardless of cryptographic weakness, SHA-1 is unlikely to
-"accidentally" collide, but it's possible that someone will
-intentionally generate collisions (in research on SHA) and then want
-to store them.  It would be unfortunate if that did not work.
-
-An advantage of naming by hash is that it lets us store only a single
-copy of identical files, but we have already decided__ that disk space
-is pretty cheap.  It is perhaps enough to have a single copy of files
-that do not change from one tree revision to the next.
-
-__ costs.html
-
-As far as an attacker: we will not automatically trust that ids from
-one branch have the same value in another.  It is possible for a
-branch to contain "lies" about its history or contents, but that
-doesn't corrupt anything else.  It may confuse or mislead someone who
-looks at the branch, but there is no substitute for human review
-anyhow.
-
--------
-
-The safest position may be to never rely on identifying content by
-hash.  Rather, things which need a universally unique ID should get a
-UUID instead.
-
-This has a slight advantage that the id can be stored directly in the
-object it refers to, when that's useful.
-
-So a `Revision` holds a UUID for the `Inventory`.  
-
-An inventory holds `InventoryEntry` objects, each with
-
-* file-id
-* filename (location in tree)
-* type (file, dir, etc)
-* text-id (uuid identifying the text)
-* text-sha1
-* text-length (for catching bugs)
-* parent-file-id

=== removed file 'doc/ignore.txt'
--- doc/ignore.txt	2005-11-07 13:17:53 +0000
+++ doc/ignore.txt	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-Ignore patterns
-***************
-
-Ignore patterns need to be flexible but simple.
-
-Based on the system from rsync, which is in turn based on that of
-CVS.  However, I won't implement all of this at first but rather add
-bits as they seem to be needed.
-
-First build a list by concatenating:
-
-* per-user configuration
-* per-tree configuration
-* command line options
-
-Just one ``.bzrignore`` at tree root?
-
-File can contain '+ ' and '- ' prefixes to include and exclude things,
-also '#' for comments.
- 
-Should have a ``--ignore`` command line option that specifies ignore
-patterns; by putting a ! in this you can turn off any other includes.
-(Similar to CVS.)

=== removed file 'doc/index.txt'
--- doc/index.txt	2005-11-07 13:17:53 +0000
+++ doc/index.txt	1970-01-01 00:00:00 +0000
@@ -1,188 +0,0 @@
-Bazaar-NG
-*********
-
-..   These documents are formatted as ReStructuredText.  You can    ..
-..   convert them to HTML, PDF, etc using the ``python-docutils``   ..
-..   package.                                                       ..
-
-
-*Bazaar-NG* (``bzr``) is a project of `Canonical Ltd`__ to develop an
-open source distributed version control system that is powerful,
-friendly, and scalable.  The project is at an early stage of
-development.
-
-__ http://canonical.com/
-
-
-**Note: These documents describe the initial design and are out of
-date in parts.**  For more up-to-date information see the wiki at
-http://bazaar.canonical.com/
-
-For more information, see the homepage at http://bazaar-ng.org/
-
-
-
-User documentation
-------------------
-
-* `Project overview/introduction <intro.html>`__
-
-* `Command reference <cmdref.html>`__ -- intended to be user
-  documentation, and gives the best overview at the moment of what the
-  system will feel like to use.  Fairly complete.
-
-
-Requirements and general design
--------------------------------
-
-* `Various purposes of a VCS <purpose.html>`__ -- taking snapshots and
-  helping with merges is not the whole story.
-
-* `Requirements <requirements.html>`__
-
-* `Costs <costs.html>`__ of various factors: time, disk, network, etc.
-
-* `Deadly sins <deadly-sins.html>`__ that gcc maintainers suggest we avoid.
-
-* `Overview of the whole design <design.html>`__ and miscellaneous
-  small design points.
-
-* `File formats <formats.html>`__
-
-* `Random observations <random.html>`__ that don't fit anywhere else yet.
-
-
-
-Design of particular features
------------------------------
-
-* `Automatic generation of ChangeLogs <changelogs.html>`__
-
-* `Cherry picking <cherry-picking.html>`__ -- merge just selected non-contiguous changes  from a branch.
-
-* `Common changeset format <common-format.html>`__ for  interchange
-  format between VCS.
-
-* `Compression <compression.html>`__ of file text for more efficient storage.
-
-* `Config specs <config-specs.html>`__ assemble a tree from several places.
-
-* `Conflicts <conflicts.html>`_ that can occur during merge-like
-  operations.
-
-* `Ignored files <ignore.html>`__
-
-* `Recovering from interrupted operations <interrupted.html>`__
-
-* `Inventory command <inventory.html>`__
-
-* `Branch joins <join-branches.html>`__ represent that all the changes
-  from one branch are integrated into another.
-
-* `Kill a version <kill-version.html>`__ to fix a broken commit or
-  wrong message, or to
-  remove confidential information from the history.
-
-* `Hash collisions <hashes.html>`__ and weaknesses, and the security
-  implications thereof.
-
-* `Layers <layers.html>`__ within the design
-
-* `Library interface <library-interface.html>`__ for Python.
-
-* `Merge <merge.html>`__
-
-* `Mirroring <mirroring.html>`__
-
-* `Optional edit command <optional-edit.html>`__: sometimes people
-  want to make the  working copy read-only, or not present at all.
-
-* `Partial commits <partial-commit.html>`__
-
-* `Patch pools <pool.html>`__ to efficiently store related branches.
-
-* `Revfiles <revfile.html>`__ store the text history of files.
-
-* `Revfiles storing annotations <revfile-annotation.html>`__
-
-* `Revision syntax <revision-syntax.html>`__ -- ``hello.c@12``, etc.
-
-* `Roll-up commits <rollup.html>`__ -- a single revision incorporates
-  the changes from several others.
-
-* `Scalability <scalability.html>`__
-
-* `Security <security.html>`__
-
-* `Shared branches <shared-branches.html>`__ maintained by more than
-  one person
-
-* `Supportability <supportability.html>`__ -- how to handle any bugs
-  or problems in the field.
-
-* `Place tags on revisions for easy reference <tagging.html>`__
-
-* `Detecting unchanged files <unchanged.html>`__
-   
-* `Merging previously-unrelated branches <unrelated-merge.html>`__
-
-* `Usability principles <usability.html>`__ (very small at the moment)
-
-* `<use-cases.html>`__
-
-* `<web-interface.html>`__
-
-* `<workflow.html>`__ Modelling/controlling flow of patches.
-
-* `<yaml.html>`__ --  Discussion of using YAML_ as a storage or transmission format.
-
-.. _YAML: http://www.yaml.org/
-
-
-
-Comparisons to other systems
-----------------------------
-
-* `Taxonomy <taxonomy.html>`__: basic questions a VCS must answer.
-
-* `Bitkeeper <bitkeeper.html>`__, the proprietary system used by some
-  kernel developers.
-
-* `Aegis <compared-aegis.html>`__, a tool focussed on enforcing
-  process and workflow.
-
-* `Codeville <compared-codeville.html>`__ has an intruiging but
-  scarcely-documented merge algorithm.
-
-* `CVSNT <compared-cvsnt.html>`__, with more Windows support and some
-  merge enhancements.
-
-* `OpenCM <compared-opencm.html>`__, another hash-based tool with a
-  good whitepaper.
-
-* `PRCS <compared-prcs.html>`__, a non-distributed inventory-based tool.
-
-* `GNU Arch <todo-from-arch.html>`__, with many pros and cons.
-
-* `Darcs <darcs.html>`__, a merge-focussed tool with good usability.
-
-* `Quilt <quilt.html>`__ -- Andrew Morton's patch scripts, popular with kernel maintainers.
-
-* `Monotone <monotone.html>`__, Graydon Hoare's hash-based distributed system.
-
-* `SVK <svk.html>`__ --     distributed operation stacked on Subversion.
-
-* `Sun Teamware <compared-teamware.html>`__
-
-
-Project management and organization
------------------------------------
-
-* `Notes on how to get a VCS adopted <adoption.html>`__
-
-* `Thanks <thanks.html>`__ to various people
-
-* `Extra commands <extra-commands.html>`__ for
-  internal/developer/debugger use.
-
-* `Choice of Python as a development language <python.html>`__

=== removed file 'doc/interrupted.txt'
--- doc/interrupted.txt	2005-11-07 13:17:53 +0000
+++ doc/interrupted.txt	1970-01-01 00:00:00 +0000
@@ -1,113 +0,0 @@
-Interrupted operations
-**********************
-
-Problem: interrupted operations
-===============================
-
-Many version control systems tend to have trouble when operations are
-interrupted.  This can happen in various ways:
-
- * user hits Ctrl-C
-
- * program hits a bug and aborts
-
- * machine crashes
-
- * network goes down
-
- * tree is naively copied (e.g. by cp/tar) while an operation is in
-   progress
-
-We can reduce the window during which operations can be interrupted:
-most importantly, by receiving everything off the network into a
-staging area, so that network interruptions won't leave a job half
-complete.  But it is not possible to totally avoid this, because the
-power can always fail.
-
-I think we can reasonably rely on flushing to stable storage at
-various points, and trust that such files will be accessible when we
-come back up.
-
-I think by using this and building from the bottom up there are never
-any broken pointers in the branch metadata: first we add the file
-versions, then the inventory, then the revision and signature, then
-link them into the revision history.  The worst that can happen is
-that there will be some orphaned files if this is interrupted at any
-point. 
-
-rsync is just impossible in the general case: it reads the files in a
-fairly unpredictable order, so what it copies may not be a tree that
-existed at any particular point in time.  If people want to make
-backups or replicate using rsync they need to treat it like any other
-database and either
-
- * make a copy which will not be updated, and rsync from that
-
- * lock the database while rsyncing
-
-The operating system facilities are not sufficient to protect against
-all of these.  We cannot satisfactorily commit a whole atomic
-transaction in one step.
-
-Operations might be updating either the metadata or the working copy.
-
-The working copy is in some ways more difficult:
-
- * Other processes are allowed to modify it from time to time in
-   arbitrary ways.
-
-   If they modify it while bazaar is working then they will lose, but
-   we should at least try to make sure there is no corruption.
-
- * We can't atomically replace the whole working copy.  We can
-   (semi) atomically updated particular files.
-
- * If the working copy files are in a weird state it is hard to know
-   whether that occurred because bzr's work was interrupted or because
-   the user changed them.
-
-   (A reasonable user might run ``bzr revert`` if they notice
-   something like this has happened, but it would be nice to avoid
-   it.)
-
-We don't want to leave things in a broken state.
-
-
-Solution: write-ahead journaling?
-=================================
-
-One possibly solution might be write-ahead journaling:
-
-  Before beginning a change, write and flush to disk a description of
-  what change will be made.
-
-  Every bzr operation checks this journal; if there are any pending
-  operations waiting then they are completed first, before proceeding
-  with whatever the user wanted.  (Perhaps this should be in a
-  separate ``bzr recover``, but I think it's better to just do it,
-  perhaps with a warning.)
-
-  The descriptions written into the journal need to be simple enough
-  that they can safely be re-run in a totally different context.  They
-  must not depend on any external resources which might have gone
-  away.
-
-  If we can do anything without depending on journalling we should.
-
-  It may be that the only case where we cannot get by with just
-  ordering is in updating the working copy; the user might get into a
-  difficult situation where they have pulled in a change and only half
-  the working copy has been updated.  One solution would be to remove
-  the working copy files, or mark them readonly, while this is in
-  progress.  We don't want people accidentally writing to a file that
-  needs to be overwritten.
-
-  Or perhaps, in this particular case, it is OK to leave them in
-  pointing to an old state, and let people revert if they're sure they
-  want the new one?  Sounds dangerous.
-
-Aaron points out that this basically sounds like changesets.  So
-before updating the history, we first calculate the changeset and
-write it out to stable storage as a single file.  We then apply the
-changeset, possibly updating several files.  Each command should check
-whether such an application was in progress.

=== removed file 'doc/intro.txt'
--- doc/intro.txt	2005-11-07 13:17:53 +0000
+++ doc/intro.txt	1970-01-01 00:00:00 +0000
@@ -1,109 +0,0 @@
-Introduction to Bazaar
-======================
-
-Bazaar's goal is *to make a distributed version control system that
-open source developers will love to use*.  Using Bazaar should feel
-good.
-
-.. epigraph::
-
-  Language designers want to design the perfect language. They want to
-  be able to say, "My language is perfect. It can do everything." But
-  it's just plain impossible to design a perfect language, because
-  there are two ways to look at a language. One way is by looking at
-  what can be done with that language. The other is by looking at how
-  we feel using that language -- how we feel while programming.
-
-  Because of the Turing completeness theory, everything one
-  Turing-complete language can do can theoretically be done by another
-  Turing-complete language, but at a different cost. You can do
-  everything in assembler, but no one wants to program in assembler
-  anymore. From the viewpoint of what you can do, therefore, languages
-  do differ -- but the differences are limited. For example, Python
-  and Ruby provide almost the same power to the programmer.
-
-  Instead of emphasizing the what, I want to emphasize the how part: how
-  we feel while programming.
-
-  -- `Yukihiro Matsumoto`__
-
-__ http://www.artima.com/intv/ruby.html
-
-Bazaar tries to make simple things simple, and complex things
-possible.  In particular:
-
- * Distributed operation is easy: you can work while disconnected; you
-   can fork any other project; you can contribute changes back
-   easily.  
-
- * The system is designed to scale to supporting very large trees with
-   a lot of history.  No operations require downloading the entire
-   history of the project.
-
- * Changes can be "cherry-picked" out of branches as needed.   Because
-   of dependencies between 
-
-
-
-History-sensitive merging
-=========================
-
-Baz keeps track of what changes have been merged into a branch.  You
-can repeatedly merge from one branch into another and Baz will pull
-across only the new changes since you last merged.
-
-
-Speed
-=====
-
-For most users, the most important factor for performance is to avoid
-unnecessary network round trips.  Baz tries hard to avoid ever
-downloading the same data twice.  
-
-Remote archives are automatically cached on your local machine by
-default.  If you have ever accessed a remote revision you should be
-able to get it again without going to the network.  The cache policy
-may be tuned.
-
-
-
-Code history
-============
-
-One important function of a revision control system is to maintain a
-record of when, why, how and by whom changes were made. 
-
-Baz requires that branches and archives be named.
-
-Unlike most other systems, Baz keeps a record for each changeset of
-which branches and archives it passed through on its way to its
-eventual destination.  This allows people to go back later and see the
-context in which the patch was written or merged.
-
-
-
-Scalability
-===========
-
-We regularly test Baz on projects with tens of thousands of commits,
-and tens of thousands of files.
-
-
-
-Merging
-=======
-
-The basic method of integration is a three-way merge.  Baz selects an
-appropriate basis version
-
-
-
-File renaming
-=============
-
-Baz allows files and directories to be renamed in a project.  Unlike
-Subversion, Baz will correctly merge changes spanning file renames.
-This is done by automatically assigning a unique ID to each file,
-which is persistent across renames.
-
-

=== removed file 'doc/inventory.txt'
--- doc/inventory.txt	2005-11-07 13:17:53 +0000
+++ doc/inventory.txt	1970-01-01 00:00:00 +0000
@@ -1,10 +0,0 @@
-Should be a simple command that shows something similar to 'svn
-status':
-
-  what is not added but perhaps should be
-  what is source, backup, precious, junk, etc
-
-Or a nice simple command like 'bk extras' to show what's not added but
-should be.
-  
-baz inventory almost does this but it way too hard to understand
\ No newline at end of file

=== removed file 'doc/join-branches.txt'
--- doc/join-branches.txt	2005-11-07 13:17:53 +0000
+++ doc/join-branches.txt	1970-01-01 00:00:00 +0000
@@ -1,81 +0,0 @@
-****************
-Joining branches
-****************
-
-(I think this is pretty brilliant. :-)
-
-Branches diverge when people create more than one changeset following
-on from a common ancestor::
-
-  A:   0 ------- 1
-  B:    \------- 2
-
-We also allow branches to reunite.  This means that all the decisions
-taken on multiple branches have been reconciled and unified into a
-single successor::
-
-  A: 0 ------- 1 ----- 3
-      \               /
-  B:   \------ 2 ----/
-
-The predecessor of 3 is 1, in the sense that it was created on that
-branch.  We could have created the exact same state as a successor to
-2, and we can move that state onto branch 2 without any loss of
-information.
-
-(One thing we can do here is just delete B.  Because all of the work
-there has been merged onto A, this will not lose anything.  We might
-do this if the purpose of B has been achieved, such as completing a
-feature or bug.  But if the work is still in progress, we might keep
-it around.  It makes little difference whether we decide to do new
-work in a branch called B or make a new one called C.)
-
-That is to say that 3 can be perfectly (trivially) merged onto B,
-with, say ``bzr push``, ``bzr pull`` or ``bzr update`` (whatever name
-works best).  Perfectly merged means that we know there will be no
-conflicts or need for manual intervention, and that we can just
-directly store it without forming a roll-up changeset.
-
-I think we might also like the choice of merging A onto B, rather than
-pulling the changeset.  That causes a new changeset to be created on
-B, noted as a successor of 2 and 3::
-
-  A: 0 ------- 1 ----- 3 ------+
-      \               /         \
-  B:   \------ 2 ----+---------- 4
-
-One complication is that 3 is probably stored in A's history as a
-patch relative to 1; we can't just move this representation across.
-Instead, we need to recalculate the delta from 2 to 3 and store that.
-
-Despite that the delta is stored differently, the original signature
-on 3 should still be valid.  So it must be a signature of the tree
-state, not the diff.
-
-Note from `Kernel Traffic discussion`__:
-
-__ http://www.kerneltraffic.org/kernel-traffic/kt20030323_210.txt
-
-    But anyway, what made Bitkeeper suck less is the real DAG
-    structure.  Neither arch (http://arch.fifthvision.net/bin/view)
-    nor subversion seem to have understood that and, as a result,
-    don't and won't provide the same level of semantics. Zero hope for
-    Linus to use them, ever. They're needed for any decently
-    distributed development process.
-
-This in turn suggests that possibly deltas should be stored separately
-from the commits that create them.  Commits name points of
-development; deltas describe how to get from one to the other.
-
-The separation is nice in allowing us to send just a delta when
-diffing trees or recording for undo.  We might want to compute many
-deltas between different trees.
-
-Is this a problem?  Does this ignore Tom's advice about the primacy of
-storing changesets?
-
-Splitting them is probably good, but then what manifest is stored in
-changesets?  We don't want to store the manifest of the whole tree if
-we can avoid it.  So I suppose the changeset just gives the hash of
-the manifest, and the manifest then can be stored separately, possibly
-delta-encoded.

=== removed file 'doc/kill-version.txt'
--- doc/kill-version.txt	2005-11-07 13:17:53 +0000
+++ doc/kill-version.txt	1970-01-01 00:00:00 +0000
@@ -1,128 +0,0 @@
-Killing versions
-****************
-
-Sometimes people really need to rewrite history.  The canonical
-example is that they have accidentally checked confidential
-information into the wrong tree.
-
-There is a tension between two imperatives:
-
-* Accurately record all history.
-
-* Remove critical information.
-
-Of course we cannot control who may have made use of the information
-in the time it was public, but often these things are caught early enough.
-
-After history has been rewritten, anything that depends on that
-history may be inconsistent.  We cannot consistently continue on a
-version that has had some revisions knocked out; therefore it seems
-simplest to kill the version over all.  
-
-You can make a tag onto a new version from a previous consistent
-revision.  
-
-Downstream users will need to switch on to the new version.
-
-We can mark the version as killed so that mirroring will delete the
-revisions and clients looking at the version can suggest switching.
-
-This should be an extremely infrequent operation so it is OK that it
-is simple as long as it fulfils the basic requirement.
-
-A related problem is that people sometimes commit the wrong log
-message, or (more seriously) the wrong files.  It is common to notice
-immediately afterwards.
-
-
-Uncommit
---------
-
-I think this is the best and most useful option at the moment: the
-`uncommit command`_ undoes the last commit, and nothing else.  It can
-be repeated to successively remove more and more history.
-
-.. _`uncommit command`: cmdref.html#uncommit
-
-Example::
-
-    % cd my-project
-    % bzr add launch-codes.txt
-    % bzr commit -m 'add launch codes'
-    A     launch-codes.txt
-    recorded r23
-    [oops!]
-    % bzr uncommit
-    [now back to just before the commit command]
-    
-    % bzr status
-    A     launch-codes.txt
-    % bzr revert launch-codes.txt
-    % bzr status
-    ?     launch-codes.txt
-
-If anyone else has depended on the option then the branches will have
-diverged and that needs to be resolved somehow, probably by the other
-people starting a new branch with the correct commit.  In particular
-uncommitting from a shared branch will break anyone who has seen that
-revision; possibly there needs to be a policy option on such branches
-to deny uncommit.
-
-If someone else on that shared branch did a the equivalent of a
-switch_ command then they would bring their changes onto the correct
-basis.  Would it be reasonable to do that automatically?
-
-.. _switch: cmdref.html#switch
-
-
-
-UI proposals
-------------
-
-Aaron's proposal::
-
-    % cd my-project
-    % baz add launch-codes.txt
-    % baz commit -s 'add launch codes'
-    recorded patch-4
-    % baz add good-code.c
-    % baz commit -s 'add good code'
-    recorded patch-5
-    [oops!]
-    % baz undo patch-3
-    % baz pull patch-5
-    % baz commit --as-latest
-    renamed old branch to my-project-old-1
-    % baz eradicate my-project-old-1
-
-Long form::
-
-  % cd my-project
-  % baz add launch-codes.txt
-  % baz commit -s 'add launch codes'
-  recorded patch-4
-  % baz add good-code.c
-  % baz commit -s 'add good code'
-  recorded patch-5
-  [oops!]
-  % cd ../
-  % baz fork my-project--patch3 my-project-fixed
-  % cd my-project-fixed
-  % baz pull ../my-project patch5
-  % cd ../
-  % rm -rf my-project
-  % mv my-project-fixed my-project
-
-Robert's proposal::
-
-  % cd my-project
-  % baz add launch-codes.txt
-  % baz commit -s 'add launch codes'
-  recorded patch-4
-  % baz add good-code.c
-  % baz commit -s 'add good code'
-  recorded patch-5
-  [oops!]
-  % baz branch patch-3 $(baz tree-version)
-  % baz pull . patch-5
-  % baz eliminate patch-4

=== removed file 'doc/layers.txt'
--- doc/layers.txt	2005-11-07 13:17:53 +0000
+++ doc/layers.txt	1970-01-01 00:00:00 +0000
@@ -1,88 +0,0 @@
- * Write-once store of files identified by globally-unique names
-   (e.g. hashes or UUIDs).
-
-   Simplest option is to just dump them in a directory.  
-
-   Optionally do delta-compression between similar/related files; or
-   build this on top of deltas.
-
- * Tree manifests/inventories which say which files should be assembled at
-   particular points to build a tree.  These too can be stored indexed
-   by hash.
-
-   - Reconstruct a revision by pulling out the manifest and then all
-     the individual files. 
-  
-   - Manipulate working copy of inventory by add/mv/remove/commands.
-
- * Retrieve deltas 
- 
-   - Calculate diffs between two file versions, just by getting them
-     from the store.
-
-   - Retrieve deltas between any two revisions: requires looking for
-     changes to the structure of the tree, and then text changes for
-     anything inside it.
-
-   - Deltas may be either stored or calculated on demand.  They can be
-     put in the store just indexed by the from and to manifest id.
-
-   - Calculate diff between a previous revision and the working copy. 
-
- * Commit and retrieve revisions
-
-   - Revisions hold metadata (date, committer, comment, optional
-     parents, merged patches), and a pointer to the inventory.
-
-   - Stored in a write-once store.
-
- * Branch holds a linear history of revisions.
-
-   - This is mostly redundant; we could just remember the current base
-     revision and walk backwards from there.  But it still seems
-     possibly useful to hold; we can check that the two are always
-     consistent.
-
-     (This suggests that we actually *could* do ``switch`` if we
-     really wanted to, by replacing the revision history and head
-     revision.  But I don't think it's a good idea.)
-
-   - Can add a new revision to the end.
-
-   - By indexing into this can translate between 0-based revision
-     numbers and revision ids. 
-
-   - By walking through and looking at revision dates can find
-     revisions in a particular date range.
-
- * Calculations on branch histories:
-
-   - Find if one branch is a prefix of another.
-
-   - Find the latest common ancestor of another.
-
- * Three-way merge between revisions
-
-   - Resolve shape of directory
-   
-   - Then resolve textual conflicts
-
- * Pull/push changes when they perfectly match
-
-   - Possible when the destination is a prefix of the source
-
-   - Just move all revisions, manifests and texts across, and 
-
- * Merge all changes from one branch into another
-
- * Signatures applied to revisions
-
-   - There is a separable module for checking a signature: this is
-     passed the claimed author, changeset, date.  This needs to fetch
-     an appropriate key, decide if it is trusted to correspond to that
-     author, is not revoked, etc.
-
-   - If it is unknown, untrusted, revoked, etc, that is reported.
-     Depending on a paranoia level it may cause the operation to
-     abort.
-

=== removed file 'doc/library-interface.txt'
--- doc/library-interface.txt	2005-11-07 13:17:53 +0000
+++ doc/library-interface.txt	1970-01-01 00:00:00 +0000
@@ -1,11 +0,0 @@
-*****************
-Library interface
-*****************
-
-Should have a pleasant library interface.
-
-* Be clear what is supposed to be in a stable public interface and
-  what is not.  (A common failing of Python programs.)
-
-* If a function changes the working directory (as may be necessary to
-  run patch) it should restore it.

=== removed file 'doc/merge.txt'
--- doc/merge.txt	2005-11-07 13:17:53 +0000
+++ doc/merge.txt	1970-01-01 00:00:00 +0000
@@ -1,191 +0,0 @@
-=======
-Merging
-=======
-
-There should be one merge command which does the right thing, and
-which is called 'merge'.
-
-The merge command pulls a changeset or a range of changesets into your
-tree.  It knows what changes have already been integrated and avoids
-pulling them again.
-
-There should be some intelligence about working out what changes have
-already been merged. 
-
-The tool intelligently chooses (or perhaps synthesizes) an ancestor
-and two trees to merge.  These are then intelligently merged.
-
-Merge should refuse to run (unless forced) if there are any
-uncommitted changes in your tree beforehand.  This has two purposes:
-if you mess up the merge you won't lose anything important; secondly
-this makes it more likely that the merge will be relatively pure.
-
-It is a good idea to commit as soon as a merge is complete and
-satisfactorily resolved, so as to protect the work you did in the
-merge and to keep it separate from later development.  (Mark suggests
-an option to automatically commit when the merge is complete.)
-
-
-Recording merges
-----------------
-
-bzr records what branches have been merged so far.  This is useful as
-historical information and also for later choosing a merge ancestor.
-
-For each revision we record all the other revisions which have come
-into this tree, either by being completely merged or as cherry-picks.
-
-(This design is similar to the PatchLogPruning__ draft from baz.)
-
-__ http://wiki.gnuarch.org/PatchLogPruning
-
-This list of merged revisions is generally append-only, but can be
-reduced if changes are taken back out.  Changes can be
-anti-cherry-picked, which causes any successors to change from being
-fully-merged to being cherry-picked.
-
-The list of merged patches is stored delta-compressed.
-
-
-``tla update``
---------------
-
-``tla update`` performs a useful but slightly subtle change: it pulls
-in only changes that have been made on the other branch since you last
-merged.  That is to say, it sets the merge basis as the most recent
-merged-from point on the other branch.
-
-This means that any changes which were taken from your branch into the
-other and then reversed or modified will not be reversed.  Those
-changes will always be considered as new in your branch and will have
-precedence.
-
-The basic idea of a merge that only brings in remote work and doesn't
-revert your own changes is good.  It could be handled by a three way
-merge with a specified version but perhaps there is a better way.
-
-
-Merging tree shape
-------------------
-
-Merge is conducted at two levels: merging the tree shape, and merging
-the file contents.  Merging the tree shape means accounting for
-renames, adds, deletes, etc.  This is almost the same as merging the
-two inventories, but we need to do a smart merge on them to enforce
-structural invariants.
-
-
-
-Interrupting a merge
---------------------
-
-Some tools insist that you complete the entire merge while the
-``merge`` command is running; you cannot exit the program or restart
-the computer because state is held in memory.  We should avoid that.
-At least when the tool is waiting for user input it should have
-written everything to disk sufficient to pick up and continue the
-merge from that point.
-
-This suggests that there should be a command to continue a merge;
-perhaps ``bzr resolve`` should look for any unresolved changes and
-start resolving them.  ``bzr merge`` can (by default) automatically
-start this process.
-
-One hard aspect is transformation of the tree state such as renames,
-directory creation, etc.  This might include files swapping place,
-etc.  We would like to do atomically but cannot.
-
-
-
-Aborting a merge
-----------------
-
-If a merge has been begun but not committed then ``bzr revert`` should
-put everything back as it was in the previous revision.  This includes
-resetting the tree state and texts, and also clearing the list of
-pending-merged revisions.
-
-
-
-Offline merge
--------------
-
-It should be possible to download all the data necessary to do a merge
-from a remote branch, then disconnect and complete the merge.  It
-should be possible to interrupt and continue the merge during this
-process.
-
-This implies that all the data is pulled down and stored somewhere
-locally before the actual merge begins.  It could be pulled either
-into the revision history on non-trunk revisions, or into temporary
-files.
-
-It seems useful to move all revisions and texts from the other branch
-into the storage of this branch, in concordance with the general idea
-of every branch moving towards complete knowledge.  This allows the
-most options for an offline merge, and also for later looking back to
-see what was merged in and what decisions were made during the merge.
-
-
-
-Merge metadata
---------------
-
-What does cherry-picking mean here?  It means we merged the changes
-from a revision relative to its predecessor?  But what if we actually
-want to merge the delta relative to something else?  Can that be
-represented?
-
-
-Rejected merges
----------------
-
-ddaa says perhaps we should have three states: with respect to a
-branch any foreign revision can be *merged*, *not-merged*, or *rejected*.
-The difference between *not-merged* and *rejected* is that not-merged
-patches will try to merge in when you next sync from their
-branch, whereas rejected changes will not.
-
-'rejected' seems technically equivalent to it merged with the text
-changes not present.  But perhaps there should be something more?
-
-
-Excluded changes
-----------------
-
-Bitkeeper has the very interesting feature of *excluded* changesets,
-where something previously committed to or merged into this branch is
-treated as if it never occurred.  Because of their representation of
-changes as a weave they can do this without dependency problems on
-later merges.
-
-Although the later changes will not mechanically conflict, there is of
-course no guarantee that excluding the patch will generate anything
-semantically valid.
-
-Cool though this is, it seems that few people understand it well
-enough to use it confidently.  It complicates the merge algorithms and
-seems to have been a source of some bugs.  It may be better just to
-apply a reversed patch.
-
-
-
-Implementation
---------------
-
-Each revision has a pointer to two sets, represented as lists of
-revision-ids:
-
-* ``merged-revisions``
-* ``picked-revisions``
-
-When a branch is merged in, its revision history plus merged-revisions
-are added to the merged-revisions file.  When changes are
-cherry-picked in they are added to the picked-revisions.
-
-These lists are stored in the text store and their sha1 and id is
-stored in the revision.
-
-While a merge is underway, these are stored in
-``.bzr/pending-merged-revisions`` and
-``.bzr/pending-picked-revisions``.

=== removed file 'doc/mirroring.txt'
--- doc/mirroring.txt	2005-11-07 13:17:53 +0000
+++ doc/mirroring.txt	1970-01-01 00:00:00 +0000
@@ -1,14 +0,0 @@
-Mirroring
-=========
-
-The basic idea of mirroring is good, but it's too hard to understand.
-
-Push mirrors and pull mirrors.
-
-Suggest that people commit to their local machine and then regularly
-mirror elsewhere as a backup.
-
-bk and darcs's design inherently avoids this; just make another repo
-and decide to use it that way.
-
-On the other hand they do not keep track of the progress of a patch.
\ No newline at end of file

=== removed file 'doc/monotone.txt'
--- doc/monotone.txt	2005-11-07 13:17:53 +0000
+++ doc/monotone.txt	1970-01-01 00:00:00 +0000
@@ -1,16 +0,0 @@
-********************
-Thoughts on Monotone
-********************
-
-Great project, but not perfect.
-
-My main feeling is that it exposes too much mechanism and in the wrong
-ways.  For example, hashes are all very well for representing
-identity, but I don't want to see them; I just want to say "r43 of
-this branch".  
-
-Cryptographic signing is good for making sure revisions are really
-what they claim to be, but I don't want to directly deal with it: I
-want it as a check that things are really happening as they should
-be.  It should be barely seen and not heard unless/until something
-goes wrong.

=== removed file 'doc/news.txt'
--- doc/news.txt	2005-11-07 13:17:53 +0000
+++ doc/news.txt	1970-01-01 00:00:00 +0000
@@ -1,147 +0,0 @@
-Bazaar-NG Development News
-**************************
-
-
-2005-02-20
-==========
-
-* Added documentation of `patch pools <pool.html>`_, explication of
-  commands in terms of file state transitions, `uncommit
-  <kill-version.html>`_, `journalling <interrupted.html>`_ through
-  recording changesets.  Feedback from Aaron on some of the design
-  documentation.
-
-* Much cleaner ``diff`` and ``status`` commands, based on a new Tree
-  class that abstracts access to either a current working copy or a
-  historical revision.
-
-* ``remove`` command now both removes the working copy and updates the
-  inventory, and has a new alias ``rm``.  
-
-* Basic local versioning works well::
-
-    % bzr init   
-    % echo 'int main() {}' > hello.c
-    % bzr add hello.c
-    % bzr commit 'my test program'
-    % bzr status
-    U    hello.c
-    % echo 'int main() { return 0; }' > hello.c 
-    % bzr status                               
-    M    hello.c
-    % bzr diff        
-    --- old/hello.c 
-    +++ new/hello.c 
-    @@ -1,1 +1,1 @@
-    -int main() {}
-    +int main() { return 0; }
-    % bzr commit 'fix return code'
-    % bzr log
-    ----------------------------------------
-    revno: 1
-    committer: mbp@sourcefrog.net
-    timestamp: Wed 2005-02-16 11:39:13.003095 EST +1100
-
-    my test program
-    ----------------------------------------
-    revno: 2
-    committer: mbp@sourcefrog.net
-    timestamp: Wed 2005-02-16 11:43:13.010274 EST +1100
-
-    fix return code
-    % bzr status
-    U    hello.c
-    % bzr rm hello.c
-    % ls
-    % bzr status    
-    D    hello.c
-    % bzr commit 'this program sucks!'
-    % bzr stauts
-    bzr: error: unknown command 'stauts'
-    exit 1
-    % bzr status
-    %
-
-
-
-* Many internal/hacker commands: ``revno``, ``get-inventory``,
-  ``get-file``, ...
-
-* Most of the implementation is split into reasonably clean objects:
-  `Branch`, `Revision`, `Tree`, `Inventory`.  I think these will give
-  a good foundation for non-intrusive remote operations.  They 
-  live in submodules of `bzrlib`.
-
- ====== ==================================
-    596 bzr.py
-    608 bzrlib/branch.py
-     39 bzrlib/errors.py
-     25 bzrlib/__init__.py
-    320 bzrlib/inventory.py
-    126 bzrlib/osutils.py
-     66 bzrlib/revision.py
-    173 bzrlib/store.py
-    107 bzrlib/tests.py
-     62 bzrlib/trace.py
-    239 bzrlib/tree.py
-     41 bzrlib/xml.py
- ------ ----------------------------------
-   2402 total
- ====== ==================================
-
-
-* After feedback and reflection I have decided not to use `SHA-1
-  hashes`__ as the main identifier of texts, inventories, revisions,
-  etc.  It would probably be safe, but there is a certain amount of
-  concern (or even FUD) about the security of these hashes.  Since
-  they cannot be trusted to be safe in the long term, it is better
-  just to use something cheaper to compute, and equally unique in the
-  absence of malice: UUIDs.
-
-__ hashes.html
-
-  We now store the SHA-1 of files, but use it only as a check that the
-  files were stored safely.  At tridge's suggestion we also keep the
-  size, which can catch some classes of bug or data corruption::
-
-    % bzr diff
-    bzr: error: wrong SHA-1 for file
-    '680757bf-2f6e-4ef3-9fb4-1b81ba04b73f' 
-    in ImmutableStore('/home/mbp/work/bazaar-ng/toy/.bzr/text-store')
-      inventory expects d643a377c01d3e29f3e6e05b1618eb6833992dd0
-      file is actually 352586b84597ea8915ef9b1fb5c9c6c5cdd26d7b
-      store is probably damaged/corrupt
-
-
-2005-02-27
-==========
-
-Revisions are now named by something based on the username and date,
-plus some random bytes to make it unique.  This may be a reasonable
-tradeoff against uniqueness and readability.   This same id is used by
-default for revision inventories::
-
-  mbp@sourcefrog.net-20050220113441-34e486671a10f75297e03986
-
-Keeping them separate is still a good thing, because the inventory may
-be large and we often want only the revision and not the inventory.
-It is possible for the revision to point to an older inventory if it
-has not changed (but this is not implemented yet.)
-
-Tridge pointed out some `possible performance problems`__ with the
-assumption that we can simply compare all files to check for changes. 
-
-__ unchanged.html
-
-XML has newlines to make it a bit more readable.
-
-Nested subdirectories are now supported down to an arbitrary depth.
-
-bzr can successfully import and reproduce itself.
-
-
-
-ongoing
-=======
-
-* Systematic command-line handling and option parsing, etc.
\ No newline at end of file

=== removed file 'doc/optional-edit.txt'
--- doc/optional-edit.txt	2005-11-07 13:17:53 +0000
+++ doc/optional-edit.txt	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-******************************
-Optional explicit edit command
-******************************
-
-The default is for each branch to have an editable working copy, which
-can be modified and committed.  However, in some cases (following RCS
-and BK) people might prefer to have either a read-only working copy,
-or none at all.
-
-Reasons:
-
- - Branches which are never edited don't need it; removing it saves
-   some time and space.  In particular this applies to branches on a
-   server which are meant to be branched from or committed too, not
-   edited.
-
- - Files for which there is no working copy or a read-only copy are
-   known not to be edited, and this can make some operations such as
-   diffing a bit simpler.
-
-Since this is mostly an optimization and requires user knowledge it
-perhaps should not be added.  Certainly not yet.
-
-Sketch::
-
-  $ bzr get --no-wc SOURCE TARGET
-  $ bzr edit --remove
-  $ bzr edit --read-only .
-  $ bzr edit --write foo.c
-

=== removed file 'doc/partial-commit.txt'
--- doc/partial-commit.txt	2005-11-07 13:17:53 +0000
+++ doc/partial-commit.txt	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-Partial commit
-**************
-
-In the first cut, commit covers the whole tree.
-
-Secondly, people might want to commit only particular files or
-subdirectories.  Semantics of this in the case of renames/adds/deletes
-may be a bit complex, but I think it can be done.  The basic point is
-to build an inventory which includes only the specified changes from
-the working copy. 
-
-Beyond that, it can be very nice in darcs to commit only selected
-changes to a file.  I think this should not be the default though;
-perhaps only do it with ``-i``.  Even better (for some users) kick off
-a graphical tool to select the particular regions.  Beyond a certain
-point it may become easier for the user to explicitly set aside some
-changes and commit others first.
-
-In any case, it is a good idea to run a test suite on the revision to
-be committed, to make sure there were no missed dependencies.
\ No newline at end of file

=== removed file 'doc/pool.txt'
--- doc/pool.txt	2005-11-07 13:17:53 +0000
+++ doc/pool.txt	1970-01-01 00:00:00 +0000
@@ -1,65 +0,0 @@
-Patch pools
-***********
-
-*Patch pools* are an optimization for efficient storage of related
-branches.  They are not required for the first release.
-
-Revisions, inventories, and file states are identified in Bazaar-NG by
-universally unique hashes, and they are never modified once they are
-created.  Objects which are common between branches may therefore be
-stored only once and referenced from each branch.  Various strategies
-are available for doing this.
-
-Objects can be held hard-linked between related branches on
-filesystems that support hardlinks.  This provides automatic reference
-counting as branches are deleted.
-
-It is common to have several branches of the same project on a
-machine, with many objects in common.  These can be configured with
-each other on the pool path.  The parent should be the default pool
-path when creating a new branch.
-
-Each user might also have a pool that acts as a cache of all remote
-revisions.  Such a cache might use some kind of least-recently-used
-policy to limit its size.
-
-The user might nominate a series or hierarchy of pools to be searched for a
-patch; these might be progressively on the local machine, local
-network and remotely.  
-
-A system like the supermirror might make good use of a pool that
-gradually accumulates all public objects in the world, and stores
-branches very cheaply.
-
-One complication is garbage collection.  Naive implementations that
-store references from branches into the pool will not be able to
-detect objects that are no longer referenced by any active branch; as
-branches are created and deleted over time such objects will
-accumulate.  This may not be a problem in many cases, given the
-relative abundance of disk compared to programmer time, and the
-relatively small number of long branches that are discarded.  There
-are some partial solutions:
-
-* Keep a reference count for each object.  There is no problem of
-  circular references.  However, keeping the count accurately requires
-  that branches are never lost or deleted other than through the
-  correct mechanism.
-
-* From time to time, building a new pool including only objects from
-  active branches.
-
-* Keeping a pool that holds only patches known to be available from
-  elsewhere, so the pool is only a cache and never the single source
-  of a particular object.  Such a pool can then be discarded at will
-  and the objects will be re-fetched from their original source.
-
-This last point suggests that new objects should never be written
-solely into a pool, because of the risk that they might be
-accidentally lost.
-
-Using the parent on the default pool path allows for varying
-greed or laziness in fetching objects.  By default, objects might be
-read only as necessary, and then stored in the local cache.  If the
-user wants to keep the whole history available locally that could be
-specified with a ``--greedy`` option when making the branch, or
-through later pulling down the history.
\ No newline at end of file

=== removed file 'doc/purpose.txt'
--- doc/purpose.txt	2005-11-07 13:17:53 +0000
+++ doc/purpose.txt	1970-01-01 00:00:00 +0000
@@ -1,78 +0,0 @@
-What is the purpose of version control?
-***************************************
-
-There are several overlapping purposes:
-
-* Allowing concurrent development by several people.  Primarily,
-  helping resolve changes when they are integrated, but also making
-  each person aware of what the others have been doing, allowing them
-  to talk about changes, etc.
-
-* To allow different lines of development, with sensible
-  reintegration.  e.g. stable/development, or branches for
-  experimental features.
-
-* To record a history of development, so that you can find out why a
-  feature went in or who added it, or which releases might be affected
-  by a bug.
-
-* In particular, as a *record of decisions* about the project made by
-  the developers.
-
-* Help in writing a gloss on that history; not simply a record of
-  events but an explanation of what happened and why.  Such a record
-  may need to be written at several levels: a very detailed
-  explanation of changes to a function; a note that a bug was fixed
-  and why; and then a brief NEWS file for the whole release.  
-
-  While past events can never change, the intepretation placed upon
-  them may change, even after the event.  For example, even after a
-  release has gone out, one might want to go back and note that a bug
-  was actually fixed.
-
-  The system is helping the developers tell a story about the
-  development of the project.
-
-* As an aid to thinking about the project.  (Much as a personal
-  journal is not merely a record or even analysis of events, but also
-  a chance to reflect and to think of the future.)
-
-  People can review diffs, and then write a description of what
-  changed, and in doing so perhaps realize something else they should
-  do, or realize they made a mistake.  Making branches helps work out
-  the order of feature integration and the stability of different
-  lines of development.
-
-* As an 'undo' protection mechanism.  This is one reason why version
-  control can be useful on projects that have only a single developer
-  and never branch.
-
-* Incidentally, as a backup mechanism.  Version control systems,
-  particularly distributed systems, tend to cause code to exist on
-  several machines, which gives some protection against loss of any
-  single copy.  It's still a good idea to use a separate backup system
-  as well.
-
-* As a file-sharing mechanism: even with just a single developer and
-  line of development it can be useful to keep files synchronized
-  between several machines, which may not always be connected.
-
-
-----
-
-Steve Berczuk says__:
-
-__ http://www.bell-labs.com/cgi-user/OrgPatterns/OrgPatterns?ConfigurationManagementPatterns
-
-    A successful configuration management process allows:
-
-    * Developers to work together on a project, sharing common code.
-
-    * Developers to share development effort on a module.
-
-    * Developers to have access to the current stable (tested) version of a system.
-
-    * The ability to back up to a previous stable version (one of a number of NamedStableBases), of a system
-
-    * The ability of a developer to checkpoint changes to a module and
-      to back off to a previous version of that module

=== removed file 'doc/python.txt'
--- doc/python.txt	2005-11-07 13:17:53 +0000
+++ doc/python.txt	1970-01-01 00:00:00 +0000
@@ -1,101 +0,0 @@
-Choice of Python
-----------------
-
-This will be written in Python, at least for the first cut, just for
-ease of development -- I think I am at least 2-3 times faster than in
-C or C++, and bugs may be less severe.  I am open to the idea of
-switching to C at some time in the future, but because that is
-enormously expensive I want to avoid it until it's clearly necessary.
-Python is also a good platform to handle cross-platform portability.
-
-Possible reasons to go to C:
-
-Audience acceptance
-  If Linus says "I'd use it if it were written in
-  C" that would be persuasive.  I think the good developers we want to
-  do not consider implementation language as a dominant factor.  A few
-  related but separate questions are important to them: modest
-  dependencies, easy installation, presence in distributions (or as
-  packages), active support, etc.  A few queries show that Python is
-  seen as relatively safe and acceptable even by people who don't
-  actually use it.
-
-Speed
-  Having scalable designs is much more important.
-  Secondly, we will do most of the heavy lifting in external
-  C programs in the first cut, and perhaps move these into native
-  libraries later.  (Subversion people had trouble in relying on GNU
-  diff on legacy platforms and they had to integrate the code eventually.)
-
-Bindings to other languages
-  If we have only a Python interpretation then it can be run as a
-  shell script from emacs or similar tools.  It can also be natively
-  called from Python scripts, which would allow GUI bindings to almost
-  every toolkit, and it can possibly be called from Java and
-  .NET/Mono.    By the time this is
-  mature, it's possible that Python code will be able to cross-call
-  Perl and other languages through Parrot.  
-  There should be enough options there to support a good
-  infrastructure there of additional tools.
-  If it was necessary to provide a C API that can perhaps be wrapped around a 
-  Python library.
-
-Reuse of tla code
-  That may be useful, if there are substantial sections that approach
-  or meet our goals for both design and implementation (e.g. being
-  good to use from a library.)
-
-  This does not necessarily mean doing the whole thing in C; we could
-  call out to tla or could wrap particular bits into libraries.
-
-
-----
-
-Erik Bgfors:
-
-  However, I think it's very important that a VCS can be wrapped in other
-  languages so that it can be integrated in IDE's and have tools written
-  for them.
-  
-  A library written in c would be simple to wrap in other languages and
-  therefore could be used from for example monodevelop and friends. I
-  really believe this is important for a VCS.
-
-I agree; this is a more important argument against Python than speed,
-where I think we can be entirely adequate just using smart design.
-But there are some partial answers:
-
-We can design bzr to be easily called as an external process -- not
-depending on interactive input, having systematically parsed output,
---format=xml output, etc.  This is the only mode CVS supports, and
-people have built many interesting tools on top of it, and it's still
-popular for svn and tla.  For things like editor integration this is
-often the easiest way.
-
-Secondly, there is a good chance of calling into Python from other
-languages.  There are projects like Jython, IronPython, Parrot and so
-on that may well fix this.
-
-Thirdly, we can present a Python library through a C interface; this
-might seem a bit weird but I think it will work fine.  Python is
-easily embeddable; this might be the best way for Windows IDE
-integration.
-
-Finally, if none of these work, then we can always recode in C,
-treating Python only as a prototype.
-
-I think working in Python I can develop it at least twice as fast as
-in C, particularly in this early phase where the design is still being
-worked out.  Although all other things being equal it might be nice to
-be in pure C, but I don't think it's worth paying that price.
-
-  One of the problems with darcs is that it's such a mess wrapping it.
-
-Yes.
-
-----
-
-Experiments to date on large trees show that even with little
-optimization, bzr is mostly disk-bound, and the CPU time usage is only
-a few seconds.  That supports the position that Python performance
-will be adequate.

=== removed file 'doc/quilt.txt'
--- doc/quilt.txt	2005-11-07 13:17:53 +0000
+++ doc/quilt.txt	1970-01-01 00:00:00 +0000
@@ -1,11 +0,0 @@
-Quilt
-=====
-
-Descendent of Andrew Morton's patch scripts.
-
-Demonstrates that quite a powerful tool can be built in a relatively
-short time.
-
-Is largely not concerned with preserving a history record.  Allows 
-
-Pop patches off, similar to excluding them.
\ No newline at end of file

=== removed file 'doc/quotes.txt'
--- doc/quotes.txt	2005-11-07 13:17:53 +0000
+++ doc/quotes.txt	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-  If you're just quilting the good ideas of others, then that seems more
-  like standing on the shoulders of giants -- bje

=== removed file 'doc/random.txt'
--- doc/random.txt	2006-01-25 14:30:06 +0000
+++ doc/random.txt	1970-01-01 00:00:00 +0000
@@ -1,257 +0,0 @@
-I think Ruby's point is right: we need to think about how a tool
-*feels* as you're using it.
-
-Making regular commits gives a nice rhythm to to working; in some
-ways it's nicer to just commit single files with C-x v v than to build
-complex changesets.  (See gmane.c.v-c.arch.devel post 19 Nov, Tom
-Lord.)
-
-
-* Would like to generate an activity report, to e.g. mail to your boss
-  or post to your blog.  "What did I change today, across all these
-  specified branches?"
-
-
-* It is possibly nice that tla by default forbids you from committing
-  if emacs autosave or lock files exist -- I find it confusing to
-  commit something other than what is shown in the editor window
-  because there are unsaved changes. 
-
-  However, grumbling about unknown files is annoying, and requiring
-  people to edit regexps in the id-tagging-method file to fix it is
-  totally unreasonable.
-
-  Perhaps there should be a preference to abort on unknown files, or
-  perhaps it should be possible to specify forbidden files.
-
-  Perhaps this is related to a mechanism to detect conflicted files:
-  should refuse to commit if there are any .rej files lying around.
-
-
-
-   *Those who lose history are doomed to recreate it.*
-         -- broked (on #gnu.arch.users)
-
-   *A universal convention supplies all of maintainability, clarity, consistency, and a foundation for good programming habits too. What it doesn't do is insist that you follow it against your will. That's Python!*
-
-    -- Tim Peters on comp.lang.python, 2001-06-16
-
-    (Bazaar provides mechanism and convention, but it is up to you
-    whether you wish to follow or enforce that convention.)
-
-----
-
-jblack asks for 
-
-   A way to subtract merges, so that you can see the work you've done
-   to a branch since conception.
-
-----
-
-:: 
-
-  <mpool> now that is a neat idea: advertise branches over zeroconf
-  <mpool> should make lca fun :-)
-
-----
-
-http://thedailywtf.com/ShowPost.aspx?PostID=24281
-
-  Source control is necessary and useful, but in a team of one (or even two) people the setup overhead isn't always worth it--especially if you're going to join source control in a month, and you don't want to have to migrate everything out of your existing (in my case, skunkworks) system before you can use it.
-
-  At least that was my experience--I putzed with CVS a bit and knew other source control systems pretty well, but in the day-to-day it wasn't worth the bother (granted, I was a bit offended at having to wait to use the mainline source control, but that's another matter).
-
-I think Bazaar-NG will have such low setup overhead (just ``init``,
-``add``) that it can be easily used for even tiny projects.  The
-ability to merge previously-unrelated trees means they can fold their
-project in later.
-
-
-----
-
-From tridge:
-
-* cope without $EMAIL better
-
-* notes at start of .bzr.log:
-  * you can delete this
-  * or include it in bug reports
-
-* should you be able to remove things from the default ignore list?
-
-* headers at start of diff, giving some comments, perhaps dates
- 
-  * is diff against /dev/null really OK?  I think so.
-
-* separate remove/delete commands?  
-
-* detect files which were removed and now in 'missing' state
-
-* should we actually compare files for 'status', or check mtime and
-  size; reading every file in the samba source tree can take a long
-  time.
-
-  without this, doing a status on a large tree can be very slow.  but
-  relying on mtime/size is a bit dangerous.
-
-  people really do work on trees which take a large chunk of memory
-  and which will not stay in memory
-
-* status up-to-date files: not 'U', and don't list without --all
-
-* if status does compare file text, then it should be quick when
-  checking just a single file
-
-* wrapper for svn that every time run logs
-
-  - command
-  - all inputs
-  - time it took
-  - sufficient to replay everything
-  - record all files
-
-* status crashes if a file is missing
-
-* option for -p1 level on diff, etc.  perhaps
-
-* commit without message should start $EDITOR
-
-* don't duplicate all files on commit
-
-* start importing tridge-junkcode
-
-* perhaps need xdelta storage sooner rather than later, to handle very
-  large file
-
-----
-
-The first operation most people do with a new version-control system
-is *not* making their own project, but rather getting a checkout of an
-existing project, building it, and possibly submitting a patch.  So
-those operations should be *extremely* easy.
-
-----
-
-* Way to check that a branch is fully merged, and no longer needed:
-  should mean all its changes have been integrated upstream, no
-  uncommitted changes or rejects or unknown files.
-
-* Filter revisions by containing a particular word (as for log).
-  Perhaps have key-value fields that might be used for
-  e.g. line-of-development or bug nr?
-
-* List difference in the revisions on one branch vs another.
-
-* Perhaps use a partially-readable but still hopefully unique ID for
-  revisions/inventories?
-
-* Preview what will happen in a merge before it is applied
-
-* When a changeset deletes a file, should have the option to just make
-  it unknown/ignored.
-
-  Perhaps this is best handled by an interactive merge.  If the file
-  is unchanged locally and deleted remotely, it will by default be
-  deleted (but the user has the option to reject the delete, or to
-  make it just unversioned, or to save a copy.)  If it is modified
-  locall then the user still needs to choose between those options but
-  there is no default (or perhaps the default is to reject the delete.)
-
-* interactive commit, prompting whether each hunk should be sent (as
-  for darcs)
-
-* Write up something about detection of unmodified files
-
-* Preview a merge so as to get some idea what will happen:
-
-  * What revisions will be merged (log entries, etc)
-
-  * What files will be affected?
-
-  * Are those simple updates, or have they been updated locally as
-    well.
-
-  * Any renames or metadata clashes?
-
-  * Show diffs or conflict markers.
-
-  * Do the merge, but write into a second directory.
-
-* "Show me all changesets that touch this file"
-
-  Can be done by walking back through all revisions, and filtering out
-  those where the file-id either gets a new name or a new text.  
-
-* Way to commit backdated revisions or pretend to be something by
-  someone else, for the benefit of import tools; in general allow
-  everything taken from the current environment to be overridden.
-
-* Cope well when trying to checkout or update over a flaky
-  connection.  Passive HTTP possibly helps with this: we can fetch all
-  the file texts first, then the inventory, and can even retry
-  interrupted connections.
-
-* Use readline for reading log messages, and store a history of
-  previous commit messages!
-
-* Warn when adding huge files(?) - more than say 10MB?  On the other
-  hand, why not just cope?
-
-* Perhaps allow people to specify a revision-id, much as people have
-  unique but human-assigned names for patches at the moment?
-
-----
-
-20050218090900.GA2071@opteron.random
-
-    Subject:      Re: [darcs-users] Re: [BK] upgrade will be needed
-    From:         Andrea Arcangeli <andrea@suse.de>
-    Newsgroups:   gmane.linux.kernel
-    Date:         Fri, 18 Feb 2005 10:09:00 +0100
-
-    On Thu, Feb 17, 2005 at 06:24:53PM -0800, Tupshin Harper wrote:
-    > small to medium sized ones). Last I checked, Arch was still too slow in 
-    > some areas, though that might have changed in recent months. Also, many 
-
-    IMHO someone needs to rewrite ARCH using the RCS or SCCS format for the
-    backend and a single file for the changesets and with sane parameters
-    conventions miming SVN. The internal algorithms of arch seems the most
-    advanced possible. It's just the interface and the fs backend that's so
-    bad and doesn't compress in the backups either.  SVN bsddb doesn't
-    compress either by default, but at least the new fsfs compresses pretty
-    well, not as good as CVS, but not as badly as bsddb and arch either.
-
-    I may be completely wrong, so take the above just as a humble
-    suggestion.
-
-    darcs scares me a bit because it's in haskell, I don't believe very much
-    in functional languages for compute intensive stuff, ram utilization
-    skyrockets sometime (I wouldn't like to need >1G of ram to manage the
-    tree). Other languages like python or perl are much slower than C/C++
-    too but at least ram utilization can be normally dominated to sane
-    levels with them and they can be greatly optimized easily with C/C++
-    extensions of the performance critical parts.
-
-
------
-
-When sending patches by email (optionall) send each one as a separate
-mail, with a sequence number [%03d/%03d] at the start of the Subject.
-See mail from linus 2005-04-07.
-
-http://linux.yyz.us/patch-format.html
-
-http://www.zip.com.au/~akpm/linux/patches/stuff/tpp.txt
-
-----
-
-dwmw2 (2005-04-07) 
-
-reorder patches by cherry-picking them from a main development tree
-before sending them on.
-
-----
-
-ignore BitKeeper
-
-re-add should give the same id as before

=== removed file 'doc/requirements.txt'
--- doc/requirements.txt	2005-11-07 13:17:53 +0000
+++ doc/requirements.txt	1970-01-01 00:00:00 +0000
@@ -1,48 +0,0 @@
-************
-Requirements
-************
-
-gcc requirements
-----------------
-
-* http://lists.gnu.org/archive/html/gnu-arch-users/2004-06/msg00082.html
-* http://gcc.gnu.org/ml/gcc/2004-06/msg00264.html
-
-Some of these are:
-
-* Must preserve existing history from CVS; must be able to export back
-  out to CVS in case they change their mind.
-
-* Support a single central blessed version.
-
-* Cheap branches and tagging.
-
-* Handle repeated merges; remember the last time something was merged.
-
-* Easy cloning.
-
-* Copy a named patch set (one or more changes) onto a particular
-  branch.
-
-* Unix, Windows, Mac.
-
-* What patches changed a particular symbol?
-
-* annotate function that shows deleted lines.
-
-* Reliable backups.  (bzr can do this simply by cloning, then
-  mirror-sync.)
-
-* Scale to enormously wide and long history.
-
-* Easy to get back to last-known-good state.
-
-
-
-kernel
-------
-
- * http://www.kerneltraffic.org/kernel-traffic/kt20030323_210.txt
-
-   Discussion of BitKeeper, strengths and weaknesses, and
-   interoperation tools.

=== removed file 'doc/revfile-annotation.txt'
--- doc/revfile-annotation.txt	2005-11-07 13:17:53 +0000
+++ doc/revfile-annotation.txt	1970-01-01 00:00:00 +0000
@@ -1,155 +0,0 @@
-==============================
-Extension to store annotations
-==============================
-
-We might extend the revfile format in a future version to also store
-annotations.  *This is not implemented yet.*
-
-In previous versions, the  index file identified texts by their
-SHA-1 digest.  This was unsatisfying for two reasons.  Firstly it
-assumes that SHA-1 will not collide, which is not an assumption we
-wish to make in long-lived files.  Secondly for annotations we need
-to be able to map from file versions back to a revision.
-
-Texts are identified by the name of the revfile and a UUID
-corresponding to the first revision in which they were first
-introduced.  This means that given a text we can identify which
-revision it belongs to, and annotations can use the index within the
-revfile to identify where a region was first introduced.
-
-  We cannot identify texts by the integer revision number, because
-  that would limit us to only referring to a file in a particular
-  branch.
-
-  I'd like to just use the revision-id, but those are variable-length
-  strings, and I'd like the revfile index to be fixed-length and
-  relatively short.  UUIDs can be encoded in binary as only 16 bytes.
-  Perhaps we should just use UUIDs for revisions and be done?
-
-
-
-Annotations
------------
-
-Annotations indicate which revision of a file first inserted a line
-(or region of bytes).
-
-Given a string, we can write annotations on it like so: a sequence of
-*(index, length)* pairs, giving the *index* of the revision which
-introduced the next run of *length* bytes.  The sum of the lengths
-must equal the length of the string.  For text files the regions will
-typically fall on line breaks.  This can be transformed in memory to
-other structures, such as a list of *(index, content)* pairs.
-
-When a line was inserted from a merge revision then the annotation for
-that line should still be the source in the merged branch, rather than
-just being the revision in which the merge took place.
-
-They can cheaply be calculated when inserting a new text, but are
-expensive to calculate after the fact because that requires searching
-back through all previous text and all texts which were merged in.  It
-therefore seems sensible to calculate them once and store them.
-
-To do this we need two operators which update an existing annotated
-file:
-
-A. Given an annotated file and a working text, update the annotation to
-   mark regions inserted in the working file as new in this revision.
-
-B. Given two annotated files, merge them to produce an annotated
-   result.    When there are conflicts, both texts should be included
-   and annotated.
-
-These may be repeated: after a merge there may be another merge, or
-there may be manual fixups or conflict resolutions.
-
-So what we require is given a diff or a diff3 between two files, map
-the regions of bytes changed into corresponding updates to the origin
-annotations.
-
-Annotations can also be delta-compressed; we only need to add new
-annotation data when there is a text insertion.
-
-    (It is possible in a merge to have a change of annotation when
-    there is no text change, though this seems unlikely.  This can
-    still be represented as a "pointless" delta, plus an update to the
-    annotations.)
-
-Index file
-----------
-
-In a proposed (not implemented) storage with annotations, the index
-file is a series of fixed-length records::
-
-  byte[16]     UUID of revision
-  byte[20]     SHA-1 of expanded text (as binary, not hex)
-  uint32       flags: 1=zlib compressed
-  uint32       sequence number this is based on, or -1 for full text
-  uint32       offset in text file of start
-  uint32       length of compressed delta in text file
-  uint32[3]    reserved
-
-Total 64 bytes.
-
-The header is also 64 bytes, for tidyness and easy calculation.  For
-this format the header must be ``bzr revfile v2\n`` padded with
-``\xff`` to 64 bytes.
-
-The first record after the header is index 0.  A record's base index
-must be less than its own index.
-
-The SHA-1 is redundant with the inventory but stored just as a check
-on the compression methods and so that the file can be validated
-without reference to any other information.
-
-Each byte in the text file should be included by at most one delta.
-
-
-Deltas
-------
-
-In a proposed (not implemented) storage with annotations, deltas to
-the text are stored as a series of variable-length records::
-
-  uint32        idx
-  uint32        m
-  uint32        n
-  uint32        l
-  byte[l]       new
-
-This describes a change originally introduced in the revision
-described by *idx* in the index.
-
-This indicates that the region [m:n] of the input file should be
-replaced by the text *new*.  If m==n this is a pure insertion of l
-bytes.  If l==0 this is a pure deletion of (n-m) bytes.
-
-
-
-
-
-Open issues
------------
-
-
-* Storing the annotations with the text is reasonably simple and
-  compact, but means that we always need to process the annotation
-  structure even when we only want the text.  In particular it means
-  that full-texts cannot just simply be copied out but rather composed
-  from chunks.  That seems inefficient since it is probably common to
-  only want the text.
-
-* Should annotations also indicate where text was deleted?
-
-* This design calls for only one annotation per line, which seems
-  standard.  However, this is lacking in at least two cases:
-
-  - Lines which originate in the same way in more than one revision,
-    through being independently introduced.  In this case we would
-    apparently have to make an arbitrary choice; I suppose branches
-    could prefer to assume lines originated in their own history.
-
-  - It might be useful to directly indicate which mergers included
-    which lines.  We do have that information in the revision history
-    though, so there seems no need to store it for every line.
-

=== removed file 'doc/revfile.txt'
--- doc/revfile.txt	2005-11-07 13:17:53 +0000
+++ doc/revfile.txt	1970-01-01 00:00:00 +0000
@@ -1,148 +0,0 @@
-********
-Revfiles
-********
-
-The unit for compressed storage in bzr is a *revfile*, whose design
-was suggested by Matt Mackall.
-
-This document describes version 1 of the file, and has some notes on
-what might be done in version 2.
-
-
-Requirements
-============
-
-Compressed storage is a tradeoff between several goals:
-
-* Reasonably compact storage of long histories.
-
-* Robustness and simplicity.
-
-* Fast extraction of versions and addition of new versions (preferably
-  without rewriting the whole file, or reading the whole history.)
-
-* Fast and precise annotations.
-
-* Storage of files of at least a few hundred MB.
-
-* Lossless in useful ways: we can extract a series of texts and write
-  them back out without losing any information.
-
-
-Design
-======
-
-revfiles store the history of a single logical file, which is
-identified in bzr by its file-id.  In this sense they are similar to
-an RCS or CVS ``,v`` file or an SCCS sfile.
-
-Each state of the file is called a *text*. 
-
-Renaming, adding and deleting this file is handled at a higher level
-by the inventory system, and is outside the scope of the revfile.  The
-revfile name is typically based on the file id which is itself
-typically based on the name the file had when it was first added.  But
-this is purely cosmetic.
-
-    For example a file now called ``frob.c`` may have the id
-    ``frobber.c-12873`` because it was originally called
-    ``frobber.c``.  Its texts are kept in the revfile
-    ``.bzr/revfiles/frobber.c-12873.revs``.
-
-When the file is deleted from the inventory the revfile does not
-change.  It's just not used in reproducing trees from that point
-onwards.
-
-The revfile does not record the date when the text was added, a commit
-message, properties, or any other metadata.  That is handled in the
-higher-level revision history.
-
-Inventories and other metadata files that vary from one version to the
-next can themselves be stored in revfiles.
-
-revfiles store files as simple byte streams, with no consideration of
-translating character sets, line endings, or keywords.  Those are also
-handled at a higher level.  However, the revfile may make use of
-knowledge that a file is line-based in generating a diff.  
-
-   (The Python builtin difflib is too slow when generating a purely
-   byte-by-byte delta so we always make a line-by-line diff; when this
-   is fixed it may be feasible to use line-by-line diffs for all
-   files.)
-
-Files whose text does not change from one revision to the next are
-stored as just a single text in the revfile.  This can happen even if
-the file was renamed or other properties were changed in the
-inventory.
-
-The revfile is held on disk as two files: an *index* and a *data*
-file.  The index file is short and always read completely into memory;
-the data file is much longer and only the relevant bits of it,
-identified by the index file, need to be read.
-
-  This design is similar to that of Netscape `mail summary files`_, in
-  that there is a small index which can always be read into memory and
-  that quickly identifies where to look in the main file.  They differ
-  in many other ways though, most particularly that the index is not
-  just a cache but holds precious data in its own right.
-
-.. _`mail summary files`: http://www.jwz.org/doc/mailsum.html
-
-This is meant to scale to hold 100,000 revisions of a single file, by
-which time the index file will be ~4.8MB and a bit big to read
-sequentially.
-
-Some of the reserved fields could be used to implement a (semi?)
-balanced tree indexed by SHA1 so we can much more efficiently find the
-index associated with a particular hash.  For 100,000 revs we would be
-able to find it in about 17 random reads, which is not too bad.  On
-the other hand that would compromise the append-only indexing, and
-100,000 revs is a fairly extreme case.
-
-This performs pretty well except when trying to calculate deltas of
-really large files.  For that the main thing would be to plug in
-something faster than difflib, which is after all pure Python.
-Another approach is to just store the gzipped full text of big files,
-though perhaps that's too perverse?
-
-
-Identifying texts
------------------
-
-In the current version, texts are identified by their SHA-1.  
-
-
-Skip-deltas
------------
-
-Because the basis of a delta does not need to be the text's logical
-predecessor, we can adjust the deltas to avoid ever needing to apply
-too many deltas to reproduce a particular file.  
-
-
-Tools
------
-
-The revfile module can be invoked as a program to give low-level
-access for data recovery, debugging, etc.
-
-
-
-
-Open issues
-===========
-
-* revfiles use unsigned 32-bit integers both in diffs and the index.
-  This should be more than enough for any reasonable source file but
-  perhaps not enough for large binaries that are frequently committed.
-
-  Perhaps for those files there should be an option to continue to use
-  the text-store.  There is unlikely to be any benefit in holding
-  deltas between them, and deltas will anyhow be hard to calculate. 
-
-* The append-only design does not allow for destroying committed data,
-  as when confidential information is accidentally added.  That could
-  be fixed by creating the fixed repository as a separate branch, into
-  which only the preserved revisions are exported.
-
-* Should we also store full-texts as a transitional step?

=== removed file 'doc/revision-syntax.txt'
--- doc/revision-syntax.txt	2005-11-07 13:17:53 +0000
+++ doc/revision-syntax.txt	1970-01-01 00:00:00 +0000
@@ -1,77 +0,0 @@
-Syntax for identifying revisions
-********************************
-
-There seem to be two main options: use a separate ``-r`` option, or
-put a revision identifier within the filename.
-
-``-r`` options are familiar from CVS and Subversion, and easy to
-specify, and cover almost all situations.
-
-Special identifiers in the filename are sometimes more concise, and
-allow for more complete specification of filenames in the presence of
-renames.  They may be more complex to implement, and will cause some
-filenames to be either forbidden or to require escaping.
-
-----
-
-
-How to interpret revisions in the presence of renamed files?  Suppose
-hello.c was renamed in r3; when we do ``bzr diff -r2 hello.c`` should
-we compare to 
-
-* the file currently called ``hello.c``, as it was in revision 2, even
-  if it then had a different name
-
-or
-
-* the file that was called ``hello.c`` in revision 2, even if that is
-  a different file-id?
-
-Often only one will work, but it is possible to have situations where
-in revision 2 there was a file called ``hello.c`` but it is not the
-same one that now has that name.
-
-If we can have a simple syntax that accomodates either that would be
-good.  One might be to mix revision numbers into the path, rather than
-a separate ``-r`` option.  For example::
-
-   hello.c@2
-   @2/hello.c
-
-   src/@2/hello.c
-
-The simplest case is to just append the number, but you can vary
-them.  It might even be possible to chain them, getting the file id
-from one revision and its state from another:
-
-  @70/hello.c@31
-
-This means "the file that was called ``hello.c`` in revision 70, give
-me its state in revision 31."  (If you wanted to do this across
-branches, I think you might need to get the file id and then look it
-up, etc.)
-
-Some more syntax: you can refer to a revision by its hash just by
-specifying that; we can distinguish them from anything else by their
-length::
-
-  hello.c@09fac8dbfd27bd9b4d23a00eb648aa751789536d 
-
-(Is that really safe?  Perhaps some punctuation is needed to
-distinguish it from a label.  But then I think people should rarely or
-never use them; perhaps it need not be allowed at all.)
-
-You can also give a date, which is used to find the most recent
-revision no later than that date::
-
-  hello.c@{2004-12-01}
-  hello.c@{yesterday}
-  ./@{10:30}/
-
-(Braces can be a bit scary for shell, but if there are no commas they
-are somewhat safe.)
-
-Or, once we have labels, you can use a label::
-
-  hello.c@release-2.2
-

=== removed file 'doc/rollup.txt'
--- doc/rollup.txt	2005-11-07 13:17:53 +0000
+++ doc/rollup.txt	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-Roll-up changesets
-******************
-
-Sometimes it is useful to collapse changes; sometimes it is useful to
-pull in patches while keeping their original identity.  So (uniquely?)
-Bazaar-NG allows either option at the user's discretion.
-
-I'm not completely sure yet how this should be controlled: should it
-be an option at every stage, or should mergers generate roll-up
-changesets?  I think possibly the second.
-
-Rolled-up changesets can be represented as so::
-
-  mbp, 2005-04-01
-  import new quantum-computing feature
-
-    jrh, 2005-03-02
-    stub implementation for quantum computing
-
-    jrh, 2005-03-03
-    plus operator
-    
-    jrh, 2005-03-04
-    regexps
-
-    jrh, 2005-03-03
-    fix bugs, ready to go
-
-down to an arbitrary level of nesting.
-    
-When bringing changes into a branch, we have the choice of either
-rolling them up into a single changeset or bringing them across
-individually.  I'm not sure, but I think this may be best handled by
-having two separate commands:
-
-* *update* (or maybe *pull*) brings across revisions onto the current
-  branch, adding them one-by-one into the revision history.  This can
-  only be executed if the destination branch is a prefix of the source
-  branch and therefore we know the patches will apply perfectly.
-
-* *merge* pulls in one or more changes from another branch, and allows
-   the user to edit the merged state or fix any conflicts.  These
-   changes are then all marked as rolled-up by a new commit.  It is
-   possible to look up those changes inside the commit, if the
-   information is still accessible.
-
-In this model, Arch is missing the first command: you cannot put
-patches from one branch onto another -- and it would be hard to add
-it, since the unique branch id is part of the name of the patch name.
-
-Most other tools are missing the second: it is impossible to combine
-changesets and therefore the total history of any branch can grow very
-long; there is no way to make summaries within the tool itself.
-
-People might also want to retrospectively zip up several changes
-existing on a branch, but I think it may be better to make a new
-branch from before the changes and pull them across onto that.
-
-----
-
-One interesting application of this is in maintaining the ``NEWS``
-file present in many software distributions.  This summarizes the
-changes to the software in each release at a very high user-visible
-level.  Although this is very much version-control data it is not
-normally known to the VC system, except as another versioned file.
-
-One way to handle this is to have a *release* branch, where the commit
-message for each release the NEWS notes for that release.

=== removed file 'doc/scalability.txt'
--- doc/scalability.txt	2005-11-07 13:17:53 +0000
+++ doc/scalability.txt	1970-01-01 00:00:00 +0000
@@ -1,20 +0,0 @@
-***********
-Scalability
-***********
-
-bzr needs to scale up very well: projects with tens of thousands of
-commits, tens of thousands of files, and tens of thousands of
-branches.
-
-We are concerned with both the big-O performance of the design, and
-the multiplicative factors of the implementation.  Both is important.
-
-For example, darcs, svn and arch use more than one inode per working
-file (pristine, id file, etc).  This is only a constant factor, but
-enough to more than double the space used by a typical tree.  We would
-like to avoid it if we can.
-
-From a early stage in development the features which do work should be
-tested on large trees.
-
-

=== removed file 'doc/security.txt'
--- doc/security.txt	2005-11-07 13:17:53 +0000
+++ doc/security.txt	1970-01-01 00:00:00 +0000
@@ -1,409 +0,0 @@
-*****************************
-Security aspects of Bazaar-NG
-*****************************
-
-
-* Good security is required.
-
-* Usability is required for good security.
-
-    Being too strict "because it's the secure way" just means that people will
-    disable you altogether, or start doing things that they know is wrong,
-    because the right way of doing this may be secure, but [..] also very
-    inconvenient. 
-
-    -- Linus Torvalds
-
-.. contents:
-
-Requirements
-============
-
-David Wheeler gives some good requirements__:
- 
-    Problem is, the people who develop SCM tools often don't think about what kind of security requirements they need to support. This mini-paper describes briefly the kinds of security requirements an SCM tool should support. 
-
-__ http://www.dwheeler.com/essays/scm-security.html
-
-    confidentiality_
-      Are only those who should be able to read information able to do so?
-
-    integrity
-      Are only those who should be able to write/change information able to do so? This includes not only limiting access rights for writing, but also protecting against repository corruption.
-
-    availability
-      Is the system available to those who need it? (I.E., is it resistant to denial-of-service attacks?)
-
-    identification/authentication
-      Does the system safely authenticate its users? If it uses tokens (like passwords), are they protected when stored and while being sent over a network, or are they exposed as cleartext?
-
-    audit
-      Are actions recorded?
-
-    non-repudiation
-      Can the system "prove" that a certain user/key did an action later?
-
-    self-protection
-      Does the system protect itself, and can its own
-      data (like timestamps) be trusted?
-
-    trusted paths
-      Can the system make sure that its communication with users is
-      protected?
-
-Attacker categories
--------------------
-
-* Unprivileged outsiders.
-
-  (Almost always read-only, but people might want to allow them to
-  write in some cases, e.g. for wikis.)
-
-* Non-malicious developers with privilege.
-
-* Malicious developers with privilege.
-
-* Attackers who have stolen a privileged developer's identity.
-
-
-Access control
---------------
-
-Dan Nicolaescu gives these examples of access control:
-
-  - security related code that is still emabargoed, only select few
-    are allowed to see it, it is not desirable to release this
-    information to the public because a fix is still being worked
-    on. It would be nice to be able to have this kind of code under
-    the same version control system used for normal development for
-    ease of use and easy merging, yet it is crucial to restrict access
-    to a branches, files or directories to certain people.
-
-  - feature freeze before a release. It would be good if the release
-    manager could disable writing to the release branch, so that the
-    last tests are run, and not have someone commit stuff by mistake. 
-
-  - documentation/translation writers don't need write access to the
-    whole source code, just to the documentation directories. 
-
-  - For proprietary companies restricting access is even more
-    important, for example only some engineers should access the
-    latest development version of some code in order to keep some
-    trade secrets, etc, etc.
-
-In Bazaar-NG, the basic unit of access control is the branch.  If
-people are not supposed to read a branch, or know of its existence,
-put it somewhere where they can't see it.  If people are allowed to
-read from but not write to a branch then set those permissions.  The
-code can later be merged into a public branch if desired with no loss
-of function.
-
-We largely rely on lower-level security measures controlling who can
-get read or write access to a branch.  If you have a branch that
-should be confidential, then put it on an appropriately-secured
-machine, with only people in a particular group allowed to read it.
-
-Not having separate repositories is probably a feature here -- unlike
-Subversion, no features depend on having branches be in the same
-repository.  Each repository can have different group ownership.
-(The directories should usually be setgid.)  It also makes it easier
-to see just what the access control is; there is only one object that
-can meaningfully have an ACL.
-
-The existence of a secret branch can be fairly well hidden from the
-world.  When its changes are merged in, all that is visible is the
-name, date, and branch name of the commit, not anything about the
-location of the source branch.
-
-The documentation case I would handle by having a separate
-documentation branch, which could perhaps be checked out into a
-subdirectory when it is required.  I think this is fairly common for
-larger projects even in CVS.
-
-
-
-
-Confidentiality
----------------
-
-As dwheeler points out, this can be important even for open source
-projects, such as when preparing a security patch.
-Mechanisms that send email should have an option to encrypt the mail.
-
-I can't think of anywhere encrypted archives would be useful.  If you
-want to store it on an encrypted filesystem you can.  If you want to
-store encrypted files you can do that too, though that will leak some
-information in the metadata and branch structure.
-
-
-Security in distributed systems
--------------------------------
-
-If I have a branch on my laptop, the software ultimately cannot
-prevent me doing anything to that branch -- physical access trumps
-software controls.  We can, at most, try to prevent non-malicious
-mistakes.
-
-The purpose of the software here is to protect other people, whose
-machines I do not control.  In particular, it should be hard for me to
-lie to them; the software should detect any false statements.
-
-In particular, these should be prevented:
-
- * Claiming to be someone else.
-
- * Attempting to rewrite history.
-
-
-Revocation
-----------
-
-Suppose Alice's code-signing key is stolen by an attacker Charles.
-Charles can sign changesets purporting to come from Alice.  
-
-Alice needs to revoke that key; hopefully she has saved a copy of the
-key elsewhere and can use that to revoke it.  Failing that she can
-mail everyone and ask them to delete it.  This can propagate through
-the usual GPG mechanism, which is very nice.
-
-Alice also needs to make a new key and get it trusted.
-
-This revocation does not distinguish between changesets genuinely
-signed by Alice in the past, and changesets fraudulently signed by
-Charles. 
-
-What can Alice do now?  First of all, she needs to work out what
-changesets signed by her key can still be trusted.  One good way to do
-this is to check against another branch signed by Bob.  If Bob's key
-is safe, we know his copy of Alice's changesets are OK and the full
-tree at various points is OK.
-
-Then:
-
- * Go through her old changesets, check that they're OK -- perhaps
-   restore from a trusted backup.  Re-sign those changesets with a new
-   key bound to the same email address.  Publish the new signatures
-   instead.
-
-   (This seems to indicate it is a good idea to bind signatures to
-   changeset by author name/address rather than by key ID.)
-
- * Roll-up all previous development into a new tree, then sign that.
-   This means there is no safe access to the previous individual
-   changes, but in some cases it may be OK.
-
-If a key is revoked at a particular time then perhaps we could still
-trust commits made before that time.  I don't know if GPG revocations
-can support that.
-
-
-Old keys
---------
-
-Keys also expire, rather than being revoked.  What does this mean?
-
-Ideally we would check that the date when a changeset claims to have
-been signed is within the validity period of the key.  This requires
-more GPG integration than may at the moment be possible, but in theory
-we can do it.
-
-Also need to make sure that commits are in order by date, or at least
-reasonably close to being in order (to allow for some clock skew).
-
-One interesting case is when version is committed for which both the
-public and private keys have been lost.  This will always be
-untrusted, but that should not prevent people continuing to use the
-archive if they can accept that.
-
-This suggests that perhaps we should allow for multiple signatures on
-a single revision.
-
-
-Encumbrance attacks
--------------------
-
-A special case where we need to be able to destroy history to avoid a
-legal problem.  Allowed as discussed elsewhere: either destroy commits
-from the tail backwards, or equivalently branch from a previous
-revision and replace with that.
-
-People who saw the original branch can still prove it happened; people
-who look in the future will not see any record.  
-
-Either way, probably requires physical branch access.
-
-
-Multiple signature keys
------------------------
-
-Should we allow for several signatures on a single changeset?  What
-would that mean?  How do we know what signatures are meaningful or
-worthwhile?
-
-
-Forensics
----------
-
-dwheeler:
-
-   [O]nce you find out who did a malicious act, the SCM should make it
-   easy to identify all of their actions. In short, if you make it
-   easy to catch someone, you increase the attackers' risk... and that
-   means the attacker is less likely to do it.
-
-dwheeler asks that the committer's IP address be recorded.  Putting
-this in the changeset seems to cause too much of a
-privacy/confidentiality problem.  However, an active server might
-reasonably record the IPs of all clients.
-
-
-Non-repudiation
----------------
-
-If a changeset has propagated to Bob, signed by Alice's key, then Bob
-can prove that someone possessing Alice's key signed it.  Alice's only
-way out is to claim her key was stolen.
-
-
-Trusted review
---------------
-
-Can be handled by importing onto another branch.  Can have various
-levels for "quickly checked", "deeply trusted", etc.
-
-(Is it really necessary to import onto a new branch rather than add
-anotations to existing branches?  Copying the whole text seems a bit
-redundant.  This might be a nice place for arch-style taggings, where
-we just add a reference to another branch.)
-
-
-Hooks
------
-
-Automatically running hooks downloaded from someone else is
-dangerous.  In particular, the user may not have the chance to check
-the hooks are reasonable before they are run.
-
-Conversely, users can subvert client-side hooks.  If we want to run a
-check before accepting code onto a shared branch, that must run on the
-server.
-
-Enforcing server-side checks gives a good way to run build,
-formatting, suspiciousness checks, etc.  This implies that write
-access to a repository is through a mediating daemon rather than by
-directly writing. 
-
-
-
-Signing
--------
-
-We use signing to prove that a particular person (or 'principal',
-possibly a robot) committed a particular changeset.
-
-It is the job of external signing software to help work out whether
-this is true or not.  This has several parts:
-
- * Mathematical verification that a signature on a particular 
-   changeset header document is correct
-
- * Determining that the signature corresponds to a particular public
-   key
-
- * Determining that the public key corresponds to the person claimed
-   to have authored the changeset (identified by email address.)
-
-The second two are really PKI functions, and somewhat harder than the
-first.
-
-The canonical implementation is to use GPG/OpenPGP, but anything will
-do.  There are simpler RSA/DSA implementations which assume each user
-manually builds a list of trusted keys.
-
-This leaves open the question of which people should be trusted to
-provide software on a particular branch or at all.  This is not a very
-easy question for software to answer.  We assume that people will know
-by other means.  For public code, it may be that all changesets are
-re-signed by say samba-team@samba.org.
-
-I think it is fair to distinguish people by an email address, or at
-least by $ID@$DOMAIN.  There is no need to have this actually receive
-email, so spam need not be a problem.
-
-The signing design is inspired by the very usable security afforded by
-OpenSSH: it automatically protects where it can, and allows higher
-security to users who want to do some work (by offline verification of
-signatures).
-
-Using a signing mechanism other than GPG when key developers already
-have GPG and there is a big infrastructure to support it seems
-undesirable.  It is true that GPG is quite complex.
-
-The purpose of signing is to protect against unauthorized modification
-of archives. 
-
-Bazaar-NG can apply a GPG signature to both patches and manifests.  This
-vallows a later proof that the revision and the changeset were produced
-by the author they claim to have been written by.
-
-We cannot cryptographically prove that a particular patch was merged
-into a branch, because the person doing the merge might have subverted
-the patch in the process of merging it.  All we can prove
-cryptographically is that the merge committer asserts they took the
-patch.
-
-GPGME and PyMe seem to give a reasonable interface for doing this:
-there is a function to check a signature, and the return indicates the
-signing name, with possible errors including a missing key, etc.
-
-
-Sign branches, not revisions
-''''''''''''''''''''''''''''
-
-Aaron Bentley suggested the interesting idea of signing the mapping of
-revisions onto branches, rather than revisions themselves.  For
-example a branch could contain just a signed pointer to the most
-recent revision. 
-
-(It probably is useful to be able to check signatures on previous
-revisions, for example when recovering from an intrusion.)
-
-
-Protocol attacks
-----------------
-
-Both client and server should be resistant to malicious changesets,
-network requests, etc.  There's no easy solution.
-
-* Defense in depth.  Check reasonablenes at various points.
-
-* Disallow changesets that try to change files outside of the branch.
-
-
-Availability
-------------
-
-bzr can be configured so as to have no single point of failure to a
-denial-of-service attack (or at least nearly none):
-
-* Can have any number of mirrors of a branch.
-
-* If a central server is taken out, developers can continue working
-  with state they already have (unbind their branches), and can
-  collaborate by email or other means until the server is repaired or
-  replaced.
-
-* The origin branch can be on a machine whose location is secret and
-  which is not directly publicly accessible.
-
-* Branches can be moved between machines or IP addresses without
-  disrupting anything else.
-
-* Branches can be moved around out-of-band, as tarballs over
-  bittorrent, etc.
-
-I think the only possible denial of service attacks are those that aim
-to shut down the entire network, or block communication with
-individual developers, for example by flooding their email address.
-But if those people can get connected through some other means, they
-can continue.

=== removed file 'doc/shared-branches.txt'
--- doc/shared-branches.txt	2005-11-07 13:17:53 +0000
+++ doc/shared-branches.txt	1970-01-01 00:00:00 +0000
@@ -1,137 +0,0 @@
-***************
-Shared branches
-***************
-
-How much can we simulate the single-branch model of svn/cvs?  GNU arch
-does reasonably well, but at the cost of making disconnected/connected
-operation leave ugly merge marks in the project history.
-
-This does seem to be a drawback of the otherwise-good branch/tree
-fusion.
-
-`Greg Hudson`__ makes the very good point that the Linux kernel is
-quite unusual among free software projects in relying on human
-integrators, rather than having a shared branch between the
-committers.  The other case is very small projects (distcc?) where
-there is a single person with commit access.
-
-__ http://web.mit.edu/ghudson/thoughts/bitkeeper.whynot
-
-I think decentralized systems can still be very good, but they need to
-support this model very well: a team of committers, working on a
-single trunk branch, but merging from other branches as well.  The
-Samba team is more typical of a demanding open-source project than the
-kernel is.
-
-People fundamentally want to be able to share a tree and all commit
-into it.  It's fine to support other models (like sending patches to
-an owner/integrator/maintainer), but it is not reasonable to require
-that there be exactly one such person.
-
-arch-pqm is a clever kludge; shouldn't be required.  Setting up email
-on all clients, and scripts to automatically process email on the
-server is certainly possible.  But for some people it may not be easy;
-it is never trivial to debug; and particularly for Windows users it
-may be very hard.  If you don't control your own email server or
-cannot  easily run scripts it will be even more messy.
-
-The model of Bitkeeper, and the default model of Bazaar-NG, is that
-each branch has one owner and exists in one place.  People submit
-their patches to the owner of the branch.  This is a pretty good
-model, but has some limitations.
-
-It is a tough transition from CVS; it requires that people learn a
-whole new way of working as well as a new tool.
-
-If the person who owns the branch is away, should all integration
-work stop?
-
-I'm not totally confident in Darcs; it seems like the shared branch
-can reach a state that is not exactly the same as any of the
-checkouts.  Maybe not?  In other respects it is a good model.
-
-Possible solution: bound branches
----------------------------------
-
-You can make a branch which is a write-through mirror of another
-branch.  They work like CVS checkouts in that you must be connected
-and fully up-to-date to commit.  These can hold as much history as you
-like from the main branch, so you can view history, annotate, make new
-branches when offline.  If you are offline for a long time then make a
-new branch, then integrate it back later.
-
-The effect is similar to systems which have separate working copies
-and storage: we have one branch used primarily as a workarea, and
-another used as storage.  I think that making them both branches
-is possibly cleaner: it expresses the way some state may be held
-locally, allows offline branching from the bound branch, etc.
-
-:: 
-
-    $ bzr get http://foo.net/foo ./foo-main
-    $ cd foo-main 
-    (make some changes)
-    $ bzr commit -m 'Add my neat feature'
-    bzr: error: this branch is not-up-to-date with master 
-        http://foo.net/foo
-    - run 'bzr update'
-    - or detach this branch from its parent to work independently
-    $ bzr update
-    - setting aside local changes
-    - pulling changes from parent
-    - putting back local changes
-    $ bzr commit -m 'Add my neat feature'
-
-The ``get`` command is very similar to ``branch``, but means that
-commits will be written back.
-
-This means that the ``pull`` or ``update`` command must be able to
-work even when there are local changes, by setting them aside.  This
-in turn means that local changes may conflict with remote changes, and
-that has to be resolved -- that is no worse than in pulling in changes
-from elsewhere.
-
-commit to a master repository should fail if the slave's patch history
-is not exactly equal to that of the master -- the slave has diverged.
-If the slave history is a prefix of the master history then an update
-will do it.  Otherwise, they have diverged and the slave gets
-detached.
-
-We can have shared server-side hooks, even for access control, at
-least in principle.
-
-Perhaps ``bind`` is a nicer word than ``slave``.
-
-It is conceptually possible to take an existing branch and bind it to
-another, as long as the history of the first is a prefix of that of
-the second.  One could also unbind a branch.  These should at most be
-advanced commands, because in general it is simpler just to make a new
-branch with the desired properties.
-
-Difficulties
-~~~~~~~~~~~~
-
-It may be a bit hard to get a remote commit exactly right,
-particularly if we want to keep a working copy there.  If working
-copies are optional, then turning it off will keep things simple but
-not totally avoid the problem.
-
-I think this is just an example of a general problem though: there is
-no totally satisfactory way to atomically update a working copy.
-(What happens to cvs or svn if you interrupt while it's doing this?
-Generally you get a broken wc.)  What we can do is create a lock while
-the update is taking place, which can be used to at least detect the
-problem. 
-
-If changes are allowed to the working copy of the master branch then
-they might conflict with what is committed by the slave.  Should those
-changes be merged into the working copy of the parent?  If so, they
-might conflict.  
-
-  (darcs handles this case by inserting conflict markers in the remote
-  file, which seems unsatisfactory to me.)
-
-So I am inclined to say that at the moment of pushing to a master
-branch, the destination should be clean.  If we have explicit edits
-then probably there should be no editable files there.  (We could
-perhaps make all the files read-only for the duration of the update.)

=== removed file 'doc/short-demo.txt'
--- doc/short-demo.txt	2005-11-07 13:17:53 +0000
+++ doc/short-demo.txt	1970-01-01 00:00:00 +0000
@@ -1,152 +0,0 @@
-******************************
-Learn Bazaar in twenty minutes
-******************************
-
-
-:Author:
-  Martin Pool <mbp@sourcefrog.net>
-
-:Date: November 2004, London
-
-
-*Bazaar* is an open source distributed version control system.  A
-version control system helps you develop software (or other documents)
-
-In Bazaar, branches hold a history of their changes.  All working
-copies are branches, and all branches are working copies.
-
-Let's get a copy of someone else's published project::
-
-    $ baz branch http://baz.alice.org/hello-2.6
-
-This creates a directory called ``hello-2.6`` in your current
-directory, containing Alice's *Hello World* 2.6 tree and a history of
-her changes.  We'll leave this directory containing a pristine copy of
-her work for future reference.
-
-We want to add a new feature.  Branching and merging is are cheap and
-easy in Baz, so development of each new feature should be done on a
-new branch -- this lets you merge them in different orders, and leave
-aside new development to fix a bug if you want.  It's good to choose a
-meaningful name for your development branches so that you can keep
-them straight.  So let's make an additional branch, based off our
-local copy of Alice's branch::
-
-    $ baz branch ./hello-2.6 ./hello-2.6-goodbye
-
-This command completed quickly: we didn't need to fetch anything from
-Alice's server to make a new branch.
-
-Now we have a second directory containing another copy of the source,
-with a different name.  Of course both are still the same as Alice's
-source.  Time to hack::
-
-    $ cd hello-2.6-goodbye
-    $ vi hello.c
-
-We add a new and much-desired ``--goodbye`` option, build and test
-it.  Having got to a good state, we think we're ready to commit our
-changes.  Many people find it helpful to review the changes before
-committing them, just to make sure there were no accidental mistakes::
-
-    $ baz diff | less
-
-This shows the changes relative to the version we started with.  If
-that looks OK, we're ready to commit::
-
-    $ baz commit -m 'Add --goodbye option'
-
-This records the changes into this branch.  We can see that they got
-recorded::
-
-    $ baz log | less
-
-This will show our change as the most recent, preceded by all our
-development.  If we only want to see our own changes, we can filter
-the log in various ways::
-
-    $ baz log --author bruce@ 
-    $ baz log --date today 
-
-(That second one might include anything Alice did before we started.)
-
-Since our changes were committed, we don't have anything outstanding,
-as we can see with this command::
-
-    $ baz diff 
-    No changes
-
-Thinking about it a bit more, we decide that it's too messy to mix the
-"Goodbye" implementation in with "Hello world".  We start up our
-editor and split it our into a new separate file, ``bye.c``.  By
-default, Baz assumes unknown files in the working directory are
-scratch files -- the same behaviour as CVS and Subversion.  We need to
-tell Baz that this file should be versioned, and then we can commit::
-
-    $ baz add bye.c
-    $ baz commit -s 'Refactor bye() into separate file'
-
-Of course this commits all our changes as a single atomic
-transaction.  If we wanted, we could tell Baz to build the program
-before committing to help ensure we never get a broken build.
-
-We're ready to publish our improved Hello World, but first we want to
-make sure we've integrated anything Alice has done while we were
-working.  First we update our mirror of Alice's branch::
-
-    $ baz sync ../hello-2.6
-
-This pulls the history of her branch onto our machine; we could
-disconnect from the network at this point and do all the merging work
-without needing to connect to ``alice.org``.   
-
-Now we'll pull Alice's new changes into our branch.  We can use a
-mirror of her branch, or we can go straight to her public branch.  In
-fact, we can merge from different copies of the same branch at
-different times, and Baz will still understand which changesets have
-already been merged.  Either of these commands will work::
-
-    $ baz merge ../hello-2.6
-    $ baz merge http://baz.alice.org/hello-2.6
-
-This pulls down any changesets on Alice's branch that aren't in ours,
-and applies them to our tree.  Since we've made changes in parallel
-with Alice, those changes might conflict.  Baz by default will insert
-CVS-style conflict markers into your branch if that happens, but you
-can also ask it to run a graphical merge tool or to tell emacs to do
-the merge.  Baz will help you merge changes other than file text, such
-as a file being renamed in one branch.  
-
-By running ``baz diff`` we can see the effect of her changes on our
-tree.  By running ``baz log --pending`` we can see a description of
-all of the changes that were pulled in.  Once the changes have been
-reconciled (which will often happen automatically), we can commit this
-to our branch::
-
-    $ baz commit -s 'Merge from Alice'
-
-Baz records that our change incorporates those patches from Alice::
-
-    $ baz log | less
-
-Now that we have the feature we wanted, we can publish our branch on
-the web.  We could copy it up using ``baz branch``, but because Baz
-branches are simply directories we can just rsync it onto a web
-server, even if the web server doesn't have Baz installed::
-
-    $ rsync -av ./hello-2.6-goodbye webserver.com:public_html/
-
-We send an email to Alice asking her to merge from this location.
-Typically she'll want to have a look at those changes before accepting
-them, and she can do that by running ``merge`` then ``diff``, as we
-did before.  If she likes the change, she can merge it, possibly
-applying some fixes in the process.  Next time we merge from her,
-we'll see our changes are in.
-
-
-
-.. Local variables:
-.. mode: rst
-.. compile-command: "rest2html short-demo.txt > short-demo.html"
-.. End:
-

=== removed file 'doc/split-join-files.txt'
--- doc/split-join-files.txt	2005-11-07 13:17:53 +0000
+++ doc/split-join-files.txt	1970-01-01 00:00:00 +0000
@@ -1,59 +0,0 @@
-Split and join files
-====================
-
-Version control systems tend to have trouble when files are split or
-joined.  Here is one possibility for handling that.
-
-
-Splitting files
----------------
-
-This can work like 'svn cp': copy with history::
-
-  % bzr cp a b
-
-This creates a new file b, whose file-history is the same as a, but
-with a different file-id, and present at a different name.
-
-This creates the slightly strange situation that b claims to have text
-versions for revisions where b was not actually present.
-
-
-Joining files
--------------
-
-We might want to also join files in various cases:
-
- * Multiple imports of the same file
-
- * Two source files are being refactored into a single one
-
- * Two people apply an external patch that creates the same file
-
-I'm not aware of any other system that handles this.
-
-  % bzr join a b
-
-a and b must be versioned files.  b is removed from the working tree
-and inventory.  b's file id is added as a secondary id as a, so that
-later merges between them will detect them as being the same.  
-
-b's weave is (???) incorporated into a.  
-
-This means that we have a file which has multiple history paths.  For
-example, asking to compare that file to its state in a previous
-version has to arbitrarily pick one to use.  That's not necessarily
-fatal if we assign one as primary, but it might be a bit confusing.
-Trying to merge from another tree might can't really choose a good
-basis.
-
-
-
-File aliases
-------------
-
-Rather than trying to join files we might just add notes that files
-are also known by a different file-id in other trees.
-
-
-

=== removed file 'doc/supportability.txt'
--- doc/supportability.txt	2005-11-07 13:17:53 +0000
+++ doc/supportability.txt	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-************************
-Bazaar-NG Supportability
-************************
-
-The goal is to be able to diagnose and fix a bug the first time it is
-reported, even if the reporter or developer can't reproduce it.
-
-Done:
-
-* Verbose logs are always written to ``.bzr.log`` in the current
-  directory.  This include all error messages and some trace messages
-  that are not normally displayed.  It also includes backtraces if
-  an exception occurs.
-
-To do:
-
-* The --verbose option should send debug output to stderr.
-
-* Re-read changesets after writing them to a temporary file, but
-  before permanently committing them.  Make sure that they are valid
-  XML (against RELAX-NG schema), that they can be parsed, and that
-  they recreate the right revision.  This should help prevent the
-  archive ever getting corrupted, which is a pain to reverse.

=== removed file 'doc/svk.txt'
--- doc/svk.txt	2005-11-07 13:17:53 +0000
+++ doc/svk.txt	1970-01-01 00:00:00 +0000
@@ -1,32 +0,0 @@
-svk
-===
-
-The strategic strength is that it can trivially and reliably
-interoperate with upstream projects using Subversion.  This tends to
-satisfy people who need disconnected operation, and so to allow
-projects to feel safe about switching to Subversion.
-
-On the other hand it may be a bit flaky in implementation -- when I
-tried it (dec 04), it crashed in confusing ways several times.  And
-certainly Subversion's reputation for reliability is mixed -- some
-people think it's very solid, but I've seen many db crashes at HP.
-
-Being written in Perl on top of Svn bindings may not inspire
-confidence.  robertc says he's worked with the libsvn bindings and
-they're a mess.  Relatively little documentation.  In general a
-feeling of a very tall stack.
-
-There is some fluff about defining multiple repositories, which seems
-like an argument for history-in-branch.
-
-Keeps track of merge arrows to do smart merges.
-
-They follow Perforce in not having any control files in the tree --
-nice in some ways but you must use the right tool to move or delete a
-working area.  (In fact the whole thing seems to be inspired a bit by
-Perforce?)  I think keeping just one dotfile at the top level may be a
-fair compromise.
-
-
-
-(If this is unfair or inaccurate mail me dammit.)
\ No newline at end of file

=== removed file 'doc/switch-in-branch.txt'
--- doc/switch-in-branch.txt	2005-11-07 13:17:53 +0000
+++ doc/switch-in-branch.txt	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-Trees which are annoying to set up.  Want to switch to a different
-branch without needing to set everything up again.
-
-Uses for switch: keeps around unknown/ignored files and any local
-changes.

=== removed file 'doc/tagging.txt'
--- doc/tagging.txt	2005-11-07 13:17:53 +0000
+++ doc/tagging.txt	1970-01-01 00:00:00 +0000
@@ -1,107 +0,0 @@
-*******
-Tagging
-*******
-
-
-It is useful to be able to point to particular revisions on a branch
-by symbolic names, rather than revision numbers or hashes.
-
-
-Proposal: just use branches
----------------------------
-
-This is probably the simplest model.
-
-In both Subversion and Arch, tags are basically just branches that do
-not differ from their parent revision.  This has a few advantages:
-
-* We do not need to introduce another type of entity, which can
-  simplify both understanding and implementation.  We also do not need
-  a special 
-
-* If branches are cheap (through shared storage, etc) then tags are
-  also appropriately cheap.
-
-* The general idea is familiar to people from those two systems (and
-  probably some others).
-
-* People often do put tags in the wrong place, and need to update
-  them, or want tags that move along from one state to another
-  (e.g. ``STABLE``.)  Tags-as-branches capture this through the usual
-  versioning mechanism, rather than needing to invent a parallel
-  versioning system for tags.
-
-There are some problems:
-
-* Users want tags to stay fixed, but branches are things that can be
-  committed-to.  So at one level there is a mismatch.
-
-* In particular, it can be easy to accidentally commit onto a tag
-  branch rather than a "branch branch", and that commit can easily be
-  'lost' and never integrated back to the right place.
-
-One possible resolution is to have a voluntary write-protect bit on a
-branch, which prevents accidental updates.  (Similar to the unix owner
-write bit.)  When it is necessary to update the branch, that bit can
-be removed or bypassed.
-
-This is an alternative to the Arch ``--seal`` mechanism.
-
-
-
-Proposal: tags within a branch
-------------------------------
-
-You can place tags on a branch as shorthand for a particular
-revision::
-
-  bzr tag rel3.14.18
-
-  bzr branch foo-project--main@rel3.14.18
-
-Tags are alphanumeric identifiers that do not begin with a digit.
-Tags will cover an entire revision, not particular files.
-
-Another term sometimes used is "labels"; I think we're close enough to
-CVS's "tags" that it's good to be consistent.  However, it does
-possibly clash with Arch's ``tag`` command and ``id-tagging-method``
-(sheesh).
-
-In Subversion a tag is just a branch you don't commit to.  You *can*
-work this way in Bazaar if you want to.  (And until tags are
-implemented, this will be the way to do it.)
-
-I'm not sure if tags should be versioned objects or not.  Options:
-
-* Tags are added or changed by a commit; they mark previous revisions
-  but are only visible when looking from a later commit.
-
-  This has the fairly strange effect that if you check out a previous
-  tag, you can't see the tag anymore (or you see the value it
-  previously had.)
-
-* Tags are not versioned; if you move them they're gone.
-
-* Tags exist within their own versioning space.
-
-It is useful to have mutable tags, in case they're incorrectly placed
-or need to be updated.  At the same time we do not want to lose
-history.  I think in this model it is not helpful to update tags
-within revisions.  One approach would be to version tags within a
-separate namespace, so 
-
-  | STABLE.0
-  | STABLE.1
-  | STABLE.2
-
-as just STABLE it finds the most recent tag.
-
-Should tags propagate across merges, and if so how?
-
-
-
-Implementation Plan
--------------------
-
-Add tags as non-versioned objects, that for the moment do not
-propagate across branches.

=== removed file 'doc/taxonomy.txt'
--- doc/taxonomy.txt	2005-11-07 13:17:53 +0000
+++ doc/taxonomy.txt	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-Taxonomy of version control systems
-===================================
-
-(ie a look at "cutting questions" that describe different design
-approaches.)
-
-
-History in working copy
------------------------
-
-Is history stored with working directory (bk, rcs, darcs), or
-separately (cvs, baz)?
-
-Storing in the working directory may be simpler in some respects;
-it's one less concept people need to learn.  On the other hand
-people typically have more working copies than branches, and this
-approach means having more copies of the history.
-
-Naively, storing everything in the working copy can mean that you
-keep multiple copies of the history, which would use a lot of disk,
-or 
-
-Rewriting history
------------------
-
-Can you change recorded history (darcs); only do this through a
-special mechanism (cvs, svn); or not do it at all?
-
-Being absolutely able to reproduce any point in time reliably is
-highly attractive.  On the other hand, sometimes people commit
-something (e.g. confidential information) that really should not be
-recorded.  And at a smaller level people might just commit the wrong
-message.
-
-
-Explicit edits
---------------
-
-Can you edit any file in a working copy (cvs, tla) or must you
-specially mark the before editing (rcs, bk)?
-
-There are two reasons to mark files for editing.  One is so that
-people can be notified that a file is about to
-
-
-Track history of patches
-------------------------
-
-Can you see how a patch got to its current destination?  As far as I
-know only arch can do this -- you can see what branches it
-incorporates changes from.  Well, kind of; not in an entirely
-straightforward manner.
-
-
-
-Collapsing patches
-------------------
-
-When patches from other people are integrated, can they be rolled up
-into larger patches (arch) or do they retain their individual identity
-(bk, darcs)?
-
-
-

=== removed file 'doc/thanks.txt'
--- doc/thanks.txt	2005-11-07 13:17:53 +0000
+++ doc/thanks.txt	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-******
-Thanks
-******
-
-Inspiration, suggestions, advice, bug reports
----------------------------------------------
-
-* Mark Shuttleworth
-* Robert Collins
-* David Allouche
-* Robert Weir
-* James Blackwell
-* Garrett Rooney
-* Andrew Tridgell
-* Paul Russell
-* Aaron Bentley
-* Faheem Mitha
-* Luke Gorrie
-* Dan Nicolaescu
-* Tim Parkin
-* Scott James Remnant
-
-Sponsor
--------
-
-* Canonical_
-
-.. _Canonical: http://www.canonical.com/
\ No newline at end of file

=== removed file 'doc/todo-from-arch.txt'
--- doc/todo-from-arch.txt	2005-11-07 13:17:53 +0000
+++ doc/todo-from-arch.txt	1970-01-01 00:00:00 +0000
@@ -1,373 +0,0 @@
-***************************************** 
-Opportunities for improvement on GNU Arch
-***************************************** 
-
-[note that this document is rather out of date in 2005-08]
-
-GNU Arch is one influence on bazaar-ng.  There are several things we
-would change from Arch in Bazaar to (we hope) improve the user
-experience.
-
-The core design of Arch is good, brilliant even.  It can scale from
-small projects too large ones, and is a good foundation for building
-tools on top.  However, the design is far too complex, both in
-concepts and execution.  So the plan is to cut out as many things as
-we can, add a few other good concepts from other systems, and try to
-make it into a whole that is consistent and understandable.
-
-
-Good bits to keep
------------------
-
-* Roll-up changesets
-
-  No other system is able to express this valuable idea: "I merged all
-  these changes from other people; here is the result."
-
-  However, it should *also* be possible to bring in perfect-fit
-  patches without creating a new commit.
-
-* Star-merge
-
-  Find a common ancestor on diverged and cross-merged branches.
-
-* Apply isolated changesets.
-
-  We should extend this by having a good way to send changesets by
-  email, preferably readable even by people who are not using Arch.
-
-* GPG signing of commits.
-
-  Open source hackers almost all have GPG keys already, and GPG deals
-  with a lot of PKI functions to do with propagating, signing and
-  revoking keys.
-
-  Signed commits are interesting in many ways, not least of which in
-  detecting intrusion to code servers.
-
-* Anonymous downloads can be done without an active server.
-
-  Good for security; also very good for people who do not have a
-  permnanently-connected machine on which they can install their own
-  software, or which is very tightly secured.
-
-  It's neat that you can upload over only sftp/ftp, but I'm not sure
-  it's really worth the hassle; getting properly atomic operations
-  over remote-file protocols is hard.
-
-* Clean and transparent storage format.
-
-  This is a neat hack, and gives people assurance that they can get
-  their data back out again even if the tool disappears.  Very nice.
-  (Bazaar-NG won't keep the exact same format, but the ideas will be
-  similar.) 
-
-* Relatively easily parseable/scriptable shell interface.  Good for
-  people writing web/emacs/editor/IDE interfaces, or scripts based it.
-
-* Automatically build (and hardlink) revision libraries, with
-  consistency checks.
-
-  I don't know how many people want *every* revision in a library, but
-  it can be handy to have a few key ones.
-
-  In general making use of hardlinks when they are available and safe
-  is nice.
-
-* Rely on ssh for remote access, authentication, and confidentiality.
-
-* Patch headers separate from patch bodies.  (Sometimes you only want
-  one.)
-
-* Autogeneration of Changelogs -- but should be in GNU format, at
-  least optionally.  I'm not convinced auto-updating them in the tree
-  is worthwhile; it makes merges weird.
-
-* Sealing branches.
-
-  It seems useful to prevent accidental commits to things that are
-  meant to be stable.  However, the set-once nature of sealing is
-  undesirable, because people can make mistakes or want to seal more
-  than once.
-
-  One possibility is to have a voluntary write-protect flag set on
-  branches that should not normally be updated.  One can remove the
-  flag if it turns out it was set wrongly.
- 
-* ``resolved`` command in Bazaar-1.1
-
-  Good for preventing accidental breakage.
-
-* Multi-level undo -- though could perhaps be more understandable,
-  perhaps through ``undo-history``.
-
-
-Bits to cut out
----------------
-
-One lesson from usability design is that it does not always work to
-have a complex model and then try to hide complexity in the user
-interface.  If you want something to be a joy to use, that must be
-designed in from the bottom up.
-
-  (Some developers may react to tla by thinking "eww, how gross" on
-  particular points.  As much as possible we might like to fix these.)
-
-* General impression that the tool is telling you how to run your life.
-
-* Non-standard terminology
-
-  Arch uses terms like "version" and "category" in ways that are
-  confusing to people accustomed to other version control systems.
-  This is not helpful.
-
-  Therefore: development proceeds on a *branch*, which is a series of
-  *revisions*.  Simple and obvious.
-
-* Too many commands.
-
-* Command-line options are wierdly inconsistent with both other
-  systems, with each others, and with what people would like to do.
-  For example, I would think the obvious usage is ``bzr diff [FILE]``,
-  but ``tla diff`` does not let you specify a file at all.
-
-  Most commands should take filenames as their argument: log, diff,
-  add, commit, etc.
-
-* Despite having too many commands, there are massive and glaring
-  gaps, such reverting a single file or a tree.
-
-* Commands are too different from what people are used to in CVS, and
-  often not for a good reason.
-
-* Identifiers are too long.  In part this is because Arch tries to
-  have identifiers which are both human-assigned and universally unique. 
-
-* Archive names are probably unnecessary.
-
-* Part of the reason for complexity in archives is that the Arch
-  design wants to be able to go and find patches on other branches at
-  a later time.  (This is not really implemented or used at the
-  moment.)
-
-  I think the complexity is unjustified: changesets and revisions have
-  universally unique names so they can simply be archived, either on
-  the machine of the person who wants them or on a central site like
-  supermirror.
-
-* The tool is *unforgiving*; if people create a branch with the wrong
-  name it will be around forever.
-
-* Branches are heaviweight; a record always persists in the archive.
-  Sometimes it is good to create micro-branches, try something out,
-  and then discard them.  If nobody wants the changes, there is no
-  reason for the tool to keep them.
-
-* Working offline requires creating a new branch and merging back and
-  forth.  This is both more work than it should be, and also polutes
-  the "story" told by branching.
-
-  As much as possible, the *accidental* difference of the location of
-  the repository should not effect the *semantics* of branches.
-  
-  (However, some merging may obviously be necessary when there is
-  divergence.) 
- 
-* Archive registration.  This causes confusion and is unnecessary.
-
-  Proposed solutions such as archive aliases or an additional command
-  to register-and-get make it worse.
-
-* Wierd file names (``++`` and ``,,``, which persist in user
-  directories and cause breakage of many tools.  Gives a bad
-  impression, and it's even worse when people have to interact with
-  them.
-
-* Overly-long identifiers.  (One advantage of pointing to branches
-  using filenames or URLs is that the length of the path depends on
-  how close it is to the users location, and they can more easily use 
-
-* Too slow by default.
-
-  Arch can be made fast, but in the hands of a nonexpert user it is
-  often slow.  For most users, disk is cheaper than CPU time, which is
-  cheaper than network roundtrips.  The performance model should be
-  transparent -- users should not be surprised that something is slow.
-
-* Tagging onto branches.
-
-  Unifying tags and commits is interesting, but the result is hard to
-  mentally model; even Arch maintainers can't say exactly how it is
-  supposed to work in some cases.
-
-* Reinventing the world from scratch in libhackerlab/frob/pika/xl.
-
-  Those are all fine projects and may be useful in the future, but
-  they are totally unnecessary to write a great version control
-  system.  It is not an enormous project; it is not CPU-cycle
-  critical; something like Python will be fine.
-
-* Lack (for the moment) of an active server.
-
-  Given that network traffic is the most expensive thing, we can
-  possibly get a better solution by having intelligence on both sides
-  of the link.  Suppose we want to get just one file from a previous
-  revision...
-
-* Poor Windows/Mac support.
-
-  Even though many developers only work on Linux, this still holds a
-  tool back.  The reason is this: at least some projects have some
-  developers on Windows some of the time.  Those projects can't switch
-  to Arch.  Most people want to only learn one tool deeply, so it
-  won't be Arch.
-
-  Don't make any overly Unixy assumptions.  Avoid too-cute filesystem
-  dependencies.
-
-  Being in Python should help with portability: people do need to
-  install it, but many developers will already have it and the total
-  burden is possibly less than that of installing C requisite
-  libraries.
-
-* Quirky filename support.
-
-  Files with non-ascii names, or names containing whitespace tend to
-  be handled poorly, perhaps partly because of arch's shell heritage.
-
-  By swallowing XML we do at least get automatic quoting of wierd
-  strings, and we will always use UTF-8 for internal storage.
-
-* Complex file-id-tagging 
-
-  Nobody should be expected to understand this.  There are two basic
-  cases: people want to auto-add everything, and want to add by hand.
-  Both can be reasonably accomodated in a simpler system.
-
-* Complex naming-convention regexps in ``.arch-inventory`` and 
-  ``{arch}/id-tagging-method``.  (The fact that there are two
-  overlapping mechanisms with very different names is also bad.)
-
-  All this complexity basically just comes down to versioned, ignored,
-  unknown, the same as in every other system.  So we might as well
-  just have that.
-
-  There are relatively few cases where regexps help more than globs,
-  and people do find them more complex.  Even experienced users can
-  forget to escape ``\.``.  We can have a bit of flexibility with
-  (say) zsh-style extended globs like ``*.(pyo|pyc)``.
-
-* Some files inside ``{arch}`` are meant to be edited by the user, and
-  some are not.  This is a flaw common to other systems, including
-  Bitkeeper.  The user should be clear on whether they should touch
-  things in a directory or not.
-
-* Source-librarian function works poorly.
-
-  It is not the place of a tool to force people to stay organized; it
-  should just facilitate it.  In any case, a library without
-  descriptive text is of little use.  So bazaar-ng does not force
-  three-level naming but rather lets people arrange their own trees,
-  and put on their own descriptions (either within the tree, or by
-  e.g. having a wiki page listing branches, descriptions and URLs.)
-
-* Whining about inode mismatches on pristines/revlibs.
-
-  It's fine that there is validation, but the tool should not show off
-  its limitations.  Just do the right thing.
-
-* More generally, not quite enough consistency/safety checking.
-
-* Unclear what commands work on subdirs and what works on the whole
-  tree.
-
-* Hard to share work on a single branch -- though still not really too
-  bad.
-
-* Lack of partial commits of added/deleted files.
-
-* Separate id tags for each file; simple implementation but probably
-  costs too much disk space.
-
-* Way too many deeply-nested directories; should be just one.
-
-* ``.listing`` files are ugly and a point of failure.  They can cause
-  trouble on some servers which limit access to dot files.
-
-  Isn't it possible to have the top-level file be predictable and find
-  everything else needed from there?
-
-* Summary separate from log message.
-
-  Simpler to just have one message, and let people extract the first
-  line/sentence if they wish.
-
-  Rather than 'keywords', let arbitrary properties be attached to the
-  revision at the time of commit.
-
-
-
-Simpler disconnected operation
-------------------------------
-
-A basic distributed VCS operation is to make it easy to work on an
-offline laptop.  Arch can do this in a few ways, but none of them are
-really simple.
-
-http://wiki.gnuarch.org/moin.cgi/mini_5fTravellingOftenWithArch
-
-Yaron Minsky writes (2005-01-18):
-
-    I was wondering what people considered to be a good setup for using
-    Arch on a laptop.  Here's the basic situation.  I have a few projects
-    that reside in arch repositories on my desktop computer.    Basically,
-    I'd like to be able to do commits from my laptop, and have those
-    commits eventually migrate up to the main repository.  I understand
-    that the right way of doing this is to set up archives on the laptop. 
-    But what's the cleanest way of doing this?  And is there some way of
-    making the commits I do on the laptop show up cleanly and individually
-    on the desktop once they are merged in?
-
-
-Tagging-method
---------------
-
-baz default is much less strict.  
-
-Much of tla depends on being able to categorize files.  Some hangovers
-from larch -- eg precious and backup are essentially the same.  junk
-is never deleted today.  
-
-Automatic version control with 'untagged-source source'.  But this is
-deprecated for baz?
-
-Annoyed by
-
- - defaults
- - having the feature at all
- - complex way to define it
-
-Default of 166 lines.
-
-Remove id-tagging-method command or at most make it read-only.  If
-people really want to use deprecated methods they can just edit the
-file.
-
-So we can ship a default id-tagging which works the same as CVS/Svn:
-give warnings for files that are not known to be junk.  This is the
-default in baz right now.
-
-Also we have .arch-inventory, which is per-directory.
-
-
-
-Why not have 'baz ignore FILENAME'?  To remove ignores, perhaps you
-have to edit the .arch-inventory.  Print "FILTER added to
-PATH/.arch-inventory"; create and baz-add this file if it doesn't.
-
-Docs should perhaps emphasize .arch-inventory as the basic method and
-only mention =tagging-method as an advanced topic.
-
-
-
-Should this really be regexps, or just file globs?
\ No newline at end of file

=== removed file 'doc/unchanged.txt'
--- doc/unchanged.txt	2005-11-07 13:17:53 +0000
+++ doc/unchanged.txt	1970-01-01 00:00:00 +0000
@@ -1,102 +0,0 @@
-Detecting unchanged files
-*************************
-
-Many operations need to know which working files have changed compared
-to the basis revision.  (We also sometimes want to know which files
-have changed between two revisions, but since we know the text-ids
-and hashes that is much easier.)  
-
-The simplest way is to just directly compare the files.  This is
-simple and reliable, but has the disadvantage that we need to read in
-both files.  For a large tree like the kernel or even samba, this can
-use a lot of cache memory and/or be slow.  Some people have machines
-that do not have enough memory to hold even one copy of the tree at a
-time, and this would use two copies.
-
-So it is nice to know which files have not changed without actually
-reading them.  Possibilities:
-
-* Make the working files be hardlinks to the file store.  Easy to see
-  if they are still the same file or not by simply stat'ing them.  For
-  extra protection, make the stored files readonly.  Has the
-  additional advantage of reducing the disk usage of the working copy.
-
-  Disadvantage is that some people have editors that do not handle
-  this safely.  In that case the changes will go undetected, and they
-  could corrupt history.  Pretty bad.
-
-  We can provide a ``bzr edit`` command that breaks the link and makes
-  the working copy writable.
-
-* As above, but link to a temporary pristine directory, not to the
-  real store.  They can get a wrong answer, but at least cannot
-  corrupt the store.
-
-* Check the mtime and size of the file; compare them to those of the
-  previous stored version.  
-
-  The mtime doesn't need to be the time the previous revision was
-  committed.
-
-  There is a possibility of a race here where the file is modified but
-  does not change size, all in the second after the checkout.  Many
-  filesystems don't report sub-second modification times, but Linux
-  now allows for it and it may be supported in future.
-
-* Read in all the working files, but first compare them to the
-  size and text-hash of the previous file revision; only do the diff
-  if they have actually changed.  Means only reading one tree, not
-  two, but we still have to scan all the source.
-
-* Copy the file, but use an explicit edit command to remember which
-  ones have been changed.  Uneditable files should be readonly to
-  prevent inadvertent changes.
-
-The problem with almost all of these models is that it is possible for
-people to change a file without tripping them.  The only way to make
-this perfectly safe is to actually compare.  So perhaps there should
-be a paranoia option.  
-
-It is crucial that no failure can lose history.  Does that mean
-hardlinks directly into the file store are just too risky?
-
-It is most important that ``diff``, ``status`` and similar things be
-fast, because they are invoked often.  It may be that the ``commit``
-command can tolerate being somewhat slower -- but then it would be
-confusing if ``commit`` saw something different to what ``diff`` does,
-so they should be the same.
-
-For the mooted `edit command`__, we will know whether a file is
-checked out as r/o or r/w; if a file is known to be read-only it can
-be assumed to be unmodified.
-
-__ optional-edit.html
-
-The ``check`` command can make sure that any files that would be
-assumed to be unmodified are actually unmodified.
-
-File times can skew, particularly on network filesystems.  We should
-not make any assumptions that mtimes are the same as the system clock
-at the time of creation (and that would probably be racy anyhow).
-
-Proposal
---------
-
-::
-  
-    if file is not editable:
-        unmodified
-
-    if not paranoid:
-        if same inum and device as basis:
-            unmodified
-        elif present as read-only:
-            unmodified
-        elif same mtime and size:
-            unmodified
-
-    read working file, calculate sha1
-    if same size and sha-1 as previous inventory-entry:
-        unmodified
-
-    possibly-modified

=== removed file 'doc/unrelated-merge.txt'
--- doc/unrelated-merge.txt	2005-11-07 13:17:53 +0000
+++ doc/unrelated-merge.txt	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-****************************
-Merging unrelated changesets
-****************************
-
-It ought to be possible to merge in even totally unrelated changesets,
-by just treating them as patches.  It is possible that the file ids
-will mismatch, in which case we could perhaps assume the filenames are
-compatible. 
\ No newline at end of file

=== removed file 'doc/usability.txt'
--- doc/usability.txt	2005-11-07 13:17:53 +0000
+++ doc/usability.txt	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
-* http://www.asktog.com/basics/firstPrinciples.html
-
-* http://wiki.gnuarch.org/moin.cgi/BazaarMockupUI
-

=== removed file 'doc/use-cases.txt'
--- doc/use-cases.txt	2005-11-07 13:17:53 +0000
+++ doc/use-cases.txt	1970-01-01 00:00:00 +0000
@@ -1,132 +0,0 @@
-Bazaar-NG Use Cases
-*******************
-
-.. contents::
-
-
-
-Review changes 
-==============
-
-Look at somebody else's tree or email submissions.  
-
-Looking at the patch alone may not be enough; we might need to apply
-it to a tree, build it and see if we like it.
-
-
-
-
-Changes on branches
-===================
-
-Clearcase allows you to put all new development onto branches that are
-later merged back.
-
-Can we detect which development branches have unmerged changes?  Can
-we dispose of those branches?
-
-
-
-unmerge
-=======
-
-Get rid of any changes that have been merged in but not yet
-committed.  Shouldn't this just be ``bzr revert``?
-
-
-
-cross damage problem with PQM 
-=============================
-
-Lock 
-
-
-
-undo some uncommitted changes
-=============================
-
-If you've made some changes and don't want them::
-
-  baz undo foo.c
-
-This stores them as a changeset in a directory that you can move
-around.  You can set a name for it::
-
-  baz undo --name blargh-refactor foo.c bar.c
-
-You can get it back::
-
-  baz redo foo.c
-
-
-move some in-progress changes onto a local branch
-=================================================
-
-This is useful if we decide some changes on a bound branch should be
-done on a separate branch; in particular people will want to do this
-if they want to work in only one subdirectory of a complex config.
-
-Possibly this should be the default with no arguments for ``bzr
-branch``.  Or possibly there should be a separate ``bzr unbind``.
-
-
-
-ignore some files
-=================
-
-I'm working on a Python project, which leaves bytecode files in the
-working directory::
-
-  baz ignore \*.pyc
-  baz ignore \*.pyo
-
-or::
-
-  baz ignore '*.py[co]'
-
-OK, there is some danger here that people always forget to quote globs
-on the command line but maybe this will be enough.
-
-Maybe take only one at a time so that we can catch unquoted globs like
-this::
- 
-  baz ignore *.pyc                      # wrong!
-
-If they do this, they see all '* added foo.pyc to .arch-inventory';
-then they can do this to get back::
-
-  baz undo .arch-inventory
-
-This is potentially much more pleasant than Subversion.
-
-
-
-Wrong commit message
-====================
-
-I accidentally commit some files with the wrong message and want to
-change them::
-
-   % bzr status
-   M    foo.c
-   % bzr commit -s 'fix foo'
-   M    foo.c
-   [oops!]
-   % bzr uncommit
-   % bzr status
-   M    foo.c
-   % bzr commit -s 'fix foo and bar'
-
-This fix should be done as soon as possible, before anything else
-depends on the change.
-   
-
-
-Monday morning
-==============
-
-Come in Monday morning; can't remember what you were doing.
-
-* log; look at what was committed
-* diff against upstream, or recent revisions
-* what else?

=== removed file 'doc/web-interface.txt'
--- doc/web-interface.txt	2005-11-07 13:17:53 +0000
+++ doc/web-interface.txt	1970-01-01 00:00:00 +0000
@@ -1,24 +0,0 @@
-*************
-Web interface
-*************
-
-The web interface may be the first way many people interact with a new
-VC system.  It may not be core functionality but it is important.
-
-mpe says he likes the bkbits.net one, in particular that you can
-quickly search the comments and pull out individual patches.  However,
-it does not really give people a good sense of how the tool works.
-
-The `Aegis web interface`__ is rather better, giving a good sense (for
-better or worse) of the ideas behind the tool, as well as the
-particular tree being viewed.  For example you can see that all
-changes in progress are registered, that one can identify conflicts
-before a merge is attempted and so on.  In part this is because there
-are many links ("Information available") and they are explained in
-some detail:
-
-  "This item will provide you with a list of changes to this project,
-  including those which have not yet commenced, those in progress, and
-  those which have been completed."
-
-__ http://aegis.sourceforge.net/webiface.html
\ No newline at end of file

=== removed file 'doc/workflow.txt'
--- doc/workflow.txt	2005-11-07 13:17:53 +0000
+++ doc/workflow.txt	1970-01-01 00:00:00 +0000
@@ -1,117 +0,0 @@
-********
-Workflow
-********
-
-People want to manage submissions of patches; see `Havoc's post`__.
-
-__ http://log.ometer.com/2004-11.html#19
-
-The ideal interface is::
-
-    baz branch http://project.org/bzr/project-2.0
-    [hackety hack]
-    baz submit
-
-It would be nice if people could submit simple changes without needing
-to set up their own public branches.  I don't think people will want
-to allow random strangers to create branches on their machine, so this
-probably means submitting the changes by email.  To form such a patch
-we need to know what branch point counts as "upstream", and who to
-send the patches to.  As a reasonable default, we might use the last
-time we branched and the last 
-
-Some of this should be better done in integration with e.g. mail
-clients or external robots or bug trackers. 
-
-Bazaar-NG allows redrafting rejected patches in an interesting way: 
-
-  Person writes a feature on a new feature branch.  They can commit
-  several times, merge up to date, even have sub-forks to an arbitrary
-  extent.  When they're ready, they submit their changes to the
-  maintainer, either by mailing the diffs relative to the main branch,
-  or by the maintainer pulling from their tree.   If they don't like
-  it, they can not commit it to their tree, and hopefully give some
-  feedback to the contributor.  (I don't think that feedback needs to
-  go back through the tool; email or some other communication
-  mechanism is probably fine.)  The contributor can then keep working
-  in their branch, until it eventually gets merged.
-
-  Alternatively, the maintainer might want to merge the change but fix
-  it up themselves.  We keep track of the fact that it was merged, and
-  the maintainer can make arbitrary fixups either in the course of
-  merging it or afterwards.  When the contributor later merges back
-  everything will work.
-
-  Another case is that the maintainer wants to improve the patch but
-  not take it into their main tree.  What they can do here is take it
-  into a separate feature branch, fix it up, and then ask the
-  contributor to merge back from there.
-
-Maintainers__ would also like to keep track of patches that have been
-submitted but not yet accepted, so they're not lost and can be
-updated.  One way to do this would be to create a branch on the
-maintainer's machine for a submitted patch, and apply the submission
-to that.  The maintainer can fix it if they want, or take updates to
-it.  The submitter can see what, if anything, was done.  Because this
-branch is identified by a URL it can be cited in bug reports, and it
-might make sense to name the branch by the bug it is supposed to fix.
-
-__ http://gcc.gnu.org/ml/gcc/2002-12/msg00444.html
-
-
-
-Aegis-style review and integration
-----------------------------------
-
-Some projects might want all changes to be submitted for review before
-merging onto the mainline.  This might be done either by convention,
-or perhaps by not allowing individual developers to merge to the
-mainline but rather having specific privileged integrators.
-
-Aegis_ enforces a lot of workflow/process; it would be good to be able
-to do something similar on top of bazaar-ng either manually or as a
-higher-level tool.  Aegis's model is that each proposed change is
-essentially on a branch that later merges into the mainline, which
-makes a lot of sense.
-
-.. _Aegis: compared-aegis.html
-
-To do something like Aegis, follow this process:
-
-* Developer makes a new branch from the trunk to develop a feature,
-  called say ``project--devel--bug-123``.
-
-* When they have almost finished development, they re-merge from the
-  trunk to make sure they're up to date.
-
-* By some mechanism they ask a reviewer to consider their changes --
-  perhaps by sending email, or using a bug tracking system, or
-  something else.  They tell the reviewer the location of their
-  branch, which might be on an HTTP server for a public project, or on
-  a directory on a shared server.
-
-* The reviewer makes a new branch for review based off the trunk,
-  ``project--review--bug-123``, and merges the development branch into
-  it.  The merge should be perfect if the developer was up to date
-  with the trunk.  If the merge fails they can either bounce it back
-  to the developer or fix the merge themselves according to local
-  policy or their own discretion.  They then review, build and test
-  the branch.  If it's OK, they commit to their review branch and send
-  a note asking for it to be integrated (or perhaps they integrate
-  themselves.)
-
-* The integrator merges from the review branch onto the trunk,
-  builds/tests and commits.  Since they pull from the reviewer's
-  branch there is no way unreviewed changes can sneak through even if
-  the developer adds to their work branch after the review.
-  
-  This can be done by a robot, or by a reviewer.
-
-* The developer can look at the review, integration and trunk branches
-  to see that their changes have merged.
-
-This model is practiced by some people at Canonical using tla.  Since
-people work within a complex configspec, they like very much to be
-able to branch in-place so that they do not need to rebuild the whole
-config to start new development.  (Though perhaps the real fix is to
-make assembling a config simpler...)

=== removed file 'doc/yaml.txt'
--- doc/yaml.txt	2005-11-07 13:17:53 +0000
+++ doc/yaml.txt	1970-01-01 00:00:00 +0000
@@ -1,40 +0,0 @@
-YAML
-****
-
-I am thinking about keeping changeset headers in YAML_, as a nice
-tradeoff:
-
- * Standard data format, so we don't need to invent, write and debug
-   an ad-hoc format.
-
- * More concise than XML, which is useful if we're storing a few.
-
- * Reasonably readable for humans; thus suitable for sending in email
-   and giving people at least some chance to read and understand it.
-   Seeing this at the top of a patch would not be actively horrible as
-   long as we keep it reasonably small; that's not true for XML.
-
- * Since YAML documents have a document header and terminator ('---'
-   and '...') we can pick them out of a text document and append
-   text patches directly afterwards.
-
- * Fits well with Python internal data structures.
-
- * There are parsers for various languages, so people can write their
-   own implementation if they really want.
-
- * There is space to specify a document format/version at the top
-   (though this is not currently handled in ydump).  
-
-The ydump module is pretty primitive, but it should have enough.
-
-.. _YAML: http://www.yaml.org/
-
-
-Conclusion
-----------
-
-On the whole, I think this is not a good idea.  It is a nicer syntax
-for XML, but there are less bindings, and it does not achieve the goal
-of having the storage format look reassuring and giving confidence
-that the data could be retrieved by an alternative implementation.
\ No newline at end of file

=== added file 'generate_docs.py'
--- generate_docs.py	1970-01-01 00:00:00 +0000
+++ generate_docs.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,93 @@
+#!/usr/bin/python
+
+# Copyright 2005 Canonical Ltd.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+"""%(prog)s - generate information from built-in bzr help
+
+%(prog)s creates a file with information on bzr in one of
+several different output formats:
+
+    man              man page
+    bash_completion  bash completion script
+    ...
+
+Examples: 
+
+    python2.4 generated-docs.py man
+    python2.4 generated-docs.py bash_completion
+
+Run "%(prog)s --help" for the option reference.
+"""
+
+import sys
+from optparse import OptionParser
+
+import tools.doc_generate
+
+def main(argv):
+    parser = OptionParser(usage="%prog [options] OUTPUT_FORMAT")
+
+    parser.add_option("-s", "--show-filename",
+                      action="store_true", dest="show_filename", default=False,
+                      help="print default filename on stdout")
+
+    parser.add_option("-o", "--output", dest="filename", metavar="FILE",
+                      help="write output to FILE")
+
+    parser.add_option("-b", "--bzr-name",
+                      dest="bzr_name", default="bzr", metavar="EXEC_NAME",
+                      help="name of bzr executable")
+
+    parser.add_option("-e", "--examples",
+                      action="callback", callback=print_extended_help,
+                      help="Examples of ways to call generate_doc")
+
+
+    (options, args) = parser.parse_args(argv)
+
+    if len(args) != 2:
+        parser.print_help()
+        sys.exit(1)
+
+    infogen_type = args[1]
+    infogen_mod = tools.doc_generate.get_module(infogen_type)
+
+    if options.filename:
+        outfilename = options.filename
+    else:
+        outfilename = infogen_mod.get_filename(options)
+
+    if outfilename == "-":
+        outfile = sys.stdout
+    else:
+        outfile = open(outfilename,"w")
+
+    if options.show_filename and (outfilename != "-"):
+        print >>sys.stdout, outfilename
+    
+    infogen_mod.infogen(options, outfile)
+
+def print_extended_help(option, opt, value, parser):
+    """ Program help examples
+
+    Prints out the examples stored in the docstring. 
+
+    """
+    print >>sys.stdout, __doc__ % {"prog":sys.argv[0]}
+    sys.exit(0)
+
+if __name__ == '__main__':
+    main(sys.argv)

=== removed file 'notes/inventory-v2-sample.xml'
--- notes/inventory-v2-sample.xml	2005-11-07 13:17:53 +0000
+++ notes/inventory-v2-sample.xml	1970-01-01 00:00:00 +0000
@@ -1,10 +0,0 @@
-<inventory>
-  <root>
-    <file name="readme.txt" id="readme-123" size="400" sha1="abcdef" 
-          revision="2050808"/>
-    <directory name="src" id="src-123"> 
-      <directory name="libwibble" id="libwibble-123">
-      </directory>
-    </directory>
-  </root>
-</inventory>
\ No newline at end of file

=== removed file 'notes/inventory-v2.rnc'
--- notes/inventory-v2.rnc	2005-11-07 13:17:53 +0000
+++ notes/inventory-v2.rnc	1970-01-01 00:00:00 +0000
@@ -1,30 +0,0 @@
-grammar {
-  file = element file {
-    attribute id { text },
-    attribute name { text }, 
-
-    # the following attributes are absent on the working-inventory
-    attribute sha1 { text }?,
-    attribute size { text }?,
-
-    attribute revision { text }?,
-
-    empty
-  }
-
-  directory = element directory {
-    attribute id { text },
-    attribute name { text },
-    
-    entry*
-  }
-
-  entry = 
-    (file | directory )
-
-  start = element inventory {
-    element root {
-      entry*
-    }
-  }
-}

=== removed file 'notes/new-inventory-sample.xml'
--- notes/new-inventory-sample.xml	2005-11-07 13:17:53 +0000
+++ notes/new-inventory-sample.xml	1970-01-01 00:00:00 +0000
@@ -1,108 +0,0 @@
-<?xml version="1.0"?>
-<inventory version="2">
-  <root_directory id="bogus-root-id">
-    <file id="bzrignore-20050311232317-81f7b71efa2db11a" name=".bzrignore" text_id="bzrignore-20050329080130-e781c2df6eadf795" text_sha1="0c5a363290308bfad3cf7c307dc95bf4e495a39d" text_size="81"/>
-    <file id="NEWS-20050323055033-4e00b5db738777ff" name="NEWS" text_id="NEWS-20050329080130-24324023f7567123" text_sha1="11823c9e5ee9da113c6eeb6baae32097ec9673cc" text_size="1419"/>
-    <file id="README-20050309040720-8f368abf9f346b9d" name="README" text_id="README-20050326030328-7adde2dfd2e0dbbb" text_sha1="b68ae05d135d67a400245ab3aa9806b6a28abe11" text_size="1019"/>
-    <file id="build-api-20050309064830-a0be0dc1452cda87" name="build-api" text_id="build-api-20050309064900-aa74414b35b5e281" text_sha1="450452fd581a1f1ba1fb4bec349f49a8e8a226b3" text_size="75"/>
-    <file id="bzr.py-20050313053754-5485f144c7006fa6" name="bzr" text_id="bzr-20050319081938-21c30193cb7b9e70" text_sha1="afde3aee636065c59d4af92fe035b9d7fbdf6cac" text_size="919"/>
-    <directory id="bzrlib-20050309040749-4ac9a0e211602846" name="bzrlib">
-      <file id="__init__.py-20050309040759-33e65acf91bbcd5d" name="__init__.py" text_id="__init__.py-20050328023935-fe6007f48dde344b" text_sha1="3f4bbd0540a1f6c3dfde11b65e59c11e266d779a" text_size="1485"/>
-      <file id="add.py-20050323030017-3a77d63feda58e33" name="add.py" text_id="add.py-20050327095302-b3edf909f0f81011" text_sha1="53ed9ff67fcc9e1af47d6a4d484fb75b385a6ed4" text_size="2905"/>
-      <file id="branch.py-20050309040759-e4baf4e0d046576e" name="branch.py" text_id="branch.py-20050326134153-f3dff98b574258fd" text_sha1="6a6e9163a74bbdaa3e842019b4cc7258aa80e7ad" text_size="27666"/>
-      <file id="check.py-20050309040759-f3a679400c06bcc1" name="check.py" text_id="check.py-20050329003252-a7262eda3a08f596" text_sha1="21c85347e72f617da56a621e77b30bf0f98a9f05" text_size="4136"/>
-      <file id="bzr.py-20050309040720-d10f4714595cf8c3" name="commands.py" text_id="commands.py-20050329114950-3ea1014fdadfe60e" text_sha1="ec9f6768ec4c729b58af4e08c11b18608a065b21" text_size="24888"/>
-      <file id="diff.py-20050309040759-26944fbbf2ebbf36" name="diff.py" text_id="diff.py-20050309040815-f0112c3b71bc202c" text_sha1="84729acb8afb74b285e635a7c09a38f63b14fee4" text_size="5290"/>
-      <file id="errors.py-20050309040759-20512168c4e14fbd" name="errors.py" text_id="errors.py-20050309040815-75b5f741f053d362" text_sha1="ca6731c62e3d746d1d0a90d9a4ff4c744ac98e83" text_size="1170"/>
-      <file id="info.py-20050323235939-6bbfe7d9700b0b9b" name="info.py" text_id="info.py-20050328024049-e66d2a23d130aa83" text_sha1="e331ce0bc51cfab9aa6eec18d7a1976e384b3a35" text_size="3304"/>
-      <file id="inventory.py-20050309040759-6648b84ca2005b37" name="inventory.py" text_id="inventory.py-20050329072929-15ad4d139ebe9368" text_sha1="87ecb4851198f1b41a397e2f9708376a69edde19" text_size="15054"/>
-      <file id="osutils.py-20050309040759-eeaff12fbf77ac86" name="osutils.py" text_id="osutils.py-20050329023134-4968f3ab1cb80d22" text_sha1="bec87e1bcdfc50cd8b2ee5c4f014d4a3650fb12a" text_size="7405"/>
-      <file id="revision.py-20050309040759-e77802c08f3999d5" name="revision.py" text_id="revision.py-20050312073831-a24ec3db352a0db5" text_sha1="f3013ccb7c45a9bb340328eced6dc4d11d0bc61e" text_size="2830"/>
-      <file id="store.py-20050309040759-164dc5173d6406c2" name="store.py" text_id="store.py-20050329012619-9187f36afe5f02fe" text_sha1="f8fe399336db9b608ec7d866a042c3c84e1f6212" text_size="5285"/>
-      <file id="tests.py-20050309040759-b2da7bf735c06b1f" name="tests.py" text_id="tests.py-20050326134153-0a5950308e43bf54" text_sha1="a1715e90a1a4568b1464a290057435c3ef4fdfaa" text_size="5574"/>
-      <file id="textui.py-20050309040759-5d0cebe09c528e7d" name="textui.py" text_id="textui.py-20050309040815-3605bf769ab4eaf1" text_sha1="a5cb825012e2b2e7797b25139e72d1240675c9de" text_size="1017"/>
-      <file id="trace.py-20050309040759-c8ed824bdcd4748a" name="trace.py" text_id="trace.py-20050328041243-e744e720fe028769" text_sha1="7ca91f974741f05b1ecda92fb2a9b06210e33da8" text_size="3549"/>
-      <file id="tree.py-20050309040759-9d5f2496be663e77" name="tree.py" text_id="tree.py-20050329080130-b62bcff71cd143be" text_sha1="fdf9556da1b2de8b6354aa5bd4c9813123835b96" text_size="13679"/>
-      <file id="xml.py-20050309040759-57d51586fdec365d" name="xml.py" text_id="xml.py-20050315051954-b18360320fd01696" text_sha1="ed94ba5b8af981d007e3ad06083cfe7cc1f1c172" text_size="1556"/>
-    </directory>
-    <directory id="doc-20050309044934-a811c79dd26eef58" name="doc">
-      <file id="Makefile-20050309064830-17b60435388a9520" name="Makefile" text_id="Makefile-20050328022353-1fac836fcad1c3ab" text_sha1="04c5ac50d22caa71223dce1c1723f4927c2eada4" text_size="192"/>
-      <file id="adoption.txt-20050309044946-816486d97a97c5c5" name="adoption.txt" text_id="adoption.txt-20050309045105-1a9c10fb45e803e8" text_sha1="d8a42556a2bf39fdde914ea496761df591e76b56" text_size="4504"/>
-      <file id="bitkeeper.txt-20050309044946-9e207c5bfce2670f" name="bitkeeper.txt" text_id="bitkeeper.txt-20050309045105-fd4be07e5b1e2776" text_sha1="4e33c092641f44a71cd96617e7a20f9e4b6386f6" text_size="898"/>
-      <file id="changelogs.txt-20050309044946-cdc40a9f9ddece03" name="changelogs.txt" text_id="changelogs.txt-20050309045105-f3425da69c90bc3f" text_sha1="650b8344a9e1af3afaa0b5d72b3775f036d9a54a" text_size="1320"/>
-      <file id="cherry-picking.txt-20050309044946-d14f736fdb588e8f" name="cherry-picking.txt" text_id="cherry-picking.txt-20050309045105-3ab30173396c9944" text_sha1="03832e529e9a319b0a2bf5a6157691d2025204aa" text_size="1632"/>
-      <file id="cmdref.txt-20050309044946-d9a444af4c8e2d8b" name="cmdref.txt" text_id="cmdref.txt-20050309045105-af9ab0e5f5d15df0" text_sha1="4b5b544493a96eaa24cda0e41602772591b085f2" text_size="25271"/>
-      <file id="common-format.txt-20050309044946-48fc9f627ac98c0a" name="common-format.txt" text_id="common-format.txt-20050309045105-82969da54b78f851" text_sha1="518e2a235b398bc0aa6e26a9a9bcaa227ce8d5eb" text_size="1092"/>
-      <file id="compared-aegis.txt-20050309044946-2c8b94a645654397" name="compared-aegis.txt" text_id="compared-aegis.txt-20050309045105-70ed007ce0982df5" text_sha1="a0f8e26276a435165d919a4d77eaca4871df88d9" text_size="4275"/>
-      <file id="compared-codeville.txt-20050309044946-1cb208cab910fa50" name="compared-codeville.txt" text_id="compared-codeville.txt-20050312085410-65820cfb547ac6ad" text_sha1="0e5452aae2c7d0dc2530a871df54564d09544bf4" text_size="4145"/>
-      <file id="compared-cvsnt.txt-20050309044946-5396218e1b8351fb" name="compared-cvsnt.txt" text_id="compared-cvsnt.txt-20050309045105-b2dd9d47ab90b632" text_sha1="491675da9b7cb26f222af6dcb2b00406fd06a4e6" text_size="816"/>
-      <file id="compared-opencm.txt-20050309044946-e7ddc908a19c87f5" name="compared-opencm.txt" text_id="compared-opencm.txt-20050309045105-92619d5a43a54851" text_sha1="957b510ff6e162b2b8a9ffd23478059c41ab3889" text_size="1220"/>
-      <file id="compared-prcs.txt-20050309044946-f7c399f458e1fb59" name="compared-prcs.txt" text_id="compared-prcs.txt-20050309045105-61f3870a3561bcae" text_sha1="b126391a028eac75db56b6c2d4a8fc65fd2287f1" text_size="1483"/>
-      <file id="compared-teamware.txt-20050309044946-8d9e164d94ba5a7c" name="compared-teamware.txt" text_id="compared-teamware.txt-20050309045105-1be6ce2995f6fe09" text_sha1="3c50a4d42a10b12d19590a4569a7ae80dbc2b43b" text_size="1123"/>
-      <file id="compression.txt-20050309044946-a73f1e60c40ee57d" name="compression.txt" text_id="compression.txt-20050309045105-033c43c42527006d" text_sha1="a7a0896daff05d98a0b44b29d332113854c25a4c" text_size="2453"/>
-      <file id="config-specs.txt-20050309044946-d9820c58b7f23437" name="config-specs.txt" text_id="config-specs.txt-20050309045105-6cd36c4900778e23" text_sha1="11ce81de2dce0e3e44c854cc607ccfeb009c14a3" text_size="1788"/>
-      <file id="conflicts.txt-20050309044946-b9f2aded67790400" name="conflicts.txt" text_id="conflicts.txt-20050309045105-b625f78a9d1aa3e9" text_sha1="f058f8352787dea8b41111a0a327f04daae76fad" text_size="1387"/>
-      <file id="costs.txt-20050309044946-57b65806cab34815" name="costs.txt" text_id="costs.txt-20050309045105-b164407881870dd5" text_sha1="1e15b93fae5ad627f256f8f4e44dbec7df9171c4" text_size="701"/>
-      <file id="darcs.txt-20050309044946-5dbd16bd2da081a4" name="darcs.txt" text_id="darcs.txt-20050323235210-62ff177fabaa5967" text_sha1="7db04d391bc6eb074ce5c2a705877d006d923190" text_size="2638"/>
-      <file id="deadly-sins.txt-20050309044946-b0453a1c48093054" name="deadly-sins.txt" text_id="deadly-sins.txt-20050309045105-38cb25a50d3b1157" text_sha1="00566c41dc686ce45e8b58c88afb34611b15ef6c" text_size="1585"/>
-      <file id="default.css-20050309064830-2b764767f5f259c8" name="default.css" text_id="default.css-20050309064900-d96676d92f48fd8c" text_sha1="7bcb9fe51bc6c900862cd7567bb8458cb9526644" text_size="3962"/>
-      <file id="design.txt-20050309044946-54973dca2e7aa16b" name="design.txt" text_id="design.txt-20050309045105-88fecfcf589e6fd6" text_sha1="841a4f912b726e7f0f6cb9e6c062e2703bdf6635" text_size="41787"/>
-      <file id="extra-commands.txt-20050309044946-74af949c5805df22" name="extra-commands.txt" text_id="extra-commands.txt-20050309045105-9c07bdbe483793bd" text_sha1="20472f13679beddf9366dbf218bea3cb90d00509" text_size="695"/>
-      <file id="faq.txt-20050309044946-87b18fde82cf414a" name="faq.txt" text_id="faq.txt-20050309045105-adc8655244525a7a" text_sha1="88713c58c3162cbedfd14c57469829aec6041b58" text_size="231"/>
-      <file id="formats.txt-20050309044946-7ea328cdb5cae6c5" name="formats.txt" text_id="formats.txt-20050322000245-4982990c48231f44" text_sha1="55106e6b47f6966dc5b3b72bfc2f3573bd2eb8d0" text_size="8161"/>
-      <file id="hashes.txt-20050309044946-7a7382d0d715151f" name="hashes.txt" text_id="hashes.txt-20050309045105-63587dc15501b6d2" text_sha1="c4d42f8209bec59ef8fb90b730f6d06448e27efe" text_size="2560"/>
-      <file id="ignore.txt-20050328001329-d89006518f61dd00" name="ignore.txt" text_id="ignore.txt-20050328022418-43a7fd05366b06f2" text_sha1="0e45bf3560ed78053ec7b088c11173aa08195ef0" text_size="654"/>
-      <file id="index.txt-20050309044946-be91bf1c15711e5f" name="index.txt" text_id="index.txt-20050328001404-0eab78b497aeade5" text_sha1="00c098809e185488d567226d48c49df498c0cdc1" text_size="5790"/>
-      <file id="interrupted.txt-20050309044946-b6074892ab231e63" name="interrupted.txt" text_id="interrupted.txt-20050309045105-fd981a331efdf680" text_sha1="0ca1b2820e2c99656315211ccd70f5a8a52a2898" text_size="4293"/>
-      <file id="intro.txt-20050309044946-5bb22ffbfa8bfc14" name="intro.txt" text_id="intro.txt-20050309045105-d98d5268094fa375" text_sha1="b97bea4c5baf0a826683fe2ce0b823f8f9a608c2" text_size="3379"/>
-      <file id="inventory.txt-20050309044946-07534ab6d8b3c324" name="inventory.txt" text_id="inventory.txt-20050309045105-fa6637d533fd707e" text_sha1="c4c2fb6973502b1a4b18ab53332cb727c465c340" text_size="312"/>
-      <file id="join-branches.txt-20050309044946-f635037a889c0388" name="join-branches.txt" text_id="join-branches.txt-20050309045105-fea7e1f5b49b41c2" text_sha1="b8148e34e1546e83acf1ed32f4ec4bb4cc3502ae" text_size="3260"/>
-      <file id="kill-version.txt-20050309044946-1b9d175ca38c872c" name="kill-version.txt" text_id="kill-version.txt-20050309045105-ff4fe197ed67a40d" text_sha1="65084715a68dc4a22f60ed46cfa1c81441f14100" text_size="3560"/>
-      <file id="layers.txt-20050309044946-a48f19d7e271ec87" name="layers.txt" text_id="layers.txt-20050309045105-cd42b07df59a768d" text_sha1="34f97443035d3f286a136eaf485169b355483efa" text_size="2867"/>
-      <file id="library-interface.txt-20050309044946-97a60acc594383cc" name="library-interface.txt" text_id="library-interface.txt-20050309045105-27a374e4890d74c9" text_sha1="d5c6c86b8dcbcc0a06f01ddb680466d19e0e2329" text_size="326"/>
-      <file id="merge.txt-20050309044946-5d1ff42572fb3086" name="merge.txt" text_id="merge.txt-20050309045105-495a4a5b8553fe6f" text_sha1="f95f7a04bca711cab1ca528a79ba3174275b95dd" text_size="758"/>
-      <file id="mirroring.txt-20050309044946-eb411f73887829b1" name="mirroring.txt" text_id="mirroring.txt-20050309045105-63ff2af43ce824c7" text_sha1="f9473f6f98e5d139af3489169459b33f238c6d09" text_size="393"/>
-      <file id="monotone.txt-20050309044946-dd2abf24d99d201f" name="monotone.txt" text_id="monotone.txt-20050309045105-8fb6ac30e651a5b8" text_sha1="0b3c1d7d437ceb3b4f9964bae9846b5aa3a69953" text_size="595"/>
-      <file id="news.txt-20050309044946-02b97194f31e86e0" name="news.txt" text_id="news.txt-20050309045105-e3cc2094a8bd32ac" text_sha1="709e86f1545aaf38d2caed6db3b150ac65a72a55" text_size="4434"/>
-      <file id="optional-edit.txt-20050309044946-eddc8e1d07ae10a8" name="optional-edit.txt" text_id="optional-edit.txt-20050309045105-9c7c7616d9ed5c58" text_sha1="c5bbe7b8d2cd7ed53c3a4e989213915a3419654d" text_size="951"/>
-      <file id="partial-commit.txt-20050309044946-76fa39222d4fcc58" name="partial-commit.txt" text_id="partial-commit.txt-20050309045105-ebd00caf089392ea" text_sha1="4a4825f373c3d6ccb1614d8c9a717bdc23267603" text_size="880"/>
-      <file id="pool.txt-20050309044946-4a2400814cb5087a" name="pool.txt" text_id="pool.txt-20050309045105-a146ad389b36ecef" text_sha1="68002fb614f9f22e07774f259d54e0e17f361b3d" text_size="2930"/>
-      <file id="purpose.txt-20050309044946-a4132525edac8d4c" name="purpose.txt" text_id="purpose.txt-20050321222949-ba749c2169e3dba0" text_sha1="711070a417d92af93d99430a478c593e6565dfe3" text_size="3145"/>
-      <file id="python.txt-20050309044946-9eeeab2c3546abe6" name="python.txt" text_id="python.txt-20050309045105-73f03ec782191b18" text_sha1="067a8357e841178ec89dbb76073c0c429e7633a8" text_size="4230"/>
-      <file id="quickref.txt-20050309044946-e118485499fadee0" name="quickref.txt" text_id="quickref.txt-20050309045105-af9c9832b3ab7fec" text_sha1="30f46dd441dbbd797e4dd111e106071bc24423de" text_size="549"/>
-      <file id="quilt.txt-20050309044946-00df099b997fed5e" name="quilt.txt" text_id="quilt.txt-20050309045105-f9eb948a305b247f" text_sha1="3d8613f245558097d280b756eec3cd2e19fbaa36" text_size="253"/>
-      <file id="random.txt-20050309044946-269c29512b381f5b" name="random.txt" text_id="random.txt-20050321222949-4cbd779bfebd936a" text_sha1="0c9400360472e0305b120dbbebf12788880f7ceb" text_size="8529"/>
-      <file id="requirements.txt-20050309044946-f01e5318ade63900" name="requirements.txt" text_id="requirements.txt-20050309045105-91208951f02f4d5c" text_sha1="7118ac308a4799ed8146c94fb5fd9dde2cf2789d" text_size="1030"/>
-      <file id="revision-syntax.txt-20050309044946-86b3a8e902a15fa4" name="revision-syntax.txt" text_id="revision-syntax.txt-20050309045105-ca2db9854ac402c0" text_sha1="c84b833a1dd795f4a65b9adabfdc9b3fb1159112" text_size="2445"/>
-      <file id="roadmap.txt-20050309044946-fd8a18ed2f6049f1" name="roadmap.txt" text_id="roadmap.txt-20050309045105-aa821d48d65a3646" text_sha1="86d8823ae029e7617a5527597602412c5aed744f" text_size="1480"/>
-      <file id="rollup.txt-20050309044946-e551f4f85db5a5a0" name="rollup.txt" text_id="rollup.txt-20050309045105-5801a84a4015957e" text_sha1="25d713bab1a5abc198358fedf6a414a00bf3f0df" text_size="2640"/>
-      <file id="scalability.txt-20050309044946-646ac26c7fd65298" name="scalability.txt" text_id="scalability.txt-20050309045105-572fbf8f67f12009" text_sha1="50b3aadd75b7478e68adc7818733783730d8ac3f" text_size="650"/>
-      <file id="security.txt-20050309044946-41f7c6000b1124d0" name="security.txt" text_id="security.txt-20050309045105-68e6d4d9a4574959" text_sha1="cb20cb44a6d5e421721396cf1ab5c648dd4d72ae" text_size="14662"/>
-      <file id="shared-branches.txt-20050309044946-20521acf9bda9528" name="shared-branches.txt" text_id="shared-branches.txt-20050309045105-7cbd7b176765a7b5" text_sha1="1b7eaedcaed0af15f431a398366b5a4f58a17927" text_size="5834"/>
-      <file id="short-demo.txt-20050309044946-2145761a6909b03e" name="short-demo.txt" text_id="short-demo.txt-20050309045105-acdbb8f1a3cde539" text_sha1="d5d95a0760231aa75584669546b1b29de26696f7" text_size="5732"/>
-      <file id="supportability.txt-20050309044946-92aeba826c90201b" name="supportability.txt" text_id="supportability.txt-20050309045105-3b42b97911c05906" text_sha1="2a393e5c052cfd6aafdec621185fd7415ef1152f" text_size="841"/>
-      <file id="svk.txt-20050309044946-c62acd7cee590d22" name="svk.txt" text_id="svk.txt-20050309045105-dec97635b569da41" text_sha1="a485ca74f87cc0baca211c8344bf31c11ee87389" text_size="422"/>
-      <file id="tagging.txt-20050309044946-66adf967ad987472" name="tagging.txt" text_id="tagging.txt-20050309045105-3477d840eb290fe3" text_sha1="39da37ca4d619169492365c917452127074e4aeb" text_size="3135"/>
-      <file id="taxonomy.txt-20050309044946-922fe1158868767f" name="taxonomy.txt" text_id="taxonomy.txt-20050309045105-d0be06847dc3a1ff" text_sha1="0ce01e87ad97edc9d25ba3c5b45dad4cad6b2084" text_size="1819"/>
-      <file id="testing.txt-20050309044946-ea100200833c223a" name="testing.txt" text_id="testing.txt-20050309045105-a7b901188c51574b" text_sha1="633cab6bde0535401ac9eabead45d96c90e600bc" text_size="773"/>
-      <file id="thanks.txt-20050309044946-58141ea3091846d8" name="thanks.txt" text_id="thanks.txt-20050319014144-66b28b029f489391" text_sha1="c5ad6319f69f8e31d15bc36d4522a036493f6bd3" text_size="420"/>
-      <file id="todo-from-arch.txt-20050309044946-4cb8ccdf8b3fcd07" name="todo-from-arch.txt" text_id="todo-from-arch.txt-20050309045105-a0d73cedaa3cb912" text_sha1="fa95080711fd9a116643867d6e7b7dbd6458c01e" text_size="13588"/>
-      <file id="unchanged.txt-20050309044946-fe7d1ec585585702" name="unchanged.txt" text_id="unchanged.txt-20050309045105-b4a697341c602735" text_sha1="db90f5d3210f1392f45c27ba8eb3528847f9ee02" text_size="3920"/>
-      <file id="unrelated-merge.txt-20050309044946-ec165531264f1c99" name="unrelated-merge.txt" text_id="unrelated-merge.txt-20050309045105-dbe2b17d18728121" text_sha1="62b6d77942c44f16951219e7838f56f13dd0ae37" text_size="310"/>
-      <file id="usability.txt-20050309044946-57e59739a429628b" name="usability.txt" text_id="usability.txt-20050309045105-e9515f46e755dc0f" text_sha1="692295f407ced0cbad7bc2af2d42ae2aa4f2bec2" text_size="104"/>
-      <file id="use-cases.txt-20050309044946-19871d18448c91fc" name="use-cases.txt" text_id="use-cases.txt-20050309045105-c18c9210fa9c667b" text_sha1="4463f0219146a6d18801d8c90e046b8ce338662b" text_size="2679"/>
-      <file id="web-interface.txt-20050309044946-65ca85c7f551bf88" name="web-interface.txt" text_id="web-interface.txt-20050309045105-28c3ac23357d1194" text_sha1="90dcbc996c2d0187c774732c3947010e27204646" text_size="1024"/>
-      <file id="work-order.txt-20050309044946-4cfe50fc6e5258fe" name="work-order.txt" text_id="work-order.txt-20050309045105-fe2baee64418083c" text_sha1="c03413dbaff3e33536b02e7e41dc52ced07037c3" text_size="1778"/>
-      <file id="workflow.txt-20050309044946-d214d0e0429e719e" name="workflow.txt" text_id="workflow.txt-20050309045105-05ebdf3422fdcef6" text_sha1="69429a38371b5d3b6b850beb373467b4e6943a3b" text_size="5225"/>
-      <file id="yaml.txt-20050309044946-8d597bdf670d9095" name="yaml.txt" text_id="yaml.txt-20050309045105-65f6ca2247754aef" text_sha1="7d9b5a23639d0f1a03c97f983f17b41b79142db0" text_size="1376"/>
-    </directory>
-    <directory id="elementtree-20050323061618-ec49a4621bc7e4f4" name="elementtree">
-      <file id="ElementTree.py-20050323061623-cfa8eefe86f35391" name="ElementTree.py" text_id="ElementTree.py-20050323062555-7c291904c45fd0b9" text_sha1="aa97bbce740f09213293096bd1a9b8085999048b" text_size="36765"/>
-      <file id="__init__.py-20050323061623-61888e93152e298d" name="__init__.py" text_id="__init__.py-20050323062555-2183ef6f9f77dc96" text_sha1="6ecf754d86258e81ad6f76b01059dbd500cb3bfb" text_size="1491"/>
-    </directory>
-    <directory id="notes-20050309064844-c41b58b77e2b0876" name="notes">
-      <file id="performance.txt-20050309064844-d9647fd301942365" name="performance.txt" text_id="performance.txt-20050329114950-6c0e608dfda43e40" text_sha1="2598fc4b749b2e3d0ac12a44eff4a1fba48cf786" text_size="9288"/>
-    </directory>
-    <file id="setup.py-20050314065409-02f8a0a6e3f9bc70" name="setup.py" text_id="setup.py-20050314070724-fbe6913928cfa373" text_sha1="4a08c1c4b5d08bdec22d450e43686b12cf0cc210" text_size="472"/>
-  </root_directory>
-</inventory>

=== removed file 'notes/performance.txt'
--- notes/performance.txt	2005-11-07 13:17:53 +0000
+++ notes/performance.txt	1970-01-01 00:00:00 +0000
@@ -1,321 +0,0 @@
-For a tree holding 2.4.18 (two copies), 2.4.19, 2.4.20
-
-With gzip -9:
-
-mbp@hope% du .bzr
-195110  .bzr/text-store
-20      .bzr/revision-store
-12355   .bzr/inventory-store
-216325  .bzr
-mbp@hope% du -s .
-523128  .
-
-Without gzip:
-
-This is actually a pretty bad example because of deleting and
-re-importing 2.4.18, but still not totally unreasonable.
-
-----
-
-linux-2.4.0: 116399 kB
-after addding everything: 119505kB
-bzr status  2.68s user 0.13s system 84% cpu 3.330 total
-bzr commit 'import 2.4.0'  4.41s user 2.15s system 11% cpu 59.490 total
-
-242446  .
-122068  .bzr
-
-
-----
-
-Performance (2005-03-01)
-
-To add all files from linux-2.4.18: about 70s, mostly inventory
-serialization/deserialization.
-
-To commit:
-- finished, 6.520u/3.870s cpu, 33.940u/10.730s cum
--     134.040 elapsed
-
-Interesting that it spends so long on external processing!  I wonder
-if this is for running uuidgen?  Let's try generating things
-internally.
-
-Great, this cuts it to 17.15s user 0.61s system 83% cpu 21.365 total
-to add, with no external command time.  The commit now seems to spend
-most of its time copying to disk.
-
-- finished, 6.550u/3.320s cpu, 35.050u/9.870s cum
--     89.650 elapsed
-
-I wonder where the external time is now?  We were also using uuids()
-for revisions.
-
-Let's remove everything and re-add.  Detecting everything was removed
-takes 
-- finished, 2.460u/0.110s cpu, 0.000u/0.000s cum
--     3.430 elapsed
-
-which may be mostly XML deserialization?
-
-Just getting the previous revision takes about this long:
-
-bzr invoked at Tue 2005-03-01 15:53:05.183741 EST +1100
-  by mbp@sourcefrog.net on hope
-  arguments: ['/home/mbp/bin/bzr', 'get-revision-inventory', 'mbp@sourcefrog.net-20050301044608-8513202ab179aff4-44e8cd52a41aa705']
-  platform: Linux-2.6.10-4-686-i686-with-debian-3.1
-- finished, 3.910u/0.390s cpu, 0.000u/0.000s cum
--     6.690 elapsed
-
-Now committing the revision which removes all files should be fast.
-
-- finished, 1.280u/0.030s cpu, 0.000u/0.000s cum
--     1.320 elapsed
-
-Now re-add with new code that doesn't call uuidgen:
-
-- finished, 1.990u/0.030s cpu, 0.000u/0.000s cum
--     2.040 elapsed
-
-16.61s user 0.55s system 74% cpu 22.965 total
-
-Status::
-
-  - finished, 2.500u/0.110s cpu, 0.010u/0.000s cum
-  -     3.350 elapsed
-
-And commit::
-
-Now patch up to 2.4.19.  There were some bugs in handling missing
-directories, but with that fixed we do much better::
-
-  bzr status  5.86s user 1.06s system 10% cpu 1:05.55 total
-
-This is slow because it's diffing every file; we should use mtimes etc
-to make this faster.  The cpu time is reasonable.
-
-I see difflib is pure Python; it might be faster to shell out to GNU
-diff when we need it.
-
-Export is very fast::
-
-  - finished, 4.220u/1.480s cpu, 0.010u/0.000s cum
-  -     10.810 elapsed
-
-  bzr export 1 ../linux-2.4.18.export1  3.92s user 1.72s system 21% cpu 26.030 total
-
-
-Now to find and add the new changes::
-
-  - finished, 2.190u/0.030s cpu, 0.000u/0.000s cum
-  -     2.300 elapsed
-
-
-:: 
-  bzr commit 'import 2.4.19'  9.36s user 1.91s system 23% cpu 47.127 total
-
-And the result is exactly right.  Try exporting::
-
-  mbp@hope%  bzr export 4 ../linux-2.4.19.export4
-  bzr export 4 ../linux-2.4.19.export4  4.21s user 1.70s system 18% cpu 32.304 total
-
-and the export is exactly the same as the tarball.
-
-Now we can optimize the diff a bit more by not comparing files that
-have the right SHA-1 from within the commit
-
-For comparison::
-
-  patch -p1 < ../kernel.pkg/patch-2.4.20  1.61s user 1.03s system 13% cpu 19.106 total
-
-
-Now status after applying the .20 patch.  With full-text verification::
-
-  bzr status  7.07s user 1.32s system 13% cpu 1:04.29 total
-
-with that turned off::
-
-  bzr status  5.86s user 0.56s system 25% cpu 25.577 total
-
-After adding:
-
-  bzr status  6.14s user 0.61s system 25% cpu 26.583 total
-
-Should add some kind of profile counter for quick compares vs slow
-compares.
-
-  bzr commit 'import 2.4.20'  7.57s user 1.36s system 20% cpu 43.568
-  total
-
-export:  finished, 3.940u/1.820s cpu, 0.000u/0.000s cum,  50.990 elapsed
-
-also exports correctly
-
-now .21
-
-bzr commit 'import 2.4.1'  5.59s user 0.51s system 60% cpu 10.122 total
-
-265520  .
-137704  .bzr
-
-import 2.4.2
-317758  .
-183463  .bzr
-
-
-with everything through to 2.4.29 imported, the .bzr directory is
-1132MB, compared to 185MB for one tree.  The .bzr.log is 100MB!.  So
-the storage is 6.1 times larger, although we're holding 30 versions.
-It's pretty large but I think not ridiculous.  By contrast the tarball
-for 2.4.0 is 104MB, and the tarball plus uncompressed patches are
-315MB.
-
-Uncompressed, the text store is 1041MB.  So it is only three times
-worse than patches, and could be compressed at presumably roughly
-equal efficiency.  It is large, but also a very simple design and
-perhaps adequate for the moment.  The text store with each file
-individually gziped is 264MB, which is also a very simple format and
-makes it less than twice the size of the source tree.
-
-This is actually rather pessimistic because I think there are some
-orphaned texts in there.
-
-Measured by du, the compressed full-text store is 363MB; also probably
-tolerable.
-
-The real fix is perhaps to use some kind of weave, not so much for
-storage efficiency as for fast annotation and therefore possible
-annotation-based merge.
-
------
-
-
-2005-03-25
-
-Now we have recursive add, add is much faster.  Adding all of the
-linux 2.4.19 kernel tree takes only 
-
-finished, 5.460u/0.610s cpu, 0.010u/0.000s cum, 6.710 elapsed
-
-
-However, the store code currently flushes to disk after every write,
-which is probably excessive.  So a commit takes
-
-finished, 8.740u/3.950s cpu, 0.010u/0.000s cum, 156.420 elapsed
-
-
-Status is now also quite fast, depsite that it still has to read all
-the working copies:
-
-mbp@hope% bzr status                                                            ~/work/linux-2.4.19
-bzr status  5.51s user 0.79s system 99% cpu 6.337 total
-
-strace shows much of this is in write(2), probably because of
-logging.  With more buffering on that file, removing all the explicit
-flushes, that is reduced to 
-
-mbp@hope% time bzr status  
-bzr status  5.23s user 0.42s system 97% cpu 5.780 total
-
-which is mostly opening, stating and reading files, as it should be.
-Still a few too many stat calls.
-
-Now fixed up handling of root directory.
-
-Without flushing everything to disk as it goes into the store:
-
-mbp@hope% bzr commit -m 'import linux 2.4.19'
-bzr commit -m 'import linux 2.4.19'  8.15s user 2.09s system 53% cpu 19.295 total
-
-mbp@hope% time bzr diff
-bzr diff  5.80s user 0.52s system 69% cpu 9.128 total
-mbp@hope% time bzr status
-bzr status  5.64s user 0.43s system 68% cpu 8.848 total
-
-patch -p1 < ../linux.pkg/patch-2.4.20  1.67s user 0.96s system 90% cpu 2.905 total
-
-The diff changes 3462 files according to diffstat.
-
-branch format: Bazaar-NG branch, format 0.0.4
-
-in the working tree:
-   8674 unchanged
-   2463 modified
-    818 added
-    229 removed
-      0 renamed
-      0 unknown
-      4 ignored
-    614 versioned subdirectories
-
-That is, 3510 entries have changed, but there are 48 changed
-directories so the count is exactly right!
-
-bzr commit -v -m 'import 2.4.20'  8.23s user 1.09s system 48% cpu 19.411 total
-
-Kind of strange that this takes as much time as committing the whole
-thing; I suppose it has to read every file.  
-
-This shows many files as being renamed; I don't know why that would
-be.
-
-
-Patch to 2.4.21:
-
- 2969 files changed, 366643 insertions(+), 147759 deletions(-)
-
-After auto-add:
-
- 2969 files changed, 372168 insertions(+), 153284 deletions(-)
-
-I wonder why it is not exactly the same?  Maybe because the python
-diff algorithm is a bit differnt to GNU diff.
-
-----
-
-2005-03-29  
-
-full check, retrieving all file texts once for the 2.4 kernel branch
-takes 10m elapsed, 1m cpu time.  lots of random IO and seeking.
-
-----
-
-
-mbp@hope% time python =bzr deleted --show-ids 
-README                                             README-fa1d8447b4fd0140-adbf4342752f0fc3
-python =bzr deleted --show-ids  1.55s user 0.09s system 96% cpu 1.701 total
-mbp@hope% time python -O =bzr deleted --show-ids 
-README                                             README-fa1d8447b4fd0140-adbf4342752f0fc3
-python -O =bzr deleted --show-ids  1.47s user 0.10s system 101% cpu 1.547 total
-mbp@hope% time python -O =bzr deleted --show-ids
-README                                             README-fa1d8447b4fd0140-adbf4342752f0fc3
-python -O =bzr deleted --show-ids  1.49s user 0.07s system 99% cpu 1.565 total
-mbp@hope% time python =bzr deleted --show-ids   
-README                                             README-fa1d8447b4fd0140-adbf4342752f0fc3
-python =bzr deleted --show-ids  1.55s user 0.08s system 99% cpu 1.637 total
-
-small but significant improvement from Python -O
-
-----
-
-Loading a large inventory through cElementTree is pretty quick; only
-about 0.117s.  By contrast reading the inventory into our data
-structure takes about 0.7s.  
-
-So I think the problem must be in converting everything to
-InventoryEntries and back again every time.
-
-Thought about that way it seems pretty inefficient: why create all
-those objects when most of them aren't called on most invocations?
-Instead perhaps the Inventory object should hold the ElementTree and
-pull things out of it only as necessary?  We can even have an index
-pointing into the ElementTree by id, path, etc.
-
-
-as of r148
-
-bzr deleted  1.46s user 0.08s system 98% cpu 1.561 total
-
-
-Alternatively maybe keep an id2path and path2id cache?  Keeping it
-coherent may be hard...

=== removed file 'notes/revfile.txt'
--- notes/revfile.txt	2005-11-07 13:17:53 +0000
+++ notes/revfile.txt	1970-01-01 00:00:00 +0000
@@ -1,45 +0,0 @@
-importing all inventories:
-
-with 50% chance of choosing earlier parent:
-
--rw-r--r--  1 mbp mbp 296961 2005-04-09 22:37 inventory.drev
--rw-r--r--  1 mbp mbp  11184 2005-04-09 22:37 inventory.irev
-
-imported in 2.490s
-
-
-with no chance:
-
-clearly slows down, 11.163s to import
-
--rw-r--r--  1 mbp mbp 63590 2005-04-09 22:39 inventory.drev
--rw-r--r--  1 mbp mbp 11184 2005-04-09 22:39 inventory.irev
-
-
-
-with 25% chance:
-
-revfile.py add-series inventory 0 mbp*  7.86s user 0.12s system 96% cpu 8.247 total
--rw-r--r--  1 mbp mbp 79535 2005-04-09 22:42 inventory.drev
--rw-r--r--  1 mbp mbp 11184 2005-04-09 22:42 inventory.irev
-
-
-
-with full text inserted every 20 revisions:
-
-revfile.py add-series inventory 0 mbp*  1.98s user 0.06s system 95% cpu 2.139 total
-
--rw-r--r--  1 mbp mbp 133719 2005-04-09 22:44 inventory.drev
--rw-r--r--  1 mbp mbp  11184 2005-04-09 22:44 inventory.irev
-
-So pretty quick, simple, and somewhat easily justified.
-
-
-
-every 50 revisions:
-
-revfile.py add-series inventory 0 mbp*  3.35s user 0.08s system 93% cpu 3.667 total
-
--rw-r--r--  1 mbp mbp 91895 2005-04-09 22:46 inventory.drev
--rw-r--r--  1 mbp mbp 11184 2005-04-09 22:46 inventory.irev
-

=== removed file 'notes/schemas.xml'
--- notes/schemas.xml	2005-11-07 13:17:53 +0000
+++ notes/schemas.xml	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
-<?xml version="1.0"?>
-<locatingRules xmlns="http://thaiopensource.com/ns/locating-rules/1.0">
-  <uri resource="inventory-v2-sample.xml" uri="inventory-v2.rnc"/>
-</locatingRules>

=== removed directory 'patches'
=== modified file 'setup.py'
--- setup.py	2006-01-25 14:30:06 +0000
+++ setup.py	2006-03-20 08:31:00 +0000
@@ -73,8 +73,8 @@
     def run(self):
         build.run(self)
 
-        import bzr_man
-        bzr_man.main()
+        import generate_docs
+        generate_docs.main(argv=["bzr", "man"])
 
 ########################
 ## Setup
@@ -88,6 +88,8 @@
       description='Friendly distributed version control system',
       license='GNU GPL v2',
       packages=['bzrlib',
+                'bzrlib.doc',
+                'bzrlib.doc.api',
                 'bzrlib.export',
                 'bzrlib.plugins',
                 'bzrlib.store',
@@ -103,4 +105,5 @@
       scripts=['bzr'],
       cmdclass={'install_scripts': my_install_scripts, 'build': bzr_build},
       data_files=[('man/man1', ['bzr.1'])],
+    #   todo: install the txt files from bzrlib.doc.api.
      )

=== added file 'tools/__init__.py'
=== added directory 'tools/doc_generate'
=== added file 'tools/doc_generate/__init__.py'
--- tools/doc_generate/__init__.py	1970-01-01 00:00:00 +0000
+++ tools/doc_generate/__init__.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,32 @@
+#!/usr/bin/python
+
+# Copyright 2005 Canonical Ltd.
+# Written by Hans Ulrich Niedermann
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""tools/doc_generate/__init__.py - main program for bzr information generation stuff"""
+
+import sys
+
+
+def get_module(target):
+    mod_name = "tools.doc_generate.autodoc_%s" % (target)
+    mod = __import__(mod_name)
+    components = mod_name.split('.')
+    for comp in components[1:]:
+        mod = getattr(mod, comp)
+    return mod
+

=== added file 'tools/doc_generate/autodoc_bash_completion.py'
--- tools/doc_generate/autodoc_bash_completion.py	1970-01-01 00:00:00 +0000
+++ tools/doc_generate/autodoc_bash_completion.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,54 @@
+# Copyright 2005 Canonical Ltd.
+# Written by Hans Ulrich Niedermann
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"bash_completion.py - create bash completion script from built-in bzr help"
+
+import os
+import sys
+import time
+
+import bzrlib
+import bzrlib.help
+import bzrlib.commands
+
+
+def get_filename(options):
+    return "%s.bash_completion" % (options.bzr_name)
+
+
+def infogen(options, outfile):
+    t = time.time()
+    tt = time.gmtime(t)
+    params = \
+           { "bzrcmd": options.bzr_name,
+             "datestamp": time.strftime("%Y-%m-%d",tt),
+             "timestamp": time.strftime("%Y-%m-%d %H:%M:%S +0000",tt),
+             "version": bzrlib.__version__,
+             }
+
+    outfile.write(preamble % params)
+
+
+preamble = """\
+# bash completion functions for for %(bzrcmd)s (bazaar-ng)
+#
+# Large parts of this file are autogenerated from the internal
+# bazaar-ng documentation and data structures.
+#
+# Generation time: %(timestamp)s
+"""
+

=== added file 'tools/doc_generate/autodoc_man.py'
--- tools/doc_generate/autodoc_man.py	1970-01-01 00:00:00 +0000
+++ tools/doc_generate/autodoc_man.py	2006-03-20 08:31:00 +0000
@@ -0,0 +1,195 @@
+# Copyright 2005 Canonical Ltd.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""man.py - create man page from built-in bzr help and static text
+
+TODO:
+  * use usage information instead of simple "bzr foo" in COMMAND OVERVIEW
+  * add command aliases
+"""
+
+import os
+import sys
+import textwrap
+import time
+
+import bzrlib
+import bzrlib.help
+import bzrlib.commands
+
+
+def get_filename(options):
+    """Provides name of manpage"""
+    return "%s.1" % (options.bzr_name)
+
+
+def infogen(options, outfile):
+    """Assembles a man page"""
+    t = time.time()
+    tt = time.gmtime(t)
+    params = \
+           { "bzrcmd": options.bzr_name,
+             "datestamp": time.strftime("%Y-%m-%d",tt),
+             "timestamp": time.strftime("%Y-%m-%d %H:%M:%S +0000",tt),
+             "version": bzrlib.__version__,
+             }
+    outfile.write(man_preamble % params)
+    outfile.write(man_escape(man_head % params))
+    outfile.write(man_escape(getcommand_list(params)))
+    outfile.write(man_escape(getcommand_help(params)))
+    outfile.write(man_escape(man_foot % params))
+
+
+def man_escape(string):
+    """Escapes strings for man page compatibility"""
+    result = string.replace("\\","\\\\")
+    result = result.replace("`","\\`")
+    result = result.replace("'","\\'")
+    result = result.replace("-","\\-")
+    return result
+
+
+def command_name_list():
+    """Builds a list of command names from bzrlib"""
+    command_names = bzrlib.commands.builtin_command_names()
+    command_names.sort()
+    return command_names
+
+
+def getcommand_list (params):
+    """Builds summary help for command names in manpage format"""
+    bzrcmd = params["bzrcmd"]
+    output = '.SH "COMMAND OVERVIEW"\n'
+    for cmd_name in command_name_list():
+        cmd_object = bzrlib.commands.get_cmd_object(cmd_name)
+        if cmd_object.hidden:
+            continue
+        cmd_help = cmd_object.help()
+        if cmd_help:
+            firstline = cmd_help.split('\n', 1)[0]
+            usage = bzrlib.help.command_usage(cmd_object)
+            tmp = '.TP\n.B "%s"\n%s\n' % (usage, firstline)
+            output = output + tmp
+        else:
+            raise RuntimeError, "Command '%s' has no help text" % (cmd_name)
+    return output
+
+
+def getcommand_help(params):
+    """Shows individual options for a bzr command"""
+    output='.SH "COMMAND REFERENCE"\n'
+    for cmd_name in command_name_list():
+        cmd_object = bzrlib.commands.get_cmd_object(cmd_name)
+        if cmd_object.hidden:
+            continue
+        output = output + format_command(params, cmd_object)
+    return output
+
+
+def format_command (params, cmd):
+    """Provides long help for each public command"""
+    subsection_header = '.SS "%s"\n' % (bzrlib.help.command_usage(cmd))
+    doc = "%s\n" % (cmd.__doc__)
+    docsplit = cmd.__doc__.split('\n')
+    doc = '\n'.join([docsplit[0]] + [line[4:] for line in docsplit[1:]])
+    option_str = ""
+    options = cmd.options()
+    if options:
+        option_str = "\nOptions:\n"
+        for option_name, option in sorted(options.items()):
+            l = '    --' + option_name
+            if option.type is not None:
+                l += ' ' + option.argname.upper()
+            short_name = option.short_name()
+            if short_name:
+                assert len(short_name) == 1
+                l += ', -' + short_name
+            l += (30 - len(l)) * ' ' + option.help
+            # TODO: Split help over multiple lines with
+            # correct indenting and wrapping.
+            wrapped = textwrap.fill(l, initial_indent='',
+                                    subsequent_indent=30*' ')
+            option_str = option_str + wrapped + '\n'       
+    return subsection_header + option_str + "\n" + doc + "\n"
+
+
+man_preamble = """\
+Man page for %(bzrcmd)s (bazaar-ng)
+.\\\"
+.\\\" Large parts of this file are autogenerated from the output of
+.\\\"     \"%(bzrcmd)s help commands\"
+.\\\"     \"%(bzrcmd)s help <cmd>\"
+.\\\"
+.\\\" Generation time: %(timestamp)s
+.\\\"
+"""
+
+
+man_head = """\
+.TH bzr 1 "%(datestamp)s" "%(version)s" "bazaar-ng"
+.SH "NAME"
+%(bzrcmd)s - bazaar-ng next-generation distributed version control
+.SH "SYNOPSIS"
+.B "%(bzrcmd)s"
+.I "command"
+[
+.I "command_options"
+]
+.br
+.B "%(bzrcmd)s"
+.B "help"
+.br
+.B "%(bzrcmd)s"
+.B "help"
+.I "command"
+.SH "DESCRIPTION"
+bazaar-ng (or
+.B "%(bzrcmd)s"
+) is a project of Canonical to develop an open source distributed version control system that is powerful, friendly, and scalable. Version control means a system that keeps track of previous revisions of software source code or similar information and helps people work on it in teams.
+.SS "Warning"
+bazaar-ng is at an early stage of development, and the design is still changing from week to week. This man page here may be inconsistent with itself, with other documentation or with the code, and sometimes refer to features that are planned but not yet written. Comments are still very welcome; please send them to bazaar-ng@lists.canonical.com.
+"""
+
+man_foot = """\
+.SH "ENVIRONMENT"
+.TP
+.I "BZRPATH"
+Path where
+.B "%(bzrcmd)s"
+is to look for external command.
+.TP
+.I "BZREMAIL"
+E-Mail address of the user. Overrides default user config.
+.TP
+.I "EMAIL"
+E-Mail address of the user. Overriddes default user config.
+.SH "FILES"
+.TP
+.I "~/.bazaar/bazaar.conf/"
+Contains the default user config. Only one section, [DEFAULT] is allowed. A 
+typical default config file may be similiar to:
+.br
+.br
+.B [DEFAULT]
+.br
+.B email=John Doe <jdoe@isp.com>
+.SH "SEE ALSO"
+.UR http://bazaar.canonical.com/
+.BR http://bazaar.canonical.com/,
+.UR http://www.bazaar-ng.org/
+.BR http://www.bazaar-ng.org/
+"""
+

=== modified file 'tutorial.txt'
--- tutorial.txt	2006-01-25 14:30:06 +0000
+++ tutorial.txt	2006-03-20 08:31:00 +0000
@@ -10,10 +10,7 @@
 Bazaar-NG Tutorial
 ==================
 
-Current for bzr-0.7, January 2006
-
-(Please send comments or corrections on this document to
-bazaar-ng@lists.canonical.com)
+Current for bzr-0.7pre, 2006-01-06.
 
 
 Introduction
@@ -183,10 +180,7 @@
 Message from an editor
 ======================
 
-If you use neither the `-m` nor the `-F` option then bzr will open an
-editor for you to enter a message.  The editor to run is controlled by
-your `$EDITOR` environment variable or (Post Bazaar-NG 0.6) email setting
-in ``~/.bazaar/branches.conf``.  If you quit the editor without making any changes, the commit will be cancelled.
+If you use neither the `-m` nor the `-F` option then bzr will open an editor for you to enter a message.  The editor to run is controlled by your `$EDITOR` environment variable or (Post Bazaar-NG 0.6) email setting in .  If you quit the editor without making any changes, the commit will be cancelled.
 
 Selective commit
 ----------------
@@ -253,8 +247,10 @@
 As with bzr diff, bzr log supports the -r argument::
 
     % bzr log -r 1000..          # Revision 1000 and everything after it
-    % bzr log -r ..1000		 # Everything up to and including revision 1000
+    % bzr log -r ..1000          # Everything up to and including revision % 1000
     % bzr log -r 1000..1100      # changes from 1000 to 1100
+    % bzr log -r 1000            # The changes in only revision 1000
+
 
 Branch statistics
 =================

